/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],se=function(J){for(var e=[],D=0,j=J.length;D<j;D++)e[D]=ne[J[D]];return e};define(ne[72],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const I=new Map,N=new Map,A=new Map,E=new Map;function l(w,p){w.has(p.detail)||w.set(p.detail,-p.timestamp)}function a(w,p){const k=w.get(p.detail);k&&(k>=0||w.set(p.detail,k+p.timestamp))}let f=[];typeof J=="function"&&typeof J.getStats=="function"&&(f=J.getStats().slice(0).sort((w,p)=>w.timestamp-p.timestamp));for(const w of f)switch(w.type){case 10:l(I,w);break;case 11:case 12:a(I,w);break;case 21:l(N,w);break;case 22:a(N,w);break;case 33:l(A,w);break;case 34:a(A,w);break;case 31:l(E,w);break;case 32:a(E,w);break}let v=0;A.forEach(w=>v+=w);function y(w){const p=[];return w.forEach((k,g)=>p.push([g,k])),p}return{amdLoad:y(I),amdInvoke:y(N),nodeRequire:y(A),nodeEval:y(E),nodeRequireTotal:v}}static toMarkdownTable(I,N){let A="";const E=[];return I.forEach((l,a)=>{E[a]=l.length}),N.forEach(l=>{l.forEach((a,f)=>{typeof a>"u"&&(a=l[f]="-");const v=a.toString().length;E[f]=Math.max(v,E[f])})}),I.forEach((l,a)=>{A+=`| ${l+" ".repeat(E[a]-l.toString().length)} `}),A+=`|
`,I.forEach((l,a)=>{A+=`| ${"-".repeat(E[a])} `}),A+=`|
`,N.forEach(l=>{l.forEach((a,f)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(E[f]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(ne[54],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=j,e.$2h=I,e.$3h=N;function D(A){return(E,l,a)=>{let f=null,v=null;if(typeof a.value=="function"?(f="value",v=a.value):typeof a.get=="function"&&(f="get",v=a.get),!v)throw new Error("not supported");a[f]=A(v,l)}}function j(A,E,l){let a=null,f=null;if(typeof l.value=="function"?(a="value",f=l.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(a="get",f=l.get),!f)throw new Error("not supported");const v=`$memoize$${E}`;l[a]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,y)}),this[v]}}function I(A,E,l){return D((a,f)=>{const v=`$debounce$${f}`,y=`$debounce$result$${f}`;return function(...w){this[y]||(this[y]=l?l():void 0),clearTimeout(this[v]),E&&(this[y]=E(this[y],...w),w=[this[y]]),this[v]=setTimeout(()=>{a.apply(this,w),this[y]=l?l():void 0},A)}})}function N(A,E,l){return D((a,f)=>{const v=`$throttle$timer$${f}`,y=`$throttle$result$${f}`,w=`$throttle$lastRun$${f}`,p=`$throttle$pending$${f}`;return function(...k){if(this[y]||(this[y]=l?l():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...k)),this[p])return;const g=this[w]+A;g<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=l?l():void 0):(this[p]=!0,this[v]=setTimeout(()=>{this[p]=!1,this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=l?l():void 0},g-Date.now()))}})}}),define(ne[73],se([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$ed=I,e.$fd=N,e.$gd=A,e.$hd=E,e.$id=l;function j(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function I(a,f="Unreachable"){throw new Error(f)}function N(a){if(!a)throw new D.$cb("Assertion Failed")}function A(a){a||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function E(a){if(!a()){debugger;a(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function l(a,f){let v=0;for(;v<a.length-1;){const y=a[v],w=a[v+1];if(!f(y,w))return!1;v++}return!0}}),define(ne[38],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=A,e.$In=v,e.$Jn=y,e.$Kn=w,e.$Ln=p,e.$Mn=k,e.$Nn=g,e.$On=c,e.$Pn=u,e.$Qn=b,e.$Rn=m,e.$Sn=$;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var j;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(n,r=!1){let t=0;const i=n.length;let s="",o=0,h=16,P=0;function R(ie){let he=0,le=0;for(;he<ie;){const ce=n.charCodeAt(t);if(ce>=48&&ce<=57)le=le*16+ce-48;else if(ce>=65&&ce<=70)le=le*16+ce-65+10;else if(ce>=97&&ce<=102)le=le*16+ce-97+10;else break;t++,he++}return he<ie&&(le=-1),le}function O(ie){t=ie,s="",o=0,h=16,P=0}function z(){const ie=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&a(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&a(n.charCodeAt(t)))for(t++;t<n.length&&a(n.charCodeAt(t));)t++;else return P=3,n.substring(ie,t);let he=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&a(n.charCodeAt(t))){for(t++;t<n.length&&a(n.charCodeAt(t));)t++;he=t}else P=3;return n.substring(ie,he)}function M(){let ie="",he=t;for(;;){if(t>=i){ie+=n.substring(he,t),P=2;break}const le=n.charCodeAt(t);if(le===34){ie+=n.substring(he,t),t++;break}if(le===92){if(ie+=n.substring(he,t),t++,t>=i){P=2;break}switch(n.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const V=R(4);V>=0?ie+=String.fromCharCode(V):P=4;break}default:P=5}he=t;continue}if(le>=0&&le<=31)if(l(le)){ie+=n.substring(he,t),P=2;break}else P=6;t++}return ie}function T(){if(s="",P=0,o=t,t>=i)return o=i,h=17;let ie=n.charCodeAt(t);if(E(ie)){do t++,s+=String.fromCharCode(ie),ie=n.charCodeAt(t);while(E(ie));return h=15}if(l(ie))return t++,s+=String.fromCharCode(ie),ie===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),h=14;switch(ie){case 123:return t++,h=1;case 125:return t++,h=2;case 91:return t++,h=3;case 93:return t++,h=4;case 58:return t++,h=6;case 44:return t++,h=5;case 34:return t++,s=M(),h=10;case 47:{const he=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!l(n.charCodeAt(t));)t++;return s=n.substring(he,t),h=12}if(n.charCodeAt(t+1)===42){t+=2;const le=i-1;let ce=!1;for(;t<le;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,P=1),s=n.substring(he,t),h=13}return s+=String.fromCharCode(ie),t++,h=16}case 45:if(s+=String.fromCharCode(ie),t++,t===i||!a(n.charCodeAt(t)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=z(),h=11;default:for(;t<i&&Q(ie);)t++,ie=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(ie),t++,h=16}}function Q(ie){if(E(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ie;do ie=T();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>t,scan:r?re:T,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>P}}function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var f;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(f||(f={}));function v(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function P(R,O,z,M){o.value=R,o.offset=O,o.length=z,o.type=M,o.colonOffset=void 0,s=o}try{b(n,{onObjectBegin:(R,O)=>{if(r<=R)throw i;s=void 0,h=r>R,t.push("")},onObjectProperty:(R,O,z)=>{if(r<O||(P(R,O,z,"property"),t[t.length-1]=R,r<=O+z))throw i},onObjectEnd:(R,O)=>{if(r<=R)throw i;s=void 0,t.pop()},onArrayBegin:(R,O)=>{if(r<=R)throw i;s=void 0,t.push(0)},onArrayEnd:(R,O)=>{if(r<=R)throw i;s=void 0,t.pop()},onLiteralValue:(R,O,z)=>{if(r<O||(P(R,O,z,$(R)),r<=O+z))throw i},onSeparator:(R,O,z)=>{if(r<=O)throw i;if(R===":"&&s&&s.type==="property")s.colonOffset=O,h=!1,s=void 0;else if(R===","){const M=t[t.length-1];typeof M=="number"?t[t.length-1]=M+1:(h=!0,t[t.length-1]=""),s=void 0}}})}catch(R){if(R!==i)throw R}return{path:t,previousNode:s,isAtPropertyKey:h,matches:R=>{let O=0;for(let z=0;O<R.length&&z<t.length;z++)if(R[O]===t[z]||R[O]==="*")O++;else if(R[O]!=="**")return!1;return O===R.length}}}function y(n,r=[],t=N.DEFAULT){let i=null,s=[];const o=[];function h(R){Array.isArray(s)?s.push(R):i!==null&&(s[i]=R)}return b(n,{onObjectBegin:()=>{const R={};h(R),o.push(s),s=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const R=[];h(R),o.push(s),s=R,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:h,onError:(R,O,z)=>{r.push({error:R,offset:O,length:z})}},t),s[0]}function w(n,r=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function o(R){return i.children.push(R),R}b(n,{onObjectBegin:R=>{i=o({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,O,z)=>{i=o({type:"property",offset:O,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:O,length:z,parent:i})},onObjectEnd:(R,O)=>{i.length=R+O-i.offset,i=i.parent,s(R+O)},onArrayBegin:(R,O)=>{i=o({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,O)=>{i.length=R+O-i.offset,i=i.parent,s(R+O)},onLiteralValue:(R,O,z)=>{o({type:$(R),offset:O,length:z,parent:i,value:R}),s(O+z)},onSeparator:(R,O,z)=>{i.type==="property"&&(R===":"?i.colonOffset=O:R===","&&s(O))},onError:(R,O,z)=>{r.push({error:R,offset:O,length:z})}},t);const P=i.children[0];return P&&delete P.parent,P}function p(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function k(n){if(!n.parent||!n.parent.children)return[];const r=k(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}function g(n){switch(n.type){case"array":return n.children.map(g);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=g(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function c(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}function u(n,r,t=!1){if(c(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=u(i[s],r,t);if(o)return o}return n}}function b(n,r,t=N.DEFAULT){const i=A(n,!1);function s(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=s(r.onObjectBegin),P=o(r.onObjectProperty),R=s(r.onObjectEnd),O=s(r.onArrayBegin),z=s(r.onArrayEnd),M=o(r.onLiteralValue),T=o(r.onSeparator),Q=s(r.onComment),re=o(r.onError),ie=t&&t.disallowComments,he=t&&t.allowTrailingComma;function le(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Y){case 12:case 13:ie?ce(10):Q();break;case 16:ce(1);break;case 15:case 14:break;default:return Y}}}function ce(Y,_=[],F=[]){if(re(Y),_.length+F.length>0){let U=i.getToken();for(;U!==17;){if(_.indexOf(U)!==-1){le();break}else if(F.indexOf(U)!==-1)break;U=le()}}}function V(Y){const _=i.getTokenValue();return Y?M(_):P(_),le(),!0}function Z(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(ce(2),Y=0)}catch{ce(2)}M(Y);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return le(),!0}function B(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(T(":"),le(),X()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){h(),le();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),T(","),le(),i.getToken()===2&&he)break}else Y&&ce(6,[],[]);B()||ce(4,[],[2,5]),Y=!0}return R(),i.getToken()!==2?ce(7,[2],[]):le(),!0}function W(){O(),le();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),T(","),le(),i.getToken()===4&&he)break}else Y&&ce(6,[],[]);X()||ce(4,[],[4,5]),Y=!0}return z(),i.getToken()!==4?ce(8,[4],[]):le(),!0}function X(){switch(i.getToken()){case 3:return W();case 1:return q();case 10:return V(!0);default:return Z()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):X()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function m(n,r){const t=A(n),i=[];let s,o=0,h;do switch(h=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==h&&i.push(n.substring(o,h)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}function $(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[74],se([0,1,38]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=j,e.$Un=I,e.$Vn=E,e.$Wn=l;function j(a,f,v){let y,w,p,k,g;if(f){for(k=f.offset,g=k+f.length,p=k;p>0&&!l(a,p-1);)p--;let h=g;for(;h<a.length&&!l(a,h);)h++;w=a.substring(p,h),y=A(w,v)}else w=a,y=0,p=0,k=0,g=a.length;const c=E(v,a);let u=!1,b=0,m;v.insertSpaces?m=N(" ",v.tabSize||4):m="	";const $=(0,D.$Hn)(w,!1);let n=!1;function r(){return c+N(m,y+b)}function t(){let h=$.scan();for(u=!1;h===15||h===14;)u=u||h===14,h=$.scan();return n=h===16||$.getTokenError()!==0,h}const i=[];function s(h,P,R){!n&&P<g&&R>k&&a.substring(P,R)!==h&&i.push({offset:P,length:R-P,content:h})}let o=t();if(o!==17){const h=$.getTokenOffset()+p,P=N(m,y);s(P,p,h)}for(;o!==17;){let h=$.getTokenOffset()+$.getTokenLength()+p,P=t(),R="";for(;!u&&(P===12||P===13);){const z=$.getTokenOffset()+p;s(" ",h,z),h=$.getTokenOffset()+$.getTokenLength()+p,R=P===12?r():"",P=t()}if(P===2)o!==1&&(b--,R=r());else if(P===4)o!==3&&(b--,R=r());else{switch(o){case 3:case 1:b++,R=r();break;case 5:case 12:R=r();break;case 13:u?R=r():R=" ";break;case 6:R=" ";break;case 10:if(P===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?R=" ":P!==5&&P!==17&&(n=!0);break;case 16:n=!0;break}u&&(P===12||P===13)&&(R=r())}const O=$.getTokenOffset()+p;s(R,h,O),o=P}return i}function I(a,f){const v=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?v.replace(/\r\n|\r|\n/g,f.eol):v}function N(a,f){let v="";for(let y=0;y<f;y++)v+=a;return v}function A(a,f){let v=0,y=0;const w=f.tabSize||4;for(;v<a.length;){const p=a.charAt(v);if(p===" ")y++;else if(p==="	")y+=w;else break;v++}return Math.floor(y/w)}function E(a,f){for(let v=0;v<f.length;v++){const y=f.charAt(v);if(y==="\r")return v+1<f.length&&f.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}function l(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(ne[75],se([0,1,38,74]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=I,e.$Yn=N,e.$Zn=A,e.$1n=E,e.$2n=l;function I(a,f,v){return N(a,f,void 0,v)}function N(a,f,v,y,w){const p=f.slice(),k=[],g=(0,D.$Kn)(a,k);let c,u;for(;p.length>0&&(u=p.pop(),c=(0,D.$Ln)(g,p),c===void 0&&v!==void 0);)typeof u=="string"?v={[u]:v}:v=[v];if(c)if(c.type==="object"&&typeof u=="string"&&Array.isArray(c.children)){const b=(0,D.$Ln)(c,[u]);if(b!==void 0)if(v===void 0){if(!b.parent)throw new Error("Malformed AST");const m=c.children.indexOf(b.parent);let $,n=b.parent.offset+b.parent.length;if(m>0){const r=c.children[m-1];$=r.offset+r.length}else $=c.offset+1,c.children.length>1&&(n=c.children[1].offset);return A(a,{offset:$,length:n-$,content:""},y)}else return A(a,{offset:b.offset,length:b.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const m=`${JSON.stringify(u)}: ${JSON.stringify(v)}`,$=w?w(c.children.map(r=>r.children[0].value)):c.children.length;let n;if($>0){const r=c.children[$-1];n={offset:r.offset+r.length,length:0,content:","+m}}else c.children.length===0?n={offset:c.offset+1,length:0,content:m}:n={offset:c.offset+1,length:0,content:m+","};return A(a,n,y)}}else if(c.type==="array"&&typeof u=="number"&&Array.isArray(c.children))if(v!==void 0){const b=`${JSON.stringify(v)}`;let m;if(c.children.length===0||u===0)m={offset:c.offset+1,length:0,content:c.children.length===0?b:b+","};else{const $=u===-1||u>c.children.length?c.children.length:u,n=c.children[$-1];m={offset:n.offset+n.length,length:0,content:","+b}}return A(a,m,y)}else{const b=u,m=c.children[b];let $;if(c.children.length===1)$={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===b){const n=c.children[b-1],r=n.offset+n.length,t=c.offset+c.length;$={offset:r,length:t-2-r,content:""}}else $={offset:m.offset,length:c.children[b+1].offset-m.offset,content:""};return A(a,$,y)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${c.type}`);else return v===void 0?[]:A(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(v)},y)}function A(a,f,v){let y=E(a,f),w=f.offset,p=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;w>0&&!(0,j.$Wn)(y,w-1);)w--;for(;p<y.length&&!(0,j.$Wn)(y,p);)p++}const k=(0,j.$Tn)(y,{offset:w,length:p-w},v);for(let c=k.length-1;c>=0;c--){const u=k[c];y=E(y,u),w=Math.min(w,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const g=a.length-(y.length-p)-w;return[{offset:w,length:g,content:y.substring(w,p)}]}function E(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function l(a,f){const v=f.slice(0).sort((w,p)=>{const k=w.offset-p.offset;return k===0?w.length-p.length:k});let y=a.length;for(let w=v.length-1;w>=0;w--){const p=v[w];if(p.offset+p.length<=y)a=E(a,p);else throw new Error("Overlapping edit");y=p.offset}return a}}),define(ne[76],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=D,e.rot=j;function D(E,l,a){return Math.min(Math.max(E,l),a)}function j(E,l){return(l+E%l)%l}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=I;class N{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=N;class A{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const a=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=A}),function(){function J(I){const N=[];typeof I=="number"&&N.push("code/timeOrigin",I);function A(l){N.push(l,Date.now())}function E(){const l=[];for(let a=0;a<N.length;a+=2)l.push({name:N[a],startTime:N[a+1]});return l}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(I+A.startTime)});return N}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=D(j))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var j in D)(typeof exports=="object"?exports:J)[j]=D[j]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function D(j){if(e[j])return e[j].exports;var I=e[j]={i:j,l:!1,exports:{}};return J[j].call(I.exports,I,I.exports,D),I.l=!0,I.exports}return D.m=J,D.c=e,D.d=function(j,I,N){D.o(j,I)||Object.defineProperty(j,I,{enumerable:!0,get:N})},D.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},D.t=function(j,I){if(1&I&&(j=D(j)),8&I||4&I&&typeof j=="object"&&j&&j.__esModule)return j;var N=Object.create(null);if(D.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:j}),2&I&&typeof j!="string")for(var A in j)D.d(N,A,function(E){return j[E]}.bind(null,A));return N},D.n=function(j){var I=j&&j.__esModule?function(){return j.default}:function(){return j};return D.d(I,"a",I),I},D.o=function(j,I){return Object.prototype.hasOwnProperty.call(j,I)},D.p="",D(D.s=0)}([function(J,e,D){(function(j){var I;e=J.exports=F,I=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],l=e.src=[],a=0,f=a++;l[f]="0|[1-9]\\d*";var v=a++;l[v]="[0-9]+";var y=a++;l[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;l[w]="("+l[f]+")\\.("+l[f]+")\\.("+l[f]+")";var p=a++;l[p]="("+l[v]+")\\.("+l[v]+")\\.("+l[v]+")";var k=a++;l[k]="(?:"+l[f]+"|"+l[y]+")";var g=a++;l[g]="(?:"+l[v]+"|"+l[y]+")";var c=a++;l[c]="(?:-("+l[k]+"(?:\\."+l[k]+")*))";var u=a++;l[u]="(?:-?("+l[g]+"(?:\\."+l[g]+")*))";var b=a++;l[b]="[0-9A-Za-z-]+";var m=a++;l[m]="(?:\\+("+l[b]+"(?:\\."+l[b]+")*))";var $=a++,n="v?"+l[w]+l[c]+"?"+l[m]+"?";l[$]="^"+n+"$";var r="[v=\\s]*"+l[p]+l[u]+"?"+l[m]+"?",t=a++;l[t]="^"+r+"$";var i=a++;l[i]="((?:<|>)?=?)";var s=a++;l[s]=l[v]+"|x|X|\\*";var o=a++;l[o]=l[f]+"|x|X|\\*";var h=a++;l[h]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[m]+"?)?)?";var P=a++;l[P]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[u]+")?"+l[m]+"?)?)?";var R=a++;l[R]="^"+l[i]+"\\s*"+l[h]+"$";var O=a++;l[O]="^"+l[i]+"\\s*"+l[P]+"$";var z=a++;l[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=a++;l[M]="(?:~>?)";var T=a++;l[T]="(\\s*)"+l[M]+"\\s+",E[T]=new RegExp(l[T],"g");var Q=a++;l[Q]="^"+l[M]+l[h]+"$";var re=a++;l[re]="^"+l[M]+l[P]+"$";var ie=a++;l[ie]="(?:\\^)";var he=a++;l[he]="(\\s*)"+l[ie]+"\\s+",E[he]=new RegExp(l[he],"g");var le=a++;l[le]="^"+l[ie]+l[h]+"$";var ce=a++;l[ce]="^"+l[ie]+l[P]+"$";var V=a++;l[V]="^"+l[i]+"\\s*("+r+")$|^$";var Z=a++;l[Z]="^"+l[i]+"\\s*("+n+")$|^$";var B=a++;l[B]="(\\s*)"+l[i]+"\\s*("+r+"|"+l[h]+")",E[B]=new RegExp(l[B],"g");var q=a++;l[q]="^\\s*("+l[h]+")\\s+-\\s+("+l[h]+")\\s*$";var W=a++;l[W]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var X=a++;l[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)I(Y,l[Y]),E[Y]||(E[Y]=new RegExp(l[Y]));function _(x,K){if(x instanceof F)return x;if(typeof x!="string"||x.length>N||!(K?E[t]:E[$]).test(x))return null;try{return new F(x,K)}catch{return null}}function F(x,K){if(x instanceof F){if(x.loose===K)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof F))return new F(x,K);I("SemVer",x,K),this.loose=K;var ee=x.trim().match(K?E[t]:E[$]);if(!ee)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var be=+ge;if(be>=0&&be<A)return be}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,K){var ee=_(x,K);return ee?ee.version:null},e.clean=function(x,K){var ee=_(x.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(x){return I("SemVer.compare",this.version,this.loose,x),x instanceof F||(x=new F(x,this.loose)),this.compareMain(x)||this.comparePre(x)},F.prototype.compareMain=function(x){return x instanceof F||(x=new F(x,this.loose)),d(this.major,x.major)||d(this.minor,x.minor)||d(this.patch,x.patch)},F.prototype.comparePre=function(x){if(x instanceof F||(x=new F(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=x.prerelease[K];if(I("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return d(ee,ge)}while(++K)},F.prototype.inc=function(x,K){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new F(x,ee).inc(K,ge).version}catch{return null}},e.diff=function(x,K){if(G(x,K))return null;var ee=_(x),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var be in ee)if((be==="major"||be==="minor"||be==="patch")&&ee[be]!==ge[be])return"pre"+be;return"prerelease"}for(var be in ee)if((be==="major"||be==="minor"||be==="patch")&&ee[be]!==ge[be])return be},e.compareIdentifiers=d;var U=/^[0-9]+$/;function d(x,K){var ee=U.test(x),ge=U.test(K);return ee&&ge&&(x=+x,K=+K),ee&&!ge?-1:ge&&!ee?1:x<K?-1:x>K?1:0}function S(x,K,ee){return new F(x,ee).compare(new F(K,ee))}function L(x,K,ee){return S(x,K,ee)>0}function C(x,K,ee){return S(x,K,ee)<0}function G(x,K,ee){return S(x,K,ee)===0}function H(x,K,ee){return S(x,K,ee)!==0}function te(x,K,ee){return S(x,K,ee)>=0}function ae(x,K,ee){return S(x,K,ee)<=0}function ue(x,K,ee,ge){var be;switch(K){case"===":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),be=x===ee;break;case"!==":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),be=x!==ee;break;case"":case"=":case"==":be=G(x,ee,ge);break;case"!=":be=H(x,ee,ge);break;case">":be=L(x,ee,ge);break;case">=":be=te(x,ee,ge);break;case"<":be=C(x,ee,ge);break;case"<=":be=ae(x,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return be}function pe(x,K){if(x instanceof pe){if(x.loose===K)return x;x=x.value}if(!(this instanceof pe))return new pe(x,K);I("comparator",x,K),this.loose=K,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(x,K){return d(K,x)},e.major=function(x,K){return new F(x,K).major},e.minor=function(x,K){return new F(x,K).minor},e.patch=function(x,K){return new F(x,K).patch},e.compare=S,e.compareLoose=function(x,K){return S(x,K,!0)},e.rcompare=function(x,K,ee){return S(K,x,ee)},e.sort=function(x,K){return x.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(x,K){return x.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=L,e.lt=C,e.eq=G,e.neq=H,e.gte=te,e.lte=ae,e.cmp=ue,e.Comparator=pe;var ye={};function fe(x,K){if(x instanceof fe)return x.loose===K?x:new fe(x.raw,K);if(x instanceof pe)return new fe(x.value,K);if(!(this instanceof fe))return new fe(x,K);if(this.loose=K,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,K,ee,ge,be,De,Pe,Le,Re,Ae,Me,Oe,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(be)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(Re)?"":me(Ae)?"<"+(+Re+1)+".0.0":me(Me)?"<"+Re+"."+(+Ae+1)+".0":Oe?"<="+Re+"."+Ae+"."+Me+"-"+Oe:"<="+Le)).trim()}function we(x,K){for(var ee=0;ee<x.length;ee++)if(!x[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<x.length;ee++)if(I(x[ee].semver),x[ee].semver!==ye&&x[ee].semver.prerelease.length>0){var ge=x[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(x,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(x)}function Ie(x,K,ee,ge){var be,De,Pe,Le,Re;switch(x=new F(x,ge),K=new fe(K,ge),ee){case">":be=L,De=ae,Pe=C,Le=">",Re=">=";break;case"<":be=C,De=te,Pe=L,Le="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var Me=K.set[Ae],Oe=null,Ne=null;if(Me.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),Oe=Oe||ze,Ne=Ne||ze,be(ze.semver,Oe.semver,ge)?Oe=ze:Pe(ze.semver,Ne.semver,ge)&&(Ne=ze)}),Oe.operator===Le||Oe.operator===Re||(!Ne.operator||Ne.operator===Le)&&De(x,Ne.semver)||Ne.operator===Re&&Pe(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var K=this.loose?E[V]:E[Z],ee=x.match(K);if(!ee)throw new TypeError("Invalid comparator: "+x);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return I("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new F(x,this.loose)),ue(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,K){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(x.value,K),Ee(this.value,ee,K);if(x.operator==="")return ee=new fe(this.value,K),Ee(x.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=ue(this.semver,"<",x.semver,K)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Re=ue(this.semver,">",x.semver,K)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||be||De&&Pe||Le||Re},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var K=this.loose;x=x.trim(),I("range",x,K);var ee=K?E[W]:E[q];x=x.replace(ee,de),I("hyphen replace",x),x=x.replace(E[B],"$1$2$3"),I("comparator trim",x,E[B]),x=(x=(x=x.replace(E[T],"$1~")).replace(E[he],"$1^")).split(/\s+/).join(" ");var ge=K?E[V]:E[Z],be=x.split(" ").map(function(De){return function(Pe,Le){return I("comp",Pe),Pe=function(Re,Ae){return Re.trim().split(/\s+/).map(function(Me){return function(Oe,Ne){I("caret",Oe,Ne);var ze=Ne?E[ce]:E[le];return Oe.replace(ze,function(Ue,ve,Se,ke,je){var Fe;return I("caret",Oe,Ue,ve,Se,ke,je),me(ve)?Fe="":me(Se)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":me(ke)?Fe=ve==="0"?">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+".0 <"+(+ve+1)+".0.0":je?(I("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Fe=ve==="0"?Se==="0"?">="+ve+"."+Se+"."+ke+je+" <"+ve+"."+Se+"."+(+ke+1):">="+ve+"."+Se+"."+ke+je+" <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+"."+ke+je+" <"+(+ve+1)+".0.0"):(I("no pr"),Fe=ve==="0"?Se==="0"?">="+ve+"."+Se+"."+ke+" <"+ve+"."+Se+"."+(+ke+1):">="+ve+"."+Se+"."+ke+" <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+"."+ke+" <"+(+ve+1)+".0.0"),I("caret return",Fe),Fe})}(Me,Ae)}).join(" ")}(Pe,Le),I("caret",Pe),Pe=function(Re,Ae){return Re.trim().split(/\s+/).map(function(Me){return function(Oe,Ne){var ze=Ne?E[re]:E[Q];return Oe.replace(ze,function(Ue,ve,Se,ke,je){var Fe;return I("tilde",Oe,Ue,ve,Se,ke,je),me(ve)?Fe="":me(Se)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":me(ke)?Fe=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0":je?(I("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Fe=">="+ve+"."+Se+"."+ke+je+" <"+ve+"."+(+Se+1)+".0"):Fe=">="+ve+"."+Se+"."+ke+" <"+ve+"."+(+Se+1)+".0",I("tilde return",Fe),Fe})}(Me,Ae)}).join(" ")}(Pe,Le),I("tildes",Pe),Pe=function(Re,Ae){return I("replaceXRanges",Re,Ae),Re.split(/\s+/).map(function(Me){return function(Oe,Ne){Oe=Oe.trim();var ze=Ne?E[O]:E[R];return Oe.replace(ze,function(Ue,ve,Se,ke,je,Fe){I("xRange",Oe,Ue,ve,Se,ke,je,Fe);var Te=me(Se),Ce=Te||me(ke),qe=Ce||me(je);return ve==="="&&qe&&(ve=""),Te?Ue=ve===">"||ve==="<"?"<0.0.0":"*":ve&&qe?(Ce&&(ke=0),qe&&(je=0),ve===">"?(ve=">=",Ce?(Se=+Se+1,ke=0,je=0):qe&&(ke=+ke+1,je=0)):ve==="<="&&(ve="<",Ce?Se=+Se+1:ke=+ke+1),Ue=ve+Se+"."+ke+"."+je):Ce?Ue=">="+Se+".0.0 <"+(+Se+1)+".0.0":qe&&(Ue=">="+Se+"."+ke+".0 <"+Se+"."+(+ke+1)+".0"),I("xRange return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),I("xrange",Pe),Pe=function(Re,Ae){return I("replaceStars",Re,Ae),Re.trim().replace(E[X],"")}(Pe,Le),I("stars",Pe),Pe}(De,K)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(De){return!!De.match(ge)})),be=be.map(function(De){return new pe(De,K)})},fe.prototype.intersects=function(x,K){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return x.set.some(function(be){return be.every(function(De){return ge.intersects(De,K)})})})})},e.toComparators=function(x,K){return new fe(x,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new F(x,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,K,ee){var ge=null,be=null;try{var De=new fe(K,ee)}catch{return null}return x.forEach(function(Pe){De.test(Pe)&&(ge&&be.compare(Pe)!==-1||(be=new F(ge=Pe,ee)))}),ge},e.minSatisfying=function(x,K,ee){var ge=null,be=null;try{var De=new fe(K,ee)}catch{return null}return x.forEach(function(Pe){De.test(Pe)&&(ge&&be.compare(Pe)!==1||(be=new F(ge=Pe,ee)))}),ge},e.validRange=function(x,K){try{return new fe(x,K).range||"*"}catch{return null}},e.ltr=function(x,K,ee){return Ie(x,K,"<",ee)},e.gtr=function(x,K,ee){return Ie(x,K,">",ee)},e.outside=Ie,e.prerelease=function(x,K){var ee=_(x,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(x,K,ee){return x=new fe(x,ee),K=new fe(K,ee),x.intersects(K)},e.coerce=function(x){if(x instanceof F)return x;if(typeof x!="string")return null;var K=x.match(E[z]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,D(1))},function(J,e){var D,j,I=J.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(g){if(D===setTimeout)return setTimeout(g,0);if((D===N||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch{try{return D.call(null,g,0)}catch{return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:N}catch{D=N}try{j=typeof clearTimeout=="function"?clearTimeout:A}catch{j=A}})();var l,a=[],f=!1,v=-1;function y(){f&&l&&(f=!1,l.length?a=l.concat(a):v=-1,a.length&&w())}function w(){if(!f){var g=E(y);f=!0;for(var c=a.length;c;){for(l=a,a=[];++v<c;)l&&l[v].run();v=-1,c=a.length}l=null,f=!1,function(u){if(j===clearTimeout)return clearTimeout(u);if((j===A||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(u);try{j(u)}catch{try{return j.call(null,u)}catch{return j.call(this,u)}}}(g)}}function p(g,c){this.fun=g,this.array=c}function k(){}I.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];a.push(new p(g,c)),a.length!==1||f||E(w)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=k,I.addListener=k,I.once=k,I.off=k,I.removeListener=k,I.removeAllListeners=k,I.emit=k,I.prependListener=k,I.prependOnceListener=k,I.listeners=function(g){return[]},I.binding=function(g){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(g){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(ne[77],se([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class j{constructor(E,l,a){this.level=E,this.key=l,this.value=a,this.forward=[]}}const I=void 0;class N{constructor(E,l=2**16){this.comparator=E,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(l)|0),this.e=new j(this.c,I,I)}get size(){return this.f}clear(){this.e=new j(this.c,I,I),this.f=0}has(E){return!!N.g(this,E,this.comparator)}get(E){return N.g(this,E,this.comparator)?.value}set(E,l){return N.h(this,E,l,this.comparator)&&(this.f+=1),this}delete(E){const l=N.k(this,E,this.comparator);return l&&(this.f-=1),l}forEach(E,l){let a=this.e.forward[0];for(;a;)E.call(l,a.value,a.key,this),a=a.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",l=this.e.forward[0];for(;l;)E+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return E}static g(E,l,a){let f=E.e;for(let v=E.d-1;v>=0;v--)for(;f.forward[v]&&a(f.forward[v].key,l)<0;)f=f.forward[v];if(f=f.forward[0],f&&a(f.key,l)===0)return f}static h(E,l,a,f){const v=[];let y=E.e;for(let w=E.d-1;w>=0;w--){for(;y.forward[w]&&f(y.forward[w].key,l)<0;)y=y.forward[w];v[w]=y}if(y=y.forward[0],y&&f(y.key,l)===0)return y.value=a,!1;{const w=N.j(E);if(w>E.d){for(let p=E.d;p<w;p++)v[p]=E.e;E.d=w}y=new j(w,l,a);for(let p=0;p<w;p++)y.forward[p]=v[p].forward[p],v[p].forward[p]=y;return!0}}static j(E,l=.5){let a=1;for(;Math.random()<l&&a<E.c;)a+=1;return a}static k(E,l,a){const f=[];let v=E.e;for(let y=E.d-1;y>=0;y--){for(;v.forward[y]&&a(v.forward[y].key,l)<0;)v=v.forward[y];f[y]=v}if(v=v.forward[0],!v||a(v.key,l)!==0)return!1;for(let y=0;y<E.d&&f[y].forward[y]===v;y++)f[y].forward[y]=v.forward[y];for(;E.d>0&&E.e.forward[E.d-1]===I;)E.d-=1;return!0}}e.$zs=N}),define(ne[46],se([0,1,9,2]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=I,e.$re=N,e.$se=A,e.$te=E,e.$ue=a,e.$ve=f,e.$we=v,e.$xe=y,e.$ye=w,e.$ze=p,e.$Ae=k,e.$Be=g,e.$Ce=c,e.$De=u,e.$Ee=b;function I(m){const $=m;return $?typeof $.read=="function":!1}function N(m){const $=m;return $?[$.on,$.pause,$.resume,$.destroy].every(n=>typeof n=="function"):!1}function A(m){const $=m;return $?N($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function E(m,$){return new l(m,$)}class l{constructor($,n){this.e=$,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(n=>n($))}h($){this.c.error.length===0?(0,D.$1)($):this.c.error.slice(0).forEach(n=>n($))}i(){this.c.end.slice(0).forEach($=>$())}on($,n){if(!this.a.destroyed)switch($){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener($,n){if(this.a.destroyed)return;let r;switch($){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(m,$){const n=[];let r;for(;(r=m.read())!==null;)n.push(r);return $(n)}function f(m,$,n){const r=[];let t;for(;(t=m.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?$(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return m.read()}}}function v(m,$){return new Promise((n,r)=>{const t=[];y(m,{onData:i=>{$&&t.push(i)},onError:i=>{$?r(i):n(void 0)},onEnd:()=>{n($?$(t):void 0)}})})}function y(m,$,n){m.on("error",r=>{n?.isCancellationRequested||$.onError(r)}),m.on("end",()=>{n?.isCancellationRequested||$.onEnd()}),m.on("data",r=>{n?.isCancellationRequested||$.onData(r)})}function w(m,$){return new Promise((n,r)=>{const t=new j.$Tc,i=[],s=P=>{if(i.push(P),i.length>$)return t.dispose(),m.pause(),n({stream:m,buffer:i,ended:!1})},o=P=>(t.dispose(),r(P)),h=()=>(t.dispose(),n({stream:m,buffer:i,ended:!0}));t.add((0,j.$Sc)(()=>m.removeListener("error",o))),m.on("error",o),t.add((0,j.$Sc)(()=>m.removeListener("end",h))),m.on("end",h),t.add((0,j.$Sc)(()=>m.removeListener("data",s))),m.on("data",s)})}function p(m,$){const n=E($);return n.end(m),n}function k(){const m=E(()=>{throw new Error("not supported")});return m.end(),m}function g(m){let $=!1;return{read:()=>$?null:($=!0,m)}}function c(m,$,n){const r=E(n);return y(m,{onData:t=>r.write($.data(t)),onError:t=>r.error($.error?$.error(t):t),onEnd:()=>r.end()}),r}function u(m,$,n){let r=!1;return{read:()=>{const t=$.read();return r?t:(r=!0,t!==null?n([m,t]):m)}}}function b(m,$,n){let r=!1;const t=E(n);return y($,{onData:i=>r?t.write(i):(r=!0,t.write(n([m,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(m)),t.end()}}),t}}),define(ne[14],se([0,1,169,46]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=a,e.$He=f,e.$Ie=v,e.$Je=y,e.$Ke=w,e.$Le=p,e.$Me=k,e.$Ne=g,e.$Oe=c,e.$Pe=u,e.$Qe=b,e.$Re=m,e.$Se=$,e.$Te=n,e.$Ue=r,e.$Ve=t,e.$We=i,e.$Xe=s,e.$Ye=o,e.$Ze=R;const I=typeof Buffer<"u",N=new D.$V(()=>new Uint8Array(256));let A,E;class l{static alloc(z){return I?new l(Buffer.allocUnsafe(z)):new l(new Uint8Array(z))}static wrap(z){return I&&!Buffer.isBuffer(z)&&(z=Buffer.from(z.buffer,z.byteOffset,z.byteLength)),new l(z)}static fromString(z,M){return!(M?.dontUseNodeBuffer||!1)&&I?new l(Buffer.from(z)):(A||(A=new TextEncoder),new l(A.encode(z)))}static fromByteArray(z){const M=l.alloc(z.length);for(let T=0,Q=z.length;T<Q;T++)M.buffer[T]=z[T];return M}static concat(z,M){if(typeof M>"u"){M=0;for(let re=0,ie=z.length;re<ie;re++)M+=z[re].byteLength}const T=l.alloc(M);let Q=0;for(let re=0,ie=z.length;re<ie;re++){const he=z[re];T.set(he,Q),Q+=he.byteLength}return T}constructor(z){this.buffer=z,this.byteLength=this.buffer.byteLength}clone(){const z=l.alloc(this.byteLength);return z.set(this),z}toString(){return I?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(z,M){return new l(this.buffer.subarray(z,M))}set(z,M){if(z instanceof l)this.buffer.set(z.buffer,M);else if(z instanceof Uint8Array)this.buffer.set(z,M);else if(z instanceof ArrayBuffer)this.buffer.set(new Uint8Array(z),M);else if(ArrayBuffer.isView(z))this.buffer.set(new Uint8Array(z.buffer,z.byteOffset,z.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(z){return y(this.buffer,z)}writeUInt32BE(z,M){w(this.buffer,z,M)}readUInt32LE(z){return p(this.buffer,z)}writeUInt32LE(z,M){k(this.buffer,z,M)}readUInt8(z){return g(this.buffer,z)}writeUInt8(z,M){c(this.buffer,z,M)}indexOf(z,M=0){return a(this.buffer,z instanceof l?z.buffer:z,M)}}e.$Fe=l;function a(O,z,M=0){const T=z.byteLength,Q=O.byteLength;if(T===0)return 0;if(T===1)return O.indexOf(z[0]);if(T>Q-M)return-1;const re=N.value;re.fill(z.length);for(let ce=0;ce<z.length;ce++)re[z[ce]]=z.length-ce-1;let ie=M+z.length-1,he=ie,le=-1;for(;ie<Q;)if(O[ie]===z[he]){if(he===0){le=ie;break}ie--,he--}else ie+=Math.max(z.length-he,re[O[ie]]),he=z.length-1;return le}function f(O,z){return O[z+0]<<0>>>0|O[z+1]<<8>>>0}function v(O,z,M){O[M+0]=z&255,z=z>>>8,O[M+1]=z&255}function y(O,z){return O[z]*2**24+O[z+1]*2**16+O[z+2]*2**8+O[z+3]}function w(O,z,M){O[M+3]=z,z=z>>>8,O[M+2]=z,z=z>>>8,O[M+1]=z,z=z>>>8,O[M]=z}function p(O,z){return O[z+0]<<0>>>0|O[z+1]<<8>>>0|O[z+2]<<16>>>0|O[z+3]<<24>>>0}function k(O,z,M){O[M+0]=z&255,z=z>>>8,O[M+1]=z&255,z=z>>>8,O[M+2]=z&255,z=z>>>8,O[M+3]=z&255}function g(O,z){return O[z]}function c(O,z,M){O[M]=z}function u(O){return j.$ue(O,z=>l.concat(z))}function b(O){return j.$Be(O)}function m(O){return j.$we(O,z=>l.concat(z))}async function $(O){return O.ended?l.concat(O.buffer):l.concat([...O.buffer,await m(O.stream)])}function n(O){return j.$ze(O,z=>l.concat(z))}function r(O){return j.$Ce(O,{data:z=>typeof z=="string"?l.fromString(z):l.wrap(z)},z=>l.concat(z))}function t(O){return j.$te(z=>l.concat(z),O)}function i(O,z){return j.$De(O,z,M=>l.concat(M))}function s(O,z){return j.$Ee(O,z,M=>l.concat(M))}function o(O){let z=0,M=0,T=0;const Q=new Uint8Array(Math.floor(O.length/4*3)),re=he=>{switch(M){case 3:Q[T++]=z|he,M=0;break;case 2:Q[T++]=z|he>>>2,z=he<<6,M=3;break;case 1:Q[T++]=z|he>>>4,z=he<<4,M=2;break;default:z=he<<2,M=1}};for(let he=0;he<O.length;he++){const le=O.charCodeAt(he);if(le>=65&&le<=90)re(le-65);else if(le>=97&&le<=122)re(le-97+26);else if(le>=48&&le<=57)re(le-48+52);else if(le===43||le===45)re(62);else if(le===47||le===95)re(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${O[he]}`)}}const ie=T;for(;M>0;)re(0);return l.wrap(Q).slice(0,ie)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:O},z=!0,M=!1){const T=M?P:h;let Q="";const re=O.byteLength%3;let ie=0;for(;ie<O.byteLength-re;ie+=3){const he=O[ie+0],le=O[ie+1],ce=O[ie+2];Q+=T[he>>>2],Q+=T[(he<<4|le>>>4)&63],Q+=T[(le<<2|ce>>>6)&63],Q+=T[ce&63]}if(re===1){const he=O[ie+0];Q+=T[he>>>2],Q+=T[he<<4&63],z&&(Q+="==")}else if(re===2){const he=O[ie+0],le=O[ie+1];Q+=T[he>>>2],Q+=T[(he<<4|le>>>4)&63],Q+=T[le<<2&63],z&&(Q+="=")}return Q}}),define(ne[43],se([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=j,e.$lj=I,e.$mj=N,e.$nj=E,e.$pj=k;function j(c){return I(c,0)}function I(c,u){switch(typeof c){case"object":return c===null?N(349,u):Array.isArray(c)?l(c,u):a(c,u);case"string":return E(c,u);case"boolean":return A(c,u);case"number":return N(c,u);case"undefined":return N(937,u);default:return N(617,u)}}function N(c,u){return(u<<5)-u+c|0}function A(c,u){return N(c?433:863,u)}function E(c,u){u=N(149417,u);for(let b=0,m=c.length;b<m;b++)u=N(c.charCodeAt(b),u);return u}function l(c,u){return u=N(104579,u),c.reduce((b,m)=>I(m,b),u)}function a(c,u){return u=N(181387,u),Object.keys(c).sort().reduce((b,m)=>(b=E(m,b),I(c[m],b)),u)}class f{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=I(u,this.g),this.g}}e.$oj=f;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(c,u,b=32){const m=b-u,$=~((1<<m)-1);return(c<<u|($&c)>>>m)>>>0}function w(c,u=0,b=c.byteLength,m=0){for(let $=0;$<b;$++)c[u+$]=m}function p(c,u,b="0"){for(;c.length<u;)c=b+c;return c}function k(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(b=>b.toString(16).padStart(2,"0")).join(""):p((c>>>0).toString(16),u/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const b=u.length;if(b===0)return;const m=this.p;let $=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=u.charCodeAt(0),t=0);;){let i=r;if(D.$Bf(r))if(t+1<b){const s=u.charCodeAt(t+1);D.$Cf(s)?(t++,i=D.$Df(r,s)):i=65533}else{n=r;break}else D.$Cf(r)&&(i=65533);if($=this.w(m,$,i),t++,t<b)r=u.charCodeAt(t);else break}this.r=$,this.u=n}w(u,b,m){return m<128?u[b++]=m:m<2048?(u[b++]=192|(m&1984)>>>6,u[b++]=128|(m&63)>>>0):m<65536?(u[b++]=224|(m&61440)>>>12,u[b++]=128|(m&4032)>>>6,u[b++]=128|(m&63)>>>0):(u[b++]=240|(m&1835008)>>>18,u[b++]=128|(m&258048)>>>12,u[b++]=128|(m&4032)>>>6,u[b++]=128|(m&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),k(this.h)+k(this.l)+k(this.m)+k(this.n)+k(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=g.g,b=this.q;for(let h=0;h<64;h+=4)u.setUint32(h,b.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)u.setUint32(h,y(u.getUint32(h-12,!1)^u.getUint32(h-32,!1)^u.getUint32(h-56,!1)^u.getUint32(h-64,!1),1),!1);let m=this.h,$=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let h=0;h<80;h++)h<20?(i=$&n|~$&r,s=1518500249):h<40?(i=$^n^r,s=1859775393):h<60?(i=$&n|$&r|n&r,s=2400959708):(i=$^n^r,s=3395469782),o=y(m,5)+i+t+s+u.getUint32(h*4,!1)&4294967295,t=r,r=n,n=y($,30),$=m,m=o;this.h=this.h+m&4294967295,this.l=this.l+$&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$qj=g}),define(ne[55],se([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(j||(j={})),function(I){const N="error",A="warning",E="warn",l="info",a="ignore";function f(y){return y?D.$xf(N,y)?I.Error:D.$xf(A,y)||D.$xf(E,y)?I.Warning:D.$xf(l,y)?I.Info:I.Ignore:I.Ignore}I.fromValue=f;function v(y){switch(y){case I.Error:return N;case I.Warning:return A;case I.Info:return l;default:return a}}I.toString=v}(j||(j={})),e.default=j}),define(ne[27],se([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=j,e.$4n=I,e.$5n=A,e.$6n=l,e.$7n=a,e.$8n=f,e.$9n=v,e.$0n=y,e.$$n=w,e.$_n=p,e.$ao=k,e.$bo=g;function j(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([b,m])=>{u[b]=m&&typeof m=="object"?j(m):m}),u}function I(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const b=u.shift();Object.freeze(b);for(const m in b)if(N.call(b,m)){const $=b[m];typeof $=="object"&&!Object.isFrozen($)&&!(0,D.$_f)($)&&u.push($)}}return c}const N=Object.prototype.hasOwnProperty;function A(c,u){return E(c,u,new Set)}function E(c,u,b){if((0,D.$fg)(c))return c;const m=u(c);if(typeof m<"u")return m;if(Array.isArray(c)){const $=[];for(const n of c)$.push(E(n,u,b));return $}if((0,D.$$f)(c)){if(b.has(c))throw new Error("Cannot clone recursive data-structure");b.add(c);const $={};for(const n in c)N.call(c,n)&&($[n]=E(c[n],u,b));return b.delete(c),$}return c}function l(c,u,b=!0){return(0,D.$$f)(c)?((0,D.$$f)(u)&&Object.keys(u).forEach(m=>{m in c?b&&((0,D.$$f)(c[m])&&(0,D.$$f)(u[m])?l(c[m],u[m],b):c[m]=u[m]):c[m]=u[m]}),c):u}function a(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let b,m;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(b=0;b<c.length;b++)if(!a(c[b],u[b]))return!1}else{const $=[];for(m in c)$.push(m);$.sort();const n=[];for(m in u)n.push(m);if(n.sort(),!a($,n))return!1;for(b=0;b<$.length;b++)if(!a(c[$[b]],u[$[b]]))return!1}return!0}function f(c){const u=new Set;return JSON.stringify(c,(b,m)=>{if((0,D.$$f)(m)||Array.isArray(m)){if(u.has(m))return"[Circular]";u.add(m)}return typeof m=="bigint"?`[BigInt ${m.toString()}]`:m})}function v(c,u){const b=Object.create(null);return!c||!u||Object.keys(u).forEach($=>{const n=c[$],r=u[$];a(n,r)||(b[$]=r)}),b}function y(c,u){const b=u.toLowerCase(),m=Object.keys(c).find($=>$.toLowerCase()===b);return m?c[m]:c[u]}function w(c,u){const b=Object.create(null);for(const[m,$]of Object.entries(c))u(m,$)&&(b[m]=$);return b}function p(c){let u=[];for(;Object.prototype!==c;)u=u.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return u}function k(c){const u=[];for(const b of p(c))typeof c[b]=="function"&&u.push(b);return u}function g(c,u){const b=$=>function(){const n=Array.prototype.slice.call(arguments,0);return u($,n)},m={};for(const $ of c)m[$]=b($);return m}}),define(ne[28],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=j;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(I){return D.test(I)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(E){for(let l=0;l<E.length;l++)E[l]=Math.floor(Math.random()*256);return E};const N=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){I(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let l=0,a="";return a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a}}()}),define(ne[78],se([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=N;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(A){const E=A.replace(/\-/g,":").toLowerCase();return!j.has(E)}function N(){const A=(0,D.networkInterfaces)();for(const E in A){const l=A[E];if(l){for(const{mac:a}of l)if(I(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[79],se([7,4]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[80],se([0,1,79]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=a,e.$3m=f,e.$4m=v;const j=60,I=j*60,N=I*24,A=N*7,E=N*30,l=N*365;function a(y,w,p,k){typeof y!="number"&&(y=y.getTime());const g=Math.round((new Date().getTime()-y)/1e3);if(g<-30)return(0,D.localize)(0,null,a(new Date().getTime()+g*1e3,!1));if(!k&&g<30)return(0,D.localize)(1,null);let c;return g<j?(c=g,w?c===1?p?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):p?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c):c===1?p?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):p?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):g<I?(c=Math.floor(g/j),w?c===1?p?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):p?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c):c===1?p?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):p?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):g<N?(c=Math.floor(g/I),w?c===1?p?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):p?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c):c===1?p?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):p?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):g<A?(c=Math.floor(g/N),w?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c)):g<E?(c=Math.floor(g/A),w?c===1?p?(0,D.localize)(30,null,c):(0,D.localize)(31,null,c):p?(0,D.localize)(32,null,c):(0,D.localize)(33,null,c):c===1?p?(0,D.localize)(34,null,c):(0,D.localize)(35,null,c):p?(0,D.localize)(36,null,c):(0,D.localize)(37,null,c)):g<l?(c=Math.floor(g/E),w?c===1?p?(0,D.localize)(38,null,c):(0,D.localize)(39,null,c):p?(0,D.localize)(40,null,c):(0,D.localize)(41,null,c):c===1?p?(0,D.localize)(42,null,c):(0,D.localize)(43,null,c):p?(0,D.localize)(44,null,c):(0,D.localize)(45,null,c)):(c=Math.floor(g/l),w?c===1?p?(0,D.localize)(46,null,c):(0,D.localize)(47,null,c):p?(0,D.localize)(48,null,c):(0,D.localize)(49,null,c):c===1?p?(0,D.localize)(50,null,c):(0,D.localize)(51,null,c):p?(0,D.localize)(52,null,c):(0,D.localize)(53,null,c))}function f(y,w){const p=Math.abs(y/1e3);return p<1?w?(0,D.localize)(54,null,y):(0,D.localize)(55,null,y):p<j?w?(0,D.localize)(56,null,Math.round(y)/1e3):(0,D.localize)(57,null,Math.round(y)/1e3):p<I?w?(0,D.localize)(58,null,Math.round(y/(1e3*j))):(0,D.localize)(59,null,Math.round(y/(1e3*j))):p<N?w?(0,D.localize)(60,null,Math.round(y/(1e3*I))):(0,D.localize)(61,null,Math.round(y/(1e3*I))):(0,D.localize)(62,null,Math.round(y/(1e3*N)))}function v(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[81],se([7,4]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],se([0,1,19,3,81]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=l,e.$ij=a,e.$jj=f;function N(v,y){return y&&(v.stack||v.stacktrace)?I.localize(0,null,E(v),A(v.stack)||A(v.stacktrace)):E(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function E(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?I.localize(1,null,v.message):v.message||I.localize(2,null)}function l(v=null,y=!1){if(!v)return I.localize(3,null);if(Array.isArray(v)){const w=D.$Hb(v),p=l(w[0],y);return w.length>1?I.localize(4,null,p,w.length):p}if(j.$9f(v))return v;if(v.detail){const w=v.detail;if(w.error)return N(w.error,y);if(w.exception)return N(w.exception,y)}return v.stack?N(v,y):v.message?v.message:I.localize(5,null)}function a(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}function f(v,y){let w;return typeof v=="string"?w=new Error(v):w=v,w.actions=y,w}}),define(ne[82],se([7,4]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[83],se([0,1,82]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=j;function j(I){switch(I){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(ne[56],se([0,1,12]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=N,e.$nm=A;var j;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(j||(e.Source=j={}));var I;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function N(E,...l){const a=l.reduce((y,w)=>(y[w]=!0,y),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(y=>!a[y]).forEach(y=>{for(let w=0;w<f.length;w++)if(y.search(f[w])!==-1){delete E[y];break}})}function A(E){E&&(delete E.DEBUG,D.$j&&delete E.DYLD_LIBRARY_PATH,D.$k&&delete E.LD_PRELOAD)}}),define(ne[84],se([0,1,11]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=j,e.$Wq=I,e.$Xq=N,e.log=E;function j(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function I(a){const f=[];let v;try{const y=JSON.parse(a.arguments),w=y[y.length-1];w&&w.__$stack&&(y.pop(),v=w.__$stack),f.push(...y)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:v}}function N(a){if(typeof a!="string")return N(I(a).stack);const f=a;if(f){const v=A(f),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:D.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function A(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function E(a,f){const{args:v,stack:y}=I(a),w=typeof v[0]=="string"&&v.length===1;let p=A(y);p&&(p=`(${p.trim()})`);let k=[];if(typeof v[0]=="string"?p&&w?k=[`%c[${f}] %c${v[0]} %c${p}`,l("blue"),l(""),l("grey")]:k=[`%c[${f}] %c${v[0]}`,l("blue"),l(""),...v.slice(1)]:k=[`%c[${f}]%`,l("blue"),...v],p&&!w&&k.push(p),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,k)}function l(a){return`color: ${a}`}}),define(ne[47],se([0,1,14,11]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=I,e.$5h=N,e.$6h=E;function I(l){return JSON.stringify(l,A)}function N(l){let a=JSON.parse(l);return a=E(a),a}function A(l,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function E(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return j.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof D.$Fe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let f=0;f<l.length;++f)l[f]=E(l[f],a+1);else for(const f in l)Object.hasOwnProperty.call(l,f)&&(l[f]=E(l[f],a+1))}return l}}),define(ne[85],se([0,1,72,15,12,11]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=f;class A{constructor(y,w,p){this.id=y,this.dependencies=w,this.callback=p}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(y,w,p)=>{typeof y!="string"&&(p=w,w=y,y=null),(typeof w!="object"||!Array.isArray(w))&&(p=w,w=null),this.c.push(new A(y,w,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this.g();const w=await(this.a?this.i(y):this.b?this.h(y):this.j(y));if(!w)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(y){return new Promise((w,p)=>{const k=document.createElement("script");k.setAttribute("async","async"),k.setAttribute("type","text/javascript");const g=()=>{k.removeEventListener("load",c),k.removeEventListener("error",u)},c=b=>{g(),w(this.c.pop())},u=b=>{g(),p(b)};k.addEventListener("load",c),k.addEventListener("error",u),this.f&&(y=this.f.createScriptURL(y)),k.setAttribute("src",y),window.document.getElementsByTagName("head")[0].appendChild(k)})}i(y){return new Promise((w,p)=>{try{this.f&&(y=this.f.createScriptURL(y)),importScripts(y),w(this.c.pop())}catch(k){p(k)}})}async j(y){try{const w=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,k=globalThis._VSCODE_NODE_MODULES.module,g=N.URI.parse(y).fsPath,c=w.readFileSync(g).toString(),u=k.wrap(c.replace(/^#!.*/,""));return new p.Script(u).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const l=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function f(v,y,w){if(D.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[v]&&(v=a[v]);const p=`${v}/${y}`;if(l.has(p))return l.get(p);let k;if(/^\w[\w\d+.-]*:\/\//.test(p))k=p;else{const b=`${w&&!I.$o?j.$Ng:j.$Mg}/${p}`;k=j.$Qg.asBrowserUri(b).toString(!0)}const g=E.INSTANCE.load(k);return l.set(p,g),g}else return await new Promise((p,k)=>{J([v],p,k)})}}),define(ne[86],se([0,1,33,48,28,78,12]),function(J,e,D,j,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$Fn=l,e.$Gn=v,e.$En=new class{c(y){return this.a||(this.a=j.$Ci.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,w=0;const p=(0,D.networkInterfaces)();for(const k in p){const g=p[k];if(g)for(const{mac:c,internal:u}of g)u||(w+=1,this.c(c.toUpperCase())&&(y+=1))}this.b=w>0?y/w:0}return this.b}};let E;async function l(y){return E||(E=(async()=>await a(y)||I.$Sg())()),E}async function a(y){try{const w=await new Promise((k,g)=>{J(["crypto"],k,g)}),p=(0,N.$Dn)();return w.createHash("sha256").update(p,"utf8").digest("hex")}catch(w){y(w);return}}const f="Software\\Microsoft\\SQMClient";async function v(y){if(A.$i){const w=await new Promise((p,k)=>{J(["@vscode/windows-registry"],p,k)});try{return w.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(p){return y(p),""}}return""}}),define(ne[87],se([0,1,33,16,25]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=u,e.$lm=b;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var l;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(l||(l={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=1:f=0;class v{constructor($,n,r){this.exePath=$,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await I.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:m=!1}={}){return m?a===0?process.env["ProgramFiles(x86)"]||null:f===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:m=!1,findPreview:$=!1}={}){const n=y({useAlternateBitness:m});if(!n)return null;const r=j.$jc(n,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const h of await I.Promises.readdir(r)){let P=-1;if($){const O=h.indexOf("-");if(O<0)continue;const z=h.substring(0,O);if(!N.test(z)||h.substring(O+1)!=="preview")continue;P=parseInt(z,10)}else{if(!N.test(h))continue;P=parseInt(h,10)}if(P<=t)continue;const R=j.$jc(r,h,"pwsh.exe");await I.SymlinkSupport.existsFile(R)&&(i=R,t=P)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=$?" Preview":"";return new v(i,`PowerShell${o}${s}`,!0)}async function p({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const $=j.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory($))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=m?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await I.Promises.readdir($))if(n.test(t)){const i=j.$jc($,t,"pwsh.exe");return new v(i,r)}return null}function k(){const m=j.$jc(D.homedir(),".dotnet","tools","pwsh.exe");return new v(m,".NET Core PowerShell Global Tool")}function g(){const m=j.$jc(process.env.windir,a===1&&f!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(m,"Windows PowerShell",!0)}async function*c(){let m=await w();m&&(yield m),m=await w({useAlternateBitness:!0}),m&&(yield m),m=await p(),m&&(yield m),m=k(),m&&(yield m),m=await w({findPreview:!0}),m&&(yield m),m=await p({findPreview:!0}),m&&(yield m),m=await w({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=g(),m&&(yield m)}async function*u(){for await(const m of c())await m.exists()&&(yield m)}async function b(){for await(const m of u())return m;return null}}),define(ne[57],se([0,1,16,12,35,56,3,25]),function(J,e,D,j,I,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=l,e.$pm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function l(v=I.env){return v.comspec||"cmd.exe"}function a(v){let y=[],w=!1;const p=function(k){if(w){y.push(k);return}(!v.send(k,c=>{if(c&&console.error(c),w=!1,y.length>0){const u=y.slice(0);y=[],u.forEach(b=>p(b))}})||j.$i)&&(w=!0)};return{send:p}}var f;(function(v){async function y(w,p,k){if(D.$ic(w))return w;if(p===void 0&&(p=I.cwd()),D.$mc(w)!=="."||(k===void 0&&A.$9f(I.env.PATH)&&(k=I.env.PATH.split(D.$tc)),k===void 0||k.length===0))return D.$jc(p,w);async function c(u){if(await E.Promises.exists(u)){let b;try{b=await E.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(b=await E.Promises.lstat(u))}return b?!b.isDirectory():!1}return!1}for(const u of k){let b;if(D.$ic(u)?b=D.$jc(u,w):b=D.$jc(p,u,w),await c(b))return b;let m=b+".com";if(await c(m)||(m=b+".exe",await c(m)))return m}return D.$jc(p,w)}v.findExecutable=y})(f||(e.win32=f={}))}),define(ne[88],se([0,1,33,12,87,57]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=A;async function A(v,y){return v===1?j.$i?f():N.$om(y):l(v,y)}let E=null;function l(v,y){if(j.$k&&v===2||j.$j&&v===3)return"/bin/bash";if(!E){let w;if(j.$i)w="/bin/bash";else{if(w=y.SHELL,!w)try{w=(0,D.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}E=w}return E}let a=null;async function f(){return a||(a=(await(0,I.$lm)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,D,j){var I=arguments.length,N=I<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,D):j,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(J,e,D,j);else for(var E=J.length-1;E>=0;E--)(A=J[E])&&(N=(I<3?A(N):I>3?A(e,D,N):A(e,D))||N);return I>3&&N&&Object.defineProperty(e,D,N),N};define(ne[58],se([0,1,19,8,14,20,54,9,5,2,47,31,3]),function(J,e,D,j,I,N,A,E,l,a,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=o,e.$0h=h,e.$ci=T,e.$di=Q;var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function p(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var k;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(k||(k={}));function g(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(c||(c={}));function u(B){let q=0;for(let W=0;;W+=7){const X=B.read(1);if(q|=(X.buffer[0]&127)<<W,!(X.buffer[0]&128))return q}}const b=t(0);function m(B,q){if(q===0){B.write(b);return}let W=0;for(let Y=q;Y!==0;Y=Y>>>7)W++;const X=I.$Fe.alloc(W);for(let Y=0;q!==0;Y++)X.buffer[Y]=q&127,q=q>>>7,q>0&&(X.buffer[Y]|=128);B.write(X)}class ${constructor(q){this.b=q,this.a=0}read(q){const W=this.b.slice(this.a,this.a+q);return this.a+=W.byteLength,W}}e.$7h=$;class n{constructor(){this.a=[]}get buffer(){return I.$Fe.concat(this.a)}write(q){this.a.push(q)}}e.$8h=n;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function t(B){const q=I.$Fe.alloc(1);return q.writeUInt8(B,0),q}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(B,q){if(typeof q>"u")B.write(i.Undefined);else if(typeof q=="string"){const W=I.$Fe.fromString(q);B.write(i.String),m(B,W.byteLength),B.write(W)}else if(s&&Buffer.isBuffer(q)){const W=I.$Fe.wrap(q);B.write(i.Buffer),m(B,W.byteLength),B.write(W)}else if(q instanceof I.$Fe)B.write(i.VSBuffer),m(B,q.byteLength),B.write(q);else if(Array.isArray(q)){B.write(i.Array),m(B,q.length);for(const W of q)o(B,W)}else if(typeof q=="number"&&(q|0)===q)B.write(i.Uint),m(B,q);else{const W=I.$Fe.fromString(JSON.stringify(q));B.write(i.Object),m(B,W.byteLength),B.write(W)}}function h(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(u(B)).toString();case r.Buffer:return B.read(u(B)).buffer;case r.VSBuffer:return B.read(u(B));case r.Array:{const W=u(B),X=[];for(let Y=0;Y<W;Y++)X.push(h(B));return X}case r.Object:return JSON.parse(B.read(u(B)).toString());case r.Int:return u(B)}}class P{constructor(q,W,X=null,Y=1e3){this.h=q,this.j=W,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(q,W){this.b.set(q,W),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const W=this.o([q.type]);this.k?.logOutgoing(W,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const W=this.o([q.type,q.id],q.data);this.k?.logOutgoing(W,q.id,1,g(q.type),q.data);return}}}o(q,W=void 0){const X=new n;return o(X,q),o(X,W),this.p(X.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const W=new $(q),X=h(W),Y=h(W),_=X[0];switch(_){case 100:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}: ${X[2]}.${X[3]}`,Y),this.s({type:_,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}: ${X[2]}.${X[3]}`,Y),this.t({type:_,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}`),this.u({type:_,id:X[1]});case 103:return this.k?.logIncoming(q.byteLength,X[1],1,`${p(_)}`),this.u({type:_,id:X[1]})}}s(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const X=new N.$oe;let Y;try{Y=W.call(this.j,q.name,q.arg,X.token)}catch(U){Y=Promise.reject(U)}const _=q.id;Y.then(U=>{this.m({id:_,data:U,type:201})},U=>{U instanceof Error?this.m({id:_,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:_,data:U,type:203})}).finally(()=>{F.dispose(),this.d.delete(q.id)});const F=(0,a.$Sc)(()=>X.cancel());this.d.set(q.id,F)}t(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const X=q.id,_=W.listen(this.j,q.name,q.arg)(F=>this.m({id:X,data:F,type:204}));this.d.set(q.id,_)}u(q){const W=this.d.get(q.id);W&&(W.dispose(),this.d.delete(q.id))}v(q){let W=this.g.get(q.channelName);W||(W=[],this.g.set(q.channelName,W));const X=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:q,timeoutTimer:X})}w(q){const W=this.g.get(q);if(W){for(const X of W)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$$h=P;var R;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class O{constructor(q,W=null){this.l=q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$de,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=W}getChannel(q){const W=this;return{call(X,Y,_){return W.a?Promise.reject(new E.$5):W.m(q,X,Y,_)},listen(X,Y){return W.a?l.Event.None:W.o(q,X,Y)}}}m(q,W,X,Y=N.CancellationToken.None){const _=this.g++,U={id:_,type:100,channelName:q,name:W,arg:X};if(Y.isCancellationRequested)return Promise.reject(new E.$5);let d;return new Promise((L,C)=>{if(Y.isCancellationRequested)return C(new E.$5);const G=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(_),L(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,C(ye);break}case 203:this.f.delete(_),C(pe.data);break}};this.f.set(_,ue),this.p(U)};let H=null;this.b===c.Idle?G():(H=(0,j.$jh)(ue=>this.u()),H.then(()=>{H=null,G()}));const te=()=>{H?(H.cancel(),H=null):this.p({id:_,type:101}),C(new E.$5)},ae=Y.onCancellationRequested(te);d=(0,a.$Rc)((0,a.$Sc)(te),ae),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(q,W,X){const Y=this.g++,F={id:Y,type:102,channelName:q,name:W,arg:X};let U=null;const d=new l.$de({onWillAddFirstListener:()=>{U=(0,j.$jh)(L=>this.u()),U.then(()=>{U=null,this.d.add(d),this.p(F)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(d),this.p({id:Y,type:103}))}}),S=L=>d.fire(L.data);return this.f.set(Y,S),d.event}p(q){switch(q.type){case 100:case 102:{const W=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(W,q.id,0,`${p(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const W=this.q([q.type,q.id]);this.j?.logOutgoing(W,q.id,0,p(q.type));return}}}q(q,W=void 0){const X=new n;return o(X,q),o(X,W),this.r(X.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const W=new $(q),X=h(W),Y=h(W),_=X[0];switch(_){case 200:return this.j?.logIncoming(q.byteLength,0,0,g(_)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,X[1],0,g(_),Y),this.t({type:X[0],id:X[1],data:Y})}}t(q){if(q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$_h=O,$e([A.$1h],O.prototype,"onDidInitializePromise",null);class z{get connections(){const q=[];return this.f.forEach(W=>q.push(W)),q}constructor(q,W,X){this.a=new Map,this.f=new Set,this.g=new l.$de,this.onDidAddConnection=this.g.event,this.h=new l.$de,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(q(({protocol:Y,onDidClientDisconnect:_})=>{const F=l.Event.once(Y.onMessage);this.j.add(F(U=>{const d=new $(U),S=h(d),L=new P(Y,S,W,X),C=new O(Y,W);this.a.forEach((H,te)=>L.registerChannel(te,H));const G={channelServer:L,channelClient:C,ctx:S};this.f.add(G),this.g.fire(G),this.j.add(_(()=>{L.dispose(),C.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(q,W){const X=this;return{call(Y,_,F){let U;if((0,y.$kg)(W)){const S=(0,D.$3b)(X.connections.filter(W));U=S?Promise.resolve(S):l.Event.toPromise(l.Event.filter(X.onDidAddConnection,W))}else U=W.routeCall(X,Y,_);const d=U.then(S=>S.channelClient.getChannel(q));return T(d).call(Y,_,F)},listen(Y,_){if((0,y.$kg)(W))return X.k(q,W,Y,_);const F=W.routeEvent(X,Y,_).then(U=>U.channelClient.getChannel(q));return T(F).listen(Y,_)}}}k(q,W,X,Y){const _=this;let F;const U=new l.$de({onWillAddFirstListener:()=>{F=new a.$Tc;const d=new l.$je,S=new Map,L=G=>{const te=G.channelClient.getChannel(q).listen(X,Y),ae=d.add(te);S.set(G,ae)},C=G=>{const H=S.get(G);H&&(H.dispose(),S.delete(G))};_.connections.filter(W).forEach(L),l.Event.filter(_.onDidAddConnection,W)(L,void 0,F),_.onDidRemoveConnection(C,void 0,F),d.event(U.fire,U,F),F.add(d)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return U.event}registerChannel(q,W){this.a.set(q,W);for(const X of this.f)X.channelServer.registerChannel(q,W)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=z;class M{constructor(q,W,X=null){const Y=new n;o(Y,W),q.send(Y.buffer),this.a=new O(q,X),this.d=new P(q,W,X)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,W){this.d.registerChannel(q,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=M;function T(B){return{call(q,W,X){return B.then(Y=>Y.call(q,W,X))},listen(q,W){const X=new l.$me;return B.then(Y=>X.input=Y.listen(q,W)),X.event}}}function Q(B){let q=!1;return{call(W,X,Y){return q?B.call(W,X,Y):(0,j.$xh)(0).then(()=>q=!0).then(()=>B.call(W,X,Y))},listen(W,X){if(q)return B.listen(W,X);const Y=new l.$me;return(0,j.$xh)(0).then(()=>q=!0).then(()=>Y.input=B.listen(W,X)),Y.event}}}class re{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const W of q.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$ei=re;var ie;(function(B){function q(_,F,U){const d=_,S=U&&U.disableMarshalling,L=new Map;for(const C in d)X(C)&&L.set(C,l.Event.buffer(d[C],!0,void 0,F));return new class{listen(C,G,H){const te=L.get(G);if(te)return te;const ae=d[G];if(typeof ae=="function"){if(Y(G))return ae.call(d,H);if(X(G))return L.set(G,l.Event.buffer(d[G],!0,void 0,F)),L.get(G)}throw new E.$bb(`Event not found: ${G}`)}call(C,G,H){const te=d[G];if(typeof te=="function"){if(!S&&Array.isArray(H))for(let ue=0;ue<H.length;ue++)H[ue]=(0,f.$6h)(H[ue]);let ae=te.apply(d,H);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${G}`)}}}B.fromService=q;function W(_,F){const U=F&&F.disableMarshalling;return new Proxy({},{get(d,S){if(typeof S=="string")return F?.properties?.has(S)?F.properties.get(S):Y(S)?function(L){return _.listen(S,L)}:X(S)?_.listen(S):async function(...L){let C;F&&!(0,y.$fg)(F.context)?C=[F.context,...L]:C=L;const G=await _.call(S,C);return U?G:(0,f.$6h)(G)};throw new E.$bb(`Property not found: ${String(S)}`)}})}B.toService=W;function X(_){return _[0]==="o"&&_[1]==="n"&&v.$wf(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&v.$wf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const q=B.toString();if(q!=="[object Object]")return q}return B}function ce(B){return Array.isArray(B)?B.map(le):le(B)}function V(B,q,W,X,Y,_,F){F=ce(F);const U=he[Y],d=U[X%U.length];let S=[`%c[${B}]%c[${String(q).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(_)?(S=S.concat(F),S.push(")")):S.push(F),console.log.apply(console,S)}class Z{constructor(q,W){this.d=q,this.f=W,this.a=0,this.b=0}logOutgoing(q,W,X,Y,_){this.b+=q,V(this.d,this.b,q,W,X,Y,_)}logIncoming(q,W,X,Y,_){this.a+=q,V(this.f,this.a,q,W,X,Y,_)}}e.$fi=Z}),define(ne[89],se([0,1,59,8,14,20,84,9,5,2,27,57,56,58]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class p extends w.$$h{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",u=>I.$Fe.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Zq=p;class k{constructor(c,u){this.i=c,this.j=u,this.c=new Set,this.g=new Map,this.h=new l.$de,this.onDidProcessExit=this.h.event;const b=u&&u.timeout?u.timeout:6e4;this.b=new j.$th(b),this.d=null,this.f=null}getChannel(c){const u=this;return{call(b,m,$){return u.k(c,b,m,$)},listen(b,m){return u.l(c,b,m)}}}k(c,u,b,m=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const $=this.n(c),n=(0,j.$jh)(i=>$.call(u,b,i)),r=m.onCancellationRequested(()=>n.cancel()),t=(0,a.$Sc)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(c,u,b){if(!this.b)return l.Event.None;this.b.cancel();let m;const $=new l.$de({onWillAddFirstListener:()=>{m=this.n(c).listen(u,b)($.fire,$),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,f.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,y.$nm)(u.env),this.d=(0,D.fork)(this.i,c,u);const b=new l.$de,$=l.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$Vq)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}b.fire(I.$Fe.wrap(Buffer.from(o,"base64")))}),n=this.j.useQueue?(0,v.$pm)(this.d):this.d,r=o=>this.d&&this.d.connected&&n.send(o.buffer.toString("base64")),t=b.event,i={send:r,onMessage:t};this.f=new w.$_h(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",s),$.dispose(),this.c.forEach(P=>(0,a.$Pc)(P)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(c){let u=this.g.get(c);return u||(u=this.m.getChannel(c),this.g.set(c,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=k}),define(ne[90],se([0,1,8,5,2,47,3]),function(J,e,D,j,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=l;var E;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function l(y){const w=y;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends I.$Uc{static{this.a=100}constructor(w,p=Object.create(null)){super(),this.r=w,this.s=p,this.b=this.B(new j.$ge),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new D.$uh(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((p,k)=>this.w(k,p)),w.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(w,p){if(this.c===a.Closed)return;let k=!1;(0,A.$fg)(p)?k=this.f.delete(w):this.f.get(w)!==p&&(this.f.set(w,p),k=!0),k&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,p){const k=this.f.get(w);return(0,A.$fg)(k)?p:k}getBoolean(w,p){const k=this.get(w);return(0,A.$fg)(k)?p:k==="true"}getNumber(w,p){const k=this.get(w);return(0,A.$fg)(k)?p:parseInt(k,10)}getObject(w,p){const k=this.get(w);return(0,A.$fg)(k)?p:(0,N.$5h)(k)}async set(w,p,k=!1){if(this.c===a.Closed)return;if((0,A.$fg)(p))return this.delete(w,k);const g=(0,A.$$f)(p)||Array.isArray(p)?(0,N.$4h)(p):String(p);if(this.f.get(w)!==g)return this.f.set(w,g),this.j.set(w,g),this.h.delete(w),this.b.fire({key:w,external:k}),this.D()}async delete(w,p=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:p}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Wp=f;class v{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((p,k)=>this.a.set(k,p)),w.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$Xp=v}),define(ne[91],se([7,4]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[49],se([0,1,60,8,16,3,25,91]),function(J,e,D,j,I,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0,e.zip=g,e.$jq=c,e.$kq=b,e.$gq="end of central directory record signature not found";const l=new RegExp(e.$gq);class a extends Error{constructor($,n){let r=n.message;switch($){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=$,this.cause=n}}e.$hq=a;function f(m){const $=m.externalFileAttributes>>16||33188;return[448,56,7].map(n=>$&n).reduce((n,r)=>n+r,$&61440)}function v(m){if(m instanceof a)return m;let $;return l.test(m.message)&&($="CorruptZip"),new a($,m)}function y(m,$,n,r,t,i){const s=I.$mc($),o=I.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(E.localize(0,null,$)));const h=I.$jc(r,$);let P;return i.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,O)=>{if(!i.isCancellationRequested)try{P=(0,D.createWriteStream)(h,{mode:n}),P.once("close",()=>R()),P.once("error",O),m.once("error",O),m.pipe(P)}catch(z){O(z)}}))}function w(m,$,n,r){let t=(0,j.$jh)(()=>Promise.resolve()),i=0;const s=r.onCancellationRequested(()=>{t.cancel(),m.close()});return new Promise((o,h)=>{const P=new j.$rh,R=O=>{O.isCancellationRequested||(i++,m.readEntry())};m.once("error",h),m.once("close",()=>t.then(()=>{r.isCancellationRequested||m.entryCount===i?o():h(new a("Incomplete",new Error(E.localize(1,null,i,m.entryCount))))},h)),m.readEntry(),m.on("entry",O=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(O.fileName)){R(r);return}const z=O.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(z)){const Q=I.$jc($,z);t=(0,j.$jh)(re=>A.Promises.mkdir(Q,{recursive:!0}).then(()=>R(re)).then(void 0,h));return}const M=k(m,O),T=f(O);t=(0,j.$jh)(Q=>P.queue(()=>M.then(re=>y(re,z,T,$,n,Q).then(()=>R(Q)))).then(null,h))})}).finally(()=>s.dispose())}async function p(m,$=!1){const{open:n}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{n(m,$?{lazyEntries:!0}:void 0,(i,s)=>{i?t(v(i)):r((0,N.$hg)(s))})})}function k(m,$){return new Promise((n,r)=>{m.openReadStream($,(t,i)=>{t?r(v(t)):n((0,N.$hg)(i))})})}async function g(m,$){const{ZipFile:n}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const i=new n;$.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,D.createWriteStream)(m);i.outputStream.pipe(s),i.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(m))})}function c(m,$,n={},r){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=p(m,!0);return n.overwrite&&(i=i.then(s=>A.Promises.rm($).then(()=>s))),i.then(s=>w(s,$,{sourcePathRegex:t},r))}function u(m,$){return p(m).then(n=>new Promise((r,t)=>{n.on("entry",i=>{i.fileName===$&&k(n,i).then(s=>r(s),s=>t(s))}),n.once("close",()=>t(new Error(E.localize(2,null,$))))}))}function b(m,$){return u(m,$).then(n=>new Promise((r,t)=>{const i=[];n.once("error",t),n.on("data",s=>i.push(s)),n.on("end",()=>r(Buffer.concat(i)))}))}}),define(ne[92],se([7,4]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[93],se([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[94],se([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[95],se([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[96],se([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[97],se([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[98],se([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[99],se([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[100],se([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[101],se([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[102],se([7,4]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[103],se([7,4]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[104],se([7,4]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[105],se([7,4]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[106],se([7,4]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[107],se([7,4]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(ne[108],se([7,4]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[109],se([7,4]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[110],se([7,4]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[111],se([7,4]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[112],se([7,4]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[113],se([0,1,9,94]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var I;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(I||(e.TokenType=I={}));function N(...a){switch(a.length){case 1:return(0,j.localize)(0,null,a[0]);case 2:return(0,j.localize)(1,null,a[0],a[1]);case 3:return(0,j.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,j.localize)(3,null),E=(0,j.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return f.isTripleEq?"===":"==";case 4:return f.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return f.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return f.lexeme;case 18:return f.lexeme;case 19:return f.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(f){return this.c=f,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(f){return this.r()||this.c.charCodeAt(this.e)!==f?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(f){this.f.push({type:f,offset:this.d})}l(f){const v=this.d,y=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:y};this.g.push({offset:v,lexeme:y,additionalInfo:f}),this.f.push(w)}n(){this.m.lastIndex=this.d;const f=this.m.exec(this.c);if(f){this.e=this.d+f[0].length;const v=this.c.substring(this.d,this.e),y=l.b.get(v);y?this.k(y):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let f=this.e,v=!1,y=!1;for(;;){if(f>=this.c.length){this.e=f,this.l(E);return}const p=this.c.charCodeAt(f);if(v)v=!1;else if(p===47&&!y){f++;break}else p===91?y=!0:p===92?v=!0:p===93&&(y=!1);f++}for(;f<this.c.length&&l.a.has(this.c.charCodeAt(f));)f++;this.e=f;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=l}),define(ne[114],se([0,1,80,54,15,16,35,17,11]),function(J,e,D,j,I,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=f,e.$8m=v,e.$5m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(I.$Qg.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,E.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,D.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",w)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$0g)(l.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?l.URI.file((0,N.$jc)(w,"argv.json")):(0,E.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,N.$kc)(w):(0,N.$hc)((0,N.$jc)(I.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?l.URI.file((0,N.$kc)(w)):l.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,N.$kc)(w);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const k=A.env.VSCODE_PORTABLE;return k?(0,N.$jc)(k,"extensions"):(0,E.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(p=>/^[^:/?#]+?:\/\//.test(p)?l.URI.parse(p):l.URI.file((0,N.$hc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?l.URI.parse(w):l.URI.file((0,N.$hc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$5m.test(w))}get extensionLogLevel(){const w=[];for(const p of this.args.log||[]){const k=e.$5m.exec(p);k&&k[1]&&k[2]&&w.push([k[1],k[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,E.$0g)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?l.URI.file((0,N.$jc)(w,"policy.json")):(0,E.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,p,k){this.a=w,this.b=p,this.c=k,this.editSessionId=this.args.editSessionId}}e.$6m=a,$e([j.$1h],a.prototype,"appRoot",null),$e([j.$1h],a.prototype,"userHome",null),$e([j.$1h],a.prototype,"userDataPath",null),$e([j.$1h],a.prototype,"appSettingsHome",null),$e([j.$1h],a.prototype,"tmpDir",null),$e([j.$1h],a.prototype,"cacheHome",null),$e([j.$1h],a.prototype,"stateResource",null),$e([j.$1h],a.prototype,"userRoamingDataHome",null),$e([j.$1h],a.prototype,"userDataSyncHome",null),$e([j.$1h],a.prototype,"sync",null),$e([j.$1h],a.prototype,"machineSettingsResource",null),$e([j.$1h],a.prototype,"workspaceStorageHome",null),$e([j.$1h],a.prototype,"localHistoryHome",null),$e([j.$1h],a.prototype,"keyboardLayoutResource",null),$e([j.$1h],a.prototype,"argvResource",null),$e([j.$1h],a.prototype,"isExtensionDevelopment",null),$e([j.$1h],a.prototype,"untitledWorkspacesHome",null),$e([j.$1h],a.prototype,"builtinExtensionsPath",null),$e([j.$1h],a.prototype,"extensionsPath",null),$e([j.$1h],a.prototype,"extensionDevelopmentLocationURI",null),$e([j.$1h],a.prototype,"extensionDevelopmentKind",null),$e([j.$1h],a.prototype,"extensionTestsLocationURI",null),$e([j.$1h],a.prototype,"debugExtensionHost",null),$e([j.$1h],a.prototype,"logLevel",null),$e([j.$1h],a.prototype,"extensionLogLevel",null),$e([j.$1h],a.prototype,"serviceMachineIdResource",null),$e([j.$1h],a.prototype,"disableTelemetry",null),$e([j.$1h],a.prototype,"disableWorkspaceTrust",null),$e([j.$1h],a.prototype,"useInMemorySecretStorage",null),$e([j.$1h],a.prototype,"policyFile",null);function f(y,w){return v(y["inspect-extensions"],y["inspect-brk-extensions"],5870,w,y.debugId,y.extensionEnvironment)}function v(y,w,p,k,g,c){const b=Number(w||y)||(k?null:p),m=b?!!w:!1;let $;if(c)try{$=JSON.parse(c)}catch{}return{port:b,break:m,debugId:g,env:$}}}),function(){"use strict";function J(e,D,j){function I(A,E){const l=N(A,E),a=[l];return e.isAbsolute(l)||a.unshift(j),e.resolve(...a)}function N(A,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,E);const f=A["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(D.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,E)}return{getUserDataPath:I}}if(typeof define=="function")define(ne[115],se([170,33,35]),function(e,D,j){return J(e,D,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=J(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[116],se([0,1,33,114,115]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=A,e.$$m=E;class N extends j.$6m{constructor(a,f){super(a,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,I.getUserDataPath)(a,f.nameShort)},f)}}e.$9m=N;function A(l,a){return(0,j.$8m)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,a,l.extensionEnvironment)}function E(l,a){return(0,j.$8m)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,a,l.extensionEnvironment)}}),define(ne[117],se([0,1,3,98]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=I;function I(A,E,l,a){try{N(A,E,l,a)}catch(f){A.error(f?.message??f)}return E}function N(A,E,l,a){const f=(v,y,w)=>{const p=v[y];if((0,D.$9f)(p)){const k=p,g=k.length;if(g>1&&k[0]==="%"&&k[g-1]==="%"){const c=k.substr(1,g-2);let u=l[c];u===void 0&&a&&(u=a[c]);const b=typeof u=="string"?u:u?.message,m=a?.[c],$=typeof m=="string"?m:m?.message;if(!b){$||A.warn(`[${E.name}]: ${(0,j.localize)(0,null,c)}`);return}if(w&&(y==="title"||y==="category")&&$&&$!==b){const n={value:b,original:$};v[y]=n}else v[y]=b}}else if((0,D.$$f)(p))for(const k in p)p.hasOwnProperty(k)&&(k==="commands"?f(p,k,!0):f(p,k,w));else if(Array.isArray(p))for(let k=0;k<p.length;k++)f(p,k,w)};for(const v in E)E.hasOwnProperty(v)&&f(E,v)}}),define(ne[118],se([0,1,49,101]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=I;function I(N){return(0,D.$kq)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,j.localize)(0,null))}})}}),define(ne[50],se([0,1,17,55,102,44]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=l,e.$Hp=a,e.$Ip=f,e.$Jp=v,e.$Kp=y,e.$Lp=w,e.$Mp=p;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function l(c){return c=c.trim(),c==="*"||A.test(c)}function a(c){if(!l(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function f(c){if(!c)return null;const u=c.majorBase,b=c.majorMustEqual,m=c.minorBase;let $=c.minorMustEqual;const n=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(u===0||($=!1),r=!1);let t=0;if(c.preRelease){const i=E.exec(c.preRelease);if(i){const[,s,o,h]=i;t=Date.UTC(Number(s),Number(o)-1,Number(h))}}return{majorBase:u,majorMustEqual:b,minorBase:m,minorMustEqual:$,patchBase:n,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function v(c,u,b){let m;typeof c=="string"?m=f(a(c)):m=c;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let n;if(typeof b=="string"?n=f(a(b)):n=b,!m||!n)return!1;const r=m.majorBase,t=m.minorBase,i=m.patchBase;let s=n.majorBase,o=n.minorBase,h=n.patchBase;const P=n.notBefore;let R=n.majorMustEqual,O=n.minorMustEqual,z=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||$&&$<P?!1:i>=h:(r===1&&s===0&&(!R||!O||!z)&&(s=1,o=0,h=0,R=!0,O=!1,z=!1),r<s?!1:r>s?!R:t<o?!1:t>o?!O:i<h?!1:i>h?!z:!($&&$<P))}function y(c,u,b,m,$){const n=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return n.push([j.default.Error,I.localize(0,null)]),n;if(typeof m.name!="string")return n.push([j.default.Error,I.localize(1,null,"name")]),n;if(typeof m.version!="string")return n.push([j.default.Error,I.localize(2,null,"version")]),n;if(!m.engines)return n.push([j.default.Error,I.localize(3,null,"engines")]),n;if(typeof m.engines.vscode!="string")return n.push([j.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof m.extensionDependencies<"u"&&!g(m.extensionDependencies))return n.push([j.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof m.activationEvents<"u"){if(!g(m.activationEvents))return n.push([j.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof m.main>"u"&&typeof m.browser>"u")return n.push([j.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&n.push([j.default.Warning,I.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return n.push([j.default.Error,I.localize(9,null,"main")]),n;{const i=(0,D.$0g)(b,m.main);(0,D.$4g)(i,b)||n.push([j.default.Warning,I.localize(10,null,i.path,b.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return n.push([j.default.Error,I.localize(11,null,"browser")]),n;{const i=(0,D.$0g)(b,m.browser);(0,D.$4g)(i,b)||n.push([j.default.Warning,I.localize(12,null,i.path,b.path)])}}if(!N.valid(m.version))return n.push([j.default.Error,I.localize(13,null)]),n;const r=[];if(!w(c,u,m,$,r))for(const i of r)n.push([j.default.Error,i]);return n}function w(c,u,b,m,$){return m||typeof b.main>"u"&&typeof b.browser>"u"?!0:k(c,u,b.engines.vscode,$)}function p(c,u,b){return c==="*"||k(u,b,c)}function k(c,u,b,m=[]){const $=f(a(b));if(!$)return m.push(I.localize(14,null,b)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return m.push(I.localize(15,null,b)),!1}else if(!$.majorMustEqual)return m.push(I.localize(16,null,b)),!1;return v(c,u,$)?!0:(m.push(I.localize(17,null,c,b)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let u=0,b=c.length;u<b;u++)if(typeof c[u]!="string")return!1;return!0}}),define(ne[119],se([0,1,14,28]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=I;async function I(N,A,E){let l=E&&E.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const f=(await A.readFile(N.serviceMachineIdResource)).value.toString();l=(0,j.$Rg)(f)?f:null}catch{l=null}if(!l){l=(0,j.$Sg)();try{await A.writeFile(N.serviceMachineIdResource,D.$Fe.fromString(l))}catch{}}return E?.store("storage.serviceMachineId",l,-1,1),l}}),define(ne[51],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class D{constructor(I,N=[],A=!1){this.ctor=I,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$ti=D}),define(ne[120],se([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=N,e.$ys=A;const j=[];var I;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function N(E,l,a){l instanceof D.$ti||(l=new D.$ti(l,[],!!a)),j.push([E,l])}function A(){return j}}),define(ne[121],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class D{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ar=D;class j{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const E=this.lookupOrInsertNode(N),l=this.lookupOrInsertNode(A);E.outgoing.set(l.key,l),l.incoming.set(E.key,E)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const E of this.a.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let E=this.a.get(A);return E||(E=new D(A,N),this.a.set(A,E)),E}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,E]of this.a)N.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const E=new Set([N]),l=this.c(A,E);if(l)return l}}c(N,A){for(const[E,l]of N.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const a=this.c(l,A);if(a)return a;A.delete(E)}}}e.$br=j}),define(ne[29],se([0,1,3,11,10]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=N,e.$5i=A,e.$6i=l,e.$7i=a,e.$8i=f,e.$9i=v,e.$0i=y,e.$$i=p,e.$_i=k,e.$aj=g,e.$3i=(0,I.$wi)("configurationService");function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof j.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof j.URI)}var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function l(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function f(c,u){const b=Object.create(null);for(const m in c)v(b,m,c[m],u);return b}function v(c,u,b,m){const $=u.split("."),n=$.pop();let r=c;for(let t=0;t<$.length;t++){const i=$[t];let s=r[i];switch(typeof s){case"undefined":s=r[i]=Object.create(null);break;case"object":if(s===null){m(`Ignoring ${u} as ${$.slice(0,t+1).join(".")} is null`);return}break;default:m(`Ignoring ${u} as ${$.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=b}catch{m(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}else m(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}function y(c,u){const b=u.split(".");w(c,b)}function w(c,u){const b=u.shift();if(u.length===0){delete c[b];return}if(Object.keys(c).indexOf(b)!==-1){const m=c[b];typeof m=="object"&&!Array.isArray(m)&&(w(m,u),Object.keys(m).length===0&&delete c[b])}}function p(c,u,b){function m(r,t){let i=r;for(const s of t){if(typeof i!="object"||i===null)return;i=i[s]}return i}const $=u.split("."),n=m(c,$);return typeof n>"u"?b:n}function k(c,u,b){Object.keys(u).forEach(m=>{m!=="__proto__"&&(m in c?D.$$f(c[m])&&D.$$f(u[m])?k(c[m],u[m],b):b&&(c[m]=u[m]):c[m]=u[m])})}function g(c){return c.replace(/[\[\]]/g,"")}}),define(ne[122],se([0,1,12,31,113,10,93,9]),function(J,e,D,j,I,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=a,e.$vj=r,e.$wj=t,e.$Pj=Y;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",D.$j),l.set("isLinux",D.$k),l.set("isWindows",D.$i),l.set("isWeb",D.$o),l.set("isMacNative",D.$j&&!D.$o),l.set("isEdge",D.$H),l.set("isFirefox",D.$F),l.set("isChrome",D.$E),l.set("isSafari",D.$G);function a(U,d){if(l.get(U)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(U,d)}const f=Object.prototype.hasOwnProperty;var v;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const y={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),p=(0,A.localize)(1,null),k=(0,A.localize)(2,null),g=(0,A.localize)(3,null),c=(0,A.localize)(4,null),u=(0,A.localize)(5,null),b=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=y){this.k=d,this.d=new I.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const S=this.l();if(!this.E()){const L=this.D(),C=L.type===17?u:void 0;throw this.h.push({message:c,offset:L.offset,lexeme:I.$rj.getLexeme(L),additionalInfo:C}),$.c}return S}catch(S){if(S!==$.c)throw S;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const S=this.o();d.push(S)}return d.length===1?d[0]:n.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const S=this.s();d.push(S)}return d.length===1?d[0]:n.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const S=this.l();return this.A(1,g),S?.negate()}case 17:return this.z(),M.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const S=this.l();return this.A(1,g),S}case 17:{const S=d.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const G=C.lexeme,H=G.lastIndexOf("/"),te=H===G.length-1?void 0:this.w(G.substring(H+1));let ae;try{ae=new RegExp(G.substring(1,H),te)}catch{throw this.B("REGEX",C)}return le.create(S,ae)}switch(C.type){case 10:case 19:{const G=[C.lexeme];this.z();let H=this.D(),te=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;G.push(I.$rj.getLexeme(H)),this.z(),H=this.D()}const ae=G.join(""),ue=ae.lastIndexOf("/"),pe=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let ye;try{ye=new RegExp(ae.substring(1,ue),pe)}catch{throw this.B("REGEX",C)}return n.regex(S,ye)}case 18:{const G=C.lexeme;this.z();let H=null;if(!(0,j.$7e)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const ue=G.slice(te+1,ae),pe=G[ae+1]==="i"?"i":"";try{H=new RegExp(ue,pe)}catch{throw this.B("REGEX",C)}}}if(H===null)throw this.B("REGEX",C);return le.create(S,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,k);const C=this.u();return n.notIn(S,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return n.equals(S,C);switch(C){case"true":return n.has(S);case"false":return n.not(S);default:return n.equals(S,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return n.notEquals(S,C);switch(C){case"true":return n.not(S);case"false":return n.has(S);default:return n.notEquals(S,C)}}case 5:return this.z(),ie.create(S,this.u());case 6:return this.z(),he.create(S,this.u());case 7:return this.z(),Q.create(S,this.u());case 8:return this.z(),re.create(S,this.u());case 13:return this.z(),n.in(S,this.u());default:return n.has(S)}}case 20:throw this.h.push({message:b,offset:d.offset,lexeme:"",additionalInfo:m}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,S){if(this.C(d))return this.z();throw this.B(S,this.D())}B(d,S,L){const C=(0,A.localize)(8,null,d,I.$rj.getLexeme(S)),G=S.offset,H=I.$rj.getLexeme(S);return this.h.push({message:C,offset:G,lexeme:H,additionalInfo:L}),$.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=$;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(d){return h.create(d)}static equals(d,S){return P.create(d,S)}static notEquals(d,S){return z.create(d,S)}static regex(d,S){return le.create(d,S)}static in(d,S){return R.create(d,S)}static notIn(d,S){return O.create(d,S)}static not(d){return M.create(d)}static and(...d){return Z.create(d,null,!0)}static or(...d){return B.create(d,null,!0)}static greater(d,S){return Q.create(d,S)}static greaterEquals(d,S){return re.create(d,S)}static smaller(d,S){return ie.create(d,S)}static smallerEquals(d,S){return he.create(d,S)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$uj=n;function r(U){const d=new $({regexParsingWithErrorRecovery:!1});return U.map(S=>(d.parse(S),d.lexingErrors.length>0?d.lexingErrors.map(L=>({errorMessage:L.additionalInfo?(0,A.localize)(9,null,L.additionalInfo):(0,A.localize)(10,null),offset:L.offset,length:L.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(L=>({errorMessage:L.additionalInfo?`${L.message}. ${L.additionalInfo}`:L.message,offset:L.offset,length:L.lexeme.length})):[]))}function t(U,d){const S=U?U.substituteConstants():void 0,L=d?d.substituteConstants():void 0;return!S&&!L?!0:!S||!L?!1:S.equals(L)}function i(U,d){return U.cmp(d)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return o.INSTANCE}}e.$xj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return s.INSTANCE}}e.$yj=o;class h{static create(d,S=null){const L=l.get(d);return typeof L=="boolean"?L?o.INSTANCE:s.INSTANCE:new h(d,S)}constructor(d,S){this.key=d,this.c=S,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:W(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=l.get(this.key);return typeof d=="boolean"?d?o.INSTANCE:s.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$zj=h;class P{static create(d,S,L=null){if(typeof S=="boolean")return S?h.create(d,L):M.create(d,L);const C=l.get(d);return typeof C=="boolean"?S===(C?"true":"false")?o.INSTANCE:s.INSTANCE:new P(d,S,L)}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=l.get(this.c);if(typeof d=="boolean"){const S=d?"true":"false";return this.d===S?o.INSTANCE:s.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Aj=P;class R{static create(d,S){return new R(d,S)}constructor(d,S){this.d=d,this.f=S,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:X(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const S=d.getValue(this.f),L=d.getValue(this.d);return Array.isArray(S)?S.includes(L):typeof L=="string"&&typeof S=="object"&&S!==null?f.call(S,L):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.$Bj=R;class O{static create(d,S){return new O(d,S)}constructor(d,S){this.d=d,this.f=S,this.type=11,this.c=R.create(d,S)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=O;class z{static create(d,S,L=null){if(typeof S=="boolean")return S?M.create(d,L):h.create(d,L);const C=l.get(d);return typeof C=="boolean"?S===(C?"true":"false")?s.INSTANCE:o.INSTANCE:new z(d,S,L)}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=l.get(this.c);if(typeof d=="boolean"){const S=d?"true":"false";return this.d===S?s.INSTANCE:o.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Dj=z;class M{static create(d,S=null){const L=l.get(d);return typeof L=="boolean"?L?s.INSTANCE:o.INSTANCE:new M(d,S)}constructor(d,S){this.c=d,this.d=S,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:W(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=l.get(this.c);return typeof d=="boolean"?d?s.INSTANCE:o.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$Ej=M;function T(U,d){if(typeof U=="string"){const S=parseFloat(U);isNaN(S)||(U=S)}return typeof U=="string"||typeof U=="number"?d(U):s.INSTANCE}class Q{static create(d,S,L=null){return T(S,C=>new Q(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$Fj=Q;class re{static create(d,S,L=null){return T(S,C=>new re(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Gj=re;class ie{static create(d,S,L=null){return T(S,C=>new ie(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Hj=ie;class he{static create(d,S,L=null){return T(S,C=>new he(d,C,L))}constructor(d,S,L){this.c=d,this.d=S,this.f=L,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Ij=he;class le{static create(d,S){return new le(d,S)}constructor(d,S){this.d=d,this.f=S,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const S=this.f?this.f.source:"",L=d.f?d.f.source:"";return S<L?-1:S>L?1:0}equals(d){if(d.type===this.type){const S=this.f?this.f.source:"",L=d.f?d.f.source:"";return this.d===d.d&&S===L}return!1}substituteConstants(){return this}evaluate(d){const S=d.getValue(this.d);return this.f?this.f.test(S):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Jj=le;class ce{static create(d){return new ce(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new ce(this.c.map(d))}negate(){return this.c}}e.$Kj=ce;function V(U){let d=null;for(let S=0,L=U.length;S<L;S++){const C=U[S].substituteConstants();if(U[S]!==C&&d===null){d=[];for(let G=0;G<S;G++)d[G]=U[G]}d!==null&&(d[S]=C)}return d===null?U:d}class Z{static create(d,S,L){return Z.d(d,S,L)}constructor(d,S){this.expr=d,this.c=S,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let S=0,L=this.expr.length;S<L;S++){const C=i(this.expr[S],d.expr[S]);if(C!==0)return C}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let S=0,L=this.expr.length;S<L;S++)if(!this.expr[S].equals(d.expr[S]))return!1;return!0}return!1}substituteConstants(){const d=V(this.expr);return d===this.expr?this:Z.create(d,this.c,!1)}evaluate(d){for(let S=0,L=this.expr.length;S<L;S++)if(!this.expr[S].evaluate(d))return!1;return!0}static d(d,S,L){const C=[];let G=!1;for(const H of d)if(H){if(H.type===1){G=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){C.push(...H.expr);continue}C.push(H)}if(C.length===0&&G)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(i);for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];for(;C.length>1;){const H=C[C.length-1];if(H.type!==9)break;C.pop();const te=C.pop(),ae=C.length===0,ue=B.create(H.expr.map(pe=>Z.create([pe,te],null,L)),null,ae);ue&&(C.push(ue),C.sort(i))}if(C.length===1)return C[0];if(L){for(let H=0;H<C.length;H++)for(let te=H+1;te<C.length;te++)if(C[H].negate().equals(C[te]))return s.INSTANCE;if(C.length===1)return C[0]}return new Z(C,S)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const S of this.expr)d.push(...S.keys());return d}map(d){return new Z(this.expr.map(S=>S.map(d)),null)}negate(){if(!this.c){const d=[];for(const S of this.expr)d.push(S.negate());this.c=B.create(d,this,!0)}return this.c}}e.$Lj=Z;class B{static create(d,S,L){return B.d(d,S,L)}constructor(d,S){this.expr=d,this.c=S,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let S=0,L=this.expr.length;S<L;S++){const C=i(this.expr[S],d.expr[S]);if(C!==0)return C}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let S=0,L=this.expr.length;S<L;S++)if(!this.expr[S].equals(d.expr[S]))return!1;return!0}return!1}substituteConstants(){const d=V(this.expr);return d===this.expr?this:B.create(d,this.c,!1)}evaluate(d){for(let S=0,L=this.expr.length;S<L;S++)if(this.expr[S].evaluate(d))return!0;return!1}static d(d,S,L){let C=[],G=!1;if(d){for(let H=0,te=d.length;H<te;H++){const ae=d[H];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){C=C.concat(ae.expr);continue}C.push(ae)}}if(C.length===0&&G)return s.INSTANCE;C.sort(i)}if(C.length!==0){if(C.length===1)return C[0];for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];if(L){for(let H=0;H<C.length;H++)for(let te=H+1;te<C.length;te++)if(C[H].negate().equals(C[te]))return o.INSTANCE;if(C.length===1)return C[0]}return new B(C,S)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const S of this.expr)d.push(...S.keys());return d}map(d){return new B(this.expr.map(S=>S.map(d)),null)}negate(){if(!this.c){const d=[];for(const S of this.expr)d.push(S.negate());for(;d.length>1;){const S=d.shift(),L=d.shift(),C=[];for(const G of F(S))for(const H of F(L))C.push(Z.create([G,H],null,!1));d.unshift(B.create(C,null,!1))}this.c=B.create(d,this,!0)}return this.c}}e.$Mj=B;class q extends h{static{this.d=[]}static all(){return q.d.values()}constructor(d,S,L){super(d,null),this.f=S,typeof L=="object"?q.d.push({...L,key:d}):L!==!0&&q.d.push({key:d,description:L,type:S!=null?typeof S:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return P.create(this.key,d)}notEqualsTo(d){return z.create(this.key,d)}}e.$Nj=q,e.$Oj=(0,N.$wi)("contextKeyService");function W(U,d){return U<d?-1:U>d?1:0}function X(U,d,S,L){return U<S?-1:U>S?1:d<L?-1:d>L?1:0}function Y(U,d){if(U.type===0||d.type===1)return!0;if(U.type===9)return d.type===9?_(U.expr,d.expr):!1;if(d.type===9){for(const S of d.expr)if(Y(U,S))return!0;return!1}if(U.type===6){if(d.type===6)return _(d.expr,U.expr);for(const S of U.expr)if(Y(S,d))return!0;return!1}return U.equals(d)}function _(U,d){let S=0,L=0;for(;S<U.length&&L<d.length;){const C=U[S].cmp(d[L]);if(C<0)return!1;C===0&&S++,L++}return S===U.length}function F(U){return U.type===9?U.expr:[U]}}),define(ne[61],se([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=void 0,e.$Ko=(0,D.$wi)("downloadService")}),define(ne[18],se([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,D.$wi)("environmentService"),e.$Ei=(0,D.$xi)(e.$Di)}),define(ne[21],se([0,1,96,10]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=I,e.$1o=N,e.$2o=A,e.$3o=E,e.$4o=l,e.$5o=a,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function I(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(u,b){switch(u){case 3:return b==="x64"?"win32-x64":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(u,b){return b==="web"&&!u.includes("web")}function l(u,b,m){return E(b,m)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===m}function a(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var f;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var y;(function(u){u.Install="install",u.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var w;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$6o=(0,j.$wi)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));class k extends Error{constructor(b,m){super(b),this.code=m,this.name=m}}e.$7o=k;var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class c extends Error{constructor(b,m){super(b),this.code=m,this.name=m}}e.$8o=c,e.$9o=(0,j.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,j.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,j.$wi)("IExtensionTipsService"),e.$bp=(0,D.localize2)(0,"Extensions"),e.$cp=(0,D.localize2)(1,"Preferences")}),define(ne[62],se([0,1,14,9,104,13]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=A;async function A(f,v,y,w,p,k){let g;try{await E(f,v,y,w,p,k)}catch(c){g=c}finally{g&&p.errorTransformer&&(g=p.errorTransformer(g)),typeof g<"u"&&y.error(g),y.end()}}async function E(f,v,y,w,p,k){l(k);const g=await f.open(v,{create:!1});try{l(k);let c=0,u=0,b=p&&typeof p.length=="number"?p.length:void 0,m=D.$Fe.alloc(Math.min(p.bufferSize,typeof b=="number"?b:p.bufferSize)),$=p&&typeof p.position=="number"?p.position:0,n=0;do u=await f.read(g,$,m.buffer,n,m.byteLength-n),$+=u,n+=u,c+=u,typeof b=="number"&&(b-=u),n===m.byteLength&&(await y.write(w(m)),m=D.$Fe.alloc(Math.min(p.bufferSize,typeof b=="number"?b:p.bufferSize)),n=0);while(u>0&&(typeof b!="number"||b>0)&&l(k)&&a(c,p));if(n>0){let r=n;typeof b=="number"&&(r=Math.min(n,b)),y.write(w(m.slice(0,r)))}}catch(c){throw(0,N.$el)(c)}finally{await f.close(g)}}function l(f){if(f.isCancellationRequested)throw(0,j.$6)();return!0}function a(f,v){if(typeof v?.limits?.size=="number"&&f>v.limits.size)throw(0,N.$dl)((0,I.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[123],se([0,1,60,2,52,5,11,8]),function(J,e,D,j,I,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class l extends j.$Uc{constructor(){super(),this.a=this.B(new N.$de),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$de),this.onDidLogMessage=this.b.event,this.c=this.B(new N.$de),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new j.$4c),this.m=new Set,this.n=5007,this.r=new E.$Th,this.P=!1,this.B(this.f(f=>this.s(f)))}s(f){this.t(f)&&this.w(f)}t(f){return(0,I.$Jq)(f)}async watch(f){this.r.isSettled||this.r.complete(),this.r=new E.$Th;try{this.h.clear(),this.g.clear();for(const v of f)this.t(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))])}isSuspended(f){return typeof f.correlationId!="number"?!1:this.m.has(f.correlationId)?"polling":this.j.has(f.correlationId)}async w(f){if(this.j.has(f.correlationId))return;const v=new j.$Tc;this.j.set(f.correlationId,v),await this.r.p,!v.isDisposed&&(this.z(f,v),this.u())}y(f){this.j.deleteAndDispose(f.correlationId),this.m.delete(f.correlationId),this.u()}z(f,v){this.C(f,v)?(this.N(`reusing an existing recursive watcher to monitor ${f.path}`),this.m.delete(f.correlationId)):(this.D(f,v),this.m.add(f.correlationId))}C(f,v){const y=this.M?.subscribe(f.path,(w,p)=>{v.isDisposed||(w?this.z(f,v):p?.type===1&&this.F(f))});return y?(v.add(y),!0):!1}D(f,v){let y=!1;const w=(p,k)=>{if(v.isDisposed)return;const g=this.G(p),c=this.G(k),u=y;y=g,!g&&(c||u)&&this.F(f)};this.N(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,D.watchFile)(f.path,{persistent:!1,interval:this.n},w)}catch(p){this.O(`fs.watchFile() failed with error ${p} on path ${f.path} (correlationId: ${f.correlationId})`)}v.add((0,j.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,D.unwatchFile)(f.path,w)}catch(p){this.O(`fs.unwatchFile() failed with error ${p} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}F(f){this.N(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const v={resource:A.URI.file(f.path),type:1,cId:f.correlationId};this.a.fire([v]),this.H(v,f),this.y(f)}G(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(f,v){if(this.P){const y=` >> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.I(y,v)}}I(f,v){this.P&&this.N(`${f}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}J(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,I.$Tq)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.P=f}}e.$3q=l}),define(ne[124],se([0,1,5,171,123,12,172,63]),function(J,e,D,j,I,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class l extends I.$3q{constructor(f){super(),this.M=f,this.onDidError=D.Event.None,this.watchers=new Set}async L(f){f=this.X(f);const v=[],y=new Set(Array.from(this.watchers));for(const w of f){const p=this.S(w);p&&(0,j.$uk)(p.request.excludes,w.excludes)&&(0,j.$uk)(p.request.includes,w.includes)?y.delete(p):v.push(w)}v.length&&this.N(`Request to start watching: ${v.map(w=>this.J(w)).join(",")}`),y.size&&this.N(`Request to stop watching: ${Array.from(y).map(w=>this.J(w.request)).join(",")}`);for(const w of y)this.W(w);for(const w of v)this.U(w)}S(f){for(const v of this.watchers)if(typeof f.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===f.correlationId)return v}else if((0,E.$ug)(v.request.path,f.path,!N.$k))return v}U(f){const v=new A.$8q(f,this.M,w=>this.a.fire(w),()=>this.c.fire(f),w=>this.b.fire(w),this.P),y={request:f,instance:v};this.watchers.add(y)}async stop(){await super.stop();for(const f of this.watchers)this.W(f)}W(f){this.N("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}X(f){const v=new Map;for(const y of f){const w=N.$k?y.path:y.path.toLowerCase();let p=v.get(y.correlationId);p||(p=new Map,v.set(y.correlationId,p)),p.has(w)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(y)}`),p.set(w,y)}return Array.from(v.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const v of this.watchers)v.instance.setVerboseLogging(f)}N(f,v){this.P&&this.b.fire({type:"trace",message:this.$(f,v)})}O(f){this.b.fire({type:"warn",message:this.$(f)})}$(f,v){return v?`[File Watcher (node.js)] ${f} (${this.J(v.request)})`:`[File Watcher (node.js)] ${f}`}}e.$0q=l}),define(ne[125],se([0,1,52,124]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class I extends D.$Mq{constructor(A,E,l){super(A,E,l),this.s()}r(A){return A.add(new j.$0q(void 0))}}e.$$q=I}),define(ne[126],se([0,1,15,58,89,52]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class A extends N.$Nq{constructor(l,a,f){super(l,a,f),this.s()}r(l){const a=l.add(new I.$1q(D.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(a.onDidProcessExit(({code:f,signal:v})=>this.t(`terminated by itself with code ${f}, signal: ${v} (ETERM)`))),j.ProxyChannel.toService((0,j.$di)(a.getChannel("watcher")))}}e.$2q=A}),define(ne[64],se([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class D{constructor(...I){this.a=new Map;for(const[N,A]of I)this.set(N,A)}set(I,N){const A=this.a.get(I);return this.a.set(I,N),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$ui=D}),define(ne[127],se([0,1,8,9,2,51,121,10,64,173]),function(J,e,D,j,I,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const f=!1;class v extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class y{constructor(g=new l.$ui,c=!1,u,b=f){this.i=g,this.j=c,this.k=u,this.l=b,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$vi,this),this._globalGraph=b?u?._globalGraph??new A.$br(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Pc)(this.h),this.h.clear();for(const g of this.g)(0,I.$Oc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const c=new class extends y{dispose(){this.h.delete(c),super.dispose()}}(g,this.j,this,this.l);return this.h.add(c),c}invokeFunction(g,...c){this.m();const u=p.traceInvocation(this.l,g);let b=!1;try{return g({get:$=>{if(b)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const n=this.s($,u);if(!n)throw new Error(`[invokeFunction] unknown service '${$}'`);return n}},...c)}finally{b=!0,u.stop()}}createInstance(g,...c){this.m();let u,b;return g instanceof N.$ti?(u=p.traceCreation(this.l,g.ctor),b=this.o(g.ctor,g.staticArguments.concat(c),u)):(u=p.traceCreation(this.l,g),b=this.o(g,c,u)),u.stop(),b}o(g,c=[],u){const b=E._util.getServiceDependencies(g).sort((n,r)=>n.index-r.index),m=[];for(const n of b){const r=this.s(n.id,u);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${n.id}.`,!1),m.push(r)}const $=b.length>0?b[0].index:c.length;if(c.length!==$){console.trace(`[createInstance] First service dependency of ${g.name} at position ${$+1} conflicts with ${c.length} static arguments`);const n=$-c.length;n>0?c=c.concat(new Array(n)):c=c.slice(0,$)}return Reflect.construct(g,c.concat(m))}q(g,c){if(this.i.get(g)instanceof N.$ti)this.i.set(g,c);else if(this.k)this.k.q(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const c=this.i.get(g);return!c&&this.k?this.k.r(g):c}s(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const u=this.r(g);return u instanceof N.$ti?this.u(g,u,c.branch(g,!0)):(c.branch(g,!1),u)}u(g,c,u){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,c,u)}finally{this.t.delete(g)}}v(g,c,u){const b=new A.$br(n=>n.id.toString());let m=0;const $=[{id:g,desc:c,_trace:u}];for(;$.length;){const n=$.pop();if(b.lookupOrInsertNode(n),m++>1e3)throw new v(b);for(const r of E._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof N.$ti){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};b.insertEdge(n,i),$.push(i)}}}for(;;){const n=b.roots();if(n.length===0){if(!b.isEmpty())throw new v(b);break}for(const{data:r}of n){if(this.r(r.id)instanceof N.$ti){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}b.removeNode(r)}}return this.r(g)}w(g,c,u=[],b,m){if(this.i.get(g)instanceof N.$ti)return this.x(g,c,u,b,m,this.g);if(this.k)return this.k.w(g,c,u,b,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(g,c,u=[],b,m,$){if(b){const n=new y(void 0,this.j,this,this.l);n.c=String(g);const r=new Map,t=new D.$Ph(()=>{const i=n.o(c,u,m);for(const[s,o]of r){const h=i[s];if(typeof h=="function")for(const P of o)P.disposable=h.apply(i,P.listener)}return r.clear(),$.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let P=r.get(s);return P||(P=new a.$5c,r.set(s,P)),(O,z,M)=>{if(t.isInitialized)return t.value[s](O,z,M);{const T={listener:[O,z,M],disposable:void 0},Q=P.push(T);return(0,I.$Sc)(()=>{Q(),T.disposable?.dispose()})}}}if(s in i)return i[s];const o=t.value;let h=o[s];return typeof h!="function"||(h=h.bind(o),i[s]=h),h},set(i,s,o){return t.value[s]=o,!0},getPrototypeOf(i){return c.prototype}})}else{const n=this.o(c,u,m);return $.add(n),n}}y(g,c){if(c&&console.warn(g),this.j)throw new Error(g)}}e.$cr=y;var w;(function(k){k[k.None=0]="None",k[k.Creation=1]="Creation",k[k.Invocation=2]="Invocation",k[k.Branch=3]="Branch"})(w||(w={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new p(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(g,c){return g?new p(1,c.name):p.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const u=new p(3,g.toString());return this.h.push([g,c,u]),u}stop(){const g=Date.now()-this.g;p.f+=g;let c=!1;function u(m,$){const n=[],r=new Array(m+1).join("	");for(const[t,i,s]of $.h)if(i&&s){c=!0,n.push(`${r}CREATES -> ${t}`);const o=u(m+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(g>2||c)&&p.all.add(b.join(`
`))}}e.$dr=p});var oe=this&&this.__param||function(J,e){return function(D,j){e(D,j,J)}};define(ne[65],se([0,1,20,2,12,106,21,10]),function(J,e,D,j,I,N,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=void 0,e.$Qr=l;function l(f){return f.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Rr=(0,E.$wi)("languagePackService");let a=class extends j.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new D.$oe;setTimeout(()=>v.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const p=y.firstPage.filter(k=>k.properties.localizedLanguages?.length&&k.tags.some(g=>g.startsWith("lp-"))).map(k=>{const g=k.properties.localizedLanguages?.[0],c=l(k);return{...this.f(c,g,k),extensionId:k.identifier.id,galleryExtension:k}});return p.push(this.f("en","English")),p}f(v,y,w){const p=y??v;let k;if(p!==v&&(k=`(${v})`),v.toLowerCase()===I.$w.toLowerCase()&&(k??="",k+=(0,N.localize)(0,null)),w?.installCount){k??="";const g=w.installCount;let c;g>1e6?c=`${Math.floor(g/1e5)/10}M`:g>1e3?c=`${Math.floor(g/1e3)}K`:c=String(g),k+=` $(cloud-download) ${c}`}return{id:v,label:p,description:k}}};e.$Sr=a,e.$Sr=a=$e([oe(0,A.$6o)],a)}),define(ne[6],se([0,1,107,34,5,43,2,30,12,17,3,11,122,10]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=k,e.log=c,e.$ek=h,e.$fk=P,e.$gk=R,e.$hk=O,e.$3j=(0,w.$wi)("logService"),e.$4j=(0,w.$wi)("loggerService");function p(){return new Date().toISOString()}function k(z){return(0,f.$ag)(z)}var g;(function(z){z[z.Off=0]="Off",z[z.Trace=1]="Trace",z[z.Debug=2]="Debug",z[z.Info=3]="Info",z[z.Warning=4]="Warning",z[z.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$6j=g.Info;function c(z,M,T){switch(M){case g.Trace:z.trace(T);break;case g.Debug:z.debug(T);break;case g.Info:z.info(T);break;case g.Warning:z.warn(T);break;case g.Error:z.error(T);break;case g.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function u(z,M=!1){let T="";for(let Q=0;Q<z.length;Q++){let re=z[Q];if(re instanceof Error&&(re=(0,j.$hj)(re,M)),typeof re=="object")try{re=JSON.stringify(re)}catch{}T+=(Q>0?" ":"")+re}return T}class b extends A.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new I.$de),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==g.Off&&this.b<=M}}e.$8j=b;class m extends b{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...T){this.f(g.Trace)&&this.g(g.Trace,u([M,...T],!0))}debug(M,...T){this.f(g.Debug)&&this.g(g.Debug,u([M,...T]))}info(M,...T){this.f(g.Info)&&this.g(g.Info,u([M,...T]))}warn(M,...T){this.f(g.Warning)&&this.g(g.Warning,u([M,...T]))}error(M,...T){if(this.f(g.Error))if(M instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=M.stack,this.g(g.Error,u(Q))}else this.g(g.Error,u([M,...T]))}flush(){}}e.$9j=m;class $ extends b{constructor(M=e.$6j){super(),this.setLevel(M),this.g=!l.$i}trace(M,...T){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,M,...T):console.log(`[main ${p()}]`,M,...T))}debug(M,...T){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,M,...T):console.log(`[main ${p()}]`,M,...T))}info(M,...T){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,M,...T):console.log(`[main ${p()}]`,M,...T))}warn(M,...T){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,M,...T):console.warn(`[main ${p()}]`,M,...T))}error(M,...T){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,M,...T):console.error(`[main ${p()}]`,M,...T))}flush(){}}e.$0j=$;class n extends b{constructor(M=e.$6j,T=!0){super(),this.g=T,this.setLevel(M)}trace(M,...T){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...T):console.log(M,...T))}debug(M,...T){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...T):console.log(M,...T))}info(M,...T){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...T):console.log(M,...T))}warn(M,...T){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...T):console.log(M,...T))}error(M,...T){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...T):console.error(M,...T))}flush(){}}e.$$j=n;class r extends b{constructor(M,T=e.$6j){super(),this.g=M,this.setLevel(T)}trace(M,...T){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(M),...T])}debug(M,...T){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(M),...T])}info(M,...T){this.f(g.Info)&&this.g.log(g.Info,[this.h(M),...T])}warn(M,...T){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(M),...T])}error(M,...T){this.f(g.Error)&&this.g.log(g.Error,[this.h(M),...T])}h(M){return typeof M=="string"?M:(0,j.$hj)(M,this.f(g.Trace))}flush(){}}e.$_j=r;class t extends b{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const T of this.g)T.setLevel(M);super.setLevel(M)}trace(M,...T){for(const Q of this.g)Q.trace(M,...T)}debug(M,...T){for(const Q of this.g)Q.debug(M,...T)}info(M,...T){for(const Q of this.g)Q.info(M,...T)}warn(M,...T){for(const Q of this.g)Q.warn(M,...T)}error(M,...T){for(const Q of this.g)Q.error(M,...T)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$ak=t;class i extends A.$Uc{constructor(M,T,Q){if(super(),this.h=M,this.j=T,this.b=new E.$Ac,this.c=this.B(new I.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$de),this.onDidChangeVisibility=this.g.event,Q)for(const re of Q)this.b.set(re.resource,{logger:void 0,info:re})}m(M){return(0,f.$9f)(M)?[...this.b.values()].find(T=>T.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,T){const Q=this.n(M),re=(0,f.$9f)(M)?M:T?.id??(0,N.$kj)(Q.toString()).toString(16);let ie=this.b.get(Q)?.logger;const he=T?.logLevel==="always"?g.Trace:T?.logLevel;ie||(ie=this.s(Q,he??this.getLogLevel(Q)??this.h,{...T,id:re}));const le={logger:ie,info:{resource:Q,id:re,logLevel:he,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(le.info),this.b.set(Q,le),ie}n(M){return(0,f.$9f)(M)?(0,a.$0g)(this.j,`${M}.log`):M}setLogLevel(M,T){if(v.URI.isUri(M)){const Q=M,re=T,ie=this.b.get(Q);ie&&re!==ie.info.logLevel&&(ie.info.logLevel=re===this.h?void 0:re,ie.logger?.setLevel(re),this.b.set(ie.info.resource,ie),this.f.fire([Q,re]))}else{this.h=M;for(const[Q,re]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&re.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,T){const Q=this.m(M);Q&&T!==!Q.info.hidden&&(Q.info.hidden=!T,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,T]))}getLogLevel(M){let T;return M&&(T=this.b.get(M)?.info.logLevel),T??this.h}registerLogger(M){const T=this.b.get(M.resource);T?T.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const T=this.b.get(M);T&&(T.logger&&T.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=i;class s{constructor(){this.onDidChangeLogLevel=new I.$de().event}setLevel(M){}getLevel(){return g.Info}trace(M,...T){}debug(M,...T){}info(M,...T){}warn(M,...T){}error(M,...T){}critical(M,...T){}dispose(){}flush(){}}e.$ck=s;class o extends s{}e.$dk=o;function h(z){if(z.verbose)return g.Trace;if(typeof z.logLevel=="string"){const M=O(z.logLevel.toLowerCase());if(M!==void 0)return M}return e.$6j}function P(z){switch(z){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function R(z){switch(z){case g.Trace:return{original:"Trace",value:D.localize(0,null)};case g.Debug:return{original:"Debug",value:D.localize(1,null)};case g.Info:return{original:"Info",value:D.localize(2,null)};case g.Warning:return{original:"Warning",value:D.localize(3,null)};case g.Error:return{original:"Error",value:D.localize(4,null)};case g.Off:return{original:"Off",value:D.localize(5,null)}}}function O(z){switch(z){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ik=new y.$Nj("logLevel",P(g.Info))}),define(ne[128],se([0,1,19,8,9,5,63,2,16,52,6]),function(J,e,D,j,I,N,A,E,l,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class v extends E.$Uc{constructor(w,p){super(),this.a=w,this.b=p,this.c=this.B(new N.$de),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$de),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$uh(0)),this.w=[],this.y=this.B(new j.$uh(0))}watch(w,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(w,p):this.z(w,p)}n(w,p){const k={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},g=(0,D.$Tb)(this.j,k);return this.r(),(0,E.$Sc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,I.$1)(w))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,a.$Oq)(p)),p=>this.G(p),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const p of this.j)(0,a.$Kq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const p of this.j)(0,a.$Kq)(p)&&w.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,p){const k={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},g=(0,D.$Tb)(this.w,k);return this.C(),(0,E.$Sc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,I.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$Oq)(w)),w=>this.G(w),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,l.$hc)(w.fsPath)}J(w){const p=this.I(w);return(0,A.$yg)(p)}}e.$Uq=v}),define(ne[129],se([0,1,19,8,14,20,5,43,66,2,48,15,130,17,46,103,13,62,6,9]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u,b){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let $=class extends a.$Uc{static{m=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$de),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$de),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$de),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$de),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$de),this.Y=this.B(new A.$de),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$de),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$Fh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${r}`);const i=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),i.add(t.onDidChangeFile(s=>{const o=new g.$jl(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(i){t.push(i)}}),!this.h.has(r)&&await j.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return l.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,w.$bh)(r))throw new g.$ll((0,k.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const i=new b.$bb;throw i.message=(0,k.localize)(1,null,r.toString()),i}return t}async m(r){const t=await this.j(r);if((0,g.$9k)(t)||(0,g.$6k)(t)||(0,g.$0k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,g.$9k)(t)||(0,g.$6k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(i){throw(0,g.$gl)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.$ll((0,k.localize)(2,null,this.sb(r)),1):(0,g.$el)(i)}}async s(r,t){const i=await this.j(r),s=this.S(i),o=t?.resolveTo,h=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,R=await i.stat(r);let O;return this.t(i,r,R,void 0,!!P,(z,M)=>(O||(O=f.$Ci.forUris(()=>!s),O.set(r,!0),o&&O.fill(!0,o)),O.get(z.resource)||O.findSuperstr(z.resource.with({query:null,fragment:null}))?!0:z.isDirectory&&h?M===1:!1))}async t(r,t,i,s,o,h){const{providerExtUri:P}=this.R(r),R={resource:t,name:P.basename(t),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.$wl)({mtime:i.mtime,size:i.size}),children:void 0};if(R.isDirectory&&h(R,s)){try{const O=await r.readdir(t),z=await j.Promises.settled(O.map(async([M,T])=>{try{const Q=P.joinPath(t,M),re=o?await r.stat(Q):{type:T};return await this.t(r,Q,re,O.length,o,h)}catch(Q){return this.b.trace(Q),null}}));R.children=(0,D.$Hb)(z)}catch(O){this.b.trace(O),R.children=[]}return R}return R}async resolveAll(r){return j.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),i=await t.stat(r);return this.t(t,r,i,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(i){return i}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new g.$ll((0,k.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=I.$Fe.fromString(""),i){await this.u(r,i);const s=await this.writeFile(r,t);return this.r.fire(new g.$il(r,0,s)),s}async writeFile(r,t,i){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let h=i;if((0,g.$_k)(s)&&!h?.atomic){const P=s.enforceAtomicWriteFile?.(r);P&&(h={...i,atomic:P})}try{await this.w(s,r,h)||await this.U(s,o.dirname(r));let R;if((0,g.$6k)(s)&&!(t instanceof I.$Fe))if((0,p.$re)(t)){const O=await(0,p.$ye)(t,3);O.ended?R=I.$Fe.concat(O.buffer):R=O}else R=(0,p.$ve)(t,O=>I.$Fe.concat(O),3);else R=t;!(0,g.$9k)(s)||(0,g.$6k)(s)&&R instanceof I.$Fe||(0,g.$6k)(s)&&(0,g.$_k)(s)&&h?.atomic?await this.hb(s,r,h,R):await this.db(s,r,h,R instanceof I.$Fe?(0,I.$Qe)(R):R),this.r.fire(new g.$il(r,4))}catch(P){throw new g.$ll((0,k.localize)(4,null,this.sb(r),(0,g.$el)(P).toString()),(0,g.$hl)(P),h)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,i){const s=!!i?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,k.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,k.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,k.localize)(7,null,this.sb(t)));if(s)throw new Error((0,k.localize)(8,null,this.sb(t)))}let h;try{h=await r.stat(t)}catch{return}if(h.type&g.FileType.Directory)throw new g.$ll((0,k.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,h),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.$vl&&typeof h.mtime=="number"&&typeof h.size=="number"&&i.mtime<h.mtime&&i.etag!==(0,g.$wl)({mtime:i.mtime,size:h.size}))throw new g.$ll((0,k.localize)(10,null),3,i);return h}async readFile(r,t,i){const s=await this.m(r);return t?.atomic?this.z(s,r,t,i):this.C(s,r,t,i)}async z(r,t,i,s){return new Promise((o,h)=>{this.cb.queueFor(t,async()=>{try{const P=await this.C(r,t,i,s);o(P)}catch(P){h(P)}},this.R(r).providerExtUri)})}async C(r,t,i,s){const o=await this.D(r,t,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,I.$Re)(o.value)}}async readFileStream(r,t,i){const s=await this.m(r);return this.D(s,r,t,i)}async D(r,t,i,s){const o=new N.$oe(s);let h=i;(0,g.$$k)(r)&&r.enforceAtomicReadFile?.(t)&&(h={...i,atomic:!0});const P=this.J(t,h).then(O=>O,O=>{throw o.dispose(!0),O});let R;try{return typeof h?.etag=="string"&&h.etag!==g.$vl&&await P,h?.atomic&&(0,g.$$k)(r)||!((0,g.$9k)(r)||(0,g.$0k)(r))||(0,g.$6k)(r)&&h?.preferUnbuffered?R=this.I(r,t,h):(0,g.$0k)(r)?R=this.G(r,t,o.token,h):R=this.H(r,t,o.token,h),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await P,value:R}}catch(O){throw R&&await(0,p.$we)(R),this.F(O,t,h)}}F(r,t,i){const s=(0,k.localize)(11,null,this.sb(t),(0,g.$el)(r).toString());return r instanceof g.$nl?new g.$nl(s,r.stat,i):r instanceof g.$ml?new g.$ml(s,r.fileOperationResult,r.size,r.options):new g.$ll(s,(0,g.$hl)(r),i)}G(r,t,i,s=Object.create(null)){const o=r.readFileStream(t,s,i);return(0,p.$Ce)(o,{data:h=>h instanceof I.$Fe?h:I.$Fe.wrap(h),error:h=>this.F(h,t,s)},h=>I.$Fe.concat(h))}H(r,t,i,s=Object.create(null)){const o=(0,I.$Ve)();return(0,c.$Hq)(r,t,o,h=>h,{...s,bufferSize:this.a,errorTransformer:h=>this.F(h,t,s)},i),o}I(r,t,i){const s=(0,p.$te)(o=>I.$Fe.concat(o));return(async()=>{try{let o;i?.atomic&&(0,g.$$k)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(t,o.byteLength,i),s.end(I.$Fe.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new g.$ll((0,k.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==g.$vl&&t.etag===i.etag)throw new g.$nl((0,k.localize)(13,null),i,t);return this.L(r,i.size,t),i}L(r,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new g.$ml((0,k.localize)(14,null,this.sb(r)),7,t,i)}async canMove(r,t,i){return this.M(r,t,"move",i)}async canCopy(r,t,i){return this.M(r,t,"copy",i)}async M(r,t,i,s){if(r.toString()!==t.toString())try{const o=i==="move"?this.qb(await this.n(r),r):await this.m(r),h=this.qb(await this.n(t),t);await this.Q(o,r,h,t,i,s)}catch(o){return o}return!0}async move(r,t,i){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"move",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$il(r,h==="move"?2:3,P)),P}async copy(r,t,i){const s=await this.m(r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"copy",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$il(r,h==="copy"?3:2,P)),P}async N(r,t,i,s,o,h){if(t.toString()===s.toString())return o;const{exists:P,isSameResourceWithDifferentPathCase:R}=await this.Q(r,t,i,s,o,h);if(P&&!R&&h&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(r===i&&(0,g.$7k)(r))await r.copy(t,s,{overwrite:h});else{const O=await this.resolve(t);O.isDirectory?await this.P(r,O,i,s):await this.O(r,t,i,s)}return o}else return r===i?(await r.rename(t,s,{overwrite:h}),o):(await this.N(r,t,i,s,"copy",h),await this.del(t,{recursive:!0}),"copy")}async O(r,t,i,s){if((0,g.$9k)(r)&&(0,g.$9k)(i))return this.jb(r,t,i,s);if((0,g.$9k)(r)&&(0,g.$6k)(i))return this.pb(r,t,i,s);if((0,g.$6k)(r)&&(0,g.$9k)(i))return this.nb(r,t,i,s);if((0,g.$6k)(r)&&(0,g.$6k)(i))return this.lb(r,t,i,s)}async P(r,t,i,s){await i.mkdir(s),Array.isArray(t.children)&&await j.Promises.settled(t.children.map(async o=>{const h=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),i,h):this.O(r,o.resource,i,h)}))}async Q(r,t,i,s,o,h){let P=!1;if(r===i){const{providerExtUri:O,isPathCaseSensitive:z}=this.R(r);if(z||(P=O.isEqual(t,s)),P&&o==="copy")throw new Error((0,k.localize)(15,null,this.sb(t),this.sb(s)));if(!P&&O.isEqualOrParent(s,t))throw new Error((0,k.localize)(16,null,this.sb(t),this.sb(s)))}const R=await this.exists(s);if(R&&!P){if(!h)throw new g.$ll((0,k.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===i){const{providerExtUri:O}=this.R(r);if(O.isEqualOrParent(t,s))throw new Error((0,k.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:R,isSameResourceWithDifferentPathCase:P}}R(r){const t=this.S(r);return{providerExtUri:t?w.$Zg:w.$2g,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$il(r,0,i)),i}async U(r,t){const i=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&g.FileType.Directory))throw new Error((0,k.localize)(19,null,this.sb(t)));break}catch(o){if((0,g.$gl)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(t)),t=s.dirname(t)}for(let o=i.length-1;o>=0;o--){t=s.joinPath(t,i[o]);try{await r.mkdir(t)}catch(h){if((0,g.$gl)(h)!==g.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(r,t){try{await this.W(r,t)}catch(i){return i}return!0}async W(r,t){const i=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,k.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,k.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,k.localize)(22,null,this.sb(r)));let h;try{h=await i.stat(r)}catch{}if(h)this.rb(r,h);else throw new g.$ll((0,k.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const R=await this.resolve(r);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,k.localize)(24,null,this.sb(r)))}return i}async del(r,t){const i=await this.W(r,t);let s=t;if((0,g.$al)(i)&&!s?.atomic){const R=i.enforceAtomicDelete?.(r);R&&(s={...t,atomic:R})}const o=!!s?.useTrash,h=!!s?.recursive,P=s?.atomic??!1;await i.delete(r,{recursive:h,useTrash:o,atomic:P}),this.r.fire(new g.$il(r,1))}async cloneFile(r,t){const i=await this.j(r),s=this.qb(await this.n(t),t);if(!(i===s&&this.R(i).providerExtUri.isEqual(r,t)))return i===s&&(0,g.$8k)(i)?i.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),i===s&&(0,g.$7k)(i)?this.cb.queueFor(r,()=>i.copy(r,t,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,s,t),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:m.ab++})}watch(r,t={recursive:!1,excludes:[]}){const i=new a.$Tc;let s=!1,o=()=>{s=!0};i.add((0,a.$Sc)(()=>o())),(async()=>{try{const P=await this.bb(r,t);s?(0,a.$Pc)(P):o=()=>(0,a.$Pc)(P)}catch(P){this.b.error(P)}})();const h=t.correlationId;if(typeof h=="number"){const P=i.add(new A.$de);return i.add(this.X.event(O=>{O.correlates(h)&&P.fire(O)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(r,t){const i=await this.j(r),s=(0,E.$kj)([this.R(i).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,i,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,p.$re)(s)||(0,p.$se)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(h){throw(0,g.$el)(h)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,i){let s=0,o;if((0,p.$se)(i)){if(i.buffer.length>0){const h=I.$Fe.concat(i.buffer);await this.gb(r,t,h,h.byteLength,s,0),s+=h.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((h,P)=>{(0,p.$xe)(o,{onData:async R=>{o.pause();try{await this.gb(r,t,R,R.byteLength,s,0)}catch(O){return P(O)}s+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>P(R),onEnd:()=>h()})})}async fb(r,t,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,i,s,o,h){let P=0;for(;P<s;){const R=await r.write(t,o+P,i.buffer,h+P,s-P);P+=R}}async hb(r,t,i,s){return this.cb.queueFor(t,()=>this.ib(r,t,i,s),this.R(r).providerExtUri)}async ib(r,t,i,s){let o;s instanceof I.$Fe?o=s:(0,p.$re)(s)?o=await(0,I.$Re)(s):(0,p.$se)(s)?o=await(0,I.$Se)(s):o=(0,I.$Pe)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,t,i,s){return this.cb.queueFor(s,()=>this.kb(r,t,i,s),this.R(i).providerExtUri)}async kb(r,t,i,s){let o,h;try{o=await r.open(t,{create:!1}),h=await i.open(s,{create:!0,unlock:!1});const P=I.$Fe.alloc(this.a);let R=0,O=0,z=0;do z=await r.read(o,R,P.buffer,O,P.byteLength-O),await this.gb(i,h,P,z,R,O),R+=z,O+=z,O===P.byteLength&&(O=0);while(z>0)}catch(P){throw(0,g.$el)(P)}finally{await j.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof h=="number"?i.close(h):Promise.resolve()])}}async lb(r,t,i,s){return this.cb.queueFor(s,()=>this.mb(r,t,i,s),this.R(i).providerExtUri)}async mb(r,t,i,s){return i.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,i,s){return this.cb.queueFor(s,()=>this.ob(r,t,i,s),this.R(i).providerExtUri)}async ob(r,t,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const h=await r.readFile(t);await this.gb(i,o,I.$Fe.wrap(h),h.byteLength,0,0)}catch(h){throw(0,g.$el)(h)}finally{await i.close(o)}}async pb(r,t,i,s){const o=await(0,I.$Re)(this.H(r,t,N.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new g.$ll((0,k.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&g.FilePermission.Readonly)throw new g.$ll((0,k.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$Iq=$,e.$Iq=$=m=$e([oe(0,u.$3j)],$)}),define(ne[131],se([0,1,60,174,8,30,14,5,63,2,16,12,17,46,25,105,13,62,128,34,126,125]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u,b,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,j.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,b.$hj)(r)}`)}})();class n extends u.$Uq{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=E.Event.None,this.P=new N.$Ac(s=>y.$1g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,v.$k&&(this.M|=1024)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await p.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await p.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,y.$0g)(t,o.name))).type:h=this.O(o),s.push([o.name,h])}catch(h){this.a.trace(h)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=g.FileType.Unknown:t.isFile()?s=g.FileType.File:t.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,i&&(s|=g.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new I.$vh;return this.P.set(t,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const o=this.I(t);return await p.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,w.$te)(h=>A.$Fe.concat(h.map(P=>A.$Fe.wrap(P))).buffer);return(0,c.$Hq)(this,t,o,h=>h.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,y.$0g)((0,y.$9g)(t),`${(0,y.$7g)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await p.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,o){const h=new a.$Tc;try{h.add(await this.Q(t)),h.add(await this.Q(i)),await this.W(i,s,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{h.dispose()}}async W(t,i,s,o){let h;try{const P=this.I(t);if(!s.create||!s.overwrite){if(await p.Promises.exists(P)){if(!s.overwrite)throw(0,g.$dl)((0,k.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$dl)((0,k.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(h,0,i,0,i.byteLength)}catch(P){throw await this.ib(t,P)}finally{typeof h=="number"&&await this.close(h)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const o=this.I(t);let h;(0,g.$4k)(i)&&!s&&(h=await this.Q(t));let P;try{if((0,g.$4k)(i)&&i.unlock)try{const{stat:O}=await p.SymlinkSupport.stat(o);O.mode&128||await p.Promises.chmod(o,O.mode|128)}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}let R;if((0,g.$4k)(i)){if(v.$i)try{await p.Promises.truncate(o,0),R="r+"}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}R||(R="w")}else R="r";P=await p.Promises.open(o,R)}catch(R){throw h?.dispose(),(0,g.$4k)(i)?await this.ib(t,R):this.hb(R)}if(this.X.set(P,0),(0,g.$4k)(i)&&this.Z.set(P,t),h){const R=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.Y.set(P,h),R&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),R.dispose())}return P}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await p.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,h){const P=this.ab(t,i);let R=null;try{R=(await p.Promises.read(t,s,o,h,P)).bytesRead}catch(O){throw this.hb(O)}finally{this.bb(t,P,R)}return R}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const o=this.X.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,o+s):this.X.delete(t)))}async write(t,i,s,o,h){return(0,I.$Qh)(()=>this.cb(t,i,s,o,h),100,3)}async cb(t,i,s,o,h){const P=this.ab(t,i);let R=null;try{R=(await p.Promises.write(t,s,o,h,P)).bytesWritten}catch(O){throw await this.ib(this.Z.get(t),O)}finally{this.bb(t,P,R)}return R}async mkdir(t){try{await p.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,f.$jc)((0,f.$mc)(s),`${(0,f.$nc)(s)}${i.atomic.postfix}`)),await p.Promises.rm(s,p.RimRafMode.MOVE,o)}else try{await p.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let h=!1;try{const{stat:P,symbolicLink:R}=await p.SymlinkSupport.stat(s);h=P.isDirectory()&&!R}catch{}if(h)await p.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.hb(s)}}async rename(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"move",s.overwrite),await p.Promises.rename(o,h)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,k.localize)(2,null,(0,f.$nc)(o),(0,f.$nc)((0,f.$mc)(h)),P.toString()))),this.hb(P)}}async copy(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"copy",s.overwrite),await p.Promises.copy(o,h,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,k.localize)(3,null,(0,f.$nc)(o),(0,f.$nc)((0,f.$mc)(h)),P.toString()))),this.hb(P)}}async db(t,i,s,o){const h=this.I(t),P=this.I(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,l.$ug)(h,P,!0)),R){if(s==="copy")throw(0,g.$dl)((0,k.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const z=await this.N(t);if(!z)throw(0,g.$dl)((0,k.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const M=await this.N(i);if(M){if(!o)throw(0,g.$dl)((0,k.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);z.type&g.FileType.File&&M.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const o=this.I(t),h=this.I(i),P=!!(this.capabilities&1024);if((0,l.$ug)(o,h,!P))return;const R=new a.$Tc;try{R.add(await this.Q(t)),R.add(await this.Q(i)),s&&await p.Promises.mkdir((0,f.$mc)(h),{recursive:!0}),await p.Promises.copyFile(o,h)}catch(O){if(O.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(O)}finally{R.dispose()}}t(t,i,s){return new m.$2q(o=>t(o),o=>i(o),s)}F(t,i,s){return new $.$$q(o=>t(o),o=>i(o),s)}hb(t){if(t instanceof g.$cl)return t;let i=t,s;switch(t.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$dl)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await p.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,g.$dl)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$_q=n}),define(ne[132],se([0,1,2,6]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=void 0;class I extends D.$Uc{constructor(A,E=[]){super(),this.a=new j.$ak([A,...E]),this.B(A.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...E){this.a.trace(A,...E)}debug(A,...E){this.a.debug(A,...E)}info(A,...E){this.a.info(A,...E)}warn(A,...E){this.a.warn(A,...E)}error(A,...E){this.a.error(A,...E)}flush(){this.a.flush()}}e.$ZQ=I}),define(ne[133],se([0,1,13,6]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;var I;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(I||(I={}));async function N(a,f,v,y,w){try{const p=await new Promise((g,c)=>{J(["@vscode/spdlog"],g,c)});p.setFlushOn(I.Trace);const k=await p.createAsyncRotatingLogger(a,f,v,y);return w?k.clearFormatters():k.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),k}catch(p){console.error(p)}return null}function A(a,f,v){switch(f){case j.LogLevel.Trace:a.trace(v);break;case j.LogLevel.Debug:a.debug(v);break;case j.LogLevel.Info:a.info(v);break;case j.LogLevel.Warning:a.warn(v);break;case j.LogLevel.Error:a.error(v);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function E(a,f){switch(f){case j.LogLevel.Trace:a.setLevel(I.Trace);break;case j.LogLevel.Debug:a.setLevel(I.Debug);break;case j.LogLevel.Info:a.setLevel(I.Info);break;case j.LogLevel.Warning:a.setLevel(I.Warning);break;case j.LogLevel.Error:a.setLevel(I.Error);break;case j.LogLevel.Off:a.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class l extends j.$9j{constructor(f,v,y,w,p){super(),this.m=[],this.setLevel(p),this.n=this.s(f,v,y,w),this.B(this.onDidChangeLogLevel(k=>{this.r&&E(this.r,k)}))}async s(f,v,y,w){const p=y?6:1,k=30/p*D.$yl.MB,g=await N(f,v,k,p,w);if(g){this.r=g,E(this.r,this.getLevel());for(const{level:c,message:u}of this.m)A(this.r,c,u);this.m=[]}}g(f,v){this.r?A(this.r,f,v):this.getLevel()<=f&&this.m.push({level:f,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$OQ=l}),define(ne[134],se([0,1,28,6,133]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=void 0;class N extends j.$bk{s(E,l,a){return new I.$OQ((0,D.$Sg)(),E.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,l)}}e.$PQ=N}),define(ne[39],se([0,1,5,66,2,10]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=void 0,e.$eo=(0,N.$wi)("policy");class A extends I.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$de),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),j.Iterable.reduce(this.g.entries(),(v,[y,w])=>({...v,[y]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(a,[f,v])=>({...a,[f]:{definition:v,value:this.g.get(f)}}),{})}}e.$fo=A;class E{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$go=E}),define(ne[135],se([0,1,8,5,66,3,13,6,39]),function(J,e,D,j,I,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;function a(v,y){const w=[];for(const p of new Set(I.Iterable.concat(v.keys(),y.keys())))v.get(p)!==y.get(p)&&w.push(p);return w}let f=class extends l.$fo{constructor(y,w,p){super(),this.m=y,this.n=w,this.s=p,this.c=this.B(new D.$uh(500));const k=j.Event.filter(w.onDidFilesChange,g=>g.affects(y));this.B(w.watch(y)),this.B(k(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const w=await this.n.readFile(this.m),p=JSON.parse(w.value.toString());if(!(0,N.$$f)(p))throw new Error("Policy file isn't a JSON object");for(const k of Object.keys(p))this.f[k]&&y.set(k,p[k])}catch(w){w.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",w)}return y}async w(){const y=await this.u(),w=a(this.g,y);this.g=y,w.length>0&&this.h.fire(w)}};e.$Sdc=f,e.$Sdc=f=$e([oe(1,A.$3k),oe(2,E.$3j)],f)}),define(ne[136],se([0,1,39,8,2,6]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;let A=class extends D.$fo{constructor(l,a){super(),this.m=l,this.n=a,this.a=new j.$qh,this.b=this.B(new I.$Vc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`);const{createWatcher:a}=await new Promise((f,v)=>{J(["@vscode/policy-watcher"],f,v)});await this.a.queue(()=>new Promise((f,v)=>{try{this.b.value=a(this.n,l,y=>{this.t(y),f()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const a in l){const f=l[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(l))}};e.$Rdc=A,e.$Rdc=A=$e([oe(0,N.$3j)],A)}),define(ne[32],se([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,D.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,73,3]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class I{constructor(){this.a=new Map}add(A,E){D.ok(j.$9f(A)),D.ok(j.$$f(E)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,E)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$co=new I}),define(ne[137],se([0,1,5,36]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function I(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class N{constructor(){this.b=new D.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,a){this.a[I(l)]=a,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;j.$co.add(e.$do.JSONContribution,A)}),define(ne[40],se([0,1,19,5,3,92,29,137,36]),function(J,e,D,j,I,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=k,e.$to=g,e.$uo=c,e.$vo=b,e.$wo=m;var a;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$ho={Configuration:"base.contributions.configuration"};var f;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const v=l.$co.as(E.$do.JSONContribution);class y{constructor(){this.h=new Set,this.i=new j.$de,this.onDidSchemaChange=this.i.event,this.j=new j.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),v.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),v.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),v.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.$ro.test(o)){const h=this.a.get(o),P=h?.valuesSources??new Map;if(s)for(const M of Object.keys(i[o]))P.set(M,s);const R={...h?.value||{},...i[o]};this.a.set(o,{source:s,value:R,valuesSources:P});const O=(0,A.$aj)(o),z={type:"object",default:R,description:N.localize(1,null,O),$ref:e.$oo,defaultDefaultValue:R,source:I.$9f(s)?void 0:s,defaultValueSource:s};t.push(...k(o)),this.d[o]=z,this.b.properties[o]=z}else{this.a.set(o,{value:i[o],source:s});const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),h=I.$9f(i)?i:i?.id,P=I.$9f(o?.source)?o?.source:o?.source?.id;if(h===P)if(r.add(s),this.a.delete(s),e.$ro.test(s))delete this.d[s],delete this.b.properties[s];else{const R=this.d[s];R&&(this.w(s,R),this.r(s,R))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=I.$fg(n.scope)?s:n.scope;const h=n.properties;if(h)for(const R in h){const O=h[R];if(r&&b(R,O)){delete h[R];continue}if(O.source=t,O.defaultDefaultValue=h[R].default,this.w(R,O),e.$ro.test(R)?O.scope=void 0:(O.scope=I.$fg(O.scope)?s:O.scope,O.restricted=I.$fg(O.restricted)?!!i?.includes(R):O.restricted),h[R].hasOwnProperty("included")&&!h[R].included){this.f[R]=h[R],delete h[R];continue}else this.d[R]=h[R],h[R].policy?.name&&this.e.set(h[R].policy.name,R);!h[R].deprecationMessage&&h[R].markdownDeprecationMessage&&(h[R].deprecationMessage=h[R].markdownDeprecationMessage),o.add(R)}const P=n.allOf;if(P)for(const R of P)this.p(R,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$io.properties[n]=r,r.scope){case 1:e.$jo.properties[n]=r;break;case 2:e.$ko.properties[n]=r;break;case 6:e.$lo.properties[n]=r;break;case 3:e.$mo.properties[n]=r;break;case 4:e.$no.properties[n]=r;break;case 5:e.$no.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$io.properties[n],r.scope){case 1:delete e.$jo.properties[n];break;case 2:delete e.$ko.properties[n];break;case 6:delete e.$lo.properties[n];break;case 3:delete e.$mo.properties[n];break;case 4:case 5:delete e.$no.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$oo};this.w(r,t),e.$io.properties[r]=t,e.$jo.properties[r]=t,e.$ko.properties[r]=t,e.$lo.properties[r]=t,e.$mo.properties[r]=t,e.$no.properties[r]=t}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=n,e.$jo.patternProperties[e.$qo]=n,e.$ko.patternProperties[e.$qo]=n,e.$lo.patternProperties[e.$qo]=n,e.$mo.patternProperties[e.$qo]=n,e.$no.patternProperties[e.$qo]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;I.$dg(i)&&(i=r.defaultDefaultValue,s=void 0),I.$dg(i)&&(i=c(r.type)),r.default=i,r.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",p=new RegExp(w,"g");e.$qo=`^(${w})+$`,e.$ro=new RegExp(e.$qo);function k($){const n=[];if(e.$ro.test($)){let r=p.exec($);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=p.exec($)}}return(0,D.$Mb)(n)}function g($){return $.reduce((n,r)=>`${n}[${r}]`,"")}function c($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new y;l.$co.add(e.$ho.Configuration,u);function b($,n){return $.trim()?e.$ro.test($)?N.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?N.localize(8,null,$):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,$,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}function m(){const $=[],n=u.getConfigurationProperties();for(const r of Object.keys(n))$.push([r,n[r].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(ne[67],se([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(J,e,D,j,I,N,A,E,l,a,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=b;function w(r){return Object.isFrozen(r)?r:E.$4n(r)}class p{static createEmptyModel(t){return new p({},[],[],void 0,t)}constructor(t,i,s,o,h){this.b=t,this.c=i,this.d=s,this.raw=o,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof p)return i;const s=new k("",this.f);return s.parseRaw(i),s.configurationModel});this.g=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,f.$$i)(this.contents,t):this.contents}inspect(t,i){const s=this;return{get value(){return w(s.rawConfiguration.getValue(t))},get override(){return i?w(s.rawConfiguration.getOverrideValue(t,i)):void 0},get merged(){return w(i?s.rawConfiguration.override(i).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:h,identifiers:P,keys:R}of s.rawConfiguration.overrides){const O=new p(h,R,[],void 0,s.f).getValue(t);O!==void 0&&o.push({identifiers:P,value:O})}return o.length?w(o):void 0}}}getOverrideValue(t,i){const s=this.j(i);return s?t?(0,f.$$i)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return D.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return D.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.h(t),this.a.set(t,i)),i}merge(...t){const i=E.$3n(this.contents),s=E.$3n(this.overrides),o=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const P of t)if(h.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(i,P.contents);for(const R of P.overrides){const[O]=s.filter(z=>D.$ub(z.identifiers,R.identifiers));O?(this.i(O.contents,R.contents),O.keys.push(...R.keys),O.keys=D.$Mb(O.keys)):s.push(E.$3n(R))}for(const R of P.keys)o.indexOf(R)===-1&&o.push(R)}return new p(i,o,s,h.every(P=>P instanceof p)?void 0:h,this.f)}h(t){const i=this.j(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[o];const P=i[o];P&&(typeof h=="object"&&typeof P=="object"?(h=E.$3n(h),this.i(h,P)):h=P),s[o]=h}return new p(s,this.keys,this.overrides,void 0,this.f)}i(t,i){for(const s of Object.keys(i)){if(s in t&&l.$$f(t[s])&&l.$$f(i[s])){this.i(t[s],i[s]);continue}t[s]=E.$3n(i[s])}}j(t){let i=null,s=null;const o=h=>{h&&(s?this.i(s,h):s=E.$3n(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?i=h.contents:h.identifiers.includes(t)&&o(h.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.k(t,i,!0)}setValue(t,i){this.k(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,f.$0i)(this.contents,t),v.$ro.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>D.$ub(s.identifiers,(0,v.$so)(t))),1))}k(t,i,s){(0,f.$9i)(this.contents,t,i,o=>this.f.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.$ro.test(t)&&this.overrides.push({identifiers:(0,v.$so)(t),keys:Object.keys(this.contents[t]),contents:(0,f.$8i)(this.contents[t],o=>this.f.error(o))})}}e.$xo=p;class k{constructor(t,i){this.f=t,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!l.$fg(t)){const s=this.h(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:h,restricted:P,hasExcludedProperties:R}=this.i(t,i);this.b=new p(s,o,h,R?[t]:void 0,this.g),this.c=P||[]}h(t){let i={},s=null,o=[];const h=[],P=[];function R(z){Array.isArray(o)?o.push(z):s!==null&&(o[s]=z)}const O={onObjectBegin:()=>{const z={};R(z),h.push(o),o=z,s=null},onObjectProperty:z=>{s=z},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const z=[];R(z),h.push(o),o=z,s=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:R,onError:(z,M,T)=>{P.push({error:z,offset:M,length:T})}};if(t)try{I.$Qn(t,O),i=o[0]||{}}catch(z){this.g.error(`Error while parsing settings file ${this.f}: ${z}`),this.d=[z]}return i}i(t,i){const s=y.$co.as(v.$ho.Configuration).getConfigurationProperties(),o=this.j(t,s,!0,i);t=o.raw;const h=(0,f.$8i)(t,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`)),P=Object.keys(t),R=this.l(t,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:h,keys:P,overrides:R,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,i,s,o){let h=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const P={},R=[];for(const O in t)if(v.$ro.test(O)&&s){const z=this.j(t[O],i,!1,o);P[O]=z.raw,h=h||z.hasExcludedProperties,R.push(...z.restricted)}else{const z=i[O],M=z?typeof z.scope<"u"?z.scope:3:void 0;z?.restricted&&R.push(O),!o.exclude?.includes(O)&&(o.include?.includes(O)||(M===void 0||o.scopes===void 0||o.scopes.includes(M))&&!(o.skipRestricted&&z?.restricted))?P[O]=t[O]:h=!0}return{raw:P,restricted:R,hasExcludedProperties:h}}l(t,i){const s=[];for(const o of Object.keys(t))if(v.$ro.test(o)){const h={};for(const P in t[o])h[P]=t[o][P];s.push({identifiers:(0,v.$so)(o),keys:Object.keys(h),contents:(0,f.$8i)(h,i)})}return s}}e.$yo=k;class g extends N.$Uc{constructor(t,i,s,o,h){super(),this.c=t,this.f=i,this.g=o,this.h=h,this.b=this.B(new j.$de),this.onDidChange=this.b.event,this.a=new k(this.c.toString(),h),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(0)||P.isOperation(3)||P.isOperation(1)||P.isOperation(4))&&s.isEqual(P.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=g;class c{constructor(t,i,s,o,h,P,R,O,z,M,T,Q,re){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=h,this.f=P,this.g=R,this.h=O,this.i=z,this.j=M,this.k=T,this.l=Q,this.m=re}get value(){return w(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(t,i,s,o,h,P,R,O,z,M){this.j=t,this.l=i,this.m=s,this.n=o,this.p=h,this.q=P,this.r=R,this.s=O,this.t=z,this.u=M,this.h=null,this.i=new A.$Ac,this.v=null}getValue(t,i,s){return this.w(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.t.get(s.resource),o||(o=p.createEmptyModel(this.u),this.t.set(s.resource,o))):o=this.s,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.h=null)}inspect(t,i,s){const o=this.w(t,i,s),h=this.A(i.resource,s),P=i.resource?this.t.get(i.resource)||this.s:this.s,R=new Set;for(const O of o.overrides)for(const z of O.identifiers)o.getOverrideValue(t,z)!==void 0&&R.add(z);return new c(t,i,o.getValue(t),R.size?[...R]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,h||void 0,P)}keys(t){const i=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,i){this.r.set(t,i),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:h,removed:P}=$(this.j,t);i=[...o,...h,...P]}for(const o of i)for(const h of(0,v.$so)(o)){const P=this.j.getKeysForOverrideIdentifier(h),R=t.getKeysForOverrideIdentifier(h),O=[...R.filter(z=>P.indexOf(z)===-1),...P.filter(z=>R.indexOf(z)===-1),...P.filter(z=>!E.$7n(this.j.override(h).getValue(z),t.override(h).getValue(z)))];s.push([h,O])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=$(this.l,t),h=[...i,...s,...o];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.applicationConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.localUserConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.remoteUserConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=$(this.workspaceConfiguration,t),P=[...i,...s,...o];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:h}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:h,removed:P,overrides:R}=$(s,i),O=[...o,...h,...P];return(O.length||!s)&&this.updateFolderConfiguration(t,i),{keys:O,overrides:R}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:h,overrides:P}=$(i,void 0);return{keys:[...s,...o,...h],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,i,s){let o=this.x(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},i){let s=this.y();if(i&&t){const o=i.getFolder(t);o&&(s=this.z(o.uri)||s);const h=this.t.get(t);h&&(s=s.merge(h))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let i=this.i.get(t);if(!i){const s=this.y(),o=this.r.get(t);o?(i=s.merge(o),this.i.set(t,i)):i=s}return i}A(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:h}=this.r.get(i);return t.push([i,{contents:s,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.q.keys.forEach(i=>t.add(i)),this.r.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}D(t){const i=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.q.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t,i){const s=this.E(t.defaults,i),o=this.E(t.policy,i),h=this.E(t.application,i),P=this.E(t.user,i),R=this.E(t.workspace,i),O=t.folders.reduce((z,M)=>(z.set(a.URI.revive(M[0]),this.E(M[1],i)),z),new A.$Ac);return new u(s,o,h,P,p.createEmptyModel(i),R,O,p.createEmptyModel(i),new A.$Ac,i)}static E(t,i){return new p(t.contents,t.keys,t.overrides,void 0,i)}}e.$Ao=u;function b(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,P])=>{const R=(0,A.$xc)(i,h,new Set);P.forEach(O=>R.add(O))});const s=[];return i.forEach((o,h)=>s.push([h,[...o.values()]])),{keys:[...t.values()],overrides:s}}class m{constructor(t,i,s,o,h){this.change=t,this.f=i,this.g=s,this.h=o,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of t.keys)this.affectedKeys.add(P);for(const[,P]of t.overrides)for(const R of P)this.affectedKeys.add(R);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const h=o+s.length;if(h>=this.d.length)return!1;const P=this.d.charCodeAt(h);if(P!==this.b&&P!==this.c)return!1;if(i){const R=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,O=this.g.getValue(t,i,this.h);return!E.$7n(R,O)}return!0}}e.$Co=m;function $(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),h=[],P=r?.getAllOverrideIdentifiers()||[],R=t?.getAllOverrideIdentifiers()||[];if(t){const O=R.filter(z=>!P.includes(z));for(const z of O)h.push([z,t.getKeysForOverrideIdentifier(z)])}if(r){const O=P.filter(z=>!R.includes(z));for(const z of O)h.push([z,r.getKeysForOverrideIdentifier(z)])}if(t&&r){for(const O of P)if(R.includes(O)){const z=n({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:t.getOverrideValue(void 0,O)||{},keys:t.getKeysForOverrideIdentifier(O)});h.push([O,[...z.added,...z.removed,...z.updated]])}}return{added:i,removed:s,updated:o,overrides:h}}function n(r,t){const i=r?t?r.keys.filter(h=>t.keys.indexOf(h)===-1):[...r.keys]:[],s=t?r?t.keys.filter(h=>r.keys.indexOf(h)===-1):[...t.keys]:[],o=[];if(r&&t){for(const h of t.keys)if(r.keys.indexOf(h)!==-1){const P=(0,f.$$i)(t.contents,h),R=(0,f.$$i)(r.contents,h);E.$7n(P,R)||o.push(h)}}return{added:i,removed:s,updated:o}}}),define(ne[138],se([0,1,19,5,2,27,3,67,40,6,39,36]),function(J,e,D,j,I,N,A,E,l,a,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=void 0;class y extends I.$Uc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new j.$de),this.onDidChangeConfiguration=this.a.event,this.b=E.$xo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(v.$co.as(l.$ho.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.f(Array.from(g),c))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,c){this.j(g,v.$co.as(l.$ho.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=E.$xo.createEmptyModel(this.c);const g=v.$co.as(l.$ho.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,c){const u=this.g();for(const b of g){const m=u[b],$=c[b];m!==void 0?this.b.addValue(b,m):$?this.b.addValue(b,$.default):this.b.removeValue(b)}}}e.$Do=y;class w{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=E.$xo.createEmptyModel(new a.$dk)}async initialize(){return this.configurationModel}}e.$Eo=w;let p=class extends I.$Uc{get configurationModel(){return this.b}constructor(g,c,u){super(),this.c=g,this.f=c,this.g=u,this.a=this.B(new j.$de),this.onDidChangeConfiguration=this.a.event,this.b=E.$xo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const c={},u=[],b=v.$co.as(l.$ho.Configuration).getConfigurationProperties();for(const m of g){const $=b[m];if(!$){u.push(m);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}u.push(m),c[$.policy.name]={type:$.type}}}return(0,A.$jg)(c)||await this.f.updatePolicyDefinitions(c),u}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const c=v.$co.as(l.$ho.Configuration).getPolicyConfigurations(),u=(0,D.$Hb)(g.map(b=>c.get(b)));this.m(u,!0)}m(g,c){this.g.trace("PolicyConfiguration#update",g);const u=v.$co.as(l.$ho.Configuration).getConfigurationProperties(),b=[],m=this.b.isEmpty();for(const $ of g){const n=u[$]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(m?r!==void 0:!(0,N.$7n)(this.b.getValue($),r))&&b.push([$,r])}else this.b.getValue($)!==void 0&&b.push([$,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const $=this.b;this.b=E.$xo.createEmptyModel(this.g);for(const n of $.keys)this.b.setValue(n,$.getValue(n));for(const[n,r]of b)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);c&&this.a.fire(this.b)}}};e.$Fo=p,e.$Fo=p=$e([oe(1,f.$eo),oe(2,a.$3j)],p)}),define(ne[139],se([0,1,19,8,14,5,38,75,2,30,27,12,17,29,67,40,138,39]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=void 0;class u extends l.$Uc{constructor($,n,r,t){super(),this.m=$,this.n=t,this.h=this.B(new N.$de),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Do(t)),this.c=r instanceof c.$go?new g.$Eo:this.B(new g.$Fo(this.b,r,t)),this.f=this.B(new p.$zo(this.m,{},y.$1g,n,t)),this.a=new p.$Ao(this.b.configurationModel,this.c.configurationModel,p.$xo.createEmptyModel(t),p.$xo.createEmptyModel(t),p.$xo.createEmptyModel(t),p.$xo.createEmptyModel(t),new a.$Ac,p.$xo.createEmptyModel(t),new a.$Ac,t),this.j=new b($,n,this),this.g=this.B(new j.$Ih(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:s})=>this.s(i,s))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Ao($,n,p.$xo.createEmptyModel(this.n),r,p.$xo.createEmptyModel(this.n),p.$xo.createEmptyModel(this.n),new a.$Ac,p.$xo.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue($,n){const r=typeof $=="string"?$:void 0,t=(0,w.$4i)($)?$:(0,w.$4i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue($,n,r,t,i){const s=(0,w.$5i)(r)?r:(0,w.$4i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=s?t:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${$} to target ${o}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,D.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const h=this.inspect($,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,f.$7n)(n,h.defaultValue)&&(n=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const R=s.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(z=>(0,D.$ub)([...z.identifiers].sort(),R));O&&(s.overrideIdentifiers=O.identifiers)}const P=s?.overrideIdentifiers?.length?[(0,k.$to)(s.overrideIdentifiers),$]:[$];await this.j.write(P,n),await this.reloadConfiguration()}inspect($,n={}){return this.a.inspect($,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.r($)}r($){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration($);this.u(r,n,2)}s($,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration($,n);this.u(t,r,7)}t($){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration($);this.u(r,n,7)}u($,n,r){const t=new p.$Co($,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Go=u;class b{constructor($,n,r){this.b=$,this.c=n,this.d=r,this.a=new j.$Dh}write($,n){return this.a.queue(()=>this.e($,n))}async e($,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)r="{}";else throw s}const t=[];if((0,A.$Jn)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,$,n);r=(0,E.$2n)(r,i),await this.c.writeFile(this.b,I.$Fe.fromString(r))}f($,n,r){const{tabSize:t,insertSpaces:i,eol:s}=this.h;if(!n.length){const o=JSON.stringify(r,null,i?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,E.$Yn)($,n,r,{tabSize:t,insertSpaces:i,eol:s})}get h(){if(!this.g){let $=v.OS===3||v.OS===2?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&($=n),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ne[68],se([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=j,e.$Im=I,e.$Jm=N,e.$Km=A;function j(l){return l.scheme===D.Schemas.vscodeRemote?l.authority:void 0}function I(l){if(!l)return;const a=l.indexOf("+");return a<0?l:l.substr(0,a)}function N(l){const{host:a,port:f}=E(l);if(typeof f>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function A(l,a){let{host:f,port:v}=E(l);return typeof v>"u"&&(v=a),{host:f,port:v}}function E(l){const a=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=l.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(ne[37],se([0,1,31,10,68]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=N,e.$Um=v,e.$Vm=y,e.$Wm=w,e.$Xm=p,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function N(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(k){k.WIN32_X64="win32-x64",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class l{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const u=typeof g=="string"?g:g.value,b=typeof c=="string"?c:c.value;return D.$xf(u,b)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Rm=l;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add(l.toKey(g))}delete(g){return this.c.delete(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}}e.$Sm=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(l.toKey(g))}get(g){return this.c.get(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}set(g,c){this.c.set(l.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=f;function v(k){return y(k)}function y(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}function w(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}function p(k,g){if(g){const c=`onResolveRemoteAuthority:${(0,I.$Im)(g)}`;return!!k.activationEvents?.includes(c)}return!1}e.$Ym=(0,j.$wi)("IBuiltinExtensionsScannerService")}),define(ne[140],se([0,1,2,37,13]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class N extends D.$Uc{constructor(E,l,a,f,v){super(),this.a=E,this.b=l,this.c=a,this.f=v,this.B(f.onDidInstallExtensions(y=>this.g(y))),this.B(f.onDidUninstallExtension(y=>this.h(y)))}g(E){for(const l of E)l.local&&this.invalidate(l.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const l of this.a.profiles)this.c.extUri.isEqual(l.extensionsResource,E)&&await this.j(l);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,j.$Lm))}catch(l){(0,I.$hl)(l)!==1&&this.f.error(l)}}}e.$Bq=N}),define(ne[45],se([0,1,14,9,2,108,40,10,6,36]),function(J,e,D,j,I,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=y,e.$Qp=w,e.$Rp=p,e.$Sp=k,e.$Tp=g,e.$Up=c,e.$Np=(0,E.$wi)("requestService");class f{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?$[n]="*****":$[n]=this.b[n];this.a=$}return this.a}}class v extends I.$Uc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,N.localize)(0,null),when:l.$ik.isEqualTo((0,l.$fk)(l.LogLevel.Trace)).serialize()})}async c($,n,r){const t=`${$} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new f(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,j.$0)(i)),i}}}e.$Op=v;function y(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function w(m){return m.res.statusCode===204}async function p(m){return w(m)?null:(await(0,D.$Re)(m.stream)).toString()}async function k(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);return p(m)}async function g(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);if(w(m))return null;const n=(await(0,D.$Re)(m.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function c(m){b(m)}let u;function b(m){const $=a.$co.as(A.$ho.Configuration),n=u;u={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[u],remove:n?[n]:[]})}b(1)}),define(ne[141],se([0,1,20,15,13,45]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0;let A=class{constructor(l,a){this.a=l,this.b=a}async download(l,a,f=D.CancellationToken.None){if(l.scheme===j.Schemas.file||l.scheme===j.Schemas.vscodeRemote){await this.b.copy(l,a);return}const v={type:"GET",url:l.toString(!0)},y=await this.a.request(v,f);if(y.res.statusCode===200)await this.b.writeFile(a,y.stream);else{const w=await(0,N.$Sp)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${w}`)}}};e.$cR=A,e.$cR=A=$e([oe(0,N.$Np),oe(1,I.$3k)],A)}),define(ne[142],se([0,1,143,3]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=N;function I(A,E){return A.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:A.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function N(A,E,l={}){const a=(0,D.parse)(A),f=l.proxyUrl||I(a,E);if(!f)return null;const v=(0,D.parse)(f);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,j.$cg)(l.strictSSL)?l.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,p)=>{J(["http-proxy-agent"],w,p)})).HttpProxyAgent(f,y):new(await new Promise((w,p)=>{J(["https-proxy-agent"],w,p)})).HttpsProxyAgent(f,y)}}),define(ne[144],se([0,1,59,16,109,20,34,9,12,28,88,175,8,76]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=k;let p;async function k(c,u,b,m){return b["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.$i?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$Am)(m)&&!b["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$Am)(m)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=y.Promises.withAsyncBody(async($,n)=>{const r=new N.$oe;let t=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,w.$Bm)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,I.localize)(0,null)))},t);try{$(await g(u,r.token))}catch(o){!(0,E.$4)(o)&&!r.token.isCancellationRequested?n(new Error((0,I.localize)(1,null,(0,A.$hj)(o)))):$({})}finally{clearTimeout(s),r.dispose()}})),p)}async function g(c,u){const b=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",b);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",m);const $=(0,a.$Sg)().replace(/-/g,"").substr(0,12),n=new RegExp($+"({.*})"+$),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,f.$qm)(l.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(u.isCancellationRequested)return s(new E.$5);const o=(0,j.$nc)(t);let h,P;const R="";/^pwsh(-preview)?$/.test(o)?(h=`& '${process.execPath}' ${R} -p '''${$}'' + JSON.stringify(process.env) + ''${$}'''`,P=["-Login","-Command"]):o==="nu"?(h=`^'${process.execPath}' ${R} -p '"${$}" + JSON.stringify(process.env) + "${$}"'`,P=["-i","-l","-c"]):o==="xonsh"?(h=`import os, json; print("${$}", json.dumps(dict(os.environ)), "${$}")`,P=["-i","-l","-c"]):(h=`'${process.execPath}' ${R} -p '"${$}" + JSON.stringify(process.env) + "${$}"'`,o==="tcsh"||o==="csh"?P=["-ic"]:P=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),h);const O=(0,D.spawn)(t,[...P,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(O.kill(),s(new E.$5))),O.on("error",T=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$hj)(T)),s(T)});const z=[];O.stdout.on("data",T=>z.push(T));const M=[];O.stderr.on("data",T=>M.push(T)),O.on("close",(T,Q)=>{const re=Buffer.concat(z).toString("utf8");c.trace("getUnixShellEnvironment#raw",re);const ie=Buffer.concat(M).toString("utf8");if(ie.trim()&&c.trace("getUnixShellEnvironment#stderr",ie),T||Q)return s(new Error((0,I.localize)(2,null,T,Q)));const he=n.exec(re),le=he?he[1]:"{}";try{const ce=JSON.parse(le);b?ce.ELECTRON_RUN_AS_NODE=b:delete ce.ELECTRON_RUN_AS_NODE,m?ce.ELECTRON_NO_ATTACH_CONSOLE=m:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,A.$hj)(ce)),s(ce)}})})}}),define(ne[145],se([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RQ=e.$QQ=void 0,e.$QQ=(0,D.$wi)("stateReadService"),e.$RQ=(0,D.$wi)("stateService")}),define(ne[69],se([0,1,8,14,2,3,18,13,6]),function(J,e,D,j,I,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=e.$TQ=e.$SQ=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends I.$Uc{constructor(p,k,g,c){super(),this.h=p,this.j=k,this.m=g,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new D.$uh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.m.error(p)}}getItem(p,k){const g=this.a[p];return(0,N.$fg)(g)?k:g}setItem(p,k){this.setItems([{key:p,data:k}])}setItems(p){let k=!1;for(const{key:g,data:c}of p)this.a[g]!==c&&((0,N.$fg)(c)?(0,N.$dg)(this.a[g])||(this.a[g]=void 0,k=!0):(this.a[g]=c,k=!0));k&&this.s()}removeItem(p){(0,N.$dg)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,j.$Fe.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(k){this.m.error(k)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$SQ=f;let v=class extends I.$Uc{constructor(p,k,g,c){super(),this.a=this.B(new f(k.stateResource,p,g,c))}async init(){await this.a.init()}getItem(p,k){return this.a.getItem(p,k)}};e.$TQ=v,e.$TQ=v=$e([oe(1,A.$Di),oe(2,l.$3j),oe(3,E.$3k)],v);class y extends v{setItem(p,k){this.a.setItem(p,k)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$UQ=y}),define(ne[70],se([0,1,12,35,28]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=A,e.$ep=E;function N(l){if(D.$u===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}function A(l,a,f,v,y,w,p,k,g){const c=Object.create(null);c["common.machineId"]=w,c["common.sqmId"]=p,c.sessionID=(0,I.$Sg)()+Date.now(),c.commitHash=v,c.version=y,c["common.platformVersion"]=(l||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.$h)(D.$u),c["common.nodePlatform"]=j.$dc,c["common.nodeArch"]=f,c["common.product"]=g||"desktop",k&&(c["common.msftInternal"]=k);let u=0;const b=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(c["common.snap"]="true");const m=N(a);return m&&(c["common.platformDetail"]=m),c}function E(l){const a=j.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return l.some(v=>f===v)}}),define(ne[22],se([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,D.$wi)("telemetryService"),e.$3l=(0,D.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var j;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var I;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(ne[71],se([0,1,9,10,6,22]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.ExtensionSignatureVerificationCode=e.$_p=void 0,e.$_p=(0,j.$wi)("IExtensionSignatureVerificationService");var A;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class E extends Error{constructor(f){super(f),this.code=f}}e.$aq=E;let l=class{constructor(f,v){this.b=f,this.c=v}d(){return this.a||(this.a=new Promise((f,v)=>J(["@vscode/vsce-sign"],async y=>f(y),v))),this.a}async verify(f,v,y){let w;try{w=await this.d()}catch(c){return this.b.error("Could not load vsce-sign module",(0,D.$0)(c)),this.b.info(`Extension signature verification is not done: ${f}`),!1}const p=new Date().getTime();let k;try{k=await w.verify(v,y,this.b.getLevel()===I.LogLevel.Trace)}catch(c){k={code:"UnknownError",didExecute:!1,output:(0,D.$0)(c)}}const g=new Date().getTime()-p;if(this.b.info(`Extension signature verification result for ${f}: ${k.code}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${f}:
${k.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:f,code:k.code,duration:g,didExecute:k.didExecute}),k.code==="Success")return!0;throw new E(k.code)}};e.$bq=l,e.$bq=l=$e([oe(0,I.$3j),oe(1,N.$2l)],l)}),define(ne[41],se([0,1,27,3,68,70,22]),function(J,e,D,j,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=f,e.$np=v,e.$op=y,e.$pp=w,e.$qp=k,e.$rp=c,e.$sp=u,e.$tp=$;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$fp=E;class l{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=l,e.$hp=new l;class a{async publicLog(r,t,i){}async publicLogError(r,t,i){}}e.$ip=a,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function f(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function v(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function y(n){const r=n.getValue(A.$0l),t=n.getValue(A.$$l);if(n.getValue(A.$_l)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(n){const r={},t={},i={};g(n,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function k(n){if(!n)return"none";const r=(0,I.$Im)(n);return p.has(r)?r:"other"}function g(n,r,t=0,i){if(n)for(const s of Object.getOwnPropertyNames(n)){const o=n[s],h=i?i+s:s;Array.isArray(o)?r[h]=(0,D.$8n)(o):o instanceof Date?r[h]=o.toISOString():(0,j.$$f)(o)?t<2?g(o,r,t+1,h+"."):r[h]=(0,D.$8n)(o):r[h]=o}}function c(n,r){const t=n.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,N.$ep)(t)||i}function u(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function b(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let t=n;const i=[];for(const P of r)for(;;){const R=P.exec(n);if(!R)break;i.push([R.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(t="";;){const P=o.exec(n);if(!P)break;const R=i.some(([O,z])=>P.index<z&&O<o.lastIndex);!s.test(P[0])&&!R&&(t+=n.substring(h,P.index)+"<REDACTED: user-file-path>",h=o.lastIndex)}return h<n.length&&(t+=n.substr(h)),t}function m(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(n))return`<REDACTED: ${t.label}>`;return n}function $(n,r){return(0,D.$5n)(n,t=>{if(t instanceof E||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let i=t.replaceAll("%20"," ");i=b(i,r);for(const s of r)i=i.replace(s,"");return i=m(i),i}})}}),define(ne[26],se([0,1,31,21,37,12,11,9,35,41]),function(J,e,D,j,I,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=f,e.$wp=p,e.$xp=k,e.$yp=g,e.$zp=c,e.$Ap=u,e.$Bp=b,e.$Cp=m,e.$Ep=$,e.$Fp=r;function f(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,D.$sf)(t.id,i.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,s,o)}static parse(i){const s=v.exec(i);return s&&s[1]&&s[2]?new y({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?f(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$vp=y;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(t){const i=w.exec(t);return i&&i[1]?[g(i[1]),i[2]]:[g(t),void 0]}function k(t,i){return`${t}.${i}`}function g(t){return t.toLowerCase()}function c(t,i){return g(k(t??I.$Nm,i))}function u(t,i){const s=[],o=h=>{for(const P of s)if(P.some(R=>f(i(R),i(h))))return P;return null};for(const h of t){const P=o(h);P?P.push(h):s.push([h])}return s}function b(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function m(t){return{id:new a.$fp(t.identifier.id),name:new a.$fp(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Dp=new I.$Rm("pprice.better-merge");function $(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const h=o.shift();if(h&&s.every(P=>!f(P.identifier,{id:h}))){const P=t.filter(R=>f(R.identifier,{id:h}));P.length===1&&(s.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function n(t,i){if(!N.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,E.$0)(h))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,j.$2o)(s?"alpine":N.$u,l.$ec);return i.debug("ComputeTargetPlatform:",o),o}}),define(ne[146],se([0,1,20,9,15,17,44,11,97,21,26,37]),function(J,e,D,j,I,N,A,E,l,a,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;const y=k=>(0,l.localize)(0,null,k),w=(0,l.localize)(1,null,"ms-dotnettools.csharp");let p=class{constructor(g,c,u){this.a=g,this.b=c,this.d=u}get f(){}async listExtensions(g,c,u){let b=await this.b.getInstalled(1,u);const m=v.$Qm.map(n=>n.toLowerCase());if(c&&c!==""){if(m.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}b=b.filter(n=>n.manifest.categories?n.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),m.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,l.localize)(2,null,this.f)),b=b.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let $;for(const n of b)$!==n.identifier.id&&($=n.identifier.id,this.a.info(g?`${$}@${n.manifest.version}`:$))}async installExtensions(g,c,u,b){const m=[];try{g.length&&this.a.info(this.f?(0,l.localize)(3,null,this.f):(0,l.localize)(4,null));const $=[],n=[],r=(i,s,o)=>{n.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...u,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||u.installPreReleaseVersion}})};for(const i of g)if(i instanceof E.URI)$.push({vsix:i,installOptions:u});else{const[s,o]=(0,f.$wp)(i);r(s,o,!1)}for(const i of c)if(i instanceof E.URI)$.push({vsix:i,installOptions:{...u,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,f.$wp)(i);r(s,o,!0)}const t=await this.b.getInstalled(void 0,u.profileLocation);if($.length&&await Promise.all($.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,b,t)}catch(o){this.a.error(o),m.push(i.toString())}})),n.length){const i=await this.g(n,t,b);m.push(...i)}}catch($){throw this.a.error((0,l.localize)(5,null,(0,j.$0)($))),$}if(m.length)throw new Error((0,l.localize)(6,null,m.join(", ")))}async updateExtensions(g){const c=await this.b.getInstalled(1,g),u=[];for(const n of c)n.identifier.uuid&&u.push({...n.identifier,preRelease:n.preRelease});this.a.trace((0,l.localize)(7,null,u.length));const b=await this.d.getExtensions(u,{compatible:!0},D.CancellationToken.None),m=[];for(const n of b)for(const r of c)(0,f.$up)(r.identifier,n.identifier)&&(0,A.gt)(n.version,r.manifest.version)&&m.push({extension:n,options:{operation:3,installPreReleaseVersion:r.preRelease,profileLocation:g}});if(!m.length){this.a.info((0,l.localize)(8,null));return}this.a.info((0,l.localize)(9,null,m.map(n=>n.extension.identifier.id).join(", ")));const $=await this.b.installGalleryExtensions(m);for(const n of $)n.error?this.a.error((0,l.localize)(10,null,n.identifier.id,(0,j.$0)(n.error))):this.a.info((0,l.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async g(g,c,u){if(g=g.filter(({id:n,version:r})=>{const t=c.find(i=>(0,f.$up)(i.identifier,{id:n}));if(t){if(!u&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,l.localize)(12,null,n,t.manifest.version,n)),!1;if(r&&t.manifest.version===r)return this.a.info((0,l.localize)(13,null,`${n}@${r}`)),!1}return!0}),!g.length)return[];const b=[],m=[],$=await this.j(g);if(await Promise.all(g.map(async({id:n,version:r,installOptions:t})=>{const i=$.get(n.toLowerCase());if(!i){this.a.error(`${y(r?`${n}@${r}`:n)}
${w}`),b.push(n);return}try{const o=await this.d.getManifest(i,D.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),b.push(n);return}const s=c.find(o=>(0,f.$up)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,l.localize)(14,null,r?`${n}@${r}`:n));return}this.a.info((0,l.localize)(15,null,n,i.version))}t.isBuiltin?this.a.info(r?(0,l.localize)(16,null,n,r):(0,l.localize)(17,null,n)):this.a.info(r?(0,l.localize)(18,null,n,r):(0,l.localize)(19,null,n)),m.push({extension:i,options:{...t,installGivenVersion:!!r}})})),m.length){const n=await this.b.installGalleryExtensions(m);for(const r of n)r.error?(this.a.error((0,l.localize)(20,null,r.identifier.id,(0,j.$0)(r.error))),b.push(r.identifier.id)):this.a.info((0,l.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return b}async h(g,c,u,b){const m=await this.b.getManifest(g);if(!m)throw new Error("Invalid vsix");if(await this.l(m,u,c.profileLocation,b))try{await this.b.install(g,c),this.a.info((0,l.localize)(22,null,(0,N.$7g)(g)))}catch(n){if((0,j.$4)(n))this.a.info((0,l.localize)(23,null,(0,N.$7g)(g)));else throw n}}async j(g){const c=new Map,u=g.some($=>$.installOptions.installPreReleaseVersion),b=await this.b.getTargetPlatform(),m=[];for(const $ of g)a.$Uo.test($.id)&&m.push({...$,preRelease:u});if(m.length){const $=await this.d.getExtensions(m,{targetPlatform:b},D.CancellationToken.None);for(const n of $)c.set(n.identifier.id.toLowerCase(),n)}return c}k(g){return!0}async l(g,c,u,b){if(!c){const m={id:(0,f.$zp)(g.publisher,g.name)},$=b.find(n=>(0,f.$up)(m,n.identifier)&&(0,A.gt)(n.manifest.version,g.version));if($)return this.a.info((0,l.localize)(24,null,$.identifier.id,$.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,c,u){const b=async $=>{if($ instanceof E.URI){const n=await this.b.getManifest($);return(0,f.$xp)(n.publisher,n.name)}return $},m=[];for(const $ of g){const n=await b($),t=(await this.b.getInstalled(void 0,u)).filter(i=>(0,f.$up)(i.identifier,{id:n}));if(!t.length)throw new Error(`${this.m(n)}
${w}`);if(t.some(i=>i.type===0)){this.a.info((0,l.localize)(25,null,n));return}if(!c&&t.some(i=>i.isBuiltin)){this.a.info((0,l.localize)(26,null,n));return}this.a.info((0,l.localize)(27,null,n));for(const i of t)await this.b.uninstall(i,{profileLocation:u}),m.push(i);this.f?this.a.info((0,l.localize)(28,null,n,this.f)):this.a.info((0,l.localize)(29,null,n))}}async locateExtension(g){const c=await this.b.getInstalled();g.forEach(u=>{c.forEach(b=>{if(b.identifier.id===u&&b.location.scheme===I.Schemas.file){this.a.info(b.location.fsPath);return}})})}m(g){return this.f?(0,l.localize)(30,null,g,this.f):(0,l.localize)(31,null,g)}};e.$cq=p,e.$cq=p=$e([oe(1,a.$9o),oe(2,a.$6o)],p)}),define(ne[147],se([0,1,8,9,2,15,17,44,3,28,25,49,29,18,21,26,71,13,6]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;let m=class extends I.$Uc{static{b=this}static{this.c=".sigzip"}constructor(n,r,t,i,s,o){super(),this.h=r,this.j=t,this.m=i,this.n=s,this.r=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,r,t){await this.g;const i=(0,A.$0g)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,i,o=>this.j.download(n,o,r))}catch(o){throw new p.$7o(o.message,p.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(n)){const o=await this.u(n);try{s=await this.n.verify(n.identifier.id,i.fsPath,o.fsPath)}catch(h){if(s=h.code,s==="PackageIsInvalidZip"||s==="SignatureArchiveIsInvalidZip"){try{await this.delete(i)}catch(R){this.r.error(R)}throw new p.$7o(v.$gq,p.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(h){this.r.error(h)}}}return{location:i,verificationStatus:s}}t(n){if(!n.isSigned)return this.r.info(`Extension is not signed: ${n.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,l.$cg)(r)?r:!0}async u(n){await this.g;const r=(0,A.$0g)(this.extensionsDownloadDir,`${this.z(n)}${b.c}`);try{await this.w(n,r,t=>this.j.downloadSignatureArchive(n,t))}catch(t){throw new p.$7o(t.message,p.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(n,r,t){if(await this.h.exists(r))return;if(r.scheme!==N.Schemas.file){await t(r);return}const i=(0,A.$0g)(this.extensionsDownloadDir,`.${(0,a.$Sg)()}`);await this.h.exists(i)||await t(i);try{await f.Promises.rename(i.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,j.$0)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const h of n.children)if(h.name.endsWith(b.c))i.push(h.resource);else{const P=k.$vp.parse(h.name);P&&t.push([P,h])}const s=(0,k.$Ap)(t,([h])=>h),o=[];for(const h of s)h.sort((P,R)=>E.rcompare(P[0].version,R[0].version)),r.push(...h.slice(1).map(P=>P[1].resource)),o.push(h[0][1]);o.sort((h,P)=>h.mtime-P.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(h=>h.resource)),r.push(...i),await D.Promises.settled(r.map(h=>(this.r.trace("Deleting from cache",h.path),this.h.del(h))))}}catch(n){this.r.error(n)}}z(n){return this.f?k.$vp.create(n).toString().toLowerCase():(0,a.$Sg)()}};e.$yq=m,e.$yq=m=b=$e([oe(0,w.$Ei),oe(1,c.$3k),oe(2,p.$6o),oe(3,y.$3i),oe(4,g.$_p),oe(5,u.$3j)],m)}),define(ne[148],se([0,1,5,2,30,26,37]),function(J,e,D,j,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class E extends j.$Uc{constructor(a,f,v,y,w,p,k){super(),this.f=a,this.g=f,this.h=v,this.j=y,this.m=w,this.n=p,this.r=k,this.a=this.B(new D.$de),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new j.$4c),this.s().then(null,g=>k.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(f=>(this.c.set(f.id,(0,j.$Rc)(this.n.watch(this.m.extUri.dirname(f.extensionsResource)),this.n.watch(f.extensionsResource))),this.G(f.extensionsResource))))}catch(f){throw this.r.error(f),f}}async w(a){for(const f of a.extensions)this.I(this.L(f.identifier,f.version),a.profileLocation)}async y(a){for(const f of a.extensions){const v=this.L(f.identifier,f.version);a.error?this.J(v,a.profileLocation):this.I(v,a.profileLocation)}}async z(a){for(const f of a.extensions)this.J(this.L(f.identifier,f.version),a.profileLocation)}async C(a){const f=[],v=[];for(const y of a.extensions){const w=this.L(y.identifier,y.version);a.error?this.I(w,a.profileLocation):(this.J(w,a.profileLocation),this.b.has(w)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),v.push(this.f.scanInstalledExtensionAtLocation(y.location).then(p=>{p?f.push(p):this.r.info("Extension not found at the location",y.location.toString())},p=>this.r.error(p)))))}try{await Promise.all(v),f.length&&await this.H(f)}catch(y){this.r.error(y)}}D(a){for(const f of this.h.profiles)a.contains(f.extensionsResource,0,1)&&this.F(f.extensionsResource)}async F(a){const f=[],v=[],y=await this.j.scanProfileExtensions(a),w=new Set,p=new Set;for(const[k,g]of this.b)g.has(a)&&p.add(k);for(const k of y){const g=this.L(k.identifier,k.version);w.add(g),p.has(g)||(f.push(k.identifier),this.I(g,a))}for(const k of p)if(!w.has(k)){const g=this.M(k);g&&(v.push(g.identifier),this.J(k,a))}(f.length||v.length)&&this.a.fire({added:f.length?{extensions:f,profileLocation:a}:void 0,removed:v.length?{extensions:v,profileLocation:a}:void 0})}async G(a){const f=await this.j.scanProfileExtensions(a);for(const v of f)this.I(this.L(v.identifier,v.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,f){let v=this.b.get(a);v||this.b.set(a,v=new I.$Bc(y=>this.m.extUri.getComparisonKey(y))),v.add(f)}J(a,f){const v=this.b.get(a);v&&v.delete(f),v?.size||this.b.delete(a)}L(a,f){return`${A.$Rm.toKey(a.id)}@${f}`}M(a){const[f,v]=(0,N.$wp)(a);return v?{identifier:{id:f},version:v}:void 0}}e.$Cq=E}),define(ne[149],se([0,1,119,41]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=I;async function I(N,A,E,l,a,f,v){const y={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,j.$mp)(A,E)&&(0,j.$op)(l)===3){const w=await(0,D.$7p)(E,a,f);y["X-Market-User-Id"]=w,y["VSCode-SessionId"]=v.machineId||w}return y}}),define(ne[150],se([0,1,176,19,8,2,15,16,25,18,21,26,6,65,11]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;let k=class extends w.$Sr{constructor(b,m,$,n){super($),this.h=b,this.j=n,this.g=this.B(new g(m,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(b,m){const n=(await this.g.getLanguagePacks())[m];if(!n){this.j.warn(`No language pack found for ${m}`);return}const r=n.translations[b];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const b=await this.g.getLanguagePacks(),m=Object.keys(b).map($=>{const n=b[$];return{...this.f($,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort(($,n)=>$.label.localeCompare(n.label)),m}async m(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",b.identifier.id),await this.update())}async n(b){const m=await this.g.getLanguagePacks();Object.keys(m).some($=>m[$]&&m[$].extensions.some(n=>(0,v.$up)(n.extensionIdentifier,b.identifier)))&&(this.j.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(m);return!(0,j.$ub)(Object.keys(b),Object.keys($))}};e.$Tr=k,e.$Tr=k=$e([oe(0,f.$9o),oe(1,a.$Ei),oe(2,f.$6o),oe(3,y.$3j)],k);let g=class extends N.$Uc{constructor(b,m){super(),this.j=m,this.c={},this.f=(0,E.$jc)(b.userDataPath,"languagepacks.json"),this.g=new I.$Dh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(b){return this.s(m=>{Object.keys(m).forEach($=>delete m[$]),this.m(m,...b)}).then(()=>this.c)}m(b,...m){for(const $ of m)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(b,$);Object.keys(b).forEach($=>this.r(b[$]))}n(b,m){const $=m.identifier,n=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const r of n)if(m.location.scheme===A.Schemas.file&&c(r)){let t=b[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},b[r.languageId]=t);const i=t.extensions.filter(s=>(0,v.$up)(s.extensionIdentifier,$))[0];i?i.version=m.manifest.version:t.extensions.push({extensionIdentifier:$,version:m.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,E.$jc)(m.location.fsPath,s.path)}}r(b){if(b){const m=(0,D.createHash)("md5");for(const $ of b.extensions)m.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);b.hash=m.digest("hex")}}s(b=()=>null){return this.g.queue(()=>{let m=null;return l.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(m=b($),$)).then($=>{for(const r of Object.keys($))$[r]||delete $[r];this.c=$,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),l.Promises.writeFile(this.f,n)}).then(()=>m,$=>this.j.error($))})}};g=$e([oe(0,a.$Ei),oe(1,y.$3j)],g);function c(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const b of u.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ne[151],se([0,1,85,9,27,41]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function l(f,v,y){const w=await(0,D.$8D)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,D.$8D)("@microsoft/1ds-post-js","dist/ms.post.js"),k=new w.AppInsightsCore,g=new p.PostChannel,c={instrumentationKey:f,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(y){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:y};c.extensionConfig[g.identifier]=u}return k.initialize(c,[]),k.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),k}class a{constructor(v,y,w,p,k){this.e=v,this.f=y,this.g=w,this.h=k,this.c=A,this.d=E,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=l(this.a,this.e,this.h)),this.b.then(y=>{v(y)},y=>{(0,j.$1)(y),console.error(y)})}}log(v,y){if(!this.a)return;y=(0,I.$6n)(y,this.g),y=(0,N.$pp)(y);const w=this.f+"/"+v;try{this.i(p=>{p.pluginVersionString=y?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$MQ=a}),define(ne[152],se([0,1,2,27,12,31,110,29,40,153,32,36,22,41]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,u,b){this.k=u,this.l=b,this.d={},this.i=new D.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,N.$_e)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$_e)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(y.$0l)||m.affectsConfiguration(y.$_l)||m.affectsConfiguration(y.$$l))&&this.m()}))}setExperimentProperty(c,u){this.d[c]=u}m(){let c=(0,w.$op)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const b=u.usage?3:u.error?2:0;c=Math.min(c,b)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,u,b){this.g<u||(b=(0,j.$6n)(b,this.d),b=(0,w.$tp)(b,this.j),b=(0,j.$6n)(b,this.c),this.b.forEach(m=>m.log(c,b)))}publicLog(c,u){this.n(c,3,u)}publicLog2(c,u){this.publicLog(c,u)}publicLogError(c,u){this.h&&this.n(c,2,u)}publicLogError2(c,u){this.publicLogError(c,u)}};e.$Zr=p,e.$Zr=p=$e([oe(1,E.$3i),oe(2,f.$jk)],p);function k(){const g=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=I.$o?"":(0,A.localize)(3,null),b=(0,A.localize)(4,null),m=(0,A.localize)(5,null),$=(0,A.localize)(6,null),n=(0,A.localize)(7,null),r=`
|       | ${b} | ${m} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${g} ${c} ${u}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}v.$co.as(l.$ho.Configuration).registerConfiguration({id:y.$9l,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[y.$0l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:k(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$co.as(l.$ho.Configuration).registerConfiguration({id:y.$9l,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.$_l]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.$0l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[154],se([0,1,14,20,177,151]),function(J,e,D,j,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=void 0;async function A(f,v){const y=await v.request(f,j.CancellationToken.None),w=(await(0,D.$Re)(y.stream)).toString(),p=y.res.statusCode??200;return{headers:y.res.headers,statusCode:p,responseData:w}}async function E(f){const v={method:f.type,headers:f.headers};return new Promise((w,p)=>{const k=I.request(f.url??"",v,g=>{g.on("data",function(c){w({headers:g.headers,statusCode:g.statusCode??200,responseData:c.toString()})}),g.on("error",function(c){p(c)})});k.write(f.data,g=>{g&&p(g)}),k.end()})}async function l(f,v,y){const w=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),p={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:w};try{const k=f?await A(p,f):await E(p);y(k.statusCode,k.headers,k.responseData)}catch{y(0,{})}}class a extends N.$MQ{constructor(v,y,w,p,k){const g={sendPOST:(c,u)=>{l(v,c,u)}};super(y,w,p,k,g)}}e.$NQ=a}),define(ne[155],se([0,1,16,25]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=I;async function I(N,A){const E=Object.create(null),l=(f,v)=>{const y=JSON.parse(f);E[v]=y};if(A){const f=[],v=await j.Promises.readdir(A);for(const w of v)try{(await j.Promises.stat((0,D.$jc)(A,w))).isDirectory()&&f.push(w)}catch{}const y=[];for(const w of f)(await j.Promises.readdir((0,D.$jc)(A,w))).filter(k=>k==="telemetry.json").length===1&&y.push(w);for(const w of y){const p=(await j.Promises.readFile((0,D.$jc)(A,w,"telemetry.json"))).toString();l(p,w)}}let a=(await j.Promises.readFile((0,D.$jc)(N,"telemetry-core.json"))).toString();return l(a,"vscode-core"),a=(await j.Promises.readFile((0,D.$jc)(N,"telemetry-extensions.json"))).toString(),l(a,"vscode-extensions"),JSON.stringify(E,null,4)}}),define(ne[156],se([0,1,12,86,22]),function(J,e,D,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=N,e.$wdc=A;async function N(E,l){let a=E.getItem(I.$7l);return(typeof a!="string"||D.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,j.$Fn)(l.error.bind(l))),a}async function A(E,l){let a=E.getItem(I.$8l);return typeof a!="string"&&(a=await(0,j.$Gn)(l.error.bind(l))),a}}),define(ne[23],se([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,D.$wi)("IUriIdentityService")}),define(ne[157],se([0,1,23,120,13,17,77,5,2]),function(J,e,D,j,I,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(y){this.g=y,this.c=new l.$Tc,this.f=2**16;const w=new Map,p=k=>{let g=w.get(k.scheme);return g===void 0&&(g=y.hasProvider(k)&&!this.g.hasCapability(k,1024),w.set(k.scheme,g)),g};this.c.add(E.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(k=>{w.delete(k.scheme)})),this.extUri=new N.$Yg(p),this.d=new A.$zs((k,g)=>this.extUri.compare(k,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,N.$$g)(y));const w=this.d.get(y);return w?w.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((p,k)=>p[1].time<k[1].time?1:p[1].time>k[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let p=0;p<w;p++)this.d.set(y[p][0],y[p][1].touch())}};e.$As=f,e.$As=f=$e([oe(0,I.$3k)],f),(0,j.$xs)(D.$Al,f,1)}),define(ne[158],se([0,1,5,2,13,48,30]),function(J,e,D,j,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class E extends j.$Uc{constructor(a,f,v,y,w,p){super(),this.f=a,this.g=f,this.h=v,this.j=y,this.m=w,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$de),this.onDidChangeFile=this.a.event,this.b=N.$Ci.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(k=>this.m.extUri.getComparisonKey(this.t(k))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(k=>this.s(k)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,v,y,w){return this.g.read(a,f,v,y,w)}write(a,f,v,y,w){return this.g.write(a,f,v,y,w)}watch(a,f){this.b.set(a,a);const v=this.g.watch(this.t(a),f);return(0,j.$Sc)(()=>{this.b.delete(a),v.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,v){return this.g.rename(this.t(a),this.t(f),v)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,v){return this.g.readFileStream(this.t(a),f,v)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,v){return this.g.writeFile(this.t(a),f,v)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,v){if((0,I.$7k)(this.g))return this.g.copy(this.t(a),this.t(f),v);throw new Error("copy not supported")}cloneFile(a,f){if((0,I.$8k)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const v of a){if(v.resource.scheme!==this.f)continue;const y=this.u(v.resource);this.b.findSubstr(y)&&f.push({resource:y,type:v.type,cId:v.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Tdc=E}),define(ne[159],se([0,1,112,16,48,17,11,10,15]),function(J,e,D,j,I,N,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=a,e.$Hi=f,e.$Ki=v,e.$Li=y,e.$Mi=w,e.$Ni=k,e.$Oi=g,e.$Ri=b,e.$Wi=m,e.$Xi=$,e.$Zi=n,e.$1i=r,e.$2i=t,e.$Fi=(0,E.$wi)("contextService");function a(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function f(i){return typeof i?.id=="string"&&!a(i)&&!y(i)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function v(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,j.$nc)(i)}:s?e.$Ii:e.$Ji;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function y(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function w(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function k(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,h,P,R){this.h=s,this.j=h,this.k=P,this.l=R,this.c=I.$Ci.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=I.$Ci.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=c;class u{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.$0g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=u;function b(i){return new u({uri:i,index:0,name:(0,N.$6g)(i)},{uri:i.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,D.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function m(i,s){return N.$1g.isEqualOrParent(i,s.untitledWorkspacesHome)}function $(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===l.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.$Yi}function r(i,s){return!m(i,s)&&!$(i)}function t(i){return(typeof i=="string"?(0,j.$oc)(i):(0,N.$8g)(i))===e.$Ti}}),define(ne[24],se([0,1,43,5,2,17,11,111,18,13,10,6,159,30,23,8,28,31,3]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=m,e.$Dl=$,e.$El=n;var b;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(b||(e.ProfileResourceType=b={}));function m(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$Cl=(0,f.$wi)("IUserDataProfilesService");function $(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function n(i,s,o,h,P,R){return{id:i,name:s,location:o,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:R&&P?.useDefaultFlags?.globalState?R.globalStorageHome:(0,N.$0g)(o,"globalStorage"),settingsResource:R&&P?.useDefaultFlags?.settings?R.settingsResource:(0,N.$0g)(o,"settings.json"),keybindingsResource:R&&P?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,N.$0g)(o,"keybindings.json"),tasksResource:R&&P?.useDefaultFlags?.tasks?R.tasksResource:(0,N.$0g)(o,"tasks.json"),snippetsHome:R&&P?.useDefaultFlags?.snippets?R.snippetsHome:(0,N.$0g)(o,"snippets"),extensionsResource:R&&P?.useDefaultFlags?.extensions?R.extensionsResource:(0,N.$0g)(o,"extensions.json"),cacheHome:(0,N.$0g)(h,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends I.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,h,P){super(),this.t=s,this.u=o,this.w=h,this.y=P,this.f=!0,this.h=this.B(new j.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,u.$9f)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(n((0,N.$7g)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},s))}}catch(R){this.y.error(R)}const h=new w.$Ac,P=new Map;if(o.length)try{const R=this.Q();if(R.workspaces)for(const[O,z]of Object.entries(R.workspaces)){const M=A.URI.parse(O),T=o.find(Q=>Q.id===z);T&&h.set(M,T)}if(R.emptyWindows)for(const[O,z]of Object.entries(R.emptyWindows)){const M=o.find(T=>T.id===z);M&&P.set(O,M)}}catch(R){this.y.error(R)}this.z={profiles:o,workspaces:h,emptyWindows:P}}return this.z}D(){const s=n("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",h=new RegExp(`${(0,c.$_e)(o)}\\s(\\d+)`);let P=0;for(const O of this.profiles){const z=h.exec(O.name),M=z?parseInt(z[1]):0;P=M>P?M:P}const R=`${o} ${P+1}`;return this.createProfile((0,D.$kj)((0,g.$Sg)()).toString(16),R,{transient:!0},s)}async createNamedProfile(s,o,h){return this.createProfile((0,D.$kj)((0,g.$Sg)()).toString(16),s,o,h)}async createProfile(s,o,h,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(s,o,h);return P&&await this.setProfileForWorkspace(P,R),R}async F(s,o,h){if(!(0,u.$9f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(o);return P||(P=(async()=>{try{if(this.profiles.find(M=>M.name===o||M.id===s))throw new Error(`Profile with ${o} name already exists`);const O=n(s,o,(0,N.$0g)(this.profilesHome,s),this.g,h,this.defaultProfile);await this.u.createFolder(O.location);const z=[];return this.j.fire({profile:O,join(M){z.push(M)}}),await k.Promises.settled(z),this.I([O],[],[]),O}finally{this.r.delete(o)}})(),this.r.set(o,P)),P}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(P=>P.id===s.id);if(!h)throw new Error(`Profile '${s.name}' does not exist`);return h=n(h.id,o.name??h.name,h.location,this.g,{shortName:o.shortName??h.shortName,icon:o.icon===null?void 0:o.icon??h.icon,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(P=>P.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const h=[];this.m.fire({profile:o,join(P){h.push(P)}});try{await Promise.allSettled(h)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(P){(0,a.$hl)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(P=>P.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,h)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,y.$Gi)(s)?s.uri:(0,y.$Li)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,h){const P=[...this.profiles,...s],R=[];this.s.profiles=[];for(let O of P)O.isDefault||o.some(z=>O.id===z.id)||(O=h.find(z=>O.id===z.id)??O,O.isTransient?this.s.profiles.push(O):R.push({location:O.location,name:O.name,shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags}));this.P(R),this.z=void 0,this.J(s,o,h)}J(s,o,h){this.h.fire({added:s,removed:o,updated:h,all:this.profiles})}L(s,o,h){h=o?.isTransient?!0:h,h||this.L(s,void 0,!0);const P=this.G(s),R=h?this.s:this.C;A.URI.isUri(P)?(R.workspaces.delete(P),o&&R.workspaces.set(P,o)):(R.emptyWindows.delete(P),o&&R.emptyWindows.set(P,o)),h||this.M()}M(){const s={};for(const[h,P]of this.C.workspaces.entries())s[h.toString()]=P.id;const o={};for(const[h,P]of this.C.emptyWindows.entries())o[h.toString()]=P.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},h=this.D();if(s.workspaces)for(const[R,O]of Object.entries(s.workspaces)){const z=A.URI.parse(O);o[R]=this.w.extUri.isEqual(z,h.location)?h.id:this.w.extUri.basename(z)}const P={};if(s.emptyWindows)for(const[R,O]of Object.entries(s.emptyWindows)){const z=A.URI.parse(O);P[R]=this.w.extUri.isEqual(z,h.location)?h.id:this.w.extUri.basename(z)}return{workspaces:o,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Fl=r,e.$Fl=r=$e([oe(0,l.$Di),oe(1,a.$3k),oe(2,p.$Al),oe(3,v.$3j)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Gl=t}),define(ne[160],se([0,1,19,8,20,9,5,2,12,3,11,95,21,26,37,6,32,22,23,24]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=void 0,e.$mq=$;let m=class extends E.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,s,o,h,P,R){super(),this.z=i,this.C=s,this.D=o,this.F=h,this.G=P,this.H=R,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$de),this.s=this.B(new A.$de),this.t=this.B(new A.$de),this.u=this.B(new A.$de),this.w=this.B(new A.$de),this.y=[],this.B((0,E.$Sc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,y.$4o)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const h=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:P})=>(0,w.$up)(P,i.identifier));if(h?.local)return h?.local;throw h?.error?h.error:new y.$7o(`Unknown error while installing extension ${i.identifier.id}`,y.ExtensionManagementErrorCode.Unknown)}catch(o){throw $(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new y.$7o(v.localize(0,null),y.ExtensionManagementErrorCode.NotAllowed);const s=[],o=[];return await Promise.allSettled(i.map(async({extension:h,options:P})=>{try{const R=await this.N(h,!!P?.installGivenVersion,!!P?.installPreReleaseVersion,P.productVersion??{version:this.G.version,date:this.G.date});o.push({...R,options:P})}catch(R){s.push({identifier:h.identifier,operation:2,source:h,error:R})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(i,s={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,s)}async toggleAppliationScope(i,s){if((0,p.$Um)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,s));for(const h of this.H.profiles){const P=(await this.getInstalled(1,h.extensionsResource)).find(R=>(0,w.$up)(R.identifier,i.identifier));P?this.w.fire(P):this.u.fire({identifier:i.identifier,profileLocation:h.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const s=new Map,o=new Map,h=[],P=(O,z)=>`${w.$vp.create(O).toString()}-${z.toString()}`,R=(O,z,M,T)=>{const Q=this.Y(O,z,M),re=`${(0,w.$zp)(O.publisher,O.name)}-${M.profileLocation.toString()}`;o.set(re,{task:Q,root:T}),this.n.fire({identifier:Q.identifier,source:z,profileLocation:M.profileLocation}),this.F.info("Installing extension:",Q.identifier.id),f.URI.isUri(z)||this.j.set(P(z,M.profileLocation),{task:Q,waitingTasks:[]})};try{for(const{manifest:O,extension:z,options:M}of i){const T=M.isApplicationScoped||M.isBuiltin||(0,p.$Um)(O),Q={...M,installOnlyNewlyAddedFromExtensionPack:M.installOnlyNewlyAddedFromExtensionPack??!f.URI.isUri(z),isApplicationScoped:T,profileLocation:T?this.H.defaultProfile.extensionsResource:M.profileLocation??this.X(),productVersion:M.productVersion??{version:this.G.version,date:this.G.date}},re=f.URI.isUri(z)?void 0:this.j.get(P(z,Q.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id),h.push(re.task.waitUntilTaskIsFinished())):R(O,z,Q,void 0)}return await Promise.all([...o.values()].map(async({task:O})=>{if(O.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const z=await this.M(O.identifier,O.manifest,!!O.options.installOnlyNewlyAddedFromExtensionPack,!!O.options.installPreReleaseVersion,O.options.profileLocation,O.options.productVersion),M=await this.getInstalled(void 0,O.options.profileLocation,O.options.productVersion),T={...O.options,context:{...O.options.context,[y.$Yo]:!0}};for(const{gallery:Q,manifest:re}of(0,D.$Mb)(z,({gallery:ie})=>ie.identifier.id)){if(o.has(`${Q.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`))continue;const ie=this.j.get(P(Q,T.profileLocation));if(ie){if(this.J(O,ie.task)){const he=ie.task.identifier;this.F.info("Waiting for already requested installing extension",he.id,O.identifier.id),ie.waitingTasks.push(O),h.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,le=>le.some(ce=>(0,w.$up)(ce.identifier,he)))).then(le=>{if(this.F.info("Finished waiting for already requested installing extension",he.id,O.identifier.id),!le.find(V=>(0,w.$up)(V.identifier,he))?.local)throw new Error(`Extension ${he.id} is not installed`)}))}}else M.some(({identifier:he})=>(0,w.$up)(he,Q.identifier))||R(re,Q,T,O)}}catch(z){if(f.URI.isUri(O.source))(0,D.$Lb)(O.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",O.identifier.id,z.message),(0,D.$Lb)(O.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",O.identifier.id,z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),z}})),await this.L([...o.entries()].map(async([O,{task:z}])=>{const M=new Date().getTime();try{const T=await z.run();if(await this.L(this.y.map(Q=>Q.postInstall(T,z.source,z.options,I.CancellationToken.None))),!f.URI.isUri(z.source)){const Q=z.operation===3,re=Q?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(n(this.C,Q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Cp)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-M,durationSinceUpdate:re}),l.$o&&z.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}s.set(O,{local:T,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){const Q=$(T);throw f.URI.isUri(z.source)||n(this.C,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Cp)(z.source),error:Q}),s.set(O,{error:Q,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:z.options.isApplicationScoped}),this.F.error("Error while installing the extension",z.identifier.id,(0,N.$0)(Q)),Q}})),h.length&&await this.L(h),[...s.values()]}catch(O){const z=(Q,re,ie)=>{const he=[];Q.manifest.extensionDependencies?.length&&he.push(...Q.manifest.extensionDependencies),Q.manifest.extensionPack?.length&&he.push(...Q.manifest.extensionPack);for(const le of he){if(ie.includes(le.toLowerCase()))continue;ie.push(le.toLowerCase());const ce=s.get(`${le.toLowerCase()}-${re.toString()}`);ce?.local&&(ie=z(ce.local,re,ie))}return ie},M=Q=>({identifier:Q.identifier,operation:2,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,error:O}),T=[];for(const[Q,{task:re,root:ie}]of o){const he=s.get(Q);he?he.local&&ie&&!s.get(`${ie.identifier.id.toLowerCase()}-${re.profileLocation.toString()}`)?.local&&(T.push(this.Z(he.local,{versionOnly:!0,profileLocation:re.profileLocation})),s.set(Q,M(re))):(re.cancel(),s.set(Q,M(re)))}for(const[Q,{task:re}]of o){const ie=s.get(Q);if(!ie?.local||re.options.donotIncludePackAndDependencies)continue;z(ie.local,re.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(le=>o.has(`${le.toLowerCase()}-${re.profileLocation.toString()}`)&&!s.get(`${le.toLowerCase()}-${re.profileLocation.toString()}`)?.local)&&(T.push(this.Z(ie.local,{versionOnly:!0,profileLocation:re.profileLocation})),s.set(Q,M(re)))}throw T.length&&await Promise.allSettled(T.map(async Q=>{try{await Q.run(),this.F.info("Rollback: Uninstalled extension",Q.extension.identifier.id)}catch(re){this.F.warn("Rollback: Error while uninstalling extension",Q.extension.identifier.id,(0,N.$0)(re))}})),O}finally{for(const{task:O}of o.values())O.source&&!f.URI.isUri(O.source)&&this.j.delete(P(O.source,O.profileLocation));if(s.size){const O=[...s.values()];for(const z of O)z.local&&this.F.info("Extension installed successfully:",z.identifier.id);this.s.fire(O)}}}J(i,s){for(const[,{task:o,waitingTasks:h}]of this.j.entries())if(o===i&&(h.includes(s)||h.some(P=>this.J(P,s)))||o===s&&h[0]&&!this.J(i,h[0]))return!1;return!0}async L(i){const s=[],o=[],h=await Promise.allSettled(i);for(const P of h)P.status==="fulfilled"?s.push(P.value):o.push(P.reason);if(o.length){if(o.length===1)throw o[0];let P=new y.$7o("",y.ExtensionManagementErrorCode.Unknown);for(const R of o){const O=R instanceof y.$7o?R.code:y.ExtensionManagementErrorCode.Unknown;P=new y.$7o(R.message?`${R.message}, ${P.message}`:P.message,O!==y.ExtensionManagementErrorCode.Unknown&&O!==y.ExtensionManagementErrorCode.Internal?O:P.code)}throw P}return s}async M(i,s,o,h,P,R){if(!this.z.isEnabled())return[];const O=await this.getInstalled(void 0,P,R),z=[],M=[],T=async(Q,re)=>{z.push(Q);const ie=re.extensionDependencies||[],he=[...ie];if(re.extensionPack){const le=o?O.find(ce=>(0,w.$up)(ce.identifier,Q)):void 0;for(const ce of re.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(V=>(0,w.$up)({id:V},{id:ce}))||he.every(V=>!(0,w.$up)({id:V},{id:ce}))&&he.push(ce)}if(he.length){const le=he.filter(ce=>z.every(V=>!(0,w.$up)(V,{id:ce})));if(le.length){const ce=await this.z.getExtensions(le.map(V=>({id:V,preRelease:h})),I.CancellationToken.None);for(const V of ce){if(z.find(q=>(0,w.$up)(q,V.identifier)))continue;const Z=ie.some(q=>(0,w.$up)({id:q},V.identifier));let B;try{B=await this.N(V,!1,h,R)}catch(q){if(Z)throw q;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,N.$0)(q));continue}M.push({gallery:B.extension,manifest:B.manifest}),await T(B.extension.identifier,B.manifest)}}}};return await T(i,s),M}async N(i,s,o,h){let P;const R=await this.getExtensionsControlManifest();if(R.malicious.some(M=>(0,w.$up)(i.identifier,M)))throw new y.$7o(v.localize(1,null,i.identifier.id),y.ExtensionManagementErrorCode.Malicious);const O=R.deprecated[i.identifier.id.toLowerCase()];if(O?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${O.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:O.extension.id,preRelease:O.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:h},I.CancellationToken.None))[0],!P)throw new y.$7o(v.localize(2,null,i.identifier.id,O.extension.id),y.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const M=await this.getTargetPlatform();throw new y.$7o(v.localize(3,null,i.identifier.id,this.G.nameLong,(0,y.$Zo)(M)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.O(i,s,o,h),!P)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],I.CancellationToken.None))[0]?new y.$7o(v.localize(4,null,i.displayName??i.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.$7o(v.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),y.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const z=await this.z.getManifest(P,I.CancellationToken.None);if(z===null)throw new y.$7o(`Missing manifest for extension ${P.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(z.version!==P.version)throw new y.$7o(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:z}}async O(i,s,o,h){const P=await this.getTargetPlatform();let R=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(R=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:P,compatible:!0,productVersion:h},I.CancellationToken.None))[0]||null),!R&&await this.z.isExtensionCompatible(i,o,P,h)&&(R=i),R||(s?R=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:P,compatible:!0,productVersion:h},I.CancellationToken.None))[0]||null:R=await this.z.getCompatibleExtension(i,o,P,h)),R}async P(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},h=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,P=this.m.get(h(i.identifier));if(P)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),P.waitUntilTaskIsFinished();const R=T=>{const Q=this.Z(T,o);return this.m.set(h(Q.extension.identifier),Q),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),Q},O=(T,Q)=>{Q?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),Q.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,Q.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Bp)(T),error:Q}),this.u.fire({identifier:T.identifier,error:Q?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},z=[],M=[];try{z.push(R(i));const T=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const Q=this.S(i,T);for(const re of Q)this.m.has(h(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):z.push(R(re))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(z.map(Q=>Q.extension),T,i),await this.L(z.map(async Q=>{try{if(await Q.run(),await this.L(this.y.map(re=>re.postUninstall(Q.extension,o,I.CancellationToken.None))),Q.extension.identifier.uuid)try{await this.z.reportStatistic(Q.extension.manifest.publisher,Q.extension.manifest.name,Q.extension.manifest.version,"uninstall")}catch{}O(Q.extension)}catch(re){const ie=$(re);throw O(Q.extension,ie),ie}finally{M.push(Q)}}))}catch(T){const Q=$(T);for(const re of z){try{re.cancel()}catch{}M.includes(re)||O(re.extension,Q)}throw Q}finally{for(const T of z)this.m.delete(h(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(i,s,o){for(const h of i){const P=this.U(h,s);if(P.length){const R=P.filter(O=>!i.some(z=>(0,w.$up)(z.identifier,O.identifier)));if(R.length)throw new Error(this.R(h,R,o))}}}R(i,s,o){return o===i?s.length===1?v.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?v.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):v.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?v.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?v.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):v.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const h=i.manifest.extensionPack?i.manifest.extensionPack:[];if(h.length){const P=s.filter(O=>!O.isBuiltin&&h.some(z=>(0,w.$up)({id:z},O.identifier))),R=[];for(const O of P)R.push(...this.S(O,s,o));return[...P,...R]}return[]}U(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(h=>(0,w.$up)({id:h},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,N.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$lq=m,e.$lq=m=$e([oe(0,y.$6o),oe(1,c.$2l),oe(2,u.$Al),oe(3,k.$3j),oe(4,g.$jk),oe(5,b.$Cl)],m);function $(t){if(t instanceof y.$7o)return t;if(t instanceof y.$8o){const s=new y.$7o(t.message,y.ExtensionManagementErrorCode.Gallery);return s.stack=t.stack,s}const i=new y.$7o(t.message,(0,N.$4)(t)?y.ExtensionManagementErrorCode.Cancelled:y.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:o,duration:h,error:P,durationSinceUpdate:R}){let O,z;(0,a.$eg)(o)&&(o===!0?o="Verified":(o===!1||(O=y.ExtensionManagementErrorCode.Signature,z=o),o="Unverified")),P&&(O=P.code,P.code===y.ExtensionManagementErrorCode.Signature&&(z=P.message)),t.publicLog(i,{...s,verificationStatus:o,success:!P,duration:h,errorcode:O,errorcodeDetail:z,durationSinceUpdate:R})}class r{constructor(){this.d=new j.$vh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,j.$jh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,j.$jh)(i=>new Promise((s,o)=>{const h=i.onCancellationRequested(()=>{h.dispose(),o(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$nq=r}),define(ne[42],se([0,1,8,14,2,5,30,11,21,26,13,10,6,24,23,3,9,22]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class b extends Error{constructor(t,i){super(t),this.code=i}}e.$oq=b,e.$pq=(0,v.$wi)("IExtensionsProfileScannerService");let m=class extends I.$Uc{constructor(t,i,s,o,h,P){super(),this.j=t,this.m=i,this.n=s,this.r=o,this.s=h,this.t=P,this.b=this.B(new N.$de),this.onAddExtensions=this.b.event,this.c=this.B(new N.$de),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$de),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$de),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i,s){const o=[],h=[];try{return await this.u(i,P=>{const R=[];if(s)R.push(...P);else for(const O of P)t.some(([z])=>(0,a.$up)(z.identifier,O.identifier)&&z.manifest.version!==O.version)?o.push(O):R.push(O);for(const[O,z]of t){const M=R.findIndex(Q=>(0,a.$up)(Q.identifier,O.identifier)&&Q.version===O.manifest.version),T={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:z};M===-1?(h.push(T),R.push(T)):R.splice(M,1,T)}return h.length&&this.b.fire({extensions:h,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),R}),h.length&&this.c.fire({extensions:h,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),h}catch(P){throw h.length&&this.c.fire({extensions:h,error:P,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:P,profileLocation:i}),P}}async updateMetadata(t,i){const s=[];return await this.u(i,o=>{const h=[];for(const P of o){const R=t.find(([O])=>(0,a.$up)(O.identifier,P.identifier)&&O.manifest.version===P.version);R&&(P.metadata={...P.metadata,...R[1]},s.push(P)),h.push(P)}return h}),s}async removeExtensionFromProfile(t,i){const s=[];try{await this.u(i,o=>{const h=[];for(const P of o)(0,a.$up)(P.identifier,t.identifier)?s.push(P):h.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:i}),h}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(t,i,s){return this.F(t).queue(async()=>{let o=[],h;try{const P=await this.m.readFile(t);h=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,f.$hl)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&s?.bailOutWhenFileNotFound)throw new b((0,g.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.w(t);let P=!1;for(const R of h){$(R)||this.w(t);let O;if((0,k.$9f)(R.relativeLocation)&&R.relativeLocation)O=this.z(R.relativeLocation);else if((0,k.$9f)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{O=E.URI.revive(R.location);const z=this.y(O);z&&(P=!0,R.relativeLocation=z)}(0,k.$dg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(P=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:O,version:R.version,metadata:R.metadata})}P&&await this.m.writeFile(t,j.$Fe.fromString(JSON.stringify(h)))}if(i){o=i(o);const P=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(t,j.$Fe.fromString(JSON.stringify(P)))}return o})}w(t){const i=new b(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(h){if((0,f.$hl)(h)===1)return;throw h}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const h=JSON.parse(s);Array.isArray(h)&&h.every(P=>$(P))?o=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$Fe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,f.$hl)(h)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(t)}catch(h){(0,f.$hl)(h)!==1&&this.t.error(h)}try{await this.m.del(i)}catch(h){(0,f.$hl)(h)!==1&&this.t.error(h)}return o})()),this.C}F(t){let i=this.h.get(t);return i||(i=new D.$Dh,this.h.set(t,i)),i}};e.$qq=m,e.$qq=m=$e([oe(1,f.$3k),oe(2,w.$Cl),oe(3,p.$Al),oe(4,c.$2l),oe(5,y.$3j)],m);function $(r){return(0,k.$$f)(r)&&(0,l.$5o)(r.identifier)&&(n(r.location)||(0,k.$9f)(r.location)&&r.location)&&((0,k.$dg)(r.relativeLocation)||(0,k.$9f)(r.relativeLocation))&&r.version&&(0,k.$9f)(r.version)}function n(r){return r?(0,k.$9f)(r.path)&&(0,k.$9f)(r.scheme):!1}}),define(ne[53],se([0,1,19,8,27,14,9,38,83,2,15,16,12,17,44,55,3,11,99,18,26,37,50,13,10,6,32,5,47,42,24,23,117]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u,b,m,$,n,r,t,i,s,o,h,P,R,O,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$vq=e.$uq=e.$tq=e.Translations=void 0,e.$wq=he;var M;(function(ce){function V(Z,B){if(Z===B)return!0;const q=Object.keys(Z),W=new Set;for(const X of Object.keys(B))W.add(X);if(q.length!==W.size)return!1;for(const X of q){if(Z[X]!==B[X])return!1;W.delete(X)}return W.size===0}ce.equals=V})(M||(e.Translations=M={})),e.$tq=(0,t.$wi)("IExtensionsScannerService");let T=class extends a.$Uc{constructor(V,Z,B,q,W,X,Y,_,F,U,d,S){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Z,this.r=B,this.s=q,this.t=W,this.u=X,this.w=Y,this.y=_,this.z=F,this.C=U,this.D=d,this.F=S,this.g=this.B(new o.$de),this.onDidChangeCache=this.g.event,this.h=(0,w.$0g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Fp)(this.w,this.y)),this.G}async scanAllExtensions(V,Z,B){const[q,W]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Z)]),X=B?await this.scanExtensionsUnderDevelopment(V,[...q,...W]):[];return this.L(q,W,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Z=[];Z.push(this.M(!!V.useCache,V.language)),Z.push(this.N(V.language,!!V.checkControlFile));const[B,q]=await Promise.all(Z);return this.J([...B,...q],0,V,!1)}async scanUserExtensions(V){const Z=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(Z,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,B,V.productVersion??this.R()),W=V.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let X;try{X=await W.scanExtensions(q)}catch(Y){if(Y instanceof P.$oq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await W.scanExtensions(q);else throw Y}return X=await this.J(X,1,V,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(V,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===f.Schemas.file).map(async q=>{const W=await this.P(q,!1,1,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=Z.find(_=>(0,m.$up)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,W)))}))).flat();return this.J(B,"development",V,!0)}return[]}async scanExistingExtension(V,Z,B){const q=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),W=await this.n.scanExtension(q);return!W||!B.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(V,Z,B){const q=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),W=await this.n.scanOneOrMultipleExtensions(q);return this.J(W,Z,B,!0)}async scanMultipleExtensions(V,Z,B){const q=[];return await Promise.all(V.map(async W=>{const X=await this.scanOneOrMultipleExtensions(W,Z,B);q.push(...X)})),this.J(q,Z,B,!0)}async scanMetadata(V){const Z=(0,w.$0g)(V,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(V,Z){const B=(0,w.$0g)(V,"package.json"),q=(await this.w.readFile(B)).value.toString(),W=JSON.parse(q);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,W.__metadata={...W.__metadata,...Z},await this.w.writeFile((0,w.$0g)(V,"package.json"),N.$Fe.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof P.$oq&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$Fe.fromString(JSON.stringify([])))}catch(Z){(0,r.$hl)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Z,B,q){return B.includeAllVersions||(V=this.L(Z===0?V:void 0,Z===1?V:void 0,Z==="development"?V:void 0,await this.getTargetPlatform(),q)),B.includeInvalid||(V=V.filter(W=>W.isValid)),V.sort((W,X)=>{const Y=v.$nc(W.location.fsPath),_=v.$nc(X.location.fsPath);return Y<_?-1:Y>_?1:0})}L(V,Z,B,q,W){const X=(_,F,U)=>{if(_.isValid&&!F.isValid)return!1;if(_.isValid===F.isValid){if(W&&p.gt(_.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(p.eq(_.manifest.version,F.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===q)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${_.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${F.location.path}.`),!0},Y=new $.$Tm;return V?.forEach(_=>{const F=Y.get(_.identifier.id);(!F||X(F,_,!1))&&Y.set(_.identifier.id,_)}),Z?.forEach(_=>{const F=Y.get(_.identifier.id);if(!F&&V&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!F||X(F,_,!1))&&Y.set(_.identifier.id,_)}),B?.forEach(_=>{const F=Y.get(_.identifier.id);(!F||X(F,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(V,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),W=await(V&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",W.length),W}async N(V,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const q=Z?await this.O():{},W=[],X=c.URI.file(v.$hc(v.$jc(f.$Qg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of B){const F=q[_.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":W.push((0,w.$0g)(X,_.name));break;default:W.push(c.URI.file(F));break}}const Y=await Promise.all(W.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,D.$Hb)(Y)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Z,B,q,W,X,Y,_){const F=await this.f(W??y.$w),U=await this.Q(V),d=Z&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,S=d?await this.Q(d):void 0;return new Q(V,U,d,S,Z,Y,B,q,X,_.version,_.date,this.C.commit,!this.z.isBuilt,W,F)}async Q(V){try{const Z=await this.w.stat(V);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$uq=T,e.$uq=T=$e([oe(4,R.$Cl),oe(5,P.$pq),oe(6,r.$3k),oe(7,i.$3j),oe(8,b.$Di),oe(9,s.$jk),oe(10,O.$Al),oe(11,t.$vi)],T);class Q{constructor(V,Z,B,q,W,X,Y,_,F,U,d,S,L,C,G){this.location=V,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=q,this.profile=W,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=_,this.validate=F,this.productVersion=U,this.productDate=d,this.productCommit=S,this.devMode=L,this.language=C,this.translations=G}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Z){return(0,w.$3g)(V.location,Z.location)&&V.mtime===Z.mtime&&(0,w.$3g)(V.applicationExtensionslocation,Z.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&V.profile===Z.profile&&I.$7n(V.profileScanOptions,Z.profileScanOptions)&&V.type===Z.type&&V.excludeObsolete===Z.excludeObsolete&&V.validate===Z.validate&&V.productVersion===Z.productVersion&&V.productDate===Z.productDate&&V.productCommit===Z.productCommit&&V.devMode===Z.devMode&&V.language===Z.language&&M.equals(V.translations,Z.translations)}}e.$vq=Q;let re=class extends a.$Uc{constructor(V,Z,B,q,W){super(),this.f=V,this.g=Z,this.h=B,this.j=q,this.m=W}async scanExtensions(V){const Z=V.profile?await this.r(V):await this.n(V);let B={};if(V.excludeObsolete&&V.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(q)}catch{}return(0,g.$jg)(B)?Z:Z.filter(q=>!B[m.$vp.create(q).toString()])}async n(V){const Z=await this.j.resolve(V.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async q=>{if(!q.isDirectory||V.type===1&&(0,w.$7g)(q.resource).indexOf(".")===0)return null;const W=new Q(q.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(W)}));return(0,D.$Hb)(B).sort((q,W)=>q.location.path<W.location.path?-1:1)}async r(V){let Z=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Z=Z.filter(q=>!q.metadata?.isApplicationScoped);const B=await this.s(V.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,V);Z.push(...B)}return Z}async s(V,Z,B){const q=await this.g.scanProfileExtensions(V,B.profileScanOptions);if(!q.length)return[];const W=await Promise.all(q.map(async X=>{if(Z(X)){const Y=new Q(X.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,D.$Hb)(W)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,w.$0g)(V.location,"package.json"))){const Z=await this.scanExtension(V);return Z?[Z]:[]}else return await this.scanExtensions(V)}catch(Z){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,A.$0)(Z)),[]}}async scanExtension(V,Z){try{let B=await this.scanExtensionManifest(V.location);if(B){B.publisher||(B.publisher=$.$Nm),Z=Z??B.__metadata,delete B.__metadata;const q=(0,m.$zp)(B.publisher,B.name),W=Z?.id?{id:q,uuid:Z.id}:{id:q},X=Z?.isSystem?0:V.type,Y=X===0||!!Z?.isBuiltin;B=await this.t(V.location,B,Q.createNlsConfiguration(V));const _={type:X,identifier:W,manifest:B,location:V.location,isBuiltin:Y,targetPlatform:Z?.targetPlatform??"undefined",publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return V.validate?this.validate(_,V):_}}catch(B){V.type!==0&&this.m.error(B)}return null}validate(V,Z){let B=!0;const q=(0,n.$Kp)(Z.productVersion,Z.productDate,Z.location,V.manifest,V.isBuiltin);for(const[W,X]of q)W===k.default.Error&&(B=!1,this.m.error(this.z(Z.location,X)));return V.isValid=B,V.validations=q,V}async scanExtensionManifest(V){const Z=(0,w.$0g)(V,"package.json");let B;try{B=(await this.j.readFile(Z)).value.toString()}catch(W){return(0,r.$hl)(W)!==1&&this.m.error(this.z(V,(0,u.localize)(0,null,Z.path,W.message))),null}let q;try{q=JSON.parse(B)}catch{const X=[];(0,E.$Jn)(B,X);for(const Y of X)this.m.error(this.z(V,(0,u.localize)(1,null,Z.path,Y.offset,Y.length,(0,l.$rq)(Y.error))));return null}return(0,E.$Sn)(q)!=="object"?(this.m.error(this.z(V,(0,u.localize)(2,null,Z.path))),null):q}async t(V,Z,B){const q=await this.u(V,Z,B);if(q)try{const W=[],X=await this.w(q.default,W);if(W.length>0)return W.forEach(_=>{this.m.error(this.z(V,(0,u.localize)(3,null,q.default?.path,(0,l.$rq)(_.error))))}),Z;if((0,E.$Sn)(q)!=="object")return this.m.error(this.z(V,(0,u.localize)(4,null,q.default?.path))),Z;const Y=q.values||Object.create(null);return(0,z.$sq)(this.m,Z,Y,X)}catch{}return Z}async u(V,Z,B){const q=(0,w.$0g)(V,"package.nls.json"),W=(F,U)=>{U.forEach(d=>{this.m.error(this.z(V,(0,u.localize)(5,null,F?.path,(0,l.$rq)(d.error))))})},X=F=>{this.m.error(this.z(V,(0,u.localize)(6,null,F?.path)))},Y=`${Z.publisher}.${Z.name}`,_=B.translations[Y];if(_)try{const F=c.URI.file(_),U=(await this.j.readFile(F)).value.toString(),d=[],S=(0,E.$Jn)(U,d);return d.length>0?(W(F,d),{values:void 0,default:q}):(0,E.$Sn)(S)!=="object"?(X(F),{values:void 0,default:q}):{values:S.contents?S.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let U;try{U=await this.y(V,B)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const d=(await this.j.readFile(U.localized)).value.toString(),S=[],L=(0,E.$Jn)(d,S);return S.length>0?(W(U.localized,S),{values:void 0,default:U.original}):(0,E.$Sn)(L)!=="object"?(X(U.localized),{values:void 0,default:U.original}):{values:L,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(V,Z){if(V)try{const B=(await this.j.readFile(V)).value.toString();return(0,E.$Jn)(B,Z)}catch{}}y(V,Z){return new Promise((B,q)=>{const W=X=>{const Y=(0,w.$0g)(V,`package.nls.${X}.json`);this.j.exists(Y).then(_=>{_&&B({localized:Y,original:(0,w.$0g)(V,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?B({localized:(0,w.$0g)(V,"package.nls.json"),original:null}):(X=X.substring(0,F),W(X))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,w.$0g)(V,"package.nls.json"),original:null});W(Z.language)})}z(V,Z){return`[${V.path}]: ${Z}`}};re=$e([oe(1,P.$pq),oe(2,O.$Al),oe(3,r.$3k),oe(4,i.$3j)],re);let ie=class extends re{constructor(V,Z,B,q,W,X,Y){super(Z,q,W,X,Y),this.G=V,this.H=B,this.D=this.B(new j.$uh(3e3)),this.F=this.B(new o.$de),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Z=this.M(V),B=await this.I(Z);if(this.C=V,B&&B.input&&Q.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),B.result.map(W=>(W.location=c.URI.revive(W.location),W));const q=await super.scanExtensions(V);return await this.J(Z,{input:V,result:q}),q}async I(V){try{const Z=await this.j.readFile(V),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,h.$6h)(B.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",V.path,(0,A.$0)(Z))}return null}async J(V,Z){try{await this.j.writeFile(V,N.$Fe.fromString(JSON.stringify(Z)))}catch(B){this.m.debug("Error while writing the extension cache file:",V.path,(0,A.$0)(B))}}async L(){if(!this.C)return;const V=this.M(this.C),Z=await this.I(V);if(!Z)return;const B=Z.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!I.$7n(q,B))try{this.m.info("Invalidating Cache",B,q),await this.j.del(V),this.F.fire()}catch(W){this.m.error(W)}}M(V){const Z=this.N(V);return this.h.extUri.joinPath(Z.cacheHome,V.type===0?$.$Mm:$.$Lm)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(V.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,R.$Cl),oe(3,P.$pq),oe(4,O.$Al),oe(5,r.$3k),oe(6,i.$3j)],ie);function he(ce,V){const Z=(0,m.$xp)(ce.manifest.publisher,ce.manifest.name);return{id:Z,identifier:new $.$Rm(Z),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:V,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class le extends T{constructor(V,Z,B,q,W,X,Y,_,F,U,d,S){super(V,Z,(0,w.$0g)(B,".vscode-oss-dev","extensions","control.json"),q,W,X,Y,_,F,U,d,S),this.S=(async()=>{if(y.$z)try{const L=await this.w.readFile(c.URI.file(y.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$xq=le}),define(ne[161],se([0,1,59,8,34,5,2,15,16,25,6,24]),function(J,e,D,j,I,N,A,E,l,a,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let y=class extends A.$Uc{constructor(p,k){super(),this.b=p,this.f=k,this.a=new j.$Ch(5)}async postUninstall(p){const k=this.g(p,"uninstall");k&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(k.script,"uninstall",k.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(g)}}));try{await a.Promises.rm(this.m(p))}catch(g){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(g)}}g(p,k){const g=`vscode:${k}`;if(p.location.scheme===E.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[g]=="string"){const c=p.manifest.scripts[g].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${g} should be a node script`),null):{script:(0,l.$jc)(p.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(p,k,g,c,u){return new Promise((b,m)=>{const $=this.j(p,k,g,u);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?m(t):b(void 0)};$.on("error",t=>{r((0,I.$hj)(t)||"Unknown")}),$.on("exit",(t,i)=>{r(t?`post-${k} process exited with code ${t}`:void 0)}),c&&(n=setTimeout(()=>{n=null,$.kill(),m("timed out")},5e3))})}j(p,k,g,c){const u={silent:!0,execArgv:void 0},b=(0,D.fork)(p,[`--type=extension-post-${k}`,...g],u);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const m=N.Event.fromNodeEventEmitter(b.stdout,"data"),$=N.Event.fromNodeEventEmitter(b.stderr,"data");this.B(m(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${k}`,t))),this.B($(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${k}`,t)));const n=N.Event.any(N.Event.map(m,t=>({data:`%c${t}`,format:[""]}),this.q),N.Event.map($,t=>({data:`%c${t}`,format:["color: red"]}),this.q));return N.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),b}m(p){return(0,l.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$zq=y,e.$zq=y=$e([oe(0,v.$Cl),oe(1,f.$3j)],y)}),define(ne[162],se([0,1,8,14,20,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,100,61,18,160,21,26,42,53,147,161,118,140,148,50,13,10,6,32,22,23,24]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u,b,m,$,n,r,t,i,s,o,h,P,R,O,z,M,T,Q,re,ie,he,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.$Dq=void 0,e.$Dq=(0,Q.$xi)(t.$9o);const V=".vsctmp";let Z=class extends r.$lq{constructor(F,U,d,S,L,C,G,H,te,ae,ue,pe){super(F,U,ue,d,ae,pe),this.eb=L,this.fb=C,this.gb=G,this.hb=te,this.db=new Map,this.qb=new f.$Bc;const ye=this.B(H.createInstance(P.$zq));this.ab=this.B(H.createInstance(B,me=>ye.postUninstall(me))),this.bb=this.B(new O.$Bq(pe,te,ue,this,this.F)),this.cb=this.B(H.createInstance(h.$yq));const fe=this.B(new z.$Cq(this,this.eb,pe,C,ue,te,d));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,i.$Fp)(this.hb,this.F)),this.ib}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const U=await this.ob(F),d=await(0,b.zip)((0,w.$0g)(this.cb.extensionsDownloadDir,(0,c.$Sg)()).fsPath,U);return g.URI.file(d)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:U,cleanup:d}=await this.kb(F),S=y.$kc(U.fsPath);try{return await(0,R.$Aq)(S)}finally{await d()}}getInstalled(F,U=this.H.defaultProfile.extensionsResource,d={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,U,d)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,U={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:d,cleanup:S}=await this.kb(F);try{const L=await(0,R.$Aq)(y.$kc(d.fsPath)),C=(0,i.$zp)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,M.$Mp)(L.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,C,this.G.version));const H=(await this.I([{manifest:L,extension:d,options:U}])).find(({identifier:te})=>(0,i.$up)(te,{id:C}));if(H?.local)return H.local;throw H?.error?H.error:(0,r.$mq)(new Error(`Unknown error while installing extension ${C}`))}finally{await S()}}async installFromLocation(F,U){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const d=await this.ab.scanUserExtensionAtLocation(F);if(!d||!d.manifest.name||!d.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.tb([[d,{source:"resource"}]],U),this.F.info("Successfully installed extension",d.identifier.id,U.toString()),d}async installExtensionsFromProfile(F,U,d){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,U.toString(),d.toString());const S=(await this.getInstalled(1,U)).filter(L=>F.some(C=>(0,i.$up)(C,L.identifier)));if(S.length){const L=await Promise.all(S.map(C=>this.ab.scanMetadata(C,U)));await this.tb(S.map((C,G)=>[C,L[G]]),d),this.F.info("Successfully installed extensions",S.map(C=>C.identifier.id),d.toString())}return S}async updateMetadata(F,U,d=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),F=await this.ab.updateMetadata(F,U,d),this.bb.invalidate(d),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const U=await this.getTargetPlatform(),[d]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:U,compatible:!0},I.CancellationToken.None);if(!d)throw new Error(m.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(S){throw new Error(m.localize(3,null,(0,N.$hj)(S)))}return this.installFromGallery(d)}$(F,U,d,S){return this.ab.copyExtension(F,U,d,S)}copyExtensions(F,U){return this.ab.copyExtensions(F,U,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,U,d){const{location:S}=await this.cb.download(F,U,!d);return S}async kb(F){if(F.scheme===v.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const U=(0,w.$0g)(this.cb.extensionsDownloadDir,(0,c.$Sg)());return await this.gb.download(F,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(S){this.F.error(S)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,U,d){if(g.URI.isUri(U))return new X(F,U,d,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const S=i.$vp.create(U).toString();let L=this.db.get(S);return L||(this.db.set(S,L=new W(F,U,d,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),L.waitUntilTaskIsFinished().finally(()=>this.db.delete(S))),L}Z(F,U){return new Y(F,U.profileLocation,this.fb)}async ob(F){const U=async S=>{let L=await u.Promises.readdir(S);L=L.map(H=>y.$jc(S,H));const C=await Promise.all(L.map(H=>u.Promises.stat(H)));let G=Promise.resolve([]);return C.forEach((H,te)=>{const ae=L[te];H.isFile()&&(G=G.then(ue=>[...ue,ae])),H.isDirectory()&&(G=G.then(ue=>U(ae).then(pe=>[...ue,...pe])))}),G};return(await U(F.location.fsPath)).map(S=>({path:`extension/${y.$lc(F.location.fsPath,S)}`,localPath:S}))}async pb({added:F,removed:U}){if(U){const d=F&&this.D.extUri.isEqual(U.profileLocation,F.profileLocation)?U.extensions.filter(S=>F.extensions.every(L=>!(0,i.$up)(L,S))):U.extensions;for(const S of d)this.F.info("Extensions removed from another source",S.id,U.profileLocation.toString()),this.u.fire({identifier:S,profileLocation:U.profileLocation})}if(F){const S=(await this.getInstalled(1,F.profileLocation)).filter(L=>F.extensions.some(C=>(0,i.$up)(C,L.identifier)));this.s.fire(S.map(L=>(this.F.info("Extensions added from another source",L.identifier.id,F.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:F.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const F=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of F.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(F){if(!F.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const d of F.rawAdded){if(this.qb.has(d)||!this.D.extUri.isEqual(this.D.extUri.dirname(d),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(d,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(d).startsWith(".")||!(await this.hb.stat(d)).isDirectory)continue;const S=await this.ab.scanUserExtensionAtLocation(d);S&&S.installedTimestamp===void 0&&(this.qb.add(d),U.push(S))}U.length&&(await this.tb(U.map(d=>[d,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(d=>d.identifier.id)))}async tb(F,U){const d=F.map(S=>S[0]);await this.ub(d),await this.fb.addExtensionsToProfile(F,U),this.s.fire(d.map(S=>({local:S,identifier:S.identifier,operation:1,profileLocation:U})))}async ub(F){const U=await this.ab.getUninstalledExtensions();for(const d of F){const S=i.$vp.create(d);U[S.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",S.id),await this.ab.setInstalled(S),this.F.info("Removed the extension from uninstalled list:",S.id))}}};e.$Eq=Z,e.$Eq=Z=$e([oe(0,t.$6o),oe(1,he.$2l),oe(2,re.$3j),oe(3,n.$Ei),oe(4,o.$tq),oe(5,s.$pq),oe(6,$.$Ko),oe(7,Q.$vi),oe(8,T.$3k),oe(9,ie.$jk),oe(10,le.$Al),oe(11,ce.$Cl)],Z);let B=class extends a.$Uc{constructor(F,U,d,S,L,C){super(),this.j=F,this.m=U,this.n=d,this.s=S,this.t=L,this.u=C,this.h=this.B(new E.$de),this.onExtract=this.h.event,this.c=(0,w.$0g)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Dh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,U,d){const S={includeInvalid:!0,profileLocation:U,productVersion:d};let L=[];return F===null||F===0?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},S,!1)):F===1&&L.push(...await this.n.scanUserExtensions(S)),L=F!==null?L.filter(C=>C.type===F):L,Promise.all(L.map(C=>this.F(C)))}async scanAllUserExtensions(F){const U=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(U.map(d=>this.F(d)))}async scanUserExtensionAtLocation(F){try{const U=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(F,U,d,S,L){const C=F.toString(),G=g.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Sg)()}`)),H=g.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,C));let te=await this.m.exists(H);if(te&&S){try{await this.y(F.id,H,"removeExisting")}catch{throw new t.$7o(m.localize(4,null,H.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(H,d);else try{try{this.u.trace(`Started extracting the extension from ${U} to ${H.fsPath}`),await(0,b.$jq)(U,G.fsPath,{sourcePath:"extension",overwrite:!0},L),this.u.info(`Extracted extension to ${H}:`,F.id)}catch(ae){let ue=t.ExtensionManagementErrorCode.Extract;throw ae instanceof b.$hq&&(ae.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$7o(ae.message,ue)}await this.n.updateMetadata(G,d);try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${H.fsPath}`),await this.C(G.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ae)}. Deleted from extracted location`,G),ae}this.h.fire(H)}catch(ae){try{await this.m.del(G,{recursive:!0})}catch{}throw ae}return this.D(H,1)}async scanMetadata(F,U){return U?(await this.w(F,U))?.metadata:this.n.scanMetadata(F.location)}async w(F,U){return(await this.s.scanProfileExtensions(U)).find(S=>(0,i.$up)(S.identifier,F.identifier))}async updateMetadata(F,U,d){return d?await this.s.updateMetadata([[F,U]],d):await this.n.updateMetadata(F.location,U),this.D(F.location,F.type,d)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const U=F.map(d=>i.$vp.create(d));await this.z(d=>U.forEach(S=>{d[S.toString()]=!0,this.u.info("Marked extension as uninstalled",S.toString())}))}async setInstalled(F){await this.z(U=>delete U[F.toString()])}async removeExtension(F,U){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,U)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(U=>delete U[i.$vp.create(F).toString()])}async copyExtension(F,U,d,S){const L=await this.w(F,U),C=await this.w(F,d);if(S={...L?.metadata,...S},C)if(this.t.extUri.isEqual(C.location,F.location))await this.s.updateMetadata([[F,{...C.metadata,...S}]],d);else{const G=await this.D(C.location,F.type,d);await this.s.removeExtensionFromProfile(G,d),await this.s.addExtensionsToProfile([[F,{...C.metadata,...S}]],d)}else await this.s.addExtensionsToProfile([[F,S]],d);return this.D(F.location,F.type,d)}async copyExtensions(F,U,d){const S=await this.scanExtensions(1,F,d),L=await Promise.all(S.filter(C=>!C.isApplicationScoped).map(async C=>[C,await this.scanMetadata(C,F)]));await this.s.addExtensionsToProfile(L,U)}async y(F,U,d){this.u.trace(`Deleting ${d} extension from disk`,F,U.fsPath);const S=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,l.$kj)((0,c.$Sg)()).toString(16)}${V}`);await this.C(U.fsPath,S.fsPath),await this.m.del(S,{recursive:!0}),this.u.info(`Deleted ${d} extension from disk`,F,U.fsPath)}async z(F){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(S){if((0,T.$hl)(S)!==1)throw S}let d={};if(U)try{d=JSON.parse(U)}catch{}return F&&(F(d),Object.keys(d).length?await this.m.writeFile(this.c,j.$Fe.fromString(JSON.stringify(d))):await this.m.del(this.c)),d})}async C(F,U){try{await u.Promises.rename(F,U,2*60*1e3)}catch(d){throw new t.$7o(d.message||m.localize(5,null,F,U),d.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,U,d){if(d){const L=(await this.n.scanUserExtensions({profileLocation:d})).find(C=>this.t.extUri.isEqual(C.location,F));if(L)return this.F(L)}else{const S=await this.n.scanExistingExtension(F,U,{includeInvalid:!0});if(S)return this.F(S)}throw new Error(m.localize(6,null,F.path))}async F(F){const U=await this.m.resolve(F.location);let d,S;return U.children&&(d=U.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,S=U.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:d,changelogUrl:S,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const L of U)F[i.$vp.create(L).toString()]||d.add(L.identifier.id.toLowerCase());try{const L=(0,i.$Ap)(U,C=>C.identifier);await D.Promises.settled(L.map(async C=>{const G=C.sort((H,te)=>p.rcompare(H.manifest.version,te.manifest.version))[0];d.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(L){this.u.error(L)}const S=U.filter(L=>L.metadata&&F[i.$vp.create(L).toString()]);await Promise.allSettled(S.map(L=>this.removeUninstalledExtension(L)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,T.$hl)(U)!==1&&this.u.error(U);return}if(F?.children)try{await Promise.allSettled(F.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(d){(0,T.$hl)(d)!==1&&this.u.error(d)}}}))}catch{}}};e.$Fq=B,e.$Fq=B=$e([oe(1,T.$3k),oe(2,o.$tq),oe(3,s.$pq),oe(4,le.$Al),oe(5,re.$3j)],B);class q extends r.$nq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,k.$dg)(this.options.operation)?this.l:this.options.operation}constructor(F,U,d,S,L,C,G,H,te,ae){super(),this.manifest=F,this.identifier=U,this.source=d,this.options=S,this.m=L,this.n=C,this.o=G,this.p=H,this.q=te,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[U,d]=await this.x(F);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,d]],this.j,!U.isValid),U}async u({zipPath:F,key:U,metadata:d},S,L){let C=await this.v(U);return C?C=await this.m.updateMetadata(C,d):(this.s.trace("Extracting extension...",U.id),C=await this.m.extractUserExtension(U,F,d,S,L),this.s.info("Extracting extension completed.",U.id)),C}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(S=>i.$vp.create(S).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class W extends q{constructor(F,U,d,S,L,C,G,H,te,ae,ue){super(F,U.identifier,U,d,L,C,G,H,te,ae),this.y=U,this.z=S,this.A=ue}async x(F){let U;try{U=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(L){throw new t.$7o(L,t.ExtensionManagementErrorCode.Scanning)}const d=U.find(L=>(0,i.$up)(L.identifier,this.y.identifier));d&&(this.l=3);const S={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:d?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:(0,k.$cg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||d?.preRelease,source:"gallery"};if(d&&d.type!==0&&d.manifest.version===this.y.version)try{return[await this.m.updateMetadata(d,S),S]}catch(L){throw new t.$7o((0,A.$0)(L),t.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(S,F)}catch(L){if(L instanceof t.$7o&&(L.code===t.ExtensionManagementErrorCode.CorruptZip||L.code===t.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const C=await this.C(S,F);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),C}catch(C){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),C}}else throw L}}async C(F,U){const{location:d,verificationStatus:S}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=S,this.D(d.fsPath),[await this.u({zipPath:d.fsPath,key:i.$vp.create(this.y),metadata:F},!1,U),F]}catch(L){try{await this.z.delete(d)}catch(C){this.s.warn("Error while deleting the downloaded file",d.toString(),(0,A.$0)(C))}throw L}}async D(F){try{await(0,R.$Aq)(F)}catch(U){throw new t.$7o(U.message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Gq=W;class X extends q{constructor(F,U,d,S,L,C,G,H,te,ae){super(F,{id:(0,i.$zp)(F.publisher,F.name)},U,d,L,C,G,H,te,ae),this.y=U,this.z=S}async h(F){const U=await super.h(F);return this.C(U,F),U}async x(F){const U=new i.$vp(this.identifier,this.manifest.version),S=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.$up)(this.identifier,G.identifier)),L={isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??S?.pinned,source:"vsix"};if(S)if(this.l=3,U.equals(new i.$vp(S.identifier,S.manifest.version)))try{await this.m.removeExtension(S,"existing")}catch{throw new Error(m.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&p.gt(S.manifest.version,this.manifest.version)&&await this.m.setUninstalled(S);else{const G=await this.v(U);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(m.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:y.$kc(this.y.fsPath),key:U,metadata:L},!0,F),L]}async C(F,U){try{let[d]=await this.z.getExtensions([{id:F.identifier.id,version:F.manifest.version}],U);if(d||([d]=await this.z.getExtensions([{id:F.identifier.id}],U)),d){const S={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,S,this.options.profileLocation)}}catch{}}}class Y extends r.$nq{constructor(F,U,d){super(),this.extension=F,this.j=U,this.k=d}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],se([0,1,6,24,23,22,42,13,18,11]),function(J,e,D,j,I,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YQ=void 0;let f=class extends A.$qq{constructor(y,w,p,k,g,c){super(a.URI.file(y.extensionsPath),w,p,k,g,c)}};e.$YQ=f,e.$YQ=f=$e([oe(0,l.$Ei),oe(1,E.$3k),oe(2,j.$Cl),oe(3,I.$Al),oe(4,N.$2l),oe(5,D.$3j)],f)}),define(ne[164],se([0,1,11,18,42,53,13,10,6,32,23,24]),function(J,e,D,j,I,N,A,E,l,a,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;let y=class extends N.$xq{constructor(p,k,g,c,u,b,m,$){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,k,g,c,u,b,m,$)}};e.$sdc=y,e.$sdc=y=$e([oe(0,v.$Cl),oe(1,I.$pq),oe(2,A.$3k),oe(3,l.$3j),oe(4,j.$Ei),oe(5,a.$jk),oe(6,f.$Al),oe(7,E.$vi)],y)}),define(ne[165],se([0,1,8,5,2,130,3,90,10,24]),function(J,e,D,j,I,N,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=w,e.$4p=k,e.$6p=c,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,l.$wi)("storageService");var f;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var v;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var y;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function w(u){const b=u.get(e.$Zp);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}class p extends I.$Uc{static{this.a=60*1e3}constructor(b={flushInterval:p.a}){super(),this.m=b,this.b=this.B(new j.$ge),this.c=this.B(new j.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$de),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(b,m,$){return j.Event.filter(this.b.event,n=>n.scope===b&&(m===void 0||n.key===m),$)}n(){this.j.value=(0,D.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(b,m){const{key:$,external:n}=m;if($===e.$Zp){switch(b){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:$,target:this.J(b)[$],external:n})}w(b){this.f.fire({reason:b})}get(b,m,$){return this.P(m)?.get(b,$)}getBoolean(b,m,$){return this.P(m)?.getBoolean(b,$)}getNumber(b,m,$){return this.P(m)?.getNumber(b,$)}getObject(b,m,$){return this.P(m)?.getObject(b,$)}storeAll(b,m){this.y(()=>{for(const $ of b)this.store($.key,$.value,$.scope,$.target,m)})}store(b,m,$,n,r=!1){if((0,A.$fg)(m)){this.remove(b,$,r);return}this.y(()=>{this.z(b,$,n),this.P($)?.set(b,m,r)})}remove(b,m,$=!1){this.y(()=>{this.z(b,m,void 0),this.P(m)?.delete(b,$)})}y(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,m){const $=[],n=this.J(b);for(const r of Object.keys(n))n[r]===m&&$.push(r);return $}z(b,m,$,n=!1){const r=this.J(m);typeof $=="number"?r[b]!==$&&(r[b]=$,this.P(m)?.set(e.$Zp,JSON.stringify(r),n)):typeof r[b]=="number"&&(delete r[b],this.P(m)?.set(e.$Zp,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(b){switch(b){case-1:return this.I;case 0:return this.G;default:return this.D}}L(b){const m=this.P(b);return m?w(m):Object.create(null)}isNew(b){return this.getBoolean(e.$Yp,b)===!0}async flush(b=f.NONE){this.f.fire({reason:b});const m=this.P(-1),$=this.P(0),n=this.P(1);switch(b){case f.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return c(b,m,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(b){return await this.flush(),this.P(b)?.optimize()}async switch(b,m){return this.w(f.NONE),(0,a.$Bl)(b)?this.R(b,m):this.S(b,m)}M(b,m){return!(b.id===m.id||k(m)&&k(b))}N(b,m,$){this.y(()=>{const n=new Set;for(const[r,t]of b)n.add(r),m.get(r)!==t&&this.u($,{key:r,external:!0});for(const[r]of m.items)n.has(r)||this.u($,{key:r,external:!0})})}}e.$3p=p;function k(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class g extends p{constructor(){super(),this.U=this.B(new E.$Wp(new E.$Xp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Wp(new E.$Xp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Wp(new E.$Xp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(b=>this.u(1,b))),this.B(this.W.onDidChangeStorage(b=>this.u(0,b))),this.B(this.U.onDidChangeStorage(b=>this.u(-1,b)))}P(b){switch(b){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(b){return!1}}e.$5p=g;async function c(u,b,m,$,n,r){const t=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,s=new Map;u.forEach((M,T)=>{i.set(T,M),s.set(T,t(M))});const o=new Map,h=new Map;b.forEach((M,T)=>{o.set(T,M),h.set(T,t(M))});const P=new Map,R=new Map;m.forEach((M,T)=>{P.set(T,M),R.set(T,t(M))}),console.group($!==n?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const O=[];if(i.forEach((M,T)=>{O.push({key:T,value:M})}),console.table(O),console.groupEnd(),console.log(s),$!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const M=[];o.forEach((T,Q)=>{M.push({key:Q,value:T})}),console.table(M),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${r})`);const z=[];P.forEach((M,T)=>{z.push({key:T,value:M})}),console.table(z),console.groupEnd(),console.log(R)}}),define(ne[166],se([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u,b,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0,e.$9p=X;const n=N.$o?"web":(0,v.$2o)(N.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...S){return String(S.reduce((L,C)=>L|C,0))}var s;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class O{constructor(L=R){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,C=this.d.pageSize){return new O({...this.d,pageNumber:L,pageSize:C})}withFilter(L,...C){const G=[...this.d.criteria,...C.length?C.map(H=>({filterType:L,value:H})):[{filterType:L}]];return new O({...this.d,criteria:G})}withSortBy(L){return new O({...this.d,sortBy:L})}withSortOrder(L){return new O({...this.d,sortOrder:L})}withFlags(...L){return new O({...this.d,flags:L.reduce((C,G)=>C|G,0)})}withAssetTypes(...L){return new O({...this.d,assetTypes:L})}withSource(L){return new O({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:C,pageSize:G,sortBy:H,sortOrder:te,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:L,pageNumber:C,pageSize:G,sortBy:H,sortOrder:te}],assetTypes:ue,flags:ae}}get searchText(){const L=this.d.criteria.filter(C=>C.filterType===s.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function z(S,L){const C=(S||[]).filter(G=>G.statisticName===L)[0];return C?C.value:0}function M(S){const L="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(G=>G.assetType.indexOf(L)===0).reduce((G,H)=>{const te=re(S,H.assetType);return te&&G.push([H.assetType.substring(L.length),te]),G},[])}function T(S){if(S.properties){const L=S.properties.filter(H=>H.key===o.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=L.filter(H=>C.test(H.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return re(S,o.Repository)}function Q(S){return{uri:`${S.fallbackAssetUri}/${o.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${o.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function re(S,L){return S.files.filter(G=>G.assetType===L)[0]?{uri:`${S.assetUri}/${L}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${L}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function ie(S,L){const C=S.properties?S.properties.filter(H=>H.key===L):[],G=C.length>0&&C[0].value;return G?G.split(",").map(H=>(0,y.$yp)(H)):[]}function he(S){const L=S.properties?S.properties.filter(C=>C.key===h.Engine):[];return L.length>0&&L[0].value||""}function le(S){const L=S.properties?S.properties.filter(C=>C.key===h.PreRelease):[];return L.length>0&&L[0].value==="true"}function ce(S){const L=S.properties?S.properties.filter(G=>G.key===h.LocalizedLanguages):[],C=L.length>0&&L[0].value||"";return C?C.split(","):[]}function V(S){return S.properties?.find(L=>L.key===h.SponsorLink)?.value}function Z(S){return S.properties?.find(L=>L.key===h.SupportLink)?.value}function B(S){return S.indexOf("preview")!==-1}function q(S){return S.targetPlatform?(0,v.$1o)(S.targetPlatform):"undefined"}function W(S){const L=(0,D.$Mb)(S.versions.map(q)),C=!!S.tags?.includes(v.$Vo),G=L.indexOf("web");return C?G===-1&&L.push("web"):G!==-1&&L.splice(G,1),L}function X(S,L){for(let C=0;C<S.length;C++){const G=S[C];if(G.version===S[C-1]?.version){let H=C;if(q(G)===L)for(;H>0&&S[H-1].version===G.version;)H--;H!==C&&(S.splice(C,1),S.splice(H,0,G))}}return S}function Y(S,L,C){S.telemetryData={index:L,querySource:C,queryActivityId:S.queryContext?.[r]}}function _(S,L,C,G){const H=S.versions[0],te={manifest:re(L,o.Manifest),readme:re(L,o.Details),changelog:re(L,o.Changelog),license:re(L,o.License),repository:T(L),download:Q(L),icon:re(L,o.Icon),signature:re(L,o.Signature),coreTranslations:M(L)};return{identifier:{id:(0,y.$zp)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:L.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(H),description:S.shortDescription??"",installCount:z(S.statistics,"install"),rating:z(S.statistics,"averagerating"),ratingCount:z(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:C,assets:te,properties:{dependencies:ie(L,h.Dependency),extensionPack:ie(L,h.ExtensionPack),engine:he(L),localizedLanguages:ce(L),targetPlatform:q(L),isPreReleaseVersion:le(L)},hasPreReleaseVersion:le(H),hasReleaseVersion:!0,preview:B(S.flags),isSigned:!!te.signature,queryContext:G,supportLink:Z(H)}}let F=class{constructor(L,C,G,H,te,ae,ue,pe){this.k=C,this.l=G,this.n=H,this.o=te,this.q=ae,this.u=ue,this.w=pe;const ye=ue.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,u.$8p)(ue.version,ue,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,C,G){const H=j.CancellationToken.isCancellationToken(C)?{}:C,te=j.CancellationToken.isCancellationToken(C)?C:G,ae=[],ue=[],pe=[],ye=[];let fe=!0;for(const we of L){we.uuid?ue.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!ue.length&&!ae.length)return[];let me=new O().withPage(1,L.length);ue.length&&(me=me.withFilter(s.ExtensionId,...ue)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(H.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),H.source&&(me=me.withSource(H.source));const{extensions:de}=await this.z(me,{targetPlatform:H.targetPlatform??n,includePreRelease:pe,versions:ye,compatible:!!H.compatible,productVersion:H.productVersion??{version:this.u.version,date:this.u.date}},te);return H.source&&de.forEach((we,Ee)=>Y(we,Ee,H.source)),de}async getCompatibleExtension(L,C,G,H={version:this.u.version,date:this.u.date}){if((0,v.$3o)(L.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(L,C,G))return L;const te=new O().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,L.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:G,compatible:!0,includePreRelease:C,productVersion:H},j.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(L,C,G,H={version:this.u.version,date:this.u.date}){if(!(0,v.$4o)(L.properties.targetPlatform,L.allTargetPlatforms,G)||!C&&L.properties.isPreReleaseVersion)return!1;let te=L.properties.engine;if(!te){const ae=await this.getManifest(L,j.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,w.$Mp)(te,H.version,H.date)}async y(L,C,G,H,te,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,v.$4o)(q(C),te,ae)||G!=="any"&&le(C)!==(G==="prerelease"))return!1;if(H)try{const pe=await this.E(L,C);if(!(0,w.$Mp)(pe,ue.version,ue.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,I.$0)(pe)),!1}return!0}async query(L,C){let G=L.text||"";const H=L.pageSize??50;let te=new O().withPage(1,H);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(s.SearchText,G)),te=te.withSortBy(0)):L.ids?te=te.withFilter(s.ExtensionId,...L.ids):L.names?te=te.withFilter(s.ExtensionName,...L.names):te=te.withSortBy(4),typeof L.sortBy=="number"&&(te=te.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(te=te.withSortOrder(L.sortOrder)),L.source&&(te=te.withSource(L.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!L.includePreRelease,productVersion:L.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,Ie)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+Ie,L.source)),{extensions:de,total:we}},{extensions:ue,total:pe}=await ae(te,C),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new I.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:ue,total:pe,pageSize:te.pageSize,getPage:ye}}async z(L,C,G){const H=L.flags;L.flags&t.IncludeLatestVersionOnly&&L.flags&t.IncludeVersions&&(L=L.withFlags(L.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(L.flags&t.IncludeLatestVersionOnly)&&!(L.flags&t.IncludeVersions)&&(L=L.withFlags(L.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(L=L.withFlags(L.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),L=L.withFlags(L.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:ue}=await this.B(L,G);if(!(L.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,C,ue);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,y.$zp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,E.$cg)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(x=>(0,y.$up)(x,we))?.includePreRelease;if(C.compatible&&(0,v.$3o)(W(de),C.targetPlatform))continue;const Ie=await this.A(de,C,ue);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==C.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,Ie])}if(fe.size){const me=new $.$_d,de=new O().withFlags(H&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,C,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const Ie=fe.get(Ee.identifier.uuid);ye.push([Ie,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(L,C,G){const H={id:(0,y.$zp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},te=C.versions?.find(ye=>(0,y.$up)(ye,H))?.version,ae=(0,E.$cg)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ye=>(0,y.$up)(ye,H))?.includePreRelease,ue=W(L),pe=X(L.versions,C.targetPlatform);if(C.compatible&&(0,v.$3o)(ue,C.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,y.$zp)(L.publisher.publisherName,L.extensionName),fe,ae?"any":"release",C.compatible,ue,C.targetPlatform,C.productVersion))return _(L,fe,ue,G);if(te&&fe.version===te)return null}}return te||C.compatible?null:_(L,L.versions[0],ue)}async B(L,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(t.Unpublished));const G=await this.j,H=JSON.stringify(L.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ae=new $.$_d;let ue,pe,ye=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&L.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:te},C),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Tp)(ue);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,I.$4)(fe)?v.ExtensionGalleryErrorCode.Cancelled:(0,I.$0)(fe).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw pe=new v.$8o((0,I.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(H.length),duration:ae.elapsed(),success:!!ue&&(0,c.$Pp)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(L,C,G,H){if(!this.isEnabled())return;const te=N.$o?this.x(`/itemName/${L}.${C}/version/${G}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${C}/${G}/stats?statType=${H}`),ae=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},j.CancellationToken.None)}catch{}}async download(L,C,G){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const H=(0,y.$Cp)(L),te=new Date().getTime(),ae=me=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:me}),ue=G===2?"install":G===3?"update":"",pe=ue?{uri:`${L.assets.download.uri}${l.URI.parse(L.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${L.assets.download.fallbackUri}${l.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:L.assets.download,ye=L.queryContext?.[r]?{[r]:L.queryContext[r]}:void 0,fe=await this.D(L.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(C,fe.stream),ae(new Date().getTime()-te)}async downloadSignatureArchive(L,C){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const G=await this.D(L.identifier.id,L.assets.signature,o.Signature);await this.q.writeFile(C,G.stream)}async getReadme(L,C){if(L.assets.readme){const G=await this.D(L.identifier.id,L.assets.readme,o.Details,{},C);return await(0,c.$Sp)(G)||""}return""}async getManifest(L,C){if(L.assets.manifest){const G=await this.D(L.identifier.id,L.assets.manifest,o.Manifest,{},C),H=await(0,c.$Sp)(G);return H?JSON.parse(H):null}return null}async C(L,C,G){const H=re(C,o.Manifest);if(!H)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(L,H,o.Manifest,{headers:te});return await(0,c.$Tp)(ae)}async getCoreTranslation(L,C){const G=L.assets.coreTranslations.filter(H=>H[0]===C.toUpperCase())[0];if(G){const H=await this.D(L.identifier.id,G[1],G[0]),te=await(0,c.$Sp)(H);return te?JSON.parse(te):null}return null}async getChangelog(L,C){if(L.assets.changelog){const G=await this.D(L.identifier.id,L.assets.changelog,o.Changelog,{},C);return await(0,c.$Sp)(G)||""}return""}async getAllCompatibleVersions(L,C,G){let H=new O().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?H=H.withFilter(s.ExtensionId,L.identifier.uuid):H=H.withFilter(s.ExtensionName,L.identifier.id);const{galleryExtensions:te}=await this.B(H,j.CancellationToken.None);if(!te.length)return[];const ae=W(te[0]);if((0,v.$3o)(ae,G))return[];const ue=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(L.identifier.id,fe,C?"any":"release",!0,ae,G)&&ue.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of X(ue,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:le(fe)}));return pe}async D(L,C,G,H={},te=j.CancellationToken.None){const ae=await this.j,ue={type:"GET"},pe={...ae,...H.headers||{}};H={...H,...ue,headers:pe};const ye=C.uri,fe=C.fallbackUri,me={...H,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,c.$Sp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,I.$4)(de))throw de;const we=(0,I.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:L,assetType:G,message:we});const Ee={...H,url:fe};return this.k.request(Ee,te)}}async E(L,C){let G=he(C);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:L,version:C.version});const H=await this.C(L,C,j.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},j.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.$Tp)(L),G=[],H={},te=[];if(C){for(const ae of C.malicious)G.push({id:ae});if(C.migrateToPreRelease)for(const[ae,ue]of Object.entries(C.migrateToPreRelease))(!ue.engine||(0,w.$Mp)(ue.engine,this.u.version,this.u.date))&&(H[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[ae,ue]of Object.entries(C.deprecated))ue&&(H[ae.toLowerCase()]=(0,E.$cg)(ue)?{}:ue);if(C.search)for(const ae of C.search)te.push(ae)}return{malicious:G,deprecated:H,search:te}}};F=$e([oe(1,c.$Np),oe(2,k.$3j),oe(3,f.$Di),oe(4,m.$2l),oe(5,p.$3k),oe(6,g.$jk),oe(7,a.$3i)],F);let U=class extends F{constructor(L,C,G,H,te,ae,ue,pe){super(L,C,G,H,te,ae,ue,pe)}};e.$0p=U,e.$0p=U=$e([oe(0,b.$1p),oe(1,c.$Np),oe(2,k.$3j),oe(3,f.$Di),oe(4,m.$2l),oe(5,p.$3k),oe(6,g.$jk),oe(7,a.$3i)],U);let d=class extends F{constructor(L,C,G,H,te,ae,ue){super(void 0,L,C,G,H,te,ae,ue)}};e.$$p=d,e.$$p=d=$e([oe(0,c.$Np),oe(1,k.$3j),oe(2,f.$Di),oe(3,m.$2l),oe(4,p.$3k),oe(5,g.$jk),oe(6,a.$3i)],d)}),define(ne[167],se([0,1,11,18,13,6,145,23,24,3,69]),function(J,e,D,j,I,N,A,E,l,a,f){"use strict";var v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$WQ=e.$VQ=void 0;let w=class extends l.$Fl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,u,b,m,$){super(b,m,u,$),this.U=c,this.W=b}O(){return this.U.getItem(v.b,[]).map(u=>({...u,location:(0,a.$9f)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):D.URI.revive(u.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(D.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$VQ=w,e.$VQ=w=v=$e([oe(0,A.$QQ),oe(1,E.$Al),oe(2,j.$Ei),oe(3,I.$3k),oe(4,N.$3j)],w);let p=y=class extends w{constructor(c,u,b,m,$){super(c,u,b,m,$),this.$=c}P(c){c.length?this.$.setItem(y.b,c.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(y.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(y.c,c):this.$.removeItem(y.c)}Q(){const c="workspaceAndProfileInfo",u=this.$.getItem(c,void 0);if(u){this.$.removeItem(c);const m=u.reduce(($,{workspace:n,profile:r})=>($[D.URI.revive(n).toString()]=D.URI.revive(r).toString(),$),{});this.$.setItem(y.c,{workspaces:m})}const b=super.Q();return this.$.getItem(y.a,!1)||(this.R(b),this.$.setItem(y.a,!0)),b}};e.$WQ=p,e.$WQ=p=y=$e([oe(0,A.$RQ),oe(1,E.$Al),oe(2,j.$Ei),oe(3,I.$3k),oe(4,N.$3j)],p);let k=class extends p{constructor(c,u,b,m){super(new f.$UQ(0,u,m,b),c,u,b,m)}async init(){return await this.$.init(),super.init()}};e.$XQ=k,e.$XQ=k=$e([oe(0,E.$Al),oe(1,j.$Ei),oe(2,I.$3k),oe(3,N.$3j)],k)}),define(ne[168],se([0,1,143,8,14,9,3,29,18,144,6,45,142,179]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0,e.$Yr=g;let p=class extends v.$Op{constructor(u,b,m,$){super($),this.m=u,this.n=b,this.r=m,this.s(),this.B(u.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,b){const{f:m,g:$}=this;let n;try{n=await(0,a.$Gm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const r={...process.env,...n},t=u.agent?u.agent:await(0,y.$Wr)(u.url||"",r,{proxyUrl:m,strictSSL:$});return u.agent=t,u.strictSSL=$,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>g(u,b))}async resolveProxy(u){}async loadCertificates(){return(await new Promise((b,m)=>{J(["@vscode/proxy-agent"],b,m)})).loadSystemCertificates({log:this.r})}};e.$Xr=p,e.$Xr=p=$e([oe(0,E.$3i),oe(1,l.$Ei),oe(2,f.$3j),oe(3,f.$4j)],p);async function k(c){return((0,D.parse)(c.url).protocol==="https:"?await new Promise((m,$)=>{J(["https"],m,$)}):await new Promise((m,$)=>{J(["http"],m,$)})).request}async function g(c,u){return j.Promises.withAsyncBody(async(b,m)=>{const $=(0,D.parse)(c.url),n=c.getRawRequest?c.getRawRequest(c):await k(c),r={hostname:$.hostname,port:$.port?parseInt($.port):$.protocol==="https:"?443:80,protocol:$.protocol,path:$.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$cg)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=n(r,i=>{const s=(0,A.$ag)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)g({...c,url:i.headers.location,followRedirects:s-1},u).then(b,m);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,w.createGunzip)())),b({res:i,stream:(0,I.$Ue)(o)})}});t.on("error",m),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),u.onCancellationRequested(()=>{t.abort(),m(new N.$5)})})}}),define(ne[180],se([0,1,33,8,34,9,2,15,16,12,35,11,25,29,139,61,141,18,116,166,21,71,146,42,53,162,164,13,129,131,51,127,64,65,150,6,135,39,136,153,32,45,168,69,70,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(J,e,D,j,I,N,A,E,l,a,f,v,y,w,p,k,g,c,u,b,m,$,n,r,t,i,s,o,h,P,R,O,z,M,T,Q,re,ie,he,le,ce,V,Z,B,q,W,X,Y,_,F,U,d,S,L,C,G,H,te,ae,ue,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends A.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const Ie=Ee.get(Q.$3j),x=Ee.get(o.$3k),K=Ee.get(c.$Ei),ee=Ee.get(S.$Cl);Ie.info("CLI main",this.b),this.h(Ie),await this.j(K,x,ee,de),await Promise.all(we.map(ge=>{(0,j.$nh)(ge.flush(),1e3)}))})}async f(){const de=new z.$ui,we={_serviceBrand:void 0,...le.default};de.set(ce.$jk,we);const Ee=new u.$9m(this.b,we);de.set(c.$Ei,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:E.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(ve=>ve?y.Promises.mkdir(ve,{recursive:!0}):void 0));const Ie=new te.$PQ((0,Q.$ek)(Ee),Ee.logsHome);de.set(Q.$4j,Ie);const x=this.B(Ie.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];Ie.getLogLevel()===Q.LogLevel.Trace&&K.push(new Q.$$j(Ie.getLogLevel()));const ee=this.B(new H.$ZQ(x,K));de.set(Q.$3j,ee);const ge=this.B(new h.$Iq(ee));de.set(o.$3k,ge);const be=this.B(new P.$_q(ee));ge.registerProvider(E.Schemas.file,be);const De=new d.$As(ge);de.set(U.$Al,De);const Pe=new B.$TQ(1,Ee,ee,ge),Le=new L.$VQ(Pe,De,Ee,ge,ee);de.set(S.$Cl,Le),ge.registerProvider(E.Schemas.vscodeUserData,new ue.$Tdc(E.Schemas.file,be,E.Schemas.vscodeUserData,Le,De,ee));const Re=a.$i&&we.win32RegValueName?this.B(new he.$Rdc(ee,we.win32RegValueName)):Ee.policyFile?this.B(new re.$Sdc(Ee.policyFile,ge,ee)):new ie.$go;de.set(ie.$eo,Re);const Ae=this.B(new p.$Go(Le.defaultProfile.settingsResource,ge,Re,ee));de.set(w.$3i,Ae),await Promise.all([Pe.init(),Ae.initialize()]);let Me;try{Me=await(0,C.$vdc)(Pe,ee)}catch(ve){ve.code!=="ENOENT"&&ee.error(ve)}const Oe=await(0,C.$wdc)(Pe,ee);Le.init(),de.set(U.$Al,new d.$As(ge));const Ne=new Z.$Xr(Ae,Ee,ee,Ie);de.set(V.$Np,Ne),de.set(k.$Ko,new R.$ti(g.$cR,void 0,!0)),de.set(r.$pq,new R.$ti(G.$YQ,void 0,!0)),de.set(t.$tq,new R.$ti(s.$sdc,void 0,!0)),de.set($.$_p,new R.$ti($.$bq,void 0,!0)),de.set(i.$Dq,new R.$ti(i.$Eq,void 0,!0)),de.set(m.$6o,new R.$ti(b.$$p,void 0,!0)),de.set(M.$Rr,new R.$ti(T.$Tr,void 0,!1));const ze=[],Ue=(0,Y.$rp)(we,Ae);if((0,Y.$mp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$NQ(Ne,Ue,"monacoworkbench",null,we.aiConfig.ariaKey));const ve={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,q.$dp)((0,D.release)(),(0,D.hostname)(),process.arch,we.commit,we.version,Me,Oe,Ue),piiPaths:(0,Y.$sp)(Ee)};de.set(W.$2l,new R.$ti(X.$Zr,[ve],!1))}else de.set(W.$2l,Y.$hp);return[new O.$cr(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,N.setUnexpectedErrorHandler)(we=>{const Ee=(0,I.$hj)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,N.$Z)(we)||(0,N.$1)(we)}),process.on("unhandledRejection",we=>(0,N.$1)(we))}async j(de,we,Ee,Ie){let x;if(de.args.profile&&(x=Ee.profiles.find(ee=>ee.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ie.createInstance(n.$cq,new Q.$$j(Q.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return Ie.createInstance(n.$cq,new Q.$$j(Q.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ie.createInstance(n.$cq,new Q.$$j(Q.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return Ie.createInstance(n.$cq,new Q.$$j(Q.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return Ie.createInstance(n.$cq,new Q.$$j(Q.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$fec)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?v.URI.file((0,l.$ic)(we)?we:(0,l.$jc)((0,f.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/03dd3c3b93322b41fe108a3448308595ee7077a4/core/vs/code/node/cliProcessMain.js.map
