/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],D=0,N=ne.length;D<N;D++)e[D]=ae[ne[D]];return e};define(ae[124],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const L=new Map,A=new Map,O=new Map,I=new Map;function C(h,c){h.has(c.detail)||h.set(c.detail,-c.timestamp)}function f(h,c){const p=h.get(c.detail);p&&(p>=0||h.set(c.detail,p+c.timestamp))}let E=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(E=ne.getStats().slice(0).sort((h,c)=>h.timestamp-c.timestamp));for(const h of E)switch(h.type){case 10:C(L,h);break;case 11:case 12:f(L,h);break;case 21:C(A,h);break;case 22:f(A,h);break;case 33:C(O,h);break;case 34:f(O,h);break;case 31:C(I,h);break;case 32:f(I,h);break}let y=0;O.forEach(h=>y+=h);function w(h){const c=[];return h.forEach((p,g)=>c.push([g,p])),c}return{amdLoad:w(L),amdInvoke:w(A),nodeRequire:w(O),nodeEval:w(I),nodeRequireTotal:y}}static toMarkdownTable(L,A){let O="";const I=[];return L.forEach((C,f)=>{I[f]=C.length}),A.forEach(C=>{C.forEach((f,E)=>{typeof f>"u"&&(f=C[E]="-");const y=f.toString().length;I[E]=Math.max(y,I[E])})}),L.forEach((C,f)=>{O+=`| ${C+" ".repeat(I[f]-C.toString().length)} `}),O+=`|
`,L.forEach((C,f)=>{O+=`| ${"-".repeat(I[f])} `}),O+=`|
`,A.forEach(C=>{C.forEach((f,E)=>{typeof f<"u"&&(O+=`| ${f+" ".repeat(I[E]-f.toString().length)} `)}),O+=`|
`}),O}}e.$U=D}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=D,e.$gb=N,e.$hb=L,e.$ib=A,e.$jb=O,e.$kb=I,e.$lb=C,e.$nb=E,e.$ob=y,e.$pb=w,e.$qb=h,e.$rb=c;function D(p,g){const l=N(p,g);if(l!==-1)return p[l]}function N(p,g,l=p.length-1){for(let u=l;u>=0;u--){const m=p[u];if(g(m))return u}return-1}function L(p,g){const l=A(p,g);return l===-1?void 0:p[l]}function A(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?m=$+1:d=$}return m-1}function O(p,g){const l=I(p,g);return l===p.length?void 0:p[l]}function I(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?d=$:m=$+1}return m}function C(p,g,l=0,u=p.length){const m=I(p,g,l,u);return m===p.length?-1:m}class f{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(f.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!g(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const l=A(this.e,g,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=f;function E(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>0&&(l=m)}return l}function y(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>=0&&(l=m)}return l}function w(p,g){return E(p,(l,u)=>-g(l,u))}function h(p,g){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const m=p[u];g(m,p[l])>0&&(l=u)}return l}function c(p,g){for(const l of p){const u=g(l);if(u!==void 0)return u}}}),define(ae[126],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=D,e.$L=N,e.$M=L,e.$N=A;function D(O,I){const C=Object.create(null);for(const f of O){const E=I(f);let y=C[E];y||(y=C[E]=[]),y.push(f)}return C}function N(O,I){const C=[],f=[];for(const E of O)I.has(E)||C.push(E);for(const E of I)O.has(E)||f.push(E);return{removed:C,added:f}}function L(O,I){const C=[],f=[];for(const[E,y]of O)I.has(E)||C.push(y);for(const[E,y]of I)O.has(E)||f.push(y);return{removed:C,added:f}}function A(O,I){const C=new Set;for(const f of I)O.has(f)&&C.add(f);return C}}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=N,e.$2h=L,e.$3h=A;function D(O){return(I,C,f)=>{let E=null,y=null;if(typeof f.value=="function"?(E="value",y=f.value):typeof f.get=="function"&&(E="get",y=f.get),!y)throw new Error("not supported");f[E]=O(y,C)}}function N(O,I,C){let f=null,E=null;if(typeof C.value=="function"?(f="value",E=C.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(f="get",E=C.get),!E)throw new Error("not supported");const y=`$memoize$${I}`;C[f]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,w)}),this[y]}}function L(O,I,C){return D((f,E)=>{const y=`$debounce$${E}`,w=`$debounce$result$${E}`;return function(...h){this[w]||(this[w]=C?C():void 0),clearTimeout(this[y]),I&&(this[w]=I(this[w],...h),h=[this[w]]),this[y]=setTimeout(()=>{f.apply(this,h),this[w]=C?C():void 0},O)}})}function A(O,I,C){return D((f,E)=>{const y=`$throttle$timer$${E}`,w=`$throttle$result$${E}`,h=`$throttle$lastRun$${E}`,c=`$throttle$pending$${E}`;return function(...p){if(this[w]||(this[w]=C?C():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[w]=I(this[w],...p)),this[c])return;const g=this[h]+O;g<=Date.now()?(this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=C?C():void 0):(this[c]=!0,this[y]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=C?C():void 0},g-Date.now()))}})}}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=A,e.$2=O,e.$3=I,e.$4=f,e.$6=y,e.$7=w,e.$8=h,e.$0=p;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function N($){e.$X.setUnexpectedErrorHandler($)}function L($){if(!$||typeof $!="object")return!1;const t=$;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A($){f($)||e.$X.onUnexpectedError($)}function O($){f($)||e.$X.onUnexpectedExternalError($)}function I($){if($ instanceof Error){const{name:t,message:r}=$,n=$.stacktrace||$.stack;return{$isError:!0,name:t,message:r,stack:n,noTelemetry:m.isErrorNoTelemetry($)}}return $}const C="Canceled";function f($){return $ instanceof E?!0:$ instanceof Error&&$.name===C&&$.message===C}class E extends Error{constructor(){super(C),this.name=this.message}}e.$5=E;function y(){const $=new Error(C);return $.name=$.message,$}function w($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}function h($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function p($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class l extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const r=new m;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(ae[17],ce([0,1,7,125]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=L,e.$tb=A,e.$ub=O,e.$vb=I,e.$wb=C,e.$xb=f,e.$yb=E,e.$zb=y,e.$Ab=w,e.$Bb=h,e.$Cb=c,e.$Db=p,e.$Eb=g,e.top=l,e.$Gb=u,e.$Hb=d,e.$Ib=$,e.$Jb=t,e.$Kb=r,e.$Lb=n,e.$Mb=s,e.$Nb=i,e.$Ob=o,e.$Pb=a,e.$Qb=b,e.$Rb=S,e.$Sb=v,e.$Tb=k,e.$Ub=P,e.$Vb=R,e.$Wb=F,e.$Xb=T,e.$Yb=q,e.$Zb=Y,e.$1b=J,e.$2b=X,e.$3b=H,e.$4b=K,e.$5b=G,e.$6b=se,e.$7b=he,e.$0b=B;function L(U,Z=0){return U[U.length-(1+Z)]}function A(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function O(U,Z,x=(te,_)=>te===_){if(U===Z)return!0;if(!U||!Z||U.length!==Z.length)return!1;for(let te=0,_=U.length;te<_;te++)if(!x(U[te],Z[te]))return!1;return!0}function I(U,Z){const x=U.length-1;Z<x&&(U[Z]=U[x]),U.pop()}function C(U,Z,x){return f(U.length,te=>x(U[te],Z))}function f(U,Z){let x=0,te=U-1;for(;x<=te;){const _=(x+te)/2|0,oe=Z(_);if(oe<0)x=_+1;else if(oe>0)te=_-1;else return _}return-(x+1)}function E(U,Z,x){if(U=U|0,U>=Z.length)throw new TypeError("invalid index");const te=Z[Math.floor(Z.length*Math.random())],_=[],oe=[],fe=[];for(const $e of Z){const de=x($e,te);de<0?_.push($e):de>0?oe.push($e):fe.push($e)}return U<_.length?E(U,_,x):U<_.length+fe.length?fe[0]:E(U-(_.length+fe.length),oe,x)}function y(U,Z){const x=[];let te;for(const _ of U.slice(0).sort(Z))!te||Z(te[0],_)!==0?(te=[_],x.push(te)):te.push(_);return x}function*w(U,Z){let x,te;for(const _ of U)te!==void 0&&Z(te,_)?x.push(_):(x&&(yield x),x=[_]),te=_;x&&(yield x)}function h(U,Z){for(let x=0;x<=U.length;x++)Z(x===0?void 0:U[x-1],x===U.length?void 0:U[x])}function c(U,Z){for(let x=0;x<U.length;x++)Z(x===0?void 0:U[x-1],U[x],x+1===U.length?void 0:U[x+1])}function p(U,Z,x){const te=[];function _($e,de,ge){if(de===0&&ge.length===0)return;const be=te[te.length-1];be&&be.start+be.deleteCount===$e?(be.deleteCount+=de,be.toInsert.push(...ge)):te.push({start:$e,deleteCount:de,toInsert:ge})}let oe=0,fe=0;for(;;){if(oe===U.length){_(oe,0,Z.slice(fe));break}if(fe===Z.length){_(oe,U.length-oe,[]);break}const $e=U[oe],de=Z[fe],ge=x($e,de);ge===0?(oe+=1,fe+=1):ge<0?(_(oe,1,[]),oe+=1):ge>0&&(_(oe,0,[de]),fe+=1)}return te}function g(U,Z,x){const te=p(U,Z,x),_=[],oe=[];for(const fe of te)_.push(...U.slice(fe.start,fe.start+fe.deleteCount)),oe.push(...fe.toInsert);return{removed:_,added:oe}}function l(U,Z,x){if(x===0)return[];const te=U.slice(0,x).sort(Z);return m(U,Z,te,x,U.length),te}function u(U,Z,x,te,_){return x===0?Promise.resolve([]):new Promise((oe,fe)=>{(async()=>{const $e=U.length,de=U.slice(0,x).sort(Z);for(let ge=x,be=Math.min(x+te,$e);ge<$e;ge=be,be=Math.min(be+te,$e)){if(ge>x&&await new Promise(Ee=>setTimeout(Ee)),_&&_.isCancellationRequested)throw new D.$5;m(U,Z,de,ge,be)}return de})().then(oe,fe)})}function m(U,Z,x,te,_){for(const oe=x.length;te<_;te++){const fe=U[te];if(Z(fe,x[oe-1])<0){x.pop();const $e=(0,N.$kb)(x,de=>Z(fe,de)<0);x.splice($e,0,fe)}}}function d(U){return U.filter(Z=>!!Z)}function $(U){let Z=0;for(let x=0;x<U.length;x++)U[x]&&(U[Z]=U[x],Z+=1);U.length=Z}function t(U,Z,x){U.splice(x,0,U.splice(Z,1)[0])}function r(U){return!Array.isArray(U)||U.length===0}function n(U){return Array.isArray(U)&&U.length>0}function s(U,Z=x=>x){const x=new Set;return U.filter(te=>{const _=Z(te);return x.has(_)?!1:(x.add(_),!0)})}function i(U){const Z=new Set;return x=>{const te=U(x);return Z.has(te)?!1:(Z.add(te),!0)}}function o(U,Z){return U.length>0?U[0]:Z}function a(U,Z){return U.length>0?U[U.length-1]:Z}function b(U,Z,x=(te,_)=>te===_){let te=0;for(let _=0,oe=Math.min(U.length,Z.length);_<oe&&x(U[_],Z[_]);_++)te++;return te}function S(U,Z){let x=typeof Z=="number"?U:0;typeof Z=="number"?x=U:(x=0,Z=U);const te=[];if(x<=Z)for(let _=x;_<Z;_++)te.push(_);else for(let _=x;_>Z;_--)te.push(_);return te}function v(U,Z,x){return U.reduce((te,_)=>(te[Z(_)]=x?x(_):_,te),Object.create(null))}function k(U,Z){return U.push(Z),()=>P(U,Z)}function P(U,Z){const x=U.indexOf(Z);if(x>-1)return U.splice(x,1),Z}function R(U,Z,x){const te=U.slice(0,Z),_=U.slice(Z);return te.concat(x,_)}function F(U,Z){let x;if(typeof Z=="number"){let te=Z;x=()=>{const _=Math.sin(te++)*179426549;return _-Math.floor(_)}}else x=Math.random;for(let te=U.length-1;te>0;te-=1){const _=Math.floor(x()*(te+1)),oe=U[te];U[te]=U[_],U[_]=oe}}function T(U,Z){const x=U.indexOf(Z);x>-1&&(U.splice(x,1),U.unshift(Z))}function q(U,Z){const x=U.indexOf(Z);x>-1&&(U.splice(x,1),U.push(Z))}function Y(U,Z){for(const x of Z)U.push(x)}function J(U,Z){return Array.isArray(U)?U.map(Z):Z(U)}function X(U){return Array.isArray(U)?U:[U]}function H(U){return U[Math.floor(Math.random()*U.length)]}function K(U,Z,x){const te=V(U,Z),_=U.length,oe=x.length;U.length=_+oe;for(let fe=_-1;fe>=te;fe--)U[fe+oe]=U[fe];for(let fe=0;fe<oe;fe++)U[fe+te]=x[fe]}function G(U,Z,x,te){const _=V(U,Z);let oe=U.splice(_,x);return oe===void 0&&(oe=[]),K(U,_,te),oe}function V(U,Z){return Z<0?Math.max(Z+U.length,0):Math.min(Z,U.length)}var ie;(function(U){function Z(oe){return oe<0}U.isLessThan=Z;function x(oe){return oe<=0}U.isLessThanOrEqual=x;function te(oe){return oe>0}U.isGreaterThan=te;function _(oe){return oe===0}U.isNeitherLessOrGreaterThan=_,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function se(U,Z){return(x,te)=>Z(U(x),U(te))}function he(...U){return(Z,x)=>{for(const te of U){const _=te(Z,x);if(!ie.isNeitherLessOrGreaterThan(_))return _}return ie.neitherLessOrGreaterThan}}const ee=(U,Z)=>U-Z;e.$8b=ee;const W=(U,Z)=>(0,e.$8b)(U?1:0,Z?1:0);e.$9b=W;function B(U){return(Z,x)=>-U(Z,x)}class j{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let x=this.c;for(;x<this.g.length&&Z(this.g[x]);)x++;const te=x===this.c?null:this.g.slice(this.c,x);return this.c=x,te}takeFromEndWhile(Z){let x=this.d;for(;x>=0&&Z(this.g[x]);)x--;const te=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const x=this.g.slice(this.c,this.c+Z);return this.c+=Z,x}}e.$$b=j;class M{static{this.empty=new M(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(x=>(Z(x),!0))}toArray(){const Z=[];return this.iterate(x=>(Z.push(x),!0)),Z}filter(Z){return new M(x=>this.iterate(te=>Z(te)?x(te):!0))}map(Z){return new M(x=>this.iterate(te=>x(Z(te))))}some(Z){let x=!1;return this.iterate(te=>(x=Z(te),!x)),x}findFirst(Z){let x;return this.iterate(te=>Z(te)?(x=te,!1):!0),x}findLast(Z){let x;return this.iterate(te=>(Z(te)&&(x=te),!0)),x}findLastMaxBy(Z){let x,te=!0;return this.iterate(_=>((te||ie.isGreaterThan(Z(_,x)))&&(te=!1,x=_),!0)),x}}e.$_b=M;class z{constructor(Z){this.c=Z}static createSortPermutation(Z,x){const te=Array.from(Z.keys()).sort((_,oe)=>x(Z[_],Z[oe]));return new z(te)}apply(Z){return Z.map((x,te)=>Z[this.c[te]])}inverse(){const Z=this.c.slice();for(let x=0;x<this.c.length;x++)Z[this.c[x]]=x;return new z(Z)}}e.$ac=z}),define(ae[127],ce([0,1,7]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$ed=L,e.$fd=A,e.$gd=O,e.$hd=I,e.$id=C;function N(f,E){if(!f)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function L(f,E="Unreachable"){throw new Error(E)}function A(f){if(!f)throw new D.$cb("Assertion Failed")}function O(f){f||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function I(f){if(!f()){debugger;f(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function C(f,E){let y=0;for(;y<f.length-1;){const w=f[y],h=f[y+1];if(!E(w,h))return!1;y++}return!0}}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=D;function D(N,L){const A=this;let O=!1,I;return function(){if(O)return I;if(O=!0,L)try{I=N.apply(A,arguments)}finally{L()}else I=N.apply(A,arguments);return I}}}),define(ae[61],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const A=Object.freeze([]);function O(){return A}N.empty=O;function*I(t){yield t}N.single=I;function C(t){return L(t)?t:I(t)}N.wrap=C;function f(t){return t||A}N.from=f;function*E(t){for(let r=t.length-1;r>=0;r--)yield t[r]}N.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=y;function w(t){return t[Symbol.iterator]().next().value}N.first=w;function h(t,r){for(const n of t)if(r(n))return!0;return!1}N.some=h;function c(t,r){for(const n of t)if(r(n))return n}N.find=c;function*p(t,r){for(const n of t)r(n)&&(yield n)}N.filter=p;function*g(t,r){let n=0;for(const s of t)yield r(s,n++)}N.map=g;function*l(...t){for(const r of t)yield*r}N.concat=l;function u(t,r,n){let s=n;for(const i of t)s=r(s,i);return s}N.reduce=u;function*m(t,r,n=t.length){for(r<0&&(r+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);r<n;r++)yield t[r]}N.slice=m;function d(t,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,t];const s=t[Symbol.iterator]();for(let i=0;i<r;i++){const o=s.next();if(o.done)return[n,N.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=d;async function $(t){const r=[];for await(const n of t)r.push(n);return Promise.resolve(r)}N.asyncToArray=$})(D||(e.Iterable=D={}))}),define(ae[35],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=O,e.$In=y,e.$Jn=w,e.$Kn=h,e.$Ln=c,e.$Mn=p,e.$Nn=g,e.$On=l,e.$Pn=u,e.$Qn=m,e.$Rn=d,e.$Sn=$;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(t,r=!1){let n=0;const s=t.length;let i="",o=0,a=16,b=0;function S(q){let Y=0,J=0;for(;Y<q;){const X=t.charCodeAt(n);if(X>=48&&X<=57)J=J*16+X-48;else if(X>=65&&X<=70)J=J*16+X-65+10;else if(X>=97&&X<=102)J=J*16+X-97+10;else break;n++,Y++}return Y<q&&(J=-1),J}function v(q){n=q,i="",o=0,a=16,b=0}function k(){const q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&f(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&f(t.charCodeAt(n)))for(n++;n<t.length&&f(t.charCodeAt(n));)n++;else return b=3,t.substring(q,n);let Y=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&f(t.charCodeAt(n))){for(n++;n<t.length&&f(t.charCodeAt(n));)n++;Y=n}else b=3;return t.substring(q,Y)}function P(){let q="",Y=n;for(;;){if(n>=s){q+=t.substring(Y,n),b=2;break}const J=t.charCodeAt(n);if(J===34){q+=t.substring(Y,n),n++;break}if(J===92){if(q+=t.substring(Y,n),n++,n>=s){b=2;break}switch(t.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const H=S(4);H>=0?q+=String.fromCharCode(H):b=4;break}default:b=5}Y=n;continue}if(J>=0&&J<=31)if(C(J)){q+=t.substring(Y,n),b=2;break}else b=6;n++}return q}function R(){if(i="",b=0,o=n,n>=s)return o=s,a=17;let q=t.charCodeAt(n);if(I(q)){do n++,i+=String.fromCharCode(q),q=t.charCodeAt(n);while(I(q));return a=15}if(C(q))return n++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=P(),a=10;case 47:{const Y=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!C(t.charCodeAt(n));)n++;return i=t.substring(Y,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const J=s-1;let X=!1;for(;n<J;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,b=1),i=t.substring(Y,n),a=13}return i+=String.fromCharCode(q),n++,a=16}case 45:if(i+=String.fromCharCode(q),n++,n===s||!f(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=k(),a=11;default:for(;n<s&&F(q);)n++,q=t.charCodeAt(n);if(o!==n){switch(i=t.substring(o,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(q),n++,a=16}}function F(q){if(I(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let q;do q=R();while(q>=12&&q<=15);return q}return{setPosition:v,getPosition:()=>n,scan:r?T:R,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>b}}function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,r){const n=[],s=new Object;let i;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function b(S,v,k,P){o.value=S,o.offset=v,o.length=k,o.type=P,o.colonOffset=void 0,i=o}try{m(t,{onObjectBegin:(S,v)=>{if(r<=S)throw s;i=void 0,a=r>S,n.push("")},onObjectProperty:(S,v,k)=>{if(r<v||(b(S,v,k,"property"),n[n.length-1]=S,r<=v+k))throw s},onObjectEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onArrayBegin:(S,v)=>{if(r<=S)throw s;i=void 0,n.push(0)},onArrayEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onLiteralValue:(S,v,k)=>{if(r<v||(b(S,v,k,$(S)),r<=v+k))throw s},onSeparator:(S,v,k)=>{if(r<=v)throw s;if(S===":"&&i&&i.type==="property")i.colonOffset=v,a=!1,i=void 0;else if(S===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(S){if(S!==s)throw S}return{path:n,previousNode:i,isAtPropertyKey:a,matches:S=>{let v=0;for(let k=0;v<S.length&&k<n.length;k++)if(S[v]===n[k]||S[v]==="*")v++;else if(S[v]!=="**")return!1;return v===S.length}}}function w(t,r=[],n=A.DEFAULT){let s=null,i=[];const o=[];function a(S){Array.isArray(i)?i.push(S):s!==null&&(i[s]=S)}return m(t,{onObjectBegin:()=>{const S={};a(S),o.push(i),i=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const S=[];a(S),o.push(i),i=S,s=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n),i[0]}function h(t,r=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function o(S){return s.children.push(S),S}m(t,{onObjectBegin:S=>{s=o({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,v,k)=>{s=o({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:v,length:k,parent:s})},onObjectEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onArrayBegin:(S,v)=>{s=o({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onLiteralValue:(S,v,k)=>{o({type:$(S),offset:v,length:k,parent:s,value:S}),i(v+k)},onSeparator:(S,v,k)=>{s.type==="property"&&(S===":"?s.colonOffset=v:S===","&&i(v))},onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n);const b=s.children[0];return b&&delete b.parent,b}function c(t,r){if(!t)return;let n=t;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===s){n=o.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const r=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=g(s))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function l(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function u(t,r,n=!1){if(l(t,r,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=r;i++){const o=u(s[i],r,n);if(o)return o}return t}}function m(t,r,n=A.DEFAULT){const s=O(t,!1);function i(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(he){return he?ee=>he(ee,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),b=o(r.onObjectProperty),S=i(r.onObjectEnd),v=i(r.onArrayBegin),k=i(r.onArrayEnd),P=o(r.onLiteralValue),R=o(r.onSeparator),F=i(r.onComment),T=o(r.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function J(){for(;;){const he=s.scan();switch(s.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:q||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(he){case 12:case 13:q?X(10):F();break;case 16:X(1);break;case 15:case 14:break;default:return he}}}function X(he,ee=[],W=[]){if(T(he),ee.length+W.length>0){let B=s.getToken();for(;B!==17;){if(ee.indexOf(B)!==-1){J();break}else if(W.indexOf(B)!==-1)break;B=J()}}}function H(he){const ee=s.getTokenValue();return he?P(ee):b(ee),J(),!0}function K(){switch(s.getToken()){case 11:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(X(2),he=0)}catch{X(2)}P(he);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return J(),!0}function G(){return s.getToken()!==10?(X(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(R(":"),J(),se()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function V(){a(),J();let he=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(he||X(4,[],[]),R(","),J(),s.getToken()===2&&Y)break}else he&&X(6,[],[]);G()||X(4,[],[2,5]),he=!0}return S(),s.getToken()!==2?X(7,[2],[]):J(),!0}function ie(){v(),J();let he=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(he||X(4,[],[]),R(","),J(),s.getToken()===4&&Y)break}else he&&X(6,[],[]);se()||X(4,[],[4,5]),he=!0}return k(),s.getToken()!==4?X(8,[4],[]):J(),!0}function se(){switch(s.getToken()){case 3:return ie();case 1:return V();case 10:return H(!0);default:return K()}}return J(),s.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):se()?(s.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}function d(t,r){const n=O(t),s=[];let i,o=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:o!==a&&s.push(t.substring(o,a)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),o=n.getPosition();break}while(i!==17);return s.join("")}function $(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[44],ce([0,1,35]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=N,e.$Un=L,e.$Vn=I,e.$Wn=C;function N(f,E,y){let w,h,c,p,g;if(E){for(p=E.offset,g=p+E.length,c=p;c>0&&!C(f,c-1);)c--;let a=g;for(;a<f.length&&!C(f,a);)a++;h=f.substring(c,a),w=O(h,y)}else h=f,w=0,c=0,p=0,g=f.length;const l=I(y,f);let u=!1,m=0,d;y.insertSpaces?d=A(" ",y.tabSize||4):d="	";const $=(0,D.$Hn)(h,!1);let t=!1;function r(){return l+A(d,w+m)}function n(){let a=$.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=$.scan();return t=a===16||$.getTokenError()!==0,a}const s=[];function i(a,b,S){!t&&b<g&&S>p&&f.substring(b,S)!==a&&s.push({offset:b,length:S-b,content:a})}let o=n();if(o!==17){const a=$.getTokenOffset()+c,b=A(d,w);i(b,c,a)}for(;o!==17;){let a=$.getTokenOffset()+$.getTokenLength()+c,b=n(),S="";for(;!u&&(b===12||b===13);){const k=$.getTokenOffset()+c;i(" ",a,k),a=$.getTokenOffset()+$.getTokenLength()+c,S=b===12?r():"",b=n()}if(b===2)o!==1&&(m--,S=r());else if(b===4)o!==3&&(m--,S=r());else{switch(o){case 3:case 1:m++,S=r();break;case 5:case 12:S=r();break;case 13:u?S=r():S=" ";break;case 6:S=" ";break;case 10:if(b===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?S=" ":b!==5&&b!==17&&(t=!0);break;case 16:t=!0;break}u&&(b===12||b===13)&&(S=r())}const v=$.getTokenOffset()+c;i(S,a,v),o=b}return s}function L(f,E){const y=JSON.stringify(f,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function A(f,E){let y="";for(let w=0;w<E;w++)y+=f;return y}function O(f,E){let y=0,w=0;const h=E.tabSize||4;for(;y<f.length;){const c=f.charAt(y);if(c===" ")w++;else if(c==="	")w+=h;else break;y++}return Math.floor(w/h)}function I(f,E){for(let y=0;y<E.length;y++){const w=E.charAt(y);if(w==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return f&&f.eol||`
`}function C(f,E){return`\r
`.indexOf(f.charAt(E))!==-1}}),define(ae[62],ce([0,1,35,44]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=L,e.$Yn=A,e.$Zn=O,e.$1n=I,e.$2n=C;function L(f,E,y){return A(f,E,void 0,y)}function A(f,E,y,w,h){const c=E.slice(),p=[],g=(0,D.$Kn)(f,p);let l,u;for(;c.length>0&&(u=c.pop(),l=(0,D.$Ln)(g,c),l===void 0&&y!==void 0);)typeof u=="string"?y={[u]:y}:y=[y];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const m=(0,D.$Ln)(l,[u]);if(m!==void 0)if(y===void 0){if(!m.parent)throw new Error("Malformed AST");const d=l.children.indexOf(m.parent);let $,t=m.parent.offset+m.parent.length;if(d>0){const r=l.children[d-1];$=r.offset+r.length}else $=l.offset+1,l.children.length>1&&(t=l.children[1].offset);return O(f,{offset:$,length:t-$,content:""},w)}else return O(f,{offset:m.offset,length:m.length,content:JSON.stringify(y)},w);else{if(y===void 0)return[];const d=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,$=h?h(l.children.map(r=>r.children[0].value)):l.children.length;let t;if($>0){const r=l.children[$-1];t={offset:r.offset+r.length,length:0,content:","+d}}else l.children.length===0?t={offset:l.offset+1,length:0,content:d}:t={offset:l.offset+1,length:0,content:d+","};return O(f,t,w)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(y!==void 0){const m=`${JSON.stringify(y)}`;let d;if(l.children.length===0||u===0)d={offset:l.offset+1,length:0,content:l.children.length===0?m:m+","};else{const $=u===-1||u>l.children.length?l.children.length:u,t=l.children[$-1];d={offset:t.offset+t.length,length:0,content:","+m}}return O(f,d,w)}else{const m=u,d=l.children[m];let $;if(l.children.length===1)$={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===m){const t=l.children[m-1],r=t.offset+t.length,n=l.offset+l.length;$={offset:r,length:n-2-r,content:""}}else $={offset:d.offset,length:l.children[m+1].offset-d.offset,content:""};return O(f,$,w)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else return y===void 0?[]:O(f,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(y)},w)}function O(f,E,y){let w=I(f,E),h=E.offset,c=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;h>0&&!(0,N.$Wn)(w,h-1);)h--;for(;c<w.length&&!(0,N.$Wn)(w,c);)c++}const p=(0,N.$Tn)(w,{offset:h,length:c-h},y);for(let l=p.length-1;l>=0;l--){const u=p[l];w=I(w,u),h=Math.min(h,u.offset),c=Math.max(c,u.offset+u.length),c+=u.content.length-u.length}const g=f.length-(w.length-c)-h;return[{offset:h,length:g,content:w.substring(h,c)}]}function I(f,E){return f.substring(0,E.offset)+E.content+f.substring(E.offset+E.length)}function C(f,E){const y=E.slice(0).sort((h,c)=>{const p=h.offset-c.offset;return p===0?h.length-c.length:p});let w=f.length;for(let h=y.length-1;h>=0;h--){const c=y[h];if(c.offset+c.length<=w)f=I(f,c);else throw new Error("Overlapping edit");w=c.offset}return f}}),define(ae[53],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ae[86],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const O=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const I=new D(A);if(this.a===D.Undefined)this.a=I,this.b=I;else if(O){const f=this.b;this.b=I,I.prev=f,f.next=I}else{const f=this.a;this.a=I,I.next=f,f.prev=I}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(I))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.$5c=N}),define(ae[34],ce([0,1]),function(ne,e){"use strict";var D,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=O,e.$zc=I,e.$Ic=d;function A($,t,r){let n=$.get(t);return n===void 0&&(n=r,$.set(t,n)),n}function O($){const t=[];return $.forEach((r,n)=>{t.push(`${n} => ${r}`)}),`Map(${$.size}) {${t.join(", ")}}`}function I($){const t=[];return $.forEach(r=>{t.push(r)}),`Set(${$.size}) {${t.join(", ")}}`}class C{constructor(t,r){this.uri=t,this.value=r}}function f($){return Array.isArray($)}class E{static{this.c=t=>t.toString()}constructor(t,r){if(this[D]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=r??E.c;else if(f(t)){this.d=new Map,this.e=r??E.c;for(const[n,s]of t)this.set(n,s)}else this.d=new Map,this.e=t??E.c}set(t,r){return this.d.set(this.e(t),new C(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[n,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=E;class y{constructor(t,r){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((n,s)=>t.call(r,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=y;var w;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class h{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const n=this.c.get(t);if(n)return r!==0&&this.m(n,r),n.value}set(t,r,n=0){let s=this.c.get(t);if(s)s.value=r,n!==0&&this.m(s,n);else{switch(s={key:t,value:r,next:void 0,previous:void 0},n){case 0:this.k(s);break;case 1:this.j(s);break;case 2:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const n=this.g;let s=this.d;for(;s;){if(r?t.bind(r)(s.value,s.key,this):t(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.key,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}values(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.value,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}entries(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:[n.key,n.value],done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.next,n--;this.d=r,this.f=n,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.previous,n--;this.e=r,this.f=n,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const n=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const n=t.next,s=t.previous;t===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,n)=>{t.push([n,r])}),t}fromJSON(t){this.clear();for(const[r,n]of t)this.set(r,n)}}e.$Cc=h;class c extends h{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends c{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Dc=p;class g extends c{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Ec=g;class l{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Fc=l;class u{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,n]of t)this.set(r,n)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((n,s)=>{t.call(r,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=u;class m{constructor(){this.c=new Map}add(t,r){let n=this.c.get(t);n||(n=new Set,this.c.set(t,n)),n.add(r)}delete(t,r){const n=this.c.get(t);n&&(n.delete(r),n.size===0&&this.c.delete(t))}forEach(t,r){const n=this.c.get(t);n&&n.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Hc=m;function d($,t){if($===t)return!0;if($.size!==t.size)return!1;for(const[r,n]of $)if(!t.has(r)||t.get(r)!==n)return!1;for(const[r]of t)if(!$.has(r))return!1;return!0}}),define(ae[2],ce([0,1,17,126,34,85,61]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=y,e.$Mc=w,e.$Nc=p,e.$Oc=g,e.$Pc=l,e.$Qc=u,e.$Rc=m,e.$Sc=d,e.$3c=S;const I=!1;let C=null;class f{constructor(){this.b=new Map}static{this.a=0}c(P){let R=this.b.get(P);return R||(R={parent:null,source:null,isSingleton:!1,value:P,idx:f.a++},this.b.set(P,R)),R}trackDisposable(P){const R=this.c(P);R.source||(R.source=new Error().stack)}setParent(P,R){const F=this.c(P);F.parent=R}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,R){const F=R.get(P);if(F)return F;const T=P.parent?this.f(this.c(P.parent),R):P;return R.set(P,T),T}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,R){let F;if(R)F=R;else{const X=new Map,H=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,X).isSingleton);if(H.length===0)return;const K=new Set(H.map(G=>G.value));if(F=H.filter(G=>!(G.parent&&K.has(G.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(X){function H(G,V){for(;G.length>0&&V.some(ie=>typeof ie=="string"?ie===G[0]:G[0].match(ie));)G.shift()}const K=X.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return H(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const q=new L.$Hc;for(const X of F){const H=T(X);for(let K=0;K<=H.length;K++)q.add(H.slice(0,K).join(`
`),X)}F.sort((0,D.$6b)(X=>X.idx,D.$8b));let Y="",J=0;for(const X of F.slice(0,P)){J++;const H=T(X),K=[];for(let G=0;G<H.length;G++){let V=H[G];V=`(shared with ${q.get(H.slice(0,G+1).join(`
`)).size}/${F.length} leaks) at ${V}`;const se=q.get(H.slice(0,G).join(`
`)),he=(0,N.$K)([...se].map(ee=>T(ee)[G]),ee=>ee);delete he[H[G]];for(const[ee,W]of Object.entries(he))K.unshift(`    - stacktraces of ${W.length} other leaks continue with ${ee}`);K.unshift(V)}Y+=`


==================== Leaking disposable ${J}/${F.length}: ${X.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return F.length>P&&(Y+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:Y}}}e.$Jc=f;function E(k){C=k}if(I){const k="__is_disposable_tracked__";E(new class{trackDisposable(P){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(R)},3e3)}setParent(P,R){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function y(k){return C?.trackDisposable(k),k}function w(k){C?.markAsDisposed(k)}function h(k,P){C?.setParent(k,P)}function c(k,P){if(C)for(const R of k)C.setParent(R,P)}function p(k){return C?.markAsSingleton(k),k}function g(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function l(k){if(O.Iterable.is(k)){const P=[];for(const R of k)if(R)try{R.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function u(k){for(const P of k)g(P)&&P.dispose();return[]}function m(...k){const P=d(()=>l(k));return c(k,P),P}function d(k){const P=y({dispose:(0,A.$db)(()=>{w(P),k()})});return P}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return h(P,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),h(P,null))}}e.$Tc=$;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,y(this),h(this.q,this)}dispose(){w(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class r{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&h(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&h(P,null),P}}e.$Vc=r;class n{constructor(P){this.a=new r,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(P){let R=P;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,w(this))},this}}e.$Yc=i;class o{constructor(){this.a=new Map}acquire(P,...R){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...R)},this.a.set(P,F));const{object:T}=F,q=(0,A.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:T,dispose:q}}}e.$Zc=o;class a{constructor(P){this.a=P}async acquire(P,...R){const F=this.a.acquire(P,...R);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=a;class b{constructor(P){this.object=P}dispose(){}}e.$2c=b;function S(k){const P=new $;try{k(P)}finally{P.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,R,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,R)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=v}),define(ae[87],ce([0,1,34]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=L,e.$cm=O;const N=new D.$Dc(1e4);function L(f){return C(f,"NFC",N)}const A=new D.$Dc(1e4);function O(f){return C(f,"NFD",A)}const I=/[^\u0000-\u0080]/;function C(f,E,y){if(!f)return f;const w=y.get(f);if(w)return w;let h;return I.test(f)?h=f.normalize(E):h=f,y.set(f,h),h}e.$dm=function(){const f=/[\u0300-\u036f]/g;return function(E){return O(E).replace(f,"")}}()}),function(){function ne(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function O(C){A.push(C,Date.now())}function I(){const C=[];for(let f=0;f<A.length;f+=2)C.push({name:A[f],startTime:A[f+1]});return C}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(L+O.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:ne)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function D(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=ne,D.c=e,D.d=function(N,L,A){D.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:A})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,L){if(1&L&&(N=D(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)D.d(A,O,function(I){return N[I]}.bind(null,O));return A},D.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(L,"a",L),L},D.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},D.p="",D(D.s=0)}([function(ne,e,D){(function(N){var L;e=ne.exports=W,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],C=e.src=[],f=0,E=f++;C[E]="0|[1-9]\\d*";var y=f++;C[y]="[0-9]+";var w=f++;C[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=f++;C[h]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var c=f++;C[c]="("+C[y]+")\\.("+C[y]+")\\.("+C[y]+")";var p=f++;C[p]="(?:"+C[E]+"|"+C[w]+")";var g=f++;C[g]="(?:"+C[y]+"|"+C[w]+")";var l=f++;C[l]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var u=f++;C[u]="(?:-?("+C[g]+"(?:\\."+C[g]+")*))";var m=f++;C[m]="[0-9A-Za-z-]+";var d=f++;C[d]="(?:\\+("+C[m]+"(?:\\."+C[m]+")*))";var $=f++,t="v?"+C[h]+C[l]+"?"+C[d]+"?";C[$]="^"+t+"$";var r="[v=\\s]*"+C[c]+C[u]+"?"+C[d]+"?",n=f++;C[n]="^"+r+"$";var s=f++;C[s]="((?:<|>)?=?)";var i=f++;C[i]=C[y]+"|x|X|\\*";var o=f++;C[o]=C[E]+"|x|X|\\*";var a=f++;C[a]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[l]+")?"+C[d]+"?)?)?";var b=f++;C[b]="[v=\\s]*("+C[i]+")(?:\\.("+C[i]+")(?:\\.("+C[i]+")(?:"+C[u]+")?"+C[d]+"?)?)?";var S=f++;C[S]="^"+C[s]+"\\s*"+C[a]+"$";var v=f++;C[v]="^"+C[s]+"\\s*"+C[b]+"$";var k=f++;C[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=f++;C[P]="(?:~>?)";var R=f++;C[R]="(\\s*)"+C[P]+"\\s+",I[R]=new RegExp(C[R],"g");var F=f++;C[F]="^"+C[P]+C[a]+"$";var T=f++;C[T]="^"+C[P]+C[b]+"$";var q=f++;C[q]="(?:\\^)";var Y=f++;C[Y]="(\\s*)"+C[q]+"\\s+",I[Y]=new RegExp(C[Y],"g");var J=f++;C[J]="^"+C[q]+C[a]+"$";var X=f++;C[X]="^"+C[q]+C[b]+"$";var H=f++;C[H]="^"+C[s]+"\\s*("+r+")$|^$";var K=f++;C[K]="^"+C[s]+"\\s*("+t+")$|^$";var G=f++;C[G]="(\\s*)"+C[s]+"\\s*("+r+"|"+C[a]+")",I[G]=new RegExp(C[G],"g");var V=f++;C[V]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var ie=f++;C[ie]="^\\s*("+C[b]+")\\s+-\\s+("+C[b]+")\\s*$";var se=f++;C[se]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)L(he,C[he]),I[he]||(I[he]=new RegExp(C[he]));function ee(le,we){if(le instanceof W)return le;if(typeof le!="string"||le.length>A||!(we?I[n]:I[$]).test(le))return null;try{return new W(le,we)}catch{return null}}function W(le,we){if(le instanceof W){if(le.loose===we)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof W))return new W(le,we);L("SemVer",le,we),this.loose=we;var pe=le.trim().match(we?I[n]:I[$]);if(!pe)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var De=+Pe;if(De>=0&&De<O)return De}return Pe}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=ee,e.valid=function(le,we){var pe=ee(le,we);return pe?pe.version:null},e.clean=function(le,we){var pe=ee(le.trim().replace(/^[=v]+/,""),we);return pe?pe.version:null},e.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof W||(le=new W(le,this.loose)),this.compareMain(le)||this.comparePre(le)},W.prototype.compareMain=function(le){return le instanceof W||(le=new W(le,this.loose)),j(this.major,le.major)||j(this.minor,le.minor)||j(this.patch,le.patch)},W.prototype.comparePre=function(le){if(le instanceof W||(le=new W(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var we=0;do{var pe=this.prerelease[we],Pe=le.prerelease[we];if(L("prerelease compare",we,pe,Pe),pe===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(pe===void 0)return-1;if(pe!==Pe)return j(pe,Pe)}while(++we)},W.prototype.inc=function(le,we){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,we,pe,Pe){typeof pe=="string"&&(Pe=pe,pe=void 0);try{return new W(le,pe).inc(we,Pe).version}catch{return null}},e.diff=function(le,we){if(Z(le,we))return null;var pe=ee(le),Pe=ee(we);if(pe.prerelease.length||Pe.prerelease.length){for(var De in pe)if((De==="major"||De==="minor"||De==="patch")&&pe[De]!==Pe[De])return"pre"+De;return"prerelease"}for(var De in pe)if((De==="major"||De==="minor"||De==="patch")&&pe[De]!==Pe[De])return De},e.compareIdentifiers=j;var B=/^[0-9]+$/;function j(le,we){var pe=B.test(le),Pe=B.test(we);return pe&&Pe&&(le=+le,we=+we),pe&&!Pe?-1:Pe&&!pe?1:le<we?-1:le>we?1:0}function M(le,we,pe){return new W(le,pe).compare(new W(we,pe))}function z(le,we,pe){return M(le,we,pe)>0}function U(le,we,pe){return M(le,we,pe)<0}function Z(le,we,pe){return M(le,we,pe)===0}function x(le,we,pe){return M(le,we,pe)!==0}function te(le,we,pe){return M(le,we,pe)>=0}function _(le,we,pe){return M(le,we,pe)<=0}function oe(le,we,pe,Pe){var De;switch(we){case"===":typeof le=="object"&&(le=le.version),typeof pe=="object"&&(pe=pe.version),De=le===pe;break;case"!==":typeof le=="object"&&(le=le.version),typeof pe=="object"&&(pe=pe.version),De=le!==pe;break;case"":case"=":case"==":De=Z(le,pe,Pe);break;case"!=":De=x(le,pe,Pe);break;case">":De=z(le,pe,Pe);break;case">=":De=te(le,pe,Pe);break;case"<":De=U(le,pe,Pe);break;case"<=":De=_(le,pe,Pe);break;default:throw new TypeError("Invalid operator: "+we)}return De}function fe(le,we){if(le instanceof fe){if(le.loose===we)return le;le=le.value}if(!(this instanceof fe))return new fe(le,we);L("comparator",le,we),this.loose=we,this.parse(le),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,we){return j(we,le)},e.major=function(le,we){return new W(le,we).major},e.minor=function(le,we){return new W(le,we).minor},e.patch=function(le,we){return new W(le,we).patch},e.compare=M,e.compareLoose=function(le,we){return M(le,we,!0)},e.rcompare=function(le,we,pe){return M(we,le,pe)},e.sort=function(le,we){return le.sort(function(pe,Pe){return e.compare(pe,Pe,we)})},e.rsort=function(le,we){return le.sort(function(pe,Pe){return e.rcompare(pe,Pe,we)})},e.gt=z,e.lt=U,e.eq=Z,e.neq=x,e.gte=te,e.lte=_,e.cmp=oe,e.Comparator=fe;var $e={};function de(le,we){if(le instanceof de)return le.loose===we?le:new de(le.raw,we);if(le instanceof fe)return new de(le.value,we);if(!(this instanceof de))return new de(le,we);if(this.loose=we,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function ge(le){return!le||le.toLowerCase()==="x"||le==="*"}function be(le,we,pe,Pe,De,Le,Oe,Te,Ae,qe,He,Fe,Ne){return((we=ge(pe)?"":ge(Pe)?">="+pe+".0.0":ge(De)?">="+pe+"."+Pe+".0":">="+we)+" "+(Te=ge(Ae)?"":ge(qe)?"<"+(+Ae+1)+".0.0":ge(He)?"<"+Ae+"."+(+qe+1)+".0":Fe?"<="+Ae+"."+qe+"."+He+"-"+Fe:"<="+Te)).trim()}function Ee(le,we){for(var pe=0;pe<le.length;pe++)if(!le[pe].test(we))return!1;if(we.prerelease.length){for(pe=0;pe<le.length;pe++)if(L(le[pe].semver),le[pe].semver!==$e&&le[pe].semver.prerelease.length>0){var Pe=le[pe].semver;if(Pe.major===we.major&&Pe.minor===we.minor&&Pe.patch===we.patch)return!0}return!1}return!0}function Ce(le,we,pe){try{we=new de(we,pe)}catch{return!1}return we.test(le)}function Re(le,we,pe,Pe){var De,Le,Oe,Te,Ae;switch(le=new W(le,Pe),we=new de(we,Pe),pe){case">":De=z,Le=_,Oe=U,Te=">",Ae=">=";break;case"<":De=U,Le=te,Oe=z,Te="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(le,we,Pe))return!1;for(var qe=0;qe<we.set.length;++qe){var He=we.set[qe],Fe=null,Ne=null;if(He.forEach(function(Ue){Ue.semver===$e&&(Ue=new fe(">=0.0.0")),Fe=Fe||Ue,Ne=Ne||Ue,De(Ue.semver,Fe.semver,Pe)?Fe=Ue:Oe(Ue.semver,Ne.semver,Pe)&&(Ne=Ue)}),Fe.operator===Te||Fe.operator===Ae||(!Ne.operator||Ne.operator===Te)&&Le(le,Ne.semver)||Ne.operator===Ae&&Oe(le,Ne.semver))return!1}return!0}fe.prototype.parse=function(le){var we=this.loose?I[H]:I[K],pe=le.match(we);if(!pe)throw new TypeError("Invalid comparator: "+le);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new W(pe[2],this.loose):this.semver=$e},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===$e||(typeof le=="string"&&(le=new W(le,this.loose)),oe(le,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(le,we){if(!(le instanceof fe))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new de(le.value,we),Ce(this.value,pe,we);if(le.operator==="")return pe=new de(this.value,we),Ce(le.semver,pe,we);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Le=this.semver.version===le.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Te=oe(this.semver,"<",le.semver,we)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ae=oe(this.semver,">",le.semver,we)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||De||Le&&Oe||Te||Ae},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var we=this.loose;le=le.trim(),L("range",le,we);var pe=we?I[ie]:I[V];le=le.replace(pe,be),L("hyphen replace",le),le=le.replace(I[G],"$1$2$3"),L("comparator trim",le,I[G]),le=(le=(le=le.replace(I[R],"$1~")).replace(I[Y],"$1^")).split(/\s+/).join(" ");var Pe=we?I[H]:I[K],De=le.split(" ").map(function(Le){return function(Oe,Te){return L("comp",Oe),Oe=function(Ae,qe){return Ae.trim().split(/\s+/).map(function(He){return function(Fe,Ne){L("caret",Fe,Ne);var Ue=Ne?I[X]:I[J];return Fe.replace(Ue,function(re,ue,me,ye,ke){var Ie;return L("caret",Fe,re,ue,me,ye,ke),ge(ue)?Ie="":ge(me)?Ie=">="+ue+".0.0 <"+(+ue+1)+".0.0":ge(ye)?Ie=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":ke?(L("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ie=ue==="0"?me==="0"?">="+ue+"."+me+"."+ye+ke+" <"+ue+"."+me+"."+(+ye+1):">="+ue+"."+me+"."+ye+ke+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+ye+ke+" <"+(+ue+1)+".0.0"):(L("no pr"),Ie=ue==="0"?me==="0"?">="+ue+"."+me+"."+ye+" <"+ue+"."+me+"."+(+ye+1):">="+ue+"."+me+"."+ye+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+ye+" <"+(+ue+1)+".0.0"),L("caret return",Ie),Ie})}(He,qe)}).join(" ")}(Oe,Te),L("caret",Oe),Oe=function(Ae,qe){return Ae.trim().split(/\s+/).map(function(He){return function(Fe,Ne){var Ue=Ne?I[T]:I[F];return Fe.replace(Ue,function(re,ue,me,ye,ke){var Ie;return L("tilde",Fe,re,ue,me,ye,ke),ge(ue)?Ie="":ge(me)?Ie=">="+ue+".0.0 <"+(+ue+1)+".0.0":ge(ye)?Ie=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":ke?(L("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ie=">="+ue+"."+me+"."+ye+ke+" <"+ue+"."+(+me+1)+".0"):Ie=">="+ue+"."+me+"."+ye+" <"+ue+"."+(+me+1)+".0",L("tilde return",Ie),Ie})}(He,qe)}).join(" ")}(Oe,Te),L("tildes",Oe),Oe=function(Ae,qe){return L("replaceXRanges",Ae,qe),Ae.split(/\s+/).map(function(He){return function(Fe,Ne){Fe=Fe.trim();var Ue=Ne?I[v]:I[S];return Fe.replace(Ue,function(re,ue,me,ye,ke,Ie){L("xRange",Fe,re,ue,me,ye,ke,Ie);var Me=ge(me),Ve=Me||ge(ye),Be=Ve||ge(ke);return ue==="="&&Be&&(ue=""),Me?re=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Be?(Ve&&(ye=0),Be&&(ke=0),ue===">"?(ue=">=",Ve?(me=+me+1,ye=0,ke=0):Be&&(ye=+ye+1,ke=0)):ue==="<="&&(ue="<",Ve?me=+me+1:ye=+ye+1),re=ue+me+"."+ye+"."+ke):Ve?re=">="+me+".0.0 <"+(+me+1)+".0.0":Be&&(re=">="+me+"."+ye+".0 <"+me+"."+(+ye+1)+".0"),L("xRange return",re),re})}(He,qe)}).join(" ")}(Oe,Te),L("xrange",Oe),Oe=function(Ae,qe){return L("replaceStars",Ae,qe),Ae.trim().replace(I[se],"")}(Oe,Te),L("stars",Oe),Oe}(Le,we)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Le){return!!Le.match(Pe)})),De=De.map(function(Le){return new fe(Le,we)})},de.prototype.intersects=function(le,we){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Pe){return le.set.some(function(De){return De.every(function(Le){return Pe.intersects(Le,we)})})})})},e.toComparators=function(le,we){return new de(le,we).set.map(function(pe){return pe.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new W(le,this.loose));for(var we=0;we<this.set.length;we++)if(Ee(this.set[we],le))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(le,we,pe){var Pe=null,De=null;try{var Le=new de(we,pe)}catch{return null}return le.forEach(function(Oe){Le.test(Oe)&&(Pe&&De.compare(Oe)!==-1||(De=new W(Pe=Oe,pe)))}),Pe},e.minSatisfying=function(le,we,pe){var Pe=null,De=null;try{var Le=new de(we,pe)}catch{return null}return le.forEach(function(Oe){Le.test(Oe)&&(Pe&&De.compare(Oe)!==1||(De=new W(Pe=Oe,pe)))}),Pe},e.validRange=function(le,we){try{return new de(le,we).range||"*"}catch{return null}},e.ltr=function(le,we,pe){return Re(le,we,"<",pe)},e.gtr=function(le,we,pe){return Re(le,we,">",pe)},e.outside=Re,e.prerelease=function(le,we){var pe=ee(le,we);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(le,we,pe){return le=new de(le,pe),we=new de(we,pe),le.intersects(we)},e.coerce=function(le){if(le instanceof W)return le;if(typeof le!="string")return null;var we=le.match(I[k]);return we==null?null:ee((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,D(1))},function(ne,e){var D,N,L=ne.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(g){if(D===setTimeout)return setTimeout(g,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch{try{return D.call(null,g,0)}catch{return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var C,f=[],E=!1,y=-1;function w(){E&&C&&(E=!1,C.length?f=C.concat(f):y=-1,f.length&&h())}function h(){if(!E){var g=I(w);E=!0;for(var l=f.length;l;){for(C=f,f=[];++y<l;)C&&C[y].run();y=-1,l=f.length}C=null,E=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(g)}}function c(g,l){this.fun=g,this.array=l}function p(){}L.nextTick=function(g){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];f.push(new c(g,l)),f.length!==1||E||I(h)},c.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(g){return[]},L.binding=function(g){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(g){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[128],ce([0,1]),function(ne,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class N{constructor(I,C,f){this.level=I,this.key=C,this.value=f,this.forward=[]}}const L=void 0;class A{constructor(I,C=2**16){this.comparator=I,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,C){return A.h(this,I,C,this.comparator)&&(this.f+=1),this}delete(I){const C=A.k(this,I,this.comparator);return C&&(this.f-=1),C}forEach(I,C){let f=this.e.forward[0];for(;f;)I.call(C,f.value,f.key,this),f=f.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",C=this.e.forward[0];for(;C;)I+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return I}static g(I,C,f){let E=I.e;for(let y=I.d-1;y>=0;y--)for(;E.forward[y]&&f(E.forward[y].key,C)<0;)E=E.forward[y];if(E=E.forward[0],E&&f(E.key,C)===0)return E}static h(I,C,f,E){const y=[];let w=I.e;for(let h=I.d-1;h>=0;h--){for(;w.forward[h]&&E(w.forward[h].key,C)<0;)w=w.forward[h];y[h]=w}if(w=w.forward[0],w&&E(w.key,C)===0)return w.value=f,!1;{const h=A.j(I);if(h>I.d){for(let c=I.d;c<h;c++)y[c]=I.e;I.d=h}w=new N(h,C,f);for(let c=0;c<h;c++)w.forward[c]=y[c].forward[c],y[c].forward[c]=w;return!0}}static j(I,C=.5){let f=1;for(;Math.random()<C&&f<I.c;)f+=1;return f}static k(I,C,f){const E=[];let y=I.e;for(let w=I.d-1;w>=0;w--){for(;y.forward[w]&&f(y.forward[w].key,C)<0;)y=y.forward[w];E[w]=y}if(y=y.forward[0],!y||f(y.key,C)!==0)return!1;for(let w=0;w<I.d&&E[w].forward[w]===y;w++)E[w].forward[w]=y.forward[w];for(;I.d>0&&I.e.forward[I.d-1]===L;)I.d-=1;return!0}}e.$zs=A}),define(ae[63],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=D&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$_d=N}),define(ae[3],ce([0,1,7,85,2,86,63]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$be=e.Event=void 0,e.$ce=h;const I=!1,C=!1,f=!1;var E;(function(R){R.None=()=>L.$Uc.None;function F(de){if(f){const{onDidAddListener:ge}=de,be=p.create();let Ee=0;de.onDidAddListener=()=>{++Ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),ge?.()}}}function T(de,ge){return se(de,()=>{},0,void 0,!0,void 0,ge)}R.defer=T;function q(de){return(ge,be=null,Ee)=>{let Ce=!1,Re;return Re=de(le=>{if(!Ce)return Re?Re.dispose():Ce=!0,ge.call(be,le)},null,Ee),Ce&&Re.dispose(),Re}}R.once=q;function Y(de,ge,be){return V((Ee,Ce=null,Re)=>de(le=>Ee.call(Ce,ge(le)),null,Re),be)}R.map=Y;function J(de,ge,be){return V((Ee,Ce=null,Re)=>de(le=>{ge(le),Ee.call(Ce,le)},null,Re),be)}R.forEach=J;function X(de,ge,be){return V((Ee,Ce=null,Re)=>de(le=>ge(le)&&Ee.call(Ce,le),null,Re),be)}R.filter=X;function H(de){return de}R.signal=H;function K(...de){return(ge,be=null,Ee)=>{const Ce=(0,L.$Rc)(...de.map(Re=>Re(le=>ge.call(be,le))));return ie(Ce,Ee)}}R.any=K;function G(de,ge,be,Ee){let Ce=be;return Y(de,Re=>(Ce=ge(Ce,Re),Ce),Ee)}R.reduce=G;function V(de,ge){let be;const Ee={onWillAddFirstListener(){be=de(Ce.fire,Ce)},onDidRemoveLastListener(){be?.dispose()}};ge||F(Ee);const Ce=new $(Ee);return ge?.add(Ce),Ce.event}function ie(de,ge){return ge instanceof Array?ge.push(de):ge&&ge.add(de),de}function se(de,ge,be=100,Ee=!1,Ce=!1,Re,le){let we,pe,Pe,De=0,Le;const Oe={leakWarningThreshold:Re,onWillAddFirstListener(){we=de(Ae=>{De++,pe=ge(pe,Ae),Ee&&!Pe&&(Te.fire(pe),pe=void 0),Le=()=>{const qe=pe;pe=void 0,Pe=void 0,(!Ee||De>1)&&Te.fire(qe),De=0},typeof be=="number"?(clearTimeout(Pe),Pe=setTimeout(Le,be)):Pe===void 0&&(Pe=0,queueMicrotask(Le))})},onWillRemoveListener(){Ce&&De>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,we.dispose()}};le||F(Oe);const Te=new $(Oe);return le?.add(Te),Te.event}R.debounce=se;function he(de,ge=0,be){return R.debounce(de,(Ee,Ce)=>Ee?(Ee.push(Ce),Ee):[Ce],ge,void 0,!0,void 0,be)}R.accumulate=he;function ee(de,ge=(Ee,Ce)=>Ee===Ce,be){let Ee=!0,Ce;return X(de,Re=>{const le=Ee||!ge(Re,Ce);return Ee=!1,Ce=Re,le},be)}R.latch=ee;function W(de,ge,be){return[R.filter(de,ge,be),R.filter(de,Ee=>!ge(Ee),be)]}R.split=W;function B(de,ge=!1,be=[],Ee){let Ce=be.slice(),Re=de(pe=>{Ce?Ce.push(pe):we.fire(pe)});Ee&&Ee.add(Re);const le=()=>{Ce?.forEach(pe=>we.fire(pe)),Ce=null},we=new $({onWillAddFirstListener(){Re||(Re=de(pe=>we.fire(pe)),Ee&&Ee.add(Re))},onDidAddFirstListener(){Ce&&(ge?setTimeout(le):le())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return Ee&&Ee.add(we),we.event}R.buffer=B;function j(de,ge){return(Ee,Ce,Re)=>{const le=ge(new z);return de(function(we){const pe=le.evaluate(we);pe!==M&&Ee.call(Ce,pe)},void 0,Re)}}R.chain=j;const M=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(be=>(ge(be),be)),this}filter(ge){return this.f.push(be=>ge(be)?be:M),this}reduce(ge,be){let Ee=be;return this.f.push(Ce=>(Ee=ge(Ee,Ce),Ee)),this}latch(ge=(be,Ee)=>be===Ee){let be=!0,Ee;return this.f.push(Ce=>{const Re=be||!ge(Ce,Ee);return be=!1,Ee=Ce,Re?Ce:M}),this}evaluate(ge){for(const be of this.f)if(ge=be(ge),ge===M)break;return ge}}function U(de,ge,be=Ee=>Ee){const Ee=(...we)=>le.fire(be(...we)),Ce=()=>de.on(ge,Ee),Re=()=>de.removeListener(ge,Ee),le=new $({onWillAddFirstListener:Ce,onDidRemoveLastListener:Re});return le.event}R.fromNodeEventEmitter=U;function Z(de,ge,be=Ee=>Ee){const Ee=(...we)=>le.fire(be(...we)),Ce=()=>de.addEventListener(ge,Ee),Re=()=>de.removeEventListener(ge,Ee),le=new $({onWillAddFirstListener:Ce,onDidRemoveLastListener:Re});return le.event}R.fromDOMEventEmitter=Z;function x(de){return new Promise(ge=>q(de)(ge))}R.toPromise=x;function te(de){const ge=new $;return de.then(be=>{ge.fire(be)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}R.fromPromise=te;function _(de,ge,be){return ge(be),de(Ee=>ge(Ee))}R.runAndSubscribe=_;class oe{constructor(ge,be){this._observable=ge,this.f=0,this.g=!1;const Ee={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};be||F(Ee),this.emitter=new $(Ee),be&&be.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,be){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function fe(de,ge){return new oe(de,ge).emitter.event}R.fromObservable=fe;function $e(de){return(ge,be,Ee)=>{let Ce=0,Re=!1;const le={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(de.reportChanges(),Re&&(Re=!1,ge.call(be)))},handlePossibleChange(){},handleChange(){Re=!0}};de.addObserver(le),de.reportChanges();const we={dispose(){de.removeObserver(le)}};return Ee instanceof L.$Tc?Ee.add(we):Array.isArray(Ee)&&Ee.push(we),we}}R.fromObservableLight=$e})(E||(e.Event=E={}));class y{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${y.f++}`,y.all.add(this)}start(F){this.g=new O.$_d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$be=y;let w=-1;function h(R){const F=w;return w=R,{dispose(){w=F}}}class c{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const q=this.threshold;if(q<=0||T<q)return;this.f||(this.f=new Map);const Y=this.f.get(F.value)||0;if(this.f.set(F.value,Y+1),this.g-=1,this.g<=0){this.g=q*.5;let J,X=0;for(const[H,K]of this.f)(!J||X<K)&&(J=H,X=K);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${X}):`),console.warn(J)}return()=>{const J=this.f.get(F.value)||0;this.f.set(F.value,J-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class l{constructor(F){this.value=F,this.id=g++}}const u=2,m=(R,F)=>{if(R instanceof l)F(R);else for(let T=0;T<R.length;T++){const q=R[T];q&&F(q)}},d=I?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class ${constructor(F){this.w=0,this.f=F,this.g=w>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const F=this.t;queueMicrotask(()=>{m(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;T&&(F=F.bind(T));const Y=new l(F);let J,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=p.create(),J=this.g.check(Y.stack,this.w+1)),C&&(Y.stack=X??p.create()),this.t?this.t instanceof l?(this.u??=new r,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const H=(0,L.$Sc)(()=>{d?.unregister(H),J?.(),this.x(Y)});if(q instanceof L.$Tc?q.add(H):Array.isArray(q)&&q.push(H),d){const K=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(H,K,H)}return H},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,q=T.indexOf(F);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[q]=void 0;const Y=this.u.current===this;if(this.w*u<=T.length){let J=0;for(let X=0;X<T.length;X++)T[X]?T[J++]=T[X]:Y&&(this.u.end--,J<this.u.i&&this.u.i--);T.length=J}}y(F,T){if(!F)return;const q=this.f?.onListenerError||D.$1;if(!q){F.value(T);return}try{F.value(T)}catch(Y){q(Y)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$de=$;const t=()=>new r;e.$ee=t;class r{constructor(){this.i=-1,this.end=0}enqueue(F,T,q){this.i=0,this.end=q,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends ${async fireAsync(F,T,q){if(this.t)for(this.h||(this.h=new A.$5c),m(this.t,Y=>this.h.push([Y.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[Y,J]=this.h.shift(),X=[],H={...J,token:T,waitUntil:K=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");q&&(K=q(K,Y)),X.push(K)}};try{Y(H)}catch(K){(0,D.$1)(K);continue}Object.freeze(X),await Promise.allSettled(X).then(K=>{for(const G of K)G.status==="rejected"&&(0,D.$1)(G.reason)})}}}e.$fe=n;class s extends ${get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new A.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ge=s;class i extends s{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$he=i;class o extends ${constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ie=o;class a{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const q=()=>{this.g&&this.o(T);const Y=this.h.indexOf(T);this.h.splice(Y,1)};return(0,L.$Sc)((0,N.$db)(q))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$je=a;class b{constructor(F,T,q,Y){this.f=new L.$Tc;const J=this.f.add(new a),X=this.f.add(new L.$4c);function H(K){X.set(K,J.add(Y(K)))}for(const K of F)H(K);this.f.add(T(K=>{H(K)})),this.f.add(q(K=>{X.deleteAndDispose(K)})),this.event=J.event}dispose(){this.f.dispose()}}e.$ke=b;class S{constructor(){this.f=[]}wrapEvent(F){return(T,q,Y)=>F(J=>{const X=this.f[this.f.length-1];X?X.push(()=>T.call(q,J)):T.call(q,J)},void 0,Y)}bufferEvents(F){const T=[];this.f.push(T);const q=F();return this.f.pop(),T.forEach(Y=>Y()),q}}e.$le=S;class v{constructor(){this.f=!1,this.g=E.None,this.h=L.$Uc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$me=v;class k{static const(F){return new P(F)}constructor(F){this.g=F,this.f=new $,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ne=k;class P{constructor(F){this.value=F,this.onDidChange=E.None}}}),define(ae[26],ce([0,1,3]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.CancellationToken=void 0,e.$pe=I;const N=Object.freeze(function(C,f){const E=setTimeout(C.bind(f),0);return{dispose(){clearTimeout(E)}}});var L;(function(C){function f(E){return E===C.None||E===C.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}C.isCancellationToken=f,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$de),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$oe=O;function I(C){const f=new O;return C.add({dispose(){f.cancel()}}),f.token}}),define(ae[129],ce([0,1,26]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=L;class N{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new D.$oe,f=this.b(C.token);return this.a={promise:f,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$1e=N;function L(I){return I}class A{constructor(C,f){this.a=void 0,this.b=void 0,typeof C=="function"?(this.c=C,this.d=L):(this.c=f,this.d=C.getCacheKey)}get(C){const f=this.d(C);return this.b!==f&&(this.b=f,this.a=this.c(C)),this.a}}e.$3e=A;class O{get cachedValues(){return this.a}constructor(C,f){this.a=new Map,this.b=new Map,typeof C=="function"?(this.c=C,this.d=L):(this.c=f,this.d=C.getCacheKey)}get(C){const f=this.d(C);if(this.b.has(f))return this.b.get(f);const E=this.c(C);return this.a.set(C,E),this.b.set(f,E),E}}e.$4e=O}),define(ae[50],ce([0,1,7,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=L,e.$re=A,e.$se=O,e.$te=I,e.$ue=f,e.$ve=E,e.$we=y,e.$xe=w,e.$ye=h,e.$ze=c,e.$Ae=p,e.$Be=g,e.$Ce=l,e.$De=u,e.$Ee=m;function L(d){const $=d;return $?typeof $.read=="function":!1}function A(d){const $=d;return $?[$.on,$.pause,$.resume,$.destroy].every(t=>typeof t=="function"):!1}function O(d){const $=d;return $?A($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function I(d,$){return new C(d,$)}class C{constructor($,t){this.e=$,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(t=>t($))}h($){this.c.error.length===0?(0,D.$1)($):this.c.error.slice(0).forEach(t=>t($))}i(){this.c.end.slice(0).forEach($=>$())}on($,t){if(!this.a.destroyed)switch($){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener($,t){if(this.a.destroyed)return;let r;switch($){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(d,$){const t=[];let r;for(;(r=d.read())!==null;)t.push(r);return $(t)}function E(d,$,t){const r=[];let n;for(;(n=d.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?$(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return d.read()}}}function y(d,$){return new Promise((t,r)=>{const n=[];w(d,{onData:s=>{$&&n.push(s)},onError:s=>{$?r(s):t(void 0)},onEnd:()=>{t($?$(n):void 0)}})})}function w(d,$,t){d.on("error",r=>{t?.isCancellationRequested||$.onError(r)}),d.on("end",()=>{t?.isCancellationRequested||$.onEnd()}),d.on("data",r=>{t?.isCancellationRequested||$.onData(r)})}function h(d,$){return new Promise((t,r)=>{const n=new N.$Tc,s=[],i=b=>{if(s.push(b),s.length>$)return n.dispose(),d.pause(),t({stream:d,buffer:s,ended:!1})},o=b=>(n.dispose(),r(b)),a=()=>(n.dispose(),t({stream:d,buffer:s,ended:!0}));n.add((0,N.$Sc)(()=>d.removeListener("error",o))),d.on("error",o),n.add((0,N.$Sc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,N.$Sc)(()=>d.removeListener("data",i))),d.on("data",i)})}function c(d,$){const t=I($);return t.end(d),t}function p(){const d=I(()=>{throw new Error("not supported")});return d.end(),d}function g(d){let $=!1;return{read:()=>$?null:($=!0,d)}}function l(d,$,t){const r=I(t);return w(d,{onData:n=>r.write($.data(n)),onError:n=>r.error($.error?$.error(n):n),onEnd:()=>r.end()}),r}function u(d,$,t){let r=!1;return{read:()=>{const n=$.read();return r?n:(r=!0,n!==null?t([d,n]):d)}}}function m(d,$,t){let r=!1;const n=I(t);return w($,{onData:s=>r?n.write(s):(r=!0,n.write(t([d,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(d)),n.end()}}),n}}),define(ae[15],ce([0,1,53,50]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=f,e.$He=E,e.$Ie=y,e.$Je=w,e.$Ke=h,e.$Le=c,e.$Me=p,e.$Ne=g,e.$Oe=l,e.$Pe=u,e.$Qe=m,e.$Re=d,e.$Se=$,e.$Te=t,e.$Ue=r,e.$Ve=n,e.$We=s,e.$Xe=i,e.$Ye=o,e.$Ze=S;const L=typeof Buffer<"u",A=new D.$V(()=>new Uint8Array(256));let O,I;class C{static alloc(k){return L?new C(Buffer.allocUnsafe(k)):new C(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new C(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&L?new C(Buffer.from(k)):(O||(O=new TextEncoder),new C(O.encode(k)))}static fromByteArray(k){const P=C.alloc(k.length);for(let R=0,F=k.length;R<F;R++)P.buffer[R]=k[R];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let T=0,q=k.length;T<q;T++)P+=k[T].byteLength}const R=C.alloc(P);let F=0;for(let T=0,q=k.length;T<q;T++){const Y=k[T];R.set(Y,F),F+=Y.byteLength}return R}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=C.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(k,P){return new C(this.buffer.subarray(k,P))}set(k,P){if(k instanceof C)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return w(this.buffer,k)}writeUInt32BE(k,P){h(this.buffer,k,P)}readUInt32LE(k){return c(this.buffer,k)}writeUInt32LE(k,P){p(this.buffer,k,P)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,P){l(this.buffer,k,P)}indexOf(k,P=0){return f(this.buffer,k instanceof C?k.buffer:k,P)}}e.$Fe=C;function f(v,k,P=0){const R=k.byteLength,F=v.byteLength;if(R===0)return 0;if(R===1)return v.indexOf(k[0]);if(R>F-P)return-1;const T=A.value;T.fill(k.length);for(let X=0;X<k.length;X++)T[k[X]]=k.length-X-1;let q=P+k.length-1,Y=q,J=-1;for(;q<F;)if(v[q]===k[Y]){if(Y===0){J=q;break}q--,Y--}else q+=Math.max(k.length-Y,T[v[q]]),Y=k.length-1;return J}function E(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0}function y(v,k,P){v[P+0]=k&255,k=k>>>8,v[P+1]=k&255}function w(v,k){return v[k]*2**24+v[k+1]*2**16+v[k+2]*2**8+v[k+3]}function h(v,k,P){v[P+3]=k,k=k>>>8,v[P+2]=k,k=k>>>8,v[P+1]=k,k=k>>>8,v[P]=k}function c(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0|v[k+2]<<16>>>0|v[k+3]<<24>>>0}function p(v,k,P){v[P+0]=k&255,k=k>>>8,v[P+1]=k&255,k=k>>>8,v[P+2]=k&255,k=k>>>8,v[P+3]=k&255}function g(v,k){return v[k]}function l(v,k,P){v[P]=k}function u(v){return N.$ue(v,k=>C.concat(k))}function m(v){return N.$Be(v)}function d(v){return N.$we(v,k=>C.concat(k))}async function $(v){return v.ended?C.concat(v.buffer):C.concat([...v.buffer,await d(v.stream)])}function t(v){return N.$ze(v,k=>C.concat(k))}function r(v){return N.$Ce(v,{data:k=>typeof k=="string"?C.fromString(k):C.wrap(k)},k=>C.concat(k))}function n(v){return N.$te(k=>C.concat(k),v)}function s(v,k){return N.$De(v,k,P=>C.concat(P))}function i(v,k){return N.$Ee(v,k,P=>C.concat(P))}function o(v){let k=0,P=0,R=0;const F=new Uint8Array(Math.floor(v.length/4*3)),T=Y=>{switch(P){case 3:F[R++]=k|Y,P=0;break;case 2:F[R++]=k|Y>>>2,k=Y<<6,P=3;break;case 1:F[R++]=k|Y>>>4,k=Y<<4,P=2;break;default:k=Y<<2,P=1}};for(let Y=0;Y<v.length;Y++){const J=v.charCodeAt(Y);if(J>=65&&J<=90)T(J-65);else if(J>=97&&J<=122)T(J-97+26);else if(J>=48&&J<=57)T(J-48+52);else if(J===43||J===45)T(62);else if(J===47||J===95)T(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${v[Y]}`)}}const q=R;for(;P>0;)T(0);return C.wrap(F).slice(0,q)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:v},k=!0,P=!1){const R=P?b:a;let F="";const T=v.byteLength%3;let q=0;for(;q<v.byteLength-T;q+=3){const Y=v[q+0],J=v[q+1],X=v[q+2];F+=R[Y>>>2],F+=R[(Y<<4|J>>>4)&63],F+=R[(J<<2|X>>>6)&63],F+=R[X&63]}if(T===1){const Y=v[q+0];F+=R[Y>>>2],F+=R[Y<<4&63],k&&(F+="==")}else if(T===2){const Y=v[q+0],J=v[q+1];F+=R[Y>>>2],F+=R[(Y<<4|J>>>4)&63],F+=R[J<<2&63],k&&(F+="=")}return F}}),define(ae[27],ce([0,1,129,53]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=L,e.$8e=O,e.$9e=C,e.$0e=f,e.$$e=E,e.$_e=y,e.$af=w,e.$bf=h,e.$cf=c,e.$df=p,e.$ef=g,e.$ff=l,e.$gf=u,e.$hf=m,e.$if=d,e.$jf=$,e.$kf=t,e.$lf=r,e.$mf=n,e.$nf=s,e.$of=i,e.$pf=o,e.$qf=a,e.$rf=b,e.$sf=S,e.$tf=v,e.$uf=k,e.$vf=P,e.$wf=R,e.$xf=F,e.$yf=T,e.$zf=q,e.$Af=Y,e.$Bf=J,e.$Cf=X,e.$Df=H,e.$Ef=K,e.$Hf=se,e.$If=he,e.$Jf=ee,e.$Kf=W,e.$Lf=M,e.$Mf=U,e.$Of=Z,e.$Pf=x,e.$Qf=te,e.$Rf=_,e.$Sf=fe,e.$Tf=$e,e.$Uf=ge,e.$Wf=be,e.$Xf=Ee,e.$Yf=Ce,e.$Zf=Re,e.$1f=le,e.$2f=we,e.$3f=pe,e.$4f=Pe,e.$5f=Ae;function L(re){return!re||typeof re!="string"?!0:re.trim().length===0}const A=/{(\d+)}/g;function O(re,...ue){return ue.length===0?re:re.replace(A,function(me,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=ue.length?me:ue[ke]})}const I=/{([^}]+)}/g;function C(re,ue){return Object.keys(ue).length===0?re:re.replace(I,(me,ye)=>ue[ye]??me)}function f(re){return re.replace(/[<>"'&]/g,ue=>{switch(ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ue})}function E(re){return re.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}function y(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(re,ue){let me=0,ye=re.indexOf(ue);for(;ye!==-1;)me++,ye=re.indexOf(ue,ye+ue.length);return me}function h(re,ue,me="\u2026"){return re.length<=ue?re:`${re.substr(0,ue)}${me}`}function c(re,ue,me="\u2026"){if(re.length<=ue)return re;const ye=Math.ceil(ue/2)-me.length/2,ke=Math.floor(ue/2)-me.length/2;return`${re.substr(0,ye)}${me}${re.substr(re.length-ke)}`}function p(re,ue=" "){const me=g(re,ue);return l(me,ue)}function g(re,ue){if(!re||!ue)return re;const me=ue.length;if(me===0||re.length===0)return re;let ye=0;for(;re.indexOf(ue,ye)===ye;)ye=ye+me;return re.substring(ye)}function l(re,ue){if(!re||!ue)return re;const me=ue.length,ye=re.length;if(me===0||ye===0)return re;let ke=ye,Ie=-1;for(;Ie=re.lastIndexOf(ue,ke-1),!(Ie===-1||Ie+me!==ke);){if(Ie===0)return"";ke=Ie}return re.substring(0,ke)}function u(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function m(re){return re.replace(/\*/g,"")}function d(re,ue,me={}){if(!re)throw new Error("Cannot create regex from empty string");ue||(re=y(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(re,ye)}function $(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function t(re){return re.split(/\r\n|\r|\n/)}function r(re){const ue=[],me=re.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(me.length/2);ye++)ue.push(me[2*ye]+(me[2*ye+1]??""));return ue}function n(re){for(let ue=0,me=re.length;ue<me;ue++){const ye=re.charCodeAt(ue);if(ye!==32&&ye!==9)return ue}return-1}function s(re,ue=0,me=re.length){for(let ye=ue;ye<me;ye++){const ke=re.charCodeAt(ye);if(ke!==32&&ke!==9)return re.substring(ue,ye)}return re.substring(ue,me)}function i(re,ue=re.length-1){for(let me=ue;me>=0;me--){const ye=re.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}function o(re,ue,me){const ye=[];let ke=0;for(const Ie of re.matchAll(ue)){if(ye.push(re.slice(ke,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");ke=Ie.index+Ie[0].length,ye.push(me(Ie[0],...Ie.slice(1),Ie.index,re,Ie.groups))}return ye.push(re.slice(ke)),Promise.all(ye).then(Ie=>Ie.join(""))}function a(re,ue){return re<ue?-1:re>ue?1:0}function b(re,ue,me=0,ye=re.length,ke=0,Ie=ue.length){for(;me<ye&&ke<Ie;me++,ke++){const Be=re.charCodeAt(me),Ke=ue.charCodeAt(ke);if(Be<Ke)return-1;if(Be>Ke)return 1}const Me=ye-me,Ve=Ie-ke;return Me<Ve?-1:Me>Ve?1:0}function S(re,ue){return v(re,ue,0,re.length,0,ue.length)}function v(re,ue,me=0,ye=re.length,ke=0,Ie=ue.length){for(;me<ye&&ke<Ie;me++,ke++){let Be=re.charCodeAt(me),Ke=ue.charCodeAt(ke);if(Be===Ke)continue;if(Be>=128||Ke>=128)return b(re.toLowerCase(),ue.toLowerCase(),me,ye,ke,Ie);P(Be)&&(Be-=32),P(Ke)&&(Ke-=32);const ze=Be-Ke;if(ze!==0)return ze}const Me=ye-me,Ve=Ie-ke;return Me<Ve?-1:Me>Ve?1:0}function k(re){return re>=48&&re<=57}function P(re){return re>=97&&re<=122}function R(re){return re>=65&&re<=90}function F(re,ue){return re.length===ue.length&&v(re,ue)===0}function T(re,ue){const me=ue.length;return ue.length>re.length?!1:v(re,ue,0,me)===0}function q(re,ue){const me=Math.min(re.length,ue.length);let ye;for(ye=0;ye<me;ye++)if(re.charCodeAt(ye)!==ue.charCodeAt(ye))return ye;return me}function Y(re,ue){const me=Math.min(re.length,ue.length);let ye;const ke=re.length-1,Ie=ue.length-1;for(ye=0;ye<me;ye++)if(re.charCodeAt(ke-ye)!==ue.charCodeAt(Ie-ye))return ye;return me}function J(re){return 55296<=re&&re<=56319}function X(re){return 56320<=re&&re<=57343}function H(re,ue){return(re-55296<<10)+(ue-56320)+65536}function K(re,ue,me){const ye=re.charCodeAt(me);if(J(ye)&&me+1<ue){const ke=re.charCodeAt(me+1);if(X(ke))return H(ye,ke)}return ye}function G(re,ue){const me=re.charCodeAt(ue-1);if(X(me)&&ue>1){const ye=re.charCodeAt(ue-2);if(J(ye))return H(ye,me)}return me}class V{get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=G(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=K(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$Ff=V;class ie{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new V(ue,me)}nextGraphemeLength(){const ue=Oe.getInstance(),me=this.c,ye=me.offset;let ke=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ie=me.offset,Me=ue.getGraphemeBreakType(me.nextCodePoint());if(De(ke,Me)){me.setOffset(Ie);break}ke=Me}return me.offset-ye}prevGraphemeLength(){const ue=Oe.getInstance(),me=this.c,ye=me.offset;let ke=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ie=me.offset,Me=ue.getGraphemeBreakType(me.prevCodePoint());if(De(Me,ke)){me.setOffset(Ie);break}ke=Me}return ye-me.offset}eol(){return this.c.eol()}}e.$Gf=ie;function se(re,ue){return new ie(re,ue).nextGraphemeLength()}function he(re,ue){return new ie(re,ue).prevGraphemeLength()}function ee(re,ue){ue>0&&X(re.charCodeAt(ue))&&ue--;const me=ue+se(re,ue);return[me-he(re,me),me]}function W(re){const ue=new ie(re);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}let B;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(re){return B||(B=j()),B.test(re)}const z=/^[\t\n\r\x20-\x7E]*$/;function U(re){return z.test(re)}e.$Nf=/[\u2028\u2029]/;function Z(re){return e.$Nf.test(re)}function x(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function te(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function _(re,ue,me=""){const ye=re.trimStart();if(ye.length<ue)return ye;const ke=/\b/g;let Ie=0;for(;ke.test(ye)&&!(ye.length-ke.lastIndex<ue);)Ie=ke.lastIndex,ke.lastIndex+=1;return Ie===0?ye:me+ye.substring(Ie).trimStart()}const oe=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*fe(re){let ue=0;for(const me of re.matchAll(oe))ue!==me.index&&(yield{isCode:!1,str:re.substring(ue,me.index)}),yield{isCode:!0,str:me[0]},ue=me.index+me[0].length;ue!==re.length&&(yield{isCode:!1,str:re.substring(ue)})}function $e(re){return re&&(re=re.replace(oe,"")),re}const de=/\\\[.*?\\\]/g;function ge(re){return $e(re).replace(de,"")}e.$Vf="\uFEFF";function be(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}function Ee(re){return be(re)?re.substr(1):re}function Ce(re,ue){if(!re||!ue||re.length<ue.length)return!1;const me=ue.length,ye=re.toLowerCase();let ke=0,Ie=-1;for(;ke<me;){const Me=ye.indexOf(ue[ke],Ie+1);if(Me<0)return!1;Ie=Me,ke++}return!0}function Re(re,ue=!1){return re?(ue&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function le(re){return re.charAt(0).toUpperCase()+re.slice(1)}function we(re,ue=1){if(ue===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}function pe(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}function Pe(re){return Oe.getInstance().getGraphemeBreakType(re)}function De(re,ue){return re===0?ue!==5&&ue!==7:re===2&&ue===3?!1:re===4||re===2||re===3||ue===4||ue===2||ue===3?!0:!(re===8&&(ue===8||ue===9||ue===11||ue===12)||(re===11||re===9)&&(ue===9||ue===10)||(re===12||re===10)&&ue===10||ue===5||ue===13||ue===7||re===1||re===13&&ue===14||re===6&&ue===6)}var Le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Oe{static{this.c=null}static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=Te()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,ye=me.length/3;let ke=1;for(;ke<=ye;)if(ue<me[3*ke])ke=2*ke;else if(ue>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(re,ue){if(re===0)return 0;const me=qe(re,ue);if(me!==void 0)return me;const ye=new V(ue,re);return ye.prevCodePoint(),ye.offset}function qe(re,ue){const me=new V(ue,re);let ye=me.prevCodePoint();for(;He(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!te(ye))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function He(re){return 127995<=re&&re<=127999}var Fe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.$6f="\xA0";class Ne{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$3e({getCacheKey:JSON.stringify},ue=>{function me(ze){const Ze=new Map;for(let Qe=0;Qe<ze.length;Qe+=2)Ze.set(ze[Qe],ze[Qe+1]);return Ze}function ye(ze,Ze){const Qe=new Map(ze);for(const[tt,nt]of Ze)Qe.set(tt,nt);return Qe}function ke(ze,Ze){if(!ze)return Ze;const Qe=new Map;for(const[tt,nt]of ze)Ze.has(tt)&&Qe.set(tt,nt);return Qe}const Ie=this.c.value;let Me=ue.filter(ze=>!ze.startsWith("_")&&ze in Ie);Me.length===0&&(Me=["_default"]);let Ve;for(const ze of Me){const Ze=me(Ie[ze]);Ve=ke(Ve,Ze)}const Be=me(Ie._common),Ke=ye(Be,Ve);return new Ne(Ke)})}static getInstance(ue){return Ne.d.get(Array.from(ue))}static{this.e=new N.$V(()=>Object.keys(Ne.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=Ne;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(ue){return Ue.e().has(ue)}static get codePoints(){return Ue.e()}}e.$8f=Ue}),define(ae[54],ce([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=N,e.$lj=L,e.$mj=A,e.$nj=I,e.$pj=p;function N(l){return L(l,0)}function L(l,u){switch(typeof l){case"object":return l===null?A(349,u):Array.isArray(l)?C(l,u):f(l,u);case"string":return I(l,u);case"boolean":return O(l,u);case"number":return A(l,u);case"undefined":return A(937,u);default:return A(617,u)}}function A(l,u){return(u<<5)-u+l|0}function O(l,u){return A(l?433:863,u)}function I(l,u){u=A(149417,u);for(let m=0,d=l.length;m<d;m++)u=A(l.charCodeAt(m),u);return u}function C(l,u){return u=A(104579,u),l.reduce((m,d)=>L(d,m),u)}function f(l,u){return u=A(181387,u),Object.keys(l).sort().reduce((m,d)=>(m=I(d,m),L(l[d],m)),u)}class E{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$oj=E;var y;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(l,u,m=32){const d=m-u,$=~((1<<d)-1);return(l<<u|($&l)>>>d)>>>0}function h(l,u=0,m=l.byteLength,d=0){for(let $=0;$<m;$++)l[u+$]=d}function c(l,u,m="0"){for(;l.length<u;)l=m+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(m=>m.toString(16).padStart(2,"0")).join(""):c((l>>>0).toString(16),u/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const m=u.length;if(m===0)return;const d=this.p;let $=this.r,t=this.u,r,n;for(t!==0?(r=t,n=-1,t=0):(r=u.charCodeAt(0),n=0);;){let s=r;if(D.$Bf(r))if(n+1<m){const i=u.charCodeAt(n+1);D.$Cf(i)?(n++,s=D.$Df(r,i)):s=65533}else{t=r;break}else D.$Cf(r)&&(s=65533);if($=this.w(d,$,s),n++,n<m)r=u.charCodeAt(n);else break}this.r=$,this.u=t}w(u,m,d){return d<128?u[m++]=d:d<2048?(u[m++]=192|(d&1984)>>>6,u[m++]=128|(d&63)>>>0):d<65536?(u[m++]=224|(d&61440)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0):(u[m++]=240|(d&1835008)>>>18,u[m++]=128|(d&258048)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=g.g,m=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,w(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let d=this.h,$=this.l,t=this.m,r=this.n,n=this.o,s,i,o;for(let a=0;a<80;a++)a<20?(s=$&t|~$&r,i=1518500249):a<40?(s=$^t^r,i=1859775393):a<60?(s=$&t|$&r|t&r,i=2400959708):(s=$^t^r,i=3395469782),o=w(d,5)+s+n+i+u.getUint32(a*4,!1)&4294967295,n=r,r=t,t=w($,30),$=d,d=o;this.h=this.h+d&4294967295,this.l=this.l+$&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.$qj=g}),define(ae[88],ce([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const A="error",O="warning",I="warn",C="info",f="ignore";function E(w){return w?D.$xf(A,w)?L.Error:D.$xf(O,w)||D.$xf(I,w)?L.Warning:D.$xf(C,w)?L.Info:L.Ignore:L.Ignore}L.fromValue=E;function y(w){switch(w){case L.Error:return A;case L.Warning:return O;case L.Info:return C;default:return f}}L.toString=y}(N||(N={})),e.default=N}),define(ae[130],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(ae[51],ce([0,1,17,27]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class L{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const c=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return c-p}value(){return this.b[this.c]}}e.$yi=L;class A{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,N.$rf)(h,this.b,0,h.length,this.c,this.d):(0,N.$tf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=A;class O{constructor(h=!0,c=!0){this.f=h,this.g=c}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let c=h.length-1;c>=0;c--,this.c--){const p=this.b.charCodeAt(c);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,N.$rf)(h,this.b,0,h.length,this.d,this.e):(0,N.$tf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=O;var I;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(I||(I={}));class C{constructor(h,c){this.f=h,this.g=c,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,N.$sf)(h,this.c.scheme);if(this.d[this.e]===2)return(0,N.$sf)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,N.$qf)(h,this.c.query);if(this.d[this.e]===5)return(0,N.$qf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=C;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(E||(E={}));class y{static forUris(h=()=>!1,c=()=>!1){return new y(new C(h,c))}static forPaths(h=!1){return new y(new O(void 0,!h))}static forStrings(){return new y(new L)}static forConfigKeys(){return new y(new A)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,c){if(c){const p=c.slice(0);(0,D.$Wb)(p);for(const g of p)this.set(g,h)}else{const p=h.slice(0);(0,D.$Wb)(p);for(const g of p)this.set(g[0],g[1])}}set(h,c){const p=this.b.reset(h);let g;this.c||(this.c=new f,this.c.segment=p.value());const l=[];for(g=this.c;;){const m=p.cmp(g.segment);if(m>0)g.left||(g.left=new f,g.left.segment=p.value()),l.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new f,g.right.segment=p.value()),l.push([1,g]),g=g.right;else if(p.hasNext())p.next(),g.mid||(g.mid=new f,g.mid.segment=p.value()),l.push([0,g]),g=g.mid;else break}const u=g.value;g.value=c,g.key=h;for(let m=l.length-1;m>=0;m--){const d=l[m][1];d.updateHeight();const $=d.balanceFactor();if($<-1||$>1){const t=l[m][0],r=l[m+1][0];if(t===1&&r===1)l[m][1]=d.rotateLeft();else if(t===-1&&r===-1)l[m][1]=d.rotateRight();else if(t===1&&r===-1)d.right=l[m+1][1]=l[m+1][1].rotateRight(),l[m][1]=d.rotateLeft();else if(t===-1&&r===1)d.left=l[m+1][1]=l[m+1][1].rotateLeft(),l[m][1]=d.rotateRight();else throw new Error;if(m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const c=this.b.reset(h);let p=this.c;for(;p;){const g=c.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(c.hasNext())c.next(),p=p.mid;else break}return p}has(h){const c=this.d(h);return!(c?.value===void 0&&c?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,c){const p=this.b.reset(h),g=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)g.push([-1,l]),l=l.left;else if(u<0)g.push([1,l]),l=l.right;else if(p.hasNext())p.next(),g.push([0,l]),l=l.mid;else break}if(l){if(c?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:m,value:d,segment:$}=u;this.e(u.key,!1),l.key=m,l.value=d,l.segment=$}}else{const u=l.left??l.right;if(g.length>0){const[m,d]=g[g.length-1];switch(m){case-1:d.left=u;break;case 0:d.mid=u;break;case 1:d.right=u;break}}else this.c=u}for(let u=g.length-1;u>=0;u--){const m=g[u][1];m.updateHeight();const d=m.balanceFactor();if(d>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[u][1]=m.rotateLeft()):d<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[u][1]=m.rotateRight()),u>0)switch(g[u-1][0]){case-1:g[u-1][1].left=g[u][1];break;case 1:g[u-1][1].right=g[u][1];break;case 0:g[u-1][1].mid=g[u][1];break}else this.c=g[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const c=this.b.reset(h);let p=this.c,g;for(;p;){const l=c.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(c.hasNext())c.next(),g=p.value||g,p=p.mid;else break}return p&&p.value||g}findSuperstr(h){return this.g(h,!1)}g(h,c){const p=this.b.reset(h);let g=this.c;for(;g;){const l=p.cmp(g.segment);if(l>0)g=g.left;else if(l<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else return g.mid?this.h(g.mid):c?g.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[c,p]of this)h(p,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const c=[];return this.j(h,c),c[Symbol.iterator]()}j(h,c){h&&(h.left&&this.j(h.left,c),h.value&&c.push([h.key,h.value]),h.mid&&this.j(h.mid,c),h.right&&this.j(h.right,c))}_isBalanced(){const h=c=>{if(!c)return!0;const p=c.balanceFactor();return p<-1||p>1?!1:h(c.left)&&h(c.right)};return h(this.c)}}e.$Ci=y}),define(ae[13],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=D,e.$0f=N,e.$$f=L,e.$_f=A,e.$ag=O,e.$bg=I,e.$cg=C,e.$dg=f,e.$eg=E,e.$fg=y,e.$gg=w,e.$hg=h,e.$ig=c,e.$jg=g,e.$kg=l,e.$lg=u,e.$mg=m,e.$ng=d;function D($){return typeof $=="string"}function N($){return Array.isArray($)&&$.every(t=>D(t))}function L($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}function A($){const t=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof t}function O($){return typeof $=="number"&&!isNaN($)}function I($){return!!$&&typeof $[Symbol.iterator]=="function"}function C($){return $===!0||$===!1}function f($){return typeof $>"u"}function E($){return!y($)}function y($){return f($)||$===null}function w($,t){if(!$)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function h($){if(y($))throw new Error("Assertion Failed: argument is undefined or null");return $}function c(...$){const t=[];for(let r=0;r<$.length;r++){const n=$[r];if(y(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(n)}return t}const p=Object.prototype.hasOwnProperty;function g($){if(!L($))return!1;for(const t in $)if(p.call($,t))return!1;return!0}function l($){return typeof $=="function"}function u(...$){return $.length>0&&$.every(l)}function m($,t){const r=Math.min($.length,t.length);for(let n=0;n<r;n++)d($[n],t[n])}function d($,t){if(D(t)){if(typeof $!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if($ instanceof t)return}catch{}if(!y($)&&$.constructor===t||t.length===1&&t.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[30],ce([0,1,13]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=N,e.$4n=L,e.$5n=O,e.$6n=C,e.$7n=f,e.$8n=E,e.$9n=y,e.$0n=w,e.$$n=h,e.$_n=c,e.$ao=p,e.$bo=g;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([m,d])=>{u[m]=d&&typeof d=="object"?N(d):d}),u}function L(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const m=u.shift();Object.freeze(m);for(const d in m)if(A.call(m,d)){const $=m[d];typeof $=="object"&&!Object.isFrozen($)&&!(0,D.$_f)($)&&u.push($)}}return l}const A=Object.prototype.hasOwnProperty;function O(l,u){return I(l,u,new Set)}function I(l,u,m){if((0,D.$fg)(l))return l;const d=u(l);if(typeof d<"u")return d;if(Array.isArray(l)){const $=[];for(const t of l)$.push(I(t,u,m));return $}if((0,D.$$f)(l)){if(m.has(l))throw new Error("Cannot clone recursive data-structure");m.add(l);const $={};for(const t in l)A.call(l,t)&&($[t]=I(l[t],u,m));return m.delete(l),$}return l}function C(l,u,m=!0){return(0,D.$$f)(l)?((0,D.$$f)(u)&&Object.keys(u).forEach(d=>{d in l?m&&((0,D.$$f)(l[d])&&(0,D.$$f)(u[d])?C(l[d],u[d],m):l[d]=u[d]):l[d]=u[d]}),l):u}function f(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let m,d;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(m=0;m<l.length;m++)if(!f(l[m],u[m]))return!1}else{const $=[];for(d in l)$.push(d);$.sort();const t=[];for(d in u)t.push(d);if(t.sort(),!f($,t))return!1;for(m=0;m<$.length;m++)if(!f(l[$[m]],u[$[m]]))return!1}return!0}function E(l){const u=new Set;return JSON.stringify(l,(m,d)=>{if((0,D.$$f)(d)||Array.isArray(d)){if(u.has(d))return"[Circular]";u.add(d)}return typeof d=="bigint"?`[BigInt ${d.toString()}]`:d})}function y(l,u){const m=Object.create(null);return!l||!u||Object.keys(u).forEach($=>{const t=l[$],r=u[$];f(t,r)||(m[$]=r)}),m}function w(l,u){const m=u.toLowerCase(),d=Object.keys(l).find($=>$.toLowerCase()===m);return d?l[d]:l[u]}function h(l,u){const m=Object.create(null);for(const[d,$]of Object.entries(l))u(d,$)&&(m[d]=$);return m}function c(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}function p(l){const u=[];for(const m of c(l))typeof l[m]=="function"&&u.push(m);return u}function g(l,u){const m=$=>function(){const t=Array.prototype.slice.call(arguments,0);return u($,t)},d={};for(const $ of l)d[$]=m($);return d}}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=N;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return D.test(L)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let C=0,f="";return f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f}}()}),define(ae[131],ce([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=A;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const I=O.replace(/\-/g,":").toLowerCase();return!N.has(I)}function A(){const O=(0,D.networkInterfaces)();for(const I in O){const C=O[I];if(C){for(const{mac:f}of C)if(L(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[132],ce([0,1,273,15]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1W=void 0;class L extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const I=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(O,I,C){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let f=0;for(;f<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,f):(0,N.$Ge)(this.a,this.b,f);if(E===-1)break;this.push(this.a.slice(f,E+this.c)),f=E+this.c}this.a=f===this.a.length?void 0:this.a.slice(f),C()}_flush(O){this.a&&this.push(this.a),O()}}e.$1W=L}),define(ae[133],ce([0,1,64]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=N,e.$Wg=A;function N(I,C,f,E=1){let y=!1;return new Promise(w=>{const h=setTimeout(()=>{if(!y)return y=!0,w(0)},f);L(I,C,E,c=>{if(!y)return y=!0,clearTimeout(h),w(c)})})}function L(I,C,f,E){if(C===0)return E(0);const y=new D.Socket;y.once("connect",()=>(O(y),L(I+f,C-1,f,E))),y.once("data",()=>{}),y.once("error",w=>(O(y),w.code!=="ECONNREFUSED"?L(I+f,C-1,f,E):E(I))),y.connect(I,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,C,f,E="127.0.0.1"){let y=!1,w,h=1;const c=D.createServer({pauseOnConnect:!0});function p(g,l){y||(y=!0,c.removeAllListeners(),c.close(),w&&clearTimeout(w),l(g))}return new Promise(g=>{w=setTimeout(()=>{p(0,g)},f),c.on("listening",()=>{p(I,g)}),c.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<C?(I++,h++,c.listen(I,E)):p(0,g)}),c.on("close",()=>{p(0,g)}),c.listen(I,E)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(C){console.error(C)}}}),define(ae[134],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gX=D;function D(N){return!!N.parentPort}}),define(ae[135],ce([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[65],ce([0,1,135]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=f,e.$3m=E,e.$4m=y;const N=60,L=N*60,A=L*24,O=A*7,I=A*30,C=A*365;function f(w,h,c,p){typeof w!="number"&&(w=w.getTime());const g=Math.round((new Date().getTime()-w)/1e3);if(g<-30)return(0,D.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,D.localize)(1,null);let l;return g<N?(l=g,h?l===1?c?(0,D.localize)(2,null,l):(0,D.localize)(3,null,l):c?(0,D.localize)(4,null,l):(0,D.localize)(5,null,l):l===1?c?(0,D.localize)(6,null,l):(0,D.localize)(7,null,l):c?(0,D.localize)(8,null,l):(0,D.localize)(9,null,l)):g<L?(l=Math.floor(g/N),h?l===1?c?(0,D.localize)(10,null,l):(0,D.localize)(11,null,l):c?(0,D.localize)(12,null,l):(0,D.localize)(13,null,l):l===1?c?(0,D.localize)(14,null,l):(0,D.localize)(15,null,l):c?(0,D.localize)(16,null,l):(0,D.localize)(17,null,l)):g<A?(l=Math.floor(g/L),h?l===1?c?(0,D.localize)(18,null,l):(0,D.localize)(19,null,l):c?(0,D.localize)(20,null,l):(0,D.localize)(21,null,l):l===1?c?(0,D.localize)(22,null,l):(0,D.localize)(23,null,l):c?(0,D.localize)(24,null,l):(0,D.localize)(25,null,l)):g<O?(l=Math.floor(g/A),h?l===1?(0,D.localize)(26,null,l):(0,D.localize)(27,null,l):l===1?(0,D.localize)(28,null,l):(0,D.localize)(29,null,l)):g<I?(l=Math.floor(g/O),h?l===1?c?(0,D.localize)(30,null,l):(0,D.localize)(31,null,l):c?(0,D.localize)(32,null,l):(0,D.localize)(33,null,l):l===1?c?(0,D.localize)(34,null,l):(0,D.localize)(35,null,l):c?(0,D.localize)(36,null,l):(0,D.localize)(37,null,l)):g<C?(l=Math.floor(g/I),h?l===1?c?(0,D.localize)(38,null,l):(0,D.localize)(39,null,l):c?(0,D.localize)(40,null,l):(0,D.localize)(41,null,l):l===1?c?(0,D.localize)(42,null,l):(0,D.localize)(43,null,l):c?(0,D.localize)(44,null,l):(0,D.localize)(45,null,l)):(l=Math.floor(g/C),h?l===1?c?(0,D.localize)(46,null,l):(0,D.localize)(47,null,l):c?(0,D.localize)(48,null,l):(0,D.localize)(49,null,l):l===1?c?(0,D.localize)(50,null,l):(0,D.localize)(51,null,l):c?(0,D.localize)(52,null,l):(0,D.localize)(53,null,l))}function E(w,h){const c=Math.abs(w/1e3);return c<1?h?(0,D.localize)(54,null,w):(0,D.localize)(55,null,w):c<N?h?(0,D.localize)(56,null,Math.round(w)/1e3):(0,D.localize)(57,null,Math.round(w)/1e3):c<L?h?(0,D.localize)(58,null,Math.round(w/(1e3*N))):(0,D.localize)(59,null,Math.round(w/(1e3*N))):c<A?h?(0,D.localize)(60,null,Math.round(w/(1e3*L))):(0,D.localize)(61,null,Math.round(w/(1e3*L))):(0,D.localize)(62,null,Math.round(w/(1e3*A)))}function y(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[136],ce([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,17,13,136]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=C,e.$ij=f,e.$jj=E;function A(y,w){return w&&(y.stack||y.stacktrace)?L.localize(0,null,I(y),O(y.stack)||O(y.stacktrace)):I(y)}function O(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?L.localize(1,null,y.message):y.message||L.localize(2,null)}function C(y=null,w=!1){if(!y)return L.localize(3,null);if(Array.isArray(y)){const h=D.$Hb(y),c=C(h[0],w);return h.length>1?L.localize(4,null,c,h.length):c}if(N.$9f(y))return y;if(y.detail){const h=y.detail;if(h.error)return A(h.error,w);if(h.exception)return A(h.exception,w)}return y.stack?A(y,w):y.message?y.message:L.localize(5,null)}function f(y){const w=y;return w instanceof Error&&Array.isArray(w.actions)}function E(y,w){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=w,h}}),define(ae[137],ce([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[138],ce([0,1,137]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=N;function N(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(ae[139],ce([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,139]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=b,e.$J=S,e.$g="en";let N=!1,L=!1,A=!1,O=!1,I=!1,C=!1,f=!1,E=!1,y=!1,w=!1,h,c=e.$g,p=e.$g,g,l;const u=globalThis;let m;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?m=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const d=typeof m?.versions?.electron=="string",$=d&&m?.type==="renderer";if(typeof m=="object"){N=m.platform==="win32",L=m.platform==="darwin",A=m.platform==="linux",O=A&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,f=d,y=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,c=e.$g;const v=m.env.VSCODE_NLS_CONFIG;if(v)try{const k=JSON.parse(v),P=k.availableLanguages["*"];h=k.locale,p=k.osLocale,c=P||e.$g,g=k._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!$?(l=navigator.userAgent,N=l.indexOf("Windows")>=0,L=l.indexOf("Macintosh")>=0,E=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=l.indexOf("Linux")>=0,w=l?.indexOf("Mobi")>=0,C=!0,h=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,c=h,p=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;L?n=1:N?n=3:A&&(n=2),e.$i=N,e.$j=L,e.$k=A,e.$l=O,e.$m=I,e.$n=f,e.$o=C,e.$p=C&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=E,e.$s=w,e.$t=y,e.$u=n,e.$v=l,e.$w=c;var s;(function(v){function k(){return e.$w}v.value=k;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=P;function R(){return e.$w==="en"}v.isDefault=R})(s||(e.Language=s={})),e.$x=h,e.$y=p,e.$z=g,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const v=[];u.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let R=0,F=v.length;R<F;R++){const T=v[R];if(T.id===P.data.vscodeScheduleAsyncWork){v.splice(R,1),T.callback();return}}});let k=0;return P=>{const R=++k;v.push({id:R,callback:P}),u.postMessage({vscodeScheduleAsyncWork:R},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=L||E?2:N?1:3;let o=!0,a=!1;function b(){if(!a){a=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,o=new Uint16Array(v.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function S(v){return parseFloat(v)>=20}}),define(ae[36],ce([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(ae[140],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HW=O;var N;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(N||(N={}));const L="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function O(){const I=D.env[L];if(I){const f=I.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of f)switch(E){case"Unity":{const y=D.env.DESKTOP_SESSION;return y&&y.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const y=D.env[A];return y==="5"?N.KDE5:y==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const C=D.env.DESKTOP_SESSION;if(C)switch(C){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return A in D.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in D.env?N.GNOME:"KDE_FULL_SESSION"in D.env?A in D.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(ae[14],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,L=97,A=90,O=122,I=46,C=47,f=92,E=58,y=63;class w extends Error{constructor(r,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const o=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${o} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,r){if(t===null||typeof t!="object")throw new w(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new w(r,"string",t)}const p=D.$dc==="win32";function g(t){return t===C||t===f}function l(t){return t===C}function u(t){return t>=N&&t<=A||t>=L&&t<=O}function m(t,r,n,s){let i="",o=0,a=-1,b=0,S=0;for(let v=0;v<=t.length;++v){if(v<t.length)S=t.charCodeAt(v);else{if(s(S))break;S=C}if(s(S)){if(!(a===v-1||b===1))if(b===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const k=i.lastIndexOf(n);k===-1?(i="",o=0):(i=i.slice(0,k),o=i.length-1-i.lastIndexOf(n)),a=v,b=0;continue}else if(i.length!==0){i="",o=0,a=v,b=0;continue}}r&&(i+=i.length>0?`${n}..`:"..",o=2)}else i.length>0?i+=`${n}${t.slice(a+1,v)}`:i=t.slice(a+1,v),o=v-a-1;a=v,b=0}else S===I&&b!==-1?++b:b=-1}return i}function d(t,r){h(r,"pathObject");const n=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${s}`:`${n}${t}${s}`:s}e.$fc={resolve(...t){let r="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let o;if(i>=0){if(o=t[i],c(o,"path"),o.length===0)continue}else r.length===0?o=D.cwd():(o=D.env[`=${r}`]||D.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===f)&&(o=`${r}\\`));const a=o.length;let b=0,S="",v=!1;const k=o.charCodeAt(0);if(a===1)g(k)&&(b=1,v=!0);else if(g(k))if(v=!0,g(o.charCodeAt(1))){let P=2,R=P;for(;P<a&&!g(o.charCodeAt(P));)P++;if(P<a&&P!==R){const F=o.slice(R,P);for(R=P;P<a&&g(o.charCodeAt(P));)P++;if(P<a&&P!==R){for(R=P;P<a&&!g(o.charCodeAt(P));)P++;(P===a||P!==R)&&(S=`\\\\${F}\\${o.slice(R,P)}`,b=P)}}}else b=1;else u(k)&&o.charCodeAt(1)===E&&(S=o.slice(0,2),b=2,a>2&&g(o.charCodeAt(2))&&(v=!0,b=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(s){if(r.length>0)break}else if(n=`${o.slice(b)}\\${n}`,s=v,v&&r.length>0)break}return n=m(n,!s,"\\",g),s?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let n=0,s,i=!1;const o=t.charCodeAt(0);if(r===1)return l(o)?"\\":t;if(g(o))if(i=!0,g(t.charCodeAt(1))){let b=2,S=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==S){const v=t.slice(S,b);for(S=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return`\\\\${v}\\${t.slice(S)}\\`;b!==S&&(s=`\\\\${v}\\${t.slice(S,b)}`,n=b)}}}else n=1;else u(o)&&t.charCodeAt(1)===E&&(s=t.slice(0,2),n=2,r>2&&g(t.charCodeAt(2))&&(i=!0,n=3));let a=n<r?m(t.slice(n),!i,"\\",g):"";return a.length===0&&!i&&(a="."),a.length>0&&g(t.charCodeAt(r-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return g(n)||r>2&&u(n)&&t.charCodeAt(1)===E&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let o=0;o<t.length;++o){const a=t[o];c(a,"path"),a.length>0&&(r===void 0?r=n=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&g(n.charCodeAt(0))){++i;const o=n.length;o>1&&g(n.charCodeAt(1))&&(++i,o>2&&(g(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<r.length&&g(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.$fc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const n=e.$fc.resolve(t),s=e.$fc.resolve(r);if(n===s||(t=n.toLowerCase(),r=s.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===f;)i++;let o=t.length;for(;o-1>i&&t.charCodeAt(o-1)===f;)o--;const a=o-i;let b=0;for(;b<r.length&&r.charCodeAt(b)===f;)b++;let S=r.length;for(;S-1>b&&r.charCodeAt(S-1)===f;)S--;const v=S-b,k=a<v?a:v;let P=-1,R=0;for(;R<k;R++){const T=t.charCodeAt(i+R);if(T!==r.charCodeAt(b+R))break;T===f&&(P=R)}if(R!==k){if(P===-1)return s}else{if(v>k){if(r.charCodeAt(b+R)===f)return s.slice(b+R+1);if(R===2)return s.slice(b+R)}a>k&&(t.charCodeAt(i+R)===f?P=R:R===2&&(P=3)),P===-1&&(P=0)}let F="";for(R=i+P+1;R<=o;++R)(R===o||t.charCodeAt(R)===f)&&(F+=F.length===0?"..":"\\..");return b+=P,F.length>0?`${F}${s.slice(b,S)}`:(s.charCodeAt(b)===f&&++b,s.slice(b,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===f){if(r.charCodeAt(1)===f){const n=r.charCodeAt(2);if(n!==y&&n!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===E&&r.charCodeAt(2)===f)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(r===1)return g(i)?t:".";if(g(i)){if(n=s=1,g(t.charCodeAt(1))){let b=2,S=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return t;b!==S&&(n=s=b+1)}}}}else u(i)&&t.charCodeAt(1)===E&&(n=r>2&&g(t.charCodeAt(2))?3:2,s=n);let o=-1,a=!0;for(let b=r-1;b>=s;--b)if(g(t.charCodeAt(b))){if(!a){o=b;break}}else a=!1;if(o===-1){if(n===-1)return".";o=n}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=n;--o){const S=t.charCodeAt(o);if(g(S)){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=n;--o)if(g(t.charCodeAt(o))){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=0,n=-1,s=0,i=-1,o=!0,a=0;t.length>=2&&t.charCodeAt(1)===E&&u(t.charCodeAt(0))&&(r=s=2);for(let b=t.length-1;b>=r;--b){const S=t.charCodeAt(b);if(g(S)){if(!o){s=b+1;break}continue}i===-1&&(o=!1,i=b+1),S===I?n===-1?n=b:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:d.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return g(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(g(i)){if(s=1,g(t.charCodeAt(1))){let P=2,R=P;for(;P<n&&!g(t.charCodeAt(P));)P++;if(P<n&&P!==R){for(R=P;P<n&&g(t.charCodeAt(P));)P++;if(P<n&&P!==R){for(R=P;P<n&&!g(t.charCodeAt(P));)P++;P===n?s=P:P!==R&&(s=P+1)}}}}else if(u(i)&&t.charCodeAt(1)===E){if(n<=2)return r.root=r.dir=t,r;if(s=2,g(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;s=3}}s>0&&(r.root=t.slice(0,s));let o=-1,a=s,b=-1,S=!0,v=t.length-1,k=0;for(;v>=s;--v){if(i=t.charCodeAt(v),g(i)){if(!S){a=v+1;break}continue}b===-1&&(S=!1,b=v+1),i===I?o===-1?o=v:k!==1&&(k=1):o!==-1&&(k=-1)}return b!==-1&&(o===-1||k===0||k===1&&o===b-1&&o===a+1?r.base=r.name=t.slice(a,b):(r.name=t.slice(a,o),r.base=t.slice(a,b),r.ext=t.slice(o,b))),a>0&&a!==s?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(p){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let r="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:$();c(i,"path"),i.length!==0&&(r=`${i}/${r}`,n=i.charCodeAt(0)===C)}return r=m(r,!n,"/",l),n?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===C,n=t.charCodeAt(t.length-1)===C;return t=m(t,!r,"/",l),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===C},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const s=t[n];c(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const n=1,s=t.length,i=s-n,o=1,a=r.length-o,b=i<a?i:a;let S=-1,v=0;for(;v<b;v++){const P=t.charCodeAt(n+v);if(P!==r.charCodeAt(o+v))break;P===C&&(S=v)}if(v===b)if(a>b){if(r.charCodeAt(o+v)===C)return r.slice(o+v+1);if(v===0)return r.slice(o+v)}else i>b&&(t.charCodeAt(n+v)===C?S=v:v===0&&(S=0));let k="";for(v=n+S+1;v<=s;++v)(v===s||t.charCodeAt(v)===C)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(o+S)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===C;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===C){if(!s){n=i;break}}else s=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=0;--o){const S=t.charCodeAt(o);if(S===C){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===C){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=-1,n=0,s=-1,i=!0,o=0;for(let a=t.length-1;a>=0;--a){const b=t.charCodeAt(a);if(b===C){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),b===I?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===n+1?"":t.slice(r,s)},format:d.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===C;let s;n?(r.root="/",s=1):s=0;let i=-1,o=0,a=-1,b=!0,S=t.length-1,v=0;for(;S>=s;--S){const k=t.charCodeAt(S);if(k===C){if(!b){o=S+1;break}continue}a===-1&&(b=!1,a=S+1),k===I?i===-1?i=S:v!==1&&(v=1):i!==-1&&(v=-1)}if(a!==-1){const k=o===0&&n?1:o;i===-1||v===0||v===1&&i===a-1&&i===o+1?r.base=r.name=t.slice(k,a):(r.name=t.slice(k,i),r.base=t.slice(k,a),r.ext=t.slice(i,a))}return o>0?r.dir=t.slice(0,o-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(ae[40],ce([0,1,14,5,27,13]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=O,e.$pg=I,e.$qg=C,e.$rg=f,e.$sg=E,e.$tg=c,e.$ug=p,e.$vg=g,e.$wg=l,e.$xg=u,e.$yg=m,e.$zg=d,e.$Ag=$,e.$Bg=t,e.$Cg=r,e.$Dg=n,e.$Eg=o;function O(a){return a===47||a===92}function I(a){return a.replace(/[\\/]/g,D.$gc.sep)}function C(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function f(a,b=D.$gc.sep){if(!a)return"";const S=a.length,v=a.charCodeAt(0);if(O(v)){if(O(a.charCodeAt(1))&&!O(a.charCodeAt(2))){let P=3;const R=P;for(;P<S&&!O(a.charCodeAt(P));P++);if(R!==P&&!O(a.charCodeAt(P+1))){for(P+=1;P<S;P++)if(O(a.charCodeAt(P)))return a.slice(0,P+1).replace(/[\\/]/g,b)}}return b}else if(l(v)&&a.charCodeAt(1)===58)return O(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<S;k++)if(O(a.charCodeAt(k)))return a.slice(0,k+1)}return""}function E(a){if(!N.$i||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let S=2;const v=S;for(;S<a.length&&(b=a.charCodeAt(S),b!==92);S++);return!(v===S||(b=a.charCodeAt(S+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(a,b=N.$i){const S=b?y:w;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||b&&h.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}function p(a,b,S){const v=a===b;return!S||v?v:!a||!b?!1:(0,L.$xf)(a,b)}function g(a,b,S,v=D.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(S){if(!(0,L.$yf)(a,b))return!1;if(b.length===a.length)return!0;let P=b.length;return b.charAt(b.length-1)===v&&P--,a.charAt(P)===v}return b.charAt(b.length-1)!==v&&(b+=v),a.indexOf(b)===0}function l(a){return a>=65&&a<=90||a>=97&&a<=122}function u(a,b){return N.$i&&a.endsWith(":")&&(a+=D.sep),(0,D.$ic)(a)||(a=(0,D.$jc)(b,a)),a=(0,D.$hc)(a),m(a)}function m(a){return N.$i?(a=(0,L.$ff)(a,D.sep),a.endsWith(":")&&(a+=D.sep)):(a=(0,L.$ff)(a,D.sep),a||(a=D.sep)),a}function d(a){const b=(0,D.$hc)(a);return N.$i?a.length>3?!1:$(b)&&(a.length===2||b.charCodeAt(2)===92):b===D.$gc.sep}function $(a,b=N.$i){return b?l(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}function t(a,b=N.$i){return $(a,b)?a[0]:void 0}function r(a,b,S){return b.length>a.length?-1:a===b?0:(S&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}function n(a){const b=a.split(":");let S,v,k;for(const P of b){const R=Number(P);(0,A.$ag)(R)?v===void 0?v=R:k===void 0&&(k=R):S=S?[S,P].join(":"):P}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:v!==void 0?v:void 0,column:k!==void 0?k:v!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(a,b,S=8){let v="";for(let P=0;P<S;P++){let R;P===0&&N.$i&&!b&&(S===3||S===4)?R=i:R=s,v+=R.charAt(Math.floor(Math.random()*R.length))}let k;return b?k=`${b}-${v}`:k=v,a?(0,D.$jc)(a,k):k}}),define(ae[141],ce([0,1,14]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=A,e.$Ss=O,e.$Ts=I,e.$Us=f,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const y=(0,D.$oc)(E),w=N[y.toLowerCase()];return w!==void 0?w:O(E)}function O(E){const y=(0,D.$oc)(E);return L[y.toLowerCase()]}function I(E){for(const y in L)if(L[y]===E)return y}const C=/^(.+)\/(.+?)(;.+)?$/;function f(E,y){const w=C.exec(E);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:y?void 0:E}}),define(ae[89],ce([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=A,e.$nm=O;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(I,...C){const f=C.reduce((w,h)=>(w[h]=!0,w),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(w=>!f[w]).forEach(w=>{for(let h=0;h<E.length;h++)if(w.search(E[h])!==-1){delete I[w];break}})}function O(I){I&&(delete I.DEBUG,D.$j&&delete I.DYLD_LIBRARY_PATH,D.$k&&delete I.LD_PRELOAD)}}),define(ae[8],ce([0,1,14,5]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=c,e.$wc=d;const L=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(s,i){return!s&&!i?"file":s}function f(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const E="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,a,b,S,v=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=C(i,v),this.authority=o||E,this.path=f(this.scheme,a||E),this.query=b||E,this.fragment=S||E,I(this,v))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:b,query:S,fragment:v}=i;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),b===void 0?b=this.path:b===null&&(b=E),S===void 0?S=this.query:S===null&&(S=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&a===this.authority&&b===this.path&&S===this.query&&v===this.fragment?this:new g(o,a,b,S,v)}static parse(i,o=!1){const a=w.exec(i);return a?new g(a[2]||E,n(a[4]||E),n(a[5]||E),n(a[7]||E),n(a[9]||E),o):new g(E,E,E,E,E)}static file(i){let o=E;if(N.$i&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(o=i.substring(2),i=y):(o=i.substring(2,a),i=i.substring(a)||y)}return new g("file",o,i,E,E)}static from(i,o){return new g(i.scheme,i.authority,i.path,i.query,i.fragment,o)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=h.file(D.$fc.join(d(i,!0),...o)).path:a=D.$gc.join(i.path,...o),i.with({path:a})}toString(i=!1){return $(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const o=new g(i);return o._formatted=i.external??null,o._fsPath=i._sep===p?i.fsPath??null:null,o}}else return i}}e.URI=h;function c(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const p=N.$i?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(s,i,o){let a,b=-1;for(let S=0;S<s.length;S++){const v=s.charCodeAt(S);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47||o&&v===91||o&&v===93||o&&v===58)b!==-1&&(a+=encodeURIComponent(s.substring(b,S)),b=-1),a!==void 0&&(a+=s.charAt(S));else{a===void 0&&(a=s.substr(0,S));const k=l[v];k!==void 0?(b!==-1&&(a+=encodeURIComponent(s.substring(b,S)),b=-1),a+=k):b===-1&&(b=S)}}return b!==-1&&(a+=encodeURIComponent(s.substring(b))),a!==void 0?a:s}function m(s){let i;for(let o=0;o<s.length;o++){const a=s.charCodeAt(o);a===35||a===63?(i===void 0&&(i=s.substr(0,o)),i+=l[a]):i!==void 0&&(i+=s[o])}return i!==void 0?i:s}function d(s,i){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,N.$i&&(o=o.replace(/\//g,"\\")),o}function $(s,i){const o=i?m:u;let a="",{scheme:b,authority:S,path:v,query:k,fragment:P}=s;if(b&&(a+=b,a+=":"),(S||b==="file")&&(a+=y,a+=y),S){let R=S.indexOf("@");if(R!==-1){const F=S.substr(0,R);S=S.substr(R+1),R=F.lastIndexOf(":"),R===-1?a+=o(F,!1,!1):(a+=o(F.substr(0,R),!1,!1),a+=":",a+=o(F.substr(R+1),!1,!0)),a+="@"}S=S.toLowerCase(),R=S.lastIndexOf(":"),R===-1?a+=o(S,!1,!0):(a+=o(S.substr(0,R),!1,!0),a+=S.substr(R))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const R=v.charCodeAt(1);R>=65&&R<=90&&(v=`/${String.fromCharCode(R+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const R=v.charCodeAt(0);R>=65&&R<=90&&(v=`${String.fromCharCode(R+32)}:${v.substr(2)}`)}a+=o(v,!0,!1)}return k&&(a+="?",a+=o(k,!1,!1)),P&&(a+="#",a+=i?P:u(P,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(r)?s.replace(r,i=>t(i)):s}}),define(ae[142],ce([0,1,8]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=N,e.$Wq=L,e.$Xq=A,e.log=I;function N(f){const E=f;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function L(f){const E=[];let y;try{const w=JSON.parse(f.arguments),h=w[w.length-1];h&&h.__$stack&&(w.pop(),y=h.__$stack),E.push(...w)}catch{E.push("Unable to log remote console arguments",f.arguments)}return{args:E,stack:y}}function A(f){if(typeof f!="string")return A(L(f).stack);const E=f;if(E){const y=O(E),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:D.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function O(f){if(!f)return f;const E=f.indexOf(`
`);return E===-1?f:f.substring(0,E)}function I(f,E){const{args:y,stack:w}=L(f),h=typeof y[0]=="string"&&y.length===1;let c=O(w);c&&(c=`(${c.trim()})`);let p=[];if(typeof y[0]=="string"?c&&h?p=[`%c[${E}] %c${y[0]} %c${c}`,C("blue"),C(""),C("grey")]:p=[`%c[${E}] %c${y[0]}`,C("blue"),C(""),...y.slice(1)]:p=[`%c[${E}]%`,C("blue"),...y],c&&!h&&p.push(c),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,p)}function C(f){return`color: ${f}`}}),define(ae[66],ce([0,1,15,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=L,e.$5h=A,e.$6h=I;function L(C){return JSON.stringify(C,O)}function A(C){let f=JSON.parse(C);return f=I(f),f}function O(C,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function I(C,f=0){if(!C||f>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof D.$Fe||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let E=0;E<C.length;++E)C[E]=I(C[E],f+1);else for(const E in C)Object.hasOwnProperty.call(C,E)&&(C[E]=I(C[E],f+1))}return C}}),define(ae[23],ce([0,1,7,5,27,8,14]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=C,e.$Gg=f,e.$Kg=y;var I;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(I||(e.Schemas=I={}));function C(c,p){return A.URI.isUri(c)?(0,L.$xf)(c.scheme,p):(0,L.$yf)(c,p+":")}function f(c,...p){return p.some(g=>C(c,g))}e.$Hg="vscode-tkn",e.$Ig="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,g){this.f=y(p,g)}getServerRootPath(){return this.f}get g(){return O.$gc.join(this.f,I.vscodeRemoteResource)}set(p,g,l){this.a[p]=g,this.b[p]=l}setConnectionToken(p,g){this.c[p]=g}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch($){return D.$1($),p}const g=p.authority;let l=this.a[g];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const u=this.b[g],m=this.c[g];let d=`path=${encodeURIComponent(p.path)}`;return typeof m=="string"&&(d+=`&${e.$Ig}=${encodeURIComponent(m)}`),A.URI.from({scheme:N.$o?this.d:I.vscodeRemoteResource,authority:`${l}:${u}`,path:this.g,query:d})}}e.$Jg=new E;function y(c,p){return O.$gc.join(p??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class w{static{this.a=e.$Pg}asBrowserUri(p){const g=this.b(p,ne);return this.uriToBrowserUri(g)}uriToBrowserUri(p){return p.scheme===I.vscodeRemote?e.$Jg.rewrite(p):p.scheme===I.file&&(N.$m||N.$q===`${I.vscodeFileResource}://${w.a}`)?p.with({scheme:I.vscodeFileResource,authority:p.authority||w.a,query:null,fragment:null}):p}asFileUri(p){const g=this.b(p,ne);return this.uriToFileUri(g)}uriToFileUri(p){return p.scheme===I.vscodeFileResource?p.with({scheme:I.file,authority:p.authority!==w.a?p.authority:null,query:null,fragment:null}):p}b(p,g){return A.URI.isUri(p)?p:A.URI.parse(g.toUrl(p))}}e.$Qg=new w;var h;(function(c){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(p.get("3"));const g="vscode-coi";function l(m){let d;typeof m=="string"?d=new URL(m).searchParams:m instanceof URL?d=m.searchParams:A.URI.isUri(m)&&(d=new URL(m.toString(!0)).searchParams);const $=d?.get(g);if($)return p.get($)}c.getHeadersFromQuery=l;function u(m,d,$){if(!globalThis.crossOriginIsolated)return;const t=d&&$?"3":$?"2":"1";m instanceof URLSearchParams?m.set(g,t):m[g]=t}c.addSearchParam=u})(h||(e.COI=h={}))}),define(ae[143],ce([0,1,124,23,5,8]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=E;class O{constructor(w,h,c){this.id=w,this.dependencies=h,this.callback=c}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,h,c)=>{typeof w!="string"&&(c=h,h=w,w=null),(typeof h!="object"||!Array.isArray(h))&&(c=h,h=null),this.c.push(new O(w,h,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const h=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!h)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(w){return new Promise((h,c)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const g=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=m=>{g(),h(this.c.pop())},u=m=>{g(),c(m)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&(w=this.f.createScriptURL(w)),p.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(w){return new Promise((h,c)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),h(this.c.pop())}catch(p){c(p)}})}async j(w){try{const h=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse(w).fsPath,l=h.readFileSync(g).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new c.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const C=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function E(y,w,h){if(D.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[y]&&(y=f[y]);const c=`${y}/${w}`;if(C.has(c))return C.get(c);let p;if(/^\w[\w\d+.-]*:\/\//.test(c))p=c;else{const m=`${h&&!L.$o?N.$Ng:N.$Mg}/${c}`;p=N.$Qg.asBrowserUri(m).toString(!0)}const g=I.INSTANCE.load(p);return C.set(c,g),g}else return await new Promise((c,p)=>{ne([y],c,p)})}}),define(ae[20],ce([0,1,40,23,14,5,27,8]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=C,e.$gh=E,e.$hh=w;function C(h){return(0,I.$wc)(h,!0)}class f{constructor(c){this.a=c}compare(c,p,g=!1){return c===p?0:(0,O.$qf)(this.getComparisonKey(c,g),this.getComparisonKey(p,g))}isEqual(c,p,g=!1){return c===p?!0:!c||!p?!1:this.getComparisonKey(c,g)===this.getComparisonKey(p,g)}getComparisonKey(c,p=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,p,g=!1){if(c.scheme===p.scheme){if(c.scheme===N.Schemas.file)return D.$vg(C(c),C(p),this.a(c))&&c.query===p.query&&(g||c.fragment===p.fragment);if((0,e.$ch)(c.authority,p.authority))return D.$vg(c.path,p.path,this.a(c),"/")&&c.query===p.query&&(g||c.fragment===p.fragment)}return!1}joinPath(c,...p){return I.URI.joinPath(c,...p)}basenameOrAuthority(c){return(0,e.$7g)(c)||c.authority}basename(c){return L.$gc.basename(c.path)}extname(c){return L.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let p;return c.scheme===N.Schemas.file?p=I.URI.file(L.$mc(C(c))).path:(p=L.$gc.dirname(c.path),c.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),p="/")),c.with({path:p})}normalizePath(c){if(!c.path.length)return c;let p;return c.scheme===N.Schemas.file?p=I.URI.file(L.$hc(C(c))).path:p=L.$gc.normalize(c.path),c.with({path:p})}relativePath(c,p){if(c.scheme!==p.scheme||!(0,e.$ch)(c.authority,p.authority))return;if(c.scheme===N.Schemas.file){const u=L.$lc(C(c),C(p));return A.$i?D.$pg(u):u}let g=c.path||"/";const l=p.path||"/";if(this.a(c)){let u=0;for(const m=Math.min(g.length,l.length);u<m&&!(g.charCodeAt(u)!==l.charCodeAt(u)&&g.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);g=l.substr(0,u)+g.substr(u)}return L.$gc.relative(g,l)}resolvePath(c,p){if(c.scheme===N.Schemas.file){const g=I.URI.file(L.$kc(C(c),p));return c.with({authority:g.authority,path:g.path})}return p=D.$qg(p),c.with({path:L.$gc.resolve(c.path,p)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,p){return c===p||c!==void 0&&p!==void 0&&(0,O.$xf)(c,p)}hasTrailingPathSeparator(c,p=L.sep){if(c.scheme===N.Schemas.file){const g=C(c);return g.length>D.$rg(g).length&&g[g.length-1]===p}else{const g=c.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,p=L.sep){return(0,e.$dh)(c,p)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,p=L.sep){let g=!1;if(c.scheme===N.Schemas.file){const l=C(c);g=l!==void 0&&l.length===D.$rg(l).length&&l[l.length-1]===p}else{p="/";const l=c.path;g=l.length===1&&l.charCodeAt(l.length-1)===47}return!g&&!(0,e.$dh)(c,p)?c.with({path:c.path+"/"}):c}}e.$Yg=f,e.$Zg=new f(()=>!1),e.$1g=new f(h=>h.scheme===N.Schemas.file?!A.$k:!0),e.$2g=new f(h=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function E(h,c){const p=[];for(let g=0;g<h.length;g++){const l=c(h[g]);h.some((u,m)=>m===g?!1:(0,e.$4g)(l,c(u)))||p.push(h[g])}return p}var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(p){const g=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(m=>{const[d,$]=m.split(":");d&&$&&g.set(d,$)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&g.set(h.META_DATA_MIME,u),g}h.parseMetaData=c})(y||(e.DataUri=y={}));function w(h,c,p){if(c){let g=h.path;return g&&g[0]!==L.$gc.sep&&(g=L.$gc.sep+g),h.with({scheme:p,authority:c,path:g})}return h.with({scheme:p})}}),define(ae[6],ce([0,1,26,7,3,2,20,5,130,53]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=E,e.$jh=y,e.$kh=w,e.$lh=h,e.$mh=c,e.$nh=p,e.$oh=g,e.$ph=l,e.$xh=o,e.$yh=a,e.$zh=b,e.$Ah=S,e.$Bh=v,e.$Qh=V,e.$Yh=Z;function E(te){return!!te&&typeof te.then=="function"}function y(te){const _=new D.$oe,oe=te(_.token),fe=new Promise(($e,de)=>{const ge=_.token.onCancellationRequested(()=>{ge.dispose(),de(new N.$5)});Promise.resolve(oe).then(be=>{ge.dispose(),_.dispose(),$e(be)},be=>{ge.dispose(),_.dispose(),de(be)})});return new class{cancel(){_.cancel(),_.dispose()}then($e,de){return fe.then($e,de)}catch($e){return this.then(void 0,$e)}finally($e){return fe.finally($e)}}}function w(te,_,oe){return new Promise((fe,$e)=>{const de=_.onCancellationRequested(()=>{de.dispose(),fe(oe)});te.then(fe,$e).finally(()=>de.dispose())})}function h(te,_){return new Promise((oe,fe)=>{const $e=_.onCancellationRequested(()=>{$e.dispose(),fe(new N.$5)});te.then(oe,fe).finally(()=>$e.dispose())})}async function c(te){let _=-1;const oe=te.map((fe,$e)=>fe.then(de=>(_=$e,de)));try{return await Promise.race(oe)}finally{te.forEach((fe,$e)=>{$e!==_&&fe.cancel()})}}function p(te,_,oe){let fe;const $e=setTimeout(()=>{fe?.(void 0),oe?.()},_);return Promise.race([te.finally(()=>clearTimeout($e)),new Promise(de=>fe=de)])}function g(te){return new Promise((_,oe)=>{const fe=te();E(fe)?fe.then(_,oe):_(fe)})}function l(){let te,_;return{promise:new Promise((fe,$e)=>{te=fe,_=$e}),resolve:te,reject:_}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(_){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=_,!this.b){const oe=()=>{if(this.b=null,this.f)return;const fe=this.queue(this.d);return this.d=null,fe};this.b=new Promise(fe=>{this.a.then(oe,oe).then(fe)})}return new Promise((oe,fe)=>{this.b.then(oe,fe)})}return this.a=_(),new Promise((oe,fe)=>{this.a.then($e=>{this.a=null,oe($e)},$e=>{this.a=null,fe($e)})})}dispose(){this.f=!0}}e.$qh=u;class m{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.$rh=m;class d{constructor(){this.a=new Map}queue(_,oe){const $e=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(_)===$e&&this.a.delete(_)});return this.a.set(_,$e),$e}}e.$sh=d;const $=(te,_)=>{let oe=!0;const fe=setTimeout(()=>{oe=!1,_()},te);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(fe),oe=!1}}},t=te=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,te())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};class r{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,oe=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise(($e,de)=>{this.d=$e,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const fe=()=>{this.a=null,this.d?.(null)};return this.a=oe===C.$ae?t(fe):$(oe,fe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=r;class n{constructor(_){this.a=new r(_),this.b=new u}trigger(_,oe){return this.a.trigger(()=>this.b.queue(_),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=n;class s{constructor(){this.a=!1,this.b=new Promise((_,oe)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=s;class i extends s{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.$wh=i;function o(te,_){return _?new Promise((oe,fe)=>{const $e=setTimeout(()=>{de.dispose(),oe()},te),de=_.onCancellationRequested(()=>{clearTimeout($e),de.dispose(),fe(new N.$5)})}):y(oe=>o(te,oe))}function a(te,_=0,oe){const fe=setTimeout(()=>{te(),oe&&$e.dispose()},_),$e=(0,A.$Sc)(()=>{clearTimeout(fe),oe?.deleteAndLeak($e)});return oe?.add($e),$e}function b(te){const _=[];let oe=0;const fe=te.length;function $e(){return oe<fe?te[oe++]():null}function de(ge){ge!=null&&_.push(ge);const be=$e();return be?be.then(de):Promise.resolve(_)}return Promise.resolve(null).then(de)}function S(te,_=fe=>!!fe,oe=null){let fe=0;const $e=te.length,de=()=>{if(fe>=$e)return Promise.resolve(oe);const ge=te[fe++];return Promise.resolve(ge()).then(Ee=>_(Ee)?Promise.resolve(Ee):de())};return de()}function v(te,_=fe=>!!fe,oe=null){if(te.length===0)return Promise.resolve(oe);let fe=te.length;const $e=()=>{fe=-1;for(const de of te)de.cancel?.()};return new Promise((de,ge)=>{for(const be of te)be.then(Ee=>{--fe>=0&&_(Ee)?($e(),de(Ee)):fe===0&&de(oe)}).catch(Ee=>{--fe>=0&&($e(),ge(Ee))})})}class k{constructor(_){this.a=0,this.b=!1,this.f=_,this.g=[],this.d=0,this.h=new L.$de}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(_){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,fe)=>{this.g.push({factory:_,c:oe,e:fe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const _=this.g.shift();this.d++;const oe=_.factory();oe.then(_.c,_.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=k;class P extends k{constructor(){super(1)}}e.$Dh=P;class R{constructor(){this.a=new ie,this.b=0}queue(_){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,_())):this.a.run(this.b++,_())}}e.$Eh=R;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const _=new ee;return this.b.add(_),_.p}g(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueSize(_,oe=O.$Zg){const fe=oe.getComparisonKey(_);return this.a.get(fe)?.size??0}queueFor(_,oe,fe=O.$Zg){const $e=fe.getComparisonKey(_);let de=this.a.get($e);if(!de){de=new P;const ge=this.f++,be=L.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(ge,be),this.a.set($e,de)}return de.queue(oe)}h(){this.g()&&this.j()}j(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=F;class T{constructor(_,oe){this.a=-1,typeof _=="function"&&typeof oe=="number"&&this.setIfNotSet(_,oe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,oe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},oe)}setIfNotSet(_,oe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},oe))}}e.$Gh=T;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(_,oe,fe=globalThis){this.cancel();const $e=fe.setInterval(()=>{_()},oe);this.d=(0,A.$Sc)(()=>{fe.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=q;class Y{constructor(_,oe){this.b=-1,this.a=_,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=Y;class J{constructor(_,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=_,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=J;class X extends Y{constructor(_,oe){super(_,oe),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.$Kh=X;class H extends A.$Uc{constructor(_,oe){super(),this.g=_,this.h=oe,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of _)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(te,_)=>{(0,I.$B)(()=>{if(oe)return;const fe=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Nh=(te,_,oe)=>{const fe=te.requestIdleCallback(_,typeof oe=="number"?{timeout:oe}:void 0);let $e=!1;return{dispose(){$e||($e=!0,te.cancelIdleCallback(fe))}}},e.$Mh=te=>(0,e.$Nh)(globalThis,te)}();class K{constructor(_,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(fe){this.l=fe}finally{this.g=!0}},this.f=(0,e.$Nh)(_,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=K;class G extends K{constructor(_){super(globalThis,_)}}e.$Ph=G;async function V(te,_,oe){let fe;for(let $e=0;$e<oe;$e++)try{return await te()}catch(de){fe=de,await o(_)}throw fe}class ie{isRunning(_){return typeof _=="number"?this.a?.taskId===_:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(_,oe,fe){return this.a={taskId:_,cancel:()=>fe?.(),promise:oe},oe.then(()=>this.d(_),()=>this.d(_)),oe}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}queue(_){if(this.b)this.b.run=_;else{const{promise:oe,resolve:fe,reject:$e}=l();this.b={run:_,promise:oe,promiseResolve:fe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=ie;class se{constructor(_,oe=()=>Date.now()){this.d=_,this.f=oe,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.$Sh=se;var he;(function(te){te[te.Resolved=0]="Resolved",te[te.Rejected=1]="Rejected"})(he||(he={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((_,oe)=>{this.a=_,this.b=oe})}complete(_){return new Promise(oe=>{this.a(_),this.d={outcome:0,value:_},oe()})}error(_){return new Promise(oe=>{this.b(_),this.d={outcome:1,value:_},oe()})}cancel(){return this.error(new N.$5)}}e.$Th=ee;var W;(function(te){async function _(fe){let $e;const de=await Promise.all(fe.map(ge=>ge.then(be=>be,be=>{$e||($e=be)})));if(typeof $e<"u")throw $e;return de}te.settled=_;function oe(fe){return new Promise(async($e,de)=>{try{await fe($e,de)}catch(ge){de(ge)}})}te.withAsyncBody=oe})(W||(e.Promises=W={}));class B{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(_){this.a=void 0,this.b=void 0,this.d=!1,this.promise=_.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=B;class j{constructor(_){this.b=_,this.a=new f.$V(()=>new B(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=j;var M;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(M||(M={}));class z{static fromArray(_){return new z(oe=>{oe.emitMany(_)})}static fromPromise(_){return new z(async oe=>{oe.emitMany(await _)})}static fromPromises(_){return new z(async oe=>{await Promise.all(_.map(async fe=>oe.emitOne(await fe)))})}static merge(_){return new z(async oe=>{await Promise.all(_.map(async fe=>{for await(const $e of fe)oe.emitOne($e)}))})}static{this.EMPTY=z.fromArray([])}constructor(_,oe){this.a=0,this.b=[],this.d=null,this.f=oe,this.g=new L.$de,queueMicrotask(async()=>{const fe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(_(fe)),this.k()}catch($e){this.l($e)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(_,oe){return new z(async fe=>{for await(const $e of _)fe.emitOne(oe($e))})}map(_){return z.map(this,_)}static filter(_,oe){return new z(async fe=>{for await(const $e of _)oe($e)&&fe.emitOne($e)})}filter(_){return z.filter(this,_)}static coalesce(_){return z.filter(_,oe=>!!oe)}coalesce(){return z.coalesce(this)}static async toPromise(_){const oe=[];for await(const fe of _)oe.push(fe);return oe}toPromise(){return z.toPromise(this)}h(_){this.a===0&&(this.b.push(_),this.g.fire())}j(_){this.a===0&&(this.b=this.b.concat(_),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(_){this.a===0&&(this.a=2,this.d=_,this.g.fire())}}e.$Wh=z;class U extends z{constructor(_,oe){super(oe),this.m=_}cancel(){this.m.cancel()}}e.$Xh=U;function Z(te){const _=new D.$oe,oe=te(_.token);return new U(_,async fe=>{const $e=_.token.onCancellationRequested(()=>{$e.dispose(),_.dispose(),fe.reject(new N.$5)});try{for await(const de of oe){if(_.token.isCancellationRequested)return;fe.emitOne(de)}$e.dispose(),_.dispose()}catch(de){$e.dispose(),_.dispose(),fe.reject(de)}})}class x{constructor(_){this.a=new ee,this.b=new z($e=>{if(oe){$e.reject(oe);return}return fe&&$e.emitMany(fe),this.d=de=>$e.reject(de),this.f=de=>$e.emitOne(de),this.a.p},_);let oe,fe;this.f=$e=>{fe||(fe=[]),fe.push($e)},this.d=$e=>{oe||(oe=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(_){this.d(_),this.a.complete()}emitOne(_){this.f(_)}}e.$Zh=x}),define(ae[90],ce([0,1,17,6,40,34,14,5,27]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=f,e.$ok=c,e.$pk=P,e.$qk=R,e.$rk=F,e.$sk=T,e.$tk=q,e.$uk=H;function f(){return Object.create(null)}e.$mk="**",e.$nk="/";const E="[/\\\\]",y="[^/\\\\]",w=/\//g;function h(K,G){switch(K){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${G?`|${E}${y}+`:""})*?`}}function c(K,G){if(!K)return[];const V=[];let ie=!1,se=!1,he="";for(const ee of K){switch(ee){case G:if(!ie&&!se){V.push(he),he="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":se=!0;break;case"]":se=!1;break}he+=ee}return he&&V.push(he),V}function p(K){if(!K)return"";let G="";const V=c(K,e.$nk);if(V.every(ie=>ie===e.$mk))G=".*";else{let ie=!1;V.forEach((se,he)=>{if(se===e.$mk){if(ie)return;G+=h(2,he===V.length-1)}else{let ee=!1,W="",B=!1,j="";for(const M of se){if(M!=="}"&&ee){W+=M;continue}if(B&&(M!=="]"||!j)){let z;M==="-"?z=M:(M==="^"||M==="!")&&!j?z="^":M===e.$nk?z="":z=(0,C.$_e)(M),j+=z;continue}switch(M){case"{":ee=!0;continue;case"[":B=!0;continue;case"}":{const U=`(?:${c(W,",").map(Z=>p(Z)).join("|")})`;G+=U,ee=!1,W="";break}case"]":{G+="["+j+"]",B=!1,j="";break}case"?":G+=y;continue;case"*":G+=h(1);continue;default:G+=(0,C.$_e)(M)}}he<V.length-1&&(V[he+1]!==e.$mk||he+2<V.length)&&(G+=E)}ie=se===e.$mk})}return G}const g=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),r=function(){return!1},n=function(){return null};function s(K,G){if(!K)return n;let V;typeof K!="string"?V=K.pattern:V=K,V=V.trim();const ie=`${V}_${!!G.trimForExclusions}`;let se=t.get(ie);if(se)return i(se,K);let he;return g.test(V)?se=a(V.substr(4),V):(he=l.exec(o(V,G)))?se=b(he[1],V):(G.trimForExclusions?m:u).test(V)?se=S(V,G):(he=d.exec(o(V,G)))?se=v(he[1].substr(1),V,!0):(he=$.exec(o(V,G)))?se=v(he[1],V,!1):se=k(V),t.set(ie,se),i(se,K)}function i(K,G){if(typeof G=="string")return K;const V=function(ie,se){return(0,L.$vg)(ie,G.base,!I.$k)?K((0,C.$ef)(ie.substr(G.base.length),O.sep),se):null};return V.allBasenames=K.allBasenames,V.allPaths=K.allPaths,V.basenames=K.basenames,V.patterns=K.patterns,V}function o(K,G){return G.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,G){return function(V,ie){return typeof V=="string"&&V.endsWith(K)?G:null}}function b(K,G){const V=`/${K}`,ie=`\\${K}`,se=function(ee,W){return typeof ee!="string"?null:W?W===K?G:null:ee===K||ee.endsWith(V)||ee.endsWith(ie)?G:null},he=[K];return se.basenames=he,se.patterns=[G],se.allBasenames=he,se}function S(K,G){const V=X(K.slice(1,-1).split(",").map(W=>s(W,G)).filter(W=>W!==n),K),ie=V.length;if(!ie)return n;if(ie===1)return V[0];const se=function(W,B){for(let j=0,M=V.length;j<M;j++)if(V[j](W,B))return K;return null},he=V.find(W=>!!W.allBasenames);he&&(se.allBasenames=he.allBasenames);const ee=V.reduce((W,B)=>B.allPaths?W.concat(B.allPaths):W,[]);return ee.length&&(se.allPaths=ee),se}function v(K,G,V){const ie=O.sep===O.$gc.sep,se=ie?K:K.replace(w,O.sep),he=O.sep+se,ee=O.$gc.sep+K;let W;return V?W=function(B,j){return typeof B=="string"&&(B===se||B.endsWith(he)||!ie&&(B===K||B.endsWith(ee)))?G:null}:W=function(B,j){return typeof B=="string"&&(B===se||!ie&&B===K)?G:null},W.allPaths=[(V?"*/":"./")+K],W}function k(K){try{const G=new RegExp(`^${p(K)}$`);return function(V){return G.lastIndex=0,typeof V=="string"&&G.test(V)?K:null}}catch{return n}}function P(K,G,V){return!K||typeof G!="string"?!1:R(K)(G,void 0,V)}function R(K,G={}){if(!K)return r;if(typeof K=="string"||F(K)){const V=s(K,G);if(V===n)return r;const ie=function(se,he){return!!V(se,he)};return V.allBasenames&&(ie.allBasenames=V.allBasenames),V.allPaths&&(ie.allPaths=V.allPaths),ie}return Y(K,G)}function F(K){const G=K;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function T(K){return K.allBasenames||[]}function q(K){return K.allPaths||[]}function Y(K,G){const V=X(Object.getOwnPropertyNames(K).map(W=>J(W,K[W],G)).filter(W=>W!==n)),ie=V.length;if(!ie)return n;if(!V.some(W=>!!W.requiresSiblings)){if(ie===1)return V[0];const W=function(M,z){let U;for(let Z=0,x=V.length;Z<x;Z++){const te=V[Z](M,z);if(typeof te=="string")return te;(0,N.$ih)(te)&&(U||(U=[]),U.push(te))}return U?(async()=>{for(const Z of U){const x=await Z;if(typeof x=="string")return x}return null})():null},B=V.find(M=>!!M.allBasenames);B&&(W.allBasenames=B.allBasenames);const j=V.reduce((M,z)=>z.allPaths?M.concat(z.allPaths):M,[]);return j.length&&(W.allPaths=j),W}const se=function(W,B,j){let M,z;for(let U=0,Z=V.length;U<Z;U++){const x=V[U];x.requiresSiblings&&j&&(B||(B=(0,O.$nc)(W)),M||(M=B.substr(0,B.length-(0,O.$oc)(W).length)));const te=x(W,B,M,j);if(typeof te=="string")return te;(0,N.$ih)(te)&&(z||(z=[]),z.push(te))}return z?(async()=>{for(const U of z){const Z=await U;if(typeof Z=="string")return Z}return null})():null},he=V.find(W=>!!W.allBasenames);he&&(se.allBasenames=he.allBasenames);const ee=V.reduce((W,B)=>B.allPaths?W.concat(B.allPaths):W,[]);return ee.length&&(se.allPaths=ee),se}function J(K,G,V){if(G===!1)return n;const ie=s(K,V);if(ie===n)return n;if(typeof G=="boolean")return ie;if(G){const se=G.when;if(typeof se=="string"){const he=(ee,W,B,j)=>{if(!j||!ie(ee,W))return null;const M=se.replace("$(basename)",()=>B),z=j(M);return(0,N.$ih)(z)?z.then(U=>U?K:null):z?K:null};return he.requiresSiblings=!0,he}}return ie}function X(K,G){const V=K.filter(W=>!!W.basenames);if(V.length<2)return K;const ie=V.reduce((W,B)=>{const j=B.basenames;return j?W.concat(j):W},[]);let se;if(G){se=[];for(let W=0,B=ie.length;W<B;W++)se.push(G)}else se=V.reduce((W,B)=>{const j=B.patterns;return j?W.concat(j):W},[]);const he=function(W,B){if(typeof W!="string")return null;if(!B){let M;for(M=W.length;M>0;M--){const z=W.charCodeAt(M-1);if(z===47||z===92)break}B=W.substr(M)}const j=ie.indexOf(B);return j!==-1?se[j]:null};he.basenames=ie,he.patterns=se,he.allBasenames=ie;const ee=K.filter(W=>!W.basenames);return ee.push(he),ee}function H(K,G){return(0,D.$ub)(K,G,(V,ie)=>typeof V=="string"&&typeof ie=="string"?V===ie:typeof V!="string"&&typeof ie!="string"?V.base===ie.base&&V.pattern===ie.pattern:!1)}}),define(ae[91],ce([0,1,15,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=I,e.$Bn=f,e.$Cn=E;function L(y){return y.toJSON()}class A{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:L(N.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:L(N.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:N.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$yn=A,e.$zn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function O(y,w,h){if(!y||h>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return w.transformOutgoing(y);for(const c in y)if(Object.hasOwnProperty.call(y,c)){const p=O(y[c],w,h+1);p!==null&&(y[c]=p)}}return null}function I(y,w){const h=O(y,w,0);return h===null?y:h}function C(y,w,h,c){if(!y||c>200)return null;if(typeof y=="object"){if(y.$mid===1)return h?N.URI.revive(w.transformIncoming(y)):w.transformIncoming(y);if(y instanceof D.$Fe)return null;for(const p in y)if(Object.hasOwnProperty.call(y,p)){const g=C(y[p],w,h,c+1);g!==null&&(y[p]=g)}}return null}function f(y,w){const h=C(y,w,!1,0);return h===null?y:h}function E(y,w){const h=C(y,w,!0,0);return h===null?y:h}}),define(ae[144],ce([0,1,37,51,32,131,5]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$Fn=C,e.$Gn=y,e.$En=new class{c(w){return this.a||(this.a=N.$Ci.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,h=0;const c=(0,D.networkInterfaces)();for(const p in c){const g=c[p];if(g)for(const{mac:l,internal:u}of g)u||(h+=1,this.c(l.toUpperCase())&&(w+=1))}this.b=h>0?w/h:0}return this.b}};let I;async function C(w){return I||(I=(async()=>await f(w)||L.$Sg())()),I}async function f(w){try{const h=await new Promise((p,g)=>{ne(["crypto"],p,g)}),c=(0,A.$Dn)();return h.createHash("sha256").update(c,"utf8").digest("hex")}catch(h){w(h);return}}const E="Software\\Microsoft\\SQMClient";async function y(w){if(O.$i){const h=await new Promise((c,p)=>{ne(["@vscode/windows-registry"],c,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(c){return w(c),""}}return""}}),define(ae[145],ce([0,1,41,146,14,36]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2W=E,e.$3W=y;const O="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",C="XDG_RUNTIME_DIR";var f;(function(w){w.Wayland="wayland",w.XWayland="xwayland",w.X11="x11",w.Unknown="unknown"})(f||(f={}));async function E(w){const h=A.env[O];if(h)return h==="wayland"||h==="x11"?h:"unknown";if(A.env[I]){const p=A.env[C];if(p){const g=(0,L.$jc)(p,"wayland-0");try{return await(0,N.access)(g,D.constants.R_OK),"wayland"}catch(l){return w(l),"unknown"}}else return"unknown"}else return"x11"}function y(w,h){if(h)switch(h){case"auto":return w;case"x11":return w==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return w==="wayland"?"xwayland":"x11"}}),define(ae[147],ce([0,1,41,146,274,5]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=O;async function O(I){if(A.$j||A.$i)return;let C;for(const f of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{C=await(0,N.open)(f,D.constants.R_OK);break}catch{}if(!C){I("Unable to retrieve release information from known identifier paths.");return}try{const f=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,L.createInterface)({input:C.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const w=y.split("=")[0].toUpperCase().trim();if(f.has(w)){const h=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?E.id=h:w==="ID_LIKE"?E.id_like=h:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(E.version_id=h)}}return E}catch(f){I(f)}}}),define(ae[31],ce([0,1,41,37,275,6,40,87,14,5,20,8]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=b;var w;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function h(J,X=w.UNLINK,H){if((0,O.$zg)(J))throw new Error("rimraf - will refuse to recursively delete root");return X===w.UNLINK?p(J):c(J,H)}async function c(J,X=(0,O.$Eg)((0,N.tmpdir)())){try{try{await D.promises.rename(J,X)}catch(H){return H.code==="ENOENT"?void 0:p(J)}p(X).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function p(J){return(0,L.promisify)(D.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function g(J){if((0,O.$zg)(J))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}async function l(J,X){return d(await(X?u(J):(0,L.promisify)(D.readdir)(J)))}async function u(J){try{return await(0,L.promisify)(D.readdir)(J,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const X=[],H=await l(J);for(const K of H){let G=!1,V=!1,ie=!1;try{const se=await e.Promises.lstat((0,C.$jc)(J,K));G=se.isFile(),V=se.isDirectory(),ie=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}X.push({name:K,isFile:()=>G,isDirectory:()=>V,isSymbolicLink:()=>ie})}return X}function m(J){return d(D.readdirSync(J))}function d(J){return J.map(X=>typeof X=="string"?f.$j?(0,I.$bm)(X):X:(X.name=f.$j?(0,I.$bm)(X.name):X.name,X))}async function $(J){const X=await l(J),H=[];for(const K of X)await r.existsDirectory((0,C.$jc)(J,K))&&H.push(K);return H}function t(J,X=1e3){return new Promise(H=>{let K=!1;const G=setInterval(()=>{K||(K=!0,D.access(J,V=>{K=!1,V&&(clearInterval(G),H(void 0))}))},X)})}var r;(function(J){async function X(G){let V;try{if(V=await e.Promises.lstat(G),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(f.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw se}throw ie}}J.stat=X;async function H(G){try{const{stat:V,symbolicLink:ie}=await J.stat(G);return V.isFile()&&ie?.dangling!==!0}catch{}return!1}J.existsFile=H;async function K(G){try{const{stat:V,symbolicLink:ie}=await J.stat(G);return V.isDirectory()&&ie?.dangling!==!0}catch{}return!1}J.existsDirectory=K})(r||(e.SymlinkSupport=r={}));const n=new A.$Fh;function s(J,X,H){return n.queueFor(y.URI.file(J),()=>{const K=S(H);return new Promise((G,V)=>a(J,X,K,ie=>ie?V(ie):G()))},E.$1g)}let i=!0;function o(J){i=J}function a(J,X,H,K){if(!i)return D.writeFile(J,X,{mode:H.mode,flag:H.flag},K);D.open(J,H.flag,H.mode,(G,V)=>{if(G)return K(G);D.writeFile(V,X,ie=>{if(ie)return D.close(V,()=>K(ie));D.fdatasync(V,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),o(!1)),D.close(V,he=>K(he))))})})}function b(J,X,H){const K=S(H);if(!i)return D.writeFileSync(J,X,{mode:K.mode,flag:K.flag});const G=D.openSync(J,K.flag,K.mode);try{D.writeFileSync(G,X);try{D.fdatasyncSync(G)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),o(!1)}}finally{D.closeSync(G)}}function S(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function v(J,X,H=6e4){if(J!==X)try{f.$i&&typeof H=="number"?await k(J,X,Date.now(),H):await(0,L.promisify)(D.rename)(J,X)}catch(K){if(J.toLowerCase()!==X.toLowerCase()&&K.code==="EXDEV"||J.endsWith("."))await P(J,X,{preserveSymlinks:!1}),await h(J,w.MOVE);else throw K}}async function k(J,X,H,K,G=0){try{return await(0,L.promisify)(D.rename)(J,X)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-H>=K)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${V}`),V;if(G===0){let ie=!1;try{const{stat:se}=await r.stat(X);se.isFile()||(ie=!0)}catch{}if(ie)throw V}return await(0,A.$xh)(Math.min(100,G*10)),k(J,X,H,K,G+1)}}async function P(J,X,H){return F(J,X,{root:{source:J,target:X},options:H,handledSourcePaths:new Set})}const R=511;async function F(J,X,H){if(H.handledSourcePaths.has(J))return;H.handledSourcePaths.add(J);const{stat:K,symbolicLink:G}=await r.stat(J);if(G){if(H.options.preserveSymlinks)try{return await Y(J,X,H)}catch{}if(G.dangling)return}return K.isDirectory()?T(J,X,K.mode&R,H):q(J,X,K.mode&R)}async function T(J,X,H,K){await e.Promises.mkdir(X,{recursive:!0,mode:H});const G=await l(J);for(const V of G)await F((0,C.$jc)(J,V),(0,C.$jc)(X,V),K)}async function q(J,X,H){await e.Promises.copyFile(J,X),await e.Promises.chmod(X,H)}async function Y(J,X,H){let K=await e.Promises.readlink(J);(0,O.$vg)(K,H.root.source,!f.$k)&&(K=(0,C.$jc)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,X)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(J,X,H,K,G)=>new Promise((V,ie)=>{D.read(J,X,H,K,G,(se,he,ee)=>se?ie(se):V({bytesRead:he,buffer:ee}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(J,X,H,K,G)=>new Promise((V,ie)=>{D.write(J,X,H,K,G,(se,he,ee)=>se?ie(se):V({bytesWritten:he,buffer:ee}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return $}get writeFile(){return s}get rm(){return h}get rename(){return v}get copy(){return P}}}),define(ae[148],ce([0,1,41,14,5,27,31]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=I,e.$5q=C,e.$6q=f,e.$7q=E;function I(w){if(L.$k)return w;const h=(0,N.$mc)(w);if(w===h)return w;const c=((0,N.$nc)(w)||w).toLowerCase();try{const g=(0,O.readdirSync)(h).filter(l=>l.toLowerCase()===c);if(g.length===1){const l=I(h);if(l)return(0,N.$jc)(l,g[0])}else if(g.length>1){const l=g.indexOf(c);if(l>=0){const u=I(h);if(u)return(0,N.$jc)(u,g[l])}}}catch{}return null}async function C(w,h){if(L.$k)return w;const c=(0,N.$mc)(w);if(w===c)return w;const p=((0,N.$nc)(w)||w).toLowerCase();try{if(h?.isCancellationRequested)return null;const l=(await O.Promises.readdir(c)).filter(u=>u.toLowerCase()===p);if(l.length===1){const u=await C(c,h);if(u)return(0,N.$jc)(u,l[0])}else if(l.length>1){const u=l.indexOf(p);if(u>=0){const m=await C(c,h);if(m)return(0,N.$jc)(m,l[u])}}}catch{}return null}async function f(w){try{return await O.Promises.realpath(w)}catch{const c=y(w);return await O.Promises.access(c,D.constants.R_OK),c}}function E(w){try{return D.realpathSync(w)}catch{const c=y(w);return D.accessSync(c,D.constants.R_OK),c}}function y(w){return(0,A.$ff)((0,N.$hc)(w),N.sep)}}),define(ae[149],ce([0,1,14,5,36,89,13,31]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=C,e.$pm=f,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function C(y=L.env){return y.comspec||"cmd.exe"}function f(y){let w=[],h=!1;const c=function(p){if(h){w.push(p);return}(!y.send(p,l=>{if(l&&console.error(l),h=!1,w.length>0){const u=w.slice(0);w=[],u.forEach(m=>c(m))}})||N.$i)&&(h=!0)};return{send:c}}var E;(function(y){async function w(h,c,p){if(D.$ic(h))return h;if(c===void 0&&(c=L.cwd()),D.$mc(h)!=="."||(p===void 0&&O.$9f(L.env.PATH)&&(p=L.env.PATH.split(D.$tc)),p===void 0||p.length===0))return D.$jc(c,h);async function l(u){if(await I.Promises.exists(u)){let m;try{m=await I.Promises.stat(u)}catch(d){d.message.startsWith("EACCES")&&(m=await I.Promises.lstat(u))}return m?!m.isDirectory():!1}return!1}for(const u of p){let m;if(D.$ic(u)?m=D.$jc(u,h):m=D.$jc(c,u,h),await l(m))return m;let d=m+".com";if(await l(d)||(d=m+".exe",await l(d)))return d}return D.$jc(c,h)}y.findExecutable=w})(E||(e.win32=E={}))}),define(ae[150],ce([0,1,67,23]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=L;function L(O){return new Promise((I,C)=>{let f;const E=new Map;function y(h,c,p,g,l){const u=E.get(c);if(h===O||u){const m={name:w(p),cmd:p,pid:h,ppid:c,load:g,mem:l};E.set(h,m),h===O&&(f=m),u&&(u.children||(u.children=[]),u.children.push(m),u.children.length>1&&(u.children=u.children.sort((d,$)=>d.pid-$.pid)))}}function w(h){const c=/--utility-sub-type=network/i,p=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let m=u.exec(h);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?c.exec(h)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const d=/[a-zA-Z-]+\.js/g;let $="";do m=d.exec(h),m&&($+=m+" ");while(m);return $&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${$})`:h}if(process.platform==="win32"){const h=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,p)=>{ne(["@vscode/windows-process-tree"],c,p)}).then(c=>{c.getProcessList(O,p=>{if(!p){C(new Error(`Root process ${O} not found`));return}c.getProcessCpuUsage(p,g=>{const l=new Map;g.forEach(u=>{const m=h(u.commandLine||"");l.set(u.pid,{name:w(m),cmd:m,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),f=l.get(O),f?(l.forEach(u=>{const m=l.get(u.ppid);m&&(m.children||(m.children=[]),m.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((m,d)=>m.pid-d.pid))}),I(f)):C(new Error(`Root process ${O} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let h=function(){let c=[f];const p=[];for(;c.length;){const l=c.shift();l&&(p.push(l.pid),l.children&&(c=c.concat(l.children)))}let g=JSON.stringify(N.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+p.join(" "),(0,D.exec)(g,{},(l,u,m)=>{if(l||m)C(l||new Error(m.toString()));else{const d=u.toString().split(`
`);for(let $=0;$<p.length;$++){const t=E.get(p[$]);t.load=parseFloat(d[$])}if(!f){C(new Error(`Root process ${O} not found`));return}I(f)}})};(0,D.exec)("which ps",{},(c,p,g)=>{if(c||g)if(process.platform!=="linux")C(c||new Error(g.toString()));else{const l=JSON.stringify(N.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(u,m,d)=>{u||d?C(u||new Error(d.toString())):(A(m,y),h())})}else{const l=p.toString().trim();(0,D.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,d,$)=>{m||$&&!$.includes("screen size is bogus")?C(m||new Error($.toString())):(A(d,y),process.platform==="linux"?h():f?I(f):C(new Error(`Root process ${O} not found`)))})}})}})}function A(O,I){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=O.toString().split(`
`);for(const E of f){const y=C.exec(E.trim());y&&y.length===6&&I(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}});var ve=this&&this.__decorate||function(ne,e,D,N){var L=arguments.length,A=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,D,N);else for(var I=ne.length-1;I>=0;I--)(O=ne[I])&&(A=(L<3?O(A):L>3?O(e,D,A):O(e,D))||A);return L>3&&A&&Object.defineProperty(e,D,A),A};define(ae[42],ce([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=o,e.$0h=a,e.$ci=R,e.$di=F;var h;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(h||(h={}));function c(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(p||(p={}));function g(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(l||(l={}));function u(G){let V=0;for(let ie=0;;ie+=7){const se=G.read(1);if(V|=(se.buffer[0]&127)<<ie,!(se.buffer[0]&128))return V}}const m=n(0);function d(G,V){if(V===0){G.write(m);return}let ie=0;for(let he=V;he!==0;he=he>>>7)ie++;const se=L.$Fe.alloc(ie);for(let he=0;V!==0;he++)se.buffer[he]=V&127,V=V>>>7,V>0&&(se.buffer[he]|=128);G.write(se)}class ${constructor(V){this.b=V,this.a=0}read(V){const ie=this.b.slice(this.a,this.a+V);return this.a+=ie.byteLength,ie}}e.$7h=$;class t{constructor(){this.a=[]}get buffer(){return L.$Fe.concat(this.a)}write(V){this.a.push(V)}}e.$8h=t;var r;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(r||(r={}));function n(G){const V=L.$Fe.alloc(1);return V.writeUInt8(G,0),V}const s={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},i=typeof Buffer<"u";function o(G,V){if(typeof V>"u")G.write(s.Undefined);else if(typeof V=="string"){const ie=L.$Fe.fromString(V);G.write(s.String),d(G,ie.byteLength),G.write(ie)}else if(i&&Buffer.isBuffer(V)){const ie=L.$Fe.wrap(V);G.write(s.Buffer),d(G,ie.byteLength),G.write(ie)}else if(V instanceof L.$Fe)G.write(s.VSBuffer),d(G,V.byteLength),G.write(V);else if(Array.isArray(V)){G.write(s.Array),d(G,V.length);for(const ie of V)o(G,ie)}else if(typeof V=="number"&&(V|0)===V)G.write(s.Uint),d(G,V);else{const ie=L.$Fe.fromString(JSON.stringify(V));G.write(s.Object),d(G,ie.byteLength),G.write(ie)}}function a(G){switch(G.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return G.read(u(G)).toString();case r.Buffer:return G.read(u(G)).buffer;case r.VSBuffer:return G.read(u(G));case r.Array:{const ie=u(G),se=[];for(let he=0;he<ie;he++)se.push(a(G));return se}case r.Object:return JSON.parse(G.read(u(G)).toString());case r.Int:return u(G)}}class b{constructor(V,ie,se=null,he=1e3){this.h=V,this.j=ie,this.k=se,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:200})}registerChannel(V,ie){this.b.set(V,ie),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const ie=this.o([V.type]);this.k?.logOutgoing(ie,0,1,g(V.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ie,V.id,1,g(V.type),V.data);return}}}o(V,ie=void 0){const se=new t;return o(se,V),o(se,ie),this.p(se.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ie=new $(V),se=a(ie),he=a(ie),ee=se[0];switch(ee){case 100:return this.k?.logIncoming(V.byteLength,se[1],1,`${c(ee)}: ${se[2]}.${se[3]}`,he),this.s({type:ee,id:se[1],channelName:se[2],name:se[3],arg:he});case 102:return this.k?.logIncoming(V.byteLength,se[1],1,`${c(ee)}: ${se[2]}.${se[3]}`,he),this.t({type:ee,id:se[1],channelName:se[2],name:se[3],arg:he});case 101:return this.k?.logIncoming(V.byteLength,se[1],1,`${c(ee)}`),this.u({type:ee,id:se[1]});case 103:return this.k?.logIncoming(V.byteLength,se[1],1,`${c(ee)}`),this.u({type:ee,id:se[1]})}}s(V){const ie=this.b.get(V.channelName);if(!ie){this.v(V);return}const se=new A.$oe;let he;try{he=ie.call(this.j,V.name,V.arg,se.token)}catch(B){he=Promise.reject(B)}const ee=V.id;he.then(B=>{this.m({id:ee,data:B,type:201})},B=>{B instanceof Error?this.m({id:ee,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:ee,data:B,type:203})}).finally(()=>{W.dispose(),this.d.delete(V.id)});const W=(0,f.$Sc)(()=>se.cancel());this.d.set(V.id,W)}t(V){const ie=this.b.get(V.channelName);if(!ie){this.v(V);return}const se=V.id,ee=ie.listen(this.j,V.name,V.arg)(W=>this.m({id:se,data:W,type:204}));this.d.set(V.id,ee)}u(V){const ie=this.d.get(V.id);ie&&(ie.dispose(),this.d.delete(V.id))}v(V){let ie=this.g.get(V.channelName);ie||(ie=[],this.g.set(V.channelName,ie));const se=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:V,timeoutTimer:se})}w(V){const ie=this.g.get(V);if(ie){for(const se of ie)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Pc)(this.d.values()),this.d.clear()}}e.$$h=b;var S;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class v{constructor(V,ie=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$de,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=ie}getChannel(V){const ie=this;return{call(se,he,ee){return ie.a?Promise.reject(new I.$5):ie.m(V,se,he,ee)},listen(se,he){return ie.a?C.Event.None:ie.o(V,se,he)}}}m(V,ie,se,he=A.CancellationToken.None){const ee=this.g++,B={id:ee,type:100,channelName:V,name:ie,arg:se};if(he.isCancellationRequested)return Promise.reject(new I.$5);let j;return new Promise((z,U)=>{if(he.isCancellationRequested)return U(new I.$5);const Z=()=>{const oe=fe=>{switch(fe.type){case 201:this.f.delete(ee),z(fe.data);break;case 202:{this.f.delete(ee);const $e=new Error(fe.data.message);$e.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,$e.name=fe.data.name,U($e);break}case 203:this.f.delete(ee),U(fe.data);break}};this.f.set(ee,oe),this.p(B)};let x=null;this.b===l.Idle?Z():(x=(0,N.$jh)(oe=>this.u()),x.then(()=>{x=null,Z()}));const te=()=>{x?(x.cancel(),x=null):this.p({id:ee,type:101}),U(new I.$5)},_=he.onCancellationRequested(te);j=(0,f.$Rc)((0,f.$Sc)(te),_),this.d.add(j)}).finally(()=>{j.dispose(),this.d.delete(j)})}o(V,ie,se){const he=this.g++,W={id:he,type:102,channelName:V,name:ie,arg:se};let B=null;const j=new C.$de({onWillAddFirstListener:()=>{B=(0,N.$jh)(z=>this.u()),B.then(()=>{B=null,this.d.add(j),this.p(W)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(j),this.p({id:he,type:103}))}}),M=z=>j.fire(z.data);return this.f.set(he,M),j.event}p(V){switch(V.type){case 100:case 102:{const ie=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ie,V.id,0,`${c(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const ie=this.q([V.type,V.id]);this.j?.logOutgoing(ie,V.id,0,c(V.type));return}}}q(V,ie=void 0){const se=new t;return o(se,V),o(se,ie),this.r(se.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ie=new $(V),se=a(ie),he=a(ie),ee=se[0];switch(ee){case 200:return this.j?.logIncoming(V.byteLength,0,0,g(ee)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,se[1],0,g(ee),he),this.t({type:se[0],id:se[1],data:he})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Pc)(this.d.values()),this.d.clear()}}e.$_h=v,ve([O.$1h],v.prototype,"onDidInitializePromise",null);class k{get connections(){const V=[];return this.f.forEach(ie=>V.push(ie)),V}constructor(V,ie,se){this.a=new Map,this.f=new Set,this.g=new C.$de,this.onDidAddConnection=this.g.event,this.h=new C.$de,this.onDidRemoveConnection=this.h.event,this.j=new f.$Tc,this.j.add(V(({protocol:he,onDidClientDisconnect:ee})=>{const W=C.Event.once(he.onMessage);this.j.add(W(B=>{const j=new $(B),M=a(j),z=new b(he,M,ie,se),U=new v(he,ie);this.a.forEach((x,te)=>z.registerChannel(te,x));const Z={channelServer:z,channelClient:U,ctx:M};this.f.add(Z),this.g.fire(Z),this.j.add(ee(()=>{z.dispose(),U.dispose(),this.f.delete(Z),this.h.fire(Z)}))}))}))}getChannel(V,ie){const se=this;return{call(he,ee,W){let B;if((0,w.$kg)(ie)){const M=(0,D.$3b)(se.connections.filter(ie));B=M?Promise.resolve(M):C.Event.toPromise(C.Event.filter(se.onDidAddConnection,ie))}else B=ie.routeCall(se,he,ee);const j=B.then(M=>M.channelClient.getChannel(V));return R(j).call(he,ee,W)},listen(he,ee){if((0,w.$kg)(ie))return se.k(V,ie,he,ee);const W=ie.routeEvent(se,he,ee).then(B=>B.channelClient.getChannel(V));return R(W).listen(he,ee)}}}k(V,ie,se,he){const ee=this;let W;const B=new C.$de({onWillAddFirstListener:()=>{W=new f.$Tc;const j=new C.$je,M=new Map,z=Z=>{const te=Z.channelClient.getChannel(V).listen(se,he),_=j.add(te);M.set(Z,_)},U=Z=>{const x=M.get(Z);x&&(x.dispose(),M.delete(Z))};ee.connections.filter(ie).forEach(z),C.Event.filter(ee.onDidAddConnection,ie)(z,void 0,W),ee.onDidRemoveConnection(U,void 0,W),j.event(B.fire,B,W),W.add(j)},onDidRemoveLastListener:()=>{W?.dispose(),W=void 0}});return B.event}registerChannel(V,ie){this.a.set(V,ie);for(const se of this.f)se.channelServer.registerChannel(V,ie)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=k;class P{constructor(V,ie,se=null){const he=new t;o(he,ie),V.send(he.buffer),this.a=new v(V,se),this.d=new b(V,ie,se)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ie){this.d.registerChannel(V,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=P;function R(G){return{call(V,ie,se){return G.then(he=>he.call(V,ie,se))},listen(V,ie){const se=new C.$me;return G.then(he=>se.input=he.listen(V,ie)),se.event}}}function F(G){let V=!1;return{call(ie,se,he){return V?G.call(ie,se,he):(0,N.$xh)(0).then(()=>V=!0).then(()=>G.call(ie,se,he))},listen(ie,se){if(V)return G.listen(ie,se);const he=new C.$me;return(0,N.$xh)(0).then(()=>V=!0).then(()=>he.input=G.listen(ie,se)),he.event}}}class T{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ie of V.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await C.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$ei=T;var q;(function(G){function V(ee,W,B){const j=ee,M=B&&B.disableMarshalling,z=new Map;for(const U in j)se(U)&&z.set(U,C.Event.buffer(j[U],!0,void 0,W));return new class{listen(U,Z,x){const te=z.get(Z);if(te)return te;const _=j[Z];if(typeof _=="function"){if(he(Z))return _.call(j,x);if(se(Z))return z.set(Z,C.Event.buffer(j[Z],!0,void 0,W)),z.get(Z)}throw new I.$bb(`Event not found: ${Z}`)}call(U,Z,x){const te=j[Z];if(typeof te=="function"){if(!M&&Array.isArray(x))for(let oe=0;oe<x.length;oe++)x[oe]=(0,E.$6h)(x[oe]);let _=te.apply(j,x);return _ instanceof Promise||(_=Promise.resolve(_)),_}throw new I.$bb(`Method not found: ${Z}`)}}}G.fromService=V;function ie(ee,W){const B=W&&W.disableMarshalling;return new Proxy({},{get(j,M){if(typeof M=="string")return W?.properties?.has(M)?W.properties.get(M):he(M)?function(z){return ee.listen(M,z)}:se(M)?ee.listen(M):async function(...z){let U;W&&!(0,w.$fg)(W.context)?U=[W.context,...z]:U=z;const Z=await ee.call(M,U);return B?Z:(0,E.$6h)(Z)};throw new I.$bb(`Property not found: ${String(M)}`)}})}G.toService=ie;function se(ee){return ee[0]==="o"&&ee[1]==="n"&&y.$wf(ee.charCodeAt(2))}function he(ee){return/^onDynamic/.test(ee)&&y.$wf(ee.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const V=G.toString();if(V!=="[object Object]")return V}return G}function X(G){return Array.isArray(G)?G.map(J):J(G)}function H(G,V,ie,se,he,ee,W){W=X(W);const B=Y[he],j=B[se%B.length];let M=[`%c[${G}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(ee)?(M=M.concat(W),M.push(")")):M.push(W),console.log.apply(console,M)}class K{constructor(V,ie){this.d=V,this.f=ie,this.a=0,this.b=0}logOutgoing(V,ie,se,he,ee){this.b+=V,H(this.d,this.b,V,ie,se,he,ee)}logIncoming(V,ie,se,he,ee){this.a+=V,H(this.f,this.a,V,ie,se,he,ee)}}e.$fi=K}),define(ae[68],ce([0,1,15,3,2,42]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let o=0;function a(S,v){if(!i.has(S)){const k=String(++o);i.set(S,k)}return i.get(S)}function b(S,v,k,P){if(!s.enableDiagnostics)return;const R=a(S,v);if(P instanceof D.$Fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=D.$Fe.alloc(P.byteLength);F.set(P),s.records.push({timestamp:Date.now(),id:R,label:v,type:k,buff:F})}else s.records.push({timestamp:Date.now(),id:R,label:v,type:k,data:P})}s.traceSocketEvent=b})(I||(e.SocketDiagnostics=I={}));var C;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let f=null;function E(){return f||(f=D.$Fe.alloc(0)),f}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,o){if(i===0)return E();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const v=this.a[0];return o&&(this.a.shift(),this.b-=i),v}if(this.a[0].byteLength>i){const v=this.a[0].slice(0,i);return o&&(this.a[0]=this.a[0].slice(i),this.b-=i),v}const a=D.$Fe.alloc(i);let b=0,S=0;for(;i>0;){const v=this.a[S];if(v.byteLength>i){const k=v.slice(0,i);a.set(k,b),b+=i,o&&(this.a[S]=v.slice(i),this.b-=i),i-=i}else a.set(v,b),b+=v.byteLength,o?(this.a.shift(),this.b-=v.byteLength):S++,i-=v.byteLength}return a}}e.$gi=y;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var c;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class p{constructor(i,o,a,b){this.type=i,this.id=o,this.ack=a,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.$Uc{constructor(i){super(),this.f=this.B(new N.$de),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new y,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,b=this.g.id,S=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new p(a,b,S,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.$Fe.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(o,i.data)}g(i,o){const a=this.f===0;return this.d.push(i,o),this.f+=i.byteLength+o.byteLength,a}h(){const i=D.$Fe.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,o){this.g(i,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends L.$Uc{constructor(i){super(),this.f=new N.$de,this.onMessage=this.f.event,this.g=new N.$de,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new l(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new p(1,0,0,i))}}e.$hi=u;class m extends A.$bi{static fromSocket(i,o){return new m(new u(i),o)}get onDidDispose(){return this.b.onDidDispose}constructor(i,o,a=null){super(i,o,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$ii=m;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$de({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ji=d;class ${constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,o=this.a;for(;o;)o=o.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let o=0,a=this.a;for(;a;)i[o++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const o=new $(i);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let o=0;o<r.a;o++)this.c[o]=i-1e3*o;setInterval(()=>{for(let o=r.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),o=(1+r.a)*1e3;let a=0;for(let b=0;b<r.a;b++)i-this.c[b]<=o&&a++;return 1-a/r.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??r.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=i.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new p(5,0,0,E());this.p.write(i),this.p.flush()}sendPause(){const i=new p(7,0,0,E());this.p.write(i)}sendResume(){const i=new p(8,0,0,E());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,o){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i);const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const o=this.b.peek();if(o&&o.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new p(6,0,0,E())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const o=++this.c;this.h=this.g;const a=new p(1,o,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const o=new p(2,0,0,i);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),o=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,b=Date.now()-this.n;if(o>=2e4&&a>=2e4&&b>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-o,2e4-a,2e4-b,500);this.f=setTimeout(()=>{this.f=null,this.B()},S)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i)}D(){this.h=this.g;const i=new p(9,0,this.h,E());this.p.write(i)}}e.$ki=n}),define(ae[92],ce([0,1,67,6,15,26,142,7,3,2,30,149,89,42]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class c extends h.$$h{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",u=>L.$Fe.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Zq=c;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new C.$de,this.onDidProcessExit=this.h.event;const m=u&&u.timeout?u.timeout:6e4;this.b=new N.$th(m),this.d=null,this.f=null}getChannel(l){const u=this;return{call(m,d,$){return u.k(l,m,d,$)},listen(m,d){return u.l(l,m,d)}}}k(l,u,m,d=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const $=this.n(l),t=(0,N.$jh)(s=>$.call(u,m,s)),r=d.onCancellationRequested(()=>t.cancel()),n=(0,f.$Sc)(()=>t.cancel());return this.c.add(n),t.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,u,m){if(!this.b)return C.Event.None;this.b.cancel();let d;const $=new C.$de({onWillAddFirstListener:()=>{d=this.n(l).listen(u,m)($.fire,$),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,E.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,w.$nm)(u.env),this.d=(0,D.fork)(this.i,l,u);const m=new C.$de,$=C.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.$Vq)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}m.fire(L.$Fe.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,y.$pm)(this.d):this.d,r=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),n=m.event,s={send:r,onMessage:n};this.f=new h.$_h(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,a)=>{process.removeListener("exit",i),$.dispose(),this.c.forEach(b=>(0,f.$Pc)(b)),this.c.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:a})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=p}),define(ae[151],ce([0,1,134,15,42,3,13,17]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hX=void 0,e.$iX=E;class C{constructor(w){this.a=w,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?N.$Fe.wrap(h.data):N.$Fe.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class f extends L.$ai{static b(w){(0,O.$gg)((0,D.$gX)(process),"Electron Utility Process");const h=new A.$de;return process.parentPort.on("message",c=>{if(w?.handledClientConnection(c))return;const p=(0,I.$Ob)(c.ports);p&&h.fire(p)}),A.Event.map(h.event,c=>({protocol:new C(c),onDidClientDisconnect:A.Event.fromNodeEventEmitter(c,"close")}))}constructor(w){super(f.b(w))}}e.$hX=f;function E(y,w,h){const c=p=>{p.data===w&&(y.removeListener("message",c),h())};y.on("message",c)}}),define(ae[69],ce([0,1,6,3,2,66,13]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=C;var I;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function C(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}var f;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(f||(e.StorageState=f={}));class E extends L.$Uc{static{this.a=100}constructor(h,c=Object.create(null)){super(),this.r=h,this.s=c,this.b=this.B(new N.$ge),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=this.B(new D.$uh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((c,p)=>this.w(p,c)),h.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w(h,c){if(this.c===f.Closed)return;let p=!1;(0,O.$fg)(c)?p=this.f.delete(h):this.f.get(h)!==c&&(this.f.set(h,c),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,c){const p=this.f.get(h);return(0,O.$fg)(p)?c:p}getBoolean(h,c){const p=this.get(h);return(0,O.$fg)(p)?c:p==="true"}getNumber(h,c){const p=this.get(h);return(0,O.$fg)(p)?c:parseInt(p,10)}getObject(h,c){const p=this.get(h);return(0,O.$fg)(p)?c:(0,A.$5h)(p)}async set(h,c,p=!1){if(this.c===f.Closed)return;if((0,O.$fg)(c))return this.delete(h,p);const g=(0,O.$$f)(c)||Array.isArray(c)?(0,A.$4h)(c):String(c);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,c=!1){if(!(this.c===f.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:c}),this.D()}async optimize(){if(this.c!==f.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=f.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(!(this.c===f.Closed||this.m))return this.D(h)}async D(h){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Wp=E;class y{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((c,p)=>this.a.set(p,c)),h.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$Xp=y}),define(ae[152],ce([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[70],ce([0,1,41,6,14,13,31,152]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0,e.zip=g,e.$jq=l,e.$kq=m,e.$gq="end of central directory record signature not found";const C=new RegExp(e.$gq);class f extends Error{constructor($,t){let r=t.message;switch($){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=$,this.cause=t}}e.$hq=f;function E(d){const $=d.externalFileAttributes>>16||33188;return[448,56,7].map(t=>$&t).reduce((t,r)=>t+r,$&61440)}function y(d){if(d instanceof f)return d;let $;return C.test(d.message)&&($="CorruptZip"),new f($,d)}function w(d,$,t,r,n,s){const i=L.$mc($),o=L.$jc(r,i);if(!o.startsWith(r))return Promise.reject(new Error(I.localize(0,null,$)));const a=L.$jc(r,$);let b;return s.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(O.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((S,v)=>{if(!s.isCancellationRequested)try{b=(0,D.createWriteStream)(a,{mode:t}),b.once("close",()=>S()),b.once("error",v),d.once("error",v),d.pipe(b)}catch(k){v(k)}}))}function h(d,$,t,r){let n=(0,N.$jh)(()=>Promise.resolve()),s=0;const i=r.onCancellationRequested(()=>{n.cancel(),d.close()});return new Promise((o,a)=>{const b=new N.$rh,S=v=>{v.isCancellationRequested||(s++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{r.isCancellationRequested||d.entryCount===s?o():a(new f("Incomplete",new Error(I.localize(1,null,s,d.entryCount))))},a)),d.readEntry(),d.on("entry",v=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(v.fileName)){S(r);return}const k=v.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(k)){const F=L.$jc($,k);n=(0,N.$jh)(T=>O.Promises.mkdir(F,{recursive:!0}).then(()=>S(T)).then(void 0,a));return}const P=p(d,v),R=E(v);n=(0,N.$jh)(F=>b.queue(()=>P.then(T=>w(T,k,R,$,t,F).then(()=>S(F)))).then(null,a))})}).finally(()=>i.dispose())}async function c(d,$=!1){const{open:t}=await new Promise((r,n)=>{ne(["yauzl"],r,n)});return new Promise((r,n)=>{t(d,$?{lazyEntries:!0}:void 0,(s,i)=>{s?n(y(s)):r((0,A.$hg)(i))})})}function p(d,$){return new Promise((t,r)=>{d.openReadStream($,(n,s)=>{n?r(y(n)):t((0,A.$hg)(s))})})}async function g(d,$){const{ZipFile:t}=await new Promise((r,n)=>{ne(["yazl"],r,n)});return new Promise((r,n)=>{const s=new t;$.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const i=(0,D.createWriteStream)(d);s.outputStream.pipe(i),s.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>r(d))})}function l(d,$,t={},r){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let s=c(d,!0);return t.overwrite&&(s=s.then(i=>O.Promises.rm($).then(()=>i))),s.then(i=>h(i,$,{sourcePathRegex:n},r))}function u(d,$){return c(d).then(t=>new Promise((r,n)=>{t.on("entry",s=>{s.fileName===$&&p(t,s).then(i=>r(i),i=>n(i))}),t.once("close",()=>n(new Error(I.localize(2,null,$))))}))}function m(d,$){return u(d,$).then(t=>new Promise((r,n)=>{const s=[];t.once("error",n),t.on("data",i=>s.push(i)),t.on("end",()=>r(Buffer.concat(s)))}))}}),define(ae[153],ce([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[154],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[155],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[156],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[157],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[158],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[159],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[160],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[161],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[162],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[163],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[164],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[165],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[166],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[167],ce([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[168],ce([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ae[169],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[170],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[171],ce([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[172],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[173],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[174],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[175],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[176],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[177],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[178],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[179],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[180],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[181],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[182],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[183],ce([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[184],ce([0,1,7,155]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var L;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...f){switch(f.length){case 1:return(0,N.localize)(0,null,f[0]);case 2:return(0,N.localize)(1,null,f[0],f[1]);case 3:return(0,N.localize)(2,null,f[0],f[1],f[2]);default:return}}const O=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const y=this.d,w=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:w};this.g.push({offset:y,lexeme:w,additionalInfo:E}),this.f.push(h)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const y=this.c.substring(this.d,this.e),w=C.b.get(y);w?this.k(w):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,y=!1,w=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(I);return}const c=this.c.charCodeAt(E);if(y)y=!1;else if(c===47&&!w){E++;break}else c===91?w=!0:c===92?y=!0:c===93&&(w=!1);E++}for(;E<this.c.length&&C.a.has(this.c.charCodeAt(E));)E++;this.e=E;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=C}),define(ae[185],ce([0,1,65,84,23,14,36,20,8]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=E,e.$8m=y,e.$5m=/^([^.]+\..+)[:=](.+)$/;class f{get appRoot(){return(0,A.$mc)(L.$Qg.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,I.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,D.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",h)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$0g)(C.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?C.URI.file((0,A.$jc)(h,"argv.json")):(0,I.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.$kc)(h):(0,A.$hc)((0,A.$jc)(L.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?C.URI.file((0,A.$kc)(h)):C.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.$kc)(h);const c=O.env.VSCODE_EXTENSIONS;if(c)return c;const p=O.env.VSCODE_PORTABLE;return p?(0,A.$jc)(p,"extensions"):(0,I.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(c=>/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file((0,A.$hc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file((0,A.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$5m.test(h))}get extensionLogLevel(){const h=[];for(const c of this.args.log||[]){const p=e.$5m.exec(c);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,I.$0g)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?C.URI.file((0,A.$jc)(h,"policy.json")):(0,I.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,c,p){this.a=h,this.b=c,this.c=p,this.editSessionId=this.args.editSessionId}}e.$6m=f,ve([N.$1h],f.prototype,"appRoot",null),ve([N.$1h],f.prototype,"userHome",null),ve([N.$1h],f.prototype,"userDataPath",null),ve([N.$1h],f.prototype,"appSettingsHome",null),ve([N.$1h],f.prototype,"tmpDir",null),ve([N.$1h],f.prototype,"cacheHome",null),ve([N.$1h],f.prototype,"stateResource",null),ve([N.$1h],f.prototype,"userRoamingDataHome",null),ve([N.$1h],f.prototype,"userDataSyncHome",null),ve([N.$1h],f.prototype,"sync",null),ve([N.$1h],f.prototype,"machineSettingsResource",null),ve([N.$1h],f.prototype,"workspaceStorageHome",null),ve([N.$1h],f.prototype,"localHistoryHome",null),ve([N.$1h],f.prototype,"keyboardLayoutResource",null),ve([N.$1h],f.prototype,"argvResource",null),ve([N.$1h],f.prototype,"isExtensionDevelopment",null),ve([N.$1h],f.prototype,"untitledWorkspacesHome",null),ve([N.$1h],f.prototype,"builtinExtensionsPath",null),ve([N.$1h],f.prototype,"extensionsPath",null),ve([N.$1h],f.prototype,"extensionDevelopmentLocationURI",null),ve([N.$1h],f.prototype,"extensionDevelopmentKind",null),ve([N.$1h],f.prototype,"extensionTestsLocationURI",null),ve([N.$1h],f.prototype,"debugExtensionHost",null),ve([N.$1h],f.prototype,"logLevel",null),ve([N.$1h],f.prototype,"extensionLogLevel",null),ve([N.$1h],f.prototype,"serviceMachineIdResource",null),ve([N.$1h],f.prototype,"disableTelemetry",null),ve([N.$1h],f.prototype,"disableWorkspaceTrust",null),ve([N.$1h],f.prototype,"useInMemorySecretStorage",null),ve([N.$1h],f.prototype,"policyFile",null);function E(w,h){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,h,w.debugId,w.extensionEnvironment)}function y(w,h,c,p,g,l){const m=Number(h||w)||(p?null:c),d=m?!!h:!1;let $;if(l)try{$=JSON.parse(l)}catch{}return{port:m,break:d,debugId:g,env:$}}}),function(){"use strict";function ne(e,D,N){function L(O,I){const C=A(O,I),f=[C];return e.isAbsolute(C)||f.unshift(N),e.resolve(...f)}function A(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,I);const E=O["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(y,"AppData","Roaming")}break;case"darwin":f=e.join(D.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,I)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[186],ce([276,37,36]),function(e,D,N){return ne(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ne(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[187],ce([0,1,37,185,186]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=O,e.$$m=I;class A extends N.$6m{constructor(f,E){super(f,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(f,E.nameShort)},E)}}e.$9m=A;function O(C,f){return(0,N.$8m)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,f,C.extensionEnvironment)}function I(C,f){return(0,N.$8m)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,f,C.extensionEnvironment)}}),define(ae[188],ce([0,1,13,158]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=L;function L(O,I,C,f){try{A(O,I,C,f)}catch(E){O.error(E?.message??E)}return I}function A(O,I,C,f){const E=(y,w,h)=>{const c=y[w];if((0,D.$9f)(c)){const p=c,g=p.length;if(g>1&&p[0]==="%"&&p[g-1]==="%"){const l=p.substr(1,g-2);let u=C[l];u===void 0&&f&&(u=f[l]);const m=typeof u=="string"?u:u?.message,d=f?.[l],$=typeof d=="string"?d:d?.message;if(!m){$||O.warn(`[${I.name}]: ${(0,N.localize)(0,null,l)}`);return}if(h&&(w==="title"||w==="category")&&$&&$!==m){const t={value:m,original:$};y[w]=t}else y[w]=m}}else if((0,D.$$f)(c))for(const p in c)c.hasOwnProperty(p)&&(p==="commands"?E(c,p,!0):E(c,p,h));else if(Array.isArray(c))for(let p=0;p<c.length;p++)E(c,p,h)};for(const y in I)I.hasOwnProperty(y)&&E(I,y)}}),define(ae[189],ce([0,1,70,161]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=L;function L(A){return(0,D.$kq)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(ae[190],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Mec=D;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,I){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${O}`)}}e.$Nec=N}),define(ae[71],ce([0,1,20,88,162,55]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=C,e.$Hp=f,e.$Ip=E,e.$Jp=y,e.$Kp=w,e.$Lp=h,e.$Mp=c;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(l){return l=l.trim(),l==="*"||O.test(l)}function f(l){if(!C(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function E(l){if(!l)return null;const u=l.majorBase,m=l.majorMustEqual,d=l.minorBase;let $=l.minorMustEqual;const t=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(u===0||($=!1),r=!1);let n=0;if(l.preRelease){const s=I.exec(l.preRelease);if(s){const[,i,o,a]=s;n=Date.UTC(Number(i),Number(o)-1,Number(a))}}return{majorBase:u,majorMustEqual:m,minorBase:d,minorMustEqual:$,patchBase:t,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:n}}function y(l,u,m){let d;typeof l=="string"?d=E(f(l)):d=l;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let t;if(typeof m=="string"?t=E(f(m)):t=m,!d||!t)return!1;const r=d.majorBase,n=d.minorBase,s=d.patchBase;let i=t.majorBase,o=t.minorBase,a=t.patchBase;const b=t.notBefore;let S=t.majorMustEqual,v=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:n>o?!0:n<o||$&&$<b?!1:s>=a:(r===1&&i===0&&(!S||!v||!k)&&(i=1,o=0,a=0,S=!0,v=!1,k=!1),r<i?!1:r>i?!S:n<o?!1:n>o?!v:s<a?!1:s>a?!k:!($&&$<b))}function w(l,u,m,d,$){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof d.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!d.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!g(d.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!g(d.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const s=(0,D.$0g)(m,d.main);(0,D.$4g)(s,m)||t.push([N.default.Warning,L.localize(10,null,s.path,m.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const s=(0,D.$0g)(m,d.browser);(0,D.$4g)(s,m)||t.push([N.default.Warning,L.localize(12,null,s.path,m.path)])}}if(!A.valid(d.version))return t.push([N.default.Error,L.localize(13,null)]),t;const r=[];if(!h(l,u,d,$,r))for(const s of r)t.push([N.default.Error,s]);return t}function h(l,u,m,d,$){return d||typeof m.main>"u"&&typeof m.browser>"u"?!0:p(l,u,m.engines.vscode,$)}function c(l,u,m){return l==="*"||p(u,m,l)}function p(l,u,m,d=[]){const $=E(f(m));if(!$)return d.push(L.localize(14,null,m)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return d.push(L.localize(15,null,m)),!1}else if(!$.majorMustEqual)return d.push(L.localize(16,null,m)),!1;return y(l,u,$)?!0:(d.push(L.localize(17,null,l,m)),!1)}function g(l){if(!Array.isArray(l))return!1;for(let u=0,m=l.length;u<m;u++)if(typeof l[u]!="string")return!1;return!0}}),define(ae[45],ce([0,1,15,32]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=L;async function L(A,O,I){let C=I&&I.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const E=(await O.readFile(A.serviceMachineIdResource)).value.toString();C=(0,N.$Rg)(E)?E:null}catch{C=null}if(!C){C=(0,N.$Sg)();try{await O.writeFile(A.serviceMachineIdResource,D.$Fe.fromString(C))}catch{}}return I?.store("storage.serviceMachineId",C,-1,1),C}}),define(ae[72],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class D{constructor(L,A=[],O=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$ti=D}),define(ae[191],ce([0,1,72]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=A,e.$ys=O;const N=[];var L;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(I,C,f){C instanceof D.$ti||(C=new D.$ti(C,[],!!f)),N.push([I,C])}function O(){return N}}),define(ae[192],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class D{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$ar=D;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const I=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(O);I.outgoing.set(C.key,C),C.incoming.set(I.key,I)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let I=this.a.get(O);return I||(I=new D(O,A),this.a.set(O,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,I]of this.a)A.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const I=new Set([A]),C=this.c(O,I);if(C)return C}}c(A,O){for(const[I,C]of A.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const f=this.c(C,O);if(f)return f;O.delete(I)}}}e.$br=N}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=L,e.$xi=A;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(D||(e._util=D={})),e.$vi=L("instantiationService");function N(O,I,C){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:O,index:C}):(I[D.DI_DEPENDENCIES]=[{id:O,index:C}],I[D.DI_TARGET]=I)}function L(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const I=function(C,f,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,C,E)};return I.toString=()=>O,D.serviceIds.set(O,I),I}function A(O){return O}}),define(ae[193],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0,e.$mec=(0,D.$wi)("checksumService")}),define(ae[21],ce([0,1,13,8,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=A,e.$5i=O,e.$6i=C,e.$7i=f,e.$8i=E,e.$9i=y,e.$0i=w,e.$$i=c,e.$_i=p,e.$aj=g,e.$3i=(0,L.$wi)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function C(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function f(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function E(l,u){const m=Object.create(null);for(const d in l)y(m,d,l[d],u);return m}function y(l,u,m,d){const $=u.split("."),t=$.pop();let r=l;for(let n=0;n<$.length;n++){const s=$[n];let i=r[s];switch(typeof i){case"undefined":i=r[s]=Object.create(null);break;case"object":if(i===null){d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is null`);return}break;default:d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}function w(l,u){const m=u.split(".");h(l,m)}function h(l,u){const m=u.shift();if(u.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const d=l[m];typeof d=="object"&&!Array.isArray(d)&&(h(d,u),Object.keys(d).length===0&&delete l[m])}}function c(l,u,m){function d(r,n){let s=r;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const $=u.split("."),t=d(l,$);return typeof t>"u"?m:t}function p(l,u,m){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in l?D.$$f(l[d])&&D.$$f(u[d])?p(l[d],u[d],m):m&&(l[d]=u[d]):l[d]=u[d])})}function g(l){return l.replace(/[\[\]]/g,"")}}),define(ae[93],ce([0,1,5,27,184,4,154,7]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=f,e.$vj=r,e.$wj=n,e.$Pj=he;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",D.$j),C.set("isLinux",D.$k),C.set("isWindows",D.$i),C.set("isWeb",D.$o),C.set("isMacNative",D.$j&&!D.$o),C.set("isEdge",D.$H),C.set("isFirefox",D.$F),C.set("isChrome",D.$E),C.set("isSafari",D.$G);function f(B,j){if(C.get(B)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(B,j)}const E=Object.prototype.hasOwnProperty;var y;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const w={regexParsingWithErrorRecovery:!0},h=(0,O.localize)(0,null),c=(0,O.localize)(1,null),p=(0,O.localize)(2,null),g=(0,O.localize)(3,null),l=(0,O.localize)(4,null),u=(0,O.localize)(5,null),m=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=w){this.k=j,this.d=new L.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const z=this.D(),U=z.type===17?u:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:L.$rj.getLexeme(z),additionalInfo:U}),$.c}return M}catch(M){if(M!==$.c)throw M;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const M=this.o();j.push(M)}return j.length===1?j[0]:t.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const M=this.s();j.push(M)}return j.length===1?j[0]:t.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,g),M?.negate()}case 17:return this.z(),P.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const M=this.l();return this.A(1,g),M}case 17:{const M=j.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Z=U.lexeme,x=Z.lastIndexOf("/"),te=x===Z.length-1?void 0:this.w(Z.substring(x+1));let _;try{_=new RegExp(Z.substring(1,x),te)}catch{throw this.B("REGEX",U)}return J.create(M,_)}switch(U.type){case 10:case 19:{const Z=[U.lexeme];this.z();let x=this.D(),te=0;for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===40?te++:U.lexeme.charCodeAt(de)===41&&te--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let de=0;de<x.lexeme.length;de++)x.lexeme.charCodeAt(de)===40?te++:U.lexeme.charCodeAt(de)===41&&te--}if(te<0)break;Z.push(L.$rj.getLexeme(x)),this.z(),x=this.D()}const _=Z.join(""),oe=_.lastIndexOf("/"),fe=oe===_.length-1?void 0:this.w(_.substring(oe+1));let $e;try{$e=new RegExp(_.substring(1,oe),fe)}catch{throw this.B("REGEX",U)}return t.regex(M,$e)}case 18:{const Z=U.lexeme;this.z();let x=null;if(!(0,N.$7e)(Z)){const te=Z.indexOf("/"),_=Z.lastIndexOf("/");if(te!==_&&te>=0){const oe=Z.slice(te+1,_),fe=Z[_+1]==="i"?"i":"";try{x=new RegExp(oe,fe)}catch{throw this.B("REGEX",U)}}}if(x===null)throw this.B("REGEX",U);return J.create(M,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const U=this.u();return t.notIn(M,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return t.equals(M,U);switch(U){case"true":return t.has(M);case"false":return t.not(M);default:return t.equals(M,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return t.notEquals(M,U);switch(U){case"true":return t.not(M);case"false":return t.has(M);default:return t.notEquals(M,U)}}case 5:return this.z(),q.create(M,this.u());case 6:return this.z(),Y.create(M,this.u());case 7:return this.z(),F.create(M,this.u());case 8:return this.z(),T.create(M,this.u());case 13:return this.z(),t.in(M,this.u());default:return t.has(M)}}case 20:throw this.h.push({message:m,offset:j.offset,lexeme:"",additionalInfo:d}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,M){if(this.C(j))return this.z();throw this.B(M,this.D())}B(j,M,z){const U=(0,O.localize)(8,null,j,L.$rj.getLexeme(M)),Z=M.offset,x=L.$rj.getLexeme(M);return this.h.push({message:U,offset:Z,lexeme:x,additionalInfo:z}),$.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=$;class t{static false(){return i.INSTANCE}static true(){return o.INSTANCE}static has(j){return a.create(j)}static equals(j,M){return b.create(j,M)}static notEquals(j,M){return k.create(j,M)}static regex(j,M){return J.create(j,M)}static in(j,M){return S.create(j,M)}static notIn(j,M){return v.create(j,M)}static not(j){return P.create(j)}static and(...j){return K.create(j,null,!0)}static or(...j){return G.create(j,null,!0)}static greater(j,M){return F.create(j,M)}static greaterEquals(j,M){return T.create(j,M)}static smaller(j,M){return q.create(j,M)}static smallerEquals(j,M){return Y.create(j,M)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$uj=t;function r(B){const j=new $({regexParsingWithErrorRecovery:!1});return B.map(M=>(j.parse(M),j.lexingErrors.length>0?j.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,O.localize)(9,null,z.additionalInfo):(0,O.localize)(10,null),offset:z.offset,length:z.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function n(B,j){const M=B?B.substituteConstants():void 0,z=j?j.substituteConstants():void 0;return!M&&!z?!0:!M||!z?!1:M.equals(z)}function s(B,j){return B.cmp(j)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return o.INSTANCE}}e.$xj=i;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return i.INSTANCE}}e.$yj=o;class a{static create(j,M=null){const z=C.get(j);return typeof z=="boolean"?z?o.INSTANCE:i.INSTANCE:new a(j,M)}constructor(j,M){this.key=j,this.c=M,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=C.get(this.key);return typeof j=="boolean"?j?o.INSTANCE:i.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$zj=a;class b{static create(j,M,z=null){if(typeof M=="boolean")return M?a.create(j,z):P.create(j,z);const U=C.get(j);return typeof U=="boolean"?M===(U?"true":"false")?o.INSTANCE:i.INSTANCE:new b(j,M,z)}constructor(j,M,z){this.c=j,this.d=M,this.f=z,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=C.get(this.c);if(typeof j=="boolean"){const M=j?"true":"false";return this.d===M?o.INSTANCE:i.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Aj=b;class S{static create(j,M){return new S(j,M)}constructor(j,M){this.d=j,this.f=M,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:se(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const M=j.getValue(this.f),z=j.getValue(this.d);return Array.isArray(M)?M.includes(z):typeof z=="string"&&typeof M=="object"&&M!==null?E.call(M,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Bj=S;class v{static create(j,M){return new v(j,M)}constructor(j,M){this.d=j,this.f=M,this.type=11,this.c=S.create(j,M)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=v;class k{static create(j,M,z=null){if(typeof M=="boolean")return M?P.create(j,z):a.create(j,z);const U=C.get(j);return typeof U=="boolean"?M===(U?"true":"false")?i.INSTANCE:o.INSTANCE:new k(j,M,z)}constructor(j,M,z){this.c=j,this.d=M,this.f=z,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=C.get(this.c);if(typeof j=="boolean"){const M=j?"true":"false";return this.d===M?i.INSTANCE:o.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Dj=k;class P{static create(j,M=null){const z=C.get(j);return typeof z=="boolean"?z?i.INSTANCE:o.INSTANCE:new P(j,M)}constructor(j,M){this.c=j,this.d=M,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=C.get(this.c);return typeof j=="boolean"?j?i.INSTANCE:o.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Ej=P;function R(B,j){if(typeof B=="string"){const M=parseFloat(B);isNaN(M)||(B=M)}return typeof B=="string"||typeof B=="number"?j(B):i.INSTANCE}class F{static create(j,M,z=null){return R(M,U=>new F(j,U,z))}constructor(j,M,z){this.c=j,this.d=M,this.f=z,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Fj=F;class T{static create(j,M,z=null){return R(M,U=>new T(j,U,z))}constructor(j,M,z){this.c=j,this.d=M,this.f=z,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Gj=T;class q{static create(j,M,z=null){return R(M,U=>new q(j,U,z))}constructor(j,M,z){this.c=j,this.d=M,this.f=z,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=q;class Y{static create(j,M,z=null){return R(M,U=>new Y(j,U,z))}constructor(j,M,z){this.c=j,this.d=M,this.f=z,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ij=Y;class J{static create(j,M){return new J(j,M)}constructor(j,M){this.d=j,this.f=M,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const M=this.f?this.f.source:"",z=j.f?j.f.source:"";return M<z?-1:M>z?1:0}equals(j){if(j.type===this.type){const M=this.f?this.f.source:"",z=j.f?j.f.source:"";return this.d===j.d&&M===z}return!1}substituteConstants(){return this}evaluate(j){const M=j.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$Jj=J;class X{static create(j){return new X(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new X(this.c.map(j))}negate(){return this.c}}e.$Kj=X;function H(B){let j=null;for(let M=0,z=B.length;M<z;M++){const U=B[M].substituteConstants();if(B[M]!==U&&j===null){j=[];for(let Z=0;Z<M;Z++)j[Z]=B[Z]}j!==null&&(j[M]=U)}return j===null?B:j}class K{static create(j,M,z){return K.d(j,M,z)}constructor(j,M){this.expr=j,this.c=M,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const U=s(this.expr[M],j.expr[M]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(j.expr[M]))return!1;return!0}return!1}substituteConstants(){const j=H(this.expr);return j===this.expr?this:K.create(j,this.c,!1)}evaluate(j){for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].evaluate(j))return!1;return!0}static d(j,M,z){const U=[];let Z=!1;for(const x of j)if(x){if(x.type===1){Z=!0;continue}if(x.type===0)return i.INSTANCE;if(x.type===6){U.push(...x.expr);continue}U.push(x)}if(U.length===0&&Z)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(s);for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];for(;U.length>1;){const x=U[U.length-1];if(x.type!==9)break;U.pop();const te=U.pop(),_=U.length===0,oe=G.create(x.expr.map(fe=>K.create([fe,te],null,z)),null,_);oe&&(U.push(oe),U.sort(s))}if(U.length===1)return U[0];if(z){for(let x=0;x<U.length;x++)for(let te=x+1;te<U.length;te++)if(U[x].negate().equals(U[te]))return i.INSTANCE;if(U.length===1)return U[0]}return new K(U,M)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const M of this.expr)j.push(...M.keys());return j}map(j){return new K(this.expr.map(M=>M.map(j)),null)}negate(){if(!this.c){const j=[];for(const M of this.expr)j.push(M.negate());this.c=G.create(j,this,!0)}return this.c}}e.$Lj=K;class G{static create(j,M,z){return G.d(j,M,z)}constructor(j,M){this.expr=j,this.c=M,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const U=s(this.expr[M],j.expr[M]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(j.expr[M]))return!1;return!0}return!1}substituteConstants(){const j=H(this.expr);return j===this.expr?this:G.create(j,this.c,!1)}evaluate(j){for(let M=0,z=this.expr.length;M<z;M++)if(this.expr[M].evaluate(j))return!0;return!1}static d(j,M,z){let U=[],Z=!1;if(j){for(let x=0,te=j.length;x<te;x++){const _=j[x];if(_){if(_.type===0){Z=!0;continue}if(_.type===1)return o.INSTANCE;if(_.type===9){U=U.concat(_.expr);continue}U.push(_)}}if(U.length===0&&Z)return i.INSTANCE;U.sort(s)}if(U.length!==0){if(U.length===1)return U[0];for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];if(z){for(let x=0;x<U.length;x++)for(let te=x+1;te<U.length;te++)if(U[x].negate().equals(U[te]))return o.INSTANCE;if(U.length===1)return U[0]}return new G(U,M)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const M of this.expr)j.push(...M.keys());return j}map(j){return new G(this.expr.map(M=>M.map(j)),null)}negate(){if(!this.c){const j=[];for(const M of this.expr)j.push(M.negate());for(;j.length>1;){const M=j.shift(),z=j.shift(),U=[];for(const Z of W(M))for(const x of W(z))U.push(K.create([Z,x],null,!1));j.unshift(G.create(U,null,!1))}this.c=G.create(j,this,!0)}return this.c}}e.$Mj=G;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(j,M,z){super(j,null),this.f=M,typeof z=="object"?V.d.push({...z,key:j}):z!==!0&&V.d.push({key:j,description:z,type:M!=null?typeof M:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return b.create(this.key,j)}notEqualsTo(j){return k.create(this.key,j)}}e.$Nj=V,e.$Oj=(0,A.$wi)("contextKeyService");function ie(B,j){return B<j?-1:B>j?1:0}function se(B,j,M,z){return B<M?-1:B>M?1:j<z?-1:j>z?1:0}function he(B,j){if(B.type===0||j.type===1)return!0;if(B.type===9)return j.type===9?ee(B.expr,j.expr):!1;if(j.type===9){for(const M of j.expr)if(he(B,M))return!0;return!1}if(B.type===6){if(j.type===6)return ee(j.expr,B.expr);for(const M of B.expr)if(he(M,j))return!0;return!1}return B.equals(j)}function ee(B,j){let M=0,z=0;for(;M<B.length&&z<j.length;){const U=B[M].cmp(j[z]);if(U<0)return!1;U===0&&M++,z++}return M===B.length}function W(B){return B.type===9?B.expr:[B]}}),define(ae[94],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$dn=e.ID=void 0,e.$en=N,e.ID="diagnosticsService",e.$dn=(0,D.$wi)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}class L{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$fn=L}),define(ae[95],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=void 0,e.$Ko=(0,D.$wi)("downloadService")}),define(ae[16],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,D.$wi)("environmentService"),e.$Ei=(0,D.$xi)(e.$Di)}),define(ae[29],ce([0,1,157,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=L,e.$1o=A,e.$2o=O,e.$3o=I,e.$4o=C,e.$5o=f,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function L(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function I(u,m){return m==="web"&&!u.includes("web")}function C(u,m,d){return I(m,d)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===d}function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var w;(function(u){u.Install="install",u.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var h;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$6o=(0,N.$wi)("extensionGalleryService");var c;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class p extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$7o=p;var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class l extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$8o=l,e.$9o=(0,N.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,N.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,N.$wi)("IExtensionTipsService"),e.$bp=(0,D.localize2)(0,"Extensions"),e.$cp=(0,D.localize2)(1,"Preferences")}),define(ae[194],ce([0,1,3,2,30,8,91,29]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=void 0;function C(g,l){return g?A.URI.revive(l?l.transformIncoming(g):g):void 0}function f(g,l){return l?l.transformOutgoingURI(g):g}function E(g,l){l=l||O.$zn;const u=g.manifest;return{...(0,O.$Cn)({...g,manifest:void 0},l),manifest:u}}function y(g,l){return g?.profileLocation?(0,O.$Cn)(g,l??O.$zn):g}function w(g,l){return l?(0,L.$5n)(g,u=>u instanceof A.URI?l.transformOutgoingURI(u):void 0):g}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const m=this.b(l);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map($=>({...$,local:$.local?w($.local,m):$.local,profileLocation:$.profileLocation?f($.profileLocation,m):$.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,d=>w(d,m))}throw new Error("Invalid listen")}async call(l,u,m){const d=this.b(l);switch(u){case"zip":{const $=E(m[0],d),t=await this.a.zip($);return f(t,d)}case"unzip":return this.a.unzip(C(m[0],d));case"install":return this.a.install(C(m[0],d),y(m[1],d));case"installFromLocation":return this.a.installFromLocation(C(m[0],d),C(m[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],C(m[1],d),C(m[2],d));case"getManifest":return this.a.getManifest(C(m[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],y(m[1],d));case"installGalleryExtensions":{const $=m[0];return this.a.installGalleryExtensions($.map(({extension:t,options:r})=>({extension:t,options:y(r,d)??{}})))}case"uninstall":return this.a.uninstall(E(m[0],d),y(m[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],d));case"getInstalled":return(await this.a.getInstalled(m[0],C(m[1],d),m[2])).map(t=>w(t,d));case"toggleAppliationScope":{const $=await this.a.toggleAppliationScope(E(m[0],d),C(m[1],d));return w($,d)}case"copyExtensions":return this.a.copyExtensions(C(m[0],d),C(m[1],d));case"updateMetadata":{const $=await this.a.updateMetadata(E(m[0],d),m[1],C(m[2],d));return w($,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$dq=h;class c extends N.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new D.$de),this.f=this.B(new D.$de),this.g=this.B(new D.$de),this.h=this.B(new D.$de),this.j=this.B(new D.$de),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(E(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(m=>(0,I.$4o)(m,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>A.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(m=>E(m,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(m=>E(m,null))}async installExtensionsFromProfile(l,u,m){return(await this.m.call("installExtensionsFromProfile",[l,u,m])).map($=>E($,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(m=>E(m,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))}uninstall(l,u){if(l.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>E(u,null))}getInstalled(l=null,u,m){return Promise.resolve(this.m.call("getInstalled",[l,u,m])).then(d=>d.map($=>E($,null)))}updateMetadata(l,u,m){return Promise.resolve(this.m.call("updateMetadata",[l,u,m])).then(d=>E(d,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(m=>E(m,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,m){const d=await this.m.call("download",[l,u,m]);return A.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$eq=c;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,m){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$fq=p}),define(ae[96],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r4b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$q4b=L;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$r4b=(0,D.$wi)("IExtensionRecommendationNotificationService")}),define(ae[12],ce([0,1,51,14,27,13,8,164,4,5,23,53]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=w,e.$5k=g,e.$6k=u,e.$7k=m,e.$8k=d,e.$9k=$,e.$0k=t,e.$$k=r,e.$_k=n,e.$al=s,e.$bl=i,e.$dl=b,e.$el=S,e.$fl=v,e.$gl=k,e.$hl=P,e.$kl=Y,e.$wl=V,e.$xl=ie,e.$zl=he,e.$3k=(0,C.$wi)("fileService");function w(ee){return ee.create===!0}var h;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var c;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var p;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function g(ee){const W=ee;return!!W&&typeof W.onDidChange=="function"}var l;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function u(ee){return!!(ee.capabilities&2)}function m(ee){return!!(ee.capabilities&8)}function d(ee){return!!(ee.capabilities&131072)}function $(ee){return!!(ee.capabilities&4)}function t(ee){return!!(ee.capabilities&16)}function r(ee){return u(ee)?!!(ee.capabilities&16384):!1}function n(ee){return u(ee)?!!(ee.capabilities&32768):!1}function s(ee){return!!(ee.capabilities&65536)}function i(ee){return!!(ee.capabilities&2048)}var o;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class a extends Error{static create(W,B){const j=new a(W.toString(),B);return v(j,B),j}constructor(W,B){super(W),this.code=B}}e.$cl=a;function b(ee,W){return a.create(ee,W)}function S(ee){return ee||b((0,I.localize)(0,null),o.Unknown)}function v(ee,W){return ee.name=W?`${W} (FileSystemError)`:"FileSystemError",ee}function k(ee){if(!ee)return o.Unknown;if(ee instanceof a)return ee.code;const W=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!W)return o.Unknown;switch(W[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function P(ee){if(ee instanceof J)return ee.fileOperationResult;switch(k(ee)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var R;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class F{constructor(W,B,j){this.resource=W,this.operation=B,this.target=j}isOperation(W){return this.operation===W}}e.$il=F;var T;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class q{static{this.a=null}constructor(W,B){this.c=B,this.b=void 0,this.d=new y.$V(()=>{const j=D.$Ci.forUris(()=>this.c);return j.fill(this.rawAdded.map(M=>[M,!0])),j}),this.f=new y.$V(()=>{const j=D.$Ci.forUris(()=>this.c);return j.fill(this.rawUpdated.map(M=>[M,!0])),j}),this.g=new y.$V(()=>{const j=D.$Ci.forUris(()=>this.c);return j.fill(this.rawDeleted.map(M=>[M,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of W){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.b!==q.a&&(typeof j.cId=="number"?this.b===void 0?this.b=j.cId:this.b!==j.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(W,...B){return this.h(W,{includeChildren:!1},...B)}affects(W,...B){return this.h(W,{includeChildren:!0},...B)}h(W,B,...j){if(!W)return!1;const M=j.length>0;return!!((!M||j.includes(1))&&(this.d.value.get(W)||B.includeChildren&&this.d.value.findSuperstr(W))||(!M||j.includes(0))&&(this.f.value.get(W)||B.includeChildren&&this.f.value.findSuperstr(W))||(!M||j.includes(2))&&(this.g.value.findSubstr(W)||B.includeChildren&&this.g.value.findSuperstr(W)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(W){return this.b===W}hasCorrelation(){return typeof this.b=="number"}}e.$jl=q;function Y(ee,W,B){return!ee||!W||ee===W||W.length>ee.length?!1:(W.charAt(W.length-1)!==N.sep&&(W+=N.sep),B?(0,L.$yf)(ee,W):ee.indexOf(W)===0)}class J extends Error{constructor(W,B,j){super(W),this.fileOperationResult=B,this.options=j}}e.$ll=J;class X extends J{constructor(W,B,j,M){super(W,B,M),this.fileOperationResult=B,this.size=j}}e.$ml=X;class H extends J{constructor(W,B,j){super(W,2,j),this.stat=B}}e.$nl=H;var K;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var G;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(G||(e.FileKind=G={})),e.$vl="";function V(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function ie(ee,W){if(!W.hasProvider(O.URI.from({scheme:ee.scheme})))return new Promise(B=>{const j=W.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===ee.scheme&&M.added&&(j.dispose(),B())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(W){return(0,A.$ag)(W)||(W=0),W<se.KB?(0,I.localize)(1,null,W.toFixed(0)):W<se.MB?(0,I.localize)(2,null,(W/se.KB).toFixed(2)):W<se.GB?(0,I.localize)(3,null,(W/se.MB).toFixed(2)):W<se.TB?(0,I.localize)(4,null,(W/se.GB).toFixed(2)):(0,I.localize)(5,null,(W/se.TB).toFixed(2))}}e.$yl=se;function he(ee){const W=typeof ee=="string"||ee?.scheme===E.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===E.Schemas.file?1024*se.MB:W?10*se.MB:f.$o?50*se.MB:1024*se.MB}});var Q=this&&this.__param||function(ne,e){return function(D,N){e(D,N,ne)}};define(ae[195],ce([0,1,73,50,12]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let A=class{constructor(I){this.a=I}async checksum(I){const C=(await this.a.readFileStream(I)).value;return new Promise((f,E)=>{const y=(0,D.createHash)("sha256");(0,N.$xe)(C,{onData:w=>y.update(w.buffer),onError:w=>E(w),onEnd:()=>f(y.digest("base64").replace(/=+$/,""))})})}};e.$nec=A,e.$nec=A=ve([Q(0,L.$3k)],A)}),define(ae[97],ce([0,1,15,7,165,12]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=O;async function O(E,y,w,h,c,p){let g;try{await I(E,y,w,h,c,p)}catch(l){g=l}finally{g&&c.errorTransformer&&(g=c.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}async function I(E,y,w,h,c,p){C(p);const g=await E.open(y,{create:!1});try{C(p);let l=0,u=0,m=c&&typeof c.length=="number"?c.length:void 0,d=D.$Fe.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),$=c&&typeof c.position=="number"?c.position:0,t=0;do u=await E.read(g,$,d.buffer,t,d.byteLength-t),$+=u,t+=u,l+=u,typeof m=="number"&&(m-=u),t===d.byteLength&&(await w.write(h(d)),d=D.$Fe.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),t=0);while(u>0&&(typeof m!="number"||m>0)&&C(p)&&f(l,c));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),w.write(h(d.slice(0,r)))}}catch(l){throw(0,A.$el)(l)}finally{await E.close(g)}}function C(E){if(E.isCancellationRequested)throw(0,N.$6)();return!0}function f(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,A.$dl)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[46],ce([0,1,90,2,14,5,8,12]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=C,e.$Kq=f,e.$Oq=h,e.$Pq=c,e.$Qq=p,e.$Rq=g,e.$Sq=u,e.$Tq=m;function C(d){return typeof d.correlationId=="number"}function f(d){return d.recursive===!0}class E extends N.$Uc{static{this.a=5}constructor($,t,r,n){super(),this.h=$,this.j=t,this.m=r,this.n=n,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const $=new N.$Tc;this.c.value=$,this.b=this.r($),this.b.setVerboseLogging(this.m),$.add(this.b.onDidChangeFile(t=>this.h(t))),$.add(this.b.onDidLogMessage(t=>this.j(t))),$.add(this.b.onDidError(t=>this.t(t)))}t($){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${$}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${$}`):this.w($)}u($){this.g++,this.s(),this.watch($)}async watch($){this.f=$,await this.b?.watch($)}async setVerboseLogging($){this.m=$,await this.b?.setVerboseLogging($)}w($){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${$}`})}y($){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${$}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=E;class y extends E{constructor($,t,r){super($,t,r,{type:"node.js",restartOnError:!1})}}e.$Mq=y;class w extends E{constructor($,t,r){super($,t,r,{type:"universal",restartOnError:!0})}}e.$Nq=w;function h(d){return d.map($=>({type:$.type,resource:O.URI.revive($.resource),cId:$.cId}))}function c(d){const $=new l;for(const t of d)$.processEvent(t);return $.coalesce()}function p(d,$){return typeof $=="string"&&!$.startsWith(D.$mk)&&!(0,L.$ic)($)?{base:d,pattern:$}:$}function g(d,$){const t=[];for(const r of $)t.push((0,D.$qk)(p(d,r)));return t}class l{constructor(){this.a=new Set,this.b=new Map}c($){return A.$k?$.resource.fsPath:$.resource.fsPath.toLowerCase()}processEvent($){const t=this.b.get(this.c($));let r=!1;if(t){const n=t.type,s=$.type;t.resource.fsPath!==$.resource.fsPath&&($.type===2||$.type===1)?r=!0:n===1&&s===2?(this.b.delete(this.c($)),this.a.delete(t)):n===2&&s===1?t.type=0:n===1&&s===0||(t.type=s)}else r=!0;r&&(this.a.add($),this.b.set(this.c($),$))}coalesce(){const $=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?($.push(r),!1):!0).sort((r,n)=>r.resource.fsPath.length-n.resource.fsPath.length).filter(r=>t.some(n=>(0,I.$kl)(r.resource.fsPath,n,!A.$k))?!1:(t.push(r.resource.fsPath),!0)).concat($)}}function u(d,$){if(typeof $=="number")switch(d.type){case 1:return($&4)===0;case 2:return($&8)===0;case 0:return($&2)===0}return!1}function m(d){if(typeof d=="number"){const $=[];return d&4&&$.push("Added"),d&8&&$.push("Deleted"),d&2&&$.push("Updated"),$.length===0?"<all>":`[${$.join(", ")}]`}return"<none>"}}),define(ae[196],ce([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,D,N,L,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$HQ=void 0,e.$HQ="localFilesystem";class y extends O.$Uc{constructor(h,c){super(),this.a=h,this.b=c,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$de),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$de),this.onDidWatchError=this.g.event,this.h=(0,C.$Sg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,c){const{buffer:p}=await this.a.call("readFile",[h,c]);return p}readFileStream(h,c,p){const g=(0,I.$te)(u=>D.$Fe.concat(u.map(m=>D.$Fe.wrap(m))).buffer),l=new O.$Tc;return l.add(this.a.listen("readFileStream",[h,c])(u=>{if(u instanceof D.$Fe)g.write(u.buffer);else{if(u==="end")g.end();else{let m;if(u instanceof Error)m=u;else{const d=u;m=(0,f.$dl)(d.message??(0,N.$hj)(d),d.code??f.FileSystemProviderErrorCode.Unknown)}g.error(m),g.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{g.error((0,L.$6)()),g.end(),l.dispose()})),g}writeFile(h,c,p){return this.a.call("writeFile",[h,D.$Fe.wrap(c),p])}open(h,c){return this.a.call("open",[h,c])}close(h){return this.a.call("close",[h])}async read(h,c,p,g,l){const[u,m]=await this.a.call("read",[h,c,l]);return p.set(u.buffer.slice(0,m),g),m}write(h,c,p,g,l){return this.a.call("write",[h,c,D.$Fe.wrap(p),g,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,c){return this.a.call("delete",[h,c])}rename(h,c,p){return this.a.call("rename",[h,c,p])}copy(h,c,p){return this.a.call("copy",[h,c,p])}cloneFile(h,c){return this.a.call("cloneFile",[h,c])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const c=h;this.f.fire((0,E.$Oq)(c))}else{const c=h;this.g.fire(c)}}))}watch(h,c){const p=(0,C.$Sg)();return this.a.call("watch",[this.h,p,h,c]),(0,O.$Sc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$IQ=y}),define(ae[197],ce([0,1,41,2,46,3,8,6]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class C extends N.$Uc{constructor(){super(),this.a=this.B(new A.$de),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$de),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$de),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new I.$Th,this.P=!1,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,L.$Jq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new I.$Th;try{this.h.clear(),this.g.clear();for(const y of E)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const y=new N.$Tc;this.j.set(E.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(E,y),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,y){this.C(E,y)?(this.N(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,y),this.m.add(E.correlationId))}C(E,y){const w=this.M?.subscribe(E.path,(h,c)=>{y.isDisposed||(h?this.z(E,y):c?.type===1&&this.F(E))});return w?(y.add(w),!0):!1}D(E,y){let w=!1;const h=(c,p)=>{if(y.isDisposed)return;const g=this.G(c),l=this.G(p),u=w;w=g,!g&&(l||u)&&this.F(E)};this.N(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,D.watchFile)(E.path,{persistent:!1,interval:this.n},h)}catch(c){this.O(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}y.add((0,N.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,D.unwatchFile)(E.path,h)}catch(c){this.O(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.N(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const y={resource:O.URI.file(E.path),type:1,cId:E.correlationId};this.a.fire([y]),this.H(y,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,y){if(this.P){const w=` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.I(w,y)}}I(E,y){this.P&&this.N(`${E}${typeof y.correlationId=="number"?` <${y.correlationId}> `:""}`)}J(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,L.$Tq)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.P=E}}e.$3q=C}),define(ae[198],ce([0,1,41,6,26,40,2,87,14,5,20,8,148,31,46]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=g;class p extends O.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(u,m,d,$,t,r){super(),this.s=u,this.t=m,this.u=d,this.w=$,this.y=t,this.z=r,this.c=this.B(new N.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new N.$Kh(n=>this.M(n),p.b)),this.g=(0,c.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Jq)(this.s)?this.s.filter:void 0,this.m=new L.$oe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const u=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await h.Promises.stat(u);if(this.m.token.isCancellationRequested)return;this.B(await this.G(u,m.isDirectory()))}catch(u){u.code!=="ENOENT"?this.O(u):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${u})`),this.D()}}D(){this.r=!0,this.w?.()}async F(u){let m=u.path;try{m=await h.Promises.realpath(u.path),u.path===m&&(m=await(0,w.$5q)(u.path,this.m.token)??u.path),u.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${m})`)}catch{}return m}async G(u,m){const d=new O.$Tc;return this.H(u,m,d)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(u,m,d)),d}H(u,m,d){if(m)return!1;const $=y.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,n)=>{if(!d.isDisposed)if(r){const s=await this.G(u,m);d.isDisposed?s.dispose():d.add(s)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:$,type:n.type,cId:this.s.correlationId},!0)});return t?(d.add(t),!0):!1}async I(u,m,d){if(f.$j&&(0,A.$vg)(u,"/Volumes/",!0)){this.O(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const $=new L.$oe(this.m.token);d.add((0,O.$Sc)(()=>$.dispose(!0)));const t=new O.$Tc;d.add(t);try{const r=y.URI.file(this.s.path),n=(0,C.$nc)(u),s=(0,D.watch)(u);t.add((0,O.$Sc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${u}'`);const i=new Set;if(m)try{for(const a of await h.Promises.readdir(u))i.add(a)}catch(a){this.O(a)}if($.token.isCancellationRequested)return;const o=new Map;t.add((0,O.$Sc)(()=>{for(const[,a]of o)a.dispose();o.clear()})),s.on("error",(a,b)=>{$.token.isCancellationRequested||(this.O(`Failed to watch ${u} for changes using fs.watch() (${a}, ${b})`),this.D())}),s.on("change",(a,b)=>{if($.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${b}`);let S="";if(b&&(S=b.toString(),f.$j&&(S=(0,I.$bm)(S))),!(!S||a!=="change"&&a!=="rename"))if(m)if(a==="rename"){o.get(S)?.dispose();const v=setTimeout(async()=>{if(o.delete(S),S===n&&!await h.Promises.exists(u)){this.J(r);return}if($.token.isCancellationRequested)return;const k=await this.N((0,C.$jc)(u,S));if($.token.isCancellationRequested)return;let P;k?i.has(S)?P=0:(P=1,i.add(S)):(i.delete(S),P=2),this.L({resource:(0,E.$0g)(r,S),type:P,cId:this.s.correlationId})},p.a);o.set(S,(0,O.$Sc)(()=>clearTimeout(v)))}else{let v;i.has(S)?v=0:(v=1,i.add(S)),this.L({resource:(0,E.$0g)(r,S),type:v,cId:this.s.correlationId})}else if(a==="rename"||S!==n){const v=setTimeout(async()=>{const k=await h.Promises.exists(u);$.token.isCancellationRequested||(k?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(u,!1))):this.J(r))},p.a);t.clear(),t.add((0,O.$Sc)(()=>clearTimeout(v)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){$.token.isCancellationRequested||this.O(`Failed to watch ${u} for changes using fs.watch() (${r.toString()})`),this.D()}}J(u){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:u,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(u,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!m&&this.g.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${u.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}M(u){const m=(0,c.$Pq)(u),d=[];for(const t of m){if((0,c.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}d.push(t)}if(d.length===0)return;if(this.z)for(const t of d)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(u){if(f.$k)return h.Promises.exists(u);try{const m=(0,C.$nc)(u);return(await h.Promises.readdir((0,C.$mc)(u))).some($=>$===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(u){this.z=u}O(u){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}P(u){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}Q(u){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}R(u){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${u}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=p;async function g(l,u,m,d,$=512){const t=await h.Promises.open(l,"r"),r=Buffer.allocUnsafe($),n=new L.$oe(d);let s,i=!1;const o={path:l,excludes:[],recursive:!1},a=new p(o,void 0,b=>{(async()=>{for(const{type:S}of b)if(S===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:v}=await h.Promises.read(t,r,0,$,null);if(!v||n.token.isCancellationRequested)break;u(r.slice(0,v))}}catch(v){s=new Error(v),n.dispose(!0)}finally{i=!1}}})()});return await a.ready,m(),new Promise((b,S)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(t)}catch(v){s=new Error(v)}s?S(s):b()})})}}),define(ae[199],ce([0,1,3,90,197,5,198,40]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class C extends L.$3q{constructor(E){super(),this.M=E,this.onDidError=D.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const y=[],w=new Set(Array.from(this.watchers));for(const h of E){const c=this.S(h);c&&(0,N.$uk)(c.request.excludes,h.excludes)&&(0,N.$uk)(c.request.includes,h.includes)?w.delete(c):y.push(h)}y.length&&this.N(`Request to start watching: ${y.map(h=>this.J(h)).join(",")}`),w.size&&this.N(`Request to stop watching: ${Array.from(w).map(h=>this.J(h.request)).join(",")}`);for(const h of w)this.W(h);for(const h of y)this.U(h)}S(E){for(const y of this.watchers)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,I.$ug)(y.request.path,E.path,!A.$k))return y}U(E){const y=new O.$8q(E,this.M,h=>this.a.fire(h),()=>this.c.fire(E),h=>this.b.fire(h),this.P),w={request:E,instance:y};this.watchers.add(w)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const y=new Map;for(const w of E){const h=A.$k?w.path:w.path.toLowerCase();let c=y.get(w.correlationId);c||(c=new Map,y.set(w.correlationId,c)),c.has(h)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(w)}`),c.set(h,w)}return Array.from(y.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const y of this.watchers)y.instance.setVerboseLogging(E)}N(E,y){this.P&&this.b.fire({type:"trace",message:this.$(E,y)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,y){return y?`[File Watcher (node.js)] ${E} (${this.J(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$0q=C}),define(ae[200],ce([0,1,46,199]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class L extends D.$Mq{constructor(O,I,C){super(O,I,C),this.s()}r(O){return O.add(new N.$0q(void 0))}}e.$$q=L}),define(ae[201],ce([0,1,23,42,92,46]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class O extends A.$Nq{constructor(C,f,E){super(C,f,E),this.s()}r(C){const f=C.add(new L.$1q(D.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(f.onDidProcessExit(({code:E,signal:y})=>this.t(`terminated by itself with code ${E}, signal: ${y} (ETERM)`))),N.ProxyChannel.toService((0,N.$di)(f.getChannel("watcher")))}}e.$2q=O}),define(ae[74],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class D{constructor(...L){this.a=new Map;for(const[A,O]of L)this.set(A,O)}set(L,A){const O=this.a.get(L);return this.a.set(L,A),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ui=D}),define(ae[202],ce([0,1,6,7,2,72,192,4,74,86]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const E=!1;class y extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new C.$ui,l=!1,u,m=E){this.i=g,this.j=l,this.k=u,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$vi,this),this._globalGraph=m?u?._globalGraph??new O.$br(d=>d):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const g of this.g)(0,L.$Oc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const l=new class extends w{dispose(){this.h.delete(l),super.dispose()}}(g,this.j,this,this.l);return this.h.add(l),l}invokeFunction(g,...l){this.m();const u=c.traceInvocation(this.l,g);let m=!1;try{return g({get:$=>{if(m)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s($,u);if(!t)throw new Error(`[invokeFunction] unknown service '${$}'`);return t}},...l)}finally{m=!0,u.stop()}}createInstance(g,...l){this.m();let u,m;return g instanceof A.$ti?(u=c.traceCreation(this.l,g.ctor),m=this.o(g.ctor,g.staticArguments.concat(l),u)):(u=c.traceCreation(this.l,g),m=this.o(g,l,u)),u.stop(),m}o(g,l=[],u){const m=I._util.getServiceDependencies(g).sort((t,r)=>t.index-r.index),d=[];for(const t of m){const r=this.s(t.id,u);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(r)}const $=m.length>0?m[0].index:l.length;if(l.length!==$){console.trace(`[createInstance] First service dependency of ${g.name} at position ${$+1} conflicts with ${l.length} static arguments`);const t=$-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,$)}return Reflect.construct(g,l.concat(d))}q(g,l){if(this.i.get(g)instanceof A.$ti)this.i.set(g,l);else if(this.k)this.k.q(g,l);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const l=this.i.get(g);return!l&&this.k?this.k.r(g):l}s(g,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const u=this.r(g);return u instanceof A.$ti?this.u(g,u,l.branch(g,!0)):(l.branch(g,!1),u)}u(g,l,u){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,l,u)}finally{this.t.delete(g)}}v(g,l,u){const m=new O.$br(t=>t.id.toString());let d=0;const $=[{id:g,desc:l,_trace:u}];for(;$.length;){const t=$.pop();if(m.lookupOrInsertNode(t),d++>1e3)throw new y(m);for(const r of I._util.getServiceDependencies(t.desc.ctor)){const n=this.r(r.id);if(n||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof A.$ti){const s={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,s),$.push(s)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new y(m);break}for(const{data:r}of t){if(this.r(r.id)instanceof A.$ti){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}m.removeNode(r)}}return this.r(g)}w(g,l,u=[],m,d){if(this.i.get(g)instanceof A.$ti)return this.x(g,l,u,m,d,this.g);if(this.k)return this.k.w(g,l,u,m,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}x(g,l,u=[],m,d,$){if(m){const t=new w(void 0,this.j,this,this.l);t.c=String(g);const r=new Map,n=new D.$Ph(()=>{const s=t.o(l,u,d);for(const[i,o]of r){const a=s[i];if(typeof a=="function")for(const b of o)b.disposable=a.apply(s,b.listener)}return r.clear(),$.add(s),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=r.get(i);return b||(b=new f.$5c,r.set(i,b)),(v,k,P)=>{if(n.isInitialized)return n.value[i](v,k,P);{const R={listener:[v,k,P],disposable:void 0},F=b.push(R);return(0,L.$Sc)(()=>{F(),R.disposable?.dispose()})}}}if(i in s)return s[i];const o=n.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),s[i]=a),a},set(s,i,o){return n.value[i]=o,!0},getPrototypeOf(s){return l.prototype}})}else{const t=this.o(l,u,d);return $.add(t),t}}y(g,l){if(l&&console.warn(g),this.j)throw new Error(g)}}e.$cr=w;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,l){return g?new c(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(g,l){return g?new c(1,l.name):c.c}static{this.f=0}constructor(g,l){this.type=g,this.name=l,this.g=Date.now(),this.h=[]}branch(g,l){const u=new c(3,g.toString());return this.h.push([g,l,u]),u}stop(){const g=Date.now()-this.g;c.f+=g;let l=!1;function u(d,$){const t=[],r=new Array(d+1).join("	");for(const[n,s,i]of $.h)if(s&&i){l=!0,t.push(`${r}CREATES -> ${n}`);const o=u(d+1,i);o&&t.push(o)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(g>2||l)&&c.all.add(m.join(`
`))}}e.$dr=c}),define(ae[56],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0,e.$Udc=(0,D.$wi)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$Vdc=N}),define(ae[75],ce([0,1,26,2,5,167,29,4]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=void 0,e.$Qr=C;function C(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Rr=(0,I.$wi)("languagePackService");let f=class extends N.$Uc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new D.$oe;setTimeout(()=>y.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const c=w.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(g=>g.startsWith("lp-"))).map(p=>{const g=p.properties.localizedLanguages?.[0],l=C(p);return{...this.f(l,g,p),extensionId:p.identifier.id,galleryExtension:p}});return c.push(this.f("en","English")),c}f(y,w,h){const c=w??y;let p;if(c!==y&&(p=`(${y})`),y.toLowerCase()===L.$w.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),h?.installCount){p??="";const g=h.installCount;let l;g>1e6?l=`${Math.floor(g/1e5)/10}M`:g>1e3?l=`${Math.floor(g/1e3)}K`:l=String(g),p+=` $(cloud-download) ${l}`}return{id:y,label:c,description:p}}};e.$Sr=f,e.$Sr=f=ve([Q(0,O.$6o)],f)}),define(ae[203],ce([0,1,2,75]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;let L=class extends D.$Uc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$jec=L,e.$jec=L=ve([Q(0,N.$Rr)],L)}),define(ae[9],ce([0,1,168,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=p,e.log=l,e.$ek=a,e.$fk=b,e.$gk=S,e.$hk=v,e.$3j=(0,h.$wi)("logService"),e.$4j=(0,h.$wi)("loggerService");function c(){return new Date().toISOString()}function p(k){return(0,E.$ag)(k)}var g;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$6j=g.Info;function l(k,P,R){switch(P){case g.Trace:k.trace(R);break;case g.Debug:k.debug(R);break;case g.Info:k.info(R);break;case g.Warning:k.warn(R);break;case g.Error:k.error(R);break;case g.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function u(k,P=!1){let R="";for(let F=0;F<k.length;F++){let T=k[F];if(T instanceof Error&&(T=(0,N.$hj)(T,P)),typeof T=="object")try{T=JSON.stringify(T)}catch{}R+=(F>0?" ":"")+T}return R}class m extends O.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new L.$de),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==g.Off&&this.b<=P}}e.$8j=m;class d extends m{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...R){this.f(g.Trace)&&this.g(g.Trace,u([P,...R],!0))}debug(P,...R){this.f(g.Debug)&&this.g(g.Debug,u([P,...R]))}info(P,...R){this.f(g.Info)&&this.g(g.Info,u([P,...R]))}warn(P,...R){this.f(g.Warning)&&this.g(g.Warning,u([P,...R]))}error(P,...R){if(this.f(g.Error))if(P instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=P.stack,this.g(g.Error,u(F))}else this.g(g.Error,u([P,...R]))}flush(){}}e.$9j=d;class $ extends m{constructor(P=e.$6j){super(),this.setLevel(P),this.g=!C.$i}trace(P,...R){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...R):console.log(`[main ${c()}]`,P,...R))}debug(P,...R){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...R):console.log(`[main ${c()}]`,P,...R))}info(P,...R){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...R):console.log(`[main ${c()}]`,P,...R))}warn(P,...R){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,P,...R):console.warn(`[main ${c()}]`,P,...R))}error(P,...R){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,P,...R):console.error(`[main ${c()}]`,P,...R))}flush(){}}e.$0j=$;class t extends m{constructor(P=e.$6j,R=!0){super(),this.g=R,this.setLevel(P)}trace(P,...R){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...R):console.log(P,...R))}debug(P,...R){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...R):console.log(P,...R))}info(P,...R){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...R):console.log(P,...R))}warn(P,...R){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...R):console.log(P,...R))}error(P,...R){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...R):console.error(P,...R))}flush(){}}e.$$j=t;class r extends m{constructor(P,R=e.$6j){super(),this.g=P,this.setLevel(R)}trace(P,...R){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(P),...R])}debug(P,...R){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(P),...R])}info(P,...R){this.f(g.Info)&&this.g.log(g.Info,[this.h(P),...R])}warn(P,...R){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(P),...R])}error(P,...R){this.f(g.Error)&&this.g.log(g.Error,[this.h(P),...R])}h(P){return typeof P=="string"?P:(0,N.$hj)(P,this.f(g.Trace))}flush(){}}e.$_j=r;class n extends m{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const R of this.g)R.setLevel(P);super.setLevel(P)}trace(P,...R){for(const F of this.g)F.trace(P,...R)}debug(P,...R){for(const F of this.g)F.debug(P,...R)}info(P,...R){for(const F of this.g)F.info(P,...R)}warn(P,...R){for(const F of this.g)F.warn(P,...R)}error(P,...R){for(const F of this.g)F.error(P,...R)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$ak=n;class s extends O.$Uc{constructor(P,R,F){if(super(),this.h=P,this.j=R,this.b=new I.$Ac,this.c=this.B(new L.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$de),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(P){return(0,E.$9f)(P)?[...this.b.values()].find(R=>R.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,R){const F=this.n(P),T=(0,E.$9f)(P)?P:R?.id??(0,A.$kj)(F.toString()).toString(16);let q=this.b.get(F)?.logger;const Y=R?.logLevel==="always"?g.Trace:R?.logLevel;q||(q=this.s(F,Y??this.getLogLevel(F)??this.h,{...R,id:T}));const J={logger:q,info:{resource:F,id:T,logLevel:Y,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(J.info),this.b.set(F,J),q}n(P){return(0,E.$9f)(P)?(0,f.$0g)(this.j,`${P}.log`):P}setLogLevel(P,R){if(y.URI.isUri(P)){const F=P,T=R,q=this.b.get(F);q&&T!==q.info.logLevel&&(q.info.logLevel=T===this.h?void 0:T,q.logger?.setLevel(T),this.b.set(q.info.resource,q),this.f.fire([F,T]))}else{this.h=P;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,R){const F=this.m(P);F&&R!==!F.info.hidden&&(F.info.hidden=!R,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,R]))}getLogLevel(P){let R;return P&&(R=this.b.get(P)?.info.logLevel),R??this.h}registerLogger(P){const R=this.b.get(P.resource);R?R.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const R=this.b.get(P);R&&(R.logger&&R.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=s;class i{constructor(){this.onDidChangeLogLevel=new L.$de().event}setLevel(P){}getLevel(){return g.Info}trace(P,...R){}debug(P,...R){}info(P,...R){}warn(P,...R){}error(P,...R){}critical(P,...R){}dispose(){}flush(){}}e.$ck=i;class o extends i{}e.$dk=o;function a(k){if(k.verbose)return g.Trace;if(typeof k.logLevel=="string"){const P=v(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.$6j}function b(k){switch(k){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function S(k){switch(k){case g.Trace:return{original:"Trace",value:D.localize(0,null)};case g.Debug:return{original:"Debug",value:D.localize(1,null)};case g.Info:return{original:"Info",value:D.localize(2,null)};case g.Warning:return{original:"Warning",value:D.localize(3,null)};case g.Error:return{original:"Error",value:D.localize(4,null)};case g.Off:return{original:"Off",value:D.localize(5,null)}}}function v(k){switch(k){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ik=new w.$Nj("logLevel",b(g.Info))}),define(ae[204],ce([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,D,N,L,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;let y=class extends L.$Uc{constructor(h,c){super(),this.a=h,this.b=c,this.B(new D.$Ih(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,I.$7g)(this.a.logsHome),c=(0,I.$9g)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,l=(await C.Promises.readdir(c)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==h),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(m=>C.Promises.rm((0,O.$jc)(c,m)))))}catch(h){(0,N.$1)(h)}}};e.$kec=y,e.$kec=y=ve([Q(0,f.$Di),Q(1,E.$3j)],y)}),define(ae[205],ce([0,1,17,6,7,3,40,2,14,46,9]),function(ne,e,D,N,L,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class y extends I.$Uc{constructor(h,c){super(),this.a=h,this.b=c,this.c=this.B(new A.$de),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$de),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$uh(0)),this.w=[],this.y=this.B(new N.$uh(0))}watch(h,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(h,c):this.z(h,c)}n(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},g=(0,D.$Tb)(this.j,p);return this.r(),(0,I.$Sc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(h=>(0,L.$1)(h))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,f.$Oq)(c)),c=>this.G(c),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const h=this.b?.watcher?.recursive?.usePolling;if(h===!0)for(const c of this.j)(0,f.$Kq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const c of this.j)(0,f.$Kq)(c)&&h.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},g=(0,D.$Tb)(this.w,p);return this.C(),(0,I.$Sc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(h=>(0,L.$1)(h))}D(){return this.u||(this.u=this.B(this.F(h=>this.c.fire((0,f.$Oq)(h)),h=>this.G(h),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(h){h.type==="error"&&this.g.fire(h.message),this.H(h)}H(h){this.a[h.type](h.message)}I(h){return(0,C.$hc)(h.fsPath)}J(h){const c=this.I(h);return(0,O.$yg)(c)}}e.$Uq=y}),define(ae[206],ce([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let $=class extends f.$Uc{static{d=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new O.$de),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$de),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$de),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$de),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$de),this.Y=this.B(new O.$de),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$de),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$Fh)}registerProvider(r,n){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${r}`);const s=new f.$Tc;return this.h.set(r,n),this.c.fire({added:!0,scheme:r,provider:n}),s.add(n.onDidChangeFile(i=>{const o=new g.$jl(i,!this.S(n));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.Z.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:r}))),(0,f.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:n}),this.h.delete(r),(0,f.$Pc)(s)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const n=[];this.f.fire({scheme:r,join(s){n.push(s)}}),!this.h.has(r)&&await N.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,n){const s=this.h.get(r.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return C.Iterable.map(this.h,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async j(r){if(!(0,h.$bh)(r))throw new g.$ll((0,p.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const n=this.h.get(r.scheme);if(!n){const s=new m.$bb;throw s.message=(0,p.localize)(1,null,r.toString()),s}return n}async m(r){const n=await this.j(r);if((0,g.$9k)(n)||(0,g.$6k)(n)||(0,g.$0k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const n=await this.j(r);if((0,g.$9k)(n)||(0,g.$6k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.s(r,n)}catch(s){throw(0,g.$gl)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.$ll((0,p.localize)(2,null,this.sb(r)),1):(0,g.$el)(s)}}async s(r,n){const s=await this.j(r),i=this.S(s),o=n?.resolveTo,a=n?.resolveSingleChildDescendants,b=n?.resolveMetadata,S=await s.stat(r);let v;return this.t(s,r,S,void 0,!!b,(k,P)=>(v||(v=E.$Ci.forUris(()=>!i),v.set(r,!0),o&&v.fill(!0,o)),v.get(k.resource)||v.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?P===1:!1))}async t(r,n,s,i,o,a){const{providerExtUri:b}=this.R(r),S={resource:n,name:b.basename(n),isFile:(s.type&g.FileType.File)!==0,isDirectory:(s.type&g.FileType.Directory)!==0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((s.permissions??0)&g.FilePermission.Locked),etag:(0,g.$wl)({mtime:s.mtime,size:s.size}),children:void 0};if(S.isDirectory&&a(S,i)){try{const v=await r.readdir(n),k=await N.Promises.settled(v.map(async([P,R])=>{try{const F=b.joinPath(n,P),T=o?await r.stat(F):{type:R};return await this.t(r,F,T,v.length,o,a)}catch(F){return this.b.trace(F),null}}));S.children=(0,D.$Hb)(k)}catch(v){this.b.trace(v),S.children=[]}return S}return S}async resolveAll(r){return N.Promises.settled(r.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.j(r),s=await n.stat(r);return this.t(n,r,s,void 0,!0,()=>!1)}async exists(r){const n=await this.j(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.u(r,n)}catch(s){return s}return!0}async u(r,n){if(!n?.overwrite&&await this.exists(r))throw new g.$ll((0,p.localize)(3,null,this.sb(r)),3,n)}async createFile(r,n=L.$Fe.fromString(""),s){await this.u(r,s);const i=await this.writeFile(r,n);return this.r.fire(new g.$il(r,0,i)),i}async writeFile(r,n,s){const i=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(i);let a=s;if((0,g.$_k)(i)&&!a?.atomic){const b=i.enforceAtomicWriteFile?.(r);b&&(a={...s,atomic:b})}try{await this.w(i,r,a)||await this.U(i,o.dirname(r));let S;if((0,g.$6k)(i)&&!(n instanceof L.$Fe))if((0,c.$re)(n)){const v=await(0,c.$ye)(n,3);v.ended?S=L.$Fe.concat(v.buffer):S=v}else S=(0,c.$ve)(n,v=>L.$Fe.concat(v),3);else S=n;!(0,g.$9k)(i)||(0,g.$6k)(i)&&S instanceof L.$Fe||(0,g.$6k)(i)&&(0,g.$_k)(i)&&a?.atomic?await this.hb(i,r,a,S):await this.db(i,r,a,S instanceof L.$Fe?(0,L.$Qe)(S):S),this.r.fire(new g.$il(r,4))}catch(b){throw new g.$ll((0,p.localize)(4,null,this.sb(r),(0,g.$el)(b).toString()),(0,g.$hl)(b),a)}return this.resolve(r,{resolveMetadata:!0})}async w(r,n,s){const i=!!s?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(r.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(r.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(i)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await r.stat(n)}catch{return}if(a.type&g.FileType.Directory)throw new g.$ll((0,p.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.$vl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,g.$wl)({mtime:s.mtime,size:a.size}))throw new g.$ll((0,p.localize)(10,null),3,s);return a}async readFile(r,n,s){const i=await this.m(r);return n?.atomic?this.z(i,r,n,s):this.C(i,r,n,s)}async z(r,n,s,i){return new Promise((o,a)=>{this.cb.queueFor(n,async()=>{try{const b=await this.C(r,n,s,i);o(b)}catch(b){a(b)}},this.R(r).providerExtUri)})}async C(r,n,s,i){const o=await this.D(r,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,L.$Re)(o.value)}}async readFileStream(r,n,s){const i=await this.m(r);return this.D(i,r,n,s)}async D(r,n,s,i){const o=new A.$oe(i);let a=s;(0,g.$$k)(r)&&r.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const b=this.J(n,a).then(v=>v,v=>{throw o.dispose(!0),v});let S;try{return typeof a?.etag=="string"&&a.etag!==g.$vl&&await b,a?.atomic&&(0,g.$$k)(r)||!((0,g.$9k)(r)||(0,g.$0k)(r))||(0,g.$6k)(r)&&a?.preferUnbuffered?S=this.I(r,n,a):(0,g.$0k)(r)?S=this.G(r,n,o.token,a):S=this.H(r,n,o.token,a),S.on("end",()=>o.dispose()),S.on("error",()=>o.dispose()),{...await b,value:S}}catch(v){throw S&&await(0,c.$we)(S),this.F(v,n,a)}}F(r,n,s){const i=(0,p.localize)(11,null,this.sb(n),(0,g.$el)(r).toString());return r instanceof g.$nl?new g.$nl(i,r.stat,s):r instanceof g.$ml?new g.$ml(i,r.fileOperationResult,r.size,r.options):new g.$ll(i,(0,g.$hl)(r),s)}G(r,n,s,i=Object.create(null)){const o=r.readFileStream(n,i,s);return(0,c.$Ce)(o,{data:a=>a instanceof L.$Fe?a:L.$Fe.wrap(a),error:a=>this.F(a,n,i)},a=>L.$Fe.concat(a))}H(r,n,s,i=Object.create(null)){const o=(0,L.$Ve)();return(0,l.$Hq)(r,n,o,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,n,i)},s),o}I(r,n,s){const i=(0,c.$te)(o=>L.$Fe.concat(o));return(async()=>{try{let o;s?.atomic&&(0,g.$$k)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.L(n,o.byteLength,s),i.end(L.$Fe.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async J(r,n){const s=await this.resolve(r,{resolveMetadata:!0});if(s.isDirectory)throw new g.$ll((0,p.localize)(12,null,this.sb(r)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.$vl&&n.etag===s.etag)throw new g.$nl((0,p.localize)(13,null),s,n);return this.L(r,s.size,n),s}L(r,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new g.$ml((0,p.localize)(14,null,this.sb(r)),7,n,s)}async canMove(r,n,s){return this.M(r,n,"move",s)}async canCopy(r,n,s){return this.M(r,n,"copy",s)}async M(r,n,s,i){if(r.toString()!==n.toString())try{const o=s==="move"?this.qb(await this.n(r),r):await this.m(r),a=this.qb(await this.n(n),n);await this.Q(o,r,a,n,s,i)}catch(o){return o}return!0}async move(r,n,s){const i=this.qb(await this.n(r),r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"move",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$il(r,a==="move"?2:3,b)),b}async copy(r,n,s){const i=await this.m(r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"copy",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$il(r,a==="copy"?3:2,b)),b}async N(r,n,s,i,o,a){if(n.toString()===i.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:S}=await this.Q(r,n,s,i,o,a);if(b&&!S&&a&&await this.del(i,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(i)),o==="copy"){if(r===s&&(0,g.$7k)(r))await r.copy(n,i,{overwrite:a});else{const v=await this.resolve(n);v.isDirectory?await this.P(r,v,s,i):await this.O(r,n,s,i)}return o}else return r===s?(await r.rename(n,i,{overwrite:a}),o):(await this.N(r,n,s,i,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(r,n,s,i){if((0,g.$9k)(r)&&(0,g.$9k)(s))return this.jb(r,n,s,i);if((0,g.$9k)(r)&&(0,g.$6k)(s))return this.pb(r,n,s,i);if((0,g.$6k)(r)&&(0,g.$9k)(s))return this.nb(r,n,s,i);if((0,g.$6k)(r)&&(0,g.$6k)(s))return this.lb(r,n,s,i)}async P(r,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async o=>{const a=this.R(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),s,a):this.O(r,o.resource,s,a)}))}async Q(r,n,s,i,o,a){let b=!1;if(r===s){const{providerExtUri:v,isPathCaseSensitive:k}=this.R(r);if(k||(b=v.isEqual(n,i)),b&&o==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(i)));if(!b&&v.isEqualOrParent(i,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(i)))}const S=await this.exists(i);if(S&&!b){if(!a)throw new g.$ll((0,p.localize)(17,null,this.sb(n),this.sb(i)),4);if(r===s){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(n,i))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(i)))}}return{exists:S,isSameResourceWithDifferentPathCase:b}}R(r){const n=this.S(r);return{providerExtUri:n?h.$Zg:h.$2g,isPathCaseSensitive:n}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const n=this.qb(await this.j(r),r);await this.U(n,r);const s=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$il(r,0,s)),s}async U(r,n){const s=[],{providerExtUri:i}=this.R(r);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await r.stat(n)).type&g.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(o){if((0,g.$gl)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await r.mkdir(n)}catch(a){if((0,g.$gl)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(r,n){try{await this.W(r,n)}catch(s){return s}return!0}async W(r,n){const s=this.qb(await this.j(r),r),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(r)));const o=n?.atomic;if(o&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(r)));if(i&&o)throw new Error((0,p.localize)(22,null,this.sb(r)));let a;try{a=await s.stat(r)}catch{}if(a)this.rb(r,a);else throw new g.$ll((0,p.localize)(23,null,this.sb(r)),1);if(!!!n?.recursive){const S=await this.resolve(r);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(r)))}return s}async del(r,n){const s=await this.W(r,n);let i=n;if((0,g.$al)(s)&&!i?.atomic){const S=s.enforceAtomicDelete?.(r);S&&(i={...n,atomic:S})}const o=!!i?.useTrash,a=!!i?.recursive,b=i?.atomic??!1;await s.delete(r,{recursive:a,useTrash:o,atomic:b}),this.r.fire(new g.$il(r,1))}async cloneFile(r,n){const s=await this.j(r),i=this.qb(await this.n(n),n);if(!(s===i&&this.R(s).providerExtUri.isEqual(r,n)))return s===i&&(0,g.$8k)(s)?s.cloneFile(r,n):(await this.U(i,this.R(i).providerExtUri.dirname(n)),s===i&&(0,g.$7k)(s)?this.cb.queueFor(r,()=>s.copy(r,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(r,()=>this.O(s,r,i,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:d.ab++})}watch(r,n={recursive:!1,excludes:[]}){const s=new f.$Tc;let i=!1,o=()=>{i=!0};s.add((0,f.$Sc)(()=>o())),(async()=>{try{const b=await this.bb(r,n);i?(0,f.$Pc)(b):o=()=>(0,f.$Pc)(b)}catch(b){this.b.error(b)}})();const a=n.correlationId;if(typeof a=="number"){const b=s.add(new O.$de);return s.add(this.X.event(v=>{v.correlates(a)&&b.fire(v)})),{onDidChange:b.event,dispose:()=>s.dispose()}}return s}async bb(r,n){const s=await this.j(r),i=(0,I.$kj)([this.R(s).providerExtUri.getComparisonKey(r),n]);let o=this.$.get(i);return o||(o={count:0,disposable:s.watch(r,n)},this.$.set(i,o)),o.count+=1,(0,f.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,f.$Pc)(o.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,f.$Pc)(r.disposable);this.$.clear()}async db(r,n,s,i){return this.cb.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,c.$re)(i)||(0,c.$se)(i)?await this.eb(r,o,i):await this.fb(r,o,i)}catch(a){throw(0,g.$el)(a)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,n,s){let i=0,o;if((0,c.$se)(s)){if(s.buffer.length>0){const a=L.$Fe.concat(s.buffer);await this.gb(r,n,a,a.byteLength,i,0),i+=a.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((a,b)=>{(0,c.$xe)(o,{onData:async S=>{o.pause();try{await this.gb(r,n,S,S.byteLength,i,0)}catch(v){return b(v)}i+=S.byteLength,setTimeout(()=>o.resume())},onError:S=>b(S),onEnd:()=>a()})})}async fb(r,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.gb(r,n,o,o.byteLength,i,0),i+=o.byteLength}async gb(r,n,s,i,o,a){let b=0;for(;b<i;){const S=await r.write(n,o+b,s.buffer,a+b,i-b);b+=S}}async hb(r,n,s,i){return this.cb.queueFor(n,()=>this.ib(r,n,s,i),this.R(r).providerExtUri)}async ib(r,n,s,i){let o;i instanceof L.$Fe?o=i:(0,c.$re)(i)?o=await(0,L.$Re)(i):(0,c.$se)(i)?o=await(0,L.$Se)(i):o=(0,L.$Pe)(i),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(r,n,s,i){return this.cb.queueFor(i,()=>this.kb(r,n,s,i),this.R(s).providerExtUri)}async kb(r,n,s,i){let o,a;try{o=await r.open(n,{create:!1}),a=await s.open(i,{create:!0,unlock:!1});const b=L.$Fe.alloc(this.a);let S=0,v=0,k=0;do k=await r.read(o,S,b.buffer,v,b.byteLength-v),await this.gb(s,a,b,k,S,v),S+=k,v+=k,v===b.byteLength&&(v=0);while(k>0)}catch(b){throw(0,g.$el)(b)}finally{await N.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(r,n,s,i){return this.cb.queueFor(i,()=>this.mb(r,n,s,i),this.R(s).providerExtUri)}async mb(r,n,s,i){return s.writeFile(i,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,n,s,i){return this.cb.queueFor(i,()=>this.ob(r,n,s,i),this.R(s).providerExtUri)}async ob(r,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const a=await r.readFile(n);await this.gb(s,o,L.$Fe.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.$el)(a)}finally{await s.close(o)}}async pb(r,n,s,i){const o=await(0,L.$Re)(this.H(r,n,A.CancellationToken.None));await this.hb(s,i,void 0,o)}qb(r,n){if(r.capabilities&2048)throw new g.$ll((0,p.localize)(25,null,this.sb(n)),6);return r}rb(r,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.$ll((0,p.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===y.Schemas.file?r.fsPath:r.toString(!0)}};e.$Iq=$,e.$Iq=$=d=ve([Q(0,u.$3j)],$)}),define(ae[207],ce([0,1,41,277,6,34,15,3,40,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$hj)(r)}`)}})();class t extends u.$Uq{static{this.L=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.P=new A.$Ac(i=>w.$1g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,y.$k&&(this.M|=1024)),this.M}async stat(n){try{const{stat:s,symbolicLink:i}=await c.SymlinkSupport.stat(this.I(n));return{type:this.O(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.hb(s)}}async N(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await c.Promises.readdir(this.I(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,w.$0g)(n,o.name))).type:a=this.O(o),i.push([o.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.hb(s)}}O(n,s){let i;return s?.dangling?i=g.FileType.Unknown:n.isFile()?i=g.FileType.File:n.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,s&&(i|=g.FileType.SymbolicLink),i}async Q(n){const s=this.I(n);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.P.get(n);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const o=new L.$vh;return this.P.set(n,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,f.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.P.get(n)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.P.delete(n)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),i=await this.Q(n));const o=this.I(n);return await c.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{i?.dispose()}}R(n){t.L&&this.a.trace(n)}readFileStream(n,s,i){const o=(0,h.$te)(a=>O.$Fe.concat(a.map(b=>O.$Fe.wrap(b))).buffer);return(0,l.$Hq)(this,n,o,a=>a.buffer,{...s,bufferSize:256*1024},i),o}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(n)?this.U(n,(0,w.$0g)((0,w.$9g)(n),`${(0,w.$7g)(n)}${i.atomic.postfix}`),s,i):this.W(n,s,i)}async S(n){try{const s=this.I(n),{symbolicLink:i}=await c.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async U(n,s,i,o){const a=new f.$Tc;try{a.add(await this.Q(n)),a.add(await this.Q(s)),await this.W(s,i,o,!0);try{await this.rename(s,n,{overwrite:!0})}catch(b){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{a.dispose()}}async W(n,s,i,o){let a;try{const b=this.I(n);if(!i.create||!i.overwrite){if(await c.Promises.exists(b)){if(!i.overwrite)throw(0,g.$dl)((0,p.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.$dl)((0,p.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:i.unlock},o),await this.write(a,0,s,0,s.byteLength)}catch(b){throw await this.ib(n,b)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(n){t.$=n}async open(n,s,i){const o=this.I(n);let a;(0,g.$4k)(s)&&!i&&(a=await this.Q(n));let b;try{if((0,g.$4k)(s)&&s.unlock)try{const{stat:v}=await c.SymlinkSupport.stat(o);v.mode&128||await c.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let S;if((0,g.$4k)(s)){if(y.$i)try{await c.Promises.truncate(o,0),S="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}S||(S="w")}else S="r";b=await c.Promises.open(o,S)}catch(S){throw a?.dispose(),(0,g.$4k)(s)?await this.ib(n,S):this.hb(S)}if(this.X.set(b,0),(0,g.$4k)(s)&&this.Z.set(b,n),a){const S=this.Y.get(b);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${o})`),this.Y.set(b,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${o})`),S.dispose())}return b}async close(n){const s=this.Y.get(n);try{if(this.X.delete(n),this.Z.delete(n)&&t.$)try{await c.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await c.Promises.close(n)}catch(i){throw this.hb(i)}finally{s&&(this.Y.get(n)===s&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.Y.delete(n)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,o,a){const b=this.ab(n,s);let S=null;try{S=(await c.Promises.read(n,i,o,a,b)).bytesRead}catch(v){throw this.hb(v)}finally{this.bb(n,b,S)}return S}ab(n,s){return s===this.X.get(n)?null:s}bb(n,s,i){const o=this.X.get(n);typeof o=="number"&&(typeof s=="number"||(typeof i=="number"?this.X.set(n,o+i):this.X.delete(n)))}async write(n,s,i,o,a){return(0,L.$Qh)(()=>this.cb(n,s,i,o,a),100,3)}async cb(n,s,i,o,a){const b=this.ab(n,s);let S=null;try{S=(await c.Promises.write(n,i,o,a,b)).bytesWritten}catch(v){throw await this.ib(this.Z.get(n),v)}finally{this.bb(n,b,S)}return S}async mkdir(n){try{await c.Promises.mkdir(this.I(n))}catch(s){throw this.hb(s)}}async delete(n,s){try{const i=this.I(n);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,E.$jc)((0,E.$mc)(i),`${(0,E.$nc)(i)}${s.atomic.postfix}`)),await c.Promises.rm(i,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(i)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let a=!1;try{const{stat:b,symbolicLink:S}=await c.SymlinkSupport.stat(i);a=b.isDirectory()&&!S}catch{}if(a)await c.Promises.rmdir(i);else throw o}else throw o}}catch(i){throw this.hb(i)}}async rename(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"move",i.overwrite),await c.Promises.rename(o,a)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(2,null,(0,E.$nc)(o),(0,E.$nc)((0,E.$mc)(a)),b.toString()))),this.hb(b)}}async copy(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"copy",i.overwrite),await c.Promises.copy(o,a,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(3,null,(0,E.$nc)(o),(0,E.$nc)((0,E.$mc)(a)),b.toString()))),this.hb(b)}}async db(n,s,i,o){const a=this.I(n),b=this.I(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,C.$ug)(a,b,!0)),S){if(i==="copy")throw(0,g.$dl)((0,p.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const k=await this.N(n);if(!k)throw(0,g.$dl)((0,p.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(s);if(P){if(!o)throw(0,g.$dl)((0,p.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&P.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.eb(n,s,!1)}async eb(n,s,i){const o=this.I(n),a=this.I(s),b=!!(this.capabilities&1024);if((0,C.$ug)(o,a,!b))return;const S=new f.$Tc;try{S.add(await this.Q(n)),S.add(await this.Q(s)),i&&await c.Promises.mkdir((0,E.$mc)(a),{recursive:!0}),await c.Promises.copyFile(o,a)}catch(v){if(v.code==="ENOENT"&&!i)return this.eb(n,s,!0);throw this.hb(v)}finally{S.dispose()}}t(n,s,i){return new d.$2q(o=>n(o),o=>s(o),i)}F(n,s,i){return new $.$$q(o=>n(o),o=>s(o),i)}hb(n){if(n instanceof g.$cl)return n;let s=n,i;switch(n.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.$dl)(s,i)}async ib(n,s){let i=this.hb(s);if(n&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.I(n));o.mode&128||(i=(0,g.$dl)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return i}}e.$_q=t}),define(ae[99],ce([0,1,3,2,4,9]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0,e.$Jec=(0,L.$wi)("sharedProcessLifecycleService");let O=class extends N.$Uc{constructor(C){super(),this.b=C,this.a=this.B(new D.$de),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Kec=O,e.$Kec=O=ve([Q(0,A.$3j)],O)}),define(ae[208],ce([0,1,8,3,9,2]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=void 0;class O extends L.$bk{constructor(y,w,h,c,p){super(w,h,c),this.r=y,this.t=p,this.B(p.listen("onDidChangeLogLevel",y)(g=>{(0,L.$5j)(g)?super.setLogLevel(g):super.setLogLevel(D.URI.revive(g[0]),g[1])})),this.B(p.listen("onDidChangeVisibility",y)(([g,l])=>super.setVisibility(D.URI.revive(g),l))),this.B(p.listen("onDidChangeLoggers",y)(({added:g,removed:l})=>{for(const u of g)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$_j({log:(y,w)=>{this.t.call("consoleLog",[y,w])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,w){super.setLogLevel(y,w),this.t.call("setLogLevel",[y,w])}setVisibility(y,w){super.setVisibility(y,w),this.t.call("setVisibility",[this.n(y),w])}s(y,w,h){return new I(this.t,y,w,h,this.r)}static setLogLevel(y,w,h){return y.call("setLogLevel",[w,h])}}e.$_r=O;class I extends L.$9j{constructor(y,w,h,c,p){super(c?.logLevel==="always"),this.r=y,this.s=w,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[w,c,p]).then(()=>{this.u(this.n),this.m=!0})}g(y,w){const h=[[y,w]];this.m?this.u(h):this.n.push(...h)}u(y){this.r.call("log",[this.s,y])}}class C{constructor(y,w){this.a=y,this.b=w}listen(y,w){const h=this.b(y);switch(w){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(p=>this.c(p,h)),removed:[...c.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,c=>[h.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,c=>(0,L.$5j)(c)?c:[h.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${w}`)}async call(y,w,h){const c=this.b(y);switch(w){case"setLogLevel":return(0,L.$5j)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(D.URI.revive(c.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,c)))}throw new Error(`Call not found: ${w}`)}c(y,w){return{...y,resource:w.transformOutgoingURI(y.resource)}}}e.$as=C;class f extends A.$Uc{constructor(y,w){super(),w.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(h=>w.call("setLogLevel",[h]))),w.call("getRegisteredLoggers").then(h=>{for(const c of h)y.registerLogger({...c,resource:D.URI.revive(c.resource)})}),this.B(w.listen("onDidChangeVisibility")(([h,c])=>y.setVisibility(D.URI.revive(h),c))),this.B(w.listen("onDidChangeLoggers")(({added:h,removed:c})=>{for(const p of h)y.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of c)y.deregisterLogger(p.resource)}))}}e.$bs=f}),define(ae[209],ce([0,1,2,9]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=void 0;class L extends D.$Uc{constructor(O,I=[]){super(),this.a=new N.$ak([O,...I]),this.B(O.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$ZQ=L}),define(ae[57],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0,e.$Fcc=(0,D.$wi)("nativeHostService")}),define(ae[210],ce([0,1,42,56]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;let L=class{constructor(O,I){return this.windowId=O,D.ProxyChannel.toService(I.getChannel("nativeHost"),{context:O,properties:(()=>{const C=new Map;return C.set("windowId",O),C})()})}};e.$1dc=L,e.$1dc=L=ve([Q(1,N.$Udc)],L)}),define(ae[58],ce([0,1,3,61,2,4]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=void 0,e.$eo=(0,A.$wi)("policy");class O extends L.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$de),this.onDidChange=this.h.event}async updatePolicyDefinitions(f){const E=Object.keys(this.f).length;return this.f={...f,...this.f},E!==Object.keys(this.f).length&&await this.j(f),N.Iterable.reduce(this.g.entries(),(y,[w,h])=>({...y,[w]:h}),{})}getPolicyValue(f){return this.g.get(f)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(f,[E,y])=>({...f,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$fo=O;class I{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$go=I}),define(ae[211],ce([0,1,3,2,58]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0;class A{constructor(C){this.b=C,this.a=new N.$Tc}listen(C,f){switch(f){case"onDidChange":return D.Event.map(this.b.onDidChange,E=>E.reduce((y,w)=>({...y,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${f}`)}call(C,f,E){switch(f){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${f}`)}dispose(){this.a.dispose()}}e.$qdc=A;class O extends L.$fo{constructor(C,f){super(),this.a=f;for(const E in C){const{definition:y,value:w}=C[E];this.f[E]=y,w!==void 0&&this.g.set(E,w)}this.a.listen("onDidChange")(E=>{for(const y in E){const w=E[y];w===null?this.g.delete(y):this.g.set(y,w)}this.h.fire(Object.keys(E))})}async j(C){const f=await this.a.call("updatePolicyDefinitions",C);for(const E in f)this.g.set(E,f[E])}}e.$rdc=O}),define(ae[100],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ae[24],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,D.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(ae[212],ce([0,1,6,7,2,14,31,9,24]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;let f=class extends L.$Uc{constructor(y,w,h){super(),this.b=w,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this.B(new D.$Ih(()=>{this.f(y)},3e4)).schedule()}async f(y){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),h=(0,A.$mc)(y),c=(0,A.$nc)(y),p=await O.Promises.readdir(h);await Promise.all(p.map(async g=>{if(g===c)return;const l=(0,A.$jc)(h,g),u=await O.Promises.stat(l);if(u.isDirectory()&&w-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),O.Promises.rm(l)}))}catch(w){(0,N.$1)(w)}}};e.$hec=f,e.$hec=f=ve([Q(1,C.$jk),Q(2,I.$3j)],f)}),define(ae[213],ce([0,1,6,7,2,14,31,16,9,24]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let E=class extends L.$Uc{constructor(w,h,c){super(),this.b=w,this.c=h,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$Ih(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),h=JSON.parse(await O.Promises.readFile((0,A.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const m=h[u];w[`${m.hash}.${u}`]=!0}const c=(0,A.$jc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(c))return;const g=await O.Promises.readdir(c);for(const u of g){if(w[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,A.$jc)(c,u))}const l=Date.now();for(const u of Object.keys(w)){const m=(0,A.$jc)(c,u),d=await O.Promises.readdir(m);for(const $ of d){if($==="tcf.json")continue;const t=(0,A.$jc)(m,$),r=await O.Promises.stat(t);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$jc)(u,$)}`),await O.Promises.rm(t))}}}catch(w){(0,N.$1)(w)}}};e.$iec=E,e.$iec=E=ve([Q(0,I.$Ei),Q(1,C.$3j),Q(2,f.$jk)],E)}),define(ae[214],ce([0,1,14,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$vG=void 0,e.$vG=(0,N.$wi)("IV8InspectProfilingService");var L;(function(A){function O(C){return!!(C.samples&&C.timeDeltas)}A.isValidProfile=O;function I(C,f="noAbsolutePaths"){for(const E of C.nodes)E.callFrame&&E.callFrame.url&&((0,D.$ic)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,D.$jc)(f,(0,D.$nc)(E.callFrame.url)));return C}A.rewriteAbsolutePaths=I})(L||(e.Utils=L={}))}),define(ae[215],ce([0,1,32]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const I=await(await new Promise((f,E)=>{ne(["v8-inspect-profiler"],f,E)})).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),C=(0,D.$Sg)();return this.a.set(C,I),C}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const I=await O.stop();return this.a.delete(A),I.profile}}e.$zec=N}),define(ae[43],ce([0,1,127,13]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class L{constructor(){this.a=new Map}add(O,I){D.ok(N.$9f(O)),D.ok(N.$$f(I)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$co=new L}),define(ae[101],ce([0,1,3,43]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function L(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this.b=new D.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,f){this.a[L(C)]=f,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$co.add(e.$do.JSONContribution,O)}),define(ae[47],ce([0,1,17,3,13,153,21,101,43]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=p,e.$to=g,e.$uo=l,e.$vo=m,e.$wo=d;var f;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$ho={Configuration:"base.contributions.configuration"};var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const y=C.$co.as(I.$do.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$de,this.onDidSchemaChange=this.i.event,this.j=new N.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.n(t,r,n),y.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.o(t,r),y.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.o(r,n),this.n(t,!1,n),y.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const n=[];for(const{overrides:s,source:i}of t)for(const o in s)if(r.add(o),e.$ro.test(o)){const a=this.a.get(o),b=a?.valuesSources??new Map;if(i)for(const P of Object.keys(s[o]))b.set(P,i);const S={...a?.value||{},...s[o]};this.a.set(o,{source:i,value:S,valuesSources:b});const v=(0,O.$aj)(o),k={type:"object",default:S,description:A.localize(1,null,v),$ref:e.$oo,defaultDefaultValue:S,source:L.$9f(i)?void 0:i,defaultValueSource:i};n.push(...p(o)),this.d[o]=k,this.b.properties[o]=k}else{this.a.set(o,{value:s[o],source:i});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(n)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:n,source:s}of t)for(const i in n){const o=this.a.get(i),a=L.$9f(s)?s:s?.id,b=L.$9f(o?.source)?o?.source:o?.source?.id;if(a===b)if(r.add(i),this.a.delete(i),e.$ro.test(i))delete this.d[i],delete this.b.properties[i];else{const S=this.d[i];S&&(this.w(i,S),this.r(i,S))}}this.u()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,n){t.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,r){const n=s=>{if(s.properties)for(const i in s.properties){r.add(i);const o=this.d[i];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,r=!0,n,s,i=3,o){i=L.$fg(t.scope)?i:t.scope;const a=t.properties;if(a)for(const S in a){const v=a[S];if(r&&m(S,v)){delete a[S];continue}if(v.source=n,v.defaultDefaultValue=a[S].default,this.w(S,v),e.$ro.test(S)?v.scope=void 0:(v.scope=L.$fg(v.scope)?i:v.scope,v.restricted=L.$fg(v.restricted)?!!s?.includes(S):v.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.f[S]=a[S],delete a[S];continue}else this.d[S]=a[S],a[S].policy?.name&&this.e.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),o.add(S)}const b=t.allOf;if(b)for(const S of b)this.p(S,r,n,s,i,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=n=>{const s=n.properties;if(s)for(const o in s)this.r(o,s[o]);n.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$io.properties[t]=r,r.scope){case 1:e.$jo.properties[t]=r;break;case 2:e.$ko.properties[t]=r;break;case 6:e.$lo.properties[t]=r;break;case 3:e.$mo.properties[t]=r;break;case 4:e.$no.properties[t]=r;break;case 5:e.$no.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$io.properties[t],r.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$oo};this.w(r,n),e.$io.properties[r]=n,e.$jo.properties[r]=n,e.$ko.properties[r]=n,e.$lo.properties[r]=n,e.$mo.properties[r]=n,e.$no.properties[r]=n}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,r){const n=this.a.get(t);let s=n?.value,i=n?.source;L.$dg(s)&&(s=r.defaultDefaultValue,i=void 0),L.$dg(s)&&(s=l(r.type)),r.default=s,r.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",c=new RegExp(h,"g");e.$qo=`^(${h})+$`,e.$ro=new RegExp(e.$qo);function p($){const t=[];if(e.$ro.test($)){let r=c.exec($);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=c.exec($)}}return(0,D.$Mb)(t)}function g($){return $.reduce((t,r)=>`${t}[${r}]`,"")}function l($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new w;C.$co.add(e.$ho.Configuration,u);function m($,t){return $.trim()?e.$ro.test($)?A.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?A.localize(8,null,$):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,$,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function d(){const $=[],t=u.getConfigurationProperties();for(const r of Object.keys(t))$.push([r,t[r].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(ae[76],ce([0,1,17,3,35,2,34,30,13,8,21,47,43]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=m;function h(r){return Object.isFrozen(r)?r:I.$4n(r)}class c{static createEmptyModel(n){return new c({},[],[],void 0,n)}constructor(n,s,i,o,a){this.b=n,this.c=s,this.d=i,this.raw=o,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof c)return s;const i=new p("",this.f);return i.parseRaw(s),i.configurationModel});this.g=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,E.$$i)(this.contents,n):this.contents}inspect(n,s){const i=this;return{get value(){return h(i.rawConfiguration.getValue(n))},get override(){return s?h(i.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?i.rawConfiguration.override(s).getValue(n):i.rawConfiguration.getValue(n))},get overrides(){const o=[];for(const{contents:a,identifiers:b,keys:S}of i.rawConfiguration.overrides){const v=new c(a,S,[],void 0,i.f).getValue(n);v!==void 0&&o.push({identifiers:b,value:v})}return o.length?h(o):void 0}}}getOverrideValue(n,s){const i=this.j(s);return i?n?(0,E.$$i)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return D.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return D.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.h(n),this.a.set(n,s)),s}merge(...n){const s=I.$3n(this.contents),i=I.$3n(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const b of n)if(a.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i(s,b.contents);for(const S of b.overrides){const[v]=i.filter(k=>D.$ub(k.identifiers,S.identifiers));v?(this.i(v.contents,S.contents),v.keys.push(...S.keys),v.keys=D.$Mb(v.keys)):i.push(I.$3n(S))}for(const S of b.keys)o.indexOf(S)===-1&&o.push(S)}return new c(s,o,i,a.every(b=>b instanceof c)?void 0:a,this.f)}h(n){const s=this.j(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[o];const b=s[o];b&&(typeof a=="object"&&typeof b=="object"?(a=I.$3n(a),this.i(a,b)):a=b),i[o]=a}return new c(i,this.keys,this.overrides,void 0,this.f)}i(n,s){for(const i of Object.keys(s)){if(i in n&&C.$$f(n[i])&&C.$$f(s[i])){this.i(n[i],s[i]);continue}n[i]=I.$3n(s[i])}}j(n){let s=null,i=null;const o=a=>{a&&(i?this.i(i,a):i=I.$3n(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&o(a.contents);return o(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.k(n,s,!0)}setValue(n,s){this.k(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,E.$0i)(this.contents,n),y.$ro.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>D.$ub(i.identifiers,(0,y.$so)(n))),1))}k(n,s,i){(0,E.$9i)(this.contents,n,s,o=>this.f.error(o)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),y.$ro.test(n)&&this.overrides.push({identifiers:(0,y.$so)(n),keys:Object.keys(this.contents[n]),contents:(0,E.$8i)(this.contents[n],o=>this.f.error(o))})}}e.$xo=c;class p{constructor(n,s){this.f=n,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!C.$fg(n)){const i=this.h(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:o,overrides:a,restricted:b,hasExcludedProperties:S}=this.i(n,s);this.b=new c(i,o,a,S?[n]:void 0,this.g),this.c=b||[]}h(n){let s={},i=null,o=[];const a=[],b=[];function S(k){Array.isArray(o)?o.push(k):i!==null&&(o[i]=k)}const v={onObjectBegin:()=>{const k={};S(k),a.push(o),o=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];S(k),a.push(o),o=k,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:S,onError:(k,P,R)=>{b.push({error:k,offset:P,length:R})}};if(n)try{L.$Qn(n,v),s=o[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}i(n,s){const i=w.$co.as(y.$ho.Configuration).getConfigurationProperties(),o=this.j(n,i,!0,s);n=o.raw;const a=(0,E.$8i)(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),b=Object.keys(n),S=this.l(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:a,keys:b,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,s,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const b={},S=[];for(const v in n)if(y.$ro.test(v)&&i){const k=this.j(n[v],s,!1,o);b[v]=k.raw,a=a||k.hasExcludedProperties,S.push(...k.restricted)}else{const k=s[v],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&S.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(P===void 0||o.scopes===void 0||o.scopes.includes(P))&&!(o.skipRestricted&&k?.restricted))?b[v]=n[v]:a=!0}return{raw:b,restricted:S,hasExcludedProperties:a}}l(n,s){const i=[];for(const o of Object.keys(n))if(y.$ro.test(o)){const a={};for(const b in n[o])a[b]=n[o][b];i.push({identifiers:(0,y.$so)(o),keys:Object.keys(a),contents:(0,E.$8i)(a,s)})}return i}}e.$yo=p;class g extends A.$Uc{constructor(n,s,i,o,a){super(),this.c=n,this.f=s,this.g=o,this.h=a,this.b=this.B(new N.$de),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),a),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&i.isEqual(b.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=g;class l{constructor(n,s,i,o,a,b,S,v,k,P,R,F,T){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=o,this.d=a,this.f=b,this.g=S,this.h=v,this.i=k,this.j=P,this.k=R,this.l=F,this.m=T}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(n,s,i,o,a,b,S,v,k,P){this.j=n,this.l=s,this.m=i,this.n=o,this.p=a,this.q=b,this.r=S,this.s=v,this.t=k,this.u=P,this.h=null,this.i=new O.$Ac,this.v=null}getValue(n,s,i){return this.w(n,s,i).getValue(n)}updateValue(n,s,i={}){let o;i.resource?(o=this.t.get(i.resource),o||(o=c.createEmptyModel(this.u),this.t.set(i.resource,o))):o=this.s,s===void 0?o.removeValue(n):o.setValue(n,s),i.resource||(this.h=null)}inspect(n,s,i){const o=this.w(n,s,i),a=this.A(s.resource,i),b=s.resource?this.t.get(s.resource)||this.s:this.s,S=new Set;for(const v of o.overrides)for(const k of v.identifiers)o.getOverrideValue(n,k)!==void 0&&S.add(k);return new l(n,s,o.getValue(n),S.size?[...S]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.q:void 0,a||void 0,b)}keys(n){const s=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,s){this.r.set(n,s),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:o,updated:a,removed:b}=$(this.j,n);s=[...o,...a,...b]}for(const o of s)for(const a of(0,y.$so)(o)){const b=this.j.getKeysForOverrideIdentifier(a),S=n.getKeysForOverrideIdentifier(a),v=[...S.filter(k=>b.indexOf(k)===-1),...b.filter(k=>S.indexOf(k)===-1),...b.filter(k=>!I.$7n(this.j.override(a).getValue(k),n.override(a).getValue(k)))];i.push([a,v])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:o}=$(this.l,n),a=[...s,...i,...o];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.applicationConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateApplicationConfiguration(n),{keys:b,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.localUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateLocalUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.remoteUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateRemoteUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.workspaceConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateWorkspaceConfiguration(n),{keys:b,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:o,updated:a,removed:b,overrides:S}=$(i,s),v=[...o,...a,...b];return(v.length||!i)&&this.updateFolderConfiguration(n,s),{keys:v,overrides:S}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:o,removed:a,overrides:b}=$(s,void 0);return{keys:[...i,...o,...a],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,s,i){let o=this.x(s,i);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(o=o.merge(this.l)),o}x({resource:n},s){let i=this.y();if(s&&n){const o=s.getFolder(n);o&&(i=this.z(o.uri)||i);const a=this.t.get(n);a&&(i=i.merge(a))}return i}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let s=this.i.get(n);if(!s){const i=this.y(),o=this.r.get(n);o?(s=i.merge(o),this.i.set(n,s)):s=i}return s}A(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.r.get(i.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,s)=>{const{contents:i,overrides:o,keys:a}=this.r.get(s);return n.push([s,{contents:i,overrides:o,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.q.keys.forEach(s=>n.add(s)),this.r.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}D(n){const s=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.q.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.r.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o))),[...s.values()]}static parse(n,s){const i=this.E(n.defaults,s),o=this.E(n.policy,s),a=this.E(n.application,s),b=this.E(n.user,s),S=this.E(n.workspace,s),v=n.folders.reduce((k,P)=>(k.set(f.URI.revive(P[0]),this.E(P[1],s)),k),new O.$Ac);return new u(i,o,a,b,c.createEmptyModel(s),S,v,c.createEmptyModel(s),new O.$Ac,s)}static E(n,s){return new c(n.contents,n.keys,n.overrides,void 0,s)}}e.$Ao=u;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,s=new Map;for(const o of r)o.keys.forEach(a=>n.add(a)),o.overrides.forEach(([a,b])=>{const S=(0,O.$xc)(s,a,new Set);b.forEach(v=>S.add(v))});const i=[];return s.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...n.values()],overrides:i}}class d{constructor(n,s,i,o,a){this.change=n,this.f=s,this.g=i,this.h=o,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of n.keys)this.affectedKeys.add(b);for(const[,b]of n.overrides)for(const S of b)this.affectedKeys.add(S);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,s){const i=this.a+n,o=this.d.indexOf(i);if(o<0)return!1;const a=o+i.length;if(a>=this.d.length)return!1;const b=this.d.charCodeAt(a);if(b!==this.b&&b!==this.c)return!1;if(s){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,v=this.g.getValue(n,s,this.h);return!I.$7n(S,v)}return!0}}e.$Co=d;function $(r,n){const{added:s,removed:i,updated:o}=t(n?.rawConfiguration,r?.rawConfiguration),a=[],b=r?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const v=S.filter(k=>!b.includes(k));for(const k of v)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(r){const v=b.filter(k=>!S.includes(k));for(const k of v)a.push([k,r.getKeysForOverrideIdentifier(k)])}if(n&&r){for(const v of b)if(S.includes(v)){const k=t({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});a.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:i,updated:o,overrides:a}}function t(r,n){const s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],o=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const b=(0,E.$$i)(n.contents,a),S=(0,E.$$i)(r.contents,a);I.$7n(b,S)||o.push(a)}}return{added:s,removed:i,updated:o}}}),define(ae[216],ce([0,1,17,3,2,30,13,76,47,9,58,43]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=void 0;class w extends L.$Uc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new N.$de),this.onDidChangeConfiguration=this.a.event,this.b=I.$xo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$co.as(C.$ho.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:l})=>this.f(Array.from(g),l))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,l){this.j(g,y.$co.as(C.$ho.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=I.$xo.createEmptyModel(this.c);const g=y.$co.as(C.$ho.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,l){const u=this.g();for(const m of g){const d=u[m],$=l[m];d!==void 0?this.b.addValue(m,d):$?this.b.addValue(m,$.default):this.b.removeValue(m)}}}e.$Do=w;class h{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=I.$xo.createEmptyModel(new f.$dk)}async initialize(){return this.configurationModel}}e.$Eo=h;let c=class extends L.$Uc{get configurationModel(){return this.b}constructor(g,l,u){super(),this.c=g,this.f=l,this.g=u,this.a=this.B(new N.$de),this.onDidChangeConfiguration=this.a.event,this.b=I.$xo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const l={},u=[],m=y.$co.as(C.$ho.Configuration).getConfigurationProperties();for(const d of g){const $=m[d];if(!$){u.push(d);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}u.push(d),l[$.policy.name]={type:$.type}}}return(0,O.$jg)(l)||await this.f.updatePolicyDefinitions(l),u}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const l=y.$co.as(C.$ho.Configuration).getPolicyConfigurations(),u=(0,D.$Hb)(g.map(m=>l.get(m)));this.m(u,!0)}m(g,l){this.g.trace("PolicyConfiguration#update",g);const u=y.$co.as(C.$ho.Configuration).getConfigurationProperties(),m=[],d=this.b.isEmpty();for(const $ of g){const t=u[$]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(d?r!==void 0:!(0,A.$7n)(this.b.getValue($),r))&&m.push([$,r])}else this.b.getValue($)!==void 0&&m.push([$,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const $=this.b;this.b=I.$xo.createEmptyModel(this.g);for(const t of $.keys)this.b.setValue(t,$.getValue(t));for(const[t,r]of m)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);l&&this.a.fire(this.b)}}};e.$Fo=c,e.$Fo=c=ve([Q(1,E.$eo),Q(2,f.$3j)],c)}),define(ae[217],ce([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,216,58]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=void 0;class u extends C.$Uc{constructor($,t,r,n){super(),this.m=$,this.n=n,this.h=this.B(new A.$de),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Do(n)),this.c=r instanceof l.$go?new g.$Eo:this.B(new g.$Fo(this.b,r,n)),this.f=this.B(new c.$zo(this.m,{},w.$1g,t,n)),this.a=new c.$Ao(this.b.configurationModel,this.c.configurationModel,c.$xo.createEmptyModel(n),c.$xo.createEmptyModel(n),c.$xo.createEmptyModel(n),c.$xo.createEmptyModel(n),new f.$Ac,c.$xo.createEmptyModel(n),new f.$Ac,n),this.j=new m($,t,this),this.g=this.B(new N.$Ih(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:i})=>this.s(s,i))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$Ao($,t,c.$xo.createEmptyModel(this.n),r,c.$xo.createEmptyModel(this.n),c.$xo.createEmptyModel(this.n),new f.$Ac,c.$xo.createEmptyModel(this.n),new f.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue($,t){const r=typeof $=="string"?$:void 0,n=(0,h.$4i)($)?$:(0,h.$4i)(t)?t:{};return this.a.getValue(r,n,void 0)}async updateValue($,t,r,n,s){const i=(0,h.$5i)(r)?r:(0,h.$4i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=i?n:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${$} to target ${o}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,D.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,E.$7n)(t,a.defaultValue)&&(t=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const S=i.overrideIdentifiers.sort(),v=this.a.localUserConfiguration.overrides.find(k=>(0,D.$ub)([...k.identifiers].sort(),S));v&&(i.overrideIdentifiers=v.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,p.$to)(i.overrideIdentifiers),$]:[$];await this.j.write(b,t),await this.reloadConfiguration()}inspect($,t={}){return this.a.inspect($,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.r($)}r($){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration($);this.u(r,t,2)}s($,t){const r=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration($,t);this.u(n,r,7)}t($){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration($);this.u(r,t,7)}u($,t,r){const n=new c.$Co($,{data:t},this.a,void 0,this.n);n.source=r,this.h.fire(n)}}e.$Go=u;class m{constructor($,t,r){this.b=$,this.c=t,this.d=r,this.a=new N.$Dh}write($,t){return this.a.queue(()=>this.e($,t))}async e($,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)r="{}";else throw i}const n=[];if((0,O.$Jn)(r,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,$,t);r=(0,I.$2n)(r,s),await this.c.writeFile(this.b,L.$Fe.fromString(r))}f($,t,r){const{tabSize:n,insertSpaces:s,eol:i}=this.h;if(!t.length){const o=JSON.stringify(r,null,s?" ".repeat(n):"	");return[{content:o,length:o.length,offset:0}]}return(0,I.$Yn)($,t,r,{tabSize:n,insertSpaces:s,eol:i})}get h(){if(!this.g){let $=y.OS===3||y.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&($=t),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[218],ce([0,1,15,3,2,68]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nvb=e.$lvb=e.$kvb=void 0,e.$mvb=I;const O=(f,E,y)=>{const w=new Uint8Array(16);for(let p=0;p<16;p++)w[p]=Math.round(Math.random()*256);const h=(0,D.$Ze)(D.$Fe.wrap(w));return[`GET ws://localhost${f}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$kvb=O,e.$lvb=D.$Fe.fromString(`\r
\r
`);async function I(f,E,y,w,h){f.write(D.$Fe.fromString((0,e.$kvb)(E,y,w)));const c=new L.$Tc;try{return await new Promise((p,g)=>{let l;c.add(f.onData(u=>{l?l=D.$Fe.concat([l,u],l.byteLength+u.byteLength):l=u;const m=l.indexOf(e.$lvb);if(m===-1)return;p(f),f.pauseData();const d=l.slice(m+e.$lvb.byteLength);d.byteLength&&h.onData.fire(d)})),c.add(f.onClose(u=>g(u??new Error("socket closed")))),c.add(f.onEnd(()=>g(new Error("socket ended"))))})}catch(p){throw f.dispose(),p}finally{c.dispose()}}class C extends L.$Uc{constructor(E,y){super(),this.g=E,this.a=this.B(new N.$ge),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$de),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(w=>this.a.fire(w))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,y){A.SocketDiagnostics.traceSocketEvent(this,this.g,E,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$nvb=C}),define(ae[219],ce([0,1,7,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=f,e.$Hl=(0,N.$wi)("remoteAuthorityResolverService");var L;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=A;class O{constructor(y,w){this.host=y,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=O;var I;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class C extends D.$bb{static isNotAvailable(y){return y instanceof C&&y._code===I.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof C&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof C&&y._code===I.NoResolverFound}static isInvalidAuthority(y){return y instanceof C&&y._code===I.InvalidAuthority}static isHandled(y){return y instanceof C&&y.isHandled}constructor(y,w=I.Unknown,h){super(y),this._message=y,this._code=w,this._detail=h,this.isHandled=w===I.NotAvailable&&h===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Kl=C;function f(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(ae[220],ce([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=b,e.$Rl=S,e.$Sl=k;const c=30*1e3;var p;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function g(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(B){const j=new L.$oe;return setTimeout(()=>j.cancel(),B),j.token}function u(B,j){if(B.isCancellationRequested||j.isCancellationRequested)return L.CancellationToken.Cancelled;const M=new L.$oe;return B.onCancellationRequested(()=>M.cancel()),j.onCancellationRequested(()=>M.cancel()),M.token}class m{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,D.$ph)(),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function d(B,j){const M=new m(j);return M.registerDisposable(B.onControlMessage(z=>{const U=JSON.parse(z.toString()),Z=V(U);Z?M.reject(Z):M.resolve(U)})),M.promise}function $(B,j,M,z,U,Z,x,te){const _=new m(te),oe=E.$_d.create(!1);return B.info(`Creating a socket (${x})...`),f.mark(`code/willCreateSocket/${Z}`),j.connect(M,z,U,x).then(fe=>{_.didTimeout?(f.mark(`code/didCreateSocketError/${Z}`),B.info(`Creating a socket (${x}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(f.mark(`code/didCreateSocketOK/${Z}`),B.info(`Creating a socket (${x}) was successful after ${oe.elapsed()} ms.`),_.resolve(fe))},fe=>{f.mark(`code/didCreateSocketError/${Z}`),B.info(`Creating a socket (${x}) returned an error after ${oe.elapsed()} ms.`),B.error(fe),_.reject(fe)}),_.promise}function t(B,j){const M=new m(j);return B.then(z=>{M.didTimeout||M.resolve(z)},z=>{M.didTimeout||M.reject(z)}),M.promise}async function r(B,j,M,z){const U=ee(B,j);B.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await $(B.logService,B.remoteSocketFactoryService,B.connectTo,C.$Jg.getServerRootPath(),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,g(j),`renderer-${g(j)}-${B.reconnectionToken}`,z)}catch(fe){throw B.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),B.logService.error(fe),fe}B.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let x,te;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(Z,null),x=B.reconnectionProtocol,te=!1):(x=new w.$ki({socket:Z}),te=!0),B.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const _=await t(B.signService.createNewMessage((0,y.$Sg)()),z),oe={type:"auth",auth:B.connectionToken||"00000000000000000000",data:_.data};x.sendControl(N.$Fe.fromString(JSON.stringify(oe)));try{const fe=await d(x,u(z,l(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}if(B.logService.trace(`${U} 4/6. received SignRequest control message.`),!await t(B.signService.validate(_,fe.signedData),z)){const be=new Error("Refused to connect to unsupported server");throw be.code="VSCODE_CONNECTION_ERROR",be}const de=await t(B.signService.sign(fe.data),z),ge={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:j};return M&&(ge.args=M),B.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(N.$Fe.fromString(JSON.stringify(ge))),{protocol:x,ownsProtocol:te}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(B.logService.error(`${U} the handshake timed out. Error:`),B.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${U} received error control message when negotiating connection. Error:`),B.logService.error(fe)),te&&G(x),fe}}async function n(B,j,M,z){const U=Date.now(),Z=ee(B,j),{protocol:x,ownsProtocol:te}=await r(B,j,M,z),_=new m(z);return _.registerDisposable(x.onControlMessage(oe=>{const fe=JSON.parse(oe.toString()),$e=V(fe);$e?(B.logService.error(`${Z} received error control message when negotiating connection. Error:`),B.logService.error($e),te&&G(x),_.reject($e)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${W(U)}!`),_.resolve({protocol:x,firstMessage:fe}))})),_.promise}async function s(B,j){const{protocol:M}=await n(B,1,void 0,j);return{protocol:M}}async function i(B,j,M){const{protocol:z,firstMessage:U}=await n(B,2,j,M),Z=U&&U.debugPort;return{protocol:z,debugPort:Z}}async function o(B,j,M){const z=Date.now(),U=ee(B,3),{protocol:Z}=await r(B,3,j,M);return B.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${W(z)}!`),Z}async function a(B,j,M){const{connectTo:z,connectionToken:U}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,connectTo:z,connectionToken:U,reconnectionToken:j,reconnectionProtocol:M,remoteSocketFactoryService:B.remoteSocketFactoryService,signService:B.signService,logService:B.logService}}async function b(B,j,M){return v(B,async z=>{const{protocol:U}=await s(z,L.CancellationToken.None);return new H(B,j,M,z.reconnectionToken,U)})}async function S(B,j){return v(B,async M=>{const{protocol:z,debugPort:U}=await i(M,j,L.CancellationToken.None);return new K(B,j,M.reconnectionToken,z,U)})}async function v(B,j){for(let z=1;;z++)try{const U=(0,y.$Sg)(),Z=await a(B,U,null);return await j(Z)}catch(U){if(z<5)B.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(U);else throw B.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(U),X.triggerPermanentFailure(0,0,h.$Kl.isHandled(U)),U}}async function k(B,j,M){const z=await a(B,(0,y.$Sg)(),null);return await o(z,{host:j,port:M},L.CancellationToken.None)}function P(B){return(0,D.$jh)(j=>new Promise((M,z)=>{const U=setTimeout(M,B*1e3);j.onCancellationRequested(()=>{clearTimeout(U),M()})}))}var R;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(R||(e.PersistentConnectionEventType=R={}));class F{constructor(j,M){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.type=0}}e.$Tl=F;class T{constructor(j,M,z,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.durationSeconds=z,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=T;class q{constructor(j,M,z){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=z,this.type=2}}e.$Vl=q;class Y{constructor(j,M,z){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=z,this.type=4}}e.$Wl=Y;class J{constructor(j,M,z,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=z,this.handled=U,this.type=3}}e.$Xl=J;class X extends I.$Uc{static triggerPermanentFailure(j,M,z){this._permanentFailure=!0,this.f=j,this.g=M,this.h=z,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(j=>j.y())}static debugPauseSocketWriting(){this.j.forEach(j=>j.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||X._permanentFailure}constructor(j,M,z,U,Z){super(),this.t=j,this.u=M,this.reconnectionToken=z,this.protocol=U,this.w=Z,this.m=this.B(new O.$de),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(U.onSocketClose(x=>{const te=he(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(x=>{const te=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),X.j.push(this),this.B((0,I.$Sc)(()=>{const x=X.j.indexOf(this);x>=0&&X.j.splice(x,1)})),this.n&&this.D(X.f,X.g,X.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const j=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const U=z<M.length?M[z]:M[M.length-1];try{if(U>0){const x=P(U);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,x)),this.u.logService.info(`${j} waiting for ${U} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${j} resolving connection...`);const Z=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${j} connecting to ${Z.connectTo}...`),await this.G(Z,l(c)),this.u.logService.info(`${j} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(h.$Kl.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,A.$4)(Z)){this.u.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof h.$Kl){this.u.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,h.$Kl.isHandled(Z));break}this.u.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(j,M,z){this.w?X.triggerPermanentFailure(j,M,z):this.D(j,M,z)}D(j,M,z){this.m.fire(new J(this.reconnectionToken,j,M,z)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=X;class H extends X{constructor(j,M,z,U,Z){super(1,j,U,Z,!0),this.client=this.B(new w.$ii(Z,{remoteAuthority:M,clientId:z},j.ipcLogger))}async G(j,M){await s(j,M)}}e.$Zl=H;class K extends X{constructor(j,M,z,U,Z){super(2,j,z,U,!1),this.H=M,this.debugPort=Z}async G(j,M){await i(j,this.H,M)}}e.$1l=K;function G(B){try{B.acceptDisconnect();const j=B.getSocket();B.dispose(),j.dispose()}catch(j){(0,A.$1)(j)}}function V(B){if(B&&B.type==="error"){const j=new Error(`Connection error: ${B.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function ie(B,j){for(;B.length<j;)B+=" ";return B}function se(B,j){return`[remote-connection][${ie(g(B),13)}][${j.substr(0,5)}\u2026]`}function he(B,j,M){return`${se(B,j)}[${M?"reconnect":"initial"}]`}function ee(B,j){return`${he(j,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.connectTo}]`}function W(B){return`${Date.now()-B} ms`}}),define(ae[102],ce([0,1,23]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=N,e.$Im=L,e.$Jm=A,e.$Km=O;function N(C){return C.scheme===D.Schemas.vscodeRemote?C.authority:void 0}function L(C){if(!C)return;const f=C.indexOf("+");return f<0?C:C.substr(0,f)}function A(C){const{host:f,port:E}=I(C);if(typeof E>"u")throw new Error(`Invalid remote authority: ${C}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:f,port:E}}function O(C,f){let{host:E,port:y}=I(C);return typeof y>"u"&&(y=f),{host:E,port:y}}function I(C){const f=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(f)return{host:f[1],port:parseInt(f[2],10)};const E=C.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=C.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:C,port:void 0}}}),define(ae[48],ce([0,1,27,4,102]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=A,e.$Um=y,e.$Vm=w,e.$Wm=h,e.$Xm=c,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,l){if(typeof g>"u"||g===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof g=="string"||typeof l=="string"){const u=typeof g=="string"?g:g.value,m=typeof l=="string"?l:l.value;return D.$xf(u,m)}return g._lower===l._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Rm=C;class f{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const l of g)this.add(l)}add(g){this.c.add(C.toKey(g))}delete(g){return this.c.delete(C.toKey(g))}has(g){return this.c.has(C.toKey(g))}}e.$Sm=f;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(C.toKey(g))}get(g){return this.c.get(C.toKey(g))}has(g){return this.c.has(C.toKey(g))}set(g,l){this.c.set(C.toKey(g),l)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=E;function y(p){return w(p)}function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function c(p,g){if(g){const l=`onResolveRemoteAuthority:${(0,L.$Im)(g)}`;return!!p.activationEvents?.includes(l)}return!1}e.$Ym=(0,N.$wi)("IBuiltinExtensionsScannerService")}),define(ae[221],ce([0,1,2,48,12]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class A extends D.$Uc{constructor(I,C,f,E,y){super(),this.a=I,this.b=C,this.c=f,this.f=y,this.B(E.onDidInstallExtensions(w=>this.g(w))),this.B(E.onDidUninstallExtension(w=>this.h(w)))}g(I){for(const C of I)C.local&&this.invalidate(C.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,I)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Lm))}catch(C){(0,L.$hl)(C)!==1&&this.f.error(C)}}}e.$Bq=A}),define(ae[103],ce([0,1,2,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,N.$wi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,D.$Sc)(()=>{const C=this.a[O]?.indexOf(I);typeof C=="number"&&C>=0&&this.a[O]?.splice(C,1)})}b(O){return(this.a[O.type]||[]).find(C=>C.supports(O))}connect(O,I,C,f){const E=this.b(O);if(!E)throw new Error(`No socket factory found for ${O}`);return E.connect(O,I,C,f)}}e.$Nl=L}),define(ae[222],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=void 0,e.$wec=(0,D.$wi)("sharedProcessTunnelService"),e.$xec="sharedProcessTunnel"}),define(ae[104],ce([0,1,4,169]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=e.$Fec=e.$Eec=e.$Dec=e.TunnelStates=e.$Cec=e.$Bec=void 0,e.$Bec=(0,D.$wi)("IRemoteTunnelService"),e.$Cec={active:!1};var L;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,I)=>({type:"connected",info:O,serviceInstallFailed:I}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$Dec="remote.tunnels.access",e.$Eec=e.$Dec+".hostNameOverride",e.$Fec=e.$Dec+".preventSleep",e.$Gec="remoteTunnelService",e.$Hec=(0,N.localize)(0,null)}),define(ae[59],ce([0,1,15,7,2,171,47,4,9,43]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=w,e.$Qp=h,e.$Rp=c,e.$Sp=p,e.$Tp=g,e.$Up=l,e.$Np=(0,I.$wi)("requestService");class E{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?$[t]="*****":$[t]=this.b[t];this.a=$}return this.a}}class y extends L.$Uc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,A.localize)(0,null),when:C.$ik.isEqualTo((0,C.$fk)(C.LogLevel.Trace)).serialize()})}async c($,t,r){const n=`${$} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new E(t.headers??{}));try{const s=await r();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,N.$0)(s)),s}}}e.$Op=y;function w(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function h(d){return d.res.statusCode===204}async function c(d){return h(d)?null:(await(0,D.$Re)(d.stream)).toString()}async function p(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);return c(d)}async function g(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);if(h(d))return null;const t=(await(0,D.$Re)(d.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function l(d){m(d)}let u;function m(d){const $=f.$co.as(O.$ho.Configuration),t=u;u={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[u],remove:t?[t]:[]})}m(1)}),define(ae[223],ce([0,1,26,23,12,59]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0;let O=class{constructor(C,f){this.a=C,this.b=f}async download(C,f,E=D.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,f);return}const y={type:"GET",url:C.toString(!0)},w=await this.a.request(y,E);if(w.res.statusCode===200)await this.b.writeFile(f,w.stream);else{const h=await(0,A.$Sp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${h}`)}}};e.$cR=O,e.$cR=O=ve([Q(0,A.$Np),Q(1,L.$3k)],O)}),define(ae[224],ce([0,1,15,26]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=void 0;class L{constructor(I){this.a=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,f,E=N.CancellationToken.None){switch(C){case"request":return this.a.request(f[0],E).then(async({res:y,stream:w})=>{const h=await(0,D.$Re)(w);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.a.resolveProxy(f[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Ur=L;class A{constructor(I){this.a=I}async request(I,C){const[f,E]=await this.a.call("request",[I],C);return{res:f,stream:(0,D.$Te)(E)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Vr=A}),define(ae[225],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=e.$1cc=void 0,e.$1cc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$2cc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$3cc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[226],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const O=String(D.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$U$b=D}),define(ae[105],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,D.$wi)(e.$Ol)}),define(ae[227],ce([0,1,226]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class N extends D.$U$b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>ne(["vsda"],A,O))}}e.$Qdc=N}),define(ae[77],ce([0,1,3,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HKb=e.$GKb=e.$FKb=e.$EKb=void 0;class L extends N.$Uc{constructor(y,w,h){super(),this.a=y,this.b=w,this.c=h}async getItems(){const y={profile:this.b,workspace:this.c},w=await this.a.call("getItems",y);return new Map(w)}updateItems(y){const w={profile:this.b,workspace:this.c};return y.insert&&(w.insert=Array.from(y.insert.entries())),y.delete&&(w.delete=Array.from(y.delete.values())),this.a.call("updateItems",w)}optimize(){const y={profile:this.b,workspace:this.c};return this.a.call("optimize",y)}}class A extends L{constructor(y,w){super(y,w,void 0),this.f=this.B(new D.$de),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(y=>this.h(y)))}h(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this.f.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class O extends A{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.$EKb=O;class I extends A{constructor(y,w){super(y,w)}async close(){this.dispose()}}e.$FKb=I;class C extends L{constructor(y,w){super(y,void 0,w),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$GKb=C;class f{constructor(y){this.a=y}isUsed(y){const w={payload:y,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$HKb=f}),define(ae[106],ce([0,1,5,36,32]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=O,e.$ep=I;function A(C){if(D.$u===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function O(C,f,E,y,w,h,c,p,g){const l=Object.create(null);l["common.machineId"]=h,l["common.sqmId"]=c,l.sessionID=(0,L.$Sg)()+Date.now(),l.commitHash=y,l.version=w,l["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$u),l["common.nodePlatform"]=N.$dc,l["common.nodeArch"]=E,l["common.product"]=g||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const m=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const d=A(f);return d&&(l["common.platformDetail"]=d),l}function I(C){const f=N.env.USERDNSDOMAIN;if(!f)return!1;const E=f.toLowerCase();return C.some(y=>E===y)}}),define(ae[22],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,D.$wi)("telemetryService"),e.$3l=(0,D.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[228],ce([0,1,37,6,35,23,14,5,8,144,31,150,94,12,24,22]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Es=l,e.$Fs=m,e.$Gs=d;const g=new Map;async function l(t,r){const n=`${t}::${r.join(":")}`,s=g.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,b=2e4;function S(k,P,R,F){const T=P.substring(k.length+1);return N.Promises.withAsyncBody(async q=>{let Y;try{Y=await E.Promises.readdir(P,{withFileTypes:!0})}catch{q();return}if(F.count>=b){F.count+=Y.length,F.maxReached=!0,q();return}let J=Y.length;if(J===0){q();return}let X=Y;F.count+Y.length>b&&(F.maxReached=!0,J=b-F.count,X=Y.slice(0,J)),F.count+=Y.length;for(const H of X)if(H.isDirectory()){if(R.includes(H.name)||await S(k,(0,O.$jc)(P,H.name),R,F),--J===0){q();return}}else{const K=H.name.lastIndexOf(".");if(K>=0){const G=H.name.substring(K+1);G&&o.set(G,(o.get(G)??0)+1)}for(const G of i)G.relativePathPattern?.test(T)!==!1&&G.filePattern.test(H.name)&&a.set(G.tag,(a.get(G.tag)??0)+1);if(--J===0){q();return}}})}const v=N.Promises.withAsyncBody(async k=>{const P={count:0,maxReached:!1};await S(t,t,r,P);const R=await d(t);k({configFiles:u(a),fileTypes:u(o),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:R})});return g.set(n,v),v}function u(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function m(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.$yl.GB).toFixed(2)}GB (${(D.freemem()/h.$yl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.$En.value()*100)}%`},r=D.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function d(t){try{const r=new Map,n=(0,O.$jc)(t,".vscode","launch.json"),s=await E.Promises.readFile(n),i=[],o=(0,L.$Jn)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$Sn)(o)==="object"&&o.configurations)for(const a of o.configurations){const b=a.type;b&&(r.has(b)?r.set(b,r.get(b)+1):r.set(b,1))}return u(r)}catch{return[]}}let $=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/h.$yl.GB).toFixed(2)}GB (${(D.freemem()/h.$yl.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${D.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(f.$En.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,y.$Ds)(r.mainPID),this.k(r)]).then(async s=>{let[i,o]=s,a=this.m(r,i);return n.forEach(b=>{if((0,w.$en)(b))a+=`
${b.errorMessage}`,o+=`
${b.errorMessage}`;else if(a+=`

Remote: ${b.hostName}`,b.processes&&(a+=`
${this.m(r,b.processes)}`),b.workspaceMetadata){o+=`
|  Remote: ${b.hostName}`;for(const S of Object.keys(b.workspaceMetadata)){const v=b.workspaceMetadata[S];let k=`${v.fileCount} files`;v.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${S}): ${k}`,o+=this.h(v)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(r,n){const{memory:s,vmHint:i,os:o,cpus:a}=m(),b={os:o,memory:s,cpus:a,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(b.load=`${D.loadavg().map(S=>Math.round(S)).join(", ")}`),I.$k&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(r,n){const s=[];return(0,y.$Ds)(r.mainPID).then(async i=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,i)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),n.forEach(o=>{if((0,w.$en)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.f(o.machineInfo)),o.processes&&s.push(this.m(r,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const b=o.workspaceMetadata[a];let S=`${b.fileCount} files`;b.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${a}): ${S}`),s.push(this.h(b))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const n=[];let i=0;const o=(v,k)=>{const P=` ${v}(${k})`;i+P.length>60?(n.push(a),a="|                 ",i=a.length):i+=P.length,a+=P};let a="|      File types:";const b=10,S=r.fileTypes.length>b?b:r.fileTypes.length;for(let v=0;v<S;v++){const k=r.fileTypes[v];o(k.name,k.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",i=0,r.configFiles.forEach(v=>{o(v.name,v.count)}),n.push(a)),r.launchConfigFiles.length>0){let v="|      Launch Configs:";r.launchConfigFiles.forEach(k=>{const P=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;v+=P}),n.push(v)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const n=[],s=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(o=>{const a=C.URI.revive(o);if(a.scheme===A.Schemas.file){const b=a.fsPath;s.push(l(b,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),n.push(`|    Folder (${(0,O.$nc)(b)}): ${v}`),n.push(this.h(S))}).catch(S=>{n.push(`|      Error: Unable to collect workspace stats for folder ${b} (${S.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(r,n){const s=new Map;r.windows.forEach(o=>s.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:a})=>s.set(o,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,s,i,n,0),i.join(`
`)}n(r,n,s,i,o){const a=o===0;let b;a?b=i.pid===r?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?b=n.get(i.pid):b=`${"  ".repeat(o)} ${i.name}`;const S=process.platform==="win32"?i.mem:D.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(S/h.$yl.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(i.children)&&i.children.forEach(v=>this.n(r,n,s,v,o+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const i=C.URI.revive(s);if(i.scheme!==A.Schemas.file)continue;const o=i.fsPath;try{(await l(o,["node_modules",".git"])).fileTypes.forEach(b=>n.add(b.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=C.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const i=s.fsPath;try{const o=await l(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Hs=$,e.$Hs=$=ve([Q(0,p.$2l),Q(1,c.$jk)],$)}),define(ae[107],ce([0,1,7,4,9,22]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.ExtensionSignatureVerificationCode=e.$_p=void 0,e.$_p=(0,N.$wi)("IExtensionSignatureVerificationService");var O;(function(f){f.None="None",f.RequiredArgumentMissing="RequiredArgumentMissing",f.InvalidArgument="InvalidArgument",f.PackageIsUnreadable="PackageIsUnreadable",f.UnhandledException="UnhandledException",f.SignatureManifestIsMissing="SignatureManifestIsMissing",f.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",f.SignatureIsMissing="SignatureIsMissing",f.SignatureIsUnreadable="SignatureIsUnreadable",f.CertificateIsUnreadable="CertificateIsUnreadable",f.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",f.FileAlreadyExists="FileAlreadyExists",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",f.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",f.Success="Success",f.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",f.SignatureIsInvalid="SignatureIsInvalid",f.SignatureManifestIsInvalid="SignatureManifestIsInvalid",f.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",f.EntryIsMissing="EntryIsMissing",f.EntryIsTampered="EntryIsTampered",f.Untrusted="Untrusted",f.CertificateRevoked="CertificateRevoked",f.SignatureIsNotValid="SignatureIsNotValid",f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class I extends Error{constructor(E){super(E),this.code=E}}e.$aq=I;let C=class{constructor(E,y){this.b=E,this.c=y}d(){return this.a||(this.a=new Promise((E,y)=>ne(["@vscode/vsce-sign"],async w=>E(w),y))),this.a}async verify(E,y,w){let h;try{h=await this.d()}catch(l){return this.b.error("Could not load vsce-sign module",(0,D.$0)(l)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const c=new Date().getTime();let p;try{p=await h.verify(y,w,this.b.getLevel()===L.LogLevel.Trace)}catch(l){p={code:"UnknownError",didExecute:!1,output:(0,D.$0)(l)}}const g=new Date().getTime()-c;if(this.b.info(`Extension signature verification result for ${E}: ${p.code}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${p.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,code:p.code,duration:g,didExecute:p.didExecute}),p.code==="Success")return!0;throw new I(p.code)}};e.$bq=C,e.$bq=C=ve([Q(0,L.$3j),Q(1,A.$2l)],C)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;class D{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:I,data:C}){return this.b.forEach(f=>f.log(I,C)),Promise.resolve(null)}}e.$6cc=D;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$7cc=N}),define(ae[49],ce([0,1,30,13,102,106,22]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=E,e.$np=y,e.$op=w,e.$pp=h,e.$qp=p,e.$rp=l,e.$sp=u,e.$tp=$;class I{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$fp=I;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=C,e.$hp=new C;class f{async publicLog(r,n,s){}async publicLogError(r,n,s){}}e.$ip=f,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function y(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const r=t.getValue(O.$0l),n=t.getValue(O.$$l);if(t.getValue(O.$_l)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function h(t){const r={},n={},s={};g(t,s);for(let i in s){i=i.length>150?i.substr(i.length-149):i;const o=s[i];typeof o=="number"?n[i]=o:typeof o=="boolean"?n[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),r[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[i]=o)}return{properties:r,measurements:n}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(t){if(!t)return"none";const r=(0,L.$Im)(t);return c.has(r)?r:"other"}function g(t,r,n=0,s){if(t)for(const i of Object.getOwnPropertyNames(t)){const o=t[i],a=s?s+i:i;Array.isArray(o)?r[a]=(0,D.$8n)(o):o instanceof Date?r[a]=o.toISOString():(0,N.$$f)(o)?n<2?g(o,r,n+1,a+"."):r[a]=(0,D.$8n)(o):r[a]=o}}function l(t,r){const n=t.msftInternalDomains||[],s=r.getValue("telemetry.internalTesting");return(0,A.$ep)(n)||s}function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const s=[];for(const b of r)for(;;){const S=b.exec(t);if(!S)break;s.push([S.index,b.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const b=o.exec(t);if(!b)break;const S=s.some(([v,k])=>b.index<k&&v<o.lastIndex);!i.test(b[0])&&!S&&(n+=t.substring(a,b.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<t.length&&(n+=t.substr(a)),n}function d(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function $(t,r){return(0,D.$5n)(t,n=>{if(n instanceof I||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=m(s,r);for(const i of r)s=s.replace(i,"");return s=d(s),s}})}}),define(ae[33],ce([0,1,27,29,48,5,8,7,36,49]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=E,e.$wp=c,e.$xp=p,e.$yp=g,e.$zp=l,e.$Ap=u,e.$Bp=m,e.$Cp=d,e.$Ep=$,e.$Fp=r;function E(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,D.$sf)(n.id,s.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const i=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,i,o)}static parse(s){const i=y.exec(s);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?E(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$vp=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(n){const s=h.exec(n);return s&&s[1]?[g(s[1]),s[2]]:[g(n),void 0]}function p(n,s){return`${n}.${s}`}function g(n){return n.toLowerCase()}function l(n,s){return g(p(n??L.$Nm,s))}function u(n,s){const i=[],o=a=>{for(const b of i)if(b.some(S=>E(s(S),s(a))))return b;return null};for(const a of n){const b=o(a);b?b.push(a):i.push([a])}return i}function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function d(n){return{id:new f.$fp(n.identifier.id),name:new f.$fp(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Dp=new L.$Rm("pprice.better-merge");function $(n,s){const i=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(b=>!E(b.identifier,{id:a}))){const b=n.filter(S=>E(S.identifier,{id:a}));b.length===1&&(i.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}async function t(n,s){if(!A.$k)return!1;let i;try{i=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,s){const i=await t(n,s),o=(0,N.$2o)(i?"alpine":A.$u,C.$ec);return s.debug("ComputeTargetPlatform:",o),o}}),define(ae[229],ce([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0;let c=class extends N.$Uc{constructor(m,d){super(),this.b=m,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,$])=>this.a.set($.configPath,$))}getConfigBasedTips(m){return this.f(m)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(m){const d=[];for(const[$,t]of this.a)if(!(t.configScheme&&t.configScheme!==m.scheme))try{const r=(await this.b.readFile((0,L.$0g)(m,$))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(r))&&d.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return d}};e.$4ac=c,e.$4ac=c=ve([Q(0,O.$3k),Q(1,I.$jk)],c);const p="extensionTips/promptedExecutableTips",g="extensionTips/lastPromptedMediumImpExeTime";class l extends c{constructor(m,d,$,t,r,n,s,i){super(s,i),this.r=m,this.s=d,this.t=$,this.u=t,this.w=r,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([o,a])=>{const b=[],S=[],v=[];Object.entries(a.recommendations).forEach(([k,P])=>{P.important?a.important?b.push({extensionId:k,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):S.push({extensionId:k,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):v.push({extensionId:k,extensionName:P.name,isExtensionPack:!!P.isExtensionPack})}),b.length&&this.g.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),S.length&&this.h.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:S}),v.length&&this.j.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v})}),(0,C.$yh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const m=await this.O(this.g),d=await this.O(this.h);return[...m,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const m=await this.O(this.g),d=await this.O(this.h),$=await this.u.getInstalled();this.m=this.D(m,$),this.n=this.D(d,$)}D(m,d){const $=new Map;m.forEach(i=>$.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:r}=this.N([...$.keys()],d);for(const i of t){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:o.exeName})}for(const i of r){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:o.exeName})}const n=this.L(),s=new Map;for(const i of r){const o=$.get(i);if(o&&(!n[o.exeName]||!n[o.exeName].includes(o.extensionId))){let a=s.get(o.exeName);a||(a=[],s.set(o.exeName,a)),a.push(o)}}return s}F(){if(this.m.size===0)return;const[m,d]=[...this.m.entries()][0];this.H(d).then($=>{switch($){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(m);break;case"incompatibleWindow":{const t=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new N.$Vc);t.value=(0,C.$yh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const m=this.I(),d=Date.now()-m,$=7*24*60*60*1e3;if(d<$){const n=this.B(new N.$Vc);n.value=(0,C.$yh)(()=>{n.dispose(),this.G()},$-d);return}const[t,r]=[...this.n.entries()][0];this.H(r).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(r[0].exeName,r);const s=this.B(new N.$Vc);s.value=(0,C.$yh)(()=>{s.dispose(),this.G()},$);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const s=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Vc);s.value=(0,C.$yh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(m){const d=await this.u.getInstalled(1),$=m.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(r=>d.every(n=>!(0,h.$up)(n.identifier,{id:r})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:$,source:3,name:m[0].exeFriendlyName,searchValue:`@exe:"${m[0].exeName}"`})}I(){let m=this.w.getNumber(g,-1);return m||(m=Date.now(),this.J(m)),m}J(m){this.w.store(g,m,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(m,d){const $=this.L();$[m]=d.map(({extensionId:t})=>t.toLowerCase()),this.w.store(p,JSON.stringify($),-1,0)}N(m,d){const $=[],t=[],r=d.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return m.forEach(n=>{r.has(n.toLowerCase())?$.push(n):t.push(n)}),{installed:$,uninstalled:t}}async O(m){const d=[],$=new Map;for(const t of m.keys()){const r=m.get(t);if(!r||!(0,D.$Lb)(r.recommendations))continue;const n=[];y.$i?r.windowsPath&&n.push(r.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,E.$jc)("/usr/local/bin",t)),n.push((0,E.$jc)("/usr/bin",t)),n.push((0,E.$jc)(this.r.fsPath,t)));for(const s of n){let i=$.get(s);if(i===void 0&&(i=await this.b.exists(A.URI.file(s)),$.set(s,i)),i)for(const{extensionId:o,extensionName:a,isExtensionPack:b,whenNotInstalled:S}of r.recommendations)d.push({extensionId:o,extensionName:a,isExtensionPack:b,exeName:t,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:S})}}return d}}e.$5ac=l}),define(ae[230],ce([0,1,26,33]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H4b=L;async function L(A,O,I,C,f){try{const E=await A.getExtensionsControlManifest();if(!E.deprecated)return;const y=await A.getInstalled(1);for(const[w,h]of Object.entries(E.deprecated)){if(!h?.extension)continue;const{id:c,autoMigrate:p,preRelease:g}=h.extension;if(!p)continue;const l=y.find(m=>(0,N.$up)(m.identifier,{id:w}));if(!l)continue;const u=(await O.getExtensions([{id:c,preRelease:g}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){f.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${c}' extension is not found`);continue}try{f.info(`Migrating '${l.identifier.id}' extension to '${c}' extension...`);const m=!C.getDisabledExtensions().some($=>(0,N.$up)($,l.identifier));await A.uninstall(l),f.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=y.find($=>(0,N.$up)($.identifier,{id:c}));(!d||!d.isPreReleaseVersion&&m)&&(d=await A.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),f.info(`Installed the pre-release extension '${d.identifier.id}'`),m||(await C.disableExtension(d.identifier),f.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(I.addToMigrationList((0,N.$xp)(l.manifest.publisher,l.manifest.name),(0,N.$xp)(d.manifest.publisher,d.manifest.name)),f.info("Added pre-release extension to the storage migration list"))),f.info(`Migrated '${l.identifier.id}' extension to '${c}' extension.`)}catch(m){f.error(m)}}}catch(E){f.error(E)}}}),define(ae[231],ce([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;let d=class extends L.$Uc{static{m=this}static{this.c=".sigzip"}constructor(t,r,n,s,i,o){super(),this.h=r,this.j=n,this.m=s,this.n=i,this.r=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,r,n){await this.g;const s=(0,O.$0g)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,o=>this.j.download(t,o,r))}catch(o){throw new c.$7o(o.message,c.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.t(t)){const o=await this.u(t);try{i=await this.n.verify(t.identifier.id,s.fsPath,o.fsPath)}catch(a){if(i=a.code,i==="PackageIsInvalidZip"||i==="SignatureArchiveIsInvalidZip"){try{await this.delete(s)}catch(S){this.r.error(S)}throw new c.$7o(y.$gq,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(a){this.r.error(a)}}}return{location:s,verificationStatus:i}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,C.$cg)(r)?r:!0}async u(t){await this.g;const r=(0,O.$0g)(this.extensionsDownloadDir,`${this.z(t)}${m.c}`);try{await this.w(t,r,n=>this.j.downloadSignatureArchive(t,n))}catch(n){throw new c.$7o(n.message,c.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(t,r,n){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await n(r);return}const s=(0,O.$0g)(this.extensionsDownloadDir,`.${(0,f.$Sg)()}`);await this.h.exists(s)||await n(s);try{await E.Promises.rename(s.fsPath,r.fsPath,2*60*1e3)}catch(i){try{await this.h.del(s)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith(m.c))s.push(a.resource);else{const b=p.$vp.parse(a.name);b&&n.push([b,a])}const i=(0,p.$Ap)(n,([a])=>a),o=[];for(const a of i)a.sort((b,S)=>I.rcompare(b[0].version,S[0].version)),r.push(...a.slice(1).map(b=>b[1].resource)),o.push(a[0][1]);o.sort((a,b)=>a.mtime-b.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),r.push(...s),await D.Promises.settled(r.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.r.error(t)}}z(t){return this.f?p.$vp.create(t).toString().toLowerCase():(0,f.$Sg)()}};e.$yq=d,e.$yq=d=m=ve([Q(0,h.$Ei),Q(1,l.$3k),Q(2,c.$6o),Q(3,w.$3i),Q(4,g.$_p),Q(5,u.$3j)],d)}),define(ae[232],ce([0,1,3,2,34,33,48]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class I extends N.$Uc{constructor(f,E,y,w,h,c,p){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.r=p,this.a=this.B(new D.$de),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$4c),this.s().then(null,g=>p.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(f=>this.u(f.added))),this.B(this.j.onAddExtensions(f=>this.w(f))),this.B(this.j.onDidAddExtensions(f=>this.y(f))),this.B(this.j.onRemoveExtensions(f=>this.z(f))),this.B(this.j.onDidRemoveExtensions(f=>this.C(f))),this.B(this.n.onDidFilesChange(f=>this.D(f)))}async u(f){try{f.length&&await Promise.all(f.map(E=>(this.c.set(E.id,(0,N.$Rc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(f){for(const E of f.extensions)this.I(this.L(E.identifier,E.version),f.profileLocation)}async y(f){for(const E of f.extensions){const y=this.L(E.identifier,E.version);f.error?this.J(y,f.profileLocation):this.I(y,f.profileLocation)}}async z(f){for(const E of f.extensions)this.J(this.L(E.identifier,E.version),f.profileLocation)}async C(f){const E=[],y=[];for(const w of f.extensions){const h=this.L(w.identifier,w.version);f.error?this.I(h,f.profileLocation):(this.J(h,f.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),y.push(this.f.scanInstalledExtensionAtLocation(w.location).then(c=>{c?E.push(c):this.r.info("Extension not found at the location",w.location.toString())},c=>this.r.error(c)))))}try{await Promise.all(y),E.length&&await this.H(E)}catch(w){this.r.error(w)}}D(f){for(const E of this.h.profiles)f.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(f){const E=[],y=[],w=await this.j.scanProfileExtensions(f),h=new Set,c=new Set;for(const[p,g]of this.b)g.has(f)&&c.add(p);for(const p of w){const g=this.L(p.identifier,p.version);h.add(g),c.has(g)||(E.push(p.identifier),this.I(g,f))}for(const p of c)if(!h.has(p)){const g=this.M(p);g&&(y.push(g.identifier),this.J(p,f))}(E.length||y.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:f}:void 0,removed:y.length?{extensions:y,profileLocation:f}:void 0})}async G(f){const E=await this.j.scanProfileExtensions(f);for(const y of E)this.I(this.L(y.identifier,y.version),f)}async H(f){f||(f=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.L(y.identifier,y.manifest.version)))),f.length&&await this.f.markAsUninstalled(...f)}I(f,E){let y=this.b.get(f);y||this.b.set(f,y=new L.$Bc(w=>this.m.extUri.getComparisonKey(w))),y.add(E)}J(f,E){const y=this.b.get(f);y&&y.delete(E),y?.size||this.b.delete(f)}L(f,E){return`${O.$Rm.toKey(f.id)}@${E}`}M(f){const[E,y]=(0,A.$wp)(f);return y?{identifier:{id:E},version:y}:void 0}}e.$Cq=I}),define(ae[233],ce([0,1,45,49]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=L;async function L(A,O,I,C,f,E,y){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$mp)(O,I)&&(0,N.$op)(C)===3){const h=await(0,D.$7p)(I,f,E);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=y.machineId||h}return w}}),define(ae[234],ce([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;let p=class extends h.$Sr{constructor(m,d,$,t){super($),this.h=m,this.j=t,this.g=this.B(new g(d,t)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(m,d){const t=(await this.g.getLanguagePacks())[d];if(!t){this.j.warn(`No language pack found for ${d}`);return}const r=t.translations[m];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),d=Object.keys(m).map($=>{const t=m[$];return{...this.f($,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort(($,t)=>$.label.localeCompare(t.label)),d}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const d=await this.g.getLanguagePacks();Object.keys(d).some($=>d[$]&&d[$].extensions.some(t=>(0,y.$up)(t.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(d);return!(0,N.$ub)(Object.keys(m),Object.keys($))}};e.$Tr=p,e.$Tr=p=ve([Q(0,E.$9o),Q(1,f.$Ei),Q(2,E.$6o),Q(3,w.$3j)],p);let g=class extends A.$Uc{constructor(m,d){super(),this.j=d,this.c={},this.f=(0,I.$jc)(m.userDataPath,"languagepacks.json"),this.g=new L.$Dh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(d=>{Object.keys(d).forEach($=>delete d[$]),this.m(d,...m)}).then(()=>this.c)}m(m,...d){for(const $ of d)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(m,$);Object.keys(m).forEach($=>this.r(m[$]))}n(m,d){const $=d.identifier,t=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const r of t)if(d.location.scheme===O.Schemas.file&&l(r)){let n=m[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=n);const s=n.extensions.filter(i=>(0,y.$up)(i.extensionIdentifier,$))[0];s?s.version=d.manifest.version:n.extensions.push({extensionIdentifier:$,version:d.manifest.version});for(const i of r.translations)n.translations[i.id]=(0,I.$jc)(d.location.fsPath,i.path)}}r(m){if(m){const d=(0,D.createHash)("md5");for(const $ of m.extensions)d.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);m.hash=d.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let d=null;return C.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(d=m($),$)).then($=>{for(const r of Object.keys($))$[r]||delete $[r];this.c=$,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),C.Promises.writeFile(this.f,t)}).then(()=>d,$=>this.j.error($))})}};g=ve([Q(0,f.$Ei),Q(1,w.$3j)],g);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const m of u.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[235],ce([0,1,143,7,30,49]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function C(E,y,w){const h=await(0,D.$8D)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,D.$8D)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new h.AppInsightsCore,g=new c.PostChannel,l={instrumentationKey:E,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(w){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};l.extensionConfig[g.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class f{constructor(y,w,h,c,p){this.e=y,this.f=w,this.g=h,this.h=p,this.c=O,this.d=I,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then(w=>{y(w)},w=>{(0,N.$1)(w),console.error(w)})}}log(y,w){if(!this.a)return;w=(0,L.$6n)(w,this.g),w=(0,A.$pp)(w);const h=this.f+"/"+y;try{this.i(c=>{c.pluginVersionString=w?.properties.version??"Unknown",c.track({name:h,baseData:{name:h,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$MQ=f}),define(ae[109],ce([0,1,2,172,16,9,24,49]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0;let C=class extends D.$Uc{constructor(E,y,w,h,c=""){super(),this.b=c;const p=y.getLogger(I.$jp);if(p)this.a=this.B(p);else{const l=(0,I.$np)(h,w)?" (Not Sent)":"",u=()=>(0,I.$mp)(h,w)&&E.getLevel()===A.LogLevel.Trace;this.a=this.B(y.createLogger(I.$jp,{name:(0,N.localize)(0,null,l),hidden:!u()})),this.B(E.onDidChangeLogLevel(()=>y.setVisibility(I.$jp,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,y){this.a.trace(`${this.b}telemetry/${E}`,(0,I.$pp)(y))}};e.$rac=C,e.$rac=C=ve([Q(0,A.$3j),Q(1,A.$4j),Q(2,L.$Di),Q(3,O.$jk)],C)}),define(ae[110],ce([0,1,2,30,5,27,173,21,47,100,24,43,22,49]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,m){this.k=u,this.l=m,this.d={},this.i=new D.$Tc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,A.$_e)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$_e)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(w.$0l)||d.affectsConfiguration(w.$_l)||d.affectsConfiguration(w.$$l))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$op)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const m=u.usage?3:u.error?2:0;l=Math.min(l,m)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,m){this.g<u||(m=(0,N.$6n)(m,this.d),m=(0,h.$tp)(m,this.j),m=(0,N.$6n)(m,this.c),this.b.forEach(d=>d.log(l,m)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$Zr=c,e.$Zr=c=ve([Q(1,I.$3i),Q(2,E.$jk)],c);function p(){const g=(0,O.localize)(0,null,f.default.nameLong),l=f.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),m=(0,O.localize)(4,null),d=(0,O.localize)(5,null),$=(0,O.localize)(6,null),t=(0,O.localize)(7,null),r=`
|       | ${m} | ${d} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${g} ${l} ${u}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}y.$co.as(C.$ho.Configuration).registerConfiguration({id:w.$9l,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[w.$0l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$co.as(C.$ho.Configuration).registerConfiguration({id:w.$9l,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.$_l]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,O.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,O.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.$0l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[236],ce([0,1,15,26,278,235]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=void 0;async function O(E,y){const w=await y.request(E,N.CancellationToken.None),h=(await(0,D.$Re)(w.stream)).toString(),c=w.res.statusCode??200;return{headers:w.res.headers,statusCode:c,responseData:h}}async function I(E){const y={method:E.type,headers:E.headers};return new Promise((h,c)=>{const p=L.request(E.url??"",y,g=>{g.on("data",function(l){h({headers:g.headers,statusCode:g.statusCode??200,responseData:l.toString()})}),g.on("error",function(l){c(l)})});p.write(E.data,g=>{g&&c(g)}),p.end()})}async function C(E,y,w){const h=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),c={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:h};try{const p=E?await O(c,E):await I(c);w(p.statusCode,p.headers,p.responseData)}catch{w(0,{})}}class f extends A.$MQ{constructor(y,w,h,c,p){const g={sendPOST:(l,u)=>{C(y,l,u)}};super(w,h,c,p,g)}}e.$NQ=f}),define(ae[237],ce([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;let w=class{constructor(c,p,g,l,u,m){this.b=c,this.c=p,this.d=g,this.e=l,this.f=u,this.g=m,this.a=new Map}h(c){if(!this.a.has(c.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const g=[c.id,JSON.stringify(p),c.aiKey],u=new N.$1q(D.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),m=[new f.$7cc(u),new E.$rac(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new y.$Zr({appenders:m,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,p,g){this.h(c).publicLog(p,g)}publicLogError(c,p,g){this.h(c).publicLogError(p,g)}};e.$oec=w,e.$oec=w=ve([Q(0,L.$3i),Q(1,C.$2l),Q(2,O.$3j),Q(3,O.$4j),Q(4,A.$Di),Q(5,I.$jk)],w)}),define(ae[78],ce([0,1,3,8,21,4,9]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$pw=e.$nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$jw=e.$iw=void 0,e.$kw=f,e.$lw=y,e.$mw=w,e.$ow=h,e.$qw=c,e.$rw=p,e.$iw=(0,A.$wi)("tunnelService"),e.$jw=(0,A.$wi)("sharedTunnelsService");var I;(function(u){u.Http="http",u.Https="https"})(I||(e.TunnelProtocol=I={}));var C;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(C||(e.TunnelPrivacyId=C={}));function f(u){return!!u.forwardPort}var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function y(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(m)return{address:m[1],port:+m[2]}}function w(u){if(u.scheme!=="http"&&u.scheme!=="https"||!u.query)return;const m=u.query.split("&");for(const d of m){const $=d.split("=")[1];if(/^https?:/.exec($)){const t=y(N.URI.parse($));if(t)return t}}}e.$nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(u){return e.$nw.indexOf(u)>=0}e.$pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(u){return e.$pw.indexOf(u)>=0}function p(u,m,d,$){if(d===1)return!1;if(d===2&&c(m)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(t?.length===4&&parseInt(t[1])>=18)return!1}return u<1024}class g{constructor(m,d,$){this.remoteAddress=m,this.localAddress=d,this.b=$,this.a=new D.$de,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sw=g;let l=class{constructor(m,d){this.k=m,this.l=d,this.a=new D.$de,this.onTunnelOpened=this.a.event,this.b=new D.$de,this.onTunnelClosed=this.b.event,this.c=new D.$de,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const m=this.l.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.i=m.privacyOptions,this.h=m.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const m=[],d=Array.from(this.e.values());for(const $ of d){const t=Array.from($.values());for(const r of t){const n=await r.value;n&&typeof n!="string"&&m.push(n)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:d}of m.values())await d.then($=>typeof $!="string"?$?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,d,$,t,r){this.q(m,d,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:d,localAddress:$,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,d){(c(m)||h(m))&&(m=e.$nw[0]);const $=this.s(m,d);if($)return++$.refcount,$.value}openTunnel(m,d,$,t,r,n=!1,s,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${$} on local port ${r}.`);const o=this.f??m;if(!o)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(o,d,$,t,r,n,s,i);return a?a.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,$),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(b);return(b.tunnelRemoteHost!==d||b.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&b.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const d=this.e.get(m.tunnelRemoteHost);if(d){const $=d.get(m.tunnelRemotePort);$&&($.refcount--,await this.p(m.tunnelRemoteHost,m.tunnelRemotePort,$))}}}}async p(m,d,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${d}.`);const t=$.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(d),t}}async closeTunnel(m,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${d} `);const $=this.e.get(m);if($&&$.has(d)){const t=$.get(d);t.refcount=0,await this.p(m,d,t)}}q(m,d,$){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(d,{refcount:1,value:$})}async r(m,d){const $=this.e.get(m);if($){const t=$.get(d),r=t?await t.value:void 0;(!r||typeof r=="string")&&$.delete(d),$.size===0&&this.e.delete(m)}}s(m,d){const $=[m];h(m)?($.push(...e.$nw),$.push(...e.$pw)):c(m)&&$.push(...e.$pw);const t=$.map(r=>this.e.get(r));for(const r of t){const n=r?.get(d);if(n)return n}}canTunnel(m){return!!y(m)}u(m,d,$,t,r,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${$} on local port ${t}.`);const i=$;this.j.add(i);const o=t===void 0?$:t,a={elevationRequired:r?this.isPortPrivileged(o):!1},b={remoteAddress:{host:d,port:$},localAddressPort:t,privacy:n,public:n?n!==C.Private:void 0,protocol:s},S=m.forwardPort(b,a);return S?(this.q(d,$,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),S}};e.$tw=l,e.$tw=l=ve([Q(0,O.$3j),Q(1,L.$3i)],l)}),define(ae[238],ce([0,1,9,78,2,7,6]),function(ne,e,D,N,L,A,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class C extends L.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Th),this.b.p)}setAddress(y){this.a=y,this.b&&(this.b.complete(y),this.b=null)}setTunnel(y){this.B(y)}}let f=class extends L.$Uc{static{I=this}static{this.a=0}constructor(y,w){super(),this.f=y,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(y,w,h,c,p,g,l){const u=new C,m=await Promise.resolve(this.f.openTunnel(y,u,h,c,p,g,l));if(!m||typeof m=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${c} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),u.dispose(),await m.dispose(),(0,A.$6)();return u.setTunnel(m),this.b.set(w,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${h}:${c} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(y,w){const h=this.b.get(y);h&&h.setAddress(w)}async destroyTunnel(y){const w=this.b.get(y);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this.b.delete(y),await w.dispose();return}this.c.add(y)}};e.$yec=f,e.$yec=f=I=ve([Q(0,N.$jw),Q(1,D.$3j)],f)}),define(ae[28],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,D.$wi)("IUriIdentityService")}),define(ae[239],ce([0,1,28,191,12,20,128,3,2]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class f{static{this._clock=0}constructor(w){this.uri=w,this.time=f._clock++}touch(){return this.time=f._clock++,this}}let E=class{constructor(w){this.g=w,this.c=new C.$Tc,this.f=2**16;const h=new Map,c=p=>{let g=h.get(p.scheme);return g===void 0&&(g=w.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,g)),g};this.c.add(I.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new A.$Yg(c),this.d=new O.$zs((p,g)=>this.extUri.compare(p,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,A.$$g)(w));const h=this.d.get(w);return h?h.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new f(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((c,p)=>c[1].time<p[1].time?1:c[1].time>p[1].time?-1:0);f._clock=0,this.d.clear();const h=this.f*.5;for(let c=0;c<h;c++)this.d.set(w[c][0],w[c][1].touch())}};e.$As=E,e.$As=E=ve([Q(0,L.$3k)],E),(0,N.$xs)(D.$Al,E,1)}),define(ae[240],ce([0,1,3,2,12,51,34]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class I extends N.$Uc{constructor(f,E,y,w,h,c){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$de),this.onDidChangeFile=this.a.event,this.b=A.$Ci.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const f of this.j.profiles)this.c.add(f.settingsResource),this.c.add(f.keybindingsResource),this.c.add(f.tasksResource),this.c.add(f.extensionsResource)}open(f,E){return this.g.open(this.t(f),E)}close(f){return this.g.close(f)}read(f,E,y,w,h){return this.g.read(f,E,y,w,h)}write(f,E,y,w,h){return this.g.write(f,E,y,w,h)}watch(f,E){this.b.set(f,f);const y=this.g.watch(this.t(f),E);return(0,N.$Sc)(()=>{this.b.delete(f),y.dispose()})}stat(f){return this.g.stat(this.t(f))}mkdir(f){return this.g.mkdir(this.t(f))}rename(f,E,y){return this.g.rename(this.t(f),this.t(E),y)}readFile(f,E){return this.g.readFile(this.t(f),E)}readFileStream(f,E,y){return this.g.readFileStream(this.t(f),E,y)}readdir(f){return this.g.readdir(this.t(f))}enforceAtomicReadFile(f){return this.c.has(f)}writeFile(f,E,y){return this.g.writeFile(this.t(f),E,y)}enforceAtomicWriteFile(f){return this.c.has(f)?{postfix:".vsctmp"}:!1}delete(f,E){return this.g.delete(this.t(f),E)}copy(f,E,y){if((0,L.$7k)(this.g))return this.g.copy(this.t(f),this.t(E),y);throw new Error("copy not supported")}cloneFile(f,E){if((0,L.$8k)(this.g))return this.g.cloneFile(this.t(f),this.t(E));throw new Error("clone not supported")}s(f){const E=[];for(const y of f){if(y.resource.scheme!==this.f)continue;const w=this.u(y.resource);this.b.findSubstr(w)&&E.push({resource:w,type:y.type,cId:y.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(f){return f.with({scheme:this.f})}u(f){return f.with({scheme:this.h})}}e.$Tdc=I}),define(ae[79],ce([0,1,62]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$kKb=L,e.$lKb=A;function N(O,I,C,f){const E=(0,D.$Yn)(O,I,C,f)[0];return E&&(O=O.substring(0,E.offset)+E.content+O.substring(E.offset+E.length)),O}function L(O,I,C){let f=C;for(;f>=0;){if(O.charAt(f)===I.charAt(I.length-1)&&I.length===1)return f+1;if(f--,I.length===2&&f>=0&&O.charAt(f)===I.charAt(0))return f+2}return 0}function A(O,I,C){let f=C;for(;f>=0;)if(O.charAt(f)===I.charAt(I.length-1)&&I.length===1||(f++,I.length===2&&f>=0&&O.charAt(f)===I.charAt(1)))return f;return O.length-1}}),define(ae[241],ce([0,1,30,55,13]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=A;function A(h,c,p,g,l,u){const m=[],d=[],$=[];if(!c){const q=h.filter(({identifier:Y})=>l.every(J=>J.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:m,removed:d,updated:$},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}h=h.map(y),c=c.map(y),p=p?p.map(y):null;const t=new Map,r=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};h.forEach(({identifier:q})=>r(q)),c.forEach(({identifier:q})=>r(q)),p?.forEach(({identifier:q})=>r(q)),g?.forEach(({identifier:q})=>r(q)),u?.forEach(q=>r(q));const n=q=>{const Y=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,Y)=>(q.set(n(Y),Y),q),i=h.reduce(s,new Map),o=c.reduce(s,new Map),a=c.reduce((q,Y)=>s(q,(0,D.$3n)(Y)),new Map),b=p?p.reduce(s,new Map):null,S=g.reduce(s,new Map),v=l.reduce((q,Y)=>{const J=t.get(Y.toLowerCase());return q.add(J?`uuid:${J}`:`id:${Y.toLowerCase()}`)},new Set),k=u?u.reduce((q,{id:Y,uuid:J})=>(J=J??t.get(Y.toLowerCase()),q.add(J?`uuid:${J}`:`id:${Y.toLowerCase()}`)),new Set):null,P=O(i,o,v,!1);if(P.added.size>0||P.removed.size>0||P.updated.size>0){const q=O(b,i,v,!1),Y=O(b,o,v,!0),J=(X,H,K,G)=>{let V,ie,se;return H.installed?(V=G.pinned,se=G.preRelease,V&&(ie=G.version)):(V=K.pinned,se=K.preRelease,V&&(ie=K.version)),V===void 0&&(V=H.pinned,V&&(ie=H.version)),se===void 0&&(se=H.preRelease),{...G,installed:H.installed||K.installed,pinned:V,preRelease:se,version:ie??(K.version&&(!H.installed||N.gt(K.version,H.version))?K.version:H.version),state:C(H,K,b?.get(X))}};for(const X of Y.removed.values()){const H=i.get(X);if(!H)continue;const K=(0,L.$hg)(b?.get(X)),G=k&&!k.has(X)&&K.installed;H.installed&&G?d.push(H.identifier):a.set(X,H)}for(const X of Y.added.values()){const H=(0,L.$hg)(o.get(X)),K=i.get(X);if(K){if(P.updated.has(X)){const G=J(X,K,H,H);I(K,H,!1,!1)||$.push(w(G,X)),a.set(X,G)}}else H.installed&&m.push(w(H,X))}for(const X of Y.updated.values()){const H=(0,L.$hg)(o.get(X)),K=(0,L.$hg)(b?.get(X)),G=i.get(X);if(G)if(k&&!k.has(X)&&K.installed&&G.installed&&!H.installed)d.push(G.identifier);else{const ie=J(X,G,H,H);$.push(w(ie,X)),a.set(X,ie)}else H.installed&&m.push(w(H,X))}for(const X of q.added.values())Y.added.has(X)||a.set(X,(0,L.$hg)(i.get(X)));for(const X of q.updated.values()){if(Y.removed.has(X)||Y.updated.has(X))continue;const H=(0,L.$hg)(i.get(X)),K=(0,L.$hg)(o.get(X));a.set(X,J(X,H,K,H))}for(const X of q.removed.values())Y.updated.has(X)||Y.removed.has(X)||S.has(X)||(0,L.$hg)(o.get(X)).installed&&k&&(k.has(X)||!(0,L.$hg)(b?.get(X)).installed||a.delete(X))}const R=[],F=O(o,a,new Set,!0),T=F.added.size>0||F.updated.size>0||F.removed.size>0;return T&&a.forEach((q,Y)=>R.push(w(q,Y))),{local:{added:m,removed:d,updated:$},remote:T?{added:[...F.added].map(q=>a.get(q)),updated:[...F.updated].map(q=>a.get(q)),removed:[...F.removed].map(q=>o.get(q)),all:R}:null}}function O(h,c,p,g){const l=h?[...h.keys()].filter(t=>!p.has(t)):[],u=[...c.keys()].filter(t=>!p.has(t)),m=u.filter(t=>!l.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),d=l.filter(t=>!u.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),$=new Set;for(const t of l){if(d.has(t))continue;const r=h.get(t),n=c.get(t);(!n||!I(r,n,g,!0))&&$.add(t)}return{added:m,removed:d,updated:$}}function I(h,c,p,g){return!(h.disabled!==c.disabled||!!h.isApplicationScoped!=!!c.isApplicationScoped||g&&h.installed!==c.installed||h.installed&&c.installed&&(h.preRelease!==c.preRelease||h.pinned!==c.pinned||c.pinned&&h.version!==c.version)||!E(h.state,c.state)||p&&h.version!==c.version)}function C(h,c,p){const g=h.state,l=c.state,u=p?.state;if(!c.version||g&&N.gt(h.version,c.version))return g;if(l&&N.gt(c.version,h.version)||!g)return l;if(!l)return g;const m=(0,D.$3n)(g),d=u?f(u,l):{added:Object.keys(l).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},$=u?f(u,g):{added:Object.keys(g).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...d.added.values(),...d.updated.values()])m[t]=l[t];for(const t of d.removed.values())$.updated.has(t)||delete m[t];return m}function f(h,c){const p=Object.keys(h),g=Object.keys(c),l=g.filter(d=>!p.includes(d)).reduce((d,$)=>(d.add($),d),new Set),u=p.filter(d=>!g.includes(d)).reduce((d,$)=>(d.add($),d),new Set),m=new Set;for(const d of p){if(u.has(d))continue;const $=h[d],t=c[d];(0,D.$7n)($,t)||m.add(d)}return{added:l,removed:u,updated:m}}function E(h={},c={}){const{added:p,removed:g,updated:l}=f(h,c);return p.size===0&&g.size===0&&l.size===0}function y(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function w(h,c){const p={...h,identifier:{id:h.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete p.disabled,h.installed||delete p.installed,h.state||delete p.state,h.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ae[111],ce([0,1,17,21,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tMb=e.$sMb=void 0,e.$sMb=(0,L.$wi)("IIgnoredExtensionsManagementService");let A=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,C){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==I&&E!==`-${I}`),C&&f.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}updateSynchronizedExtensions(I,C){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==I&&E!==`-${I}`),C&&f.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}getIgnoredExtensions(I){const C=I.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),f=this.b().map(w=>w.toLowerCase()),E=[],y=[];if(Array.isArray(f))for(const w of f)w.startsWith("-")?y.push(w.substring(1)):E.push(w);return(0,D.$Mb)([...C,...E].filter(w=>!y.includes(w)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$tMb=A,e.$tMb=A=ve([Q(0,N.$3i)],A)}),define(ae[242],ce([0,1,17,35,30,93,79]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=C;function I(d){return(0,N.$Jn)(d)||[]}async function C(d,$,t,r,n){const s=I(d),i=I($),o=t?I(t):null,a=[...s,...i,...o||[]].map(J=>J.key),b=await n.resolveUserBindings(a),S=E(s,i,o,b);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const v=w(s),k=w(i),P=o?w(o):null,R=c(v,k,b),F=P?c(P,v,b):{added:[...v.keys()].reduce((J,X)=>(J.add(X),J),new Set),removed:new Set,updated:new Set},T=P?c(P,k,b):{added:[...k.keys()].reduce((J,X)=>(J.add(X),J),new Set),removed:new Set,updated:new Set},q=f(R,F,T);let Y=d;for(const J of q.removed.values())q.conflicts.has(J)||(Y=u(Y,J,r));for(const J of q.added.values()){if(q.conflicts.has(J))continue;const X=k.get(J);if(X.some(H=>H.command!==`-${J}`&&S.conflicts.has(b[H.key]))){q.conflicts.add(J);continue}Y=l(Y,X,r)}for(const J of q.updated.values()){if(q.conflicts.has(J))continue;const X=k.get(J);if(X.some(H=>H.command!==`-${J}`&&S.conflicts.has(b[H.key]))){q.conflicts.add(J);continue}Y=m(Y,J,X,r)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}function f(d,$,t){const r=new Set,n=new Set,s=new Set,i=new Set;for(const o of $.removed.values())t.updated.has(o)&&i.add(o);for(const o of t.removed.values())i.has(o)||($.updated.has(o)?i.add(o):n.add(o));for(const o of $.added.values())i.has(o)||t.added.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.added.values())i.has(o)||($.added.has(o)?d.updated.has(o)&&i.add(o):r.add(o));for(const o of $.updated.values())i.has(o)||t.updated.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.updated.values())i.has(o)||($.updated.has(o)?d.updated.has(o)&&i.add(o):s.add(o));return{added:r,removed:n,updated:s,conflicts:i}}function E(d,$,t,r){const n=new Set,s=y(d,r),i=y($,r),o=t?y(t,r):null,a=h(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const b=o?h(o,s):{added:[...s.keys()].reduce((F,T)=>(F.add(T),F),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=o?h(o,i):{added:[...i.keys()].reduce((F,T)=>(F.add(T),F),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:v,removed:k,updated:P,conflicts:R}=f(a,b,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:k,updated:P,conflicts:R}}function y(d,$){const t=new Map;for(const r of d){const n=$[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function w(d){const $=new Map;for(const t of d){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=$.get(r);n||(n=[],$.set(r,n)),n.push(t)}return $}function h(d,$){const t=[...d.keys()],r=[...$.keys()],n=r.filter(o=>!t.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),s=t.filter(o=>!r.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),i=new Set;for(const o of t){if(s.has(o))continue;const a=d.get(o).map(S=>({...S,key:o})),b=$.get(o).map(S=>({...S,key:o}));(0,D.$ub)(a,b,(S,v)=>g(S,v))||i.add(o)}return{added:n,removed:s,updated:i}}function c(d,$,t){const r=[...d.keys()],n=[...$.keys()],s=n.filter(a=>!r.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),i=r.filter(a=>!n.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),o=new Set;for(const a of r){if(i.has(a))continue;const b=d.get(a).map(v=>({...v,key:t[v.key]})),S=$.get(a).map(v=>({...v,key:t[v.key]}));p(b,S)||o.add(a)}return{added:s,removed:i,updated:o}}function p(d,$){return!(!(0,D.$ub)(d.filter(({command:t})=>t[0]!=="-"),$.filter(({command:t})=>t[0]!=="-"),(t,r)=>g(t,r))||!(0,D.$ub)(d.filter(({command:t})=>t[0]==="-"),$.filter(({command:t})=>t[0]==="-"),(t,r)=>g(t,r)))}function g(d,$){if(d.command!==$.command||d.key!==$.key)return!1;const t=A.$uj.deserialize(d.when),r=A.$uj.deserialize($.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!L.$7n(d.args,$.args))}function l(d,$,t){for(const r of $)d=O.edit(d,[-1],r,t);return d}function u(d,$,t){const r=I(d);for(let n=r.length-1;n>=0;n--)(r[n].command===$||r[n].command===`-${$}`)&&(d=O.edit(d,[n],void 0,t));return d}function m(d,$,t,r){const n=I(d),s=n.findIndex(i=>i.command===$||i.command===`-${$}`);for(let i=n.length-1;i>=0;i--)(n[i].command===$||n[i].command===`-${$}`)&&(d=O.edit(d,[i],void 0,r));for(let i=t.length-1;i>=0;i--)d=O.edit(d,[s],t[i],r);return d}}),define(ae[243],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=D,e.$j_b=L;function D(A,O,I){const C={},f={},E=new Set;if(!O)return{local:{added:C,updated:f,removed:[...E.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const y=N(A,O);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:C,updated:f,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=N(I,A),h=N(I,O),c={},p={},g=new Set,l=new Set;for(const u of w.removed.values())h.updated.has(u)?C[u]=O[u]:g.add(u);for(const u of h.removed.values())l.has(u)||(w.updated.has(u)?l.add(u):E.add(u));for(const u of w.updated.values())l.has(u)||(h.updated.has(u)?y.updated.has(u)&&l.add(u):p[u]=A[u]);for(const u of h.updated.values())l.has(u)||(w.updated.has(u)?y.updated.has(u)&&l.add(u):A[u]!==void 0&&(f[u]=O[u]));for(const u of w.added.values())l.has(u)||(h.added.has(u)?y.updated.has(u)&&l.add(u):c[u]=A[u]);for(const u of h.added.values())l.has(u)||(w.added.has(u)?y.updated.has(u)&&l.add(u):C[u]=O[u]);return{local:{added:C,removed:[...E.values()],updated:f},remote:{added:c,removed:[...g.values()],updated:p},conflicts:[...l.values()]}}function N(A,O){const I=A?Object.keys(A):[],C=O?Object.keys(O):[],f=C.filter(w=>!I.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),E=I.filter(w=>!C.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),y=new Set;for(const w of I){if(E.has(w))continue;const h=A[w],c=O[w];h!==c&&y.add(w)}return{added:f,removed:E,updated:y}}function L(A,O){const{added:I,removed:C,updated:f}=N(A,O);return I.size===0&&C.size===0&&f.size===0}}),define(ae[244],ce([0,1,30]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=N;function N(A,O,I,C){const f={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!O){const w=A.filter(({id:h})=>!C.includes(h));return w.length?E.added=w:E=null,{local:f,remote:E}}const y=L(A,O,C);if(y.added.length>0||y.removed.length>0||y.updated.length>0){const w=L(I,A,C),h=L(I,O,C);for(const c of h.removed){const p=A.find(g=>g.id===c);p&&f.removed.push(p)}for(const c of h.added){const p=O.find(g=>g.id===c);w.added.includes(c)?y.updated.includes(c)&&f.updated.push(p):f.added.push(p)}for(const c of h.updated)f.updated.push(O.find(p=>p.id===c));for(const c of w.added)h.added.includes(c)||E.added.push(A.find(p=>p.id===c));for(const c of w.updated)h.removed.includes(c)||h.updated.includes(c)||E.updated.push(A.find(p=>p.id===c));for(const c of w.removed){const p=O.find(g=>g.id===c);p&&E.removed.push(p)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:f,remote:E}}function L(A,O,I){A=A?A.filter(({id:h})=>!I.includes(h)):[],O=O.filter(({id:h})=>!I.includes(h));const C=A.map(({id:h})=>h),f=O.map(({id:h})=>h),E=f.filter(h=>!C.includes(h)),y=C.filter(h=>!f.includes(h)),w=[];for(const{id:h,name:c,shortName:p,icon:g,useDefaultFlags:l}of A){if(y.includes(h))continue;const u=O.find(m=>m.id===h);(!u||u.name!==c||u.shortName!==p||u.icon!==g||!(0,D.$7n)(u.useDefaultFlags,l))&&w.push(h)}return{added:E,removed:y,updated:w}}}),define(ae[25],ce([0,1,17,13,179,47,29,4,101,43]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plb=e.$olb=e.$nlb=e.$mlb=e.$llb=e.$klb=e.$jlb=e.$ilb=e.$hlb=e.$flb=e.MergeState=e.Change=e.SyncStatus=e.$elb=e.$dlb=e.$clb=e.UserDataSyncErrorCode=e.$alb=e.$_kb=e.$$kb=e.$0kb=e.$9kb=e.$6kb=e.SyncResource=e.$3kb=e.$2kb=void 0,e.$Zkb=E,e.$1kb=y,e.$4kb=w,e.$5kb=h,e.$7kb=p,e.$8kb=g,e.$blb=l,e.$glb=s;function E(){const i=f.$co.as(A.$ho.Configuration).getConfigurationProperties();return Object.keys(i).filter(o=>!!i[o].disallowSyncIgnore)}function y(){const i=f.$co.as(A.$ho.Configuration).getConfigurationProperties(),o=Object.keys(i).filter(S=>!!i[S].ignoreSync),a=Object.keys(i).filter(S=>i[S].scope===2||i[S].scope===6),b=E();return(0,D.$Mb)([...o,...a,...b])}e.$2kb="settingsSync",e.$3kb="settingsSync.keybindingsPerPlatform";function w(){const i="vscode://schemas/ignoredSettings",o=f.$co.as(A.$ho.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$3kb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$To,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=f.$co.as(C.$do.JSONContribution),b=()=>{const S=E(),v=y(),k=Object.keys(A.$io.properties).filter(F=>!v.includes(F)),P=v.filter(F=>!S.includes(F)),R={items:{type:"string",enum:[...k,...P.map(F=>`-${F}`)]}};a.registerSchema(i,R)};return o.onDidUpdateConfiguration(()=>b())}function h(i){return i&&(0,N.$$f)(i)&&(0,N.$9f)(i.id)&&Array.isArray(i.scopes)}var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$6kb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...o){return i?[i,...o]:o}function g(i,o,a,b){return b.joinPath(a.userDataSyncHome,...p(i,o,`lastSync${o}.json`))}e.$9kb=(0,I.$wi)("IUserDataSyncStoreManagementService"),e.$0kb=(0,I.$wi)("IUserDataSyncStoreService"),e.$$kb=(0,I.$wi)("IUserDataSyncLocalStoreService"),e.$_kb="x-operation-id",e.$alb="X-Execution-Id";function l(i){const o={};return o[e.$alb]=i,o}var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class m extends Error{constructor(o,a,b,S){super(o),this.code=a,this.resource=b,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$clb=m;class d extends m{constructor(o,a,b,S,v){super(o,b,void 0,v),this.url=a,this.serverCode=S}}e.$dlb=d;class $ extends m{constructor(o,a){super(o,a)}}e.$elb=$,function(i){function o(a){if(a instanceof i)return a;const b=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(b&&b[1]){const S=b[2]==="unknown"?void 0:b[2],v=b[3]==="unknown"?void 0:b[3];return new i(a.message,b[1],S,v)}return new i(a.message,"Unknown")}i.toUserDataSyncError=o}(m||(e.$clb=m={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(r||(e.Change=r={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$flb="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$hlb=(0,I.$wi)("IUserDataSyncEnablementService"),e.$ilb=(0,I.$wi)("IUserDataSyncService"),e.$jlb=(0,I.$wi)("IUserDataSyncResourceProviderService"),e.$klb=(0,I.$wi)("IUserDataAutoSyncService"),e.$llb=(0,I.$wi)("IUserDataSyncUtilService"),e.$mlb=(0,I.$wi)("IUserDataSyncLogService"),e.$nlb="userDataSync",e.$olb="vscode-userdata-sync",e.$plb="preview"}),define(ae[245],ce([0,1,30,25]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KLb=L;function L(O,I,C,f,E){if(!I)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const y=A(O,I);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=C?A(C,I):{added:Object.keys(I).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},h=C?A(C,O):{added:Object.keys(O).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},p=D.$3n(I),g=!C;for(const u of h.added.values())u!==N.$flb&&g&&w.added.has(u)||(p[u]=O[u]);for(const u of h.updated.values())p[u]=O[u];for(const u of h.removed.values())f.unregistered.includes(u)||delete p[u];for(const u of w.added.values()){const m=I[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(u))continue;const d=O[u];d&&d.value===m.value||u===N.$flb&&g&&h.added.has(u)||(d?c.updated[u]=m:c.added[u]=m)}for(const u of w.updated.values()){const m=I[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const d=O[u];d&&d.value===m.value||(c.updated[u]=m)}for(const u of w.removed.values()){if(f.machine.includes(u)){E.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||c.removed.push(u)}const l=A(I,p);return{local:c,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}function A(O,I){const C=Object.keys(O),f=Object.keys(I),E=f.filter(h=>!C.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),y=C.filter(h=>!f.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),w=new Set;for(const h of C){if(y.has(h))continue;const c=O[h],p=I[h];D.$7n(c,p)||w.add(h)}return{added:E,removed:y,updated:w}}}),define(ae[246],ce([0,1,17,35,62,44,30,79,25]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mKb=f,e.$nKb=w,e.$oKb=h,e.$pKb=c,e.$qKb=g,e.$rKb=u;function f(a,b,S){let v=[];S?v=y(S):v=E(b);const k=[],P=[...(0,C.$Zkb)()];if(Array.isArray(v))for(const R of v)R.startsWith("-")?P.push(R.substring(1)):k.push(R);return(0,D.$Mb)([...a,...k].filter(R=>!P.includes(R)))}function E(a){let b=a.inspect("settingsSync.ignoredSettings").userValue;return b!==void 0||(b=a.inspect("sync.ignoredSettings").userValue,b!==void 0)?b:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const b=(0,N.$Jn)(a);return b?b["settingsSync.ignoredSettings"]||b["sync.ignoredSettings"]||[]:[]}function w(a,b){const S=(0,N.$Jn)(a)||{};let v="{}";for(const k of Object.keys(S)){const P=(0,L.$Yn)(v,[k],S[k],b);v=(0,L.$2n)(v,P)}return v}function h(a,b,S,v){if(S.length){const k=o(b),P=(0,N.$Jn)(b)||{},R=(0,N.$Jn)(a);if(!R)return a;const F=[];for(const T of S){const q=P[T],Y=R[T];q===void 0?a=I.edit(a,[T],void 0,v):Y!==void 0?a=I.edit(a,[T],q,v):F.push(t(T,k))}F.sort((T,q)=>T.startOffset-q.startOffset),F.forEach(T=>a=u(T.setting.key,b,a,v))}return a}function c(a,b,S,v,k,P){const R=h(a,b,v,P),F=S!==R,T=S!==b;if(!F&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!T)return{conflictsSettings:[],localContent:null,remoteContent:R,hasConflicts:!1};if(T&&!F)return{conflictsSettings:[],localContent:h(b,a,v,P),remoteContent:null,hasConflicts:!1};if(S===null&&g(a)){const M=p(a,b,v)?null:h(b,a,v,P);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let q=a,Y=b;const J=(0,N.$Jn)(a),X=(0,N.$Jn)(b),H=S?(0,N.$Jn)(S):null,K=v.reduce((M,z)=>(M.add(z),M),new Set),G=l(J,X,K),V=l(H,J,K),ie=l(H,X,K),se=new Map,he=new Set,ee=M=>{he.add(M);const z=k.filter(({key:U})=>U===M)[0];z?(q=I.edit(q,[M],z.value,P),Y=I.edit(Y,[M],z.value,P)):se.set(M,{key:M,localValue:J[M],remoteValue:X[M]})};for(const M of V.removed.values())ie.updated.has(M)?ee(M):Y=I.edit(Y,[M],void 0,P);for(const M of ie.removed.values())he.has(M)||(V.updated.has(M)?ee(M):q=I.edit(q,[M],void 0,P));for(const M of V.updated.values())he.has(M)||(ie.updated.has(M)?G.updated.has(M)&&ee(M):Y=I.edit(Y,[M],J[M],P));for(const M of ie.updated.values())he.has(M)||(V.updated.has(M)?G.updated.has(M)&&ee(M):q=I.edit(q,[M],X[M],P));for(const M of V.added.values())he.has(M)||(ie.added.has(M)?G.updated.has(M)&&ee(M):Y=u(M,q,Y,P));for(const M of ie.added.values())he.has(M)||(V.added.has(M)?G.updated.has(M)&&ee(M):q=u(M,Y,q,P));const W=se.size>0||!p(q,Y,v),B=W||!p(q,a,[]),j=W||!p(Y,b,[]);return{localContent:B?q:null,remoteContent:j?Y:null,conflictsSettings:[...se.values()],hasConflicts:W}}function p(a,b,S){if(a===b)return!0;const v=(0,N.$Jn)(a),k=(0,N.$Jn)(b),P=S.reduce((T,q)=>(T.add(q),T),new Set),R=o(a).filter(T=>!(T.setting&&P.has(T.setting.key))),F=o(b).filter(T=>!(T.setting&&P.has(T.setting.key)));if(R.length!==F.length)return!1;for(let T=0;T<R.length;T++){const q=R[T],Y=F[T];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$7n(v[q.setting.key],k[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function g(a){return a?o(a).length===0:!0}function l(a,b,S){const v=a?Object.keys(a).filter(T=>!S.has(T)):[],k=Object.keys(b).filter(T=>!S.has(T)),P=k.filter(T=>!v.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),R=v.filter(T=>!k.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),F=new Set;if(a)for(const T of v){if(R.has(T))continue;const q=a[T],Y=b[T];O.$7n(q,Y)||F.add(T)}return{added:P,removed:R,updated:F}}function u(a,b,S,v){const k=(0,N.$Jn)(b),P=o(b),R=o(S),F=m(a,P,R);return d(S,a,k[a],F,R,v)}function m(a,b,S){const v=b.findIndex(P=>P.setting?.key===a),k=b[v-1];if(k){if(k.setting){const R=t(k.setting.key,S);if(R)return{index:S.indexOf(R),insertAfter:!0}}else{const R=r(v,b);if(R){const F=t(R.setting.key,S);if(F){const T=n(S.indexOf(F),S),q=s(b,R,b[v]);if(T){const Y=s(S,F,T),J=i(q,Y);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.indexOf(T),insertAfter:!1}}else{const Y=s(S,F,S[S.length-1]),J=i(q,Y);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const P=b[v+1];if(P)if(P.setting){const R=t(P.setting.key,S);if(R)return{index:S.indexOf(R),insertAfter:!1}}else{const R=n(v,b);if(R){const F=t(R.setting.key,S);if(F){const T=r(S.indexOf(F),S),q=s(b,b[v],R);if(T){const Y=s(S,T,F),J=i(q.reverse(),Y.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:S.indexOf(T),insertAfter:!0}}else{const Y=s(S,S[0],F),J=i(q.reverse(),Y.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function d(a,b,S,v,k,P){let R;return v.index===-1?R=(0,L.$Yn)(a,[b],S,P):R=$(a,b,S,v,k,P).map(F=>(0,L.$Zn)(a,F,P)[0]),(0,L.$2n)(a,R)}function $(a,b,S,v,k,P){const R=`${JSON.stringify(b)}: ${JSON.stringify(S)}`,F=(0,A.$Vn)(P,a),T=k[v.index];if(v.insertAfter){const q=[];if(T.setting)q.push({offset:T.endOffset,length:0,content:","+R});else{const Y=n(v.index,k),J=r(v.index,k),X=J?.setting?.commaOffset;J&&X===void 0&&q.push({offset:J.endOffset,length:0,content:","});const H=X!==void 0&&X>T.endOffset;q.push({offset:H?X+1:T.endOffset,length:0,content:Y?F+R+",":F+R})}return q}else{if(T.setting)return[{offset:T.startOffset,length:0,content:R+","}];const q=(k[v.index-1]&&!k[v.index-1].setting?F:"")+R+(n(v.index,k)?",":"")+F;return[{offset:T.startOffset,length:0,content:q}]}}function t(a,b){return b.filter(S=>S.setting?.key===a)[0]}function r(a,b){for(let S=a-1;S>=0;S--)if(b[S].setting)return b[S]}function n(a,b){for(let S=a+1;S<b.length;S++)if(b[S].setting)return b[S]}function s(a,b,S){const v=a.indexOf(b),k=a.indexOf(S);return a.filter((P,R)=>v<R&&R<k)}function i(a,b){if(a.length&&b.length){let S=0;for(;S<b.length&&S<a.length;S++)if(a[S].value!==b[S].value)return b[S-1];return b[S-1]}}function o(a){const b=[];let S=-1,v,k;const P={onObjectBegin:R=>{S++},onObjectProperty:(R,F,T)=>{S===0&&(v=F,k=R)},onObjectEnd:(R,F)=>{S--,S===0&&b.push({startOffset:v,endOffset:R+F,value:a.substring(v,R+F),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(R,F)=>{S++},onArrayEnd:(R,F)=>{S--,S===0&&b.push({startOffset:v,endOffset:R+F,value:a.substring(v,R+F),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(R,F,T)=>{S===0&&b.push({startOffset:v,endOffset:F+T,value:a.substring(v,F+T),setting:{key:k,commaOffset:void 0}})},onSeparator:(R,F,T)=>{if(S===0&&R===","){let q=b.length-1;for(;q>=0&&!b[q].setting;q--);const Y=b[q];Y&&b.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:F}})}},onComment:(R,F)=>{S===0&&b.push({startOffset:R,endOffset:R+F,value:a.substring(R,R+F)})}};return(0,N.$Qn)(a,P),b}}),define(ae[80],ce([0,1,3,2,4,25]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Jb=e.$7Jb=void 0,e.$7Jb=(0,L.$wi)("IUserDataSyncAccountService");let O=class extends N.$Uc{get account(){return this.a}constructor(C,f){super(),this.g=C,this.h=f,this.b=this.B(new D.$de),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$de),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$8Jb=O,e.$8Jb=O=ve([Q(0,A.$0kb),Q(1,A.$mlb)],O)}),define(ae[247],ce([0,1,20,180,16,9,25]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uMb=void 0;let I=class extends A.$8j{constructor(f,E){super(),this.g=this.B(f.createLogger((0,D.$0g)(E.logsHome,`${O.$nlb}.log`),{id:O.$nlb,name:(0,N.localize)(0,null)}))}trace(f,...E){this.g.trace(f,...E)}debug(f,...E){this.g.debug(f,...E)}info(f,...E){this.g.info(f,...E)}warn(f,...E){this.g.warn(f,...E)}error(f,...E){this.g.error(f,...E)}flush(){this.g.flush()}};e.$uMb=I,e.$uMb=I=ve([Q(0,A.$4j),Q(1,L.$Di)],I)}),define(ae[248],ce([0,1,6,3,2]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class A extends L.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:C,getActiveWindowId:f}){super(),this.a=this.B(new L.$Tc),N.Event.latch(N.Event.any(I,C))(this.f,this,this.a),this.b=(0,D.$jh)(()=>f()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$odc=A}),define(ae[112],ce([0,1,183,14,51,20,8,4,23]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=f,e.$Hi=E,e.$Ki=y,e.$Li=w,e.$Mi=h,e.$Ni=p,e.$Oi=g,e.$Ri=m,e.$Wi=d,e.$Xi=$,e.$Zi=t,e.$1i=r,e.$2i=n,e.$Fi=(0,I.$wi)("contextService");function f(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}function E(s){return typeof s?.id=="string"&&!f(s)&&!w(s)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function y(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$nc)(s)}:i?e.$Ii:e.$Ji;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function w(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}function h(s){const i=s;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}var c;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}function g(s){const i=s;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}class l{constructor(i,o,a,b,S){this.h=i,this.j=a,this.k=b,this.l=S,this.c=L.$Ci.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=L.$Ci.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=l;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.$0g)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=u;function m(s){return new u({uri:s,index:0,name:(0,A.$6g)(s)},{uri:s.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,D.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function d(s,i){return A.$1g.isEqualOrParent(s,i.untitledWorkspacesHome)}function $(s){let i;return O.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===C.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Yi}function r(s,i){return!d(s,i)&&!$(s)}function n(s){return(typeof s=="string"?(0,N.$oc)(s):(0,A.$8g)(s))===e.$Ti}}),define(ae[18],ce([0,1,54,3,2,20,8,174,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=d,e.$Dl=$,e.$El=t;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function d(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.$Cl=(0,E.$wi)("IUserDataProfilesService");function $(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:i}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,i,o,a,b,S){return{id:s,name:i,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:S&&b?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.$0g)(o,"globalStorage"),settingsResource:S&&b?.useDefaultFlags?.settings?S.settingsResource:(0,A.$0g)(o,"settings.json"),keybindingsResource:S&&b?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.$0g)(o,"keybindings.json"),tasksResource:S&&b?.useDefaultFlags?.tasks?S.tasksResource:(0,A.$0g)(o,"tasks.json"),snippetsHome:S&&b?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.$0g)(o,"snippets"),extensionsResource:S&&b?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.$0g)(o,"extensions.json"),cacheHome:(0,A.$0g)(a,s),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let r=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,o,a,b){super(),this.t=i,this.u=o,this.w=a,this.y=b,this.f=!0,this.h=this.B(new N.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),o=[i];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,u.$9f)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}o.push(t((0,A.$7g)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},i))}}catch(S){this.y.error(S)}const a=new h.$Ac,b=new Map;if(o.length)try{const S=this.Q();if(S.workspaces)for(const[v,k]of Object.entries(S.workspaces)){const P=O.URI.parse(v),R=o.find(F=>F.id===k);R&&a.set(P,R)}if(S.emptyWindows)for(const[v,k]of Object.entries(S.emptyWindows)){const P=o.find(R=>R.id===k);P&&b.set(v,P)}}catch(S){this.y.error(S)}this.z={profiles:o,workspaces:a,emptyWindows:b}}return this.z}D(){const i=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const o="Temp",a=new RegExp(`${(0,l.$_e)(o)}\\s(\\d+)`);let b=0;for(const v of this.profiles){const k=a.exec(v.name),P=k?parseInt(k[1]):0;b=P>b?P:b}const S=`${o} ${b+1}`;return this.createProfile((0,D.$kj)((0,g.$Sg)()).toString(16),S,{transient:!0},i)}async createNamedProfile(i,o,a){return this.createProfile((0,D.$kj)((0,g.$Sg)()).toString(16),i,o,a)}async createProfile(i,o,a,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(i,o,a);return b&&await this.setProfileForWorkspace(b,S),S}async F(i,o,a){if(!(0,u.$9f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(o);return b||(b=(async()=>{try{if(this.profiles.find(P=>P.name===o||P.id===i))throw new Error(`Profile with ${o} name already exists`);const v=t(i,o,(0,A.$0g)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.u.createFolder(v.location);const k=[];return this.j.fire({profile:v,join(P){k.push(P)}}),await p.Promises.settled(k),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,b)),b}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(b=>b.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,o.name??a.name,a.location,this.g,{shortName:o.shortName??a.shortName,icon:o.icon===null?void 0:o.icon??a.icon,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.m.fire({profile:o,join(b){a.push(b)}});try{await Promise.allSettled(a)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(b){(0,f.$hl)(b)!==1&&this.y.error(b)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(b=>b.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.L(i,a)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.G(i);return O.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(i){return(0,w.$Gi)(i)?i.uri:(0,w.$Li)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location)))}I(i,o,a){const b=[...this.profiles,...i],S=[];this.s.profiles=[];for(let v of b)v.isDefault||o.some(k=>v.id===k.id)||(v=a.find(k=>v.id===k.id)??v,v.isTransient?this.s.profiles.push(v):S.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(S),this.z=void 0,this.J(i,o,a)}J(i,o,a){this.h.fire({added:i,removed:o,updated:a,all:this.profiles})}L(i,o,a){a=o?.isTransient?!0:a,a||this.L(i,void 0,!0);const b=this.G(i),S=a?this.s:this.C;O.URI.isUri(b)?(S.workspaces.delete(b),o&&S.workspaces.set(b,o)):(S.emptyWindows.delete(b),o&&S.emptyWindows.set(b,o)),a||this.M()}M(){const i={};for(const[a,b]of this.C.workspaces.entries())i[a.toString()]=b.id;const o={};for(const[a,b]of this.C.emptyWindows.entries())o[a.toString()]=b.id;this.R({workspaces:i,emptyWindows:o}),this.z=void 0}N(i){const o={},a=this.D();if(i.workspaces)for(const[S,v]of Object.entries(i.workspaces)){const k=O.URI.parse(v);o[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}const b={};if(i.emptyWindows)for(const[S,v]of Object.entries(i.emptyWindows)){const k=O.URI.parse(v);b[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}return{workspaces:o,emptyWindows:b}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Fl=r,e.$Fl=r=ve([Q(0,C.$Di),Q(1,f.$3k),Q(2,c.$Al),Q(3,y.$3j)],r);class n extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Gl=n}),define(ae[249],ce([0,1,6,2,18]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;let A=class extends N.$Uc{constructor(I){super(),this.B(new D.$Ih(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$Aec=A,e.$Aec=A=ve([Q(0,L.$Cl)],A)}),define(ae[250],ce([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=void 0,e.$mq=$;let d=class extends I.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,i,o,a,b,S){super(),this.z=s,this.C=i,this.D=o,this.F=a,this.G=b,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$de),this.s=this.B(new O.$de),this.t=this.B(new O.$de),this.u=this.B(new O.$de),this.w=this.B(new O.$de),this.y=[],this.B((0,I.$Sc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(o=>(0,w.$4o)(o,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{const a=(await this.installGalleryExtensions([{extension:s,options:i}])).find(({identifier:b})=>(0,h.$up)(b,s.identifier));if(a?.local)return a?.local;throw a?.error?a.error:new w.$7o(`Unknown error while installing extension ${s.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(o){throw $(o)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new w.$7o(y.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const i=[],o=[];return await Promise.allSettled(s.map(async({extension:a,options:b})=>{try{const S=await this.N(a,!!b?.installGivenVersion,!!b?.installPreReleaseVersion,b.productVersion??{version:this.G.version,date:this.G.date});o.push({...S,options:b})}catch(S){i.push({identifier:a.identifier,operation:2,source:a,error:S})}})),o.length&&i.push(...await this.I(o)),i}async uninstall(s,i={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,i)}async toggleAppliationScope(s,i){if((0,c.$Um)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let o=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)||(o=await this.$(s,this.H.defaultProfile.extensionsResource,i));for(const a of this.H.profiles){const b=(await this.getInstalled(1,a.extensionsResource)).find(S=>(0,h.$up)(S.identifier,s.identifier));b?this.w.fire(b):this.u.fire({identifier:s.identifier,profileLocation:a.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,i,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const i=new Map,o=new Map,a=[],b=(v,k)=>`${h.$vp.create(v).toString()}-${k.toString()}`,S=(v,k,P,R)=>{const F=this.Y(v,k,P),T=`${(0,h.$zp)(v.publisher,v.name)}-${P.profileLocation.toString()}`;o.set(T,{task:F,root:R}),this.n.fire({identifier:F.identifier,source:k,profileLocation:P.profileLocation}),this.F.info("Installing extension:",F.identifier.id),E.URI.isUri(k)||this.j.set(b(k,P.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:v,extension:k,options:P}of s){const R=P.isApplicationScoped||P.isBuiltin||(0,c.$Um)(v),F={...P,installOnlyNewlyAddedFromExtensionPack:P.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(k),isApplicationScoped:R,profileLocation:R?this.H.defaultProfile.extensionsResource:P.profileLocation??this.X(),productVersion:P.productVersion??{version:this.G.version,date:this.G.date}},T=E.URI.isUri(k)?void 0:this.j.get(b(k,F.profileLocation));T?(this.F.info("Extension is already requested to install",T.task.identifier.id),a.push(T.task.waitUntilTaskIsFinished())):S(v,k,F,void 0)}return await Promise.all([...o.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const k=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),P=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),R={...v.options,context:{...v.options.context,[w.$Yo]:!0}};for(const{gallery:F,manifest:T}of(0,D.$Mb)(k,({gallery:q})=>q.identifier.id)){if(o.has(`${F.identifier.id.toLowerCase()}-${R.profileLocation.toString()}`))continue;const q=this.j.get(b(F,R.profileLocation));if(q){if(this.J(v,q.task)){const Y=q.task.identifier;this.F.info("Waiting for already requested installing extension",Y.id,v.identifier.id),q.waitingTasks.push(v),a.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,J=>J.some(X=>(0,h.$up)(X.identifier,Y)))).then(J=>{if(this.F.info("Finished waiting for already requested installing extension",Y.id,v.identifier.id),!J.find(H=>(0,h.$up)(H.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else P.some(({identifier:Y})=>(0,h.$up)(Y,F.identifier))||S(T,F,R,v)}}catch(k){if(E.URI.isUri(v.source))(0,D.$Lb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,k.message),(0,D.$Lb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),k}})),await this.L([...o.entries()].map(async([v,{task:k}])=>{const P=new Date().getTime();try{const R=await k.run();if(await this.L(this.y.map(F=>F.postInstall(R,k.source,k.options,L.CancellationToken.None))),!E.URI.isUri(k.source)){const F=k.operation===3,T=F?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(t(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$Cp)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-P,durationSinceUpdate:T}),C.$o&&k.operation!==3)try{await this.z.reportStatistic(R.manifest.publisher,R.manifest.name,R.manifest.version,"install")}catch{}}i.set(v,{local:R,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:R.isApplicationScoped})}catch(R){const F=$(R);throw E.URI.isUri(k.source)||t(this.C,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$Cp)(k.source),error:F}),i.set(v,{error:F,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,A.$0)(F)),F}})),a.length&&await this.L(a),[...i.values()]}catch(v){const k=(F,T,q)=>{const Y=[];F.manifest.extensionDependencies?.length&&Y.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&Y.push(...F.manifest.extensionPack);for(const J of Y){if(q.includes(J.toLowerCase()))continue;q.push(J.toLowerCase());const X=i.get(`${J.toLowerCase()}-${T.toString()}`);X?.local&&(q=k(X.local,T,q))}return q},P=F=>({identifier:F.identifier,operation:2,source:F.source,context:F.options.context,profileLocation:F.profileLocation,error:v}),R=[];for(const[F,{task:T,root:q}]of o){const Y=i.get(F);Y?Y.local&&q&&!i.get(`${q.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`)?.local&&(R.push(this.Z(Y.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(F,P(T))):(T.cancel(),i.set(F,P(T)))}for(const[F,{task:T}]of o){const q=i.get(F);if(!q?.local||T.options.donotIncludePackAndDependencies)continue;k(q.local,T.profileLocation,[q.local.identifier.id.toLowerCase()]).slice(1).some(J=>o.has(`${J.toLowerCase()}-${T.profileLocation.toString()}`)&&!i.get(`${J.toLowerCase()}-${T.profileLocation.toString()}`)?.local)&&(R.push(this.Z(q.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(F,P(T)))}throw R.length&&await Promise.allSettled(R.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(T){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,A.$0)(T))}})),v}finally{for(const{task:v}of o.values())v.source&&!E.URI.isUri(v.source)&&this.j.delete(b(v.source,v.profileLocation));if(i.size){const v=[...i.values()];for(const k of v)k.local&&this.F.info("Extension installed successfully:",k.identifier.id);this.s.fire(v)}}}J(s,i){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===s&&(a.includes(i)||a.some(b=>this.J(b,i)))||o===i&&a[0]&&!this.J(s,a[0]))return!1;return!0}async L(s){const i=[],o=[],a=await Promise.allSettled(s);for(const b of a)b.status==="fulfilled"?i.push(b.value):o.push(b.reason);if(o.length){if(o.length===1)throw o[0];let b=new w.$7o("",w.ExtensionManagementErrorCode.Unknown);for(const S of o){const v=S instanceof w.$7o?S.code:w.ExtensionManagementErrorCode.Unknown;b=new w.$7o(S.message?`${S.message}, ${b.message}`:b.message,v!==w.ExtensionManagementErrorCode.Unknown&&v!==w.ExtensionManagementErrorCode.Internal?v:b.code)}throw b}return i}async M(s,i,o,a,b,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,b,S),k=[],P=[],R=async(F,T)=>{k.push(F);const q=T.extensionDependencies||[],Y=[...q];if(T.extensionPack){const J=o?v.find(X=>(0,h.$up)(X.identifier,F)):void 0;for(const X of T.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(H=>(0,h.$up)({id:H},{id:X}))||Y.every(H=>!(0,h.$up)({id:H},{id:X}))&&Y.push(X)}if(Y.length){const J=Y.filter(X=>k.every(H=>!(0,h.$up)(H,{id:X})));if(J.length){const X=await this.z.getExtensions(J.map(H=>({id:H,preRelease:a})),L.CancellationToken.None);for(const H of X){if(k.find(V=>(0,h.$up)(V,H.identifier)))continue;const K=q.some(V=>(0,h.$up)({id:V},H.identifier));let G;try{G=await this.N(H,!1,a,S)}catch(V){if(K)throw V;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,A.$0)(V));continue}P.push({gallery:G.extension,manifest:G.manifest}),await R(G.extension.identifier,G.manifest)}}}};return await R(s,i),P}async N(s,i,o,a){let b;const S=await this.getExtensionsControlManifest();if(S.malicious.some(P=>(0,h.$up)(s.identifier,P)))throw new w.$7o(y.localize(1,null,s.identifier.id),w.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),b=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:a},L.CancellationToken.None))[0],!b)throw new w.$7o(y.localize(2,null,s.identifier.id,v.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const P=await this.getTargetPlatform();throw new w.$7o(y.localize(3,null,s.identifier.id,this.G.nameLong,(0,w.$Zo)(P)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.O(s,i,o,a),!b)throw!o&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],L.CancellationToken.None))[0]?new w.$7o(y.localize(4,null,s.displayName??s.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$7o(y.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",b.identifier.id);const k=await this.z.getManifest(b,L.CancellationToken.None);if(k===null)throw new w.$7o(`Missing manifest for extension ${b.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(k.version!==b.version)throw new w.$7o(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:k}}async O(s,i,o,a){const b=await this.getTargetPlatform();let S=null;return!i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==o&&(S=(await this.z.getExtensions([{...s.identifier,preRelease:o}],{targetPlatform:b,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(s,o,b,a)&&(S=s),S||(i?S=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:b,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(s,o,b,a)),S}async P(s,i){const o={...i,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:i.profileLocation??this.X()},a=R=>`${R.id.toLowerCase()}${o.versionOnly?`-${s.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,b=this.m.get(a(s.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),b.waitUntilTaskIsFinished();const S=R=>{const F=this.Z(R,o);return this.m.set(a(F.extension.identifier),F),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${R.identifier.id}@${R.manifest.version}`),this.t.fire({identifier:R.identifier,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped}),F},v=(R,F)=>{F?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${R.identifier.id}@${R.manifest.version}`,F.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${R.identifier.id}@${R.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$Bp)(R),error:F}),this.u.fire({identifier:R.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped})},k=[],P=[];try{k.push(S(s));const R=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const F=this.S(s,R);for(const T of F)this.m.has(a(T.identifier))?this.F.info("Extensions is already requested to uninstall",T.identifier.id):k.push(S(T))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(k.map(F=>F.extension),R,s),await this.L(k.map(async F=>{try{if(await F.run(),await this.L(this.y.map(T=>T.postUninstall(F.extension,o,L.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}v(F.extension)}catch(T){const q=$(T);throw v(F.extension,q),q}finally{P.push(F)}}))}catch(R){const F=$(R);for(const T of k){try{T.cancel()}catch{}P.includes(T)||v(T.extension,F)}throw F}finally{for(const R of k)this.m.delete(a(R.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}Q(s,i,o){for(const a of s){const b=this.U(a,i);if(b.length){const S=b.filter(v=>!s.some(k=>(0,h.$up)(k.identifier,v.identifier)));if(S.length)throw new Error(this.R(a,S,o))}}}R(s,i,o){return o===s?i.length===1?y.localize(6,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(7,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?y.localize(9,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(10,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(11,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}S(s,i,o=[]){if(o.indexOf(s)!==-1)return[];o.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const b=i.filter(v=>!v.isBuiltin&&a.some(k=>(0,h.$up)({id:k},v.identifier))),S=[];for(const v of b)S.push(...this.S(v,i,o));return[...b,...S]}return[]}U(s,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,h.$up)({id:a},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$lq=d,e.$lq=d=ve([Q(0,w.$6o),Q(1,l.$2l),Q(2,u.$Al),Q(3,p.$3j),Q(4,g.$jk),Q(5,m.$Cl)],d);function $(n){if(n instanceof w.$7o)return n;if(n instanceof w.$8o){const i=new w.$7o(n.message,w.ExtensionManagementErrorCode.Gallery);return i.stack=n.stack,i}const s=new w.$7o(n.message,(0,A.$4)(n)?w.ExtensionManagementErrorCode.Cancelled:w.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function t(n,s,{extensionData:i,verificationStatus:o,duration:a,error:b,durationSinceUpdate:S}){let v,k;(0,f.$eg)(o)&&(o===!0?o="Verified":(o===!1||(v=w.ExtensionManagementErrorCode.Signature,k=o),o="Unverified")),b&&(v=b.code,b.code===w.ExtensionManagementErrorCode.Signature&&(k=b.message)),n.publicLog(s,{...i,verificationStatus:o,success:!b,duration:a,errorcode:v,errorcodeDetail:k,durationSinceUpdate:S})}class r{constructor(){this.d=new N.$vh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$jh)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$jh)(s=>new Promise((i,o)=>{const a=s.onCancellationRequested(()=>{a.dispose(),o(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$nq=r}),define(ae[52],ce([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class m extends Error{constructor(n,s){super(n),this.code=s}}e.$oq=m,e.$pq=(0,y.$wi)("IExtensionsProfileScannerService");let d=class extends L.$Uc{constructor(n,s,i,o,a,b){super(),this.j=n,this.m=s,this.n=i,this.r=o,this.s=a,this.t=b,this.b=this.B(new A.$de),this.onAddExtensions=this.b.event,this.c=this.B(new A.$de),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$de),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$de),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,i){const o=[],a=[];try{return await this.u(s,b=>{const S=[];if(i)S.push(...b);else for(const v of b)n.some(([k])=>(0,f.$up)(k.identifier,v.identifier)&&k.manifest.version!==v.version)?o.push(v):S.push(v);for(const[v,k]of n){const P=S.findIndex(F=>(0,f.$up)(F.identifier,v.identifier)&&F.version===v.manifest.version),R={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:k};P===-1?(a.push(R),S.push(R)):S.splice(P,1,R)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),S}),a.length&&this.c.fire({extensions:a,profileLocation:s}),o.length&&this.g.fire({extensions:o,profileLocation:s}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:s}),o.length&&this.g.fire({extensions:o,error:b,profileLocation:s}),b}}async updateMetadata(n,s){const i=[];return await this.u(s,o=>{const a=[];for(const b of o){const S=n.find(([v])=>(0,f.$up)(v.identifier,b.identifier)&&v.manifest.version===b.version);S&&(b.metadata={...b.metadata,...S[1]},i.push(b)),a.push(b)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.u(s,o=>{const a=[];for(const b of o)(0,f.$up)(b.identifier,n.identifier)?i.push(b):a.push(b);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(o){throw i.length&&this.g.fire({extensions:i,error:o,profileLocation:s}),o}}async u(n,s,i){return this.F(n).queue(async()=>{let o=[],a;try{const b=await this.m.readFile(n);a=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,E.$hl)(b)!==1)throw b;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&i?.bailOutWhenFileNotFound)throw new m((0,g.$0)(b),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let b=!1;for(const S of a){$(S)||this.w(n);let v;if((0,p.$9f)(S.relativeLocation)&&S.relativeLocation)v=this.z(S.relativeLocation);else if((0,p.$9f)(S.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${S.location}`);continue}else{v=I.URI.revive(S.location);const k=this.y(v);k&&(b=!0,S.relativeLocation=k)}(0,p.$dg)(S.metadata?.hasPreReleaseVersion)&&S.metadata?.preRelease&&(b=!0,S.metadata.hasPreReleaseVersion=!0),o.push({identifier:S.identifier,location:v,version:S.version,metadata:S.metadata})}b&&await this.m.writeFile(n,N.$Fe.fromString(JSON.stringify(a)))}if(s){o=s(o);const b=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(n,N.$Fe.fromString(JSON.stringify(b)))}return o})}w(n){const s=new m(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(a){if((0,E.$hl)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let o;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(b=>$(b))?o=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Fe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.$hl)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,E.$hl)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,E.$hl)(a)!==1&&this.t.error(a)}return o})()),this.C}F(n){let s=this.h.get(n);return s||(s=new D.$Dh,this.h.set(n,s)),s}};e.$qq=d,e.$qq=d=ve([Q(1,E.$3k),Q(2,h.$Cl),Q(3,c.$Al),Q(4,l.$2l),Q(5,w.$3j)],d);function $(r){return(0,p.$$f)(r)&&(0,C.$5o)(r.identifier)&&(t(r.location)||(0,p.$9f)(r.location)&&r.location)&&((0,p.$dg)(r.relativeLocation)||(0,p.$9f)(r.relativeLocation))&&r.version&&(0,p.$9f)(r.version)}function t(r){return r?(0,p.$9f)(r.path)&&(0,p.$9f)(r.scheme):!1}}),define(ae[81],ce([0,1,17,6,30,15,7,35,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$vq=e.$uq=e.$tq=e.Translations=void 0,e.$wq=Y;var P;(function(X){function H(K,G){if(K===G)return!0;const V=Object.keys(K),ie=new Set;for(const se of Object.keys(G))ie.add(se);if(V.length!==ie.size)return!1;for(const se of V){if(K[se]!==G[se])return!1;ie.delete(se)}return ie.size===0}X.equals=H})(P||(e.Translations=P={})),e.$tq=(0,n.$wi)("IExtensionsScannerService");let R=class extends f.$Uc{constructor(H,K,G,V,ie,se,he,ee,W,B,j,M){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=K,this.r=G,this.s=V,this.t=ie,this.u=se,this.w=he,this.y=ee,this.z=W,this.C=B,this.D=j,this.F=M,this.g=this.B(new o.$de),this.onDidChangeCache=this.g.event,this.h=(0,h.$0g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Fp)(this.w,this.y)),this.G}async scanAllExtensions(H,K,G){const[V,ie]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(K)]),se=G?await this.scanExtensionsUnderDevelopment(H,[...V,...ie]):[];return this.L(V,ie,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const K=[];K.push(this.M(!!H.useCache,H.language)),K.push(this.N(H.language,!!H.checkControlFile));const[G,V]=await Promise.all(K);return this.J([...G,...V],0,H,!1)}async scanUserExtensions(H){const K=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const G=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(K,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,G,H.productVersion??this.R()),ie=H.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let se;try{se=await ie.scanExtensions(V)}catch(he){if(he instanceof b.$oq&&he.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),se=await ie.scanExtensions(V);else throw he}return se=await this.J(se,1,H,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(H,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===E.Schemas.file).map(async V=>{const ie=await this.P(V,!1,1,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(he=>(he.type=K.find(ee=>(0,d.$up)(ee.identifier,he.identifier))?.type??he.type,this.n.validate(he,ie)))}))).flat();return this.J(G,"development",H,!0)}return[]}async scanExistingExtension(H,K,G){const V=await this.P(H,!1,K,!0,G.language,!0,void 0,G.productVersion??this.R()),ie=await this.n.scanExtension(V);return!ie||!G.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(H,K,G){const V=await this.P(H,!1,K,!0,G.language,!0,void 0,G.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(V);return this.J(ie,K,G,!0)}async scanMultipleExtensions(H,K,G){const V=[];return await Promise.all(H.map(async ie=>{const se=await this.scanOneOrMultipleExtensions(ie,K,G);V.push(...se)})),this.J(V,K,G,!0)}async scanMetadata(H){const K=(0,h.$0g)(H,"package.json"),G=(await this.w.readFile(K)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(H,K){const G=(0,h.$0g)(H,"package.json"),V=(await this.w.readFile(G)).value.toString(),ie=JSON.parse(V);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,ie.__metadata={...ie.__metadata,...K},await this.w.writeFile((0,h.$0g)(H,"package.json"),A.$Fe.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof b.$oq&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Fe.fromString(JSON.stringify([])))}catch(K){(0,r.$hl)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,K,G,V){return G.includeAllVersions||(H=this.L(K===0?H:void 0,K===1?H:void 0,K==="development"?H:void 0,await this.getTargetPlatform(),V)),G.includeInvalid||(H=H.filter(ie=>ie.isValid)),H.sort((ie,se)=>{const he=y.$nc(ie.location.fsPath),ee=y.$nc(se.location.fsPath);return he<ee?-1:he>ee?1:0})}L(H,K,G,V,ie){const se=(ee,W,B)=>{if(ee.isValid&&!W.isValid)return!1;if(ee.isValid===W.isValid){if(ie&&c.gt(ee.manifest.version,W.manifest.version))return this.y.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(c.eq(ee.manifest.version,W.manifest.version)){if(ee.type===0)return this.y.debug(`Skipping extension ${W.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===V)return this.y.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return B?this.y.warn(`Overwriting user extension ${ee.location.path} with ${W.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${W.location.path}.`),!0},he=new $.$Tm;return H?.forEach(ee=>{const W=he.get(ee.identifier.id);(!W||se(W,ee,!1))&&he.set(ee.identifier.id,ee)}),K?.forEach(ee=>{const W=he.get(ee.identifier.id);if(!W&&H&&ee.type===0){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!W||se(W,ee,!1))&&he.set(ee.identifier.id,ee)}),G?.forEach(ee=>{const W=he.get(ee.identifier.id);(!W||se(W,ee,!0))&&he.set(ee.identifier.id,ee),he.set(ee.identifier.id,ee)}),[...he.values()]}async M(H,K){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),ie=await(H&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(H,K){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const V=K?await this.O():{},ie=[],se=l.URI.file(y.$hc(y.$jc(E.$Qg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of G){const W=V[ee.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":ie.push((0,h.$0g)(se,ee.name));break;default:ie.push(l.URI.file(W));break}}const he=await Promise.all(ie.map(async ee=>this.n.scanExtension(await this.P(ee,!1,0,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,D.$Hb)(he)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,K,G,V,ie,se,he,ee){const W=await this.f(ie??w.$w),B=await this.Q(H),j=K&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=j?await this.Q(j):void 0;return new F(H,B,j,M,K,he,G,V,se,ee.version,ee.date,this.C.commit,!this.z.isBuilt,ie,W)}async Q(H){try{const K=await this.w.stat(H);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$uq=R,e.$uq=R=ve([Q(4,S.$Cl),Q(5,b.$pq),Q(6,r.$3k),Q(7,s.$3j),Q(8,m.$Di),Q(9,i.$jk),Q(10,v.$Al),Q(11,n.$vi)],R);class F{constructor(H,K,G,V,ie,se,he,ee,W,B,j,M,z,U,Z){this.location=H,this.mtime=K,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=V,this.profile=ie,this.profileScanOptions=se,this.type=he,this.excludeObsolete=ee,this.validate=W,this.productVersion=B,this.productDate=j,this.productCommit=M,this.devMode=z,this.language=U,this.translations=Z}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,K){return(0,h.$3g)(H.location,K.location)&&H.mtime===K.mtime&&(0,h.$3g)(H.applicationExtensionslocation,K.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&H.profile===K.profile&&L.$7n(H.profileScanOptions,K.profileScanOptions)&&H.type===K.type&&H.excludeObsolete===K.excludeObsolete&&H.validate===K.validate&&H.productVersion===K.productVersion&&H.productDate===K.productDate&&H.productCommit===K.productCommit&&H.devMode===K.devMode&&H.language===K.language&&P.equals(H.translations,K.translations)}}e.$vq=F;let T=class extends f.$Uc{constructor(H,K,G,V,ie){super(),this.f=H,this.g=K,this.h=G,this.j=V,this.m=ie}async scanExtensions(H){const K=H.profile?await this.r(H):await this.n(H);let G={};if(H.excludeObsolete&&H.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(V)}catch{}return(0,g.$jg)(G)?K:K.filter(V=>!G[d.$vp.create(V).toString()])}async n(H){const K=await this.j.resolve(H.location);if(!K.children?.length)return[];const G=await Promise.all(K.children.map(async V=>{if(!V.isDirectory||H.type===1&&(0,h.$7g)(V.resource).indexOf(".")===0)return null;const ie=new F(V.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ie)}));return(0,D.$Hb)(G).sort((V,ie)=>V.location.path<ie.location.path?-1:1)}async r(H){let K=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){K=K.filter(V=>!V.metadata?.isApplicationScoped);const G=await this.s(H.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,H);K.push(...G)}return K}async s(H,K,G){const V=await this.g.scanProfileExtensions(H,G.profileScanOptions);if(!V.length)return[];const ie=await Promise.all(V.map(async se=>{if(K(se)){const he=new F(se.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(he,se.metadata)}return null}));return(0,D.$Hb)(ie)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,h.$0g)(H.location,"package.json"))){const K=await this.scanExtension(H);return K?[K]:[]}else return await this.scanExtensions(H)}catch(K){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,O.$0)(K)),[]}}async scanExtension(H,K){try{let G=await this.scanExtensionManifest(H.location);if(G){G.publisher||(G.publisher=$.$Nm),K=K??G.__metadata,delete G.__metadata;const V=(0,d.$zp)(G.publisher,G.name),ie=K?.id?{id:V,uuid:K.id}:{id:V},se=K?.isSystem?0:H.type,he=se===0||!!K?.isBuiltin;G=await this.t(H.location,G,F.createNlsConfiguration(H));const ee={type:se,identifier:ie,manifest:G,location:H.location,isBuiltin:he,targetPlatform:K?.targetPlatform??"undefined",publisherDisplayName:K?.publisherDisplayName,metadata:K,isValid:!0,validations:[]};return H.validate?this.validate(ee,H):ee}}catch(G){H.type!==0&&this.m.error(G)}return null}validate(H,K){let G=!0;const V=(0,t.$Kp)(K.productVersion,K.productDate,K.location,H.manifest,H.isBuiltin);for(const[ie,se]of V)ie===p.default.Error&&(G=!1,this.m.error(this.z(K.location,se)));return H.isValid=G,H.validations=V,H}async scanExtensionManifest(H){const K=(0,h.$0g)(H,"package.json");let G;try{G=(await this.j.readFile(K)).value.toString()}catch(ie){return(0,r.$hl)(ie)!==1&&this.m.error(this.z(H,(0,u.localize)(0,null,K.path,ie.message))),null}let V;try{V=JSON.parse(G)}catch{const se=[];(0,I.$Jn)(G,se);for(const he of se)this.m.error(this.z(H,(0,u.localize)(1,null,K.path,he.offset,he.length,(0,C.$rq)(he.error))));return null}return(0,I.$Sn)(V)!=="object"?(this.m.error(this.z(H,(0,u.localize)(2,null,K.path))),null):V}async t(H,K,G){const V=await this.u(H,K,G);if(V)try{const ie=[],se=await this.w(V.default,ie);if(ie.length>0)return ie.forEach(ee=>{this.m.error(this.z(H,(0,u.localize)(3,null,V.default?.path,(0,C.$rq)(ee.error))))}),K;if((0,I.$Sn)(V)!=="object")return this.m.error(this.z(H,(0,u.localize)(4,null,V.default?.path))),K;const he=V.values||Object.create(null);return(0,k.$sq)(this.m,K,he,se)}catch{}return K}async u(H,K,G){const V=(0,h.$0g)(H,"package.nls.json"),ie=(W,B)=>{B.forEach(j=>{this.m.error(this.z(H,(0,u.localize)(5,null,W?.path,(0,C.$rq)(j.error))))})},se=W=>{this.m.error(this.z(H,(0,u.localize)(6,null,W?.path)))},he=`${K.publisher}.${K.name}`,ee=G.translations[he];if(ee)try{const W=l.URI.file(ee),B=(await this.j.readFile(W)).value.toString(),j=[],M=(0,I.$Jn)(B,j);return j.length>0?(ie(W,j),{values:void 0,default:V}):(0,I.$Sn)(M)!=="object"?(se(W),{values:void 0,default:V}):{values:M.contents?M.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let B;try{B=await this.y(H,G)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const j=(await this.j.readFile(B.localized)).value.toString(),M=[],z=(0,I.$Jn)(j,M);return M.length>0?(ie(B.localized,M),{values:void 0,default:B.original}):(0,I.$Sn)(z)!=="object"?(se(B.localized),{values:void 0,default:B.original}):{values:z,default:B.original}}catch{return{values:void 0,default:B.original}}}}async w(H,K){if(H)try{const G=(await this.j.readFile(H)).value.toString();return(0,I.$Jn)(G,K)}catch{}}y(H,K){return new Promise((G,V)=>{const ie=se=>{const he=(0,h.$0g)(H,`package.nls.${se}.json`);this.j.exists(he).then(ee=>{ee&&G({localized:he,original:(0,h.$0g)(H,"package.nls.json")});const W=se.lastIndexOf("-");W===-1?G({localized:(0,h.$0g)(H,"package.nls.json"),original:null}):(se=se.substring(0,W),ie(se))})};if(K.devMode||K.pseudo||!K.language)return G({localized:(0,h.$0g)(H,"package.nls.json"),original:null});ie(K.language)})}z(H,K){return`[${H.path}]: ${K}`}};T=ve([Q(1,b.$pq),Q(2,v.$Al),Q(3,r.$3k),Q(4,s.$3j)],T);let q=class extends T{constructor(H,K,G,V,ie,se,he){super(K,V,ie,se,he),this.G=H,this.H=G,this.D=this.B(new N.$uh(3e3)),this.F=this.B(new o.$de),this.onDidChangeCache=this.F.event}async scanExtensions(H){const K=this.M(H),G=await this.I(K);if(this.C=H,G&&G.input&&F.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),G.result.map(ie=>(ie.location=l.URI.revive(ie.location),ie));const V=await super.scanExtensions(H);return await this.J(K,{input:H,result:V}),V}async I(H){try{const K=await this.j.readFile(H),G=JSON.parse(K.value.toString());return{result:G.result,input:(0,a.$6h)(G.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",H.path,(0,O.$0)(K))}return null}async J(H,K){try{await this.j.writeFile(H,A.$Fe.fromString(JSON.stringify(K)))}catch(G){this.m.debug("Error while writing the extension cache file:",H.path,(0,O.$0)(G))}}async L(){if(!this.C)return;const H=this.M(this.C),K=await this.I(H);if(!K)return;const G=K.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$7n(V,G))try{this.m.info("Invalidating Cache",G,V),await this.j.del(H),this.F.fire()}catch(ie){this.m.error(ie)}}M(H){const K=this.N(H);return this.h.extUri.joinPath(K.cacheHome,H.type===0?$.$Mm:$.$Lm)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(H.location,K.extensionsResource))??this.G:this.H.defaultProfile}};q=ve([Q(2,S.$Cl),Q(3,b.$pq),Q(4,v.$Al),Q(5,r.$3k),Q(6,s.$3j)],q);function Y(X,H){const K=(0,d.$xp)(X.manifest.publisher,X.manifest.name);return{id:K,identifier:new $.$Rm(K),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:H,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,publisherDisplayName:X.publisherDisplayName,...X.manifest}}class J extends R{constructor(H,K,G,V,ie,se,he,ee,W,B,j,M){super(H,K,(0,h.$0g)(G,".vscode-oss-dev","extensions","control.json"),V,ie,se,he,ee,W,B,j,M),this.S=(async()=>{if(w.$z)try{const z=await this.w.readFile(l.URI.file(w.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$xq=J}),define(ae[251],ce([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let w=class extends O.$Uc{constructor(c,p){super(),this.b=c,this.f=p,this.a=new N.$Ch(5)}async postUninstall(c){const p=this.g(c,"uninstall");p&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(g)}}));try{await f.Promises.rm(this.m(c))}catch(g){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(g)}}g(c,p){const g=`vscode:${p}`;if(c.location.scheme===I.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[g]=="string"){const l=c.manifest.scripts[g].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${g} should be a node script`),null):{script:(0,C.$jc)(c.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(c,p,g,l,u){return new Promise((m,d)=>{const $=this.j(c,p,g,u);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?d(n):m(void 0)};$.on("error",n=>{r((0,L.$hj)(n)||"Unknown")}),$.on("exit",(n,s)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(t=setTimeout(()=>{t=null,$.kill(),d("timed out")},5e3))})}j(c,p,g,l){const u={silent:!0,execArgv:void 0},m=(0,D.fork)(c,[`--type=extension-post-${p}`,...g],u);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const d=A.Event.fromNodeEventEmitter(m.stdout,"data"),$=A.Event.fromNodeEventEmitter(m.stderr,"data");this.B(d(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n))),this.B($(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n)));const t=A.Event.any(A.Event.map(d,n=>({data:`%c${n}`,format:[""]}),this.q),A.Event.map($,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return A.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}m(c){return(0,C.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$zq=w,e.$zq=w=ve([Q(0,y.$Cl),Q(1,E.$3j)],w)}),define(ae[113],ce([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k,P,R,F,T,q,Y,J,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.$Dq=void 0,e.$Dq=(0,F.$xi)(n.$9o);const H=".vsctmp";let K=class extends r.$lq{constructor(W,B,j,M,z,U,Z,x,te,_,oe,fe){super(W,B,oe,j,_,fe),this.eb=z,this.fb=U,this.gb=Z,this.hb=te,this.db=new Map,this.qb=new E.$Bc;const $e=this.B(x.createInstance(b.$zq));this.ab=this.B(x.createInstance(G,ge=>$e.postUninstall(ge))),this.bb=this.B(new v.$Bq(fe,te,oe,this,this.F)),this.cb=this.B(x.createInstance(a.$yq));const de=this.B(new k.$Cq(this,this.eb,fe,U,oe,te,j));this.B(de.onDidChangeExtensionsByAnotherSource(ge=>this.pb(ge))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Fp)(this.hb,this.F)),this.ib}async zip(W){this.F.trace("ExtensionManagementService#zip",W.identifier.id);const B=await this.ob(W),j=await(0,m.zip)((0,h.$0g)(this.cb.extensionsDownloadDir,(0,l.$Sg)()).fsPath,B);return g.URI.file(j)}async unzip(W){return this.F.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:B,cleanup:j}=await this.kb(W),M=w.$kc(B.fsPath);try{return await(0,S.$Aq)(M)}finally{await j()}}getInstalled(W,B=this.H.defaultProfile.extensionsResource,j={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(W??null,B,j)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.ab.scanUserExtensionAtLocation(W)}async install(W,B={}){this.F.trace("ExtensionManagementService#install",W.toString());const{location:j,cleanup:M}=await this.kb(W);try{const z=await(0,S.$Aq)(w.$kc(j.fsPath)),U=(0,s.$zp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,P.$Mp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,U,this.G.version));const x=(await this.I([{manifest:z,extension:j,options:B}])).find(({identifier:te})=>(0,s.$up)(te,{id:U}));if(x?.local)return x.local;throw x?.error?x.error:(0,r.$mq)(new Error(`Unknown error while installing extension ${U}`))}finally{await M()}}async installFromLocation(W,B){this.F.trace("ExtensionManagementService#installFromLocation",W.toString());const j=await this.ab.scanUserExtensionAtLocation(W);if(!j||!j.manifest.name||!j.manifest.version)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.tb([[j,{source:"resource"}]],B),this.F.info("Successfully installed extension",j.identifier.id,B.toString()),j}async installExtensionsFromProfile(W,B,j){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",W,B.toString(),j.toString());const M=(await this.getInstalled(1,B)).filter(z=>W.some(U=>(0,s.$up)(U,z.identifier)));if(M.length){const z=await Promise.all(M.map(U=>this.ab.scanMetadata(U,B)));await this.tb(M.map((U,Z)=>[U,z[Z]]),j),this.F.info("Successfully installed extensions",M.map(U=>U.identifier.id),j.toString())}return M}async updateMetadata(W,B,j=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",W.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0,B.hasPreReleaseVersion=!0),B.isMachineScoped===!1&&(B.isMachineScoped=void 0),B.isBuiltin===!1&&(B.isBuiltin=void 0),B.pinned===!1&&(B.pinned=void 0),W=await this.ab.updateMetadata(W,B,j),this.bb.invalidate(j),this.w.fire(W),W}async reinstallFromGallery(W){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const B=await this.getTargetPlatform(),[j]=await this.z.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:B,compatible:!0},L.CancellationToken.None);if(!j)throw new Error(d.localize(2,null));await this.ab.setUninstalled(W);try{await this.ab.removeUninstalledExtension(W)}catch(M){throw new Error(d.localize(3,null,(0,A.$hj)(M)))}return this.installFromGallery(j)}$(W,B,j,M){return this.ab.copyExtension(W,B,j,M)}copyExtensions(W,B){return this.ab.copyExtensions(W,B,{version:this.G.version,date:this.G.date})}markAsUninstalled(...W){return this.ab.setUninstalled(...W)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(W){this.F.error(W)}}async download(W,B,j){const{location:M}=await this.cb.download(W,B,!j);return M}async kb(W){if(W.scheme===y.Schemas.file)return{location:W,async cleanup(){}};this.F.trace("Downloading extension from",W.toString());const B=(0,h.$0g)(this.cb.extensionsDownloadDir,(0,l.$Sg)());return await this.gb.download(W,B),this.F.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.hb.del(B)}catch(M){this.F.error(M)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(W,B,j){if(g.URI.isUri(B))return new se(W,B,j,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const M=s.$vp.create(B).toString();let z=this.db.get(M);return z||(this.db.set(M,z=new ie(W,B,j,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(M))),z}Z(W,B){return new he(W,B.profileLocation,this.fb)}async ob(W){const B=async M=>{let z=await u.Promises.readdir(M);z=z.map(x=>w.$jc(M,x));const U=await Promise.all(z.map(x=>u.Promises.stat(x)));let Z=Promise.resolve([]);return U.forEach((x,te)=>{const _=z[te];x.isFile()&&(Z=Z.then(oe=>[...oe,_])),x.isDirectory()&&(Z=Z.then(oe=>B(_).then(fe=>[...oe,...fe])))}),Z};return(await B(W.location.fsPath)).map(M=>({path:`extension/${w.$lc(W.location.fsPath,M)}`,localPath:M}))}async pb({added:W,removed:B}){if(B){const j=W&&this.D.extUri.isEqual(B.profileLocation,W.profileLocation)?B.extensions.filter(M=>W.extensions.every(z=>!(0,s.$up)(z,M))):B.extensions;for(const M of j)this.F.info("Extensions removed from another source",M.id,B.profileLocation.toString()),this.u.fire({identifier:M,profileLocation:B.profileLocation})}if(W){const M=(await this.getInstalled(1,W.profileLocation)).filter(z=>W.extensions.some(U=>(0,s.$up)(U,z.identifier)));this.s.fire(M.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,W.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:W.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(B=>this.qb.add(B)));const W=await this.hb.resolve(this.eb.userExtensionsLocation);for(const B of W.children??[])B.isDirectory&&this.qb.add(B.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(B=>this.sb(B)))}async sb(W){if(!W.affects(this.eb.userExtensionsLocation,1))return;const B=[];for(const j of W.rawAdded){if(this.qb.has(j)||!this.D.extUri.isEqual(this.D.extUri.dirname(j),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(j,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(j).startsWith(".")||!(await this.hb.stat(j)).isDirectory)continue;const M=await this.ab.scanUserExtensionAtLocation(j);M&&M.installedTimestamp===void 0&&(this.qb.add(j),B.push(M))}B.length&&(await this.tb(B.map(j=>[j,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",B.map(j=>j.identifier.id)))}async tb(W,B){const j=W.map(M=>M[0]);await this.ub(j),await this.fb.addExtensionsToProfile(W,B),this.s.fire(j.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:B})))}async ub(W){const B=await this.ab.getUninstalledExtensions();for(const j of W){const M=s.$vp.create(j);B[M.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",M.id),await this.ab.setInstalled(M),this.F.info("Removed the extension from uninstalled list:",M.id))}}};e.$Eq=K,e.$Eq=K=ve([Q(0,n.$6o),Q(1,Y.$2l),Q(2,T.$3j),Q(3,t.$Ei),Q(4,o.$tq),Q(5,i.$pq),Q(6,$.$Ko),Q(7,F.$vi),Q(8,R.$3k),Q(9,q.$jk),Q(10,J.$Al),Q(11,X.$Cl)],K);let G=class extends f.$Uc{constructor(W,B,j,M,z,U){super(),this.j=W,this.m=B,this.n=j,this.s=M,this.t=z,this.u=U,this.h=this.B(new I.$de),this.onExtract=this.h.event,this.c=(0,h.$0g)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Dh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(W,B,j){const M={includeInvalid:!0,profileLocation:B,productVersion:j};let z=[];return W===null||W===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},M,!1)):W===1&&z.push(...await this.n.scanUserExtensions(M)),z=W!==null?z.filter(U=>U.type===W):z,Promise.all(z.map(U=>this.F(U)))}async scanAllUserExtensions(W){const B=await this.n.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return Promise.all(B.map(j=>this.F(j)))}async scanUserExtensionAtLocation(W){try{const B=await this.n.scanExistingExtension(W,1,{includeInvalid:!0});if(B)return await this.F(B)}catch(B){this.u.error(B)}return null}async extractUserExtension(W,B,j,M,z){const U=W.toString(),Z=g.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Sg)()}`)),x=g.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,U));let te=await this.m.exists(x);if(te&&M){try{await this.y(W.id,x,"removeExisting")}catch{throw new n.$7o(d.localize(4,null,x.fsPath,W.id),n.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(x,j);else try{try{this.u.trace(`Started extracting the extension from ${B} to ${x.fsPath}`),await(0,m.$jq)(B,Z.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${x}:`,W.id)}catch(_){let oe=n.ExtensionManagementErrorCode.Extract;throw _ instanceof m.$hq&&(_.type==="CorruptZip"?oe=n.ExtensionManagementErrorCode.CorruptZip:_.type==="Incomplete"&&(oe=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$7o(_.message,oe)}await this.n.updateMetadata(Z,j);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${x.fsPath}`),await this.C(Z.fsPath,x.fsPath),this.u.info("Renamed to",x.fsPath)}catch(_){if(_.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(_)}. Deleted from extracted location`,Z),_}this.h.fire(x)}catch(_){try{await this.m.del(Z,{recursive:!0})}catch{}throw _}return this.D(x,1)}async scanMetadata(W,B){return B?(await this.w(W,B))?.metadata:this.n.scanMetadata(W.location)}async w(W,B){return(await this.s.scanProfileExtensions(B)).find(M=>(0,s.$up)(M.identifier,W.identifier))}async updateMetadata(W,B,j){return j?await this.s.updateMetadata([[W,B]],j):await this.n.updateMetadata(W.location,B),this.D(W.location,W.type,j)}getUninstalledExtensions(){return this.z()}async setUninstalled(...W){const B=W.map(j=>s.$vp.create(j));await this.z(j=>B.forEach(M=>{j[M.toString()]=!0,this.u.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(W){await this.z(B=>delete B[W.toString()])}async removeExtension(W,B){if(this.t.extUri.isEqualOrParent(W.location,this.n.userExtensionsLocation))return this.y(W.identifier.id,W.location,B)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.z(B=>delete B[s.$vp.create(W).toString()])}async copyExtension(W,B,j,M){const z=await this.w(W,B),U=await this.w(W,j);if(M={...z?.metadata,...M},U)if(this.t.extUri.isEqual(U.location,W.location))await this.s.updateMetadata([[W,{...U.metadata,...M}]],j);else{const Z=await this.D(U.location,W.type,j);await this.s.removeExtensionFromProfile(Z,j),await this.s.addExtensionsToProfile([[W,{...U.metadata,...M}]],j)}else await this.s.addExtensionsToProfile([[W,M]],j);return this.D(W.location,W.type,j)}async copyExtensions(W,B,j){const M=await this.scanExtensions(1,W,j),z=await Promise.all(M.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,W)]));await this.s.addExtensionsToProfile(z,B)}async y(W,B,j){this.u.trace(`Deleting ${j} extension from disk`,W,B.fsPath);const M=this.t.extUri.joinPath(this.t.extUri.dirname(B),`${this.t.extUri.basename(B)}.${(0,C.$kj)((0,l.$Sg)()).toString(16)}${H}`);await this.C(B.fsPath,M.fsPath),await this.m.del(M,{recursive:!0}),this.u.info(`Deleted ${j} extension from disk`,W,B.fsPath)}async z(W){return this.g.queue(async()=>{let B;try{B=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,R.$hl)(M)!==1)throw M}let j={};if(B)try{j=JSON.parse(B)}catch{}return W&&(W(j),Object.keys(j).length?await this.m.writeFile(this.c,N.$Fe.fromString(JSON.stringify(j))):await this.m.del(this.c)),j})}async C(W,B){try{await u.Promises.rename(W,B,2*60*1e3)}catch(j){throw new n.$7o(j.message||d.localize(5,null,W,B),j.code||n.ExtensionManagementErrorCode.Rename)}}async D(W,B,j){if(j){const z=(await this.n.scanUserExtensions({profileLocation:j})).find(U=>this.t.extUri.isEqual(U.location,W));if(z)return this.F(z)}else{const M=await this.n.scanExistingExtension(W,B,{includeInvalid:!0});if(M)return this.F(M)}throw new Error(d.localize(6,null,W.path))}async F(W){const B=await this.m.resolve(W.location);let j,M;return B.children&&(j=B.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,M=B.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:j,changelogUrl:M,publisherDisplayName:W.metadata?.publisherDisplayName,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!W.metadata?.hasPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned,isWorkspaceScoped:!1,source:W.metadata?.source??(W.identifier.uuid?"gallery":"vsix")}}async G(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(W));const B=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const z of B)W[s.$vp.create(z).toString()]||j.add(z.identifier.id.toLowerCase());try{const z=(0,s.$Ap)(B,U=>U.identifier);await D.Promises.settled(z.map(async U=>{const Z=U.sort((x,te)=>c.rcompare(x.manifest.version,te.manifest.version))[0];j.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(z){this.u.error(z)}const M=B.filter(z=>z.metadata&&W[s.$vp.create(z).toString()]);await Promise.allSettled(M.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let W;try{W=await this.m.resolve(this.n.userExtensionsLocation)}catch(B){(0,R.$hl)(B)!==1&&this.u.error(B);return}if(W?.children)try{await Promise.allSettled(W.children.map(async B=>{if(!(!B.isDirectory||!B.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",B.resource.toString());try{await this.m.del(B.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",B.resource.toString())}catch(j){(0,R.$hl)(j)!==1&&this.u.error(j)}}}))}catch{}}};e.$Fq=G,e.$Fq=G=ve([Q(1,R.$3k),Q(2,o.$tq),Q(3,i.$pq),Q(4,J.$Al),Q(5,T.$3j)],G);class V extends r.$nq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$dg)(this.options.operation)?this.l:this.options.operation}constructor(W,B,j,M,z,U,Z,x,te,_){super(),this.manifest=W,this.identifier=B,this.source=j,this.options=M,this.m=z,this.n=U,this.o=Z,this.p=x,this.q=te,this.s=_,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(W){const[B,j]=await this.x(W);return this.j=B.isBuiltin||B.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,j]],this.j,!B.isValid),B}async u({zipPath:W,key:B,metadata:j},M,z){let U=await this.v(B);return U?U=await this.m.updateMetadata(U,j):(this.s.trace("Extracting extension...",B.id),U=await this.m.extractUserExtension(B,W,j,M,z),this.s.info("Extracting extension completed.",B.id)),U}async v(W){return await this.w(W)?(this.s.trace("Removing the extension from uninstalled list:",W.id),await this.m.setInstalled(W),this.s.info("Removed the extension from uninstalled list:",W.id),(await this.m.scanAllUserExtensions(!0)).find(M=>s.$vp.create(M).equals(W))):void 0}async w(W){return!!(await this.m.getUninstalledExtensions())[W.toString()]}}class ie extends V{constructor(W,B,j,M,z,U,Z,x,te,_,oe){super(W,B.identifier,B,j,z,U,Z,x,te,_),this.y=B,this.z=M,this.A=oe}async x(W){let B;try{B=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(z){throw new n.$7o(z,n.ExtensionManagementErrorCode.Scanning)}const j=B.find(z=>(0,s.$up)(z.identifier,this.y.identifier));j&&(this.l=3);const M={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:j?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned,preRelease:(0,p.$cg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||j?.preRelease,source:"gallery"};if(j&&j.type!==0&&j.manifest.version===this.y.version)try{return[await this.m.updateMetadata(j,M),M]}catch(z){throw new n.$7o((0,O.$0)(z),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(M,W)}catch(z){if(z instanceof n.$7o&&(z.code===n.ExtensionManagementErrorCode.CorruptZip||z.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const U=await this.C(M,W);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),U}catch(U){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),U}}else throw z}}async C(W,B){const{location:j,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.D(j.fsPath),[await this.u({zipPath:j.fsPath,key:s.$vp.create(this.y),metadata:W},!1,B),W]}catch(z){try{await this.z.delete(j)}catch(U){this.s.warn("Error while deleting the downloaded file",j.toString(),(0,O.$0)(U))}throw z}}async D(W){try{await(0,S.$Aq)(W)}catch(B){throw new n.$7o(B.message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Gq=ie;class se extends V{constructor(W,B,j,M,z,U,Z,x,te,_){super(W,{id:(0,s.$zp)(W.publisher,W.name)},B,j,z,U,Z,x,te,_),this.y=B,this.z=M}async h(W){const B=await super.h(W);return this.C(B,W),B}async x(W){const B=new s.$vp(this.identifier,this.manifest.version),M=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(Z=>(0,s.$up)(this.identifier,Z.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,source:"vsix"};if(M)if(this.l=3,B.equals(new s.$vp(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&c.gt(M.manifest.version,this.manifest.version)&&await this.m.setUninstalled(M);else{const Z=await this.v(B);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(d.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:w.$kc(this.y.fsPath),key:B,metadata:z},!0,W),z]}async C(W,B){try{let[j]=await this.z.getExtensions([{id:W.identifier.id,version:W.manifest.version}],B);if(j||([j]=await this.z.getExtensions([{id:W.identifier.id}],B)),j){const M={id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,hasPreReleaseVersion:W.hasPreReleaseVersion||j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(W,M,this.options.profileLocation)}}catch{}}}class he extends r.$nq{constructor(W,B,j){super(),this.extension=W,this.j=B,this.k=j}async h(W){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[252],ce([0,1,9,18,28,22,52,12,16,8]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YQ=void 0;let E=class extends O.$qq{constructor(w,h,c,p,g,l){super(f.URI.file(w.extensionsPath),h,c,p,g,l)}};e.$YQ=E,e.$YQ=E=ve([Q(0,C.$Ei),Q(1,I.$3k),Q(2,N.$Cl),Q(3,L.$Al),Q(4,A.$2l),Q(5,D.$3j)],E)}),define(ae[253],ce([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;let w=class extends A.$xq{constructor(c,p,g,l,u,m,d,$){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,c.defaultProfile,c,p,g,l,u,m,d,$)}};e.$sdc=w,e.$sdc=w=ve([Q(0,y.$Cl),Q(1,L.$pq),Q(2,O.$3k),Q(3,C.$3j),Q(4,N.$Ei),Q(5,f.$jk),Q(6,E.$Al),Q(7,I.$vi)],w)}),define(ae[19],ce([0,1,6,3,2,98,13,69,4,18]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=h,e.$4p=p,e.$6p=l,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,C.$wi)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var w;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function h(u){const m=u.get(e.$Zp);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class c extends L.$Uc{static{this.a=60*1e3}constructor(m={flushInterval:c.a}){super(),this.m=m,this.b=this.B(new N.$ge),this.c=this.B(new N.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$de),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,d,$){return N.Event.filter(this.b.event,t=>t.scope===m&&(d===void 0||t.key===d),$)}n(){this.j.value=(0,D.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,d){const{key:$,external:t}=d;if($===e.$Zp){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:$,target:this.J(m)[$],external:t})}w(m){this.f.fire({reason:m})}get(m,d,$){return this.P(d)?.get(m,$)}getBoolean(m,d,$){return this.P(d)?.getBoolean(m,$)}getNumber(m,d,$){return this.P(d)?.getNumber(m,$)}getObject(m,d,$){return this.P(d)?.getObject(m,$)}storeAll(m,d){this.y(()=>{for(const $ of m)this.store($.key,$.value,$.scope,$.target,d)})}store(m,d,$,t,r=!1){if((0,O.$fg)(d)){this.remove(m,$,r);return}this.y(()=>{this.z(m,$,t),this.P($)?.set(m,d,r)})}remove(m,d,$=!1){this.y(()=>{this.z(m,d,void 0),this.P(d)?.delete(m,$)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,d){const $=[],t=this.J(m);for(const r of Object.keys(t))t[r]===d&&$.push(r);return $}z(m,d,$,t=!1){const r=this.J(d);typeof $=="number"?r[m]!==$&&(r[m]=$,this.P(d)?.set(e.$Zp,JSON.stringify(r),t)):typeof r[m]=="number"&&(delete r[m],this.P(d)?.set(e.$Zp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const d=this.P(m);return d?h(d):Object.create(null)}isNew(m){return this.getBoolean(e.$Yp,m)===!0}async flush(m=E.NONE){this.f.fire({reason:m});const d=this.P(-1),$=this.P(0),t=this.P(1);switch(m){case E.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return l(m,d,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,d){return this.w(E.NONE),(0,f.$Bl)(m)?this.R(m,d):this.S(m,d)}M(m,d){return!(m.id===d.id||p(d)&&p(m))}N(m,d,$){this.y(()=>{const t=new Set;for(const[r,n]of m)t.add(r),d.get(r)!==n&&this.u($,{key:r,external:!0});for(const[r]of d.items)t.has(r)||this.u($,{key:r,external:!0})})}}e.$3p=c;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class g extends c{constructor(){super(),this.U=this.B(new I.$Wp(new I.$Xp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Wp(new I.$Xp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Wp(new I.$Xp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$5p=g;async function l(u,m,d,$,t,r){const n=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,i=new Map;u.forEach((P,R)=>{s.set(R,P),i.set(R,n(P))});const o=new Map,a=new Map;m.forEach((P,R)=>{o.set(R,P),a.set(R,n(P))});const b=new Map,S=new Map;d.forEach((P,R)=>{b.set(R,P),S.set(R,n(P))}),console.group($!==t?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const v=[];if(s.forEach((P,R)=>{v.push({key:R,value:P})}),console.table(v),console.groupEnd(),console.log(i),$!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];o.forEach((R,F)=>{P.push({key:F,value:R})}),console.table(P),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const k=[];b.forEach((P,R)=>{k.push({key:R,value:P})}),console.table(k),console.groupEnd(),console.log(S)}}),define(ae[114],ce([0,1,3,2,13,29,33,19]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Jb=e.$5Jb=void 0;let C=class extends N.$Uc{constructor(y,w){super(),this.a=new D.$de,this.onDidChangeEnablement=this.a.event,this.b=this.B(new f(y)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(w.onDidInstallExtensions(h=>h.forEach(({local:c,operation:p})=>{c&&p===4&&this.f(c.identifier)})))}async enableExtension(y,w){return this.f(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}async disableExtension(y,w){return this.c(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}getDisabledExtensions(){return this.h(A.$0o)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(y){const w=this.getDisabledExtensions();return w.every(h=>!(0,O.$up)(h,y))?(w.push(y),this.g(w),!0):!1}f(y){const w=this.getDisabledExtensions();for(let h=0;h<w.length;h++){const c=w[h];if((0,O.$up)(c,y))return w.splice(h,1),this.g(w),!0}return!1}g(y){this.j(A.$0o,y)}h(y){return this.b.get(y,0)}j(y,w){this.b.set(y,w,0)}};e.$5Jb=C,e.$5Jb=C=ve([Q(0,I.$1p),Q(1,A.$9o)],C);class f extends N.$Uc{constructor(y){super(),this.c=y,this.a=Object.create(null),this.b=this.B(new D.$de),this.onDidChange=this.b.event,this.B(y.onDidChangeValue(0,void 0,this.B(new N.$Tc))(w=>this.f(w)))}get(y,w){let h;return w===0?((0,L.$fg)(this.a[y])&&(this.a[y]=this.g(y,w)),h=this.a[y]):h=this.g(y,w),JSON.parse(h)}set(y,w,h){const c=JSON.stringify(w.map(({id:g,uuid:l})=>({id:g,uuid:l})));this.g(y,h)!==c&&(h===0&&(w.length?this.a[y]=c:delete this.a[y]),this.h(y,w.length?c:void 0,h))}f(y){if(!(0,L.$fg)(this.a[y.key])&&this.g(y.key,y.scope)!==this.a[y.key]){const h=this.get(y.key,y.scope);delete this.a[y.key];const c=this.get(y.key,y.scope),p=h.filter(l=>!c.some(u=>(0,O.$up)(l,u))),g=c.filter(l=>!h.some(u=>(0,O.$up)(u,l)));(p.length||g.length)&&this.b.fire([...p,...g])}}g(y,w){return this.c.get(y,w,"[]")}h(y,w,h){w?this.c.store(y,w,h,1):this.c.remove(y,h)}}e.$6Jb=f}),define(ae[254],ce([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0,e.$9p=se;const t=A.$o?"web":(0,y.$2o)(A.$u,O.$ec),r="X-Market-Search-Activity-Id";var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...M){return String(M.reduce((z,U)=>z|U,0))}var i;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class v{constructor(z=S){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,U=this.d.pageSize){return new v({...this.d,pageNumber:z,pageSize:U})}withFilter(z,...U){const Z=[...this.d.criteria,...U.length?U.map(x=>({filterType:z,value:x})):[{filterType:z}]];return new v({...this.d,criteria:Z})}withSortBy(z){return new v({...this.d,sortBy:z})}withSortOrder(z){return new v({...this.d,sortOrder:z})}withFlags(...z){return new v({...this.d,flags:z.reduce((U,Z)=>U|Z,0)})}withAssetTypes(...z){return new v({...this.d,assetTypes:z})}withSource(z){return new v({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:U,pageSize:Z,sortBy:x,sortOrder:te,flags:_,assetTypes:oe}=this.d;return{filters:[{criteria:z,pageNumber:U,pageSize:Z,sortBy:x,sortOrder:te}],assetTypes:oe,flags:_}}get searchText(){const z=this.d.criteria.filter(U=>U.filterType===i.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(M,z){const U=(M||[]).filter(Z=>Z.statisticName===z)[0];return U?U.value:0}function P(M){const z="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(Z=>Z.assetType.indexOf(z)===0).reduce((Z,x)=>{const te=T(M,x.assetType);return te&&Z.push([x.assetType.substring(z.length),te]),Z},[])}function R(M){if(M.properties){const z=M.properties.filter(x=>x.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=z.filter(x=>U.test(x.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return T(M,o.Repository)}function F(M){return{uri:`${M.fallbackAssetUri}/${o.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${o.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function T(M,z){return M.files.filter(Z=>Z.assetType===z)[0]?{uri:`${M.assetUri}/${z}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${z}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function q(M,z){const U=M.properties?M.properties.filter(x=>x.key===z):[],Z=U.length>0&&U[0].value;return Z?Z.split(",").map(x=>(0,w.$yp)(x)):[]}function Y(M){const z=M.properties?M.properties.filter(U=>U.key===a.Engine):[];return z.length>0&&z[0].value||""}function J(M){const z=M.properties?M.properties.filter(U=>U.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function X(M){const z=M.properties?M.properties.filter(Z=>Z.key===a.LocalizedLanguages):[],U=z.length>0&&z[0].value||"";return U?U.split(","):[]}function H(M){return M.properties?.find(z=>z.key===a.SponsorLink)?.value}function K(M){return M.properties?.find(z=>z.key===a.SupportLink)?.value}function G(M){return M.indexOf("preview")!==-1}function V(M){return M.targetPlatform?(0,y.$1o)(M.targetPlatform):"undefined"}function ie(M){const z=(0,D.$Mb)(M.versions.map(V)),U=!!M.tags?.includes(y.$Vo),Z=z.indexOf("web");return U?Z===-1&&z.push("web"):Z!==-1&&z.splice(Z,1),z}function se(M,z){for(let U=0;U<M.length;U++){const Z=M[U];if(Z.version===M[U-1]?.version){let x=U;if(V(Z)===z)for(;x>0&&M[x-1].version===Z.version;)x--;x!==U&&(M.splice(U,1),M.splice(x,0,Z))}}return M}function he(M,z,U){M.telemetryData={index:z,querySource:U,queryActivityId:M.queryContext?.[r]}}function ee(M,z,U,Z){const x=M.versions[0],te={manifest:T(z,o.Manifest),readme:T(z,o.Details),changelog:T(z,o.Changelog),license:T(z,o.License),repository:R(z),download:F(z),icon:T(z,o.Icon),signature:T(z,o.Signature),coreTranslations:P(z)};return{identifier:{id:(0,w.$zp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:z.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(x),description:M.shortDescription??"",installCount:k(M.statistics,"install"),rating:k(M.statistics,"averagerating"),ratingCount:k(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:U,assets:te,properties:{dependencies:q(z,a.Dependency),extensionPack:q(z,a.ExtensionPack),engine:Y(z),localizedLanguages:X(z),targetPlatform:V(z),isPreReleaseVersion:J(z)},hasPreReleaseVersion:J(x),hasReleaseVersion:!0,preview:G(M.flags),isSigned:!!te.signature,queryContext:Z,supportLink:K(x)}}let W=class{constructor(z,U,Z,x,te,_,oe,fe){this.k=U,this.l=Z,this.n=x,this.o=te,this.q=_,this.u=oe,this.w=fe;const $e=oe.extensionsGallery,de=$e?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.d=de?$e.servicePPEUrl:$e?.serviceUrl,this.g=de?void 0:$e?.searchUrl,this.h=$e?.controlUrl,this.j=(0,u.$8p)(oe.version,oe,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,U,Z){const x=N.CancellationToken.isCancellationToken(U)?{}:U,te=N.CancellationToken.isCancellationToken(U)?U:Z,_=[],oe=[],fe=[],$e=[];let de=!0;for(const Ee of z){Ee.uuid?oe.push(Ee.uuid):_.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);fe.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&$e.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Ce}if(!oe.length&&!_.length)return[];let ge=new v().withPage(1,z.length);oe.length&&(ge=ge.withFilter(i.ExtensionId,...oe)),_.length&&(ge=ge.withFilter(i.ExtensionName,..._)),(x.queryAllVersions||de)&&(ge=ge.withFlags(ge.flags,n.IncludeVersions)),x.source&&(ge=ge.withSource(x.source));const{extensions:be}=await this.z(ge,{targetPlatform:x.targetPlatform??t,includePreRelease:fe,versions:$e,compatible:!!x.compatible,productVersion:x.productVersion??{version:this.u.version,date:this.u.date}},te);return x.source&&be.forEach((Ee,Ce)=>he(Ee,Ce,x.source)),be}async getCompatibleExtension(z,U,Z,x={version:this.u.version,date:this.u.date}){if((0,y.$3o)(z.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(z,U,Z))return z;const te=new v().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,z.identifier.uuid),{extensions:_}=await this.z(te,{targetPlatform:Z,compatible:!0,includePreRelease:U,productVersion:x},N.CancellationToken.None);return _[0]||null}async isExtensionCompatible(z,U,Z,x={version:this.u.version,date:this.u.date}){if(!(0,y.$4o)(z.properties.targetPlatform,z.allTargetPlatforms,Z)||!U&&z.properties.isPreReleaseVersion)return!1;let te=z.properties.engine;if(!te){const _=await this.getManifest(z,N.CancellationToken.None);if(!_)throw new Error("Manifest was not found");te=_.engines.vscode}return(0,h.$Mp)(te,x.version,x.date)}async y(z,U,Z,x,te,_,oe={version:this.u.version,date:this.u.date}){if(!(0,y.$4o)(V(U),te,_)||Z!=="any"&&J(U)!==(Z==="prerelease"))return!1;if(x)try{const fe=await this.E(z,U);if(!(0,h.$Mp)(fe,oe.version,oe.date))return!1}catch(fe){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,L.$0)(fe)),!1}return!0}async query(z,U){let Z=z.text||"";const x=z.pageSize??50;let te=new v().withPage(1,x);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,be)=>(te=te.withFilter(i.Category,be||ge),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,be)=>(te=te.withFilter(i.Tag,be||ge),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(i.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),te=te.withFilter(i.SearchText,Z)),te=te.withSortBy(0)):z.ids?te=te.withFilter(i.ExtensionId,...z.ids):z.names?te=te.withFilter(i.ExtensionName,...z.names):te=te.withSortBy(4),typeof z.sortBy=="number"&&(te=te.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(te=te.withSortOrder(z.sortOrder)),z.source&&(te=te.withSource(z.source));const _=async(de,ge)=>{const{extensions:be,total:Ee}=await this.z(de,{targetPlatform:t,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},ge);return be.forEach((Ce,Re)=>he(Ce,(de.pageNumber-1)*de.pageSize+Re,z.source)),{extensions:be,total:Ee}},{extensions:oe,total:fe}=await _(te,U),$e=async(de,ge)=>{if(ge.isCancellationRequested)throw new L.$5;const{extensions:be}=await _(te.withPage(de+1),ge);return be};return{firstPage:oe,total:fe,pageSize:te.pageSize,getPage:$e}}async z(z,U,Z){const x=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),U.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:te,total:_,context:oe}=await this.B(z,Z);if(!(z.flags&n.IncludeLatestVersionOnly)){const ge=[];for(const be of te){const Ee=await this.A(be,U,oe);Ee&&ge.push(Ee)}return{extensions:ge,total:_}}const $e=[],de=new Map;for(let ge=0;ge<te.length;ge++){const be=te[ge],Ee={id:(0,w.$zp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ce=(0,I.$cg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(le=>(0,w.$up)(le,Ee))?.includePreRelease;if(U.compatible&&(0,y.$3o)(ie(be),U.targetPlatform))continue;const Re=await this.A(be,U,oe);!Re||Re.properties.isPreReleaseVersion&&(!Ce||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==U.targetPlatform&&Re.hasPreReleaseVersion?de.set(be.extensionId,ge):$e.push([ge,Re])}if(de.size){const ge=new $.$_d,be=new v().withFlags(x&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(i.ExtensionId,...de.keys()),{extensions:Ee}=await this.z(be,U,Z);this.o.publicLog2("galleryService:additionalQuery",{duration:ge.elapsed(),count:de.size});for(const Ce of Ee){const Re=de.get(Ce.identifier.uuid);$e.push([Re,Ce])}}return{extensions:$e.sort((ge,be)=>ge[0]-be[0]).map(([,ge])=>ge),total:_}}async A(z,U,Z){const x={id:(0,w.$zp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=U.versions?.find($e=>(0,w.$up)($e,x))?.version,_=(0,I.$cg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find($e=>(0,w.$up)($e,x))?.includePreRelease,oe=ie(z),fe=se(z.versions,U.targetPlatform);if(U.compatible&&(0,y.$3o)(oe,U.targetPlatform))return null;for(let $e=0;$e<fe.length;$e++){const de=fe[$e];if(!(te&&de.version!==te)){if(await this.y((0,w.$zp)(z.publisher.publisherName,z.extensionName),de,_?"any":"release",U.compatible,oe,U.targetPlatform,U.productVersion))return ee(z,de,oe,Z);if(te&&de.version===te)return null}}return te||U.compatible?null:ee(z,z.versions[0],oe)}async B(z,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const Z=await this.j,x=JSON.stringify(z.raw),te={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},_=new $.$_d;let oe,fe,$e=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&z.criteria.some(ge=>ge.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:te},U),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:$e};const de=await(0,l.$Tp)(oe);if(de){const ge=de.results[0],be=ge.extensions,Ee=ge.resultMetadata&&ge.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return $e=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:$e,context:{[r]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:$e}}catch(de){const ge=(0,L.$4)(de)?y.ExtensionGalleryErrorCode.Cancelled:(0,L.$0)(de).startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed;throw fe=new y.$8o((0,L.$0)(de),ge),fe}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(x.length),duration:_.elapsed(),success:!!oe&&(0,l.$Pp)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:fe?.code,count:String($e)})}}async reportStatistic(z,U,Z,x){if(!this.isEnabled())return;const te=A.$o?this.x(`/itemName/${z}.${U}/version/${Z}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${U}/${Z}/stats?statType=${x}`),_=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.j,Accept:_};try{await this.k.request({type:"POST",url:te,headers:fe},N.CancellationToken.None)}catch{}}async download(z,U,Z){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const x=(0,w.$Cp)(z),te=new Date().getTime(),_=ge=>this.o.publicLog("galleryService:downloadVSIX",{...x,duration:ge}),oe=Z===2?"install":Z===3?"update":"",fe=oe?{uri:`${z.assets.download.uri}${C.URI.parse(z.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${z.assets.download.fallbackUri}${C.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:z.assets.download,$e=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,de=await this.D(z.identifier.id,fe,o.VSIX,$e?{headers:$e}:void 0);await this.q.writeFile(U,de.stream),_(new Date().getTime()-te)}async downloadSignatureArchive(z,U){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const Z=await this.D(z.identifier.id,z.assets.signature,o.Signature);await this.q.writeFile(U,Z.stream)}async getReadme(z,U){if(z.assets.readme){const Z=await this.D(z.identifier.id,z.assets.readme,o.Details,{},U);return await(0,l.$Sp)(Z)||""}return""}async getManifest(z,U){if(z.assets.manifest){const Z=await this.D(z.identifier.id,z.assets.manifest,o.Manifest,{},U),x=await(0,l.$Sp)(Z);return x?JSON.parse(x):null}return null}async C(z,U,Z){const x=T(U,o.Manifest);if(!x)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},_=await this.D(z,x,o.Manifest,{headers:te});return await(0,l.$Tp)(_)}async getCoreTranslation(z,U){const Z=z.assets.coreTranslations.filter(x=>x[0]===U.toUpperCase())[0];if(Z){const x=await this.D(z.identifier.id,Z[1],Z[0]),te=await(0,l.$Sp)(x);return te?JSON.parse(te):null}return null}async getChangelog(z,U){if(z.assets.changelog){const Z=await this.D(z.identifier.id,z.assets.changelog,o.Changelog,{},U);return await(0,l.$Sp)(Z)||""}return""}async getAllCompatibleVersions(z,U,Z){let x=new v().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?x=x.withFilter(i.ExtensionId,z.identifier.uuid):x=x.withFilter(i.ExtensionName,z.identifier.id);const{galleryExtensions:te}=await this.B(x,N.CancellationToken.None);if(!te.length)return[];const _=ie(te[0]);if((0,y.$3o)(_,Z))return[];const oe=[];await Promise.all(te[0].versions.map(async de=>{try{await this.y(z.identifier.id,de,U?"any":"release",!0,_,Z)&&oe.push(de)}catch{}}));const fe=[],$e=new Set;for(const de of se(oe,Z))$e.has(de.version)||($e.add(de.version),fe.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:J(de)}));return fe}async D(z,U,Z,x={},te=N.CancellationToken.None){const _=await this.j,oe={type:"GET"},fe={..._,...x.headers||{}};x={...x,...oe,headers:fe};const $e=U.uri,de=U.fallbackUri,ge={...x,url:$e};try{const be=await this.k.request(ge,te);if(be.res.statusCode===200)return be;const Ee=await(0,l.$Sp)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Ee}`)}catch(be){if((0,L.$4)(be))throw be;const Ee=(0,L.$0)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:Z,message:Ee});const Ce={...x,url:de};return this.k.request(Ce,te)}}async E(z,U){let Z=Y(U);if(!Z){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:U.version});const x=await this.C(z,U,N.CancellationToken.None);if(!x)throw new Error("Manifest was not found");Z=x.engines.vscode}return Z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.$Tp)(z),Z=[],x={},te=[];if(U){for(const _ of U.malicious)Z.push({id:_});if(U.migrateToPreRelease)for(const[_,oe]of Object.entries(U.migrateToPreRelease))(!oe.engine||(0,h.$Mp)(oe.engine,this.u.version,this.u.date))&&(x[_.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[_,oe]of Object.entries(U.deprecated))oe&&(x[_.toLowerCase()]=(0,I.$cg)(oe)?{}:oe);if(U.search)for(const _ of U.search)te.push(_)}return{malicious:Z,deprecated:x,search:te}}};W=ve([Q(1,l.$Np),Q(2,p.$3j),Q(3,E.$Di),Q(4,d.$2l),Q(5,c.$3k),Q(6,g.$jk),Q(7,f.$3i)],W);let B=class extends W{constructor(z,U,Z,x,te,_,oe,fe){super(z,U,Z,x,te,_,oe,fe)}};e.$0p=B,e.$0p=B=ve([Q(0,m.$1p),Q(1,l.$Np),Q(2,p.$3j),Q(3,E.$Di),Q(4,d.$2l),Q(5,c.$3k),Q(6,g.$jk),Q(7,f.$3i)],B);let j=class extends W{constructor(z,U,Z,x,te,_,oe){super(void 0,z,U,Z,x,te,_,oe)}};e.$$p=j,e.$$p=j=ve([Q(0,l.$Np),Q(1,p.$3j),Q(2,E.$Di),Q(3,d.$2l),Q(4,c.$3k),Q(5,g.$jk),Q(6,f.$3i)],j)}),define(ae[82],ce([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,D,N,L,A,O,I,C,f,E){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=void 0,e.$7v=(0,D.$wi)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends L.$Uc{static{y=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$yp)(p.id)}@${p.version}`}static c(p){const g=w.exec(p);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(p,g){const l=await p.getInstalled(),u=[];for(const[m,d]of y.f(g)){const $=l.find(t=>(0,O.$up)(t.identifier,{id:m}))?.manifest.version;for(const t of d)$!==t&&u.push(y.b({id:m,version:t}))}for(const m of u)g.remove(m,0)}static f(p){const g=new Map,l=p.keys(0,1);for(const u of l){const m=y.c(u);if(m){let d=g.get(m.id.toLowerCase());d||g.set(m.id.toLowerCase(),d=[]),d.push(m.version)}}return g}constructor(p,g,l){super(),this.j=p,this.m=g,this.n=l,this.g=this.B(new N.$de),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=y.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Tc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const g=y.c(p.key);if(g){if(this.j.get(p.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let l=this.h.get(g.id.toLowerCase());l||this.h.set(g.id.toLowerCase(),l=[]),l.push(g.version),this.g.fire()}return}}s(p){if((0,E.$9f)(p))return p;const g=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,O.$xp)(g,l)}getExtensionState(p,g){const l=this.s(p),u=this.getExtensionStateRaw(p,g);if(u)try{return JSON.parse(u)}catch(m){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${g}): ${m}`)}}getExtensionStateRaw(p,g){const l=this.s(p),u=this.j.get(l,g?0:1);return u&&u?.length>y.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${g}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,g,l){const u=this.s(p);g===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(g),l?0:1,1)}setKeysForSync(p,g){this.j.store(y.b(p),JSON.stringify(g),0,1)}getKeysForSync(p){const g=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(y.b(p),0),u=l?JSON.parse(l):void 0;return u&&g?(0,C.$Mb)([...u,...g]):u||g}addToMigrationList(p,g){if(p!==g){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(g));l.push([p,g]),this.t=l}}getSourceExtensionToMigrate(p){const g=this.t.find(([,l])=>p===l);return g?g[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(p);if(Array.isArray(g))return g}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$8v=h,e.$8v=h=y=ve([Q(0,A.$1p),Q(1,I.$jk),Q(2,f.$3j)],h)}),define(ae[255],ce([0,1,2,29,82,230,113,9,19]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;let f=class extends D.$Uc{constructor(y,w,h,c,p,g){super(),y.cleanUp(),(0,A.$H4b)(y,w,h,c,g),L.$8v.removeOutdatedExtensionVersions(y,p)}};e.$Iec=f,e.$Iec=f=ve([Q(0,O.$Dq),Q(1,N.$6o),Q(2,L.$7v),Q(3,N.$_o),Q(4,C.$1p),Q(5,I.$3j)],f)}),define(ae[256],ce([0,1,29,12,24,16,96,57,19,22,229]),function(ne,e,D,N,L,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;let y=class extends E.$5ac{constructor(h,c,p,g,l,u,m,d){super(h.userHome,l,c,p,g,u,m,d)}};e.$Pec=y,e.$Pec=y=ve([Q(0,A.$Ei),Q(1,f.$2l),Q(2,D.$9o),Q(3,C.$1p),Q(4,I.$Fcc),Q(5,O.$r4b),Q(6,N.$3k),Q(7,L.$jk)],y)}),define(ae[257],ce([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;const $=[D.$Eec,D.$Fec],t="remoteTunnelSession",r="remoteTunnelIsService";let n=class extends O.$Uc{constructor(a,b,S,v,k,P,R){super(),this.y=a,this.z=b,this.C=S,this.D=P,this.F=R,this.f=new N.$de,this.onDidTokenFailed=this.f.event,this.g=new N.$de,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$de,this.onDidChangeMode=this.h.event,this.n=D.$Cec,this.w=!1,this.I=(F,T)=>{T?this.j.error(F):this.j.info(F)},this.j=this.B(v.createLogger((0,d.$0g)(S.logsHome,`${D.$Gec}.log`),{id:D.$Gec,name:D.$Hec})),this.t=new w.$th(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,I.$fk)(F)))),this.B(k.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(P.onDidChangeConfiguration(F=>{$.some(T=>F.affectsConfiguration(T))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){i(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}J(){if(!this.u){let a;y.$j?a=this.C.appRoot:a=(0,C.$mc)((0,C.$mc)(this.C.appRoot)),this.u=(0,C.$jc)(a,"bin",`${this.z.tunnelApplicationName}${y.$i?".exe":""}`)}return this.u}async startTunnel(a){if(i(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(D.$Cec);try{a&&this.O("uninstallService",["service","uninstall"])}catch(b){this.j.error(b)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",b=!1;const S=(T,q)=>{q?this.j.error(T):a+=T,!this.C.isBuilt&&T.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,p.localize)(0,null)))},v=this.O("status",["status"],S);this.r=v;try{if(await v,this.r!==v)return;let T;try{T=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(D.TunnelStates.disconnected());return}if(b=T.service_installed,this.j.info(T.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!T.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(T){this.j.error(T),this.G(D.TunnelStates.disconnected());return}finally{this.r===v&&(this.r=void 0)}const k=this.n.active?this.n.session:void 0;if(k&&k.token){const T=k.token;this.G(D.TunnelStates.connecting((0,p.localize)(1,null,k.accountLabel,k.providerId)));const q=(J,X)=>{J=J.replaceAll(T,"*".repeat(4)),S(J,X)},Y=this.O("login",["user","login","--provider",k.providerId,"--access-token",T,"--log",(0,I.$fk)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(k),this.G(D.TunnelStates.disconnected(k));return}}const P=this.Q();P?this.G(D.TunnelStates.connecting((0,p.localize)(2,null,P))):this.G(D.TunnelStates.connecting((0,p.localize)(3,null)));const R=["--accept-server-license-terms","--log",(0,I.$fk)(this.j.getLevel())];P?R.push("--name",P):R.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!b&&(F=await this.M(R)===!1),this.N(k,R,F)}async M(a){let b;try{b=await this.O("serviceInstall",["service","install",...a])}catch(S){this.j.error(S),b=1}if(b!==0){const S=(0,p.localize)(4,null);return this.j.warn(S),this.G(D.TunnelStates.connecting(S)),!1}return!0}async N(a,b,S){b.push("--parent-process-id",String(process.pid)),this.P()&&b.push("--no-sleep");let v=!1;const k=this.O("tunnel",b,(P,R)=>{R?this.j.error(P):this.j.info(P),P.includes("Connected to an existing tunnel process")&&(v=!0);const F=P.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const T={link:F[1],domain:F[2],tunnelName:F[4],isAttached:v};this.G(D.TunnelStates.connected(T,S))}else P.match(/error refreshing token/)&&(k.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=k,k.finally(()=>{k===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$Cec,this.G(D.TunnelStates.disconnected()))})}O(a,b,S=this.I){return(0,w.$jh)(v=>new Promise((k,P)=>{v.isCancellationRequested&&k(-1);let R;const F=["ignore","pipe","pipe"];if(v.onCancellationRequested(()=>{R&&(this.j.info(`${a} terminating(${R.pid})`),R.kill())}),!this.C.isBuilt)S(`Building tunnel CLI from sources and run
`,!1),S(`${a} Spawning: cargo run -- tunnel ${b.join(" ")}
`,!1),R=(0,f.spawn)("cargo",["run","--","tunnel",...b],{cwd:(0,C.$jc)(this.C.appRoot,"cli"),stdio:F});else{S(`Running tunnel CLI
`,!1);const T=this.J();S(`${a} Spawning: ${T} tunnel ${b.join(" ")}
`,!1),R=(0,f.spawn)(T,["tunnel",...b],{cwd:(0,g.homedir)(),stdio:F})}R.stdout.pipe(new m.$1W(`
`)).on("data",T=>{if(R){const q=T.toString();S(q,!1)}}),R.stderr.pipe(new m.$1W(`
`)).on("data",T=>{if(R){const q=T.toString();S(q,!0)}}),R.on("exit",T=>{R&&(S(`${a} exit(${R.pid}): + ${T} `,!1),R=void 0,k(T||0))}),R.on("error",T=>{R&&(S(`${a} error(${R.pid}): + ${T} `,!0),R=void 0,P())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$Fec)}Q(){let a=this.D.getValue(D.$Eec)||(0,g.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(t,-1),b=this.F.getBoolean(r,-1,!1);if(a){const S=JSON.parse(a);if(S&&(0,u.$9f)(S.accountLabel)&&(0,u.$9f)(S.sessionId)&&(0,u.$9f)(S.providerId))return{active:!0,session:S,asService:b};this.j.error("Problems restoring session from storage, invalid format",S)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$Cec}S(a){if(a.active){const b={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(t,JSON.stringify(b),-1,1),this.F.store(r,a.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(r,-1)}};e.$Lec=n,e.$Lec=n=ve([Q(0,L.$2l),Q(1,E.$jk),Q(2,A.$Ei),Q(3,I.$4j),Q(4,h.$Jec),Q(5,c.$3i),Q(6,l.$1p)],n);function s(o,a){return o&&a?o.sessionId===a.sessionId&&o.providerId===a.providerId&&o.token===a.token:o===a}const i=(o,a)=>o.active!==a.active?!1:o.active&&a.active?o.asService===a.asService&&s(o.session,a.session):!0}),define(ae[258],ce([0,1,6,2,23,20,69,19,77,18]),function(ne,e,D,N,L,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class E extends I.$3p{constructor(w,h,c,p){super(),this.bb=w,this.cb=h,this.db=c,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Tc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new C.$EKb(this.db.getChannel("storage"))),h=this.B(new O.$Wp(w));return this.B(h.onDidChangeStorage(c=>this.u(-1,c))),h}gb(w){this.X.clear(),this.W=w;let h;if((0,I.$4p)(w))h=this.U;else{const c=this.X.add(new C.$FKb(this.db.getChannel("storage"),w));h=this.X.add(new O.$Wp(c))}return this.X.add(h.onDidChangeStorage(c=>this.u(0,c))),h}hb(w){this.$.clear(),this.Z=w?.id;let h;if(w){const c=this.$.add(new C.$GKb(this.db.getChannel("storage"),w));h=this.$.add(new O.$Wp(c)),this.$.add(h.onDidChangeStorage(p=>this.u(1,p)))}return h}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$0g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const h=this.Y,c=h.items;h!==this.U&&await h.close(),this.Y=this.gb(w),await this.Y.init(),this.N(c,this.Y,0)}async S(w,h){const c=this.ab,p=c?.items??new Map;await c?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(p,this.ab,1)}hasScope(w){return(0,f.$Bl)(w)?this.W.id===w.id:this.Z===w.id}}e.$Qec=E}),define(ae[259],ce([0,1,3,2,18,91]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Q=e.$6Q=void 0;class O{constructor(f,E){this.a=f,this.b=E}listen(f,E){const y=this.b(f);switch(E){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(h=>(0,A.$An)({...h},y)),added:w.added.map(h=>(0,A.$An)({...h},y)),removed:w.removed.map(h=>(0,A.$An)({...h},y)),updated:w.updated.map(h=>(0,A.$An)({...h},y))}))}throw new Error(`Invalid listen ${E}`)}async call(f,E,y){const w=this.b(f);switch(E){case"createProfile":{const h=await this.a.createProfile(y[0],y[1],y[2]);return(0,A.$An)({...h},w)}case"updateProfile":{let h=(0,L.$Dl)((0,A.$Bn)(y[0],w),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,y[1]),(0,A.$An)({...h},w)}case"removeProfile":{const h=(0,L.$Dl)((0,A.$Bn)(y[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${E}`)}}e.$6Q=O;class I extends N.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(f,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new D.$de),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=f.map(w=>(0,L.$Dl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const h=w.added.map(g=>(0,L.$Dl)(g,this.profilesHome.scheme)),c=w.removed.map(g=>(0,L.$Dl)(g,this.profilesHome.scheme)),p=w.updated.map(g=>(0,L.$Dl)(g,this.profilesHome.scheme));this.a=w.all.map(g=>(0,L.$Dl)(g,this.profilesHome.scheme)),this.b.fire({added:h,removed:c,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(f){this.c=f}isEnabled(){return this.c}async createNamedProfile(f,E,y){const w=await this.f.call("createNamedProfile",[f,E,y]);return(0,L.$Dl)(w,this.profilesHome.scheme)}async createProfile(f,E,y,w){const h=await this.f.call("createProfile",[f,E,y,w]);return(0,L.$Dl)(h,this.profilesHome.scheme)}async createTransientProfile(f){const E=await this.f.call("createTransientProfile",[f]);return(0,L.$Dl)(E,this.profilesHome.scheme)}async setProfileForWorkspace(f,E){await this.f.call("setProfileForWorkspace",[f,E])}removeProfile(f){return this.f.call("removeProfile",[f])}async updateProfile(f,E){const y=await this.f.call("updateProfile",[f,E]);return(0,L.$Dl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$7Q=I}),define(ae[60],ce([0,1,2,69,4,19,3,77,18]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KKb=e.$JKb=e.$IKb=void 0,e.$IKb=(0,L.$wi)("IUserDataProfileStorageService");let f=class extends D.$Uc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async c=>this.b(c))}async updateStorageData(h,c,p){return this.withProfileScopedStorageService(h,async g=>this.c(g,c,p))}async withProfileScopedStorageService(h,c){if(this.a.hasScope(h))return c(this.a);const p=await this.g(h),g=new y(p);try{await g.initialize();const l=await c(g);return await g.flush(),l}finally{g.dispose(),await this.f(p)}}b(h){const c=new Map,p=g=>{for(const l of h.keys(0,g))c.set(l,{value:h.get(l,0),target:g})};return p(0),p(1),c}c(h,c,p){h.storeAll(Array.from(c.entries()).map(([g,l])=>({key:g,value:l,scope:0,target:p})),!0)}async f(h){try{await h.close()}finally{(0,D.$Oc)(h)&&h.dispose()}}};e.$JKb=f,e.$JKb=f=ve([Q(0,A.$1p)],f);class E extends f{constructor(h,c,p,g){super(p),this.j=h;const l=h.getChannel("profileStorageListener"),u=this.B(new D.$Vc);this.h=this.B(new O.$de({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(m=>{g.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(d=>(0,C.$Dl)(d,c.profilesHome.scheme)),valueChanges:m.valueChanges.map(d=>({...d,profile:(0,C.$Dl)(d.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const c=this.j.getChannel("storage");return(0,A.$4p)(h)?new I.$EKb(c):new I.$FKb(c,h)}}e.$KKb=E;class y extends A.$3p{constructor(h){super({flushInterval:100}),this.s=this.B(new N.$Wp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[260],ce([0,1,19,9,18,56,60]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;let I=class extends O.$KKb{constructor(f,E,y,w){super(f,E,y,w)}};e.$vec=I,e.$vec=I=ve([Q(0,A.$Udc),Q(1,L.$Cl),Q(2,D.$1p),Q(3,N.$3j)],I)}),define(ae[39],ce([0,1,17,6,15,26,3,35,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JLb=e.$ILb=e.$HLb=e.$GLb=void 0,e.$DLb=t,e.$ELb=r,e.$FLb=n;function t(b){return!!(b&&b.ref!==void 0&&typeof b.ref=="string"&&b.ref!==""&&b.syncData!==void 0&&(b.syncData===null||r(b.syncData)))}function r(b){return!!(b&&b.version!==void 0&&typeof b.version=="number"&&b.content!==void 0&&typeof b.content=="string"&&(Object.keys(b).length===2||Object.keys(b).length===3&&b.machineId!==void 0&&typeof b.machineId=="string"))}function n(b,S){return`${(0,f.$1f)(b)}${S.isDefault?"":` (${S.name})`}`}let s=class extends C.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(S,v,k,P,R,F,T,q,Y,J,X,H){super(),this.syncResource=S,this.collection=v,this.G=k,this.H=P,this.I=R,this.J=F,this.L=T,this.M=q,this.N=Y,this.O=J,this.P=X,this.c=null,this.m="idle",this.n=this.B(new O.$de),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$de),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$uh(50)),this.w=this.B(new O.$de),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(S.syncResource,S.profile),this.h=H.extUri,this.f=this.h.joinPath(P.userDataSyncHome,...(0,d.$7kb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.g=this.h.joinPath(this.f,d.$plb),this.y=(0,d.$8kb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,P,this.h),this.j=(0,g.$7p)(P,k,R)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const S=await this.c;this.c=null;const v=await this.Y(S.remoteUserData,S.lastSyncUserData,!0,this.ob());this.S(v)}else{this.O.trace(`${this.D}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.ub(S):!0)&&this.w.fire()}}S(S){this.m!==S&&(this.m=S,this.n.fire(S))}async sync(S,v={}){await this.U(S,!0,this.ob(),v)}async preview(S,v,k={}){return this.U(S,!1,v,k)}async apply(S,v={}){try{this.F={...v};const k=await this.ab(S);return this.S(k),this.c}finally{this.F={}}}async U(S,v,k,P){try{if(this.F={...P},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let R="idle";try{const F=await this.getLastSyncUserData(),T=await this.X(S,F);return R=await this.Y(T,F,v,k),R==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):R==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(R)}}finally{this.F={}}}async replace(S){const v=this.kb(S);if(!v)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const k=await this.getLastSyncUserData(),P=await this.X(null,k),R=await this.W(P),F=await this.qb({ref:P.ref,syncData:v},k,R,this.ob(),A.CancellationToken.None),T=[];for(const q of F){const Y=await this.sb(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:J}=await this.sb(q,q.previewResource,q.remoteContent,A.CancellationToken.None);T.push([q,{...Y,remoteChange:J!==0?J:2}])}await this.tb(P,k,T,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(S){const v=await this.j;return!!S.syncData?.machineId&&S.syncData.machineId===v}async X(S,v){if(v){const k=S?S[this.resource]:void 0;if(v.ref===k||k===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async Y(S,v,k,P){if(S.syncData&&S.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$clb((0,y.localize)(0,null,this.resource,this.pb,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(S,v,k,P)}catch(R){if(R instanceof d.$clb)switch(R.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(S,v,k,P);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.Y(S,v,k,P)}throw R}}async Z(S,v,k,P){try{const R=await this.W(S),F=!R&&v===null&&this.gb()!==void 0,T=k&&!F;this.c||(this.c=(0,N.$jh)(Y=>this.eb(S,v,R,T,P,Y)));let q=await this.c;if(k&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":k?await this.ab(!1):"syncing"}catch(R){throw this.c=null,R}}async merge(S){return await this.$(S,async v=>{const k=await this.rb(v,A.CancellationToken.None);await this.G.writeFile(v.previewResource,L.$Fe.fromString(k?.content||""));const P=k&&!k.hasConflicts?await this.sb(v,v.previewResource,void 0,A.CancellationToken.None):void 0;return v.acceptResult=P,v.mergeState=k.hasConflicts?"conflict":P?"accepted":"preview",v.localChange=P?P.localChange:k.localChange,v.remoteChange=P?P.remoteChange:k.remoteChange,v}),this.c}async accept(S,v){return await this.$(S,async k=>{const P=await this.sb(k,S,v,A.CancellationToken.None);return k.acceptResult=P,k.mergeState="accepted",k.localChange=P.localChange,k.remoteChange=P.remoteChange,k}),this.c}async discard(S){return await this.$(S,async v=>{const k=await this.rb(v,A.CancellationToken.None);return await this.G.writeFile(v.previewResource,L.$Fe.fromString(k.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=k.localChange,v.remoteChange=k.remoteChange,v}),this.c}async $(S,v){if(!this.c)return;let k=await this.c;const P=k.resourcePreviews.findIndex(({localResource:R,remoteResource:F,previewResource:T})=>this.h.isEqual(R,S)||this.h.isEqual(F,S)||this.h.isEqual(T,S));P!==-1&&(this.c=(0,N.$jh)(async R=>{const F=[...k.resourcePreviews];return F[P]=await v(F[P]),{...k,resourcePreviews:F}}),k=await this.c,this.cb(k.resourcePreviews),k.resourcePreviews.some(({mergeState:R})=>R==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(S){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.tb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(k=>[k,k.acceptResult]),S),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(S){const v=S.filter(({mergeState:k})=>k==="conflict");(0,D.$ub)(this.s,v,(k,P)=>this.h.isEqual(k.previewResource,P.previewResource))||(this.s=v,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async db(S){const v=this.c?await this.c:null;if(v)for(const k of v.resourcePreviews){if(this.h.isEqual(k.acceptedResource,S))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,S))return k.remoteContent;if(this.h.isEqual(k.localResource,S))return k.localContent;if(this.h.isEqual(k.baseResource,S))return k.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(S){(0,c.$hl)(S)!==1&&this.O.error(S)}}async eb(S,v,k,P,R,F){const T=await this.qb(S,v,k,R,F),q=[];for(const Y of T){const J=Y.previewResource.with({scheme:d.$olb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=P?await this.rb(Y,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$Fe.fromString(X?.content||""));const H=X&&!X.hasConflicts?await this.sb(Y,Y.previewResource,void 0,F):void 0;q.push({...Y,acceptResult:H,mergeState:X?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:X?X.localChange:Y.localChange,remoteChange:H?H.remoteChange:X?X.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:v,resourcePreviews:q,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let S=this.gb();if(S||(S=await this.jb()),!S)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const v=JSON.parse(S),k=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!v.version&&!!k&&v.version!==k,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let P,R=1;for(;P===void 0&&R++<6;)try{const F=await this.hb();F&&(F.ref===v.ref?P=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof c.$ll&&F.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof d.$clb)throw F;this.O.error(F,R)}}if(P===void 0)try{const F=await this.J.resolveResourceContent(this.resource,v.ref,this.collection,this.F);P=F===null?null:this.kb(F),await this.ib({ref:v.ref,syncData:P})}catch(F){if(F instanceof d.$clb&&F.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return P===void 0?null:{...v,syncData:P}}async fb(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k=this.M.getResourceSyncStateVersion(this.resource),P={ref:S.ref,version:k,...v};this.I.store(this.z,JSON.stringify(P),-1,1),await this.ib(S)}gb(){return this.I.get(this.z,-1)}async hb(){const S=(await this.G.readFile(this.y)).value.toString();try{const v=S?JSON.parse(S):void 0;if(t(v))return v}catch(v){this.O.error(v)}}async ib(S){await this.G.writeFile(this.y,L.$Fe.fromString(JSON.stringify(S)))}async jb(){try{const S=await this.G.readFile(this.y),v=JSON.parse(S.value.toString());await this.G.del(this.y),v.ref&&v.content!==void 0?(this.I.store(this.z,JSON.stringify({...v,content:void 0}),-1,1),await this.ib({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,v)}catch(S){S instanceof c.$ll&&S.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(S)}return this.I.get(this.z,-1)}async getRemoteUserData(S){const{ref:v,content:k}=await this.lb(S);let P=null;return k!==null&&(P=this.kb(k)),{ref:v,syncData:P}}kb(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.O.error(v)}throw new d.$clb((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(S){const v=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.J.readResource(this.resource,v,this.collection,this.F)}async mb(S,v){const k=await this.j,P={version:this.pb,machineId:k,content:S};try{return v=await this.J.writeResource(this.resource,JSON.stringify(P),v,this.collection,this.F),{ref:v,syncData:P}}catch(R){throw R instanceof d.$clb&&R.code==="TooLarge"&&(R=new d.$clb(R.message,R.code,this.resource)),R}}async nb(S){const v={version:this.pb,content:S};return this.L.writeResource(this.resource,JSON.stringify(v),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$2kb)}};e.$GLb=s,e.$GLb=s=ve([Q(2,c.$3k),Q(3,h.$Di),Q(4,l.$1p),Q(5,d.$0kb),Q(6,d.$$kb),Q(7,d.$hlb),Q(8,u.$2l),Q(9,d.$mlb),Q(10,w.$3i),Q(11,m.$Al)],s);let i=class extends s{constructor(S,v,k,P,R,F,T,q,Y,J,X,H,K){super(v,k,P,R,F,T,q,Y,J,X,H,K),this.r=S,this.B(this.G.watch(this.h.dirname(S))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(S,v,k){try{v?await this.G.writeFile(this.r,L.$Fe.fromString(S),k?void 0:v):await this.G.createFile(this.r,L.$Fe.fromString(S),{overwrite:k})}catch(P){throw P instanceof c.$ll&&P.fileOperationResult===1||P instanceof c.$ll&&P.fileOperationResult===3?new d.$clb(P.message,"LocalPreconditionFailed"):P}}async xb(){try{await this.G.del(this.r)}catch(S){if(!(S instanceof c.$ll&&S.fileOperationResult===1))throw S}}yb(S){S.contains(this.r)&&this.Q()}};e.$HLb=i,e.$HLb=i=ve([Q(3,c.$3k),Q(4,h.$Di),Q(5,l.$1p),Q(6,d.$0kb),Q(7,d.$$kb),Q(8,d.$hlb),Q(9,u.$2l),Q(10,d.$mlb),Q(11,w.$3i),Q(12,m.$Al)],i);let o=class extends i{constructor(S,v,k,P,R,F,T,q,Y,J,X,H,K,G){super(S,v,k,P,R,F,T,q,Y,J,X,K,G),this.zb=H,this.Bb=void 0}Ab(S,v){const k=[],P=(0,I.$Jn)(S,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,E.$dg)(P)&&v!==Array.isArray(P)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$ILb=o,e.$ILb=o=ve([Q(3,c.$3k),Q(4,h.$Di),Q(5,l.$1p),Q(6,d.$0kb),Q(7,d.$$kb),Q(8,d.$hlb),Q(9,u.$2l),Q(10,d.$mlb),Q(11,d.$llb),Q(12,w.$3i),Q(13,m.$Al)],o);let a=class{constructor(S,v,k,P,R,F,T){this.resource=S,this.g=v,this.h=k,this.j=P,this.k=R,this.l=F,this.d=T.extUri,this.f=(0,d.$8kb)(void 0,this.resource,k,this.d)}async initialize({ref:S,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(v);if(k)try{await this.o({ref:S,syncData:k})}catch(P){this.j.error(P)}}m(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k={ref:S.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,L.$Fe.fromString(JSON.stringify(S)))}};e.$JLb=a,e.$JLb=a=ve([Q(1,$.$Cl),Q(2,h.$Di),Q(3,p.$3j),Q(4,c.$3k),Q(5,l.$1p),Q(6,m.$Al)],a)}),define(ae[115],ce([0,1,6,26,7,3,44,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=e.$_$b=e.$$$b=void 0,e.$9$b=S,e.$0$b=v;async function b(F,T){const q=JSON.parse(F.content);if(F.version===1||F.version===2){const Y=(await T.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of q)F.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),F.version===2&&Y.every(X=>!(0,h.$up)(X.identifier,J.identifier))&&(J.installed=!0)}return q}function S(F){return JSON.parse(F.content)}function v(F,T){return F.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,C.$qf)(q.identifier.id,Y.identifier.id)),T?(0,O.$Un)(F,{}):JSON.stringify(F)}let k=class extends n.$GLb{constructor(T,q,Y,J,X,H,K,G,V,ie,se,he,ee,W,B,j,M){super({syncResource:"extensions",profile:T},q,J,Y,X,H,K,he,ee,ie,se,B),this.Cb=G,this.Db=V,this.Eb=M,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$olb,authority:"base"}),this.yb=this.wb.with({scheme:o.$olb,authority:"local"}),this.zb=this.wb.with({scheme:o.$olb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$olb,authority:"accepted"}),this.Bb=this.Eb.createInstance(P),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:U})=>!!U)),A.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),A.Event.filter(j.onDidChange,z=>z.valueChanges.some(({profile:U,changes:Z})=>this.syncResource.profile.id===U.id&&Z.some(x=>x.key===w.$0o))),W.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(T,q){const Y=T.syncData?await b(T.syncData,this.Cb):null,J=q?.skippedExtensions??[],X=q?.builtinExtensions??null,H=q?.syncData?await b(q.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:ie}=(0,s.$8$b)(K,Y,H,J,G,X),se={local:V,remote:ie,content:this.Hb(K,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:ie!==null?2:0},he=this.Ob(K,!1);return[{skippedExtensions:J,builtinExtensions:X,baseResource:this.xb,baseContent:H?this.Ob(H,!1):he,localResource:this.yb,localContent:he,localExtensions:K,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(T){const q=T.syncData?await b(T.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,s.$8$b)(Y,q,q,T.skippedExtensions||[],J,T.builtinExtensions||[]);return X!==null}Hb(T,q,Y,J){const X=[...q,...Y],H=new Set,K=G=>{H.add(G.id.toLowerCase()),G.uuid&&H.add(G.uuid)};X.forEach(({identifier:G})=>K(G)),J.forEach(K);for(const G of T)H.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&H.has(G.identifier.uuid)||X.push(G);return this.Ob(X,!1)}async rb(T,q){return{...T.previewResult,hasConflicts:!1}}async sb(T,q,Y,J){if(this.h.isEqual(q,this.yb))return this.Kb(T);if(this.h.isEqual(q,this.zb))return this.Lb(T);if(this.h.isEqual(q,this.wb))return T.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),J=(0,s.$8$b)(T.localExtensions,null,null,T.skippedExtensions,Y,T.builtinExtensions),{local:X,remote:H}=J;return{content:T.localContent,local:X,remote:H,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),J=T.remoteContent?JSON.parse(T.remoteContent):null;if(J!==null){const X=(0,s.$8$b)(T.localExtensions,J,T.localExtensions,[],Y,T.builtinExtensions),{local:H,remote:K}=X;return{content:T.remoteContent,local:H,remote:K,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:T.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(T,q,Y,J){let{skippedExtensions:X,builtinExtensions:H,localExtensions:K}=Y[0][0];const{local:G,remote:V,localChange:ie,remoteChange:se}=Y[0][1];if(ie===0&&se===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(K)),X=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,X,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(V.all);T=await this.mb(he,J?null:T.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ee=>ee.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ee=>ee.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ee=>ee.identifier.id))}.`:""}`)}q?.ref!==T.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(K,H),await this.fb(T,{skippedExtensions:X,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(he=>he.identifier.id))}.`:""}`))}Nb(T,q){const Y=new Set,J=[];for(const X of T)Y.add(X.identifier.id.toLowerCase()),X.installed||J.push(X.identifier);if(q)for(const X of q)Y.has(X.id.toLowerCase())||J.push(X);return J}async resolveContent(T){if(this.h.isEqual(this.zb,T)||this.h.isEqual(this.xb,T)||this.h.isEqual(this.yb,T)||this.h.isEqual(this.Ab,T)){const q=await this.db(T);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(T,q){return v(T,q)}async hasLocalData(){try{const{localExtensions:T}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(T.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$$$b=k,e.$$$b=k=ve([Q(2,E.$Di),Q(3,g.$3k),Q(4,d.$1p),Q(5,o.$0kb),Q(6,o.$$kb),Q(7,w.$9o),Q(8,i.$sMb),Q(9,o.$mlb),Q(10,f.$3i),Q(11,o.$hlb),Q(12,$.$2l),Q(13,c.$7v),Q(14,t.$Al),Q(15,a.$IKb),Q(16,l.$vi)],k);let P=class{constructor(T,q,Y,J,X,H){this.a=T,this.b=q,this.c=Y,this.d=J,this.f=X,this.g=H}async getLocalExtensions(T){const q=await this.a.getInstalled(void 0,T.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(T,async(X,H)=>{const K=X.getDisabledExtensions();return q.map(G=>{const{identifier:V,isBuiltin:ie,manifest:se,preRelease:he,pinned:ee,isApplicationScoped:W}=G,B={identifier:V,preRelease:he,version:se.version,pinned:!!ee};W&&!(0,p.$Um)(se)&&(B.isApplicationScoped=W),K.some(j=>(0,h.$up)(j,V))&&(B.disabled=!0),ie||(B.installed=!0);try{const j=H.getKeysForSync({id:V.id,version:se.version});if(j){const M=H.getExtensionState(G,!0)||{};B.state=Object.keys(M).reduce((z,U)=>(j.includes(U)&&(z[U]=M[U]),z),{})}}catch(j){this.g.info(`${(0,n.$FLb)("extensions",T)}: Error while parsing extension state`,(0,L.$0)(j))}return B})}),ignoredExtensions:Y}}async updateLocalExtensions(T,q,Y,J,X){const H=(0,n.$FLb)("extensions",X),K=[],G=new Map,V=[],ie=[],se=await this.a.getInstalled(void 0,X.extensionsResource);if((T.length||Y.length)&&await this.j(X,async(W,B)=>{await D.Promises.settled([...T,...Y].map(async j=>{const M=se.find(Z=>(0,h.$up)(Z.identifier,j.identifier));if(M&&M.isBuiltin){j.state&&M.manifest.version===j.version&&this.h(j.state,M,M.manifest.version,B),W.getDisabledExtensions().some(x=>(0,h.$up)(x,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${H}: Disabling extension...`,j.identifier.id),await W.disableExtension(j.identifier),this.g.info(`${H}: Disabled extension`,j.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,j.identifier.id),await W.enableExtension(j.identifier),this.g.info(`${H}: Enabled extension`,j.identifier.id))),V.push(j.identifier);return}const z=j.pinned?j.version:void 0,U=(await this.c.getExtensions([{...j.identifier,version:z,preRelease:z?void 0:j.preRelease}],N.CancellationToken.None))[0];if(j.state&&(M?M.manifest.version===j.version:U)&&this.h(j.state,M||U,M?.manifest.version,B),U)try{W.getDisabledExtensions().some(x=>(0,h.$up)(x,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${H}: Disabling extension...`,j.identifier.id,U.version),await W.disableExtension(U.identifier),this.g.info(`${H}: Disabled extension`,j.identifier.id,U.version)):(this.g.trace(`${H}: Enabling extension...`,j.identifier.id,U.version),await W.enableExtension(U.identifier),this.g.info(`${H}: Enabled extension`,j.identifier.id,U.version))),(!M||M.preRelease!==j.preRelease||M.pinned!==j.pinned||z&&M.manifest.version!==z)&&(await this.a.canInstall(U)?(K.push({extension:U,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:j.pinned&&!!j.version,installPreReleaseVersion:j.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:j.isApplicationScoped,context:{[w.$Wo]:!0,[w.$Xo]:!0}}}),G.set(U.identifier.id.toLowerCase(),j)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),ie.push(j)))}catch(Z){ie.push(j),this.g.error(Z),this.g.info(`${H}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else ie.push(j),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}))}),q.length){const W=se.filter(({identifier:B,isBuiltin:j})=>!j&&q.some(M=>(0,h.$up)(B,M)));await D.Promises.settled(W.map(async B=>{this.g.trace(`${H}: Uninstalling local extension...`,B.identifier.id),await this.a.uninstall(B,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,B.identifier.id),V.push(B.identifier)}))}const he=await this.a.installGalleryExtensions(K);for(const{identifier:W,local:B,error:j,source:M}of he){const z=M;if(B)this.g.info(`${H}: Installed extension.`,W.id,z.version),V.push(W);else{const U=G.get(W.id.toLowerCase());U&&(ie.push(U),this.g.info(`${H}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),j instanceof w.$7o&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):j&&this.g.error(j)}}const ee=[];for(const W of J)V.some(B=>(0,h.$up)(B,W.identifier))||ee.push(W);for(const W of ie)ee.some(B=>(0,h.$up)(B.identifier,W.identifier))||ee.push(W);return ee}h(T,q,Y,J){const X=J.getExtensionState(q,!0)||{},H=Y?J.getKeysForSync({id:q.identifier.id,version:Y}):void 0;H?H.forEach(K=>{X[K]=T[K]}):Object.keys(T).forEach(K=>X[K]=T[K]),J.setExtensionState(q,X,!0)}async j(T,q){return this.b.withProfileScopedStorageService(T,async Y=>{const J=new I.$Tc,X=this.f.createChild(new u.$ui([d.$1p,Y])),H=J.add(X.createInstance(y.$5Jb)),K=J.add(X.createInstance(c.$8v));try{return await q(H,K)}finally{J.dispose()}})}};e.$_$b=P,e.$_$b=P=ve([Q(0,w.$9o),Q(1,a.$IKb),Q(2,w.$6o),Q(3,i.$sMb),Q(4,l.$vi),Q(5,o.$mlb)],P);let R=class extends n.$JLb{constructor(T,q,Y,J,X,H,K,G){super("extensions",J,X,H,Y,K,G),this.p=T,this.q=q}async t(T){return T.syncData?await b(T.syncData,this.p):null}u(T,q){const Y=[],J=[],X=[];for(const H of T){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const K=q.find(G=>(0,h.$up)(G.identifier,H.identifier));K?(Y.push(K),H.disabled&&X.push(H.identifier)):H.installed&&(J.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&X.push(H.identifier))}return{installedExtensions:Y,newExtensions:J,disabledExtensions:X,remoteExtensions:T}}};e.$a_b=R,e.$a_b=R=ve([Q(0,w.$9o),Q(1,i.$sMb),Q(2,g.$3k),Q(3,r.$Cl),Q(4,E.$Di),Q(5,m.$3j),Q(6,d.$1p),Q(7,t.$Al)],R)}),define(ae[116],ce([0,1,15,7,3,35,44,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PLb=e.$OLb=e.$NLb=e.$MLb=void 0,e.$LLb=i;const n="globalState.argv.",s=["locale"];function i(k,P){const R=k.storage?Object.keys(k.storage).sort():[],F={};return R.forEach(T=>F[T]=k.storage[T]),k.storage=F,P?(0,O.$Un)(k,{}):JSON.stringify(k)}const o=1;let a=class extends l.$GLb{constructor(P,R,F,T,q,Y,J,X,H,K,G,V,ie,se){super({syncResource:"globalState",profile:P},R,T,X,V,q,Y,H,K,J,G,ie),this.Bb=F,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$olb,authority:"base"}),this.xb=this.vb.with({scheme:d.$olb,authority:"local"}),this.yb=this.vb.with({scheme:d.$olb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$olb,authority:"accepted"}),this.Ab=se.createInstance(b),this.B(T.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(T.onDidFilesChange,he=>he.contains(this.H.argvResource)),L.Event.filter(F.onDidChange,he=>!!(he.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||he.valueChanges.some(({profile:ee,changes:W})=>this.syncResource.profile.id===ee.id&&W.some(B=>B.target===0)))))(()=>this.Q()))}async qb(P,R,F){const T=P.syncData?JSON.parse(P.syncData.content):null;R=R===null&&F?P:R;const q=R&&R.syncData?JSON.parse(R.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);T?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(q),{local:X,remote:H}=(0,m.$KLb)(Y.storage,T?T.storage:null,q?q.storage:null,J,this.O),K={content:null,local:X,remote:H,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:H.all!==null?2:0},G=i(Y,!1);return[{baseResource:this.wb,baseContent:q?i(q,!1):G,localResource:this.xb,localContent:G,localUserData:Y,remoteResource:this.yb,remoteContent:T?i(T,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(P){const R=P.syncData?JSON.parse(P.syncData.content):null;if(R===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),T=await this.Jb(R),{remote:q}=(0,m.$KLb)(F.storage,R.storage,R.storage,T,this.O);return q.all!==null}async rb(P,R){return{...P.previewResult,hasConflicts:!1}}async sb(P,R,F,T){if(this.h.isEqual(R,this.xb))return this.Gb(P);if(this.h.isEqual(R,this.yb))return this.Hb(P);if(this.h.isEqual(R,this.vb))return P.previewResult;throw new Error(`Invalid Resource: ${R.toString()}`)}async Gb(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(P.localUserData.storage),removed:[],updated:[],all:P.localUserData.storage},localChange:0,remoteChange:2}}async Hb(P){if(P.remoteContent!==null){const R=JSON.parse(P.remoteContent),{local:F,remote:T}=(0,m.$KLb)(P.localUserData.storage,R.storage,null,P.storageKeys,this.O);return{content:P.remoteContent,local:F,remote:T,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(P,R,F,T){const{localUserData:q}=F[0][0],{local:Y,remote:J,localChange:X,remoteChange:H}=F[0][1];if(X===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),X!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:J.all});P=await this.mb(K,T?null:P.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}R?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(P){if(this.h.isEqual(this.yb,P)||this.h.isEqual(this.wb,P)||this.h.isEqual(this.xb,P)||this.h.isEqual(this.zb,P)){const R=await this.db(P);return R&&i(JSON.parse(R),!0)}return null}async hasLocalData(){try{const{storage:P}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(P).length>1||P[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(P){const R=await this.Bb.readStorageData(this.syncResource.profile),F=[],T=[];for(const[J,X]of R)X.target===0?F.push(J):X.target===1&&T.push(J);const q=[...F,...T],Y=P?.storage?Object.keys(P.storage).filter(J=>!J.startsWith(n)&&!q.includes(J)&&R.get(J)!==void 0):[];if(!I.$o){const J=[...d.$6kb.map(X=>(0,d.$glb)(X)),d.$flb];Y.push(...J),T.push(...J)}return{user:F,machine:T,unregistered:Y}}};e.$MLb=a,e.$MLb=a=ve([Q(2,t.$IKb),Q(3,y.$3k),Q(4,d.$0kb),Q(5,d.$$kb),Q(6,d.$mlb),Q(7,E.$Di),Q(8,d.$hlb),Q(9,p.$2l),Q(10,f.$3i),Q(11,c.$1p),Q(12,g.$Al),Q(13,r.$vi)],a);let b=class{constructor(P,R,F,T){this.a=P,this.b=R,this.c=F,this.d=T}async getLocalGlobalState(P){const R={};if(P.isDefault){const T=await this.f(),q=(0,A.$Jn)(T);for(const Y of s)q[Y]!==void 0&&(R[`${n}${Y}`]={version:1,value:q[Y]})}const F=await this.c.readStorageData(P);for(const[T,q]of F)q.value&&q.target===0&&(R[T]={version:1,value:q.value});return{storage:R}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const P=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),P.value.toString()}catch(P){this.d.debug((0,N.$0)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:R,updated:F},T){const q=(0,l.$FLb)("globalState",T),Y={},J=new Map,X=await this.c.readStorageData(T),H=(K,G)=>{for(const V of K){if(V.startsWith(n)){Y[V.substring(n.length)]=G?G[V].value:void 0;continue}if(G){const ie=G[V];ie.value!==X.get(V)?.value&&J.set(V,ie.value)}else X.get(V)!==void 0&&J.set(V,void 0)}};if(H(Object.keys(P),P),H(Object.keys(F),F),H(R),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const K=await this.f();let G=K;for(const V of Object.keys(Y))G=(0,u.edit)(G,[V],Y[V],{});K!==G&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$Fe.fromString(G)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}J.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(T,J,0),this.d.info(`${q}: Updated global state`,[...J.keys()]))}};e.$NLb=b,e.$NLb=b=ve([Q(0,y.$3k),Q(1,E.$Di),Q(2,t.$IKb),Q(3,d.$mlb)],b);let S=class extends l.$JLb{constructor(P,R,F,T,q,Y){super("globalState",F,T,q,R,P,Y)}async o(P){const R=P.syncData?JSON.parse(P.syncData.content):null;if(!R){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},T={};for(const q of Object.keys(R.storage))q.startsWith(n)?F[q.substring(n.length)]=R.storage[q].value:this.l.get(q,0)===void 0&&(T[q]=R.storage[q].value);if(Object.keys(F).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(F))q=(0,u.edit)(q,[Y],F[Y],{});await this.k.writeFile(this.h.argvResource,D.$Fe.fromString(q))}if(Object.keys(T).length){const q=[];for(const Y of Object.keys(T))q.push({key:Y,value:T[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$OLb=S,e.$OLb=S=ve([Q(0,c.$1p),Q(1,y.$3k),Q(2,$.$Cl),Q(3,E.$Di),Q(4,d.$mlb),Q(5,g.$Al)],S);let v=class{constructor(P,R,F,T,q){this.a=P,this.b=R,this.c=F,this.d=T,this.f=q}getSyncStoreType(P){return this.h(P)?.storage[d.$flb]?.value}async sync(P){const R=(0,d.$blb)((0,C.$Sg)());try{return await this.g(P,R)}catch(F){if(F instanceof d.$clb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(P,R)}throw F}}async g(P,R){const F=await this.a.readResource("globalState",null,void 0,R),T=this.h(F)||{storage:{}};T.storage[d.$flb]={value:P,version:o};const q=await(0,h.$7p)(this.c,this.d,this.b),Y={version:o,machineId:q,content:i(T,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),F.ref,void 0,R)}h({content:P}){if(!P)return null;const R=JSON.parse(P);if((0,l.$ELb)(R))return R?JSON.parse(R.content):null;throw new Error("Invalid remote data")}};e.$PLb=v,e.$PLb=v=ve([Q(1,c.$1p),Q(2,E.$Di),Q(3,y.$3k),Q(4,w.$3j)],v)}),define(ae[117],ce([0,1,17,15,3,35,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=e.$d_b=void 0,e.$c_b=m;function m(t,r,n){try{const s=JSON.parse(t);if(!r)return(0,I.$dg)(s.all)?null:s.all;switch(O.OS){case 2:return(0,I.$dg)(s.mac)?null:s.mac;case 3:return(0,I.$dg)(s.linux)?null:s.linux;case 1:return(0,I.$dg)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let d=class extends g.$ILb{constructor(r,n,s,i,o,a,b,S,v,k,P,R,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},n,S,v,k,s,i,b,R,o,P,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$olb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$olb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$olb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$olb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(r,n,s,i){const o=r.syncData?m(r.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?r:n;const a=n?this.Ob(n):null,b=await this.vb(),S=await this.Cb();let v=null,k=!1,P=!1,R=!1;if(o){let q=b?b.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$clb((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,l.$b_b)(q,o,a,S,this.zb);Y.hasChanges&&(v=Y.mergeContent,R=Y.hasConflicts,k=R||Y.mergeContent!==q,P=R||Y.mergeContent!==o)}}else b&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=b.value.toString(),P=!0);const F={content:R?a:v,localChange:k?b?2:1:0,remoteChange:P?2:0,hasConflicts:R},T=b?b.value.toString():null;return[{fileContent:b,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:T,localChange:F.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(r){const n=this.Ob(r);if(n===null)return!0;const s=await this.vb(),i=s?s.value.toString():"",o=await this.Cb(),a=await(0,l.$b_b)(i||"[]",n,n,o,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(r,n){return r.previewResult}async sb(r,n,s,i){if(this.h.isEqual(n,this.Gb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(r,n,s,i){const{fileContent:o}=s[0][0];let{content:a,localChange:b,remoteChange:S}=s[0][1];if(b===0&&S===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$clb((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(b!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(a||"[]",o,i),this.O.info(`${this.D}: Updated local keybindings`)),S!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const v=this.Pb(a||"[]",r.syncData?.content);r=await this.mb(v,i?null:r.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(r,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.vb();if(r){const n=(0,A.$Jn)(r.value.toString());if((0,D.$Lb)(n))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Hb,r)||this.h.isEqual(this.Fb,r)||this.h.isEqual(this.Gb,r)||this.h.isEqual(this.Ib,r)?this.db(r):null}Ob(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Qb()?null:m(r.syncData.content,this.Qb(),this.O)}Pb(r,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete s.all:s.all=r,O.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(u.$3kb)}};e.$d_b=d,e.$d_b=d=ve([Q(2,u.$0kb),Q(3,u.$$kb),Q(4,u.$mlb),Q(5,f.$3i),Q(6,u.$hlb),Q(7,y.$3k),Q(8,E.$Di),Q(9,w.$1p),Q(10,u.$llb),Q(11,h.$2l),Q(12,c.$Al)],d);let $=class extends g.$JLb{constructor(r,n,s,i,o,a){super("keybindings",n,s,i,r,o,a)}async o(r){const n=r.syncData?this.p(r.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Fe.fromString(n)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Jn)(r.value.toString());return!(0,D.$Lb)(n)}catch(r){return r.fileOperationResult===1}}p(r){try{return m(r,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$e_b=$,e.$e_b=$=ve([Q(0,y.$3k),Q(1,p.$Cl),Q(2,E.$Di),Q(3,u.$mlb),Q(4,w.$1p),Q(5,c.$Al)],$)}),define(ae[118],ce([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=e.$g_b=void 0,e.$f_b=u;function l($){return $&&$.settings&&typeof $.settings=="string"&&Object.keys($).length===1}function u($){const t=JSON.parse($);return l(t)?t:{settings:$}}let m=class extends c.$ILb{constructor(t,r,n,s,i,o,a,b,S,v,k,P,R,F){super(t.settingsResource,{syncResource:"settings",profile:t},r,n,s,i,o,a,k,P,b,S,v,F),this.Eb=R,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:g.$olb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$olb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$olb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$olb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),n=await this.X(t,r),s=this.Lb(n),i=new O.$yo(g.$2kb,this.O);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(g.$2kb)||{}}async qb(t,r,n){const s=await this.vb(),i=await this.Cb(),o=this.Lb(t);r=r===null&&n?t:r;const a=r?this.Lb(r):null,b=await this.Pb();let S=null,v=!1,k=!1,P=!1;if(o){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$pKb)(q,o.settings,a?a.settings:null,b,[],i);S=Y.localContent||Y.remoteContent,v=Y.localContent!==null,k=Y.remoteContent!==null,P=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=s.value.toString().trim()||"{}",this.Qb(S),k=!0);const R=s?s.value.toString():null,F=a?.settings??null,T={content:P?F:S,localChange:v?2:0,remoteChange:k?2:0,hasConflicts:P};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:R,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async ub(t){const r=this.Lb(t);if(r===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",i=await this.Pb(),o=await this.Cb();return(0,p.$pKb)(s||"{}",r.settings,r.settings,i,[],o).remoteContent!==null}async rb(t,r){const n=await this.Cb(),s=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,p.$oKb)(t.previewResult.content,"{}",s,n):null}}async sb(t,r,n,s){const i=await this.Cb(),o=await this.Pb();if(this.h.isEqual(r,this.localResource))return{content:t.fileContent?(0,p.$oKb)(t.fileContent.value.toString(),"{}",o,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,p.$oKb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,p.$oKb)(n,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(t,r,n,s){const{fileContent:i}=n[0][0];let{content:o,localChange:a,remoteChange:b}=n[0][1];if(a===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(o,i,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),b!==0){const S=await this.Cb(),v=this.Lb(t),k=await this.Pb(o);o=(0,p.$oKb)(o,v?v.settings:"{}",k,S),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),s?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,p.$qKb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let r=await super.db(t);if(r){const n=await this.Cb(),s=await this.Pb();r=(0,p.$oKb)(r,"{}",s,n)}return r}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return u(t)}catch(r){this.O.error(r)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const r=await this.Ob;return(0,p.$mKb)(r,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new g.$clb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$g_b=m,e.$g_b=m=ve([Q(2,f.$3k),Q(3,I.$Di),Q(4,E.$1p),Q(5,g.$0kb),Q(6,g.$$kb),Q(7,g.$mlb),Q(8,g.$llb),Q(9,A.$3i),Q(10,g.$hlb),Q(11,y.$2l),Q(12,C.$9o),Q(13,w.$Al)],m);let d=class extends c.$JLb{constructor(t,r,n,s,i,o){super("settings",r,n,s,t,i,o)}async o(t){const r=t.syncData?this.p(t.syncData.content):null;if(!r){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$Fe.fromString(r.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$qKb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(r){this.j.error(r)}return null}};e.$h_b=d,e.$h_b=d=ve([Q(0,f.$3k),Q(1,h.$Cl),Q(2,I.$Di),Q(3,g.$mlb),Q(4,E.$1p),Q(5,w.$Al)],d)}),define(ae[119],ce([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=e.$l_b=void 0,e.$k_b=p;function p(u){return JSON.parse(u.content)}let g=class extends w.$GLb{constructor(m,d,$,t,r,n,s,i,o,a,b,S){super({syncResource:"snippets",profile:m},d,t,$,r,n,s,a,b,i,o,S),this.pb=1,this.vb=m.snippetsHome,this.B(this.G.watch($.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,v=>v.affects(this.vb))(()=>this.Q()))}async qb(m,d,$){const t=await this.Hb(),r=this.Gb(t),n=m.syncData?this.Fb(m.syncData):null;d=d===null&&$?m:d;const s=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.$i_b)(r,n,s);return this.Bb(i,t,n||{},s||{})}async ub(m){const d=m.syncData?this.Fb(m.syncData):null;if(d===null)return!0;const $=await this.Hb(),t=this.Gb($),r=(0,h.$i_b)(t,d,d);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async rb(m,d){return m.previewResult}async sb(m,d,$,t){if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$olb,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$olb,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return $===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:$,localChange:$===null?m.fileContent!==null?3:0:2,remoteChange:$===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(m,d,$,t){const r=$.map(([n,s])=>({...n,acceptResult:s}));r.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.Cb(r),await this.Db(r,t)),r.some(({remoteChange:n})=>n!==0)&&(m=await this.Eb(r,m,t)),d?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.G.del(n)}catch{}}Bb(m,d,$,t){const r=new Map;for(const n of Object.keys(m.local.added)){const s={content:m.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}for(const n of Object.keys(m.local.updated)){const s={content:m.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}for(const n of m.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}for(const n of Object.keys(m.remote.added)){const s={content:m.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}for(const n of Object.keys(m.remote.updated)){const s={content:m.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}for(const n of m.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}for(const n of m.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:$[n]?2:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}for(const n of Object.keys(d))if(!r.has(n)){const s={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$olb,authority:"accepted"})})}return[...r.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:c.$olb,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$olb,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$olb,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$olb,authority:"accepted"}))?this.db(m):null}async hasLocalData(){try{const m=await this.Hb();if(Object.keys(m).length)return!0}catch{}return!1}async Cb(m){const d={};for(const $ of m)$.fileContent&&(d[this.h.basename($.localResource)]=$.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(m,d){for(const{fileContent:$,acceptResult:t,localResource:r,remoteResource:n,localChange:s}of m)if(s!==0){const i=n?this.h.basename(n):this.h.basename(r),o=this.h.joinPath(this.vb,i);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,D.$Fe.fromString(t.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,D.$Fe.fromString(t.content),d?void 0:$),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(m,d,$){const t=d.syncData?this.Fb(d.syncData):{},r=(0,L.$3n)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:o}of m)if(o!==0){const a=s?this.h.basename(s):this.h.basename(i);o===3?delete r[a]:r[a]=n.content}return(0,h.$j_b)(t,r)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(r),$?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(m){return p(m)}Gb(m){const d={};for(const $ of Object.keys(m))d[$]=m[$].value.toString();return d}async Hb(){const m={};let d;try{d=await this.G.resolve(this.vb)}catch($){if($ instanceof I.$ll&&$.fileOperationResult===1)return m;throw $}for(const $ of d.children||[]){const t=$.resource,r=this.h.extname(t);if(r===".json"||r===".code-snippets"){const n=this.h.relativePath(this.vb,t),s=await this.G.readFile(t);m[n]=s}}return m}};e.$l_b=g,e.$l_b=g=ve([Q(2,O.$Di),Q(3,I.$3k),Q(4,C.$1p),Q(5,c.$0kb),Q(6,c.$$kb),Q(7,c.$mlb),Q(8,A.$3i),Q(9,c.$hlb),Q(10,f.$2l),Q(11,E.$Al)],g);let l=class extends w.$JLb{constructor(m,d,$,t,r,n){super("snippets",d,$,t,m,r,n)}async o(m){const d=m.syncData?JSON.parse(m.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(d)){const r=d[t];if(r){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,D.$Fe.fromString(r)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(m)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};e.$m_b=l,e.$m_b=l=ve([Q(0,I.$3k),Q(1,y.$Cl),Q(2,O.$Di),Q(3,c.$mlb),Q(4,C.$1p),Q(5,E.$Al)],l)}),define(ae[120],ce([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=e.$o_b=void 0,e.$n_b=w;function w(g,l){try{return JSON.parse(g).tasks??null}catch(u){return l.error(u),null}}let h=class extends E.$HLb{constructor(l,u,m,d,$,t,r,n,s,i,o,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,i,m,d,r,o,$,t,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:y.$olb,authority:"base"}),this.Cb=this.Ab.with({scheme:y.$olb,authority:"local"}),this.Db=this.Ab.with({scheme:y.$olb,authority:"remote"}),this.Eb=this.Ab.with({scheme:y.$olb,authority:"accepted"})}async qb(l,u,m,d){const $=l.syncData?w(l.syncData.content,this.O):null;u=u===null&&m?l:u;const t=u?.syncData?w(u.syncData.content,this.O):null,r=await this.vb();let n=null,s=!1,i=!1,o=!1;if(l.syncData){const S=r?r.value.toString():null;if(!t||t!==S||t!==$){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const v=p(S,$,t);n=v.content,o=v.hasConflicts,s=v.hasLocalChanged,i=v.hasRemoteChanged}}else r&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=r.value.toString(),i=!0);const a={content:o?t:n,localChange:s?r?2:1:0,remoteChange:i?2:0,hasConflicts:o},b=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:b,localChange:a.localChange,remoteResource:this.Db,remoteContent:$,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?w(l.syncData.content,this.O):null;if(u===null)return!0;const m=await this.vb(),d=m?m.value.toString():null,$=p(d,u,u);return $.hasLocalChanged||$.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,m,d){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return m===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,m,d){const{fileContent:$}=m[0][0],{content:t,localChange:r,remoteChange:n}=m[0][1];if(r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),r!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),$&&await this.nb(JSON.stringify(this.Kb($.value.toString()))),t?await this.wb(t,$,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(t));l=await this.mb(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$o_b=h,e.$o_b=h=ve([Q(2,y.$0kb),Q(3,y.$$kb),Q(4,y.$mlb),Q(5,N.$3i),Q(6,y.$hlb),Q(7,A.$3k),Q(8,L.$Di),Q(9,O.$1p),Q(10,I.$2l),Q(11,C.$Al)],h);let c=class extends E.$JLb{constructor(l,u,m,d,$,t){super("tasks",u,m,d,l,$,t),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?w(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$Fe.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$p_b=c,e.$p_b=c=ve([Q(0,A.$3k),Q(1,f.$Cl),Q(2,L.$Di),Q(3,y.$mlb),Q(4,O.$1p),Q(5,C.$Al)],c);function p(g,l,u){if(g===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(g===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=u!==g,d=u!==l;return!m&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!d?{content:g,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!m?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:g,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[121],ce([0,1,44,21,16,12,19,22,28,18,39,244,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0,e.$0ac=c,e.$$ac=p;let h=class extends E.$GLb{constructor(l,u,m,d,$,t,r,n,s,i,o,a,b){super({syncResource:"profiles",profile:l},u,d,$,t,r,n,o,a,s,i,b),this.vb=m,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$olb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$olb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$olb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$olb,authority:"accepted"}),this.B(m.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),m=await this.X(l,u);return m?.syncData?p(m.syncData):null}async qb(l,u,m){if(!this.vb.isEnabled())throw new w.$clb("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?p(l.syncData):null,$=u?.syncData?p(u.syncData):null,t=this.Db(),{local:r,remote:n}=(0,y.$8ac)(t,d,$,[]),s={local:r,remote:n,content:$?this.Eb($):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:n!==null?2:0},i=c(t,!1);return[{baseResource:this.baseResource,baseContent:$?this.Eb($):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,m=this.Db(),{remote:d}=(0,y.$8ac)(m,u,u,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,m,d){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),m=(0,y.$8ac)(u,null,null,[]),{local:d,remote:$}=m;return{content:l.localContent,local:d,remote:$,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:$!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,m=[],d=[];for(const $ of this.Db()){const t=u?.find(r=>r.id===$.id);t&&(m.push({id:$.id,name:$.name,collection:t.collection}),d.push($))}if(u!==null){const $=(0,y.$8ac)(d,u,m,[]),{local:t,remote:r}=$;return{content:l.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,m,d){const{local:$,remote:t,localChange:r,remoteChange:n}=m[0][1];r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=m[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new w.$clb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0&&(await this.nb(c(this.Db(),!1)),await Promise.all($.removed.map(async i=>{this.O.trace(`${this.D}: Removing '${i.name}' profile...`),await this.vb.removeProfile(i),this.O.info(`${this.D}: Removed profile '${i.name}'.`)})),await Promise.all($.added.map(async i=>{this.O.trace(`${this.D}: Creating '${i.name}' profile...`),await this.vb.createProfile(i.id,i.name,{shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${i.name}'.`)})),await Promise.all($.updated.map(async i=>{const o=this.vb.profiles.find(a=>a.id===i.id);o?(this.O.trace(`${this.D}: Updating '${i.name}' profile...`),await this.vb.updateProfile(o,{name:i.name,shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${i.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${i.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],o=s.length+(t?.added.length??0)<=20;if(o)for(const a of t?.added||[]){const b=await this.J.createCollection(this.F);i.push(b),s.push({id:a.id,name:a.name,collection:b,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:b})=>a.id===b),1);for(const a of t?.updated||[]){const b=s.find(({id:S})=>a.id===S);b&&s.splice(s.indexOf(b),1,{...b,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const b of i)await this.J.deleteCollection(b,this.F)}throw a}for(const a of t?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,D.$Un)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,m)=>u.name.localeCompare(m.name)))}};e.$9ac=h,e.$9ac=h=ve([Q(2,f.$Cl),Q(3,A.$3k),Q(4,L.$Di),Q(5,O.$1p),Q(6,w.$0kb),Q(7,w.$$kb),Q(8,w.$mlb),Q(9,N.$3i),Q(10,w.$hlb),Q(11,I.$2l),Q(12,C.$Al)],h);function c(g,l){const u=[...g].sort((m,d)=>m.name.localeCompare(d.name)).map(m=>({id:m.id,name:m.name}));return l?(0,D.$Un)(u,{}):JSON.stringify(u)}function p(g){return JSON.parse(g.content)}}),define(ae[261],ce([0,1,3,2,5,16,19,22,25]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;const f="sync.enable";let E=class extends N.$Uc{constructor(w,h,c,p){super(),this.c=w,this.f=h,this.g=c,this.h=p,this.a=new D.$de,this.onDidChangeEnablement=this.a.event,this.b=new D.$de,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new N.$Tc))(g=>this.m(g)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(f,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(f,{enabled:w}),this.c.store(f,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,C.$glb)(w),-1,!0)}setResourceEnablement(w,h){if(this.isResourceEnabled(w)!==h){const c=(0,C.$glb)(w);this.j(c,h)}}getResourceSyncStateVersion(w){}j(w,h){this.c.store(w,h,-1,L.$o?0:1)}m(w){if(f===w.key){this.a.fire(this.isEnabled());return}const h=C.$6kb.filter(c=>(0,C.$glb)(c)===w.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$Vac=E,e.$Vac=E=ve([Q(0,O.$1p),Q(1,I.$2l),Q(2,A.$Di),Q(3,C.$9kb)],E)}),define(ae[262],ce([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=void 0;let w=class extends A.$Uc{constructor(c,p,g,l,u){super(),this.a=c,this.b=p,this.c=g,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const g of y.$6kb)try{await this.m(this.j(g,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,f.$hl)(p)!==1&&this.f.error(p);return}if(c.children){for(const p of c.children)if(p.isDirectory&&!this.g.profiles.some(g=>g.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(g){this.f.error(g)}}}async getAllResourceRefs(c,p,g){const l=this.j(c,p,g);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(u){if((0,f.$hl)(u)!==1)throw u}return[]}async resolveResourceContent(c,p,g,l){const u=this.j(c,g,l),m=(0,O.$0g)(u,p);try{return(await this.b.readFile(m)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource(c,p,g,l,u){const m=this.j(c,l,u),d=(0,O.$0g)(m,`${(0,L.$4m)(g).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,N.$Fe.fromString(p))}catch($){this.f.error($)}}j(c,p,g=this.a.userDataSyncHome){return(0,O.$0g)(g,...p?[p,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const p=await this.b.resolve(c);if(p.children){const g=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=g.filter(d=>Date.now()-this.n(d)>l);const m=g.length-u.length;m<10&&(u=u.slice(10-m)),await D.Promises.settled(u.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(p){this.f.error(p)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$7ac=w,e.$7ac=w=ve([Q(0,C.$Di),Q(1,f.$3k),Q(2,I.$3i),Q(3,y.$mlb),Q(4,E.$Cl)],w)}),define(ae[83],ce([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykb=e.$Wkb=void 0,e.$Xkb=$,e.$Wkb=(0,f.$wi)("IUserDataSyncMachinesService");const p="sync.currentMachineName",g="Safari",l="Chrome",u="Edge",m="Firefox",d="Android";function $(n){switch(n){case g:case l:case u:case m:case d:case(0,L.$h)(0):return!0}return!1}function t(){return L.$G?g:L.$E?l:L.$H?u:L.$F?m:L.$I?d:(0,L.$h)(L.$o?0:L.$u)}let r=class extends N.$Uc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(s,i,o,a,b,S){super(),this.h=o,this.j=a,this.m=b,this.n=S,this.c=this.B(new D.$de),this.onDidChange=this.c.event,this.g=null,this.f=(0,y.$7p)(s,i,o)}async getMachines(s){const i=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(s){const i=await this.f,o=await this.s(s);o.machines.some(({id:a})=>a===i)||(o.machines.push({id:i,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(s){const i=await this.f,o=await this.s(s),a=o.machines.filter(({id:b})=>b!==i);a.length!==o.machines.length&&(o.machines=a,await this.t(o))}async renameMachine(s,i,o){const a=await this.s(o),b=a.machines.find(({id:S})=>S===s);if(b){b.name=i,await this.t(a);const S=await this.f;s===S&&this.h.store(p,i,-1,1)}}async setEnablements(s){const i=await this.s();for(const[o,a]of s){const b=i.machines.find(S=>S.id===o);b&&(b.disabled=a?void 0:!0)}await this.t(i)}r(s){const i=this.h.get(p,-1);if(i)return i;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$_e)(o)}\\s#(\\d+)`);let b=0;for(const S of s){const v=a.exec(S.name),k=v?parseInt(v[1]):0;b=k>b?k:b}return`${o} #${b+1}`}async s(s){this.g=await this.u(s);const i=this.w(this.g);if(i.version!==c.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return i}async t(s){const i=JSON.stringify(s),o=await this.j.writeResource(c.b,i,this.g?.ref||null);this.g={ref:o,content:i},this.c.fire()}async u(s){if(this.g){const i=s&&s.latest?s.latest[c.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.m.error(i)}return{version:c.a,machines:[]}}};e.$Ykb=r,e.$Ykb=r=c=ve([Q(0,I.$Di),Q(1,C.$3k),Q(2,w.$1p),Q(3,h.$0kb),Q(4,h.$mlb),Q(5,E.$jk)],r)}),define(ae[263],ce([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=void 0;const u="sync.disableMachineEventually",m="sync.sessionId",d="sync.storeUrl",$="sync.productQuality";let t=class extends I.$Uc{get n(){const s=this.H.get(d,-1);return s?E.URI.parse(s):void 0}set n(s){s?this.H.store(d,s.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get($,-1)}set s(s){s?this.H.store($,s,-1,1):this.H.remove($,-1)}constructor(s,i,o,a,b,S,v,k,P,R){super(),this.u=i,this.w=o,this.y=a,this.z=b,this.C=S,this.D=v,this.F=k,this.G=P,this.H=R,this.a=this.B(new I.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$de),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$uh(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,f.$3g)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(v.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(b.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:i}=this.L();s?this.a.value===void 0&&(this.a.value=new r(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$4m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,i,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(m,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),i)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const i=p.$clb.toUserDataSyncError(s);i instanceof p.$elb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?C.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(u,!0,-1,1),await(0,D.$xh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(s,i,o){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$abc=t,e.$abc=t=ve([Q(0,w.$jk),Q(1,p.$9kb),Q(2,p.$0kb),Q(3,p.$hlb),Q(4,p.$ilb),Q(5,p.$mlb),Q(6,g.$7Jb),Q(7,c.$2l),Q(8,l.$Wkb),Q(9,h.$1p)],t);class r extends I.$Uc{static{this.a="Interval"}constructor(s,i,o,a,b,S,v,k,P){super(),this.m=s,this.n=i,this.r=o,this.s=a,this.u=b,this.w=S,this.y=v,this.z=k,this.C=P,this.b=this.B(new I.$Vc),this.c=this.B(new O.$de),this.onDidStartSync=this.c.event,this.f=this.B(new O.$de),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}D(){this.b.value=(0,D.$yh)(()=>{this.sync(r.a,!1),this.b.value=void 0},this.n)}sync(s,i){const o=(0,D.$jh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(b){if((0,A.$4)(b))return}return this.H(s,i,a)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,f.$3g)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!s&&(!(0,f.$3g)(i.defaultUrl,s.defaultUrl)||!(0,f.$3g)(i.insidersUrl,s.insidersUrl)||!(0,f.$3g)(i.stableUrl,s.stableUrl))}async H(s,i,o){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(i,o)}catch(b){if(this.y.error(b),a=b,p.$clb.toUserDataSyncError(b).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,o),a=void 0}catch(S){this.y.error(S),a=S}}this.f.fire(a)}async I(s,i){if(this.h=await this.u.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$elb((0,y.localize)(0,null),"DefaultServiceChanged"):new p.$elb((0,y.localize)(1,null),"ServiceChanged"):new p.$elb((0,y.localize)(2,null),"TurnedOff");const o=this.C.get(m,-1);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new p.$elb((0,y.localize)(3,null),"DefaultServiceChanged"):new p.$elb((0,y.localize)(4,null),"ServiceChanged"):new p.$elb((0,y.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const b=a.find(v=>v.isCurrent);if(b?.disabled)throw new p.$elb((0,y.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.g===null)try{this.g=await this.s.manifest(null)}catch(v){throw new p.$elb((0,L.$hj)(v),v instanceof p.$clb?v.code:"Unknown")}this.g&&this.g.session!==o&&this.C.store(m,this.g.session,-1,1),!i.isCancellationRequested&&(b||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(ae[264],ce([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,44,27]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;let n=class{static{r=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,o,a,b,S,v,k,P,R,F){this.e=i,this.f=o,this.g=a,this.h=S,this.i=v,this.j=k,this.k=P,this.l=R,this.n=F,this.d=b.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const o=this.L(i.content,"profiles");return(0,d.$$ac)(o)}return[]}async getLocalSyncedProfiles(i){const o=await this.f.getAllResourceRefs("profiles",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("profiles",o[0].ref,void 0,i);if(a){const b=this.L(a,"profiles");return(0,d.$$ac)(b)}}return[]}async getLocalSyncedMachines(i){const o=await this.f.getAllResourceRefs("machines",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("machines",o[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(S=>({...S,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,o){return(await this.e.getAllResourceRefs(i,o?.collection)).map(({created:b,ref:S})=>({created:b,uri:this.J({remote:!0,syncResource:i,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:S,node:void 0})}))}async getLocalSyncResourceHandles(i,o,a){return(await this.f.getAllResourceRefs(i,o?.collection,a)).map(({created:S,ref:v})=>({created:S,uri:this.J({remote:!1,syncResource:i,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:v,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const o=this.K(i),a=o?this.k.profiles.find(b=>b.id===o.profile):void 0;return o&&a?{profile:a,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:i}){const o=this.K(i);if(!o)return[];const a=this.k.profiles.find(b=>b.id===o.profile);switch(o.syncResource){case"settings":return this.s(i,a);case"keybindings":return this.u(i,a);case"tasks":return this.w(i,a);case"snippets":return this.y(i,a);case"globalState":return this.D(i,a);case"extensions":return this.A(i,a);case"profiles":return this.G(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const o=this.K(i);if(o){if(o.remote){if(o.ref){const{content:a}=await this.M(o.syncResource,o.ref,o.collection);if(a)return this.L(a,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const a=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(a)return this.L(a,o.syncResource)?.machineId}return}return(0,O.$7p)(this.h,this.j,this.i)}}async resolveContent(i){const o=this.K(i);if(!o||o.node===r.a)return null;if(o.ref){const a=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&a?this.q(o.syncResource,a,o.node):a}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(i,o,a,b,S){if(i){const{content:v}=await this.M(o,b,a);return v}return this.f.resolveResourceContent(o,b,a,S)}q(i,o,a){const b=this.L(o,i);switch(i){case"settings":return this.t(b,a);case"keybindings":return this.v(b,a);case"tasks":return this.x(b,a);case"snippets":return this.z(b,a);case"globalState":return this.E(b,a);case"extensions":return this.B(b,a);case"profiles":return this.H(b,a);case"workspaceState":return null}}async r(i,o){const a=this.k.profiles.find(b=>b.id===o);if(!a)return null;switch(i){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,o){const a=this.d.joinPath(i,"settings.json"),b=o?o.settingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}t(i,o){switch(o){case"settings.json":return(0,h.$f_b)(i.content).settings}return null}u(i,o){const a=this.d.joinPath(i,"keybindings.json"),b=o?o.keybindingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}v(i,o){switch(o){case"keybindings.json":return(0,c.$c_b)(i.content,!!this.l.getValue(f.$3kb),this.g)}return null}w(i,o){const a=this.d.joinPath(i,"tasks.json"),b=o?o.tasksResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}x(i,o){switch(o){case"tasks.json":return(0,g.$n_b)(i.content,this.g)}return null}async y(i,o){const a=await this.resolveContent(i);if(a){const b=this.L(a,"snippets");if(b){const S=(0,w.$k_b)(b),v=[];for(const k of Object.keys(S)){const P=this.d.joinPath(i,k),R=o?this.d.joinPath(o.snippetsHome,k):this.d.joinPath(i,r.a);v.push({resource:P,comparableResource:R})}return v}}return[]}z(i,o){return(0,w.$k_b)(i)[o]||null}A(i,o){const a=this.d.joinPath(i,"extensions.json"),b=o?this.J({remote:!1,syncResource:"extensions",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}B(i,o){switch(o){case"extensions.json":return(0,l.$0$b)((0,l.$9$b)(i),!0)}return null}async C(i){const{localExtensions:o}=await this.n.createInstance(l.$_$b).getLocalExtensions(i);return(0,l.$0$b)(o,!0)}D(i,o){const a=this.d.joinPath(i,"globalState.json"),b=o?this.J({remote:!1,syncResource:"globalState",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}E(i,o){switch(o){case"globalState.json":return(0,u.$LLb)(JSON.parse(i.content),!0)}return null}async F(i){const o=await this.n.createInstance(u.$NLb).getLocalGlobalState(i);return(0,u.$LLb)(o,!0)}G(i,o){const a=this.d.joinPath(i,"profiles.json"),b=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:b}]}H(i,o){switch(o){case"profiles.json":return(0,$.$Un)(JSON.parse(i.content),{})}return null}async I(i){return(0,d.$0ac)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(i){const o=i.remote?r.b:r.c,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.$df)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.d.joinPath(D.URI.from({scheme:f.$olb,authority:o,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}K(i){if(i.scheme!==f.$olb)return;const o=[];for(;i.path!=="/";)o.unshift(this.d.basename(i)),i=this.d.dirname(i);if(o.length<2)return;const a=i.authority===r.b;let b,S;const v=[];let k,P,R,F,T;for(;o.length;){const q=o.shift();q.startsWith("scheme:")?b=q.substring(7):q.startsWith("authority:")?S=q.substring(10):q.startsWith("syncResource:")?k=q.substring(13):q.startsWith("profile:")?P=q.substring(8):q.startsWith("collection:")?R=q.substring(11):q.startsWith("ref:")?F=q.substring(4):k?T=q:v.push(q)}return{remote:a,syncResource:k,profile:P,collection:R,ref:F,node:T,location:b&&S!==void 0?this.d.joinPath(D.URI.from({scheme:b,authority:S,query:i.query,fragment:i.fragment,path:"/"}),...v):void 0}}L(i,o){try{const a=JSON.parse(i);if((0,y.$ELb)(a))return a}catch(a){this.g.error(a)}throw new f.$clb((0,N.localize)(0,null),"IncompatibleRemoteContent",o)}async M(i,o,a){const b=await this.e.resolveResourceContent(i,o,a);return{ref:o,content:b}}};e.$Ibc=n,e.$Ibc=n=r=ve([Q(0,f.$0kb),Q(1,f.$$kb),Q(2,f.$mlb),Q(3,C.$Al),Q(4,L.$Di),Q(5,I.$1p),Q(6,A.$3k),Q(7,E.$Cl),Q(8,p.$3i),Q(9,m.$vi)],n)}),define(ae[265],ce([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;const i="sync.lastSyncTime";let o=class extends I.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(k,P,R,F,T,q,Y,J,X,H,K){super(),this.C=k,this.D=P,this.F=R,this.G=F,this.H=T,this.I=q,this.J=Y,this.L=J,this.M=X,this.N=H,this.O=K,this.f="uninitialized",this.g=this.B(new O.$de),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$de),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$de),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$de),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$de),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$de),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$de),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=R.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,I.$Sc)(()=>this.bb()))}async createSyncTask(k,P){this.cb(),this.H.info("Sync started.");const R=new Date().getTime(),F=(0,E.$Sg)();try{const J=(0,s.$blb)(F);P&&(J["Cache-Control"]="no-cache"),k=await this.D.manifest(k,J)}catch(J){const X=s.$clb.toUserDataSyncError(J);throw S(X,F,this.F,this.I),X}const T=!1,q=this;let Y;return{manifest:k,async run(){if(T)throw new Error("Can run a task only once");Y=(0,N.$jh)(J=>q.P(k,!1,F,J)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-R}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$clb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const k=new Date().getTime(),P=(0,E.$Sg)(),R=(0,s.$blb)(P);let F;try{F=await this.D.manifest(null,R)}catch(Y){const J=s.$clb.toUserDataSyncError(Y);throw S(J,P,this.F,this.I),J}await this.resetLocal();const T=this,q=new L.$oe;return{id:P,async merge(){return T.P(F,!0,P,q.token)},async apply(){try{try{await T.R(F,P,q.token)}catch(Y){if(s.$clb.toUserDataSyncError(Y).code==="MethodNotFound")T.H.info("Client is making invalid requests. Cleaning up data..."),await T.cleanUpRemoteData(),T.H.info("Applying manual sync again..."),await T.R(F,P,q.token);else throw Y}}catch(Y){throw T.H.error(Y),Y}T.H.info(`Sync done. Took ${new Date().getTime()-k}ms`),T.$()},async stop(){q.cancel(),await T.U(),await T.resetLocal()}}}async P(k,P,R,F){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const T=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(T,k,P,R,F));const q=T.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(Y,k,P,R,F)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(k,P,R,F,T){for(const q of k){if(T.isCancellationRequested)return;const Y=this.M.profiles.find(X=>X.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const J=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(J,P,R,F,T))}for(const[q,Y]of this.z.entries())this.M.profiles.some(J=>J.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(k,P,R){const F=this.ab();for(const X of F){if(R.isCancellationRequested)return;await X.apply(P,R)}const T=F.find(X=>X.profile.isDefault);if(!T)return;const q=T.enabled.find(X=>X.resource==="profiles");if(!q)return;const J=(await q.getRemoteSyncedProfiles(k?.latest??null)||[]).filter(X=>F.every(H=>H.profile.id!==X.id));J.length&&await this.Q(J,k,!1,P,R)}async S(k,P,R,F,T){return(await k.sync(P,R,F,T)).map(([Y,J])=>({profile:k.profile,syncResource:Y,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(k=>k.stop()))}async resolveContent(k){const P=await this.N.resolveContent(k);if(P)return P;for(const R of this.ab())for(const F of R.enabled){const T=await F.resolveContent(k);if(T)return T}return null}async replace(k){this.cb();const P=this.N.resolveUserDataSyncResource(k);if(!P)return;const R=await this.resolveContent(k.uri);R&&await this.W(P.profile,async F=>{if(P.syncResource===F.resource)return await F.replace(R),!0})}async accept(k,P,R,F){this.cb(),await this.W(k.profile,async T=>{if(k.syncResource===T.resource)return await T.accept(P,R),F&&await T.apply((0,f.$cg)(F)?!1:F.force,(0,s.$blb)((0,E.$Sg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(k){this.H.error(k)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[k]of this.z.values())try{await k.resetLocal()}catch(P){this.H.error(P)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const k=await this.N.getRemoteSyncedProfiles(),P=k.map(q=>q.collection),R=await this.D.getAllCollections(),F=R.filter(q=>!P.includes(q));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const T=k.filter(q=>R.includes(q.collection));if(T.length!==k.length){const q=this.G.createInstance(n.$9ac,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(T,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(k){this.cb();const P=await this.D.getActivityData();await this.C.writeFile(k,P)}async extractActivityData(k,P){const R=(await this.C.readFile(k)).value.toString(),F=JSON.parse(R);if(F.resources)for(const T in F.resources)for(const q of F.resources[T])await this.O.writeResource(T,q.content,new Date(q.created*1e3),void 0,P);if(F.collections)for(const T in F.collections)for(const q in F.collections[T].resources)for(const Y of F.collections[T].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),T,P)}async W(k,P){const R=new I.$Tc;try{const F=this.z.get(k.id);if(F){const X=await this.X(F[0],P,R);return(0,f.$dg)(X)?null:X}if(k.isDefault){const X=R.add(this.G.createInstance(a,k,void 0)),H=await this.X(X,P,R);return(0,f.$dg)(H)?null:H}if(this.M.isEnabled())return null;const T=R.add(this.G.createInstance(n.$9ac,k,void 0)),q=await this.D.manifest(null),J=(await T.getRemoteSyncedProfiles(q?.latest??null)||[]).find(X=>X.id===k.id);if(J){const X=R.add(this.G.createInstance(a,k,J.collection)),H=await this.X(X,P,R);return(0,f.$dg)(H)?null:H}return null}finally{R.dispose()}}async X(k,P,R){const F=[...k.enabled,...k.disabled.reduce((T,q)=>(q!=="workspaceState"&&T.push(R.add(k.createSynchronizer(q))),T),[])];for(const T of F){const q=await P(T);if(!(0,f.$dg)(q))return q}}Y(k){const P=this.f;this.f!==k&&(this.f=k,this.g.fire(k),P==="hasConflicts"&&this.$())}Z(){const k=this.ab().map(P=>P.conflicts).flat();(0,D.$ub)(this.j,k,(P,R)=>P.profile.id===R.profile.id&&P.syncResource===R.syncResource&&(0,D.$ub)(P.conflicts,R.conflicts,(F,T)=>(0,C.$3g)(F.previewResource,T.previewResource)))||(this.j=k,this.m.fire(k))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(k,P){let R=this.z.get(k.id);if(R&&R[0].collection!==P?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),R[1].dispose(),R=void 0,this.z.delete(k.id)),!R){const F=new I.$Tc,T=F.add(this.G.createInstance(a,k,P?.collection));F.add(T.onDidChangeStatus(q=>this.Y(q))),F.add(T.onDidChangeConflicts(q=>this.Z())),F.add(T.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(k.id,R=[T,F])}return R[0]}ab(){const k=[];for(const[P]of this.z.values())k.push(P);return k}bb(){this.z.forEach(([,k])=>k.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$_ac=o,e.$_ac=o=ve([Q(0,h.$3k),Q(1,s.$0kb),Q(2,s.$9kb),Q(3,c.$vi),Q(4,s.$mlb),Q(5,g.$2l),Q(6,p.$1p),Q(7,s.$hlb),Q(8,l.$Cl),Q(9,s.$jlb),Q(10,s.$$kb)],o);let a=class extends I.$Uc{get enabled(){return this.f.sort((k,P)=>k[1]-P[1]).map(([k])=>k)}get disabled(){return s.$6kb.filter(k=>!this.r.isResourceEnabled(k))}get status(){return this.g}get conflicts(){return this.m}constructor(k,P,R,F,T,q,Y,J,X,H){super(),this.profile=k,this.collection=P,this.r=R,this.t=F,this.u=T,this.w=q,this.y=Y,this.z=J,this.C=X,this.D=H,this.f=[],this.g="idle",this.h=this.B(new O.$de),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$de),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$de),this.onDidChangeConflicts=this.n.event,this.B(R.onDidChangeResourceEnablement(([K,G])=>this.F(K,G))),this.B((0,I.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of s.$6kb)R.isResourceEnabled(K)&&this.G(K)}F(k,P){P?this.G(k):this.H(k)}G(k){if(this.f.some(([T])=>T.resource===k))return;if(k==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(k==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||k==="workspaceState")return;if(k!=="profiles"&&this.profile.useDefaultFlags?.[k]){this.z.debug(`Skipping syncing ${k} in ${this.profile.name} because it is already synced by default profile`);return}const P=new I.$Tc,R=P.add(this.createSynchronizer(k));P.add(R.onDidChangeStatus(()=>this.L())),P.add(R.onDidChangeConflicts(()=>this.M())),P.add(R.onDidChangeLocal(()=>this.j.fire(k)));const F=this.N(k);this.f.push([R,F,P])}H(k){const P=this.f.findIndex(([R])=>R.resource===k);if(P!==-1){const[[R,,F]]=this.f.splice(P,1);F.dispose(),this.L(),Promise.allSettled([R.stop(),R.resetLocal()]).then(null,T=>this.z.error(T))}}createSynchronizer(k){switch(k){case"settings":return this.t.createInstance($.$g_b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$d_b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$l_b,this.profile,this.collection);case"tasks":return this.t.createInstance(r.$o_b,this.profile,this.collection);case"globalState":return this.t.createInstance(m.$MLb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$$$b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$9ac,this.profile,this.collection)}}async sync(k,P,R,F){if(F.isCancellationRequested)return[];const T=this.enabled;if(!T.length)return[];try{const q=[],Y=(0,s.$blb)(R),J=(this.collection?k?.collections?.[this.collection]?.latest:k?.latest)??null,X=P?await this.I(J):{};for(const H of T){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(P){const K=await H.preview(J,X,Y);if(K)for(const G of K.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await H.merge(G.previewResource)}else await H.sync(J,Y)}catch(K){const G=s.$clb.toUserDataSyncError(K);if(S(G,R,this.w,this.y),b(K))throw G;this.z.error(K),this.z.error(`${H.resource}: ${(0,A.$hj)(K)}`),q.push([H.resource,G])}}return q}finally{this.L()}}async apply(k,P){const R=(0,s.$blb)(k);for(const F of this.enabled){if(P.isCancellationRequested)return;try{await F.apply(!1,R)}catch(T){const q=s.$clb.toUserDataSyncError(T);if(S(q,k,this.w,this.y),b(T))throw q;this.z.error(T),this.z.error(`${F.resource}: ${(0,A.$hj)(T)}`)}}}async stop(){for(const k of this.enabled)try{k.status!=="idle"&&await k.stop()}catch(P){this.z.error(P)}}async resetLocal(){for(const k of this.enabled)try{await k.resetLocal()}catch(P){this.z.error(`${k.resource}: ${(0,A.$hj)(P)}`),this.z.error(P)}}async I(k){if(!this.profile.isDefault)return{};const P=this.D.getValue(s.$2kb),R=this.enabled.find(F=>F instanceof $.$g_b);if(R){const F=await R.getRemoteUserDataSyncConfiguration(k);return{...P,...F}}return P}J(k){this.g!==k&&(this.g=k,this.h.fire(k))}L(){return this.M(),this.enabled.some(k=>k.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(k=>k.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const k=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,D.$ub)(this.m,k,(P,R)=>P.syncResource===R.syncResource&&(0,D.$ub)(P.conflicts,R.conflicts,(F,T)=>(0,C.$3g)(F.previewResource,T.previewResource)))||(this.m=k,this.n.fire(k))}N(k){switch(k){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ve([Q(2,s.$hlb),Q(3,c.$vi),Q(4,w.$6o),Q(5,s.$9kb),Q(6,g.$2l),Q(7,s.$mlb),Q(8,l.$Cl),Q(9,y.$3i)],a);function b(v){if(v instanceof s.$clb)switch(v.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function S(v,k,P,R){R.publicLog2("sync/error",{code:v.code,serverCode:v instanceof s.$dlb?String(v.serverCode):void 0,url:v instanceof s.$dlb?v.url:void 0,resource:v.resource,executionId:k,service:P.userDataSyncStore.url.toString()})}}),define(ae[266],ce([0,1,3,2,8,18,25]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=void 0;function I(w,h){return{...w,profile:(0,A.$Dl)(w.profile,h.profilesHome.scheme)}}function C(w){return{created:w.created,uri:L.URI.revive(w.uri)}}class f{constructor(h,c,p){this.c=h,this.d=c,this.f=p,this.a=new Map,this.b=new D.$de}listen(h,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(h,c,p){try{return await this.g(h,c,p)}catch(g){throw this.f.error(g),g}}async g(h,c,p){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(I(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(C(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const g=c.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),g){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const c=this.a.get(this.j(h));if(!c)throw new Error(`Manual sync taks not found: ${h}`);return c}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$tec=f;let E=class extends N.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,c){super(),this.n=c,this.b="uninitialized",this.c=this.B(new D.$de),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$de),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$de),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$de),this.onSyncErrors=this.m.event,this.a={call(p,g,l){return h.call(p,g,l).then(null,u=>{throw O.$clb.toUserDataSyncError(u)})},listen(p,g){return h.listen(p,g)}},this.a.call("_getInitialData").then(([p,g,l])=>{this.s(p),this.t(g),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(g=>({...g,error:O.$clb.toUserDataSyncError(g.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),c=this;return new y(h,{async call(g,l,u){return c.a.call(`manualSync/${g}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,c,p,g){return this.a.call("accept",[h,c,p,g])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,c){return this.a.call("extractActivityData",[h,c])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map(c=>({syncResource:c.syncResource,profile:(0,A.$Dl)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$uec=E,e.$uec=E=ve([Q(1,A.$Cl)],E);class y extends N.$Uc{constructor(h,c){super(),this.id=h,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ae[122],ce([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CLb=e.$BLb=e.$ALb=e.$zLb=e.$yLb=void 0;const $="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,o=1e3*60*5;let a=class extends O.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$flb,-1)}set c(R){this.h.store(d.$flb,R,-1,C.$o?0:1)}constructor(R,F,T){super(),this.f=R,this.g=F,this.h=T,this.a=this.B(new A.$de),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Tc);this.B(A.Event.filter(T.onDidChangeValue(-1,d.$flb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[$]),this.a.fire()}m(R){if(R&&(R=C.$o&&R.web?{...R,...R.web}:R,(0,E.$9f)(R.url)&&(0,E.$$f)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(F=>Array.isArray(R.authenticationProviders[F].scopes)))){const F=R,T=!!F.canSwitch,q=F.url===F.insidersUrl?"insiders":"stable",Y=(T?this.c:void 0)||q,J=Y==="insiders"?F.insidersUrl:Y==="stable"?F.stableUrl:F.url;return{url:y.URI.parse(J),type:Y,defaultType:q,defaultUrl:y.URI.parse(F.url),stableUrl:y.URI.parse(F.stableUrl),insidersUrl:y.URI.parse(F.insidersUrl),canSwitch:T,authenticationProviders:Object.keys(F.authenticationProviders).reduce((X,H)=>(X.push({id:H,scopes:F.authenticationProviders[H].scopes}),X),[])}}}};e.$yLb=a,e.$yLb=a=ve([Q(0,g.$jk),Q(1,h.$3i),Q(2,m.$1p)],a);let b=class extends a{constructor(R,F,T){super(R,F,T);const q=this.h.get(t,-1);q&&(this.n=JSON.parse(q));const Y=this.f[$];Y?this.h.store(t,JSON.stringify(Y),-1,1):this.h.remove(t,-1)}async switch(R){R!==this.c&&(this.c=R,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$zLb=b,e.$zLb=b=ve([Q(0,g.$jk),Q(1,h.$3i),Q(2,m.$1p)],b);let S=class extends O.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(R,F,T,q,Y,J,X){super(),this.n=T,this.r=q,this.s=X,this.g=this.B(new A.$de),this.onTokenFailed=this.g.event,this.h=this.B(new A.$de),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$de),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(R),this.c=(0,u.$7p)(Y,J,X).then(H=>{const K={"X-Client-Name":`${F.applicationName}${C.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(K["X-Client-Commit"]=F.commit),K}),this.f=new k(i,o,this.n,this.r),this.u(),this.B((0,O.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(R,F){this.b={token:R,type:F}}t(R){this.a=R?(0,f.$0g)(R,"v1"):void 0}u(){const R=this.s.getNumber(r,-1);R&&Date.now()<R&&this.y(new Date(R))}y(R){this.j?.getTime()!==R?.getTime()&&(this.j=R,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(r,this.j.getTime(),-1,1),this.w=(0,D.$jh)(F=>(0,D.$xh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(r,-1),this.m.fire())}async getAllCollections(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,f.$0g)(this.a,"collection").toString();R={...R},R["Content-Type"]="application/json";const T=await this.D(F,{type:"GET",headers:R},[],N.CancellationToken.None);return(await(0,l.$Tp)(T))?.map(({id:q})=>q)||[]}async createCollection(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,f.$0g)(this.a,"collection").toString();R={...R},R["Content-Type"]=I.$Qs.text;const T=await this.D(F,{type:"POST",headers:R},[],N.CancellationToken.None),q=await(0,l.$Sp)(T);if(!q)throw new d.$dlb("Server did not return the collection id",F,"NoCollection",T.res.statusCode,T.res.headers[d.$_kb]);return q}async deleteCollection(R,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=R?(0,f.$0g)(this.a,"collection",R).toString():(0,f.$0g)(this.a,"collection").toString();F={...F},await this.D(T,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async getAllResourceRefs(R,F){if(!this.a)throw new Error("No settings sync store url configured.");const T=this.z(this.a,F,R),q={},Y=await this.D(T.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,l.$Tp)(Y)||[]).map(({url:X,created:H})=>({ref:(0,f.$_g)(T,T.with({path:X})),created:H*1e3}))}async resolveResourceContent(R,F,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,f.$0g)(this.z(this.a,T,R),F).toString();q={...q},q["Cache-Control"]="no-cache";const J=await this.D(Y,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,l.$Sp)(J)}async deleteResource(R,F,T){if(!this.a)throw new Error("No settings sync store url configured.");const q=F!==null?(0,f.$0g)(this.z(this.a,T,R),F).toString():this.z(this.a,T,R).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,f.$0g)(this.a,"resource").toString(),F={"Content-Type":I.$Qs.text};await this.D(R,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async readResource(R,F,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,f.$0g)(this.z(this.a,T,R),"latest").toString();q={...q},q["Cache-Control"]="no-cache",F&&(q["If-None-Match"]=F.ref);const J=await this.D(Y,{type:"GET",headers:q},[304],N.CancellationToken.None);let X=null;if(J.res.statusCode===304&&(X=F),X===null){const H=J.res.headers.etag;if(!H)throw new d.$dlb("Server did not return the ref",Y,"NoRef",J.res.statusCode,J.res.headers[d.$_kb]);const K=await(0,l.$Sp)(J);if(!K&&J.res.statusCode===304)throw new d.$dlb("Empty response",Y,"EmptyResponse",J.res.statusCode,J.res.headers[d.$_kb]);X={ref:H,content:K}}return X}async writeResource(R,F,T,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,q,R).toString();Y={...Y},Y["Content-Type"]=I.$Qs.text,T&&(Y["If-Match"]=T);const X=await this.D(J,{type:"POST",data:F,headers:Y},[],N.CancellationToken.None),H=X.res.headers.etag;if(!H)throw new d.$dlb("Server did not return the ref",J,"NoRef",X.res.statusCode,X.res.headers[d.$_kb]);return H}async manifest(R,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,f.$0g)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",R&&(F["If-None-Match"]=R.ref);const q=await this.D(T,{type:"GET",headers:F},[304],N.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=R),!Y){const X=q.res.headers.etag;if(!X)throw new d.$dlb("Server did not return the ref",T,"NoRef",q.res.statusCode,q.res.headers[d.$_kb]);const H=await(0,l.$Sp)(q);if(!H&&q.res.statusCode===304)throw new d.$dlb("Empty response",T,"EmptyResponse",q.res.statusCode,q.res.headers[d.$_kb]);H&&(Y={...JSON.parse(H),ref:X})}const J=this.s.get(n,-1);return J&&Y&&J!==Y.session&&this.C(),Y===null&&J&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,f.$0g)(this.a,"download").toString(),F={},T=await this.D(R,{type:"GET",headers:F},[],N.CancellationToken.None);if(!(0,l.$Pp)(T))throw new d.$dlb("Server returned "+T.res.statusCode,R,"EmptyResponse",T.res.statusCode,T.res.headers[d.$_kb]);if((0,l.$Qp)(T))throw new d.$dlb("Empty response",R,"EmptyResponse",T.res.statusCode,T.res.headers[d.$_kb]);return T.stream}z(R,F,T){return F?(0,f.$0g)(R,"collection",F,"resource",T):(0,f.$0g)(R,"resource",T)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(R,F,T,q){if(!this.b)throw new d.$dlb("No Auth Token Available",R,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$dlb(`${F.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;F.headers={...F.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:R,type:F.type,headers:{...F.headers,authorization:void 0}});let J;try{J=await this.f.request(R,F,q)}catch(V){if(!(V instanceof d.$dlb)){let ie="RequestFailed";const se=(0,L.$0)(V).toLowerCase();se.includes("xhr timeout")?ie="RequestTimeout":se.includes("protocol")&&se.includes("not supported")?ie="RequestProtocolNotSupported":se.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":se.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,L.$4)(V)&&(ie="RequestCanceled"),V=new d.$dlb(`Connection refused for the request '${R}'.`,R,ie,void 0,void 0)}throw this.r.info("Request failed",R),V}const X=J.res.headers[d.$_kb],H={url:R,status:J.res.statusCode,"execution-id":F.headers[d.$alb],"operation-id":X},K=(0,l.$Pp)(J)||J.res.statusCode&&T.includes(J.res.statusCode);let G="";if(K?this.r.trace("Request succeeded",H):(G=await(0,l.$Rp)(J)||"",this.r.info("Request failed",H,G)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$dlb(`${F.type} request '${R}' failed because of Unauthorized (401).`,R,"Unauthorized",J.res.statusCode,X);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$dlb(`${F.type} request '${R}' failed because the access is forbidden (403).`,R,"Forbidden",J.res.statusCode,X)}if(this.h.fire(),J.res.statusCode===404)throw new d.$dlb(`${F.type} request '${R}' failed because the requested resource is not found (404).`,R,"NotFound",J.res.statusCode,X);if(J.res.statusCode===405)throw new d.$dlb(`${F.type} request '${R}' failed because the requested endpoint is not found (405). ${G}`,R,"MethodNotFound",J.res.statusCode,X);if(J.res.statusCode===409)throw new d.$dlb(`${F.type} request '${R}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,R,"Conflict",J.res.statusCode,X);if(J.res.statusCode===410)throw new d.$dlb(`${F.type} request '${R}' failed because the requested resource is not longer available (410).`,R,"Gone",J.res.statusCode,X);if(J.res.statusCode===412)throw new d.$dlb(`${F.type} request '${R}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,R,"PreconditionFailed",J.res.statusCode,X);if(J.res.statusCode===413)throw new d.$dlb(`${F.type} request '${R}' failed because of too large payload (413).`,R,"TooLarge",J.res.statusCode,X);if(J.res.statusCode===426)throw new d.$dlb(`${F.type} request '${R}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,R,"UpgradeRequired",J.res.statusCode,X);if(J.res.statusCode===429){const V=J.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new d.$dlb(`${F.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",J.res.statusCode,X)):new d.$dlb(`${F.type} request '${R}' failed because of too many requests (429).`,R,"RemoteTooManyRequests",J.res.statusCode,X)}if(!K)throw new d.$dlb("Server returned "+J.res.statusCode,R,"Unknown",J.res.statusCode,X);return J}F(R){let F=this.s.get(s,-1);F===void 0&&(F=(0,w.$Sg)(),this.s.store(s,F,-1,1)),R["X-Machine-Session-Id"]=F;const T=this.s.get(n,-1);T!==void 0&&(R["X-User-Session-Id"]=T)}};e.$ALb=S,e.$ALb=S=ve([Q(1,g.$jk),Q(2,l.$Np),Q(3,d.$mlb),Q(4,c.$Di),Q(5,p.$3k),Q(6,m.$1p)],S);let v=class extends S{constructor(R,F,T,q,Y,J,X){super(R.userDataSyncStore?.url,F,T,q,Y,J,X),this.B(R.onDidChangeUserDataSyncStore(()=>this.t(R.userDataSyncStore?.url)))}};e.$BLb=v,e.$BLb=v=ve([Q(0,d.$9kb),Q(1,g.$jk),Q(2,l.$Np),Q(3,d.$mlb),Q(4,c.$Di),Q(5,p.$3k),Q(6,m.$1p)],v);class k{constructor(R,F,T,q){this.c=R,this.d=F,this.f=T,this.g=q,this.a=[],this.b=void 0}request(R,F,T){if(this.h()&&this.i(),F.url=R,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$dlb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,R,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(R),this.f.request(F,T)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$CLb=k}),define(ae[267],ce([0,1,3,2,8,21,24,19,122]),function(ne,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=e.$qec=e.$pec=void 0;class f{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$pec=f;class E extends N.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new D.$de),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(g=>{this.a=g,this.b.fire(g)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$qec=E;class y{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$rec=y;let w=class extends C.$yLb{constructor(c,p,g,l){super(p,g,l),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:L.URI.revive(c.url),type:c.type,defaultUrl:L.URI.revive(c.defaultUrl),insidersUrl:L.URI.revive(c.insidersUrl),stableUrl:L.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$sec=w,e.$sec=w=ve([Q(1,O.$jk),Q(2,A.$3i),Q(3,I.$1p)],w)}),define(ae[268],ce([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,D,N,L,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;let y=class extends I.$abc{constructor(h,c,p,g,l,u,m,d,$,t,r){super(h,c,p,g,l,m,d,$,t,r),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Oec=y,e.$Oec=y=ve([Q(0,L.$jk),Q(1,C.$9kb),Q(2,C.$0kb),Q(3,C.$hlb),Q(4,C.$ilb),Q(5,N.$Fcc),Q(6,C.$mlb),Q(7,f.$7Jb),Q(8,O.$2l),Q(9,E.$Wkb),Q(10,A.$1p)],y)}),define(ae[269],ce([0,1,73,23,5,20]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0,e.$7bc=O,e.$8bc=I,e.$9bc=C,e.$6bc=128/4;function O(f){function E(){let y=f.scheme===N.Schemas.file?(0,A.$Xg)(f):f.toString();return L.$k||(y=y.toLowerCase()),(0,D.createHash)("md5").update(y).digest("hex")}return{id:E(),configPath:f}}function I(f,E){function y(){if(f.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(f.toString()).digest("hex");if(!E)return;let h;return L.$k?h=E.ino:L.$j?h=E.birthtime.getTime():L.$i&&(typeof E.birthtimeMs=="number"?h=Math.floor(E.birthtimeMs):h=E.birthtime.getTime()),(0,D.createHash)("md5").update(f.fsPath).update(h?String(h):"").digest("hex")}const w=y();if(typeof w=="string")return{id:w,uri:f}}function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[270],ce([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;let p=class extends L.$Uc{constructor(l,u,m,d){super(),this.a=l,this.b=u,this.c=m,this.f=d,this.B(new D.$Ih(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,u=await O.Promises.readdir(l),m=new f.$HKb(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const $=(0,A.$jc)(l,d);d.length===y.$6bc||d===E.$Ii.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await m.isUsed($)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm($))}))}catch(l){(0,N.$1)(l)}}};e.$lec=p,e.$lec=p=ve([Q(0,I.$Ei),Q(1,C.$3j),Q(2,w.$Fcc),Q(3,h.$Udc)],p)}),define(ae[123],ce([0,1,73,64,37,279,15,7,3,2,14,5,32,42,68]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=n,e.$pi=s,e.$ri=a,e.$si=b;class p{traceSocketEvent(v,k){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,k)}constructor(v,k=""){this.f=!0,this.debugLabel=k,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,I.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const k=P=>{this.traceSocketEvent("read",P),v(O.$Fe.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(v){const k=P=>{v({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(v){const k=()=>{v()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$li=p;var g;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var l;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(l||(l={}));class u extends f.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,k){this.socket.traceSocketEvent(v,k)}constructor(v,k,P,R){super(),this.f=this.B(new C.$de),this.g=this.B(new C.$de),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new m(this,k,P,R,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,I.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new c.$gi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let k=0;for(;k<v.byteLength;)this.a.writeMessage(v.slice(k,Math.min(k+262144,v.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(v,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let R=2;v.byteLength<126?R+=0:v.byteLength<2**16?R+=2:R+=8;const F=O.$Fe.alloc(R),T=k?64:0,q=P&15;if(F.writeUInt8(128|T|q,0),v.byteLength<126)F.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){F.writeUInt8(126,1);let Y=1;F.writeUInt8(v.byteLength>>>8&255,++Y),F.writeUInt8(v.byteLength>>>0&255,++Y)}else{F.writeUInt8(127,1);let Y=1;F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(v.byteLength>>>24&255,++Y),F.writeUInt8(v.byteLength>>>16&255,++Y),F.writeUInt8(v.byteLength>>>8&255,++Y),F.writeUInt8(v.byteLength>>>0&255,++Y)}this.socket.write(O.$Fe.concat([F,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),R=(P&128)>>>7,F=(P&64)>>>6,T=P&15,q=k.readUInt8(1),Y=(q&128)>>>7,J=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!R,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),R=(P&128)>>>7;let F=P&127,T=1;F===126?F=k.readUInt8(++T)*2**8+k.readUInt8(++T):F===127&&(F=k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T));let q=0;R&&(q=k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=u;class m extends f.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Fe.alloc(0)}constructor(v,k,P,R,F,T){super(),this.n=v,this.r=F,this.s=T,this.a=this.B(new C.$de),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$de),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$de),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new d(this.n,R,P,{windowBits:15})),this.f=this.B(new $(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(v,k){this.g.push({data:v,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,v);this.s(P,k)}else this.s(v,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,k){return new Promise((P,R)=>{v.write(k),v.flush(F=>P(F))})}acceptFrame(v,k,P){this.h.push({data:v,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const k=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,k,P){return new Promise((R,F)=>{v.write(k),P&&v.write(O.$Fe.fromByteArray([0,0,255,255])),v.flush(T=>R(T))})}}class d extends f.$Uc{get recordedInflateBytes(){return this.j?O.$Fe.concat(this.f):O.$Fe.alloc(0)}constructor(v,k,P,R){super(),this.h=v,this.j=k,this.a=this.B(new C.$de),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(R),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(O.$Fe.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=O.$Fe.concat(this.g);this.g.length=0,v(k)})}}class $ extends f.$Uc{constructor(v,k){super(),this.g=v,this.a=this.B(new C.$de),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(O.$Fe.wrap(P))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=O.$Fe.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),v(k)})}}function t(S,v){if(v===0)return;const k=S.byteLength>>>2;for(let Y=0;Y<k;Y++){const J=S.readUInt32BE(Y*4);S.writeUInt32BE(J^v,Y*4)}const P=k*4,R=S.byteLength-P,F=v>>>24&255,T=v>>>16&255,q=v>>>8&255;R>=1&&S.writeUInt8(S.readUInt8(P)^F,P),R>=2&&S.writeUInt8(S.readUInt8(P+1)^T,P+1),R>=3&&S.writeUInt8(S.readUInt8(P+2)^q,P+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function n(){const S=(0,w.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const v=process.platform!=="darwin"&&e.$ni?e.$ni:(0,L.tmpdir)(),k=(0,E.$jc)(v,`vscode-ipc-${S}.sock`);return i(k),k}function s(S,v,k){const R=(0,D.createHash)("sha256").update(S).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${v}-sock`;const F=k.substr(0,4),T=v.substr(0,6);let q;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?q=(0,E.$jc)(e.$ni,`vscode-${R}-${F}-${T}.sock`):q=(0,E.$jc)(S,`${F}-${T}.sock`),i(q),q}function i(S){const v=r[y.$u];typeof v=="number"&&S.length>=v&&console.warn(`WARNING: IPC handle "${S}" is longer than ${v} chars, try a shorter --user-data-dir`)}class o extends h.$ai{static b(v){const k=C.Event.fromNodeEventEmitter(v,"connection");return C.Event.map(k,P=>({protocol:new c.$hi(new p(P,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(P,"close"))}))}constructor(v){super(o.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=o;function a(S){return new Promise((v,k)=>{const P=(0,N.createServer)();P.on("error",k),P.listen(S,()=>{P.removeListener("error",k),v(new o(P))})})}function b(S,v){return new Promise((k,P)=>{const R=(0,N.createConnection)(S,()=>{R.removeListener("error",P),k(c.$ii.fromSocket(new p(R,`ipc-client${v}`),v))});R.once("error",P)})}}),define(ae[271],ce([0,1,64,123,218]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0,e.$Rec=new class{supports(A){return!0}connect({host:A,port:O},I,C,f){return new Promise((E,y)=>{const w=D.createConnection({host:A,port:O},()=>{w.removeListener("error",y),w.write((0,L.$kvb)(I,C,f));const h=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",h),E(new N.$li(w,f)))};w.on("data",h)});w.setNoDelay(!0),w.once("error",y)})}}}),define(ae[272],ce([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=void 0;async function l(t,r,n,s,i){let o;for(let a=3;a&&(o?.dispose(),o=await new u(t,r,n,s,i).waitForReady(),!(i&&L.$Vg[i]||!L.$Vg[o.tunnelLocalPort]));a--);return o}class u extends I.$Uc{constructor(r,n,s,i,o){super(),this.m=n,this.n=o,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new O.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,n=(0,p.$qw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,L.$Wg)(r,2,1e3,n),i=null;return this.b.listen(s,this.m),await this.c.wait(),i=this.b.address(),i||(s=0,this.b.listen(s,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(r){r.pause();const n=(0,p.$ow)(this.tunnelRemoteHost)||(0,p.$qw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$Sl)(this.a,n,this.tunnelRemotePort),i=s.getSocket(),o=s.readEntireBuffer();s.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),i.end()}),r.on("close",()=>i.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),i instanceof A.$li?i.socket.destroy():i.end()}),i instanceof A.$li?this.t(r,i):this.s(r,i),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),i.end()})}s(r,n){n.onClose(()=>r.destroy()),n.onEnd(()=>r.end()),n.onData(s=>r.write(s.buffer)),r.on("data",s=>n.write(g.$Fe.wrap(s))),r.resume()}t(r,n){const s=n.socket;s.on("end",()=>r.end()),s.on("close",()=>r.end()),s.on("error",()=>{r.destroy()}),s.pipe(r),r.pipe(s)}}e.$Ldc=u;let m=class extends p.$tw{constructor(r,n,s,i,o){super(n,o),this.v=r,this.w=s,this.y=i}isPortPrivileged(r){return(0,p.$rw)(r,this.m,C.OS,N.release())}t(r,n,s,i,o,a,b,S){const v=this.s(n,s);if(v)return++v.refcount,v.value;if((0,p.$kw)(r))return this.u(r,n,s,o,a,b,S);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${o}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=l(k,i,n,s,o);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,P),P}}};e.$Mdc=m,e.$Mdc=m=ve([Q(0,h.$Ml),Q(1,E.$3j),Q(2,c.$Pl),Q(3,y.$jk),Q(4,f.$3i)],m);let d=class extends m{constructor(r,n,s,i,o){super(r,n,s,i,o)}};e.$Ndc=d,e.$Ndc=d=ve([Q(0,h.$Ml),Q(1,E.$3j),Q(2,c.$Pl),Q(3,y.$jk),Q(4,f.$3i)],d);let $=class extends I.$Uc{constructor(r,n,s,i,o){super(),this.b=r,this.c=n,this.f=s,this.g=i,this.h=o,this.a=new Map}async openTunnel(r,n,s,i,o,a,b,S,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this.a.has(r)){const k=new d(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(r,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(n,s,i,o,a,b,S,v)}};e.$Odc=$,e.$Odc=$=ve([Q(0,h.$Ml),Q(1,E.$3j),Q(2,y.$jk),Q(3,c.$Pl),Q(4,f.$3i)],$)}),define(ae[280],ce([0,1,37,38,7,2,23,8,17,3,42,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(ne,e,D,N,L,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k,P,R,F,T,q,Y,J,X,H,K,G,V,ie,se,he,ee,W,B,j,M,z,U,Z,x,te,_,oe,fe,$e,de,ge,be,Ee,Ce,Re,le,we,pe,Pe,De,Le,Oe,Te,Ae,qe,He,Fe,Ne,Ue,re,ue,me,ye,ke,Ie,Me,Ve,Be,Ke,ze,Ze,Qe,tt,nt,mt,Ct,Pt,It,Rt,Dt,Ot,jt,Lt,wt,At,pt,Nt,Ft,ot,Mt,Tt,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=yt;class qt extends A.$Uc{constructor(Se){super(),this.f=Se,this.a=this.B(new y.$hX(this)),this.b=void 0,this.c=this.B(new f.$de),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,y.$iX)(process.parentPort,ot.$1cc.exit,je)}async init(){const Se=await this.h();(0,te.$4kb)(),Se.invokeFunction(je=>{const Ge=je.get(K.$3j),We=je.get(W.$2l),Ye=je.get(ye.$Cl);Ge.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Ge),this.n(We,Ye),this.B(Ye.onDidChangeProfiles(()=>this.n(We,Ye))),this.r(We,Ge)}),this.B((0,A.$Rc)(Se.createInstance(w.$hec,this.f.codeCachePath),Se.createInstance(h.$iec),Se.createInstance(g.$lec),Se.createInstance(p.$kec),Se.createInstance(c.$jec),Se.createInstance(Qe.$Iec),Se.createInstance(Ke.$Aec)))}async h(){const Se=new J.$ui,je={_serviceBrand:void 0,...V.default};Se.set(ie.$jk,je);const Ge=new E.$ei(Xe=>Xe==="main"),We=new wt.$Vdc(this.a,Ge);Se.set(wt.$Udc,We);const Ye=this.f.policiesData?new Ie.$rdc(this.f.policiesData,We.getChannel("policy")):new Me.$go;Se.set(Me.$eo,Ye);const Je=new Ft.$9m(this.f.args,je);Se.set(s.$Ei,Je);const it=new G.$_r(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Xe=>({...Xe,resource:I.URI.revive(Xe.resource)})),We.getChannel("logger"));Se.set(K.$4j,it);const ct=this.B(it.createLogger("sharedprocess",{name:(0,tt.localize)(0,null)})),ft=this.B(new K.$$j(ct.getLevel())),xe=this.B(new nt.$ZQ(ct,[ft]));Se.set(K.$3j,xe),this.b=this.B(new mt.$Kec(xe)),Se.set(mt.$Jec,this.b);const _e=this.B(new R.$Iq(xe));Se.set(P.$3k,_e);const dt=this.B(new F.$_q(xe));_e.registerProvider(O.Schemas.file,dt);const lt=new qe.$As(_e);Se.set(Ae.$Al,lt);const et=this.B(new Ve.$7Q(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Se.set(ye.$Cl,et);const gt=this.B(new Fe.$Tdc(O.Schemas.file,this.B(new Ne.$IQ(We.getChannel(Ne.$HQ),{pathCaseSensitive:He.$k})),O.Schemas.vscodeUserData,et,lt,xe));_e.registerProvider(O.Schemas.vscodeUserData,gt);const st=this.B(new d.$Go(et.defaultProfile.settingsResource,_e,Ye,xe));Se.set(m.$3i,st);const $t=new At.$Qec(void 0,{defaultProfile:et.defaultProfile,currentProfile:et.defaultProfile},We,Je);Se.set(he.$1p,$t),this.B((0,A.$Sc)(()=>$t.flush())),await Promise.all([st.initialize(),$t.initialize()]);const vt=new It.$Vr(We.getChannel("request"));Se.set(se.$Np,vt),Se.set(l.$mec,new T.$ti(u.$nec,void 0,!1)),Se.set(re.$vG,new T.$ti(Ue.$zec,void 0,!1));const Et=new Ot.$1dc(-1,We);Se.set(Dt.$Fcc,Et),Se.set(r.$Ko,new T.$ti(n.$cR,void 0,!0));const zt=this.B(new we.$odc(Et)),Bt=new E.$ei(Xe=>zt.getActiveClientId().then(ut=>Xe===ut));Se.set(k.$r4b,new Rt.$Mec(this.a.getChannel("extensionRecommendationNotification",Bt)));let ht;const rt=[],St=(0,z.$rp)(je,st);if((0,z.$mp)(je,Je)){const Xe=new j.$rac(xe,it,Je,je);if(rt.push(Xe),!(0,z.$np)(je,Je)&&je.aiConfig?.ariaKey){const ut=new Be.$NQ(vt,St,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,A.$Sc)(()=>ut.flush())),rt.push(ut)}ht=new M.$Zr({appenders:rt,commonProperties:(0,ee.$dp)((0,D.release)(),(0,D.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,St),sendErrorTelemetry:!0,piiPaths:(0,z.$sp)(Je)},st,je)}else{ht=z.$hp;const Xe=z.$lp;rt.push(Xe)}this.a.registerChannel("telemetryAppender",new B.$6cc(rt)),Se.set(W.$2l,ht);const Vt=new U.$oec(st,ht,xe,it,Je,je);Se.set(W.$3l,Vt),Se.set(ke.$pq,new T.$ti(Pt.$YQ,void 0,!0)),Se.set(ue.$tq,new T.$ti(me.$sdc,void 0,!0)),Se.set(b.$_p,new T.$ti(b.$bq,void 0,!0)),Se.set(v.$Dq,new T.$ti(v.$Eq,void 0,!0)),Se.set(a.$6o,new T.$ti(o.$0p,void 0,!0)),Se.set(a.$ap,new T.$ti(Lt.$Pec,void 0,!1)),Se.set(X.$Rr,new T.$ti(H.$Tr,void 0,!1)),Se.set($.$dn,new T.$ti(t.$Hs,void 0,!1)),Se.set(_.$7Jb,new T.$ti(_.$8Jb,void 0,!0)),Se.set(te.$mlb,new T.$ti($e.$uMb,void 0,!0)),Se.set(te.$llb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Xe=>Xe.ctx!=="main"))),Se.set(a.$_o,new T.$ti(i.$5Jb,void 0,!1)),Se.set(x.$sMb,new T.$ti(x.$tMb,void 0,!0)),Se.set(Z.$7v,new T.$ti(Z.$8v)),Se.set(te.$9kb,new T.$ti(Ce.$zLb,void 0,!0)),Se.set(te.$0kb,new T.$ti(Ce.$BLb,void 0,!0)),Se.set(de.$Wkb,new T.$ti(de.$Ykb,void 0,!0)),Se.set(te.$$kb,new T.$ti(oe.$7ac,void 0,!1)),Se.set(te.$hlb,new T.$ti(ge.$Vac,void 0,!0)),Se.set(te.$ilb,new T.$ti(be.$_ac,void 0,!1)),Se.set(Re.$IKb,new T.$ti(le.$vec,void 0,!0)),Se.set(te.$jlb,new T.$ti(Ze.$Ibc,void 0,!0)),Se.set(pe.$Pl,new T.$ti(Pe.$Qdc,void 0,!1));const kt=new pt.$Nl;return Se.set(pt.$Ml,kt),kt.register(0,Nt.$Rec),Se.set(De.$jw,new T.$ti(Le.$Odc)),Se.set(Oe.$wec,new T.$ti(Te.$yec)),Se.set(ze.$Bec,new T.$ti(Ct.$Lec)),new Y.$cr(Se)}j(Se){const je=new S.$dq(Se.get(a.$9o),()=>null);this.a.registerChannel("extensions",je);const Ge=E.ProxyChannel.fromService(Se.get(X.$Rr),this.q);this.a.registerChannel("languagePacks",Ge);const We=E.ProxyChannel.fromService(Se.get($.$dn),this.q);this.a.registerChannel("diagnostics",We);const Ye=new S.$fq(Se.get(a.$ap));this.a.registerChannel("extensionTipsService",Ye);const Je=E.ProxyChannel.fromService(Se.get(l.$mec),this.q);this.a.registerChannel("checksum",Je);const it=E.ProxyChannel.fromService(Se.get(re.$vG),this.q);this.a.registerChannel("v8InspectProfiling",it);const ct=E.ProxyChannel.fromService(Se.get(de.$Wkb),this.q);this.a.registerChannel("userDataSyncMachines",ct);const ft=E.ProxyChannel.fromService(Se.get(W.$3l),this.q);this.a.registerChannel("customEndpointTelemetry",ft);const xe=new fe.$pec(Se.get(_.$7Jb));this.a.registerChannel("userDataSyncAccount",xe);const _e=new fe.$rec(Se.get(te.$9kb));this.a.registerChannel("userDataSyncStoreManagement",_e);const dt=new Ee.$tec(Se.get(te.$ilb),Se.get(ye.$Cl),Se.get(K.$3j));this.a.registerChannel("userDataSync",dt);const lt=this.B(Se.get(q.$vi).createInstance(jt.$Oec));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(lt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(Se.get(te.$jlb),this.q));const et=E.ProxyChannel.fromService(Se.get(Oe.$wec),this.q);this.a.registerChannel(Oe.$xec,et);const gt=E.ProxyChannel.fromService(Se.get(ze.$Bec),this.q);this.a.registerChannel("remoteTunnel",gt)}m(Se){process.on("uncaughtException",je=>(0,L.$1)(je)),process.on("unhandledRejection",je=>(0,L.$1)(je)),(0,L.setUnexpectedErrorHandler)(je=>{const Ge=(0,N.$hj)(je,!0);Ge&&Se.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}async r(Se,je){if(He.$k){const[Ge,We]=await Promise.all([(0,Mt.$Tg)(je.error.bind(je)),(0,bt.$2W)(je.error.bind(je))]),Ye=(0,Tt.$HW)(),Je=(0,bt.$3W)(We,this.f.args["ozone-platform"]);Ge&&Se.publicLog2("clientPlatformInfo",{platformId:Ge.id,platformVersionId:Ge.version_id,platformIdLike:Ge.id_like,desktopEnvironment:Ye,displayProtocol:We,codeDisplayProtocol:Je})}}handledClientConnection(Se){if(Se.data!==ot.$3cc.response)return!1;const je=(0,C.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function yt(at){try{const Se=new qt(at);process.parentPort.postMessage(ot.$1cc.ipcReady),await Se.init(),process.parentPort.postMessage(ot.$1cc.initDone)}catch(Se){process.parentPort.postMessage({error:Se.toString()})}}const Ut=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",at=>{clearTimeout(Ut),yt(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/03dd3c3b93322b41fe108a3448308595ee7077a4/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
