/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],ge=function(oe){for(var e=[],p=0,S=oe.length;p<S;p++)e[p]=fe[oe[p]];return e};define(fe[40],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=p,e.$gb=S,e.$hb=E,e.$ib=A,e.$jb=j,e.$kb=k,e.$lb=h,e.$nb=v,e.$ob=l,e.$pb=P,e.$qb=o,e.$rb=a;function p($,f){const n=S($,f);if(n!==-1)return $[n]}function S($,f,n=$.length-1){for(let s=n;s>=0;s--){const d=$[s];if(f(d))return s}return-1}function E($,f){const n=A($,f);return n===-1?void 0:$[n]}function A($,f,n=0,s=$.length){let d=n,y=s;for(;d<y;){const i=Math.floor((d+y)/2);f($[i])?d=i+1:y=i}return d-1}function j($,f){const n=k($,f);return n===$.length?void 0:$[n]}function k($,f,n=0,s=$.length){let d=n,y=s;for(;d<y;){const i=Math.floor((d+y)/2);f($[i])?y=i:d=i+1}return d}function h($,f,n=0,s=$.length){const d=k($,f,n,s);return d===$.length?-1:d}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!f(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const n=A(this.e,f,this.c);return this.c=n+1,n===-1?void 0:this.e[n]}}e.$mb=r;function v($,f){if($.length===0)return;let n=$[0];for(let s=1;s<$.length;s++){const d=$[s];f(d,n)>0&&(n=d)}return n}function l($,f){if($.length===0)return;let n=$[0];for(let s=1;s<$.length;s++){const d=$[s];f(d,n)>=0&&(n=d)}return n}function P($,f){return v($,(n,s)=>-f(n,s))}function o($,f){if($.length===0)return-1;let n=0;for(let s=1;s<$.length;s++){const d=$[s];f(d,$[n])>0&&(n=s)}return n}function a($,f){for(const n of $){const s=f(n);if(s!==void 0)return s}}}),define(fe[41],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=p,e.$L=S,e.$M=E,e.$N=A;function p(j,k){const h=Object.create(null);for(const r of j){const v=k(r);let l=h[v];l||(l=h[v]=[]),l.push(r)}return h}function S(j,k){const h=[],r=[];for(const v of j)k.has(v)||h.push(v);for(const v of k)j.has(v)||r.push(v);return{removed:h,added:r}}function E(j,k){const h=[],r=[];for(const[v,l]of j)k.has(v)||h.push(l);for(const[v,l]of k)j.has(v)||r.push(l);return{removed:h,added:r}}function A(j,k){const h=new Set;for(const r of k)j.has(r)&&h.add(r);return h}}),define(fe[14],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=S,e.$2h=E,e.$3h=A;function p(j){return(k,h,r)=>{let v=null,l=null;if(typeof r.value=="function"?(v="value",l=r.value):typeof r.get=="function"&&(v="get",l=r.get),!l)throw new Error("not supported");r[v]=j(l,h)}}function S(j,k,h){let r=null,v=null;if(typeof h.value=="function"?(r="value",v=h.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(r="get",v=h.get),!v)throw new Error("not supported");const l=`$memoize$${k}`;h[r]=function(...P){return this.hasOwnProperty(l)||Object.defineProperty(this,l,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,P)}),this[l]}}function E(j,k,h){return p((r,v)=>{const l=`$debounce$${v}`,P=`$debounce$result$${v}`;return function(...o){this[P]||(this[P]=h?h():void 0),clearTimeout(this[l]),k&&(this[P]=k(this[P],...o),o=[this[P]]),this[l]=setTimeout(()=>{r.apply(this,o),this[P]=h?h():void 0},j)}})}function A(j,k,h){return p((r,v)=>{const l=`$throttle$timer$${v}`,P=`$throttle$result$${v}`,o=`$throttle$lastRun$${v}`,a=`$throttle$pending$${v}`;return function(...$){if(this[P]||(this[P]=h?h():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),k&&(this[P]=k(this[P],...$)),this[a])return;const f=this[o]+j;f<=Date.now()?(this[o]=Date.now(),r.apply(this,[this[P]]),this[P]=h?h():void 0):(this[a]=!0,this[l]=setTimeout(()=>{this[a]=!1,this[o]=Date.now(),r.apply(this,[this[P]]),this[P]=h?h():void 0},f-Date.now()))}})}}),define(fe[7],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=S,e.$Z=E,e.$1=A,e.$2=j,e.$3=k,e.$4=r,e.$6=l,e.$7=P,e.$8=o,e.$0=$;class p{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=p,e.$X=new p;function S(i){e.$X.setUnexpectedErrorHandler(i)}function E(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(i){r(i)||e.$X.onUnexpectedError(i)}function j(i){r(i)||e.$X.onUnexpectedExternalError(i)}function k(i){if(i instanceof Error){const{name:t,message:c}=i,L=i.stacktrace||i.stack;return{$isError:!0,name:t,message:c,stack:L,noTelemetry:d.isErrorNoTelemetry(i)}}return i}const h="Canceled";function r(i){return i instanceof v?!0:i instanceof Error&&i.name===h&&i.message===h}class v extends Error{constructor(){super(h),this.name=this.message}}e.$5=v;function l(){const i=new Error(h);return i.name=i.message,i}function P(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function o(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class a extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=a;function $(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class n extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=n;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=s;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const c=new d;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=d;class y extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,y.prototype)}}e.$cb=y}),define(fe[16],ge([0,1,7,40]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=E,e.$tb=A,e.$ub=j,e.$vb=k,e.$wb=h,e.$xb=r,e.$yb=v,e.$zb=l,e.$Ab=P,e.$Bb=o,e.$Cb=a,e.$Db=$,e.$Eb=f,e.top=n,e.$Gb=s,e.$Hb=y,e.$Ib=i,e.$Jb=t,e.$Kb=c,e.$Lb=L,e.$Mb=m,e.$Nb=D,e.$Ob=C,e.$Pb=w,e.$Qb=F,e.$Rb=Q,e.$Sb=U,e.$Tb=O,e.$Ub=g,e.$Vb=I,e.$Wb=b,e.$Xb=M,e.$Yb=Z,e.$Zb=ie,e.$1b=V,e.$2b=ee,e.$3b=ae,e.$4b=le,e.$5b=G,e.$6b=_,e.$7b=de,e.$0b=x;function E(N,X=0){return N[N.length-(1+X)]}function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function j(N,X,W=(H,R)=>H===R){if(N===X)return!0;if(!N||!X||N.length!==X.length)return!1;for(let H=0,R=N.length;H<R;H++)if(!W(N[H],X[H]))return!1;return!0}function k(N,X){const W=N.length-1;X<W&&(N[X]=N[W]),N.pop()}function h(N,X,W){return r(N.length,H=>W(N[H],X))}function r(N,X){let W=0,H=N-1;for(;W<=H;){const R=(W+H)/2|0,Y=X(R);if(Y<0)W=R+1;else if(Y>0)H=R-1;else return R}return-(W+1)}function v(N,X,W){if(N=N|0,N>=X.length)throw new TypeError("invalid index");const H=X[Math.floor(X.length*Math.random())],R=[],Y=[],te=[];for(const ce of X){const se=W(ce,H);se<0?R.push(ce):se>0?Y.push(ce):te.push(ce)}return N<R.length?v(N,R,W):N<R.length+te.length?te[0]:v(N-(R.length+te.length),Y,W)}function l(N,X){const W=[];let H;for(const R of N.slice(0).sort(X))!H||X(H[0],R)!==0?(H=[R],W.push(H)):H.push(R);return W}function*P(N,X){let W,H;for(const R of N)H!==void 0&&X(H,R)?W.push(R):(W&&(yield W),W=[R]),H=R;W&&(yield W)}function o(N,X){for(let W=0;W<=N.length;W++)X(W===0?void 0:N[W-1],W===N.length?void 0:N[W])}function a(N,X){for(let W=0;W<N.length;W++)X(W===0?void 0:N[W-1],N[W],W+1===N.length?void 0:N[W+1])}function $(N,X,W){const H=[];function R(ce,se,he){if(se===0&&he.length===0)return;const $e=H[H.length-1];$e&&$e.start+$e.deleteCount===ce?($e.deleteCount+=se,$e.toInsert.push(...he)):H.push({start:ce,deleteCount:se,toInsert:he})}let Y=0,te=0;for(;;){if(Y===N.length){R(Y,0,X.slice(te));break}if(te===X.length){R(Y,N.length-Y,[]);break}const ce=N[Y],se=X[te],he=W(ce,se);he===0?(Y+=1,te+=1):he<0?(R(Y,1,[]),Y+=1):he>0&&(R(Y,0,[se]),te+=1)}return H}function f(N,X,W){const H=$(N,X,W),R=[],Y=[];for(const te of H)R.push(...N.slice(te.start,te.start+te.deleteCount)),Y.push(...te.toInsert);return{removed:R,added:Y}}function n(N,X,W){if(W===0)return[];const H=N.slice(0,W).sort(X);return d(N,X,H,W,N.length),H}function s(N,X,W,H,R){return W===0?Promise.resolve([]):new Promise((Y,te)=>{(async()=>{const ce=N.length,se=N.slice(0,W).sort(X);for(let he=W,$e=Math.min(W+H,ce);he<ce;he=$e,$e=Math.min($e+H,ce)){if(he>W&&await new Promise(we=>setTimeout(we)),R&&R.isCancellationRequested)throw new p.$5;d(N,X,se,he,$e)}return se})().then(Y,te)})}function d(N,X,W,H,R){for(const Y=W.length;H<R;H++){const te=N[H];if(X(te,W[Y-1])<0){W.pop();const ce=(0,S.$kb)(W,se=>X(te,se)<0);W.splice(ce,0,te)}}}function y(N){return N.filter(X=>!!X)}function i(N){let X=0;for(let W=0;W<N.length;W++)N[W]&&(N[X]=N[W],X+=1);N.length=X}function t(N,X,W){N.splice(W,0,N.splice(X,1)[0])}function c(N){return!Array.isArray(N)||N.length===0}function L(N){return Array.isArray(N)&&N.length>0}function m(N,X=W=>W){const W=new Set;return N.filter(H=>{const R=X(H);return W.has(R)?!1:(W.add(R),!0)})}function D(N){const X=new Set;return W=>{const H=N(W);return X.has(H)?!1:(X.add(H),!0)}}function C(N,X){return N.length>0?N[0]:X}function w(N,X){return N.length>0?N[N.length-1]:X}function F(N,X,W=(H,R)=>H===R){let H=0;for(let R=0,Y=Math.min(N.length,X.length);R<Y&&W(N[R],X[R]);R++)H++;return H}function Q(N,X){let W=typeof X=="number"?N:0;typeof X=="number"?W=N:(W=0,X=N);const H=[];if(W<=X)for(let R=W;R<X;R++)H.push(R);else for(let R=W;R>X;R--)H.push(R);return H}function U(N,X,W){return N.reduce((H,R)=>(H[X(R)]=W?W(R):R,H),Object.create(null))}function O(N,X){return N.push(X),()=>g(N,X)}function g(N,X){const W=N.indexOf(X);if(W>-1)return N.splice(W,1),X}function I(N,X,W){const H=N.slice(0,X),R=N.slice(X);return H.concat(W,R)}function b(N,X){let W;if(typeof X=="number"){let H=X;W=()=>{const R=Math.sin(H++)*179426549;return R-Math.floor(R)}}else W=Math.random;for(let H=N.length-1;H>0;H-=1){const R=Math.floor(W()*(H+1)),Y=N[H];N[H]=N[R],N[R]=Y}}function M(N,X){const W=N.indexOf(X);W>-1&&(N.splice(W,1),N.unshift(X))}function Z(N,X){const W=N.indexOf(X);W>-1&&(N.splice(W,1),N.push(X))}function ie(N,X){for(const W of X)N.push(W)}function V(N,X){return Array.isArray(N)?N.map(X):X(N)}function ee(N){return Array.isArray(N)?N:[N]}function ae(N){return N[Math.floor(Math.random()*N.length)]}function le(N,X,W){const H=q(N,X),R=N.length,Y=W.length;N.length=R+Y;for(let te=R-1;te>=H;te--)N[te+Y]=N[te];for(let te=0;te<Y;te++)N[te+H]=W[te]}function G(N,X,W,H){const R=q(N,X);let Y=N.splice(R,W);return Y===void 0&&(Y=[]),le(N,R,H),Y}function q(N,X){return X<0?Math.max(X+N.length,0):Math.min(X,N.length)}var K;(function(N){function X(Y){return Y<0}N.isLessThan=X;function W(Y){return Y<=0}N.isLessThanOrEqual=W;function H(Y){return Y>0}N.isGreaterThan=H;function R(Y){return Y===0}N.isNeitherLessOrGreaterThan=R,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(K||(e.CompareResult=K={}));function _(N,X){return(W,H)=>X(N(W),N(H))}function de(...N){return(X,W)=>{for(const H of N){const R=H(X,W);if(!K.isNeitherLessOrGreaterThan(R))return R}return K.neitherLessOrGreaterThan}}const B=(N,X)=>N-X;e.$8b=B;const ue=(N,X)=>(0,e.$8b)(N?1:0,X?1:0);e.$9b=ue;function x(N){return(X,W)=>-N(X,W)}class u{constructor(X){this.g=X,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(X){let W=this.c;for(;W<this.g.length&&X(this.g[W]);)W++;const H=W===this.c?null:this.g.slice(this.c,W);return this.c=W,H}takeFromEndWhile(X){let W=this.d;for(;W>=0&&X(this.g[W]);)W--;const H=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,H}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const X=this.g[this.c];return this.c++,X}removeLast(){const X=this.g[this.d];return this.d--,X}takeCount(X){const W=this.g.slice(this.c,this.c+X);return this.c+=X,W}}e.$$b=u;class z{static{this.empty=new z(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(W=>(X(W),!0))}toArray(){const X=[];return this.iterate(W=>(X.push(W),!0)),X}filter(X){return new z(W=>this.iterate(H=>X(H)?W(H):!0))}map(X){return new z(W=>this.iterate(H=>W(X(H))))}some(X){let W=!1;return this.iterate(H=>(W=X(H),!W)),W}findFirst(X){let W;return this.iterate(H=>X(H)?(W=H,!1):!0),W}findLast(X){let W;return this.iterate(H=>(X(H)&&(W=H),!0)),W}findLastMaxBy(X){let W,H=!0;return this.iterate(R=>((H||K.isGreaterThan(X(R,W)))&&(H=!1,W=R),!0)),W}}e.$_b=z;class ne{constructor(X){this.c=X}static createSortPermutation(X,W){const H=Array.from(X.keys()).sort((R,Y)=>W(X[R],X[Y]));return new ne(H)}apply(X){return X.map((W,H)=>X[this.c[H]])}inverse(){const X=this.c.slice();for(let W=0;W<this.c.length;W++)X[this.c[W]]=W;return new ne(X)}}e.$ac=ne}),define(fe[42],ge([0,1,7]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=S,e.$ed=E,e.$fd=A,e.$gd=j,e.$hd=k,e.$id=h;function S(r,v){if(!r)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}function E(r,v="Unreachable"){throw new Error(v)}function A(r){if(!r)throw new p.$cb("Assertion Failed")}function j(r){r||(0,p.$1)(new p.$cb("Soft Assertion Failed"))}function k(r){if(!r()){debugger;r(),(0,p.$1)(new p.$cb("Assertion Failed"))}}function h(r,v){let l=0;for(;l<r.length-1;){const P=r[l],o=r[l+1];if(!v(P,o))return!1;l++}return!0}}),define(fe[29],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=p;function p(S,E){const A=this;let j=!1,k;return function(){if(j)return k;if(j=!0,E)try{k=S.apply(A,arguments)}finally{E()}else k=S.apply(A,arguments);return k}}}),define(fe[43],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(S){function E(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}S.is=E;const A=Object.freeze([]);function j(){return A}S.empty=j;function*k(t){yield t}S.single=k;function h(t){return E(t)?t:k(t)}S.wrap=h;function r(t){return t||A}S.from=r;function*v(t){for(let c=t.length-1;c>=0;c--)yield t[c]}S.reverse=v;function l(t){return!t||t[Symbol.iterator]().next().done===!0}S.isEmpty=l;function P(t){return t[Symbol.iterator]().next().value}S.first=P;function o(t,c){for(const L of t)if(c(L))return!0;return!1}S.some=o;function a(t,c){for(const L of t)if(c(L))return L}S.find=a;function*$(t,c){for(const L of t)c(L)&&(yield L)}S.filter=$;function*f(t,c){let L=0;for(const m of t)yield c(m,L++)}S.map=f;function*n(...t){for(const c of t)yield*c}S.concat=n;function s(t,c,L){let m=L;for(const D of t)m=c(m,D);return m}S.reduce=s;function*d(t,c,L=t.length){for(c<0&&(c+=t.length),L<0?L+=t.length:L>t.length&&(L=t.length);c<L;c++)yield t[c]}S.slice=d;function y(t,c=Number.POSITIVE_INFINITY){const L=[];if(c===0)return[L,t];const m=t[Symbol.iterator]();for(let D=0;D<c;D++){const C=m.next();if(C.done)return[L,S.empty()];L.push(C.value)}return[L,{[Symbol.iterator](){return m}}]}S.consume=y;async function i(t){const c=[];for await(const L of t)c.push(L);return Promise.resolve(c)}S.asyncToArray=i})(p||(e.Iterable=p={}))}),define(fe[22],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class p{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=p}),define(fe[44],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class p{static{this.Undefined=new p(void 0)}constructor(A){this.element=A,this.next=p.Undefined,this.prev=p.Undefined}}class S{constructor(){this.a=p.Undefined,this.b=p.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===p.Undefined}clear(){let A=this.a;for(;A!==p.Undefined;){const j=A.next;A.prev=p.Undefined,A.next=p.Undefined,A=j}this.a=p.Undefined,this.b=p.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,j){const k=new p(A);if(this.a===p.Undefined)this.a=k,this.b=k;else if(j){const r=this.b;this.b=k,k.prev=r,r.next=k}else{const r=this.a;this.a=k,k.next=r,r.prev=k}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(k))}}shift(){if(this.a!==p.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==p.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==p.Undefined&&A.next!==p.Undefined){const j=A.prev;j.next=A.next,A.next.prev=j}else A.prev===p.Undefined&&A.next===p.Undefined?(this.a=p.Undefined,this.b=p.Undefined):A.next===p.Undefined?(this.b=this.b.prev,this.b.next=p.Undefined):A.prev===p.Undefined&&(this.a=this.a.next,this.a.prev=p.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==p.Undefined;)yield A.element,A=A.next}}e.$5c=S}),define(fe[25],ge([0,1]),function(oe,e){"use strict";var p,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=j,e.$zc=k,e.$Ic=y;function A(i,t,c){let L=i.get(t);return L===void 0&&(L=c,i.set(t,L)),L}function j(i){const t=[];return i.forEach((c,L)=>{t.push(`${L} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}function k(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}class h{constructor(t,c){this.uri=t,this.value=c}}function r(i){return Array.isArray(i)}class v{static{this.c=t=>t.toString()}constructor(t,c){if(this[p]="ResourceMap",t instanceof v)this.d=new Map(t.d),this.e=c??v.c;else if(r(t)){this.d=new Map,this.e=c??v.c;for(const[L,m]of t)this.set(L,m)}else this.d=new Map,this.e=t??v.c}set(t,c){return this.d.set(this.e(t),new h(t,c)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[L,m]of this.d)t(m.value,m.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=v;class l{constructor(t,c){this[S]="ResourceSet",!t||typeof t=="function"?this.c=new v(t):(this.c=new v(c),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,c){this.c.forEach((L,m)=>t.call(c,m,m,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=l;var P;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(P||(e.Touch=P={}));class o{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,c=0){const L=this.c.get(t);if(L)return c!==0&&this.m(L,c),L.value}set(t,c,L=0){let m=this.c.get(t);if(m)m.value=c,L!==0&&this.m(m,L);else{switch(m={key:t,value:c,next:void 0,previous:void 0},L){case 0:this.k(m);break;case 1:this.j(m);break;case 2:this.k(m);break;default:this.k(m);break}this.c.set(t,m),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.c.get(t);if(c)return this.c.delete(t),this.l(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,c){const L=this.g;let m=this.d;for(;m;){if(c?t.bind(c)(m.value,m.key,this):t(m.value,m.key,this),this.g!==L)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const t=this,c=this.g;let L=this.d;const m={[Symbol.iterator](){return m},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(L){const D={value:L.key,done:!1};return L=L.next,D}else return{value:void 0,done:!0}}};return m}values(){const t=this,c=this.g;let L=this.d;const m={[Symbol.iterator](){return m},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(L){const D={value:L.value,done:!1};return L=L.next,D}else return{value:void 0,done:!0}}};return m}entries(){const t=this,c=this.g;let L=this.d;const m={[Symbol.iterator](){return m},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(L){const D={value:[L.key,L.value],done:!1};return L=L.next,D}else return{value:void 0,done:!0}}};return m}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.d,L=this.size;for(;c&&L>t;)this.c.delete(c.key),c=c.next,L--;this.d=c,this.f=L,c&&(c.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.e,L=this.size;for(;c&&L>t;)this.c.delete(c.key),c=c.previous,L--;this.e=c,this.f=L,c&&(c.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const c=t.next,L=t.previous;if(!c||!L)throw new Error("Invalid list");c.previous=L,L.next=c}t.next=void 0,t.previous=void 0,this.g++}m(t,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.d)return;const L=t.next,m=t.previous;t===this.e?(m.next=void 0,this.e=m):(L.previous=m,m.next=L),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(c===2){if(t===this.e)return;const L=t.next,m=t.previous;t===this.d?(L.previous=void 0,this.d=L):(L.previous=m,m.next=L),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((c,L)=>{t.push([L,c])}),t}fromJSON(t){this.clear();for(const[c,L]of t)this.set(c,L)}}e.$Cc=o;class a extends o{constructor(t,c=1){super(),this.n=t,this.o=Math.min(Math.max(0,c),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class $ extends a{constructor(t,c=1){super(t,c)}q(t){this.h(t)}set(t,c){return super.set(t,c),this.p(),this}}e.$Dc=$;class f extends a{constructor(t,c=1){super(t,c)}q(t){this.i(t)}set(t,c){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,c),this}}e.$Ec=f;class n{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let c=this.c.get(t)||0;return c===0?!1:(c--,c===0?this.c.delete(t):this.c.set(t,c),!0)}has(t){return this.c.has(t)}}e.$Fc=n;class s{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[c,L]of t)this.set(c,L)}clear(){this.c.clear(),this.d.clear()}set(t,c){this.c.set(t,c),this.d.set(c,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const c=this.c.get(t);return c===void 0?!1:(this.c.delete(t),this.d.delete(c),!0)}forEach(t,c){this.c.forEach((L,m)=>{t.call(c,L,m,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=s;class d{constructor(){this.c=new Map}add(t,c){let L=this.c.get(t);L||(L=new Set,this.c.set(t,L)),L.add(c)}delete(t,c){const L=this.c.get(t);L&&(L.delete(c),L.size===0&&this.c.delete(t))}forEach(t,c){const L=this.c.get(t);L&&L.forEach(c)}get(t){const c=this.c.get(t);return c||new Set}}e.$Hc=d;function y(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[c,L]of i)if(!t.has(c)||t.get(c)!==L)return!1;for(const[c]of t)if(!i.has(c))return!1;return!0}}),define(fe[2],ge([0,1,16,41,25,29,43]),function(oe,e,p,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=v,e.$Lc=l,e.$Mc=P,e.$Nc=$,e.$Oc=f,e.$Pc=n,e.$Qc=s,e.$Rc=d,e.$Sc=y,e.$3c=Q;const k=!1;let h=null;class r{constructor(){this.b=new Map}static{this.a=0}c(g){let I=this.b.get(g);return I||(I={parent:null,source:null,isSingleton:!1,value:g,idx:r.a++},this.b.set(g,I)),I}trackDisposable(g){const I=this.c(g);I.source||(I.source=new Error().stack)}setParent(g,I){const b=this.c(g);b.parent=I}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,I){const b=I.get(g);if(b)return b;const M=g.parent?this.f(this.c(g.parent),I):g;return I.set(g,M),M}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,b])=>b.source!==null&&!this.f(b,g).isSingleton).flatMap(([b])=>b)}computeLeakingDisposables(g=10,I){let b;if(I)b=I;else{const ee=new Map,ae=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,ee).isSingleton);if(ae.length===0)return;const le=new Set(ae.map(G=>G.value));if(b=ae.filter(G=>!(G.parent&&le.has(G.parent))),b.length===0)throw new Error("There are cyclic diposable chains!")}if(!b)return;function M(ee){function ae(G,q){for(;G.length>0&&q.some(K=>typeof K=="string"?K===G[0]:G[0].match(K));)G.shift()}const le=ee.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return ae(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const Z=new E.$Hc;for(const ee of b){const ae=M(ee);for(let le=0;le<=ae.length;le++)Z.add(ae.slice(0,le).join(`
`),ee)}b.sort((0,p.$6b)(ee=>ee.idx,p.$8b));let ie="",V=0;for(const ee of b.slice(0,g)){V++;const ae=M(ee),le=[];for(let G=0;G<ae.length;G++){let q=ae[G];q=`(shared with ${Z.get(ae.slice(0,G+1).join(`
`)).size}/${b.length} leaks) at ${q}`;const _=Z.get(ae.slice(0,G).join(`
`)),de=(0,S.$K)([..._].map(B=>M(B)[G]),B=>B);delete de[ae[G]];for(const[B,ue]of Object.entries(de))le.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${B}`);le.unshift(q)}ie+=`


==================== Leaking disposable ${V}/${b.length}: ${ee.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return b.length>g&&(ie+=`


... and ${b.length-g} more leaking disposables

`),{leaks:b,details:ie}}}e.$Jc=r;function v(O){h=O}if(k){const O="__is_disposable_tracked__";v(new class{trackDisposable(g){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[O]||console.log(I)},3e3)}setParent(g,I){if(g&&g!==t.None)try{g[O]=!0}catch{}}markAsDisposed(g){if(g&&g!==t.None)try{g[O]=!0}catch{}}markAsSingleton(g){}})}function l(O){return h?.trackDisposable(O),O}function P(O){h?.markAsDisposed(O)}function o(O,g){h?.setParent(O,g)}function a(O,g){if(h)for(const I of O)h.setParent(I,g)}function $(O){return h?.markAsSingleton(O),O}function f(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function n(O){if(j.Iterable.is(O)){const g=[];for(const I of O)if(I)try{I.dispose()}catch(b){g.push(b)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function s(O){for(const g of O)f(g)&&g.dispose();return[]}function d(...O){const g=y(()=>n(O));return a(O,g),g}function y(O){const g=l({dispose:(0,A.$db)(()=>{P(g),O()})});return g}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,l(this)}dispose(){this.g||(P(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{n(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return o(g,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),o(g,null))}}e.$Tc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,l(this),o(this.q,this)}dispose(){P(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Uc=t;class c{constructor(){this.b=!1,l(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&o(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&o(g,null),g}}e.$Vc=c;class L{constructor(g){this.a=new c,this.b=!1,this.a.value=g}get value(){return this.a.value}set value(g){this.b||g===this.a.value||(this.a.value=g)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=L;class m{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=m;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,l(this)}set(g){let I=g;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,P(this))},this}}e.$Yc=D;class C{constructor(){this.a=new Map}acquire(g,...I){let b=this.a.get(g);b||(b={counter:0,object:this.b(g,...I)},this.a.set(g,b));const{object:M}=b,Z=(0,A.$db)(()=>{--b.counter===0&&(this.c(g,b.object),this.a.delete(g))});return b.counter++,{object:M,dispose:Z}}}e.$Zc=C;class w{constructor(g){this.a=g}async acquire(g,...I){const b=this.a.acquire(g,...I);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(M){throw b.dispose(),M}}}e.$1c=w;class F{constructor(g){this.object=g}dispose(){}}e.$2c=F;function Q(O){const g=new i;try{O(g)}finally{g.dispose()}}class U{constructor(){this.a=new Map,this.b=!1,l(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,I,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(g)?.dispose(),this.a.set(g,I)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=U}),define(fe[45],ge([0,1,25]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=E,e.$cm=j;const S=new p.$Dc(1e4);function E(r){return h(r,"NFC",S)}const A=new p.$Dc(1e4);function j(r){return h(r,"NFD",A)}const k=/[^\u0000-\u0080]/;function h(r,v,l){if(!r)return r;const P=l.get(r);if(P)return P;let o;return k.test(r)?o=r.normalize(v):o=r,l.set(r,o),o}e.$dm=function(){const r=/[\u0300-\u036f]/g;return function(v){return j(v).replace(r,"")}}()}),function(){function oe(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function j(h){A.push(h,Date.now())}function k(){const h=[];for(let r=0;r<A.length;r+=2)h.push({name:A[r],startTime:A[r+1]});return h}return{mark:j,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(E+j.startTime)});return A}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function p(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=p(S))}(),define(fe[46],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0;const p=globalThis.performance&&typeof globalThis.performance.now=="function";class S{static create(A){return new S(A)}constructor(A){this.c=p&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$_d=S}),define(fe[4],ge([0,1,7,29,2,44,46]),function(oe,e,p,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$be=e.Event=void 0,e.$ce=o;const k=!1,h=!1,r=!1;var v;(function(I){I.None=()=>E.$Uc.None;function b(se){if(r){const{onDidAddListener:he}=se,$e=$.create();let we=0;se.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function M(se,he){return _(se,()=>{},0,void 0,!0,void 0,he)}I.defer=M;function Z(se){return(he,$e=null,we)=>{let ye=!1,ve;return ve=se(Ee=>{if(!ye)return ve?ve.dispose():ye=!0,he.call($e,Ee)},null,we),ye&&ve.dispose(),ve}}I.once=Z;function ie(se,he,$e){return q((we,ye=null,ve)=>se(Ee=>we.call(ye,he(Ee)),null,ve),$e)}I.map=ie;function V(se,he,$e){return q((we,ye=null,ve)=>se(Ee=>{he(Ee),we.call(ye,Ee)},null,ve),$e)}I.forEach=V;function ee(se,he,$e){return q((we,ye=null,ve)=>se(Ee=>he(Ee)&&we.call(ye,Ee),null,ve),$e)}I.filter=ee;function ae(se){return se}I.signal=ae;function le(...se){return(he,$e=null,we)=>{const ye=(0,E.$Rc)(...se.map(ve=>ve(Ee=>he.call($e,Ee))));return K(ye,we)}}I.any=le;function G(se,he,$e,we){let ye=$e;return ie(se,ve=>(ye=he(ye,ve),ye),we)}I.reduce=G;function q(se,he){let $e;const we={onWillAddFirstListener(){$e=se(ye.fire,ye)},onDidRemoveLastListener(){$e?.dispose()}};he||b(we);const ye=new i(we);return he?.add(ye),ye.event}function K(se,he){return he instanceof Array?he.push(se):he&&he.add(se),se}function _(se,he,$e=100,we=!1,ye=!1,ve,Ee){let Pe,ke,je,Fe=0,Ne;const De={leakWarningThreshold:ve,onWillAddFirstListener(){Pe=se(We=>{Fe++,ke=he(ke,We),we&&!je&&(Ue.fire(ke),ke=void 0),Ne=()=>{const He=ke;ke=void 0,je=void 0,(!we||Fe>1)&&Ue.fire(He),Fe=0},typeof $e=="number"?(clearTimeout(je),je=setTimeout(Ne,$e)):je===void 0&&(je=0,queueMicrotask(Ne))})},onWillRemoveListener(){ye&&Fe>0&&Ne?.()},onDidRemoveLastListener(){Ne=void 0,Pe.dispose()}};Ee||b(De);const Ue=new i(De);return Ee?.add(Ue),Ue.event}I.debounce=_;function de(se,he=0,$e){return I.debounce(se,(we,ye)=>we?(we.push(ye),we):[ye],he,void 0,!0,void 0,$e)}I.accumulate=de;function B(se,he=(we,ye)=>we===ye,$e){let we=!0,ye;return ee(se,ve=>{const Ee=we||!he(ve,ye);return we=!1,ye=ve,Ee},$e)}I.latch=B;function ue(se,he,$e){return[I.filter(se,he,$e),I.filter(se,we=>!he(we),$e)]}I.split=ue;function x(se,he=!1,$e=[],we){let ye=$e.slice(),ve=se(ke=>{ye?ye.push(ke):Pe.fire(ke)});we&&we.add(ve);const Ee=()=>{ye?.forEach(ke=>Pe.fire(ke)),ye=null},Pe=new i({onWillAddFirstListener(){ve||(ve=se(ke=>Pe.fire(ke)),we&&we.add(ve))},onDidAddFirstListener(){ye&&(he?setTimeout(Ee):Ee())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return we&&we.add(Pe),Pe.event}I.buffer=x;function u(se,he){return(we,ye,ve)=>{const Ee=he(new ne);return se(function(Pe){const ke=Ee.evaluate(Pe);ke!==z&&we.call(ye,ke)},void 0,ve)}}I.chain=u;const z=Symbol("HaltChainable");class ne{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:z),this}reduce(he,$e){let we=$e;return this.f.push(ye=>(we=he(we,ye),we)),this}latch(he=($e,we)=>$e===we){let $e=!0,we;return this.f.push(ye=>{const ve=$e||!he(ye,we);return $e=!1,we=ye,ve?ye:z}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===z)break;return he}}function N(se,he,$e=we=>we){const we=(...Pe)=>Ee.fire($e(...Pe)),ye=()=>se.on(he,we),ve=()=>se.removeListener(he,we),Ee=new i({onWillAddFirstListener:ye,onDidRemoveLastListener:ve});return Ee.event}I.fromNodeEventEmitter=N;function X(se,he,$e=we=>we){const we=(...Pe)=>Ee.fire($e(...Pe)),ye=()=>se.addEventListener(he,we),ve=()=>se.removeEventListener(he,we),Ee=new i({onWillAddFirstListener:ye,onDidRemoveLastListener:ve});return Ee.event}I.fromDOMEventEmitter=X;function W(se){return new Promise(he=>Z(se)(he))}I.toPromise=W;function H(se){const he=new i;return se.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}I.fromPromise=H;function R(se,he,$e){return he($e),se(we=>he(we))}I.runAndSubscribe=R;class Y{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||b(we),this.emitter=new i(we),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(se,he){return new Y(se,he).emitter.event}I.fromObservable=te;function ce(se){return(he,$e,we)=>{let ye=0,ve=!1;const Ee={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(se.reportChanges(),ve&&(ve=!1,he.call($e)))},handlePossibleChange(){},handleChange(){ve=!0}};se.addObserver(Ee),se.reportChanges();const Pe={dispose(){se.removeObserver(Ee)}};return we instanceof E.$Tc?we.add(Pe):Array.isArray(we)&&we.push(Pe),Pe}}I.fromObservableLight=ce})(v||(e.Event=v={}));class l{static{this.all=new Set}static{this.f=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${l.f++}`,l.all.add(this)}start(b){this.g=new j.$_d,this.listenerCount=b}stop(){if(this.g){const b=this.g.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.g=void 0}}}e.$be=l;let P=-1;function o(I){const b=P;return P=I,{dispose(){P=b}}}class a{constructor(b,M=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=M,this.g=0}dispose(){this.f?.clear()}check(b,M){const Z=this.threshold;if(Z<=0||M<Z)return;this.f||(this.f=new Map);const ie=this.f.get(b.value)||0;if(this.f.set(b.value,ie+1),this.g-=1,this.g<=0){this.g=Z*.5;let V,ee=0;for(const[ae,le]of this.f)(!V||ee<le)&&(V=ae,ee=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${ee}):`),console.warn(V)}return()=>{const V=this.f.get(b.value)||0;this.f.set(b.value,V-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class n{constructor(b){this.value=b,this.id=f++}}const s=2,d=(I,b)=>{if(I instanceof n)b(I);else for(let M=0;M<I.length;M++){const Z=I[M];Z&&b(Z)}},y=k?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class i{constructor(b){this.w=0,this.f=b,this.g=P>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new l(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const b=this.t;queueMicrotask(()=>{d(b,M=>M.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(b,M,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),E.$Uc.None;if(this.m)return E.$Uc.None;M&&(b=b.bind(M));const ie=new n(b);let V,ee;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ie.stack=$.create(),V=this.g.check(ie.stack,this.w+1)),h&&(ie.stack=ee??$.create()),this.t?this.t instanceof n?(this.u??=new c,this.t=[this.t,ie]):this.t.push(ie):(this.f?.onWillAddFirstListener?.(this),this.t=ie,this.f?.onDidAddFirstListener?.(this)),this.w++;const ae=(0,E.$Sc)(()=>{y?.unregister(ae),V?.(),this.x(ie)});if(Z instanceof E.$Tc?Z.add(ae):Array.isArray(Z)&&Z.push(ae),y){const le=new Error().stack.split(`
`).slice(2).join(`
`).trim();y.register(ae,le,ae)}return ae},this.q}x(b){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const M=this.t,Z=M.indexOf(b);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,M[Z]=void 0;const ie=this.u.current===this;if(this.w*s<=M.length){let V=0;for(let ee=0;ee<M.length;ee++)M[ee]?M[V++]=M[ee]:ie&&(this.u.end--,V<this.u.i&&this.u.i--);M.length=V}}y(b,M){if(!b)return;const Z=this.f?.onListenerError||p.$1;if(!Z){b.value(M);return}try{b.value(M)}catch(ie){Z(ie)}}z(b){const M=b.current.t;for(;b.i<b.end;)this.y(M[b.i++],b.value);b.reset()}fire(b){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof n)this.y(this.t,b);else{const M=this.u;M.enqueue(this,b,this.t.length),this.z(M)}this.j?.stop()}hasListeners(){return this.w>0}}e.$de=i;const t=()=>new c;e.$ee=t;class c{constructor(){this.i=-1,this.end=0}enqueue(b,M,Z){this.i=0,this.end=Z,this.current=b,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends i{async fireAsync(b,M,Z){if(this.t)for(this.h||(this.h=new A.$5c),d(this.t,ie=>this.h.push([ie.value,b]));this.h.size>0&&!M.isCancellationRequested;){const[ie,V]=this.h.shift(),ee=[],ae={...V,token:M,waitUntil:le=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Z&&(le=Z(le,ie)),ee.push(le)}};try{ie(ae)}catch(le){(0,p.$1)(le);continue}Object.freeze(ee),await Promise.allSettled(ee).then(le=>{for(const G of le)G.status==="rejected"&&(0,p.$1)(G.reason)})}}}e.$fe=L;class m extends i{get isPaused(){return this.h!==0}constructor(b){super(b),this.h=0,this.s=new A.$5c,this.A=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.A(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.w&&(this.h!==0?this.s.push(b):super.fire(b))}}e.$ge=m;class D extends m{constructor(b){super(b),this.k=b.delay??100}fire(b){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(b)}}e.$he=D;class C extends i{constructor(b){super(b),this.h=[],this.k=b?.merge}fire(b){this.hasListeners()&&(this.h.push(b),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(M=>super.fire(M)),this.h=[]}))}}e.$ie=C;class w{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(b){const M={event:b,listener:null};this.h.push(M),this.g&&this.m(M);const Z=()=>{this.g&&this.o(M);const ie=this.h.indexOf(M);this.h.splice(ie,1)};return(0,E.$Sc)((0,S.$db)(Z))}j(){this.g=!0,this.h.forEach(b=>this.m(b))}k(){this.g=!1,this.h.forEach(b=>this.o(b))}m(b){b.listener=b.event(M=>this.f.fire(M))}o(b){b.listener?.dispose(),b.listener=null}dispose(){this.f.dispose();for(const b of this.h)b.listener?.dispose();this.h=[]}}e.$je=w;class F{constructor(b,M,Z,ie){this.f=new E.$Tc;const V=this.f.add(new w),ee=this.f.add(new E.$4c);function ae(le){ee.set(le,V.add(ie(le)))}for(const le of b)ae(le);this.f.add(M(le=>{ae(le)})),this.f.add(Z(le=>{ee.deleteAndDispose(le)})),this.event=V.event}dispose(){this.f.dispose()}}e.$ke=F;class Q{constructor(){this.f=[]}wrapEvent(b){return(M,Z,ie)=>b(V=>{const ee=this.f[this.f.length-1];ee?ee.push(()=>M.call(Z,V)):M.call(Z,V)},void 0,ie)}bufferEvents(b){const M=[];this.f.push(M);const Z=b();return this.f.pop(),M.forEach(ie=>ie()),Z}}e.$le=Q;class U{constructor(){this.f=!1,this.g=v.None,this.h=E.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(b){this.g=b,this.f&&(this.h.dispose(),this.h=b(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$me=U;class O{static const(b){return new g(b)}constructor(b){this.g=b,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(b){b!==this.g&&(this.g=b,this.f.fire(void 0))}}e.$ne=O;class g{constructor(b){this.value=b,this.onDidChange=v.None}}}),define(fe[17],ge([0,1,4]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.CancellationToken=void 0,e.$pe=k;const S=Object.freeze(function(h,r){const v=setTimeout(h.bind(r),0);return{dispose(){clearTimeout(v)}}});var E;(function(h){function r(v){return v===h.None||v===h.Cancelled||v instanceof A?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}h.isCancellationToken=r,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(E||(e.CancellationToken=E={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new p.$de),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=E.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=E.None}}e.$oe=j;function k(h){const r=new j;return h.add({dispose(){r.cancel()}}),r.token}}),define(fe[47],ge([0,1,17]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=E;class S{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new p.$oe,r=this.b(h.token);return this.a={promise:r,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}e.$1e=S;function E(k){return k}class A{constructor(h,r){this.a=void 0,this.b=void 0,typeof h=="function"?(this.c=h,this.d=E):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);return this.b!==r&&(this.b=r,this.a=this.c(h)),this.a}}e.$3e=A;class j{get cachedValues(){return this.a}constructor(h,r){this.a=new Map,this.b=new Map,typeof h=="function"?(this.c=h,this.d=E):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);if(this.b.has(r))return this.b.get(r);const v=this.c(h);return this.a.set(h,v),this.b.set(r,v),v}}e.$4e=j}),define(fe[48],ge([0,1,7,2]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=E,e.$re=A,e.$se=j,e.$te=k,e.$ue=r,e.$ve=v,e.$we=l,e.$xe=P,e.$ye=o,e.$ze=a,e.$Ae=$,e.$Be=f,e.$Ce=n,e.$De=s,e.$Ee=d;function E(y){const i=y;return i?typeof i.read=="function":!1}function A(y){const i=y;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function j(y){const i=y;return i?A(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function k(y,i){return new h(y,i)}class h{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,p.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let c;switch(i){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const L=c.indexOf(t);L>=0&&c.splice(L,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(y,i){const t=[];let c;for(;(c=y.read())!==null;)t.push(c);return i(t)}function v(y,i,t){const c=[];let L;for(;(L=y.read())!==null&&c.length<t;)c.push(L);return L===null&&c.length>0?i(c):{read:()=>{if(c.length>0)return c.shift();if(typeof L<"u"){const m=L;return L=void 0,m}return y.read()}}}function l(y,i){return new Promise((t,c)=>{const L=[];P(y,{onData:m=>{i&&L.push(m)},onError:m=>{i?c(m):t(void 0)},onEnd:()=>{t(i?i(L):void 0)}})})}function P(y,i,t){y.on("error",c=>{t?.isCancellationRequested||i.onError(c)}),y.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),y.on("data",c=>{t?.isCancellationRequested||i.onData(c)})}function o(y,i){return new Promise((t,c)=>{const L=new S.$Tc,m=[],D=F=>{if(m.push(F),m.length>i)return L.dispose(),y.pause(),t({stream:y,buffer:m,ended:!1})},C=F=>(L.dispose(),c(F)),w=()=>(L.dispose(),t({stream:y,buffer:m,ended:!0}));L.add((0,S.$Sc)(()=>y.removeListener("error",C))),y.on("error",C),L.add((0,S.$Sc)(()=>y.removeListener("end",w))),y.on("end",w),L.add((0,S.$Sc)(()=>y.removeListener("data",D))),y.on("data",D)})}function a(y,i){const t=k(i);return t.end(y),t}function $(){const y=k(()=>{throw new Error("not supported")});return y.end(),y}function f(y){let i=!1;return{read:()=>i?null:(i=!0,y)}}function n(y,i,t){const c=k(t);return P(y,{onData:L=>c.write(i.data(L)),onError:L=>c.error(i.error?i.error(L):L),onEnd:()=>c.end()}),c}function s(y,i,t){let c=!1;return{read:()=>{const L=i.read();return c?L:(c=!0,L!==null?t([y,L]):y)}}}function d(y,i,t){let c=!1;const L=k(t);return P(i,{onData:m=>c?L.write(m):(c=!0,L.write(t([y,m]))),onError:m=>L.error(m),onEnd:()=>{c||(c=!0,L.write(y)),L.end()}}),L}}),define(fe[18],ge([0,1,22,48]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=r,e.$He=v,e.$Ie=l,e.$Je=P,e.$Ke=o,e.$Le=a,e.$Me=$,e.$Ne=f,e.$Oe=n,e.$Pe=s,e.$Qe=d,e.$Re=y,e.$Se=i,e.$Te=t,e.$Ue=c,e.$Ve=L,e.$We=m,e.$Xe=D,e.$Ye=C,e.$Ze=Q;const E=typeof Buffer<"u",A=new p.$V(()=>new Uint8Array(256));let j,k;class h{static alloc(O){return E?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return E&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,g){return!(g?.dontUseNodeBuffer||!1)&&E?new h(Buffer.from(O)):(j||(j=new TextEncoder),new h(j.encode(O)))}static fromByteArray(O){const g=h.alloc(O.length);for(let I=0,b=O.length;I<b;I++)g.buffer[I]=O[I];return g}static concat(O,g){if(typeof g>"u"){g=0;for(let M=0,Z=O.length;M<Z;M++)g+=O[M].byteLength}const I=h.alloc(g);let b=0;for(let M=0,Z=O.length;M<Z;M++){const ie=O[M];I.set(ie,b),b+=ie.byteLength}return I}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return E?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(O,g){return new h(this.buffer.subarray(O,g))}set(O,g){if(O instanceof h)this.buffer.set(O.buffer,g);else if(O instanceof Uint8Array)this.buffer.set(O,g);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),g);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return P(this.buffer,O)}writeUInt32BE(O,g){o(this.buffer,O,g)}readUInt32LE(O){return a(this.buffer,O)}writeUInt32LE(O,g){$(this.buffer,O,g)}readUInt8(O){return f(this.buffer,O)}writeUInt8(O,g){n(this.buffer,O,g)}indexOf(O,g=0){return r(this.buffer,O instanceof h?O.buffer:O,g)}}e.$Fe=h;function r(U,O,g=0){const I=O.byteLength,b=U.byteLength;if(I===0)return 0;if(I===1)return U.indexOf(O[0]);if(I>b-g)return-1;const M=A.value;M.fill(O.length);for(let ee=0;ee<O.length;ee++)M[O[ee]]=O.length-ee-1;let Z=g+O.length-1,ie=Z,V=-1;for(;Z<b;)if(U[Z]===O[ie]){if(ie===0){V=Z;break}Z--,ie--}else Z+=Math.max(O.length-ie,M[U[Z]]),ie=O.length-1;return V}function v(U,O){return U[O+0]<<0>>>0|U[O+1]<<8>>>0}function l(U,O,g){U[g+0]=O&255,O=O>>>8,U[g+1]=O&255}function P(U,O){return U[O]*2**24+U[O+1]*2**16+U[O+2]*2**8+U[O+3]}function o(U,O,g){U[g+3]=O,O=O>>>8,U[g+2]=O,O=O>>>8,U[g+1]=O,O=O>>>8,U[g]=O}function a(U,O){return U[O+0]<<0>>>0|U[O+1]<<8>>>0|U[O+2]<<16>>>0|U[O+3]<<24>>>0}function $(U,O,g){U[g+0]=O&255,O=O>>>8,U[g+1]=O&255,O=O>>>8,U[g+2]=O&255,O=O>>>8,U[g+3]=O&255}function f(U,O){return U[O]}function n(U,O,g){U[g]=O}function s(U){return S.$ue(U,O=>h.concat(O))}function d(U){return S.$Be(U)}function y(U){return S.$we(U,O=>h.concat(O))}async function i(U){return U.ended?h.concat(U.buffer):h.concat([...U.buffer,await y(U.stream)])}function t(U){return S.$ze(U,O=>h.concat(O))}function c(U){return S.$Ce(U,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function L(U){return S.$te(O=>h.concat(O),U)}function m(U,O){return S.$De(U,O,g=>h.concat(g))}function D(U,O){return S.$Ee(U,O,g=>h.concat(g))}function C(U){let O=0,g=0,I=0;const b=new Uint8Array(Math.floor(U.length/4*3)),M=ie=>{switch(g){case 3:b[I++]=O|ie,g=0;break;case 2:b[I++]=O|ie>>>2,O=ie<<6,g=3;break;case 1:b[I++]=O|ie>>>4,O=ie<<4,g=2;break;default:O=ie<<2,g=1}};for(let ie=0;ie<U.length;ie++){const V=U.charCodeAt(ie);if(V>=65&&V<=90)M(V-65);else if(V>=97&&V<=122)M(V-97+26);else if(V>=48&&V<=57)M(V-48+52);else if(V===43||V===45)M(62);else if(V===47||V===95)M(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${U[ie]}`)}}const Z=I;for(;g>0;)M(0);return h.wrap(b).slice(0,Z)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Q({buffer:U},O=!0,g=!1){const I=g?F:w;let b="";const M=U.byteLength%3;let Z=0;for(;Z<U.byteLength-M;Z+=3){const ie=U[Z+0],V=U[Z+1],ee=U[Z+2];b+=I[ie>>>2],b+=I[(ie<<4|V>>>4)&63],b+=I[(V<<2|ee>>>6)&63],b+=I[ee&63]}if(M===1){const ie=U[Z+0];b+=I[ie>>>2],b+=I[ie<<4&63],O&&(b+="==")}else if(M===2){const ie=U[Z+0],V=U[Z+1];b+=I[ie>>>2],b+=I[(ie<<4|V>>>4)&63],b+=I[V<<2&63],O&&(b+="=")}return b}}),define(fe[9],ge([0,1,47,22]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=E,e.$8e=j,e.$9e=h,e.$0e=r,e.$$e=v,e.$_e=l,e.$af=P,e.$bf=o,e.$cf=a,e.$df=$,e.$ef=f,e.$ff=n,e.$gf=s,e.$hf=d,e.$if=y,e.$jf=i,e.$kf=t,e.$lf=c,e.$mf=L,e.$nf=m,e.$of=D,e.$pf=C,e.$qf=w,e.$rf=F,e.$sf=Q,e.$tf=U,e.$uf=O,e.$vf=g,e.$wf=I,e.$xf=b,e.$yf=M,e.$zf=Z,e.$Af=ie,e.$Bf=V,e.$Cf=ee,e.$Df=ae,e.$Ef=le,e.$Hf=_,e.$If=de,e.$Jf=B,e.$Kf=ue,e.$Lf=z,e.$Mf=N,e.$Of=X,e.$Pf=W,e.$Qf=H,e.$Rf=R,e.$Sf=te,e.$Tf=ce,e.$Uf=he,e.$Wf=$e,e.$Xf=we,e.$Yf=ye,e.$Zf=ve,e.$1f=Ee,e.$2f=Pe,e.$3f=ke,e.$4f=je,e.$5f=We;function E(T){return!T||typeof T!="string"?!0:T.trim().length===0}const A=/{(\d+)}/g;function j(T,...J){return J.length===0?T:T.replace(A,function(re,me){const pe=parseInt(me,10);return isNaN(pe)||pe<0||pe>=J.length?re:J[pe]})}const k=/{([^}]+)}/g;function h(T,J){return Object.keys(J).length===0?T:T.replace(k,(re,me)=>J[me]??re)}function r(T){return T.replace(/[<>"'&]/g,J=>{switch(J){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return J})}function v(T){return T.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}function l(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function P(T,J){let re=0,me=T.indexOf(J);for(;me!==-1;)re++,me=T.indexOf(J,me+J.length);return re}function o(T,J,re="\u2026"){return T.length<=J?T:`${T.substr(0,J)}${re}`}function a(T,J,re="\u2026"){if(T.length<=J)return T;const me=Math.ceil(J/2)-re.length/2,pe=Math.floor(J/2)-re.length/2;return`${T.substr(0,me)}${re}${T.substr(T.length-pe)}`}function $(T,J=" "){const re=f(T,J);return n(re,J)}function f(T,J){if(!T||!J)return T;const re=J.length;if(re===0||T.length===0)return T;let me=0;for(;T.indexOf(J,me)===me;)me=me+re;return T.substring(me)}function n(T,J){if(!T||!J)return T;const re=J.length,me=T.length;if(re===0||me===0)return T;let pe=me,Ce=-1;for(;Ce=T.lastIndexOf(J,pe-1),!(Ce===-1||Ce+re!==pe);){if(Ce===0)return"";pe=Ce}return T.substring(0,pe)}function s(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(T){return T.replace(/\*/g,"")}function y(T,J,re={}){if(!T)throw new Error("Cannot create regex from empty string");J||(T=l(T)),re.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let me="";return re.global&&(me+="g"),re.matchCase||(me+="i"),re.multiline&&(me+="m"),re.unicode&&(me+="u"),new RegExp(T,me)}function i(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}function t(T){return T.split(/\r\n|\r|\n/)}function c(T){const J=[],re=T.split(/(\r\n|\r|\n)/);for(let me=0;me<Math.ceil(re.length/2);me++)J.push(re[2*me]+(re[2*me+1]??""));return J}function L(T){for(let J=0,re=T.length;J<re;J++){const me=T.charCodeAt(J);if(me!==32&&me!==9)return J}return-1}function m(T,J=0,re=T.length){for(let me=J;me<re;me++){const pe=T.charCodeAt(me);if(pe!==32&&pe!==9)return T.substring(J,me)}return T.substring(J,re)}function D(T,J=T.length-1){for(let re=J;re>=0;re--){const me=T.charCodeAt(re);if(me!==32&&me!==9)return re}return-1}function C(T,J,re){const me=[];let pe=0;for(const Ce of T.matchAll(J)){if(me.push(T.slice(pe,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");pe=Ce.index+Ce[0].length,me.push(re(Ce[0],...Ce.slice(1),Ce.index,T,Ce.groups))}return me.push(T.slice(pe)),Promise.all(me).then(Ce=>Ce.join(""))}function w(T,J){return T<J?-1:T>J?1:0}function F(T,J,re=0,me=T.length,pe=0,Ce=J.length){for(;re<me&&pe<Ce;re++,pe++){const Me=T.charCodeAt(re),Ae=J.charCodeAt(pe);if(Me<Ae)return-1;if(Me>Ae)return 1}const Le=me-re,Oe=Ce-pe;return Le<Oe?-1:Le>Oe?1:0}function Q(T,J){return U(T,J,0,T.length,0,J.length)}function U(T,J,re=0,me=T.length,pe=0,Ce=J.length){for(;re<me&&pe<Ce;re++,pe++){let Me=T.charCodeAt(re),Ae=J.charCodeAt(pe);if(Me===Ae)continue;if(Me>=128||Ae>=128)return F(T.toLowerCase(),J.toLowerCase(),re,me,pe,Ce);g(Me)&&(Me-=32),g(Ae)&&(Ae-=32);const Se=Me-Ae;if(Se!==0)return Se}const Le=me-re,Oe=Ce-pe;return Le<Oe?-1:Le>Oe?1:0}function O(T){return T>=48&&T<=57}function g(T){return T>=97&&T<=122}function I(T){return T>=65&&T<=90}function b(T,J){return T.length===J.length&&U(T,J)===0}function M(T,J){const re=J.length;return J.length>T.length?!1:U(T,J,0,re)===0}function Z(T,J){const re=Math.min(T.length,J.length);let me;for(me=0;me<re;me++)if(T.charCodeAt(me)!==J.charCodeAt(me))return me;return re}function ie(T,J){const re=Math.min(T.length,J.length);let me;const pe=T.length-1,Ce=J.length-1;for(me=0;me<re;me++)if(T.charCodeAt(pe-me)!==J.charCodeAt(Ce-me))return me;return re}function V(T){return 55296<=T&&T<=56319}function ee(T){return 56320<=T&&T<=57343}function ae(T,J){return(T-55296<<10)+(J-56320)+65536}function le(T,J,re){const me=T.charCodeAt(re);if(V(me)&&re+1<J){const pe=T.charCodeAt(re+1);if(ee(pe))return ae(me,pe)}return me}function G(T,J){const re=T.charCodeAt(J-1);if(ee(re)&&J>1){const me=T.charCodeAt(J-2);if(V(me))return ae(me,re)}return re}class q{get offset(){return this.e}constructor(J,re=0){this.c=J,this.d=J.length,this.e=re}setOffset(J){this.e=J}prevCodePoint(){const J=G(this.c,this.e);return this.e-=J>=65536?2:1,J}nextCodePoint(){const J=le(this.c,this.d,this.e);return this.e+=J>=65536?2:1,J}eol(){return this.e>=this.d}}e.$Ff=q;class K{get offset(){return this.c.offset}constructor(J,re=0){this.c=new q(J,re)}nextGraphemeLength(){const J=De.getInstance(),re=this.c,me=re.offset;let pe=J.getGraphemeBreakType(re.nextCodePoint());for(;!re.eol();){const Ce=re.offset,Le=J.getGraphemeBreakType(re.nextCodePoint());if(Fe(pe,Le)){re.setOffset(Ce);break}pe=Le}return re.offset-me}prevGraphemeLength(){const J=De.getInstance(),re=this.c,me=re.offset;let pe=J.getGraphemeBreakType(re.prevCodePoint());for(;re.offset>0;){const Ce=re.offset,Le=J.getGraphemeBreakType(re.prevCodePoint());if(Fe(Le,pe)){re.setOffset(Ce);break}pe=Le}return me-re.offset}eol(){return this.c.eol()}}e.$Gf=K;function _(T,J){return new K(T,J).nextGraphemeLength()}function de(T,J){return new K(T,J).prevGraphemeLength()}function B(T,J){J>0&&ee(T.charCodeAt(J))&&J--;const re=J+_(T,J);return[re-de(T,re),re]}function ue(T){const J=new K(T);let re=0;for(;!J.eol();)re++,J.nextGraphemeLength();return re}let x;function u(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(T){return x||(x=u()),x.test(T)}const ne=/^[\t\n\r\x20-\x7E]*$/;function N(T){return ne.test(T)}e.$Nf=/[\u2028\u2029]/;function X(T){return e.$Nf.test(T)}function W(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}function H(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}function R(T,J,re=""){const me=T.trimStart();if(me.length<J)return me;const pe=/\b/g;let Ce=0;for(;pe.test(me)&&!(me.length-pe.lastIndex<J);)Ce=pe.lastIndex,pe.lastIndex+=1;return Ce===0?me:re+me.substring(Ce).trimStart()}const Y=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*te(T){let J=0;for(const re of T.matchAll(Y))J!==re.index&&(yield{isCode:!1,str:T.substring(J,re.index)}),yield{isCode:!0,str:re[0]},J=re.index+re[0].length;J!==T.length&&(yield{isCode:!1,str:T.substring(J)})}function ce(T){return T&&(T=T.replace(Y,"")),T}const se=/\\\[.*?\\\]/g;function he(T){return ce(T).replace(se,"")}e.$Vf="\uFEFF";function $e(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}function we(T){return $e(T)?T.substr(1):T}function ye(T,J){if(!T||!J||T.length<J.length)return!1;const re=J.length,me=T.toLowerCase();let pe=0,Ce=-1;for(;pe<re;){const Le=me.indexOf(J[pe],Ce+1);if(Le<0)return!1;Ce=Le,pe++}return!0}function ve(T,J=!1){return T?(J&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}function Ee(T){return T.charAt(0).toUpperCase()+T.slice(1)}function Pe(T,J=1){if(J===0)return"";let re=-1;do re=T.indexOf(`
`,re+1),J--;while(J>0&&re>=0);return re===-1?T:(T[re-1]==="\r"&&re--,T.substr(0,re))}function ke(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}function je(T){return De.getInstance().getGraphemeBreakType(T)}function Fe(T,J){return T===0?J!==5&&J!==7:T===2&&J===3?!1:T===4||T===2||T===3||J===4||J===2||J===3?!0:!(T===8&&(J===8||J===9||J===11||J===12)||(T===11||T===9)&&(J===9||J===10)||(T===12||T===10)&&J===10||J===5||J===13||J===7||T===1||T===13&&J===14||T===6&&J===6)}var Ne;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=Ue()}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const re=this.d,me=re.length/3;let pe=1;for(;pe<=me;)if(J<re[3*pe])pe=2*pe;else if(J>re[3*pe+1])pe=2*pe+1;else return re[3*pe+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(T,J){if(T===0)return 0;const re=He(T,J);if(re!==void 0)return re;const me=new q(J,T);return me.prevCodePoint(),me.offset}function He(T,J){const re=new q(J,T);let me=re.prevCodePoint();for(;Ge(me)||me===65039||me===8419;){if(re.offset===0)return;me=re.prevCodePoint()}if(!H(me))return;let pe=re.offset;return pe>0&&re.prevCodePoint()===8205&&(pe=re.offset),pe}function Ge(T){return 127995<=T&&T<=127999}var Xe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$6f="\xA0";class Te{static{this.c=new S.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new p.$3e({getCacheKey:JSON.stringify},J=>{function re(Se){const Re=new Map;for(let Ie=0;Ie<Se.length;Ie+=2)Re.set(Se[Ie],Se[Ie+1]);return Re}function me(Se,Re){const Ie=new Map(Se);for(const[qe,Ve]of Re)Ie.set(qe,Ve);return Ie}function pe(Se,Re){if(!Se)return Re;const Ie=new Map;for(const[qe,Ve]of Se)Re.has(qe)&&Ie.set(qe,Ve);return Ie}const Ce=this.c.value;let Le=J.filter(Se=>!Se.startsWith("_")&&Se in Ce);Le.length===0&&(Le=["_default"]);let Oe;for(const Se of Le){const Re=re(Ce[Se]);Oe=pe(Oe,Re)}const Me=re(Ce._common),Ae=me(Me,Oe);return new Te(Ae)})}static getInstance(J){return Te.d.get(Array.from(J))}static{this.e=new S.$V(()=>Object.keys(Te.c.value).filter(J=>!J.startsWith("_")))}static getLocales(){return Te.e.value}constructor(J){this.f=J}isAmbiguous(J){return this.f.has(J)}getPrimaryConfusable(J){return this.f.get(J)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=Te;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(J){return Be.e().has(J)}static get codePoints(){return Be.e()}}e.$8f=Be}),define(fe[49],ge([0,1,9]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=S,e.$lj=E,e.$mj=A,e.$nj=k,e.$pj=$;function S(n){return E(n,0)}function E(n,s){switch(typeof n){case"object":return n===null?A(349,s):Array.isArray(n)?h(n,s):r(n,s);case"string":return k(n,s);case"boolean":return j(n,s);case"number":return A(n,s);case"undefined":return A(937,s);default:return A(617,s)}}function A(n,s){return(s<<5)-s+n|0}function j(n,s){return A(n?433:863,s)}function k(n,s){s=A(149417,s);for(let d=0,y=n.length;d<y;d++)s=A(n.charCodeAt(d),s);return s}function h(n,s){return s=A(104579,s),n.reduce((d,y)=>E(y,d),s)}function r(n,s){return s=A(181387,s),Object.keys(n).sort().reduce((d,y)=>(d=k(y,d),E(n[y],d)),s)}class v{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=E(s,this.g),this.g}}e.$oj=v;var l;(function(n){n[n.BLOCK_SIZE=64]="BLOCK_SIZE",n[n.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(l||(l={}));function P(n,s,d=32){const y=d-s,i=~((1<<y)-1);return(n<<s|(i&n)>>>y)>>>0}function o(n,s=0,d=n.byteLength,y=0){for(let i=0;i<d;i++)n[s+i]=y}function a(n,s,d="0"){for(;n.length<s;)n=d+n;return n}function $(n,s=32){return n instanceof ArrayBuffer?Array.from(new Uint8Array(n)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((n>>>0).toString(16),s/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const d=s.length;if(d===0)return;const y=this.p;let i=this.r,t=this.u,c,L;for(t!==0?(c=t,L=-1,t=0):(c=s.charCodeAt(0),L=0);;){let m=c;if(p.$Bf(c))if(L+1<d){const D=s.charCodeAt(L+1);p.$Cf(D)?(L++,m=p.$Df(c,D)):m=65533}else{t=c;break}else p.$Cf(c)&&(m=65533);if(i=this.w(y,i,m),L++,L<d)c=s.charCodeAt(L);else break}this.r=i,this.u=t}w(s,d,y){return y<128?s[d++]=y:y<2048?(s[d++]=192|(y&1984)>>>6,s[d++]=128|(y&63)>>>0):y<65536?(s[d++]=224|(y&61440)>>>12,s[d++]=128|(y&4032)>>>6,s[d++]=128|(y&63)>>>0):(s[d++]=240|(y&1835008)>>>18,s[d++]=128|(y&258048)>>>12,s[d++]=128|(y&4032)>>>6,s[d++]=128|(y&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,s[0]=s[64],s[1]=s[65],s[2]=s[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),$(this.h)+$(this.l)+$(this.m)+$(this.n)+$(this.o)}x(){this.p[this.r++]=128,o(this.p,this.r),this.r>56&&(this.y(),o(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=f.g,d=this.q;for(let w=0;w<64;w+=4)s.setUint32(w,d.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)s.setUint32(w,P(s.getUint32(w-12,!1)^s.getUint32(w-32,!1)^s.getUint32(w-56,!1)^s.getUint32(w-64,!1),1),!1);let y=this.h,i=this.l,t=this.m,c=this.n,L=this.o,m,D,C;for(let w=0;w<80;w++)w<20?(m=i&t|~i&c,D=1518500249):w<40?(m=i^t^c,D=1859775393):w<60?(m=i&t|i&c|t&c,D=2400959708):(m=i^t^c,D=3395469782),C=P(y,5)+m+L+D+s.getUint32(w*4,!1)&4294967295,L=c,c=t,t=P(i,30),i=y,y=C;this.h=this.h+y&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+L&4294967295}}e.$qj=f}),define(fe[50],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(fe[51],ge([0,1,16,9]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class E{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const a=o.charCodeAt(0),$=this.b.charCodeAt(this.c);return a-$}value(){return this.b[this.c]}}e.$yi=E;class A{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,S.$rf)(o,this.b,0,o.length,this.c,this.d):(0,S.$tf)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=A;class j{constructor(o=!0,a=!0){this.f=o,this.g=a}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let a=o.length-1;a>=0;a--,this.c--){const $=this.b.charCodeAt(a);if(!($===47||this.f&&$===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===47||this.f&&a===92)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,S.$rf)(o,this.b,0,o.length,this.d,this.e):(0,S.$tf)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=j;var k;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(k||(k={}));class h{constructor(o,a){this.f=o,this.g=a,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(3)),this.g(o)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===1)return(0,S.$sf)(o,this.c.scheme);if(this.d[this.e]===2)return(0,S.$sf)(o,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(o);if(this.d[this.e]===4)return(0,S.$qf)(o,this.c.query);if(this.d[this.e]===5)return(0,S.$qf)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=h;class r{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(v||(v={}));class l{static forUris(o=()=>!1,a=()=>!1){return new l(new h(o,a))}static forPaths(o=!1){return new l(new j(void 0,!o))}static forStrings(){return new l(new E)}static forConfigKeys(){return new l(new A)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,a){if(a){const $=a.slice(0);(0,p.$Wb)($);for(const f of $)this.set(f,o)}else{const $=o.slice(0);(0,p.$Wb)($);for(const f of $)this.set(f[0],f[1])}}set(o,a){const $=this.b.reset(o);let f;this.c||(this.c=new r,this.c.segment=$.value());const n=[];for(f=this.c;;){const d=$.cmp(f.segment);if(d>0)f.left||(f.left=new r,f.left.segment=$.value()),n.push([-1,f]),f=f.left;else if(d<0)f.right||(f.right=new r,f.right.segment=$.value()),n.push([1,f]),f=f.right;else if($.hasNext())$.next(),f.mid||(f.mid=new r,f.mid.segment=$.value()),n.push([0,f]),f=f.mid;else break}const s=f.value;f.value=a,f.key=o;for(let d=n.length-1;d>=0;d--){const y=n[d][1];y.updateHeight();const i=y.balanceFactor();if(i<-1||i>1){const t=n[d][0],c=n[d+1][0];if(t===1&&c===1)n[d][1]=y.rotateLeft();else if(t===-1&&c===-1)n[d][1]=y.rotateRight();else if(t===1&&c===-1)y.right=n[d+1][1]=n[d+1][1].rotateRight(),n[d][1]=y.rotateLeft();else if(t===-1&&c===1)y.left=n[d+1][1]=n[d+1][1].rotateLeft(),n[d][1]=y.rotateRight();else throw new Error;if(d>0)switch(n[d-1][0]){case-1:n[d-1][1].left=n[d][1];break;case 1:n[d-1][1].right=n[d][1];break;case 0:n[d-1][1].mid=n[d][1];break}else this.c=n[0][1]}}return s}get(o){return this.d(o)?.value}d(o){const a=this.b.reset(o);let $=this.c;for(;$;){const f=a.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(a.hasNext())a.next(),$=$.mid;else break}return $}has(o){const a=this.d(o);return!(a?.value===void 0&&a?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,a){const $=this.b.reset(o),f=[];let n=this.c;for(;n;){const s=$.cmp(n.segment);if(s>0)f.push([-1,n]),n=n.left;else if(s<0)f.push([1,n]),n=n.right;else if($.hasNext())$.next(),f.push([0,n]),n=n.mid;else break}if(n){if(a?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const s=this.f(n.right);if(s.key){const{key:d,value:y,segment:i}=s;this.e(s.key,!1),n.key=d,n.value=y,n.segment=i}}else{const s=n.left??n.right;if(f.length>0){const[d,y]=f[f.length-1];switch(d){case-1:y.left=s;break;case 0:y.mid=s;break;case 1:y.right=s;break}}else this.c=s}for(let s=f.length-1;s>=0;s--){const d=f[s][1];d.updateHeight();const y=d.balanceFactor();if(y>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),f[s][1]=d.rotateLeft()):y<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),f[s][1]=d.rotateRight()),s>0)switch(f[s-1][0]){case-1:f[s-1][1].left=f[s][1];break;case 1:f[s-1][1].right=f[s][1];break;case 0:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const a=this.b.reset(o);let $=this.c,f;for(;$;){const n=a.cmp($.segment);if(n>0)$=$.left;else if(n<0)$=$.right;else if(a.hasNext())a.next(),f=$.value||f,$=$.mid;else break}return $&&$.value||f}findSuperstr(o){return this.g(o,!1)}g(o,a){const $=this.b.reset(o);let f=this.c;for(;f;){const n=$.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if($.hasNext())$.next(),f=f.mid;else return f.mid?this.h(f.mid):a?f.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[a,$]of this)o($,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const a=[];return this.j(o,a),a[Symbol.iterator]()}j(o,a){o&&(o.left&&this.j(o.left,a),o.value&&a.push([o.key,o.value]),o.mid&&this.j(o.mid,a),o.right&&this.j(o.right,a))}_isBalanced(){const o=a=>{if(!a)return!0;const $=a.balanceFactor();return $<-1||$>1?!1:o(a.left)&&o(a.right)};return o(this.c)}}e.$Ci=l}),define(fe[10],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=p,e.$0f=S,e.$$f=E,e.$_f=A,e.$ag=j,e.$bg=k,e.$cg=h,e.$dg=r,e.$eg=v,e.$fg=l,e.$gg=P,e.$hg=o,e.$ig=a,e.$jg=f,e.$kg=n,e.$lg=s,e.$mg=d,e.$ng=y;function p(i){return typeof i=="string"}function S(i){return Array.isArray(i)&&i.every(t=>p(t))}function E(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function A(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function j(i){return typeof i=="number"&&!isNaN(i)}function k(i){return!!i&&typeof i[Symbol.iterator]=="function"}function h(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function v(i){return!l(i)}function l(i){return r(i)||i===null}function P(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function o(i){if(l(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function a(...i){const t=[];for(let c=0;c<i.length;c++){const L=i[c];if(l(L))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(L)}return t}const $=Object.prototype.hasOwnProperty;function f(i){if(!E(i))return!1;for(const t in i)if($.call(i,t))return!1;return!0}function n(i){return typeof i=="function"}function s(...i){return i.length>0&&i.every(n)}function d(i,t){const c=Math.min(i.length,t.length);for(let L=0;L<c;L++)y(i[L],t[L])}function y(i,t){if(p(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(n(t)){try{if(i instanceof t)return}catch{}if(!l(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(fe[30],ge([0,1,10]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=S,e.$4n=E,e.$5n=j,e.$6n=h,e.$7n=r,e.$8n=v,e.$9n=l,e.$0n=P,e.$$n=o,e.$_n=a,e.$ao=$,e.$bo=f;function S(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const s=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([d,y])=>{s[d]=y&&typeof y=="object"?S(y):y}),s}function E(n){if(!n||typeof n!="object")return n;const s=[n];for(;s.length>0;){const d=s.shift();Object.freeze(d);for(const y in d)if(A.call(d,y)){const i=d[y];typeof i=="object"&&!Object.isFrozen(i)&&!(0,p.$_f)(i)&&s.push(i)}}return n}const A=Object.prototype.hasOwnProperty;function j(n,s){return k(n,s,new Set)}function k(n,s,d){if((0,p.$fg)(n))return n;const y=s(n);if(typeof y<"u")return y;if(Array.isArray(n)){const i=[];for(const t of n)i.push(k(t,s,d));return i}if((0,p.$$f)(n)){if(d.has(n))throw new Error("Cannot clone recursive data-structure");d.add(n);const i={};for(const t in n)A.call(n,t)&&(i[t]=k(n[t],s,d));return d.delete(n),i}return n}function h(n,s,d=!0){return(0,p.$$f)(n)?((0,p.$$f)(s)&&Object.keys(s).forEach(y=>{y in n?d&&((0,p.$$f)(n[y])&&(0,p.$$f)(s[y])?h(n[y],s[y],d):n[y]=s[y]):n[y]=s[y]}),n):s}function r(n,s){if(n===s)return!0;if(n==null||s===null||s===void 0||typeof n!=typeof s||typeof n!="object"||Array.isArray(n)!==Array.isArray(s))return!1;let d,y;if(Array.isArray(n)){if(n.length!==s.length)return!1;for(d=0;d<n.length;d++)if(!r(n[d],s[d]))return!1}else{const i=[];for(y in n)i.push(y);i.sort();const t=[];for(y in s)t.push(y);if(t.sort(),!r(i,t))return!1;for(d=0;d<i.length;d++)if(!r(n[i[d]],s[i[d]]))return!1}return!0}function v(n){const s=new Set;return JSON.stringify(n,(d,y)=>{if((0,p.$$f)(y)||Array.isArray(y)){if(s.has(y))return"[Circular]";s.add(y)}return typeof y=="bigint"?`[BigInt ${y.toString()}]`:y})}function l(n,s){const d=Object.create(null);return!n||!s||Object.keys(s).forEach(i=>{const t=n[i],c=s[i];r(t,c)||(d[i]=c)}),d}function P(n,s){const d=s.toLowerCase(),y=Object.keys(n).find(i=>i.toLowerCase()===d);return y?n[y]:n[s]}function o(n,s){const d=Object.create(null);for(const[y,i]of Object.entries(n))s(y,i)&&(d[y]=i);return d}function a(n){let s=[];for(;Object.prototype!==n;)s=s.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return s}function $(n){const s=[];for(const d of a(n))typeof n[d]=="function"&&s.push(d);return s}function f(n,s){const d=i=>function(){const t=Array.prototype.slice.call(arguments,0);return s(i,t)},y={};for(const i of n)y[i]=d(i);return y}}),define(fe[52],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=S;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(E){return p.test(E)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(k){for(let h=0;h<k.length;h++)k[h]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),j=[];for(let k=0;k<256;k++)j.push(k.toString(16).padStart(2,"0"));return function(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,r="";return r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r}}()}),define(fe[31],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gX=p;function p(S){return!!S.parentPort}}),define(fe[53],ge([13,11]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(fe[54],ge([0,1,53]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=r,e.$3m=v,e.$4m=l;const S=60,E=S*60,A=E*24,j=A*7,k=A*30,h=A*365;function r(P,o,a,$){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return(0,p.localize)(0,null,r(new Date().getTime()+f*1e3,!1));if(!$&&f<30)return(0,p.localize)(1,null);let n;return f<S?(n=f,o?n===1?a?(0,p.localize)(2,null,n):(0,p.localize)(3,null,n):a?(0,p.localize)(4,null,n):(0,p.localize)(5,null,n):n===1?a?(0,p.localize)(6,null,n):(0,p.localize)(7,null,n):a?(0,p.localize)(8,null,n):(0,p.localize)(9,null,n)):f<E?(n=Math.floor(f/S),o?n===1?a?(0,p.localize)(10,null,n):(0,p.localize)(11,null,n):a?(0,p.localize)(12,null,n):(0,p.localize)(13,null,n):n===1?a?(0,p.localize)(14,null,n):(0,p.localize)(15,null,n):a?(0,p.localize)(16,null,n):(0,p.localize)(17,null,n)):f<A?(n=Math.floor(f/E),o?n===1?a?(0,p.localize)(18,null,n):(0,p.localize)(19,null,n):a?(0,p.localize)(20,null,n):(0,p.localize)(21,null,n):n===1?a?(0,p.localize)(22,null,n):(0,p.localize)(23,null,n):a?(0,p.localize)(24,null,n):(0,p.localize)(25,null,n)):f<j?(n=Math.floor(f/A),o?n===1?(0,p.localize)(26,null,n):(0,p.localize)(27,null,n):n===1?(0,p.localize)(28,null,n):(0,p.localize)(29,null,n)):f<k?(n=Math.floor(f/j),o?n===1?a?(0,p.localize)(30,null,n):(0,p.localize)(31,null,n):a?(0,p.localize)(32,null,n):(0,p.localize)(33,null,n):n===1?a?(0,p.localize)(34,null,n):(0,p.localize)(35,null,n):a?(0,p.localize)(36,null,n):(0,p.localize)(37,null,n)):f<h?(n=Math.floor(f/k),o?n===1?a?(0,p.localize)(38,null,n):(0,p.localize)(39,null,n):a?(0,p.localize)(40,null,n):(0,p.localize)(41,null,n):n===1?a?(0,p.localize)(42,null,n):(0,p.localize)(43,null,n):a?(0,p.localize)(44,null,n):(0,p.localize)(45,null,n)):(n=Math.floor(f/h),o?n===1?a?(0,p.localize)(46,null,n):(0,p.localize)(47,null,n):a?(0,p.localize)(48,null,n):(0,p.localize)(49,null,n):n===1?a?(0,p.localize)(50,null,n):(0,p.localize)(51,null,n):a?(0,p.localize)(52,null,n):(0,p.localize)(53,null,n))}function v(P,o){const a=Math.abs(P/1e3);return a<1?o?(0,p.localize)(54,null,P):(0,p.localize)(55,null,P):a<S?o?(0,p.localize)(56,null,Math.round(P)/1e3):(0,p.localize)(57,null,Math.round(P)/1e3):a<E?o?(0,p.localize)(58,null,Math.round(P/(1e3*S))):(0,p.localize)(59,null,Math.round(P/(1e3*S))):a<A?o?(0,p.localize)(60,null,Math.round(P/(1e3*E))):(0,p.localize)(61,null,Math.round(P/(1e3*E))):(0,p.localize)(62,null,Math.round(P/(1e3*A)))}function l(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[55],ge([13,11]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(fe[56],ge([0,1,16,10,55]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=h,e.$ij=r,e.$jj=v;function A(l,P){return P&&(l.stack||l.stacktrace)?E.localize(0,null,k(l),j(l.stack)||j(l.stacktrace)):k(l)}function j(l){return Array.isArray(l)?l.join(`
`):l}function k(l){return l.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof l.code=="string"&&typeof l.errno=="number"&&typeof l.syscall=="string"?E.localize(1,null,l.message):l.message||E.localize(2,null)}function h(l=null,P=!1){if(!l)return E.localize(3,null);if(Array.isArray(l)){const o=p.$Hb(l),a=h(o[0],P);return o.length>1?E.localize(4,null,a,o.length):a}if(S.$9f(l))return l;if(l.detail){const o=l.detail;if(o.error)return A(o.error,P);if(o.exception)return A(o.exception,P)}return l.stack?A(l,P):l.message?l.message:E.localize(5,null)}function r(l){const P=l;return P instanceof Error&&Array.isArray(P.actions)}function v(l,P){let o;return typeof l=="string"?o=new Error(l):o=l,o.actions=P,o}}),define(fe[57],ge([13,11]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(fe[3],ge([0,1,57]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=c,e.$D=F,e.$J=Q,e.$g="en";let S=!1,E=!1,A=!1,j=!1,k=!1,h=!1,r=!1,v=!1,l=!1,P=!1,o,a=e.$g,$=e.$g,f,n;const s=globalThis;let d;typeof s.vscode<"u"&&typeof s.vscode.process<"u"?d=s.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const y=typeof d?.versions?.electron=="string",i=y&&d?.type==="renderer";if(typeof d=="object"){S=d.platform==="win32",E=d.platform==="darwin",A=d.platform==="linux",j=A&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,r=y,l=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=e.$g,a=e.$g;const U=d.env.VSCODE_NLS_CONFIG;if(U)try{const O=JSON.parse(U),g=O.availableLanguages["*"];o=O.locale,$=O.osLocale,a=g||e.$g,f=O._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!i?(n=navigator.userAgent,S=n.indexOf("Windows")>=0,E=n.indexOf("Macintosh")>=0,v=(n.indexOf("Macintosh")>=0||n.indexOf("iPad")>=0||n.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=n.indexOf("Linux")>=0,P=n?.indexOf("Mobi")>=0,h=!0,o=p.getConfiguredDefaultLocale(p.localize(0,null))||e.$g,a=o,$=navigator.language):console.error("Unable to resolve platform.");var t;(function(U){U[U.Web=0]="Web",U[U.Mac=1]="Mac",U[U.Linux=2]="Linux",U[U.Windows=3]="Windows"})(t||(e.Platform=t={}));function c(U){switch(U){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let L=0;E?L=1:S?L=3:A&&(L=2),e.$i=S,e.$j=E,e.$k=A,e.$l=j,e.$m=k,e.$n=r,e.$o=h,e.$p=h&&typeof s.importScripts=="function",e.$q=e.$p?s.origin:void 0,e.$r=v,e.$s=P,e.$t=l,e.$u=L,e.$v=n,e.$w=a;var m;(function(U){function O(){return e.$w}U.value=O;function g(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}U.isDefaultVariant=g;function I(){return e.$w==="en"}U.isDefault=I})(m||(e.Language=m={})),e.$x=o,e.$y=$,e.$z=f,e.$A=typeof s.postMessage=="function"&&!s.importScripts,e.$B=(()=>{if(e.$A){const U=[];s.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let I=0,b=U.length;I<b;I++){const M=U[I];if(M.id===g.data.vscodeScheduleAsyncWork){U.splice(I,1),M.callback();return}}});let O=0;return g=>{const I=++O;U.push({id:I,callback:g}),s.postMessage({vscodeScheduleAsyncWork:I},"*")}}return U=>setTimeout(U)})();var D;(function(U){U[U.Windows=1]="Windows",U[U.Macintosh=2]="Macintosh",U[U.Linux=3]="Linux"})(D||(e.OperatingSystem=D={})),e.OS=E||v?2:S?1:3;let C=!0,w=!1;function F(){if(!w){w=!0;const U=new Uint8Array(2);U[0]=1,U[1]=2,C=new Uint16Array(U.buffer)[0]===513}return C}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function Q(U){return parseFloat(U)>=20}}),define(fe[15],ge([0,1,3]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let S;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const A=E.process;S={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return p.$i?"win32":p.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=S.cwd,e.env=S.env,e.$dc=S.platform,e.$ec=S.arch}),define(fe[5],ge([0,1,15]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const S=65,E=97,A=90,j=122,k=46,h=47,r=92,v=58,l=63;class P extends Error{constructor(c,L,m){let D;typeof L=="string"&&L.indexOf("not ")===0?(D="must not be",L=L.replace(/^not /,"")):D="must be";const C=c.indexOf(".")!==-1?"property":"argument";let w=`The "${c}" ${C} ${D} of type ${L}`;w+=`. Received type ${typeof m}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function o(t,c){if(t===null||typeof t!="object")throw new P(c,"Object",t)}function a(t,c){if(typeof t!="string")throw new P(c,"string",t)}const $=p.$dc==="win32";function f(t){return t===h||t===r}function n(t){return t===h}function s(t){return t>=S&&t<=A||t>=E&&t<=j}function d(t,c,L,m){let D="",C=0,w=-1,F=0,Q=0;for(let U=0;U<=t.length;++U){if(U<t.length)Q=t.charCodeAt(U);else{if(m(Q))break;Q=h}if(m(Q)){if(!(w===U-1||F===1))if(F===2){if(D.length<2||C!==2||D.charCodeAt(D.length-1)!==k||D.charCodeAt(D.length-2)!==k){if(D.length>2){const O=D.lastIndexOf(L);O===-1?(D="",C=0):(D=D.slice(0,O),C=D.length-1-D.lastIndexOf(L)),w=U,F=0;continue}else if(D.length!==0){D="",C=0,w=U,F=0;continue}}c&&(D+=D.length>0?`${L}..`:"..",C=2)}else D.length>0?D+=`${L}${t.slice(w+1,U)}`:D=t.slice(w+1,U),C=U-w-1;w=U,F=0}else Q===k&&F!==-1?++F:F=-1}return D}function y(t,c){o(c,"pathObject");const L=c.dir||c.root,m=c.base||`${c.name||""}${c.ext||""}`;return L?L===c.root?`${L}${m}`:`${L}${t}${m}`:m}e.$fc={resolve(...t){let c="",L="",m=!1;for(let D=t.length-1;D>=-1;D--){let C;if(D>=0){if(C=t[D],a(C,"path"),C.length===0)continue}else c.length===0?C=p.cwd():(C=p.env[`=${c}`]||p.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==c.toLowerCase()&&C.charCodeAt(2)===r)&&(C=`${c}\\`));const w=C.length;let F=0,Q="",U=!1;const O=C.charCodeAt(0);if(w===1)f(O)&&(F=1,U=!0);else if(f(O))if(U=!0,f(C.charCodeAt(1))){let g=2,I=g;for(;g<w&&!f(C.charCodeAt(g));)g++;if(g<w&&g!==I){const b=C.slice(I,g);for(I=g;g<w&&f(C.charCodeAt(g));)g++;if(g<w&&g!==I){for(I=g;g<w&&!f(C.charCodeAt(g));)g++;(g===w||g!==I)&&(Q=`\\\\${b}\\${C.slice(I,g)}`,F=g)}}}else F=1;else s(O)&&C.charCodeAt(1)===v&&(Q=C.slice(0,2),F=2,w>2&&f(C.charCodeAt(2))&&(U=!0,F=3));if(Q.length>0)if(c.length>0){if(Q.toLowerCase()!==c.toLowerCase())continue}else c=Q;if(m){if(c.length>0)break}else if(L=`${C.slice(F)}\\${L}`,m=U,U&&c.length>0)break}return L=d(L,!m,"\\",f),m?`${c}\\${L}`:`${c}${L}`||"."},normalize(t){a(t,"path");const c=t.length;if(c===0)return".";let L=0,m,D=!1;const C=t.charCodeAt(0);if(c===1)return n(C)?"\\":t;if(f(C))if(D=!0,f(t.charCodeAt(1))){let F=2,Q=F;for(;F<c&&!f(t.charCodeAt(F));)F++;if(F<c&&F!==Q){const U=t.slice(Q,F);for(Q=F;F<c&&f(t.charCodeAt(F));)F++;if(F<c&&F!==Q){for(Q=F;F<c&&!f(t.charCodeAt(F));)F++;if(F===c)return`\\\\${U}\\${t.slice(Q)}\\`;F!==Q&&(m=`\\\\${U}\\${t.slice(Q,F)}`,L=F)}}}else L=1;else s(C)&&t.charCodeAt(1)===v&&(m=t.slice(0,2),L=2,c>2&&f(t.charCodeAt(2))&&(D=!0,L=3));let w=L<c?d(t.slice(L),!D,"\\",f):"";return w.length===0&&!D&&(w="."),w.length>0&&f(t.charCodeAt(c-1))&&(w+="\\"),m===void 0?D?`\\${w}`:w:D?`${m}\\${w}`:`${m}${w}`},isAbsolute(t){a(t,"path");const c=t.length;if(c===0)return!1;const L=t.charCodeAt(0);return f(L)||c>2&&s(L)&&t.charCodeAt(1)===v&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,L;for(let C=0;C<t.length;++C){const w=t[C];a(w,"path"),w.length>0&&(c===void 0?c=L=w:c+=`\\${w}`)}if(c===void 0)return".";let m=!0,D=0;if(typeof L=="string"&&f(L.charCodeAt(0))){++D;const C=L.length;C>1&&f(L.charCodeAt(1))&&(++D,C>2&&(f(L.charCodeAt(2))?++D:m=!1))}if(m){for(;D<c.length&&f(c.charCodeAt(D));)D++;D>=2&&(c=`\\${c.slice(D)}`)}return e.$fc.normalize(c)},relative(t,c){if(a(t,"from"),a(c,"to"),t===c)return"";const L=e.$fc.resolve(t),m=e.$fc.resolve(c);if(L===m||(t=L.toLowerCase(),c=m.toLowerCase(),t===c))return"";let D=0;for(;D<t.length&&t.charCodeAt(D)===r;)D++;let C=t.length;for(;C-1>D&&t.charCodeAt(C-1)===r;)C--;const w=C-D;let F=0;for(;F<c.length&&c.charCodeAt(F)===r;)F++;let Q=c.length;for(;Q-1>F&&c.charCodeAt(Q-1)===r;)Q--;const U=Q-F,O=w<U?w:U;let g=-1,I=0;for(;I<O;I++){const M=t.charCodeAt(D+I);if(M!==c.charCodeAt(F+I))break;M===r&&(g=I)}if(I!==O){if(g===-1)return m}else{if(U>O){if(c.charCodeAt(F+I)===r)return m.slice(F+I+1);if(I===2)return m.slice(F+I)}w>O&&(t.charCodeAt(D+I)===r?g=I:I===2&&(g=3)),g===-1&&(g=0)}let b="";for(I=D+g+1;I<=C;++I)(I===C||t.charCodeAt(I)===r)&&(b+=b.length===0?"..":"\\..");return F+=g,b.length>0?`${b}${m.slice(F,Q)}`:(m.charCodeAt(F)===r&&++F,m.slice(F,Q))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$fc.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===r){if(c.charCodeAt(1)===r){const L=c.charCodeAt(2);if(L!==l&&L!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(s(c.charCodeAt(0))&&c.charCodeAt(1)===v&&c.charCodeAt(2)===r)return`\\\\?\\${c}`;return t},dirname(t){a(t,"path");const c=t.length;if(c===0)return".";let L=-1,m=0;const D=t.charCodeAt(0);if(c===1)return f(D)?t:".";if(f(D)){if(L=m=1,f(t.charCodeAt(1))){let F=2,Q=F;for(;F<c&&!f(t.charCodeAt(F));)F++;if(F<c&&F!==Q){for(Q=F;F<c&&f(t.charCodeAt(F));)F++;if(F<c&&F!==Q){for(Q=F;F<c&&!f(t.charCodeAt(F));)F++;if(F===c)return t;F!==Q&&(L=m=F+1)}}}}else s(D)&&t.charCodeAt(1)===v&&(L=c>2&&f(t.charCodeAt(2))?3:2,m=L);let C=-1,w=!0;for(let F=c-1;F>=m;--F)if(f(t.charCodeAt(F))){if(!w){C=F;break}}else w=!1;if(C===-1){if(L===-1)return".";C=L}return t.slice(0,C)},basename(t,c){c!==void 0&&a(c,"ext"),a(t,"path");let L=0,m=-1,D=!0,C;if(t.length>=2&&s(t.charCodeAt(0))&&t.charCodeAt(1)===v&&(L=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,F=-1;for(C=t.length-1;C>=L;--C){const Q=t.charCodeAt(C);if(f(Q)){if(!D){L=C+1;break}}else F===-1&&(D=!1,F=C+1),w>=0&&(Q===c.charCodeAt(w)?--w===-1&&(m=C):(w=-1,m=F))}return L===m?m=F:m===-1&&(m=t.length),t.slice(L,m)}for(C=t.length-1;C>=L;--C)if(f(t.charCodeAt(C))){if(!D){L=C+1;break}}else m===-1&&(D=!1,m=C+1);return m===-1?"":t.slice(L,m)},extname(t){a(t,"path");let c=0,L=-1,m=0,D=-1,C=!0,w=0;t.length>=2&&t.charCodeAt(1)===v&&s(t.charCodeAt(0))&&(c=m=2);for(let F=t.length-1;F>=c;--F){const Q=t.charCodeAt(F);if(f(Q)){if(!C){m=F+1;break}continue}D===-1&&(C=!1,D=F+1),Q===k?L===-1?L=F:w!==1&&(w=1):L!==-1&&(w=-1)}return L===-1||D===-1||w===0||w===1&&L===D-1&&L===m+1?"":t.slice(L,D)},format:y.bind(null,"\\"),parse(t){a(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const L=t.length;let m=0,D=t.charCodeAt(0);if(L===1)return f(D)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(f(D)){if(m=1,f(t.charCodeAt(1))){let g=2,I=g;for(;g<L&&!f(t.charCodeAt(g));)g++;if(g<L&&g!==I){for(I=g;g<L&&f(t.charCodeAt(g));)g++;if(g<L&&g!==I){for(I=g;g<L&&!f(t.charCodeAt(g));)g++;g===L?m=g:g!==I&&(m=g+1)}}}}else if(s(D)&&t.charCodeAt(1)===v){if(L<=2)return c.root=c.dir=t,c;if(m=2,f(t.charCodeAt(2))){if(L===3)return c.root=c.dir=t,c;m=3}}m>0&&(c.root=t.slice(0,m));let C=-1,w=m,F=-1,Q=!0,U=t.length-1,O=0;for(;U>=m;--U){if(D=t.charCodeAt(U),f(D)){if(!Q){w=U+1;break}continue}F===-1&&(Q=!1,F=U+1),D===k?C===-1?C=U:O!==1&&(O=1):C!==-1&&(O=-1)}return F!==-1&&(C===-1||O===0||O===1&&C===F-1&&C===w+1?c.base=c.name=t.slice(w,F):(c.name=t.slice(w,C),c.base=t.slice(w,F),c.ext=t.slice(C,F))),w>0&&w!==m?c.dir=t.slice(0,w-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if($){const t=/\\/g;return()=>{const c=p.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>p.cwd()})();e.$gc={resolve(...t){let c="",L=!1;for(let m=t.length-1;m>=-1&&!L;m--){const D=m>=0?t[m]:i();a(D,"path"),D.length!==0&&(c=`${D}/${c}`,L=D.charCodeAt(0)===h)}return c=d(c,!L,"/",n),L?`/${c}`:c.length>0?c:"."},normalize(t){if(a(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===h,L=t.charCodeAt(t.length-1)===h;return t=d(t,!c,"/",n),t.length===0?c?"/":L?"./":".":(L&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return a(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let c;for(let L=0;L<t.length;++L){const m=t[L];a(m,"path"),m.length>0&&(c===void 0?c=m:c+=`/${m}`)}return c===void 0?".":e.$gc.normalize(c)},relative(t,c){if(a(t,"from"),a(c,"to"),t===c||(t=e.$gc.resolve(t),c=e.$gc.resolve(c),t===c))return"";const L=1,m=t.length,D=m-L,C=1,w=c.length-C,F=D<w?D:w;let Q=-1,U=0;for(;U<F;U++){const g=t.charCodeAt(L+U);if(g!==c.charCodeAt(C+U))break;g===h&&(Q=U)}if(U===F)if(w>F){if(c.charCodeAt(C+U)===h)return c.slice(C+U+1);if(U===0)return c.slice(C+U)}else D>F&&(t.charCodeAt(L+U)===h?Q=U:U===0&&(Q=0));let O="";for(U=L+Q+1;U<=m;++U)(U===m||t.charCodeAt(U)===h)&&(O+=O.length===0?"..":"/..");return`${O}${c.slice(C+Q)}`},toNamespacedPath(t){return t},dirname(t){if(a(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===h;let L=-1,m=!0;for(let D=t.length-1;D>=1;--D)if(t.charCodeAt(D)===h){if(!m){L=D;break}}else m=!1;return L===-1?c?"/":".":c&&L===1?"//":t.slice(0,L)},basename(t,c){c!==void 0&&a(c,"ext"),a(t,"path");let L=0,m=-1,D=!0,C;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,F=-1;for(C=t.length-1;C>=0;--C){const Q=t.charCodeAt(C);if(Q===h){if(!D){L=C+1;break}}else F===-1&&(D=!1,F=C+1),w>=0&&(Q===c.charCodeAt(w)?--w===-1&&(m=C):(w=-1,m=F))}return L===m?m=F:m===-1&&(m=t.length),t.slice(L,m)}for(C=t.length-1;C>=0;--C)if(t.charCodeAt(C)===h){if(!D){L=C+1;break}}else m===-1&&(D=!1,m=C+1);return m===-1?"":t.slice(L,m)},extname(t){a(t,"path");let c=-1,L=0,m=-1,D=!0,C=0;for(let w=t.length-1;w>=0;--w){const F=t.charCodeAt(w);if(F===h){if(!D){L=w+1;break}continue}m===-1&&(D=!1,m=w+1),F===k?c===-1?c=w:C!==1&&(C=1):c!==-1&&(C=-1)}return c===-1||m===-1||C===0||C===1&&c===m-1&&c===L+1?"":t.slice(c,m)},format:y.bind(null,"/"),parse(t){a(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const L=t.charCodeAt(0)===h;let m;L?(c.root="/",m=1):m=0;let D=-1,C=0,w=-1,F=!0,Q=t.length-1,U=0;for(;Q>=m;--Q){const O=t.charCodeAt(Q);if(O===h){if(!F){C=Q+1;break}continue}w===-1&&(F=!1,w=Q+1),O===k?D===-1?D=Q:U!==1&&(U=1):D!==-1&&(U=-1)}if(w!==-1){const O=C===0&&L?1:C;D===-1||U===0||U===1&&D===w-1&&D===C+1?c.base=c.name=t.slice(O,w):(c.name=t.slice(O,D),c.base=t.slice(O,w),c.ext=t.slice(D,w))}return C>0?c.dir=t.slice(0,C-1):L&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=$?e.$fc.normalize:e.$gc.normalize,e.$ic=$?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=$?e.$fc.join:e.$gc.join,e.$kc=$?e.$fc.resolve:e.$gc.resolve,e.$lc=$?e.$fc.relative:e.$gc.relative,e.$mc=$?e.$fc.dirname:e.$gc.dirname,e.$nc=$?e.$fc.basename:e.$gc.basename,e.$oc=$?e.$fc.extname:e.$gc.extname,e.$pc=$?e.$fc.format:e.$gc.format,e.$qc=$?e.$fc.parse:e.$gc.parse,e.$rc=$?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=$?e.$fc.sep:e.$gc.sep,e.$tc=$?e.$fc.delimiter:e.$gc.delimiter}),define(fe[32],ge([0,1,5,3,9,10]),function(oe,e,p,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=j,e.$pg=k,e.$qg=h,e.$rg=r,e.$sg=v,e.$tg=a,e.$ug=$,e.$vg=f,e.$wg=n,e.$xg=s,e.$yg=d,e.$zg=y,e.$Ag=i,e.$Bg=t,e.$Cg=c,e.$Dg=L,e.$Eg=C;function j(w){return w===47||w===92}function k(w){return w.replace(/[\\/]/g,p.$gc.sep)}function h(w){return w.indexOf("/")===-1&&(w=k(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function r(w,F=p.$gc.sep){if(!w)return"";const Q=w.length,U=w.charCodeAt(0);if(j(U)){if(j(w.charCodeAt(1))&&!j(w.charCodeAt(2))){let g=3;const I=g;for(;g<Q&&!j(w.charCodeAt(g));g++);if(I!==g&&!j(w.charCodeAt(g+1))){for(g+=1;g<Q;g++)if(j(w.charCodeAt(g)))return w.slice(0,g+1).replace(/[\\/]/g,F)}}return F}else if(n(U)&&w.charCodeAt(1)===58)return j(w.charCodeAt(2))?w.slice(0,2)+F:w.slice(0,2);let O=w.indexOf("://");if(O!==-1){for(O+=3;O<Q;O++)if(j(w.charCodeAt(O)))return w.slice(0,O+1)}return""}function v(w){if(!S.$i||!w||w.length<5)return!1;let F=w.charCodeAt(0);if(F!==92||(F=w.charCodeAt(1),F!==92))return!1;let Q=2;const U=Q;for(;Q<w.length&&(F=w.charCodeAt(Q),F!==92);Q++);return!(U===Q||(F=w.charCodeAt(Q+1),isNaN(F)||F===92))}const l=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(w,F=S.$i){const Q=F?l:P;return!(!w||w.length===0||/^\s+$/.test(w)||(Q.lastIndex=0,Q.test(w))||F&&o.test(w)||w==="."||w===".."||F&&w[w.length-1]==="."||F&&w.length!==w.trim().length||w.length>255)}function $(w,F,Q){const U=w===F;return!Q||U?U:!w||!F?!1:(0,E.$xf)(w,F)}function f(w,F,Q,U=p.sep){if(w===F)return!0;if(!w||!F||F.length>w.length)return!1;if(Q){if(!(0,E.$yf)(w,F))return!1;if(F.length===w.length)return!0;let g=F.length;return F.charAt(F.length-1)===U&&g--,w.charAt(g)===U}return F.charAt(F.length-1)!==U&&(F+=U),w.indexOf(F)===0}function n(w){return w>=65&&w<=90||w>=97&&w<=122}function s(w,F){return S.$i&&w.endsWith(":")&&(w+=p.sep),(0,p.$ic)(w)||(w=(0,p.$jc)(F,w)),w=(0,p.$hc)(w),d(w)}function d(w){return S.$i?(w=(0,E.$ff)(w,p.sep),w.endsWith(":")&&(w+=p.sep)):(w=(0,E.$ff)(w,p.sep),w||(w=p.sep)),w}function y(w){const F=(0,p.$hc)(w);return S.$i?w.length>3?!1:i(F)&&(w.length===2||F.charCodeAt(2)===92):F===p.$gc.sep}function i(w,F=S.$i){return F?n(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function t(w,F=S.$i){return i(w,F)?w[0]:void 0}function c(w,F,Q){return F.length>w.length?-1:w===F?0:(Q&&(w=w.toLowerCase(),F=F.toLowerCase()),w.indexOf(F))}function L(w){const F=w.split(":");let Q,U,O;for(const g of F){const I=Number(g);(0,A.$ag)(I)?U===void 0?U=I:O===void 0&&(O=I):Q=Q?[Q,g].join(":"):g}if(!Q)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:Q,line:U!==void 0?U:void 0,column:O!==void 0?O:U!==void 0?1:void 0}}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(w,F,Q=8){let U="";for(let g=0;g<Q;g++){let I;g===0&&S.$i&&!F&&(Q===3||Q===4)?I=D:I=m,U+=I.charAt(Math.floor(Math.random()*I.length))}let O;return F?O=`${F}-${U}`:O=U,w?(0,p.$jc)(w,O):O}}),define(fe[33],ge([0,1,3]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=A,e.$nm=j;var S;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(S||(e.Source=S={}));var E;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function A(k,...h){const r=h.reduce((P,o)=>(P[o]=!0,P),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(P=>!r[P]).forEach(P=>{for(let o=0;o<v.length;o++)if(P.search(v[o])!==-1){delete k[P];break}})}function j(k){k&&(delete k.DEBUG,p.$j&&delete k.DYLD_LIBRARY_PATH,p.$k&&delete k.LD_PRELOAD)}}),define(fe[6],ge([0,1,5,3]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=a,e.$wc=y;const E=/^\w[\w\d+.-]*$/,A=/^\//,j=/^\/\//;function k(m,D){if(!m.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!E.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!A.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(m,D){return!m&&!D?"file":m}function r(m,D){switch(m){case"https":case"http":case"file":D?D[0]!==l&&(D=l+D):D=l;break}return D}const v="",l="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(D){return D instanceof o?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,C,w,F,Q,U=!1){typeof D=="object"?(this.scheme=D.scheme||v,this.authority=D.authority||v,this.path=D.path||v,this.query=D.query||v,this.fragment=D.fragment||v):(this.scheme=h(D,U),this.authority=C||v,this.path=r(this.scheme,w||v),this.query=F||v,this.fragment=Q||v,k(this,U))}get fsPath(){return y(this,!1)}with(D){if(!D)return this;let{scheme:C,authority:w,path:F,query:Q,fragment:U}=D;return C===void 0?C=this.scheme:C===null&&(C=v),w===void 0?w=this.authority:w===null&&(w=v),F===void 0?F=this.path:F===null&&(F=v),Q===void 0?Q=this.query:Q===null&&(Q=v),U===void 0?U=this.fragment:U===null&&(U=v),C===this.scheme&&w===this.authority&&F===this.path&&Q===this.query&&U===this.fragment?this:new f(C,w,F,Q,U)}static parse(D,C=!1){const w=P.exec(D);return w?new f(w[2]||v,L(w[4]||v),L(w[5]||v),L(w[7]||v),L(w[9]||v),C):new f(v,v,v,v,v)}static file(D){let C=v;if(S.$i&&(D=D.replace(/\\/g,l)),D[0]===l&&D[1]===l){const w=D.indexOf(l,2);w===-1?(C=D.substring(2),D=l):(C=D.substring(2,w),D=D.substring(w)||l)}return new f("file",C,D,v,v)}static from(D,C){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,C)}static joinPath(D,...C){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return S.$i&&D.scheme==="file"?w=o.file(p.$fc.join(y(D,!0),...C)).path:w=p.$gc.join(D.path,...C),D.with({path:w})}toString(D=!1){return i(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof o)return D;{const C=new f(D);return C._formatted=D.external??null,C._fsPath=D._sep===$?D.fsPath??null:null,C}}else return D}}e.URI=o;function a(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}const $=S.$i?1:void 0;class f extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(D=!1){return D?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const D={$mid:1};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=$),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function s(m,D,C){let w,F=-1;for(let Q=0;Q<m.length;Q++){const U=m.charCodeAt(Q);if(U>=97&&U<=122||U>=65&&U<=90||U>=48&&U<=57||U===45||U===46||U===95||U===126||D&&U===47||C&&U===91||C&&U===93||C&&U===58)F!==-1&&(w+=encodeURIComponent(m.substring(F,Q)),F=-1),w!==void 0&&(w+=m.charAt(Q));else{w===void 0&&(w=m.substr(0,Q));const O=n[U];O!==void 0?(F!==-1&&(w+=encodeURIComponent(m.substring(F,Q)),F=-1),w+=O):F===-1&&(F=Q)}}return F!==-1&&(w+=encodeURIComponent(m.substring(F))),w!==void 0?w:m}function d(m){let D;for(let C=0;C<m.length;C++){const w=m.charCodeAt(C);w===35||w===63?(D===void 0&&(D=m.substr(0,C)),D+=n[w]):D!==void 0&&(D+=m[C])}return D!==void 0?D:m}function y(m,D){let C;return m.authority&&m.path.length>1&&m.scheme==="file"?C=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?D?C=m.path.substr(1):C=m.path[1].toLowerCase()+m.path.substr(2):C=m.path,S.$i&&(C=C.replace(/\//g,"\\")),C}function i(m,D){const C=D?d:s;let w="",{scheme:F,authority:Q,path:U,query:O,fragment:g}=m;if(F&&(w+=F,w+=":"),(Q||F==="file")&&(w+=l,w+=l),Q){let I=Q.indexOf("@");if(I!==-1){const b=Q.substr(0,I);Q=Q.substr(I+1),I=b.lastIndexOf(":"),I===-1?w+=C(b,!1,!1):(w+=C(b.substr(0,I),!1,!1),w+=":",w+=C(b.substr(I+1),!1,!0)),w+="@"}Q=Q.toLowerCase(),I=Q.lastIndexOf(":"),I===-1?w+=C(Q,!1,!0):(w+=C(Q.substr(0,I),!1,!0),w+=Q.substr(I))}if(U){if(U.length>=3&&U.charCodeAt(0)===47&&U.charCodeAt(2)===58){const I=U.charCodeAt(1);I>=65&&I<=90&&(U=`/${String.fromCharCode(I+32)}:${U.substr(3)}`)}else if(U.length>=2&&U.charCodeAt(1)===58){const I=U.charCodeAt(0);I>=65&&I<=90&&(U=`${String.fromCharCode(I+32)}:${U.substr(2)}`)}w+=C(U,!0,!1)}return O&&(w+="?",w+=C(O,!1,!1)),g&&(w+="#",w+=D?g:s(g,!1,!1)),w}function t(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+t(m.substr(3)):m}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(m){return m.match(c)?m.replace(c,D=>t(D)):m}}),define(fe[58],ge([0,1,6]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=S,e.$Wq=E,e.$Xq=A,e.log=k;function S(r){const v=r;return v&&typeof v.type=="string"&&typeof v.severity=="string"}function E(r){const v=[];let l;try{const P=JSON.parse(r.arguments),o=P[P.length-1];o&&o.__$stack&&(P.pop(),l=o.__$stack),v.push(...P)}catch{v.push("Unable to log remote console arguments",r.arguments)}return{args:v,stack:l}}function A(r){if(typeof r!="string")return A(E(r).stack);const v=r;if(v){const l=j(v),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(l||"");if(P&&P.length===4)return{uri:p.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}function j(r){if(!r)return r;const v=r.indexOf(`
`);return v===-1?r:r.substring(0,v)}function k(r,v){const{args:l,stack:P}=E(r),o=typeof l[0]=="string"&&l.length===1;let a=j(P);a&&(a=`(${a.trim()})`);let $=[];if(typeof l[0]=="string"?a&&o?$=[`%c[${v}] %c${l[0]} %c${a}`,h("blue"),h(""),h("grey")]:$=[`%c[${v}] %c${l[0]}`,h("blue"),h(""),...l.slice(1)]:$=[`%c[${v}]%`,h("blue"),...l],a&&!o&&$.push(a),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,$)}function h(r){return`color: ${r}`}}),define(fe[59],ge([0,1,18,6]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=E,e.$5h=A,e.$6h=k;function E(h){return JSON.stringify(h,j)}function A(h){let r=JSON.parse(h);return r=k(r),r}function j(h,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:r.flags}:r}function k(h,r=0){if(!h||r>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return S.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof p.$Fe||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let v=0;v<h.length;++v)h[v]=k(h[v],r+1);else for(const v in h)Object.hasOwnProperty.call(h,v)&&(h[v]=k(h[v],r+1))}return h}}),define(fe[19],ge([0,1,7,3,9,6,5]),function(oe,e,p,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=h,e.$Gg=r,e.$Kg=l;var k;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(k||(e.Schemas=k={}));function h(a,$){return A.URI.isUri(a)?(0,E.$xf)(a.scheme,$):(0,E.$yf)(a,$+":")}function r(a,...$){return $.some(f=>h(a,f))}e.$Hg="vscode-tkn",e.$Ig="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($,f){this.f=l($,f)}getServerRootPath(){return this.f}get g(){return j.$gc.join(this.f,k.vscodeRemoteResource)}set($,f,n){this.a[$]=f,this.b[$]=n}setConnectionToken($,f){this.c[$]=f}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(i){return p.$1(i),$}const f=$.authority;let n=this.a[f];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this.b[f],d=this.c[f];let y=`path=${encodeURIComponent($.path)}`;return typeof d=="string"&&(y+=`&${e.$Ig}=${encodeURIComponent(d)}`),A.URI.from({scheme:S.$o?this.d:k.vscodeRemoteResource,authority:`${n}:${s}`,path:this.g,query:y})}}e.$Jg=new v;function l(a,$){return j.$gc.join($??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class P{static{this.a=e.$Pg}asBrowserUri($){const f=this.b($,oe);return this.uriToBrowserUri(f)}uriToBrowserUri($){return $.scheme===k.vscodeRemote?e.$Jg.rewrite($):$.scheme===k.file&&(S.$m||S.$q===`${k.vscodeFileResource}://${P.a}`)?$.with({scheme:k.vscodeFileResource,authority:$.authority||P.a,query:null,fragment:null}):$}asFileUri($){const f=this.b($,oe);return this.uriToFileUri(f)}uriToFileUri($){return $.scheme===k.vscodeFileResource?$.with({scheme:k.file,authority:$.authority!==P.a?$.authority:null,query:null,fragment:null}):$}b($,f){return A.URI.isUri($)?$:A.URI.parse(f.toUrl($))}}e.$Qg=new P;var o;(function(a){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze($.get("3"));const f="vscode-coi";function n(d){let y;typeof d=="string"?y=new URL(d).searchParams:d instanceof URL?y=d.searchParams:A.URI.isUri(d)&&(y=new URL(d.toString(!0)).searchParams);const i=y?.get(f);if(i)return $.get(i)}a.getHeadersFromQuery=n;function s(d,y,i){if(!globalThis.crossOriginIsolated)return;const t=y&&i?"3":i?"2":"1";d instanceof URLSearchParams?d.set(f,t):d[f]=t}a.addSearchParam=s})(o||(e.COI=o={}))}),define(fe[23],ge([0,1,32,19,5,3,9,6]),function(oe,e,p,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=h,e.$gh=v,e.$hh=P;function h(o){return(0,k.$wc)(o,!0)}class r{constructor(a){this.a=a}compare(a,$,f=!1){return a===$?0:(0,j.$qf)(this.getComparisonKey(a,f),this.getComparisonKey($,f))}isEqual(a,$,f=!1){return a===$?!0:!a||!$?!1:this.getComparisonKey(a,f)===this.getComparisonKey($,f)}getComparisonKey(a,$=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,$,f=!1){if(a.scheme===$.scheme){if(a.scheme===S.Schemas.file)return p.$vg(h(a),h($),this.a(a))&&a.query===$.query&&(f||a.fragment===$.fragment);if((0,e.$ch)(a.authority,$.authority))return p.$vg(a.path,$.path,this.a(a),"/")&&a.query===$.query&&(f||a.fragment===$.fragment)}return!1}joinPath(a,...$){return k.URI.joinPath(a,...$)}basenameOrAuthority(a){return(0,e.$7g)(a)||a.authority}basename(a){return E.$gc.basename(a.path)}extname(a){return E.$gc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let $;return a.scheme===S.Schemas.file?$=k.URI.file(E.$mc(h(a))).path:($=E.$gc.dirname(a.path),a.authority&&$.length&&$.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),$="/")),a.with({path:$})}normalizePath(a){if(!a.path.length)return a;let $;return a.scheme===S.Schemas.file?$=k.URI.file(E.$hc(h(a))).path:$=E.$gc.normalize(a.path),a.with({path:$})}relativePath(a,$){if(a.scheme!==$.scheme||!(0,e.$ch)(a.authority,$.authority))return;if(a.scheme===S.Schemas.file){const s=E.$lc(h(a),h($));return A.$i?p.$pg(s):s}let f=a.path||"/";const n=$.path||"/";if(this.a(a)){let s=0;for(const d=Math.min(f.length,n.length);s<d&&!(f.charCodeAt(s)!==n.charCodeAt(s)&&f.charAt(s).toLowerCase()!==n.charAt(s).toLowerCase());s++);f=n.substr(0,s)+f.substr(s)}return E.$gc.relative(f,n)}resolvePath(a,$){if(a.scheme===S.Schemas.file){const f=k.URI.file(E.$kc(h(a),$));return a.with({authority:f.authority,path:f.path})}return $=p.$qg($),a.with({path:E.$gc.resolve(a.path,$)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,$){return a===$||a!==void 0&&$!==void 0&&(0,j.$xf)(a,$)}hasTrailingPathSeparator(a,$=E.sep){if(a.scheme===S.Schemas.file){const f=h(a);return f.length>p.$rg(f).length&&f[f.length-1]===$}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,$=E.sep){return(0,e.$dh)(a,$)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,$=E.sep){let f=!1;if(a.scheme===S.Schemas.file){const n=h(a);f=n!==void 0&&n.length===p.$rg(n).length&&n[n.length-1]===$}else{$="/";const n=a.path;f=n.length===1&&n.charCodeAt(n.length-1)===47}return!f&&!(0,e.$dh)(a,$)?a.with({path:a.path+"/"}):a}}e.$Yg=r,e.$Zg=new r(()=>!1),e.$1g=new r(o=>o.scheme===S.Schemas.file?!A.$k:!0),e.$2g=new r(o=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function v(o,a){const $=[];for(let f=0;f<o.length;f++){const n=a(o[f]);o.some((s,d)=>d===f?!1:(0,e.$4g)(n,a(s)))||$.push(o[f])}return $}var l;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function a($){const f=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(d=>{const[y,i]=d.split(":");y&&i&&f.set(y,i)});const s=$.path.substring(0,$.path.indexOf(";"));return s&&f.set(o.META_DATA_MIME,s),f}o.parseMetaData=a})(l||(e.DataUri=l={}));function P(o,a,$){if(a){let f=o.path;return f&&f[0]!==E.$gc.sep&&(f=E.$gc.sep+f),o.with({scheme:$,authority:a,path:f})}return o.with({scheme:$})}}),define(fe[12],ge([0,1,17,7,4,2,23,3,50,22]),function(oe,e,p,S,E,A,j,k,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=v,e.$jh=l,e.$kh=P,e.$lh=o,e.$mh=a,e.$nh=$,e.$oh=f,e.$ph=n,e.$xh=C,e.$yh=w,e.$zh=F,e.$Ah=Q,e.$Bh=U,e.$Qh=q,e.$Yh=X;function v(H){return!!H&&typeof H.then=="function"}function l(H){const R=new p.$oe,Y=H(R.token),te=new Promise((ce,se)=>{const he=R.token.onCancellationRequested(()=>{he.dispose(),se(new S.$5)});Promise.resolve(Y).then($e=>{he.dispose(),R.dispose(),ce($e)},$e=>{he.dispose(),R.dispose(),se($e)})});return new class{cancel(){R.cancel(),R.dispose()}then(ce,se){return te.then(ce,se)}catch(ce){return this.then(void 0,ce)}finally(ce){return te.finally(ce)}}}function P(H,R,Y){return new Promise((te,ce)=>{const se=R.onCancellationRequested(()=>{se.dispose(),te(Y)});H.then(te,ce).finally(()=>se.dispose())})}function o(H,R){return new Promise((Y,te)=>{const ce=R.onCancellationRequested(()=>{ce.dispose(),te(new S.$5)});H.then(Y,te).finally(()=>ce.dispose())})}async function a(H){let R=-1;const Y=H.map((te,ce)=>te.then(se=>(R=ce,se)));try{return await Promise.race(Y)}finally{H.forEach((te,ce)=>{ce!==R&&te.cancel()})}}function $(H,R,Y){let te;const ce=setTimeout(()=>{te?.(void 0),Y?.()},R);return Promise.race([H.finally(()=>clearTimeout(ce)),new Promise(se=>te=se)])}function f(H){return new Promise((R,Y)=>{const te=H();v(te)?te.then(R,Y):R(te)})}function n(){let H,R;return{promise:new Promise((te,ce)=>{H=te,R=ce}),resolve:H,reject:R}}class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=R,!this.b){const Y=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(Y,Y).then(te)})}return new Promise((Y,te)=>{this.b.then(Y,te)})}return this.a=R(),new Promise((Y,te)=>{this.a.then(ce=>{this.a=null,Y(ce)},ce=>{this.a=null,te(ce)})})}dispose(){this.f=!0}}e.$qh=s;class d{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$rh=d;class y{constructor(){this.a=new Map}queue(R,Y){const ce=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(R)===ce&&this.a.delete(R)});return this.a.set(R,ce),ce}}e.$sh=y;const i=(H,R)=>{let Y=!0;const te=setTimeout(()=>{Y=!1,R()},H);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(te),Y=!1}}},t=H=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,H())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class c{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,Y=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((ce,se)=>{this.d=ce,this.f=se}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=Y===h.$ae?t(te):i(Y,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=c;class L{constructor(R){this.a=new c(R),this.b=new s}trigger(R,Y){return this.a.trigger(()=>this.b.queue(R),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=L;class m{constructor(){this.a=!1,this.b=new Promise((R,Y)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=m;class D extends m{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$wh=D;function C(H,R){return R?new Promise((Y,te)=>{const ce=setTimeout(()=>{se.dispose(),Y()},H),se=R.onCancellationRequested(()=>{clearTimeout(ce),se.dispose(),te(new S.$5)})}):l(Y=>C(H,Y))}function w(H,R=0,Y){const te=setTimeout(()=>{H(),Y&&ce.dispose()},R),ce=(0,A.$Sc)(()=>{clearTimeout(te),Y?.deleteAndLeak(ce)});return Y?.add(ce),ce}function F(H){const R=[];let Y=0;const te=H.length;function ce(){return Y<te?H[Y++]():null}function se(he){he!=null&&R.push(he);const $e=ce();return $e?$e.then(se):Promise.resolve(R)}return Promise.resolve(null).then(se)}function Q(H,R=te=>!!te,Y=null){let te=0;const ce=H.length,se=()=>{if(te>=ce)return Promise.resolve(Y);const he=H[te++];return Promise.resolve(he()).then(we=>R(we)?Promise.resolve(we):se())};return se()}function U(H,R=te=>!!te,Y=null){if(H.length===0)return Promise.resolve(Y);let te=H.length;const ce=()=>{te=-1;for(const se of H)se.cancel?.()};return new Promise((se,he)=>{for(const $e of H)$e.then(we=>{--te>=0&&R(we)?(ce(),se(we)):te===0&&se(Y)}).catch(we=>{--te>=0&&(ce(),he(we))})})}class O{constructor(R){this.a=0,this.b=!1,this.f=R,this.g=[],this.d=0,this.h=new E.$de}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(R){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,te)=>{this.g.push({factory:R,c:Y,e:te}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const R=this.g.shift();this.d++;const Y=R.factory();Y.then(R.c,R.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=O;class g extends O{constructor(){super(1)}}e.$Dh=g;class I{constructor(){this.a=new K,this.b=0}queue(R){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,R())):this.a.run(this.b++,R())}}e.$Eh=I;class b{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const R=new B;return this.b.add(R),R.p}g(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueSize(R,Y=j.$Zg){const te=Y.getComparisonKey(R);return this.a.get(te)?.size??0}queueFor(R,Y,te=j.$Zg){const ce=te.getComparisonKey(R);let se=this.a.get(ce);if(!se){se=new g;const he=this.f++,$e=E.Event.once(se.onDrained)(()=>{se?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(he,$e),this.a.set(ce,se)}return se.queue(Y)}h(){this.g()&&this.j()}j(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=b;class M{constructor(R,Y){this.a=-1,typeof R=="function"&&typeof Y=="number"&&this.setIfNotSet(R,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},Y)}setIfNotSet(R,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},Y))}}e.$Gh=M;class Z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(R,Y,te=globalThis){this.cancel();const ce=te.setInterval(()=>{R()},Y);this.d=(0,A.$Sc)(()=>{te.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=Z;class ie{constructor(R,Y){this.b=-1,this.a=R,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=ie;class V{constructor(R,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=R,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=V;class ee extends ie{constructor(R,Y){super(R,Y),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$Kh=ee;class ae extends A.$Uc{constructor(R,Y){super(),this.g=R,this.h=Y,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of R)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=ae,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(H,R)=>{(0,k.$B)(()=>{if(Y)return;const te=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Nh=(H,R,Y)=>{const te=H.requestIdleCallback(R,typeof Y=="number"?{timeout:Y}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,H.cancelIdleCallback(te))}}},e.$Mh=H=>(0,e.$Nh)(globalThis,H)}();class le{constructor(R,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$Nh)(R,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=le;class G extends le{constructor(R){super(globalThis,R)}}e.$Ph=G;async function q(H,R,Y){let te;for(let ce=0;ce<Y;ce++)try{return await H()}catch(se){te=se,await C(R)}throw te}class K{isRunning(R){return typeof R=="number"?this.a?.taskId===R:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(R,Y,te){return this.a={taskId:R,cancel:()=>te?.(),promise:Y},Y.then(()=>this.d(R),()=>this.d(R)),Y}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this.b)this.b.run=R;else{const{promise:Y,resolve:te,reject:ce}=n();this.b={run:R,promise:Y,promiseResolve:te,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=K;class _{constructor(R,Y=()=>Date.now()){this.d=R,this.f=Y,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$Sh=_;var de;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(de||(de={}));class B{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,Y)=>{this.a=R,this.b=Y})}complete(R){return new Promise(Y=>{this.a(R),this.d={outcome:0,value:R},Y()})}error(R){return new Promise(Y=>{this.b(R),this.d={outcome:1,value:R},Y()})}cancel(){return this.error(new S.$5)}}e.$Th=B;var ue;(function(H){async function R(te){let ce;const se=await Promise.all(te.map(he=>he.then($e=>$e,$e=>{ce||(ce=$e)})));if(typeof ce<"u")throw ce;return se}H.settled=R;function Y(te){return new Promise(async(ce,se)=>{try{await te(ce,se)}catch(he){se(he)}})}H.withAsyncBody=Y})(ue||(e.Promises=ue={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(R){this.a=void 0,this.b=void 0,this.d=!1,this.promise=R.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=x;class u{constructor(R){this.b=R,this.a=new r.$V(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=u;var z;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(z||(z={}));class ne{static fromArray(R){return new ne(Y=>{Y.emitMany(R)})}static fromPromise(R){return new ne(async Y=>{Y.emitMany(await R)})}static fromPromises(R){return new ne(async Y=>{await Promise.all(R.map(async te=>Y.emitOne(await te)))})}static merge(R){return new ne(async Y=>{await Promise.all(R.map(async te=>{for await(const ce of te)Y.emitOne(ce)}))})}static{this.EMPTY=ne.fromArray([])}constructor(R,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new E.$de,queueMicrotask(async()=>{const te={emitOne:ce=>this.h(ce),emitMany:ce=>this.j(ce),reject:ce=>this.l(ce)};try{await Promise.resolve(R(te)),this.k()}catch(ce){this.l(ce)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(R,Y){return new ne(async te=>{for await(const ce of R)te.emitOne(Y(ce))})}map(R){return ne.map(this,R)}static filter(R,Y){return new ne(async te=>{for await(const ce of R)Y(ce)&&te.emitOne(ce)})}filter(R){return ne.filter(this,R)}static coalesce(R){return ne.filter(R,Y=>!!Y)}coalesce(){return ne.coalesce(this)}static async toPromise(R){const Y=[];for await(const te of R)Y.push(te);return Y}toPromise(){return ne.toPromise(this)}h(R){this.a===0&&(this.b.push(R),this.g.fire())}j(R){this.a===0&&(this.b=this.b.concat(R),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(R){this.a===0&&(this.a=2,this.d=R,this.g.fire())}}e.$Wh=ne;class N extends ne{constructor(R,Y){super(Y),this.m=R}cancel(){this.m.cancel()}}e.$Xh=N;function X(H){const R=new p.$oe,Y=H(R.token);return new N(R,async te=>{const ce=R.token.onCancellationRequested(()=>{ce.dispose(),R.dispose(),te.reject(new S.$5)});try{for await(const se of Y){if(R.token.isCancellationRequested)return;te.emitOne(se)}ce.dispose(),R.dispose()}catch(se){ce.dispose(),R.dispose(),te.reject(se)}})}class W{constructor(R){this.a=new B,this.b=new ne(ce=>{if(Y){ce.reject(Y);return}return te&&ce.emitMany(te),this.d=se=>ce.reject(se),this.f=se=>ce.emitOne(se),this.a.p},R);let Y,te;this.f=ce=>{te||(te=[]),te.push(ce)},this.d=ce=>{Y||(Y=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(R){this.d(R),this.a.complete()}emitOne(R){this.f(R)}}e.$Zh=W}),define(fe[60],ge([0,1,18,6]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=k,e.$Bn=r,e.$Cn=v;function E(l){return l.toJSON()}class A{constructor(P){this.a=P}transformIncoming(P){const o=this.a.transformIncoming(P);return o===P?P:E(S.URI.from(o))}transformOutgoing(P){const o=this.a.transformOutgoing(P);return o===P?P:E(S.URI.from(o))}transformOutgoingURI(P){const o=this.a.transformOutgoing(P);return o===P?P:S.URI.from(o)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$yn=A,e.$zn=new class{transformIncoming(l){return l}transformOutgoing(l){return l}transformOutgoingURI(l){return l}transformOutgoingScheme(l){return l}};function j(l,P,o){if(!l||o>200)return null;if(typeof l=="object"){if(l instanceof S.URI)return P.transformOutgoing(l);for(const a in l)if(Object.hasOwnProperty.call(l,a)){const $=j(l[a],P,o+1);$!==null&&(l[a]=$)}}return null}function k(l,P){const o=j(l,P,0);return o===null?l:o}function h(l,P,o,a){if(!l||a>200)return null;if(typeof l=="object"){if(l.$mid===1)return o?S.URI.revive(P.transformIncoming(l)):P.transformIncoming(l);if(l instanceof p.$Fe)return null;for(const $ in l)if(Object.hasOwnProperty.call(l,$)){const f=h(l[$],P,o,a+1);f!==null&&(l[$]=f)}}return null}function r(l,P){const o=h(l,P,!1,0);return o===null?l:o}function v(l,P){const o=h(l,P,!0,0);return o===null?l:o}}),define(fe[24],ge([0,1,106,20,107,12,32,45,5,3,23,6]),function(oe,e,p,S,E,A,j,k,h,r,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=d,e.whenDeleted=t,e.configureFlushOnWrite=C,e.writeFileSync=F;var P;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(P||(e.RimRafMode=P={}));async function o(V,ee=P.UNLINK,ae){if((0,j.$zg)(V))throw new Error("rimraf - will refuse to recursively delete root");return ee===P.UNLINK?$(V):a(V,ae)}async function a(V,ee=(0,j.$Eg)((0,S.tmpdir)())){try{try{await p.promises.rename(V,ee)}catch(ae){return ae.code==="ENOENT"?void 0:$(V)}$(ee).catch(ae=>{})}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function $(V){return(0,E.promisify)(p.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function f(V){if((0,j.$zg)(V))throw new Error("rimraf - will refuse to recursively delete root");p.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function n(V,ee){return y(await(ee?s(V):(0,E.promisify)(p.readdir)(V)))}async function s(V){try{return await(0,E.promisify)(p.readdir)(V,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const ee=[],ae=await n(V);for(const le of ae){let G=!1,q=!1,K=!1;try{const _=await e.Promises.lstat((0,h.$jc)(V,le));G=_.isFile(),q=_.isDirectory(),K=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}ee.push({name:le,isFile:()=>G,isDirectory:()=>q,isSymbolicLink:()=>K})}return ee}function d(V){return y(p.readdirSync(V))}function y(V){return V.map(ee=>typeof ee=="string"?r.$j?(0,k.$bm)(ee):ee:(ee.name=r.$j?(0,k.$bm)(ee.name):ee.name,ee))}async function i(V){const ee=await n(V),ae=[];for(const le of ee)await c.existsDirectory((0,h.$jc)(V,le))&&ae.push(le);return ae}function t(V,ee=1e3){return new Promise(ae=>{let le=!1;const G=setInterval(()=>{le||(le=!0,p.access(V,q=>{le=!1,q&&(clearInterval(G),ae(void 0))}))},ee)})}var c;(function(V){async function ee(G){let q;try{if(q=await e.Promises.lstat(G),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(r.$i&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw _}throw K}}V.stat=ee;async function ae(G){try{const{stat:q,symbolicLink:K}=await V.stat(G);return q.isFile()&&K?.dangling!==!0}catch{}return!1}V.existsFile=ae;async function le(G){try{const{stat:q,symbolicLink:K}=await V.stat(G);return q.isDirectory()&&K?.dangling!==!0}catch{}return!1}V.existsDirectory=le})(c||(e.SymlinkSupport=c={}));const L=new A.$Fh;function m(V,ee,ae){return L.queueFor(l.URI.file(V),()=>{const le=Q(ae);return new Promise((G,q)=>w(V,ee,le,K=>K?q(K):G()))},v.$1g)}let D=!0;function C(V){D=V}function w(V,ee,ae,le){if(!D)return p.writeFile(V,ee,{mode:ae.mode,flag:ae.flag},le);p.open(V,ae.flag,ae.mode,(G,q)=>{if(G)return le(G);p.writeFile(q,ee,K=>{if(K)return p.close(q,()=>le(K));p.fdatasync(q,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),C(!1)),p.close(q,de=>le(de))))})})}function F(V,ee,ae){const le=Q(ae);if(!D)return p.writeFileSync(V,ee,{mode:le.mode,flag:le.flag});const G=p.openSync(V,le.flag,le.mode);try{p.writeFileSync(G,ee);try{p.fdatasyncSync(G)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),C(!1)}}finally{p.closeSync(G)}}function Q(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function U(V,ee,ae=6e4){if(V!==ee)try{r.$i&&typeof ae=="number"?await O(V,ee,Date.now(),ae):await(0,E.promisify)(p.rename)(V,ee)}catch(le){if(V.toLowerCase()!==ee.toLowerCase()&&le.code==="EXDEV"||V.endsWith("."))await g(V,ee,{preserveSymlinks:!1}),await o(V,P.MOVE);else throw le}}async function O(V,ee,ae,le,G=0){try{return await(0,E.promisify)(p.rename)(V,ee)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-ae>=le)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${q}`),q;if(G===0){let K=!1;try{const{stat:_}=await c.stat(ee);_.isFile()||(K=!0)}catch{}if(K)throw q}return await(0,A.$xh)(Math.min(100,G*10)),O(V,ee,ae,le,G+1)}}async function g(V,ee,ae){return b(V,ee,{root:{source:V,target:ee},options:ae,handledSourcePaths:new Set})}const I=511;async function b(V,ee,ae){if(ae.handledSourcePaths.has(V))return;ae.handledSourcePaths.add(V);const{stat:le,symbolicLink:G}=await c.stat(V);if(G){if(ae.options.preserveSymlinks)try{return await ie(V,ee,ae)}catch{}if(G.dangling)return}return le.isDirectory()?M(V,ee,le.mode&I,ae):Z(V,ee,le.mode&I)}async function M(V,ee,ae,le){await e.Promises.mkdir(ee,{recursive:!0,mode:ae});const G=await n(V);for(const q of G)await b((0,h.$jc)(V,q),(0,h.$jc)(ee,q),le)}async function Z(V,ee,ae){await e.Promises.copyFile(V,ee),await e.Promises.chmod(ee,ae)}async function ie(V,ee,ae){let le=await e.Promises.readlink(V);(0,j.$vg)(le,ae.root.source,!r.$k)&&(le=(0,h.$jc)(ae.root.target,le.substr(ae.root.source.length+1))),await e.Promises.symlink(le,ee)}e.Promises=new class{get access(){return(0,E.promisify)(p.access)}get stat(){return(0,E.promisify)(p.stat)}get lstat(){return(0,E.promisify)(p.lstat)}get utimes(){return(0,E.promisify)(p.utimes)}get read(){return(V,ee,ae,le,G)=>new Promise((q,K)=>{p.read(V,ee,ae,le,G,(_,de,B)=>_?K(_):q({bytesRead:de,buffer:B}))})}get readFile(){return(0,E.promisify)(p.readFile)}get write(){return(V,ee,ae,le,G)=>new Promise((q,K)=>{p.write(V,ee,ae,le,G,(_,de,B)=>_?K(_):q({bytesWritten:de,buffer:B}))})}get appendFile(){return(0,E.promisify)(p.appendFile)}get fdatasync(){return(0,E.promisify)(p.fdatasync)}get truncate(){return(0,E.promisify)(p.truncate)}get copyFile(){return(0,E.promisify)(p.copyFile)}get open(){return(0,E.promisify)(p.open)}get close(){return(0,E.promisify)(p.close)}get symlink(){return(0,E.promisify)(p.symlink)}get readlink(){return(0,E.promisify)(p.readlink)}get chmod(){return(0,E.promisify)(p.chmod)}get mkdir(){return(0,E.promisify)(p.mkdir)}get unlink(){return(0,E.promisify)(p.unlink)}get rmdir(){return(0,E.promisify)(p.rmdir)}get realpath(){return(0,E.promisify)(p.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return n}get readDirsInDir(){return i}get writeFile(){return m}get rm(){return o}get rename(){return U}get copy(){return g}}}),define(fe[61],ge([0,1,20,5,24]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=s,e.$lm=d;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var h;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(h||(h={}));let r;switch(process.arch){case"ia32":r=1;break;case"arm":case"arm64":r=2;break;default:r=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class l{constructor(i,t,c){this.exePath=i,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function P({useAlternateBitness:y=!1}={}){return y?r===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function o({useAlternateBitness:y=!1,findPreview:i=!1}={}){const t=P({useAlternateBitness:y});if(!t)return null;const c=S.$jc(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(c))return null;let L=-1,m=null;for(const w of await E.Promises.readdir(c)){let F=-1;if(i){const U=w.indexOf("-");if(U<0)continue;const O=w.substring(0,U);if(!A.test(O)||w.substring(U+1)!=="preview")continue;F=parseInt(O,10)}else{if(!A.test(w))continue;F=parseInt(w,10)}if(F<=L)continue;const Q=S.$jc(c,w,"pwsh.exe");await E.SymlinkSupport.existsFile(Q)&&(m=Q,L=F)}if(!m)return null;const D=t.includes("x86")?" (x86)":"",C=i?" Preview":"";return new l(m,`PowerShell${C}${D}`,!0)}async function a({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const i=S.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=y?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const L of await E.Promises.readdir(i))if(t.test(L)){const m=S.$jc(i,L,"pwsh.exe");return new l(m,c)}return null}function $(){const y=S.$jc(p.homedir(),".dotnet","tools","pwsh.exe");return new l(y,".NET Core PowerShell Global Tool")}function f(){const y=S.$jc(process.env.windir,r===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new l(y,"Windows PowerShell",!0)}async function*n(){let y=await o();y&&(yield y),y=await o({useAlternateBitness:!0}),y&&(yield y),y=await a(),y&&(yield y),y=$(),y&&(yield y),y=await o({findPreview:!0}),y&&(yield y),y=await a({findPreview:!0}),y&&(yield y),y=await o({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=f(),y&&(yield y)}async function*s(){for await(const y of n())await y.exists()&&(yield y)}async function d(){for await(const y of s())return y;return null}}),define(fe[34],ge([0,1,5,3,15,33,10,24]),function(oe,e,p,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=h,e.$pm=r,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(l=E.env){return l.comspec||"cmd.exe"}function r(l){let P=[],o=!1;const a=function($){if(o){P.push($);return}(!l.send($,n=>{if(n&&console.error(n),o=!1,P.length>0){const s=P.slice(0);P=[],s.forEach(d=>a(d))}})||S.$i)&&(o=!0)};return{send:a}}var v;(function(l){async function P(o,a,$){if(p.$ic(o))return o;if(a===void 0&&(a=E.cwd()),p.$mc(o)!=="."||($===void 0&&j.$9f(E.env.PATH)&&($=E.env.PATH.split(p.$tc)),$===void 0||$.length===0))return p.$jc(a,o);async function n(s){if(await k.Promises.exists(s)){let d;try{d=await k.Promises.stat(s)}catch(y){y.message.startsWith("EACCES")&&(d=await k.Promises.lstat(s))}return d?!d.isDirectory():!1}return!1}for(const s of $){let d;if(p.$ic(s)?d=p.$jc(s,o):d=p.$jc(a,s,o),await n(d))return d;let y=d+".com";if(await n(y)||(y=d+".exe",await n(y)))return y}return p.$jc(a,o)}l.findExecutable=P})(v||(e.win32=v={}))}),define(fe[62],ge([0,1,26,19]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=E;function E(j){return new Promise((k,h)=>{let r;const v=new Map;function l(o,a,$,f,n){const s=v.get(a);if(o===j||s){const d={name:P($),cmd:$,pid:o,ppid:a,load:f,mem:n};v.set(o,d),o===j&&(r=d),s&&(s.children||(s.children=[]),s.children.push(d),s.children.length>1&&(s.children=s.children.sort((y,i)=>y.pid-i.pid)))}}function P(o){const a=/--utility-sub-type=network/i,$=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,n=/conhost\.exe.+--headless/i,s=/--type=([a-zA-Z-]+)/;if($.exec(o))return"electron-crash-reporter";if(f.exec(o))return"winpty-agent";if(n.exec(o))return"conpty-agent";let d=s.exec(o);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?a.exec(o)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const y=/[a-zA-Z-]+\.js/g;let i="";do d=y.exec(o),d&&(i+=d+" ");while(d);return i&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron-nodejs (${i})`:o}if(process.platform==="win32"){const o=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,$)=>{oe(["@vscode/windows-process-tree"],a,$)}).then(a=>{a.getProcessList(j,$=>{if(!$){h(new Error(`Root process ${j} not found`));return}a.getProcessCpuUsage($,f=>{const n=new Map;f.forEach(s=>{const d=o(s.commandLine||"");n.set(s.pid,{name:P(d),cmd:d,pid:s.pid,ppid:s.ppid,load:s.cpu||0,mem:s.memory||0})}),r=n.get(j),r?(n.forEach(s=>{const d=n.get(s.ppid);d&&(d.children||(d.children=[]),d.children.push(s))}),n.forEach(s=>{s.children&&(s.children=s.children.sort((d,y)=>d.pid-y.pid))}),k(r)):h(new Error(`Root process ${j} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let o=function(){let a=[r];const $=[];for(;a.length;){const n=a.shift();n&&($.push(n.pid),n.children&&(a=a.concat(n.children)))}let f=JSON.stringify(S.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+$.join(" "),(0,p.exec)(f,{},(n,s,d)=>{if(n||d)h(n||new Error(d.toString()));else{const y=s.toString().split(`
`);for(let i=0;i<$.length;i++){const t=v.get($[i]);t.load=parseFloat(y[i])}if(!r){h(new Error(`Root process ${j} not found`));return}k(r)}})};(0,p.exec)("which ps",{},(a,$,f)=>{if(a||f)if(process.platform!=="linux")h(a||new Error(f.toString()));else{const n=JSON.stringify(S.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,p.exec)(n,{},(s,d,y)=>{s||y?h(s||new Error(y.toString())):(A(d,l),o())})}else{const n=$.toString().trim();(0,p.exec)(`${n} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,y,i)=>{d||i&&!i.includes("screen size is bogus")?h(d||new Error(i.toString())):(A(y,l),process.platform==="linux"?o():r?k(r):h(new Error(`Root process ${j} not found`)))})}})}})}function A(j,k){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=j.toString().split(`
`);for(const v of r){const l=h.exec(v.trim());l&&l.length===6&&k(parseInt(l[1]),parseInt(l[2]),l[5],parseFloat(l[3]),parseFloat(l[4]))}}}),define(fe[63],ge([0,1,20,3,61,34]),function(oe,e,p,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=j;async function j(l,P){return l===1?S.$i?v():A.$om(P):h(l,P)}let k=null;function h(l,P){if(S.$k&&l===2||S.$j&&l===3)return"/bin/bash";if(!k){let o;if(S.$i)o="/bin/bash";else{if(o=P.SHELL,!o)try{o=(0,p.userInfo)().shell}catch{}o||(o="sh"),o==="/bin/false"&&(o="/bin/bash")}k=o}return k}let r=null;async function v(){return r||(r=(await(0,E.$lm)()).exePath),r}});var be=this&&this.__decorate||function(oe,e,p,S){var E=arguments.length,A=E<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,p):S,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,p,S);else for(var k=oe.length-1;k>=0;k--)(j=oe[k])&&(A=(E<3?j(A):E>3?j(e,p,A):j(e,p))||A);return E>3&&A&&Object.defineProperty(e,p,A),A};define(fe[27],ge([0,1,16,12,18,17,14,7,4,2,59,9,10]),function(oe,e,p,S,E,A,j,k,h,r,v,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=C,e.$0h=w,e.$ci=I,e.$di=b;var o;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(o||(o={}));function a(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var $;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})($||($={}));function f(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var n;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(n||(n={}));function s(G){let q=0;for(let K=0;;K+=7){const _=G.read(1);if(q|=(_.buffer[0]&127)<<K,!(_.buffer[0]&128))return q}}const d=L(0);function y(G,q){if(q===0){G.write(d);return}let K=0;for(let de=q;de!==0;de=de>>>7)K++;const _=E.$Fe.alloc(K);for(let de=0;q!==0;de++)_.buffer[de]=q&127,q=q>>>7,q>0&&(_.buffer[de]|=128);G.write(_)}class i{constructor(q){this.b=q,this.a=0}read(q){const K=this.b.slice(this.a,this.a+q);return this.a+=K.byteLength,K}}e.$7h=i;class t{constructor(){this.a=[]}get buffer(){return E.$Fe.concat(this.a)}write(q){this.a.push(q)}}e.$8h=t;var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(c||(c={}));function L(G){const q=E.$Fe.alloc(1);return q.writeUInt8(G,0),q}const m={Undefined:L(c.Undefined),String:L(c.String),Buffer:L(c.Buffer),VSBuffer:L(c.VSBuffer),Array:L(c.Array),Object:L(c.Object),Uint:L(c.Int)},D=typeof Buffer<"u";function C(G,q){if(typeof q>"u")G.write(m.Undefined);else if(typeof q=="string"){const K=E.$Fe.fromString(q);G.write(m.String),y(G,K.byteLength),G.write(K)}else if(D&&Buffer.isBuffer(q)){const K=E.$Fe.wrap(q);G.write(m.Buffer),y(G,K.byteLength),G.write(K)}else if(q instanceof E.$Fe)G.write(m.VSBuffer),y(G,q.byteLength),G.write(q);else if(Array.isArray(q)){G.write(m.Array),y(G,q.length);for(const K of q)C(G,K)}else if(typeof q=="number"&&(q|0)===q)G.write(m.Uint),y(G,q);else{const K=E.$Fe.fromString(JSON.stringify(q));G.write(m.Object),y(G,K.byteLength),G.write(K)}}function w(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(s(G)).toString();case c.Buffer:return G.read(s(G)).buffer;case c.VSBuffer:return G.read(s(G));case c.Array:{const K=s(G),_=[];for(let de=0;de<K;de++)_.push(w(G));return _}case c.Object:return JSON.parse(G.read(s(G)).toString());case c.Int:return s(G)}}class F{constructor(q,K,_=null,de=1e3){this.h=q,this.j=K,this.k=_,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(B=>this.q(B)),this.m({type:200})}registerChannel(q,K){this.b.set(q,K),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const K=this.o([q.type]);this.k?.logOutgoing(K,0,1,f(q.type));return}case 201:case 202:case 204:case 203:{const K=this.o([q.type,q.id],q.data);this.k?.logOutgoing(K,q.id,1,f(q.type),q.data);return}}}o(q,K=void 0){const _=new t;return C(_,q),C(_,K),this.p(_.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const K=new i(q),_=w(K),de=w(K),B=_[0];switch(B){case 100:return this.k?.logIncoming(q.byteLength,_[1],1,`${a(B)}: ${_[2]}.${_[3]}`,de),this.s({type:B,id:_[1],channelName:_[2],name:_[3],arg:de});case 102:return this.k?.logIncoming(q.byteLength,_[1],1,`${a(B)}: ${_[2]}.${_[3]}`,de),this.t({type:B,id:_[1],channelName:_[2],name:_[3],arg:de});case 101:return this.k?.logIncoming(q.byteLength,_[1],1,`${a(B)}`),this.u({type:B,id:_[1]});case 103:return this.k?.logIncoming(q.byteLength,_[1],1,`${a(B)}`),this.u({type:B,id:_[1]})}}s(q){const K=this.b.get(q.channelName);if(!K){this.v(q);return}const _=new A.$oe;let de;try{de=K.call(this.j,q.name,q.arg,_.token)}catch(x){de=Promise.reject(x)}const B=q.id;de.then(x=>{this.m({id:B,data:x,type:201})},x=>{x instanceof Error?this.m({id:B,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:B,data:x,type:203})}).finally(()=>{ue.dispose(),this.d.delete(q.id)});const ue=(0,r.$Sc)(()=>_.cancel());this.d.set(q.id,ue)}t(q){const K=this.b.get(q.channelName);if(!K){this.v(q);return}const _=q.id,B=K.listen(this.j,q.name,q.arg)(ue=>this.m({id:_,data:ue,type:204}));this.d.set(q.id,B)}u(q){const K=this.d.get(q.id);K&&(K.dispose(),this.d.delete(q.id))}v(q){let K=this.g.get(q.channelName);K||(K=[],this.g.set(q.channelName,K));const _=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);K.push({request:q,timeoutTimer:_})}w(q){const K=this.g.get(q);if(K){for(const _ of K)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$$h=F;var Q;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(Q||(e.RequestInitiator=Q={}));class U{constructor(q,K=null){this.l=q,this.a=!1,this.b=n.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$de,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=K}getChannel(q){const K=this;return{call(_,de,B){return K.a?Promise.reject(new k.$5):K.m(q,_,de,B)},listen(_,de){return K.a?h.Event.None:K.o(q,_,de)}}}m(q,K,_,de=A.CancellationToken.None){const B=this.g++,x={id:B,type:100,channelName:q,name:K,arg:_};if(de.isCancellationRequested)return Promise.reject(new k.$5);let u;return new Promise((ne,N)=>{if(de.isCancellationRequested)return N(new k.$5);const X=()=>{const Y=te=>{switch(te.type){case 201:this.f.delete(B),ne(te.data);break;case 202:{this.f.delete(B);const ce=new Error(te.data.message);ce.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,ce.name=te.data.name,N(ce);break}case 203:this.f.delete(B),N(te.data);break}};this.f.set(B,Y),this.p(x)};let W=null;this.b===n.Idle?X():(W=(0,S.$jh)(Y=>this.u()),W.then(()=>{W=null,X()}));const H=()=>{W?(W.cancel(),W=null):this.p({id:B,type:101}),N(new k.$5)},R=de.onCancellationRequested(H);u=(0,r.$Rc)((0,r.$Sc)(H),R),this.d.add(u)}).finally(()=>{u.dispose(),this.d.delete(u)})}o(q,K,_){const de=this.g++,ue={id:de,type:102,channelName:q,name:K,arg:_};let x=null;const u=new h.$de({onWillAddFirstListener:()=>{x=(0,S.$jh)(ne=>this.u()),x.then(()=>{x=null,this.d.add(u),this.p(ue)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(u),this.p({id:de,type:103}))}}),z=ne=>u.fire(ne.data);return this.f.set(de,z),u.event}p(q){switch(q.type){case 100:case 102:{const K=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(K,q.id,0,`${a(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const K=this.q([q.type,q.id]);this.j?.logOutgoing(K,q.id,0,a(q.type));return}}}q(q,K=void 0){const _=new t;return C(_,q),C(_,K),this.r(_.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const K=new i(q),_=w(K),de=w(K),B=_[0];switch(B){case 200:return this.j?.logIncoming(q.byteLength,0,0,f(B)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,_[1],0,f(B),de),this.t({type:_[0],id:_[1],data:de})}}t(q){if(q.type===200){this.b=n.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===n.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$_h=U,be([j.$1h],U.prototype,"onDidInitializePromise",null);class O{get connections(){const q=[];return this.f.forEach(K=>q.push(K)),q}constructor(q,K,_){this.a=new Map,this.f=new Set,this.g=new h.$de,this.onDidAddConnection=this.g.event,this.h=new h.$de,this.onDidRemoveConnection=this.h.event,this.j=new r.$Tc,this.j.add(q(({protocol:de,onDidClientDisconnect:B})=>{const ue=h.Event.once(de.onMessage);this.j.add(ue(x=>{const u=new i(x),z=w(u),ne=new F(de,z,K,_),N=new U(de,K);this.a.forEach((W,H)=>ne.registerChannel(H,W));const X={channelServer:ne,channelClient:N,ctx:z};this.f.add(X),this.g.fire(X),this.j.add(B(()=>{ne.dispose(),N.dispose(),this.f.delete(X),this.h.fire(X)}))}))}))}getChannel(q,K){const _=this;return{call(de,B,ue){let x;if((0,P.$kg)(K)){const z=(0,p.$3b)(_.connections.filter(K));x=z?Promise.resolve(z):h.Event.toPromise(h.Event.filter(_.onDidAddConnection,K))}else x=K.routeCall(_,de,B);const u=x.then(z=>z.channelClient.getChannel(q));return I(u).call(de,B,ue)},listen(de,B){if((0,P.$kg)(K))return _.k(q,K,de,B);const ue=K.routeEvent(_,de,B).then(x=>x.channelClient.getChannel(q));return I(ue).listen(de,B)}}}k(q,K,_,de){const B=this;let ue;const x=new h.$de({onWillAddFirstListener:()=>{ue=new r.$Tc;const u=new h.$je,z=new Map,ne=X=>{const H=X.channelClient.getChannel(q).listen(_,de),R=u.add(H);z.set(X,R)},N=X=>{const W=z.get(X);W&&(W.dispose(),z.delete(X))};B.connections.filter(K).forEach(ne),h.Event.filter(B.onDidAddConnection,K)(ne,void 0,ue),B.onDidRemoveConnection(N,void 0,ue),u.event(x.fire,x,ue),ue.add(u)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return x.event}registerChannel(q,K){this.a.set(q,K);for(const _ of this.f)_.channelServer.registerChannel(q,K)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=O;class g{constructor(q,K,_=null){const de=new t;C(de,K),q.send(de.buffer),this.a=new U(q,_),this.d=new F(q,K,_)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,K){this.d.registerChannel(q,K)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=g;function I(G){return{call(q,K,_){return G.then(de=>de.call(q,K,_))},listen(q,K){const _=new h.$me;return G.then(de=>_.input=de.listen(q,K)),_.event}}}function b(G){let q=!1;return{call(K,_,de){return q?G.call(K,_,de):(0,S.$xh)(0).then(()=>q=!0).then(()=>G.call(K,_,de))},listen(K,_){if(q)return G.listen(K,_);const de=new h.$me;return(0,S.$xh)(0).then(()=>q=!0).then(()=>de.input=G.listen(K,_)),de.event}}}class M{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const K of q.connections)if(await Promise.resolve(this.a(K.ctx)))return Promise.resolve(K);return await h.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$ei=M;var Z;(function(G){function q(B,ue,x){const u=B,z=x&&x.disableMarshalling,ne=new Map;for(const N in u)_(N)&&ne.set(N,h.Event.buffer(u[N],!0,void 0,ue));return new class{listen(N,X,W){const H=ne.get(X);if(H)return H;const R=u[X];if(typeof R=="function"){if(de(X))return R.call(u,W);if(_(X))return ne.set(X,h.Event.buffer(u[X],!0,void 0,ue)),ne.get(X)}throw new k.$bb(`Event not found: ${X}`)}call(N,X,W){const H=u[X];if(typeof H=="function"){if(!z&&Array.isArray(W))for(let Y=0;Y<W.length;Y++)W[Y]=(0,v.$6h)(W[Y]);let R=H.apply(u,W);return R instanceof Promise||(R=Promise.resolve(R)),R}throw new k.$bb(`Method not found: ${X}`)}}}G.fromService=q;function K(B,ue){const x=ue&&ue.disableMarshalling;return new Proxy({},{get(u,z){if(typeof z=="string")return ue?.properties?.has(z)?ue.properties.get(z):de(z)?function(ne){return B.listen(z,ne)}:_(z)?B.listen(z):async function(...ne){let N;ue&&!(0,P.$fg)(ue.context)?N=[ue.context,...ne]:N=ne;const X=await B.call(z,N);return x?X:(0,v.$6h)(X)};throw new k.$bb(`Property not found: ${String(z)}`)}})}G.toService=K;function _(B){return B[0]==="o"&&B[1]==="n"&&l.$wf(B.charCodeAt(2))}function de(B){return/^onDynamic/.test(B)&&l.$wf(B.charCodeAt(9))}})(Z||(e.ProxyChannel=Z={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const q=G.toString();if(q!=="[object Object]")return q}return G}function ee(G){return Array.isArray(G)?G.map(V):V(G)}function ae(G,q,K,_,de,B,ue){ue=ee(ue);const x=ie[de],u=x[_%x.length];let z=[`%c[${G}]%c[${String(q).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${u}`];/\($/.test(B)?(z=z.concat(ue),z.push(")")):z.push(ue),console.log.apply(console,z)}class le{constructor(q,K){this.d=q,this.f=K,this.a=0,this.b=0}logOutgoing(q,K,_,de,B){this.b+=q,ae(this.d,this.b,q,K,_,de,B)}logIncoming(q,K,_,de,B){this.a+=q,ae(this.f,this.a,q,K,_,de,B)}}e.$fi=le}),define(fe[64],ge([0,1,26,12,18,17,58,7,4,2,30,34,33,27]),function(oe,e,p,S,E,A,j,k,h,r,v,l,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class a extends o.$$h{constructor(n){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",s=>E.$Fe.wrap(Buffer.from(s,"base64")))},n),process.once("disconnect",()=>this.dispose())}}e.$Zq=a;class ${constructor(n,s){this.i=n,this.j=s,this.c=new Set,this.g=new Map,this.h=new h.$de,this.onDidProcessExit=this.h.event;const d=s&&s.timeout?s.timeout:6e4;this.b=new S.$th(d),this.d=null,this.f=null}getChannel(n){const s=this;return{call(d,y,i){return s.k(n,d,y,i)},listen(d,y){return s.l(n,d,y)}}}k(n,s,d,y=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const i=this.n(n),t=(0,S.$jh)(m=>i.call(s,d,m)),c=y.onCancellationRequested(()=>t.cancel()),L=(0,r.$Sc)(()=>t.cancel());return this.c.add(L),t.finally(()=>{c.dispose(),this.c.delete(L),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(n,s,d){if(!this.b)return h.Event.None;this.b.cancel();let y;const i=new h.$de({onWillAddFirstListener:()=>{y=this.n(n).listen(s,d)(i.fire,i),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const n=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,v.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(C=>!/^--inspect(-brk)?=/.test(C)).filter(C=>!C.startsWith("--vscode-"))),(0,P.$nm)(s.env),this.d=(0,p.fork)(this.i,n,s);const d=new h.$de,i=h.Event.fromNodeEventEmitter(this.d,"message",C=>C)(C=>{if((0,j.$Vq)(C)){(0,j.log)(C,`IPC Library: ${this.j.serverName}`);return}d.fire(E.$Fe.wrap(Buffer.from(C,"base64")))}),t=this.j.useQueue?(0,l.$pm)(this.d):this.d,c=C=>this.d&&this.d.connected&&t.send(C.buffer.toString("base64")),L=d.event,m={send:c,onMessage:L};this.f=new o.$_h(m);const D=()=>this.o();process.once("exit",D),this.d.on("error",C=>console.warn('IPC "'+this.j.serverName+'" errored with '+C)),this.d.on("exit",(C,w)=>{process.removeListener("exit",D),i.dispose(),this.c.forEach(F=>(0,r.$Pc)(F)),this.c.clear(),C!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+C+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:C,signal:w})})}return this.f}n(n){let s=this.g.get(n);return s||(s=this.m.getChannel(n),this.g.set(n,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=$}),define(fe[65],ge([0,1,31,18,27,4,10,16]),function(oe,e,p,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hX=void 0,e.$iX=v;class h{constructor(P){this.a=P,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",o=>o.data?S.$Fe.wrap(o.data):S.$Fe.alloc(0)),P.start()}send(P){this.a.postMessage(P.buffer)}disconnect(){this.a.close()}}class r extends E.$ai{static b(P){(0,j.$gg)((0,p.$gX)(process),"Electron Utility Process");const o=new A.$de;return process.parentPort.on("message",a=>{if(P?.handledClientConnection(a))return;const $=(0,k.$Ob)(a.ports);$&&o.fire($)}),A.Event.map(o.event,a=>({protocol:new h(a),onDidClientDisconnect:A.Event.fromNodeEventEmitter(a,"close")}))}constructor(P){super(r.b(P))}}e.$hX=r;function v(l,P,o){const a=$=>{$.data===P&&(l.removeListener("message",a),o())};l.on("message",a)}}),define(fe[66],ge([13,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(fe[67],ge([13,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(fe[68],ge([13,11]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(fe[69],ge([13,11]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(fe[70],ge([13,11]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(fe[71],ge([13,11]),function(oe,e){return oe.create("vs/platform/terminal/node/ptyService",e)}),define(fe[72],ge([13,11]),function(oe,e){return oe.create("vs/platform/terminal/node/terminalProcess",e)}),define(fe[73],ge([0,1,7,67]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var E;(function(r){r[r.LParen=0]="LParen",r[r.RParen=1]="RParen",r[r.Neg=2]="Neg",r[r.Eq=3]="Eq",r[r.NotEq=4]="NotEq",r[r.Lt=5]="Lt",r[r.LtEq=6]="LtEq",r[r.Gt=7]="Gt",r[r.GtEq=8]="GtEq",r[r.RegexOp=9]="RegexOp",r[r.RegexStr=10]="RegexStr",r[r.True=11]="True",r[r.False=12]="False",r[r.In=13]="In",r[r.Not=14]="Not",r[r.And=15]="And",r[r.Or=16]="Or",r[r.Str=17]="Str",r[r.QuotedStr=18]="QuotedStr",r[r.Error=19]="Error",r[r.EOF=20]="EOF"})(E||(e.TokenType=E={}));function A(...r){switch(r.length){case 1:return(0,S.localize)(0,null,r[0]);case 2:return(0,S.localize)(1,null,r[0],r[1]);case 3:return(0,S.localize)(2,null,r[0],r[1],r[2]);default:return}}const j=(0,S.localize)(3,null),k=(0,S.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,p.$8)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const l=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:l})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const l=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:l})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const l=this.d,P=this.c.substring(this.d,this.e),o={type:19,offset:this.d,lexeme:P};this.g.push({offset:l,lexeme:P,additionalInfo:v}),this.f.push(o)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const l=this.c.substring(this.d,this.e),P=h.b.get(l);P?this.k(P):this.f.push({type:17,lexeme:l,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,l=!1,P=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(k);return}const a=this.c.charCodeAt(v);if(l)l=!1;else if(a===47&&!P){v++;break}else a===91?P=!0:a===92?l=!0:a===93&&(P=!1);v++}for(;v<this.c.length&&h.a.has(this.c.charCodeAt(v));)v++;this.e=v;const o=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:o,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=h}),define(fe[74],ge([0,1,54,14,19,5,15,23,6]),function(oe,e,p,S,E,A,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=v,e.$8m=l,e.$5m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,A.$mc)(E.$Qg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,k.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const o=(0,p.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",o)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$0g)(h.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=j.env.VSCODE_PORTABLE;return o?h.URI.file((0,A.$jc)(o,"argv.json")):(0,k.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,A.$kc)(o):(0,A.$hc)((0,A.$jc)(E.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const o=this.args["extensions-download-dir"];return o?h.URI.file((0,A.$kc)(o)):h.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,A.$kc)(o);const a=j.env.VSCODE_EXTENSIONS;if(a)return a;const $=j.env.VSCODE_PORTABLE;return $?(0,A.$jc)($,"extensions"):(0,k.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(a=>/^[^:/?#]+?:\/\//.test(a)?h.URI.parse(a):h.URI.file((0,A.$hc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(o=>o==="ui"||o==="workspace"||o==="web"?o:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?h.URI.parse(o):h.URI.file((0,A.$hc)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(o=>!e.$5m.test(o))}get extensionLogLevel(){const o=[];for(const a of this.args.log||[]){const $=e.$5m.exec(a);$&&$[1]&&$[2]&&o.push([$[1],$[2]])}return o.length?o:void 0}get serviceMachineIdResource(){return(0,k.$0g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const o=j.env.VSCODE_PORTABLE;return o?h.URI.file((0,A.$jc)(o,"policy.json")):(0,k.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(o){this.args.continueOn=o}get args(){return this.a}constructor(o,a,$){this.a=o,this.b=a,this.c=$,this.editSessionId=this.args.editSessionId}}e.$6m=r,be([S.$1h],r.prototype,"appRoot",null),be([S.$1h],r.prototype,"userHome",null),be([S.$1h],r.prototype,"userDataPath",null),be([S.$1h],r.prototype,"appSettingsHome",null),be([S.$1h],r.prototype,"tmpDir",null),be([S.$1h],r.prototype,"cacheHome",null),be([S.$1h],r.prototype,"stateResource",null),be([S.$1h],r.prototype,"userRoamingDataHome",null),be([S.$1h],r.prototype,"userDataSyncHome",null),be([S.$1h],r.prototype,"sync",null),be([S.$1h],r.prototype,"machineSettingsResource",null),be([S.$1h],r.prototype,"workspaceStorageHome",null),be([S.$1h],r.prototype,"localHistoryHome",null),be([S.$1h],r.prototype,"keyboardLayoutResource",null),be([S.$1h],r.prototype,"argvResource",null),be([S.$1h],r.prototype,"isExtensionDevelopment",null),be([S.$1h],r.prototype,"untitledWorkspacesHome",null),be([S.$1h],r.prototype,"builtinExtensionsPath",null),be([S.$1h],r.prototype,"extensionsPath",null),be([S.$1h],r.prototype,"extensionDevelopmentLocationURI",null),be([S.$1h],r.prototype,"extensionDevelopmentKind",null),be([S.$1h],r.prototype,"extensionTestsLocationURI",null),be([S.$1h],r.prototype,"debugExtensionHost",null),be([S.$1h],r.prototype,"logLevel",null),be([S.$1h],r.prototype,"extensionLogLevel",null),be([S.$1h],r.prototype,"serviceMachineIdResource",null),be([S.$1h],r.prototype,"disableTelemetry",null),be([S.$1h],r.prototype,"disableWorkspaceTrust",null),be([S.$1h],r.prototype,"useInMemorySecretStorage",null),be([S.$1h],r.prototype,"policyFile",null);function v(P,o){return l(P["inspect-extensions"],P["inspect-brk-extensions"],5870,o,P.debugId,P.extensionEnvironment)}function l(P,o,a,$,f,n){const d=Number(o||P)||($?null:a),y=d?!!o:!1;let i;if(n)try{i=JSON.parse(n)}catch{}return{port:d,break:y,debugId:f,env:i}}}),define(fe[75],ge([0,1,108,3,68]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$tm=k,e.$um=r,e.$vm=o,e.$wm=a;const A={o:(0,E.localize)(0,null),e:(0,E.localize)(1,null),t:(0,E.localize)(2,null)};e.$rm=["tunnel","serve-web"],e.$sm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k($,f,n=j){const s=$.find(C=>C.length>0&&C[0]!=="-"),d={},y=["_"],i=[],t={};let c;for(const C in f){const w=f[C];w.type==="subcommand"?C===s&&(c=w):(w.alias&&(d[C]=w.alias),w.type==="string"||w.type==="string[]"?(y.push(C),w.deprecates&&y.push(...w.deprecates)):w.type==="boolean"&&(i.push(C),w.deprecates&&i.push(...w.deprecates)),w.global&&(t[C]=w))}if(c&&s){const C=t;for(const U in c.options)C[U]=c.options[U];const w=$.filter(U=>U!==s),F=n.getSubcommandReporter?n.getSubcommandReporter(s):void 0,Q=k(w,C,F);return{[s]:Q,_:[]}}const L=p($,{string:y,boolean:i,alias:d}),m={},D=L;m._=L._.map(C=>String(C)).filter(C=>C.length>0),delete D._;for(const C in f){const w=f[C];if(w.type==="subcommand")continue;w.alias&&delete D[w.alias];let F=D[C];if(w.deprecates)for(const Q of w.deprecates)D.hasOwnProperty(Q)&&(F||(F=D[Q],F&&n.onDeprecatedOption(Q,w.deprecationMessage||(0,E.localize)(38,null,C))),delete D[Q]);if(typeof F<"u"){if(w.type==="string[]"){if(Array.isArray(F)||(F=[F]),!w.allowEmptyValue){const Q=F.filter(U=>U.length>0);Q.length!==F.length&&(n.onEmptyValue(C),F=Q.length>0?Q:void 0)}}else w.type==="string"&&(Array.isArray(F)?(F=F.pop(),n.onMultipleValues(C,F)):!F&&!w.allowEmptyValue&&(n.onEmptyValue(C),F=void 0));m[C]=F,w.deprecationMessage&&n.onDeprecatedOption(C,w.deprecationMessage)}delete D[C]}for(const C in D)n.onUnknownOption(C);return m}function h($,f){let n="";return f.args&&(Array.isArray(f.args)?n=` <${f.args.join("> <")}>`:n=` <${f.args}>`),f.alias?`-${f.alias} --${$}${n}`:`--${$}${n}`}function r($,f){const n=[];for(const s in $){const d=$[s],y=h(s,d);n.push([y,d.description])}return v(n,f)}function v($,f){const s=$.reduce((i,t)=>Math.max(i,t[0].length),12)+2+1;if(f-s<25)return $.reduce((i,t)=>i.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=f-s-1,y=[];for(const i of $){const t=i[0],c=P(i[1],d),L=l(s-t.length-2);y.push("  "+t+L+c[0]);for(let m=1;m<c.length;m++)y.push(l(s)+c[m])}return y}function l($){return" ".repeat($)}function P($,f){const n=[];for(;$.length;){const s=$.length<f?$.length:$.lastIndexOf(" ",f),d=$.slice(0,s).trim();$=$.slice(s),n.push(d)}return n}function o($,f,n,s,d){const y=process.stdout.isTTY&&process.stdout.columns||80,i=d?.noInputFiles!==!0?`[${(0,E.localize)(39,null)}...]`:"",t=[`${$} ${n}`];t.push(""),t.push(`${(0,E.localize)(40,null)}: ${f} [${(0,E.localize)(41,null)}]${i}`),t.push(""),d?.noPipe!==!0&&(S.$i?t.push((0,E.localize)(42,null,f)):t.push((0,E.localize)(43,null,f)),t.push(""));const c={},L=[];for(const m in s){const D=s[m];if(D.type==="subcommand")D.description&&L.push({command:m,description:D.description});else if(D.description&&D.cat){let C=c[D.cat];C||(c[D.cat]=C={}),C[m]=D}}for(const m in c){const D=m,C=c[D];C&&(t.push(A[D]),t.push(...r(C,y)),t.push(""))}return L.length&&(t.push((0,E.localize)(44,null)),t.push(...v(L.map(m=>[m.command,m.description]),y)),t.push("")),t.join(`
`)}function a($,f){return`${$||(0,E.localize)(45,null)}
${f||(0,E.localize)(46,null)}
${process.arch}`}}),function(){"use strict";function oe(e,p,S){function E(j,k){const h=A(j,k),r=[h];return e.isAbsolute(h)||r.unshift(S),e.resolve(...r)}function A(j,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,k);const v=j["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const l=process.env.USERPROFILE;if(typeof l!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(l,"AppData","Roaming")}break;case"darwin":r=e.join(p.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,k)}return{getUserDataPath:E}}if(typeof define=="function")define(fe[76],ge([77,20,15]),function(e,p,S){return oe(e,p,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),p=require("os");module.exports=oe(e,p,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[78],ge([0,1,20,74,76]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=j,e.$$m=k;class A extends S.$6m{constructor(r,v){super(r,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,E.getUserDataPath)(r,v.nameShort)},v)}}e.$9m=A;function j(h,r){return(0,S.$8m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,r,h.extensionEnvironment)}function k(h,r){return(0,S.$8m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,r,h.extensionEnvironment)}}),define(fe[21],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=E,e.$xi=A;var p;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function k(h){return h[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=k})(p||(e._util=p={})),e.$vi=E("instantiationService");function S(j,k,h){k[p.DI_TARGET]===k?k[p.DI_DEPENDENCIES].push({id:j,index:h}):(k[p.DI_DEPENDENCIES]=[{id:j,index:h}],k[p.DI_TARGET]=k)}function E(j){if(p.serviceIds.has(j))return p.serviceIds.get(j);const k=function(h,r,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(k,h,v)};return k.toString=()=>j,p.serviceIds.set(j,k),k}function A(j){return j}}),define(fe[35],ge([0,1,3,9,73,21,66,7]),function(oe,e,p,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=r,e.$vj=c,e.$wj=L,e.$Pj=de;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",p.$j),h.set("isLinux",p.$k),h.set("isWindows",p.$i),h.set("isWeb",p.$o),h.set("isMacNative",p.$j&&!p.$o),h.set("isEdge",p.$H),h.set("isFirefox",p.$F),h.set("isChrome",p.$E),h.set("isSafari",p.$G);function r(x,u){if(h.get(x)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(x,u)}const v=Object.prototype.hasOwnProperty;var l;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(l||(e.ContextKeyExprType=l={}));const P={regexParsingWithErrorRecovery:!0},o=(0,j.localize)(0,null),a=(0,j.localize)(1,null),$=(0,j.localize)(2,null),f=(0,j.localize)(3,null),n=(0,j.localize)(4,null),s=(0,j.localize)(5,null),d=(0,j.localize)(6,null),y=(0,j.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(u=P){this.k=u,this.d=new E.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(u){if(u===""){this.h.push({message:o,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(u).scan(),this.g=0,this.h=[];try{const z=this.l();if(!this.E()){const ne=this.D(),N=ne.type===17?s:void 0;throw this.h.push({message:n,offset:ne.offset,lexeme:E.$rj.getLexeme(ne),additionalInfo:N}),i.c}return z}catch(z){if(z!==i.c)throw z;return}}l(){return this.m()}m(){const u=[this.o()];for(;this.y(16);){const z=this.o();u.push(z)}return u.length===1?u[0]:t.or(...u)}o(){const u=[this.s()];for(;this.y(15);){const z=this.s();u.push(z)}return u.length===1?u[0]:t.and(...u)}s(){if(this.y(2)){const u=this.D();switch(u.type){case 11:return this.z(),D.INSTANCE;case 12:return this.z(),C.INSTANCE;case 0:{this.z();const z=this.l();return this.A(1,f),z?.negate()}case 17:return this.z(),g.create(u.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",u)}}return this.t()}t(){const u=this.D();switch(u.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const z=this.l();return this.A(1,f),z}case 17:{const z=u.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const X=N.lexeme,W=X.lastIndexOf("/"),H=W===X.length-1?void 0:this.w(X.substring(W+1));let R;try{R=new RegExp(X.substring(1,W),H)}catch{throw this.B("REGEX",N)}return V.create(z,R)}switch(N.type){case 10:case 19:{const X=[N.lexeme];this.z();let W=this.D(),H=0;for(let se=0;se<N.lexeme.length;se++)N.lexeme.charCodeAt(se)===40?H++:N.lexeme.charCodeAt(se)===41&&H--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let se=0;se<W.lexeme.length;se++)W.lexeme.charCodeAt(se)===40?H++:N.lexeme.charCodeAt(se)===41&&H--}if(H<0)break;X.push(E.$rj.getLexeme(W)),this.z(),W=this.D()}const R=X.join(""),Y=R.lastIndexOf("/"),te=Y===R.length-1?void 0:this.w(R.substring(Y+1));let ce;try{ce=new RegExp(R.substring(1,Y),te)}catch{throw this.B("REGEX",N)}return t.regex(z,ce)}case 18:{const X=N.lexeme;this.z();let W=null;if(!(0,S.$7e)(X)){const H=X.indexOf("/"),R=X.lastIndexOf("/");if(H!==R&&H>=0){const Y=X.slice(H+1,R),te=X[R+1]==="i"?"i":"";try{W=new RegExp(Y,te)}catch{throw this.B("REGEX",N)}}}if(W===null)throw this.B("REGEX",N);return V.create(z,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,$);const N=this.u();return t.notIn(z,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return t.equals(z,N);switch(N){case"true":return t.has(z);case"false":return t.not(z);default:return t.equals(z,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return t.notEquals(z,N);switch(N){case"true":return t.not(z);case"false":return t.has(z);default:return t.notEquals(z,N)}}case 5:return this.z(),Z.create(z,this.u());case 6:return this.z(),ie.create(z,this.u());case 7:return this.z(),b.create(z,this.u());case 8:return this.z(),M.create(z,this.u());case 13:return this.z(),t.in(z,this.u());default:return t.has(z)}}case 20:throw this.h.push({message:d,offset:u.offset,lexeme:"",additionalInfo:y}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const u=this.D();switch(u.type){case 17:case 18:return this.z(),u.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(u){return u.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(u){return this.C(u)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(u,z){if(this.C(u))return this.z();throw this.B(z,this.D())}B(u,z,ne){const N=(0,j.localize)(8,null,u,E.$rj.getLexeme(z)),X=z.offset,W=E.$rj.getLexeme(z);return this.h.push({message:N,offset:X,lexeme:W,additionalInfo:ne}),i.c}C(u){return this.D().type===u}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=i;class t{static false(){return D.INSTANCE}static true(){return C.INSTANCE}static has(u){return w.create(u)}static equals(u,z){return F.create(u,z)}static notEquals(u,z){return O.create(u,z)}static regex(u,z){return V.create(u,z)}static in(u,z){return Q.create(u,z)}static notIn(u,z){return U.create(u,z)}static not(u){return g.create(u)}static and(...u){return le.create(u,null,!0)}static or(...u){return G.create(u,null,!0)}static greater(u,z){return b.create(u,z)}static greaterEquals(u,z){return M.create(u,z)}static smaller(u,z){return Z.create(u,z)}static smallerEquals(u,z){return ie.create(u,z)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(u){return u==null?void 0:this.c.parse(u)}}e.$uj=t;function c(x){const u=new i({regexParsingWithErrorRecovery:!1});return x.map(z=>(u.parse(z),u.lexingErrors.length>0?u.lexingErrors.map(ne=>({errorMessage:ne.additionalInfo?(0,j.localize)(9,null,ne.additionalInfo):(0,j.localize)(10,null),offset:ne.offset,length:ne.lexeme.length})):u.parsingErrors.length>0?u.parsingErrors.map(ne=>({errorMessage:ne.additionalInfo?`${ne.message}. ${ne.additionalInfo}`:ne.message,offset:ne.offset,length:ne.lexeme.length})):[]))}function L(x,u){const z=x?x.substituteConstants():void 0,ne=u?u.substituteConstants():void 0;return!z&&!ne?!0:!z||!ne?!1:z.equals(ne)}function m(x,u){return x.cmp(u)}class D{static{this.INSTANCE=new D}constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return C.INSTANCE}}e.$xj=D;class C{static{this.INSTANCE=new C}constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return D.INSTANCE}}e.$yj=C;class w{static create(u,z=null){const ne=h.get(u);return typeof ne=="boolean"?ne?C.INSTANCE:D.INSTANCE:new w(u,z)}constructor(u,z){this.key=u,this.c=z,this.type=2}cmp(u){return u.type!==this.type?this.type-u.type:K(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=h.get(this.key);return typeof u=="boolean"?u?C.INSTANCE:D.INSTANCE:this}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.$zj=w;class F{static create(u,z,ne=null){if(typeof z=="boolean")return z?w.create(u,ne):g.create(u,ne);const N=h.get(u);return typeof N=="boolean"?z===(N?"true":"false")?C.INSTANCE:D.INSTANCE:new F(u,z,ne)}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=4}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=h.get(this.c);if(typeof u=="boolean"){const z=u?"true":"false";return this.d===z?C.INSTANCE:D.INSTANCE}return this}evaluate(u){return u.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(u){return u.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Aj=F;class Q{static create(u,z){return new Q(u,z)}constructor(u,z){this.d=u,this.f=z,this.type=10,this.c=null}cmp(u){return u.type!==this.type?this.type-u.type:_(this.d,this.f,u.d,u.f)}equals(u){return u.type===this.type?this.d===u.d&&this.f===u.f:!1}substituteConstants(){return this}evaluate(u){const z=u.getValue(this.f),ne=u.getValue(this.d);return Array.isArray(z)?z.includes(ne):typeof ne=="string"&&typeof z=="object"&&z!==null?v.call(z,ne):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(u){return u.mapIn(this.d,this.f)}negate(){return this.c||(this.c=U.create(this.d,this.f)),this.c}}e.$Bj=Q;class U{static create(u,z){return new U(u,z)}constructor(u,z){this.d=u,this.f=z,this.type=11,this.c=Q.create(u,z)}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(u){return u.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=U;class O{static create(u,z,ne=null){if(typeof z=="boolean")return z?g.create(u,ne):w.create(u,ne);const N=h.get(u);return typeof N=="boolean"?z===(N?"true":"false")?D.INSTANCE:C.INSTANCE:new O(u,z,ne)}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=5}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=h.get(this.c);if(typeof u=="boolean"){const z=u?"true":"false";return this.d===z?D.INSTANCE:C.INSTANCE}return this}evaluate(u){return u.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(u){return u.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Dj=O;class g{static create(u,z=null){const ne=h.get(u);return typeof ne=="boolean"?ne?D.INSTANCE:C.INSTANCE:new g(u,z)}constructor(u,z){this.c=u,this.d=z,this.type=3}cmp(u){return u.type!==this.type?this.type-u.type:K(this.c,u.c)}equals(u){return u.type===this.type?this.c===u.c:!1}substituteConstants(){const u=h.get(this.c);return typeof u=="boolean"?u?D.INSTANCE:C.INSTANCE:this}evaluate(u){return!u.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(u){return u.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Ej=g;function I(x,u){if(typeof x=="string"){const z=parseFloat(x);isNaN(z)||(x=z)}return typeof x=="string"||typeof x=="number"?u(x):D.INSTANCE}class b{static create(u,z,ne=null){return I(z,N=>new b(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=12}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Fj=b;class M{static create(u,z,ne=null){return I(z,N=>new M(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=13}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Gj=M;class Z{static create(u,z,ne=null){return I(z,N=>new Z(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=14}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Hj=Z;class ie{static create(u,z,ne=null){return I(z,N=>new ie(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=15}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ij=ie;class V{static create(u,z){return new V(u,z)}constructor(u,z){this.d=u,this.f=z,this.type=7,this.c=null}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.d<u.d)return-1;if(this.d>u.d)return 1;const z=this.f?this.f.source:"",ne=u.f?u.f.source:"";return z<ne?-1:z>ne?1:0}equals(u){if(u.type===this.type){const z=this.f?this.f.source:"",ne=u.f?u.f.source:"";return this.d===u.d&&z===ne}return!1}substituteConstants(){return this}evaluate(u){const z=u.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const u=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${u}`}keys(){return[this.d]}map(u){return u.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Jj=V;class ee{static create(u){return new ee(u)}constructor(u){this.c=u,this.type=8}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(u){return new ee(this.c.map(u))}negate(){return this.c}}e.$Kj=ee;function ae(x){let u=null;for(let z=0,ne=x.length;z<ne;z++){const N=x[z].substituteConstants();if(x[z]!==N&&u===null){u=[];for(let X=0;X<z;X++)u[X]=x[X]}u!==null&&(u[z]=N)}return u===null?x:u}class le{static create(u,z,ne){return le.d(u,z,ne)}constructor(u,z){this.expr=u,this.c=z,this.type=6}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const N=m(this.expr[z],u.expr[z]);if(N!==0)return N}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(u.expr[z]))return!1;return!0}return!1}substituteConstants(){const u=ae(this.expr);return u===this.expr?this:le.create(u,this.c,!1)}evaluate(u){for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].evaluate(u))return!1;return!0}static d(u,z,ne){const N=[];let X=!1;for(const W of u)if(W){if(W.type===1){X=!0;continue}if(W.type===0)return D.INSTANCE;if(W.type===6){N.push(...W.expr);continue}N.push(W)}if(N.length===0&&X)return C.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(m);for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];for(;N.length>1;){const W=N[N.length-1];if(W.type!==9)break;N.pop();const H=N.pop(),R=N.length===0,Y=G.create(W.expr.map(te=>le.create([te,H],null,ne)),null,R);Y&&(N.push(Y),N.sort(m))}if(N.length===1)return N[0];if(ne){for(let W=0;W<N.length;W++)for(let H=W+1;H<N.length;H++)if(N[W].negate().equals(N[H]))return D.INSTANCE;if(N.length===1)return N[0]}return new le(N,z)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(const z of this.expr)u.push(...z.keys());return u}map(u){return new le(this.expr.map(z=>z.map(u)),null)}negate(){if(!this.c){const u=[];for(const z of this.expr)u.push(z.negate());this.c=G.create(u,this,!0)}return this.c}}e.$Lj=le;class G{static create(u,z,ne){return G.d(u,z,ne)}constructor(u,z){this.expr=u,this.c=z,this.type=9}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const N=m(this.expr[z],u.expr[z]);if(N!==0)return N}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(u.expr[z]))return!1;return!0}return!1}substituteConstants(){const u=ae(this.expr);return u===this.expr?this:G.create(u,this.c,!1)}evaluate(u){for(let z=0,ne=this.expr.length;z<ne;z++)if(this.expr[z].evaluate(u))return!0;return!1}static d(u,z,ne){let N=[],X=!1;if(u){for(let W=0,H=u.length;W<H;W++){const R=u[W];if(R){if(R.type===0){X=!0;continue}if(R.type===1)return C.INSTANCE;if(R.type===9){N=N.concat(R.expr);continue}N.push(R)}}if(N.length===0&&X)return D.INSTANCE;N.sort(m)}if(N.length!==0){if(N.length===1)return N[0];for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];if(ne){for(let W=0;W<N.length;W++)for(let H=W+1;H<N.length;H++)if(N[W].negate().equals(N[H]))return C.INSTANCE;if(N.length===1)return N[0]}return new G(N,z)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(const z of this.expr)u.push(...z.keys());return u}map(u){return new G(this.expr.map(z=>z.map(u)),null)}negate(){if(!this.c){const u=[];for(const z of this.expr)u.push(z.negate());for(;u.length>1;){const z=u.shift(),ne=u.shift(),N=[];for(const X of ue(z))for(const W of ue(ne))N.push(le.create([X,W],null,!1));u.unshift(G.create(N,null,!1))}this.c=G.create(u,this,!0)}return this.c}}e.$Mj=G;class q extends w{static{this.d=[]}static all(){return q.d.values()}constructor(u,z,ne){super(u,null),this.f=z,typeof ne=="object"?q.d.push({...ne,key:u}):ne!==!0&&q.d.push({key:u,description:ne,type:z!=null?typeof z:void 0})}bindTo(u){return u.createKey(this.key,this.f)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return F.create(this.key,u)}notEqualsTo(u){return O.create(this.key,u)}}e.$Nj=q,e.$Oj=(0,A.$wi)("contextKeyService");function K(x,u){return x<u?-1:x>u?1:0}function _(x,u,z,ne){return x<z?-1:x>z?1:u<ne?-1:u>ne?1:0}function de(x,u){if(x.type===0||u.type===1)return!0;if(x.type===9)return u.type===9?B(x.expr,u.expr):!1;if(u.type===9){for(const z of u.expr)if(de(x,z))return!0;return!1}if(x.type===6){if(u.type===6)return B(u.expr,x.expr);for(const z of x.expr)if(de(z,u))return!0;return!1}return x.equals(u)}function B(x,u){let z=0,ne=0;for(;z<x.length&&ne<u.length;){const N=x[z].cmp(u[ne]);if(N<0)return!1;N===0&&z++,ne++}return z===x.length}function ue(x){return x.type===9?x.expr:[x]}}),define(fe[79],ge([0,1,51,5,9,10,6,69,21,3,19,22]),function(oe,e,p,S,E,A,j,k,h,r,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=P,e.$5k=f,e.$6k=s,e.$7k=d,e.$8k=y,e.$9k=i,e.$0k=t,e.$$k=c,e.$_k=L,e.$al=m,e.$bl=D,e.$dl=F,e.$el=Q,e.$fl=U,e.$gl=O,e.$hl=g,e.$kl=ie,e.$wl=q,e.$xl=K,e.$zl=de,e.$3k=(0,h.$wi)("fileService");function P(B){return B.create===!0}var o;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(o||(e.FileType=o={}));var a;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var $;(function(B){B[B.UPDATED=2]="UPDATED",B[B.ADDED=4]="ADDED",B[B.DELETED=8]="DELETED"})($||(e.FileChangeFilter=$={}));function f(B){const ue=B;return!!ue&&typeof ue.onDidChange=="function"}var n;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(n||(e.FileSystemProviderCapabilities=n={}));function s(B){return!!(B.capabilities&2)}function d(B){return!!(B.capabilities&8)}function y(B){return!!(B.capabilities&131072)}function i(B){return!!(B.capabilities&4)}function t(B){return!!(B.capabilities&16)}function c(B){return s(B)?!!(B.capabilities&16384):!1}function L(B){return s(B)?!!(B.capabilities&32768):!1}function m(B){return!!(B.capabilities&65536)}function D(B){return!!(B.capabilities&2048)}var C;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class w extends Error{static create(ue,x){const u=new w(ue.toString(),x);return U(u,x),u}constructor(ue,x){super(ue),this.code=x}}e.$cl=w;function F(B,ue){return w.create(B,ue)}function Q(B){return B||F((0,k.localize)(0,null),C.Unknown)}function U(B,ue){return B.name=ue?`${ue} (FileSystemError)`:"FileSystemError",B}function O(B){if(!B)return C.Unknown;if(B instanceof w)return B.code;const ue=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!ue)return C.Unknown;switch(ue[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}function g(B){if(B instanceof V)return B.fileOperationResult;switch(O(B)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 9;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileTooLarge:return 7;default:return 10}}var I;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class b{constructor(ue,x,u){this.resource=ue,this.operation=x,this.target=u}isOperation(ue){return this.operation===ue}}e.$il=b;var M;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class Z{static{this.a=null}constructor(ue,x){this.c=x,this.b=void 0,this.d=new l.$V(()=>{const u=p.$Ci.forUris(()=>this.c);return u.fill(this.rawAdded.map(z=>[z,!0])),u}),this.f=new l.$V(()=>{const u=p.$Ci.forUris(()=>this.c);return u.fill(this.rawUpdated.map(z=>[z,!0])),u}),this.g=new l.$V(()=>{const u=p.$Ci.forUris(()=>this.c);return u.fill(this.rawDeleted.map(z=>[z,!0])),u}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const u of ue){switch(u.type){case 1:this.rawAdded.push(u.resource);break;case 0:this.rawUpdated.push(u.resource);break;case 2:this.rawDeleted.push(u.resource);break}this.b!==Z.a&&(typeof u.cId=="number"?this.b===void 0?this.b=u.cId:this.b!==u.cId&&(this.b=Z.a):this.b!==void 0&&(this.b=Z.a))}}contains(ue,...x){return this.h(ue,{includeChildren:!1},...x)}affects(ue,...x){return this.h(ue,{includeChildren:!0},...x)}h(ue,x,...u){if(!ue)return!1;const z=u.length>0;return!!((!z||u.includes(1))&&(this.d.value.get(ue)||x.includeChildren&&this.d.value.findSuperstr(ue))||(!z||u.includes(0))&&(this.f.value.get(ue)||x.includeChildren&&this.f.value.findSuperstr(ue))||(!z||u.includes(2))&&(this.g.value.findSubstr(ue)||x.includeChildren&&this.g.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.b===ue}hasCorrelation(){return typeof this.b=="number"}}e.$jl=Z;function ie(B,ue,x){return!B||!ue||B===ue||ue.length>B.length?!1:(ue.charAt(ue.length-1)!==S.sep&&(ue+=S.sep),x?(0,E.$yf)(B,ue):B.indexOf(ue)===0)}class V extends Error{constructor(ue,x,u){super(ue),this.fileOperationResult=x,this.options=u}}e.$ll=V;class ee extends V{constructor(ue,x,u,z){super(ue,x,z),this.fileOperationResult=x,this.size=u}}e.$ml=ee;class ae extends V{constructor(ue,x,u){super(ue,2,u),this.stat=x}}e.$nl=ae;var le;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var G;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(G||(e.FileKind=G={})),e.$vl="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}async function K(B,ue){if(!ue.hasProvider(j.URI.from({scheme:B.scheme})))return new Promise(x=>{const u=ue.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===B.scheme&&z.added&&(u.dispose(),x())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(ue){return(0,A.$ag)(ue)||(ue=0),ue<_.KB?(0,k.localize)(1,null,ue.toFixed(0)):ue<_.MB?(0,k.localize)(2,null,(ue/_.KB).toFixed(2)):ue<_.GB?(0,k.localize)(3,null,(ue/_.MB).toFixed(2)):ue<_.TB?(0,k.localize)(4,null,(ue/_.GB).toFixed(2)):(0,k.localize)(5,null,(ue/_.TB).toFixed(2))}}e.$yl=_;function de(B){const ue=typeof B=="string"||B?.scheme===v.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===v.Schemas.file?1024*_.MB:ue?10*_.MB:r.$o?50*_.MB:1024*_.MB}}),define(fe[8],ge([0,1,70,56,4,49,2,25,3,23,10,6,35,21]),function(oe,e,p,S,E,A,j,k,h,r,v,l,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=$,e.log=n,e.$ek=w,e.$fk=F,e.$gk=Q,e.$hk=U,e.$3j=(0,o.$wi)("logService"),e.$4j=(0,o.$wi)("loggerService");function a(){return new Date().toISOString()}function $(O){return(0,v.$ag)(O)}var f;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$6j=f.Info;function n(O,g,I){switch(g){case f.Trace:O.trace(I);break;case f.Debug:O.debug(I);break;case f.Info:O.info(I);break;case f.Warning:O.warn(I);break;case f.Error:O.error(I);break;case f.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function s(O,g=!1){let I="";for(let b=0;b<O.length;b++){let M=O[b];if(M instanceof Error&&(M=(0,S.$hj)(M,g)),typeof M=="object")try{M=JSON.stringify(M)}catch{}I+=(b>0?" ":"")+M}return I}class d extends j.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new E.$de),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==f.Off&&this.b<=g}}e.$8j=d;class y extends d{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...I){this.f(f.Trace)&&this.g(f.Trace,s([g,...I],!0))}debug(g,...I){this.f(f.Debug)&&this.g(f.Debug,s([g,...I]))}info(g,...I){this.f(f.Info)&&this.g(f.Info,s([g,...I]))}warn(g,...I){this.f(f.Warning)&&this.g(f.Warning,s([g,...I]))}error(g,...I){if(this.f(f.Error))if(g instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=g.stack,this.g(f.Error,s(b))}else this.g(f.Error,s([g,...I]))}flush(){}}e.$9j=y;class i extends d{constructor(g=e.$6j){super(),this.setLevel(g),this.g=!h.$i}trace(g,...I){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,g,...I):console.log(`[main ${a()}]`,g,...I))}debug(g,...I){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,g,...I):console.log(`[main ${a()}]`,g,...I))}info(g,...I){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,g,...I):console.log(`[main ${a()}]`,g,...I))}warn(g,...I){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,g,...I):console.warn(`[main ${a()}]`,g,...I))}error(g,...I){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,g,...I):console.error(`[main ${a()}]`,g,...I))}flush(){}}e.$0j=i;class t extends d{constructor(g=e.$6j,I=!0){super(),this.g=I,this.setLevel(g)}trace(g,...I){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...I):console.log(g,...I))}debug(g,...I){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...I):console.log(g,...I))}info(g,...I){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...I):console.log(g,...I))}warn(g,...I){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...I):console.log(g,...I))}error(g,...I){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...I):console.error(g,...I))}flush(){}}e.$$j=t;class c extends d{constructor(g,I=e.$6j){super(),this.g=g,this.setLevel(I)}trace(g,...I){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(g),...I])}debug(g,...I){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(g),...I])}info(g,...I){this.f(f.Info)&&this.g.log(f.Info,[this.h(g),...I])}warn(g,...I){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(g),...I])}error(g,...I){this.f(f.Error)&&this.g.log(f.Error,[this.h(g),...I])}h(g){return typeof g=="string"?g:(0,S.$hj)(g,this.f(f.Trace))}flush(){}}e.$_j=c;class L extends d{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const I of this.g)I.setLevel(g);super.setLevel(g)}trace(g,...I){for(const b of this.g)b.trace(g,...I)}debug(g,...I){for(const b of this.g)b.debug(g,...I)}info(g,...I){for(const b of this.g)b.info(g,...I)}warn(g,...I){for(const b of this.g)b.warn(g,...I)}error(g,...I){for(const b of this.g)b.error(g,...I)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose();super.dispose()}}e.$ak=L;class m extends j.$Uc{constructor(g,I,b){if(super(),this.h=g,this.j=I,this.b=new k.$Ac,this.c=this.B(new E.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$de),this.onDidChangeVisibility=this.g.event,b)for(const M of b)this.b.set(M.resource,{logger:void 0,info:M})}m(g){return(0,v.$9f)(g)?[...this.b.values()].find(I=>I.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,I){const b=this.n(g),M=(0,v.$9f)(g)?g:I?.id??(0,A.$kj)(b.toString()).toString(16);let Z=this.b.get(b)?.logger;const ie=I?.logLevel==="always"?f.Trace:I?.logLevel;Z||(Z=this.s(b,ie??this.getLogLevel(b)??this.h,{...I,id:M}));const V={logger:Z,info:{resource:b,id:M,logLevel:ie,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(V.info),this.b.set(b,V),Z}n(g){return(0,v.$9f)(g)?(0,r.$0g)(this.j,`${g}.log`):g}setLogLevel(g,I){if(l.URI.isUri(g)){const b=g,M=I,Z=this.b.get(b);Z&&M!==Z.info.logLevel&&(Z.info.logLevel=M===this.h?void 0:M,Z.logger?.setLevel(M),this.b.set(Z.info.resource,Z),this.f.fire([b,M]))}else{this.h=g;for(const[b,M]of this.b.entries())this.b.get(b)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,I){const b=this.m(g);b&&I!==!b.info.hidden&&(b.info.hidden=!I,this.b.set(b.info.resource,b),this.g.fire([b.info.resource,I]))}getLogLevel(g){let I;return g&&(I=this.b.get(g)?.info.logLevel),I??this.h}registerLogger(g){const I=this.b.get(g.resource);I?I.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const I=this.b.get(g);I&&(I.logger&&I.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=m;class D{constructor(){this.onDidChangeLogLevel=new E.$de().event}setLevel(g){}getLevel(){return f.Info}trace(g,...I){}debug(g,...I){}info(g,...I){}warn(g,...I){}error(g,...I){}critical(g,...I){}dispose(){}flush(){}}e.$ck=D;class C extends D{}e.$dk=C;function w(O){if(O.verbose)return f.Trace;if(typeof O.logLevel=="string"){const g=U(O.logLevel.toLowerCase());if(g!==void 0)return g}return e.$6j}function F(O){switch(O){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function Q(O){switch(O){case f.Trace:return{original:"Trace",value:p.localize(0,null)};case f.Debug:return{original:"Debug",value:p.localize(1,null)};case f.Info:return{original:"Info",value:p.localize(2,null)};case f.Warning:return{original:"Warning",value:p.localize(3,null)};case f.Error:return{original:"Error",value:p.localize(4,null)};case f.Off:return{original:"Off",value:p.localize(5,null)}}}function U(O){switch(O){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ik=new P.$Nj("logLevel",F(f.Info))}),define(fe[80],ge([0,1,6,4,8,2]),function(oe,e,p,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=void 0;class j extends E.$bk{constructor(l,P,o,a,$){super(P,o,a),this.r=l,this.t=$,this.B($.listen("onDidChangeLogLevel",l)(f=>{(0,E.$5j)(f)?super.setLogLevel(f):super.setLogLevel(p.URI.revive(f[0]),f[1])})),this.B($.listen("onDidChangeVisibility",l)(([f,n])=>super.setVisibility(p.URI.revive(f),n))),this.B($.listen("onDidChangeLoggers",l)(({added:f,removed:n})=>{for(const s of f)super.registerLogger({...s,resource:p.URI.revive(s.resource)});for(const s of n)super.deregisterLogger(s.resource)}))}createConsoleMainLogger(){return new E.$_j({log:(l,P)=>{this.t.call("consoleLog",[l,P])}})}registerLogger(l){super.registerLogger(l),this.t.call("registerLogger",[l,this.r])}deregisterLogger(l){super.deregisterLogger(l),this.t.call("deregisterLogger",[l,this.r])}setLogLevel(l,P){super.setLogLevel(l,P),this.t.call("setLogLevel",[l,P])}setVisibility(l,P){super.setVisibility(l,P),this.t.call("setVisibility",[this.n(l),P])}s(l,P,o){return new k(this.t,l,P,o,this.r)}static setLogLevel(l,P,o){return l.call("setLogLevel",[P,o])}}e.$_r=j;class k extends E.$9j{constructor(l,P,o,a,$){super(a?.logLevel==="always"),this.r=l,this.s=P,this.m=!1,this.n=[],this.setLevel(o),this.r.call("createLogger",[P,a,$]).then(()=>{this.u(this.n),this.m=!0})}g(l,P){const o=[[l,P]];this.m?this.u(o):this.n.push(...o)}u(l){this.r.call("log",[this.s,l])}}class h{constructor(l,P){this.a=l,this.b=P}listen(l,P){const o=this.b(l);switch(P){case"onDidChangeLoggers":return S.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map($=>this.c($,o)),removed:[...a.removed].map($=>this.c($,o))}));case"onDidChangeVisibility":return S.Event.map(this.a.onDidChangeVisibility,a=>[o.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return S.Event.map(this.a.onDidChangeLogLevel,a=>(0,E.$5j)(a)?a:[o.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${P}`)}async call(l,P,o){const a=this.b(l);switch(P){case"setLogLevel":return(0,E.$5j)(o[0])?this.a.setLogLevel(o[0]):this.a.setLogLevel(p.URI.revive(a.transformIncoming(o[0][0])),o[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map($=>this.c($,a)))}throw new Error(`Call not found: ${P}`)}c(l,P){return{...l,resource:P.transformOutgoingURI(l.resource)}}}e.$as=h;class r extends A.$Uc{constructor(l,P){super(),P.call("setLogLevel",[l.getLogLevel()]),this.B(l.onDidChangeLogLevel(o=>P.call("setLogLevel",[o]))),P.call("getRegisteredLoggers").then(o=>{for(const a of o)l.registerLogger({...a,resource:p.URI.revive(a.resource)})}),this.B(P.listen("onDidChangeVisibility")(([o,a])=>l.setVisibility(p.URI.revive(o),a))),this.B(P.listen("onDidChangeLoggers")(({added:o,removed:a})=>{for(const $ of o)l.registerLogger({...$,resource:p.URI.revive($.resource)});for(const $ of a)l.deregisterLogger($.resource)}))}}e.$bs=r}),define(fe[81],ge([0,1,2,8]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=void 0;class E extends p.$Uc{constructor(j,k=[]){super(),this.a=new S.$ak([j,...k]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...k){this.a.trace(j,...k)}debug(j,...k){this.a.debug(j,...k)}info(j,...k){this.a.info(j,...k)}warn(j,...k){this.a.warn(j,...k)}error(j,...k){this.a.error(j,...k)}flush(){this.a.flush()}}e.$ZQ=E}),define(fe[82],ge([0,1,79,8]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;var E;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(E||(E={}));async function A(r,v,l,P,o){try{const a=await new Promise((f,n)=>{oe(["@vscode/spdlog"],f,n)});a.setFlushOn(E.Trace);const $=await a.createAsyncRotatingLogger(r,v,l,P);return o?$.clearFormatters():$.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),$}catch(a){console.error(a)}return null}function j(r,v,l){switch(v){case S.LogLevel.Trace:r.trace(l);break;case S.LogLevel.Debug:r.debug(l);break;case S.LogLevel.Info:r.info(l);break;case S.LogLevel.Warning:r.warn(l);break;case S.LogLevel.Error:r.error(l);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function k(r,v){switch(v){case S.LogLevel.Trace:r.setLevel(E.Trace);break;case S.LogLevel.Debug:r.setLevel(E.Debug);break;case S.LogLevel.Info:r.setLevel(E.Info);break;case S.LogLevel.Warning:r.setLevel(E.Warning);break;case S.LogLevel.Error:r.setLevel(E.Error);break;case S.LogLevel.Off:r.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class h extends S.$9j{constructor(v,l,P,o,a){super(),this.m=[],this.setLevel(a),this.n=this.s(v,l,P,o),this.B(this.onDidChangeLogLevel($=>{this.r&&k(this.r,$)}))}async s(v,l,P,o){const a=P?6:1,$=30/a*p.$yl.MB,f=await A(v,l,$,a,o);if(f){this.r=f,k(this.r,this.getLevel());for(const{level:n,message:s}of this.m)j(this.r,n,s);this.m=[]}}g(v,l){this.r?j(this.r,v,l):this.getLevel()<=v&&this.m.push({level:v,message:l})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$OQ=h}),define(fe[83],ge([0,1,52,8,82]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=void 0;class A extends S.$bk{s(k,h,r){return new E.$OQ((0,p.$Sg)(),k.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,h)}}e.$PQ=A}),define(fe[84],ge([0,1,15]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let S;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const A=E.context.configuration();if(A)S=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(S=globalThis._VSCODE_PRODUCT_JSON,p.env.VSCODE_DEV&&Object.assign(S,{nameShort:`${S.nameShort} Dev`,nameLong:`${S.nameLong} Dev`,dataFolderName:`${S.dataFolderName}-dev`,serverDataFolderName:S.serverDataFolderName?`${S.serverDataFolderName}-dev`:void 0}),!S.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(S,{version:A.version})}}else S={},Object.keys(S).length===0&&Object.assign(S,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=S}),define(fe[85],ge([0,1,21]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,p.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(fe[86],ge([0,1,42,10]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class E{constructor(){this.a=new Map}add(j,k){p.ok(S.$9f(j)),p.ok(S.$$f(k)),p.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,k)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$co=new E}),define(fe[87],ge([0,1,4,2]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vub=void 0;class E extends S.$Uc{constructor(j){super(),this.f=j,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new p.$de),this.onMarkAdded=this.c.event}*markers(){for(const j of this.a.values())yield j;for(const j of this.b.values())yield j}addMark(j){const k=j?.marker||this.f.registerMarker(),h=j?.id;k&&(h?(this.a.set(h,k),k.onDispose(()=>this.a.delete(h))):(this.b.set(k.id,k),k.onDispose(()=>this.b.delete(k.id))),this.c.fire({marker:k,id:h,hidden:j?.hidden,hoverMessage:j?.hoverMessage}))}getMark(j){return this.a.get(j)}}e.$vub=E});var ze=this&&this.__param||function(oe,e){return function(p,S){e(p,S,oe)}};define(fe[88],ge([0,1,4,2,8,14]),function(oe,e,p,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;var j;(function(h){h[h.Unknown=0]="Unknown",h[h.Input=1]="Input",h[h.Execute=2]="Execute"})(j||(j={}));let k=class extends S.$Uc{get value(){return this.h}get cursorIndex(){return this.j}get ghostTextIndex(){return this.m}constructor(r,v,l,P){super(),this.u=r,this.w=P,this.a=0,this.c=0,this.g="",this.h="",this.j=0,this.m=-1,this.n=this.B(new p.$de),this.onDidStartInput=this.n.event,this.r=this.B(new p.$de),this.onDidChangeInput=this.r.event,this.s=this.B(new p.$de),this.onDidFinishInput=this.s.event,this.t=this.B(new p.$de),this.onDidInterrupt=this.t.event,this.B(p.Event.any(this.u.onCursorMove,this.u.onData,this.u.onWriteParsed)(()=>this.F())),this.B(this.u.onData(o=>this.G(o))),this.B(v(o=>this.C(o))),this.B(l(()=>this.D())),this.B(this.onDidStartInput(()=>this.z("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.z("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.z("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.z("PromptInputModel#onDidInterrupt")))}z(r){this.w.getLevel()===E.LogLevel.Trace&&this.w.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.f=r}setConfidentCommandLine(r){this.h!==r&&(this.h=r,this.j=-1,this.m=-1,this.r.fire(this.O()))}getCombinedString(){const r=this.h.replaceAll(`
`,"\u23CE");if(this.j===-1)return r;let v=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(v+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,v+=`${r.substring(this.ghostTextIndex)}]`):v+=r.substring(this.cursorIndex),v}C(r){this.a!==1&&(this.a=1,this.b=r.marker,this.c=this.u.buffer.active.cursorX,this.h="",this.j=0,this.n.fire(this.O()),this.r.fire(this.O()))}D(){if(this.a===2)return;this.j=-1,this.m!==-1&&(this.h=this.h.substring(0,this.m),this.m=-1);const r=this.O();this.g===""&&this.t.fire(r),this.a=2,this.s.fire(r),this.r.fire(r)}F(){if(this.a!==1)return;const r=this.b?.line;if(r===void 0)return;const v=this.u.buffer.active;let l=v.getLine(r);const P=l?.translateToString(!0,this.c);if(!l||P===void 0){this.w.trace("PromptInputModel#_sync: no line");return}const o=v.baseY+v.cursorY;let a=P,$=o===r?this.M(this.c,v,l):P.length+1,f=-1;o===r&&v.cursorX>1&&(f=this.H(v,l,$));for(let n=r+1;n<=o;n++){l=v.getLine(n);let s=l?.translateToString(!0);if(s&&l)if(this.f===void 0||this.J(s))s=this.I(s),a+=`
${s}`,$+=o===n?this.M(this.L(l,s),v,l):s.length+1;else break}for(let n=o+1;n<v.baseY+this.u.rows;n++){l=v.getLine(n);const s=l?.translateToString(!0);if(s&&l)if(this.f===void 0||this.J(s))a+=`
${this.I(s)}`;else break;else break}this.w.getLevel()===E.LogLevel.Trace&&this.w.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`),(this.h!==a||this.j!==$||this.m!==f)&&(this.h=a,this.j=$,this.m=f,this.r.fire(this.O()))}G(r){this.g=r}H(r,v,l){let P=-1,o=!1,a=r.cursorX;for(;a>0;){const $=v.getCell(--a);if(!$)break;if($.getChars().trim().length>0){o=!this.N($);break}}if(o){let $=0,f=r.cursorX;for(;f<v.length;){const n=v.getCell(f++);if(!n||n.getCode()===0)break;if(this.N(n)){P=l+$;break}$+=n.getChars().length}}return P}I(r){return this.J(r)&&(r=r.substring(this.f.length)),r}J(r){return!!(this.f&&r.startsWith(this.f))}L(r,v){if(!this.f||!v.startsWith(this.f))return 0;let l="",P=0;for(;l!==this.f;)l+=r.getCell(P++).getChars();return P}M(r,v,l){return l?.translateToString(!0,r,v.cursorX).length??0}N(r){return!!(r.isItalic()||r.isDim())}O(){return Object.freeze({value:this.h,cursorIndex:this.j,ghostTextIndex:this.m})}};e.$3r=k,be([(0,A.$3h)(0)],k.prototype,"F",null),e.$3r=k=be([ze(3,E.$3j)],k)}),define(fe[89],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=void 0;class p{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(v){this.b.endMarker=v}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(v,l){this.a=v,this.b=l}static deserialize(v,l,P){const o=v.buffer.normal,a=l.startLine!==void 0?v.registerMarker(l.startLine-(o.baseY+o.cursorY)):void 0;if(!a)return;const $=l.promptStartLine!==void 0?v.registerMarker(l.promptStartLine-(o.baseY+o.cursorY)):void 0,f=l.endLine!==void 0?v.registerMarker(l.endLine-(o.baseY+o.cursorY)):void 0,n=l.executedLine!==void 0?v.registerMarker(l.executedLine-(o.baseY+o.cursorY)):void 0;return new p(v,{command:P?"":l.command,commandLineConfidence:l.commandLineConfidence??"low",isTrusted:l.isTrusted,promptStartMarker:$,marker:a,startX:l.startX,endMarker:f,executedMarker:n,executedX:l.executedX,timestamp:l.timestamp,duration:l.duration,cwd:l.cwd,commandStartLineContent:l.commandStartLineContent,exitCode:l.exitCode,markProperties:l.markProperties,aliases:void 0,wasReplayed:!0})}serialize(v){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:v?"":this.command,commandLineConfidence:v?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return E(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const v=this.executedMarker.line,l=this.endMarker.line;if(v===l)return;let P="",o;for(let a=v;a<l;a++)o=this.a.buffer.active.getLine(a),o&&(P+=o.translateToString(!o.isWrapped)+(o.isWrapped?"":`
`));return P===""?void 0:P}getOutputMatch(v){if(!this.executedMarker||!this.endMarker)return;const l=this.endMarker.line;if(l===-1)return;const P=this.a.buffer.active,o=Math.max(this.executedMarker.line,0),a=v.lineMatcher,$=typeof a=="string"?1:v.length||j(a),f=[];let n;if(v.anchor==="bottom")for(let s=l-(v.offset||0);s>=o;s--){let d=s;const y=s;for(;d>=o&&P.getLine(d)?.isWrapped;)d--;if(s=d,f.unshift(A(P,d,y,this.a.cols)),n||(n=f[0].match(a)),f.length>=$)break}else for(let s=o+(v.offset||0);s<l;s++){const d=s;let y=s;for(;y+1<l&&P.getLine(y+1)?.isWrapped;)y++;if(s=y,f.push(A(P,d,y,this.a.cols)),n||(n=f[f.length-1].match(a)),f.length>=$)break}return n?{regexMatch:n,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return k(this,this.a.buffer.active)}getCommandRowCount(){return h(this)}}e.$4r=p;class S{constructor(v){this.c=v}serialize(v){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:v,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(v,l,P,o){if(l===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||P)return new p(this.c,{command:P?"":this.command||"",commandLineConfidence:P?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:v,exitCode:l,commandStartLineContent:this.commandStartLineContent,markProperties:o})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return E(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return k(this,this.c.buffer.active)}getCommandRowCount(){return h(this)}}e.$5r=S;function E(r,v,l,P,o,a){if(!l||!o||P===void 0||a===void 0)return"";let $="";for(let f=l.line;f<=o.line;f++){const n=r.getLine(f);n&&($+=n.translateToString(!0,f===l.line?P:0,f===o.line?a:v))}return $}function A(r,v,l,P){const o=Math.max(2048/P*2);l=Math.min(l,v+o);let a="";for(let $=v;$<=l;$++){const f=r.getLine($);f&&(a+=f.translateToString(!0,0,P))}return a}function j(r){if(!r.multiline)return 1;const v=r.source;let l=1,P=v.indexOf("\\n");for(;P!==-1;)l++,P=v.indexOf("\\n",P+1);return l}function k(r,v){const l="hasOutput"in r?r.marker:r.commandStartMarker;if(!l||!r.promptStartMarker)return 1;let P=1,o=r.promptStartMarker.line;for(;o<l.line&&(v.getLine(o)?.translateToString(!0)??"").length===0;)o++;return P=l.line-o+1,P}function h(r){const v="hasOutput"in r?r.marker:r.commandStartMarker,l="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!v||!l)return 1;let o=Math.max(l.line,v.line)-v.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&o--,o}}),define(fe[90],ge([0,1,12,14,4,2,8,89,88]),function(oe,e,p,S,E,A,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rub=void 0,e.$sub=o;let r=class extends A.$Uc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}get D(){return!!(this.n.commandStartMarker&&!this.n.commandExecutedMarker)}get hasInput(){if(!(!this.D||!this.n?.commandStartMarker)){if(this.M.buffer.active.baseY+this.M.buffer.active.cursorY===this.n.commandStartMarker?.line){const n=this.M.buffer.active.getLine(this.M.buffer.active.cursorY)?.translateToString(!0,this.n.commandStartX);return n===void 0?void 0:n.length>0}return!0}}constructor(n,s){super(),this.M=n,this.N=s,this.type=2,this.f=[],this.n=new k.$5r(this.M),this.r=[],this.t=!1,this.F=this.B(new E.$de),this.onCommandStarted=this.F.event,this.G=this.B(new E.$de),this.onBeforeCommandFinished=this.G.event,this.H=this.B(new E.$de),this.onCommandFinished=this.H.event,this.I=this.B(new E.$de),this.onCommandExecuted=this.I.event,this.J=this.B(new E.$de),this.onCommandInvalidated=this.J.event,this.L=this.B(new E.$de),this.onCurrentCommandInvalidated=this.L.event,this.c=this.B(new h.$3r(this.M,this.onCommandStarted,this.onCommandExecuted,this.N)),this.B(this.onCommandExecuted(y=>{if(y.commandLineConfidence!=="high"){const i=y;y.command=i.extractCommandLine(),y.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&y.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(y.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&y.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(y.commandLineConfidence="medium")}}));const d=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return d.L}get onCommandStartedEmitter(){return d.F}get onCommandExecutedEmitter(){return d.I}get dimensions(){return d.s}get isCommandStorageDisabled(){return d.t}get commandMarkers(){return d.r}set commandMarkers(y){d.r=y}get clearCommandsInViewport(){return d.Q.bind(d)}commitCommandFinished(){d.w?.flush(),d.w=void 0}},this.C=this.B(new A.$Wc(new v(this.M,this,this.z,this.N))),this.s={cols:this.M.cols,rows:this.M.rows},this.B(this.M.onResize(y=>this.O(y))),this.B(this.M.onCursorMove(()=>this.P()))}O(n){this.C.value.preHandleResize?.(n),this.s.cols=n.cols,this.s.rows=n.rows}P(){this.M.buffer.active===this.M.buffer.normal&&this.n.commandStartMarker&&this.M.buffer.active.baseY+this.M.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.Q(),this.n.isInvalid=!0,this.L.fire({reason:"windows"}))}Q(){let n=0;for(let s=this.f.length-1;s>=0;s--){const d=this.f[s].marker?.line;if(d&&d<this.M.buffer.active.baseY)break;n++}n>0&&this.J.fire(this.f.splice(this.f.length-n,n))}setContinuationPrompt(n){this.c.setContinuationPrompt(n)}setCwd(n){this.g=n}setIsWindowsPty(n){if(n&&!(this.C.value instanceof P)){const s=this;this.C.value=new P(this.M,this,new class{get onCurrentCommandInvalidatedEmitter(){return s.L}get onCommandStartedEmitter(){return s.F}get onCommandExecutedEmitter(){return s.I}get dimensions(){return s.s}get isCommandStorageDisabled(){return s.t}get commandMarkers(){return s.r}set commandMarkers(d){s.r=d}get clearCommandsInViewport(){return s.Q.bind(s)}commitCommandFinished(){s.w?.flush(),s.w=void 0}},this.N)}else!n&&!(this.C.value instanceof v)&&(this.C.value=new v(this.M,this,this.z,this.N))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(n){if(this.n.promptStartMarker&&n>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>n)){for(let s=this.commands.length-1;s>=0;s--)if((this.commands[s].promptStartMarker??this.commands[s].marker).line<=n)return this.commands[s]}}getCwdForLine(n){if(this.n.promptStartMarker&&n>=this.n.promptStartMarker?.line)return this.g;const s=this.getCommandForLine(n);if(s&&"cwd"in s)return s.cwd}handlePromptStart(n){const s=this.commands.at(-1);s?.endMarker&&s?.executedMarker&&s.endMarker.line===s.executedMarker.line&&(this.N.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${s.endMarker.line} -> ${s.executedMarker.line+1}`),s.endMarker=$(this.M,s.executedMarker,1)),this.n.promptStartMarker=n?.marker||(s?.endMarker?$(this.M,s.endMarker):this.M.registerMarker(0)),this.N.debug("CommandDetectionCapability#handlePromptStart",this.M.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.M.registerMarker(0),this.N.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.N.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.M.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.N.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(n){if(this.u=n,this.n.cwd=this.g,this.n.commandStartMarker=n?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.M.buffer.active.cursorY){this.n.commandStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(n)}handleGenericCommand(n){n?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(n),this.handleCommandStart(n),this.handleCommandExecuted(n),this.handleCommandFinished(void 0,n)}handleCommandExecuted(n){this.C.value.handleCommandExecuted(n),this.n.markExecutedTime()}handleCommandFinished(n,s){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.N.debug("CommandDetectionCapability#handleCommandFinished",this.M.buffer.active.cursorX,s?.marker?.line,this.n.command,this.n),n===void 0){const y=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&y?.command===this.n.command&&(n=y.exitCode)}if(this.n.commandStartMarker===void 0||!this.M.buffer.active)return;this.n.commandFinishedMarker=s?.marker||this.M.registerMarker(0),this.C.value.postHandleCommandFinished?.();const d=this.n.promoteToFullCommand(this.g,n,this.u?.ignoreCommandLine??!1,s?.markProperties);d&&(this.f.push(d),this.w=new p.$Ih(()=>{this.G.fire(d),this.n.isInvalid||(this.N.debug("CommandDetectionCapability#onCommandFinished",d),this.H.fire(d))},50),this.w.schedule()),this.n=new k.$5r(this.M),this.u=void 0}setCommandLine(n,s){this.N.debug("CommandDetectionCapability#setCommandLine",n,s),this.n.command=n,this.n.commandLineConfidence="high",this.n.isTrusted=s,s&&this.c.setConfidentCommandLine(n)}serialize(){const n=this.commands.map(d=>d.serialize(this.t)),s=this.n.serialize(this.g);return s&&n.push(s),{isWindowsPty:this.C.value instanceof P,commands:n}}deserialize(n){n.isWindowsPty&&this.setIsWindowsPty(n.isWindowsPty);const s=this.M.buffer.normal;for(const d of n.commands){if(!d.endLine){const i=d.startLine!==void 0?this.M.registerMarker(d.startLine-(s.baseY+s.cursorY)):void 0;if(!i)continue;this.n.commandStartMarker=d.startLine!==void 0?this.M.registerMarker(d.startLine-(s.baseY+s.cursorY)):void 0,this.n.commandStartX=d.startX,this.n.promptStartMarker=d.promptStartLine!==void 0?this.M.registerMarker(d.promptStartLine-(s.baseY+s.cursorY)):void 0,this.g=d.cwd,this.F.fire({marker:i});continue}const y=k.$4r.deserialize(this.M,d,this.t);y&&(this.f.push(y),this.N.debug("CommandDetectionCapability#onCommandFinished",y),this.H.fire(y))}}setPromptTerminator(n){this.N.debug("CommandDetectionCapability#setPromptTerminator",n),this.h=n}};e.$rub=r,be([(0,S.$2h)(500)],r.prototype,"P",null),e.$rub=r=be([ze(1,j.$3j)],r);class v extends A.$Uc{constructor(n,s,d,y){super(),this.c=n,this.f=s,this.g=d,this.h=y,this.B(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&d.clearCommandsInViewport(),!1)))}handleCommandStart(n){this.g.commitCommandFinished();const s=this.f.currentCommand;s.commandStartX=this.c.buffer.active.cursorX,s.commandStartMarker=n?.marker||this.c.registerMarker(0),s.commandExecutedMarker?.dispose(),s.commandExecutedMarker=void 0,s.commandExecutedX=void 0;for(const d of this.g.commandMarkers)d.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:n?.marker||s.commandStartMarker,markProperties:n?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",s.commandStartX,s.commandStartMarker?.line)}handleCommandExecuted(n){const s=this.f.currentCommand;if(s.commandExecutedMarker=n?.marker||this.c.registerMarker(0),s.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",s.commandExecutedX,s.commandExecutedMarker?.line),!s.commandStartMarker||!s.commandExecutedMarker||s.commandStartX===void 0)return;s.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(s.commandStartMarker.line)?.translateToString(!0,s.commandStartX,s.commandRightPromptStartX).trim();let d=s.commandStartMarker.line+1;const y=s.commandExecutedMarker.line;for(;d<y;d++){const i=this.c.buffer.active.getLine(d);if(i){const t=s.continuations?.find(L=>L.marker.line===d);t&&(s.command+=`
`);const c=t?.end??0;s.command+=i.translateToString(!0,c)}}d===y&&(s.command+=this.c.buffer.active.getLine(y)?.translateToString(!0,void 0,s.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(s)}}var l;(function(f){f[f.MaxCheckLineCount=10]="MaxCheckLineCount",f[f.Interval=20]="Interval",f[f.MaximumPollCount=10]="MaximumPollCount"})(l||(l={}));let P=class extends A.$Uc{constructor(n,s,d,y){super(),this.n=n,this.r=s,this.s=d,this.t=y,this.c=this.B(new A.$Vc),this.g=0,this.h=0,this.B(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(n){const s=this.n.buffer.active.baseY,d=n.rows-this.s.dimensions.rows;d>0&&this.D().then(()=>{const y=Math.min(d,s);for(let i=this.r.commands.length-1;i>=0;i--){const t=this.r.commands[i];if(!t.marker||t.marker.line<s||t.commandStartLineContent===void 0)break;const c=this.n.buffer.active.getLine(t.marker.line);if(!c||c.translateToString(!0)===t.commandStartLineContent)continue;const L=t.marker.line-y;this.n.buffer.active.getLine(L)?.translateToString(!0)===t.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:y})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const n=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?$(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new p.$Ih(()=>this.u(n),20),this.f.schedule()}u(n){if(this.q.isDisposed)return;const s=this.n.buffer.active;let d=this.g;for(;d<10&&n.line+d<s.baseY+this.n.rows;){if(this.C()){const y=this.F(n.line+d);if(y){const i=typeof y=="string"?y:y.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof y=="object"&&y.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=$(this.n,this.r.currentCommand.commandStartMarker);const t=this.r.commands.at(-1);t&&this.r.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=$(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${n.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}d++}d<10?(this.g=d,++this.h<10?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=10,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const n=this.n.registerMarker(0);n&&this.s.commandMarkers.push(n)}})),this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(n){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const n=this.r.currentCommand,s=n.command,d=n.commandStartMarker?.line,y=n.commandExecutedMarker?.line;if(!s||s.length===0||d===void 0||d===-1||y===void 0||y===-1)return;let i=0,t=!1;for(let c=d;c<=y;c++){const L=this.n.buffer.active.getLine(c);if(!L)break;const m=L.translateToString(!0);for(let D=0;D<m.length;D++){for(;s.length<i&&s[i]===" ";)i++;if(m[D]===s[i]&&i++,i===s.length){const C=D>=this.n.cols-1;n.commandExecutedMarker=this.n.registerMarker(c-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(C?1:0)),n.commandExecutedX=C?0:D+1,t=!0;break}}if(t)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((n,s)=>n.line-s.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const n=this.r.commands.at(-1);if(!n)return!0;const s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,d=(n.endMarker?n.endMarker.line:n.marker?.line)??-1;return s>d}D(){const n=this.n.buffer.active.cursorX,s=this.n.buffer.active.cursorY;let d=0;return new Promise((y,i)=>{const t=setInterval(()=>{if(n!==this.n.buffer.active.cursorX||s!==this.n.buffer.active.cursorY){y(),clearInterval(t);return}d+=10,d>1e3&&(clearInterval(t),y())},10)})}F(n=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const s=this.n.buffer.active.getLine(n);if(!s)return;const d=s.translateToString(!0);if(!d)return;const y=d.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(y){const m=this.G(y,d,">");if(m)return{prompt:m,likelySingleLine:!0}}const i=d.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const m=this.G(i,d,"\u276F");if(m)return m}const t=d.match(/^(?<prompt>\$)/)?.groups?.prompt;if(t){const m=this.G(t,d,"$");if(m)return m}const c=d.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(c)return{prompt:c,likelySingleLine:!0};if(this.r.promptTerminator&&d.trim().endsWith(this.r.promptTerminator)){const m=this.G(d,d,this.r.promptTerminator);if(m)return m}const L=d.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return L?.groups?.prompt?{prompt:L.groups.prompt,likelySingleLine:!0}:void 0}G(n,s,d){if(n)return s===n&&n.endsWith(d)&&(n+=" "),n}};P=be([ze(3,j.$3j)],P);function o(f,n,s,d){if(!d)return;const y=n.executedMarker,i=n.endMarker;if(!y||!i)return;const t=y.line,c=i.line,L=d.length,m=[];if(d.anchor==="bottom")for(let D=c-(d.offset||0);D>=t;D--){let C=D;const w=D;for(;C>=t&&f.getLine(C)?.isWrapped;)C--;D=C,m.unshift(a(f,C,w,s)),m.length>L&&m.pop()}else for(let D=t+(d.offset||0);D<c;D++){const C=D;let w=D;for(;w+1<c&&f.getLine(w+1)?.isWrapped;)w++;D=w,m.push(a(f,C,w,s)),m.length===L&&m.shift()}return m}function a(f,n,s,d){const y=Math.max(2048/d*2);s=Math.min(s,n+y);let i="";for(let t=n;t<=s;t++){const c=f.getLine(t);c&&(i+=c.translateToString(!0,0,d))}return i}function $(f,n,s=0){return f.registerMarker(n.line-(f.buffer.active.baseY+f.buffer.active.cursorY)+s)}}),define(fe[91],ge([0,1,4,2]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tub=void 0;class E extends S.$Uc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new p.$de),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(j){const k=this.a!==j;this.a=j;const h=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,h+1),k&&this.c.fire(j)}}e.$tub=E}),define(fe[92],ge([0,1,4,2]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uub=void 0;var E;(function(j){j[j.MinimumPromptLength=2]="MinimumPromptLength"})(E||(E={}));class A extends S.$Tc{get commands(){return this.a}constructor(k){super(),this.c=k,this.type=3,this.a=[],this.b=this.add(new p.$de),this.onCommandFinished=this.b.event,this.add(this.c.onData(h=>this.h(h))),this.add(this.c.parser.registerCsiHandler({final:"J"},h=>(h.length>=1&&(h[0]===2||h[0]===3)&&this.m(),!1)))}h(k){k==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const k=this.c.registerMarker(0);k&&(this.a.push(k),this.b.fire(k))}}m(){let k=0;for(let h=this.a.length-1;h>=0&&!(this.a[h].line<this.c.buffer.active.baseY);h--)k++;this.a.splice(this.a.length-k,k)}}e.$uub=A}),define(fe[93],ge([0,1,4,2]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qub=e.$pub=void 0;class E extends S.$Uc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new p.$de),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new p.$de),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new p.$de),this.onDidRemoveCapability=this.g.event,this.h=this.B(new p.$de),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(k,h){this.a.set(k,h),this.f.fire(k),this.h.fire({id:k,capability:h})}get(k){return this.a.get(k)}remove(k){const h=this.a.get(k);h&&(this.a.delete(k),this.b.fire(k),this.h.fire({id:k,capability:h}))}has(k){return this.a.has(k)}}e.$pub=E;class A extends S.$Uc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new p.$de),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new p.$de),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new p.$de),this.onDidRemoveCapability=this.f.event,this.g=this.B(new p.$de),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const k of this._stores)for(const h of k.items)yield h}has(k){for(const h of this._stores)for(const r of h.items)if(r===k)return!0;return!1}get(k){for(const h of this._stores){const r=h.get(k);if(r)return r}}add(k){this._stores.push(k);for(const h of k.items)this.b.fire(h),this.g.fire({id:h,capability:k.get(h)});this.B(k.onDidAddCapabilityType(h=>this.b.fire(h))),this.B(k.onDidAddCapability(h=>this.g.fire(h))),this.B(k.onDidRemoveCapabilityType(h=>this.a.fire(h))),this.B(k.onDidRemoveCapability(h=>this.f.fire(h)))}}e.$qub=A}),define(fe[36],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var p;(function(S){S[S.Replace=1]="Replace",S[S.Append=2]="Append",S[S.Prepend=3]="Prepend"})(p||(e.EnvironmentVariableMutatorType=p={}))}),define(fe[94],ge([0,1,3,36]),function(oe,e,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;const E=new Map([[S.EnvironmentVariableMutatorType.Append,"APPEND"],[S.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[S.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(v){this.collections=v,this.a=new Map,this.b=new Map,v.forEach((l,P)=>{this.d(l,P);const o=l.map.entries();let a=o.next();for(;!a.done;){const $=a.value[1],f=a.value[0];let n=this.a.get(f);if(n||(n=[],this.a.set(f,n)),n.length>0&&n[0].type===S.EnvironmentVariableMutatorType.Replace){a=o.next();continue}const s={extensionIdentifier:P,value:$.value,type:$.type,scope:$.scope,variable:$.variable,options:$.options};s.scope||delete s.scope,n.unshift(s),a=o.next()}})}async applyToProcessEnvironment(v,l,P){let o;p.$i&&(o={},Object.keys(v).forEach(a=>o[a.toLowerCase()]=a));for(const[a,$]of this.getVariableMap(l)){const f=p.$i&&o[a.toLowerCase()]||a;for(const n of $){const s=P?await P(n.value):n.value;if(n.options?.applyAtProcessCreation??!0)switch(n.type){case S.EnvironmentVariableMutatorType.Append:v[f]=(v[f]||"")+s;break;case S.EnvironmentVariableMutatorType.Prepend:v[f]=s+(v[f]||"");break;case S.EnvironmentVariableMutatorType.Replace:v[f]=s;break}if(n.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${E.get(n.type)}`;v[d]=(v[d]?v[d]+":":"")+a+"="+this.c(s)}}}}c(v){return v.replaceAll(":","\\x3a")}diff(v,l){const P=new Map,o=new Map,a=new Map;if(v.getVariableMap(l).forEach(($,f)=>{const n=this.getVariableMap(l).get(f),s=k($,n);s&&P.set(f,s)}),this.getVariableMap(l).forEach(($,f)=>{const n=v.getVariableMap(l).get(f),s=k($,n);s&&a.set(f,s)}),this.getVariableMap(l).forEach(($,f)=>{const n=v.getVariableMap(l).get(f),s=h($,n);s&&o.set(f,s)}),!(P.size===0&&o.size===0&&a.size===0))return{added:P,changed:o,removed:a}}getVariableMap(v){const l=new Map;for(const P of this.a.values()){const o=P.filter(a=>j(a,v));o.length>0&&l.set(o[0].variable,o)}return l}getDescriptionMap(v){const l=new Map;for(const P of this.b.values()){const o=P.filter(a=>j(a,v,!0));for(const a of o)l.set(a.extensionIdentifier,a.description)}return l}d(v,l){if(!v.descriptionMap)return;const P=v.descriptionMap.entries();let o=P.next();for(;!o.done;){const a=o.value[1],$=o.value[0];let f=this.b.get($);f||(f=[],this.b.set($,f));const n={extensionIdentifier:l,scope:a.scope,description:a.description};n.scope||delete n.scope,f.push(n),o=P.next()}}}e.$rs=A;function j(r,v,l=!1){return r.scope?!!(r.scope.workspaceFolder&&v?.workspaceFolder&&r.scope.workspaceFolder.index===v.workspaceFolder.index):l?v===r.scope:!0}function k(r,v){if(!v)return r;const l=new Set;v.forEach(o=>l.add(o.extensionIdentifier));const P=[];return r.forEach(o=>{l.has(o.extensionIdentifier)||P.push(o)}),P.length===0?void 0:P}function h(r,v){if(!v)return;const l=new Map;v.forEach(o=>l.set(o.extensionIdentifier,o));const P=[];return r.forEach(o=>{const a=l.get(o.extensionIdentifier);a&&(o.type!==a.type||o.value!==a.value||o.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&P.push(a)}),P.length===0?void 0:P}}),define(fe[95],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=p,e.$ms=S,e.$ns=E,e.$os=A,e.$ps=j,e.$qs=k;function p(h){return[...h.entries()]}function S(h){return h?[...h.entries()]:[]}function E(h){return new Map(h)}function A(h){return new Map(h??[])}function j(h){return Array.from(h.entries()).map(r=>[r[0],p(r[1].map),S(r[1].descriptionMap)])}function k(h){return new Map(h.map(r=>[r[0],{map:E(r[1]),descriptionMap:A(r[2])}]))}}),define(fe[96],ge([0,1,12,17,4,2,8]),function(oe,e,p,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;let k=class extends A.$Uc{constructor(r,v){super(),this.h=v,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$de),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,A.$Sc)(()=>{for(const l of this.f.values())(0,A.$Pc)(l)}))}createRequest(r){return new Promise((v,l)=>{const P=++this.a;this.c.set(P,v),this.g.fire({requestId:P,...r});const o=new S.$oe;(0,p.$xh)(this.b,o.token).then(()=>l(`Request ${P} timed out (${this.b}ms)`)),this.f.set(P,[(0,A.$Sc)(()=>o.cancel())])})}acceptReply(r,v){const l=this.c.get(r);l?(this.c.delete(r),(0,A.$Pc)(this.f.get(r)||[]),this.f.delete(r),l(v)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$cs=k,e.$cs=k=be([ze(1,j.$3j)],k)}),define(fe[28],ge([0,1,21,35,86]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$8r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$7r=void 0,e.$7r=new S.$Nj("terminalTabFocusMode",!1,!0);var A;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var j;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var k;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(k||(e.PosixShellType=k={}));var h;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(h||(e.WindowsShellType=h={}));var r;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var v;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(v||(e.TerminalIpcChannels=v={}));var l;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(l||(e.ProcessPropertyType=l={})),e.$8r=(0,p.$wi)("ptyService");var P;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P||(e.HeartbeatConstants=P={}));var o;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(o||(e.TerminalLocation=o={}));var a;(function(i){i.TerminalView="view",i.Editor="editor"})(a||(e.TerminalLocationString=a={}));var $;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})($||(e.LocalReconnectConstants=$={}));var f;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var n;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(n||(e.ProfileSource=n={}));var s;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(s||(e.ShellIntegrationStatus=s={}));var d;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$9r={Backend:"workbench.contributions.terminal.processBackend"};class y{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const c=this.b(t.remoteAuthority);if(this.a.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this.a.set(c,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}E.$co.add(e.$9r.Backend,new y),e.$0r=(0,p.$wi)("localPtyService"),e.$$r=(0,p.$wi)("terminalLogService")}),define(fe[97],ge([0,1,12,2,3]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class A extends S.$Uc{constructor(k,h,r,v){super(),this.a=0,this.b=!1,this.c=!1,this.B(k.onProcessData(l=>{if(this.b||this.c)return;const P=typeof l=="string"?l:l.data;for(let o=0;o<P.length;o++)P[o]===h[this.a]?this.a++:this.f(),this.a===h.length&&(v.debug(`Auto reply match: "${h}", response: "${r}"`),k.input(r),this.c=!0,(0,p.$xh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){E.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$Jic=A}),define(fe[98],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fvb=void 0;class p{constructor(E){this.b=E,this.a=new Map}dispose(){for(const E of this.a.values())E.dispose()}startBuffering(E,A,j=5){const k=A(h=>{const r=typeof h=="string"?h:h.data;let v=this.a.get(E);if(v){v.data.push(r);return}const l=setTimeout(()=>this.flushBuffer(E),j);v={data:[r],timeoutId:l,dispose:()=>{clearTimeout(l),this.flushBuffer(E),k.dispose()}},this.a.set(E,v)});return k}stopBuffering(E){this.a.get(E)?.dispose()}flushBuffer(E){const A=this.a.get(E);A&&(this.a.delete(E),this.b(E,A.data.join("")))}}e.$Fvb=p}),define(fe[37],ge([0,1,3]),function(oe,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=S,e.$qQ=E,e.$rQ=A,e.$sQ=j;function S(k){let h=k;h.includes("\\")&&(h=h.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return h=h.replace(r,""),`'${h}'`}function E(k,h,r){if(!k)return"";if(!h)return k;h.match(/[\/\\]$/)&&(h=h.slice(0,h.length-1));const v=k.replace(/\\/g,"/").toLowerCase(),l=h.replace(/\\/g,"/").toLowerCase();return v.includes(l)?`~${r}${k.slice(h.length+1)}`:k}function A(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),p.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}function j(k){return!k.strictEnv}}),define(fe[99],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=S;var p;(function(E){E[E.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(p||(p={}));function S(E){const A=[];let j=0;for(let k=0;k<E.length-1;k++)(k-j+1>=50||E[k+1]==="\x1B")&&(A.push(E.substring(j,k+1)),j=k+1,k++);return j!==E.length&&A.push(E.substring(j)),A}}),define(fe[100],ge([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LUb=p;function p(S,E={}){let A="";return E.excludeLeadingNewLine||(A+=`\r
`),A+="\x1B[0m\x1B[7m * ",E.loudFormatting?A+="\x1B[0;104m":A+="\x1B[0m",A+=` ${S} \x1B[0m
\r`,A}}),define(fe[101],ge([0,1,2,93,90,91,92,4,87,6,37,9]),function(oe,e,p,S,E,A,j,k,h,r,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wub=e.ShellIntegrationOscPs=void 0,e.$xub=f,e.$yub=n,e.$zub=s;var P;(function(d){d[d.FinalTerm=133]="FinalTerm",d[d.VSCode=633]="VSCode",d[d.ITerm=1337]="ITerm",d[d.SetCwd=7]="SetCwd",d[d.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(P||(e.ShellIntegrationOscPs=P={}));var o;(function(d){d.PromptStart="A",d.CommandStart="B",d.CommandExecuted="C",d.CommandFinished="D",d.CommandLine="E",d.ContinuationStart="F",d.ContinuationEnd="G",d.RightPromptStart="H",d.RightPromptEnd="I",d.Property="P",d.SetMark="SetMark"})(o||(o={}));var a;(function(d){d.SetMark="SetMark",d.CurrentDir="CurrentDir"})(a||(a={}));class $ extends p.$Uc{get status(){return this.g}constructor(y,i,t,c){super(),this.j=y,this.m=i,this.n=t,this.r=c,this.capabilities=this.B(new S.$pub),this.b=!1,this.f=[],this.g=0,this.h=new k.$de,this.onDidChangeStatus=this.h.event,this.B((0,p.$Sc)(()=>{this.z(),this.s()}))}s(){(0,p.$Pc)(this.f),this.f.length=0}activate(y){this.a=y,this.capabilities.add(3,this.B(new j.$uub(this.a))),this.B(y.parser.registerOscHandler(633,i=>this.w(i))),this.B(y.parser.registerOscHandler(1337,i=>this.H(i))),this.f.push(y.parser.registerOscHandler(133,i=>this.t(i))),this.B(y.parser.registerOscHandler(7,i=>this.J(i))),this.B(y.parser.registerOscHandler(9,i=>this.I(i))),this.y()}getMarkerId(y,i){this.N(y).getMark(i)}t(y){const i=this.u(y);return this.g===0&&(this.g=1,this.h.fire(this.g)),i}u(y){if(!this.a)return!1;const[i,...t]=y.split(";");switch(i){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const c=t.length===1?parseInt(t[0]):void 0;return this.M(this.a).handleCommandFinished(c),!0}}return!1}w(y){const i=this.C(y);return!this.b&&i&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),i}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(y){if(!this.a)return!1;const i=y.indexOf(";"),t=i===-1?y:y.substring(0,i),c=i===-1?[]:y.substring(i+1).split(";");switch(t){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart(),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const L=c[0],m=L!==void 0?parseInt(L):void 0;return this.M(this.a).handleCommandFinished(m),!0}case"E":{const L=c[0],m=c[1];let D;return L!==void 0?D=f(L):D="",this.M(this.a).setCommandLine(D,m===this.j),!0}case"F":return this.M(this.a).handleContinuationStart(),!0;case"G":return this.M(this.a).handleContinuationEnd(),!0;case"H":return this.M(this.a).handleRightPromptStart(),!0;case"I":return this.M(this.a).handleRightPromptEnd(),!0;case"P":{const L=c[0],m=L!==void 0?f(L):"",{key:D,value:C}=n(m);if(C===void 0)return!0;switch(D){case"ContinuationPrompt":return this.D((0,l.$Uf)(C)),!0;case"Cwd":return this.G(C),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty(C==="True"),!0;case"Prompt":{const w=C.replace(/\x1b\[[0-9;]*m/g,"");return this.F(w),!0}case"Task":return this.N(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.N(this.a).addMark(s(c)),!0}return!1}D(y){this.a&&this.M(this.a).setContinuationPrompt(y)}F(y){if(!this.a)return;const i=y.substring(y.lastIndexOf(`
`)).trim(),t=i.substring(i.lastIndexOf(" ")).trim();t&&this.M(this.a).setPromptTerminator(t)}G(y){y=(0,v.$rQ)(y),this.L().updateCwd(y),this.capabilities.get(2)?.setCwd(y)}H(y){if(!this.a)return!1;const[i]=y.split(";");switch(i){case"SetMark":this.N(this.a).addMark();default:{const{key:t,value:c}=n(i);if(c===void 0)return!0;switch(t){case"CurrentDir":return this.G(c),!0}}}return!1}I(y){if(!this.a)return!1;const[i,...t]=y.split(";");switch(i){case"9":return t.length&&this.G(t[0]),!0}return!1}J(y){if(!this.a)return!1;const[i]=y.split(";");if(i.match(/^file:\/\/.*\//)){const t=r.URI.parse(i);if(t.path&&t.path.length>0)return this.G(t.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.M(this.a).serialize()}deserialize(y){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(y)}L(){let y=this.capabilities.get(0);return y||(y=this.B(new A.$tub),this.capabilities.add(0,y)),y}M(y){let i=this.capabilities.get(2);return i||(i=this.B(new E.$rub(y,this.r)),this.capabilities.add(2,i)),i}N(y){let i=this.capabilities.get(4);return i||(i=this.B(new h.$vub(y)),this.capabilities.add(4,i)),i}}e.$wub=$;function f(d){return d.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(y,i,t)=>t?String.fromCharCode(parseInt(t,16)):i)}function n(d){const y=d.indexOf("=");return y===-1?{key:d,value:void 0}:{key:d.substring(0,y),value:d.substring(1+y)}}function s(d){let y,i=!1;for(const t of d)t!==void 0&&(t==="Hidden"&&(i=!0),t.startsWith("Id=")&&(y=t.substring(3)));return{id:y,hidden:i}}}),define(fe[38],ge([0,1,5,14,4,2,62,8]),function(oe,e,p,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=e.$Kic=void 0;var h;(function(v){v[v.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",v[v.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(h||(h={})),e.$Kic=[];let r=class extends A.$Uc{set hasChildProcesses(l){this.a!==l&&(this.a=l,this.f.debug("ChildProcessMonitor: Has child processes changed",l),this.b.fire(l))}get hasChildProcesses(){return this.a}constructor(l,P){super(),this.c=l,this.f=P,this.a=!1,this.b=this.B(new E.$de),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const l=await(0,j.$Ds)(this.c);this.hasChildProcesses=this.j(l)}catch(l){this.f.debug("ChildProcessMonitor: Fetching process tree failed",l)}}h(){this.g()}j(l){if(!l.children)return!1;if(l.children.length===1){const P=l.children[0];let o;if(P.cmd.startsWith('"'))o=P.cmd.substring(1,P.cmd.indexOf('"',1));else{const a=P.cmd.indexOf(" ");a===-1?o=P.cmd:o=P.cmd.substring(0,a)}return e.$Kic.indexOf((0,p.$qc)(o).name)===-1}return l.children.length>0}};e.$Lic=r,be([(0,S.$2h)(1e3)],r.prototype,"g",null),be([(0,S.$3h)(5e3)],r.prototype,"h",null),e.$Lic=r=be([ze(1,k.$3j)],r)}),define(fe[102],ge([0,1,4,2,28]),function(oe,e,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;class A extends S.$Uc{constructor(){super(),this.a=this.B(new p.$de),this.onBeat=this.a.event;const k=setInterval(()=>{this.a.fire()},E.HeartbeatConstants.BeatInterval);this.B((0,S.$Sc)(()=>clearInterval(k)))}}e.$Mic=A}),define(fe[39],ge([0,1,20,19,30,5,3,15,9,10,24,36,95,94]),function(oe,e,p,S,E,A,j,k,h,r,v,l,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=a,e.$ts=$,e.$us=f;function a(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(p.release());let w=0;return C&&C.length===4&&(w=parseInt(C[3])),w}async function $(C,w,F,Q=k.env,U=v.Promises.exists){if(A.$ic(C))return await U(C)?C:void 0;if(w===void 0&&(w=k.cwd()),A.$mc(C)!=="."){const b=A.$jc(w,C);return await U(b)?b:void 0}const g=(0,E.$0n)(Q,"PATH");if(F===void 0&&(0,r.$9f)(g)&&(F=g.split(A.$tc)),F===void 0||F.length===0){const b=A.$jc(w,C);return await U(b)?b:void 0}for(const b of F){let M;if(A.$ic(b)?M=A.$jc(b,C):M=A.$jc(w,b,C),await U(M))return M;if(j.$i){let Z=M+".com";if(await U(Z)||(Z=M+".exe",await U(Z)))return Z}}const I=A.$jc(w,C);return await U(I)?I:void 0}function f(C,w,F,Q,U){const O=j.$i&&(!w.windowsEnableConpty||a()<18309);if(!w.shellIntegration.enabled||!C.executable||C.isFeatureTerminal&&!C.forceShellIntegration||C.ignoreShellIntegration||O)return;const g=C.args,I=k.$dc==="win32"?A.$nc(C.executable).toLowerCase():A.$nc(C.executable),b=A.$mc(S.$Qg.asFileUri("").fsPath);let M;const Z={VSCODE_INJECTION:"1"};if(w.shellIntegration.nonce&&(Z.VSCODE_NONCE=w.shellIntegration.nonce),j.$i){if(I==="pwsh.exe"||I==="powershell.exe")return!g||m(g)?M=d.get(s.WindowsPwsh):L(g)&&(M=d.get(s.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,h.$8e)(M[M.length-1],b,""),w.shellIntegration.suggestEnabled&&(Z.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:Z}):void 0;if(I==="bash.exe")return!g||g.length===0?M=d.get(s.Bash):D(g)&&(Z.VSCODE_SHELL_LOGIN="1",n(w,Z),M=d.get(s.Bash)),M?(M=[...M],M[M.length-1]=(0,h.$8e)(M[M.length-1],b),{newArgs:M,envMixin:Z}):void 0;Q.warn(`Shell integration cannot be enabled for executable "${C.executable}" and args`,C.args);return}switch(I){case"bash":return!g||g.length===0?M=d.get(s.Bash):D(g)&&(Z.VSCODE_SHELL_LOGIN="1",n(w,Z),M=d.get(s.Bash)),M?(M=[...M],M[M.length-1]=(0,h.$8e)(M[M.length-1],b),{newArgs:M,envMixin:Z}):void 0;case"fish":{const ie=F?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=A.$jc(b,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Z.XDG_DATA_DIRS=`${ie}:${V}`,n(w,Z),{newArgs:void 0,envMixin:Z}}case"pwsh":return!g||m(g)?M=d.get(s.Pwsh):L(g)&&(M=d.get(s.PwshLogin)),M?(w.shellIntegration.suggestEnabled&&(Z.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,h.$8e)(M[M.length-1],b,""),{newArgs:M,envMixin:Z}):void 0;case"zsh":{if(!g||g.length===0?M=d.get(s.Zsh):D(g)?(M=d.get(s.ZshLogin),n(w,Z)):(g===d.get(s.Zsh)||g===d.get(s.ZshLogin))&&(M=g),!M)return;M=[...M],M[M.length-1]=(0,h.$8e)(M[M.length-1],b);let ie;try{ie=p.userInfo().username}catch{ie="unknown"}const V=A.$jc(p.tmpdir(),`${ie}-${U.applicationName}-zsh`);Z.ZDOTDIR=V;const ee=F?.ZDOTDIR??p.homedir()??"~";Z.USER_ZDOTDIR=ee;const ae=[];return ae.push({source:A.$jc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$jc(V,".zshrc")}),ae.push({source:A.$jc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$jc(V,".zprofile")}),ae.push({source:A.$jc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$jc(V,".zshenv")}),ae.push({source:A.$jc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$jc(V,".zlogin")}),{newArgs:M,envMixin:Z,filesToCopy:ae}}}Q.warn(`Shell integration cannot be enabled for executable "${C.executable}" and args`,C.args)}function n(C,w){if(j.$j&&C.environmentVariableCollections){const F=(0,P.$qs)(C.environmentVariableCollections),U=new o.$rs(F).getVariableMap({workspaceFolder:C.workspaceFolder}).get("PATH"),O=[];if(U)for(const g of U)g.type===l.EnvironmentVariableMutatorType.Prepend&&O.push(g.value);O.length>0&&(w.VSCODE_PATH_PREFIX=O.join(""))}}var s;(function(C){C.WindowsPwsh="windows-pwsh",C.WindowsPwshLogin="windows-pwsh-login",C.Pwsh="pwsh",C.PwshLogin="pwsh-login",C.Zsh="zsh",C.ZshLogin="zsh-login",C.Bash="bash"})(s||(s={}));const d=new Map;d.set(s.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(s.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(s.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(s.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(s.Zsh,["-i"]),d.set(s.ZshLogin,["-il"]),d.set(s.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],i=["--login","-l"],t=["-i","--interactive"],c=["-nol","-nologo"];function L(C){return typeof C=="string"?y.includes(C.toLowerCase()):C.length===1&&y.includes(C[0].toLowerCase())||C.length===2&&(y.includes(C[0].toLowerCase())||y.includes(C[1].toLowerCase()))&&(c.includes(C[0].toLowerCase())||c.includes(C[1].toLowerCase()))}function m(C){return typeof C=="string"?c.includes(C.toLowerCase()):C.length===0||C?.length===1&&c.includes(C[0].toLowerCase())}function D(C){return typeof C!="string"&&(C=C.filter(w=>!t.includes(w.toLowerCase()))),C==="string"&&i.includes(C.toLowerCase())||typeof C!="string"&&C.length===1&&i.includes(C[0].toLowerCase())}}),define(fe[103],ge([0,1,12,14,4,2,3]),function(oe,e,p,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;const k=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let h;class r extends A.$Uc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(l){if(super(),this.h=l,this.c="",this.f=new E.$de,this.g=new E.$de,!j.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${j.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){j.$i&&(await(0,p.$xh)(300),this.getShellName().then(l=>{const P=this.getShellType(l);P!==this.b&&(this.g.fire(P),this.f.fire(l),this.b=P,this.c=l)}))}m(l){if(!l)return"";if(k.indexOf(l.name)===-1||!l.children||l.children.length===0)return l.name;let P=0;for(;P<l.children.length;P++){const o=l.children[P];if(!o.children||o.children.length===0||o.children[0].name!=="conhost.exe")break}return P>=l.children.length?l.name:this.m(l.children[P])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(h||(h=await new Promise((l,P)=>{oe(["@vscode/windows-process-tree"],l,P)})),this.a=new Promise(l=>{h.getProcessTree(this.h,P=>{const o=this.m(P);this.a=void 0,l(o)})}),this.a)}getShellType(l){switch(l.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return l.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.$Nic=r,be([(0,S.$2h)(500)],r.prototype,"checkShell",null)}),define(fe[104],ge([0,1,26,12,4,2,5,3,6,24,72,8,85,38,39,103,109,99]),function(oe,e,p,S,E,A,j,k,h,r,v,l,P,o,a,$,f,n){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;var d;(function(L){L[L.DataFlushTimeout=250]="DataFlushTimeout",L[L.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(d||(d={}));var y;(function(L){L[L.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",L[L.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",L[L.WriteInterval=5]="WriteInterval"})(y||(y={}));const i=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let t=class extends A.$Uc{static{s=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return k.$i?this.t?.shellType:i.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(m,D,C,w,F,Q,U,O,g){super(),this.shellLaunchConfig=m,this.N=Q,this.O=U,this.P=O,this.Q=g,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new E.$de),this.onProcessData=this.I.event,this.J=this.B(new E.$de),this.onProcessReady=this.J.event,this.L=this.B(new E.$de),this.onDidChangeProperty=this.L.event,this.M=this.B(new E.$de),this.onProcessExit=this.M.event;let I;k.$i?I=j.$nc(this.shellLaunchConfig.executable||""):I="xterm-256color",this.D=D,this.a.initialCwd=this.D,this.a.cwd=this.D;const b=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,a.$ss)()>=18309;this.F={name:I,cwd:D,env:F,cols:C,rows:w,useConpty:b,conptyInheritCursor:b&&!!m.initialText},k.$i&&(b&&C===0&&w===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new c,this.B(this.C.onTrigger(M=>{this.C?.dispose(),this.C=void 0,M.cols&&M.rows&&this.resize(M.cols,M.rows)}))),this.onProcessReady(M=>{this.t=this.B(new $.$Nic(M.pid)),this.B(this.t.onShellTypeChanged(Z=>this.L.fire({type:"shellType",value:Z}))),this.B(this.t.onShellNameChanged(Z=>this.L.fire({type:"title",value:Z})))})),this.B((0,A.$Sc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const D=(await Promise.all([this.R(),this.S()])).find(w=>w!==void 0);if(D)return D;let C;if(this.O.shellIntegration.enabled)if(C=(0,a.$us)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),C){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),C.envMixin)for(const[w,F]of Object.entries(C.envMixin))this.F.env||={},this.F.env[w]=F;if(C.filesToCopy)for(const w of C.filesToCopy){await r.Promises.mkdir(j.$mc(w.dest),{recursive:!0});try{await r.Promises.copyFile(w.source,w.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,C),C?.newArgs?{injectedArgs:C.newArgs}:void 0}catch(w){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",w),{message:`A native exception occurred during launch (${w.message})`}}}async R(){try{if(!(await r.Promises.stat(this.D)).isDirectory())return{message:(0,v.localize)(0,null,this.D.toString())}}catch(m){if(m?.code==="ENOENT")return{message:(0,v.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const m=this.shellLaunchConfig;if(!m.executable)throw new Error("IShellLaunchConfig.executable not set");const D=m.cwd instanceof h.URI?m.cwd.path:m.cwd,C=m.env&&m.env.PATH?m.env.PATH.split(j.$tc):void 0,w=await(0,a.$ts)(m.executable,D,C,this.N);if(!w)return{message:(0,v.localize)(2,null,m.executable)};try{const F=await r.Promises.stat(w);if(!F.isFile()&&!F.isSymbolicLink())return{message:(0,v.localize)(3,null,m.executable)};m.executable=w}catch(F){if(F?.code!=="EACCES")throw F}}async U(m,D,C){const w=C?.newArgs||m.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",m.executable,w,D);const F=(0,f.spawn)(m.executable,w,D);this.m=F,this.u=this.B(new o.$Lic(F.pid,this.P)),this.u.onDidChangeHasChildProcesses(Q=>this.L.fire({type:"hasChildProcesses",value:Q})),this.s=new Promise(Q=>{this.onProcessReady(()=>Q())}),F.onData(Q=>{this.H+=Q.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,F.pause()),this.P.trace("node-pty.IPty#onData",Q),this.I.fire(Q),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),F.onExit(Q=>{this.g=Q.exitCode,this.X()}),this.$(F.pid),this.W(F)}W(m){setTimeout(()=>this.ab(m)),k.$i||(this.w=setInterval(()=>{this.n!==m.process&&this.ab(m)},200))}X(){this.P.getLevel()===l.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!k.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-s.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,S.$xh)(250-(Date.now()-s.b)+50);s.b=Date.now()}}$(m){this.J.fire({pid:m,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(m){if(this.q.isDisposed)return;this.n=m.process,this.L.fire({type:"title",value:this.n});const D=this.currentTitle.replace(/ \(figterm\)$/g,"");D.toLowerCase().startsWith("python")?this.L.fire({type:"shellType",value:"python"}):this.L.fire({type:"shellType",value:i.get(D)})}shutdown(m){this.P.getLevel()===l.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),m&&!k.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input(m,D=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,n.$6r)(m).map(C=>({isBinary:D,data:C}))),this.bb())}async processBinary(m){this.input(m,!0)}async refreshProperty(m){switch(m){case"cwd":{const D=await this.getCwd();return D!==this.a.cwd&&(this.a.cwd=D,this.L.fire({type:"cwd",value:this.a.cwd})),D}case"initialCwd":{const D=await this.getInitialCwd();return D!==this.a.initialCwd&&(this.a.initialCwd=D,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),D}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(m,D){m==="fixedDimensions"&&(this.a.fixedDimensions=D)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const m=this.y.shift();this.P.trace("node-pty.IPty#write",m.data),m.isBinary?this.m.write(Buffer.from(m.data,"binary")):this.m.write(m.data),this.u?.handleInput()}resize(m,D){if(!this.q.isDisposed&&!(typeof m!="number"||typeof D!="number"||isNaN(m)||isNaN(D))&&this.m){if(m=Math.max(m,1),D=Math.max(D,1),this.C){this.C.cols=m,this.C.rows=D;return}this.P.trace("node-pty.IPty#resize",m,D);try{this.m.resize(m,D)}catch(C){if(this.P.trace("node-pty.IPty#resize exception "+C.message),this.g!==void 0&&C.message!=="ioctl(2) failed, EBADF"&&C.message!=="Cannot resize a pty that has already exited")throw C}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(m){this.H=Math.max(this.H-m,0),this.P.trace(`Flow control: Ack ${m} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(k.$j)return new Promise(m=>{if(!this.m){m(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,p.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(D,C,w)=>{!D&&C!==""?m(C.substring(C.indexOf("/"),C.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",D,C,w),m(this.D))})});if(k.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await r.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return k.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,a.$ss)()}:void 0}};e.$Oic=t,e.$Oic=t=s=be([ze(7,l.$3j),ze(8,P.$jk)],t);class c extends A.$Uc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new E.$de),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,A.$Sc)(()=>clearTimeout(this.a)))}}}),define(fe[105],ge([0,1,26,12,4,2,3,63,8,96,28,98,37,110,39,104,71,38,97,7,101,100,77,14,111]),function(oe,e,p,S,E,A,j,k,h,r,v,l,P,o,a,$,f,n,s,d,y,i,t,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0,e.$Pic=m;function m(I,b,M){if(typeof M.value!="function")throw new Error("not supported");const Z="value",ie=M.value;M[Z]=async function(...V){this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${ie.name}(${V.map(ae=>JSON.stringify(ae)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,S.$xh)(this.traceRpcArgs.simulatedLatency);let ee;try{ee=await ie.apply(this,V)}catch(ae){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${ie.name}`,ae),ae}return this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${ie.name}`,ee),ee}}let D,C;class w extends A.$Uc{H(b,M){return M(Z=>{this.I.getLevel()===h.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${b}.fire(${JSON.stringify(Z)})`)}),M}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(b,M,Z,ie){super(),this.I=b,this.J=M,this.L=Z,this.M=ie,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new E.$de),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new E.$de),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new E.$de),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new E.$de),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new E.$de),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new E.$de),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new E.$de),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new E.$de),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,A.$Sc)(()=>{for(const V of this.a.values())V.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$cs(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(b){n.$Kic.length=0,n.$Kic.push(...b)}async requestDetachInstance(b,M){return this.f.createRequest({workspaceId:b,instanceId:M})}async acceptDetachInstanceReply(b,M){let Z;const ie=this.a.get(M);ie&&(Z=await this.S(M,ie)),this.f.acceptReply(b,Z)}async freePortKillProcess(b){const Z=(await new Promise((ie,V)=>{(0,p.exec)(j.$i?`netstat -ano | findstr "${b}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${b}`,{},(ee,ae)=>{if(ee)return V("Problem occurred when listing active processes");ie(ae)})})).split(/\r?\n/).filter(ie=>!!ie.trim());if(Z.length>=1){const ie=/\s+(\d+)(?:\s+|$)/,V=Z[0].match(ie)?.[1];if(V)try{process.kill(Number.parseInt(V))}catch{}else throw new Error(`Processes for port ${b} were not found`);return{port:b,processId:V}}throw new Error(`Could not kill process with port ${b}`)}async serializeTerminalState(b){const M=[];for(const[ie,V]of this.a.entries())V.hasWrittenData&&b.indexOf(ie)!==-1&&M.push(S.Promises.withAsyncBody(async ee=>{ee({id:ie,shellLaunchConfig:V.shellLaunchConfig,processDetails:await this.S(ie,V),processLaunchConfig:V.processLaunchOptions,unicodeVersion:V.unicodeVersion,replayEvent:await V.serializeNormalBuffer(),timestamp:Date.now()})}));const Z={version:1,state:await Promise.all(M)};return JSON.stringify(Z)}async reviveTerminalProcesses(b,M,Z){const ie=[];for(const V of M)ie.push(this.N(b,V));await Promise.all(ie)}async N(b,M){const Z=(0,f.localize)(0,null),ie=await this.createProcess({...M.shellLaunchConfig,cwd:M.processDetails.cwd,color:M.processDetails.color,icon:M.processDetails.icon,name:M.processDetails.titleSource===v.TitleEventSource.Api?M.processDetails.title:void 0,initialText:M.replayEvent.events[0].data+(0,i.$LUb)(Z,{loudFormatting:!0})},M.processDetails.cwd,M.replayEvent.events[0].cols,M.replayEvent.events[0].rows,M.unicodeVersion,M.processLaunchConfig.env,M.processLaunchConfig.executableEnv,M.processLaunchConfig.options,!0,M.processDetails.workspaceId,M.processDetails.workspaceName,!0,M.replayEvent.events[0].data),V=this.R(b,M.id);this.g.set(V,{newId:ie,state:M}),this.I.info(`Revived process, old id ${V} -> new id ${ie}`)}async shutdownAll(){this.dispose()}async createProcess(b,M,Z,ie,V,ee,ae,le,G,q,K,_,de){if(b.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const B=++this.n,ue=new $.$Oic(b,M,Z,ie,ee,ae,le,this.I,this.J),x={env:ee,executableEnv:ae,options:le},u=new Q(B,ue,q,K,G,Z,ie,x,V,this.L,this.I,_&&typeof b.initialText=="string"?b.initialText:void 0,de,b.icon,b.color,b.name,b.fixedDimensions);return ue.onProcessExit(z=>{u.dispose(),this.a.delete(B),this.C.fire({id:B,event:z})}),u.onProcessData(z=>this.w.fire({id:B,event:z})),u.onProcessReplay(z=>this.y.fire({id:B,event:z})),u.onProcessReady(z=>this.z.fire({id:B,event:z})),u.onProcessOrphanQuestion(()=>this.D.fire({id:B})),u.onDidChangeProperty(z=>this.G.fire({id:B,property:z})),u.onPersistentProcessReady(()=>{for(const z of this.j.entries())u.installAutoReply(z[0],z[1])}),this.a.set(B,u),B}async attachToProcess(b){try{await this.U(b).attach(),this.I.info(`Persistent process reconnection "${b}"`)}catch(M){throw this.I.warn(`Persistent process reconnection "${b}" failed`,M.message),M}}async updateTitle(b,M,Z){this.U(b).setTitle(M,Z)}async updateIcon(b,M,Z,ie){this.U(b).setIcon(M,Z,ie)}async clearBuffer(b){this.U(b).clearBuffer()}async refreshProperty(b,M){return this.U(b).refreshProperty(M)}async updateProperty(b,M,Z){return this.U(b).updateProperty(M,Z)}async detachFromProcess(b,M){return this.U(b).detach(M)}async reduceConnectionGraceTime(){for(const b of this.a.values())b.reduceGraceTime()}async listProcesses(){const b=Array.from(this.a.entries()).filter(([ie,V])=>V.shouldPersistTerminal);this.I.info(`Listing ${b.length} persistent terminals, ${this.a.size} total terminals`);const M=b.map(async([ie,V])=>this.S(ie,V));return(await Promise.all(M)).filter(ie=>ie.isOrphan)}async getPerformanceMarks(){return L.getMarks()}async start(b){const M=this.a.get(b);return M?M.start():{message:`Could not find pty with id "${b}"`}}async shutdown(b,M){return this.a.get(b)?.shutdown(M)}async input(b,M){return this.U(b).input(M)}async processBinary(b,M){return this.U(b).writeBinary(M)}async resize(b,M,Z){return this.U(b).resize(M,Z)}async getInitialCwd(b){return this.U(b).getInitialCwd()}async getCwd(b){return this.U(b).getCwd()}async acknowledgeDataEvent(b,M){return this.U(b).acknowledgeDataEvent(M)}async setUnicodeVersion(b,M){return this.U(b).setUnicodeVersion(M)}async getLatency(){return[]}async orphanQuestionReply(b){return this.U(b).orphanQuestionReply()}async installAutoReply(b,M){this.j.set(b,M);for(const Z of this.a.values())Z.installAutoReply(b,M)}async uninstallAllAutoReplies(){for(const b of this.j.keys())for(const M of this.a.values())M.uninstallAutoReply(b)}async uninstallAutoReply(b){for(const M of this.a.values())M.uninstallAutoReply(b)}async getDefaultSystemShell(b=j.OS){return(0,k.$qm)(b,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(b,M){if(M==="win-to-unix"){if(!j.$i)return b;if((0,a.$ss)()<17063)return b.replace(/\\/g,"/");const Z=this.O();return Z?new Promise(ie=>{(0,p.execFile)(Z,["-e","wslpath",b],{},(ee,ae,le)=>{ie(ee?b:(0,P.$pQ)(ae.trim()))}).stdin.end()}):b}if(M==="unix-to-win"&&j.$i){if((0,a.$ss)()<17063)return b;const Z=this.O();return Z?new Promise(ie=>{(0,p.execFile)(Z,["-e","wslpath","-w",b],{},(ee,ae,le)=>{ie(ee?b:ae.trim())}).stdin.end()}):b}return b}O(){const b=(0,a.$ss)()>=16299,M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Z=process.env.SystemRoot;if(Z)return(0,t.join)(Z,M?"Sysnative":"System32",b?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(b,M){try{return this.g.get(this.R(b,M))?.newId}catch(Z){this.I.warn(`Couldn't find terminal ID ${b}-${M}`,Z.message)}}async setTerminalLayoutInfo(b){this.b.set(b.workspaceId,b)}async getTerminalLayoutInfo(b){L.mark("code/willGetTerminalLayoutInfo");const M=this.b.get(b.workspaceId);if(M){const Z=new Set,V=(await Promise.all(M.tabs.map(async ee=>this.P(b.workspaceId,ee,Z)))).filter(ee=>ee.terminals.length>0);return L.mark("code/didGetTerminalLayoutInfo"),{tabs:V}}L.mark("code/didGetTerminalLayoutInfo")}async P(b,M,Z){const V=(await Promise.all(M.terminals.map(ee=>this.Q(b,ee,Z)))).filter(ee=>ee.terminal!==null);return{isActive:M.isActive,activePersistentProcessId:M.activePersistentProcessId,terminals:V}}async Q(b,M,Z){try{const ie=this.R(b,M.terminal),V=this.g.get(ie)?.newId;this.I.info(`Expanding terminal instance, old id ${ie} -> new id ${V}`),this.g.delete(ie);const ee=V??M.terminal;if(Z.has(ee))throw new Error(`Terminal ${ee} has already been expanded`);Z.add(ee);const ae=this.U(ee);return{terminal:{...ae&&await this.S(M.terminal,ae,V!==void 0),id:ee},relativeSize:M.relativeSize}}catch(ie){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",ie.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",M),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:M.relativeSize}}}R(b,M){return`${b}-${M}`}async S(b,M,Z=!1){L.mark(`code/willBuildProcessDetails/${b}`);const[ie,V]=await Promise.all([M.getCwd(),Z?!0:M.isOrphaned()]),ee={id:b,title:M.title,titleSource:M.titleSource,pid:M.pid,workspaceId:M.workspaceId,workspaceName:M.workspaceName,cwd:ie,isOrphan:V,icon:M.icon,color:M.color,fixedDimensions:M.fixedDimensions,environmentVariableCollections:M.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:M.shellLaunchConfig.reconnectionProperties,waitOnExit:M.shellLaunchConfig.waitOnExit,hideFromUser:M.shellLaunchConfig.hideFromUser,isFeatureTerminal:M.shellLaunchConfig.isFeatureTerminal,type:M.shellLaunchConfig.type,hasChildProcesses:M.hasChildProcesses,shellIntegrationNonce:M.processLaunchOptions.options.shellIntegration.nonce};return L.mark(`code/didBuildProcessDetails/${b}`),ee}U(b){const M=this.a.get(b);if(!M)throw new d.$bb("Could not find pty on pty host");return M}}e.$Qic=w,be([c.$1h],w.prototype,"traceRpcArgs",null),be([m],w.prototype,"refreshIgnoreProcessNames",null),be([m],w.prototype,"requestDetachInstance",null),be([m],w.prototype,"acceptDetachInstanceReply",null),be([m],w.prototype,"freePortKillProcess",null),be([m],w.prototype,"serializeTerminalState",null),be([m],w.prototype,"reviveTerminalProcesses",null),be([m],w.prototype,"shutdownAll",null),be([m],w.prototype,"createProcess",null),be([m],w.prototype,"attachToProcess",null),be([m],w.prototype,"updateTitle",null),be([m],w.prototype,"updateIcon",null),be([m],w.prototype,"clearBuffer",null),be([m],w.prototype,"refreshProperty",null),be([m],w.prototype,"updateProperty",null),be([m],w.prototype,"detachFromProcess",null),be([m],w.prototype,"reduceConnectionGraceTime",null),be([m],w.prototype,"listProcesses",null),be([m],w.prototype,"getPerformanceMarks",null),be([m],w.prototype,"start",null),be([m],w.prototype,"shutdown",null),be([m],w.prototype,"input",null),be([m],w.prototype,"processBinary",null),be([m],w.prototype,"resize",null),be([m],w.prototype,"getInitialCwd",null),be([m],w.prototype,"getCwd",null),be([m],w.prototype,"acknowledgeDataEvent",null),be([m],w.prototype,"setUnicodeVersion",null),be([m],w.prototype,"getLatency",null),be([m],w.prototype,"orphanQuestionReply",null),be([m],w.prototype,"installAutoReply",null),be([m],w.prototype,"uninstallAllAutoReplies",null),be([m],w.prototype,"uninstallAutoReply",null),be([m],w.prototype,"getDefaultSystemShell",null),be([m],w.prototype,"getEnvironment",null),be([m],w.prototype,"getWslPath",null),be([m],w.prototype,"getRevivedPtyNewId",null),be([m],w.prototype,"setTerminalLayoutInfo",null),be([m],w.prototype,"getTerminalLayoutInfo",null);var F;(function(I){I.None="None",I.ReplayOnly="ReplayOnly",I.Session="Session"})(F||(F={}));class Q extends A.$Uc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(b,M){M===v.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=b,this.O=M}setIcon(b,M,Z){(!this.Y||"id"in M&&"id"in this.Y&&M.id!==this.Y.id||!this.color||Z!==this.Z)&&(this.P.freeRawReviveBuffer(),b&&this.j.setValue("Session","setIcon")),this.Y=M,this.Z=Z}S(b){this.R=b}constructor(b,M,Z,ie,V,ee,ae,le,G,q,K,_,de,B,ue,x,u){super(),this.U=b,this.W=M,this.workspaceId=Z,this.workspaceName=ie,this.shouldPersistTerminal=V,this.processLaunchOptions=le,this.unicodeVersion=G,this.X=K,this.Y=B,this.Z=ue,this.b=new Map,this.f=new Map,this.g=!1,this.w=new S.$Dh,this.C=this.B(new E.$de),this.onProcessReplay=this.C.event,this.D=this.B(new E.$de),this.onProcessReady=this.D.event,this.F=this.B(new E.$de),this.onPersistentProcessReady=this.F.event,this.G=this.B(new E.$de),this.onProcessData=this.G.event,this.H=this.B(new E.$de),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new E.$de),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=v.TitleEventSource.Process,this.j=new U(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=_!==void 0,this.P=new O(ee,ae,q.scrollback,G,_,le.options.shellIntegration.nonce,V?de:void 0,this.X),x&&this.setTitle(x,v.TitleEventSource.Api),this.R=u,this.n=null,this.u=0,this.y=this.B(new S.$Jh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${g(q.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},q.graceTime)),this.z=this.B(new S.$Jh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${g(q.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},q.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(z=>{this.L=z.pid,this.M=z.cwd,this.D.fire(z)})),this.B(this.W.onDidChangeProperty(z=>{this.I.fire(z)})),this.a=new l.$Fvb((z,ne)=>this.G.fire(ne)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(z=>this.P.handleData(z))),this.B((0,A.$Sc)(()=>{for(const z of this.b.values())z.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(b){this.shouldPersistTerminal&&(this.j.value!=="None"||b)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty(b){return this.W.refreshProperty(b)}async updateProperty(b,M){if(b==="fixedDimensions")return this.S(M)}async start(){if(!this.g){const b=await this.W.start();return b&&"message"in b||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),b}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown(b){return this.W.shutdown(b)}input(b){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const M of this.b.values())M.handleInput();return this.W.input(b)}}writeBinary(b){return this.W.processBinary(b)}resize(b,M){if(!this.J){this.P.handleResize(b,M),this.a.flushBuffer(this.U);for(const Z of this.b.values())Z.handleResize();return this.W.resize(b,M)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(b){this.unicodeVersion=b,this.P.setUnicodeVersion?.(b)}acknowledgeDataEvent(b){if(!this.J)return this.W.acknowledgeDataEvent(b)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const b=await this.P.generateReplayEvent();let M=0;for(const Z of b.events)M+=Z.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${M} chars and ${b.events.length} size events`),this.C.fire(b),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(b,M){this.b.get(b)?.dispose(),this.b.set(b,new s.$Jic(this.W,b,M,this.X))}uninstallAutoReply(b){this.b.get(b)?.dispose(),this.b.delete(b)}sendCommandResult(b,M,Z){this.f.get(b)&&this.f.delete(b)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const b=this.n;this.n=null,b.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new S.$wh(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class U{get value(){return this.b}setValue(b,M){this.b!==b&&(this.b=b,this.f(M))}constructor(b,M,Z){this.a=b,this.b=M,this.d=Z,this.f("initialized")}f(b){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${b}`)}}class O{constructor(b,M,Z,ie,V,ee,ae,le){this.f=ae,this.a=new o.Terminal({cols:b,rows:M,scrollback:Z,allowProposedApi:!0}),V&&this.a.writeln(V),this.setUnicodeVersion(ie),this.b=new y.$wub(ee,!0,void 0,le),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(b){this.a.write(b)}handleResize(b,M){this.a.resize(b,M)}clearBuffer(){this.a.clear()}async generateReplayEvent(b,M){const Z=new(await this._getSerializeConstructor());this.a.loadAddon(Z);const ie={scrollback:this.a.options.scrollback};b&&(ie.excludeAltBuffer=!0,ie.excludeModes=!0);let V;return M&&this.f?V=this.f:V=Z.serialize(ie),{events:[{cols:this.a.cols,rows:this.a.rows,data:V}],commands:this.b.serialize()}}async setUnicodeVersion(b){this.a.unicode.activeVersion!==b&&(b==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=b)}async _getUnicode11Constructor(){return C||(C=(await new Promise((b,M)=>{oe(["@xterm/addon-unicode11"],b,M)})).Unicode11Addon),C}async _getSerializeConstructor(){return D||(D=(await new Promise((b,M)=>{oe(["@xterm/addon-serialize"],b,M)})).SerializeAddon),D}}function g(I){let b=0,M=0,Z=0;I>=1e3&&(Z=Math.floor(I/1e3),I-=Z*1e3),Z>=60&&(M=Math.floor(Z/60),Z-=M*60),M>=60&&(b=Math.floor(M/60),M-=b*60);const ie=b?`${b}h`:"",V=M?`${M}m`:"",ee=Z?`${Z}s`:"",ae=I?`${I}ms`:"";return`${ie}${V}${ee}${ae}`}}),define(fe[112],ge([0,1,60,27,64,65,11,75,78,8,80,81,83,84,28,102,105,31,12,2]),function(oe,e,p,S,E,A,j,k,h,r,v,l,P,o,a,$,f,n,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),y();async function y(){const i=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),t=parseInt(process.env.VSCODE_LATENCY??"0"),c={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,i&&await(0,s.$xh)(i);const L=(0,n.$gX)(process);let m;L?m=new A.$hX:m=new E.$Zq(a.TerminalIpcChannels.PtyHost);const D={_serviceBrand:void 0,...o.default},C=new h.$9m((0,k.$tm)(process.argv,k.$sm),D),w=new P.$PQ((0,r.$ek)(C),C.logsHome);m.registerChannel(a.TerminalIpcChannels.Logger,new v.$as(w,()=>p.$zn));const F=w.createLogger("ptyhost",{name:(0,j.localize)(0,null)}),Q=new l.$ZQ(F);i&&Q.warn(`Pty Host startup is delayed ${i}ms`),t&&Q.warn(`Pty host is simulating ${t}ms latency`);const U=new d.$Tc,O=new $.$Mic;m.registerChannel(a.TerminalIpcChannels.Heartbeat,S.ProxyChannel.fromService(O,U));const g=new f.$Qic(Q,D,c,t),I=S.ProxyChannel.fromService(g,U);m.registerChannel(a.TerminalIpcChannels.PtyHost,I),L&&m.registerChannel(a.TerminalIpcChannels.PtyHostWindow,I),process.once("exit",()=>{Q.trace("Pty host exiting"),Q.dispose(),O.dispose(),g.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/03dd3c3b93322b41fe108a3448308595ee7077a4/core/vs/platform/terminal/node/ptyHostMain.js.map
