/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(he){for(var e=[],d=0,O=he.length;d<O;d++)e[d]=Se[he[d]];return e};define(Se[163],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class d{static get(){const L=new Map,R=new Map,N=new Map,p=new Map;function m(v,w){v.has(w.detail)||v.set(w.detail,-w.timestamp)}function k(v,w){const h=v.get(w.detail);h&&(h>=0||v.set(w.detail,h+w.timestamp))}let A=[];typeof he=="function"&&typeof he.getStats=="function"&&(A=he.getStats().slice(0).sort((v,w)=>v.timestamp-w.timestamp));for(const v of A)switch(v.type){case 10:m(L,v);break;case 11:case 12:k(L,v);break;case 21:m(R,v);break;case 22:k(R,v);break;case 33:m(N,v);break;case 34:k(N,v);break;case 31:m(p,v);break;case 32:k(p,v);break}let C=0;N.forEach(v=>C+=v);function $(v){const w=[];return v.forEach((h,f)=>w.push([f,h])),w}return{amdLoad:$(L),amdInvoke:$(R),nodeRequire:$(N),nodeEval:$(p),nodeRequireTotal:C}}static toMarkdownTable(L,R){let N="";const p=[];return L.forEach((m,k)=>{p[k]=m.length}),R.forEach(m=>{m.forEach((k,A)=>{typeof k>"u"&&(k=m[A]="-");const C=k.toString().length;p[A]=Math.max(C,p[A])})}),L.forEach((m,k)=>{N+=`| ${m+" ".repeat(p[k]-m.toString().length)} `}),N+=`|
`,L.forEach((m,k)=>{N+=`| ${"-".repeat(p[k])} `}),N+=`|
`,R.forEach(m=>{m.forEach((k,A)=>{typeof k<"u"&&(N+=`| ${k+" ".repeat(p[A]-k.toString().length)} `)}),N+=`|
`}),N}}e.$U=d}),define(Se[164],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=d,e.$gb=O,e.$hb=L,e.$ib=R,e.$jb=N,e.$kb=p,e.$lb=m,e.$nb=A,e.$ob=C,e.$pb=$,e.$qb=v,e.$rb=w;function d(h,f){const a=O(h,f);if(a!==-1)return h[a]}function O(h,f,a=h.length-1){for(let n=a;n>=0;n--){const i=h[n];if(f(i))return n}return-1}function L(h,f){const a=R(h,f);return a===-1?void 0:h[a]}function R(h,f,a=0,n=h.length){let i=a,l=n;for(;i<l;){const o=Math.floor((i+l)/2);f(h[o])?i=o+1:l=o}return i-1}function N(h,f){const a=p(h,f);return a===h.length?void 0:h[a]}function p(h,f,a=0,n=h.length){let i=a,l=n;for(;i<l;){const o=Math.floor((i+l)/2);f(h[o])?l=o:i=o+1}return i}function m(h,f,a=0,n=h.length){const i=p(h,f,a,n);return i===h.length?-1:i}class k{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(k.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const a=R(this.e,f,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=k;function A(h,f){if(h.length===0)return;let a=h[0];for(let n=1;n<h.length;n++){const i=h[n];f(i,a)>0&&(a=i)}return a}function C(h,f){if(h.length===0)return;let a=h[0];for(let n=1;n<h.length;n++){const i=h[n];f(i,a)>=0&&(a=i)}return a}function $(h,f){return A(h,(a,n)=>-f(a,n))}function v(h,f){if(h.length===0)return-1;let a=0;for(let n=1;n<h.length;n++){const i=h[n];f(i,h[a])>0&&(a=n)}return a}function w(h,f){for(const a of h){const n=f(a);if(n!==void 0)return n}}}),define(Se[74],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=d,e.$L=O,e.$M=L,e.$N=R;function d(N,p){const m=Object.create(null);for(const k of N){const A=p(k);let C=m[A];C||(C=m[A]=[]),C.push(k)}return m}function O(N,p){const m=[],k=[];for(const A of N)p.has(A)||m.push(A);for(const A of p)N.has(A)||k.push(A);return{removed:m,added:k}}function L(N,p){const m=[],k=[];for(const[A,C]of N)p.has(A)||m.push(C);for(const[A,C]of p)N.has(A)||k.push(C);return{removed:m,added:k}}function R(N,p){const m=new Set;for(const k of p)N.has(k)&&m.add(k);return m}}),define(Se[56],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=O,e.$2h=L,e.$3h=R;function d(N){return(p,m,k)=>{let A=null,C=null;if(typeof k.value=="function"?(A="value",C=k.value):typeof k.get=="function"&&(A="get",C=k.get),!C)throw new Error("not supported");k[A]=N(C,m)}}function O(N,p,m){let k=null,A=null;if(typeof m.value=="function"?(k="value",A=m.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(k="get",A=m.get),!A)throw new Error("not supported");const C=`$memoize$${p}`;m[k]=function(...$){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[C]}}function L(N,p,m){return d((k,A)=>{const C=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...v){this[$]||(this[$]=m?m():void 0),clearTimeout(this[C]),p&&(this[$]=p(this[$],...v),v=[this[$]]),this[C]=setTimeout(()=>{k.apply(this,v),this[$]=m?m():void 0},N)}})}function R(N,p,m){return d((k,A)=>{const C=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...h){if(this[$]||(this[$]=m?m():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[$]=p(this[$],...h)),this[w])return;const f=this[v]+N;f<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[$]]),this[$]=m?m():void 0):(this[w]=!0,this[C]=setTimeout(()=>{this[w]=!1,this[v]=Date.now(),k.apply(this,[this[$]]),this[$]=m?m():void 0},f-Date.now()))}})}}),define(Se[13],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=O,e.$Z=L,e.$1=R,e.$2=N,e.$3=p,e.$4=k,e.$6=C,e.$7=$,e.$8=v,e.$0=h;class d{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=d,e.$X=new d;function O(o){e.$X.setUnexpectedErrorHandler(o)}function L(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(o){k(o)||e.$X.onUnexpectedError(o)}function N(o){k(o)||e.$X.onUnexpectedExternalError(o)}function p(o){if(o instanceof Error){const{name:t,message:u}=o,r=o.stacktrace||o.stack;return{$isError:!0,name:t,message:u,stack:r,noTelemetry:i.isErrorNoTelemetry(o)}}return o}const m="Canceled";function k(o){return o instanceof A?!0:o instanceof Error&&o.name===m&&o.message===m}class A extends Error{constructor(){super(m),this.name=this.message}}e.$5=A;function C(){const o=new Error(m);return o.name=o.message,o}function $(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function v(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class w extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=w;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const u=new i;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class l extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.$cb=l}),define(Se[19],De([1,0,13,164]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=N,e.$vb=p,e.$wb=m,e.$xb=k,e.$yb=A,e.$zb=C,e.$Ab=$,e.$Bb=v,e.$Cb=w,e.$Db=h,e.$Eb=f,e.top=a,e.$Gb=n,e.$Hb=l,e.$Ib=o,e.$Jb=t,e.$Kb=u,e.$Lb=r,e.$Mb=c,e.$Nb=s,e.$Ob=y,e.$Pb=b,e.$Qb=S,e.$Rb=g,e.$Sb=E,e.$Tb=D,e.$Ub=P,e.$Vb=I,e.$Wb=F,e.$Xb=T,e.$Yb=z,e.$Zb=M,e.$1b=j,e.$2b=U,e.$3b=Z,e.$4b=ie,e.$5b=Q,e.$6b=ne,e.$7b=be,e.$0b=ee;function L(ue,ce=0){return ue[ue.length-(1+ce)]}function R(ue){if(ue.length===0)throw new Error("Invalid tail call");return[ue.slice(0,ue.length-1),ue[ue.length-1]]}function N(ue,ce,oe=(le,J)=>le===J){if(ue===ce)return!0;if(!ue||!ce||ue.length!==ce.length)return!1;for(let le=0,J=ue.length;le<J;le++)if(!oe(ue[le],ce[le]))return!1;return!0}function p(ue,ce){const oe=ue.length-1;ce<oe&&(ue[ce]=ue[oe]),ue.pop()}function m(ue,ce,oe){return k(ue.length,le=>oe(ue[le],ce))}function k(ue,ce){let oe=0,le=ue-1;for(;oe<=le;){const J=(oe+le)/2|0,se=ce(J);if(se<0)oe=J+1;else if(se>0)le=J-1;else return J}return-(oe+1)}function A(ue,ce,oe){if(ue=ue|0,ue>=ce.length)throw new TypeError("invalid index");const le=ce[Math.floor(ce.length*Math.random())],J=[],se=[],$e=[];for(const ve of ce){const Re=oe(ve,le);Re<0?J.push(ve):Re>0?se.push(ve):$e.push(ve)}return ue<J.length?A(ue,J,oe):ue<J.length+$e.length?$e[0]:A(ue-(J.length+$e.length),se,oe)}function C(ue,ce){const oe=[];let le;for(const J of ue.slice(0).sort(ce))!le||ce(le[0],J)!==0?(le=[J],oe.push(le)):le.push(J);return oe}function*$(ue,ce){let oe,le;for(const J of ue)le!==void 0&&ce(le,J)?oe.push(J):(oe&&(yield oe),oe=[J]),le=J;oe&&(yield oe)}function v(ue,ce){for(let oe=0;oe<=ue.length;oe++)ce(oe===0?void 0:ue[oe-1],oe===ue.length?void 0:ue[oe])}function w(ue,ce){for(let oe=0;oe<ue.length;oe++)ce(oe===0?void 0:ue[oe-1],ue[oe],oe+1===ue.length?void 0:ue[oe+1])}function h(ue,ce,oe){const le=[];function J(ve,Re,ge){if(Re===0&&ge.length===0)return;const Ie=le[le.length-1];Ie&&Ie.start+Ie.deleteCount===ve?(Ie.deleteCount+=Re,Ie.toInsert.push(...ge)):le.push({start:ve,deleteCount:Re,toInsert:ge})}let se=0,$e=0;for(;;){if(se===ue.length){J(se,0,ce.slice($e));break}if($e===ce.length){J(se,ue.length-se,[]);break}const ve=ue[se],Re=ce[$e],ge=oe(ve,Re);ge===0?(se+=1,$e+=1):ge<0?(J(se,1,[]),se+=1):ge>0&&(J(se,0,[Re]),$e+=1)}return le}function f(ue,ce,oe){const le=h(ue,ce,oe),J=[],se=[];for(const $e of le)J.push(...ue.slice($e.start,$e.start+$e.deleteCount)),se.push(...$e.toInsert);return{removed:J,added:se}}function a(ue,ce,oe){if(oe===0)return[];const le=ue.slice(0,oe).sort(ce);return i(ue,ce,le,oe,ue.length),le}function n(ue,ce,oe,le,J){return oe===0?Promise.resolve([]):new Promise((se,$e)=>{(async()=>{const ve=ue.length,Re=ue.slice(0,oe).sort(ce);for(let ge=oe,Ie=Math.min(oe+le,ve);ge<ve;ge=Ie,Ie=Math.min(Ie+le,ve)){if(ge>oe&&await new Promise(Ae=>setTimeout(Ae)),J&&J.isCancellationRequested)throw new d.$5;i(ue,ce,Re,ge,Ie)}return Re})().then(se,$e)})}function i(ue,ce,oe,le,J){for(const se=oe.length;le<J;le++){const $e=ue[le];if(ce($e,oe[se-1])<0){oe.pop();const ve=(0,O.$kb)(oe,Re=>ce($e,Re)<0);oe.splice(ve,0,$e)}}}function l(ue){return ue.filter(ce=>!!ce)}function o(ue){let ce=0;for(let oe=0;oe<ue.length;oe++)ue[oe]&&(ue[ce]=ue[oe],ce+=1);ue.length=ce}function t(ue,ce,oe){ue.splice(oe,0,ue.splice(ce,1)[0])}function u(ue){return!Array.isArray(ue)||ue.length===0}function r(ue){return Array.isArray(ue)&&ue.length>0}function c(ue,ce=oe=>oe){const oe=new Set;return ue.filter(le=>{const J=ce(le);return oe.has(J)?!1:(oe.add(J),!0)})}function s(ue){const ce=new Set;return oe=>{const le=ue(oe);return ce.has(le)?!1:(ce.add(le),!0)}}function y(ue,ce){return ue.length>0?ue[0]:ce}function b(ue,ce){return ue.length>0?ue[ue.length-1]:ce}function S(ue,ce,oe=(le,J)=>le===J){let le=0;for(let J=0,se=Math.min(ue.length,ce.length);J<se&&oe(ue[J],ce[J]);J++)le++;return le}function g(ue,ce){let oe=typeof ce=="number"?ue:0;typeof ce=="number"?oe=ue:(oe=0,ce=ue);const le=[];if(oe<=ce)for(let J=oe;J<ce;J++)le.push(J);else for(let J=oe;J>ce;J--)le.push(J);return le}function E(ue,ce,oe){return ue.reduce((le,J)=>(le[ce(J)]=oe?oe(J):J,le),Object.create(null))}function D(ue,ce){return ue.push(ce),()=>P(ue,ce)}function P(ue,ce){const oe=ue.indexOf(ce);if(oe>-1)return ue.splice(oe,1),ce}function I(ue,ce,oe){const le=ue.slice(0,ce),J=ue.slice(ce);return le.concat(oe,J)}function F(ue,ce){let oe;if(typeof ce=="number"){let le=ce;oe=()=>{const J=Math.sin(le++)*179426549;return J-Math.floor(J)}}else oe=Math.random;for(let le=ue.length-1;le>0;le-=1){const J=Math.floor(oe()*(le+1)),se=ue[le];ue[le]=ue[J],ue[J]=se}}function T(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.unshift(ce))}function z(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.push(ce))}function M(ue,ce){for(const oe of ce)ue.push(oe)}function j(ue,ce){return Array.isArray(ue)?ue.map(ce):ce(ue)}function U(ue){return Array.isArray(ue)?ue:[ue]}function Z(ue){return ue[Math.floor(Math.random()*ue.length)]}function ie(ue,ce,oe){const le=G(ue,ce),J=ue.length,se=oe.length;ue.length=J+se;for(let $e=J-1;$e>=le;$e--)ue[$e+se]=ue[$e];for(let $e=0;$e<se;$e++)ue[$e+le]=oe[$e]}function Q(ue,ce,oe,le){const J=G(ue,ce);let se=ue.splice(J,oe);return se===void 0&&(se=[]),ie(ue,J,le),se}function G(ue,ce){return ce<0?Math.max(ce+ue.length,0):Math.min(ce,ue.length)}var x;(function(ue){function ce(se){return se<0}ue.isLessThan=ce;function oe(se){return se<=0}ue.isLessThanOrEqual=oe;function le(se){return se>0}ue.isGreaterThan=le;function J(se){return se===0}ue.isNeitherLessOrGreaterThan=J,ue.greaterThan=1,ue.lessThan=-1,ue.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function ne(ue,ce){return(oe,le)=>ce(ue(oe),ue(le))}function be(...ue){return(ce,oe)=>{for(const le of ue){const J=le(ce,oe);if(!x.isNeitherLessOrGreaterThan(J))return J}return x.neitherLessOrGreaterThan}}const ae=(ue,ce)=>ue-ce;e.$8b=ae;const Ce=(ue,ce)=>(0,e.$8b)(ue?1:0,ce?1:0);e.$9b=Ce;function ee(ue){return(ce,oe)=>-ue(ce,oe)}class B{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let oe=this.c;for(;oe<this.g.length&&ce(this.g[oe]);)oe++;const le=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,le}takeFromEndWhile(ce){let oe=this.d;for(;oe>=0&&ce(this.g[oe]);)oe--;const le=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const oe=this.g.slice(this.c,this.c+ce);return this.c+=ce,oe}}e.$$b=B;class _{static{this.empty=new _(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(oe=>(ce(oe),!0))}toArray(){const ce=[];return this.iterate(oe=>(ce.push(oe),!0)),ce}filter(ce){return new _(oe=>this.iterate(le=>ce(le)?oe(le):!0))}map(ce){return new _(oe=>this.iterate(le=>oe(ce(le))))}some(ce){let oe=!1;return this.iterate(le=>(oe=ce(le),!oe)),oe}findFirst(ce){let oe;return this.iterate(le=>ce(le)?(oe=le,!1):!0),oe}findLast(ce){let oe;return this.iterate(le=>(ce(le)&&(oe=le),!0)),oe}findLastMaxBy(ce){let oe,le=!0;return this.iterate(J=>((le||x.isGreaterThan(ce(J,oe)))&&(le=!1,oe=J),!0)),oe}}e.$_b=_;class pe{constructor(ce){this.c=ce}static createSortPermutation(ce,oe){const le=Array.from(ce.keys()).sort((J,se)=>oe(ce[J],ce[se]));return new pe(le)}apply(ce){return ce.map((oe,le)=>ce[this.c[le]])}inverse(){const ce=this.c.slice();for(let oe=0;oe<this.c.length;oe++)ce[this.c[oe]]=oe;return new pe(ce)}}e.$ac=pe}),define(Se[62],De([1,0,13]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.$ed=L,e.$fd=R,e.$gd=N,e.$hd=p,e.$id=m;function O(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(k,A="Unreachable"){throw new Error(A)}function R(k){if(!k)throw new d.$cb("Assertion Failed")}function N(k){k||(0,d.$1)(new d.$cb("Soft Assertion Failed"))}function p(k){if(!k()){debugger;k(),(0,d.$1)(new d.$cb("Assertion Failed"))}}function m(k,A){let C=0;for(;C<k.length-1;){const $=k[C],v=k[C+1];if(!A($,v))return!1;C++}return!0}}),define(Se[165],De([1,0,19]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=L,e.$8c=R,e.$9c=N,e.$0c=p,e.$$c=m,e.$_c=k;const O=(v,w)=>v===w;e.$6c=O;function L(v=e.$6c){return(w,h)=>d.$ub(w,h,v)}function R(){return(v,w)=>JSON.stringify(v)===JSON.stringify(w)}function N(){return(v,w)=>v.equals(w)}function p(v,w,h){return!v||!w?v===w:h(v,w)}function m(v,w){if(v===w)return!0;if(Array.isArray(v)&&Array.isArray(w)){if(v.length!==w.length)return!1;for(let h=0;h<v.length;h++)if(!m(v[h],w[h]))return!1;return!0}if(v&&typeof v=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(v)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const h=v,f=w,a=Object.keys(h),n=Object.keys(f),i=new Set(n);if(a.length!==n.length)return!1;for(const l of a)if(!i.has(l)||!m(h[l],f[l]))return!1;return!0}return!1}function k(v){return JSON.stringify($(v))}let A=0;const C=new WeakMap;function $(v){if(Array.isArray(v))return v.map($);if(v&&typeof v=="object")if(Object.getPrototypeOf(v)===Object.prototype){const w=v,h=Object.create(null);for(const f of Object.keys(w).sort())h[f]=$(w[f]);return h}else{let w=C.get(v);return w===void 0&&(w=A++,C.set(v,w)),w+"----2b76a038c20c4bcc"}return v}}),define(Se[75],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=d;function d(O,L){const R=this;let N=!1,p;return function(){if(N)return p;if(N=!0,L)try{p=O.apply(R,arguments)}finally{L()}else p=O.apply(R,arguments);return p}}}),define(Se[125],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=void 0;class d{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$EP=d,e.$FP=new d("id#")}),define(Se[39],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(O){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=L;const R=Object.freeze([]);function N(){return R}O.empty=N;function*p(t){yield t}O.single=p;function m(t){return L(t)?t:p(t)}O.wrap=m;function k(t){return t||R}O.from=k;function*A(t){for(let u=t.length-1;u>=0;u--)yield t[u]}O.reverse=A;function C(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=C;function $(t){return t[Symbol.iterator]().next().value}O.first=$;function v(t,u){for(const r of t)if(u(r))return!0;return!1}O.some=v;function w(t,u){for(const r of t)if(u(r))return r}O.find=w;function*h(t,u){for(const r of t)u(r)&&(yield r)}O.filter=h;function*f(t,u){let r=0;for(const c of t)yield u(c,r++)}O.map=f;function*a(...t){for(const u of t)yield*u}O.concat=a;function n(t,u,r){let c=r;for(const s of t)c=u(c,s);return c}O.reduce=n;function*i(t,u,r=t.length){for(u<0&&(u+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);u<r;u++)yield t[u]}O.slice=i;function l(t,u=Number.POSITIVE_INFINITY){const r=[];if(u===0)return[r,t];const c=t[Symbol.iterator]();for(let s=0;s<u;s++){const y=c.next();if(y.done)return[r,O.empty()];r.push(y.value)}return[r,{[Symbol.iterator](){return c}}]}O.consume=l;async function o(t){const u=[];for await(const r of t)u.push(r);return Promise.resolve(u)}O.asyncToArray=o})(d||(e.Iterable=d={}))}),define(Se[166],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=N,e.$In=C,e.$Jn=$,e.$Kn=v,e.$Ln=w,e.$Mn=h,e.$Nn=f,e.$On=a,e.$Pn=n,e.$Qn=i,e.$Rn=l,e.$Sn=o;var d;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(d||(e.ScanError=d={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function N(t,u=!1){let r=0;const c=t.length;let s="",y=0,b=16,S=0;function g(z){let M=0,j=0;for(;M<z;){const U=t.charCodeAt(r);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;r++,M++}return M<z&&(j=-1),j}function E(z){r=z,s="",y=0,b=16,S=0}function D(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&k(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&k(t.charCodeAt(r)))for(r++;r<t.length&&k(t.charCodeAt(r));)r++;else return S=3,t.substring(z,r);let M=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&k(t.charCodeAt(r))){for(r++;r<t.length&&k(t.charCodeAt(r));)r++;M=r}else S=3;return t.substring(z,M)}function P(){let z="",M=r;for(;;){if(r>=c){z+=t.substring(M,r),S=2;break}const j=t.charCodeAt(r);if(j===34){z+=t.substring(M,r),r++;break}if(j===92){if(z+=t.substring(M,r),r++,r>=c){S=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Z=g(4);Z>=0?z+=String.fromCharCode(Z):S=4;break}default:S=5}M=r;continue}if(j>=0&&j<=31)if(m(j)){z+=t.substring(M,r),S=2;break}else S=6;r++}return z}function I(){if(s="",S=0,y=r,r>=c)return y=c,b=17;let z=t.charCodeAt(r);if(p(z)){do r++,s+=String.fromCharCode(z),z=t.charCodeAt(r);while(p(z));return b=15}if(m(z))return r++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),b=14;switch(z){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,s=P(),b=10;case 47:{const M=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!m(t.charCodeAt(r));)r++;return s=t.substring(M,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const j=c-1;let U=!1;for(;r<j;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,S=1),s=t.substring(M,r),b=13}return s+=String.fromCharCode(z),r++,b=16}case 45:if(s+=String.fromCharCode(z),r++,r===c||!k(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=D(),b=11;default:for(;r<c&&F(z);)r++,z=t.charCodeAt(r);if(y!==r){switch(s=t.substring(y,r),s){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return s+=String.fromCharCode(z),r++,b=16}}function F(z){if(p(z)||m(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>r,scan:u?T:I,getToken:()=>b,getTokenValue:()=>s,getTokenOffset:()=>y,getTokenLength:()=>r-y,getTokenError:()=>S}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,u){const r=[],c=new Object;let s;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function S(g,E,D,P){y.value=g,y.offset=E,y.length=D,y.type=P,y.colonOffset=void 0,s=y}try{i(t,{onObjectBegin:(g,E)=>{if(u<=g)throw c;s=void 0,b=u>g,r.push("")},onObjectProperty:(g,E,D)=>{if(u<E||(S(g,E,D,"property"),r[r.length-1]=g,u<=E+D))throw c},onObjectEnd:(g,E)=>{if(u<=g)throw c;s=void 0,r.pop()},onArrayBegin:(g,E)=>{if(u<=g)throw c;s=void 0,r.push(0)},onArrayEnd:(g,E)=>{if(u<=g)throw c;s=void 0,r.pop()},onLiteralValue:(g,E,D)=>{if(u<E||(S(g,E,D,o(g)),u<=E+D))throw c},onSeparator:(g,E,D)=>{if(u<=E)throw c;if(g===":"&&s&&s.type==="property")s.colonOffset=E,b=!1,s=void 0;else if(g===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(b=!0,r[r.length-1]=""),s=void 0}}})}catch(g){if(g!==c)throw g}return{path:r,previousNode:s,isAtPropertyKey:b,matches:g=>{let E=0;for(let D=0;E<g.length&&D<r.length;D++)if(g[E]===r[D]||g[E]==="*")E++;else if(g[E]!=="**")return!1;return E===g.length}}}function $(t,u=[],r=R.DEFAULT){let c=null,s=[];const y=[];function b(g){Array.isArray(s)?s.push(g):c!==null&&(s[c]=g)}return i(t,{onObjectBegin:()=>{const g={};b(g),y.push(s),s=g,c=null},onObjectProperty:g=>{c=g},onObjectEnd:()=>{s=y.pop()},onArrayBegin:()=>{const g=[];b(g),y.push(s),s=g,c=null},onArrayEnd:()=>{s=y.pop()},onLiteralValue:b,onError:(g,E,D)=>{u.push({error:g,offset:E,length:D})}},r),s[0]}function v(t,u=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){c.type==="property"&&(c.length=g-c.offset,c=c.parent)}function y(g){return c.children.push(g),g}i(t,{onObjectBegin:g=>{c=y({type:"object",offset:g,length:-1,parent:c,children:[]})},onObjectProperty:(g,E,D)=>{c=y({type:"property",offset:E,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:g,offset:E,length:D,parent:c})},onObjectEnd:(g,E)=>{c.length=g+E-c.offset,c=c.parent,s(g+E)},onArrayBegin:(g,E)=>{c=y({type:"array",offset:g,length:-1,parent:c,children:[]})},onArrayEnd:(g,E)=>{c.length=g+E-c.offset,c=c.parent,s(g+E)},onLiteralValue:(g,E,D)=>{y({type:o(g),offset:E,length:D,parent:c,value:g}),s(E+D)},onSeparator:(g,E,D)=>{c.type==="property"&&(g===":"?c.colonOffset=E:g===","&&s(E))},onError:(g,E,D)=>{u.push({error:g,offset:E,length:D})}},r);const S=c.children[0];return S&&delete S.parent,S}function w(t,u){if(!t)return;let r=t;for(const c of u)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const y of r.children)if(Array.isArray(y.children)&&y.children[0].value===c){r=y.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function h(t){if(!t.parent||!t.parent.children)return[];const u=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const u=Object.create(null);for(const r of t.children){const c=r.children[1];c&&(u[r.children[0].value]=f(c))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}function n(t,u,r=!1){if(a(t,u,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=u;s++){const y=n(c[s],u,r);if(y)return y}return t}}function i(t,u,r=R.DEFAULT){const c=N(t,!1);function s(be){return be?()=>be(c.getTokenOffset(),c.getTokenLength()):()=>!0}function y(be){return be?ae=>be(ae,c.getTokenOffset(),c.getTokenLength()):()=>!0}const b=s(u.onObjectBegin),S=y(u.onObjectProperty),g=s(u.onObjectEnd),E=s(u.onArrayBegin),D=s(u.onArrayEnd),P=y(u.onLiteralValue),I=y(u.onSeparator),F=s(u.onComment),T=y(u.onError),z=r&&r.disallowComments,M=r&&r.allowTrailingComma;function j(){for(;;){const be=c.scan();switch(c.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:z||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(be){case 12:case 13:z?U(10):F();break;case 16:U(1);break;case 15:case 14:break;default:return be}}}function U(be,ae=[],Ce=[]){if(T(be),ae.length+Ce.length>0){let ee=c.getToken();for(;ee!==17;){if(ae.indexOf(ee)!==-1){j();break}else if(Ce.indexOf(ee)!==-1)break;ee=j()}}}function Z(be){const ae=c.getTokenValue();return be?P(ae):S(ae),j(),!0}function ie(){switch(c.getToken()){case 11:{let be=0;try{be=JSON.parse(c.getTokenValue()),typeof be!="number"&&(U(2),be=0)}catch{U(2)}P(be);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return j(),!0}function Q(){return c.getToken()!==10?(U(3,[],[2,5]),!1):(Z(!1),c.getToken()===6?(I(":"),j(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function G(){b(),j();let be=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(be||U(4,[],[]),I(","),j(),c.getToken()===2&&M)break}else be&&U(6,[],[]);Q()||U(4,[],[2,5]),be=!0}return g(),c.getToken()!==2?U(7,[2],[]):j(),!0}function x(){E(),j();let be=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(be||U(4,[],[]),I(","),j(),c.getToken()===4&&M)break}else be&&U(6,[],[]);ne()||U(4,[],[4,5]),be=!0}return D(),c.getToken()!==4?U(8,[4],[]):j(),!0}function ne(){switch(c.getToken()){case 3:return x();case 1:return G();case 10:return Z(!0);default:return ie()}}return j(),c.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(c.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}function l(t,u){const r=N(t),c=[];let s,y=0,b;do switch(b=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:y!==b&&c.push(t.substring(y,b)),u!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,u)),y=r.getPosition();break}while(s!==17);return c.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[46],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class d{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=d}),define(Se[76],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class d{static{this.Undefined=new d(void 0)}constructor(R){this.element=R,this.next=d.Undefined,this.prev=d.Undefined}}class O{constructor(){this.a=d.Undefined,this.b=d.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===d.Undefined}clear(){let R=this.a;for(;R!==d.Undefined;){const N=R.next;R.prev=d.Undefined,R.next=d.Undefined,R=N}this.a=d.Undefined,this.b=d.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,N){const p=new d(R);if(this.a===d.Undefined)this.a=p,this.b=p;else if(N){const k=this.b;this.b=p,p.prev=k,k.next=p}else{const k=this.a;this.a=p,p.next=k,k.prev=p}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(p))}}shift(){if(this.a!==d.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==d.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==d.Undefined&&R.next!==d.Undefined){const N=R.prev;N.next=R.next,R.next.prev=N}else R.prev===d.Undefined&&R.next===d.Undefined?(this.a=d.Undefined,this.b=d.Undefined):R.next===d.Undefined?(this.b=this.b.prev,this.b.next=d.Undefined):R.prev===d.Undefined&&(this.a=this.a.next,this.a.prev=d.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==d.Undefined;)yield R.element,R=R.next}}e.$5c=O}),define(Se[27],De([1,0]),function(he,e){"use strict";var d,O,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=N,e.$zc=p,e.$Ic=l;function R(o,t,u){let r=o.get(t);return r===void 0&&(r=u,o.set(t,r)),r}function N(o){const t=[];return o.forEach((u,r)=>{t.push(`${r} => ${u}`)}),`Map(${o.size}) {${t.join(", ")}}`}function p(o){const t=[];return o.forEach(u=>{t.push(u)}),`Set(${o.size}) {${t.join(", ")}}`}class m{constructor(t,u){this.uri=t,this.value=u}}function k(o){return Array.isArray(o)}class A{static{this.c=t=>t.toString()}constructor(t,u){if(this[d]="ResourceMap",t instanceof A)this.d=new Map(t.d),this.e=u??A.c;else if(k(t)){this.d=new Map,this.e=u??A.c;for(const[r,c]of t)this.set(r,c)}else this.d=new Map,this.e=t??A.c}set(t,u){return this.d.set(this.e(t),new m(t,u)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,u){typeof u<"u"&&(t=t.bind(u));for(const[r,c]of this.d)t(c.value,c.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(d=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=A;class C{constructor(t,u){this[O]="ResourceSet",!t||typeof t=="function"?this.c=new A(t):(this.c=new A(u),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,u){this.c.forEach((r,c)=>t.call(u,c,c,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var $;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})($||(e.Touch=$={}));class v{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,u=0){const r=this.c.get(t);if(r)return u!==0&&this.m(r,u),r.value}set(t,u,r=0){let c=this.c.get(t);if(c)c.value=u,r!==0&&this.m(c,r);else{switch(c={key:t,value:u,next:void 0,previous:void 0},r){case 0:this.k(c);break;case 1:this.j(c);break;case 2:this.k(c);break;default:this.k(c);break}this.c.set(t,c),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this.c.get(t);if(u)return this.c.delete(t),this.l(u),this.f--,u.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,u){const r=this.g;let c=this.d;for(;c;){if(u?t.bind(u)(c.value,c.key,this):t(c.value,c.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,u=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.key,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}values(){const t=this,u=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.value,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}entries(){const t=this,u=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:[r.key,r.value],done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this.d,r=this.size;for(;u&&r>t;)this.c.delete(u.key),u=u.next,r--;this.d=u,this.f=r,u&&(u.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this.e,r=this.size;for(;u&&r>t;)this.c.delete(u.key),u=u.previous,r--;this.e=u,this.f=r,u&&(u.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const u=t.next,r=t.previous;if(!u||!r)throw new Error("Invalid list");u.previous=r,r.next=u}t.next=void 0,t.previous=void 0,this.g++}m(t,u){if(!this.d||!this.e)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this.d)return;const r=t.next,c=t.previous;t===this.e?(c.next=void 0,this.e=c):(r.previous=c,c.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(u===2){if(t===this.e)return;const r=t.next,c=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=c,c.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((u,r)=>{t.push([r,u])}),t}fromJSON(t){this.clear();for(const[u,r]of t)this.set(u,r)}}e.$Cc=v;class w extends v{constructor(t,u=1){super(),this.n=t,this.o=Math.min(Math.max(0,u),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends w{constructor(t,u=1){super(t,u)}q(t){this.h(t)}set(t,u){return super.set(t,u),this.p(),this}}e.$Dc=h;class f extends w{constructor(t,u=1){super(t,u)}q(t){this.i(t)}set(t,u){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,u),this}}e.$Ec=f;class a{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let u=this.c.get(t)||0;return u===0?!1:(u--,u===0?this.c.delete(t):this.c.set(t,u),!0)}has(t){return this.c.has(t)}}e.$Fc=a;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[u,r]of t)this.set(u,r)}clear(){this.c.clear(),this.d.clear()}set(t,u){this.c.set(t,u),this.d.set(u,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const u=this.c.get(t);return u===void 0?!1:(this.c.delete(t),this.d.delete(u),!0)}forEach(t,u){this.c.forEach((r,c)=>{t.call(u,r,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class i{constructor(){this.c=new Map}add(t,u){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(u)}delete(t,u){const r=this.c.get(t);r&&(r.delete(u),r.size===0&&this.c.delete(t))}forEach(t,u){const r=this.c.get(t);r&&r.forEach(u)}get(t){const u=this.c.get(t);return u||new Set}}e.$Hc=i;function l(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[u,r]of o)if(!t.has(u)||t.get(u)!==r)return!1;for(const[u]of t)if(!o.has(u))return!1;return!0}}),define(Se[3],De([1,0,19,74,27,75,39]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=C,e.$Mc=$,e.$Nc=h,e.$Oc=f,e.$Pc=a,e.$Qc=n,e.$Rc=i,e.$Sc=l,e.$3c=g;const p=!1;let m=null;class k{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:k.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const F=this.c(P);F.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const F=I.get(P);if(F)return F;const T=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,T),T}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,I){let F;if(I)F=I;else{const U=new Map,Z=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,U).isSingleton);if(Z.length===0)return;const ie=new Set(Z.map(Q=>Q.value));if(F=Z.filter(Q=>!(Q.parent&&ie.has(Q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(U){function Z(Q,G){for(;Q.length>0&&G.some(x=>typeof x=="string"?x===Q[0]:Q[0].match(x));)Q.shift()}const ie=U.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return Z(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const z=new L.$Hc;for(const U of F){const Z=T(U);for(let ie=0;ie<=Z.length;ie++)z.add(Z.slice(0,ie).join(`
`),U)}F.sort((0,d.$6b)(U=>U.idx,d.$8b));let M="",j=0;for(const U of F.slice(0,P)){j++;const Z=T(U),ie=[];for(let Q=0;Q<Z.length;Q++){let G=Z[Q];G=`(shared with ${z.get(Z.slice(0,Q+1).join(`
`)).size}/${F.length} leaks) at ${G}`;const ne=z.get(Z.slice(0,Q).join(`
`)),be=(0,O.$K)([...ne].map(ae=>T(ae)[Q]),ae=>ae);delete be[Z[Q]];for(const[ae,Ce]of Object.entries(be))ie.unshift(`    - stacktraces of ${Ce.length} other leaks continue with ${ae}`);ie.unshift(G)}M+=`


==================== Leaking disposable ${j}/${F.length}: ${U.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>P&&(M+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:M}}}e.$Jc=k;function A(D){m=D}if(p){const D="__is_disposable_tracked__";A(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[D]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[D]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[D]=!0}catch{}}markAsSingleton(P){}})}function C(D){return m?.trackDisposable(D),D}function $(D){m?.markAsDisposed(D)}function v(D,P){m?.setParent(D,P)}function w(D,P){if(m)for(const I of D)m.setParent(I,P)}function h(D){return m?.markAsSingleton(D),D}function f(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function a(D){if(N.Iterable.is(D)){const P=[];for(const I of D)if(I)try{I.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function n(D){for(const P of D)f(P)&&P.dispose();return[]}function i(...D){const P=l(()=>a(D));return w(D,P),P}function l(D){const P=C({dispose:(0,R.$db)(()=>{$(P),D()})});return P}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return v(P,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),v(P,null))}}e.$Tc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,C(this),v(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class u{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&v(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&v(P,null),P}}e.$Vc=u;class r{constructor(P){this.a=new u,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class c{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,$(this))},this}}e.$Yc=s;class y{constructor(){this.a=new Map}acquire(P,...I){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...I)},this.a.set(P,F));const{object:T}=F,z=(0,R.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:T,dispose:z}}}e.$Zc=y;class b{constructor(P){this.a=P}async acquire(P,...I){const F=this.a.acquire(P,...I);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=b;class S{constructor(P){this.object=P}dispose(){}}e.$2c=S;function g(D){const P=new o;try{D(P)}finally{P.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=E}),function(he,e){typeof define=="function"&&define.amd?define(Se[167],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ce,oe){for(var le=0;le<oe.length;le++){var J=oe[le];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ce,J.key,J)}}function d(ce,oe,le){return oe&&e(ce.prototype,oe),le&&e(ce,le),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function O(ce,oe){if(ce){if(typeof ce=="string")return L(ce,oe);var le=Object.prototype.toString.call(ce).slice(8,-1);if(le==="Object"&&ce.constructor&&(le=ce.constructor.name),le==="Map"||le==="Set")return Array.from(ce);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return L(ce,oe)}}function L(ce,oe){(oe==null||oe>ce.length)&&(oe=ce.length);for(var le=0,J=new Array(oe);le<oe;le++)J[le]=ce[le];return J}function R(ce,oe){var le=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(le)return(le=le.call(ce)).next.bind(le);if(Array.isArray(ce)||(le=O(ce))||oe&&ce&&typeof ce.length=="number"){le&&(ce=le);var J=0;return function(){return J>=ce.length?{done:!0}:{done:!1,value:ce[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=N();function p(ce){he.defaults=ce}var m=/[&<>"']/,k=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(oe){return $[oe]};function w(ce,oe){if(oe){if(m.test(ce))return ce.replace(k,v)}else if(A.test(ce))return ce.replace(C,v);return ce}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ce){return ce.replace(h,function(oe,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(ce,oe){ce=typeof ce=="string"?ce:ce.source,oe=oe||"";var le={replace:function(se,$e){return $e=$e.source||$e,$e=$e.replace(a,"$1"),ce=ce.replace(se,$e),le},getRegex:function(){return new RegExp(ce,oe)}};return le}var i=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(ce,oe,le){if(ce){var J;try{J=decodeURIComponent(f(le)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}oe&&!l.test(le)&&(le=s(oe,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ce,oe){t[" "+ce]||(u.test(ce)?t[" "+ce]=ce+"/":t[" "+ce]=g(ce,"/",!0)),ce=t[" "+ce];var le=ce.indexOf(":")===-1;return oe.substring(0,2)==="//"?le?oe:ce.replace(r,"$1")+oe:oe.charAt(0)==="/"?le?oe:ce.replace(c,"$1")+oe:ce+oe}var y={exec:function(){}};function b(ce){for(var oe=1,le,J;oe<arguments.length;oe++){le=arguments[oe];for(J in le)Object.prototype.hasOwnProperty.call(le,J)&&(ce[J]=le[J])}return ce}function S(ce,oe){var le=ce.replace(/\|/g,function($e,ve,Re){for(var ge=!1,Ie=ve;--Ie>=0&&Re[Ie]==="\\";)ge=!ge;return ge?"|":" |"}),J=le.split(/ \|/),se=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>oe)J.splice(oe);else for(;J.length<oe;)J.push("");for(;se<J.length;se++)J[se]=J[se].trim().replace(/\\\|/g,"|");return J}function g(ce,oe,le){var J=ce.length;if(J===0)return"";for(var se=0;se<J;){var $e=ce.charAt(J-se-1);if($e===oe&&!le)se++;else if($e!==oe&&le)se++;else break}return ce.slice(0,J-se)}function E(ce,oe){if(ce.indexOf(oe[1])===-1)return-1;for(var le=ce.length,J=0,se=0;se<le;se++)if(ce[se]==="\\")se++;else if(ce[se]===oe[0])J++;else if(ce[se]===oe[1]&&(J--,J<0))return se;return-1}function D(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ce,oe){if(oe<1)return"";for(var le="";oe>1;)oe&1&&(le+=ce),oe>>=1,ce+=ce;return le+ce}function I(ce,oe,le,J){var se=oe.href,$e=oe.title?w(oe.title):null,ve=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){J.state.inLink=!0;var Re={type:"link",raw:le,href:se,title:$e,text:ve,tokens:J.inlineTokens(ve)};return J.state.inLink=!1,Re}return{type:"image",raw:le,href:se,title:$e,text:w(ve)}}function F(ce,oe){var le=ce.match(/^(\s+)(?:```)/);if(le===null)return oe;var J=le[1];return oe.split(`
`).map(function(se){var $e=se.match(/^\s+/);if($e===null)return se;var ve=$e[0];return ve.length>=J.length?se.slice(J.length):se}).join(`
`)}var T=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.space=function(J){var se=this.rules.block.newline.exec(J);if(se&&se[0].length>0)return{type:"space",raw:se[0]}},oe.code=function(J){var se=this.rules.block.code.exec(J);if(se){var $e=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:g($e,`
`)}}},oe.fences=function(J){var se=this.rules.block.fences.exec(J);if(se){var $e=se[0],ve=F($e,se[3]||"");return{type:"code",raw:$e,lang:se[2]?se[2].trim():se[2],text:ve}}},oe.heading=function(J){var se=this.rules.block.heading.exec(J);if(se){var $e=se[2].trim();if(/#$/.test($e)){var ve=g($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:se[0],depth:se[1].length,text:$e,tokens:this.lexer.inline($e)}}},oe.hr=function(J){var se=this.rules.block.hr.exec(J);if(se)return{type:"hr",raw:se[0]}},oe.blockquote=function(J){var se=this.rules.block.blockquote.exec(J);if(se){var $e=se[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},oe.list=function(J){var se=this.rules.block.list.exec(J);if(se){var $e,ve,Re,ge,Ie,Ae,ze,V,W,K,X,de,we=se[1].trim(),Fe=we.length>1,Ve={type:"list",raw:"",ordered:Fe,start:Fe?+we.slice(0,-1):"",loose:!1,items:[]};we=Fe?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Fe?we:"[*+-]");for(var Je=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(de=!1,!(!(se=Je.exec(J))||this.rules.block.hr.test(J)));){if($e=se[0],J=J.substring($e.length),V=se[2].split(`
`,1)[0],W=J.split(`
`,1)[0],this.options.pedantic?(ge=2,X=V.trimLeft()):(ge=se[2].search(/[^ ]/),ge=ge>4?1:ge,X=V.slice(ge),ge+=se[1].length),Ae=!1,!V&&/^ *$/.test(W)&&($e+=W+`
`,J=J.substring(W.length+1),de=!0),!de)for(var tt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");J&&(K=J.split(`
`,1)[0],V=K,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(V)||it.test(V)||tt.test(V)||_e.test(J)));){if(V.search(/[^ ]/)>=ge||!V.trim())X+=`
`+V.slice(ge);else if(!Ae)X+=`
`+V;else break;!Ae&&!V.trim()&&(Ae=!0),$e+=K+`
`,J=J.substring(K.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test($e)&&(ze=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(X),ve&&(Re=ve[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:$e,task:!!ve,checked:Re,loose:!1,text:X}),Ve.raw+=$e}Ve.items[Ve.items.length-1].raw=$e.trimRight(),Ve.items[Ve.items.length-1].text=X.trimRight(),Ve.raw=Ve.raw.trimRight();var rt=Ve.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var at=Ve.items[Ie].tokens.filter(function(ye){return ye.type==="space"}),Ne=at.every(function(ye){for(var qe=ye.raw.split(""),te=0,re=R(qe),Pe;!(Pe=re()).done;){var He=Pe.value;if(He===`
`&&(te+=1),te>1)return!0}return!1});!Ve.loose&&at.length&&Ne&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},oe.html=function(J){var se=this.rules.block.html.exec(J);if(se){var $e={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(se[0]):w(se[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},oe.def=function(J){var se=this.rules.block.def.exec(J);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var $e=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:se[0],href:se[2],title:se[3]}}},oe.table=function(J){var se=this.rules.block.table.exec(J);if(se){var $e={type:"table",header:S(se[1]).map(function(ze){return{text:ze}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]&&se[3].trim()?se[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=se[0];var ve=$e.align.length,Re,ge,Ie,Ae;for(Re=0;Re<ve;Re++)/^ *-+: *$/.test($e.align[Re])?$e.align[Re]="right":/^ *:-+: *$/.test($e.align[Re])?$e.align[Re]="center":/^ *:-+ *$/.test($e.align[Re])?$e.align[Re]="left":$e.align[Re]=null;for(ve=$e.rows.length,Re=0;Re<ve;Re++)$e.rows[Re]=S($e.rows[Re],$e.header.length).map(function(ze){return{text:ze}});for(ve=$e.header.length,ge=0;ge<ve;ge++)$e.header[ge].tokens=this.lexer.inline($e.header[ge].text);for(ve=$e.rows.length,ge=0;ge<ve;ge++)for(Ae=$e.rows[ge],Ie=0;Ie<Ae.length;Ie++)Ae[Ie].tokens=this.lexer.inline(Ae[Ie].text);return $e}}},oe.lheading=function(J){var se=this.rules.block.lheading.exec(J);if(se)return{type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:this.lexer.inline(se[1])}},oe.paragraph=function(J){var se=this.rules.block.paragraph.exec(J);if(se){var $e=se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1];return{type:"paragraph",raw:se[0],text:$e,tokens:this.lexer.inline($e)}}},oe.text=function(J){var se=this.rules.block.text.exec(J);if(se)return{type:"text",raw:se[0],text:se[0],tokens:this.lexer.inline(se[0])}},oe.escape=function(J){var se=this.rules.inline.escape.exec(J);if(se)return{type:"escape",raw:se[0],text:w(se[1])}},oe.tag=function(J){var se=this.rules.inline.tag.exec(J);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):w(se[0]):se[0]}},oe.link=function(J){var se=this.rules.inline.link.exec(J);if(se){var $e=se[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=g($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Re=E(se[2],"()");if(Re>-1){var ge=se[0].indexOf("!")===0?5:4,Ie=ge+se[1].length+Re;se[2]=se[2].substring(0,Re),se[0]=se[0].substring(0,Ie).trim(),se[3]=""}}var Ae=se[2],ze="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);V&&(Ae=V[1],ze=V[3])}else ze=se[3]?se[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test($e)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),I(se,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},oe.reflink=function(J,se){var $e;if(($e=this.rules.inline.reflink.exec(J))||($e=this.rules.inline.nolink.exec(J))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=se[ve.toLowerCase()],!ve||!ve.href){var Re=$e[0].charAt(0);return{type:"text",raw:Re,text:Re}}return I($e,ve,$e[0],this.lexer)}},oe.emStrong=function(J,se,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=ve[1]||ve[2]||"";if(!Re||Re&&($e===""||this.rules.inline.punctuation.exec($e))){var ge=ve[0].length-1,Ie,Ae,ze=ge,V=0,W=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,se=se.slice(-1*J.length+ge);(ve=W.exec(se))!=null;)if(Ie=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Ie){if(Ae=Ie.length,ve[3]||ve[4]){ze+=Ae;continue}else if((ve[5]||ve[6])&&ge%3&&!((ge+Ae)%3)){V+=Ae;continue}if(ze-=Ae,!(ze>0)){if(Ae=Math.min(Ae,Ae+ze+V),Math.min(ge,Ae)%2){var K=J.slice(1,ge+ve.index+Ae);return{type:"em",raw:J.slice(0,ge+ve.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var X=J.slice(2,ge+ve.index+Ae-1);return{type:"strong",raw:J.slice(0,ge+ve.index+Ae+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},oe.codespan=function(J){var se=this.rules.inline.code.exec(J);if(se){var $e=se[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Re=/^ /.test($e)&&/ $/.test($e);return ve&&Re&&($e=$e.substring(1,$e.length-1)),$e=w($e,!0),{type:"codespan",raw:se[0],text:$e}}},oe.br=function(J){var se=this.rules.inline.br.exec(J);if(se)return{type:"br",raw:se[0]}},oe.del=function(J){var se=this.rules.inline.del.exec(J);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2])}},oe.autolink=function(J,se){var $e=this.rules.inline.autolink.exec(J);if($e){var ve,Re;return $e[2]==="@"?(ve=w(this.options.mangle?se($e[1]):$e[1]),Re="mailto:"+ve):(ve=w($e[1]),Re=ve),{type:"link",raw:$e[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.url=function(J,se){var $e;if($e=this.rules.inline.url.exec(J)){var ve,Re;if($e[2]==="@")ve=w(this.options.mangle?se($e[0]):$e[0]),Re="mailto:"+ve;else{var ge;do ge=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(ge!==$e[0]);ve=w($e[0]),$e[1]==="www."?Re="http://"+ve:Re=ve}return{type:"link",raw:$e[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.inlineText=function(J,se){var $e=this.rules.inline.text.exec(J);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):w($e[0]):$e[0]:ve=w(this.options.smartypants?se($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=b({},z),z.gfm=b({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=b({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=n(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=n(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=n(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=n(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=n(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=n(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=n(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=n(M.reflink).replace("label",M._label).replace("ref",z._label).getRegex(),M.nolink=n(M.nolink).replace("ref",z._label).getRegex(),M.reflinkSearch=n(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=b({},M),M.pedantic=b({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=b({},M.normal,{escape:n(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=n(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=b({},M.gfm,{br:n(M.br).replace("{2,}","*").getRegex(),text:n(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ce){var oe="",le,J,se=ce.length;for(le=0;le<se;le++)J=ce.charCodeAt(le),Math.random()>.5&&(J="x"+J.toString(16)),oe+="&#"+J+";";return oe}var Z=function(){function ce(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||he.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:z.normal,inline:M.normal};this.options.pedantic?(J.block=z.pedantic,J.inline=M.pedantic):this.options.gfm&&(J.block=z.gfm,this.options.breaks?J.inline=M.breaks:J.inline=M.gfm),this.tokenizer.rules=J}ce.lex=function(J,se){var $e=new ce(se);return $e.lex(J)},ce.lexInline=function(J,se){var $e=new ce(se);return $e.inlineTokens(J)};var oe=ce.prototype;return oe.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},oe.blockTokens=function(J,se){var $e=this;se===void 0&&(se=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ze,V,W){return V+"    ".repeat(W.length)});for(var ve,Re,ge,Ie;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(ve=ze.call({lexer:$e},J,se))?(J=J.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.raw.length===1&&se.length>0?se[se.length-1].raw+=`
`:se.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.list(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.def(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ge=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,V=J.slice(1),W=void 0;$e.options.extensions.startBlock.forEach(function(K){W=K.call({lexer:this},V),typeof W=="number"&&W>=0&&(ze=Math.min(ze,W))}),ze<1/0&&ze>=0&&(ge=J.substring(0,ze+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(ge))){Re=se[se.length-1],Ie&&Re.type==="paragraph"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve),Ie=ge.length!==J.length,J=J.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve);continue}if(J){var Ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,se},oe.inline=function(J,se){return se===void 0&&(se=[]),this.inlineQueue.push({src:J,tokens:se}),se},oe.inlineTokens=function(J,se){var $e=this;se===void 0&&(se=[]);var ve,Re,ge,Ie=J,Ae,ze,V;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)W.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ze||(V=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(ve=X.call({lexer:$e},J,se))?(J=J.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.tag(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.link(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.emStrong(J,Ie,V)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.codespan(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.br(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.del(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.autolink(J,U)){J=J.substring(ve.raw.length),se.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(J,U))){J=J.substring(ve.raw.length),se.push(ve);continue}if(ge=J,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,de=J.slice(1),we=void 0;$e.options.extensions.startInline.forEach(function(Fe){we=Fe.call({lexer:this},de),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<1/0&&X>=0&&(ge=J.substring(0,X+1))}(),ve=this.tokenizer.inlineText(ge,j)){J=J.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(V=ve.raw.slice(-1)),ze=!0,Re=se[se.length-1],Re&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return se},d(ce,null,[{key:"rules",get:function(){return{block:z,inline:M}}}]),ce}(),ie=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.code=function(J,se,$e){var ve=(se||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(J,ve);Re!=null&&Re!==J&&($e=!0,J=Re)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+w(ve,!0)+'">'+($e?J:w(J,!0))+`</code></pre>
`:"<pre><code>"+($e?J:w(J,!0))+`</code></pre>
`},oe.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},oe.html=function(J){return J},oe.heading=function(J,se,$e,ve){if(this.options.headerIds){var Re=this.options.headerPrefix+ve.slug($e);return"<h"+se+' id="'+Re+'">'+J+"</h"+se+`>
`}return"<h"+se+">"+J+"</h"+se+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(J,se,$e){var ve=se?"ol":"ul",Re=se&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Re+`>
`+J+"</"+ve+`>
`},oe.listitem=function(J){return"<li>"+J+`</li>
`},oe.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(J){return"<p>"+J+`</p>
`},oe.table=function(J,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+se+`</table>
`},oe.tablerow=function(J){return`<tr>
`+J+`</tr>
`},oe.tablecell=function(J,se){var $e=se.header?"th":"td",ve=se.align?"<"+$e+' align="'+se.align+'">':"<"+$e+">";return ve+J+("</"+$e+`>
`)},oe.strong=function(J){return"<strong>"+J+"</strong>"},oe.em=function(J){return"<em>"+J+"</em>"},oe.codespan=function(J){return"<code>"+J+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(J){return"<del>"+J+"</del>"},oe.link=function(J,se,$e){if(J=o(this.options.sanitize,this.options.baseUrl,J),J===null)return $e;var ve='<a href="'+w(J)+'"';return se&&(ve+=' title="'+se+'"'),ve+=">"+$e+"</a>",ve},oe.image=function(J,se,$e){if(J=o(this.options.sanitize,this.options.baseUrl,J),J===null)return $e;var ve='<img src="'+J+'" alt="'+$e+'"';return se&&(ve+=' title="'+se+'"'),ve+=this.options.xhtml?"/>":">",ve},oe.text=function(J){return J},ce}(),Q=function(){function ce(){}var oe=ce.prototype;return oe.strong=function(J){return J},oe.em=function(J){return J},oe.codespan=function(J){return J},oe.del=function(J){return J},oe.html=function(J){return J},oe.text=function(J){return J},oe.link=function(J,se,$e){return""+$e},oe.image=function(J,se,$e){return""+$e},oe.br=function(){return""},ce}(),G=function(){function ce(){this.seen={}}var oe=ce.prototype;return oe.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(J,se){var $e=J,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[J];do ve++,$e=J+"-"+ve;while(this.seen.hasOwnProperty($e))}return se||(this.seen[J]=ve,this.seen[$e]=0),$e},oe.slug=function(J,se){se===void 0&&(se={});var $e=this.serialize(J);return this.getNextSafeSlug($e,se.dryrun)},ce}(),x=function(){function ce(le){this.options=le||he.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Q,this.slugger=new G}ce.parse=function(J,se){var $e=new ce(se);return $e.parse(J)},ce.parseInline=function(J,se){var $e=new ce(se);return $e.parseInline(J)};var oe=ce.prototype;return oe.parse=function(J,se){se===void 0&&(se=!0);var $e="",ve,Re,ge,Ie,Ae,ze,V,W,K,X,de,we,Fe,Ve,Je,tt,_e,nt,it,rt=J.length;for(ve=0;ve<rt;ve++){if(X=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(it=this.options.extensions.renderers[X.type].call({parser:this},X),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){$e+=it||"";continue}switch(X.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(X.tokens),X.depth,f(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(W="",V="",Ie=X.header.length,Re=0;Re<Ie;Re++)V+=this.renderer.tablecell(this.parseInline(X.header[Re].tokens),{header:!0,align:X.align[Re]});for(W+=this.renderer.tablerow(V),K="",Ie=X.rows.length,Re=0;Re<Ie;Re++){for(ze=X.rows[Re],V="",Ae=ze.length,ge=0;ge<Ae;ge++)V+=this.renderer.tablecell(this.parseInline(ze[ge].tokens),{header:!1,align:X.align[ge]});K+=this.renderer.tablerow(V)}$e+=this.renderer.table(W,K);continue}case"blockquote":{K=this.parse(X.tokens),$e+=this.renderer.blockquote(K);continue}case"list":{for(de=X.ordered,we=X.start,Fe=X.loose,Ie=X.items.length,K="",Re=0;Re<Ie;Re++)Je=X.items[Re],tt=Je.checked,_e=Je.task,Ve="",Je.task&&(nt=this.renderer.checkbox(tt),Fe?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=nt+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=nt+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:nt}):Ve+=nt),Ve+=this.parse(Je.tokens,Fe),K+=this.renderer.listitem(Ve,_e,tt);$e+=this.renderer.list(K,de,we);continue}case"html":{$e+=this.renderer.html(X.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(K=X.tokens?this.parseInline(X.tokens):X.text;ve+1<rt&&J[ve+1].type==="text";)X=J[++ve],K+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);$e+=se?this.renderer.paragraph(K):K;continue}default:{var at='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return $e},oe.parseInline=function(J,se){se=se||this.renderer;var $e="",ve,Re,ge,Ie=J.length;for(ve=0;ve<Ie;ve++){if(Re=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(ge=this.options.extensions.renderers[Re.type].call({parser:this},Re),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){$e+=ge||"";continue}switch(Re.type){case"escape":{$e+=se.text(Re.text);break}case"html":{$e+=se.html(Re.text);break}case"link":{$e+=se.link(Re.href,Re.title,this.parseInline(Re.tokens,se));break}case"image":{$e+=se.image(Re.href,Re.title,Re.text);break}case"strong":{$e+=se.strong(this.parseInline(Re.tokens,se));break}case"em":{$e+=se.em(this.parseInline(Re.tokens,se));break}case"codespan":{$e+=se.codespan(Re.text);break}case"br":{$e+=se.br();break}case"del":{$e+=se.del(this.parseInline(Re.tokens,se));break}case"text":{$e+=se.text(Re.text);break}default:{var Ae='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return $e},ce}();function ne(ce,oe,le){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof oe=="function"&&(le=oe,oe=null),oe=b({},ne.defaults,oe||{}),D(oe),le){var J=oe.highlight,se;try{se=Z.lex(ce,oe)}catch(Ie){return le(Ie)}var $e=function(Ae){var ze;if(!Ae)try{oe.walkTokens&&ne.walkTokens(se,oe.walkTokens),ze=x.parse(se,oe)}catch(V){Ae=V}return oe.highlight=J,Ae?le(Ae):le(null,ze)};if(!J||J.length<3||(delete oe.highlight,!se.length))return $e();var ve=0;ne.walkTokens(se,function(Ie){Ie.type==="code"&&(ve++,setTimeout(function(){J(Ie.text,Ie.lang,function(Ae,ze){if(Ae)return $e(Ae);ze!=null&&ze!==Ie.text&&(Ie.text=ze,Ie.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Re(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+w(Ie.message+"",!0)+"</pre>";throw Ie}try{var ge=Z.lex(ce,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ne.walkTokens(ge,oe.walkTokens)).then(function(){return x.parse(ge,oe)}).catch(Re);ne.walkTokens(ge,oe.walkTokens)}return x.parse(ge,oe)}catch(Ie){Re(Ie)}}ne.options=ne.setOptions=function(ce){return b(ne.defaults,ce),p(ne.defaults),ne},ne.getDefaults=N,ne.defaults=he.defaults,ne.use=function(){for(var ce=arguments.length,oe=new Array(ce),le=0;le<ce;le++)oe[le]=arguments[le];var J=b.apply(void 0,[{}].concat(oe)),se=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;oe.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Ie=se.renderers?se.renderers[ge.name]:null;Ie?se.renderers[ge.name]=function(){for(var Ae=arguments.length,ze=new Array(Ae),V=0;V<Ae;V++)ze[V]=arguments[V];var W=ge.renderer.apply(this,ze);return W===!1&&(W=Ie.apply(this,ze)),W}:se.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[ge.level]?se[ge.level].unshift(ge.tokenizer):se[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?se.startBlock?se.startBlock.push(ge.start):se.startBlock=[ge.start]:ge.level==="inline"&&(se.startInline?se.startInline.push(ge.start):se.startInline=[ge.start]))}ge.childTokens&&(se.childTokens[ge.name]=ge.childTokens)})),ve.renderer&&function(){var ge=ne.defaults.renderer||new ie,Ie=function(V){var W=ge[V];ge[V]=function(){for(var K=arguments.length,X=new Array(K),de=0;de<K;de++)X[de]=arguments[de];var we=ve.renderer[V].apply(ge,X);return we===!1&&(we=W.apply(ge,X)),we}};for(var Ae in ve.renderer)Ie(Ae);J.renderer=ge}(),ve.tokenizer&&function(){var ge=ne.defaults.tokenizer||new T,Ie=function(V){var W=ge[V];ge[V]=function(){for(var K=arguments.length,X=new Array(K),de=0;de<K;de++)X[de]=arguments[de];var we=ve.tokenizer[V].apply(ge,X);return we===!1&&(we=W.apply(ge,X)),we}};for(var Ae in ve.tokenizer)Ie(Ae);J.tokenizer=ge}(),ve.walkTokens){var Re=ne.defaults.walkTokens;J.walkTokens=function(ge){var Ie=[];return Ie.push(ve.walkTokens.call(this,ge)),Re&&(Ie=Ie.concat(Re.call(this,ge))),Ie}}$e&&(J.extensions=se),ne.setOptions(J)})},ne.walkTokens=function(ce,oe){for(var le=[],J=function(){var Re=$e.value;switch(le=le.concat(oe.call(ne,Re)),Re.type){case"table":{for(var ge=R(Re.header),Ie;!(Ie=ge()).done;){var Ae=Ie.value;le=le.concat(ne.walkTokens(Ae.tokens,oe))}for(var ze=R(Re.rows),V;!(V=ze()).done;)for(var W=V.value,K=R(W),X;!(X=K()).done;){var de=X.value;le=le.concat(ne.walkTokens(de.tokens,oe))}break}case"list":{le=le.concat(ne.walkTokens(Re.items,oe));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Re.type]?ne.defaults.extensions.childTokens[Re.type].forEach(function(we){le=le.concat(ne.walkTokens(Re[we],oe))}):Re.tokens&&(le=le.concat(ne.walkTokens(Re.tokens,oe)))}},se=R(ce),$e;!($e=se()).done;)J();return le},ne.parseInline=function(ce,oe){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");oe=b({},ne.defaults,oe||{}),D(oe);try{var le=Z.lexInline(ce,oe);return oe.walkTokens&&ne.walkTokens(le,oe.walkTokens),x.parseInline(le,oe)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+w(J.message+"",!0)+"</pre>";throw J}},ne.Parser=x,ne.parser=x.parse,ne.Renderer=ie,ne.TextRenderer=Q,ne.Lexer=Z,ne.lexer=Z.lex,ne.Tokenizer=T,ne.Slugger=G,ne.parse=ne;var be=ne.options,ae=ne.setOptions,Ce=ne.use,ee=ne.walkTokens,B=ne.parseInline,_=ne,pe=x.parse,ue=Z.lex;he.Lexer=Z,he.Parser=x,he.Renderer=ie,he.Slugger=G,he.TextRenderer=Q,he.Tokenizer=T,he.getDefaults=N,he.lexer=ue,he.marked=ne,he.options=be,he.parse=_,he.parseInline=B,he.parser=pe,he.setOptions=ae,he.use=Ce,he.walkTokens=ee,Object.defineProperty(he,"__esModule",{value:!0})}),define(Se[168],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=d;function d(h){const f=R(h);if(f&&f.length>0)return new Uint32Array(f)}let O=0;const L=new Uint32Array(10);function R(h){if(O=0,N(h,C,4352),O>0||(N(h,$,4449),O>0)||(N(h,v,4520),O>0)||(N(h,w,12593),O))return L.subarray(0,O);if(h>=44032&&h<=55203){const f=h-44032,a=f%588,n=Math.floor(f/588),i=Math.floor(a/28),l=a%28-1;if(n<C.length?N(n,C,0):4352+n-12593<w.length&&N(4352+n,w,12593),i<$.length?N(i,$,0):4449+i-12593<w.length&&N(4449+i-12593,w,12593),l>=0&&(l<v.length?N(l,v,0):4520+l-12593<w.length&&N(4520+l-12593,w,12593)),O>0)return L.subarray(0,O)}}function N(h,f,a){h>=a&&h<a+f.length&&p(f[h-a])}function p(h){h!==0&&(L[O++]=h&255,h>>8&&(L[O++]=h>>8&255),h>>16&&(L[O++]=h>>16&255))}var m;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var k;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(k||(k={}));var A;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(A||(A={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),$=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[77],De([1,0,27]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=L,e.$cm=N;const O=new d.$Dc(1e4);function L(k){return m(k,"NFC",O)}const R=new d.$Dc(1e4);function N(k){return m(k,"NFD",R)}const p=/[^\u0000-\u0080]/;function m(k,A,C){if(!k)return k;const $=C.get(k);if($)return $;let v;return p.test(k)?v=k.normalize(A):v=k,C.set(k,v),v}e.$dm=function(){const k=/[\u0300-\u036f]/g;return function(A){return N(A).replace(k,"")}}()}),define(Se[126],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=d,e.rot=O;function d(p,m,k){return Math.min(Math.max(p,m),k)}function O(p,m){return(m+p%m)%m}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=L;class R{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=R;class N{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const k=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=N}),define(Se[169],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=R,e.$cd=$;class d{constructor(w,h,f){this.owner=w,this.debugNameSource=h,this.referenceFn=f}getDebugName(w){return R(w,this)}}e.$ad=d;const O=new Map,L=new WeakMap;function R(v,w){const h=L.get(v);if(h)return h;const f=N(v,w);if(f){let a=O.get(f)??0;a++,O.set(f,a);const n=a===1?f:`${f}#${a}`;return L.set(v,n),n}}function N(v,w){const h=L.get(v);if(h)return h;const f=w.owner?A(w.owner)+".":"";let a;const n=w.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(a=n(),a!==void 0)return f+a}else return f+n;const i=w.referenceFn;if(i!==void 0&&(a=$(i),a!==void 0))return f+a;if(w.owner!==void 0){const l=p(w.owner,v);if(l!==void 0)return f+l}}function p(v,w){for(const h in v)if(v[h]===w)return h}const m=new Map,k=new WeakMap;function A(v){const w=k.get(v);if(w)return w;const h=C(v);let f=m.get(h)??0;f++,m.set(h,f);const a=f===1?h:`${h}#${f}`;return k.set(v,a),a}function C(v){const w=v.constructor;return w?w.name:"Object"}function $(v){const w=v.toString(),f=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(f?f[1]:void 0)?.trim()}}),define(Se[170],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=L;let d;function O(h){d=h}function L(){return d}class R{constructor(){this.a=0,this.d=new WeakMap}b(f){return N([p(v("|  ",this.a)),f])}c(f){return f.hadValue?f.didChange?[p(" "),k(A(f.oldValue,70),{color:"red",strikeThrough:!0}),p(" "),k(A(f.newValue,60),{color:"green"})]:[p(" (unchanged)")]:[p(" "),k(A(f.newValue,60),{color:"green"}),p(" (initial)")]}handleObservableChanged(f,a){console.log(...this.b([m("observable value changed"),k(f.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(f){if(f.size!==0)return k(" (changed deps: "+[...f].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const a=f.handleChange;this.d.set(f,new Set),f.handleChange=(n,i)=>(this.d.get(f).add(n),a.apply(f,[n,i]))}handleDerivedRecomputed(f,a){const n=this.d.get(f);console.log(...this.b([m("derived recomputed"),k(f.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(n),{data:[{fn:f._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(f,a){console.log(...this.b([m("observable from event triggered"),k(f.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:f._getValue}]}]))}handleAutorunCreated(f){const a=f.handleChange;this.d.set(f,new Set),f.handleChange=(n,i)=>(this.d.get(f).add(n),a.apply(f,[n,i]))}handleAutorunTriggered(f){const a=this.d.get(f);console.log(...this.b([m("autorun"),k(f.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:f._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(f){this.a--}handleBeginTransaction(f){let a=f.getDebugName();a===void 0&&(a=""),console.log(...this.b([m("transaction"),k(a,{color:"BlueViolet"}),{data:[{fn:f._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=R;function N(h){const f=new Array,a=[];let n="";function i(o){if("length"in o)for(const t of o)t&&i(t);else"text"in o?(n+=`%c${o.text}`,f.push(o.style),o.data&&a.push(...o.data)):"data"in o&&a.push(...o.data)}i(h);const l=[n,...f];return l.push(...a),l}function p(h){return k(h,{color:"black"})}function m(h){return k(w(`${h}: `,10),{color:"black",bold:!0})}function k(h,f={color:"black"}){function a(i){return Object.entries(i).reduce((l,[o,t])=>`${l}${o}:${t};`,"")}const n={color:f.color};return f.strikeThrough&&(n["text-decoration"]="line-through"),f.bold&&(n["font-weight"]="bold"),{text:h,style:a(n)}}function A(h,f){switch(typeof h){case"number":return""+h;case"string":return h.length+2<=f?`"${h}"`:`"${h.substr(0,f-7)}"+...`;case"boolean":return h?"true":"false";case"undefined":return"undefined";case"object":return h===null?"null":Array.isArray(h)?C(h,f):$(h,f);case"symbol":return h.toString();case"function":return`[[Function${h.name?" "+h.name:""}]]`;default:return""+h}}function C(h,f){let a="[ ",n=!0;for(const i of h){if(n||(a+=", "),a.length-5>f){a+="...";break}n=!1,a+=`${A(i,f-a.length)}`}return a+=" ]",a}function $(h,f){let a="{ ",n=!0;for(const[i,l]of Object.entries(h)){if(n||(a+=", "),a.length-5>f){a+="...";break}n=!1,a+=`${i}: ${A(l,f-a.length)}`}return a+=" }",a}function v(h,f){let a="";for(let n=1;n<=f;n++)a+=h;return a}function w(h,f){for(;h.length<f;)h+=" ";return h}}),define(Se[171],De([1,0,165,169,170]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$3d=e.$Zd=e.$Ud=e.$Td=void 0,e.$Qd=N,e.$Rd=m,e.$Sd=A,e.$Vd=v,e.$Wd=h,e.$Xd=f,e.$Yd=a,e.$1d=i,e.$2d=l,e.$4d=t;let R;function N(r){R=r}let p;function m(r){p=r}let k;function A(r){k=r}class C{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,s){const y=s===void 0?void 0:c,b=s===void 0?c:s;return k({owner:y,debugName:()=>{const S=(0,O.$cd)(b);if(S!==void 0)return S;const E=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(b.toString());if(E)return`${this.debugName}.${E[2]}`;if(!y)return`${this.debugName} (mapped)`},debugReferenceFn:b},S=>b(this.read(S),S))}recomputeInitiallyAndOnChange(c,s){return c.add(R(this,s)),this}keepObserved(c){return c.add(p(this)),this}get a(){return this.get()}}e.$Td=C;class $ extends C{constructor(){super(...arguments),this.b=new Set}addObserver(c){const s=this.b.size;this.b.add(c),s===0&&this.c()}removeObserver(c){this.b.delete(c)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Ud=$;function v(r,c){const s=new n(r,c);try{r(s)}finally{s.finish()}}let w;function h(r){if(w)r(w);else{const c=new n(r,void 0);w=c;try{r(c)}finally{c.finish(),w=void 0}}}async function f(r,c){const s=new n(r,c);try{await r(s)}finally{s.finish()}}function a(r,c,s){r?c(r):v(c,s)}class n{constructor(c,s){this._fn=c,this.b=s,this.a=[],(0,L.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(c,s){this.a.push({observer:c,observable:s}),c.beginUpdate(s)}finish(){const c=this.a;for(let s=0;s<c.length;s++){const{observer:y,observable:b}=c[s];y.endUpdate(b)}this.a=null,(0,L.$Id)()?.handleEndTransaction()}}e.$Zd=n;function i(r,c){let s;return typeof r=="string"?s=new O.$ad(void 0,r,void 0):s=new O.$ad(r,void 0,void 0),new o(s,c,d.$6c)}function l(r,c){return new o(new O.$ad(r.owner,r.debugName,void 0),c,r.equalsFn??d.$6c)}class o extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(c,s,y){super(),this.e=c,this.g=y,this.d=s}get(){return this.d}set(c,s,y){if(this.g(this.d,c))return;let b;s||(s=b=new n(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(c),(0,L.$Id)()?.handleObservableChanged(this,{oldValue:S,newValue:c,change:y,didChange:!0,hadValue:!0});for(const g of this.b)s.updateObserver(g,this),g.handleChange(this,y)}finally{b&&b.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(c){this.d=c}}e.$3d=o;function t(r,c){let s;return typeof r=="string"?s=new O.$ad(void 0,r,void 0):s=new O.$ad(r,void 0,void 0),new u(s,c,d.$6c)}class u extends o{h(c){this.d!==c&&(this.d&&this.d.dispose(),this.d=c)}dispose(){this.d?.dispose()}}e.$5d=u}),function(){function he(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function N(m){R.push(m,Date.now())}function p(){const m=[];for(let k=0;k<R.length;k+=2)m.push({name:R[k],startTime:R[k+1]});return m}return{mark:N,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const N of performance.getEntriesByType("mark"))R.push({name:N.name,startTime:Math.round(L+N.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function d(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=d(O))}(),define(Se[172],De([1,0,39]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=void 0;const O=Symbol("unset");class L{constructor(){this.a=new N,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||d.Iterable.empty()}insert(m,k,A){this.d(m,C=>C._value=k,A)}mutate(m,k){this.d(m,A=>A._value=k(A._value===O?void 0:A._value))}delete(m){const k=this.c(m);if(!k)return;let A=k.length-1;const C=k[A].node._value;if(C!==O){for(this.b--,k[A].node._value=O;A>0;A--){const{node:$,part:v}=k[A];if($.children?.size||$._value!==O)break;k[A-1].node.children.delete(v)}return C}}*deleteRecursive(m){const k=this.c(m);if(!k)return;const A=k[k.length-1].node;for(let C=k.length-1;C>0;C--){const $=k[C-1];if($.node.children.delete(k[C].part),$.node.children.size>0||$.node._value!==O)break}for(const C of R(A))C._value!==O&&(this.b--,yield C._value)}find(m){let k=this.a;for(const A of m){const C=k.children?.get(A);if(!C)return;k=C}return k._value===O?void 0:k._value}hasKeyOrParent(m){let k=this.a;for(const A of m){const C=k.children?.get(A);if(!C)return!1;if(C._value!==O)return!0;k=C}return!1}hasKeyOrChildren(m){let k=this.a;for(const A of m){const C=k.children?.get(A);if(!C)return!1;k=C}return!0}hasKey(m){let k=this.a;for(const A of m){const C=k.children?.get(A);if(!C)return!1;k=C}return k._value!==O}c(m){const k=[{part:"",node:this.a}];let A=0;for(const C of m){const $=k[A].node.children?.get(C);if(!$)return;k.push({part:C,node:$}),A++}return k}d(m,k,A){let C=this.a;for(const w of m){if(C.children)if(C.children.has(w))C=C.children.get(w);else{const h=new N;C.children.set(w,h),C=h}else{const h=new N;C.children=new Map([[w,h]]),C=h}A?.(C)}const $=C._value===O?0:1;k(C);const v=C._value===O?0:1;this.b+=v-$}*values(){for(const{_value:m}of R(this.a))m!==O&&(yield m)}}e.$oP=L;function*R(p){const m=[p];for(;m.length>0;){const k=m.pop();if(yield k,k.children)for(const A of k.children.values())m.push(A)}}class N{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var d=e();for(var O in d)(typeof exports=="object"?exports:he)[O]=d[O]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function d(O){if(e[O])return e[O].exports;var L=e[O]={i:O,l:!1,exports:{}};return he[O].call(L.exports,L,L.exports,d),L.l=!0,L.exports}return d.m=he,d.c=e,d.d=function(O,L,R){d.o(O,L)||Object.defineProperty(O,L,{enumerable:!0,get:R})},d.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},d.t=function(O,L){if(1&L&&(O=d(O)),8&L||4&L&&typeof O=="object"&&O&&O.__esModule)return O;var R=Object.create(null);if(d.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:O}),2&L&&typeof O!="string")for(var N in O)d.d(R,N,function(p){return O[p]}.bind(null,N));return R},d.n=function(O){var L=O&&O.__esModule?function(){return O.default}:function(){return O};return d.d(L,"a",L),L},d.o=function(O,L){return Object.prototype.hasOwnProperty.call(O,L)},d.p="",d(d.s=0)}([function(he,e,d){(function(O){var L;e=he.exports=Ce,L=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],m=e.src=[],k=0,A=k++;m[A]="0|[1-9]\\d*";var C=k++;m[C]="[0-9]+";var $=k++;m[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;m[v]="("+m[A]+")\\.("+m[A]+")\\.("+m[A]+")";var w=k++;m[w]="("+m[C]+")\\.("+m[C]+")\\.("+m[C]+")";var h=k++;m[h]="(?:"+m[A]+"|"+m[$]+")";var f=k++;m[f]="(?:"+m[C]+"|"+m[$]+")";var a=k++;m[a]="(?:-("+m[h]+"(?:\\."+m[h]+")*))";var n=k++;m[n]="(?:-?("+m[f]+"(?:\\."+m[f]+")*))";var i=k++;m[i]="[0-9A-Za-z-]+";var l=k++;m[l]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var o=k++,t="v?"+m[v]+m[a]+"?"+m[l]+"?";m[o]="^"+t+"$";var u="[v=\\s]*"+m[w]+m[n]+"?"+m[l]+"?",r=k++;m[r]="^"+u+"$";var c=k++;m[c]="((?:<|>)?=?)";var s=k++;m[s]=m[C]+"|x|X|\\*";var y=k++;m[y]=m[A]+"|x|X|\\*";var b=k++;m[b]="[v=\\s]*("+m[y]+")(?:\\.("+m[y]+")(?:\\.("+m[y]+")(?:"+m[a]+")?"+m[l]+"?)?)?";var S=k++;m[S]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[n]+")?"+m[l]+"?)?)?";var g=k++;m[g]="^"+m[c]+"\\s*"+m[b]+"$";var E=k++;m[E]="^"+m[c]+"\\s*"+m[S]+"$";var D=k++;m[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=k++;m[P]="(?:~>?)";var I=k++;m[I]="(\\s*)"+m[P]+"\\s+",p[I]=new RegExp(m[I],"g");var F=k++;m[F]="^"+m[P]+m[b]+"$";var T=k++;m[T]="^"+m[P]+m[S]+"$";var z=k++;m[z]="(?:\\^)";var M=k++;m[M]="(\\s*)"+m[z]+"\\s+",p[M]=new RegExp(m[M],"g");var j=k++;m[j]="^"+m[z]+m[b]+"$";var U=k++;m[U]="^"+m[z]+m[S]+"$";var Z=k++;m[Z]="^"+m[c]+"\\s*("+u+")$|^$";var ie=k++;m[ie]="^"+m[c]+"\\s*("+t+")$|^$";var Q=k++;m[Q]="(\\s*)"+m[c]+"\\s*("+u+"|"+m[b]+")",p[Q]=new RegExp(m[Q],"g");var G=k++;m[G]="^\\s*("+m[b]+")\\s+-\\s+("+m[b]+")\\s*$";var x=k++;m[x]="^\\s*("+m[S]+")\\s+-\\s+("+m[S]+")\\s*$";var ne=k++;m[ne]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)L(be,m[be]),p[be]||(p[be]=new RegExp(m[be]));function ae(W,K){if(W instanceof Ce)return W;if(typeof W!="string"||W.length>R||!(K?p[r]:p[o]).test(W))return null;try{return new Ce(W,K)}catch{return null}}function Ce(W,K){if(W instanceof Ce){if(W.loose===K)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Ce))return new Ce(W,K);L("SemVer",W,K),this.loose=K;var X=W.trim().match(K?p[r]:p[o]);if(!X)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var we=+de;if(we>=0&&we<N)return we}return de}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=ae,e.valid=function(W,K){var X=ae(W,K);return X?X.version:null},e.clean=function(W,K){var X=ae(W.trim().replace(/^[=v]+/,""),K);return X?X.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof Ce||(W=new Ce(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Ce.prototype.compareMain=function(W){return W instanceof Ce||(W=new Ce(W,this.loose)),B(this.major,W.major)||B(this.minor,W.minor)||B(this.patch,W.patch)},Ce.prototype.comparePre=function(W){if(W instanceof Ce||(W=new Ce(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var K=0;do{var X=this.prerelease[K],de=W.prerelease[K];if(L("prerelease compare",K,X,de),X===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(X===void 0)return-1;if(X!==de)return B(X,de)}while(++K)},Ce.prototype.inc=function(W,K){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,K,X,de){typeof X=="string"&&(de=X,X=void 0);try{return new Ce(W,X).inc(K,de).version}catch{return null}},e.diff=function(W,K){if(ce(W,K))return null;var X=ae(W),de=ae(K);if(X.prerelease.length||de.prerelease.length){for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==de[we])return"pre"+we;return"prerelease"}for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==de[we])return we},e.compareIdentifiers=B;var ee=/^[0-9]+$/;function B(W,K){var X=ee.test(W),de=ee.test(K);return X&&de&&(W=+W,K=+K),X&&!de?-1:de&&!X?1:W<K?-1:W>K?1:0}function _(W,K,X){return new Ce(W,X).compare(new Ce(K,X))}function pe(W,K,X){return _(W,K,X)>0}function ue(W,K,X){return _(W,K,X)<0}function ce(W,K,X){return _(W,K,X)===0}function oe(W,K,X){return _(W,K,X)!==0}function le(W,K,X){return _(W,K,X)>=0}function J(W,K,X){return _(W,K,X)<=0}function se(W,K,X,de){var we;switch(K){case"===":typeof W=="object"&&(W=W.version),typeof X=="object"&&(X=X.version),we=W===X;break;case"!==":typeof W=="object"&&(W=W.version),typeof X=="object"&&(X=X.version),we=W!==X;break;case"":case"=":case"==":we=ce(W,X,de);break;case"!=":we=oe(W,X,de);break;case">":we=pe(W,X,de);break;case">=":we=le(W,X,de);break;case"<":we=ue(W,X,de);break;case"<=":we=J(W,X,de);break;default:throw new TypeError("Invalid operator: "+K)}return we}function $e(W,K){if(W instanceof $e){if(W.loose===K)return W;W=W.value}if(!(this instanceof $e))return new $e(W,K);L("comparator",W,K),this.loose=K,this.parse(W),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,K){return B(K,W)},e.major=function(W,K){return new Ce(W,K).major},e.minor=function(W,K){return new Ce(W,K).minor},e.patch=function(W,K){return new Ce(W,K).patch},e.compare=_,e.compareLoose=function(W,K){return _(W,K,!0)},e.rcompare=function(W,K,X){return _(K,W,X)},e.sort=function(W,K){return W.sort(function(X,de){return e.compare(X,de,K)})},e.rsort=function(W,K){return W.sort(function(X,de){return e.rcompare(X,de,K)})},e.gt=pe,e.lt=ue,e.eq=ce,e.neq=oe,e.gte=le,e.lte=J,e.cmp=se,e.Comparator=$e;var ve={};function Re(W,K){if(W instanceof Re)return W.loose===K?W:new Re(W.raw,K);if(W instanceof $e)return new Re(W.value,K);if(!(this instanceof Re))return new Re(W,K);if(this.loose=K,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function Ie(W,K,X,de,we,Fe,Ve,Je,tt,_e,nt,it,rt){return((K=ge(X)?"":ge(de)?">="+X+".0.0":ge(we)?">="+X+"."+de+".0":">="+K)+" "+(Je=ge(tt)?"":ge(_e)?"<"+(+tt+1)+".0.0":ge(nt)?"<"+tt+"."+(+_e+1)+".0":it?"<="+tt+"."+_e+"."+nt+"-"+it:"<="+Je)).trim()}function Ae(W,K){for(var X=0;X<W.length;X++)if(!W[X].test(K))return!1;if(K.prerelease.length){for(X=0;X<W.length;X++)if(L(W[X].semver),W[X].semver!==ve&&W[X].semver.prerelease.length>0){var de=W[X].semver;if(de.major===K.major&&de.minor===K.minor&&de.patch===K.patch)return!0}return!1}return!0}function ze(W,K,X){try{K=new Re(K,X)}catch{return!1}return K.test(W)}function V(W,K,X,de){var we,Fe,Ve,Je,tt;switch(W=new Ce(W,de),K=new Re(K,de),X){case">":we=pe,Fe=J,Ve=ue,Je=">",tt=">=";break;case"<":we=ue,Fe=le,Ve=pe,Je="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(W,K,de))return!1;for(var _e=0;_e<K.set.length;++_e){var nt=K.set[_e],it=null,rt=null;if(nt.forEach(function(at){at.semver===ve&&(at=new $e(">=0.0.0")),it=it||at,rt=rt||at,we(at.semver,it.semver,de)?it=at:Ve(at.semver,rt.semver,de)&&(rt=at)}),it.operator===Je||it.operator===tt||(!rt.operator||rt.operator===Je)&&Fe(W,rt.semver)||rt.operator===tt&&Ve(W,rt.semver))return!1}return!0}$e.prototype.parse=function(W){var K=this.loose?p[Z]:p[ie],X=W.match(K);if(!X)throw new TypeError("Invalid comparator: "+W);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new Ce(X[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===ve||(typeof W=="string"&&(W=new Ce(W,this.loose)),se(W,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(W,K){if(!(W instanceof $e))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Re(W.value,K),ze(this.value,X,K);if(W.operator==="")return X=new Re(this.value,K),ze(W.semver,X,K);var de=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Fe=this.semver.version===W.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Je=se(this.semver,"<",W.semver,K)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=se(this.semver,">",W.semver,K)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return de||we||Fe&&Ve||Je||tt},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(W){var K=this.loose;W=W.trim(),L("range",W,K);var X=K?p[x]:p[G];W=W.replace(X,Ie),L("hyphen replace",W),W=W.replace(p[Q],"$1$2$3"),L("comparator trim",W,p[Q]),W=(W=(W=W.replace(p[I],"$1~")).replace(p[M],"$1^")).split(/\s+/).join(" ");var de=K?p[Z]:p[ie],we=W.split(" ").map(function(Fe){return function(Ve,Je){return L("comp",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){L("caret",it,rt);var at=rt?p[U]:p[j];return it.replace(at,function(Ne,ye,qe,te,re){var Pe;return L("caret",it,Ne,ye,qe,te,re),ge(ye)?Pe="":ge(qe)?Pe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ge(te)?Pe=ye==="0"?">="+ye+"."+qe+".0 <"+ye+"."+(+qe+1)+".0":">="+ye+"."+qe+".0 <"+(+ye+1)+".0.0":re?(L("replaceCaret pr",re),re.charAt(0)!=="-"&&(re="-"+re),Pe=ye==="0"?qe==="0"?">="+ye+"."+qe+"."+te+re+" <"+ye+"."+qe+"."+(+te+1):">="+ye+"."+qe+"."+te+re+" <"+ye+"."+(+qe+1)+".0":">="+ye+"."+qe+"."+te+re+" <"+(+ye+1)+".0.0"):(L("no pr"),Pe=ye==="0"?qe==="0"?">="+ye+"."+qe+"."+te+" <"+ye+"."+qe+"."+(+te+1):">="+ye+"."+qe+"."+te+" <"+ye+"."+(+qe+1)+".0":">="+ye+"."+qe+"."+te+" <"+(+ye+1)+".0.0"),L("caret return",Pe),Pe})}(nt,_e)}).join(" ")}(Ve,Je),L("caret",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){var at=rt?p[T]:p[F];return it.replace(at,function(Ne,ye,qe,te,re){var Pe;return L("tilde",it,Ne,ye,qe,te,re),ge(ye)?Pe="":ge(qe)?Pe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ge(te)?Pe=">="+ye+"."+qe+".0 <"+ye+"."+(+qe+1)+".0":re?(L("replaceTilde pr",re),re.charAt(0)!=="-"&&(re="-"+re),Pe=">="+ye+"."+qe+"."+te+re+" <"+ye+"."+(+qe+1)+".0"):Pe=">="+ye+"."+qe+"."+te+" <"+ye+"."+(+qe+1)+".0",L("tilde return",Pe),Pe})}(nt,_e)}).join(" ")}(Ve,Je),L("tildes",Ve),Ve=function(tt,_e){return L("replaceXRanges",tt,_e),tt.split(/\s+/).map(function(nt){return function(it,rt){it=it.trim();var at=rt?p[E]:p[g];return it.replace(at,function(Ne,ye,qe,te,re,Pe){L("xRange",it,Ne,ye,qe,te,re,Pe);var He=ge(qe),Le=He||ge(te),st=Le||ge(re);return ye==="="&&st&&(ye=""),He?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&st?(Le&&(te=0),st&&(re=0),ye===">"?(ye=">=",Le?(qe=+qe+1,te=0,re=0):st&&(te=+te+1,re=0)):ye==="<="&&(ye="<",Le?qe=+qe+1:te=+te+1),Ne=ye+qe+"."+te+"."+re):Le?Ne=">="+qe+".0.0 <"+(+qe+1)+".0.0":st&&(Ne=">="+qe+"."+te+".0 <"+qe+"."+(+te+1)+".0"),L("xRange return",Ne),Ne})}(nt,_e)}).join(" ")}(Ve,Je),L("xrange",Ve),Ve=function(tt,_e){return L("replaceStars",tt,_e),tt.trim().replace(p[ne],"")}(Ve,Je),L("stars",Ve),Ve}(Fe,K)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Fe){return!!Fe.match(de)})),we=we.map(function(Fe){return new $e(Fe,K)})},Re.prototype.intersects=function(W,K){if(!(W instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(de){return W.set.some(function(we){return we.every(function(Fe){return de.intersects(Fe,K)})})})})},e.toComparators=function(W,K){return new Re(W,K).set.map(function(X){return X.map(function(de){return de.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Ce(W,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],W))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(W,K,X){var de=null,we=null;try{var Fe=new Re(K,X)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(de&&we.compare(Ve)!==-1||(we=new Ce(de=Ve,X)))}),de},e.minSatisfying=function(W,K,X){var de=null,we=null;try{var Fe=new Re(K,X)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(de&&we.compare(Ve)!==1||(we=new Ce(de=Ve,X)))}),de},e.validRange=function(W,K){try{return new Re(W,K).range||"*"}catch{return null}},e.ltr=function(W,K,X){return V(W,K,"<",X)},e.gtr=function(W,K,X){return V(W,K,">",X)},e.outside=V,e.prerelease=function(W,K){var X=ae(W,K);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(W,K,X){return W=new Re(W,X),K=new Re(K,X),W.intersects(K)},e.coerce=function(W){if(W instanceof Ce)return W;if(typeof W!="string")return null;var K=W.match(p[D]);return K==null?null:ae((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,d(1))},function(he,e){var d,O,L=he.exports={};function R(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function p(f){if(d===setTimeout)return setTimeout(f,0);if((d===R||!d)&&setTimeout)return d=setTimeout,setTimeout(f,0);try{return d(f,0)}catch{try{return d.call(null,f,0)}catch{return d.call(this,f,0)}}}(function(){try{d=typeof setTimeout=="function"?setTimeout:R}catch{d=R}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var m,k=[],A=!1,C=-1;function $(){A&&m&&(A=!1,m.length?k=m.concat(k):C=-1,k.length&&v())}function v(){if(!A){var f=p($);A=!0;for(var a=k.length;a;){for(m=k,k=[];++C<a;)m&&m[C].run();C=-1,a=k.length}m=null,A=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(f)}}function w(f,a){this.fun=f,this.array=a}function h(){}L.nextTick=function(f){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];k.push(new w(f,a)),k.length!==1||A||p(v)},w.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=h,L.addListener=h,L.once=h,L.off=h,L.removeListener=h,L.removeAllListeners=h,L.emit=h,L.prependListener=h,L.prependOnceListener=h,L.listeners=function(f){return[]},L.binding=function(f){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(f){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Se[40],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0;const d=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(R){return new O(R)}constructor(R){this.c=d&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$_d=O}),define(Se[4],De([1,0,13,75,3,76,40]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$be=e.Event=void 0,e.$ce=v;const p=!1,m=!1,k=!1;var A;(function(I){I.None=()=>L.$Uc.None;function F(Re){if(k){const{onDidAddListener:ge}=Re,Ie=h.create();let Ae=0;Re.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ie.print()),ge?.()}}}function T(Re,ge){return ne(Re,()=>{},0,void 0,!0,void 0,ge)}I.defer=T;function z(Re){return(ge,Ie=null,Ae)=>{let ze=!1,V;return V=Re(W=>{if(!ze)return V?V.dispose():ze=!0,ge.call(Ie,W)},null,Ae),ze&&V.dispose(),V}}I.once=z;function M(Re,ge,Ie){return G((Ae,ze=null,V)=>Re(W=>Ae.call(ze,ge(W)),null,V),Ie)}I.map=M;function j(Re,ge,Ie){return G((Ae,ze=null,V)=>Re(W=>{ge(W),Ae.call(ze,W)},null,V),Ie)}I.forEach=j;function U(Re,ge,Ie){return G((Ae,ze=null,V)=>Re(W=>ge(W)&&Ae.call(ze,W),null,V),Ie)}I.filter=U;function Z(Re){return Re}I.signal=Z;function ie(...Re){return(ge,Ie=null,Ae)=>{const ze=(0,L.$Rc)(...Re.map(V=>V(W=>ge.call(Ie,W))));return x(ze,Ae)}}I.any=ie;function Q(Re,ge,Ie,Ae){let ze=Ie;return M(Re,V=>(ze=ge(ze,V),ze),Ae)}I.reduce=Q;function G(Re,ge){let Ie;const Ae={onWillAddFirstListener(){Ie=Re(ze.fire,ze)},onDidRemoveLastListener(){Ie?.dispose()}};ge||F(Ae);const ze=new o(Ae);return ge?.add(ze),ze.event}function x(Re,ge){return ge instanceof Array?ge.push(Re):ge&&ge.add(Re),Re}function ne(Re,ge,Ie=100,Ae=!1,ze=!1,V,W){let K,X,de,we=0,Fe;const Ve={leakWarningThreshold:V,onWillAddFirstListener(){K=Re(tt=>{we++,X=ge(X,tt),Ae&&!de&&(Je.fire(X),X=void 0),Fe=()=>{const _e=X;X=void 0,de=void 0,(!Ae||we>1)&&Je.fire(_e),we=0},typeof Ie=="number"?(clearTimeout(de),de=setTimeout(Fe,Ie)):de===void 0&&(de=0,queueMicrotask(Fe))})},onWillRemoveListener(){ze&&we>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,K.dispose()}};W||F(Ve);const Je=new o(Ve);return W?.add(Je),Je.event}I.debounce=ne;function be(Re,ge=0,Ie){return I.debounce(Re,(Ae,ze)=>Ae?(Ae.push(ze),Ae):[ze],ge,void 0,!0,void 0,Ie)}I.accumulate=be;function ae(Re,ge=(Ae,ze)=>Ae===ze,Ie){let Ae=!0,ze;return U(Re,V=>{const W=Ae||!ge(V,ze);return Ae=!1,ze=V,W},Ie)}I.latch=ae;function Ce(Re,ge,Ie){return[I.filter(Re,ge,Ie),I.filter(Re,Ae=>!ge(Ae),Ie)]}I.split=Ce;function ee(Re,ge=!1,Ie=[],Ae){let ze=Ie.slice(),V=Re(X=>{ze?ze.push(X):K.fire(X)});Ae&&Ae.add(V);const W=()=>{ze?.forEach(X=>K.fire(X)),ze=null},K=new o({onWillAddFirstListener(){V||(V=Re(X=>K.fire(X)),Ae&&Ae.add(V))},onDidAddFirstListener(){ze&&(ge?setTimeout(W):W())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return Ae&&Ae.add(K),K.event}I.buffer=ee;function B(Re,ge){return(Ae,ze,V)=>{const W=ge(new pe);return Re(function(K){const X=W.evaluate(K);X!==_&&Ae.call(ze,X)},void 0,V)}}I.chain=B;const _=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(Ie=>(ge(Ie),Ie)),this}filter(ge){return this.f.push(Ie=>ge(Ie)?Ie:_),this}reduce(ge,Ie){let Ae=Ie;return this.f.push(ze=>(Ae=ge(Ae,ze),Ae)),this}latch(ge=(Ie,Ae)=>Ie===Ae){let Ie=!0,Ae;return this.f.push(ze=>{const V=Ie||!ge(ze,Ae);return Ie=!1,Ae=ze,V?ze:_}),this}evaluate(ge){for(const Ie of this.f)if(ge=Ie(ge),ge===_)break;return ge}}function ue(Re,ge,Ie=Ae=>Ae){const Ae=(...K)=>W.fire(Ie(...K)),ze=()=>Re.on(ge,Ae),V=()=>Re.removeListener(ge,Ae),W=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:V});return W.event}I.fromNodeEventEmitter=ue;function ce(Re,ge,Ie=Ae=>Ae){const Ae=(...K)=>W.fire(Ie(...K)),ze=()=>Re.addEventListener(ge,Ae),V=()=>Re.removeEventListener(ge,Ae),W=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:V});return W.event}I.fromDOMEventEmitter=ce;function oe(Re){return new Promise(ge=>z(Re)(ge))}I.toPromise=oe;function le(Re){const ge=new o;return Re.then(Ie=>{ge.fire(Ie)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}I.fromPromise=le;function J(Re,ge,Ie){return ge(Ie),Re(Ae=>ge(Ae))}I.runAndSubscribe=J;class se{constructor(ge,Ie){this._observable=ge,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};Ie||F(Ae),this.emitter=new o(Ae),Ie&&Ie.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,Ie){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(Re,ge){return new se(Re,ge).emitter.event}I.fromObservable=$e;function ve(Re){return(ge,Ie,Ae)=>{let ze=0,V=!1;const W={beginUpdate(){ze++},endUpdate(){ze--,ze===0&&(Re.reportChanges(),V&&(V=!1,ge.call(Ie)))},handlePossibleChange(){},handleChange(){V=!0}};Re.addObserver(W),Re.reportChanges();const K={dispose(){Re.removeObserver(W)}};return Ae instanceof L.$Tc?Ae.add(K):Array.isArray(Ae)&&Ae.push(K),K}}I.fromObservableLight=ve})(A||(e.Event=A={}));class C{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${C.f++}`,C.all.add(this)}start(F){this.g=new N.$_d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$be=C;let $=-1;function v(I){const F=$;return $=I,{dispose(){$=F}}}class w{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const z=this.threshold;if(z<=0||T<z)return;this.f||(this.f=new Map);const M=this.f.get(F.value)||0;if(this.f.set(F.value,M+1),this.g-=1,this.g<=0){this.g=z*.5;let j,U=0;for(const[Z,ie]of this.f)(!j||U<ie)&&(j=Z,U=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${U}):`),console.warn(j)}return()=>{const j=this.f.get(F.value)||0;this.f.set(F.value,j-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class a{constructor(F){this.value=F,this.id=f++}}const n=2,i=(I,F)=>{if(I instanceof a)F(I);else for(let T=0;T<I.length;T++){const z=I[T];z&&F(z)}},l=p?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class o{constructor(F){this.w=0,this.f=F,this.g=$>0||this.f?.leakWarningThreshold?new w(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const F=this.t;queueMicrotask(()=>{i(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;T&&(F=F.bind(T));const M=new a(F);let j,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(M.stack=h.create(),j=this.g.check(M.stack,this.w+1)),m&&(M.stack=U??h.create()),this.t?this.t instanceof a?(this.u??=new u,this.t=[this.t,M]):this.t.push(M):(this.f?.onWillAddFirstListener?.(this),this.t=M,this.f?.onDidAddFirstListener?.(this)),this.w++;const Z=(0,L.$Sc)(()=>{l?.unregister(Z),j?.(),this.x(M)});if(z instanceof L.$Tc?z.add(Z):Array.isArray(z)&&z.push(Z),l){const ie=new Error().stack.split(`
`).slice(2).join(`
`).trim();l.register(Z,ie,Z)}return Z},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,z=T.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[z]=void 0;const M=this.u.current===this;if(this.w*n<=T.length){let j=0;for(let U=0;U<T.length;U++)T[U]?T[j++]=T[U]:M&&(this.u.end--,j<this.u.i&&this.u.i--);T.length=j}}y(F,T){if(!F)return;const z=this.f?.onListenerError||d.$1;if(!z){F.value(T);return}try{F.value(T)}catch(M){z(M)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$de=o;const t=()=>new u;e.$ee=t;class u{constructor(){this.i=-1,this.end=0}enqueue(F,T,z){this.i=0,this.end=z,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends o{async fireAsync(F,T,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,M=>this.h.push([M.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[M,j]=this.h.shift(),U=[],Z={...j,token:T,waitUntil:ie=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");z&&(ie=z(ie,M)),U.push(ie)}};try{M(Z)}catch(ie){(0,d.$1)(ie);continue}Object.freeze(U),await Promise.allSettled(U).then(ie=>{for(const Q of ie)Q.status==="rejected"&&(0,d.$1)(Q.reason)})}}}e.$fe=r;class c extends o{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ge=c;class s extends c{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$he=s;class y extends o{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ie=y;class b{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const z=()=>{this.g&&this.o(T);const M=this.h.indexOf(T);this.h.splice(M,1)};return(0,L.$Sc)((0,O.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$je=b;class S{constructor(F,T,z,M){this.f=new L.$Tc;const j=this.f.add(new b),U=this.f.add(new L.$4c);function Z(ie){U.set(ie,j.add(M(ie)))}for(const ie of F)Z(ie);this.f.add(T(ie=>{Z(ie)})),this.f.add(z(ie=>{U.deleteAndDispose(ie)})),this.event=j.event}dispose(){this.f.dispose()}}e.$ke=S;class g{constructor(){this.f=[]}wrapEvent(F){return(T,z,M)=>F(j=>{const U=this.f[this.f.length-1];U?U.push(()=>T.call(z,j)):T.call(z,j)},void 0,M)}bufferEvents(F){const T=[];this.f.push(T);const z=F();return this.f.pop(),T.forEach(M=>M()),z}}e.$le=g;class E{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$me=E;class D{static const(F){return new P(F)}constructor(F){this.g=F,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ne=D;class P{constructor(F){this.value=F,this.onDidChange=A.None}}}),define(Se[22],De([1,0,4]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.CancellationToken=void 0,e.$pe=p;const O=Object.freeze(function(m,k){const A=setTimeout(m.bind(k),0);return{dispose(){clearTimeout(A)}}});var L;(function(m){function k(A){return A===m.None||A===m.Cancelled||A instanceof R?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}m.isCancellationToken=k,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new d.$de),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$oe=N;function p(m){const k=new N;return m.add({dispose(){k.cancel()}}),k.token}}),define(Se[173],De([1,0,22]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=L;class O{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new d.$oe,k=this.b(m.token);return this.a={promise:k,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$1e=O;function L(p){return p}class R{constructor(m,k){this.a=void 0,this.b=void 0,typeof m=="function"?(this.c=m,this.d=L):(this.c=k,this.d=m.getCacheKey)}get(m){const k=this.d(m);return this.b!==k&&(this.b=k,this.a=this.c(m)),this.a}}e.$3e=R;class N{get cachedValues(){return this.a}constructor(m,k){this.a=new Map,this.b=new Map,typeof m=="function"?(this.c=m,this.d=L):(this.c=k,this.d=m.getCacheKey)}get(m){const k=this.d(m);if(this.b.has(k))return this.b.get(k);const A=this.c(m);return this.a.set(m,A),this.b.set(k,A),A}}e.$4e=N}),define(Se[98],De([1,0,13,3]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=L,e.$re=R,e.$se=N,e.$te=p,e.$ue=k,e.$ve=A,e.$we=C,e.$xe=$,e.$ye=v,e.$ze=w,e.$Ae=h,e.$Be=f,e.$Ce=a,e.$De=n,e.$Ee=i;function L(l){const o=l;return o?typeof o.read=="function":!1}function R(l){const o=l;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function N(l){const o=l;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function p(l,o){return new m(l,o)}class m{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,d.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let u;switch(o){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const r=u.indexOf(t);r>=0&&u.splice(r,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(l,o){const t=[];let u;for(;(u=l.read())!==null;)t.push(u);return o(t)}function A(l,o,t){const u=[];let r;for(;(r=l.read())!==null&&u.length<t;)u.push(r);return r===null&&u.length>0?o(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return l.read()}}}function C(l,o){return new Promise((t,u)=>{const r=[];$(l,{onData:c=>{o&&r.push(c)},onError:c=>{o?u(c):t(void 0)},onEnd:()=>{t(o?o(r):void 0)}})})}function $(l,o,t){l.on("error",u=>{t?.isCancellationRequested||o.onError(u)}),l.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),l.on("data",u=>{t?.isCancellationRequested||o.onData(u)})}function v(l,o){return new Promise((t,u)=>{const r=new O.$Tc,c=[],s=S=>{if(c.push(S),c.length>o)return r.dispose(),l.pause(),t({stream:l,buffer:c,ended:!1})},y=S=>(r.dispose(),u(S)),b=()=>(r.dispose(),t({stream:l,buffer:c,ended:!0}));r.add((0,O.$Sc)(()=>l.removeListener("error",y))),l.on("error",y),r.add((0,O.$Sc)(()=>l.removeListener("end",b))),l.on("end",b),r.add((0,O.$Sc)(()=>l.removeListener("data",s))),l.on("data",s)})}function w(l,o){const t=p(o);return t.end(l),t}function h(){const l=p(()=>{throw new Error("not supported")});return l.end(),l}function f(l){let o=!1;return{read:()=>o?null:(o=!0,l)}}function a(l,o,t){const u=p(t);return $(l,{onData:r=>u.write(o.data(r)),onError:r=>u.error(o.error?o.error(r):r),onEnd:()=>u.end()}),u}function n(l,o,t){let u=!1;return{read:()=>{const r=o.read();return u?r:(u=!0,r!==null?t([l,r]):l)}}}function i(l,o,t){let u=!1;const r=p(t);return $(o,{onData:c=>u?r.write(c):(u=!0,r.write(t([l,c]))),onError:c=>r.error(c),onEnd:()=>{u||(u=!0,r.write(l)),r.end()}}),r}}),define(Se[21],De([1,0,46,98]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=k,e.$He=A,e.$Ie=C,e.$Je=$,e.$Ke=v,e.$Le=w,e.$Me=h,e.$Ne=f,e.$Oe=a,e.$Pe=n,e.$Qe=i,e.$Re=l,e.$Se=o,e.$Te=t,e.$Ue=u,e.$Ve=r,e.$We=c,e.$Xe=s,e.$Ye=y,e.$Ze=g;const L=typeof Buffer<"u",R=new d.$V(()=>new Uint8Array(256));let N,p;class m{static alloc(D){return L?new m(Buffer.allocUnsafe(D)):new m(new Uint8Array(D))}static wrap(D){return L&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new m(D)}static fromString(D,P){return!(P?.dontUseNodeBuffer||!1)&&L?new m(Buffer.from(D)):(N||(N=new TextEncoder),new m(N.encode(D)))}static fromByteArray(D){const P=m.alloc(D.length);for(let I=0,F=D.length;I<F;I++)P.buffer[I]=D[I];return P}static concat(D,P){if(typeof P>"u"){P=0;for(let T=0,z=D.length;T<z;T++)P+=D[T].byteLength}const I=m.alloc(P);let F=0;for(let T=0,z=D.length;T<z;T++){const M=D[T];I.set(M,F),F+=M.byteLength}return I}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=m.alloc(this.byteLength);return D.set(this),D}toString(){return L?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(D,P){return new m(this.buffer.subarray(D,P))}set(D,P){if(D instanceof m)this.buffer.set(D.buffer,P);else if(D instanceof Uint8Array)this.buffer.set(D,P);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),P);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return $(this.buffer,D)}writeUInt32BE(D,P){v(this.buffer,D,P)}readUInt32LE(D){return w(this.buffer,D)}writeUInt32LE(D,P){h(this.buffer,D,P)}readUInt8(D){return f(this.buffer,D)}writeUInt8(D,P){a(this.buffer,D,P)}indexOf(D,P=0){return k(this.buffer,D instanceof m?D.buffer:D,P)}}e.$Fe=m;function k(E,D,P=0){const I=D.byteLength,F=E.byteLength;if(I===0)return 0;if(I===1)return E.indexOf(D[0]);if(I>F-P)return-1;const T=R.value;T.fill(D.length);for(let U=0;U<D.length;U++)T[D[U]]=D.length-U-1;let z=P+D.length-1,M=z,j=-1;for(;z<F;)if(E[z]===D[M]){if(M===0){j=z;break}z--,M--}else z+=Math.max(D.length-M,T[E[z]]),M=D.length-1;return j}function A(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}function C(E,D,P){E[P+0]=D&255,D=D>>>8,E[P+1]=D&255}function $(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}function v(E,D,P){E[P+3]=D,D=D>>>8,E[P+2]=D,D=D>>>8,E[P+1]=D,D=D>>>8,E[P]=D}function w(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}function h(E,D,P){E[P+0]=D&255,D=D>>>8,E[P+1]=D&255,D=D>>>8,E[P+2]=D&255,D=D>>>8,E[P+3]=D&255}function f(E,D){return E[D]}function a(E,D,P){E[P]=D}function n(E){return O.$ue(E,D=>m.concat(D))}function i(E){return O.$Be(E)}function l(E){return O.$we(E,D=>m.concat(D))}async function o(E){return E.ended?m.concat(E.buffer):m.concat([...E.buffer,await l(E.stream)])}function t(E){return O.$ze(E,D=>m.concat(D))}function u(E){return O.$Ce(E,{data:D=>typeof D=="string"?m.fromString(D):m.wrap(D)},D=>m.concat(D))}function r(E){return O.$te(D=>m.concat(D),E)}function c(E,D){return O.$De(E,D,P=>m.concat(P))}function s(E,D){return O.$Ee(E,D,P=>m.concat(P))}function y(E){let D=0,P=0,I=0;const F=new Uint8Array(Math.floor(E.length/4*3)),T=M=>{switch(P){case 3:F[I++]=D|M,P=0;break;case 2:F[I++]=D|M>>>2,D=M<<6,P=3;break;case 1:F[I++]=D|M>>>4,D=M<<4,P=2;break;default:D=M<<2,P=1}};for(let M=0;M<E.length;M++){const j=E.charCodeAt(M);if(j>=65&&j<=90)T(j-65);else if(j>=97&&j<=122)T(j-97+26);else if(j>=48&&j<=57)T(j-48+52);else if(j===43||j===45)T(62);else if(j===47||j===95)T(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${E[M]}`)}}const z=I;for(;P>0;)T(0);return m.wrap(F).slice(0,z)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:E},D=!0,P=!1){const I=P?S:b;let F="";const T=E.byteLength%3;let z=0;for(;z<E.byteLength-T;z+=3){const M=E[z+0],j=E[z+1],U=E[z+2];F+=I[M>>>2],F+=I[(M<<4|j>>>4)&63],F+=I[(j<<2|U>>>6)&63],F+=I[U&63]}if(T===1){const M=E[z+0];F+=I[M>>>2],F+=I[M<<4&63],D&&(F+="==")}else if(T===2){const M=E[z+0],j=E[z+1];F+=I[M>>>2],F+=I[(M<<4|j>>>4)&63],F+=I[j<<2&63],D&&(F+="=")}return F}}),define(Se[14],De([1,0,173,46]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=L,e.$8e=N,e.$9e=m,e.$0e=k,e.$$e=A,e.$_e=C,e.$af=$,e.$bf=v,e.$cf=w,e.$df=h,e.$ef=f,e.$ff=a,e.$gf=n,e.$hf=i,e.$if=l,e.$jf=o,e.$kf=t,e.$lf=u,e.$mf=r,e.$nf=c,e.$of=s,e.$pf=y,e.$qf=b,e.$rf=S,e.$sf=g,e.$tf=E,e.$uf=D,e.$vf=P,e.$wf=I,e.$xf=F,e.$yf=T,e.$zf=z,e.$Af=M,e.$Bf=j,e.$Cf=U,e.$Df=Z,e.$Ef=ie,e.$Hf=ne,e.$If=be,e.$Jf=ae,e.$Kf=Ce,e.$Lf=_,e.$Mf=ue,e.$Of=ce,e.$Pf=oe,e.$Qf=le,e.$Rf=J,e.$Sf=$e,e.$Tf=ve,e.$Uf=ge,e.$Wf=Ie,e.$Xf=Ae,e.$Yf=ze,e.$Zf=V,e.$1f=W,e.$2f=K,e.$3f=X,e.$4f=de,e.$5f=tt;function L(Ne){return!Ne||typeof Ne!="string"?!0:Ne.trim().length===0}const R=/{(\d+)}/g;function N(Ne,...ye){return ye.length===0?Ne:Ne.replace(R,function(qe,te){const re=parseInt(te,10);return isNaN(re)||re<0||re>=ye.length?qe:ye[re]})}const p=/{([^}]+)}/g;function m(Ne,ye){return Object.keys(ye).length===0?Ne:Ne.replace(p,(qe,te)=>ye[te]??qe)}function k(Ne){return Ne.replace(/[<>"'&]/g,ye=>{switch(ye){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ye})}function A(Ne){return Ne.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}function C(Ne){return Ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function $(Ne,ye){let qe=0,te=Ne.indexOf(ye);for(;te!==-1;)qe++,te=Ne.indexOf(ye,te+ye.length);return qe}function v(Ne,ye,qe="\u2026"){return Ne.length<=ye?Ne:`${Ne.substr(0,ye)}${qe}`}function w(Ne,ye,qe="\u2026"){if(Ne.length<=ye)return Ne;const te=Math.ceil(ye/2)-qe.length/2,re=Math.floor(ye/2)-qe.length/2;return`${Ne.substr(0,te)}${qe}${Ne.substr(Ne.length-re)}`}function h(Ne,ye=" "){const qe=f(Ne,ye);return a(qe,ye)}function f(Ne,ye){if(!Ne||!ye)return Ne;const qe=ye.length;if(qe===0||Ne.length===0)return Ne;let te=0;for(;Ne.indexOf(ye,te)===te;)te=te+qe;return Ne.substring(te)}function a(Ne,ye){if(!Ne||!ye)return Ne;const qe=ye.length,te=Ne.length;if(qe===0||te===0)return Ne;let re=te,Pe=-1;for(;Pe=Ne.lastIndexOf(ye,re-1),!(Pe===-1||Pe+qe!==re);){if(Pe===0)return"";re=Pe}return Ne.substring(0,re)}function n(Ne){return Ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ne){return Ne.replace(/\*/g,"")}function l(Ne,ye,qe={}){if(!Ne)throw new Error("Cannot create regex from empty string");ye||(Ne=C(Ne)),qe.wholeWord&&(/\B/.test(Ne.charAt(0))||(Ne="\\b"+Ne),/\B/.test(Ne.charAt(Ne.length-1))||(Ne=Ne+"\\b"));let te="";return qe.global&&(te+="g"),qe.matchCase||(te+="i"),qe.multiline&&(te+="m"),qe.unicode&&(te+="u"),new RegExp(Ne,te)}function o(Ne){return Ne.source==="^"||Ne.source==="^$"||Ne.source==="$"||Ne.source==="^\\s*$"?!1:!!(Ne.exec("")&&Ne.lastIndex===0)}function t(Ne){return Ne.split(/\r\n|\r|\n/)}function u(Ne){const ye=[],qe=Ne.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(qe.length/2);te++)ye.push(qe[2*te]+(qe[2*te+1]??""));return ye}function r(Ne){for(let ye=0,qe=Ne.length;ye<qe;ye++){const te=Ne.charCodeAt(ye);if(te!==32&&te!==9)return ye}return-1}function c(Ne,ye=0,qe=Ne.length){for(let te=ye;te<qe;te++){const re=Ne.charCodeAt(te);if(re!==32&&re!==9)return Ne.substring(ye,te)}return Ne.substring(ye,qe)}function s(Ne,ye=Ne.length-1){for(let qe=ye;qe>=0;qe--){const te=Ne.charCodeAt(qe);if(te!==32&&te!==9)return qe}return-1}function y(Ne,ye,qe){const te=[];let re=0;for(const Pe of Ne.matchAll(ye)){if(te.push(Ne.slice(re,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");re=Pe.index+Pe[0].length,te.push(qe(Pe[0],...Pe.slice(1),Pe.index,Ne,Pe.groups))}return te.push(Ne.slice(re)),Promise.all(te).then(Pe=>Pe.join(""))}function b(Ne,ye){return Ne<ye?-1:Ne>ye?1:0}function S(Ne,ye,qe=0,te=Ne.length,re=0,Pe=ye.length){for(;qe<te&&re<Pe;qe++,re++){const st=Ne.charCodeAt(qe),ut=ye.charCodeAt(re);if(st<ut)return-1;if(st>ut)return 1}const He=te-qe,Le=Pe-re;return He<Le?-1:He>Le?1:0}function g(Ne,ye){return E(Ne,ye,0,Ne.length,0,ye.length)}function E(Ne,ye,qe=0,te=Ne.length,re=0,Pe=ye.length){for(;qe<te&&re<Pe;qe++,re++){let st=Ne.charCodeAt(qe),ut=ye.charCodeAt(re);if(st===ut)continue;if(st>=128||ut>=128)return S(Ne.toLowerCase(),ye.toLowerCase(),qe,te,re,Pe);P(st)&&(st-=32),P(ut)&&(ut-=32);const mt=st-ut;if(mt!==0)return mt}const He=te-qe,Le=Pe-re;return He<Le?-1:He>Le?1:0}function D(Ne){return Ne>=48&&Ne<=57}function P(Ne){return Ne>=97&&Ne<=122}function I(Ne){return Ne>=65&&Ne<=90}function F(Ne,ye){return Ne.length===ye.length&&E(Ne,ye)===0}function T(Ne,ye){const qe=ye.length;return ye.length>Ne.length?!1:E(Ne,ye,0,qe)===0}function z(Ne,ye){const qe=Math.min(Ne.length,ye.length);let te;for(te=0;te<qe;te++)if(Ne.charCodeAt(te)!==ye.charCodeAt(te))return te;return qe}function M(Ne,ye){const qe=Math.min(Ne.length,ye.length);let te;const re=Ne.length-1,Pe=ye.length-1;for(te=0;te<qe;te++)if(Ne.charCodeAt(re-te)!==ye.charCodeAt(Pe-te))return te;return qe}function j(Ne){return 55296<=Ne&&Ne<=56319}function U(Ne){return 56320<=Ne&&Ne<=57343}function Z(Ne,ye){return(Ne-55296<<10)+(ye-56320)+65536}function ie(Ne,ye,qe){const te=Ne.charCodeAt(qe);if(j(te)&&qe+1<ye){const re=Ne.charCodeAt(qe+1);if(U(re))return Z(te,re)}return te}function Q(Ne,ye){const qe=Ne.charCodeAt(ye-1);if(U(qe)&&ye>1){const te=Ne.charCodeAt(ye-2);if(j(te))return Z(te,qe)}return qe}class G{get offset(){return this.e}constructor(ye,qe=0){this.c=ye,this.d=ye.length,this.e=qe}setOffset(ye){this.e=ye}prevCodePoint(){const ye=Q(this.c,this.e);return this.e-=ye>=65536?2:1,ye}nextCodePoint(){const ye=ie(this.c,this.d,this.e);return this.e+=ye>=65536?2:1,ye}eol(){return this.e>=this.d}}e.$Ff=G;class x{get offset(){return this.c.offset}constructor(ye,qe=0){this.c=new G(ye,qe)}nextGraphemeLength(){const ye=Ve.getInstance(),qe=this.c,te=qe.offset;let re=ye.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const Pe=qe.offset,He=ye.getGraphemeBreakType(qe.nextCodePoint());if(we(re,He)){qe.setOffset(Pe);break}re=He}return qe.offset-te}prevGraphemeLength(){const ye=Ve.getInstance(),qe=this.c,te=qe.offset;let re=ye.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const Pe=qe.offset,He=ye.getGraphemeBreakType(qe.prevCodePoint());if(we(He,re)){qe.setOffset(Pe);break}re=He}return te-qe.offset}eol(){return this.c.eol()}}e.$Gf=x;function ne(Ne,ye){return new x(Ne,ye).nextGraphemeLength()}function be(Ne,ye){return new x(Ne,ye).prevGraphemeLength()}function ae(Ne,ye){ye>0&&U(Ne.charCodeAt(ye))&&ye--;const qe=ye+ne(Ne,ye);return[qe-be(Ne,qe),qe]}function Ce(Ne){const ye=new x(Ne);let qe=0;for(;!ye.eol();)qe++,ye.nextGraphemeLength();return qe}let ee;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Ne){return ee||(ee=B()),ee.test(Ne)}const pe=/^[\t\n\r\x20-\x7E]*$/;function ue(Ne){return pe.test(Ne)}e.$Nf=/[\u2028\u2029]/;function ce(Ne){return e.$Nf.test(Ne)}function oe(Ne){return Ne>=11904&&Ne<=55215||Ne>=63744&&Ne<=64255||Ne>=65281&&Ne<=65374}function le(Ne){return Ne>=127462&&Ne<=127487||Ne===8986||Ne===8987||Ne===9200||Ne===9203||Ne>=9728&&Ne<=10175||Ne===11088||Ne===11093||Ne>=127744&&Ne<=128591||Ne>=128640&&Ne<=128764||Ne>=128992&&Ne<=129008||Ne>=129280&&Ne<=129535||Ne>=129648&&Ne<=129782}function J(Ne,ye,qe=""){const te=Ne.trimStart();if(te.length<ye)return te;const re=/\b/g;let Pe=0;for(;re.test(te)&&!(te.length-re.lastIndex<ye);)Pe=re.lastIndex,re.lastIndex+=1;return Pe===0?te:qe+te.substring(Pe).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(Ne){let ye=0;for(const qe of Ne.matchAll(se))ye!==qe.index&&(yield{isCode:!1,str:Ne.substring(ye,qe.index)}),yield{isCode:!0,str:qe[0]},ye=qe.index+qe[0].length;ye!==Ne.length&&(yield{isCode:!1,str:Ne.substring(ye)})}function ve(Ne){return Ne&&(Ne=Ne.replace(se,"")),Ne}const Re=/\\\[.*?\\\]/g;function ge(Ne){return ve(Ne).replace(Re,"")}e.$Vf="\uFEFF";function Ie(Ne){return!!(Ne&&Ne.length>0&&Ne.charCodeAt(0)===65279)}function Ae(Ne){return Ie(Ne)?Ne.substr(1):Ne}function ze(Ne,ye){if(!Ne||!ye||Ne.length<ye.length)return!1;const qe=ye.length,te=Ne.toLowerCase();let re=0,Pe=-1;for(;re<qe;){const He=te.indexOf(ye[re],Pe+1);if(He<0)return!1;Pe=He,re++}return!0}function V(Ne,ye=!1){return Ne?(ye&&(Ne=Ne.replace(/\\./g,"")),Ne.toLowerCase()!==Ne):!1}function W(Ne){return Ne.charAt(0).toUpperCase()+Ne.slice(1)}function K(Ne,ye=1){if(ye===0)return"";let qe=-1;do qe=Ne.indexOf(`
`,qe+1),ye--;while(ye>0&&qe>=0);return qe===-1?Ne:(Ne[qe-1]==="\r"&&qe--,Ne.substr(0,qe))}function X(Ne){return Ne=Ne%(2*26),Ne<26?String.fromCharCode(97+Ne):String.fromCharCode(65+Ne-26)}function de(Ne){return Ve.getInstance().getGraphemeBreakType(Ne)}function we(Ne,ye){return Ne===0?ye!==5&&ye!==7:Ne===2&&ye===3?!1:Ne===4||Ne===2||Ne===3||ye===4||ye===2||ye===3?!0:!(Ne===8&&(ye===8||ye===9||ye===11||ye===12)||(Ne===11||Ne===9)&&(ye===9||ye===10)||(Ne===12||Ne===10)&&ye===10||ye===5||ye===13||ye===7||Ne===1||Ne===13&&ye===14||Ne===6&&ye===6)}var Fe;(function(Ne){Ne[Ne.Other=0]="Other",Ne[Ne.Prepend=1]="Prepend",Ne[Ne.CR=2]="CR",Ne[Ne.LF=3]="LF",Ne[Ne.Control=4]="Control",Ne[Ne.Extend=5]="Extend",Ne[Ne.Regional_Indicator=6]="Regional_Indicator",Ne[Ne.SpacingMark=7]="SpacingMark",Ne[Ne.L=8]="L",Ne[Ne.V=9]="V",Ne[Ne.T=10]="T",Ne[Ne.LV=11]="LV",Ne[Ne.LVT=12]="LVT",Ne[Ne.ZWJ=13]="ZWJ",Ne[Ne.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(e.GraphemeBreakType=Fe={}));class Ve{static{this.c=null}static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=Je()}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const qe=this.d,te=qe.length/3;let re=1;for(;re<=te;)if(ye<qe[3*re])re=2*re;else if(ye>qe[3*re+1])re=2*re+1;else return qe[3*re+2];return 0}}function Je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Ne,ye){if(Ne===0)return 0;const qe=_e(Ne,ye);if(qe!==void 0)return qe;const te=new G(ye,Ne);return te.prevCodePoint(),te.offset}function _e(Ne,ye){const qe=new G(ye,Ne);let te=qe.prevCodePoint();for(;nt(te)||te===65039||te===8419;){if(qe.offset===0)return;te=qe.prevCodePoint()}if(!le(te))return;let re=qe.offset;return re>0&&qe.prevCodePoint()===8205&&(re=qe.offset),re}function nt(Ne){return 127995<=Ne&&Ne<=127999}var it;(function(Ne){Ne[Ne.zwj=8205]="zwj",Ne[Ne.emojiVariantSelector=65039]="emojiVariantSelector",Ne[Ne.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.$6f="\xA0";class rt{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new d.$3e({getCacheKey:JSON.stringify},ye=>{function qe(mt){const Dt=new Map;for(let It=0;It<mt.length;It+=2)Dt.set(mt[It],mt[It+1]);return Dt}function te(mt,Dt){const It=new Map(mt);for(const[Ut,Wt]of Dt)It.set(Ut,Wt);return It}function re(mt,Dt){if(!mt)return Dt;const It=new Map;for(const[Ut,Wt]of mt)Dt.has(Ut)&&It.set(Ut,Wt);return It}const Pe=this.c.value;let He=ye.filter(mt=>!mt.startsWith("_")&&mt in Pe);He.length===0&&(He=["_default"]);let Le;for(const mt of He){const Dt=qe(Pe[mt]);Le=re(Le,Dt)}const st=qe(Pe._common),ut=te(st,Le);return new rt(ut)})}static getInstance(ye){return rt.d.get(Array.from(ye))}static{this.e=new O.$V(()=>Object.keys(rt.c.value).filter(ye=>!ye.startsWith("_")))}static getLocales(){return rt.e.value}constructor(ye){this.f=ye}isAmbiguous(ye){return this.f.has(ye)}getPrimaryConfusable(ye){return this.f.get(ye)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=rt;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ye){return at.e().has(ye)}static get codePoints(){return at.e()}}e.$8f=at}),define(Se[127],De([1,0,27,168,14]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=R,e.$zk=p,e.$Ak=m,e.$Bk=C,e.$Ck=y,e.$Dk=b,e.$Ek=I,e.$Fk=F,e.$Gk=T,e.$Hk=z,e.$Ik=_,e.$Kk=oe,e.$Lk=se,e.$Mk=$e;function R(...ge){return function(Ie,Ae){for(let ze=0,V=ge.length;ze<V;ze++){const W=ge[ze](Ie,Ae);if(W)return W}return null}}e.$xk=N.bind(void 0,!1),e.$yk=N.bind(void 0,!0);function N(ge,Ie,Ae){if(!Ae||Ae.length<Ie.length)return null;let ze;return ge?ze=L.$yf(Ae,Ie):ze=Ae.indexOf(Ie)===0,ze?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function p(ge,Ie){const Ae=Ie.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}function m(ge,Ie){return k(ge.toLowerCase(),Ie.toLowerCase(),0,0)}function k(ge,Ie,Ae,ze){if(Ae===ge.length)return[];if(ze===Ie.length)return null;if(ge[Ae]===Ie[ze]){let V=null;return(V=k(ge,Ie,Ae+1,ze+1))?l({start:ze,end:ze+1},V):null}return k(ge,Ie,Ae,ze+1)}function A(ge){return 97<=ge&&ge<=122}function C(ge){return 65<=ge&&ge<=90}function $(ge){return 48<=ge&&ge<=57}function v(ge){return ge===32||ge===9||ge===10||ge===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>w.add(ge.charCodeAt(0)));function h(ge){return v(ge)||w.has(ge)}function f(ge,Ie){return ge===Ie||h(ge)&&h(Ie)}const a=new Map;function n(ge){if(a.has(ge))return a.get(ge);let Ie;const Ae=(0,O.$vk)(ge);return Ae&&(Ie=Ae),a.set(ge,Ie),Ie}function i(ge){return A(ge)||C(ge)||$(ge)}function l(ge,Ie){return Ie.length===0?Ie=[ge]:ge.end===Ie[0].start?Ie[0].start=ge.start:Ie.unshift(ge),Ie}function o(ge,Ie){for(let Ae=Ie;Ae<ge.length;Ae++){const ze=ge.charCodeAt(Ae);if(C(ze)||$(ze)||Ae>0&&!i(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function t(ge,Ie,Ae,ze){if(Ae===ge.length)return[];if(ze===Ie.length)return null;if(ge[Ae]!==Ie[ze].toLowerCase())return null;{let V=null,W=ze+1;for(V=t(ge,Ie,Ae+1,ze+1);!V&&(W=o(Ie,W))<Ie.length;)V=t(ge,Ie,Ae+1,W),W++;return V===null?null:l({start:ze,end:ze+1},V)}}function u(ge){let Ie=0,Ae=0,ze=0,V=0,W=0;for(let Fe=0;Fe<ge.length;Fe++)W=ge.charCodeAt(Fe),C(W)&&Ie++,A(W)&&Ae++,i(W)&&ze++,$(W)&&V++;const K=Ie/ge.length,X=Ae/ge.length,de=ze/ge.length,we=V/ge.length;return{upperPercent:K,lowerPercent:X,alphaPercent:de,numericPercent:we}}function r(ge){const{upperPercent:Ie,lowerPercent:Ae}=ge;return Ae===0&&Ie>.6}function c(ge){const{upperPercent:Ie,lowerPercent:Ae,alphaPercent:ze,numericPercent:V}=ge;return Ae>.2&&Ie<.8&&ze>.6&&V<.2}function s(ge){let Ie=0,Ae=0,ze=0,V=0;for(let W=0;W<ge.length;W++)ze=ge.charCodeAt(W),C(ze)&&Ie++,A(ze)&&Ae++,v(ze)&&V++;return(Ie===0||Ae===0)&&V===0?ge.length<=30:Ie<=5}function y(ge,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!s(ge))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ae=u(Ie);if(!c(Ae)){if(!r(Ae))return null;Ie=Ie.toLowerCase()}let ze=null,V=0;for(ge=ge.toLowerCase();V<Ie.length&&(ze=t(ge,Ie,0,V))===null;)V=o(Ie,V+1);return ze}function b(ge,Ie,Ae=!1){if(!Ie||Ie.length===0)return null;let ze=null,V=0;for(ge=ge.toLowerCase(),Ie=Ie.toLowerCase();V<Ie.length&&(ze=S(ge,Ie,0,V,Ae),ze===null);)V=g(Ie,V+1);return ze}function S(ge,Ie,Ae,ze,V){let W=0;if(Ae===ge.length)return[];if(ze===Ie.length)return null;if(!f(ge.charCodeAt(Ae),Ie.charCodeAt(ze))){const de=n(ge.charCodeAt(Ae));if(!de)return null;for(let we=0;we<de.length;we++)if(!f(de[we],Ie.charCodeAt(ze+we)))return null;W+=de.length-1}let K=null,X=ze+W+1;if(K=S(ge,Ie,Ae+1,X,V),!V)for(;!K&&(X=g(Ie,X))<Ie.length;)K=S(ge,Ie,Ae+1,X,V),X++;if(!K)return null;if(ge.charCodeAt(Ae)!==Ie.charCodeAt(ze)){const de=n(ge.charCodeAt(Ae));if(!de)return K;for(let we=0;we<de.length;we++)if(de[we]!==Ie.charCodeAt(ze+we))return K}return l({start:ze,end:ze+W+1},K)}function g(ge,Ie){for(let Ae=Ie;Ae<ge.length;Ae++)if(h(ge.charCodeAt(Ae))||Ae>0&&h(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const E=R(e.$yk,y,p),D=R(e.$yk,y,m),P=new d.$Dc(1e4);function I(ge,Ie,Ae=!1){if(typeof ge!="string"||typeof Ie!="string")return null;let ze=P.get(ge);ze||(ze=new RegExp(L.$gf(ge),"i"),P.set(ge,ze));const V=ze.exec(Ie);return V?[{start:V.index,end:V.index+V[0].length}]:Ae?D(ge,Ie):E(ge,Ie)}function F(ge,Ie){const Ae=oe(ge,ge.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?z(Ae):null}function T(ge,Ie,Ae,ze,V,W){const K=Math.min(13,ge.length);for(;Ae<K;Ae++){const X=oe(ge,Ie,Ae,ze,V,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,W]}function z(ge){if(typeof ge>"u")return[];const Ie=[],Ae=ge[1];for(let ze=ge.length-1;ze>1;ze--){const V=ge[ze]+Ae,W=Ie[Ie.length-1];W&&W.end===V?W.end=V+1:Ie.push({start:V,end:V+1})}return Ie}const M=128;function j(){const ge=[],Ie=[];for(let Ae=0;Ae<=M;Ae++)Ie[Ae]=0;for(let Ae=0;Ae<=M;Ae++)ge.push(Ie.slice(0));return ge}function U(ge){const Ie=[];for(let Ae=0;Ae<=ge;Ae++)Ie[Ae]=0;return Ie}const Z=U(2*M),ie=U(2*M),Q=j(),G=j(),x=j(),ne=!1;function be(ge,Ie,Ae,ze,V){function W(X,de,we=" "){for(;X.length<de;)X=we+X;return X}let K=` |   |${ze.split("").map(X=>W(X,3)).join("|")}
`;for(let X=0;X<=Ae;X++)X===0?K+=" |":K+=`${Ie[X-1]}|`,K+=ge[X].slice(0,V+1).map(de=>W(de.toString(),3)).join("|")+`
`;return K}function ae(ge,Ie,Ae,ze){ge=ge.substr(Ie),Ae=Ae.substr(ze),console.log(be(G,ge,ge.length,Ae,Ae.length)),console.log(be(x,ge,ge.length,Ae,Ae.length)),console.log(be(Q,ge,ge.length,Ae,Ae.length))}function Ce(ge,Ie){if(Ie<0||Ie>=ge.length)return!1;const Ae=ge.codePointAt(Ie);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Qf(Ae)}}function ee(ge,Ie){if(Ie<0||Ie>=ge.length)return!1;switch(ge.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function B(ge,Ie,Ae){return Ie[ge]!==Ae[ge]}function _(ge,Ie,Ae,ze,V,W,K=!1){for(;Ie<Ae&&V<W;)ge[Ie]===ze[V]&&(K&&(Z[Ie]=V),Ie+=1),V+=1;return Ie===Ae}var pe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var ue;(function(ge){ge.Default=[-100,0];function Ie(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ie})(ue||(e.FuzzyScore=ue={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Ae){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ae}}e.$Jk=ce;function oe(ge,Ie,Ae,ze,V,W,K=ce.default){const X=ge.length>M?M:ge.length,de=ze.length>M?M:ze.length;if(Ae>=X||W>=de||X-Ae>de-W||!_(Ie,Ae,X,V,W,de,!0))return;le(X,de,Ae,W,Ie,V);let we=1,Fe=1,Ve=Ae,Je=W;const tt=[!1];for(we=1,Ve=Ae;Ve<X;we++,Ve++){const at=Z[Ve],Ne=ie[Ve],ye=Ve+1<X?ie[Ve+1]:de;for(Fe=at-W+1,Je=at;Je<ye;Fe++,Je++){let qe=Number.MIN_SAFE_INTEGER,te=!1;Je<=Ne&&(qe=J(ge,Ie,Ve,Ae,ze,V,Je,de,W,Q[we-1][Fe-1]===0,tt));let re=0;qe!==Number.MAX_SAFE_INTEGER&&(te=!0,re=qe+G[we-1][Fe-1]);const Pe=Je>at,He=Pe?G[we][Fe-1]+(Q[we][Fe-1]>0?-5:0):0,Le=Je>at+1&&Q[we][Fe-1]>0,st=Le?G[we][Fe-2]+(Q[we][Fe-2]>0?-5:0):0;if(Le&&(!Pe||st>=He)&&(!te||st>=re))G[we][Fe]=st,x[we][Fe]=3,Q[we][Fe]=0;else if(Pe&&(!te||He>=re))G[we][Fe]=He,x[we][Fe]=2,Q[we][Fe]=0;else if(te)G[we][Fe]=re,x[we][Fe]=1,Q[we][Fe]=Q[we-1][Fe-1]+1;else throw new Error("not possible")}}if(ne&&ae(ge,Ae,ze,W),!tt[0]&&!K.firstMatchCanBeWeak)return;we--,Fe--;const _e=[G[we][Fe],W];let nt=0,it=0;for(;we>=1;){let at=Fe;do{const Ne=x[we][at];if(Ne===3)at=at-2;else if(Ne===2)at=at-1;else break}while(at>=1);nt>1&&Ie[Ae+we-1]===V[W+Fe-1]&&!B(at+W-1,ze,V)&&nt+1>Q[we][at]&&(at=Fe),at===Fe?nt++:nt=1,it||(it=at),we--,Fe=at-1,_e.push(Fe)}de-W===X&&K.boostFullMatch&&(_e[0]+=2);const rt=it-X;return _e[0]-=rt,_e}function le(ge,Ie,Ae,ze,V,W){let K=ge-1,X=Ie-1;for(;K>=Ae&&X>=ze;)V[K]===W[X]&&(ie[K]=X,K--),X--}function J(ge,Ie,Ae,ze,V,W,K,X,de,we,Fe){if(Ie[Ae]!==W[K])return Number.MIN_SAFE_INTEGER;let Ve=1,Je=!1;return K===Ae-ze?Ve=ge[Ae]===V[K]?7:5:B(K,V,W)&&(K===0||!B(K-1,V,W))?(Ve=ge[Ae]===V[K]?7:5,Je=!0):Ce(W,K)&&(K===0||!Ce(W,K-1))?Ve=5:(Ce(W,K-1)||ee(W,K-1))&&(Ve=5,Je=!0),Ve>1&&Ae===ze&&(Fe[0]=!0),Je||(Je=B(K,V,W)||Ce(W,K-1)||ee(W,K-1)),Ae===ze?K>de&&(Ve-=Je?3:5):we?Ve+=Je?2:0:Ve+=Je?0:1,K+1===X&&(Ve-=Je?3:5),Ve}function se(ge,Ie,Ae,ze,V,W,K){return ve(ge,Ie,Ae,ze,V,W,!0,K)}function $e(ge,Ie,Ae,ze,V,W,K){return ve(ge,Ie,Ae,ze,V,W,!1,K)}function ve(ge,Ie,Ae,ze,V,W,K,X){let de=oe(ge,Ie,Ae,ze,V,W,X);if(de&&!K)return de;if(ge.length>=3){const we=Math.min(7,ge.length-1);for(let Fe=Ae+1;Fe<we;Fe++){const Ve=Re(ge,Fe);if(Ve){const Je=oe(Ve,Ve.toLowerCase(),Ae,ze,V,W,X);Je&&(Je[0]-=3,(!de||Je[0]>de[0])&&(de=Je))}}}return de}function Re(ge,Ie){if(Ie+1>=ge.length)return;const Ae=ge[Ie],ze=ge[Ie+1];if(Ae!==ze)return ge.slice(0,Ie)+ze+Ae+ge.slice(Ie+2)}}),define(Se[57],De([1,0,14]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=O,e.$lj=L,e.$mj=R,e.$nj=p,e.$pj=h;function O(a){return L(a,0)}function L(a,n){switch(typeof a){case"object":return a===null?R(349,n):Array.isArray(a)?m(a,n):k(a,n);case"string":return p(a,n);case"boolean":return N(a,n);case"number":return R(a,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(a,n){return(n<<5)-n+a|0}function N(a,n){return R(a?433:863,n)}function p(a,n){n=R(149417,n);for(let i=0,l=a.length;i<l;i++)n=R(a.charCodeAt(i),n);return n}function m(a,n){return n=R(104579,n),a.reduce((i,l)=>L(l,i),n)}function k(a,n){return n=R(181387,n),Object.keys(a).sort().reduce((i,l)=>(i=p(l,i),L(a[l],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$oj=A;var C;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function $(a,n,i=32){const l=i-n,o=~((1<<l)-1);return(a<<n|(o&a)>>>l)>>>0}function v(a,n=0,i=a.byteLength,l=0){for(let o=0;o<i;o++)a[n+o]=l}function w(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function h(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):w((a>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const l=this.p;let o=this.r,t=this.u,u,r;for(t!==0?(u=t,r=-1,t=0):(u=n.charCodeAt(0),r=0);;){let c=u;if(d.$Bf(u))if(r+1<i){const s=n.charCodeAt(r+1);d.$Cf(s)?(r++,c=d.$Df(u,s)):c=65533}else{t=u;break}else d.$Cf(u)&&(c=65533);if(o=this.w(l,o,c),r++,r<i)u=n.charCodeAt(r);else break}this.r=o,this.u=t}w(n,i,l){return l<128?n[i++]=l:l<2048?(n[i++]=192|(l&1984)>>>6,n[i++]=128|(l&63)>>>0):l<65536?(n[i++]=224|(l&61440)>>>12,n[i++]=128|(l&4032)>>>6,n[i++]=128|(l&63)>>>0):(n[i++]=240|(l&1835008)>>>18,n[i++]=128|(l&258048)>>>12,n[i++]=128|(l&4032)>>>6,n[i++]=128|(l&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,i=this.q;for(let b=0;b<64;b+=4)n.setUint32(b,i.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)n.setUint32(b,$(n.getUint32(b-12,!1)^n.getUint32(b-32,!1)^n.getUint32(b-56,!1)^n.getUint32(b-64,!1),1),!1);let l=this.h,o=this.l,t=this.m,u=this.n,r=this.o,c,s,y;for(let b=0;b<80;b++)b<20?(c=o&t|~o&u,s=1518500249):b<40?(c=o^t^u,s=1859775393):b<60?(c=o&t|o&u|t&u,s=2400959708):(c=o^t^u,s=3395469782),y=$(l,5)+c+r+s+n.getUint32(b*4,!1)&4294967295,r=u,u=t,t=$(o,30),o=l,l=y;this.h=this.h+l&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+r&4294967295}}e.$qj=f}),define(Se[41],De([1,0,14]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(O||(O={})),function(L){const R="error",N="warning",p="warn",m="info",k="ignore";function A($){return $?d.$xf(R,$)?L.Error:d.$xf(N,$)||d.$xf(p,$)?L.Warning:d.$xf(m,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function C($){switch($){case L.Error:return R;case L.Warning:return N;case L.Info:return m;default:return k}}L.toString=C}(O||(O={})),e.default=O}),define(Se[174],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,14]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class L{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const w=v.charCodeAt(0),h=this.b.charCodeAt(this.c);return w-h}value(){return this.b[this.c]}}e.$yi=L;class R{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,O.$rf)(v,this.b,0,v.length,this.c,this.d):(0,O.$tf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=R;class N{constructor(v=!0,w=!0){this.f=v,this.g=w}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let w=v.length-1;w>=0;w--,this.c--){const h=this.b.charCodeAt(w);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,O.$rf)(v,this.b,0,v.length,this.d,this.e):(0,O.$tf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=N;var p;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(p||(p={}));class m{constructor(v,w){this.f=v,this.g=w,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new N(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,O.$sf)(v,this.c.scheme);if(this.d[this.e]===2)return(0,O.$sf)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,O.$qf)(v,this.c.query);if(this.d[this.e]===5)return(0,O.$qf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=m;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class C{static forUris(v=()=>!1,w=()=>!1){return new C(new m(v,w))}static forPaths(v=!1){return new C(new N(void 0,!v))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new R)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,w){if(w){const h=w.slice(0);(0,d.$Wb)(h);for(const f of h)this.set(f,v)}else{const h=v.slice(0);(0,d.$Wb)(h);for(const f of h)this.set(f[0],f[1])}}set(v,w){const h=this.b.reset(v);let f;this.c||(this.c=new k,this.c.segment=h.value());const a=[];for(f=this.c;;){const i=h.cmp(f.segment);if(i>0)f.left||(f.left=new k,f.left.segment=h.value()),a.push([-1,f]),f=f.left;else if(i<0)f.right||(f.right=new k,f.right.segment=h.value()),a.push([1,f]),f=f.right;else if(h.hasNext())h.next(),f.mid||(f.mid=new k,f.mid.segment=h.value()),a.push([0,f]),f=f.mid;else break}const n=f.value;f.value=w,f.key=v;for(let i=a.length-1;i>=0;i--){const l=a[i][1];l.updateHeight();const o=l.balanceFactor();if(o<-1||o>1){const t=a[i][0],u=a[i+1][0];if(t===1&&u===1)a[i][1]=l.rotateLeft();else if(t===-1&&u===-1)a[i][1]=l.rotateRight();else if(t===1&&u===-1)l.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=l.rotateLeft();else if(t===-1&&u===1)l.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=l.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const w=this.b.reset(v);let h=this.c;for(;h;){const f=w.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else break}return h}has(v){const w=this.d(v);return!(w?.value===void 0&&w?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,w){const h=this.b.reset(v),f=[];let a=this.c;for(;a;){const n=h.cmp(a.segment);if(n>0)f.push([-1,a]),a=a.left;else if(n<0)f.push([1,a]),a=a.right;else if(h.hasNext())h.next(),f.push([0,a]),a=a.mid;else break}if(a){if(w?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:l,segment:o}=n;this.e(n.key,!1),a.key=i,a.value=l,a.segment=o}}else{const n=a.left??a.right;if(f.length>0){const[i,l]=f[f.length-1];switch(i){case-1:l.left=n;break;case 0:l.mid=n;break;case 1:l.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const i=f[n][1];i.updateHeight();const l=i.balanceFactor();if(l>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),f[n][1]=i.rotateLeft()):l<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),f[n][1]=i.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const w=this.b.reset(v);let h=this.c,f;for(;h;){const a=w.cmp(h.segment);if(a>0)h=h.left;else if(a<0)h=h.right;else if(w.hasNext())w.next(),f=h.value||f,h=h.mid;else break}return h&&h.value||f}findSuperstr(v){return this.g(v,!1)}g(v,w){const h=this.b.reset(v);let f=this.c;for(;f;){const a=h.cmp(f.segment);if(a>0)f=f.left;else if(a<0)f=f.right;else if(h.hasNext())h.next(),f=f.mid;else return f.mid?this.h(f.mid):w?f.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[w,h]of this)v(h,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const w=[];return this.j(v,w),w[Symbol.iterator]()}j(v,w){v&&(v.left&&this.j(v.left,w),v.value&&w.push([v.key,v.value]),v.mid&&this.j(v.mid,w),v.right&&this.j(v.right,w))}_isBalanced(){const v=w=>{if(!w)return!0;const h=w.balanceFactor();return h<-1||h>1?!1:v(w.left)&&v(w.right)};return v(this.c)}}e.$Ci=C}),define(Se[18],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=d,e.$0f=O,e.$$f=L,e.$_f=R,e.$ag=N,e.$bg=p,e.$cg=m,e.$dg=k,e.$eg=A,e.$fg=C,e.$gg=$,e.$hg=v,e.$ig=w,e.$jg=f,e.$kg=a,e.$lg=n,e.$mg=i,e.$ng=l;function d(o){return typeof o=="string"}function O(o){return Array.isArray(o)&&o.every(t=>d(t))}function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function N(o){return typeof o=="number"&&!isNaN(o)}function p(o){return!!o&&typeof o[Symbol.iterator]=="function"}function m(o){return o===!0||o===!1}function k(o){return typeof o>"u"}function A(o){return!C(o)}function C(o){return k(o)||o===null}function $(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function v(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function w(...o){const t=[];for(let u=0;u<o.length;u++){const r=o[u];if(C(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(r)}return t}const h=Object.prototype.hasOwnProperty;function f(o){if(!L(o))return!1;for(const t in o)if(h.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function n(...o){return o.length>0&&o.every(a)}function i(o,t){const u=Math.min(o.length,t.length);for(let r=0;r<u;r++)l(o[r],t[r])}function l(o,t){if(d(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[99],De([1,0,18]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=L,e.$Rj=R;const O=Object.create(null);function L(N,p){if((0,d.$9f)(p)){const m=O[p];if(m===void 0)throw new Error(`${N} references an unknown codicon: ${p}`);p=m}return O[N]=p,{id:N}}function R(){return O}}),define(Se[175],De([1,0,99]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,d.$Qj)("add",6e4),plus:(0,d.$Qj)("plus",6e4),gistNew:(0,d.$Qj)("gist-new",6e4),repoCreate:(0,d.$Qj)("repo-create",6e4),lightbulb:(0,d.$Qj)("lightbulb",60001),lightBulb:(0,d.$Qj)("light-bulb",60001),repo:(0,d.$Qj)("repo",60002),repoDelete:(0,d.$Qj)("repo-delete",60002),gistFork:(0,d.$Qj)("gist-fork",60003),repoForked:(0,d.$Qj)("repo-forked",60003),gitPullRequest:(0,d.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,d.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,d.$Qj)("record-keys",60005),keyboard:(0,d.$Qj)("keyboard",60005),tag:(0,d.$Qj)("tag",60006),gitPullRequestLabel:(0,d.$Qj)("git-pull-request-label",60006),tagAdd:(0,d.$Qj)("tag-add",60006),tagRemove:(0,d.$Qj)("tag-remove",60006),person:(0,d.$Qj)("person",60007),personFollow:(0,d.$Qj)("person-follow",60007),personOutline:(0,d.$Qj)("person-outline",60007),personFilled:(0,d.$Qj)("person-filled",60007),gitBranch:(0,d.$Qj)("git-branch",60008),gitBranchCreate:(0,d.$Qj)("git-branch-create",60008),gitBranchDelete:(0,d.$Qj)("git-branch-delete",60008),sourceControl:(0,d.$Qj)("source-control",60008),mirror:(0,d.$Qj)("mirror",60009),mirrorPublic:(0,d.$Qj)("mirror-public",60009),star:(0,d.$Qj)("star",60010),starAdd:(0,d.$Qj)("star-add",60010),starDelete:(0,d.$Qj)("star-delete",60010),starEmpty:(0,d.$Qj)("star-empty",60010),comment:(0,d.$Qj)("comment",60011),commentAdd:(0,d.$Qj)("comment-add",60011),alert:(0,d.$Qj)("alert",60012),warning:(0,d.$Qj)("warning",60012),search:(0,d.$Qj)("search",60013),searchSave:(0,d.$Qj)("search-save",60013),logOut:(0,d.$Qj)("log-out",60014),signOut:(0,d.$Qj)("sign-out",60014),logIn:(0,d.$Qj)("log-in",60015),signIn:(0,d.$Qj)("sign-in",60015),eye:(0,d.$Qj)("eye",60016),eyeUnwatch:(0,d.$Qj)("eye-unwatch",60016),eyeWatch:(0,d.$Qj)("eye-watch",60016),circleFilled:(0,d.$Qj)("circle-filled",60017),primitiveDot:(0,d.$Qj)("primitive-dot",60017),closeDirty:(0,d.$Qj)("close-dirty",60017),debugBreakpoint:(0,d.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,d.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,d.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,d.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,d.$Qj)("primitive-square",60018),edit:(0,d.$Qj)("edit",60019),pencil:(0,d.$Qj)("pencil",60019),info:(0,d.$Qj)("info",60020),issueOpened:(0,d.$Qj)("issue-opened",60020),gistPrivate:(0,d.$Qj)("gist-private",60021),gitForkPrivate:(0,d.$Qj)("git-fork-private",60021),lock:(0,d.$Qj)("lock",60021),mirrorPrivate:(0,d.$Qj)("mirror-private",60021),close:(0,d.$Qj)("close",60022),removeClose:(0,d.$Qj)("remove-close",60022),x:(0,d.$Qj)("x",60022),repoSync:(0,d.$Qj)("repo-sync",60023),sync:(0,d.$Qj)("sync",60023),clone:(0,d.$Qj)("clone",60024),desktopDownload:(0,d.$Qj)("desktop-download",60024),beaker:(0,d.$Qj)("beaker",60025),microscope:(0,d.$Qj)("microscope",60025),vm:(0,d.$Qj)("vm",60026),deviceDesktop:(0,d.$Qj)("device-desktop",60026),file:(0,d.$Qj)("file",60027),fileText:(0,d.$Qj)("file-text",60027),more:(0,d.$Qj)("more",60028),ellipsis:(0,d.$Qj)("ellipsis",60028),kebabHorizontal:(0,d.$Qj)("kebab-horizontal",60028),mailReply:(0,d.$Qj)("mail-reply",60029),reply:(0,d.$Qj)("reply",60029),organization:(0,d.$Qj)("organization",60030),organizationFilled:(0,d.$Qj)("organization-filled",60030),organizationOutline:(0,d.$Qj)("organization-outline",60030),newFile:(0,d.$Qj)("new-file",60031),fileAdd:(0,d.$Qj)("file-add",60031),newFolder:(0,d.$Qj)("new-folder",60032),fileDirectoryCreate:(0,d.$Qj)("file-directory-create",60032),trash:(0,d.$Qj)("trash",60033),trashcan:(0,d.$Qj)("trashcan",60033),history:(0,d.$Qj)("history",60034),clock:(0,d.$Qj)("clock",60034),folder:(0,d.$Qj)("folder",60035),fileDirectory:(0,d.$Qj)("file-directory",60035),symbolFolder:(0,d.$Qj)("symbol-folder",60035),logoGithub:(0,d.$Qj)("logo-github",60036),markGithub:(0,d.$Qj)("mark-github",60036),github:(0,d.$Qj)("github",60036),terminal:(0,d.$Qj)("terminal",60037),console:(0,d.$Qj)("console",60037),repl:(0,d.$Qj)("repl",60037),zap:(0,d.$Qj)("zap",60038),symbolEvent:(0,d.$Qj)("symbol-event",60038),error:(0,d.$Qj)("error",60039),stop:(0,d.$Qj)("stop",60039),variable:(0,d.$Qj)("variable",60040),symbolVariable:(0,d.$Qj)("symbol-variable",60040),array:(0,d.$Qj)("array",60042),symbolArray:(0,d.$Qj)("symbol-array",60042),symbolModule:(0,d.$Qj)("symbol-module",60043),symbolPackage:(0,d.$Qj)("symbol-package",60043),symbolNamespace:(0,d.$Qj)("symbol-namespace",60043),symbolObject:(0,d.$Qj)("symbol-object",60043),symbolMethod:(0,d.$Qj)("symbol-method",60044),symbolFunction:(0,d.$Qj)("symbol-function",60044),symbolConstructor:(0,d.$Qj)("symbol-constructor",60044),symbolBoolean:(0,d.$Qj)("symbol-boolean",60047),symbolNull:(0,d.$Qj)("symbol-null",60047),symbolNumeric:(0,d.$Qj)("symbol-numeric",60048),symbolNumber:(0,d.$Qj)("symbol-number",60048),symbolStructure:(0,d.$Qj)("symbol-structure",60049),symbolStruct:(0,d.$Qj)("symbol-struct",60049),symbolParameter:(0,d.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,d.$Qj)("symbol-type-parameter",60050),symbolKey:(0,d.$Qj)("symbol-key",60051),symbolText:(0,d.$Qj)("symbol-text",60051),symbolReference:(0,d.$Qj)("symbol-reference",60052),goToFile:(0,d.$Qj)("go-to-file",60052),symbolEnum:(0,d.$Qj)("symbol-enum",60053),symbolValue:(0,d.$Qj)("symbol-value",60053),symbolRuler:(0,d.$Qj)("symbol-ruler",60054),symbolUnit:(0,d.$Qj)("symbol-unit",60054),activateBreakpoints:(0,d.$Qj)("activate-breakpoints",60055),archive:(0,d.$Qj)("archive",60056),arrowBoth:(0,d.$Qj)("arrow-both",60057),arrowDown:(0,d.$Qj)("arrow-down",60058),arrowLeft:(0,d.$Qj)("arrow-left",60059),arrowRight:(0,d.$Qj)("arrow-right",60060),arrowSmallDown:(0,d.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,d.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,d.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,d.$Qj)("arrow-small-up",60064),arrowUp:(0,d.$Qj)("arrow-up",60065),bell:(0,d.$Qj)("bell",60066),bold:(0,d.$Qj)("bold",60067),book:(0,d.$Qj)("book",60068),bookmark:(0,d.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,d.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,d.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,d.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,d.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,d.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,d.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,d.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,d.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,d.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,d.$Qj)("briefcase",60076),broadcast:(0,d.$Qj)("broadcast",60077),browser:(0,d.$Qj)("browser",60078),bug:(0,d.$Qj)("bug",60079),calendar:(0,d.$Qj)("calendar",60080),caseSensitive:(0,d.$Qj)("case-sensitive",60081),check:(0,d.$Qj)("check",60082),checklist:(0,d.$Qj)("checklist",60083),chevronDown:(0,d.$Qj)("chevron-down",60084),chevronLeft:(0,d.$Qj)("chevron-left",60085),chevronRight:(0,d.$Qj)("chevron-right",60086),chevronUp:(0,d.$Qj)("chevron-up",60087),chromeClose:(0,d.$Qj)("chrome-close",60088),chromeMaximize:(0,d.$Qj)("chrome-maximize",60089),chromeMinimize:(0,d.$Qj)("chrome-minimize",60090),chromeRestore:(0,d.$Qj)("chrome-restore",60091),circleOutline:(0,d.$Qj)("circle-outline",60092),circle:(0,d.$Qj)("circle",60092),debugBreakpointUnverified:(0,d.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,d.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,d.$Qj)("circle-slash",60093),circuitBoard:(0,d.$Qj)("circuit-board",60094),clearAll:(0,d.$Qj)("clear-all",60095),clippy:(0,d.$Qj)("clippy",60096),closeAll:(0,d.$Qj)("close-all",60097),cloudDownload:(0,d.$Qj)("cloud-download",60098),cloudUpload:(0,d.$Qj)("cloud-upload",60099),code:(0,d.$Qj)("code",60100),collapseAll:(0,d.$Qj)("collapse-all",60101),colorMode:(0,d.$Qj)("color-mode",60102),commentDiscussion:(0,d.$Qj)("comment-discussion",60103),creditCard:(0,d.$Qj)("credit-card",60105),dash:(0,d.$Qj)("dash",60108),dashboard:(0,d.$Qj)("dashboard",60109),database:(0,d.$Qj)("database",60110),debugContinue:(0,d.$Qj)("debug-continue",60111),debugDisconnect:(0,d.$Qj)("debug-disconnect",60112),debugPause:(0,d.$Qj)("debug-pause",60113),debugRestart:(0,d.$Qj)("debug-restart",60114),debugStart:(0,d.$Qj)("debug-start",60115),debugStepInto:(0,d.$Qj)("debug-step-into",60116),debugStepOut:(0,d.$Qj)("debug-step-out",60117),debugStepOver:(0,d.$Qj)("debug-step-over",60118),debugStop:(0,d.$Qj)("debug-stop",60119),debug:(0,d.$Qj)("debug",60120),deviceCameraVideo:(0,d.$Qj)("device-camera-video",60121),deviceCamera:(0,d.$Qj)("device-camera",60122),deviceMobile:(0,d.$Qj)("device-mobile",60123),diffAdded:(0,d.$Qj)("diff-added",60124),diffIgnored:(0,d.$Qj)("diff-ignored",60125),diffModified:(0,d.$Qj)("diff-modified",60126),diffRemoved:(0,d.$Qj)("diff-removed",60127),diffRenamed:(0,d.$Qj)("diff-renamed",60128),diff:(0,d.$Qj)("diff",60129),diffSidebyside:(0,d.$Qj)("diff-sidebyside",60129),discard:(0,d.$Qj)("discard",60130),editorLayout:(0,d.$Qj)("editor-layout",60131),emptyWindow:(0,d.$Qj)("empty-window",60132),exclude:(0,d.$Qj)("exclude",60133),extensions:(0,d.$Qj)("extensions",60134),eyeClosed:(0,d.$Qj)("eye-closed",60135),fileBinary:(0,d.$Qj)("file-binary",60136),fileCode:(0,d.$Qj)("file-code",60137),fileMedia:(0,d.$Qj)("file-media",60138),filePdf:(0,d.$Qj)("file-pdf",60139),fileSubmodule:(0,d.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,d.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,d.$Qj)("file-symlink-file",60142),fileZip:(0,d.$Qj)("file-zip",60143),files:(0,d.$Qj)("files",60144),filter:(0,d.$Qj)("filter",60145),flame:(0,d.$Qj)("flame",60146),foldDown:(0,d.$Qj)("fold-down",60147),foldUp:(0,d.$Qj)("fold-up",60148),fold:(0,d.$Qj)("fold",60149),folderActive:(0,d.$Qj)("folder-active",60150),folderOpened:(0,d.$Qj)("folder-opened",60151),gear:(0,d.$Qj)("gear",60152),gift:(0,d.$Qj)("gift",60153),gistSecret:(0,d.$Qj)("gist-secret",60154),gist:(0,d.$Qj)("gist",60155),gitCommit:(0,d.$Qj)("git-commit",60156),gitCompare:(0,d.$Qj)("git-compare",60157),compareChanges:(0,d.$Qj)("compare-changes",60157),gitMerge:(0,d.$Qj)("git-merge",60158),githubAction:(0,d.$Qj)("github-action",60159),githubAlt:(0,d.$Qj)("github-alt",60160),globe:(0,d.$Qj)("globe",60161),grabber:(0,d.$Qj)("grabber",60162),graph:(0,d.$Qj)("graph",60163),gripper:(0,d.$Qj)("gripper",60164),heart:(0,d.$Qj)("heart",60165),home:(0,d.$Qj)("home",60166),horizontalRule:(0,d.$Qj)("horizontal-rule",60167),hubot:(0,d.$Qj)("hubot",60168),inbox:(0,d.$Qj)("inbox",60169),issueReopened:(0,d.$Qj)("issue-reopened",60171),issues:(0,d.$Qj)("issues",60172),italic:(0,d.$Qj)("italic",60173),jersey:(0,d.$Qj)("jersey",60174),json:(0,d.$Qj)("json",60175),kebabVertical:(0,d.$Qj)("kebab-vertical",60176),key:(0,d.$Qj)("key",60177),law:(0,d.$Qj)("law",60178),lightbulbAutofix:(0,d.$Qj)("lightbulb-autofix",60179),linkExternal:(0,d.$Qj)("link-external",60180),link:(0,d.$Qj)("link",60181),listOrdered:(0,d.$Qj)("list-ordered",60182),listUnordered:(0,d.$Qj)("list-unordered",60183),liveShare:(0,d.$Qj)("live-share",60184),loading:(0,d.$Qj)("loading",60185),location:(0,d.$Qj)("location",60186),mailRead:(0,d.$Qj)("mail-read",60187),mail:(0,d.$Qj)("mail",60188),markdown:(0,d.$Qj)("markdown",60189),megaphone:(0,d.$Qj)("megaphone",60190),mention:(0,d.$Qj)("mention",60191),milestone:(0,d.$Qj)("milestone",60192),gitPullRequestMilestone:(0,d.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,d.$Qj)("mortar-board",60193),move:(0,d.$Qj)("move",60194),multipleWindows:(0,d.$Qj)("multiple-windows",60195),mute:(0,d.$Qj)("mute",60196),noNewline:(0,d.$Qj)("no-newline",60197),note:(0,d.$Qj)("note",60198),octoface:(0,d.$Qj)("octoface",60199),openPreview:(0,d.$Qj)("open-preview",60200),package:(0,d.$Qj)("package",60201),paintcan:(0,d.$Qj)("paintcan",60202),pin:(0,d.$Qj)("pin",60203),play:(0,d.$Qj)("play",60204),run:(0,d.$Qj)("run",60204),plug:(0,d.$Qj)("plug",60205),preserveCase:(0,d.$Qj)("preserve-case",60206),preview:(0,d.$Qj)("preview",60207),project:(0,d.$Qj)("project",60208),pulse:(0,d.$Qj)("pulse",60209),question:(0,d.$Qj)("question",60210),quote:(0,d.$Qj)("quote",60211),radioTower:(0,d.$Qj)("radio-tower",60212),reactions:(0,d.$Qj)("reactions",60213),references:(0,d.$Qj)("references",60214),refresh:(0,d.$Qj)("refresh",60215),regex:(0,d.$Qj)("regex",60216),remoteExplorer:(0,d.$Qj)("remote-explorer",60217),remote:(0,d.$Qj)("remote",60218),remove:(0,d.$Qj)("remove",60219),replaceAll:(0,d.$Qj)("replace-all",60220),replace:(0,d.$Qj)("replace",60221),repoClone:(0,d.$Qj)("repo-clone",60222),repoForcePush:(0,d.$Qj)("repo-force-push",60223),repoPull:(0,d.$Qj)("repo-pull",60224),repoPush:(0,d.$Qj)("repo-push",60225),report:(0,d.$Qj)("report",60226),requestChanges:(0,d.$Qj)("request-changes",60227),rocket:(0,d.$Qj)("rocket",60228),rootFolderOpened:(0,d.$Qj)("root-folder-opened",60229),rootFolder:(0,d.$Qj)("root-folder",60230),rss:(0,d.$Qj)("rss",60231),ruby:(0,d.$Qj)("ruby",60232),saveAll:(0,d.$Qj)("save-all",60233),saveAs:(0,d.$Qj)("save-as",60234),save:(0,d.$Qj)("save",60235),screenFull:(0,d.$Qj)("screen-full",60236),screenNormal:(0,d.$Qj)("screen-normal",60237),searchStop:(0,d.$Qj)("search-stop",60238),server:(0,d.$Qj)("server",60240),settingsGear:(0,d.$Qj)("settings-gear",60241),settings:(0,d.$Qj)("settings",60242),shield:(0,d.$Qj)("shield",60243),smiley:(0,d.$Qj)("smiley",60244),sortPrecedence:(0,d.$Qj)("sort-precedence",60245),splitHorizontal:(0,d.$Qj)("split-horizontal",60246),splitVertical:(0,d.$Qj)("split-vertical",60247),squirrel:(0,d.$Qj)("squirrel",60248),starFull:(0,d.$Qj)("star-full",60249),starHalf:(0,d.$Qj)("star-half",60250),symbolClass:(0,d.$Qj)("symbol-class",60251),symbolColor:(0,d.$Qj)("symbol-color",60252),symbolConstant:(0,d.$Qj)("symbol-constant",60253),symbolEnumMember:(0,d.$Qj)("symbol-enum-member",60254),symbolField:(0,d.$Qj)("symbol-field",60255),symbolFile:(0,d.$Qj)("symbol-file",60256),symbolInterface:(0,d.$Qj)("symbol-interface",60257),symbolKeyword:(0,d.$Qj)("symbol-keyword",60258),symbolMisc:(0,d.$Qj)("symbol-misc",60259),symbolOperator:(0,d.$Qj)("symbol-operator",60260),symbolProperty:(0,d.$Qj)("symbol-property",60261),wrench:(0,d.$Qj)("wrench",60261),wrenchSubaction:(0,d.$Qj)("wrench-subaction",60261),symbolSnippet:(0,d.$Qj)("symbol-snippet",60262),tasklist:(0,d.$Qj)("tasklist",60263),telescope:(0,d.$Qj)("telescope",60264),textSize:(0,d.$Qj)("text-size",60265),threeBars:(0,d.$Qj)("three-bars",60266),thumbsdown:(0,d.$Qj)("thumbsdown",60267),thumbsup:(0,d.$Qj)("thumbsup",60268),tools:(0,d.$Qj)("tools",60269),triangleDown:(0,d.$Qj)("triangle-down",60270),triangleLeft:(0,d.$Qj)("triangle-left",60271),triangleRight:(0,d.$Qj)("triangle-right",60272),triangleUp:(0,d.$Qj)("triangle-up",60273),twitter:(0,d.$Qj)("twitter",60274),unfold:(0,d.$Qj)("unfold",60275),unlock:(0,d.$Qj)("unlock",60276),unmute:(0,d.$Qj)("unmute",60277),unverified:(0,d.$Qj)("unverified",60278),verified:(0,d.$Qj)("verified",60279),versions:(0,d.$Qj)("versions",60280),vmActive:(0,d.$Qj)("vm-active",60281),vmOutline:(0,d.$Qj)("vm-outline",60282),vmRunning:(0,d.$Qj)("vm-running",60283),watch:(0,d.$Qj)("watch",60284),whitespace:(0,d.$Qj)("whitespace",60285),wholeWord:(0,d.$Qj)("whole-word",60286),window:(0,d.$Qj)("window",60287),wordWrap:(0,d.$Qj)("word-wrap",60288),zoomIn:(0,d.$Qj)("zoom-in",60289),zoomOut:(0,d.$Qj)("zoom-out",60290),listFilter:(0,d.$Qj)("list-filter",60291),listFlat:(0,d.$Qj)("list-flat",60292),listSelection:(0,d.$Qj)("list-selection",60293),selection:(0,d.$Qj)("selection",60293),listTree:(0,d.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,d.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,d.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,d.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,d.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,d.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,d.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,d.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,d.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,d.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,d.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,d.$Qj)("symbol-string",60301),debugReverseContinue:(0,d.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,d.$Qj)("debug-step-back",60303),debugRestartFrame:(0,d.$Qj)("debug-restart-frame",60304),debugAlt:(0,d.$Qj)("debug-alt",60305),callIncoming:(0,d.$Qj)("call-incoming",60306),callOutgoing:(0,d.$Qj)("call-outgoing",60307),menu:(0,d.$Qj)("menu",60308),expandAll:(0,d.$Qj)("expand-all",60309),feedback:(0,d.$Qj)("feedback",60310),gitPullRequestReviewer:(0,d.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,d.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,d.$Qj)("ungroup-by-ref-type",60312),account:(0,d.$Qj)("account",60313),gitPullRequestAssignee:(0,d.$Qj)("git-pull-request-assignee",60313),bellDot:(0,d.$Qj)("bell-dot",60314),debugConsole:(0,d.$Qj)("debug-console",60315),library:(0,d.$Qj)("library",60316),output:(0,d.$Qj)("output",60317),runAll:(0,d.$Qj)("run-all",60318),syncIgnored:(0,d.$Qj)("sync-ignored",60319),pinned:(0,d.$Qj)("pinned",60320),githubInverted:(0,d.$Qj)("github-inverted",60321),serverProcess:(0,d.$Qj)("server-process",60322),serverEnvironment:(0,d.$Qj)("server-environment",60323),pass:(0,d.$Qj)("pass",60324),issueClosed:(0,d.$Qj)("issue-closed",60324),stopCircle:(0,d.$Qj)("stop-circle",60325),playCircle:(0,d.$Qj)("play-circle",60326),record:(0,d.$Qj)("record",60327),debugAltSmall:(0,d.$Qj)("debug-alt-small",60328),vmConnect:(0,d.$Qj)("vm-connect",60329),cloud:(0,d.$Qj)("cloud",60330),merge:(0,d.$Qj)("merge",60331),export:(0,d.$Qj)("export",60332),graphLeft:(0,d.$Qj)("graph-left",60333),magnet:(0,d.$Qj)("magnet",60334),notebook:(0,d.$Qj)("notebook",60335),redo:(0,d.$Qj)("redo",60336),checkAll:(0,d.$Qj)("check-all",60337),pinnedDirty:(0,d.$Qj)("pinned-dirty",60338),passFilled:(0,d.$Qj)("pass-filled",60339),circleLargeFilled:(0,d.$Qj)("circle-large-filled",60340),circleLarge:(0,d.$Qj)("circle-large",60341),circleLargeOutline:(0,d.$Qj)("circle-large-outline",60341),combine:(0,d.$Qj)("combine",60342),gather:(0,d.$Qj)("gather",60342),table:(0,d.$Qj)("table",60343),variableGroup:(0,d.$Qj)("variable-group",60344),typeHierarchy:(0,d.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,d.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,d.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,d.$Qj)("git-pull-request-create",60348),runAbove:(0,d.$Qj)("run-above",60349),runBelow:(0,d.$Qj)("run-below",60350),notebookTemplate:(0,d.$Qj)("notebook-template",60351),debugRerun:(0,d.$Qj)("debug-rerun",60352),workspaceTrusted:(0,d.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,d.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,d.$Qj)("workspace-unknown",60355),terminalCmd:(0,d.$Qj)("terminal-cmd",60356),terminalDebian:(0,d.$Qj)("terminal-debian",60357),terminalLinux:(0,d.$Qj)("terminal-linux",60358),terminalPowershell:(0,d.$Qj)("terminal-powershell",60359),terminalTmux:(0,d.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,d.$Qj)("terminal-ubuntu",60361),terminalBash:(0,d.$Qj)("terminal-bash",60362),arrowSwap:(0,d.$Qj)("arrow-swap",60363),copy:(0,d.$Qj)("copy",60364),personAdd:(0,d.$Qj)("person-add",60365),filterFilled:(0,d.$Qj)("filter-filled",60366),wand:(0,d.$Qj)("wand",60367),debugLineByLine:(0,d.$Qj)("debug-line-by-line",60368),inspect:(0,d.$Qj)("inspect",60369),layers:(0,d.$Qj)("layers",60370),layersDot:(0,d.$Qj)("layers-dot",60371),layersActive:(0,d.$Qj)("layers-active",60372),compass:(0,d.$Qj)("compass",60373),compassDot:(0,d.$Qj)("compass-dot",60374),compassActive:(0,d.$Qj)("compass-active",60375),azure:(0,d.$Qj)("azure",60376),issueDraft:(0,d.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,d.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,d.$Qj)("git-pull-request-draft",60379),debugAll:(0,d.$Qj)("debug-all",60380),debugCoverage:(0,d.$Qj)("debug-coverage",60381),runErrors:(0,d.$Qj)("run-errors",60382),folderLibrary:(0,d.$Qj)("folder-library",60383),debugContinueSmall:(0,d.$Qj)("debug-continue-small",60384),beakerStop:(0,d.$Qj)("beaker-stop",60385),graphLine:(0,d.$Qj)("graph-line",60386),graphScatter:(0,d.$Qj)("graph-scatter",60387),pieChart:(0,d.$Qj)("pie-chart",60388),bracket:(0,d.$Qj)("bracket",60175),bracketDot:(0,d.$Qj)("bracket-dot",60389),bracketError:(0,d.$Qj)("bracket-error",60390),lockSmall:(0,d.$Qj)("lock-small",60391),azureDevops:(0,d.$Qj)("azure-devops",60392),verifiedFilled:(0,d.$Qj)("verified-filled",60393),newline:(0,d.$Qj)("newline",60394),layout:(0,d.$Qj)("layout",60395),layoutActivitybarLeft:(0,d.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,d.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,d.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,d.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,d.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,d.$Qj)("layout-panel-right",60401),layoutPanel:(0,d.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,d.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,d.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,d.$Qj)("layout-statusbar",60405),layoutMenubar:(0,d.$Qj)("layout-menubar",60406),layoutCentered:(0,d.$Qj)("layout-centered",60407),target:(0,d.$Qj)("target",60408),indent:(0,d.$Qj)("indent",60409),recordSmall:(0,d.$Qj)("record-small",60410),errorSmall:(0,d.$Qj)("error-small",60411),terminalDecorationError:(0,d.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,d.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,d.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,d.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,d.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,d.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,d.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,d.$Qj)("layout-sidebar-left-off",60418),blank:(0,d.$Qj)("blank",60419),heartFilled:(0,d.$Qj)("heart-filled",60420),map:(0,d.$Qj)("map",60421),mapHorizontal:(0,d.$Qj)("map-horizontal",60421),foldHorizontal:(0,d.$Qj)("fold-horizontal",60421),mapFilled:(0,d.$Qj)("map-filled",60422),mapHorizontalFilled:(0,d.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,d.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,d.$Qj)("circle-small",60423),bellSlash:(0,d.$Qj)("bell-slash",60424),bellSlashDot:(0,d.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,d.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,d.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,d.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,d.$Qj)("search-fuzzy",60429),commentDraft:(0,d.$Qj)("comment-draft",60430),send:(0,d.$Qj)("send",60431),sparkle:(0,d.$Qj)("sparkle",60432),insert:(0,d.$Qj)("insert",60433),mic:(0,d.$Qj)("mic",60434),thumbsdownFilled:(0,d.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,d.$Qj)("thumbsup-filled",60436),coffee:(0,d.$Qj)("coffee",60437),snake:(0,d.$Qj)("snake",60438),game:(0,d.$Qj)("game",60439),vr:(0,d.$Qj)("vr",60440),chip:(0,d.$Qj)("chip",60441),piano:(0,d.$Qj)("piano",60442),music:(0,d.$Qj)("music",60443),micFilled:(0,d.$Qj)("mic-filled",60444),repoFetch:(0,d.$Qj)("repo-fetch",60445),copilot:(0,d.$Qj)("copilot",60446),lightbulbSparkle:(0,d.$Qj)("lightbulb-sparkle",60447),robot:(0,d.$Qj)("robot",60448),sparkleFilled:(0,d.$Qj)("sparkle-filled",60449),diffSingle:(0,d.$Qj)("diff-single",60450),diffMultiple:(0,d.$Qj)("diff-multiple",60451),surroundWith:(0,d.$Qj)("surround-with",60452),share:(0,d.$Qj)("share",60453),gitStash:(0,d.$Qj)("git-stash",60454),gitStashApply:(0,d.$Qj)("git-stash-apply",60455),gitStashPop:(0,d.$Qj)("git-stash-pop",60456),vscode:(0,d.$Qj)("vscode",60457),vscodeInsiders:(0,d.$Qj)("vscode-insiders",60458),codeOss:(0,d.$Qj)("code-oss",60459),runCoverage:(0,d.$Qj)("run-coverage",60460),runAllCoverage:(0,d.$Qj)("run-all-coverage",60461),coverage:(0,d.$Qj)("coverage",60462),githubProject:(0,d.$Qj)("github-project",60463),mapVertical:(0,d.$Qj)("map-vertical",60464),foldVertical:(0,d.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,d.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,d.$Qj)("fold-vertical-filled",60465),goToSearch:(0,d.$Qj)("go-to-search",60466),percentage:(0,d.$Qj)("percentage",60467),sortPercentage:(0,d.$Qj)("sort-percentage",60467)}}),define(Se[79],De([1,0,99,175]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=L;function L(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,d.$Qj)("dialog-error","error"),dialogWarning:(0,d.$Qj)("dialog-warning","warning"),dialogInfo:(0,d.$Qj)("dialog-info","info"),dialogClose:(0,d.$Qj)("dialog-close","close"),treeItemExpanded:(0,d.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,d.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,d.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,d.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,d.$Qj)("tree-item-loading","loading"),menuSelection:(0,d.$Qj)("menu-selection","check"),menuSubmenu:(0,d.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,d.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,d.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,d.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,d.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,d.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,d.$Qj)("toolbar-more","more"),quickInputBack:(0,d.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,d.$Qj)("drop-down-button",60084),symbolCustomColor:(0,d.$Qj)("symbol-customcolor",60252),exportIcon:(0,d.$Qj)("export",60332),workspaceUnspecified:(0,d.$Qj)("workspace-unspecified",60355),newLine:(0,d.$Qj)("newline",60394),thumbsDownFilled:(0,d.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,d.$Qj)("thumbsup-filled",60436),gitFetch:(0,d.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,d.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,d.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...O.$Sj,...e.$Uj}}),define(Se[24],De([1,0,18]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=O,e.$4n=L,e.$5n=N,e.$6n=m,e.$7n=k,e.$8n=A,e.$9n=C,e.$0n=$,e.$$n=v,e.$_n=w,e.$ao=h,e.$bo=f;function O(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const n=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([i,l])=>{n[i]=l&&typeof l=="object"?O(l):l}),n}function L(a){if(!a||typeof a!="object")return a;const n=[a];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const l in i)if(R.call(i,l)){const o=i[l];typeof o=="object"&&!Object.isFrozen(o)&&!(0,d.$_f)(o)&&n.push(o)}}return a}const R=Object.prototype.hasOwnProperty;function N(a,n){return p(a,n,new Set)}function p(a,n,i){if((0,d.$fg)(a))return a;const l=n(a);if(typeof l<"u")return l;if(Array.isArray(a)){const o=[];for(const t of a)o.push(p(t,n,i));return o}if((0,d.$$f)(a)){if(i.has(a))throw new Error("Cannot clone recursive data-structure");i.add(a);const o={};for(const t in a)R.call(a,t)&&(o[t]=p(a[t],n,i));return i.delete(a),o}return a}function m(a,n,i=!0){return(0,d.$$f)(a)?((0,d.$$f)(n)&&Object.keys(n).forEach(l=>{l in a?i&&((0,d.$$f)(a[l])&&(0,d.$$f)(n[l])?m(a[l],n[l],i):a[l]=n[l]):a[l]=n[l]}),a):n}function k(a,n){if(a===n)return!0;if(a==null||n===null||n===void 0||typeof a!=typeof n||typeof a!="object"||Array.isArray(a)!==Array.isArray(n))return!1;let i,l;if(Array.isArray(a)){if(a.length!==n.length)return!1;for(i=0;i<a.length;i++)if(!k(a[i],n[i]))return!1}else{const o=[];for(l in a)o.push(l);o.sort();const t=[];for(l in n)t.push(l);if(t.sort(),!k(o,t))return!1;for(i=0;i<o.length;i++)if(!k(a[o[i]],n[o[i]]))return!1}return!0}function A(a){const n=new Set;return JSON.stringify(a,(i,l)=>{if((0,d.$$f)(l)||Array.isArray(l)){if(n.has(l))return"[Circular]";n.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function C(a,n){const i=Object.create(null);return!a||!n||Object.keys(n).forEach(o=>{const t=a[o],u=n[o];k(t,u)||(i[o]=u)}),i}function $(a,n){const i=n.toLowerCase(),l=Object.keys(a).find(o=>o.toLowerCase()===i);return l?a[l]:a[n]}function v(a,n){const i=Object.create(null);for(const[l,o]of Object.entries(a))n(l,o)&&(i[l]=o);return i}function w(a){let n=[];for(;Object.prototype!==a;)n=n.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return n}function h(a){const n=[];for(const i of w(a))typeof a[i]=="function"&&n.push(i);return n}function f(a,n){const i=o=>function(){const t=Array.prototype.slice.call(arguments,0);return n(o,t)},l={};for(const o of a)l[o]=i(o);return l}}),define(Se[50],De([1,0,79]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=L;var O;(function(N){function p(m){return m&&typeof m=="object"&&typeof m.id=="string"}N.isThemeColor=p})(O||(e.ThemeColor=O={}));function L(N){return{id:N}}var R;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function m(n){const i=p.exec(n.id);if(!i)return m(d.$Vj.error);const[,l,o]=i,t=["codicon","codicon-"+l];return o&&t.push("codicon-modifier-"+o.substring(1)),t}N.asClassNameArray=m;function k(n){return m(n).join(" ")}N.asClassName=k;function A(n){return"."+m(n).join(".")}N.asCSSSelector=A;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}N.isThemeIcon=C;const $=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function v(n){const i=$.exec(n);if(!i)return;const[,l]=i;return{id:l}}N.fromString=v;function w(n){return{id:n}}N.fromId=w;function h(n,i){let l=n.id;const o=l.lastIndexOf("~");return o!==-1&&(l=l.substring(0,o)),i&&(l=`${l}~${i}`),{id:l}}N.modify=h;function f(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}N.getModifier=f;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}N.isEqual=a})(R||(e.ThemeIcon=R={}))}),define(Se[176],De([1,0,127,14,50]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=m,e.$Ok=A,e.$Pk=$,e.$Qk=v,e.$Rk=h,e.$Sk=f;const R="$(",N=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${N.source}`,"g");function m(a){return a.replace(p,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${N.source}`,"g");function A(a){return a.replace(k,n=>`\\${n}`)}const C=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function $(a){return a.indexOf(R)===-1?a:a.replace(C,(n,i,l,o)=>l?n:i||o||"")}function v(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(a){w.lastIndex=0;let n="";const i=[];let l=0;for(;;){const o=w.lastIndex,t=w.exec(a),u=a.substring(o,t?.index);if(u.length>0){n+=u;for(let r=0;r<u.length;r++)i.push(l)}if(!t)break;l+=t[0].length}return{text:n,iconOffsets:i}}function f(a,n,i=!1){const{text:l,iconOffsets:o}=n;if(!o||o.length===0)return(0,d.$Ek)(a,l,i);const t=(0,O.$ef)(l," "),u=l.length-t.length,r=(0,d.$Ek)(a,t,i);if(r)for(const c of r){const s=o[c.start+u]+u;c.start+=s,c.end+=s}return r}}),define(Se[128],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$5e=O,e.$6e=L;var d;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d||(e.Constants=d={}));function O(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(Se[30],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=O;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(L){return d.test(L)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(p){for(let m=0;m<p.length;m++)p[m]=Math.floor(Math.random()*256);return p};const R=new Uint8Array(16),N=[];for(let p=0;p<256;p++)N.push(p.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,k="";return k+=N[R[m++]],k+=N[R[m++]],k+=N[R[m++]],k+=N[R[m++]],k+="-",k+=N[R[m++]],k+=N[R[m++]],k+="-",k+=N[R[m++]],k+=N[R[m++]],k+="-",k+=N[R[m++]],k+=N[R[m++]],k+="-",k+=N[R[m++]],k+=N[R[m++]],k+=N[R[m++]],k+=N[R[m++]],k+=N[R[m++]],k+=N[R[m++]],k}}()}),define(Se[177],De([1,0,19,39,30]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=R,e.$Rt=N,e.$Tt=k;function R(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}function N(C,$,v){const w={id:(0,L.$Sg)(),name:C,uri:$,data:v};return{asString:async()=>"",asFile:()=>w,value:void 0}}class p{constructor(){this.a=new Map}get size(){let $=0;for(const v of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const v=[...this.a.keys()];return O.Iterable.some(this,([w,h])=>h.asFile())&&v.push("files"),A(m($),v)}get($){return this.a.get(this.b($))?.[0]}append($,v){const w=this.a.get($);w?w.push(v):this.a.set(this.b($),[v])}replace($,v){this.a.set(this.b($),[v])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,v]of this.a)for(const w of v)yield[$,w]}b($){return m($)}}e.$St=p;function m(C){return C.toLowerCase()}function k(C,$){return A(m(C),$.map(m))}function A(C,$){if(C==="*/*")return $.length>0;if($.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[w,h,f]=v;return f==="*"?$.some(a=>a.startsWith(h+"/")):!1}e.$Ut=Object.freeze({create:C=>(0,d.$Mb)(C.map($=>$.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Ut.split(C).filter($=>!$.startsWith("#"))})}),define(Se[178],De([1,0,63]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=O,e.$Wg=R;function O(p,m,k,A=1){let C=!1;return new Promise($=>{const v=setTimeout(()=>{if(!C)return C=!0,$(0)},k);L(p,m,A,w=>{if(!C)return C=!0,clearTimeout(v),$(w)})})}function L(p,m,k,A){if(m===0)return A(0);const C=new d.Socket;C.once("connect",()=>(N(C),L(p+k,m-1,k,A))),C.once("data",()=>{}),C.once("error",$=>(N(C),$.code!=="ECONNREFUSED"?L(p+k,m-1,k,A):A(p))),C.connect(p,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(p,m,k,A="127.0.0.1"){let C=!1,$,v=1;const w=d.createServer({pauseOnConnect:!0});function h(f,a){C||(C=!0,w.removeAllListeners(),w.close(),$&&clearTimeout($),a(f))}return new Promise(f=>{$=setTimeout(()=>{h(0,f)},k),w.on("listening",()=>{h(p,f)}),w.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&v<m?(p++,v++,w.listen(p,A)):h(0,f)}),w.on("close",()=>{h(0,f)}),w.listen(p,A)})}function N(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(m){console.error(m)}}}),define(Se[129],De([1,0,128]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.$It=void 0;class O{constructor(p){const m=(0,d.$5e)(p);this.c=m,this.a=O.d(m),this.b=new Map}static d(p){const m=new Uint8Array(256);return m.fill(p),m}set(p,m){const k=(0,d.$5e)(m);p>=0&&p<256?this.a[p]=k:this.b.set(p,k)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$It=O;var L;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new O(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$Jt=R}),define(Se[179],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=O;var d;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(d||(e.StringEOL=d={}));function O(L){let R=0,N=0,p=0,m=0;for(let k=0,A=L.length;k<A;k++){const C=L.charCodeAt(k);C===13?(R===0&&(N=k),R++,k+1<A&&L.charCodeAt(k+1)===10?(m|=2,k++):m|=3,p=k+1):C===10&&(m|=1,R===0&&(N=k),R++,p=k+1)}return R===0&&(N=L.length),[R,N,L.length-p,m]}}),define(Se[51],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class d{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new d(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return d.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return d.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return d.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const N=L.lineNumber|0,p=R.lineNumber|0;if(N===p){const m=L.column|0,k=R.column|0;return m-k}return N-p}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new d(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$tt=d}),define(Se[29],De([1,0,51]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class O{constructor(R,N,p,m){R>p||R===p&&N>m?(this.startLineNumber=p,this.startColumn=m,this.endLineNumber=R,this.endColumn=N):(this.startLineNumber=R,this.startColumn=N,this.endLineNumber=p,this.endColumn=m)}isEmpty(){return O.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return O.containsPosition(this,R)}static containsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<R.startColumn||N.lineNumber===R.endLineNumber&&N.column>R.endColumn)}static strictContainsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<=R.startColumn||N.lineNumber===R.endLineNumber&&N.column>=R.endColumn)}containsRange(R){return O.containsRange(this,R)}static containsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>R.endColumn)}strictContainsRange(R){return O.strictContainsRange(this,R)}static strictContainsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<=R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>=R.endColumn)}plusRange(R){return O.plusRange(this,R)}static plusRange(R,N){let p,m,k,A;return N.startLineNumber<R.startLineNumber?(p=N.startLineNumber,m=N.startColumn):N.startLineNumber===R.startLineNumber?(p=N.startLineNumber,m=Math.min(N.startColumn,R.startColumn)):(p=R.startLineNumber,m=R.startColumn),N.endLineNumber>R.endLineNumber?(k=N.endLineNumber,A=N.endColumn):N.endLineNumber===R.endLineNumber?(k=N.endLineNumber,A=Math.max(N.endColumn,R.endColumn)):(k=R.endLineNumber,A=R.endColumn),new O(p,m,k,A)}intersectRanges(R){return O.intersectRanges(this,R)}static intersectRanges(R,N){let p=R.startLineNumber,m=R.startColumn,k=R.endLineNumber,A=R.endColumn;const C=N.startLineNumber,$=N.startColumn,v=N.endLineNumber,w=N.endColumn;return p<C?(p=C,m=$):p===C&&(m=Math.max(m,$)),k>v?(k=v,A=w):k===v&&(A=Math.min(A,w)),p>k||p===k&&m>A?null:new O(p,m,k,A)}equalsRange(R){return O.equalsRange(this,R)}static equalsRange(R,N){return!R&&!N?!0:!!R&&!!N&&R.startLineNumber===N.startLineNumber&&R.startColumn===N.startColumn&&R.endLineNumber===N.endLineNumber&&R.endColumn===N.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(R){return new d.$tt(R.endLineNumber,R.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(R){return new d.$tt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,N){return new O(this.startLineNumber,this.startColumn,R,N)}setStartPosition(R,N){return new O(R,N,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(R){return new O(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(R){return new O(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new O(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,N=R){return new O(R.lineNumber,R.column,N.lineNumber,N.column)}static lift(R){return R?new O(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<R.startColumn)}static areIntersecting(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<=N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,N){if(R&&N){const k=R.startLineNumber|0,A=N.startLineNumber|0;if(k===A){const C=R.startColumn|0,$=N.startColumn|0;if(C===$){const v=R.endLineNumber|0,w=N.endLineNumber|0;if(v===w){const h=R.endColumn|0,f=N.endColumn|0;return h-f}return v-w}return C-$}return k-A}return(R?1:0)-(N?1:0)}static compareRangesUsingEnds(R,N){return R.endLineNumber===N.endLineNumber?R.endColumn===N.endColumn?R.startLineNumber===N.startLineNumber?R.startColumn-N.startColumn:R.startLineNumber-N.startLineNumber:R.endColumn-N.endColumn:R.endLineNumber-N.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ut=O}),define(Se[180],De([1,0,29]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class O{static insert(R,N){return{range:new d.$ut(R.lineNumber,R.column,R.lineNumber,R.column),text:N,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,N){return{range:R,text:N}}static replaceMove(R,N){return{range:R,text:N,forceMoveMarkers:!0}}}e.$vt=O}),define(Se[181],De([1,0,51,29]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.SelectionDirection=void 0;var L;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends O.$ut{constructor(p,m,k,A){super(p,m,k,A),this.selectionStartLineNumber=p,this.selectionStartColumn=m,this.positionLineNumber=k,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return R.selectionsEqual(this,p)}static selectionsEqual(p,m){return p.selectionStartLineNumber===m.selectionStartLineNumber&&p.selectionStartColumn===m.selectionStartColumn&&p.positionLineNumber===m.positionLineNumber&&p.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,m){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,p,m):new R(p,m,this.startLineNumber,this.startColumn)}getPosition(){return new d.$tt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.$tt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,m){return this.getDirection()===0?new R(p,m,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,p,m)}static fromPositions(p,m=p){return new R(p.lineNumber,p.column,m.lineNumber,m.column)}static fromRange(p,m){return m===0?new R(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new R(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new R(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,m){if(p&&!m||!p&&m)return!1;if(!p&&!m)return!0;if(p.length!==m.length)return!1;for(let k=0,A=p.length;k<A;k++)if(!this.selectionsEqual(p[k],m[k]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,m,k,A,C){return C===0?new R(p,m,k,A):new R(k,A,p,m)}}e.$wt=R}),define(Se[182],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[183],De([1,0,27,129]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.WordCharacterClass=void 0,e.$Lt=p;var L;(function(m){m[m.Regular=0]="Regular",m[m.Whitespace=1]="Whitespace",m[m.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends O.$It{constructor(k,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let C=0,$=k.length;C<$;C++)this.set(k.charCodeAt(C),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(k,A){let C=null;for(const $ of this.h(k)){if($.index>A)break;C=$}return C}findNextIntlWordAtOrAfterOffset(k,A){for(const C of this.h(k))if(!(C.index<A))return C;return null}h(k){return this.e?this.f===k?this.g:(this.f=k,this.g=this.j(this.e.segment(k)),this.g):[]}j(k){const A=[];for(const C of k)this.k(C)&&A.push(C);return A}k(k){return!!k.isWordLike}}e.$Kt=R;const N=new d.$Dc(10);function p(m,k){const A=`${m}/${k.join(",")}`;let C=N.get(A);return C||(C=new R(m,k),N.set(A,C)),C}}),define(Se[130],De([1,0,39,3,76]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=void 0,e.$7s=N,e.$8s=m,e.$9s=k,e.$5s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(C=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$5s)C.indexOf(v)>=0||($+="\\"+v);return $+="\\s]+)",new RegExp($,"g")}e.$6s=R();function N(C){let $=e.$6s;if(C&&C instanceof RegExp)if(C.global)$=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),$=new RegExp(C.source,v)}return $.lastIndex=0,$}const p=new L.$5c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(C){const $=p.unshift(C);return(0,O.$Sc)($)}function k(C,$,v,w,h){if($=N($),h||(h=d.Iterable.first(p)),v.length>h.maxLen){let l=C-h.maxLen/2;return l<0?l=0:w+=l,v=v.substring(l,C+h.maxLen/2),k(C,$,v,w,h)}const f=Date.now(),a=C-1-w;let n=-1,i=null;for(let l=1;!(Date.now()-f>=h.timeBudget);l++){const o=a-h.windowSize*l;$.lastIndex=Math.max(0,o);const t=A($,v,a,n);if(!t&&i||(i=t,o<=0))break;n=o}if(i){const l={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return $.lastIndex=0,l}return null}function A(C,$,v,w){let h;for(;h=C.exec($);){const f=h.index||0;if(f<=v&&C.lastIndex>=v)return h;if(w>0&&f>w)return null}return null}}),define(Se[184],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var d;(function(N){N[N.None=0]="None",N[N.Indent=1]="Indent",N[N.IndentOutdent=2]="IndentOutdent",N[N.Outdent=3]="Outdent"})(d||(e.IndentAction=d={}));class O{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let m=0,k=p.notIn.length;m<k;m++)switch(p.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,m){if(p.getTokenCount()===0)return!0;const k=p.findTokenIndexAtOffset(m-2),A=p.getStandardTokenType(k);return this.isOK(A)}g(p,m){for(let k=p;k<=m;k++){const A=String.fromCharCode(k);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=O;class L{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of p)R(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),R(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),R(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),R(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&R(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$lu=L;function R(N,p,m){N.has(p)?N.get(p).push(m):N.set(p,[m])}}),define(Se[185],De([1,0,129]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3=e.$w3=e.State=void 0,e.$y3=$;var O;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class L{constructor(w,h,f){const a=new Uint8Array(w*h);for(let n=0,i=w*h;n<i;n++)a[n]=f;this.a=a,this.rows=w,this.cols=h}get(w,h){return this.a[w*this.cols+h]}set(w,h,f){this.a[w*this.cols+h]=f}}class R{constructor(w){let h=0,f=0;for(let n=0,i=w.length;n<i;n++){const[l,o,t]=w[n];o>h&&(h=o),l>f&&(f=l),t>f&&(f=t)}h++,f++;const a=new L(f,h,0);for(let n=0,i=w.length;n<i;n++){const[l,o,t]=w[n];a.set(l,o,t)}this.a=a,this.b=h}nextState(w,h){return h<0||h>=this.b?0:this.a.get(w,h)}}e.$w3=R;let N=null;function p(){return N===null&&(N=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var m;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(m||(m={}));let k=null;function A(){if(k===null){k=new d.$It(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<v.length;h++)k.set(v.charCodeAt(h),1);const w=".,;:";for(let h=0;h<w.length;h++)k.set(w.charCodeAt(h),2)}return k}class C{static a(w,h,f,a,n){let i=n-1;do{const l=h.charCodeAt(i);if(w.get(l)!==2)break;i--}while(i>a);if(a>0){const l=h.charCodeAt(a-1),o=h.charCodeAt(i);(l===40&&o===41||l===91&&o===93||l===123&&o===125)&&i--}return{range:{startLineNumber:f,startColumn:a+1,endLineNumber:f,endColumn:i+2},url:h.substring(a,i+1)}}static computeLinks(w,h=p()){const f=A(),a=[];for(let n=1,i=w.getLineCount();n<=i;n++){const l=w.getLineContent(n),o=l.length;let t=0,u=0,r=0,c=1,s=!1,y=!1,b=!1,S=!1;for(;t<o;){let g=!1;const E=l.charCodeAt(t);if(c===13){let D;switch(E){case 40:s=!0,D=0;break;case 41:D=s?0:1;break;case 91:b=!0,y=!0,D=0;break;case 93:b=!1,D=y?0:1;break;case 123:S=!0,D=0;break;case 125:D=S?0:1;break;case 39:case 34:case 96:r===E?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=b?0:1;break;default:D=f.get(E)}D===1&&(a.push(C.a(f,l,n,u,t)),g=!0)}else if(c===12){let D;E===91?(y=!0,D=0):D=f.get(E),D===1?g=!0:c=13}else c=h.nextState(c,E),c===0&&(g=!0);g&&(c=1,s=!1,y=!1,S=!1,u=t+1,r=E),t++}c===13&&a.push(C.a(f,l,n,u,o))}return a}}e.$x3=C;function $(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}}),define(Se[80],De([1,0,24]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Fv=e.$Ev=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Gv=w,e.$Kv=l;var O;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var L;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var N;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(N||(e.MinimapSectionHeaderStyle=N={}));var p;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(p||(e.InjectedTextCursorStops=p={}));var m;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var k;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var A;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,d.$7n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Ev=C;class ${constructor(t,u){this._findMatchBrand=void 0,this.range=t,this.matches=u}}e.$Fv=$;var v;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function w(o){return o&&typeof o.read=="function"}var h;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(h||(e.PositionAffinity=h={}));var f;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class a{constructor(t,u,r,c,s,y){this.identifier=t,this.range=u,this.text=r,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=s,this._isTracked=y}}e.$Hv=a;class n{constructor(t,u,r){this.regex=t,this.wordSeparators=u,this.simpleSearch=r}}e.$Iv=n;class i{constructor(t,u,r){this.reverseEdits=t,this.changes=u,this.trimAutoWhitespaceLineNumbers=r}}e.$Jv=i;function l(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(Se[186],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.NodeColor=e.$FC=void 0,e.$HC=L,e.$IC=R,e.$JC=k,e.$KC=A,e.$LC=C,e.$MC=$,e.$NC=v,e.$OC=w;class d{constructor(f,a){this.piece=f,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$GC)return L(this.right);let f=this;for(;f.parent!==e.$GC&&f.parent.left!==f;)f=f.parent;return f.parent===e.$GC?e.$GC:f.parent}prev(){if(this.left!==e.$GC)return R(this.left);let f=this;for(;f.parent!==e.$GC&&f.parent.right!==f;)f=f.parent;return f.parent===e.$GC?e.$GC:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$FC=d;var O;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$GC=new d(null,0),e.$GC.parent=e.$GC,e.$GC.left=e.$GC,e.$GC.right=e.$GC,e.$GC.color=0;function L(h){for(;h.left!==e.$GC;)h=h.left;return h}function R(h){for(;h.right!==e.$GC;)h=h.right;return h}function N(h){return h===e.$GC?0:h.size_left+h.piece.length+N(h.right)}function p(h){return h===e.$GC?0:h.lf_left+h.piece.lineFeedCnt+p(h.right)}function m(){e.$GC.parent=e.$GC}function k(h,f){const a=f.right;a.size_left+=f.size_left+(f.piece?f.piece.length:0),a.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=a.left,a.left!==e.$GC&&(a.left.parent=f),a.parent=f.parent,f.parent===e.$GC?h.root=a:f.parent.left===f?f.parent.left=a:f.parent.right=a,a.left=f,f.parent=a}function A(h,f){const a=f.left;f.left=a.right,a.right!==e.$GC&&(a.right.parent=f),a.parent=f.parent,f.size_left-=a.size_left+(a.piece?a.piece.length:0),f.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),f.parent===e.$GC?h.root=a:f===f.parent.right?f.parent.right=a:f.parent.left=a,a.right=f,f.parent=a}function C(h,f){let a,n;if(f.left===e.$GC?(n=f,a=n.right):f.right===e.$GC?(n=f,a=n.left):(n=L(f.right),a=n.right),n===h.root){h.root=a,a.color=0,f.detach(),m(),h.root.parent=e.$GC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===f?(a.parent=n.parent,w(h,a)):(n.parent===f?a.parent=n:a.parent=n.parent,w(h,a),n.left=f.left,n.right=f.right,n.parent=f.parent,n.color=f.color,f===h.root?h.root=n:f===f.parent.left?f.parent.left=n:f.parent.right=n,n.left!==e.$GC&&(n.left.parent=n),n.right!==e.$GC&&(n.right.parent=n),n.size_left=f.size_left,n.lf_left=f.lf_left,w(h,n)),f.detach(),a.parent.left===a){const o=N(a),t=p(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const u=o-a.parent.size_left,r=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,v(h,a.parent,u,r)}}if(w(h,a.parent),i){m();return}let l;for(;a!==h.root&&a.color===0;)a===a.parent.left?(l=a.parent.right,l.color===1&&(l.color=0,a.parent.color=1,k(h,a.parent),l=a.parent.right),l.left.color===0&&l.right.color===0?(l.color=1,a=a.parent):(l.right.color===0&&(l.left.color=0,l.color=1,A(h,l),l=a.parent.right),l.color=a.parent.color,a.parent.color=0,l.right.color=0,k(h,a.parent),a=h.root)):(l=a.parent.left,l.color===1&&(l.color=0,a.parent.color=1,A(h,a.parent),l=a.parent.left),l.left.color===0&&l.right.color===0?(l.color=1,a=a.parent):(l.left.color===0&&(l.right.color=0,l.color=1,k(h,l),l=a.parent.left),l.color=a.parent.color,a.parent.color=0,l.left.color=0,A(h,a.parent),a=h.root));a.color=0,m()}function $(h,f){for(w(h,f);f!==h.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const a=f.parent.parent.right;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,k(h,f)),f.parent.color=0,f.parent.parent.color=1,A(h,f.parent.parent))}else{const a=f.parent.parent.left;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,A(h,f)),f.parent.color=0,f.parent.parent.color=1,k(h,f.parent.parent))}h.root.color=0}function v(h,f,a,n){for(;f!==h.root&&f!==e.$GC;)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}function w(h,f){let a=0,n=0;if(f!==h.root){for(;f!==h.root&&f===f.parent.right;)f=f.parent;if(f!==h.root)for(f=f.parent,a=N(f.left)-f.size_left,n=p(f.left)-f.lf_left,f.size_left+=a,f.lf_left+=n;f!==h.root&&(a!==0||n!==0);)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}}}),define(Se[187],De([1,0,19,128]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=void 0;class L{constructor(m){this.a=m,this.b=new Uint32Array(m.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(m,k){m=(0,O.$6e)(m);const A=this.a,C=this.b,$=k.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,m),0),this.a.set(A.subarray(m),m+$),this.a.set(k,m),m-1<this.c[0]&&(this.c[0]=m-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(m,k){return m=(0,O.$6e)(m),k=(0,O.$6e)(k),this.a[m]===k?!1:(this.a[m]=k,m-1<this.c[0]&&(this.c[0]=m-1),!0)}removeValues(m,k){m=(0,O.$6e)(m),k=(0,O.$6e)(k);const A=this.a,C=this.b;if(m>=A.length)return!1;const $=A.length-m;return k>=$&&(k=$),k===0?!1:(this.a=new Uint32Array(A.length-k),this.a.set(A.subarray(0,m),0),this.a.set(A.subarray(m+k),m),this.b=new Uint32Array(this.a.length),m-1<this.c[0]&&(this.c[0]=m-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(m){return m<0?0:(m=(0,O.$6e)(m),this.d(m))}d(m){if(m<=this.c[0])return this.b[m];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),m>=this.a.length&&(m=this.a.length-1);for(let A=k;A<=m;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],m),this.b[m]}getIndexOf(m){m=Math.floor(m),this.getTotalSum();let k=0,A=this.a.length-1,C=0,$=0,v=0;for(;k<=A;)if(C=k+(A-k)/2|0,$=this.b[C],v=$-this.a[C],m<v)A=C-1;else if(m>=$)k=C+1;else break;return new N(C,m-v)}}e.$3v=L;class R{constructor(m){this.a=m,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(m){return this.g(),m===0?0:this.d[m-1]}getIndexOf(m){this.g();const k=this.e[m],A=k>0?this.d[k-1]:0;return new N(k,m-A)}removeValues(m,k){this.a.splice(m,k),this.f(m)}insertValues(m,k){this.a=(0,d.$Vb)(this.a,m,k),this.f(m)}f(m){this.b=!1,this.c=Math.min(this.c,m-1)}g(){if(!this.b){for(let m=this.c+1,k=this.a.length;m<k;m++){const A=this.a[m],C=m>0?this.d[m-1]:0;this.d[m]=C+A;for(let $=0;$<A;$++)this.e[C+$]=m}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(m,k){this.a[m]!==k&&(this.a[m]=k,this.f(m))}}e.$4v=R;class N{constructor(m,k){this.index=m,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=m,this.remainder=k}}e.$5v=N}),define(Se[188],De([1,0,14,51,187]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=void 0;class R{constructor(p,m,k,A){this.d=p,this.f=m,this.g=k,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const m=p.changes;for(const k of m)this.o(k.range),this.p(new O.$tt(k.range.startLineNumber,k.range.startColumn),k.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,m=this.f.length,k=new Uint32Array(m);for(let A=0;A<m;A++)k[A]=this.f[A].length+p;this.j=new L.$3v(k)}}n(p,m){this.f[p]=m,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,m){if(m.length===0)return;const k=(0,d.$kf)(m);if(k.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+k[0]+this.f[p.lineNumber-1].substring(p.column-1));return}k[k.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+k[0]);const A=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this.f.splice(p.lineNumber+C-1,0,k[C]),A[C-1]=k[C].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$6v=R}),define(Se[100],De([1,0,14,183,51,29,80]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$SC=e.$PC=void 0,e.$QC=k,e.$RC=A,e.$TC=h;const p=999;class m{constructor(n,i,l,o){this.searchString=n,this.isRegex=i,this.matchCase=l,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=k(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=d.$if(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let l=!this.isRegex&&!n;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new N.$Iv(i,this.wordSeparators?(0,O.$Lt)(this.wordSeparators,[]):null,l?this.searchString:null)}}e.$PC=m;function k(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const l=a.charCodeAt(n);if(l===10)return!0;if(l===92){if(n++,n>=i)break;const o=a.charCodeAt(n);if(o===110||o===114||o===87)return!0}}return!1}function A(a,n,i){if(!i)return new N.$Fv(a,null);const l=[];for(let o=0,t=n.length;o<t;o++)l[o]=n[o];return new N.$Fv(a,l)}class C{constructor(n){const i=[];let l=0;for(let o=0,t=n.length;o<t;o++)n.charCodeAt(o)===10&&(i[l++]=o);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let l=0,o=i.length-1;if(o===-1||n<=i[0])return 0;for(;l<o;){const t=l+((o-l)/2>>0);i[t]>=n?o=t-1:i[t+1]>=n?(l=t,o=t):l=t+1}return l+1}}class ${static findMatches(n,i,l,o,t){const u=i.parseSearchRequest();return u?u.regex.multiline?this.b(n,l,new f(u.wordSeparators,u.regex),o,t):this.c(n,l,u,o,t):[]}static a(n,i,l,o,t,u){let r,c=0;o?(c=o.findLineFeedCountBeforeOffset(t),r=i+t+c):r=i+t;let s;if(o){const g=o.findLineFeedCountBeforeOffset(t+u.length)-c;s=r+u.length+g}else s=r+u.length;const y=n.getPositionAt(r),b=n.getPositionAt(s);return new R.$ut(y.lineNumber,y.column,b.lineNumber,b.column)}static b(n,i,l,o,t){const u=n.getOffsetAt(i.getStartPosition()),r=n.getValueInRange(i,1),c=n.getEOL()===`\r
`?new C(r):null,s=[];let y=0,b;for(l.reset(0);b=l.next(r);)if(s[y++]=A(this.a(n,u,r,c,b.index,b[0]),b,o),y>=t)return s;return s}static c(n,i,l,o,t){const u=[];let r=0;if(i.startLineNumber===i.endLineNumber){const s=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return r=this.d(l,s,i.startLineNumber,i.startColumn-1,r,u,o,t),u}const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);r=this.d(l,c,i.startLineNumber,i.startColumn-1,r,u,o,t);for(let s=i.startLineNumber+1;s<i.endLineNumber&&r<t;s++)r=this.d(l,n.getLineContent(s),s,0,r,u,o,t);if(r<t){const s=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);r=this.d(l,s,i.endLineNumber,0,r,u,o,t)}return u}static d(n,i,l,o,t,u,r,c){const s=n.wordSeparators;if(!r&&n.simpleSearch){const S=n.simpleSearch,g=S.length,E=i.length;let D=-g;for(;(D=i.indexOf(S,D+g))!==-1;)if((!s||h(s,i,E,D,g))&&(u[t++]=new N.$Fv(new R.$ut(l,D+1+o,l,D+1+g+o),null),t>=c))return t;return t}const y=new f(n.wordSeparators,n.regex);let b;y.reset(0);do if(b=y.next(i),b&&(u[t++]=A(new R.$ut(l,b.index+1+o,l,b.index+1+b[0].length+o),b,r),t>=c))return t;while(b);return t}static findNextMatch(n,i,l,o){const t=i.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,l,u,o):this.f(n,l,u,o)}static e(n,i,l,o){const t=new L.$tt(i.lineNumber,1),u=n.getOffsetAt(t),r=n.getLineCount(),c=n.getValueInRange(new R.$ut(t.lineNumber,t.column,r,n.getLineMaxColumn(r)),1),s=n.getEOL()===`\r
`?new C(c):null;l.reset(i.column-1);const y=l.next(c);return y?A(this.a(n,u,c,s,y.index,y[0]),y,o):i.lineNumber!==1||i.column!==1?this.e(n,new L.$tt(1,1),l,o):null}static f(n,i,l,o){const t=n.getLineCount(),u=i.lineNumber,r=n.getLineContent(u),c=this.g(l,r,u,i.column,o);if(c)return c;for(let s=1;s<=t;s++){const y=(u+s-1)%t,b=n.getLineContent(y+1),S=this.g(l,b,y+1,1,o);if(S)return S}return null}static g(n,i,l,o,t){n.reset(o-1);const u=n.next(i);return u?A(new R.$ut(l,u.index+1,l,u.index+1+u[0].length),u,t):null}static findPreviousMatch(n,i,l,o){const t=i.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,l,u,o):this.j(n,l,u,o)}static h(n,i,l,o){const t=this.b(n,new R.$ut(1,1,i.lineNumber,i.column),l,o,10*p);if(t.length>0)return t[t.length-1];const u=n.getLineCount();return i.lineNumber!==u||i.column!==n.getLineMaxColumn(u)?this.h(n,new L.$tt(u,n.getLineMaxColumn(u)),l,o):null}static j(n,i,l,o){const t=n.getLineCount(),u=i.lineNumber,r=n.getLineContent(u).substring(0,i.column-1),c=this.k(l,r,u,o);if(c)return c;for(let s=1;s<=t;s++){const y=(t+u-s-1)%t,b=n.getLineContent(y+1),S=this.k(l,b,y+1,o);if(S)return S}return null}static k(n,i,l,o){let t=null,u;for(n.reset(0);u=n.next(i);)t=A(new R.$ut(l,u.index+1,l,u.index+1+u[0].length),u,o);return t}}e.$SC=$;function v(a,n,i,l,o){if(l===0)return!0;const t=n.charCodeAt(l-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const u=n.charCodeAt(l);if(a.get(u)!==0)return!0}return!1}function w(a,n,i,l,o){if(l+o===i)return!0;const t=n.charCodeAt(l+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const u=n.charCodeAt(l+o-1);if(a.get(u)!==0)return!0}return!1}function h(a,n,i,l,o){return v(a,n,i,l,o)&&w(a,n,i,l,o)}class f{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let l;do{if(this.b+this.c===i||(l=this.a.exec(n),!l))return null;const o=l.index,t=l[0].length;if(o===this.b&&t===this.c){if(t===0){d.$Ef(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||h(this._wordSeparators,n,i,o,t))return l}while(l);return null}}e.$UC=f}),define(Se[131],De([1,0,51,29,80,186,100]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=void 0,e.$VC=A,e.$WC=C;const p=65535;function m(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class k{constructor(n,i,l,o,t){this.lineStarts=n,this.cr=i,this.lf=l,this.crlf=o,this.isBasicASCII=t}}function A(a,n=!0){const i=[0];let l=1;for(let o=0,t=a.length;o<t;o++){const u=a.charCodeAt(o);u===13?o+1<t&&a.charCodeAt(o+1)===10?(i[l++]=o+2,o++):i[l++]=o+1:u===10&&(i[l++]=o+1)}return n?m(i):i}function C(a,n){a.length=0,a[0]=0;let i=1,l=0,o=0,t=0,u=!0;for(let c=0,s=n.length;c<s;c++){const y=n.charCodeAt(c);y===13?c+1<s&&n.charCodeAt(c+1)===10?(t++,a[i++]=c+2,c++):(l++,a[i++]=c+1):y===10?(o++,a[i++]=c+1):u&&y!==9&&(y<32||y>126)&&(u=!1)}const r=new k(m(a),l,o,t,u);return a.length=0,r}class ${constructor(n,i,l,o,t){this.bufferIndex=n,this.start=i,this.end=l,this.lineFeedCnt=o,this.length=t}}e.$XC=$;class v{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$YC=v;class w{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$GC&&n.iterate(n.root,l=>(l!==R.$GC&&this.a.push(l.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const l=this.b[i];if(l.nodeStartOffset<=n&&l.nodeStartOffset+l.node.piece.length>=n)return l}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const l=this.b[i];if(l.nodeStartLineNumber&&l.nodeStartLineNumber<n&&l.nodeStartLineNumber+l.node.piece.lineFeedCnt>=n)return l}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const l=this.b;for(let o=0;o<l.length;o++){const t=l[o];if(t.node.parent===null||t.nodeStartOffset>=n){l[o]=null,i=!0;continue}}if(i){const o=[];for(const t of l)t!==null&&o.push(t);this.b=o}}}class f{constructor(n,i,l){this.create(n,i,l)}create(n,i,l){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=R.$GC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=l;let o=null;for(let t=0,u=n.length;t<u;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const r=new $(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),o=this.S(o,r)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=p,l=i-Math.floor(i/3),o=l*2;let t="",u=0;const r=[];if(this.iterate(this.root,c=>{const s=this.R(c),y=s.length;if(u<=l||u+y<o)return t+=s,u+=y,!0;const b=t.replace(/\r\n|\r|\n/g,n);return r.push(new v(b,A(b))),t=s,u=y,!0}),u>0){const c=t.replace(/\r\n|\r|\n/g,n);r.push(new v(c,A(c)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new w(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,o=>{if(o===R.$GC)return!0;const t=this.R(o),u=t.length,r=n.G(i),c=n.G(i+u),s=n.getValueInRange2(r,c);return i+=u,t===s})}getOffsetAt(n,i){let l=0,o=this.root;for(;o!==R.$GC;)if(o.left!==R.$GC&&o.lf_left+1>=n)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=n){l+=o.size_left;const t=this.B(o,n-o.lf_left-2);return l+=t+i-1}else n-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;return l}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,l=0;const o=n;for(;i!==R.$GC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(l+=i.lf_left+t.index,t.index===0){const u=this.getOffsetAt(l+1,1),r=o-u;return new d.$tt(l+1,r+1)}return new d.$tt(l+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,l+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$GC){const t=this.getOffsetAt(l+1,1),u=o-n-t;return new d.$tt(l+1,u+1)}else i=i.right;return new d.$tt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const l=this.H(n.startLineNumber,n.startColumn),o=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(l,o);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const r=n.node,c=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);return c.substring(s+n.remainder,s+i.remainder)}let l=n.node;const o=this.a[l.piece.bufferIndex].buffer,t=this.u(l.piece.bufferIndex,l.piece.start);let u=o.substring(t+n.remainder,t+l.piece.length);for(l=l.next();l!==R.$GC;){const r=this.a[l.piece.bufferIndex].buffer,c=this.u(l.piece.bufferIndex,l.piece.start);if(l===i.node){u+=r.substring(c,c+i.remainder);break}else u+=r.substr(c,l.piece.length);l=l.next()}return u}getLinesContent(){const n=[];let i=0,l="",o=!1;return this.iterate(this.root,t=>{if(t===R.$GC)return!0;const u=t.piece;let r=u.length;if(r===0)return!0;const c=this.a[u.bufferIndex].buffer,s=this.a[u.bufferIndex].lineStarts,y=u.start.line,b=u.end.line;let S=s[y]+u.start.column;if(o&&(c.charCodeAt(S)===10&&(S++,r--),n[i++]=l,l="",o=!1,r===0))return!0;if(y===b)return!this.f&&c.charCodeAt(S+r-1)===13?(o=!0,l+=c.substr(S,r-1)):l+=c.substr(S,r),!0;l+=this.f?c.substring(S,Math.max(S,s[y+1]-this.e)):c.substring(S,s[y+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=l;for(let g=y+1;g<b;g++)l=this.f?c.substring(s[g],s[g+1]-this.e):c.substring(s[g],s[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=l;return!this.f&&c.charCodeAt(s[b]+u.end.column-1)===13?(o=!0,u.end.column===0?i--:l=c.substr(s[b],u.end.column-1)):l=c.substr(s[b],u.end.column),!0}),o&&(n[i++]=l,l=""),n[i++]=l,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const l=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start);return l.buffer.charCodeAt(o)}else{const i=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(o)}}getLineCharCode(n,i){const l=this.H(n,i+1);return this.l(l)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,l,o,t,u,r,c,s,y,b){const S=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),D=this.u(n.piece.bufferIndex,u);let P;const I={line:0,column:0};let F,T;i._wordSeparators?(F=S.buffer.substring(E,D),T=z=>z+E,i.reset(0)):(F=S.buffer,T=z=>z,i.reset(E));do if(P=i.next(F),P){if(T(P.index)>=D)return y;this.s(n,T(P.index)-g,I);const z=this.t(n.piece.bufferIndex,t,I),M=I.line===t.line?I.column-t.column+o:I.column+1,j=M+P[0].length;if(b[y++]=(0,N.$RC)(new O.$ut(l+z,M,l+z,j),P,c),T(P.index)+P[0].length>=D||y>=s)return y}while(P);return y}findMatchesLineByLine(n,i,l,o){const t=[];let u=0;const r=new N.$UC(i.wordSeparators,i.regex);let c=this.H(n.startLineNumber,n.startColumn);if(c===null)return[];const s=this.H(n.endLineNumber,n.endColumn);if(s===null)return[];let y=this.s(c.node,c.remainder);const b=this.s(s.node,s.remainder);if(c.node===s.node)return this.findMatchesInNode(c.node,r,n.startLineNumber,n.startColumn,y,b,i,l,o,u,t),t;let S=n.startLineNumber,g=c.node;for(;g!==s.node;){const D=this.t(g.piece.bufferIndex,y,g.piece.end);if(D>=1){const I=this.a[g.piece.bufferIndex].lineStarts,F=this.u(g.piece.bufferIndex,g.piece.start),T=I[y.line+D],z=S===n.startLineNumber?n.startColumn:1;if(u=this.findMatchesInNode(g,r,S,z,y,this.s(g,T-F),i,l,o,u,t),u>=o)return t;S+=D}const P=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const I=this.getLineContent(S).substring(P,n.endColumn-1);return u=this.n(i,r,I,n.endLineNumber,P,u,t,l,o),t}if(u=this.n(i,r,this.getLineContent(S).substr(P),S,P,u,t,l,o),u>=o)return t;S++,c=this.H(S,1),g=c.node,y=this.s(c.node,c.remainder)}if(S===n.endLineNumber){const D=S===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(S).substring(D,n.endColumn-1);return u=this.n(i,r,P,n.endLineNumber,D,u,t,l,o),t}const E=S===n.startLineNumber?n.startColumn:1;return u=this.findMatchesInNode(s.node,r,S,E,y,b,i,l,o,u,t),t}n(n,i,l,o,t,u,r,c,s){const y=n.wordSeparators;if(!c&&n.simpleSearch){const S=n.simpleSearch,g=S.length,E=l.length;let D=-g;for(;(D=l.indexOf(S,D+g))!==-1;)if((!y||(0,N.$TC)(y,l,E,D,g))&&(r[u++]=new L.$Fv(new O.$ut(o,D+1+t,o,D+1+g+t),null),u>=s))return u;return u}let b;i.reset(0);do if(b=i.next(l),b&&(r[u++]=(0,N.$RC)(new O.$ut(o,b.index+1+t,o,b.index+1+b[0].length+t),b,c),u>=s))return u;while(b);return u}insert(n,i,l=!1){if(this.f=this.f&&l,this.j.lineNumber=0,this.j.value="",this.root!==R.$GC){const{node:o,remainder:t,nodeStartOffset:u}=this.G(n),r=o.piece,c=r.bufferIndex,s=this.s(o,t);if(o.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&u+r.length===n&&i.length<p){this.F(o,i),this.y();return}if(u===n)this.o(i,o),this.h.validate(n);else if(u+o.piece.length>n){const y=[];let b=new $(r.bufferIndex,s,r.end,this.t(r.bufferIndex,s,r.end),this.u(c,r.end)-this.u(c,s));if(this.K()&&this.M(i)&&this.I(o,t)===10){const D={line:b.start.line+1,column:0};b=new $(b.bufferIndex,D,b.end,this.t(b.bufferIndex,D,b.end),b.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(o,t-1)===13){const D=this.s(o,t-1);this.C(o,D),i="\r"+i,o.piece.length===0&&y.push(o)}else this.C(o,s);else this.C(o,s);const S=this.w(i);b.length>0&&this.S(o,b);let g=o;for(let E=0;E<S.length;E++)g=this.S(g,S[E]);this.v(y)}else this.q(i,o)}else{const o=this.w(i);let t=this.T(null,o[0]);for(let u=1;u<o.length;u++)t=this.S(t,o[u])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$GC)return;const l=this.G(n),o=this.G(n+i),t=l.node,u=o.node;if(t===u){const S=this.s(t,l.remainder),g=this.s(t,o.remainder);if(l.nodeStartOffset===n){if(i===t.piece.length){const E=t.next();(0,R.$LC)(this,t),this.N(E),this.y();return}this.D(t,g),this.h.validate(n),this.N(t),this.y();return}if(l.nodeStartOffset+t.piece.length===n+i){this.C(t,S),this.O(t),this.y();return}this.E(t,S,g),this.y();return}const r=[],c=this.s(t,l.remainder);this.C(t,c),this.h.validate(n),t.piece.length===0&&r.push(t);const s=this.s(u,o.remainder);this.D(u,s),u.piece.length===0&&r.push(u);const y=t.next();for(let S=y;S!==R.$GC&&S!==u;S=S.next())r.push(S);const b=t.piece.length===0?t.prev():t;this.v(r),this.O(b),this.y()}o(n,i){const l=[];if(this.K()&&this.M(n)&&this.L(i)){const u=i.piece,r={line:u.start.line+1,column:0},c=new $(u.bufferIndex,r,u.end,this.t(u.bufferIndex,r,u.end),u.length-1);i.piece=c,n+=`
`,(0,R.$NC)(this,i,-1,-1),i.piece.length===0&&l.push(i)}const o=this.w(n);let t=this.T(i,o[o.length-1]);for(let u=o.length-2;u>=0;u--)t=this.T(t,o[u]);this.N(t),this.v(l)}q(n,i){this.Q(n,i)&&(n+=`
`);const l=this.w(n),o=this.S(i,l[0]);let t=o;for(let u=1;u<l.length;u++)t=this.S(t,l[u]);this.N(o)}s(n,i,l){const o=n.piece,t=n.piece.bufferIndex,u=this.a[t].lineStarts,c=u[o.start.line]+o.start.column+i;let s=o.start.line,y=o.end.line,b=0,S=0,g=0;for(;s<=y&&(b=s+(y-s)/2|0,g=u[b],b!==y);)if(S=u[b+1],c<g)y=b-1;else if(c>=S)s=b+1;else break;return l?(l.line=b,l.column=c-g,null):{line:b,column:c-g}}t(n,i,l){if(l.column===0)return l.line-i.line;const o=this.a[n].lineStarts;if(l.line===o.length-1)return l.line-i.line;const t=o[l.line+1],u=o[l.line]+l.column;if(t>u+1)return l.line-i.line;const r=u-1;return this.a[n].buffer.charCodeAt(r)===13?l.line-i.line+1:l.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$LC)(this,n[i])}w(n){if(n.length>p){const y=[];for(;n.length>p;){const S=n.charCodeAt(p-1);let g;S===13||S>=55296&&S<=56319?(g=n.substring(0,p-1),n=n.substring(p-1)):(g=n.substring(0,p),n=n.substring(p));const E=A(g);y.push(new $(this.a.length,{line:0,column:0},{line:E.length-1,column:g.length-E[E.length-1]},E.length-1,g.length)),this.a.push(new v(g,E))}const b=A(n);return y.push(new $(this.a.length,{line:0,column:0},{line:b.length-1,column:n.length-b[b.length-1]},b.length-1,n.length)),this.a.push(new v(n,b)),y}let i=this.a[0].buffer.length;const l=A(n,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let y=0;y<l.length;y++)l[y]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let y=0;y<l.length;y++)l[y]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[u],c={line:u,column:r},s=new $(0,o,c,this.t(0,o,c),t-i);return this.g=c,[s]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let l=this.root,o="";const t=this.h.get2(n);if(t){l=t.node;const u=this.B(l,n-t.nodeStartLineNumber-1),r=this.a[l.piece.bufferIndex].buffer,c=this.u(l.piece.bufferIndex,l.piece.start);if(t.nodeStartLineNumber+l.piece.lineFeedCnt===n)o=r.substring(c+u,c+l.piece.length);else{const s=this.B(l,n-t.nodeStartLineNumber);return r.substring(c+u,c+s-i)}}else{let u=0;const r=n;for(;l!==R.$GC;)if(l.left!==R.$GC&&l.lf_left>=n-1)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt>n-1){const c=this.B(l,n-l.lf_left-2),s=this.B(l,n-l.lf_left-1),y=this.a[l.piece.bufferIndex].buffer,b=this.u(l.piece.bufferIndex,l.piece.start);return u+=l.size_left,this.h.set({node:l,nodeStartOffset:u,nodeStartLineNumber:r-(n-1-l.lf_left)}),y.substring(b+c,b+s-i)}else if(l.lf_left+l.piece.lineFeedCnt===n-1){const c=this.B(l,n-l.lf_left-2),s=this.a[l.piece.bufferIndex].buffer,y=this.u(l.piece.bufferIndex,l.piece.start);o=s.substring(y+c,y+l.piece.length);break}else n-=l.lf_left+l.piece.lineFeedCnt,u+=l.size_left+l.piece.length,l=l.right}for(l=l.next();l!==R.$GC;){const u=this.a[l.piece.bufferIndex].buffer;if(l.piece.lineFeedCnt>0){const r=this.B(l,0),c=this.u(l.piece.bufferIndex,l.piece.start);return o+=u.substring(c,c+r-i),o}else{const r=this.u(l.piece.bufferIndex,l.piece.start);o+=u.substr(r,l.piece.length)}l=l.next()}return o}y(){let n=this.root,i=1,l=0;for(;n!==R.$GC;)i+=n.lf_left+n.piece.lineFeedCnt,l+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=l,this.h.validate(this.c)}A(n,i){const l=n.piece,o=this.s(n,i),t=o.line-l.start.line;if(this.u(l.bufferIndex,l.end)-this.u(l.bufferIndex,l.start)===i){const u=this.t(n.piece.bufferIndex,l.start,o);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:o.column}}B(n,i){if(i<0)return 0;const l=n.piece,o=this.a[l.bufferIndex].lineStarts,t=l.start.line+i+1;return t>l.end.line?o[l.end.line]+l.end.column-o[l.start.line]-l.start.column:o[t]-o[l.start.line]-l.start.column}C(n,i){const l=n.piece,o=l.lineFeedCnt,t=this.u(l.bufferIndex,l.end),u=i,r=this.u(l.bufferIndex,u),c=this.t(l.bufferIndex,l.start,u),s=c-o,y=r-t,b=l.length+y;n.piece=new $(l.bufferIndex,l.start,u,c,b),(0,R.$NC)(this,n,y,s)}D(n,i){const l=n.piece,o=l.lineFeedCnt,t=this.u(l.bufferIndex,l.start),u=i,r=this.t(l.bufferIndex,u,l.end),c=this.u(l.bufferIndex,u),s=r-o,y=t-c,b=l.length+y;n.piece=new $(l.bufferIndex,u,l.end,r,b),(0,R.$NC)(this,n,y,s)}E(n,i,l){const o=n.piece,t=o.start,u=o.end,r=o.length,c=o.lineFeedCnt,s=i,y=this.t(o.bufferIndex,o.start,s),b=this.u(o.bufferIndex,i)-this.u(o.bufferIndex,t);n.piece=new $(o.bufferIndex,o.start,s,y,b),(0,R.$NC)(this,n,b-r,y-c);const S=new $(o.bufferIndex,l,u,this.t(o.bufferIndex,l,u),this.u(o.bufferIndex,u)-this.u(o.bufferIndex,l)),g=this.S(n,S);this.N(g)}F(n,i){this.Q(i,n)&&(i+=`
`);const l=this.K()&&this.L(i)&&this.M(n),o=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let g=0;g<t.length;g++)t[g]+=o;if(l){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[u],c={line:u,column:r},s=n.piece.length+i.length,y=n.piece.lineFeedCnt,b=this.t(0,n.piece.start,c),S=b-y;n.piece=new $(n.piece.bufferIndex,n.piece.start,c,b,s),this.g=c,(0,R.$NC)(this,n,i.length,S)}G(n){let i=this.root;const l=this.h.get(n);if(l)return{node:l.node,nodeStartOffset:l.nodeStartOffset,remainder:n-l.nodeStartOffset};let o=0;for(;i!==R.$GC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){o+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:o};return this.h.set(t),t}else n-=i.size_left+i.piece.length,o+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let l=this.root,o=0;for(;l!==R.$GC;)if(l.left!==R.$GC&&l.lf_left>=n-1)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt>n-1){const t=this.B(l,n-l.lf_left-2),u=this.B(l,n-l.lf_left-1);return o+=l.size_left,{node:l,remainder:Math.min(t+i-1,u),nodeStartOffset:o}}else if(l.lf_left+l.piece.lineFeedCnt===n-1){const t=this.B(l,n-l.lf_left-2);if(t+i-1<=l.piece.length)return{node:l,remainder:t+i-1,nodeStartOffset:o};i-=l.piece.length-t;break}else n-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;for(l=l.next();l!==R.$GC;){if(l.piece.lineFeedCnt>0){const t=this.B(l,0),u=this.J(l);return{node:l,remainder:Math.min(i-1,t),nodeStartOffset:u}}else if(l.piece.length>=i-1){const t=this.J(l);return{node:l,remainder:i-1,nodeStartOffset:t}}else i-=l.piece.length;l=l.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const l=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start)+i;return l.buffer.charCodeAt(o)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$GC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,l=this.a[i.bufferIndex].lineStarts,o=i.start.line,t=l[o]+i.start.column;return o===l.length-1||l[o+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$GC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const l=[],o=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:o[n.piece.end.line]-o[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const u=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new $(n.piece.bufferIndex,n.piece.start,t,r,u),(0,R.$NC)(this,n,-1,-1),n.piece.length===0&&l.push(n);const c={line:i.piece.start.line+1,column:0},s=i.piece.length-1,y=this.t(i.piece.bufferIndex,c,i.piece.end);i.piece=new $(i.piece.bufferIndex,c,i.piece.end,y,s),(0,R.$NC)(this,i,-1,-1),i.piece.length===0&&l.push(i);const b=this.w(`\r
`);this.S(n,b[0]);for(let S=0;S<l.length;S++)(0,R.$LC)(this,l[S])}Q(n,i){if(this.K()&&this.M(n)){const l=i.next();if(this.L(l)){if(n+=`
`,l.piece.length===1)(0,R.$LC)(this,l);else{const o=l.piece,t={line:o.start.line+1,column:0},u=o.length-1,r=this.t(o.bufferIndex,t,o.end);l.piece=new $(o.bufferIndex,t,o.end,r,u),(0,R.$NC)(this,l,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$GC)return i(R.$GC);const l=this.iterate(n.left,i);return l&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$GC)return"";const i=this.a[n.piece.bufferIndex],l=n.piece,o=this.u(l.bufferIndex,l.start),t=this.u(l.bufferIndex,l.end);return i.buffer.substring(o,t)}getPieceContent(n){const i=this.a[n.bufferIndex],l=this.u(n.bufferIndex,n.start),o=this.u(n.bufferIndex,n.end);return i.buffer.substring(l,o)}S(n,i){const l=new R.$FC(i,1);if(l.left=R.$GC,l.right=R.$GC,l.parent=R.$GC,l.size_left=0,l.lf_left=0,this.root===R.$GC)this.root=l,l.color=0;else if(n.right===R.$GC)n.right=l,l.parent=n;else{const t=(0,R.$HC)(n.right);t.left=l,l.parent=t}return(0,R.$MC)(this,l),l}T(n,i){const l=new R.$FC(i,1);if(l.left=R.$GC,l.right=R.$GC,l.parent=R.$GC,l.size_left=0,l.lf_left=0,this.root===R.$GC)this.root=l,l.color=0;else if(n.left===R.$GC)n.left=l,l.parent=n;else{const o=(0,R.$IC)(n.left);o.right=l,l.parent=o}return(0,R.$MC)(this,l),l}U(n){let i="";return this.iterate(n,l=>(i+=this.R(l),!0)),i}}e.$ZC=f}),define(Se[189],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$=e.$v$=void 0;class d{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const N=this.a.get(R);return this.a.delete(R),N}}addDragOperationTransfer(R,N){this.a.set(R,N)}}e.$v$=d;class O{constructor(R){this.identifier=R}}e.$w$=O}),define(Se[190],De([1,0,4,3]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new d.$de,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,m){return this.a.set(p,m),this.handleChange([p]),(0,O.$Sc)(()=>{this.a.get(p)===m&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,m){this.b.get(p)?.dispose();const k=new R(this,p,m);return this.b.set(p,k),(0,O.$Sc)(()=>{const A=this.b.get(p);!A||A!==k||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const m=this.get(p);if(m)return m;const k=this.b.get(p);return!k||k.isResolved?null:(await k.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const k=this.b.get(p);return!!(!k||k.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Zt=L;class R extends O.$Uc{get isResolved(){return this.c}constructor(p,m,k){super(),this.f=p,this.g=m,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Se[191],De([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(Se[192],De([1,0,4,3,191]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=A;class R extends O.$Uc{constructor($,v="",w="",h=!0,f){super(),this.h=this.B(new d.$de),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=v,this.u=w,this.w=h,this.C=f}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,v){this.C&&await this.C($)}}e.$bj=R;class N extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new d.$de),this.onWillRun=this.f.event,this.m=this.B(new d.$de),this.onDidRun=this.m.event}async run($,v){if(!$.enabled)return;this.f.fire({action:$});let w;try{await this.u($,v)}catch(h){w=h}this.m.fire({action:$,error:w})}async u($,v){await $.run(v)}}e.$cj=N;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let v=[];for(const w of $)w.length&&(v.length?v=[...v,new p,...w]:v=w);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=p;class m{get actions(){return this.a}constructor($,v,w,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=v,this.class=h,this.a=w}async run(){}}e.$ej=m;class k extends R{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,L.localize(0,null),void 0,!1)}}e.$fj=k;function A(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...$)=>C.run(...$),tooltip:C.label}}}),define(Se[193],De([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(Se[194],De([1,0,193]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=k,e.$3m=A,e.$4m=C;const O=60,L=O*60,R=L*24,N=R*7,p=R*30,m=R*365;function k($,v,w,h){typeof $!="number"&&($=$.getTime());const f=Math.round((new Date().getTime()-$)/1e3);if(f<-30)return(0,d.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(!h&&f<30)return(0,d.localize)(1,null);let a;return f<O?(a=f,v?a===1?w?(0,d.localize)(2,null,a):(0,d.localize)(3,null,a):w?(0,d.localize)(4,null,a):(0,d.localize)(5,null,a):a===1?w?(0,d.localize)(6,null,a):(0,d.localize)(7,null,a):w?(0,d.localize)(8,null,a):(0,d.localize)(9,null,a)):f<L?(a=Math.floor(f/O),v?a===1?w?(0,d.localize)(10,null,a):(0,d.localize)(11,null,a):w?(0,d.localize)(12,null,a):(0,d.localize)(13,null,a):a===1?w?(0,d.localize)(14,null,a):(0,d.localize)(15,null,a):w?(0,d.localize)(16,null,a):(0,d.localize)(17,null,a)):f<R?(a=Math.floor(f/L),v?a===1?w?(0,d.localize)(18,null,a):(0,d.localize)(19,null,a):w?(0,d.localize)(20,null,a):(0,d.localize)(21,null,a):a===1?w?(0,d.localize)(22,null,a):(0,d.localize)(23,null,a):w?(0,d.localize)(24,null,a):(0,d.localize)(25,null,a)):f<N?(a=Math.floor(f/R),v?a===1?(0,d.localize)(26,null,a):(0,d.localize)(27,null,a):a===1?(0,d.localize)(28,null,a):(0,d.localize)(29,null,a)):f<p?(a=Math.floor(f/N),v?a===1?w?(0,d.localize)(30,null,a):(0,d.localize)(31,null,a):w?(0,d.localize)(32,null,a):(0,d.localize)(33,null,a):a===1?w?(0,d.localize)(34,null,a):(0,d.localize)(35,null,a):w?(0,d.localize)(36,null,a):(0,d.localize)(37,null,a)):f<m?(a=Math.floor(f/p),v?a===1?w?(0,d.localize)(38,null,a):(0,d.localize)(39,null,a):w?(0,d.localize)(40,null,a):(0,d.localize)(41,null,a):a===1?w?(0,d.localize)(42,null,a):(0,d.localize)(43,null,a):w?(0,d.localize)(44,null,a):(0,d.localize)(45,null,a)):(a=Math.floor(f/m),v?a===1?w?(0,d.localize)(46,null,a):(0,d.localize)(47,null,a):w?(0,d.localize)(48,null,a):(0,d.localize)(49,null,a):a===1?w?(0,d.localize)(50,null,a):(0,d.localize)(51,null,a):w?(0,d.localize)(52,null,a):(0,d.localize)(53,null,a))}function A($,v){const w=Math.abs($/1e3);return w<1?v?(0,d.localize)(54,null,$):(0,d.localize)(55,null,$):w<O?v?(0,d.localize)(56,null,Math.round($)/1e3):(0,d.localize)(57,null,Math.round($)/1e3):w<L?v?(0,d.localize)(58,null,Math.round($/(1e3*O))):(0,d.localize)(59,null,Math.round($/(1e3*O))):w<R?v?(0,d.localize)(60,null,Math.round($/(1e3*L))):(0,d.localize)(61,null,Math.round($/(1e3*L))):(0,d.localize)(62,null,Math.round($/(1e3*R)))}function C($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[195],De([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(Se[47],De([1,0,19,18,195]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=m,e.$ij=k,e.$jj=A;function R(C,$){return $&&(C.stack||C.stacktrace)?L.localize(0,null,p(C),N(C.stack)||N(C.stacktrace)):p(C)}function N(C){return Array.isArray(C)?C.join(`
`):C}function p(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function m(C=null,$=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const v=d.$Hb(C),w=m(v[0],$);return v.length>1?L.localize(4,null,w,v.length):w}if(O.$9f(C))return C;if(C.detail){const v=C.detail;if(v.error)return R(v.error,$);if(v.exception)return R(v.exception,$)}return C.stack?R(C,$):C.message?C.message:L.localize(5,null)}function k(C){const $=C;return $ instanceof Error&&Array.isArray($.actions)}function A(C,$){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=$,v}}),define(Se[196],De([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(Se[12],De([1,0,196]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=u,e.$D=S,e.$J=g,e.$g="en";let O=!1,L=!1,R=!1,N=!1,p=!1,m=!1,k=!1,A=!1,C=!1,$=!1,v,w=e.$g,h=e.$g,f,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const l=typeof i?.versions?.electron=="string",o=l&&i?.type==="renderer";if(typeof i=="object"){O=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",N=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,k=l,C=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,w=e.$g;const E=i.env.VSCODE_NLS_CONFIG;if(E)try{const D=JSON.parse(E),P=D.availableLanguages["*"];v=D.locale,h=D.osLocale,w=P||e.$g,f=D._translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,O=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,A=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,$=a?.indexOf("Mobi")>=0,m=!0,v=d.getConfiguredDefaultLocale(d.localize(0,null))||e.$g,w=v,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;L?r=1:O?r=3:R&&(r=2),e.$i=O,e.$j=L,e.$k=R,e.$l=N,e.$m=p,e.$n=k,e.$o=m,e.$p=m&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=$,e.$t=C,e.$u=r,e.$v=a,e.$w=w;var c;(function(E){function D(){return e.$w}E.value=D;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=P;function I(){return e.$w==="en"}E.isDefault=I})(c||(e.Language=c={})),e.$x=v,e.$y=h,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const E=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,F=E.length;I<F;I++){const T=E[I];if(T.id===P.data.vscodeScheduleAsyncWork){E.splice(I,1),T.callback();return}}});let D=0;return P=>{const I=++D;E.push({id:I,callback:P}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return E=>setTimeout(E)})();var s;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=L||A?2:O?1:3;let y=!0,b=!1;function S(){if(!b){b=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,y=new Uint16Array(E.buffer)[0]===513}return y}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function g(E){return parseFloat(E)>=20}}),define(Se[52],De([1,0,12]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;O={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return d.$i?"win32":d.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(Se[17],De([1,0,52]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,L=97,R=90,N=122,p=46,m=47,k=92,A=58,C=63;class $ extends Error{constructor(u,r,c){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const y=u.indexOf(".")!==-1?"property":"argument";let b=`The "${u}" ${y} ${s} of type ${r}`;b+=`. Received type ${typeof c}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,u){if(t===null||typeof t!="object")throw new $(u,"Object",t)}function w(t,u){if(typeof t!="string")throw new $(u,"string",t)}const h=d.$dc==="win32";function f(t){return t===m||t===k}function a(t){return t===m}function n(t){return t>=O&&t<=R||t>=L&&t<=N}function i(t,u,r,c){let s="",y=0,b=-1,S=0,g=0;for(let E=0;E<=t.length;++E){if(E<t.length)g=t.charCodeAt(E);else{if(c(g))break;g=m}if(c(g)){if(!(b===E-1||S===1))if(S===2){if(s.length<2||y!==2||s.charCodeAt(s.length-1)!==p||s.charCodeAt(s.length-2)!==p){if(s.length>2){const D=s.lastIndexOf(r);D===-1?(s="",y=0):(s=s.slice(0,D),y=s.length-1-s.lastIndexOf(r)),b=E,S=0;continue}else if(s.length!==0){s="",y=0,b=E,S=0;continue}}u&&(s+=s.length>0?`${r}..`:"..",y=2)}else s.length>0?s+=`${r}${t.slice(b+1,E)}`:s=t.slice(b+1,E),y=E-b-1;b=E,S=0}else g===p&&S!==-1?++S:S=-1}return s}function l(t,u){v(u,"pathObject");const r=u.dir||u.root,c=u.base||`${u.name||""}${u.ext||""}`;return r?r===u.root?`${r}${c}`:`${r}${t}${c}`:c}e.$fc={resolve(...t){let u="",r="",c=!1;for(let s=t.length-1;s>=-1;s--){let y;if(s>=0){if(y=t[s],w(y,"path"),y.length===0)continue}else u.length===0?y=d.cwd():(y=d.env[`=${u}`]||d.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==u.toLowerCase()&&y.charCodeAt(2)===k)&&(y=`${u}\\`));const b=y.length;let S=0,g="",E=!1;const D=y.charCodeAt(0);if(b===1)f(D)&&(S=1,E=!0);else if(f(D))if(E=!0,f(y.charCodeAt(1))){let P=2,I=P;for(;P<b&&!f(y.charCodeAt(P));)P++;if(P<b&&P!==I){const F=y.slice(I,P);for(I=P;P<b&&f(y.charCodeAt(P));)P++;if(P<b&&P!==I){for(I=P;P<b&&!f(y.charCodeAt(P));)P++;(P===b||P!==I)&&(g=`\\\\${F}\\${y.slice(I,P)}`,S=P)}}}else S=1;else n(D)&&y.charCodeAt(1)===A&&(g=y.slice(0,2),S=2,b>2&&f(y.charCodeAt(2))&&(E=!0,S=3));if(g.length>0)if(u.length>0){if(g.toLowerCase()!==u.toLowerCase())continue}else u=g;if(c){if(u.length>0)break}else if(r=`${y.slice(S)}\\${r}`,c=E,E&&u.length>0)break}return r=i(r,!c,"\\",f),c?`${u}\\${r}`:`${u}${r}`||"."},normalize(t){w(t,"path");const u=t.length;if(u===0)return".";let r=0,c,s=!1;const y=t.charCodeAt(0);if(u===1)return a(y)?"\\":t;if(f(y))if(s=!0,f(t.charCodeAt(1))){let S=2,g=S;for(;S<u&&!f(t.charCodeAt(S));)S++;if(S<u&&S!==g){const E=t.slice(g,S);for(g=S;S<u&&f(t.charCodeAt(S));)S++;if(S<u&&S!==g){for(g=S;S<u&&!f(t.charCodeAt(S));)S++;if(S===u)return`\\\\${E}\\${t.slice(g)}\\`;S!==g&&(c=`\\\\${E}\\${t.slice(g,S)}`,r=S)}}}else r=1;else n(y)&&t.charCodeAt(1)===A&&(c=t.slice(0,2),r=2,u>2&&f(t.charCodeAt(2))&&(s=!0,r=3));let b=r<u?i(t.slice(r),!s,"\\",f):"";return b.length===0&&!s&&(b="."),b.length>0&&f(t.charCodeAt(u-1))&&(b+="\\"),c===void 0?s?`\\${b}`:b:s?`${c}\\${b}`:`${c}${b}`},isAbsolute(t){w(t,"path");const u=t.length;if(u===0)return!1;const r=t.charCodeAt(0);return f(r)||u>2&&n(r)&&t.charCodeAt(1)===A&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,r;for(let y=0;y<t.length;++y){const b=t[y];w(b,"path"),b.length>0&&(u===void 0?u=r=b:u+=`\\${b}`)}if(u===void 0)return".";let c=!0,s=0;if(typeof r=="string"&&f(r.charCodeAt(0))){++s;const y=r.length;y>1&&f(r.charCodeAt(1))&&(++s,y>2&&(f(r.charCodeAt(2))?++s:c=!1))}if(c){for(;s<u.length&&f(u.charCodeAt(s));)s++;s>=2&&(u=`\\${u.slice(s)}`)}return e.$fc.normalize(u)},relative(t,u){if(w(t,"from"),w(u,"to"),t===u)return"";const r=e.$fc.resolve(t),c=e.$fc.resolve(u);if(r===c||(t=r.toLowerCase(),u=c.toLowerCase(),t===u))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===k;)s++;let y=t.length;for(;y-1>s&&t.charCodeAt(y-1)===k;)y--;const b=y-s;let S=0;for(;S<u.length&&u.charCodeAt(S)===k;)S++;let g=u.length;for(;g-1>S&&u.charCodeAt(g-1)===k;)g--;const E=g-S,D=b<E?b:E;let P=-1,I=0;for(;I<D;I++){const T=t.charCodeAt(s+I);if(T!==u.charCodeAt(S+I))break;T===k&&(P=I)}if(I!==D){if(P===-1)return c}else{if(E>D){if(u.charCodeAt(S+I)===k)return c.slice(S+I+1);if(I===2)return c.slice(S+I)}b>D&&(t.charCodeAt(s+I)===k?P=I:I===2&&(P=3)),P===-1&&(P=0)}let F="";for(I=s+P+1;I<=y;++I)(I===y||t.charCodeAt(I)===k)&&(F+=F.length===0?"..":"\\..");return S+=P,F.length>0?`${F}${c.slice(S,g)}`:(c.charCodeAt(S)===k&&++S,c.slice(S,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$fc.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===k){if(u.charCodeAt(1)===k){const r=u.charCodeAt(2);if(r!==C&&r!==p)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(n(u.charCodeAt(0))&&u.charCodeAt(1)===A&&u.charCodeAt(2)===k)return`\\\\?\\${u}`;return t},dirname(t){w(t,"path");const u=t.length;if(u===0)return".";let r=-1,c=0;const s=t.charCodeAt(0);if(u===1)return f(s)?t:".";if(f(s)){if(r=c=1,f(t.charCodeAt(1))){let S=2,g=S;for(;S<u&&!f(t.charCodeAt(S));)S++;if(S<u&&S!==g){for(g=S;S<u&&f(t.charCodeAt(S));)S++;if(S<u&&S!==g){for(g=S;S<u&&!f(t.charCodeAt(S));)S++;if(S===u)return t;S!==g&&(r=c=S+1)}}}}else n(s)&&t.charCodeAt(1)===A&&(r=u>2&&f(t.charCodeAt(2))?3:2,c=r);let y=-1,b=!0;for(let S=u-1;S>=c;--S)if(f(t.charCodeAt(S))){if(!b){y=S;break}}else b=!1;if(y===-1){if(r===-1)return".";y=r}return t.slice(0,y)},basename(t,u){u!==void 0&&w(u,"ext"),w(t,"path");let r=0,c=-1,s=!0,y;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(r=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let b=u.length-1,S=-1;for(y=t.length-1;y>=r;--y){const g=t.charCodeAt(y);if(f(g)){if(!s){r=y+1;break}}else S===-1&&(s=!1,S=y+1),b>=0&&(g===u.charCodeAt(b)?--b===-1&&(c=y):(b=-1,c=S))}return r===c?c=S:c===-1&&(c=t.length),t.slice(r,c)}for(y=t.length-1;y>=r;--y)if(f(t.charCodeAt(y))){if(!s){r=y+1;break}}else c===-1&&(s=!1,c=y+1);return c===-1?"":t.slice(r,c)},extname(t){w(t,"path");let u=0,r=-1,c=0,s=-1,y=!0,b=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(u=c=2);for(let S=t.length-1;S>=u;--S){const g=t.charCodeAt(S);if(f(g)){if(!y){c=S+1;break}continue}s===-1&&(y=!1,s=S+1),g===p?r===-1?r=S:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||s===-1||b===0||b===1&&r===s-1&&r===c+1?"":t.slice(r,s)},format:l.bind(null,"\\"),parse(t){w(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.length;let c=0,s=t.charCodeAt(0);if(r===1)return f(s)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(f(s)){if(c=1,f(t.charCodeAt(1))){let P=2,I=P;for(;P<r&&!f(t.charCodeAt(P));)P++;if(P<r&&P!==I){for(I=P;P<r&&f(t.charCodeAt(P));)P++;if(P<r&&P!==I){for(I=P;P<r&&!f(t.charCodeAt(P));)P++;P===r?c=P:P!==I&&(c=P+1)}}}}else if(n(s)&&t.charCodeAt(1)===A){if(r<=2)return u.root=u.dir=t,u;if(c=2,f(t.charCodeAt(2))){if(r===3)return u.root=u.dir=t,u;c=3}}c>0&&(u.root=t.slice(0,c));let y=-1,b=c,S=-1,g=!0,E=t.length-1,D=0;for(;E>=c;--E){if(s=t.charCodeAt(E),f(s)){if(!g){b=E+1;break}continue}S===-1&&(g=!1,S=E+1),s===p?y===-1?y=E:D!==1&&(D=1):y!==-1&&(D=-1)}return S!==-1&&(y===-1||D===0||D===1&&y===S-1&&y===b+1?u.base=u.name=t.slice(b,S):(u.name=t.slice(b,y),u.base=t.slice(b,S),u.ext=t.slice(y,S))),b>0&&b!==c?u.dir=t.slice(0,b-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(h){const t=/\\/g;return()=>{const u=d.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>d.cwd()})();e.$gc={resolve(...t){let u="",r=!1;for(let c=t.length-1;c>=-1&&!r;c--){const s=c>=0?t[c]:o();w(s,"path"),s.length!==0&&(u=`${s}/${u}`,r=s.charCodeAt(0)===m)}return u=i(u,!r,"/",a),r?`/${u}`:u.length>0?u:"."},normalize(t){if(w(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===m,r=t.charCodeAt(t.length-1)===m;return t=i(t,!u,"/",a),t.length===0?u?"/":r?"./":".":(r&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return w(t,"path"),t.length>0&&t.charCodeAt(0)===m},join(...t){if(t.length===0)return".";let u;for(let r=0;r<t.length;++r){const c=t[r];w(c,"path"),c.length>0&&(u===void 0?u=c:u+=`/${c}`)}return u===void 0?".":e.$gc.normalize(u)},relative(t,u){if(w(t,"from"),w(u,"to"),t===u||(t=e.$gc.resolve(t),u=e.$gc.resolve(u),t===u))return"";const r=1,c=t.length,s=c-r,y=1,b=u.length-y,S=s<b?s:b;let g=-1,E=0;for(;E<S;E++){const P=t.charCodeAt(r+E);if(P!==u.charCodeAt(y+E))break;P===m&&(g=E)}if(E===S)if(b>S){if(u.charCodeAt(y+E)===m)return u.slice(y+E+1);if(E===0)return u.slice(y+E)}else s>S&&(t.charCodeAt(r+E)===m?g=E:E===0&&(g=0));let D="";for(E=r+g+1;E<=c;++E)(E===c||t.charCodeAt(E)===m)&&(D+=D.length===0?"..":"/..");return`${D}${u.slice(y+g)}`},toNamespacedPath(t){return t},dirname(t){if(w(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===m;let r=-1,c=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===m){if(!c){r=s;break}}else c=!1;return r===-1?u?"/":".":u&&r===1?"//":t.slice(0,r)},basename(t,u){u!==void 0&&w(u,"ext"),w(t,"path");let r=0,c=-1,s=!0,y;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let b=u.length-1,S=-1;for(y=t.length-1;y>=0;--y){const g=t.charCodeAt(y);if(g===m){if(!s){r=y+1;break}}else S===-1&&(s=!1,S=y+1),b>=0&&(g===u.charCodeAt(b)?--b===-1&&(c=y):(b=-1,c=S))}return r===c?c=S:c===-1&&(c=t.length),t.slice(r,c)}for(y=t.length-1;y>=0;--y)if(t.charCodeAt(y)===m){if(!s){r=y+1;break}}else c===-1&&(s=!1,c=y+1);return c===-1?"":t.slice(r,c)},extname(t){w(t,"path");let u=-1,r=0,c=-1,s=!0,y=0;for(let b=t.length-1;b>=0;--b){const S=t.charCodeAt(b);if(S===m){if(!s){r=b+1;break}continue}c===-1&&(s=!1,c=b+1),S===p?u===-1?u=b:y!==1&&(y=1):u!==-1&&(y=-1)}return u===-1||c===-1||y===0||y===1&&u===c-1&&u===r+1?"":t.slice(u,c)},format:l.bind(null,"/"),parse(t){w(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.charCodeAt(0)===m;let c;r?(u.root="/",c=1):c=0;let s=-1,y=0,b=-1,S=!0,g=t.length-1,E=0;for(;g>=c;--g){const D=t.charCodeAt(g);if(D===m){if(!S){y=g+1;break}continue}b===-1&&(S=!1,b=g+1),D===p?s===-1?s=g:E!==1&&(E=1):s!==-1&&(E=-1)}if(b!==-1){const D=y===0&&r?1:y;s===-1||E===0||E===1&&s===b-1&&s===y+1?u.base=u.name=t.slice(D,b):(u.name=t.slice(D,s),u.base=t.slice(D,b),u.ext=t.slice(s,b))}return y>0?u.dir=t.slice(0,y-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(Se[132],De([1,0,46,17]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=p,e.$hr=m,e.$ir=k,e.$jr=A,e.$kr=C,e.$lr=$,e.$mr=v,e.$nr=w,e.$or=h,e.$pr=f,e.$qr=s,e.$rr=y,e.$sr=b;const L=new d.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),N=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(S,g,E=!1){const D=S||"",P=g||"",I=L.value.collator.compare(D,P);return L.value.collatorIsNumeric&&I===0&&D!==P?D<P?-1:1:I}function m(S,g){const E=R.value.collator;return S=S||"",g=g||"",l(E,S,g)}function k(S,g){const E=R.value.collator;return S=S||"",g=g||"",r(S,g)||l(E,S,g)}function A(S,g){const E=R.value.collator;return S=S||"",g=g||"",u(S,g)||l(E,S,g)}function C(S,g){return S=S||"",g=g||"",S===g?0:S<g?-1:1}function $(S,g){const[E,D]=n(S),[P,I]=n(g);let F=L.value.collator.compare(D,I);if(F===0){if(L.value.collatorIsNumeric&&D!==I)return D<I?-1:1;if(F=L.value.collator.compare(E,P),L.value.collatorIsNumeric&&F===0&&E!==P)return E<P?-1:1}return F}function v(S,g){S=S||"",g=g||"";const E=i(S),D=i(g),P=R.value.collator,I=N.value.collator;return l(I,E,D)||l(P,S,g)}function w(S,g){S=S||"",g=g||"";const E=i(S),D=i(g),P=R.value.collator,I=N.value.collator;return l(I,E,D)||r(S,g)||l(P,S,g)}function h(S,g){S=S||"",g=g||"";const E=i(S),D=i(g),P=R.value.collator,I=N.value.collator;return l(I,E,D)||u(S,g)||l(P,S,g)}function f(S,g){S=S||"",g=g||"";const E=i(S).toLowerCase(),D=i(g).toLowerCase();return E!==D?E<D?-1:1:S!==g?S<g?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(S,g=!1){const E=S?a.exec(S):[];let D=[E&&E[1]||"",E&&E[3]||""];return g&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function i(S){const g=S?a.exec(S):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function l(S,g,E){const D=S.compare(g,E);return D!==0?D:g.length!==E.length?g.length<E.length?-1:1:0}function o(S){const g=S.charAt(0);return g.toLocaleUpperCase()!==g}function t(S){const g=S.charAt(0);return g.toLocaleLowerCase()!==g}function u(S,g){return o(S)&&t(g)?-1:t(S)&&o(g)?1:0}function r(S,g){return t(S)&&o(g)?-1:o(S)&&t(g)?1:0}function c(S,g,E=!1){return E||(S=S&&S.toLowerCase(),g=g&&g.toLowerCase()),S===g?0:S<g?-1:1}function s(S,g,E=!1){const D=S.split(O.sep),P=g.split(O.sep),I=D.length-1,F=P.length-1;let T,z;for(let M=0;;M++){if(T=I===M,z=F===M,T&&z)return p(D[M],P[M],E);if(T)return-1;if(z)return 1;const j=c(D[M],P[M],E);if(j!==0)return j}}function y(S,g,E){const D=S.toLowerCase(),P=g.toLowerCase(),I=b(S,g,E);if(I)return I;const F=D.endsWith(E),T=P.endsWith(E);if(F!==T)return F?-1:1;const z=p(D,P);return z!==0?z:D.localeCompare(P)}function b(S,g,E){const D=S.toLowerCase(),P=g.toLowerCase(),I=D.startsWith(E),F=P.startsWith(E);if(I!==F)return I?-1:1;if(I&&F){if(D.length<P.length)return-1;if(D.length>P.length)return 1}return 0}}),define(Se[31],De([1,0,17,12,14,18]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=N,e.$pg=p,e.$qg=m,e.$rg=k,e.$sg=A,e.$tg=w,e.$ug=h,e.$vg=f,e.$wg=a,e.$xg=n,e.$yg=i,e.$zg=l,e.$Ag=o,e.$Bg=t,e.$Cg=u,e.$Dg=r,e.$Eg=y;function N(b){return b===47||b===92}function p(b){return b.replace(/[\\/]/g,d.$gc.sep)}function m(b){return b.indexOf("/")===-1&&(b=p(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function k(b,S=d.$gc.sep){if(!b)return"";const g=b.length,E=b.charCodeAt(0);if(N(E)){if(N(b.charCodeAt(1))&&!N(b.charCodeAt(2))){let P=3;const I=P;for(;P<g&&!N(b.charCodeAt(P));P++);if(I!==P&&!N(b.charCodeAt(P+1))){for(P+=1;P<g;P++)if(N(b.charCodeAt(P)))return b.slice(0,P+1).replace(/[\\/]/g,S)}}return S}else if(a(E)&&b.charCodeAt(1)===58)return N(b.charCodeAt(2))?b.slice(0,2)+S:b.slice(0,2);let D=b.indexOf("://");if(D!==-1){for(D+=3;D<g;D++)if(N(b.charCodeAt(D)))return b.slice(0,D+1)}return""}function A(b){if(!O.$i||!b||b.length<5)return!1;let S=b.charCodeAt(0);if(S!==92||(S=b.charCodeAt(1),S!==92))return!1;let g=2;const E=g;for(;g<b.length&&(S=b.charCodeAt(g),S!==92);g++);return!(E===g||(S=b.charCodeAt(g+1),isNaN(S)||S===92))}const C=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(b,S=O.$i){const g=S?C:$;return!(!b||b.length===0||/^\s+$/.test(b)||(g.lastIndex=0,g.test(b))||S&&v.test(b)||b==="."||b===".."||S&&b[b.length-1]==="."||S&&b.length!==b.trim().length||b.length>255)}function h(b,S,g){const E=b===S;return!g||E?E:!b||!S?!1:(0,L.$xf)(b,S)}function f(b,S,g,E=d.sep){if(b===S)return!0;if(!b||!S||S.length>b.length)return!1;if(g){if(!(0,L.$yf)(b,S))return!1;if(S.length===b.length)return!0;let P=S.length;return S.charAt(S.length-1)===E&&P--,b.charAt(P)===E}return S.charAt(S.length-1)!==E&&(S+=E),b.indexOf(S)===0}function a(b){return b>=65&&b<=90||b>=97&&b<=122}function n(b,S){return O.$i&&b.endsWith(":")&&(b+=d.sep),(0,d.$ic)(b)||(b=(0,d.$jc)(S,b)),b=(0,d.$hc)(b),i(b)}function i(b){return O.$i?(b=(0,L.$ff)(b,d.sep),b.endsWith(":")&&(b+=d.sep)):(b=(0,L.$ff)(b,d.sep),b||(b=d.sep)),b}function l(b){const S=(0,d.$hc)(b);return O.$i?b.length>3?!1:o(S)&&(b.length===2||S.charCodeAt(2)===92):S===d.$gc.sep}function o(b,S=O.$i){return S?a(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function t(b,S=O.$i){return o(b,S)?b[0]:void 0}function u(b,S,g){return S.length>b.length?-1:b===S?0:(g&&(b=b.toLowerCase(),S=S.toLowerCase()),b.indexOf(S))}function r(b){const S=b.split(":");let g,E,D;for(const P of S){const I=Number(P);(0,R.$ag)(I)?E===void 0?E=I:D===void 0&&(D=I):g=g?[g,P].join(":"):P}if(!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:E!==void 0?E:void 0,column:D!==void 0?D:E!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(b,S,g=8){let E="";for(let P=0;P<g;P++){let I;P===0&&O.$i&&!S&&(g===3||g===4)?I=s:I=c,E+=I.charAt(Math.floor(Math.random()*I.length))}let D;return S?D=`${S}-${E}`:D=E,b?(0,d.$jc)(b,D):D}}),define(Se[133],De([1,0,132,127,57,17,12,14]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=A,e.$ur=f,e.$vr=r,e.$wr=E,e.$xr=z,e.$yr=j;const m=0,k=[m,[]];function A(U,Z,ie,Q){if(!U||!Z)return k;const G=U.length,x=Z.length;if(G<x)return k;const ne=U.toLowerCase();return C(Z,ie,x,U,ne,G,Q)}function C(U,Z,ie,Q,G,x,ne){const be=[],ae=[];for(let _=0;_<ie;_++){const pe=_*x,ue=pe-x,ce=_>0,oe=U[_],le=Z[_];for(let J=0;J<x;J++){const se=J>0,$e=pe+J,ve=$e-1,Re=ue+J-1,ge=se?be[ve]:0,Ie=ce&&se?be[Re]:0,Ae=ce&&se?ae[Re]:0;let ze;!Ie&&ce?ze=0:ze=$(oe,le,Q,G,J,Ae),ze&&Ie+ze>=ge&&(ne||ce||G.startsWith(Z,J))?(ae[$e]=Ae+1,be[$e]=Ie+ze):(ae[$e]=m,be[$e]=ge)}}const Ce=[];let ee=ie-1,B=x-1;for(;ee>=0&&B>=0;){const _=ee*x+B;ae[_]===m||(Ce.push(B),ee--),B--}return[be[ie*x-1],Ce.reverse()]}function $(U,Z,ie,Q,G,x){let ne=0;if(!v(Z,Q[G]))return ne;if(ne+=1,x>0&&(ne+=x*5),U===ie[G]&&(ne+=1),G===0)ne+=8;else{const be=w(ie.charCodeAt(G-1));be?ne+=be:(0,O.$Bk)(ie.charCodeAt(G))&&x===0&&(ne+=2)}return ne}function v(U,Z){return U===Z?!0:U==="/"||U==="\\"?Z==="/"||Z==="\\":!1}function w(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function f(U,Z,ie=0,Q=0){const G=Z;return G.values&&G.values.length>1?a(U,G.values,ie,Q):n(U,Z,ie,Q)}function a(U,Z,ie,Q){let G=0;const x=[];for(const ne of Z){const[be,ae]=n(U,ne,ie,Q);if(typeof be!="number")return h;G+=be,x.push(...ae)}return[G,S(x)]}function n(U,Z,ie,Q){const G=(0,O.$Kk)(Z.original,Z.originalLowercase,ie,U,U.toLowerCase(),Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,O.$Hk)(G)]:h}const i=Object.freeze({score:0}),l=1<<18,o=1<<17,t=65536;function u(U,Z,ie,Q){const G=Q.values?Q.values:[Q];return(0,L.$kj)({[Q.normalized]:{values:G.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:Z,allowNonContiguousMatches:ie}})}function r(U,Z,ie,Q,G){if(!U||!Z.normalized)return i;const x=Q.getItemLabel(U);if(!x)return i;const ne=Q.getItemDescription(U),be=u(x,ne,ie,Z),ae=G[be];if(ae)return ae;const Ce=c(x,ne,Q.getItemPath(U),Z,ie);return G[be]=Ce,Ce}function c(U,Z,ie,Q,G){const x=!ie||!Q.containsPathSeparator;return ie&&(N.$k?Q.pathNormalized===ie:(0,p.$xf)(Q.pathNormalized,ie))?{score:l,labelMatch:[{start:0,end:U.length}],descriptionMatch:Z?[{start:0,end:Z.length}]:void 0}:Q.values&&Q.values.length>1?s(U,Z,ie,Q.values,x,G):y(U,Z,ie,Q,x,G)}function s(U,Z,ie,Q,G,x){let ne=0;const be=[],ae=[];for(const Ce of Q){const{score:ee,labelMatch:B,descriptionMatch:_}=y(U,Z,ie,Ce,G,x);if(ee===m)return i;ne+=ee,B&&be.push(...B),_&&ae.push(..._)}return{score:ne,labelMatch:S(be),descriptionMatch:S(ae)}}function y(U,Z,ie,Q,G,x){if(G||!Z){const[ne,be]=A(U,Q.normalized,Q.normalizedLowercase,x&&!Q.expectContiguousMatch);if(ne){const ae=(0,O.$yk)(Q.normalized,U);let Ce;if(ae){Ce=o;const ee=Math.round(Q.normalized.length/U.length*100);Ce+=ee}else Ce=t;return{score:Ce+ne,labelMatch:ae||b(be)}}}if(Z){let ne=Z;ie&&(ne=`${Z}${R.sep}`);const be=ne.length,ae=`${ne}${U}`,[Ce,ee]=A(ae,Q.normalized,Q.normalizedLowercase,x&&!Q.expectContiguousMatch);if(Ce){const B=b(ee),_=[],pe=[];return B.forEach(ue=>{ue.start<be&&ue.end>be?(_.push({start:0,end:ue.end-be}),pe.push({start:ue.start,end:be})):ue.start>=be?_.push({start:ue.start-be,end:ue.end-be}):pe.push(ue)}),{score:Ce,labelMatch:_,descriptionMatch:pe}}}return i}function b(U){const Z=[];if(!U)return Z;let ie;for(const Q of U)ie&&ie.end===Q?ie.end+=1:(ie={start:Q,end:Q+1},Z.push(ie));return Z}function S(U){const Z=U.sort((G,x)=>G.start-x.start),ie=[];let Q;for(const G of Z)!Q||!g(Q,G)?(Q=G,ie.push(G)):(Q.start=Math.min(Q.start,G.start),Q.end=Math.max(Q.end,G.end));return ie}function g(U,Z){return!(U.end<Z.start||Z.end<U.start)}function E(U,Z,ie,Q,G,x){const ne=r(U,ie,Q,G,x),be=r(Z,ie,Q,G,x),ae=ne.score,Ce=be.score;if((ae===l||Ce===l)&&ae!==Ce)return ae===l?-1:1;if(ae>t||Ce>t){if(ae!==Ce)return ae>Ce?-1:1;if(ae<o&&Ce<o){const oe=P(ne.labelMatch,be.labelMatch);if(oe!==0)return oe}const ue=G.getItemLabel(U)||"",ce=G.getItemLabel(Z)||"";if(ue.length!==ce.length)return ue.length-ce.length}if(ae!==Ce)return ae>Ce?-1:1;const ee=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,B=Array.isArray(be.labelMatch)&&be.labelMatch.length>0;if(ee&&!B)return-1;if(B&&!ee)return 1;const _=D(U,ne,G),pe=D(Z,be,G);return _&&pe&&_!==pe?pe>_?-1:1:I(U,Z,ie,G)}function D(U,Z,ie){let Q=-1,G=-1;if(Z.descriptionMatch&&Z.descriptionMatch.length?Q=Z.descriptionMatch[0].start:Z.labelMatch&&Z.labelMatch.length&&(Q=Z.labelMatch[0].start),Z.labelMatch&&Z.labelMatch.length){if(G=Z.labelMatch[Z.labelMatch.length-1].end,Z.descriptionMatch&&Z.descriptionMatch.length){const x=ie.getItemDescription(U);x&&(G+=x.length)}}else Z.descriptionMatch&&Z.descriptionMatch.length&&(G=Z.descriptionMatch[Z.descriptionMatch.length-1].end);return G-Q}function P(U,Z){if(!U&&!Z||(!U||!U.length)&&(!Z||!Z.length))return 0;if(!Z||!Z.length)return-1;if(!U||!U.length)return 1;const ie=U[0].start,G=U[U.length-1].end-ie,x=Z[0].start,be=Z[Z.length-1].end-x;return G===be?0:be<G?1:-1}function I(U,Z,ie,Q){const G=Q.getItemLabel(U)||"",x=Q.getItemLabel(Z)||"",ne=Q.getItemDescription(U),be=Q.getItemDescription(Z),ae=G.length+(ne?ne.length:0),Ce=x.length+(be?be.length:0);if(ae!==Ce)return ae-Ce;const ee=Q.getItemPath(U),B=Q.getItemPath(Z);return ee&&B&&ee.length!==B.length?ee.length-B.length:G!==x?(0,d.$rr)(G,x,ie.normalized):ne&&be&&ne!==be?(0,d.$rr)(ne,be,ie.normalized):ee&&B&&ee!==B?(0,d.$rr)(ee,B,ie.normalized):0}function F(U){return U.startsWith('"')&&U.endsWith('"')}const T=" ";function z(U){typeof U!="string"&&(U="");const Z=U.toLowerCase(),{pathNormalized:ie,normalized:Q,normalizedLowercase:G}=M(U),x=ie.indexOf(R.sep)>=0,ne=F(U);let be;const ae=U.split(T);if(ae.length>1)for(const Ce of ae){const ee=F(Ce),{pathNormalized:B,normalized:_,normalizedLowercase:pe}=M(Ce);_&&(be||(be=[]),be.push({original:Ce,originalLowercase:Ce.toLowerCase(),pathNormalized:B,normalized:_,normalizedLowercase:pe,expectContiguousMatch:ee}))}return{original:U,originalLowercase:Z,pathNormalized:ie,normalized:Q,normalizedLowercase:G,values:be,containsPathSeparator:x,expectContiguousMatch:ne}}function M(U){let Z;N.$i?Z=U.replace(/\//g,R.sep):Z=U.replace(/\\/g,R.sep);const ie=(0,p.$hf)(Z).replace(/\s|"/g,"");return{pathNormalized:Z,normalized:ie,normalizedLowercase:ie.toLowerCase()}}function j(U){return Array.isArray(U)?z(U.map(Z=>Z.original).join(T)):z(U.original)}}),define(Se[101],De([1,0,17]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=R,e.$Ss=N,e.$Ts=p,e.$Us=k,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const C=(0,d.$oc)(A),$=O[C.toLowerCase()];return $!==void 0?$:N(A)}function N(A){const C=(0,d.$oc)(A);return L[C.toLowerCase()]}function p(A){for(const C in L)if(L[C]===A)return C}const m=/^(.+)\/(.+?)(;.+)?$/;function k(A,C){const $=m.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:C?void 0:A}}),define(Se[102],De([1,0,12]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=R,e.$nm=N;var O;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(O||(e.Source=O={}));var L;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(p,...m){const k=m.reduce(($,v)=>($[v]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter($=>!k[$]).forEach($=>{for(let v=0;v<A.length;v++)if($.search(A[v])!==-1){delete p[$];break}})}function N(p){p&&(delete p.DEBUG,d.$j&&delete p.DYLD_LIBRARY_PATH,d.$k&&delete p.LD_PRELOAD)}}),define(Se[2],De([1,0,17,12]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=w,e.$wc=l;const L=/^\w[\w\d+.-]*$/,R=/^\//,N=/^\/\//;function p(c,s){if(!c.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!L.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!R.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(c,s){return!c&&!s?"file":c}function k(c,s){switch(c){case"https":case"http":case"file":s?s[0]!==C&&(s=C+s):s=C;break}return s}const A="",C="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(s){return s instanceof v?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,y,b,S,g,E=!1){typeof s=="object"?(this.scheme=s.scheme||A,this.authority=s.authority||A,this.path=s.path||A,this.query=s.query||A,this.fragment=s.fragment||A):(this.scheme=m(s,E),this.authority=y||A,this.path=k(this.scheme,b||A),this.query=S||A,this.fragment=g||A,p(this,E))}get fsPath(){return l(this,!1)}with(s){if(!s)return this;let{scheme:y,authority:b,path:S,query:g,fragment:E}=s;return y===void 0?y=this.scheme:y===null&&(y=A),b===void 0?b=this.authority:b===null&&(b=A),S===void 0?S=this.path:S===null&&(S=A),g===void 0?g=this.query:g===null&&(g=A),E===void 0?E=this.fragment:E===null&&(E=A),y===this.scheme&&b===this.authority&&S===this.path&&g===this.query&&E===this.fragment?this:new f(y,b,S,g,E)}static parse(s,y=!1){const b=$.exec(s);return b?new f(b[2]||A,r(b[4]||A),r(b[5]||A),r(b[7]||A),r(b[9]||A),y):new f(A,A,A,A,A)}static file(s){let y=A;if(O.$i&&(s=s.replace(/\\/g,C)),s[0]===C&&s[1]===C){const b=s.indexOf(C,2);b===-1?(y=s.substring(2),s=C):(y=s.substring(2,b),s=s.substring(b)||C)}return new f("file",y,s,A,A)}static from(s,y){return new f(s.scheme,s.authority,s.path,s.query,s.fragment,y)}static joinPath(s,...y){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return O.$i&&s.scheme==="file"?b=v.file(d.$fc.join(l(s,!0),...y)).path:b=d.$gc.join(s.path,...y),s.with({path:b})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof v)return s;{const y=new f(s);return y._formatted=s.external??null,y._fsPath=s._sep===h?s.fsPath??null:null,y}}else return s}}e.URI=v;function w(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const h=O.$i?1:void 0;class f extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(c,s,y){let b,S=-1;for(let g=0;g<c.length;g++){const E=c.charCodeAt(g);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||s&&E===47||y&&E===91||y&&E===93||y&&E===58)S!==-1&&(b+=encodeURIComponent(c.substring(S,g)),S=-1),b!==void 0&&(b+=c.charAt(g));else{b===void 0&&(b=c.substr(0,g));const D=a[E];D!==void 0?(S!==-1&&(b+=encodeURIComponent(c.substring(S,g)),S=-1),b+=D):S===-1&&(S=g)}}return S!==-1&&(b+=encodeURIComponent(c.substring(S))),b!==void 0?b:c}function i(c){let s;for(let y=0;y<c.length;y++){const b=c.charCodeAt(y);b===35||b===63?(s===void 0&&(s=c.substr(0,y)),s+=a[b]):s!==void 0&&(s+=c[y])}return s!==void 0?s:c}function l(c,s){let y;return c.authority&&c.path.length>1&&c.scheme==="file"?y=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?s?y=c.path.substr(1):y=c.path[1].toLowerCase()+c.path.substr(2):y=c.path,O.$i&&(y=y.replace(/\//g,"\\")),y}function o(c,s){const y=s?i:n;let b="",{scheme:S,authority:g,path:E,query:D,fragment:P}=c;if(S&&(b+=S,b+=":"),(g||S==="file")&&(b+=C,b+=C),g){let I=g.indexOf("@");if(I!==-1){const F=g.substr(0,I);g=g.substr(I+1),I=F.lastIndexOf(":"),I===-1?b+=y(F,!1,!1):(b+=y(F.substr(0,I),!1,!1),b+=":",b+=y(F.substr(I+1),!1,!0)),b+="@"}g=g.toLowerCase(),I=g.lastIndexOf(":"),I===-1?b+=y(g,!1,!0):(b+=y(g.substr(0,I),!1,!0),b+=g.substr(I))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const I=E.charCodeAt(1);I>=65&&I<=90&&(E=`/${String.fromCharCode(I+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const I=E.charCodeAt(0);I>=65&&I<=90&&(E=`${String.fromCharCode(I+32)}:${E.substr(2)}`)}b+=y(E,!0,!1)}return D&&(b+="?",b+=y(D,!1,!1)),P&&(b+="#",b+=s?P:n(P,!1,!1)),b}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(c){return c.match(u)?c.replace(u,s=>t(s)):c}}),define(Se[197],De([1,0,2]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=O,e.$Wq=L,e.$Xq=R,e.log=p;function O(k){const A=k;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(k){const A=[];let C;try{const $=JSON.parse(k.arguments),v=$[$.length-1];v&&v.__$stack&&($.pop(),C=v.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",k.arguments)}return{args:A,stack:C}}function R(k){if(typeof k!="string")return R(L(k).stack);const A=k;if(A){const C=N(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if($&&$.length===4)return{uri:d.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function N(k){if(!k)return k;const A=k.indexOf(`
`);return A===-1?k:k.substring(0,A)}function p(k,A){const{args:C,stack:$}=L(k),v=typeof C[0]=="string"&&C.length===1;let w=N($);w&&(w=`(${w.trim()})`);let h=[];if(typeof C[0]=="string"?w&&v?h=[`%c[${A}] %c${C[0]} %c${w}`,m("blue"),m(""),m("grey")]:h=[`%c[${A}] %c${C[0]}`,m("blue"),m(""),...C.slice(1)]:h=[`%c[${A}]%`,m("blue"),...C],w&&!v&&h.push(w),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,h)}function m(k){return`color: ${k}`}}),define(Se[58],De([1,0,21,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=L,e.$5h=R,e.$6h=p;function L(m){return JSON.stringify(m,N)}function R(m){let k=JSON.parse(m);return k=p(k),k}function N(m,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function p(m,k=0){if(!m||k>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof d.$Fe||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let A=0;A<m.length;++A)m[A]=p(m[A],k+1);else for(const A in m)Object.hasOwnProperty.call(m,A)&&(m[A]=p(m[A],k+1))}return m}}),define(Se[15],De([1,0,13,12,14,2,17]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=m,e.$Gg=k,e.$Kg=C;var p;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(p||(e.Schemas=p={}));function m(w,h){return R.URI.isUri(w)?(0,L.$xf)(w.scheme,h):(0,L.$yf)(w,h+":")}function k(w,...h){return h.some(f=>m(w,f))}e.$Hg="vscode-tkn",e.$Ig="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,f){this.f=C(h,f)}getServerRootPath(){return this.f}get g(){return N.$gc.join(this.f,p.vscodeRemoteResource)}set(h,f,a){this.a[h]=f,this.b[h]=a}setConnectionToken(h,f){this.c[h]=f}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(o){return d.$1(o),h}const f=h.authority;let a=this.a[f];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[f],i=this.c[f];let l=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(l+=`&${e.$Ig}=${encodeURIComponent(i)}`),R.URI.from({scheme:O.$o?this.d:p.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:l})}}e.$Jg=new A;function C(w,h){return N.$gc.join(h??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class ${static{this.a=e.$Pg}asBrowserUri(h){const f=this.b(h,he);return this.uriToBrowserUri(f)}uriToBrowserUri(h){return h.scheme===p.vscodeRemote?e.$Jg.rewrite(h):h.scheme===p.file&&(O.$m||O.$q===`${p.vscodeFileResource}://${$.a}`)?h.with({scheme:p.vscodeFileResource,authority:h.authority||$.a,query:null,fragment:null}):h}asFileUri(h){const f=this.b(h,he);return this.uriToFileUri(f)}uriToFileUri(h){return h.scheme===p.vscodeFileResource?h.with({scheme:p.file,authority:h.authority!==$.a?h.authority:null,query:null,fragment:null}):h}b(h,f){return R.URI.isUri(h)?h:R.URI.parse(f.toUrl(h))}}e.$Qg=new $;var v;(function(w){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(h.get("3"));const f="vscode-coi";function a(i){let l;typeof i=="string"?l=new URL(i).searchParams:i instanceof URL?l=i.searchParams:R.URI.isUri(i)&&(l=new URL(i.toString(!0)).searchParams);const o=l?.get(f);if(o)return h.get(o)}w.getHeadersFromQuery=a;function n(i,l,o){if(!globalThis.crossOriginIsolated)return;const t=l&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(f,t):i[f]=t}w.addSearchParam=n})(v||(e.COI=v={}))}),define(Se[198],De([1,0,163,15,12,2]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=A;class N{constructor($,v,w){this.id=$,this.dependencies=v,this.callback=w}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,v,w)=>{typeof $!="string"&&(w=v,v=$,$=null),(typeof v!="object"||!Array.isArray(v))&&(w=v,v=null),this.c.push(new N($,v,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const v=await(this.a?this.i($):this.b?this.h($):this.j($));if(!v)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h($){return new Promise((v,w)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const f=()=>{h.removeEventListener("load",a),h.removeEventListener("error",n)},a=i=>{f(),v(this.c.pop())},n=i=>{f(),w(i)};h.addEventListener("load",a),h.addEventListener("error",n),this.f&&($=this.f.createScriptURL($)),h.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(h)})}i($){return new Promise((v,w)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),v(this.c.pop())}catch(h){w(h)}})}async j($){try{const v=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,f=R.URI.parse($).fsPath,a=v.readFileSync(f).toString(),n=h.wrap(a.replace(/^#!.*/,""));return new w.Script(n).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const m=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function A(C,$,v){if(d.$T){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[C]&&(C=k[C]);const w=`${C}/${$}`;if(m.has(w))return m.get(w);let h;if(/^\w[\w\d+.-]*:\/\//.test(w))h=w;else{const i=`${v&&!L.$o?O.$Ng:O.$Mg}/${w}`;h=O.$Qg.asBrowserUri(i).toString(!0)}const f=p.INSTANCE.load(h);return m.set(w,f),f}else return await new Promise((w,h)=>{he([C],w,h)})}}),define(Se[23],De([1,0,31,15,17,12,14,2]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=m,e.$gh=A,e.$hh=$;function m(v){return(0,p.$wc)(v,!0)}class k{constructor(w){this.a=w}compare(w,h,f=!1){return w===h?0:(0,N.$qf)(this.getComparisonKey(w,f),this.getComparisonKey(h,f))}isEqual(w,h,f=!1){return w===h?!0:!w||!h?!1:this.getComparisonKey(w,f)===this.getComparisonKey(h,f)}getComparisonKey(w,h=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,h,f=!1){if(w.scheme===h.scheme){if(w.scheme===O.Schemas.file)return d.$vg(m(w),m(h),this.a(w))&&w.query===h.query&&(f||w.fragment===h.fragment);if((0,e.$ch)(w.authority,h.authority))return d.$vg(w.path,h.path,this.a(w),"/")&&w.query===h.query&&(f||w.fragment===h.fragment)}return!1}joinPath(w,...h){return p.URI.joinPath(w,...h)}basenameOrAuthority(w){return(0,e.$7g)(w)||w.authority}basename(w){return L.$gc.basename(w.path)}extname(w){return L.$gc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let h;return w.scheme===O.Schemas.file?h=p.URI.file(L.$mc(m(w))).path:(h=L.$gc.dirname(w.path),w.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),h="/")),w.with({path:h})}normalizePath(w){if(!w.path.length)return w;let h;return w.scheme===O.Schemas.file?h=p.URI.file(L.$hc(m(w))).path:h=L.$gc.normalize(w.path),w.with({path:h})}relativePath(w,h){if(w.scheme!==h.scheme||!(0,e.$ch)(w.authority,h.authority))return;if(w.scheme===O.Schemas.file){const n=L.$lc(m(w),m(h));return R.$i?d.$pg(n):n}let f=w.path||"/";const a=h.path||"/";if(this.a(w)){let n=0;for(const i=Math.min(f.length,a.length);n<i&&!(f.charCodeAt(n)!==a.charCodeAt(n)&&f.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);f=a.substr(0,n)+f.substr(n)}return L.$gc.relative(f,a)}resolvePath(w,h){if(w.scheme===O.Schemas.file){const f=p.URI.file(L.$kc(m(w),h));return w.with({authority:f.authority,path:f.path})}return h=d.$qg(h),w.with({path:L.$gc.resolve(w.path,h)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,h){return w===h||w!==void 0&&h!==void 0&&(0,N.$xf)(w,h)}hasTrailingPathSeparator(w,h=L.sep){if(w.scheme===O.Schemas.file){const f=m(w);return f.length>d.$rg(f).length&&f[f.length-1]===h}else{const f=w.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,h=L.sep){return(0,e.$dh)(w,h)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,h=L.sep){let f=!1;if(w.scheme===O.Schemas.file){const a=m(w);f=a!==void 0&&a.length===d.$rg(a).length&&a[a.length-1]===h}else{h="/";const a=w.path;f=a.length===1&&a.charCodeAt(a.length-1)===47}return!f&&!(0,e.$dh)(w,h)?w.with({path:w.path+"/"}):w}}e.$Yg=k,e.$Zg=new k(()=>!1),e.$1g=new k(v=>v.scheme===O.Schemas.file?!R.$k:!0),e.$2g=new k(v=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function A(v,w){const h=[];for(let f=0;f<v.length;f++){const a=w(v[f]);v.some((n,i)=>i===f?!1:(0,e.$4g)(a,w(n)))||h.push(v[f])}return h}var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function w(h){const f=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[l,o]=i.split(":");l&&o&&f.set(l,o)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&f.set(v.META_DATA_MIME,n),f}v.parseMetaData=w})(C||(e.DataUri=C={}));function $(v,w,h){if(w){let f=v.path;return f&&f[0]!==L.$gc.sep&&(f=L.$gc.sep+f),v.with({scheme:h,authority:w,path:f})}return v.with({scheme:h})}}),define(Se[7],De([1,0,22,13,4,3,23,12,174,46]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=A,e.$jh=C,e.$kh=$,e.$lh=v,e.$mh=w,e.$nh=h,e.$oh=f,e.$ph=a,e.$xh=y,e.$yh=b,e.$zh=S,e.$Ah=g,e.$Bh=E,e.$Qh=G,e.$Yh=ce;function A(le){return!!le&&typeof le.then=="function"}function C(le){const J=new d.$oe,se=le(J.token),$e=new Promise((ve,Re)=>{const ge=J.token.onCancellationRequested(()=>{ge.dispose(),Re(new O.$5)});Promise.resolve(se).then(Ie=>{ge.dispose(),J.dispose(),ve(Ie)},Ie=>{ge.dispose(),J.dispose(),Re(Ie)})});return new class{cancel(){J.cancel(),J.dispose()}then(ve,Re){return $e.then(ve,Re)}catch(ve){return this.then(void 0,ve)}finally(ve){return $e.finally(ve)}}}function $(le,J,se){return new Promise(($e,ve)=>{const Re=J.onCancellationRequested(()=>{Re.dispose(),$e(se)});le.then($e,ve).finally(()=>Re.dispose())})}function v(le,J){return new Promise((se,$e)=>{const ve=J.onCancellationRequested(()=>{ve.dispose(),$e(new O.$5)});le.then(se,$e).finally(()=>ve.dispose())})}async function w(le){let J=-1;const se=le.map(($e,ve)=>$e.then(Re=>(J=ve,Re)));try{return await Promise.race(se)}finally{le.forEach(($e,ve)=>{ve!==J&&$e.cancel()})}}function h(le,J,se){let $e;const ve=setTimeout(()=>{$e?.(void 0),se?.()},J);return Promise.race([le.finally(()=>clearTimeout(ve)),new Promise(Re=>$e=Re)])}function f(le){return new Promise((J,se)=>{const $e=le();A($e)?$e.then(J,se):J($e)})}function a(){let le,J;return{promise:new Promise(($e,ve)=>{le=$e,J=ve}),resolve:le,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const se=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(se,se).then($e)})}return new Promise((se,$e)=>{this.b.then(se,$e)})}return this.a=J(),new Promise((se,$e)=>{this.a.then(ve=>{this.a=null,se(ve)},ve=>{this.a=null,$e(ve)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$rh=i;class l{constructor(){this.a=new Map}queue(J,se){const ve=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(J)===ve&&this.a.delete(J)});return this.a.set(J,ve),ve}}e.$sh=l;const o=(le,J)=>{let se=!0;const $e=setTimeout(()=>{se=!1,J()},le);return{isTriggered:()=>se,dispose:()=>{clearTimeout($e),se=!1}}},t=le=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,le())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class u{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,se=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ve,Re)=>{this.d=ve,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=se===m.$ae?t($e):o(se,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=u;class r{constructor(J){this.a=new u(J),this.b=new n}trigger(J,se){return this.a.trigger(()=>this.b.queue(J),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=r;class c{constructor(){this.a=!1,this.b=new Promise((J,se)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=c;class s extends c{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$wh=s;function y(le,J){return J?new Promise((se,$e)=>{const ve=setTimeout(()=>{Re.dispose(),se()},le),Re=J.onCancellationRequested(()=>{clearTimeout(ve),Re.dispose(),$e(new O.$5)})}):C(se=>y(le,se))}function b(le,J=0,se){const $e=setTimeout(()=>{le(),se&&ve.dispose()},J),ve=(0,R.$Sc)(()=>{clearTimeout($e),se?.deleteAndLeak(ve)});return se?.add(ve),ve}function S(le){const J=[];let se=0;const $e=le.length;function ve(){return se<$e?le[se++]():null}function Re(ge){ge!=null&&J.push(ge);const Ie=ve();return Ie?Ie.then(Re):Promise.resolve(J)}return Promise.resolve(null).then(Re)}function g(le,J=$e=>!!$e,se=null){let $e=0;const ve=le.length,Re=()=>{if($e>=ve)return Promise.resolve(se);const ge=le[$e++];return Promise.resolve(ge()).then(Ae=>J(Ae)?Promise.resolve(Ae):Re())};return Re()}function E(le,J=$e=>!!$e,se=null){if(le.length===0)return Promise.resolve(se);let $e=le.length;const ve=()=>{$e=-1;for(const Re of le)Re.cancel?.()};return new Promise((Re,ge)=>{for(const Ie of le)Ie.then(Ae=>{--$e>=0&&J(Ae)?(ve(),Re(Ae)):$e===0&&Re(se)}).catch(Ae=>{--$e>=0&&(ve(),ge(Ae))})})}class D{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new L.$de}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,$e)=>{this.g.push({factory:J,c:se,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const se=J.factory();se.then(J.c,J.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=D;class P extends D{constructor(){super(1)}}e.$Dh=P;class I{constructor(){this.a=new x,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Eh=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ae;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,se=N.$Zg){const $e=se.getComparisonKey(J);return this.a.get($e)?.size??0}queueFor(J,se,$e=N.$Zg){const ve=$e.getComparisonKey(J);let Re=this.a.get(ve);if(!Re){Re=new P;const ge=this.f++,Ie=L.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(ve),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(ge,Ie),this.a.set(ve,Re)}return Re.queue(se)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=F;class T{constructor(J,se){this.a=-1,typeof J=="function"&&typeof se=="number"&&this.setIfNotSet(J,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},se)}setIfNotSet(J,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},se))}}e.$Gh=T;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,se,$e=globalThis){this.cancel();const ve=$e.setInterval(()=>{J()},se);this.d=(0,R.$Sc)(()=>{$e.clearInterval(ve),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=z;class M{constructor(J,se){this.b=-1,this.a=J,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=M;class j{constructor(J,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=J,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=j;class U extends M{constructor(J,se){super(J,se),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Kh=U;class Z extends R.$Uc{constructor(J,se){super(),this.g=J,this.h=se,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of J)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(le,J)=>{(0,p.$B)(()=>{if(se)return;const $e=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Nh=(le,J,se)=>{const $e=le.requestIdleCallback(J,typeof se=="number"?{timeout:se}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,le.cancelIdleCallback($e))}}},e.$Mh=le=>(0,e.$Nh)(globalThis,le)}();class ie{constructor(J,se){this.g=!1,this.d=()=>{try{this.j=se()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Nh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ie;class Q extends ie{constructor(J){super(globalThis,J)}}e.$Ph=Q;async function G(le,J,se){let $e;for(let ve=0;ve<se;ve++)try{return await le()}catch(Re){$e=Re,await y(J)}throw $e}class x{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,se,$e){return this.a={taskId:J,cancel:()=>$e?.(),promise:se},se.then(()=>this.d(J),()=>this.d(J)),se}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:se,resolve:$e,reject:ve}=a();this.b={run:J,promise:se,promiseResolve:$e,promiseReject:ve}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=x;class ne{constructor(J,se=()=>Date.now()){this.d=J,this.f=se,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Sh=ne;var be;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(be||(be={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,se)=>{this.a=J,this.b=se})}complete(J){return new Promise(se=>{this.a(J),this.d={outcome:0,value:J},se()})}error(J){return new Promise(se=>{this.b(J),this.d={outcome:1,value:J},se()})}cancel(){return this.error(new O.$5)}}e.$Th=ae;var Ce;(function(le){async function J($e){let ve;const Re=await Promise.all($e.map(ge=>ge.then(Ie=>Ie,Ie=>{ve||(ve=Ie)})));if(typeof ve<"u")throw ve;return Re}le.settled=J;function se($e){return new Promise(async(ve,Re)=>{try{await $e(ve,Re)}catch(ge){Re(ge)}})}le.withAsyncBody=se})(Ce||(e.Promises=Ce={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=ee;class B{constructor(J){this.b=J,this.a=new k.$V(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=B;var _;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(_||(_={}));class pe{static fromArray(J){return new pe(se=>{se.emitMany(J)})}static fromPromise(J){return new pe(async se=>{se.emitMany(await J)})}static fromPromises(J){return new pe(async se=>{await Promise.all(J.map(async $e=>se.emitOne(await $e)))})}static merge(J){return new pe(async se=>{await Promise.all(J.map(async $e=>{for await(const ve of $e)se.emitOne(ve)}))})}static{this.EMPTY=pe.fromArray([])}constructor(J,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new L.$de,queueMicrotask(async()=>{const $e={emitOne:ve=>this.h(ve),emitMany:ve=>this.j(ve),reject:ve=>this.l(ve)};try{await Promise.resolve(J($e)),this.k()}catch(ve){this.l(ve)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,se){return new pe(async $e=>{for await(const ve of J)$e.emitOne(se(ve))})}map(J){return pe.map(this,J)}static filter(J,se){return new pe(async $e=>{for await(const ve of J)se(ve)&&$e.emitOne(ve)})}filter(J){return pe.filter(this,J)}static coalesce(J){return pe.filter(J,se=>!!se)}coalesce(){return pe.coalesce(this)}static async toPromise(J){const se=[];for await(const $e of J)se.push($e);return se}toPromise(){return pe.toPromise(this)}h(J){this.a===0&&(this.b.push(J),this.g.fire())}j(J){this.a===0&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(J){this.a===0&&(this.a=2,this.d=J,this.g.fire())}}e.$Wh=pe;class ue extends pe{constructor(J,se){super(se),this.m=J}cancel(){this.m.cancel()}}e.$Xh=ue;function ce(le){const J=new d.$oe,se=le(J.token);return new ue(J,async $e=>{const ve=J.token.onCancellationRequested(()=>{ve.dispose(),J.dispose(),$e.reject(new O.$5)});try{for await(const Re of se){if(J.token.isCancellationRequested)return;$e.emitOne(Re)}ve.dispose(),J.dispose()}catch(Re){ve.dispose(),J.dispose(),$e.reject(Re)}})}class oe{constructor(J){this.a=new ae,this.b=new pe(ve=>{if(se){ve.reject(se);return}return $e&&ve.emitMany($e),this.d=Re=>ve.reject(Re),this.f=Re=>ve.emitOne(Re),this.a.p},J);let se,$e;this.f=ve=>{$e||($e=[]),$e.push(ve)},this.d=ve=>{se||(se=ve)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Zh=oe}),define(Se[35],De([1,0,19,7,31,27,17,12,14]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=k,e.$ok=w,e.$pk=P,e.$qk=I,e.$rk=F,e.$sk=T,e.$tk=z,e.$uk=Z;function k(){return Object.create(null)}e.$mk="**",e.$nk="/";const A="[/\\\\]",C="[^/\\\\]",$=/\//g;function v(ie,Q){switch(ie){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${Q?`|${A}${C}+`:""})*?`}}function w(ie,Q){if(!ie)return[];const G=[];let x=!1,ne=!1,be="";for(const ae of ie){switch(ae){case Q:if(!x&&!ne){G.push(be),be="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}be+=ae}return be&&G.push(be),G}function h(ie){if(!ie)return"";let Q="";const G=w(ie,e.$nk);if(G.every(x=>x===e.$mk))Q=".*";else{let x=!1;G.forEach((ne,be)=>{if(ne===e.$mk){if(x)return;Q+=v(2,be===G.length-1)}else{let ae=!1,Ce="",ee=!1,B="";for(const _ of ne){if(_!=="}"&&ae){Ce+=_;continue}if(ee&&(_!=="]"||!B)){let pe;_==="-"?pe=_:(_==="^"||_==="!")&&!B?pe="^":_===e.$nk?pe="":pe=(0,m.$_e)(_),B+=pe;continue}switch(_){case"{":ae=!0;continue;case"[":ee=!0;continue;case"}":{const ue=`(?:${w(Ce,",").map(ce=>h(ce)).join("|")})`;Q+=ue,ae=!1,Ce="";break}case"]":{Q+="["+B+"]",ee=!1,B="";break}case"?":Q+=C;continue;case"*":Q+=v(1);continue;default:Q+=(0,m.$_e)(_)}}be<G.length-1&&(G[be+1]!==e.$mk||be+2<G.length)&&(Q+=A)}x=ne===e.$mk})}return Q}const f=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),u=function(){return!1},r=function(){return null};function c(ie,Q){if(!ie)return r;let G;typeof ie!="string"?G=ie.pattern:G=ie,G=G.trim();const x=`${G}_${!!Q.trimForExclusions}`;let ne=t.get(x);if(ne)return s(ne,ie);let be;return f.test(G)?ne=b(G.substr(4),G):(be=a.exec(y(G,Q)))?ne=S(be[1],G):(Q.trimForExclusions?i:n).test(G)?ne=g(G,Q):(be=l.exec(y(G,Q)))?ne=E(be[1].substr(1),G,!0):(be=o.exec(y(G,Q)))?ne=E(be[1],G,!1):ne=D(G),t.set(x,ne),s(ne,ie)}function s(ie,Q){if(typeof Q=="string")return ie;const G=function(x,ne){return(0,L.$vg)(x,Q.base,!p.$k)?ie((0,m.$ef)(x.substr(Q.base.length),N.sep),ne):null};return G.allBasenames=ie.allBasenames,G.allPaths=ie.allPaths,G.basenames=ie.basenames,G.patterns=ie.patterns,G}function y(ie,Q){return Q.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function b(ie,Q){return function(G,x){return typeof G=="string"&&G.endsWith(ie)?Q:null}}function S(ie,Q){const G=`/${ie}`,x=`\\${ie}`,ne=function(ae,Ce){return typeof ae!="string"?null:Ce?Ce===ie?Q:null:ae===ie||ae.endsWith(G)||ae.endsWith(x)?Q:null},be=[ie];return ne.basenames=be,ne.patterns=[Q],ne.allBasenames=be,ne}function g(ie,Q){const G=U(ie.slice(1,-1).split(",").map(Ce=>c(Ce,Q)).filter(Ce=>Ce!==r),ie),x=G.length;if(!x)return r;if(x===1)return G[0];const ne=function(Ce,ee){for(let B=0,_=G.length;B<_;B++)if(G[B](Ce,ee))return ie;return null},be=G.find(Ce=>!!Ce.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=G.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return ae.length&&(ne.allPaths=ae),ne}function E(ie,Q,G){const x=N.sep===N.$gc.sep,ne=x?ie:ie.replace($,N.sep),be=N.sep+ne,ae=N.$gc.sep+ie;let Ce;return G?Ce=function(ee,B){return typeof ee=="string"&&(ee===ne||ee.endsWith(be)||!x&&(ee===ie||ee.endsWith(ae)))?Q:null}:Ce=function(ee,B){return typeof ee=="string"&&(ee===ne||!x&&ee===ie)?Q:null},Ce.allPaths=[(G?"*/":"./")+ie],Ce}function D(ie){try{const Q=new RegExp(`^${h(ie)}$`);return function(G){return Q.lastIndex=0,typeof G=="string"&&Q.test(G)?ie:null}}catch{return r}}function P(ie,Q,G){return!ie||typeof Q!="string"?!1:I(ie)(Q,void 0,G)}function I(ie,Q={}){if(!ie)return u;if(typeof ie=="string"||F(ie)){const G=c(ie,Q);if(G===r)return u;const x=function(ne,be){return!!G(ne,be)};return G.allBasenames&&(x.allBasenames=G.allBasenames),G.allPaths&&(x.allPaths=G.allPaths),x}return M(ie,Q)}function F(ie){const Q=ie;return Q?typeof Q.base=="string"&&typeof Q.pattern=="string":!1}function T(ie){return ie.allBasenames||[]}function z(ie){return ie.allPaths||[]}function M(ie,Q){const G=U(Object.getOwnPropertyNames(ie).map(Ce=>j(Ce,ie[Ce],Q)).filter(Ce=>Ce!==r)),x=G.length;if(!x)return r;if(!G.some(Ce=>!!Ce.requiresSiblings)){if(x===1)return G[0];const Ce=function(_,pe){let ue;for(let ce=0,oe=G.length;ce<oe;ce++){const le=G[ce](_,pe);if(typeof le=="string")return le;(0,O.$ih)(le)&&(ue||(ue=[]),ue.push(le))}return ue?(async()=>{for(const ce of ue){const oe=await ce;if(typeof oe=="string")return oe}return null})():null},ee=G.find(_=>!!_.allBasenames);ee&&(Ce.allBasenames=ee.allBasenames);const B=G.reduce((_,pe)=>pe.allPaths?_.concat(pe.allPaths):_,[]);return B.length&&(Ce.allPaths=B),Ce}const ne=function(Ce,ee,B){let _,pe;for(let ue=0,ce=G.length;ue<ce;ue++){const oe=G[ue];oe.requiresSiblings&&B&&(ee||(ee=(0,N.$nc)(Ce)),_||(_=ee.substr(0,ee.length-(0,N.$oc)(Ce).length)));const le=oe(Ce,ee,_,B);if(typeof le=="string")return le;(0,O.$ih)(le)&&(pe||(pe=[]),pe.push(le))}return pe?(async()=>{for(const ue of pe){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},be=G.find(Ce=>!!Ce.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=G.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return ae.length&&(ne.allPaths=ae),ne}function j(ie,Q,G){if(Q===!1)return r;const x=c(ie,G);if(x===r)return r;if(typeof Q=="boolean")return x;if(Q){const ne=Q.when;if(typeof ne=="string"){const be=(ae,Ce,ee,B)=>{if(!B||!x(ae,Ce))return null;const _=ne.replace("$(basename)",()=>ee),pe=B(_);return(0,O.$ih)(pe)?pe.then(ue=>ue?ie:null):pe?ie:null};return be.requiresSiblings=!0,be}}return x}function U(ie,Q){const G=ie.filter(Ce=>!!Ce.basenames);if(G.length<2)return ie;const x=G.reduce((Ce,ee)=>{const B=ee.basenames;return B?Ce.concat(B):Ce},[]);let ne;if(Q){ne=[];for(let Ce=0,ee=x.length;Ce<ee;Ce++)ne.push(Q)}else ne=G.reduce((Ce,ee)=>{const B=ee.patterns;return B?Ce.concat(B):Ce},[]);const be=function(Ce,ee){if(typeof Ce!="string")return null;if(!ee){let _;for(_=Ce.length;_>0;_--){const pe=Ce.charCodeAt(_-1);if(pe===47||pe===92)break}ee=Ce.substr(_)}const B=x.indexOf(ee);return B!==-1?ne[B]:null};be.basenames=x,be.patterns=ne,be.allBasenames=x;const ae=ie.filter(Ce=>!Ce.basenames);return ae.push(be),ae}function Z(ie,Q){return(0,d.$ub)(ie,Q,(G,x)=>typeof G=="string"&&typeof x=="string"?G===x:typeof G!="string"&&typeof x!="string"?G.base===x.base&&G.pattern===x.pattern:!1)}}),define(Se[81],De([1,0,13,176,23,14,2]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=k,e.$Vk=A,e.$Wk=C,e.$Xk=$,e.$Yk=v,e.$Zk=w,e.$1k=h,e.$2k=f;var p;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class m{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,d.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=$(this.supportThemeIcons?(0,O.$Nk)(n):n).replace(/([ \t]+)/g,(l,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${v(i,n)}
`,this}appendLink(n,i,l){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(n,i){const l=new RegExp((0,R.$_e)(i),"g");return n.replace(l,(o,t)=>n.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Tk=m;function k(a){return A(a)?!a.value:Array.isArray(a)?a.every(k):!0}function A(a){return a instanceof m?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function C(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,L.$3g)(N.URI.from(a.baseUri),N.URI.from(n.baseUri)))}function $(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(a,n){const i=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,l=i>=3?i+1:3;return[`${"`".repeat(l)}${n}`,a,`${"`".repeat(l)}`].join(`
`)}function w(a){return a.replace(/"/g,"&quot;")}function h(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(a){const n=[],i=a.split("|").map(o=>o.trim());a=i[0];const l=i[1];if(l){const o=/height=(\d+)/.exec(l),t=/width=(\d+)/.exec(l),u=o?o[1]:"",r=t?t[1]:"",c=isFinite(parseInt(r)),s=isFinite(parseInt(u));c&&n.push(`width="${r}"`),s&&n.push(`height="${u}"`)}return{href:a,dimensions:n}}}),define(Se[103],De([1,0,19,31,17,12,23,14]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=m,e.$Ew=A,e.$Fw=$,e.$Gw=v,e.$Hw=a,e.$Iw=i,e.$Jw=l,e.$Kw=o,e.$Lw=t,e.$Mw=u;function m(c,s){const{os:y,tildify:b,relative:S}=s;if(S){const D=k(c,S,y);if(typeof D=="string")return D}let g=c.fsPath;if(y===1&&!R.$i?g=g.replace(/\//g,"\\"):y!==1&&R.$i&&(g=g.replace(/\\/g,"/")),y!==1&&b?.userHome){const D=b.userHome.fsPath;let P;c.scheme!==b.userHome.scheme&&c.path[0]===L.$gc.sep&&c.path[1]!==L.$gc.sep?P=b.userHome.with({path:c.path}).fsPath:P=g,g=$(P,D,y)}return(y===1?L.$fc:L.$gc).normalize(A(g,y===1))}function k(c,s,y){const b=y===1?L.$fc:L.$gc,S=y===3?N.$Zg:N.$2g,g=s.getWorkspace(),E=(0,d.$Ob)(g.folders);if(!E)return;c.scheme!==E.uri.scheme&&c.path[0]===L.$gc.sep&&c.path[1]!==L.$gc.sep&&(c=E.uri.with({path:c.path}));const D=s.getWorkspaceFolder(c);if(!D)return;let P;if(S.isEqual(D.uri,c)?P="":P=S.relativePath(D.uri,c)??"",P&&(P=b.normalize(P)),g.folders.length>1&&!s.noPrefix){const I=D.name?D.name:S.basenameOrAuthority(D.uri);P=P?`${I} \u2022 ${P}`:I}return P}function A(c,s=R.$i){return(0,O.$Ag)(c,s)?c.charAt(0).toUpperCase()+c.slice(1):c}let C=Object.create(null);function $(c,s,y=R.OS){if(y===1||!c||!s)return c;let b=C.original===s?C.normalized:void 0;b||(b=s,R.$i&&(b=(0,O.$pg)(b)),b=`${(0,p.$ff)(b,L.$gc.sep)}${L.$gc.sep}`,C={original:s,normalized:b});let S=c;return R.$i&&(S=(0,O.$pg)(S)),(y===3?S.startsWith(b):(0,p.$yf)(S,b))?`~/${S.substr(b.length)}`:c}function v(c,s){return c.replace(/^~($|\/|\\)/,`${s}$1`)}const w="\u2026",h="\\\\",f="~";function a(c,s=L.sep){const y=new Array(c.length);let b=!1;for(let S=0;S<c.length;S++){const g=c[S];if(g===""){y[S]=`.${s}`;continue}if(!g){y[S]=g;continue}b=!0;let E="",D=g;D.indexOf(h)===0?(E=D.substr(0,D.indexOf(h)+h.length),D=D.substr(D.indexOf(h)+h.length)):D.indexOf(s)===0?(E=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length)):D.indexOf(f)===0&&(E=D.substr(0,D.indexOf(f)+f.length),D=D.substr(D.indexOf(f)+f.length));const P=D.split(s);for(let I=1;b&&I<=P.length;I++)for(let F=P.length-I;b&&F>=0;F--){b=!1;let T=P.slice(F,F+I).join(s);for(let z=0;!b&&z<c.length;z++)if(z!==S&&c[z]&&c[z].indexOf(T)>-1){const M=F+I===P.length,j=F>0&&c[z].indexOf(s)>-1?s+T:T,U=c[z].endsWith(j);b=!M||U}if(!b){let z="";(P[0].endsWith(":")||E!=="")&&(F===1&&(F=0,I++,T=P[0]+s+T),F>0&&(z=P[0]+s),z=E+z),F>0&&(z=z+w+s),z=z+T,F+I<P.length&&(z=z+s+w),y[S]=z}}b&&(y[S]=g)}return y}var n;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(c,s=Object.create(null)){const y=[];let b=!1,S="";for(const g of c)if(g==="$"||b&&g==="{")S&&y.push({value:S,type:n.TEXT}),S="",b=!0;else if(g==="}"&&b){const E=s[S];if(typeof E=="string")E.length&&y.push({value:E,type:n.VARIABLE});else if(E){const D=y[y.length-1];(!D||D.type!==n.SEPARATOR)&&y.push({value:E.label,type:n.SEPARATOR})}S="",b=!1}else S+=g;return S&&!b&&y.push({value:S,type:n.TEXT}),y.filter((g,E)=>{if(g.type===n.SEPARATOR){const D=y[E-1],P=y[E+1];return[D,P].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(g=>g.value).join("")}function l(c,s){return R.$j||s?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):c.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function o(c,s){return R.$j||s?c.replace(/\(&&\w\)|&&/g,""):R.$i?c.replace(/&&|&/g,y=>y==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function u(c){if(c.endsWith("]")){const s=c.lastIndexOf(" [",c.length-2);if(s!==-1){const y=r(c.substring(0,s)),b=c.substring(s);return{name:y.name+b,parentPath:y.parentPath}}}return r(c)}function r(c){const s=c.indexOf("/")!==-1?L.$gc:L.$fc,y=s.basename(c),b=s.dirname(c);return y.length?{name:y,parentPath:b}:{name:b,parentPath:""}}}),define(Se[134],De([1,0,21,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=p,e.$Bn=k,e.$Cn=A;function L(C){return C.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const v=this.a.transformIncoming($);return v===$?$:L(O.URI.from(v))}transformOutgoing($){const v=this.a.transformOutgoing($);return v===$?$:L(O.URI.from(v))}transformOutgoingURI($){const v=this.a.transformOutgoing($);return v===$?$:O.URI.from(v)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$yn=R,e.$zn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function N(C,$,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof O.URI)return $.transformOutgoing(C);for(const w in C)if(Object.hasOwnProperty.call(C,w)){const h=N(C[w],$,v+1);h!==null&&(C[w]=h)}}return null}function p(C,$){const v=N(C,$,0);return v===null?C:v}function m(C,$,v,w){if(!C||w>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?O.URI.revive($.transformIncoming(C)):$.transformIncoming(C);if(C instanceof d.$Fe)return null;for(const h in C)if(Object.hasOwnProperty.call(C,h)){const f=m(C[h],$,v,w+1);f!==null&&(C[h]=f)}}return null}function k(C,$){const v=m(C,$,!1,0);return v===null?C:v}function A(C,$){const v=m(C,$,!0,0);return v===null?C:v}}),define(Se[32],De([1,0,53,64,400,7,31,77,17,12,23,2]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=y,e.writeFileSync=S;var $;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function v(j,U=$.UNLINK,Z){if((0,N.$zg)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===$.UNLINK?h(j):w(j,Z)}async function w(j,U=(0,N.$Eg)((0,O.tmpdir)())){try{try{await d.promises.rename(j,U)}catch(Z){return Z.code==="ENOENT"?void 0:h(j)}h(U).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function h(j){return(0,L.promisify)(d.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function f(j){if((0,N.$zg)(j))throw new Error("rimraf - will refuse to recursively delete root");d.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function a(j,U){return l(await(U?n(j):(0,L.promisify)(d.readdir)(j)))}async function n(j){try{return await(0,L.promisify)(d.readdir)(j,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const U=[],Z=await a(j);for(const ie of Z){let Q=!1,G=!1,x=!1;try{const ne=await e.Promises.lstat((0,m.$jc)(j,ie));Q=ne.isFile(),G=ne.isDirectory(),x=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}U.push({name:ie,isFile:()=>Q,isDirectory:()=>G,isSymbolicLink:()=>x})}return U}function i(j){return l(d.readdirSync(j))}function l(j){return j.map(U=>typeof U=="string"?k.$j?(0,p.$bm)(U):U:(U.name=k.$j?(0,p.$bm)(U.name):U.name,U))}async function o(j){const U=await a(j),Z=[];for(const ie of U)await u.existsDirectory((0,m.$jc)(j,ie))&&Z.push(ie);return Z}function t(j,U=1e3){return new Promise(Z=>{let ie=!1;const Q=setInterval(()=>{ie||(ie=!0,d.access(j,G=>{ie=!1,G&&(clearInterval(Q),Z(void 0))}))},U)})}var u;(function(j){async function U(Q){let G;try{if(G=await e.Promises.lstat(Q),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(Q),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(k.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Q)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ne}throw x}}j.stat=U;async function Z(Q){try{const{stat:G,symbolicLink:x}=await j.stat(Q);return G.isFile()&&x?.dangling!==!0}catch{}return!1}j.existsFile=Z;async function ie(Q){try{const{stat:G,symbolicLink:x}=await j.stat(Q);return G.isDirectory()&&x?.dangling!==!0}catch{}return!1}j.existsDirectory=ie})(u||(e.SymlinkSupport=u={}));const r=new R.$Fh;function c(j,U,Z){return r.queueFor(C.URI.file(j),()=>{const ie=g(Z);return new Promise((Q,G)=>b(j,U,ie,x=>x?G(x):Q()))},A.$1g)}let s=!0;function y(j){s=j}function b(j,U,Z,ie){if(!s)return d.writeFile(j,U,{mode:Z.mode,flag:Z.flag},ie);d.open(j,Z.flag,Z.mode,(Q,G)=>{if(Q)return ie(Q);d.writeFile(G,U,x=>{if(x)return d.close(G,()=>ie(x));d.fdatasync(G,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),y(!1)),d.close(G,be=>ie(be))))})})}function S(j,U,Z){const ie=g(Z);if(!s)return d.writeFileSync(j,U,{mode:ie.mode,flag:ie.flag});const Q=d.openSync(j,ie.flag,ie.mode);try{d.writeFileSync(Q,U);try{d.fdatasyncSync(Q)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),y(!1)}}finally{d.closeSync(Q)}}function g(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function E(j,U,Z=6e4){if(j!==U)try{k.$i&&typeof Z=="number"?await D(j,U,Date.now(),Z):await(0,L.promisify)(d.rename)(j,U)}catch(ie){if(j.toLowerCase()!==U.toLowerCase()&&ie.code==="EXDEV"||j.endsWith("."))await P(j,U,{preserveSymlinks:!1}),await v(j,$.MOVE);else throw ie}}async function D(j,U,Z,ie,Q=0){try{return await(0,L.promisify)(d.rename)(j,U)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-Z>=ie)throw console.error(`[node.js fs] rename failed after ${Q} retries with error: ${G}`),G;if(Q===0){let x=!1;try{const{stat:ne}=await u.stat(U);ne.isFile()||(x=!0)}catch{}if(x)throw G}return await(0,R.$xh)(Math.min(100,Q*10)),D(j,U,Z,ie,Q+1)}}async function P(j,U,Z){return F(j,U,{root:{source:j,target:U},options:Z,handledSourcePaths:new Set})}const I=511;async function F(j,U,Z){if(Z.handledSourcePaths.has(j))return;Z.handledSourcePaths.add(j);const{stat:ie,symbolicLink:Q}=await u.stat(j);if(Q){if(Z.options.preserveSymlinks)try{return await M(j,U,Z)}catch{}if(Q.dangling)return}return ie.isDirectory()?T(j,U,ie.mode&I,Z):z(j,U,ie.mode&I)}async function T(j,U,Z,ie){await e.Promises.mkdir(U,{recursive:!0,mode:Z});const Q=await a(j);for(const G of Q)await F((0,m.$jc)(j,G),(0,m.$jc)(U,G),ie)}async function z(j,U,Z){await e.Promises.copyFile(j,U),await e.Promises.chmod(U,Z)}async function M(j,U,Z){let ie=await e.Promises.readlink(j);(0,N.$vg)(ie,Z.root.source,!k.$k)&&(ie=(0,m.$jc)(Z.root.target,ie.substr(Z.root.source.length+1))),await e.Promises.symlink(ie,U)}e.Promises=new class{get access(){return(0,L.promisify)(d.access)}get stat(){return(0,L.promisify)(d.stat)}get lstat(){return(0,L.promisify)(d.lstat)}get utimes(){return(0,L.promisify)(d.utimes)}get read(){return(j,U,Z,ie,Q)=>new Promise((G,x)=>{d.read(j,U,Z,ie,Q,(ne,be,ae)=>ne?x(ne):G({bytesRead:be,buffer:ae}))})}get readFile(){return(0,L.promisify)(d.readFile)}get write(){return(j,U,Z,ie,Q)=>new Promise((G,x)=>{d.write(j,U,Z,ie,Q,(ne,be,ae)=>ne?x(ne):G({bytesWritten:be,buffer:ae}))})}get appendFile(){return(0,L.promisify)(d.appendFile)}get fdatasync(){return(0,L.promisify)(d.fdatasync)}get truncate(){return(0,L.promisify)(d.truncate)}get copyFile(){return(0,L.promisify)(d.copyFile)}get open(){return(0,L.promisify)(d.open)}get close(){return(0,L.promisify)(d.close)}get symlink(){return(0,L.promisify)(d.symlink)}get readlink(){return(0,L.promisify)(d.readlink)}get chmod(){return(0,L.promisify)(d.chmod)}get mkdir(){return(0,L.promisify)(d.mkdir)}get unlink(){return(0,L.promisify)(d.unlink)}get rmdir(){return(0,L.promisify)(d.rmdir)}get realpath(){return(0,L.promisify)(d.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return v}get rename(){return E}get copy(){return P}}}),define(Se[104],De([1,0,53,17,12,14,32]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=p,e.$5q=m,e.$6q=k,e.$7q=A;function p($){if(L.$k)return $;const v=(0,O.$mc)($);if($===v)return $;const w=((0,O.$nc)($)||$).toLowerCase();try{const f=(0,N.readdirSync)(v).filter(a=>a.toLowerCase()===w);if(f.length===1){const a=p(v);if(a)return(0,O.$jc)(a,f[0])}else if(f.length>1){const a=f.indexOf(w);if(a>=0){const n=p(v);if(n)return(0,O.$jc)(n,f[a])}}}catch{}return null}async function m($,v){if(L.$k)return $;const w=(0,O.$mc)($);if($===w)return $;const h=((0,O.$nc)($)||$).toLowerCase();try{if(v?.isCancellationRequested)return null;const a=(await N.Promises.readdir(w)).filter(n=>n.toLowerCase()===h);if(a.length===1){const n=await m(w,v);if(n)return(0,O.$jc)(n,a[0])}else if(a.length>1){const n=a.indexOf(h);if(n>=0){const i=await m(w,v);if(i)return(0,O.$jc)(i,a[n])}}}catch{}return null}async function k($){try{return await N.Promises.realpath($)}catch{const w=C($);return await N.Promises.access(w,d.constants.R_OK),w}}function A($){try{return d.realpathSync($)}catch{const w=C($);return d.accessSync(w,d.constants.R_OK),w}}function C($){return(0,R.$ff)((0,O.$hc)($),O.sep)}}),define(Se[105],De([1,0,17,12,52,102,18,32]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=m,e.$pm=k,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function m(C=L.env){return C.comspec||"cmd.exe"}function k(C){let $=[],v=!1;const w=function(h){if(v){$.push(h);return}(!C.send(h,a=>{if(a&&console.error(a),v=!1,$.length>0){const n=$.slice(0);$=[],n.forEach(i=>w(i))}})||O.$i)&&(v=!0)};return{send:w}}var A;(function(C){async function $(v,w,h){if(d.$ic(v))return v;if(w===void 0&&(w=L.cwd()),d.$mc(v)!=="."||(h===void 0&&N.$9f(L.env.PATH)&&(h=L.env.PATH.split(d.$tc)),h===void 0||h.length===0))return d.$jc(w,v);async function a(n){if(await p.Promises.exists(n)){let i;try{i=await p.Promises.stat(n)}catch(l){l.message.startsWith("EACCES")&&(i=await p.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(d.$ic(n)?i=d.$jc(n,v):i=d.$jc(w,n,v),await a(i))return i;let l=i+".com";if(await a(l)||(l=i+".exe",await a(l)))return l}return d.$jc(w,v)}C.findExecutable=$})(A||(e.win32=A={}))});var Ge=this&&this.__decorate||function(he,e,d,O){var L=arguments.length,R=L<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,d):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(he,e,d,O);else for(var p=he.length-1;p>=0;p--)(N=he[p])&&(R=(L<3?N(R):L>3?N(e,d,R):N(e,d))||R);return L>3&&R&&Object.defineProperty(e,d,R),R};define(Se[82],De([1,0,19,7,21,22,56,13,4,3,58,14,18]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=y,e.$0h=b,e.$ci=I,e.$di=F;var v;(function(Q){Q[Q.Promise=100]="Promise",Q[Q.PromiseCancel=101]="PromiseCancel",Q[Q.EventListen=102]="EventListen",Q[Q.EventDispose=103]="EventDispose"})(v||(v={}));function w(Q){switch(Q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(Q){Q[Q.Initialize=200]="Initialize",Q[Q.PromiseSuccess=201]="PromiseSuccess",Q[Q.PromiseError=202]="PromiseError",Q[Q.PromiseErrorObj=203]="PromiseErrorObj",Q[Q.EventFire=204]="EventFire"})(h||(h={}));function f(Q){switch(Q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(Q){Q[Q.Uninitialized=0]="Uninitialized",Q[Q.Idle=1]="Idle"})(a||(a={}));function n(Q){let G=0;for(let x=0;;x+=7){const ne=Q.read(1);if(G|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return G}}const i=r(0);function l(Q,G){if(G===0){Q.write(i);return}let x=0;for(let be=G;be!==0;be=be>>>7)x++;const ne=L.$Fe.alloc(x);for(let be=0;G!==0;be++)ne.buffer[be]=G&127,G=G>>>7,G>0&&(ne.buffer[be]|=128);Q.write(ne)}class o{constructor(G){this.b=G,this.a=0}read(G){const x=this.b.slice(this.a,this.a+G);return this.a+=x.byteLength,x}}e.$7h=o;class t{constructor(){this.a=[]}get buffer(){return L.$Fe.concat(this.a)}write(G){this.a.push(G)}}e.$8h=t;var u;(function(Q){Q[Q.Undefined=0]="Undefined",Q[Q.String=1]="String",Q[Q.Buffer=2]="Buffer",Q[Q.VSBuffer=3]="VSBuffer",Q[Q.Array=4]="Array",Q[Q.Object=5]="Object",Q[Q.Int=6]="Int"})(u||(u={}));function r(Q){const G=L.$Fe.alloc(1);return G.writeUInt8(Q,0),G}const c={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object),Uint:r(u.Int)},s=typeof Buffer<"u";function y(Q,G){if(typeof G>"u")Q.write(c.Undefined);else if(typeof G=="string"){const x=L.$Fe.fromString(G);Q.write(c.String),l(Q,x.byteLength),Q.write(x)}else if(s&&Buffer.isBuffer(G)){const x=L.$Fe.wrap(G);Q.write(c.Buffer),l(Q,x.byteLength),Q.write(x)}else if(G instanceof L.$Fe)Q.write(c.VSBuffer),l(Q,G.byteLength),Q.write(G);else if(Array.isArray(G)){Q.write(c.Array),l(Q,G.length);for(const x of G)y(Q,x)}else if(typeof G=="number"&&(G|0)===G)Q.write(c.Uint),l(Q,G);else{const x=L.$Fe.fromString(JSON.stringify(G));Q.write(c.Object),l(Q,x.byteLength),Q.write(x)}}function b(Q){switch(Q.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return Q.read(n(Q)).toString();case u.Buffer:return Q.read(n(Q)).buffer;case u.VSBuffer:return Q.read(n(Q));case u.Array:{const x=n(Q),ne=[];for(let be=0;be<x;be++)ne.push(b(Q));return ne}case u.Object:return JSON.parse(Q.read(n(Q)).toString());case u.Int:return n(Q)}}class S{constructor(G,x,ne=null,be=1e3){this.h=G,this.j=x,this.k=ne,this.l=be,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(G,x){this.b.set(G,x),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const x=this.o([G.type]);this.k?.logOutgoing(x,0,1,f(G.type));return}case 201:case 202:case 204:case 203:{const x=this.o([G.type,G.id],G.data);this.k?.logOutgoing(x,G.id,1,f(G.type),G.data);return}}}o(G,x=void 0){const ne=new t;return y(ne,G),y(ne,x),this.p(ne.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const x=new o(G),ne=b(x),be=b(x),ae=ne[0];switch(ae){case 100:return this.k?.logIncoming(G.byteLength,ne[1],1,`${w(ae)}: ${ne[2]}.${ne[3]}`,be),this.s({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 102:return this.k?.logIncoming(G.byteLength,ne[1],1,`${w(ae)}: ${ne[2]}.${ne[3]}`,be),this.t({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 101:return this.k?.logIncoming(G.byteLength,ne[1],1,`${w(ae)}`),this.u({type:ae,id:ne[1]});case 103:return this.k?.logIncoming(G.byteLength,ne[1],1,`${w(ae)}`),this.u({type:ae,id:ne[1]})}}s(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=new R.$oe;let be;try{be=x.call(this.j,G.name,G.arg,ne.token)}catch(ee){be=Promise.reject(ee)}const ae=G.id;be.then(ee=>{this.m({id:ae,data:ee,type:201})},ee=>{ee instanceof Error?this.m({id:ae,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:ae,data:ee,type:203})}).finally(()=>{Ce.dispose(),this.d.delete(G.id)});const Ce=(0,k.$Sc)(()=>ne.cancel());this.d.set(G.id,Ce)}t(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=G.id,ae=x.listen(this.j,G.name,G.arg)(Ce=>this.m({id:ne,data:Ce,type:204}));this.d.set(G.id,ae)}u(G){const x=this.d.get(G.id);x&&(x.dispose(),this.d.delete(G.id))}v(G){let x=this.g.get(G.channelName);x||(x=[],this.g.set(G.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:G,timeoutTimer:ne})}w(G){const x=this.g.get(G);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$$h=S;var g;(function(Q){Q[Q.LocalSide=0]="LocalSide",Q[Q.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));class E{constructor(G,x=null){this.l=G,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$de,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(G){const x=this;return{call(ne,be,ae){return x.a?Promise.reject(new p.$5):x.m(G,ne,be,ae)},listen(ne,be){return x.a?m.Event.None:x.o(G,ne,be)}}}m(G,x,ne,be=R.CancellationToken.None){const ae=this.g++,ee={id:ae,type:100,channelName:G,name:x,arg:ne};if(be.isCancellationRequested)return Promise.reject(new p.$5);let B;return new Promise((pe,ue)=>{if(be.isCancellationRequested)return ue(new p.$5);const ce=()=>{const se=$e=>{switch($e.type){case 201:this.f.delete(ae),pe($e.data);break;case 202:{this.f.delete(ae);const ve=new Error($e.data.message);ve.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,ve.name=$e.data.name,ue(ve);break}case 203:this.f.delete(ae),ue($e.data);break}};this.f.set(ae,se),this.p(ee)};let oe=null;this.b===a.Idle?ce():(oe=(0,O.$jh)(se=>this.u()),oe.then(()=>{oe=null,ce()}));const le=()=>{oe?(oe.cancel(),oe=null):this.p({id:ae,type:101}),ue(new p.$5)},J=be.onCancellationRequested(le);B=(0,k.$Rc)((0,k.$Sc)(le),J),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(G,x,ne){const be=this.g++,Ce={id:be,type:102,channelName:G,name:x,arg:ne};let ee=null;const B=new m.$de({onWillAddFirstListener:()=>{ee=(0,O.$jh)(pe=>this.u()),ee.then(()=>{ee=null,this.d.add(B),this.p(Ce)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(B),this.p({id:be,type:103}))}}),_=pe=>B.fire(pe.data);return this.f.set(be,_),B.event}p(G){switch(G.type){case 100:case 102:{const x=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(x,G.id,0,`${w(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const x=this.q([G.type,G.id]);this.j?.logOutgoing(x,G.id,0,w(G.type));return}}}q(G,x=void 0){const ne=new t;return y(ne,G),y(ne,x),this.r(ne.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const x=new o(G),ne=b(x),be=b(x),ae=ne[0];switch(ae){case 200:return this.j?.logIncoming(G.byteLength,0,0,f(ae)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ne[1],0,f(ae),be),this.t({type:ne[0],id:ne[1],data:be})}}t(G){if(G.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$_h=E,Ge([N.$1h],E.prototype,"onDidInitializePromise",null);class D{get connections(){const G=[];return this.f.forEach(x=>G.push(x)),G}constructor(G,x,ne){this.a=new Map,this.f=new Set,this.g=new m.$de,this.onDidAddConnection=this.g.event,this.h=new m.$de,this.onDidRemoveConnection=this.h.event,this.j=new k.$Tc,this.j.add(G(({protocol:be,onDidClientDisconnect:ae})=>{const Ce=m.Event.once(be.onMessage);this.j.add(Ce(ee=>{const B=new o(ee),_=b(B),pe=new S(be,_,x,ne),ue=new E(be,x);this.a.forEach((oe,le)=>pe.registerChannel(le,oe));const ce={channelServer:pe,channelClient:ue,ctx:_};this.f.add(ce),this.g.fire(ce),this.j.add(ae(()=>{pe.dispose(),ue.dispose(),this.f.delete(ce),this.h.fire(ce)}))}))}))}getChannel(G,x){const ne=this;return{call(be,ae,Ce){let ee;if((0,$.$kg)(x)){const _=(0,d.$3b)(ne.connections.filter(x));ee=_?Promise.resolve(_):m.Event.toPromise(m.Event.filter(ne.onDidAddConnection,x))}else ee=x.routeCall(ne,be,ae);const B=ee.then(_=>_.channelClient.getChannel(G));return I(B).call(be,ae,Ce)},listen(be,ae){if((0,$.$kg)(x))return ne.k(G,x,be,ae);const Ce=x.routeEvent(ne,be,ae).then(ee=>ee.channelClient.getChannel(G));return I(Ce).listen(be,ae)}}}k(G,x,ne,be){const ae=this;let Ce;const ee=new m.$de({onWillAddFirstListener:()=>{Ce=new k.$Tc;const B=new m.$je,_=new Map,pe=ce=>{const le=ce.channelClient.getChannel(G).listen(ne,be),J=B.add(le);_.set(ce,J)},ue=ce=>{const oe=_.get(ce);oe&&(oe.dispose(),_.delete(ce))};ae.connections.filter(x).forEach(pe),m.Event.filter(ae.onDidAddConnection,x)(pe,void 0,Ce),ae.onDidRemoveConnection(ue,void 0,Ce),B.event(ee.fire,ee,Ce),Ce.add(B)},onDidRemoveLastListener:()=>{Ce?.dispose(),Ce=void 0}});return ee.event}registerChannel(G,x){this.a.set(G,x);for(const ne of this.f)ne.channelServer.registerChannel(G,x)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=D;class P{constructor(G,x,ne=null){const be=new t;y(be,x),G.send(be.buffer),this.a=new E(G,ne),this.d=new S(G,x,ne)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,x){this.d.registerChannel(G,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=P;function I(Q){return{call(G,x,ne){return Q.then(be=>be.call(G,x,ne))},listen(G,x){const ne=new m.$me;return Q.then(be=>ne.input=be.listen(G,x)),ne.event}}}function F(Q){let G=!1;return{call(x,ne,be){return G?Q.call(x,ne,be):(0,O.$xh)(0).then(()=>G=!0).then(()=>Q.call(x,ne,be))},listen(x,ne){if(G)return Q.listen(x,ne);const be=new m.$me;return(0,O.$xh)(0).then(()=>G=!0).then(()=>be.input=Q.listen(x,ne)),be.event}}}class T{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const x of G.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await m.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ei=T;var z;(function(Q){function G(ae,Ce,ee){const B=ae,_=ee&&ee.disableMarshalling,pe=new Map;for(const ue in B)ne(ue)&&pe.set(ue,m.Event.buffer(B[ue],!0,void 0,Ce));return new class{listen(ue,ce,oe){const le=pe.get(ce);if(le)return le;const J=B[ce];if(typeof J=="function"){if(be(ce))return J.call(B,oe);if(ne(ce))return pe.set(ce,m.Event.buffer(B[ce],!0,void 0,Ce)),pe.get(ce)}throw new p.$bb(`Event not found: ${ce}`)}call(ue,ce,oe){const le=B[ce];if(typeof le=="function"){if(!_&&Array.isArray(oe))for(let se=0;se<oe.length;se++)oe[se]=(0,A.$6h)(oe[se]);let J=le.apply(B,oe);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new p.$bb(`Method not found: ${ce}`)}}}Q.fromService=G;function x(ae,Ce){const ee=Ce&&Ce.disableMarshalling;return new Proxy({},{get(B,_){if(typeof _=="string")return Ce?.properties?.has(_)?Ce.properties.get(_):be(_)?function(pe){return ae.listen(_,pe)}:ne(_)?ae.listen(_):async function(...pe){let ue;Ce&&!(0,$.$fg)(Ce.context)?ue=[Ce.context,...pe]:ue=pe;const ce=await ae.call(_,ue);return ee?ce:(0,A.$6h)(ce)};throw new p.$bb(`Property not found: ${String(_)}`)}})}Q.toService=x;function ne(ae){return ae[0]==="o"&&ae[1]==="n"&&C.$wf(ae.charCodeAt(2))}function be(ae){return/^onDynamic/.test(ae)&&C.$wf(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(Q){if(Array.isArray(Q))return Q;if(Q&&typeof Q=="object"&&typeof Q.toString=="function"){const G=Q.toString();if(G!=="[object Object]")return G}return Q}function U(Q){return Array.isArray(Q)?Q.map(j):j(Q)}function Z(Q,G,x,ne,be,ae,Ce){Ce=U(Ce);const ee=M[be],B=ee[ne%ee.length];let _=[`%c[${Q}]%c[${String(G).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ae)?(_=_.concat(Ce),_.push(")")):_.push(Ce),console.log.apply(console,_)}class ie{constructor(G,x){this.d=G,this.f=x,this.a=0,this.b=0}logOutgoing(G,x,ne,be,ae){this.b+=G,Z(this.d,this.b,G,x,ne,be,ae)}logIncoming(G,x,ne,be,ae){this.a+=G,Z(this.f,this.a,G,x,ne,be,ae)}}e.$fi=ie}),define(Se[83],De([1,0,21,4,3,82]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var p;(function(c){c.enableDiagnostics=!1,c.records=[];const s=new WeakMap;let y=0;function b(g,E){if(!s.has(g)){const D=String(++y);s.set(g,D)}return s.get(g)}function S(g,E,D,P){if(!c.enableDiagnostics)return;const I=b(g,E);if(P instanceof d.$Fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=d.$Fe.alloc(P.byteLength);F.set(P),c.records.push({timestamp:Date.now(),id:I,label:E,type:D,buff:F})}else c.records.push({timestamp:Date.now(),id:I,label:E,type:D,data:P})}c.traceSocketEvent=S})(p||(e.SocketDiagnostics=p={}));var m;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let k=null;function A(){return k||(k=d.$Fe.alloc(0)),k}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,y){if(s===0)return A();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const E=this.a[0];return y&&(this.a.shift(),this.b-=s),E}if(this.a[0].byteLength>s){const E=this.a[0].slice(0,s);return y&&(this.a[0]=this.a[0].slice(s),this.b-=s),E}const b=d.$Fe.alloc(s);let S=0,g=0;for(;s>0;){const E=this.a[g];if(E.byteLength>s){const D=E.slice(0,s);b.set(D,S),S+=s,y&&(this.a[g]=E.slice(s),this.b-=s),s-=s}else b.set(E,S),S+=E.byteLength,y?(this.a.shift(),this.b-=E.byteLength):g++,s-=E.byteLength}return b}}e.$gi=C;var $;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})($||($={}));function v(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class h{constructor(s,y,b,S){this.type=s,this.id=y,this.ack=b,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends L.$Uc{constructor(s){super(),this.f=this.B(new O.$de),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new C,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,S=this.g.id,g=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",y),this.f.fire(new h(b,S,g,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=d.$Fe.alloc(13);y.writeUInt8(s.type,0),y.writeUInt32BE(s.id,1),y.writeUInt32BE(s.ack,5),y.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(y,s.data)}g(s,y){const b=this.f===0;return this.d.push(s,y),this.f+=s.byteLength+y.byteLength,b}h(){const s=d.$Fe.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,y){this.g(s,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class n extends L.$Uc{constructor(s){super(),this.f=new O.$de,this.onMessage=this.f.event,this.g=new O.$de,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new a(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(y=>{y.type===1&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new h(1,0,0,s))}}e.$hi=n;class i extends R.$bi{static fromSocket(s,y){return new i(new n(s),y)}get onDidDispose(){return this.b.onDidDispose}constructor(s,y,b=null){super(s,y,b),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$ii=i;class l{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$de({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$ji=l;class o{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,y=this.a;for(;y;)y=y.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let y=0,b=this.a;for(;b;)s[y++]=b.data,b=b.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const y=new o(s);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const s=Date.now();for(let y=0;y<u.a;y++)this.c[y]=s-1e3*y;setInterval(()=>{for(let y=u.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),y=(1+u.a)*1e3;let b=0;for(let S=0;S<u.a;S++)s-this.c[S]<=y&&b++;return 1-b/u.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new l,this.onControlMessage=this.u.event,this.v=new l,this.onMessage=this.v.event,this.w=new l,this.onDidDispose=this.w.event,this.x=new l,this.onSocketClose=this.x.event,this.y=new l,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??u.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=s.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new h(5,0,0,A());this.p.write(s),this.p.flush()}sendPause(){const s=new h(7,0,0,A());this.p.write(s)}sendResume(){const s=new h(8,0,0,A());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,y){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new h(3,0,this.h,A());this.p.write(s);const y=this.b.toArray();for(let b=0,S=y.length;b<S;b++)this.p.write(y[b]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const y=this.b.peek();if(y&&y.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const y=Date.now();y-this.m>1e4&&(this.m=y,this.p.write(new h(6,0,0,A())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const y=this.b.toArray();for(let b=0,S=y.length;b<S;b++)this.p.write(y[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const y=++this.c;this.h=this.g;const b=new h(1,y,this.h,s);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(s){const y=new h(2,0,0,s);this.p.write(y)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),y=Date.now()-s.writtenTime,b=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(y>=2e4&&b>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:b});return}const g=Math.max(2e4-y,2e4-b,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},g)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new h(3,0,this.h,A());this.p.write(s)}D(){this.h=this.g;const s=new h(9,0,this.h,A());this.p.write(s)}}e.$ki=r}),define(Se[199],De([1,0,54,7,21,22,197,13,4,3,24,105,102,82]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class w extends v.$$h{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",n=>L.$Fe.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Zq=w;class h{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new m.$de,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new O.$th(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,l,o){return n.k(a,i,l,o)},listen(i,l){return n.l(a,i,l)}}}k(a,n,i,l=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const o=this.n(a),t=(0,O.$jh)(c=>o.call(n,i,c)),u=l.onCancellationRequested(()=>t.cancel()),r=(0,k.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{u.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return m.Event.None;this.b.cancel();let l;const o=new m.$de({onWillAddFirstListener:()=>{l=this.n(a).listen(n,i)(o.fire,o),this.c.add(l)},onDidRemoveLastListener:()=>{this.c.delete(l),l.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,$.$nm)(n.env),this.d=(0,d.fork)(this.i,a,n);const i=new m.$de,o=m.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,N.$Vq)(y)){(0,N.log)(y,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$Fe.wrap(Buffer.from(y,"base64")))}),t=this.j.useQueue?(0,C.$pm)(this.d):this.d,u=y=>this.d&&this.d.connected&&t.send(y.buffer.toString("base64")),r=i.event,c={send:u,onMessage:r};this.f=new v.$_h(c);const s=()=>this.o();process.once("exit",s),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,b)=>{process.removeListener("exit",s),o.dispose(),this.c.forEach(S=>(0,k.$Pc)(S)),this.c.clear(),y!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:b})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=h}),define(Se[200],De([1,0,7,4,3,58,18]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=m;var p;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function m($){const v=$;return v?.changed instanceof Map||v?.deleted instanceof Set}var k;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(k||(e.StorageState=k={}));class A extends L.$Uc{static{this.a=100}constructor(v,w=Object.create(null)){super(),this.r=v,this.s=w,this.b=this.B(new O.$ge),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new d.$uh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((w,h)=>this.w(h,w)),v.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(v,w){if(this.c===k.Closed)return;let h=!1;(0,N.$fg)(w)?h=this.f.delete(v):this.f.get(v)!==w&&(this.f.set(v,w),h=!0),h&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,w){const h=this.f.get(v);return(0,N.$fg)(h)?w:h}getBoolean(v,w){const h=this.get(v);return(0,N.$fg)(h)?w:h==="true"}getNumber(v,w){const h=this.get(v);return(0,N.$fg)(h)?w:parseInt(h,10)}getObject(v,w){const h=this.get(v);return(0,N.$fg)(h)?w:(0,R.$5h)(h)}async set(v,w,h=!1){if(this.c===k.Closed)return;if((0,N.$fg)(w))return this.delete(v,h);const f=(0,N.$$f)(w)||Array.isArray(w)?(0,R.$4h)(w):String(w);if(this.f.get(v)!==f)return this.f.set(v,f),this.j.set(v,f),this.h.delete(v),this.b.fire({key:v,external:h}),this.D()}async delete(v,w=!1){if(!(this.c===k.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:w}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(!(this.c===k.Closed||this.m))return this.D(v)}async D(v){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Wp=A;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((w,h)=>this.a.set(h,w)),v.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Xp=C}),define(Se[201],De([1,0,14,12,21]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=A,e.$Et=C;let R;function N(){return R||(R=new TextDecoder("UTF-16LE")),R}let p;function m(){return p||(p=new TextDecoder("UTF-16BE")),p}let k;function A(){return k||(k=O.$D()?N():m()),k}function C(w,h,f){const a=new Uint16Array(w.buffer,h,f);return f>0&&(a[0]===65279||a[0]===65534)?$(w,h,f):N().decode(a)}function $(w,h,f){const a=[];let n=0;for(let i=0;i<f;i++){const l=L.$He(w,h);h+=2,a[n++]=String.fromCharCode(l)}return a.join("")}class v{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return A().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const f=this.a-this.d;f<=1&&(f===0||d.$Bf(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const f=h.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=h;return}for(let a=0;a<f;a++)this.b[this.d++]=h.charCodeAt(a)}}e.$Ft=v}),define(Se[202],De([1,0,21,201]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=N;function L(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,A,C,$){this.oldPosition=k,this.oldText=A,this.newPosition=C,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,A,C){const $=A.length;d.$Ke(k,$,C),C+=4;for(let v=0;v<$;v++)d.$Ie(k,A.charCodeAt(v),C),C+=2;return C}static d(k,A){const C=d.$Je(k,A);return A+=4,(0,O.$Et)(k,A,C)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(k,A){return d.$Ke(k,this.oldPosition,A),A+=4,d.$Ke(k,this.newPosition,A),A+=4,A=R.c(k,this.oldText,A),A=R.c(k,this.newText,A),A}static read(k,A,C){const $=d.$Je(k,A);A+=4;const v=d.$Je(k,A);A+=4;const w=R.d(k,A);A+=R.a(w);const h=R.d(k,A);return A+=R.a(h),C.push(new R($,w,v,h)),A}}e.$Gt=R;function N(m,k){return m===null||m.length===0?k:new p(m,k).compress()}class p{constructor(k,A){this.a=k,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,A=0,C=this.n(k),$=this.l(A);for(;k<this.f||A<this.h;){if(C===null){this.k($),$=this.l(++A);continue}if($===null){this.m(C),C=this.n(++k);continue}if($.oldEnd<=C.newPosition){this.k($),$=this.l(++A);continue}if(C.newEnd<=$.oldPosition){this.m(C),C=this.n(++k);continue}if($.oldPosition<C.newPosition){const[a,n]=p.r($,C.newPosition-$.oldPosition);this.k(a),$=n;continue}if(C.newPosition<$.oldPosition){const[a,n]=p.q(C,$.oldPosition-C.newPosition);this.m(a),C=n;continue}let h,f;if($.oldEnd===C.newEnd)h=C,f=$,C=this.n(++k),$=this.l(++A);else if($.oldEnd<C.newEnd){const[a,n]=p.q(C,$.oldLength);h=a,f=$,C=n,$=this.l(++A)}else{const[a,n]=p.r($,C.newLength);h=C,f=a,C=this.n(++k),$=n}this.d[this.e++]=new R(h.oldPosition,h.oldText,f.newPosition,f.newText),this.g+=h.newLength-h.oldLength,this.j+=f.newLength-f.oldLength}const v=p.s(this.d);return p.t(v)}k(k){this.d[this.e++]=p.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=p.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,A){return new R(A.oldPosition-k,A.oldText,A.newPosition,A.newText)}static p(k,A){return new R(A.oldPosition,A.oldText,A.newPosition+k,A.newText)}static q(k,A){const C=k.newText.substr(0,A),$=k.newText.substr(A);return[new R(k.oldPosition,k.oldText,k.newPosition,C),new R(k.oldEnd,"",k.newPosition+A,$)]}static r(k,A){const C=k.oldText.substr(0,A),$=k.oldText.substr(A);return[new R(k.oldPosition,C,k.newPosition,k.newText),new R(k.oldPosition+A,$,k.newEnd,"")]}static s(k){if(k.length===0)return k;const A=[];let C=0,$=k[0];for(let v=1;v<k.length;v++){const w=k[v];$.oldEnd===w.oldPosition?$=new R($.oldPosition,$.oldText+w.oldText,$.newPosition,$.newText+w.newText):(A[C++]=$,$=w)}return A[C++]=$,A}static t(k){if(k.length===0)return k;const A=[];let C=0;for(let $=0;$<k.length;$++){const v=k[$];v.oldText!==v.newText&&(A[C++]=v)}return A}}}),define(Se[203],De([1,0,35,17]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=L,e.$Yt=R;function L(N,p,m,k,A,C){if(Array.isArray(N)){let $=0;for(const v of N){const w=L(v,p,m,k,A,C);if(w===10)return w;w>$&&($=w)}return $}else{if(typeof N=="string")return k?N==="*"?5:N===m?10:0:0;if(N){const{language:$,pattern:v,scheme:w,hasAccessToAllModels:h,notebookType:f}=N;if(!k&&!h)return 0;f&&A&&(p=A);let a=0;if(w)if(w===p.scheme)a=10;else if(w==="*")a=5;else return 0;if($)if($===m)a=10;else if($==="*")a=Math.max(a,5);else return 0;if(f)if(f===C)a=10;else if(f==="*"&&C!==void 0)a=Math.max(a,5);else return 0;if(v){let n;if(typeof v=="string"?n=v:n={...v,base:(0,O.$hc)(v.base)},n===p.fsPath||(0,d.$pk)(n,p.fsPath))a=10;else return 0}return a}else return 0}}function R(N){return typeof N=="string"?!1:Array.isArray(N)?N.some(R):!!N.notebookType}}),define(Se[204],De([1,0,4,14,29,80,131,179,202,3]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=void 0;class A extends k.$Uc{constructor($,v,w,h,f,a,n){super(),this.m=this.B(new d.$de),this.onDidChangeContent=this.m.event,this.f=v,this.j=!a,this.g=h,this.h=f,this.c=new N.$ZC($,w,n)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,v){return this.c.getOffsetAt($,v)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,v){const w=$+v,h=this.getPositionAt($),f=this.getPositionAt(w);return new L.$ut(h.lineNumber,h.column,f.lineNumber,f.column)}getValueInRange($,v=0){if($.isEmpty())return"";const w=this.n(v);return this.c.getValueInRange($,w)}getValueLengthInRange($,v=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const w=this.getOffsetAt($.startLineNumber,$.startColumn),h=this.getOffsetAt($.endLineNumber,$.endColumn);let f=0;const a=this.n(v),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,l=$.endLineNumber-$.startLineNumber;f=i*l}return h-w+f}getCharacterCountInRange($,v=0){if(this.j){let w=0;const h=$.startLineNumber,f=$.endLineNumber;for(let a=h;a<=f;a++){const n=this.getLineContent(a),i=a===h?$.startColumn-1:0,l=a===f?$.endColumn-1:n.length;for(let o=i;o<l;o++)O.$Bf(n.charCodeAt(o))?(w=w+1,o=o+1):w=w+1}return w+=this.n(v).length*(f-h),w}return this.getValueLengthInRange($,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,v){return this.c.getLineCharCode($,v)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const v=O.$mf(this.getLineContent($));return v===-1?0:v+1}getLineLastNonWhitespaceColumn($){const v=O.$of(this.getLineContent($));return v===-1?0:v+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,v,w){let h=this.g,f=this.h,a=this.j,n=!0,i=[];for(let s=0;s<$.length;s++){const y=$[s];n&&y._isTracked&&(n=!1);const b=y.range;if(y.text){let P=!0;a||(P=!O.$Mf(y.text),a=P),!h&&P&&(h=O.$Lf(y.text)),!f&&P&&(f=O.$Of(y.text))}let S="",g=0,E=0,D=0;if(y.text){let P;[g,E,D,P]=(0,p.$1t)(y.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?S=y.text:S=y.text.replace(/\r\n|\r|\n/g,I)}i[s]={sortIndex:s,identifier:y.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:S,eolCount:g,firstLineLength:E,lastLineLength:D,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}i.sort(A.u);let l=!1;for(let s=0,y=i.length-1;s<y;s++){const b=i[s].range.getEndPosition(),S=i[s+1].range.getStartPosition();if(S.isBeforeOrEqual(b)){if(S.isBefore(b))throw new Error("Overlapping ranges are not allowed!");l=!0}}n&&(i=this.s(i));const o=w||v?A._getInverseEditRanges(i):[],t=[];if(v)for(let s=0;s<i.length;s++){const y=i[s],b=o[s];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let S=b.startLineNumber;S<=b.endLineNumber;S++){let g="";S===b.startLineNumber&&(g=this.getLineContent(y.range.startLineNumber),O.$mf(g)!==-1)||t.push({lineNumber:S,oldContent:g})}}let u=null;if(w){let s=0;u=[];for(let y=0;y<i.length;y++){const b=i[y],S=o[y],g=this.getValueInRange(b.range),E=b.rangeOffset+s;s+=b.text.length-g.length,u[y]={sortIndex:b.sortIndex,identifier:b.identifier,range:S,text:g,textChange:new m.$Gt(b.rangeOffset,g,E,b.text)}}l||u.sort((y,b)=>y.sortIndex-b.sortIndex)}this.g=h,this.h=f,this.j=a;const r=this.t(i);let c=null;if(v&&t.length>0){t.sort((s,y)=>y.lineNumber-s.lineNumber),c=[];for(let s=0,y=t.length;s<y;s++){const b=t[s].lineNumber;if(s>0&&t[s-1].lineNumber===b)continue;const S=t[s].oldContent,g=this.getLineContent(b);g.length===0||g===S||O.$mf(g)!==-1||c.push(b)}}return this.m.fire(),new R.$Jv(u,r,c)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let v=!1;const w=$[0].range,h=$[$.length-1].range,f=new L.$ut(w.startLineNumber,w.startColumn,h.endLineNumber,h.endColumn);let a=w.startLineNumber,n=w.startColumn;const i=[];for(let r=0,c=$.length;r<c;r++){const s=$[r],y=s.range;v=v||s.forceMoveMarkers,i.push(this.getValueInRange(new L.$ut(a,n,y.startLineNumber,y.startColumn))),s.text.length>0&&i.push(s.text),a=y.endLineNumber,n=y.endColumn}const l=i.join(""),[o,t,u]=(0,p.$1t)(l);return{sortIndex:0,identifier:$[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:l,eolCount:o,firstLineLength:t,lastLineLength:u,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const v=[];for(let w=0;w<$.length;w++){const h=$[w],f=h.range.startLineNumber,a=h.range.startColumn,n=h.range.endLineNumber,i=h.range.endColumn;if(f===n&&a===i&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const l=new L.$ut(f,a,n,i);v.push({range:l,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return v}findMatchesLineByLine($,v,w,h){return this.c.findMatchesLineByLine($,v,w,h)}getPieceTree(){return this.c}static _getInverseEditRange($,v){const w=$.startLineNumber,h=$.startColumn,[f,a,n]=(0,p.$1t)(v);let i;if(v.length>0){const l=f+1;l===1?i=new L.$ut(w,h,w,h+a):i=new L.$ut(w,h,w+l-1,n+1)}else i=new L.$ut(w,h,w,h);return i}static _getInverseEditRanges($){const v=[];let w=0,h=0,f=null;for(let a=0,n=$.length;a<n;a++){const i=$[a];let l,o;f?f.range.endLineNumber===i.range.startLineNumber?(l=w,o=h+(i.range.startColumn-f.range.endColumn)):(l=w+(i.range.startLineNumber-f.range.endLineNumber),o=i.range.startColumn):(l=i.range.startLineNumber,o=i.range.startColumn);let t;if(i.text.length>0){const u=i.eolCount+1;u===1?t=new L.$ut(l,o,l,o+i.firstLineLength):t=new L.$ut(l,o,l+u-1,i.lastLineLength+1)}else t=new L.$ut(l,o,l,o);w=t.endLineNumber,h=t.endColumn,v.push(t),f=i}return v}static u($,v){const w=L.$ut.compareRangesUsingEnds($.range,v.range);return w===0?$.sortIndex-v.sortIndex:w}static w($,v){const w=L.$ut.compareRangesUsingEnds($.range,v.range);return w===0?v.sortIndex-$.sortIndex:-w}}e.$1C=A}),define(Se[205],De([1,0,14,131,204]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class R{constructor(m,k,A,C,$,v,w,h,f){this.a=m,this.b=k,this.c=A,this.d=C,this.e=$,this.f=v,this.g=w,this.h=h,this.j=f}k(m){const k=this.c+this.d+this.e,A=this.c+this.e;return k===0?m===1?`
`:`\r
`:A>k/2?`\r
`:`
`}create(m){const k=this.k(m),A=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let $=0,v=A.length;$<v;$++){const w=A[$].buffer.replace(/\r\n|\r|\n/g,k),h=(0,O.$VC)(w);A[$]=new O.$YC(w,h)}const C=new L.$1C(A,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class N{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&d.$Wf(m)&&(this.b=d.$Vf,m=m.substr(1));const k=m.charCodeAt(m.length-1);k===13||k>=55296&&k<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=k):(this.m(m,!1),this.c=!1,this.d=k)}m(m,k){!k&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const k=(0,O.$WC)(this.e,m);this.a.push(new O.$YC(m,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=d.$Lf(m)),this.k||(this.k=d.$Of(m)))}finish(m=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const k=(0,O.$VC)(m.buffer);m.lineStarts=k,this.d===13&&this.f++}}}e.$2C=N}),define(Se[135],De([1,0,21,12]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccb=m,e.$dcb=A;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function R(C){for(let $=0,v=C.length;$<v;$+=4){const w=C[$+0],h=C[$+1],f=C[$+2],a=C[$+3];C[$+0]=a,C[$+1]=f,C[$+2]=h,C[$+3]=w}}function N(C){const $=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return O.$D()||R($),d.$Fe.wrap($)}function p(C){const $=C.buffer;if(O.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const v=new Uint8Array($.byteLength);return v.set($),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function m(C){const $=new Uint32Array(k(C));let v=0;if($[v++]=C.id,C.type==="full")$[v++]=1,$[v++]=C.data.length,$.set(C.data,v),v+=C.data.length;else{$[v++]=2,$[v++]=C.deltas.length;for(const w of C.deltas)$[v++]=w.start,$[v++]=w.deleteCount,w.data?($[v++]=w.data.length,$.set(w.data,v),v+=w.data.length):$[v++]=0}return N($)}function k(C){let $=0;if($+=2,C.type==="full")$+=1+C.data.length;else{$+=1,$+=3*C.deltas.length;for(const v of C.deltas)v.data&&($+=v.data.length)}return $}function A(C){const $=p(C);let v=0;const w=$[v++];if($[v++]===1){const n=$[v++],i=$.subarray(v,v+n);return v+=n,{id:w,type:"full",data:i}}const f=$[v++],a=[];for(let n=0;n<f;n++){const i=$[v++],l=$[v++],o=$[v++];let t;o>0&&(t=$.subarray(v,v+o),v+=o),a[n]={start:i,deleteCount:l,data:t}}return{id:w,type:"delta",deltas:a}}}),define(Se[206],De([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(Se[136],De([1,0,19,24,12,182,130,206]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=f,e.clampedInt=n,e.clampedFloat=l,e.stringSet=u,e.cursorStyleToString=D,e.filterValidationDecorations=ve;var m;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(re){this.c=re}hasChanged(re){return this.c[re]}}e.ConfigurationChangedEvent=k;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(re,Pe,He,Le){this.id=re,this.name=Pe,this.defaultValue=He,this.schema=Le}applyUpdate(re,Pe){return v(re,Pe)}compute(re,Pe,He){return He}}class ${constructor(re,Pe){this.newValue=re,this.didChange=Pe}}e.ApplyUpdateResult=$;function v(te,re){if(typeof te!="object"||typeof re!="object"||!te||!re)return new $(re,te!==re);if(Array.isArray(te)||Array.isArray(re)){const He=Array.isArray(te)&&Array.isArray(re)&&d.$ub(te,re);return new $(re,!He)}let Pe=!1;for(const He in re)if(re.hasOwnProperty(He)){const Le=v(te[He],re[He]);Le.didChange&&(te[He]=Le.newValue,Pe=!0)}return new $(te,Pe)}class w{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Pe){return v(re,Pe)}validate(re){return this.defaultValue}}class h{constructor(re,Pe,He,Le){this.id=re,this.name=Pe,this.defaultValue=He,this.schema=Le}applyUpdate(re,Pe){return v(re,Pe)}validate(re){return typeof re>"u"?this.defaultValue:re}compute(re,Pe,He){return He}}function f(te,re){return typeof te>"u"?re:te==="false"?!1:!!te}class a extends h{constructor(re,Pe,He,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=He),super(re,Pe,He,Le)}validate(re){return f(re,this.defaultValue)}}function n(te,re,Pe,He){if(typeof te>"u")return re;let Le=parseInt(te,10);return isNaN(Le)?re:(Le=Math.max(Pe,Le),Le=Math.min(He,Le),Le|0)}class i extends h{static clampedInt(re,Pe,He,Le){return n(re,Pe,He,Le)}constructor(re,Pe,He,Le,st,ut=void 0){typeof ut<"u"&&(ut.type="integer",ut.default=He,ut.minimum=Le,ut.maximum=st),super(re,Pe,He,ut),this.minimum=Le,this.maximum=st}validate(re){return i.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}function l(te,re,Pe,He){if(typeof te>"u")return re;const Le=o.float(te,re);return o.clamp(Le,Pe,He)}class o extends h{static clamp(re,Pe,He){return re<Pe?Pe:re>He?He:re}static float(re,Pe){if(typeof re=="number")return re;if(typeof re>"u")return Pe;const He=parseFloat(re);return isNaN(He)?Pe:He}constructor(re,Pe,He,Le,st){typeof st<"u"&&(st.type="number",st.default=He),super(re,Pe,He,st),this.validationFn=Le}validate(re){return this.validationFn(o.float(re,this.defaultValue))}}class t extends h{static string(re,Pe){return typeof re!="string"?Pe:re}constructor(re,Pe,He,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=He),super(re,Pe,He,Le)}validate(re){return t.string(re,this.defaultValue)}}function u(te,re,Pe,He){return typeof te!="string"?re:He&&te in He?He[te]:Pe.indexOf(te)===-1?re:te}class r extends h{constructor(re,Pe,He,Le,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Le,st.default=He),super(re,Pe,He,st),this.c=Le}validate(re){return u(re,this.defaultValue,this.c)}}class c extends C{constructor(re,Pe,He,Le,st,ut,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=Le),super(re,Pe,He,mt),this.c=st,this.d=ut}validate(re){return typeof re!="string"?this.defaultValue:this.c.indexOf(re)===-1?this.defaultValue:this.d(re)}}function s(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class y extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Pe,He){return He===0?re.accessibilitySupport:He}}class b extends C{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:p.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{insertSpace:f(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function g(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function D(te){switch(te){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function P(te){switch(te){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class I extends w{constructor(){super(142)}compute(re,Pe,He){const Le=["monaco-editor"];return Pe.get(39)&&Le.push(Pe.get(39)),re.extraEditorClassName&&Le.push(re.extraEditorClassName),Pe.get(74)==="default"?Le.push("mouse-default"):Pe.get(74)==="copy"&&Le.push("mouse-copy"),Pe.get(111)&&Le.push("showUnused"),Pe.get(140)&&Le.push("showDeprecated"),Le.join(" ")}}class F extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(re,Pe,He){return He&&re.emptySelectionClipboard}}class T extends C{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:p.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:p.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{cursorMoveOnType:f(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":u(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":u(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Pe.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"||re.length===0?z.OFF:re==="true"?z.ON:re:re?z.ON:z.OFF}}e.EditorFontLigatures=z;class M extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"?M.OFF:re==="true"?M.TRANSLATE:re:re?M.TRANSLATE:M.OFF}compute(re,Pe,He){return re.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class j extends w{constructor(){super(50)}compute(re,Pe,He){return re.fontInfo}}class U extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(re){const Pe=o.float(re,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Pe,6,100)}compute(re,Pe,He){return re.fontInfo.fontSize}}class Z extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(re){return re==="normal"||re==="bold"?re:String(i.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class ie extends C{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{multiple:u(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??u(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??u(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??u(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??u(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??u(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends C{constructor(){const re={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:re.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:re.above,description:p.localize(46,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),delay:i.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:f(Pe.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Pe.above,this.defaultValue.above)}}}var G;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class x extends w{constructor(){super(145)}compute(re,Pe,He){return x.computeLayout(Pe,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio,glyphMarginDecorationLaneCount:re.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(re){const Pe=re.height/re.lineHeight,He=Math.floor(re.paddingTop/re.lineHeight);let Le=Math.floor(re.paddingBottom/re.lineHeight);re.scrollBeyondLastLine&&(Le=Math.max(Le,Pe-1));const st=(He+re.viewLineCount+Le)/(re.pixelRatio*re.height),ut=Math.floor(re.viewLineCount/st);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Le,desiredRatio:st,minimapLineCount:ut}}static c(re,Pe){const He=re.outerWidth,Le=re.outerHeight,st=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const ut=Pe.stableMinimapLayoutInput,mt=ut&&re.outerHeight===ut.outerHeight&&re.lineHeight===ut.lineHeight&&re.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&re.pixelRatio===ut.pixelRatio&&re.scrollBeyondLastLine===ut.scrollBeyondLastLine&&re.paddingTop===ut.paddingTop&&re.paddingBottom===ut.paddingBottom&&re.minimap.enabled===ut.minimap.enabled&&re.minimap.side===ut.minimap.side&&re.minimap.size===ut.minimap.size&&re.minimap.showSlider===ut.minimap.showSlider&&re.minimap.renderCharacters===ut.minimap.renderCharacters&&re.minimap.maxColumn===ut.minimap.maxColumn&&re.minimap.scale===ut.minimap.scale&&re.verticalScrollbarWidth===ut.verticalScrollbarWidth&&re.isViewportWrapping===ut.isViewportWrapping,Dt=re.lineHeight,It=re.typicalHalfwidthCharacterWidth,Ut=re.scrollBeyondLastLine,Wt=re.minimap.renderCharacters;let St=st>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const Yt=re.minimap.maxColumn,xt=re.minimap.size,xe=re.minimap.side,cn=re.verticalScrollbarWidth,Kt=re.viewLineCount,ft=re.remainingWidth,$t=re.isViewportWrapping,_t=Wt?2:3;let Xt=Math.floor(st*Le);const jt=Xt/st;let gt=!1,qt=!1,en=_t*St,Vt=St/st,Ze=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Tt,extraLinesBeforeFirstLine:on,extraLinesBeyondLastLine:Gt,desiredRatio:an,minimapLineCount:Lt}=x.computeContainedMinimapLineCount({viewLineCount:Kt,scrollBeyondLastLine:Ut,paddingTop:re.paddingTop,paddingBottom:re.paddingBottom,height:Le,lineHeight:Dt,pixelRatio:st});if(Kt/Lt>1)gt=!0,qt=!0,St=1,en=1,Vt=St/st;else{let Bt=!1,At=St+1;if(xt==="fit"){const pt=Math.ceil((on+Kt+Gt)*en);$t&&mt&&ft<=Pe.stableFitRemainingWidth?(Bt=!0,At=Pe.stableFitMaxMinimapScale):Bt=pt>Xt}if(xt==="fill"||Bt){gt=!0;const pt=St;en=Math.min(Dt*st,Math.max(1,Math.floor(1/an))),$t&&mt&&ft<=Pe.stableFitRemainingWidth&&(At=Pe.stableFitMaxMinimapScale),St=Math.min(At,Math.max(1,Math.floor(en/_t))),St>pt&&(Ze=Math.min(2,St/pt)),Vt=St/st/Ze,Xt=Math.ceil(Math.max(Tt,on+Kt+Gt)*en),$t?(Pe.stableMinimapLayoutInput=re,Pe.stableFitRemainingWidth=ft,Pe.stableFitMaxMinimapScale=St):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const dn=Math.floor(Yt*Vt),Zt=Math.min(dn,Math.max(0,Math.floor((ft-cn-2)*Vt/(It+Vt)))+e.MINIMAP_GUTTER_WIDTH);let Ht=Math.floor(st*Zt);const bt=Ht/st;Ht=Math.floor(Ht*Ze);const zt=Wt?1:2,Mt=xe==="left"?0:He-Zt-cn;return{renderMinimap:zt,minimapLeft:Mt,minimapWidth:Zt,minimapHeightIsEditorHeight:gt,minimapIsSampling:qt,minimapScale:St,minimapLineHeight:en,minimapCanvasInnerWidth:Ht,minimapCanvasInnerHeight:Xt,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:jt}}static computeLayout(re,Pe){const He=Pe.outerWidth|0,Le=Pe.outerHeight|0,st=Pe.lineHeight|0,ut=Pe.lineNumbersDigitCount|0,mt=Pe.typicalHalfwidthCharacterWidth,Dt=Pe.maxDigitWidth,It=Pe.pixelRatio,Ut=Pe.viewLineCount,Wt=re.get(137),St=Wt==="inherit"?re.get(136):Wt,Yt=St==="inherit"?re.get(132):St,xt=re.get(135),xe=Pe.isDominatedByLongLines,cn=re.get(57),Kt=re.get(68).renderType!==0,ft=re.get(69),$t=re.get(105),_t=re.get(84),Xt=re.get(73),jt=re.get(103),gt=jt.verticalScrollbarSize,qt=jt.verticalHasArrows,en=jt.arrowSize,Vt=jt.horizontalScrollbarSize,Ze=re.get(43),dn=re.get(110)!=="never";let Zt=re.get(66);Ze&&dn&&(Zt+=16);let Ht=0;if(Kt){const un=Math.max(ut,ft);Ht=Math.round(un*Dt)}let bt=0;cn&&(bt=st*Pe.glyphMarginDecorationLaneCount);let zt=0,Mt=zt+bt,Tt=Mt+Ht,on=Tt+Zt;const Gt=He-bt-Ht-Zt;let an=!1,Lt=!1,Ft=-1;St==="inherit"&&xe?(an=!0,Lt=!0):Yt==="on"||Yt==="bounded"?Lt=!0:Yt==="wordWrapColumn"&&(Ft=xt);const Bt=x.c({outerWidth:He,outerHeight:Le,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:It,scrollBeyondLastLine:$t,paddingTop:_t.top,paddingBottom:_t.bottom,minimap:Xt,verticalScrollbarWidth:gt,viewLineCount:Ut,remainingWidth:Gt,isViewportWrapping:Lt},Pe.memory||new A);Bt.renderMinimap!==0&&Bt.minimapLeft===0&&(zt+=Bt.minimapWidth,Mt+=Bt.minimapWidth,Tt+=Bt.minimapWidth,on+=Bt.minimapWidth);const At=Gt-Bt.minimapWidth,pt=Math.max(1,Math.floor((At-gt-2)/mt)),kt=qt?en:0;return Lt&&(Ft=Math.max(1,pt),Yt==="bounded"&&(Ft=Math.min(Ft,xt))),{width:He,height:Le,glyphMarginLeft:zt,glyphMarginWidth:bt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:Ht,decorationsLeft:Tt,decorationsWidth:Zt,contentLeft:on,contentWidth:At,minimap:Bt,viewportColumn:pt,isWordWrapMinified:an,isViewportWrapping:Lt,wrappingColumn:Ft,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Vt,overviewRuler:{top:kt,width:gt,height:Le-2*kt,right:0}}}}e.EditorLayoutInfoComputer=x;class ne extends C{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(re){return u(re,"simple",["simple","advanced"])}compute(re,Pe,He){return Pe.get(2)===2?"advanced":He}}var be;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(be||(e.ShowLightbulbIconMode=be={}));class ae extends C{constructor(){const re={enabled:be.On};super(65,"lightbulb",re,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[be.Off,be.OnCode,be.On],default:re.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:u(re.enabled,this.defaultValue.enabled,[be.Off,be.OnCode,be.On])}}}class Ce extends C{constructor(){const re={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",re,{"editor.stickyScroll.enabled":{type:"boolean",default:re.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:re.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:re.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:re.scrollWithEditor,description:p.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:u(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends C{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:p.localize(65,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:u(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:f(Pe.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(re){return typeof re=="string"&&/^\d+(\.\d+)?ch$/.test(re)?-parseFloat(re.substring(0,re.length-2)):i.clampedInt(re,this.defaultValue,0,1e3)}compute(re,Pe,He){return He<0?i.clampedInt(-He*re.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class _ extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>o.clamp(re,0,150),{markdownDescription:p.localize(66,null)})}compute(re,Pe,He){return re.fontInfo.lineHeight}}class pe extends C{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:re.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:re.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:re.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:re.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:re.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),autohide:f(Pe.autohide,this.defaultValue.autohide),size:u(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(Pe.side,this.defaultValue.side,["right","left"]),showSlider:u(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Pe.scale,1,1,3),maxColumn:i.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:f(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:f(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function ue(te){return te==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class ce extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{top:i.clampedInt(Pe.top,0,0,1e3),bottom:i.clampedInt(Pe.bottom,0,0,1e3)}}}class oe extends C{constructor(){const re={enabled:!0,cycle:!0};super(86,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:p.localize(84,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),cycle:f(Pe.cycle,this.defaultValue.cycle)}}}class le extends w{constructor(){super(143)}compute(re,Pe,He){return re.pixelRatio}}class J extends C{constructor(){const re={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:re.strings,description:p.localize(88,null)},comments:{anyOf:Pe,default:re.comments,description:p.localize(89,null)},other:{anyOf:Pe,default:re.other,description:p.localize(90,null)}},default:re,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=re}validate(re){if(typeof re=="boolean"){const It=re?"on":"off";return{comments:It,strings:It,other:It}}if(!re||typeof re!="object")return this.defaultValue;const{other:Pe,comments:He,strings:Le}=re,st=["on","inline","off"];let ut,mt,Dt;return typeof Pe=="boolean"?ut=Pe?"on":"off":ut=u(Pe,this.defaultValue.other,st),typeof He=="boolean"?mt=He?"on":"off":mt=u(He,this.defaultValue.comments,st),typeof Le=="boolean"?Dt=Le?"on":"off":Dt=u(Le,this.defaultValue.strings,st),{other:ut,comments:mt,strings:Dt}}}var se;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class $e extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(re){let Pe=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof re<"u"&&(typeof re=="function"?(Pe=4,He=re):re==="interval"?Pe=3:re==="relative"?Pe=2:re==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:He}}}function ve(te){const re=te.get(98);return re==="editable"?te.get(91):re!=="on"}class Re extends C{constructor(){const re=[],Pe={type:"number",description:p.localize(97,null)};super(102,"rulers",re,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:re,description:p.localize(99,null)})}validate(re){if(Array.isArray(re)){const Pe=[];for(const He of re)if(typeof He=="number")Pe.push({column:i.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Le=He;Pe.push({column:i.clampedInt(Le.column,0,0,1e4),color:Le.color})}return Pe.sort((He,Le)=>He.column-Le.column),Pe}return this.defaultValue}}class ge extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(re){return!re||typeof re!="object"?this.defaultValue:re}}function Ie(te,re){if(typeof te!="string")return re;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends C{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:re.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re,He=i.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=i.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Pe.vertical,this.defaultValue.vertical),horizontal:Ie(Pe.horizontal,this.defaultValue.horizontal),useShadows:f(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:i.clampedInt(Pe.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:i.clampedInt(Pe.verticalSliderSize,Le,0,1e3),scrollByPage:f(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends C{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:p.localize(118,null)}})}applyUpdate(re,Pe){let He=!1;Pe.allowedCharacters&&re&&(O.$7n(re.allowedCharacters,Pe.allowedCharacters)||(re={...re,allowedCharacters:Pe.allowedCharacters},He=!0)),Pe.allowedLocales&&re&&(O.$7n(re.allowedLocales,Pe.allowedLocales)||(re={...re,allowedLocales:Pe.allowedLocales},He=!0));const Le=super.applyUpdate(re,Pe);return He?new $(Le.newValue,!0):Le}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{nonBasicASCII:de(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(re.allowedLocales,this.defaultValue.allowedLocales)}}c(re,Pe){if(typeof re!="object"||!re)return Pe;const He={};for(const[Le,st]of Object.entries(re))st===!0&&(He[Le]=!0);return He}}class V extends C{constructor(){const re={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:re.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:re.fontFamily,description:p.localize(125,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),mode:u(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class W extends C{constructor(){const re={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",re,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:re.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:re.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:re.backgroundColoring,description:p.localize(132,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showToolbar:u(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:f(Pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:f(Pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends C{constructor(){const re={enabled:R.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends C{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:re.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:re.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:re.highlightActiveIndentation,description:p.localize(148,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{bracketPairs:de(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(te,re,Pe){const He=Pe.indexOf(te);return He===-1?re:Pe[He]}class we extends C{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:re.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:re.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{insertMode:u(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:f(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:f(Pe.preview,this.defaultValue.preview),previewMode:u(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Pe.showMethods,this.defaultValue.showMethods),showFunctions:f(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Pe.showFields,this.defaultValue.showFields),showVariables:f(Pe.showVariables,this.defaultValue.showVariables),showClasses:f(Pe.showClasses,this.defaultValue.showClasses),showStructs:f(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:f(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Pe.showModules,this.defaultValue.showModules),showProperties:f(Pe.showProperties,this.defaultValue.showProperties),showEvents:f(Pe.showEvents,this.defaultValue.showEvents),showOperators:f(Pe.showOperators,this.defaultValue.showOperators),showUnits:f(Pe.showUnits,this.defaultValue.showUnits),showValues:f(Pe.showValues,this.defaultValue.showValues),showConstants:f(Pe.showConstants,this.defaultValue.showConstants),showEnums:f(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Pe.showKeywords,this.defaultValue.showKeywords),showWords:f(Pe.showWords,this.defaultValue.showWords),showColors:f(Pe.showColors,this.defaultValue.showColors),showFiles:f(Pe.showFiles,this.defaultValue.showFiles),showReferences:f(Pe.showReferences,this.defaultValue.showReferences),showFolders:f(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:f(Pe.showUsers,this.defaultValue.showUsers),showIssues:f(Pe.showIssues,this.defaultValue.showIssues)}}}class Fe extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(re.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends C{constructor(){const re=[];super(130,"wordSegmenterLocales",re,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(re){if(typeof re=="string"&&(re=[re]),Array.isArray(re)){const Pe=[];for(const He of re)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&Pe.push(He)}catch{}return Pe}return this.defaultValue}}var Je;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(Je||(e.WrappingIndent=Je={}));class tt extends C{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(re,Pe,He){return Pe.get(2)===2?0:He}}class _e extends w{constructor(){super(146)}compute(re,Pe,He){const Le=Pe.get(145);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class nt extends C{constructor(){const re={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",re,{"editor.dropIntoEditor.enabled":{type:"boolean",default:re.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showDropSelector:u(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends C{constructor(){const re={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",re,{"editor.pasteAs.enabled":{type:"boolean",default:re.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showPasteSelector:u(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",Ne="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?at:L.$k?Ne:rt,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ye(te){return e.editorOptionsRegistry[te.id]=te,te}var qe;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",te[te.quickSuggestions=89]="quickSuggestions",te[te.quickSuggestionsDelay=90]="quickSuggestionsDelay",te[te.readOnly=91]="readOnly",te[te.readOnlyMessage=92]="readOnlyMessage",te[te.renameOnType=93]="renameOnType",te[te.renderControlCharacters=94]="renderControlCharacters",te[te.renderFinalNewline=95]="renderFinalNewline",te[te.renderLineHighlight=96]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=98]="renderValidationDecorations",te[te.renderWhitespace=99]="renderWhitespace",te[te.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",te[te.roundedSelection=101]="roundedSelection",te[te.rulers=102]="rulers",te[te.scrollbar=103]="scrollbar",te[te.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=105]="scrollBeyondLastLine",te[te.scrollPredominantAxis=106]="scrollPredominantAxis",te[te.selectionClipboard=107]="selectionClipboard",te[te.selectionHighlight=108]="selectionHighlight",te[te.selectOnLineNumbers=109]="selectOnLineNumbers",te[te.showFoldingControls=110]="showFoldingControls",te[te.showUnused=111]="showUnused",te[te.snippetSuggestions=112]="snippetSuggestions",te[te.smartSelect=113]="smartSelect",te[te.smoothScrolling=114]="smoothScrolling",te[te.stickyScroll=115]="stickyScroll",te[te.stickyTabStops=116]="stickyTabStops",te[te.stopRenderingLineAfter=117]="stopRenderingLineAfter",te[te.suggest=118]="suggest",te[te.suggestFontSize=119]="suggestFontSize",te[te.suggestLineHeight=120]="suggestLineHeight",te[te.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",te[te.suggestSelection=122]="suggestSelection",te[te.tabCompletion=123]="tabCompletion",te[te.tabIndex=124]="tabIndex",te[te.unicodeHighlighting=125]="unicodeHighlighting",te[te.unusualLineTerminators=126]="unusualLineTerminators",te[te.useShadowDOM=127]="useShadowDOM",te[te.useTabStops=128]="useTabStops",te[te.wordBreak=129]="wordBreak",te[te.wordSegmenterLocales=130]="wordSegmenterLocales",te[te.wordSeparators=131]="wordSeparators",te[te.wordWrap=132]="wordWrap",te[te.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=135]="wordWrapColumn",te[te.wordWrapOverride1=136]="wordWrapOverride1",te[te.wordWrapOverride2=137]="wordWrapOverride2",te[te.wrappingIndent=138]="wrappingIndent",te[te.wrappingStrategy=139]="wrappingStrategy",te[te.showDeprecated=140]="showDeprecated",te[te.inlayHints=141]="inlayHints",te[te.editorClassName=142]="editorClassName",te[te.pixelRatio=143]="pixelRatio",te[te.tabFocusMode=144]="tabFocusMode",te[te.layoutInfo=145]="layoutInfo",te[te.wrappingInfo=146]="wrappingInfo",te[te.defaultColorDecorators=147]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(qe||(e.EditorOption=qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:ye(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:ye(new y),accessibilityPageSize:ye(new i(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:ye(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:ye(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ye(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:ye(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:ye(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:ye(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:ye(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:ye(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:ye(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:ye(new a(13,"automaticLayout",!1)),autoSurround:ye(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:ye(new K),bracketPairGuides:ye(new X),stickyTabStops:ye(new a(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:ye(new a(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:ye(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:ye(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:ye(new a(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:ye(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:ye(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:ye(new a(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:ye(new b),contextmenu:ye(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new a(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:ye(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:ye(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:ye(new c(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:p.localize(260,null)})),cursorSurroundingLines:ye(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:ye(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:ye(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:ye(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new a(34,"domReadOnly",!1)),dragAndDrop:ye(new a(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:ye(new F),dropIntoEditor:ye(new nt),stickyScroll:ye(new Ce),experimentalWhitespaceRendering:ye(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:ye(new t(39,"extraEditorClassName","")),fastScrollSensitivity:ye(new o(40,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:p.localize(271,null)})),find:ye(new T),fixedOverflowWidgets:ye(new a(42,"fixedOverflowWidgets",!1)),folding:ye(new a(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:ye(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:ye(new a(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:ye(new a(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:ye(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:ye(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:ye(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:ye(new j),fontLigatures2:ye(new z),fontSize:ye(new U),fontWeight:ye(new Z),fontVariations:ye(new M),formatOnPaste:ye(new a(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:ye(new a(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:ye(new a(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:ye(new ie),hideCursorInOverviewRuler:ye(new a(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:ye(new Q),inDiffEditor:ye(new a(61,"inDiffEditor",!1)),letterSpacing:ye(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>o.clamp(te,-5,20),{description:p.localize(285,null)})),lightbulb:ye(new ae),lineDecorationsWidth:ye(new B),lineHeight:ye(new _),lineNumbers:ye(new $e),lineNumbersMinChars:ye(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new a(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:ye(new a(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:ye(new r(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:ye(new pe),mouseStyle:ye(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new o(75,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:ye(new a(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:ye(new a(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:ye(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:ye(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:ye(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:ye(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:ye(new a(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:ye(new i(83,"overviewRulerLanes",3,0,3)),padding:ye(new ce),pasteAs:ye(new it),parameterHints:ye(new oe),peekWidgetDefaultFocus:ye(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:ye(new a(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:ye(new J),quickSuggestionsDelay:ye(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:ye(new a(91,"readOnly",!1)),readOnlyMessage:ye(new ge),renameOnType:ye(new a(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:ye(new a(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:ye(new r(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:ye(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:ye(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:ye(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:ye(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ye(new a(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:ye(new Re),scrollbar:ye(new Ae),scrollBeyondLastColumn:ye(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:ye(new a(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:ye(new a(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:ye(new a(107,"selectionClipboard",!0,{description:p.localize(325,null),included:L.$k})),selectionHighlight:ye(new a(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:ye(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:ye(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:ye(new a(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:ye(new a(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:ye(new ee),snippetSuggestions:ye(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:ye(new Fe),smoothScrolling:ye(new a(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:ye(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new we),inlineSuggest:ye(new V),inlineEdit:ye(new W),inlineCompletionsAccessibilityVerbose:ye(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:ye(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ye(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ye(new a(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:ye(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:ye(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:ye(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ye(new ze),unusualLineTerminators:ye(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:ye(new a(127,"useShadowDOM",!0)),useTabStops:ye(new a(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:ye(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:ye(new Ve),wordSeparators:ye(new t(131,"wordSeparators",N.$5s,{description:p.localize(359,null)})),wordWrap:ye(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:ye(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:ye(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ye(new I),defaultColorDecorators:ye(new a(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:ye(new le),tabFocusMode:ye(new a(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:ye(new x),wrappingInfo:ye(new _e),wrappingIndent:ye(new tt),wrappingStrategy:ye(new ne)}}),define(Se[207],De([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(Se[84],De([1,0,79,2,180,29,190,207]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$fu=e.$eu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$du=e.$cu=e.SymbolKinds=e.SymbolTag=e.$au=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$$t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$0t=e.$9t=e.$8t=void 0,e.$_t=r,e.$bu=s;class m{constructor(G,x,ne){this.offset=G,this.type=x,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$8t=m;class k{constructor(G,x){this.tokens=G,this.endState=x,this._tokenizationResultBrand=void 0}}e.$9t=k;class A{constructor(G,x){this.tokens=G,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$0t=A;var C;(function(Q){Q[Q.Increase=0]="Increase",Q[Q.Decrease=1]="Decrease"})(C||(e.HoverVerbosityAction=C={}));var $;(function(Q){Q[Q.Method=0]="Method",Q[Q.Function=1]="Function",Q[Q.Constructor=2]="Constructor",Q[Q.Field=3]="Field",Q[Q.Variable=4]="Variable",Q[Q.Class=5]="Class",Q[Q.Struct=6]="Struct",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Event=10]="Event",Q[Q.Operator=11]="Operator",Q[Q.Unit=12]="Unit",Q[Q.Value=13]="Value",Q[Q.Constant=14]="Constant",Q[Q.Enum=15]="Enum",Q[Q.EnumMember=16]="EnumMember",Q[Q.Keyword=17]="Keyword",Q[Q.Text=18]="Text",Q[Q.Color=19]="Color",Q[Q.File=20]="File",Q[Q.Reference=21]="Reference",Q[Q.Customcolor=22]="Customcolor",Q[Q.Folder=23]="Folder",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue",Q[Q.Snippet=27]="Snippet"})($||(e.CompletionItemKind=$={}));var v;(function(Q){const G=new Map;G.set(0,d.$Vj.symbolMethod),G.set(1,d.$Vj.symbolFunction),G.set(2,d.$Vj.symbolConstructor),G.set(3,d.$Vj.symbolField),G.set(4,d.$Vj.symbolVariable),G.set(5,d.$Vj.symbolClass),G.set(6,d.$Vj.symbolStruct),G.set(7,d.$Vj.symbolInterface),G.set(8,d.$Vj.symbolModule),G.set(9,d.$Vj.symbolProperty),G.set(10,d.$Vj.symbolEvent),G.set(11,d.$Vj.symbolOperator),G.set(12,d.$Vj.symbolUnit),G.set(13,d.$Vj.symbolValue),G.set(15,d.$Vj.symbolEnum),G.set(14,d.$Vj.symbolConstant),G.set(15,d.$Vj.symbolEnum),G.set(16,d.$Vj.symbolEnumMember),G.set(17,d.$Vj.symbolKeyword),G.set(27,d.$Vj.symbolSnippet),G.set(18,d.$Vj.symbolText),G.set(19,d.$Vj.symbolColor),G.set(20,d.$Vj.symbolFile),G.set(21,d.$Vj.symbolReference),G.set(22,d.$Vj.symbolCustomColor),G.set(23,d.$Vj.symbolFolder),G.set(24,d.$Vj.symbolTypeParameter),G.set(25,d.$Vj.account),G.set(26,d.$Vj.issues);function x(ae){let Ce=G.get(ae);return Ce||(console.info("No codicon found for CompletionItemKind "+ae),Ce=d.$Vj.symbolProperty),Ce}Q.toIcon=x;const ne=new Map;ne.set("method",0),ne.set("function",1),ne.set("constructor",2),ne.set("field",3),ne.set("variable",4),ne.set("class",5),ne.set("struct",6),ne.set("interface",7),ne.set("module",8),ne.set("property",9),ne.set("event",10),ne.set("operator",11),ne.set("unit",12),ne.set("value",13),ne.set("constant",14),ne.set("enum",15),ne.set("enum-member",16),ne.set("enumMember",16),ne.set("keyword",17),ne.set("snippet",27),ne.set("text",18),ne.set("color",19),ne.set("file",20),ne.set("reference",21),ne.set("customcolor",22),ne.set("folder",23),ne.set("type-parameter",24),ne.set("typeParameter",24),ne.set("account",25),ne.set("issue",26);function be(ae,Ce){let ee=ne.get(ae);return typeof ee>"u"&&!Ce&&(ee=9),ee}Q.fromString=be})(v||(e.CompletionItemKinds=v={}));var w;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var h;(function(Q){Q[Q.None=0]="None",Q[Q.KeepWhitespace=1]="KeepWhitespace",Q[Q.InsertAsSnippet=4]="InsertAsSnippet"})(h||(e.CompletionItemInsertTextRule=h={}));var f;(function(Q){Q[Q.Word=0]="Word",Q[Q.Line=1]="Line",Q[Q.Suggest=2]="Suggest"})(f||(e.PartialAcceptTriggerKind=f={}));var a;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a||(e.CompletionTriggerKind=a={}));var n;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(G,x,ne,be){this.range=G,this.text=x,this.completionKind=ne,this.isSnippetText=be}equals(G){return R.$ut.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$$t=i;var l;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Auto=2]="Auto"})(l||(e.CodeActionTriggerType=l={}));var o;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.PasteAs=1]="PasteAs"})(o||(e.DocumentPasteTriggerKind=o={}));var t;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var u;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function r(Q){return Q&&O.URI.isUri(Q.uri)&&R.$ut.isIRange(Q.range)&&(R.$ut.isIRange(Q.originSelectionRange)||R.$ut.isIRange(Q.targetSelectionRange))}var c;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.$au={17:(0,p.localize)(0,null),16:(0,p.localize)(1,null),4:(0,p.localize)(2,null),13:(0,p.localize)(3,null),8:(0,p.localize)(4,null),9:(0,p.localize)(5,null),21:(0,p.localize)(6,null),23:(0,p.localize)(7,null),7:(0,p.localize)(8,null),0:(0,p.localize)(9,null),11:(0,p.localize)(10,null),10:(0,p.localize)(11,null),19:(0,p.localize)(12,null),5:(0,p.localize)(13,null),1:(0,p.localize)(14,null),2:(0,p.localize)(15,null),20:(0,p.localize)(16,null),15:(0,p.localize)(17,null),18:(0,p.localize)(18,null),24:(0,p.localize)(19,null),3:(0,p.localize)(20,null),6:(0,p.localize)(21,null),14:(0,p.localize)(22,null),22:(0,p.localize)(23,null),25:(0,p.localize)(24,null),12:(0,p.localize)(25,null)};function s(Q,G){return(0,p.localize)(26,null,Q,e.$au[G])}var y;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var b;(function(Q){const G=new Map;G.set(0,d.$Vj.symbolFile),G.set(1,d.$Vj.symbolModule),G.set(2,d.$Vj.symbolNamespace),G.set(3,d.$Vj.symbolPackage),G.set(4,d.$Vj.symbolClass),G.set(5,d.$Vj.symbolMethod),G.set(6,d.$Vj.symbolProperty),G.set(7,d.$Vj.symbolField),G.set(8,d.$Vj.symbolConstructor),G.set(9,d.$Vj.symbolEnum),G.set(10,d.$Vj.symbolInterface),G.set(11,d.$Vj.symbolFunction),G.set(12,d.$Vj.symbolVariable),G.set(13,d.$Vj.symbolConstant),G.set(14,d.$Vj.symbolString),G.set(15,d.$Vj.symbolNumber),G.set(16,d.$Vj.symbolBoolean),G.set(17,d.$Vj.symbolArray),G.set(18,d.$Vj.symbolObject),G.set(19,d.$Vj.symbolKey),G.set(20,d.$Vj.symbolNull),G.set(21,d.$Vj.symbolEnumMember),G.set(22,d.$Vj.symbolStruct),G.set(23,d.$Vj.symbolEvent),G.set(24,d.$Vj.symbolOperator),G.set(25,d.$Vj.symbolTypeParameter);function x(ne){let be=G.get(ne);return be||(console.info("No codicon found for SymbolKind "+ne),be=d.$Vj.symbolProperty),be}Q.toIcon=x})(b||(e.SymbolKinds=b={}));class S{static asEditOperation(G){return L.$vt.replace(R.$ut.lift(G.range),G.text)}}e.$cu=S;class g{static{this.Comment=new g("comment")}static{this.Imports=new g("imports")}static{this.Region=new g("region")}static fromValue(G){switch(G){case"comment":return g.Comment;case"imports":return g.Imports;case"region":return g.Region}return new g(G)}constructor(G){this.value=G}}e.$du=g;var E;(function(Q){Q[Q.AIGenerated=1]="AIGenerated"})(E||(e.NewSymbolNameTag=E={}));var D;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(D||(e.NewSymbolNameTriggerKind=D={}));var P;(function(Q){function G(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}Q.is=G})(P||(e.Command=P={}));var I;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var F;(function(Q){Q[Q.Unresolved=0]="Unresolved",Q[Q.Resolved=1]="Resolved"})(F||(e.CommentThreadState=F={}));var T;(function(Q){Q[Q.Current=0]="Current",Q[Q.Outdated=1]="Outdated"})(T||(e.CommentThreadApplicability=T={}));var z;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var M;(function(Q){Q[Q.Published=0]="Published",Q[Q.Draft=1]="Draft"})(M||(e.CommentState=M={}));var j;(function(Q){Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class U{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$eu=U,e.$fu=new N.$Zt;var Z;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(Z||(e.ExternalUriOpenerPriority=Z={}));var ie;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(ie||(e.InlineEditTriggerKind=ie={}))}),define(Se[208],De([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[209],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[210],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(Se[211],De([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[212],De([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[213],De([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[214],De([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[215],De([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(Se[216],De([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(Se[217],De([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[218],De([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(Se[219],De([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(Se[220],De([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(Se[221],De([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[222],De([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[223],De([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(Se[224],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[225],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[226],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[227],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[228],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[229],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[230],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[231],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[232],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[233],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[234],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[235],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[236],De([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[237],De([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(Se[238],De([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(Se[239],De([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(Se[240],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[241],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[242],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[243],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[244],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[245],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[246],De([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[247],De([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[248],De([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[249],De([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[250],De([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[251],De([1,0,13,210]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var L;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...k){switch(k.length){case 1:return(0,O.localize)(0,null,k[0]);case 2:return(0,O.localize)(1,null,k[0],k[1]);case 3:return(0,O.localize)(2,null,k[0],k[1],k[2]);default:return}}const N=(0,O.localize)(3,null),p=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,d.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,$=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:$};this.g.push({offset:C,lexeme:$,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),$=m.b.get(C);$?this.k($):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const w=this.c.charCodeAt(A);if(C)C=!1;else if(w===47&&!$){A++;break}else w===91?$=!0:w===92?C=!0:w===93&&($=!1);A++}for(;A<this.c.length&&m.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=m}),define(Se[252],De([1,0,23,41,213,401]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=m,e.$Hp=k,e.$Ip=A,e.$Jp=C,e.$Kp=$,e.$Lp=v,e.$Mp=w;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function m(a){return a=a.trim(),a==="*"||N.test(a)}function k(a){if(!m(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(N);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,l=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let u=a.patchMustEqual;a.hasCaret&&(n===0||(o=!1),u=!1);let r=0;if(a.preRelease){const c=p.exec(a.preRelease);if(c){const[,s,y,b]=c;r=Date.UTC(Number(s),Number(y)-1,Number(b))}}return{majorBase:n,majorMustEqual:i,minorBase:l,minorMustEqual:o,patchBase:t,patchMustEqual:u,isMinimum:a.hasGreaterEquals,notBefore:r}}function C(a,n,i){let l;typeof a=="string"?l=A(k(a)):l=a;let o;n instanceof Date?o=n.getTime():typeof n=="string"&&(o=new Date(n).getTime());let t;if(typeof i=="string"?t=A(k(i)):t=i,!l||!t)return!1;const u=l.majorBase,r=l.minorBase,c=l.patchBase;let s=t.majorBase,y=t.minorBase,b=t.patchBase;const S=t.notBefore;let g=t.majorMustEqual,E=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?u>s?!0:u<s?!1:r>y?!0:r<y||o&&o<S?!1:c>=b:(u===1&&s===0&&(!g||!E||!D)&&(s=1,y=0,b=0,g=!0,E=!1,D=!1),u<s?!1:u>s?!g:r<y?!1:r>y?!E:c<b?!1:c>b?!D:!(o&&o<S))}function $(a,n,i,l,o){const t=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return t.push([O.default.Error,L.localize(0,null)]),t;if(typeof l.name!="string")return t.push([O.default.Error,L.localize(1,null,"name")]),t;if(typeof l.version!="string")return t.push([O.default.Error,L.localize(2,null,"version")]),t;if(!l.engines)return t.push([O.default.Error,L.localize(3,null,"engines")]),t;if(typeof l.engines.vscode!="string")return t.push([O.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof l.extensionDependencies<"u"&&!f(l.extensionDependencies))return t.push([O.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof l.activationEvents<"u"){if(!f(l.activationEvents))return t.push([O.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof l.main>"u"&&typeof l.browser>"u")return t.push([O.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&t.push([O.default.Warning,L.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return t.push([O.default.Error,L.localize(9,null,"main")]),t;{const c=(0,d.$0g)(i,l.main);(0,d.$4g)(c,i)||t.push([O.default.Warning,L.localize(10,null,c.path,i.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return t.push([O.default.Error,L.localize(11,null,"browser")]),t;{const c=(0,d.$0g)(i,l.browser);(0,d.$4g)(c,i)||t.push([O.default.Warning,L.localize(12,null,c.path,i.path)])}}if(!R.valid(l.version))return t.push([O.default.Error,L.localize(13,null)]),t;const u=[];if(!v(a,n,l,o,u))for(const c of u)t.push([O.default.Error,c]);return t}function v(a,n,i,l,o){return l||typeof i.main>"u"&&typeof i.browser>"u"?!0:h(a,n,i.engines.vscode,o)}function w(a,n,i){return a==="*"||h(n,i,a)}function h(a,n,i,l=[]){const o=A(k(i));if(!o)return l.push(L.localize(14,null,i)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return l.push(L.localize(15,null,i)),!1}else if(!o.majorMustEqual)return l.push(L.localize(16,null,i)),!1;return C(a,n,o)?!0:(l.push(L.localize(17,null,a,i)),!1)}function f(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(Se[106],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class d{constructor(L,R=[],N=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=N}}e.$ti=d}),define(Se[85],De([1,0,106]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=R,e.$ys=N;const O=[];var L;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(p,m,k){m instanceof d.$ti||(m=new d.$ti(m,[],!!k)),O.push([p,m])}function N(){return O}}),define(Se[253],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class d{constructor(R,N){this.key=R,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$ar=d;class O{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const N of this.a.values())N.outgoing.size===0&&R.push(N);return R}insertEdge(R,N){const p=this.lookupOrInsertNode(R),m=this.lookupOrInsertNode(N);p.outgoing.set(m.key,m),m.incoming.set(p.key,p)}removeNode(R){const N=this.b(R);this.a.delete(N);for(const p of this.a.values())p.outgoing.delete(N),p.incoming.delete(N)}lookupOrInsertNode(R){const N=this.b(R);let p=this.a.get(N);return p||(p=new d(N,R),this.a.set(N,p)),p}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[N,p]of this.a)R.push(`${N}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,N]of this.a){const p=new Set([R]),m=this.c(N,p);if(m)return m}}c(R,N){for(const[p,m]of R.outgoing){if(N.has(p))return[...N,p].join(" -> ");N.add(p);const k=this.c(m,N);if(k)return k;N.delete(p)}}}e.$br=O}),define(Se[5],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=L,e.$xi=R;var d;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function p(m){return m[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=p})(d||(e._util=d={})),e.$vi=L("instantiationService");function O(N,p,m){p[d.DI_TARGET]===p?p[d.DI_DEPENDENCIES].push({id:N,index:m}):(p[d.DI_DEPENDENCIES]=[{id:N,index:m}],p[d.DI_TARGET]=p)}function L(N){if(d.serviceIds.has(N))return d.serviceIds.get(N);const p=function(m,k,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(p,m,A)};return p.toString=()=>N,d.serviceIds.set(N,p),p}function R(N){return N}}),define(Se[55],De([1,0,18,2,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=R,e.$5i=N,e.$6i=m,e.$7i=k,e.$8i=A,e.$9i=C,e.$0i=$,e.$$i=w,e.$_i=h,e.$aj=f,e.$3i=(0,L.$wi)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof O.URI)}function N(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof O.URI)}var p;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function m(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function A(a,n){const i=Object.create(null);for(const l in a)C(i,l,a[l],n);return i}function C(a,n,i,l){const o=n.split("."),t=o.pop();let u=a;for(let r=0;r<o.length;r++){const c=o[r];let s=u[c];switch(typeof s){case"undefined":s=u[c]=Object.create(null);break;case"object":if(s===null){l(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is null`);return}break;default:l(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}u=s}if(typeof u=="object"&&u!==null)try{u[t]=i}catch{l(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(u)}`)}else l(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(u)}`)}function $(a,n){const i=n.split(".");v(a,i)}function v(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const l=a[i];typeof l=="object"&&!Array.isArray(l)&&(v(l,n),Object.keys(l).length===0&&delete a[i])}}function w(a,n,i){function l(u,r){let c=u;for(const s of r){if(typeof c!="object"||c===null)return;c=c[s]}return c}const o=n.split("."),t=l(a,o);return typeof t>"u"?i:t}function h(a,n,i){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in a?d.$$f(a[l])&&d.$$f(n[l])?h(a[l],n[l],i):i&&(a[l]=n[l]):a[l]=n[l])})}function f(a){return a.replace(/[\[\]]/g,"")}}),define(Se[38],De([1,0,12,14,251,5,209,13]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=k,e.$vj=u,e.$wj=r,e.$Pj=be;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",d.$j),m.set("isLinux",d.$k),m.set("isWindows",d.$i),m.set("isWeb",d.$o),m.set("isMacNative",d.$j&&!d.$o),m.set("isEdge",d.$H),m.set("isFirefox",d.$F),m.set("isChrome",d.$E),m.set("isSafari",d.$G);function k(ee,B){if(m.get(ee)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ee,B)}const A=Object.prototype.hasOwnProperty;var C;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const $={regexParsingWithErrorRecovery:!0},v=(0,N.localize)(0,null),w=(0,N.localize)(1,null),h=(0,N.localize)(2,null),f=(0,N.localize)(3,null),a=(0,N.localize)(4,null),n=(0,N.localize)(5,null),i=(0,N.localize)(6,null),l=(0,N.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=$){this.k=B,this.d=new L.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const pe=this.D(),ue=pe.type===17?n:void 0;throw this.h.push({message:a,offset:pe.offset,lexeme:L.$rj.getLexeme(pe),additionalInfo:ue}),o.c}return _}catch(_){if(_!==o.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const _=this.o();B.push(_)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const _=this.s();B.push(_)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),y.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,f),_?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,f),_}case 17:{const _=B.lexeme;if(this.z(),this.y(9)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==10)throw this.B("REGEX",ue);const ce=ue.lexeme,oe=ce.lastIndexOf("/"),le=oe===ce.length-1?void 0:this.w(ce.substring(oe+1));let J;try{J=new RegExp(ce.substring(1,oe),le)}catch{throw this.B("REGEX",ue)}return j.create(_,J)}switch(ue.type){case 10:case 19:{const ce=[ue.lexeme];this.z();let oe=this.D(),le=0;for(let Re=0;Re<ue.lexeme.length;Re++)ue.lexeme.charCodeAt(Re)===40?le++:ue.lexeme.charCodeAt(Re)===41&&le--;for(;!this.E()&&oe.type!==15&&oe.type!==16;){switch(oe.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let Re=0;Re<oe.lexeme.length;Re++)oe.lexeme.charCodeAt(Re)===40?le++:ue.lexeme.charCodeAt(Re)===41&&le--}if(le<0)break;ce.push(L.$rj.getLexeme(oe)),this.z(),oe=this.D()}const J=ce.join(""),se=J.lastIndexOf("/"),$e=se===J.length-1?void 0:this.w(J.substring(se+1));let ve;try{ve=new RegExp(J.substring(1,se),$e)}catch{throw this.B("REGEX",ue)}return t.regex(_,ve)}case 18:{const ce=ue.lexeme;this.z();let oe=null;if(!(0,O.$7e)(ce)){const le=ce.indexOf("/"),J=ce.lastIndexOf("/");if(le!==J&&le>=0){const se=ce.slice(le+1,J),$e=ce[J+1]==="i"?"i":"";try{oe=new RegExp(se,$e)}catch{throw this.B("REGEX",ue)}}}if(oe===null)throw this.B("REGEX",ue);return j.create(_,oe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const ue=this.u();return t.notIn(_,ue)}switch(this.D().type){case 3:{this.z();const ue=this.u();if(this.x().type===18)return t.equals(_,ue);switch(ue){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,ue)}}case 4:{this.z();const ue=this.u();if(this.x().type===18)return t.notEquals(_,ue);switch(ue){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,ue)}}case 5:return this.z(),z.create(_,this.u());case 6:return this.z(),M.create(_,this.u());case 7:return this.z(),F.create(_,this.u());case 8:return this.z(),T.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:i,offset:B.offset,lexeme:"",additionalInfo:l}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,pe){const ue=(0,N.localize)(8,null,B,L.$rj.getLexeme(_)),ce=_.offset,oe=L.$rj.getLexeme(_);return this.h.push({message:ue,offset:ce,lexeme:oe,additionalInfo:pe}),o.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=o;class t{static false(){return s.INSTANCE}static true(){return y.INSTANCE}static has(B){return b.create(B)}static equals(B,_){return S.create(B,_)}static notEquals(B,_){return D.create(B,_)}static regex(B,_){return j.create(B,_)}static in(B,_){return g.create(B,_)}static notIn(B,_){return E.create(B,_)}static not(B){return P.create(B)}static and(...B){return ie.create(B,null,!0)}static or(...B){return Q.create(B,null,!0)}static greater(B,_){return F.create(B,_)}static greaterEquals(B,_){return T.create(B,_)}static smaller(B,_){return z.create(B,_)}static smallerEquals(B,_){return M.create(B,_)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$uj=t;function u(ee){const B=new o({regexParsingWithErrorRecovery:!1});return ee.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,N.localize)(9,null,pe.additionalInfo):(0,N.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function r(ee,B){const _=ee?ee.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!_&&!pe?!0:!_||!pe?!1:_.equals(pe)}function c(ee,B){return ee.cmp(B)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return y.INSTANCE}}e.$xj=s;class y{static{this.INSTANCE=new y}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return s.INSTANCE}}e.$yj=y;class b{static create(B,_=null){const pe=m.get(B);return typeof pe=="boolean"?pe?y.INSTANCE:s.INSTANCE:new b(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:x(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=m.get(this.key);return typeof B=="boolean"?B?y.INSTANCE:s.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$zj=b;class S{static create(B,_,pe=null){if(typeof _=="boolean")return _?b.create(B,pe):P.create(B,pe);const ue=m.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?y.INSTANCE:s.INSTANCE:new S(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=m.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?y.INSTANCE:s.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Aj=S;class g{static create(B,_){return new g(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(_)?_.includes(pe):typeof pe=="string"&&typeof _=="object"&&_!==null?A.call(_,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Bj=g;class E{static create(B,_){return new E(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=11,this.c=g.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=E;class D{static create(B,_,pe=null){if(typeof _=="boolean")return _?P.create(B,pe):b.create(B,pe);const ue=m.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?s.INSTANCE:y.INSTANCE:new D(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=m.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?s.INSTANCE:y.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Dj=D;class P{static create(B,_=null){const pe=m.get(B);return typeof pe=="boolean"?pe?s.INSTANCE:y.INSTANCE:new P(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:x(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=m.get(this.c);return typeof B=="boolean"?B?s.INSTANCE:y.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Ej=P;function I(ee,B){if(typeof ee=="string"){const _=parseFloat(ee);isNaN(_)||(ee=_)}return typeof ee=="string"||typeof ee=="number"?B(ee):s.INSTANCE}class F{static create(B,_,pe=null){return I(_,ue=>new F(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Fj=F;class T{static create(B,_,pe=null){return I(_,ue=>new T(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Gj=T;class z{static create(B,_,pe=null){return I(_,ue=>new z(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=z;class M{static create(B,_,pe=null){return I(_,ue=>new M(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ij=M;class j{static create(B,_){return new j(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return _<pe?-1:_>pe?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&_===pe}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Jj=j;class U{static create(B){return new U(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new U(this.c.map(B))}negate(){return this.c}}e.$Kj=U;function Z(ee){let B=null;for(let _=0,pe=ee.length;_<pe;_++){const ue=ee[_].substituteConstants();if(ee[_]!==ue&&B===null){B=[];for(let ce=0;ce<_;ce++)B[ce]=ee[ce]}B!==null&&(B[_]=ue)}return B===null?ee:B}class ie{static create(B,_,pe){return ie.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=c(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=Z(this.expr);return B===this.expr?this:ie.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,pe){const ue=[];let ce=!1;for(const oe of B)if(oe){if(oe.type===1){ce=!0;continue}if(oe.type===0)return s.INSTANCE;if(oe.type===6){ue.push(...oe.expr);continue}ue.push(oe)}if(ue.length===0&&ce)return y.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort(c);for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];for(;ue.length>1;){const oe=ue[ue.length-1];if(oe.type!==9)break;ue.pop();const le=ue.pop(),J=ue.length===0,se=Q.create(oe.expr.map($e=>ie.create([$e,le],null,pe)),null,J);se&&(ue.push(se),ue.sort(c))}if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return s.INSTANCE;if(ue.length===1)return ue[0]}return new ie(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new ie(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=Q.create(B,this,!0)}return this.c}}e.$Lj=ie;class Q{static create(B,_,pe){return Q.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=c(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=Z(this.expr);return B===this.expr?this:Q.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,pe){let ue=[],ce=!1;if(B){for(let oe=0,le=B.length;oe<le;oe++){const J=B[oe];if(J){if(J.type===0){ce=!0;continue}if(J.type===1)return y.INSTANCE;if(J.type===9){ue=ue.concat(J.expr);continue}ue.push(J)}}if(ue.length===0&&ce)return s.INSTANCE;ue.sort(c)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return y.INSTANCE;if(ue.length===1)return ue[0]}return new Q(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new Q(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),pe=B.shift(),ue=[];for(const ce of Ce(_))for(const oe of Ce(pe))ue.push(ie.create([ce,oe],null,!1));B.unshift(Q.create(ue,null,!1))}this.c=Q.create(B,this,!0)}return this.c}}e.$Mj=Q;class G extends b{static{this.d=[]}static all(){return G.d.values()}constructor(B,_,pe){super(B,null),this.f=_,typeof pe=="object"?G.d.push({...pe,key:B}):pe!==!0&&G.d.push({key:B,description:pe,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return D.create(this.key,B)}}e.$Nj=G,e.$Oj=(0,R.$wi)("contextKeyService");function x(ee,B){return ee<B?-1:ee>B?1:0}function ne(ee,B,_,pe){return ee<_?-1:ee>_?1:B<pe?-1:B>pe?1:0}function be(ee,B){if(ee.type===0||B.type===1)return!0;if(ee.type===9)return B.type===9?ae(ee.expr,B.expr):!1;if(B.type===9){for(const _ of B.expr)if(be(ee,_))return!0;return!1}if(ee.type===6){if(B.type===6)return ae(B.expr,ee.expr);for(const _ of ee.expr)if(be(_,B))return!0;return!1}return ee.equals(B)}function ae(ee,B){let _=0,pe=0;for(;_<ee.length&&pe<B.length;){const ue=ee[_].cmp(B[pe]);if(ue<0)return!1;ue===0&&_++,pe++}return _===ee.length}function Ce(ee){return ee.type===9?ee.expr:[ee]}}),define(Se[254],De([1,0,23,41,211,5,103,12,24]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Pw=e.$Ow=e.$Nw=void 0,e.$Qw=v,e.$Rw=w,e.$Nw=(0,R.$wi)("dialogService");var k;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(k||(k={}));class A{a(f){return this.d(f,k.Confirmation)}b(f){return this.d(f,k.Prompt)}c(f){return this.d(f,k.Input)}d(f,a){const n=[];switch(a){case k.Confirmation:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case k.Prompt:{const i=f;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(l=>l.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case k.Input:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===O.default.Info?"info":f===O.default.Error?"error":f===O.default.Warning?"warning":"none"}f(f,a,n){const i=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&i.push(f.cancelButton);let l=i[a]?.run({checkboxChecked:n});return l instanceof Promise||(l=Promise.resolve(l)),{result:l,checkboxChecked:n}}}e.$Ow=A,e.$Pw=(0,R.$wi)("fileDialogService");var C;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const $=10;function v(h){const f=[];return f.push(...h.slice(0,$).map(a=>typeof a=="string"?a:(0,d.$7g)(a))),h.length>$&&(h.length-$===1?f.push((0,L.localize)(7,null)):f.push((0,L.localize)(8,null,h.length-$))),f.push(""),f.join(`
`)}function w(h,f){const a=(0,m.$3n)(h);let n=(a.buttons??[]).map(t=>(0,N.$Kw)(t)),i=(h.buttons||[]).map((t,u)=>u),l=0,o=a.cancelId??n.length-1;if(n.length>1){const t=typeof o=="number"?n[o]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&n.length>1&&o!==1){n.splice(o,1),n.splice(1,0,t);const u=i[o];i.splice(o,1),i.splice(1,0,u),o=1}p.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),l=n.length-1,typeof t=="string"&&(o=l-1))}else if(p.$i&&typeof t=="string"&&n.length>1&&o!==n.length-1){n.splice(o,1),n.push(t);const u=i[o];i.splice(o,1),i.push(u),o=n.length-1}}return a.buttons=n,a.defaultId=l,a.cancelId=o,a.noLink=!0,a.title=a.title||f.nameLong,{options:a,buttonIndeces:i}}}),define(Se[137],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,d.$wi)("environmentService"),e.$Ei=(0,d.$xi)(e.$Di)}),define(Se[138],De([1,0,212,5]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=L,e.$1o=R,e.$2o=N,e.$3o=p,e.$4o=m,e.$5o=k,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function L(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function N(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(n,i){return i==="web"&&!n.includes("web")}function m(n,i,l){return p(i,l)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===l}function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var $;(function(n){n.Install="install",n.Uninstall="uninstall"})($||(e.StatisticType=$={}));var v;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$6o=(0,O.$wi)("extensionGalleryService");var w;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));class h extends Error{constructor(i,l){super(i),this.code=l,this.name=l}}e.$7o=h;var f;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(f||(e.ExtensionGalleryErrorCode=f={}));class a extends Error{constructor(i,l){super(i),this.code=l,this.name=l}}e.$8o=a,e.$9o=(0,O.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,O.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,O.$wi)("IExtensionTipsService"),e.$bp=(0,d.localize2)(0,"Extensions"),e.$cp=(0,d.localize2)(1,"Preferences")}),define(Se[255],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=e.$u7b=void 0,e.$u7b=(0,d.$wi)("externalTerminal"),e.$v7b="Terminal.app"}),define(Se[256],De([1,0,54,56,15,17,12,102,32,105,214,255]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=e.$Bcc=void 0;const $=A.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends v{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(d,o,k.$om(),t)}spawnTerminal(o,t,u,r){const c=t.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=R.$nc(c,".exe").toLowerCase();if(s==="cmder")return o.spawn(c,r?[r]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return c.indexOf(" ")>=0&&y.push('""'),y.push(c),s==="wt"&&y.push("-d ."),new Promise((b,S)=>{const g=a(process),E=o.spawn(u,y,{cwd:r,env:g,detached:!0});E.on("error",S),E.on("exit",()=>b())})}async runInTerminal(o,t,u,r,c){const s="windowsExec"in c&&c.windowsExec?c.windowsExec:w.getDefaultTerminalWindows(),y=await w.f();return new Promise((b,S)=>{const g=`"${t} - ${$}"`,E=`"${u.join('" "')}" & pause`,D=Object.assign({},a(process),r);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const P={cwd:t,env:D,windowsVerbatimArguments:!0};let I,F;R.$nc(s,".exe")==="wt"?(I=s,F=["-d",".",w.b,"/c",E]):y?(I=y,F=["-d",".",s,"/c",E]):(I=w.b,F=["/c","start",g,"/wait",s,"/c",`"${E}"`]),d.spawn(I,F,P).on("error",z=>{S(n(z))}),b(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const o=await k.win32.findExecutable("wt");return await m.Promises.exists(o)?o:void 0}catch{return}}}e.$Bcc=w,Ge([O.$1h],w,"f",null);class h extends v{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(d,o,t)}runInTerminal(o,t,u,r,c){const s=c.osxExec||C.$v7b;return new Promise((y,b)=>{if(s===C.$v7b||s==="iTerm.app"){const S=s===C.$v7b?"TerminalHelper":"iTermHelper",E=[L.$Qg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",o||$,"-w",t];for(const I of u)E.push("-a"),E.push(I);if(r){const I=Object.assign({},a(process),r);for(const F in I){const T=I[F];T===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${T}`))}}let D="";const P=d.spawn(h.b,E);P.on("error",I=>{b(n(I))}),P.stderr.on("data",I=>{D+=I.toString()}),P.on("exit",I=>{if(I===0)y(void 0);else if(D){const F=D.split(`
`,1);b(new Error(F[0]))}else b(new Error(A.localize(1,null,S,I)))})}else b(new Error(A.localize(2,null,s)))})}spawnTerminal(o,t,u){const r=t.osxExec||C.$v7b;return new Promise((c,s)=>{const y=["-a",r];u&&y.push(u);const b=a(process),S=o.spawn("/usr/bin/open",y,{cwd:u,env:b});S.on("error",s),S.on("exit",()=>c())})}}e.$Ccc=h;class f extends v{static{this.b=A.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(d,o,t)}runInTerminal(o,t,u,r,c){const s=c.linuxExec?Promise.resolve(c.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((y,b)=>{const S=[];s.then(g=>{g.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const E=`${i(u)}; echo; read -p "${f.b}" -n1;`;S.push(`''${E}''`);const D=Object.assign({},a(process),r);Object.keys(D).filter(T=>D[T]===null).forEach(T=>delete D[T]);const P={cwd:t,env:D};let I="";const F=d.spawn(g,S,P);F.on("error",T=>{b(n(T))}),F.stderr.on("data",T=>{I+=T.toString()}),F.on("exit",T=>{if(T===0)y(void 0);else if(I){const z=I.split(`
`,1);b(new Error(z[0]))}else b(new Error(A.localize(4,null,g,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!N.$k)f.d=Promise.resolve("xterm");else{const o=await m.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(o,t,u){const r=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,s)=>{r.then(y=>{const b=a(process),S=o.spawn(y,[],{cwd:u,env:b});S.on("error",s),S.on("exit",()=>c())})})}}e.$Dcc=f;function a(l){const o={...l.env};return(0,p.$mm)(o),o}function n(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(A.localize(5,null,l.path)):l}function i(l){let o="";for(const t of l)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(Se[33],De([1,0,78,17,14,18,2,215,5,12,15,46]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=$,e.$5k=f,e.$6k=n,e.$7k=i,e.$8k=l,e.$9k=o,e.$0k=t,e.$$k=u,e.$_k=r,e.$al=c,e.$bl=s,e.$dl=S,e.$el=g,e.$fl=E,e.$gl=D,e.$hl=P,e.$kl=M,e.$wl=G,e.$xl=x,e.$zl=be,e.$3k=(0,m.$wi)("fileService");function $(ae){return ae.create===!0}var v;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var w;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var h;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function f(ae){const Ce=ae;return!!Ce&&typeof Ce.onDidChange=="function"}var a;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function n(ae){return!!(ae.capabilities&2)}function i(ae){return!!(ae.capabilities&8)}function l(ae){return!!(ae.capabilities&131072)}function o(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function u(ae){return n(ae)?!!(ae.capabilities&16384):!1}function r(ae){return n(ae)?!!(ae.capabilities&32768):!1}function c(ae){return!!(ae.capabilities&65536)}function s(ae){return!!(ae.capabilities&2048)}var y;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class b extends Error{static create(Ce,ee){const B=new b(Ce.toString(),ee);return E(B,ee),B}constructor(Ce,ee){super(Ce),this.code=ee}}e.$cl=b;function S(ae,Ce){return b.create(ae,Ce)}function g(ae){return ae||S((0,p.localize)(0,null),y.Unknown)}function E(ae,Ce){return ae.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",ae}function D(ae){if(!ae)return y.Unknown;if(ae instanceof b)return ae.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ce)return y.Unknown;switch(Ce[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function P(ae){if(ae instanceof j)return ae.fileOperationResult;switch(D(ae)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 9;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileTooLarge:return 7;default:return 10}}var I;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class F{constructor(Ce,ee,B){this.resource=Ce,this.operation=ee,this.target=B}isOperation(Ce){return this.operation===Ce}}e.$il=F;var T;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class z{static{this.a=null}constructor(Ce,ee){this.c=ee,this.b=void 0,this.d=new C.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawAdded.map(_=>[_,!0])),B}),this.f=new C.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawUpdated.map(_=>[_,!0])),B}),this.g=new C.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawDeleted.map(_=>[_,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of Ce){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==z.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(Ce,...ee){return this.h(Ce,{includeChildren:!1},...ee)}affects(Ce,...ee){return this.h(Ce,{includeChildren:!0},...ee)}h(Ce,ee,...B){if(!Ce)return!1;const _=B.length>0;return!!((!_||B.includes(1))&&(this.d.value.get(Ce)||ee.includeChildren&&this.d.value.findSuperstr(Ce))||(!_||B.includes(0))&&(this.f.value.get(Ce)||ee.includeChildren&&this.f.value.findSuperstr(Ce))||(!_||B.includes(2))&&(this.g.value.findSubstr(Ce)||ee.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$jl=z;function M(ae,Ce,ee){return!ae||!Ce||ae===Ce||Ce.length>ae.length?!1:(Ce.charAt(Ce.length-1)!==O.sep&&(Ce+=O.sep),ee?(0,L.$yf)(ae,Ce):ae.indexOf(Ce)===0)}class j extends Error{constructor(Ce,ee,B){super(Ce),this.fileOperationResult=ee,this.options=B}}e.$ll=j;class U extends j{constructor(Ce,ee,B,_){super(Ce,ee,_),this.fileOperationResult=ee,this.size=B}}e.$ml=U;class Z extends j{constructor(Ce,ee,B){super(Ce,2,B),this.stat=ee}}e.$nl=Z;var ie;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var Q;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$vl="";function G(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function x(ae,Ce){if(!Ce.hasProvider(N.URI.from({scheme:ae.scheme})))return new Promise(ee=>{const B=Ce.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===ae.scheme&&_.added&&(B.dispose(),ee())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Ce){return(0,R.$ag)(Ce)||(Ce=0),Ce<ne.KB?(0,p.localize)(1,null,Ce.toFixed(0)):Ce<ne.MB?(0,p.localize)(2,null,(Ce/ne.KB).toFixed(2)):Ce<ne.GB?(0,p.localize)(3,null,(Ce/ne.MB).toFixed(2)):Ce<ne.TB?(0,p.localize)(4,null,(Ce/ne.GB).toFixed(2)):(0,p.localize)(5,null,(Ce/ne.TB).toFixed(2))}}e.$yl=ne;function be(ae){const Ce=typeof ae=="string"||ae?.scheme===A.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===A.Schemas.file?1024*ne.MB:Ce?10*ne.MB:k.$o?50*ne.MB:1024*ne.MB}}),define(Se[257],De([1,0,21,13,216,33]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=N;async function N(A,C,$,v,w,h){let f;try{await p(A,C,$,v,w,h)}catch(a){f=a}finally{f&&w.errorTransformer&&(f=w.errorTransformer(f)),typeof f<"u"&&$.error(f),$.end()}}async function p(A,C,$,v,w,h){m(h);const f=await A.open(C,{create:!1});try{m(h);let a=0,n=0,i=w&&typeof w.length=="number"?w.length:void 0,l=d.$Fe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=w&&typeof w.position=="number"?w.position:0,t=0;do n=await A.read(f,o,l.buffer,t,l.byteLength-t),o+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===l.byteLength&&(await $.write(v(l)),l=d.$Fe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&m(h)&&k(a,w));if(t>0){let u=t;typeof i=="number"&&(u=Math.min(t,i)),$.write(v(l.slice(0,u)))}}catch(a){throw(0,R.$el)(a)}finally{await A.close(f)}}function m(A){if(A.isCancellationRequested)throw(0,O.$6)();return!0}function k(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,R.$dl)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[65],De([1,0,35,3,17,12,2,33]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=m,e.$Kq=k,e.$Oq=v,e.$Pq=w,e.$Qq=h,e.$Rq=f,e.$Sq=n,e.$Tq=i;function m(l){return typeof l.correlationId=="number"}function k(l){return l.recursive===!0}class A extends O.$Uc{static{this.a=5}constructor(o,t,u,r){super(),this.h=o,this.j=t,this.m=u,this.n=r,this.c=this.B(new O.$Vc),this.f=void 0,this.g=0}s(){const o=new O.$Tc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(t=>this.h(t))),o.add(this.b.onDidLogMessage(t=>this.j(t))),o.add(this.b.onDidError(t=>this.t(t)))}t(o){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=A;class C extends A{constructor(o,t,u){super(o,t,u,{type:"node.js",restartOnError:!1})}}e.$Mq=C;class $ extends A{constructor(o,t,u){super(o,t,u,{type:"universal",restartOnError:!0})}}e.$Nq=$;function v(l){return l.map(o=>({type:o.type,resource:N.URI.revive(o.resource),cId:o.cId}))}function w(l){const o=new a;for(const t of l)o.processEvent(t);return o.coalesce()}function h(l,o){return typeof o=="string"&&!o.startsWith(d.$mk)&&!(0,L.$ic)(o)?{base:l,pattern:o}:o}function f(l,o){const t=[];for(const u of o)t.push((0,d.$qk)(h(l,u)));return t}class a{constructor(){this.a=new Set,this.b=new Map}c(o){return R.$k?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.b.get(this.c(o));let u=!1;if(t){const r=t.type,c=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===2||o.type===1)?u=!0:r===1&&c===2?(this.b.delete(this.c(o)),this.a.delete(t)):r===2&&c===1?t.type=0:r===1&&c===0||(t.type=c)}else u=!0;u&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],t=[];return Array.from(this.a).filter(u=>u.type!==2?(o.push(u),!1):!0).sort((u,r)=>u.resource.fsPath.length-r.resource.fsPath.length).filter(u=>t.some(r=>(0,p.$kl)(u.resource.fsPath,r,!R.$k))?!1:(t.push(u.resource.fsPath),!0)).concat(o)}}function n(l,o){if(typeof o=="number")switch(l.type){case 1:return(o&4)===0;case 2:return(o&8)===0;case 0:return(o&2)===0}return!1}function i(l){if(typeof l=="number"){const o=[];return l&4&&o.push("Added"),l&8&&o.push("Deleted"),l&2&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(Se[258],De([1,0,53,3,65,4,2,7]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class m extends O.$Uc{constructor(){super(),this.a=this.B(new R.$de),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$de),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$de),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new O.$4c),this.m=new Set,this.n=5007,this.r=new p.$Th,this.P=!1,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Jq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new p.$Th;try{this.h.clear(),this.g.clear();for(const C of A)this.t(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||(this.j.deleteAndDispose(C),this.m.delete(C));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const C=new O.$Tc;this.j.set(A.correlationId,C),await this.r.p,!C.isDisposed&&(this.z(A,C),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,C){this.C(A,C)?(this.N(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,C),this.m.add(A.correlationId))}C(A,C){const $=this.M?.subscribe(A.path,(v,w)=>{C.isDisposed||(v?this.z(A,C):w?.type===1&&this.F(A))});return $?(C.add($),!0):!1}D(A,C){let $=!1;const v=(w,h)=>{if(C.isDisposed)return;const f=this.G(w),a=this.G(h),n=$;$=f,!f&&(a||n)&&this.F(A)};this.N(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.watchFile)(A.path,{persistent:!1,interval:this.n},v)}catch(w){this.O(`fs.watchFile() failed with error ${w} on path ${A.path} (correlationId: ${A.correlationId})`)}C.add((0,O.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.unwatchFile)(A.path,v)}catch(w){this.O(`fs.unwatchFile() failed with error ${w} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.N(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const C={resource:N.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([C]),this.H(C,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,C){if(this.P){const $=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.I($,C)}}I(A,C){this.P&&this.N(`${A}${typeof C.correlationId=="number"?` <${C.correlationId}> `:""}`)}J(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, filter: ${(0,L.$Tq)(A.filter)}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}async setVerboseLogging(A){this.P=A}}e.$3q=m}),define(Se[259],De([1,0,53,7,22,31,3,77,17,12,23,2,104,32,65]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=f;class h extends N.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,l,o,t,u){super(),this.s=n,this.t=i,this.u=l,this.w=o,this.y=t,this.z=u,this.c=this.B(new O.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new O.$Kh(r=>this.M(r),h.b)),this.g=(0,w.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,w.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,w.$Jq)(this.s)?this.s.filter:void 0,this.m=new L.$oe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await v.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await v.Promises.realpath(n.path),n.path===i&&(i=await(0,$.$5q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const l=new N.$Tc;return this.H(n,i,l)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,l)),l}H(n,i,l){if(i)return!1;const o=C.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(u,r)=>{if(!l.isDisposed)if(u){const c=await this.G(n,i);l.isDisposed?c.dispose():l.add(c)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:r.type,cId:this.s.correlationId},!0)});return t?(l.add(t),!0):!1}async I(n,i,l){if(k.$j&&(0,R.$vg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new L.$oe(this.m.token);l.add((0,N.$Sc)(()=>o.dispose(!0)));const t=new N.$Tc;l.add(t);try{const u=C.URI.file(this.s.path),r=(0,m.$nc)(n),c=(0,d.watch)(n);t.add((0,N.$Sc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${n}'`);const s=new Set;if(i)try{for(const b of await v.Promises.readdir(n))s.add(b)}catch(b){this.O(b)}if(o.token.isCancellationRequested)return;const y=new Map;t.add((0,N.$Sc)(()=>{for(const[,b]of y)b.dispose();y.clear()})),c.on("error",(b,S)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${b}, ${S})`),this.D())}),c.on("change",(b,S)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${b}"] ${S}`);let g="";if(S&&(g=S.toString(),k.$j&&(g=(0,p.$bm)(g))),!(!g||b!=="change"&&b!=="rename"))if(i)if(b==="rename"){y.get(g)?.dispose();const E=setTimeout(async()=>{if(y.delete(g),g===r&&!await v.Promises.exists(n)){this.J(u);return}if(o.token.isCancellationRequested)return;const D=await this.N((0,m.$jc)(n,g));if(o.token.isCancellationRequested)return;let P;D?s.has(g)?P=0:(P=1,s.add(g)):(s.delete(g),P=2),this.L({resource:(0,A.$0g)(u,g),type:P,cId:this.s.correlationId})},h.a);y.set(g,(0,N.$Sc)(()=>clearTimeout(E)))}else{let E;s.has(g)?E=0:(E=1,s.add(g)),this.L({resource:(0,A.$0g)(u,g),type:E,cId:this.s.correlationId})}else if(b==="rename"||g!==r){const E=setTimeout(async()=>{const D=await v.Promises.exists(n);o.token.isCancellationRequested||(D?(this.L({resource:u,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(u))},h.a);t.clear(),t.add((0,N.$Sc)(()=>clearTimeout(E)))}else this.L({resource:u,type:0,cId:this.s.correlationId},!0)})}catch(u){o.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${u.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(l=>l(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(l=>l(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,w.$Pq)(n),l=[];for(const t of i){if((0,w.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}l.push(t)}if(l.length===0)return;if(this.z)for(const t of l)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(k.$k)return v.Promises.exists(n);try{const i=(0,m.$nc)(n);return(await v.Promises.readdir((0,m.$mc)(n))).some(o=>o===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=h;async function f(a,n,i,l,o=512){const t=await v.Promises.open(a,"r"),u=Buffer.allocUnsafe(o),r=new L.$oe(l);let c,s=!1;const y={path:a,excludes:[],recursive:!1},b=new h(y,void 0,S=>{(async()=>{for(const{type:g}of S)if(g===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await v.Promises.read(t,u,0,o,null);if(!E||r.token.isCancellationRequested)break;n(u.slice(0,E))}}catch(E){c=new Error(E),r.dispose(!0)}finally{s=!1}}})()});return await b.ready,i(),new Promise((S,g)=>{r.token.onCancellationRequested(async()=>{b.dispose();try{await v.Promises.close(t)}catch(E){c=new Error(E)}c?g(c):S()})})}}),define(Se[260],De([1,0,4,35,258,12,259,31]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class m extends L.$3q{constructor(A){super(),this.M=A,this.onDidError=d.Event.None,this.watchers=new Set}async L(A){A=this.X(A);const C=[],$=new Set(Array.from(this.watchers));for(const v of A){const w=this.S(v);w&&(0,O.$uk)(w.request.excludes,v.excludes)&&(0,O.$uk)(w.request.includes,v.includes)?$.delete(w):C.push(v)}C.length&&this.N(`Request to start watching: ${C.map(v=>this.J(v)).join(",")}`),$.size&&this.N(`Request to stop watching: ${Array.from($).map(v=>this.J(v.request)).join(",")}`);for(const v of $)this.W(v);for(const v of C)this.U(v)}S(A){for(const C of this.watchers)if(typeof A.correlationId=="number"||typeof C.request.correlationId=="number"){if(C.request.correlationId===A.correlationId)return C}else if((0,p.$ug)(C.request.path,A.path,!R.$k))return C}U(A){const C=new N.$8q(A,this.M,v=>this.a.fire(v),()=>this.c.fire(A),v=>this.b.fire(v),this.P),$={request:A,instance:C};this.watchers.add($)}async stop(){await super.stop();for(const A of this.watchers)this.W(A)}W(A){this.N("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}X(A){const C=new Map;for(const $ of A){const v=R.$k?$.path:$.path.toLowerCase();let w=C.get($.correlationId);w||(w=new Map,C.set($.correlationId,w)),w.has(v)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J($)}`),w.set(v,$)}return Array.from(C.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(A){super.setVerboseLogging(A);for(const C of this.watchers)C.instance.setVerboseLogging(A)}N(A,C){this.P&&this.b.fire({type:"trace",message:this.$(A,C)})}O(A){this.b.fire({type:"warn",message:this.$(A)})}$(A,C){return C?`[File Watcher (node.js)] ${A} (${this.J(C.request)})`:`[File Watcher (node.js)] ${A}`}}e.$0q=m}),define(Se[261],De([1,0,65,260]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class L extends d.$Mq{constructor(N,p,m){super(N,p,m),this.s()}r(N){return N.add(new O.$0q(void 0))}}e.$$q=L}),define(Se[262],De([1,0,15,82,199,65]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class N extends R.$Nq{constructor(m,k,A){super(m,k,A),this.s()}r(m){const k=m.add(new L.$1q(d.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(k.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C} (ETERM)`))),O.ProxyChannel.toService((0,O.$di)(k.getChannel("watcher")))}}e.$2q=N}),define(Se[107],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class d{constructor(...L){this.a=new Map;for(const[R,N]of L)this.set(R,N)}set(L,R){const N=this.a.get(L);return this.a.set(L,R),N}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ui=d}),define(Se[263],De([1,0,7,13,3,106,253,5,107,76]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const A=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class ${constructor(f=new m.$ui,a=!1,n,i=A){this.i=f,this.j=a,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$vi,this),this._globalGraph=i?n?._globalGraph??new N.$br(l=>l):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const f of this.g)(0,L.$Oc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f){this.m();const a=new class extends ${dispose(){this.h.delete(a),super.dispose()}}(f,this.j,this,this.l);return this.h.add(a),a}invokeFunction(f,...a){this.m();const n=w.traceInvocation(this.l,f);let i=!1;try{return f({get:o=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,n);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(f,...a){this.m();let n,i;return f instanceof R.$ti?(n=w.traceCreation(this.l,f.ctor),i=this.o(f.ctor,f.staticArguments.concat(a),n)):(n=w.traceCreation(this.l,f),i=this.o(f,a,n)),n.stop(),i}o(f,a=[],n){const i=p._util.getServiceDependencies(f).sort((t,u)=>t.index-u.index),l=[];for(const t of i){const u=this.s(t.id,n);u||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),l.push(u)}const o=i.length>0?i[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${f.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(f,a.concat(l))}q(f,a){if(this.i.get(f)instanceof R.$ti)this.i.set(f,a);else if(this.k)this.k.q(f,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const a=this.i.get(f);return!a&&this.k?this.k.r(f):a}s(f,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const n=this.r(f);return n instanceof R.$ti?this.u(f,n,a.branch(f,!0)):(a.branch(f,!1),n)}u(f,a,n){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,a,n)}finally{this.t.delete(f)}}v(f,a,n){const i=new N.$br(t=>t.id.toString());let l=0;const o=[{id:f,desc:a,_trace:n}];for(;o.length;){const t=o.pop();if(i.lookupOrInsertNode(t),l++>1e3)throw new C(i);for(const u of p._util.getServiceDependencies(t.desc.ctor)){const r=this.r(u.id);if(r||this.y(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),r instanceof R.$ti){const c={id:u.id,desc:r,_trace:t._trace.branch(u.id,!0)};i.insertEdge(t,c),o.push(c)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new C(i);break}for(const{data:u}of t){if(this.r(u.id)instanceof R.$ti){const c=this.w(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.q(u.id,c)}i.removeNode(u)}}return this.r(f)}w(f,a,n=[],i,l){if(this.i.get(f)instanceof R.$ti)return this.x(f,a,n,i,l,this.g);if(this.k)return this.k.w(f,a,n,i,l);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(f,a,n=[],i,l,o){if(i){const t=new $(void 0,this.j,this,this.l);t.c=String(f);const u=new Map,r=new d.$Ph(()=>{const c=t.o(a,n,l);for(const[s,y]of u){const b=c[s];if(typeof b=="function")for(const S of y)S.disposable=b.apply(c,S.listener)}return u.clear(),o.add(c),c});return new Proxy(Object.create(null),{get(c,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=u.get(s);return S||(S=new k.$5c,u.set(s,S)),(E,D,P)=>{if(r.isInitialized)return r.value[s](E,D,P);{const I={listener:[E,D,P],disposable:void 0},F=S.push(I);return(0,L.$Sc)(()=>{F(),I.disposable?.dispose()})}}}if(s in c)return c[s];const y=r.value;let b=y[s];return typeof b!="function"||(b=b.bind(y),c[s]=b),b},set(c,s,y){return r.value[s]=y,!0},getPrototypeOf(c){return a.prototype}})}else{const t=this.o(a,n,l);return o.add(t),t}}y(f,a){if(a&&console.warn(f),this.j)throw new Error(f)}}e.$cr=$;var v;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(v||(v={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,a){return f?new w(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(f,a){return f?new w(1,a.name):w.c}static{this.f=0}constructor(f,a){this.type=f,this.name=a,this.g=Date.now(),this.h=[]}branch(f,a){const n=new w(3,f.toString());return this.h.push([f,a,n]),n}stop(){const f=Date.now()-this.g;w.f+=f;let a=!1;function n(l,o){const t=[],u=new Array(l+1).join("	");for(const[r,c,s]of o.h)if(c&&s){a=!0,t.push(`${u}CREATES -> ${r}`);const y=n(l+1,s);y&&t.push(y)}else t.push(`${u}uses -> ${r}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(f>2||a)&&w.all.add(i.join(`
`))}}e.$dr=w}),define(Se[11],De([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=h,e.log=a,e.$ek=b,e.$fk=S,e.$gk=g,e.$hk=E,e.$3j=(0,v.$wi)("logService"),e.$4j=(0,v.$wi)("loggerService");function w(){return new Date().toISOString()}function h(D){return(0,A.$ag)(D)}var f;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$6j=f.Info;function a(D,P,I){switch(P){case f.Trace:D.trace(I);break;case f.Debug:D.debug(I);break;case f.Info:D.info(I);break;case f.Warning:D.warn(I);break;case f.Error:D.error(I);break;case f.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(D,P=!1){let I="";for(let F=0;F<D.length;F++){let T=D[F];if(T instanceof Error&&(T=(0,O.$hj)(T,P)),typeof T=="object")try{T=JSON.stringify(T)}catch{}I+=(F>0?" ":"")+T}return I}class i extends N.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new L.$de),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==f.Off&&this.b<=P}}e.$8j=i;class l extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(f.Trace)&&this.g(f.Trace,n([P,...I],!0))}debug(P,...I){this.f(f.Debug)&&this.g(f.Debug,n([P,...I]))}info(P,...I){this.f(f.Info)&&this.g(f.Info,n([P,...I]))}warn(P,...I){this.f(f.Warning)&&this.g(f.Warning,n([P,...I]))}error(P,...I){if(this.f(f.Error))if(P instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=P.stack,this.g(f.Error,n(F))}else this.g(f.Error,n([P,...I]))}flush(){}}e.$9j=l;class o extends i{constructor(P=e.$6j){super(),this.setLevel(P),this.g=!m.$i}trace(P,...I){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,P,...I):console.log(`[main ${w()}]`,P,...I))}debug(P,...I){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,P,...I):console.log(`[main ${w()}]`,P,...I))}info(P,...I){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,P,...I):console.log(`[main ${w()}]`,P,...I))}warn(P,...I){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,P,...I):console.warn(`[main ${w()}]`,P,...I))}error(P,...I){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,P,...I):console.error(`[main ${w()}]`,P,...I))}flush(){}}e.$0j=o;class t extends i{constructor(P=e.$6j,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$$j=t;class u extends i{constructor(P,I=e.$6j){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(P),...I])}debug(P,...I){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(P),...I])}info(P,...I){this.f(f.Info)&&this.g.log(f.Info,[this.h(P),...I])}warn(P,...I){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(P),...I])}error(P,...I){this.f(f.Error)&&this.g.log(f.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,O.$hj)(P,this.f(f.Trace))}flush(){}}e.$_j=u;class r extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const F of this.g)F.trace(P,...I)}debug(P,...I){for(const F of this.g)F.debug(P,...I)}info(P,...I){for(const F of this.g)F.info(P,...I)}warn(P,...I){for(const F of this.g)F.warn(P,...I)}error(P,...I){for(const F of this.g)F.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$ak=r;class c extends N.$Uc{constructor(P,I,F){if(super(),this.h=P,this.j=I,this.b=new p.$Ac,this.c=this.B(new L.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$de),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(P){return(0,A.$9f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const F=this.n(P),T=(0,A.$9f)(P)?P:I?.id??(0,R.$kj)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const M=I?.logLevel==="always"?f.Trace:I?.logLevel;z||(z=this.s(F,M??this.getLogLevel(F)??this.h,{...I,id:T}));const j={logger:z,info:{resource:F,id:T,logLevel:M,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(j.info),this.b.set(F,j),z}n(P){return(0,A.$9f)(P)?(0,k.$0g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(C.URI.isUri(P)){const F=P,T=I,z=this.b.get(F);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([F,T]))}else{this.h=P;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const F=this.m(P);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=c;class s{constructor(){this.onDidChangeLogLevel=new L.$de().event}setLevel(P){}getLevel(){return f.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$ck=s;class y extends s{}e.$dk=y;function b(D){if(D.verbose)return f.Trace;if(typeof D.logLevel=="string"){const P=E(D.logLevel.toLowerCase());if(P!==void 0)return P}return e.$6j}function S(D){switch(D){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function g(D){switch(D){case f.Trace:return{original:"Trace",value:d.localize(0,null)};case f.Debug:return{original:"Debug",value:d.localize(1,null)};case f.Info:return{original:"Info",value:d.localize(2,null)};case f.Warning:return{original:"Warning",value:d.localize(3,null)};case f.Error:return{original:"Error",value:d.localize(4,null)};case f.Off:return{original:"Off",value:d.localize(5,null)}}}function E(D){switch(D){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ik=new $.$Nj("logLevel",S(f.Info))}),define(Se[264],De([1,0,19,7,13,4,31,3,17,65,11]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class C extends p.$Uc{constructor(v,w){super(),this.a=v,this.b=w,this.c=this.B(new R.$de),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$de),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$uh(0)),this.w=[],this.y=this.B(new O.$uh(0))}watch(v,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(v,w):this.z(v,w)}n(v,w){const h={path:this.J(v),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},f=(0,d.$Tb)(this.j,h);return this.r(),(0,p.$Sc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,L.$1)(v))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,k.$Oq)(w)),w=>this.G(w),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const w of this.j)(0,k.$Kq)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const w of this.j)(0,k.$Kq)(w)&&v.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,w){const h={path:this.J(v),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},f=(0,d.$Tb)(this.w,h);return this.C(),(0,p.$Sc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,L.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,k.$Oq)(v)),v=>this.G(v),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.H(v)}H(v){this.a[v.type](v.message)}I(v){return(0,m.$hc)(v.fsPath)}J(v){const w=this.I(v);return(0,N.$yg)(w)}}e.$Uq=C}),define(Se[265],De([1,0,53,402,7,27,21,4,31,3,17,12,23,98,32,217,33,257,264,47,262,261]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,O.gracefulify)(d)}catch(u){console.error(`Error enabling graceful-fs: ${(0,i.$hj)(u)}`)}})();class t extends n.$Uq{static{this.L=!1}constructor(r,c){super(r,c),this.onDidChangeCapabilities=p.Event.None,this.P=new R.$Ac(s=>$.$1g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,C.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:c,symbolicLink:s}=await w.SymlinkSupport.stat(this.I(r));return{type:this.O(c,s),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:f.FilePermission.Locked}}catch(c){throw this.hb(c)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const c=await w.Promises.readdir(this.I(r),{withFileTypes:!0}),s=[];return await Promise.all(c.map(async y=>{try{let b;y.isSymbolicLink()?b=(await this.stat((0,$.$0g)(r,y.name))).type:b=this.O(y),s.push([y.name,b])}catch(b){this.a.trace(b)}})),s}catch(c){throw this.hb(c)}}O(r,c){let s;return c?.dangling?s=f.FileType.Unknown:r.isFile()?s=f.FileType.File:r.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,c&&(s|=f.FileType.SymbolicLink),s}async Q(r){const c=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let s;for(;s=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await s.wait();const y=new L.$vh;return this.P.set(r,y),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,k.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.P.get(r)===y&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),y.open()})}async readFile(r,c){let s;try{c?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),s=await this.Q(r));const y=this.I(r);return await w.Promises.readFile(y)}catch(y){throw this.hb(y)}finally{s?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,c,s){const y=(0,v.$te)(b=>N.$Fe.concat(b.map(S=>N.$Fe.wrap(S))).buffer);return(0,a.$Hq)(this,r,y,b=>b.buffer,{...c,bufferSize:256*1024},s),y}async writeFile(r,c,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(r)?this.U(r,(0,$.$0g)((0,$.$9g)(r),`${(0,$.$7g)(r)}${s.atomic.postfix}`),c,s):this.W(r,c,s)}async S(r){try{const c=this.I(r),{symbolicLink:s}=await w.SymlinkSupport.stat(c);if(s)return!1}catch{}return!0}async U(r,c,s,y){const b=new k.$Tc;try{b.add(await this.Q(r)),b.add(await this.Q(c)),await this.W(c,s,y,!0);try{await this.rename(c,r,{overwrite:!0})}catch(S){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{b.dispose()}}async W(r,c,s,y){let b;try{const S=this.I(r);if(!s.create||!s.overwrite){if(await w.Promises.exists(S)){if(!s.overwrite)throw(0,f.$dl)((0,h.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.$dl)((0,h.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:s.unlock},y),await this.write(b,0,c,0,c.byteLength)}catch(S){throw await this.ib(r,S)}finally{typeof b=="number"&&await this.close(b)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,c,s){const y=this.I(r);let b;(0,f.$4k)(c)&&!s&&(b=await this.Q(r));let S;try{if((0,f.$4k)(c)&&c.unlock)try{const{stat:E}=await w.SymlinkSupport.stat(y);E.mode&128||await w.Promises.chmod(y,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let g;if((0,f.$4k)(c)){if(C.$i)try{await w.Promises.truncate(y,0),g="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}g||(g="w")}else g="r";S=await w.Promises.open(y,g)}catch(g){throw b?.dispose(),(0,f.$4k)(c)?await this.ib(r,g):this.hb(g)}if(this.X.set(S,0),(0,f.$4k)(c)&&this.Z.set(S,r),b){const g=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${y})`),this.Y.set(S,b),g&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${y})`),g.dispose())}return S}async close(r){const c=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await w.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(r)}catch(s){throw this.hb(s)}finally{c&&(this.Y.get(r)===c&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),c.dispose())}}async read(r,c,s,y,b){const S=this.ab(r,c);let g=null;try{g=(await w.Promises.read(r,s,y,b,S)).bytesRead}catch(E){throw this.hb(E)}finally{this.bb(r,S,g)}return g}ab(r,c){return c===this.X.get(r)?null:c}bb(r,c,s){const y=this.X.get(r);typeof y=="number"&&(typeof c=="number"||(typeof s=="number"?this.X.set(r,y+s):this.X.delete(r)))}async write(r,c,s,y,b){return(0,L.$Qh)(()=>this.cb(r,c,s,y,b),100,3)}async cb(r,c,s,y,b){const S=this.ab(r,c);let g=null;try{g=(await w.Promises.write(r,s,y,b,S)).bytesWritten}catch(E){throw await this.ib(this.Z.get(r),E)}finally{this.bb(r,S,g)}return g}async mkdir(r){try{await w.Promises.mkdir(this.I(r))}catch(c){throw this.hb(c)}}async delete(r,c){try{const s=this.I(r);if(c.recursive){let y;c?.atomic!==!1&&c.atomic.postfix&&(y=(0,A.$jc)((0,A.$mc)(s),`${(0,A.$nc)(s)}${c.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,y)}else try{await w.Promises.unlink(s)}catch(y){if(y.code==="EPERM"||y.code==="EISDIR"){let b=!1;try{const{stat:S,symbolicLink:g}=await w.SymlinkSupport.stat(s);b=S.isDirectory()&&!g}catch{}if(b)await w.Promises.rmdir(s);else throw y}else throw y}}catch(s){throw this.hb(s)}}async rename(r,c,s){const y=this.I(r),b=this.I(c);if(y!==b)try{await this.db(r,c,"move",s.overwrite),await w.Promises.rename(y,b)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(2,null,(0,A.$nc)(y),(0,A.$nc)((0,A.$mc)(b)),S.toString()))),this.hb(S)}}async copy(r,c,s){const y=this.I(r),b=this.I(c);if(y!==b)try{await this.db(r,c,"copy",s.overwrite),await w.Promises.copy(y,b,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(3,null,(0,A.$nc)(y),(0,A.$nc)((0,A.$mc)(b)),S.toString()))),this.hb(S)}}async db(r,c,s,y){const b=this.I(r),S=this.I(c);let g=!1;if(!!(this.capabilities&1024)||(g=(0,m.$ug)(b,S,!0)),g){if(s==="copy")throw(0,f.$dl)((0,h.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.N(r);if(!D)throw(0,f.$dl)((0,h.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(c);if(P){if(!y)throw(0,f.$dl)((0,h.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);D.type&f.FileType.File&&P.type&f.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,c){return this.eb(r,c,!1)}async eb(r,c,s){const y=this.I(r),b=this.I(c),S=!!(this.capabilities&1024);if((0,m.$ug)(y,b,!S))return;const g=new k.$Tc;try{g.add(await this.Q(r)),g.add(await this.Q(c)),s&&await w.Promises.mkdir((0,A.$mc)(b),{recursive:!0}),await w.Promises.copyFile(y,b)}catch(E){if(E.code==="ENOENT"&&!s)return this.eb(r,c,!0);throw this.hb(E)}finally{g.dispose()}}t(r,c,s){return new l.$2q(y=>r(y),y=>c(y),s)}F(r,c,s){return new o.$$q(y=>r(y),y=>c(y),s)}hb(r){if(r instanceof f.$cl)return r;let c=r,s;switch(r.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=f.FileSystemProviderErrorCode.Unknown;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.$dl)(c,s)}async ib(r,c){let s=this.hb(c);if(r&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:y}=await w.SymlinkSupport.stat(this.I(r));y.mode&128||(s=(0,f.$dl)(c,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(y){this.a.trace(y)}return s}}e.$_q=t}),define(Se[266],De([1,0,3,11]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=void 0;class L extends d.$Uc{constructor(N,p=[]){super(),this.a=new O.$ak([N,...p]),this.B(N.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...p){this.a.trace(N,...p)}debug(N,...p){this.a.debug(N,...p)}info(N,...p){this.a.info(N,...p)}warn(N,...p){this.a.warn(N,...p)}error(N,...p){this.a.error(N,...p)}flush(){this.a.flush()}}e.$ZQ=L}),define(Se[267],De([1,0,33,11]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;var L;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(L||(L={}));async function R(k,A,C,$,v){try{const w=await new Promise((f,a)=>{he(["@vscode/spdlog"],f,a)});w.setFlushOn(L.Trace);const h=await w.createAsyncRotatingLogger(k,A,C,$);return v?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(w){console.error(w)}return null}function N(k,A,C){switch(A){case O.LogLevel.Trace:k.trace(C);break;case O.LogLevel.Debug:k.debug(C);break;case O.LogLevel.Info:k.info(C);break;case O.LogLevel.Warning:k.warn(C);break;case O.LogLevel.Error:k.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(k,A){switch(A){case O.LogLevel.Trace:k.setLevel(L.Trace);break;case O.LogLevel.Debug:k.setLevel(L.Debug);break;case O.LogLevel.Info:k.setLevel(L.Info);break;case O.LogLevel.Warning:k.setLevel(L.Warning);break;case O.LogLevel.Error:k.setLevel(L.Error);break;case O.LogLevel.Off:k.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class m extends O.$9j{constructor(A,C,$,v,w){super(),this.m=[],this.setLevel(w),this.n=this.s(A,C,$,v),this.B(this.onDidChangeLogLevel(h=>{this.r&&p(this.r,h)}))}async s(A,C,$,v){const w=$?6:1,h=30/w*d.$yl.MB,f=await R(A,C,h,w,v);if(f){this.r=f,p(this.r,this.getLevel());for(const{level:a,message:n}of this.m)N(this.r,a,n);this.m=[]}}g(A,C){this.r?N(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$OQ=m}),define(Se[139],De([1,0,41,219,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var N;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(N||(e.MarkerSeverity=N={})),function(m){function k(w,h){return h-w}m.compare=k;const A=Object.create(null);A[m.Error]=(0,O.localize)(0,null),A[m.Warning]=(0,O.localize)(1,null),A[m.Info]=(0,O.localize)(2,null);function C(w){return A[w]||""}m.toString=C;function $(w){switch(w){case d.default.Error:return m.Error;case d.default.Warning:return m.Warning;case d.default.Info:return m.Info;case d.default.Ignore:return m.Hint}}m.fromSeverity=$;function v(w){switch(w){case m.Error:return d.default.Error;case m.Warning:return d.default.Warning;case m.Info:return d.default.Info;case m.Hint:return d.default.Ignore}}m.toSeverity=v}(N||(e.MarkerSeverity=N={}));var p;(function(m){const k="";function A($){return C($,!0)}m.makeKey=A;function C($,v){const w=[k];return $.source?w.push($.source.replace("\xA6","\\\xA6")):w.push(k),$.code?typeof $.code=="string"?w.push($.code.replace("\xA6","\\\xA6")):w.push($.code.value.replace("\xA6","\\\xA6")):w.push(k),$.severity!==void 0&&$.severity!==null?w.push(N.toString($.severity)):w.push(k),$.message&&v?w.push($.message.replace("\xA6","\\\xA6")):w.push(k),$.startLineNumber!==void 0&&$.startLineNumber!==null?w.push($.startLineNumber.toString()):w.push(k),$.startColumn!==void 0&&$.startColumn!==null?w.push($.startColumn.toString()):w.push(k),$.endLineNumber!==void 0&&$.endLineNumber!==null?w.push($.endLineNumber.toString()):w.push(k),$.endColumn!==void 0&&$.endColumn!==null?w.push($.endColumn.toString()):w.push(k),w.push(k),w.join("\xA6")}m.makeKeyOptionalMessage=C})(p||(e.IMarkerData=p={})),e.$7t=(0,L.$wi)("markerService")}),define(Se[268],De([1,0,4,41,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0v=e.Severity=void 0,e.$$v=p,e.Severity=O.default,e.$0v=(0,L.$wi)("notificationService");var R;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var N;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(N||(e.NeverShowAgainScope=N={}));function p(C){if(C){const $=C;return typeof $.id=="string"&&typeof $.label=="string"}return!1}var m;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class k{constructor(){this.progress=new A,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity($){}updateMessage($){}updateActions($){}close(){}}e.$_v=k;class A{infinite(){}done(){}total($){}worked($){}}e.$aw=A}),define(Se[269],De([1,0,52]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)O=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,d.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:R.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(Se[108],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,d.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(he,e){return function(d,O){e(d,O,he)}};define(Se[109],De([1,0,7,22,3,5]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.ProgressLocation=e.$bw=void 0,e.$bw=(0,R.$wi)("progressService");var N;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(N||(e.ProgressLocation=N={})),e.$cw=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$dw=p;class m{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const v=this.d;this.d=()=>{v?.(),$()}}):Promise.resolve()}}e.$ew=m;let k=class extends L.$Uc{constructor($,v){super(),this.a=new d.$Th,v.withProgress($,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$fw=k,e.$fw=k=Ge([We(1,e.$bw)],k);class A extends L.$Uc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new L.$Tc)}start($){this.stop();const v=++this.a,w=new O.$oe;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>w.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:v,token:w.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$gw=A,e.$hw=(0,R.$wi)("editorProgressService")}),define(Se[36],De([1,0,62,18]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class L{constructor(){this.a=new Map}add(N,p){d.ok(O.$9f(N)),d.ok(O.$$f(p)),d.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,p)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$co=new L}),define(Se[110],De([1,0,4,36]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function L(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class R{constructor(){this.b=new d.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,k){this.a[L(m)]=k,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const N=new R;O.$co.add(e.$do.JSONContribution,N)}),define(Se[66],De([1,0,19,4,18,208,55,110,36]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=h,e.$to=f,e.$uo=a,e.$vo=i,e.$wo=l;var k;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$ho={Configuration:"base.contributions.configuration"};var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const C=m.$co.as(p.$do.JSONContribution);class ${constructor(){this.h=new Set,this.i=new O.$de,this.onDidSchemaChange=this.i.event,this.j=new O.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const r=new Set;this.n(t,u,r),C.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const u=new Set;this.o(t,u),C.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const r=new Set;this.o(u,r),this.n(t,!1,r),C.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const r=[];for(const{overrides:c,source:s}of t)for(const y in c)if(u.add(y),e.$ro.test(y)){const b=this.a.get(y),S=b?.valuesSources??new Map;if(s)for(const P of Object.keys(c[y]))S.set(P,s);const g={...b?.value||{},...c[y]};this.a.set(y,{source:s,value:g,valuesSources:S});const E=(0,N.$aj)(y),D={type:"object",default:g,description:R.localize(1,null,E),$ref:e.$oo,defaultDefaultValue:g,source:L.$9f(s)?void 0:s,defaultValueSource:s};r.push(...h(y)),this.d[y]=D,this.b.properties[y]=D}else{this.a.set(y,{value:c[y],source:s});const b=this.d[y];b&&(this.w(y,b),this.r(y,b))}this.m(r)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:r,source:c}of t)for(const s in r){const y=this.a.get(s),b=L.$9f(c)?c:c?.id,S=L.$9f(y?.source)?y?.source:y?.source?.id;if(b===S)if(u.add(s),this.a.delete(s),e.$ro.test(s))delete this.d[s],delete this.b.properties[s];else{const g=this.d[s];g&&(this.w(s,g),this.r(s,g))}}this.u()}deltaConfiguration(t){let u=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,r){t.forEach(c=>{this.p(c,u,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(t,u){const r=c=>{if(c.properties)for(const s in c.properties){u.add(s);const y=this.d[s];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[s],this.s(s,c.properties[s])}c.allOf?.forEach(s=>r(s))};for(const c of t){r(c);const s=this.c.indexOf(c);s!==-1&&this.c.splice(s,1)}}p(t,u=!0,r,c,s=3,y){s=L.$fg(t.scope)?s:t.scope;const b=t.properties;if(b)for(const g in b){const E=b[g];if(u&&i(g,E)){delete b[g];continue}if(E.source=r,E.defaultDefaultValue=b[g].default,this.w(g,E),e.$ro.test(g)?E.scope=void 0:(E.scope=L.$fg(E.scope)?s:E.scope,E.restricted=L.$fg(E.restricted)?!!c?.includes(g):E.restricted),b[g].hasOwnProperty("included")&&!b[g].included){this.f[g]=b[g],delete b[g];continue}else this.d[g]=b[g],b[g].policy?.name&&this.e.set(b[g].policy.name,g);!b[g].deprecationMessage&&b[g].markdownDeprecationMessage&&(b[g].deprecationMessage=b[g].markdownDeprecationMessage),y.add(g)}const S=t.allOf;if(S)for(const g of S)this.p(g,u,r,c,s,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=r=>{const c=r.properties;if(c)for(const y in c)this.r(y,c[y]);r.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$io.properties[t]=u,u.scope){case 1:e.$jo.properties[t]=u;break;case 2:e.$ko.properties[t]=u;break;case 6:e.$lo.properties[t]=u;break;case 3:e.$mo.properties[t]=u;break;case 4:e.$no.properties[t]=u;break;case 5:e.$no.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$io.properties[t],u.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$oo};this.w(u,r),e.$io.properties[u]=r,e.$jo.properties[u]=r,e.$ko.properties[u]=r,e.$lo.properties[u]=r,e.$mo.properties[u]=r,e.$no.properties[u]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,u){const r=this.a.get(t);let c=r?.value,s=r?.source;L.$dg(c)&&(c=u.defaultDefaultValue,s=void 0),L.$dg(c)&&(c=a(u.type)),u.default=c,u.defaultValueSource=s}}const v="\\[([^\\]]+)\\]",w=new RegExp(v,"g");e.$qo=`^(${v})+$`,e.$ro=new RegExp(e.$qo);function h(o){const t=[];if(e.$ro.test(o)){let u=w.exec(o);for(;u?.length;){const r=u[1].trim();r&&t.push(r),u=w.exec(o)}}return(0,d.$Mb)(t)}function f(o){return o.reduce((t,u)=>`${t}[${u}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new $;m.$co.add(e.$ho.Configuration,n);function i(o,t){return o.trim()?e.$ro.test(o)?R.localize(7,null,o):n.getConfigurationProperties()[o]!==void 0?R.localize(8,null,o):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,o,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function l(){const o=[],t=n.getConfigurationProperties();for(const u of Object.keys(t))o.push([u,t[u].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(Se[270],De([1,0,19,4,166,3,27,24,18,2,55,66,36]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=i;function v(u){return Object.isFrozen(u)?u:p.$4n(u)}class w{static createEmptyModel(r){return new w({},[],[],void 0,r)}constructor(r,c,s,y,b){this.b=r,this.c=c,this.d=s,this.raw=y,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof w)return c;const s=new h("",this.f);return s.parseRaw(c),s.configurationModel});this.g=r.reduce((c,s)=>s===c?s:c.merge(s),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$$i)(this.contents,r):this.contents}inspect(r,c){const s=this;return{get value(){return v(s.rawConfiguration.getValue(r))},get override(){return c?v(s.rawConfiguration.getOverrideValue(r,c)):void 0},get merged(){return v(c?s.rawConfiguration.override(c).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const y=[];for(const{contents:b,identifiers:S,keys:g}of s.rawConfiguration.overrides){const E=new w(b,g,[],void 0,s.f).getValue(r);E!==void 0&&y.push({identifiers:S,value:E})}return y.length?v(y):void 0}}}getOverrideValue(r,c){const s=this.j(c);return s?r?(0,A.$$i)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const s of this.overrides)s.identifiers.includes(r)&&c.push(...s.keys);return d.$Mb(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return d.$Mb(r)}override(r){let c=this.a.get(r);return c||(c=this.h(r),this.a.set(r,c)),c}merge(...r){const c=p.$3n(this.contents),s=p.$3n(this.overrides),y=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const S of r)if(b.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(c,S.contents);for(const g of S.overrides){const[E]=s.filter(D=>d.$ub(D.identifiers,g.identifiers));E?(this.i(E.contents,g.contents),E.keys.push(...g.keys),E.keys=d.$Mb(E.keys)):s.push(p.$3n(g))}for(const g of S.keys)y.indexOf(g)===-1&&y.push(g)}return new w(c,y,s,b.every(S=>S instanceof w)?void 0:b,this.f)}h(r){const c=this.j(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const s={};for(const y of d.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let b=this.contents[y];const S=c[y];S&&(typeof b=="object"&&typeof S=="object"?(b=p.$3n(b),this.i(b,S)):b=S),s[y]=b}return new w(s,this.keys,this.overrides,void 0,this.f)}i(r,c){for(const s of Object.keys(c)){if(s in r&&m.$$f(r[s])&&m.$$f(c[s])){this.i(r[s],c[s]);continue}r[s]=p.$3n(c[s])}}j(r){let c=null,s=null;const y=b=>{b&&(s?this.i(s,b):s=p.$3n(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?c=b.contents:b.identifiers.includes(r)&&y(b.contents);return y(c),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.k(r,c,!0)}setValue(r,c){this.k(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,A.$0i)(this.contents,r),C.$ro.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>d.$ub(s.identifiers,(0,C.$so)(r))),1))}k(r,c,s){(0,A.$9i)(this.contents,r,c,y=>this.f.error(y)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),C.$ro.test(r)&&this.overrides.push({identifiers:(0,C.$so)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$8i)(this.contents[r],y=>this.f.error(y))})}}e.$xo=w;class h{constructor(r,c){this.f=r,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||w.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!m.$fg(r)){const s=this.h(r);this.parseRaw(s,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:s,keys:y,overrides:b,restricted:S,hasExcludedProperties:g}=this.i(r,c);this.b=new w(s,y,b,g?[r]:void 0,this.g),this.c=S||[]}h(r){let c={},s=null,y=[];const b=[],S=[];function g(D){Array.isArray(y)?y.push(D):s!==null&&(y[s]=D)}const E={onObjectBegin:()=>{const D={};g(D),b.push(y),y=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{y=b.pop()},onArrayBegin:()=>{const D=[];g(D),b.push(y),y=D,s=null},onArrayEnd:()=>{y=b.pop()},onLiteralValue:g,onError:(D,P,I)=>{S.push({error:D,offset:P,length:I})}};if(r)try{L.$Qn(r,E),c=y[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return c}i(r,c){const s=$.$co.as(C.$ho.Configuration).getConfigurationProperties(),y=this.j(r,s,!0,c);r=y.raw;const b=(0,A.$8i)(r,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),S=Object.keys(r),g=this.l(r,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:b,keys:S,overrides:g,restricted:y.restricted,hasExcludedProperties:y.hasExcludedProperties}}j(r,c,s,y){let b=!1;if(!y?.scopes&&!y?.skipRestricted&&!y?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const S={},g=[];for(const E in r)if(C.$ro.test(E)&&s){const D=this.j(r[E],c,!1,y);S[E]=D.raw,b=b||D.hasExcludedProperties,g.push(...D.restricted)}else{const D=c[E],P=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&g.push(E),!y.exclude?.includes(E)&&(y.include?.includes(E)||(P===void 0||y.scopes===void 0||y.scopes.includes(P))&&!(y.skipRestricted&&D?.restricted))?S[E]=r[E]:b=!0}return{raw:S,restricted:g,hasExcludedProperties:b}}l(r,c){const s=[];for(const y of Object.keys(r))if(C.$ro.test(y)){const b={};for(const S in r[y])b[S]=r[y][S];s.push({identifiers:(0,C.$so)(y),keys:Object.keys(b),contents:(0,A.$8i)(b,c)})}return s}}e.$yo=h;class f extends R.$Uc{constructor(r,c,s,y,b){super(),this.c=r,this.f=c,this.g=y,this.h=b,this.b=this.B(new O.$de),this.onDidChange=this.b.event,this.a=new h(this.c.toString(),b),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return w.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=f;class a{constructor(r,c,s,y,b,S,g,E,D,P,I,F,T){this.a=r,this.b=c,this.c=s,this.overrideIdentifiers=y,this.d=b,this.f=S,this.g=g,this.h=E,this.i=D,this.j=P,this.k=I,this.l=F,this.m=T}get value(){return v(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(r,c,s,y,b,S,g,E,D,P){this.j=r,this.l=c,this.m=s,this.n=y,this.p=b,this.q=S,this.r=g,this.s=E,this.t=D,this.u=P,this.h=null,this.i=new N.$Ac,this.v=null}getValue(r,c,s){return this.w(r,c,s).getValue(r)}updateValue(r,c,s={}){let y;s.resource?(y=this.t.get(s.resource),y||(y=w.createEmptyModel(this.u),this.t.set(s.resource,y))):y=this.s,c===void 0?y.removeValue(r):y.setValue(r,c),s.resource||(this.h=null)}inspect(r,c,s){const y=this.w(r,c,s),b=this.A(c.resource,s),S=c.resource?this.t.get(c.resource)||this.s:this.s,g=new Set;for(const E of y.overrides)for(const D of E.identifiers)y.getOverrideValue(r,D)!==void 0&&g.add(D);return new a(r,c,y.getValue(r),g.size?[...g]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,b||void 0,S)}keys(r){const c=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,c){this.r.set(r,c),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const s=[];if(!c){const{added:y,updated:b,removed:S}=o(this.j,r);c=[...y,...b,...S]}for(const y of c)for(const b of(0,C.$so)(y)){const S=this.j.getKeysForOverrideIdentifier(b),g=r.getKeysForOverrideIdentifier(b),E=[...g.filter(D=>S.indexOf(D)===-1),...S.filter(D=>g.indexOf(D)===-1),...S.filter(D=>!p.$7n(this.j.override(b).getValue(D),r.override(b).getValue(D)))];s.push([b,E])}return this.updateDefaultConfiguration(r),{keys:c,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:s,removed:y}=o(this.l,r),b=[...c,...s,...y];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:s,removed:y,overrides:b}=o(this.applicationConfiguration,r),S=[...c,...s,...y];return S.length&&this.updateApplicationConfiguration(r),{keys:S,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:s,removed:y,overrides:b}=o(this.localUserConfiguration,r),S=[...c,...s,...y];return S.length&&this.updateLocalUserConfiguration(r),{keys:S,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:s,removed:y,overrides:b}=o(this.remoteUserConfiguration,r),S=[...c,...s,...y];return S.length&&this.updateRemoteUserConfiguration(r),{keys:S,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:s,removed:y,overrides:b}=o(this.workspaceConfiguration,r),S=[...c,...s,...y];return S.length&&this.updateWorkspaceConfiguration(r),{keys:S,overrides:b}}compareAndUpdateFolderConfiguration(r,c){const s=this.folderConfigurations.get(r),{added:y,updated:b,removed:S,overrides:g}=o(s,c),E=[...y,...b,...S];return(E.length||!s)&&this.updateFolderConfiguration(r,c),{keys:E,overrides:g}}compareAndDeleteFolderConfiguration(r){const c=this.folderConfigurations.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:y,removed:b,overrides:S}=o(c,void 0);return{keys:[...s,...y,...b],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,c,s){let y=this.x(c,s);return c.overrideIdentifier&&(y=y.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(y=y.merge(this.l)),y}x({resource:r},c){let s=this.y();if(c&&r){const y=c.getFolder(r);y&&(s=this.z(y.uri)||s);const b=this.t.get(r);b&&(s=s.merge(b))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let c=this.i.get(r);if(!c){const s=this.y(),y=this.r.get(r);y?(c=s.merge(y),this.i.set(r,c)):c=s}return c}A(r,c){if(c&&r){const s=c.getFolder(r);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,c)=>{const{contents:s,overrides:y,keys:b}=this.r.get(c);return r.push([c,{contents:s,overrides:y,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.q.keys.forEach(c=>r.add(c)),this.r.forEach(c=>c.keys.forEach(s=>r.add(s))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}D(r){const c=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.q.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(y=>c.add(y))),[...c.values()]}static parse(r,c){const s=this.E(r.defaults,c),y=this.E(r.policy,c),b=this.E(r.application,c),S=this.E(r.user,c),g=this.E(r.workspace,c),E=r.folders.reduce((D,P)=>(D.set(k.URI.revive(P[0]),this.E(P[1],c)),D),new N.$Ac);return new n(s,y,b,S,w.createEmptyModel(c),g,E,w.createEmptyModel(c),new N.$Ac,c)}static E(r,c){return new w(r.contents,r.keys,r.overrides,void 0,c)}}e.$Ao=n;function i(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,c=new Map;for(const y of u)y.keys.forEach(b=>r.add(b)),y.overrides.forEach(([b,S])=>{const g=(0,N.$xc)(c,b,new Set);S.forEach(E=>g.add(E))});const s=[];return c.forEach((y,b)=>s.push([b,[...y.values()]])),{keys:[...r.values()],overrides:s}}class l{constructor(r,c,s,y,b){this.change=r,this.f=c,this.g=s,this.h=y,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of r.keys)this.affectedKeys.add(S);for(const[,S]of r.overrides)for(const g of S)this.affectedKeys.add(g);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,c){const s=this.a+r,y=this.d.indexOf(s);if(y<0)return!1;const b=y+s.length;if(b>=this.d.length)return!1;const S=this.d.charCodeAt(b);if(S!==this.b&&S!==this.c)return!1;if(c){const g=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,E=this.g.getValue(r,c,this.h);return!p.$7n(g,E)}return!0}}e.$Co=l;function o(u,r){const{added:c,removed:s,updated:y}=t(r?.rawConfiguration,u?.rawConfiguration),b=[],S=u?.getAllOverrideIdentifiers()||[],g=r?.getAllOverrideIdentifiers()||[];if(r){const E=g.filter(D=>!S.includes(D));for(const D of E)b.push([D,r.getKeysForOverrideIdentifier(D)])}if(u){const E=S.filter(D=>!g.includes(D));for(const D of E)b.push([D,u.getKeysForOverrideIdentifier(D)])}if(r&&u){for(const E of S)if(g.includes(E)){const D=t({contents:u.getOverrideValue(void 0,E)||{},keys:u.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});b.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:c,removed:s,updated:y,overrides:b}}function t(u,r){const c=u?r?u.keys.filter(b=>r.keys.indexOf(b)===-1):[...u.keys]:[],s=r?u?r.keys.filter(b=>u.keys.indexOf(b)===-1):[...r.keys]:[],y=[];if(u&&r){for(const b of r.keys)if(u.keys.indexOf(b)!==-1){const S=(0,A.$$i)(r.contents,b),g=(0,A.$$i)(u.contents,b);p.$7n(S,g)||y.push(b)}}return{added:c,removed:s,updated:y}}}),define(Se[271],De([1,0,21,4,3,83]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nvb=e.$lvb=e.$kvb=void 0,e.$mvb=p;const N=(k,A,C)=>{const $=new Uint8Array(16);for(let h=0;h<16;h++)$[h]=Math.round(Math.random()*256);const v=(0,d.$Ze)(d.$Fe.wrap($));return[`GET ws://localhost${k}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$kvb=N,e.$lvb=d.$Fe.fromString(`\r
\r
`);async function p(k,A,C,$,v){k.write(d.$Fe.fromString((0,e.$kvb)(A,C,$)));const w=new L.$Tc;try{return await new Promise((h,f)=>{let a;w.add(k.onData(n=>{a?a=d.$Fe.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$lvb);if(i===-1)return;h(k),k.pauseData();const l=a.slice(i+e.$lvb.byteLength);l.byteLength&&v.onData.fire(l)})),w.add(k.onClose(n=>f(n??new Error("socket closed")))),w.add(k.onEnd(()=>f(new Error("socket ended"))))})}catch(h){throw k.dispose(),h}finally{w.dispose()}}class m extends L.$Uc{constructor(A,C){super(),this.g=A,this.a=this.B(new O.$ge),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new O.$de),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event($=>this.a.fire($))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$nvb=m}),define(Se[67],De([1,0,13,5]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=k,e.$Hl=(0,O.$wi)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=R;class N{constructor(C,$){this.host=C,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=N;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class m extends d.$bb{static isNotAvailable(C){return C instanceof m&&C._code===p.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof m&&C._code===p.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof m&&C._code===p.NoResolverFound}static isInvalidAuthority(C){return C instanceof m&&C._code===p.InvalidAuthority}static isHandled(C){return C instanceof m&&C.isHandled}constructor(C,$=p.Unknown,v){super(C),this._message=C,this._code=$,this._detail=v,this.isHandled=$===p.NotAvailable&&v===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Kl=m;function k(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}}),define(Se[272],De([1,0,7,21,22,13,4,3,15,59,40,30,83,67]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=S,e.$Rl=g,e.$Sl=D;const w=30*1e3;var h;(function(ee){ee[ee.Management=1]="Management",ee[ee.ExtensionHost=2]="ExtensionHost",ee[ee.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function f(ee){switch(ee){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(ee){const B=new L.$oe;return setTimeout(()=>B.cancel(),ee),B.token}function n(ee,B){if(ee.isCancellationRequested||B.isCancellationRequested)return L.CancellationToken.Cancelled;const _=new L.$oe;return ee.onCancellationRequested(()=>_.cancel()),B.onCancellationRequested(()=>_.cancel()),_.token}class i{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new p.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,d.$ph)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function l(ee,B){const _=new i(B);return _.registerDisposable(ee.onControlMessage(pe=>{const ue=JSON.parse(pe.toString()),ce=G(ue);ce?_.reject(ce):_.resolve(ue)})),_.promise}function o(ee,B,_,pe,ue,ce,oe,le){const J=new i(le),se=A.$_d.create(!1);return ee.info(`Creating a socket (${oe})...`),k.mark(`code/willCreateSocket/${ce}`),B.connect(_,pe,ue,oe).then($e=>{J.didTimeout?(k.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(k.mark(`code/didCreateSocketOK/${ce}`),ee.info(`Creating a socket (${oe}) was successful after ${se.elapsed()} ms.`),J.resolve($e))},$e=>{k.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) returned an error after ${se.elapsed()} ms.`),ee.error($e),J.reject($e)}),J.promise}function t(ee,B){const _=new i(B);return ee.then(pe=>{_.didTimeout||_.resolve(pe)},pe=>{_.didTimeout||_.reject(pe)}),_.promise}async function u(ee,B,_,pe){const ue=ae(ee,B);ee.logService.trace(`${ue} 1/6. invoking socketFactory.connect().`);let ce;try{ce=await o(ee.logService,ee.remoteSocketFactoryService,ee.connectTo,m.$Jg.getServerRootPath(),`reconnectionToken=${ee.reconnectionToken}&reconnection=${ee.reconnectionProtocol?"true":"false"}`,f(B),`renderer-${f(B)}-${ee.reconnectionToken}`,pe)}catch($e){throw ee.logService.error(`${ue} socketFactory.connect() failed or timed out. Error:`),ee.logService.error($e),$e}ee.logService.trace(`${ue} 2/6. socketFactory.connect() was successful.`);let oe,le;ee.reconnectionProtocol?(ee.reconnectionProtocol.beginAcceptReconnection(ce,null),oe=ee.reconnectionProtocol,le=!1):(oe=new $.$ki({socket:ce}),le=!0),ee.logService.trace(`${ue} 3/6. sending AuthRequest control message.`);const J=await t(ee.signService.createNewMessage((0,C.$Sg)()),pe),se={type:"auth",auth:ee.connectionToken||"00000000000000000000",data:J.data};oe.sendControl(O.$Fe.fromString(JSON.stringify(se)));try{const $e=await l(oe,n(pe,a(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(ee.logService.trace(`${ue} 4/6. received SignRequest control message.`),!await t(ee.signService.validate(J,$e.signedData),pe)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Re=await t(ee.signService.sign($e.data),pe),ge={type:"connectionType",commit:ee.commit,signedData:Re,desiredConnectionType:B};return _&&(ge.args=_),ee.logService.trace(`${ue} 5/6. sending ConnectionTypeRequest control message.`),oe.sendControl(O.$Fe.fromString(JSON.stringify(ge))),{protocol:oe,ownsProtocol:le}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(ee.logService.error(`${ue} the handshake timed out. Error:`),ee.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(ee.logService.error(`${ue} received error control message when negotiating connection. Error:`),ee.logService.error($e)),le&&Q(oe),$e}}async function r(ee,B,_,pe){const ue=Date.now(),ce=ae(ee,B),{protocol:oe,ownsProtocol:le}=await u(ee,B,_,pe),J=new i(pe);return J.registerDisposable(oe.onControlMessage(se=>{const $e=JSON.parse(se.toString()),ve=G($e);ve?(ee.logService.error(`${ce} received error control message when negotiating connection. Error:`),ee.logService.error(ve),le&&Q(oe),J.reject(ve)):(ee.reconnectionProtocol?.endAcceptReconnection(),ee.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${Ce(ue)}!`),J.resolve({protocol:oe,firstMessage:$e}))})),J.promise}async function c(ee,B){const{protocol:_}=await r(ee,1,void 0,B);return{protocol:_}}async function s(ee,B,_){const{protocol:pe,firstMessage:ue}=await r(ee,2,B,_),ce=ue&&ue.debugPort;return{protocol:pe,debugPort:ce}}async function y(ee,B,_){const pe=Date.now(),ue=ae(ee,3),{protocol:ce}=await u(ee,3,B,_);return ee.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${Ce(pe)}!`),ce}async function b(ee,B,_){const{connectTo:pe,connectionToken:ue}=await ee.addressProvider.getAddress();return{commit:ee.commit,quality:ee.quality,connectTo:pe,connectionToken:ue,reconnectionToken:B,reconnectionProtocol:_,remoteSocketFactoryService:ee.remoteSocketFactoryService,signService:ee.signService,logService:ee.logService}}async function S(ee,B,_){return E(ee,async pe=>{const{protocol:ue}=await c(pe,L.CancellationToken.None);return new Z(ee,B,_,pe.reconnectionToken,ue)})}async function g(ee,B){return E(ee,async _=>{const{protocol:pe,debugPort:ue}=await s(_,B,L.CancellationToken.None);return new ie(ee,B,_.reconnectionToken,pe,ue)})}async function E(ee,B){for(let pe=1;;pe++)try{const ue=(0,C.$Sg)(),ce=await b(ee,ue,null);return await B(ce)}catch(ue){if(pe<5)ee.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),ee.logService.error(ue);else throw ee.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ee.logService.error(ue),U.triggerPermanentFailure(0,0,v.$Kl.isHandled(ue)),ue}}async function D(ee,B,_){const pe=await b(ee,(0,C.$Sg)(),null);return await y(pe,{host:B,port:_},L.CancellationToken.None)}function P(ee){return(0,d.$jh)(B=>new Promise((_,pe)=>{const ue=setTimeout(_,ee*1e3);B.onCancellationRequested(()=>{clearTimeout(ue),_()})}))}var I;(function(ee){ee[ee.ConnectionLost=0]="ConnectionLost",ee[ee.ReconnectionWait=1]="ReconnectionWait",ee[ee.ReconnectionRunning=2]="ReconnectionRunning",ee[ee.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ee[ee.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class F{constructor(B,_){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.type=0}}e.$Tl=F;class T{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.durationSeconds=pe,this.c=ue,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=T;class z{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=2}}e.$Vl=z;class M{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=4}}e.$Wl=M;class j{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.handled=ue,this.type=3}}e.$Xl=j;class U extends p.$Uc{static triggerPermanentFailure(B,_,pe){this._permanentFailure=!0,this.f=B,this.g=_,this.h=pe,this.j.forEach(ue=>ue.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(B,_,pe,ue,ce){super(),this.t=B,this.u=_,this.reconnectionToken=pe,this.protocol=ue,this.w=ce,this.m=this.B(new N.$de),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(ue.onSocketClose(oe=>{const le=be(this.t,this.reconnectionToken,!0);oe?oe.type===0?(this.u.logService.info(`${le} received socket close event (hadError: ${oe.hadError}).`),oe.error&&this.u.logService.error(oe.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${oe.wasClean}, code: ${oe.code}, reason: ${oe.reason}).`),oe.event&&this.u.logService.error(oe.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(ue.onSocketTimeout(oe=>{const le=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${oe.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${oe.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${oe.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,p.$Sc)(()=>{const oe=U.j.indexOf(this);oe>=0&&U.j.splice(oe,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const ue=pe<_.length?_[pe]:_[_.length-1];try{if(ue>0){const oe=P(ue);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ue,oe)),this.u.logService.info(`${B} waiting for ${ue} seconds before reconnecting...`);try{await oe}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${B} resolving connection...`);const ce=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ce.connectTo}...`),await this.G(ce,a(w)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(ce){if(ce.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(v.$Kl.isTemporarilyNotAvailable(ce)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((ce.code==="ETIMEDOUT"||ce.code==="ENETUNREACH"||ce.code==="ECONNREFUSED"||ce.code==="ECONNRESET")&&ce.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((0,R.$4)(ce)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if(ce instanceof v.$Kl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,v.$Kl.isHandled(ce));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(B,_,pe){this.w?U.triggerPermanentFailure(B,_,pe):this.D(B,_,pe)}D(B,_,pe){this.m.fire(new j(this.reconnectionToken,B,_,pe)),Q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=U;class Z extends U{constructor(B,_,pe,ue,ce){super(1,B,ue,ce,!0),this.client=this.B(new $.$ii(ce,{remoteAuthority:_,clientId:pe},B.ipcLogger))}async G(B,_){await c(B,_)}}e.$Zl=Z;class ie extends U{constructor(B,_,pe,ue,ce){super(2,B,pe,ue,!1),this.H=_,this.debugPort=ce}async G(B,_){await s(B,this.H,_)}}e.$1l=ie;function Q(ee){try{ee.acceptDisconnect();const B=ee.getSocket();ee.dispose(),B.dispose()}catch(B){(0,R.$1)(B)}}function G(ee){if(ee&&ee.type==="error"){const B=new Error(`Connection error: ${ee.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function x(ee,B){for(;ee.length<B;)ee+=" ";return ee}function ne(ee,B){return`[remote-connection][${x(f(ee),13)}][${B.substr(0,5)}\u2026]`}function be(ee,B,_){return`${ne(ee,B)}[${_?"reconnect":"initial"}]`}function ae(ee,B){return`${be(B,ee.reconnectionToken,!!ee.reconnectionProtocol)}[${ee.connectTo}]`}function Ce(ee){return`${Date.now()-ee} ms`}}),define(Se[86],De([1,0,15]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=O,e.$Im=L,e.$Jm=R,e.$Km=N;function O(m){return m.scheme===d.Schemas.vscodeRemote?m.authority:void 0}function L(m){if(!m)return;const k=m.indexOf("+");return k<0?m:m.substr(0,k)}function R(m){const{host:k,port:A}=p(m);if(typeof A>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:A}}function N(m,k){let{host:A,port:C}=p(m);return typeof C>"u"&&(C=k),{host:A,port:C}}function p(m){const k=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const A=m.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const C=m.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:m,port:void 0}}}),define(Se[25],De([1,0,14,5,86]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=R,e.$Um=C,e.$Vm=$,e.$Wm=v,e.$Xm=w,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(N||(e.ExtensionType=N={}));var p;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class m{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,a){if(typeof f>"u"||f===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){const n=typeof f=="string"?f:f.value,i=typeof a=="string"?a:a.value;return d.$xf(n,i)}return f._lower===a._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Rm=m;class k{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const a of f)this.add(a)}add(f){this.c.add(m.toKey(f))}delete(f){return this.c.delete(m.toKey(f))}has(f){return this.c.has(m.toKey(f))}}e.$Sm=k;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(m.toKey(f))}get(f){return this.c.get(m.toKey(f))}has(f){return this.c.has(m.toKey(f))}set(f,a){this.c.set(m.toKey(f),a)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=A;function C(h){return $(h)}function $(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function v(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function w(h,f){if(f){const a=`onResolveRemoteAuthority:${(0,L.$Im)(f)}`;return!!h.activationEvents?.includes(a)}return!1}e.$Ym=(0,O.$wi)("IBuiltinExtensionsScannerService")}),define(Se[140],De([1,0,13,25]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(N,p){this.a.set(N,p)}readActivationEvents(N){return this.b.has(N)||this.b.set(N,this.c(N)),this.b.get(N)}createActivationEventsMap(N){const p=Object.create(null);for(const m of N){const k=this.readActivationEvents(m);k.length>0&&(p[O.$Rm.toKey(m.identifier)]=k)}return p}c(N){if(typeof N.main>"u"&&typeof N.browser>"u")return[];const p=Array.isArray(N.activationEvents)?N.activationEvents.slice(0):[];for(let m=0;m<p.length;m++)p[m]==="onUri"&&(p[m]=`onUri:${O.$Rm.toKey(N.identifier)}`);if(!N.contributes)return p;for(const m in N.contributes){const k=this.a.get(m);if(!k)continue;const A=N.contributes[m],C=Array.isArray(A)?A:[A];try{k(C,p)}catch($){(0,d.$1)($)}}return p}}e.$tG=L,e.$uG=new L}),define(Se[273],De([1,0,3,5]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,O.$wi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(N,p){return this.a[N]??=[],this.a[N].push(p),(0,d.$Sc)(()=>{const m=this.a[N]?.indexOf(p);typeof m=="number"&&m>=0&&this.a[N]?.splice(m,1)})}b(N){return(this.a[N.type]||[]).find(m=>m.supports(N))}connect(N,p,m,k){const A=this.b(N);if(!A)throw new Error(`No socket factory found for ${N}`);return A.connect(N,p,m,k)}}e.$Nl=L}),define(Se[274],De([1,0,21,13,3,220,66,5,11,36]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=$,e.$Qp=v,e.$Rp=w,e.$Sp=h,e.$Tp=f,e.$Up=a,e.$Np=(0,p.$wi)("requestService");class A{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?o[t]="*****":o[t]=this.b[t];this.a=o}return this.a}}class C extends L.$Uc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,R.localize)(0,null),when:m.$ik.isEqualTo((0,m.$fk)(m.LogLevel.Trace)).serialize()})}async c(o,t,u){const r=`${o} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new A(t.headers??{}));try{const c=await u();return this.a.trace(`${r} - end`,t.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.a.error(`${r} - error`,t.type,(0,O.$0)(c)),c}}}e.$Op=C;function $(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}function v(l){return l.res.statusCode===204}async function w(l){return v(l)?null:(await(0,d.$Re)(l.stream)).toString()}async function h(l){if(!$(l))throw new Error("Server returned "+l.res.statusCode);return w(l)}async function f(l){if(!$(l))throw new Error("Server returned "+l.res.statusCode);if(v(l))return null;const t=(await(0,d.$Re)(l.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}function a(l){i(l)}let n;function i(l){const o=k.$co.as(N.$ho.Configuration),t=n;n={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},o.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(Se[275],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=void 0;class d{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const N=String(d.a++);return this.b.set(N,R),{id:N,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const N=this.b.get(L.id);if(!N)return!1;this.b.delete(L.id);try{return N.validate(R)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$U$b=d}),define(Se[111],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,d.$wi)(e.$Ol)}),define(Se[141],De([1,0,275]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class O extends d.$U$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(N=>new N.signer().sign(R))}h(){return new Promise((R,N)=>he(["vsda"],R,N))}}e.$Qdc=O}),define(Se[276],De([1,0,12,52,30]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=N,e.$ep=p;function R(m){if(d.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function N(m,k,A,C,$,v,w,h,f){const a=Object.create(null);a["common.machineId"]=v,a["common.sqmId"]=w,a.sessionID=(0,L.$Sg)()+Date.now(),a.commitHash=C,a.version=$,a["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,d.$h)(d.$u),a["common.nodePlatform"]=O.$dc,a["common.nodeArch"]=A,a["common.product"]=f||"desktop",h&&(a["common.msftInternal"]=h);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),d.$l&&(a["common.snap"]="true");const l=R(k);return l&&(a["common.platformDetail"]=l),a}function p(m){const k=O.env.USERDNSDOMAIN;if(!k)return!1;const A=k.toLowerCase();return m.some(C=>A===C)}}),define(Se[277],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,d.$wi)("telemetryService"),e.$3l=(0,d.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var O;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(Se[87],De([1,0,24,18,86,276,277]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=A,e.$np=C,e.$op=$,e.$pp=v,e.$qp=h,e.$rp=a,e.$sp=n,e.$tp=o;class p{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$fp=p;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=m,e.$hp=new m;class k{async publicLog(u,r,c){}async publicLogError(u,r,c){}}e.$ip=k,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}function C(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const u=t.getValue(N.$0l),r=t.getValue(N.$$l);if(t.getValue(N.$_l)===!1||r===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(t){const u={},r={},c={};f(t,c);for(let s in c){s=s.length>150?s.substr(s.length-149):s;const y=c[s];typeof y=="number"?r[s]=y:typeof y=="boolean"?r[s]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${y.length}`),u[s]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(u[s]=y)}return{properties:u,measurements:r}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const u=(0,L.$Im)(t);return w.has(u)?u:"other"}function f(t,u,r=0,c){if(t)for(const s of Object.getOwnPropertyNames(t)){const y=t[s],b=c?c+s:s;Array.isArray(y)?u[b]=(0,d.$8n)(y):y instanceof Date?u[b]=y.toISOString():(0,O.$$f)(y)?r<2?f(y,u,r+1,b+"."):u[b]=(0,d.$8n)(y):u[b]=y}}function a(t,u){const r=t.msftInternalDomains||[],c=u.getValue("telemetry.internalTesting");return(0,R.$ep)(r)||c}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const c=[];for(const S of u)for(;;){const g=S.exec(t);if(!g)break;c.push([g.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const S=y.exec(t);if(!S)break;const g=c.some(([E,D])=>S.index<D&&E<y.lastIndex);!s.test(S[0])&&!g&&(r+=t.substring(b,S.index)+"<REDACTED: user-file-path>",b=y.lastIndex)}return b<t.length&&(r+=t.substr(b)),r}function l(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of u)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,u){return(0,d.$5n)(t,r=>{if(r instanceof p||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=i(c,u);for(const s of u)c=c.replace(s,"");return c=l(c),c}})}}),define(Se[278],De([1,0,14,138,25,12,2,13,52,87]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=A,e.$wp=w,e.$xp=h,e.$yp=f,e.$zp=a,e.$Ap=n,e.$Bp=i,e.$Cp=l,e.$Ep=o,e.$Fp=u;function A(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,d.$sf)(r.id,c.id)===0}const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(c){const s=c.manifest?c.manifest.version:c.version,y=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new $(c.identifier,s,y)}static parse(c){const s=C.exec(c);return s&&s[1]&&s[2]?new $({id:s[1]},s[2],s[4]||void 0):null}constructor(c,s,y="undefined"){this.version=s,this.targetPlatform=y,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof $?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$vp=$;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(r){const c=v.exec(r);return c&&c[1]?[f(c[1]),c[2]]:[f(r),void 0]}function h(r,c){return`${r}.${c}`}function f(r){return r.toLowerCase()}function a(r,c){return f(h(r??L.$Nm,c))}function n(r,c){const s=[],y=b=>{for(const S of s)if(S.some(g=>A(c(g),c(b))))return S;return null};for(const b of r){const S=y(b);S?S.push(b):s.push([b])}return s}function i(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function l(r){return{id:new k.$fp(r.identifier.id),name:new k.$fp(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Dp=new L.$Rm("pprice.better-merge");function o(r,c){const s=[],y=c.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const b=y.shift();if(b&&s.every(S=>!A(S.identifier,{id:b}))){const S=r.filter(g=>A(g.identifier,{id:b}));S.length===1&&(s.push(S[0]),y.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,c){if(!R.$k)return!1;let s;try{s=(await r.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){c.debug("Error while getting the os-release file.",(0,p.$0)(b))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,c){const s=await t(r,c),y=(0,O.$2o)(s?"alpine":R.$u,m.$ec);return c.debug("ComputeTargetPlatform:",y),y}}),define(Se[279],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=d,e.$ms=O,e.$ns=L,e.$os=R,e.$ps=N,e.$qs=p;function d(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function L(m){return new Map(m)}function R(m){return new Map(m??[])}function N(m){return Array.from(m.entries()).map(k=>[k[0],d(k[1].map),O(k[1].descriptionMap)])}function p(m){return new Map(m.map(k=>[k[0],{map:L(k[1]),descriptionMap:R(k[2])}]))}}),define(Se[280],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fvb=void 0;class d{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,N=5){const p=R(m=>{const k=typeof m=="string"?m:m.data;let A=this.a.get(L);if(A){A.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(L),N);A={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),p.dispose()}},this.a.set(L,A)});return p}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$Fvb=d}),define(Se[281],De([1,0,7,79,99,50,4,18,2,221,110,36]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.$hx=e.IconFontDefinition=e.IconContribution=e.$ex=void 0,e.$fx=f,e.$gx=a,e.$ex={IconContribution:"base.contributions.icons"};var $;(function(o){function t(u,r){let c=u.defaults;for(;R.ThemeIcon.isThemeIcon(c);){const s=h.getIcon(c.id);if(!s)return;c=s.defaults}return c}o.getDefinition=t})($||(e.IconContribution=$={}));var v;(function(o){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=t;function u(r){const c=s=>(0,p.$9f)(s)?s:void 0;if(r&&Array.isArray(r.src)&&r.src.every(s=>(0,p.$9f)(s.format)&&(0,p.$9f)(s.location)))return{weight:c(r.weight),style:c(r.style),src:r.src.map(s=>({format:s.format,location:m.URI.parse(s.location)}))}}o.fromJSONObject=u})(v||(e.IconFontDefinition=v={}));class w{constructor(){this.a=new N.$de,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,u,r,c){const s=this.b[t];if(s){if(r&&!s.description){s.description=r,this.d.properties[t].markdownDescription=`${r} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=r),this.a.fire()}return s}const y={id:t,description:r,defaults:u,deprecationMessage:c};this.b[t]=y;const b={$ref:"#/definitions/icons"};return c&&(b.deprecationMessage=c),r&&(b.markdownDescription=`${r}: $(${t})`),this.d.properties[t]=b,this.e.enum.push(t),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const u=this.e.enum.indexOf(t);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,u){const r=this.f[t];return r||(this.f[t]=u,this.a.fire(),u)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(s,y)=>s.id.localeCompare(y.id),u=s=>{for(;R.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(s=>this.b[s]);for(const s of c.filter(y=>!!y.description).sort(t))r.push(`|<i class="${u(s)}"></i>|${s.id}|${R.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const s of c.filter(y=>!R.ThemeIcon.isThemeIcon(y.defaults)).sort(t))r.push(`|<i class="${u(s)}"></i>|${s.id}|`);return r.join(`
`)}}const h=new w;C.$co.add(e.$ex.IconContribution,h);function f(o,t,u,r){return h.registerIcon(o,t,u,r)}function a(){return h}function n(){const o=(0,L.$Rj)();for(const t in o){const u="\\"+o[t].toString(16);h.registerIcon(t,{fontCharacter:u})}}n(),e.$hx="vscode://schemas/icons";const i=C.$co.as(A.$do.JSONContribution);i.registerSchema(e.$hx,h.getIconSchema());const l=new d.$Ih(()=>i.notifySchemaChanged(e.$hx),200);h.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.$ix=f("widget-close",O.$Vj.close,(0,k.localize)(2,null)),e.$jx=f("goto-previous-location",O.$Vj.arrowUp,(0,k.localize)(3,null)),e.$kx=f("goto-next-location",O.$Vj.arrowDown,(0,k.localize)(4,null)),e.$lx=R.ThemeIcon.modify(O.$Vj.sync,"spin"),e.$mx=R.ThemeIcon.modify(O.$Vj.loading,"spin")}),define(Se[88],De([1,0,4,2,55,5,11]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$pw=e.$nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$jw=e.$iw=void 0,e.$kw=k,e.$lw=C,e.$mw=$,e.$ow=v,e.$qw=w,e.$rw=h,e.$iw=(0,R.$wi)("tunnelService"),e.$jw=(0,R.$wi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function k(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function C(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const l of i){const o=l.split("=")[1];if(/^https?:/.exec(o)){const t=C(O.URI.parse(o));if(t)return t}}}e.$nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(n){return e.$nw.indexOf(n)>=0}e.$pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(n){return e.$pw.indexOf(n)>=0}function h(n,i,l,o){if(l===1)return!1;if(l===2&&w(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class f{constructor(i,l,o){this.remoteAddress=i,this.localAddress=l,this.b=o,this.a=new d.$de,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sw=f;let a=class{constructor(i,l){this.k=i,this.l=l,this.a=new d.$de,this.onTunnelOpened=this.a.event,this.b=new d.$de,this.onTunnelClosed=this.b.event,this.c=new d.$de,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],l=Array.from(this.e.values());for(const o of l){const t=Array.from(o.values());for(const u of t){const r=await u.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:l}of i.values())await l.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,l,o,t,u){this.q(i,l,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:l,localAddress:o,privacy:t,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,l){(w(i)||v(i))&&(i=e.$nw[0]);const o=this.s(i,l);if(o)return++o.refcount,o.value}openTunnel(i,l,o,t,u,r=!1,c,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${o} on local port ${u}.`);const y=this.f??i;if(!y)return;if(l||(l="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(y,l,o,t,u,r,c,s);return b?b.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(l,o),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(l,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(S);return(S.tunnelRemoteHost!==l||S.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&S.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const l=this.e.get(i.tunnelRemoteHost);if(l){const o=l.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,l,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${l}.`);const t=o.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(l),t}}async closeTunnel(i,l){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${l} `);const o=this.e.get(i);if(o&&o.has(l)){const t=o.get(l);t.refcount=0,await this.p(i,l,t)}}q(i,l,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(l,{refcount:1,value:o})}async r(i,l){const o=this.e.get(i);if(o){const t=o.get(l),u=t?await t.value:void 0;(!u||typeof u=="string")&&o.delete(l),o.size===0&&this.e.delete(i)}}s(i,l){const o=[i];v(i)?(o.push(...e.$nw),o.push(...e.$pw)):w(i)&&o.push(...e.$pw);const t=o.map(u=>this.e.get(u));for(const u of t){const r=u?.get(l);if(r)return r}}canTunnel(i){return!!C(i)}u(i,l,o,t,u,r,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${o} on local port ${t}.`);const s=o;this.j.add(s);const y=t===void 0?o:t,b={elevationRequired:u?this.isPortPrivileged(y):!1},S={remoteAddress:{host:l,port:o},localAddressPort:t,privacy:r,public:r?r!==m.Private:void 0,protocol:c},g=i.forwardPort(S,b);return g?(this.q(l,o,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),g}};e.$tw=a,e.$tw=a=Ge([We(0,N.$3j),We(1,L.$3i)],a)}),define(Se[282],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,d.$wi)("IUriIdentityService")}),define(Se[283],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uw=void 0,e.$uw=(0,d.$wi)("editSessionIdentityService");var O;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[284],De([1,0,15]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=O,e.$IM=L,e.$JM=R,e.$KM=N,e.$LM=p;function O(m){return m.scheme!==d.Schemas.file&&m.scheme!==d.Schemas.vscodeRemote}function L(m){if(m.folders.length)return m.folders.every(k=>O(k.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function R(m){return L(m)?.scheme}function N(m){return L(m)?.authority}function p(m){return L(m)!==void 0}}),define(Se[42],De([1,0,223,17,78,23,2,5,15]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=k,e.$Hi=A,e.$Ki=C,e.$Li=$,e.$Mi=v,e.$Ni=h,e.$Oi=f,e.$Ri=i,e.$Wi=l,e.$Xi=o,e.$Zi=t,e.$1i=u,e.$2i=r,e.$Fi=(0,p.$wi)("contextService");function k(c){const s=c;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}function A(c){return typeof c?.id=="string"&&!k(c)&&!$(c)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function C(c,s){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,O.$nc)(c)}:s?e.$Ii:e.$Ji;const y=c;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function $(c){const s=c;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}function v(c){const s=c;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const y=c;if(y?.configPath)return{id:y.id,configPath:N.URI.revive(y.configPath)};if(c?.id)return{id:c.id}}var w;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function h(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function f(c){const s=c;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class a{constructor(s,y,b,S,g){this.h=s,this.j=b,this.k=S,this.l=g,this.c=L.$Ci.forUris(this.l,()=>!0),this.folders=y}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=L.$Ci.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=a;class n{constructor(s,y){this.raw=y,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.$0g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(c){return new n({uri:c,index:0,name:(0,R.$6g)(c)},{uri:c.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,d.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function l(c,s){return R.$1g.isEqualOrParent(c,s.untitledWorkspacesHome)}function o(c){let s;return N.URI.isUri(c)?s=c:s=c.configuration,s?.scheme===m.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$Yi}function u(c,s){return!l(c,s)&&!o(c)}function r(c){return(typeof c=="string"?(0,O.$oc)(c):(0,R.$8g)(c))===e.$Ti}}),define(Se[285],De([1,0,57,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=l,e.$Dl=o,e.$El=t;var i;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function l(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&N.URI.isUri(s.location)&&N.URI.isUri(s.globalStorageHome)&&N.URI.isUri(s.settingsResource)&&N.URI.isUri(s.keybindingsResource)&&N.URI.isUri(s.tasksResource)&&N.URI.isUri(s.snippetsHome)&&N.URI.isUri(s.extensionsResource))}e.$Cl=(0,A.$wi)("IUserDataProfilesService");function o(c,s){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:N.URI.revive(c.location).with({scheme:s}),globalStorageHome:N.URI.revive(c.globalStorageHome).with({scheme:s}),settingsResource:N.URI.revive(c.settingsResource).with({scheme:s}),keybindingsResource:N.URI.revive(c.keybindingsResource).with({scheme:s}),tasksResource:N.URI.revive(c.tasksResource).with({scheme:s}),snippetsHome:N.URI.revive(c.snippetsHome).with({scheme:s}),extensionsResource:N.URI.revive(c.extensionsResource).with({scheme:s}),cacheHome:N.URI.revive(c.cacheHome).with({scheme:s}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,s,y,b,S,g){return{id:c,name:s,location:y,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:g&&S?.useDefaultFlags?.globalState?g.globalStorageHome:(0,R.$0g)(y,"globalStorage"),settingsResource:g&&S?.useDefaultFlags?.settings?g.settingsResource:(0,R.$0g)(y,"settings.json"),keybindingsResource:g&&S?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,R.$0g)(y,"keybindings.json"),tasksResource:g&&S?.useDefaultFlags?.tasks?g.tasksResource:(0,R.$0g)(y,"tasks.json"),snippetsHome:g&&S?.useDefaultFlags?.snippets?g.snippetsHome:(0,R.$0g)(y,"snippets"),extensionsResource:g&&S?.useDefaultFlags?.extensions?g.extensionsResource:(0,R.$0g)(y,"extensions.json"),cacheHome:(0,R.$0g)(b,c),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let u=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,y,b,S){super(),this.t=s,this.u=y,this.w=b,this.y=S,this.f=!0,this.h=this.B(new O.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),y=[s];if(this.f)try{for(const g of this.O()){if(!g.name||!(0,n.$9f)(g.name)||!g.location){this.y.warn("Skipping the invalid stored profile",g.location||g.name);continue}y.push(t((0,R.$7g)(g.location),g.name,g.location,this.g,{shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags},s))}}catch(g){this.y.error(g)}const b=new v.$Ac,S=new Map;if(y.length)try{const g=this.Q();if(g.workspaces)for(const[E,D]of Object.entries(g.workspaces)){const P=N.URI.parse(E),I=y.find(F=>F.id===D);I&&b.set(P,I)}if(g.emptyWindows)for(const[E,D]of Object.entries(g.emptyWindows)){const P=y.find(I=>I.id===D);P&&S.set(E,P)}}catch(g){this.y.error(g)}this.z={profiles:y,workspaces:b,emptyWindows:S}}return this.z}D(){const s=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const y="Temp",b=new RegExp(`${(0,a.$_e)(y)}\\s(\\d+)`);let S=0;for(const E of this.profiles){const D=b.exec(E.name),P=D?parseInt(D[1]):0;S=P>S?P:S}const g=`${y} ${S+1}`;return this.createProfile((0,d.$kj)((0,f.$Sg)()).toString(16),g,{transient:!0},s)}async createNamedProfile(s,y,b){return this.createProfile((0,d.$kj)((0,f.$Sg)()).toString(16),s,y,b)}async createProfile(s,y,b,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.F(s,y,b);return S&&await this.setProfileForWorkspace(S,g),g}async F(s,y,b){if(!(0,n.$9f)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(y);return S||(S=(async()=>{try{if(this.profiles.find(P=>P.name===y||P.id===s))throw new Error(`Profile with ${y} name already exists`);const E=t(s,y,(0,R.$0g)(this.profilesHome,s),this.g,b,this.defaultProfile);await this.u.createFolder(E.location);const D=[];return this.j.fire({profile:E,join(P){D.push(P)}}),await h.Promises.settled(D),this.I([E],[],[]),E}finally{this.r.delete(y)}})(),this.r.set(y,S)),S}async updateProfile(s,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(S=>S.id===s.id);if(!b)throw new Error(`Profile '${s.name}' does not exist`);return b=t(b.id,y.name??b.name,b.location,this.g,{shortName:y.shortName??b.shortName,icon:y.icon===null?void 0:y.icon??b.icon,transient:y.transient??b.isTransient,useDefaultFlags:y.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(S=>S.id===s.id);if(!y)throw new Error(`Profile '${s.name}' does not exist`);const b=[];this.m.fire({profile:y,join(S){b.push(S)}});try{await Promise.allSettled(b)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(S){(0,k.$hl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(S=>S.id===y.id);if(!b)throw new Error(`Profile '${y.name}' does not exist`);this.L(s,b)}unsetWorkspace(s,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,y)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(y=>y.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(s.map(y=>this.removeProfile(y)))}getProfileForWorkspace(s){const y=this.G(s);return N.URI.isUri(y)?this.s.workspaces.get(y)??this.C.workspaces.get(y):this.s.emptyWindows.get(y)??this.C.emptyWindows.get(y)}G(s){return(0,$.$Gi)(s)?s.uri:(0,$.$Li)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,s.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,s.location))||[...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,s.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,s.location)))}I(s,y,b){const S=[...this.profiles,...s],g=[];this.s.profiles=[];for(let E of S)E.isDefault||y.some(D=>E.id===D.id)||(E=b.find(D=>E.id===D.id)??E,E.isTransient?this.s.profiles.push(E):g.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(g),this.z=void 0,this.J(s,y,b)}J(s,y,b){this.h.fire({added:s,removed:y,updated:b,all:this.profiles})}L(s,y,b){b=y?.isTransient?!0:b,b||this.L(s,void 0,!0);const S=this.G(s),g=b?this.s:this.C;N.URI.isUri(S)?(g.workspaces.delete(S),y&&g.workspaces.set(S,y)):(g.emptyWindows.delete(S),y&&g.emptyWindows.set(S,y)),b||this.M()}M(){const s={};for(const[b,S]of this.C.workspaces.entries())s[b.toString()]=S.id;const y={};for(const[b,S]of this.C.emptyWindows.entries())y[b.toString()]=S.id;this.R({workspaces:s,emptyWindows:y}),this.z=void 0}N(s){const y={},b=this.D();if(s.workspaces)for(const[g,E]of Object.entries(s.workspaces)){const D=N.URI.parse(E);y[g]=this.w.extUri.isEqual(D,b.location)?b.id:this.w.extUri.basename(D)}const S={};if(s.emptyWindows)for(const[g,E]of Object.entries(s.emptyWindows)){const D=N.URI.parse(E);S[g]=this.w.extUri.isEqual(D,b.location)?b.id:this.w.extUri.basename(D)}return{workspaces:y,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Fl=u,e.$Fl=u=Ge([We(0,m.$Di),We(1,k.$3k),We(2,w.$Al),We(3,C.$3j)],u);class r extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Gl=r}),define(Se[142],De([1,0,7,4,3,59,18,200,5,285]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=v,e.$4p=h,e.$6p=a,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,m.$wi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var $;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function v(n){const i=n.get(e.$Zp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new O.$ge),this.c=this.B(new O.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$de),this.onWillSaveState=this.f.event,this.h=this.B(new d.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,l,o){return O.Event.filter(this.b.event,t=>t.scope===i&&(l===void 0||t.key===l),o)}n(){this.j.value=(0,d.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,l){const{key:o,external:t}=l;if(o===e.$Zp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:o,target:this.J(i)[o],external:t})}w(i){this.f.fire({reason:i})}get(i,l,o){return this.P(l)?.get(i,o)}getBoolean(i,l,o){return this.P(l)?.getBoolean(i,o)}getNumber(i,l,o){return this.P(l)?.getNumber(i,o)}getObject(i,l,o){return this.P(l)?.getObject(i,o)}storeAll(i,l){this.y(()=>{for(const o of i)this.store(o.key,o.value,o.scope,o.target,l)})}store(i,l,o,t,u=!1){if((0,N.$fg)(l)){this.remove(i,o,u);return}this.y(()=>{this.z(i,o,t),this.P(o)?.set(i,l,u)})}remove(i,l,o=!1){this.y(()=>{this.z(i,l,void 0),this.P(l)?.delete(i,o)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,l){const o=[],t=this.J(i);for(const u of Object.keys(t))t[u]===l&&o.push(u);return o}z(i,l,o,t=!1){const u=this.J(l);typeof o=="number"?u[i]!==o&&(u[i]=o,this.P(l)?.set(e.$Zp,JSON.stringify(u),t)):typeof u[i]=="number"&&(delete u[i],this.P(l)?.set(e.$Zp,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const l=this.P(i);return l?v(l):Object.create(null)}isNew(i){return this.getBoolean(e.$Yp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const l=this.P(-1),o=this.P(0),t=this.P(1);switch(i){case A.NONE:await d.Promises.settled([l?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await d.Promises.settled([l?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,l=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(i,l,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,l){return this.w(A.NONE),(0,k.$Bl)(i)?this.R(i,l):this.S(i,l)}M(i,l){return!(i.id===l.id||h(l)&&h(i))}N(i,l,o){this.y(()=>{const t=new Set;for(const[u,r]of i)t.add(u),l.get(u)!==r&&this.u(o,{key:u,external:!0});for(const[u]of l.items)t.has(u)||this.u(o,{key:u,external:!0})})}}e.$3p=w;function h(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class f extends w{constructor(){super(),this.U=this.B(new p.$Wp(new p.$Xp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Wp(new p.$Xp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Wp(new p.$Xp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$5p=f;async function a(n,i,l,o,t,u){const r=P=>{try{return JSON.parse(P)}catch{return P}},c=new Map,s=new Map;n.forEach((P,I)=>{c.set(I,P),s.set(I,r(P))});const y=new Map,b=new Map;i.forEach((P,I)=>{y.set(I,P),b.set(I,r(P))});const S=new Map,g=new Map;l.forEach((P,I)=>{S.set(I,P),g.set(I,r(P))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const E=[];if(c.forEach((P,I)=>{E.push({key:I,value:P})}),console.table(E),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];y.forEach((I,F)=>{P.push({key:F,value:I})}),console.table(P),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${u})`);const D=[];S.forEach((P,I)=>{D.push({key:I,value:P})}),console.table(D),console.groupEnd(),console.log(g)}}),define(Se[112],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class d{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){d.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$hlc=d}),define(Se[60],De([1,0,15,23,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$mlc=void 0;class R{constructor(){this.a=new Set(Object.keys(d.Schemas)),this.b=new Map,this.extUri=new O.$Yg(p=>{const m=this.b.get(p.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(p,m){m===null?this.b.delete(p.scheme):this.b.set(p.scheme,m)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$mlc=R,e.$nlc=(0,L.$wi)("IExtHostFileSystemInfo")}),define(Se[28],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0,e.$PP=(0,d.$wi)("IExtHostInitDataService")}),define(Se[286],De([1,0,228,11,266,28]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;let N=class extends L.$ZQ{constructor(m,k,A){const C=A.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",$=A.remote.isRemote?(0,d.localize)(0,null):m?(0,d.localize)(1,null):(0,d.localize)(2,null);super(k.createLogger(C,{name:$}))}};e.$tnc=N,e.$tnc=N=Ge([We(1,O.$4j),We(2,R.$PP)],N)}),define(Se[287],De([1,0,7]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=e.$5lc=void 0;class O{constructor(N,p,m){this.h=new Map,this.a=N,this.b=p,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new d.$Ih(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of k.values())A.complete()}catch(A){for(const C of k.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,N])=>N!==void 0).map(([N])=>N)}get whenReady(){return this.d}get(N,p){let m=this.f[N];return typeof m>"u"&&(m=p),m}update(N,p){this.f[N]=p;const m=this.h.get(N);if(m!==void 0)return m.p;const k=new d.$Th;return this.h.set(N,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$5lc=O;class L extends O{setKeysForSync(N){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},N)}constructor(N,p){super(N.identifier.value,!0,p),this.j=N}}e.$6lc=L}),define(Se[288],De([1,0,4,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;class L{constructor(N){this.c=N,this.a=new d.$de,this.onDidSaveNotebookDocument=this.a.event,this.b=new d.$de,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(N,p,m,k){const C=this.c.getNotebookDocument(O.URI.revive(N)).acceptModelChanged(p.value,m,k);this.b.fire(C)}$acceptDirtyStateChanged(N,p){this.c.getNotebookDocument(O.URI.revive(N)).acceptDirty(p)}$acceptModelSaved(N){const p=this.c.getNotebookDocument(O.URI.revive(N));this.a.fire(p.apiNotebook)}}e.$Tmc=L}),define(Se[20],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0,e.$zP=(0,d.$wi)("IExtHostRpcService");class O{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$AP=O}),define(Se[289],De([1,0,25,4]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class L{#e;constructor(N,p){this.b=new O.$de,this.onDidChange=this.b.event,this.a=d.$Rm.toKey(N.identifier),this.#e=p,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(N){return this.#e.get(this.a,N)}store(N,p){return this.#e.store(this.a,N,p)}delete(N){return this.#e.delete(this.a,N)}}e.$cmc=L}),define(Se[68],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0,e.$Clc=(0,d.$wi)("IURITransformerService");class O{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=N=>N,this.transformOutgoing=N=>N,this.transformOutgoingURI=N=>N,this.transformOutgoingScheme=N=>N)}}e.$Dlc=O}),define(Se[290],De([1,0,21]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erb=L,e.$Frb=N;class O{constructor(){this.buffers=[]}add(m){let k=this.buffers.indexOf(m);return k<0&&(k=this.buffers.length,this.buffers.push(m)),k}}function L(p,m){if(m.serializeBuffersForPostMessage){const k=new O,C=JSON.stringify(p,(v,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(w)};if(ArrayBuffer.isView(w)){const h=R(w);if(h)return{$$vscode_array_buffer_reference$$:!0,index:k.add(w.buffer),view:{type:h,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),$=k.buffers.map(v=>{const w=new Uint8Array(v);return d.$Fe.wrap(w)});return{message:C,buffers:$}}else return{message:JSON.stringify(p),buffers:[]}}function R(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function N(p,m){const k=m.map($=>{const v=new ArrayBuffer($.byteLength);return new Uint8Array(v).set($.buffer),v}),A=m.length?($,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const w=v,{index:h}=w,f=k[h];if(w.view)switch(w.view.type){case 1:return new Int8Array(f,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return v}:void 0;return{message:JSON.parse(p,A),arrayBuffers:k}}}),define(Se[291],De([1,0,292,403,404,63,2,11,405]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=A;const k=!1;function A(i,l,o,t,u,r){const c=r.environment.useHostProxy,s=typeof c=="boolean"?c:!r.remote.isRemote,y={resolveProxy:g=>i.resolveProxy(g),lookupProxyAuthorization:f.bind(void 0,t,u,l,{},r.remote.isRemote),getProxyURL:()=>l.getConfiguration("http").get("proxy"),getProxySupport:()=>l.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(l),addCertificatesV2:()=>v(l),log:t,getLogLevel:()=>{const g=t.getLevel();switch(g){case p.LogLevel.Trace:return m.LogLevel.Trace;case p.LogLevel.Debug:return m.LogLevel.Debug;case p.LogLevel.Info:return m.LogLevel.Info;case p.LogLevel.Warning:return m.LogLevel.Warning;case p.LogLevel.Error:return m.LogLevel.Error;case p.LogLevel.Off:return m.LogLevel.Off;default:return E(g)}function E(D){return t.error("Unknown log level",D),m.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,loadAdditionalCertificates:async()=>{const g=[];if(r.remote.isRemote&&g.push((0,m.loadSystemCertificates)({log:t})),s){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const E=i.loadCertificates();E.then(D=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",D.length)),g.push(E)}return(await Promise.all(g)).flat()},env:process.env},b=(0,m.createProxyResolver)(y),S=C(y,b);return h(o,S)}function C(i,l){return{http:Object.assign(d,(0,m.createHttpPatch)(i,d,l)),https:Object.assign(O,(0,m.createHttpPatch)(i,O,l)),net:Object.assign(R,(0,m.createNetPatch)(i,R)),tls:Object.assign(L,(0,m.createTlsPatch)(i,L))}}function $(i){const l=i.getConfiguration("http");return!l.get("experimental.systemCertificatesV2",k)&&!!l.get("systemCertificates")}function v(i){const l=i.getConfiguration("http");return!!l.get("experimental.systemCertificatesV2",k)&&!!l.get("systemCertificates")}const w=new Map;function h(i,l){return i.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,u=t._load;t._load=function(c,s,y){if(c==="net")return l.net;if(c==="tls")return l.tls;if(c!=="http"&&c!=="https")return u.apply(this,arguments);const b=o.findSubstr(N.URI.file(s.filename));let S=w.get(b);if(S||w.set(b,S={}),!S[c]){const g=l[c];S[c]={...g}}return S[c]}})}async function f(i,l,o,t,u,r,c,s){const y=t[r];c&&(t[r]=c),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${y}`);const b=c||y,S=Array.isArray(b)?b:typeof b=="string"?[b]:[];if(n(l,S,u),S.some(g=>/^(Negotiate|Kerberos)( |$)/i.test(g))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const g=await new Promise((F,T)=>{he(["kerberos"],F,T)}),E=new URL(r),D=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${D}`),"Negotiate "+await(await g.initializeClient(D)).step("")}catch(g){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",g)}}let a=!1;function n(i,l,o){a||!l.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:l.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(Se[293],De([1,0,134]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=L;function O(R){return{transformIncoming:N=>N.scheme==="vscode-remote"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="file"?{scheme:"vscode-local",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoing:N=>N.scheme==="file"?{scheme:"vscode-remote",authority:R,path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="vscode-local"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoingScheme:N=>N==="file"?"vscode-remote":N==="vscode-local"?"file":N}}function L(R){return new d.$yn(O(R))}}),define(Se[143],De([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=h,e.$zF=f,e.$AF=a,e.$BF=n,e.$CF=i,e.$DF=l,e.$EF=o,e.$FF=t,e.$GF=u,e.$JF=S,e.$KF=E,e.$LF=D,e.$MF=P,e.$NF=I,e.$OF=F,e.$PF=T,e.$QF=ie,e.$SF=x,e.$TF=be,e.$UF=ae,e.$VF=Ce,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var v;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var w;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function h(ee){const B=ee;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function f(ee){const B=ee;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function a(ee,B,_){for(const pe of _.visibleEditorPanes)if(pe.group.id===B&&ee.matches(pe.input))return pe.getViewState()}function n(ee){if(S(ee))return!1;const B=ee;return L.URI.isUri(B?.resource)}function i(ee){if(S(ee))return!1;const B=ee;return B?.original!==void 0&&B.modified!==void 0}function l(ee){if(S(ee))return!1;const B=ee;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function o(ee){if(S(ee)||i(ee))return!1;const B=ee;return B?.primary!==void 0&&B.secondary!==void 0}function t(ee){if(S(ee))return!1;const B=ee;return B?B.resource===void 0||B.resource.scheme===k.Schemas.untitled||B.forceUntitled===!0:!1}function u(ee){if(S(ee))return!1;const B=ee;return L.URI.isUri(B?.base?.resource)&&L.URI.isUri(B?.input1?.resource)&&L.URI.isUri(B?.input2?.resource)&&L.URI.isUri(B?.result?.resource)}var r;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var c;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class s{constructor(){this.a=new Map}registerSource(B,_){let pe=this.a.get(B);return pe||(pe={source:B,label:_},this.a.set(B,pe)),pe.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$HF=new s;var y;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class b extends R.$Uc{}e.$IF=b;function S(ee){return ee instanceof b}function g(ee){const B=ee;return L.URI.isUri(B?.preferredResource)}function E(ee){const B=ee;return S(B?.primary)&&S(B?.secondary)}function D(ee){const B=ee;return S(B?.modified)&&S(B?.original)}function P(ee,B,_,pe,ue){return Ce(pe,[(0,C.$gj)({id:"workbench.action.openLargeFile",label:(0,d.localize)(2,null),run:()=>{const ce={..._,limits:{size:Number.MAX_VALUE}};ee.openEditor(B,ce)}}),(0,C.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,d.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function I(ee){return S(ee?.editor)}function F(ee){const B=ee;return I(ee)&&B?.group!==void 0}function T(ee){const B=ee;return typeof B?.groupId=="number"&&S(B.editor)}var z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ee[ee.EDITOR_STICKY=12]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=13]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var j;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(B,_){if(!B)return;if(u(B))return e.$RF.getOriginalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getOriginalUri(ue,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===j.PRIMARY?ue:ce}}if(i(B)||l(B)||o(B)||u(B))return;const pe=g(B)?B.preferredResource:B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}a(B){return E(B)||o(B)?{primary:B.primary,secondary:B.secondary}:D(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,_){if(!B)return;if(u(B))return e.$RF.getCanonicalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===j.PRIMARY?ue:ce}}if(i(B)||l(B)||o(B)||u(B))return;const pe=B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}b(B,_){if(Array.isArray(_)){if(_.some(pe=>B.scheme===pe))return B}else if(_===B.scheme)return B}}var Z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function ie(ee,B,_,pe){if(!ee.isSticky(B))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return _===Z.MOUSE||_===Z.KEYBOARD;case"mouse":return _===Z.MOUSE;case"keyboard":return _===Z.KEYBOARD}return!1}e.$RF=new U;var Q;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class G{constructor(){this.c=new Map,this.d=new Map}start(B){const _=this.a=B.get(N.$vi);for(const[pe,ue]of this.c)this.e(pe,ue,_);this.c.clear()}e(B,_,pe){const ue=pe.createInstance(_);this.d.set(B,ue)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,O.$hg)(this.b)}registerEditorSerializer(B,_){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,_,this.a):this.c.set(B,_),(0,R.$Sc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}p.$co.add(e.$tF.EditorFactory,new G);async function x(ee,B,_){return!ee||!ee.length?[]:await Promise.all(ee.map(async pe=>{const ue=L.URI.revive(pe.fileUri);if(!ue){_.info("Cannot resolve the path because it is not valid.",pe);return}if(!await B.canHandleResource(ue)){_.info("Cannot resolve the path because it cannot be handled",pe);return}let oe=pe.exists,le=pe.type;if(typeof oe!="boolean"||typeof le!="number")try{le=(await B.stat(ue)).isDirectory?m.FileType.Directory:m.FileType.Unknown,oe=!0}catch(se){_.error(se),oe=!1}if(!oe&&pe.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",pe);return}if(le===m.FileType.Directory){_.info("Cannot resolve the path because it is a directory",pe);return}const J={...pe.options,pinned:!0};return oe?{resource:ue,options:J}:{resource:ue,options:J,forceUntitled:!0}}))}var ne;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function be(ee){const B=ee;if(!B)return!1;const _=B;if(_.modified)return be(_.modified);const pe=B;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ae(ee){return(0,A.$ij)(ee)}function Ce(ee,B,_){const pe=(0,A.$jj)(ee,B);return pe.forceMessage=_?.forceMessage,pe.forceSeverity=_?.forceSeverity,pe.allowDialog=_?.allowDialog,pe}}),define(Se[294],De([1,0,4,239,5,3,27,36,24,79,281]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=v,e.$WF="views",e.$XF=(0,O.localize)(0,null),e.$YF=(0,A.$fx)("default-view-icon",k.$Vj.window,(0,O.localize)(1,null));var C;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(C||(e.Extensions=C={}));var $;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$ZF=[0,1,2];function v(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class w extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new d.$de),this.onDidRegister=this.c.event,this.f=this.B(new d.$de),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,r,c){const s=this.get(u.id);if(s)return s;const y=u;return y.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,N.$xc)(this.g,r,[]).push(y),c?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:r}),y}deregisterViewContainer(u){for(const r of this.g.keys()){const c=this.g.get(r),s=c?.indexOf(u);if(s!==-1){c?.splice(s,1),c.length===0&&this.g.delete(r),this.f.fire({viewContainer:u,viewContainerLocation:r});return}}}get(u){return this.all.filter(r=>r.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(c=>c?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(r=>this.getViewContainerLocation(r)===u)}}p.$co.add(C.ViewContainersRegistry,new w);var h;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(h||(e.ViewContentGroups=h={}));function f(t,u){const r=t.group??h.More,c=u.group??h.More;return r!==c?r.localeCompare(c):(t.order??5)-(u.order??5)}class a extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new d.$de),this.onViewsRegistered=this.c.event,this.f=this.B(new d.$de),this.onViewsDeregistered=this.f.event,this.g=this.B(new d.$de),this.onDidChangeContainer=this.g.event,this.h=this.B(new d.$de),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new N.$Hc}registerViews(u,r){this.registerViews2([{views:u,viewContainer:r}])}registerViews2(u){u.forEach(({views:r,viewContainer:c})=>this.r(r,c)),this.c.fire(u)}deregisterViews(u,r){const c=this.s(u,r);c.length&&this.f.fire({views:c,viewContainer:r})}moveViews(u,r){for(const c of this.m.keys())if(c!==r){const s=this.s(u,c);s.length&&(this.r(s,r),this.g.fire({views:s,from:c,to:r}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const r of this.j){const c=(this.m.get(r)||[]).filter(s=>s.id===u)[0];if(c)return c}return null}getViewContainer(u){for(const r of this.j)if((this.m.get(r)||[]).filter(s=>s.id===u)[0])return r;return null}registerViewWelcomeContent(u,r){return this.n.add(u,r),this.h.fire(u),(0,R.$Sc)(()=>{this.n.delete(u,r),this.h.fire(u)})}registerViewWelcomeContent2(u,r){const c=new Map;for(const[s,y]of r)this.n.add(u,y),c.set(s,(0,R.$Sc)(()=>{this.n.delete(u,y),this.h.fire(u)}));return this.h.fire(u),c}getViewWelcomeContent(u){const r=[];return this.n.forEach(u,c=>r.push(c)),r.sort(f)}r(u,r){let c=this.m.get(r);c||(c=[],this.m.set(r,c),this.j.push(r));for(const s of u){if(this.getView(s.id)!==null)throw new Error((0,O.localize)(2,null,s.id));c.push(s)}}s(u,r){const c=this.m.get(r);if(!c)return[];const s=[],y=[];for(const b of c)u.includes(b)?s.push(b):y.push(b);return s.length&&(y.length?this.m.set(r,y):(this.m.delete(r),this.j.splice(this.j.indexOf(r),1))),s}}p.$co.add(C.ViewsRegistry,new a),e.$2F=(0,L.$wi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class l{constructor(u,r){this.c=!1,this.d=!1,(0,m.$6n)(this,u),this.d=!!r,this.resolve=async c=>{if(r&&!this.c){const s=await r(c);s&&(this.tooltip=this.tooltip??s.tooltip,this.command=this.command??s.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=l;class o extends Error{constructor(u){super((0,O.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$4F=o}),define(Se[295],De([1,0,240,38]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new O.$Nj("chatSessionResponseVote","",{type:"string",description:(0,d.localize)(0,null)}),e.$9F=new O.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,d.localize)(1,null)}),e.$0F=new O.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,d.localize)(2,null)}),e.$$F=new O.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,d.localize)(3,null)}),e.$_F=new O.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,d.localize)(4,null)}),e.$aG=new O.$Nj("chatResponse",!1,{type:"boolean",description:(0,d.localize)(5,null)}),e.$bG=new O.$Nj("chatRequest",!1,{type:"boolean",description:(0,d.localize)(6,null)}),e.$cG=new O.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,d.localize)(7,null)}),e.$dG=new O.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,d.localize)(8,null)}),e.$eG=new O.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,d.localize)(9,null)}),e.$fG=new O.$Nj("inChatInput",!1,{type:"boolean",description:(0,d.localize)(10,null)}),e.$gG=new O.$Nj("inChat",!1,{type:"boolean",description:(0,d.localize)(11,null)}),e.$hG=new O.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,d.localize)(12,null)}),e.$iG=new O.$Nj("chatCursorAtTop",!1),e.$jG=new O.$Nj("chatInputHasAgent",!1),e.$kG=new O.$Nj("chatLocation",void 0)}),define(Se[296],De([1,0,7,22,4,39,3,171,14,38,5,11,108,274,142,295]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var a;(function(o){o.Panel="panel",o.Terminal="terminal",o.Notebook="notebook",o.Editor="editor"})(a||(e.ChatAgentLocation=a={})),function(o){function t(u){switch(u){case"panel":return o.Panel;case"terminal":return o.Terminal;case"notebook":return o.Notebook;case"editor":return o.Editor}return o.Panel}o.fromRaw=t}(a||(e.ChatAgentLocation=a={})),e.$iH=(0,A.$wi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new L.$de,this.onDidChangeAgents=this.d.event,this.e=h.$hG.bindTo(this.f)}registerAgent(t,u){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const c=this,s=u.slashCommands;u={...u,get slashCommands(){return s.filter(b=>!b.when||c.f.contextMatchesRules(k.$uj.deserialize(b.when)))}};const y={data:u};return this.b.push(y),(0,N.$Sc)(()=>{this.b=this.b.filter(b=>b!==y),this.d.fire(void 0)})}registerAgentImplementation(t,u){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=u,this.d.fire(new i(r.data,u)),(0,N.$Sc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,u){const r={data:t,impl:u};return this.b.push(r),this.d.fire(new i(t,u)),(0,N.$Sc)(()=>{this.b=this.b.filter(c=>c!==r),this.d.fire(void 0)})}updateAgent(t,u){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...u},this.d.fire(new i(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(u=>!!u.isDefault&&u.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(u=>!!u.isDefault&&u.locations.includes(t))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(u=>u.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(u=>u.name===t)}async invokeAgent(t,u,r,c,s){const y=this.g(t);if(!y?.impl)throw new Error(`No activated agent with id ${t}`);return await y.impl.invoke(u,r,c,s)}async getFollowups(t,u,r,c,s){const y=this.g(t);if(!y?.impl)throw new Error(`No activated agent with id ${t}`);return y.impl?.provideFollowups?y.impl.provideFollowups(u,r,c,s):[]}};e.$jH=n,e.$jH=n=Ge([We(0,k.$Oj)],n);class i{constructor(t,u){this.b=t,this.d=u}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,u,r,c){return this.d.invoke(t,u,r,c)}async provideFollowups(t,u,r,c){return this.d.provideFollowups?this.d.provideFollowups(t,u,r,c):[]}provideWelcomeMessage(t,u){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,u)}provideSampleQuestions(t,u){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,u)}}e.$kH=i,e.$lH=(0,A.$wi)("chatAgentNameService");let l=class{static{f=this}static{this.b="chat.participantNameRegistry"}constructor(t,u,r,c){if(this.g=u,this.h=r,this.i=c,this.e=(0,p.$1d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const s=c.get(f.b,-1);try{this.e.set(JSON.parse(s??"{}"),void 0)}catch{c.remove(f.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,d.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const u=await(0,v.$Tp)(t);if(!u||u.version!==1)throw new Error("Unexpected chat participant registry response.");const r=u.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(f.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(c=>(0,m.$xf)(c,c.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=l,e.$mH=l=f=Ge([We(0,$.$jk),We(1,v.$Np),We(2,C.$3j),We(3,w.$1p)],l)}),define(Se[297],De([1,0,2,29,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=R,e.$qG=N;function R(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof d.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(O.$ut.isIRange)}function N(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(R)}var p;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var m;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$rG=(0,L.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(Se[144],De([1,0,4,7,241]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new d.$de,this.o=new d.$de,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,m,k,A){const C={command:p};if(m&&Object.keys(m).length>0&&(C.arguments=m),this.u("request",C),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const w={type:"response",seq:0,request_seq:C.seq,success:!1,command:p,message:(0,L.localize)(0,null,A,p)};v(w)}},A)}return k&&this.f.set(C.seq,k),C.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,m){return p.type!=="event"||m.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,O.$xh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const m=p,k=this.f.get(m.request_seq);k&&(this.f.delete(m.request_seq),k(m));break}}}}u(p,m){m.type=p,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((m,k)=>p.set(k,m)),await(0,O.$xh)(500),p.forEach((m,k)=>{m({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Rrb=R}),define(Se[298],De([1,0,2,242,38,5]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=m,e.$BJ=A,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new L.$Nj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$xI=new L.$Nj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$yI=new L.$Nj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$zI="debugUx",e.$AI=new L.$Nj(e.$zI,"default",{type:"string",description:O.localize(3,null)}),e.$BI=new L.$Nj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$CI=new L.$Nj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$DI=new L.$Nj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$EI=new L.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$FI=new L.$Nj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$GI=new L.$Nj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$HI=new L.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$II=new L.$Nj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$JI=new L.$Nj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$KI=new L.$Nj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$LI=new L.$Nj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$MI=new L.$Nj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$NI=new L.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$OI=new L.$Nj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$PI=new L.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$QI=new L.$Nj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$RI=new L.$Nj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$SI=new L.$Nj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$TI=new L.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$UI=new L.$Nj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$VI=new L.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$WI=new L.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$XI=new L.$Nj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$YI=new L.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$ZI=new L.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$1I=new L.$Nj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$2I=new L.$Nj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$3I=new L.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$4I=new L.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$5I=new L.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$6I=new L.$Nj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$7I=new L.$Nj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$8I=new L.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$9I=new L.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$0I=new L.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$$I=new L.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$_I=new L.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$aJ=new L.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$bJ=new L.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$cJ=new L.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$dJ=new L.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$eJ=new L.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$fJ=new L.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$gJ=new L.$Nj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$hJ=new L.$Nj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$iJ=new L.$Nj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$jJ=new L.$Nj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$kJ=new L.$Nj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$lJ=new L.$Nj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$mJ=new L.$Nj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$nJ=new L.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$oJ=new L.$Nj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$pJ=new L.$Nj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$qJ=new L.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$rJ=new L.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$sJ=new L.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$tJ=new L.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const N=i=>O.localize(61,null,i);e.$uJ=N,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function m(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$AJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var C;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(C||(e.DataBreakpointSetType=C={}));var $;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var v;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$CJ=(0,R.$wi)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var h;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(h||(e.DebugVisualizationType=h={}));var f;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(f||(e.DebugTreeItemCollapsibleState=f={}));var a;(function(i){i.deserialize=l=>l,i.serialize=l=>l})(a||(e.IDebugVisualizationTreeItem=a={}));var n;(function(i){i.deserialize=l=>({id:l.id,name:l.name,iconPath:l.iconPath&&{light:d.URI.revive(l.iconPath.light),dark:d.URI.revive(l.iconPath.dark)},iconClass:l.iconClass,visualization:l.visualization}),i.serialize=l=>l})(n||(e.IDebugVisualization=n={}))}),define(Se[299],De([1,0,14,2,17,24,15,29,22,19]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=C,e.$qH=$,e.$rH=v,e.$sH=w,e.$tH=h,e.$uH=f,e.$vH=a,e.$wH=i,e.$xH=t,e.$yH=u,e.$zH=c,e.$AH=y;const A=/{([^}]+)}/g;function C(S,g,E){return S.replace(A,function(D,P){return g&&P.length>0&&P[0]!=="_"?D:E&&E.hasOwnProperty(P)?E[P]:D})}function $(S){const g={};for(const E of Object.keys(S))E.startsWith("!")||(g[E]=S[E]);return g}function v(S){return S.configuration.request==="attach"&&!w(S)&&(!S.parentSession||v(S.parentSession))}function w(S){let g=S.configuration.type;if(g)return g==="vslsShare"&&(g=S.configuration.adapterProxy.configuration.type),(0,d.$xf)(g,"extensionhost")||(0,d.$xf)(g,"pwa-extensionhost")?S:S.parentSession?w(S.parentSession):void 0}function h(S){return S.type&&(S.label||S.program||S.runtime)}function f(S,g,E){let D,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=I.exec(S);){const T=F.index+1,z=T+F[0].length;if(T<=g&&z>=E){D=F[0],P=T;break}}if(D){const T=/\w+/g;let z=null;for(;(z=T.exec(D))&&!(z.index+1+P+z[0].length>=E););z&&(D=D.substring(0,T.lastIndex))}return D?{start:P,end:P+D.length-1}:{start:0,end:0}}async function a(S,g,E,D){if(S.evaluatableExpressionProvider.has(g)){const P=S.evaluatableExpressionProvider.ordered(g),I=(0,k.$Hb)(await Promise.all(P.map(async F=>{try{return await F.provideEvaluatableExpression(g,E,D??m.CancellationToken.None)}catch{return}})));if(I.length>0){let F=I[0].expression;const T=I[0].range;return F||(F=g.getLineContent(E.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:F}}}else{const P=g.getLineContent(E.lineNumber),{start:I,end:F}=f(P,E.column,E.column),T=P.substring(I-1,F);return{matchingExpression:T,range:new p.$ut(E.lineNumber,I,E.lineNumber,I+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(n))}function l(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return O.URI.parse(S.path);if((0,L.$ic)(S.path))return O.URI.file(S.path)}return S.path}function o(S){if(typeof S.path=="object"){const g=O.URI.revive(S.path);if(g)return g.scheme===N.Schemas.file?g.fsPath:g.toString()}return S.path}function t(S,g){const E=g?l:o,D=(0,R.$3n)(S);return r(D,(P,I)=>{P&&I&&(I.path=E(I))}),D}function u(S,g){const E=g?l:o,D=(0,R.$3n)(S);return r(D,(P,I)=>{!P&&I&&(I.path=E(I))}),D}function r(S,g){switch(S.type){case"event":{const E=S;switch(E.event){case"output":g(!1,E.body.source);break;case"loadedSource":g(!1,E.body.source);break;case"breakpoint":g(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=S;switch(E.command){case"setBreakpoints":g(!0,E.arguments.source);break;case"breakpointLocations":g(!0,E.arguments.source);break;case"source":g(!0,E.arguments.source);break;case"gotoTargets":g(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(D=>g(!1,D));break;default:break}break}case"response":{const E=S;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(D=>g(!1,D.source));break;case"loadedSources":E.body.sources.forEach(D=>g(!1,D));break;case"scopes":E.body.scopes.forEach(D=>g(!1,D.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(D=>g(!1,D.source));break;case"setBreakpoints":E.body.breakpoints.forEach(D=>g(!1,D.source));break;case"disassemble":E.body?.instructions.forEach(P=>g(!1,P.location));break;default:break}break}}}function c(S){return S.filter(g=>!g.presentation?.hidden).sort((g,E)=>g.presentation?E.presentation?g.presentation.group?E.presentation.group?g.presentation.group!==E.presentation.group?g.presentation.group.localeCompare(E.presentation.group):s(g.presentation.order,E.presentation.order):-1:E.presentation.group?1:s(g.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function s(S,g){return typeof S!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:S-g}async function y(S,g){const E=S.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(E!=="none"&&(await g.saveAll(),E==="allEditorsInActiveGroup")){const D=g.activeEditorPane;D&&D.input.resource?.scheme===N.Schemas.untitled&&await g.save({editor:D.input,groupId:D.group.id})}await S.reloadConfiguration()}const b=(S,g)=>!S||!g?S===g:S.name===g.name&&S.path===g.path&&S.sourceReference===g.sourceReference;e.$BH=b}),define(Se[300],De([1,0,54,63,24,17,12,14,32,243,144]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=e.$Cnc=e.$Bnc=e.$Anc=e.$znc=void 0;class C extends A.$Rrb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${C.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(C.a);if(n!==-1){const l=this.p.toString("utf8",0,n).split(C.b);for(const o of l){const t=o.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+C.a.length);continue}}break}}}e.$znc=C;class $ extends C{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",l=>{i?this.n.fire(l):n(l)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Anc=$;class v extends ${constructor(a){super(),this.z=a}y(a){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$Bnc=v;class w extends ${constructor(a){super(),this.z=a}y(a){return O.createConnection(this.z.path,a)}}e.$Cnc=w;class h extends C{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(R.$ic(a)){if(!await m.Promises.exists(a))throw new Error(k.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let l=process.env;if(i.env&&Object.keys(i.env).length>0&&(l=L.$6n(L.$3n(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:l,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const u=d.fork(n[0],n.slice(1),t);if(!u.pid)throw new Error(k.localize(2,null,n[0]));this.x=u}else throw new Error(k.localize(3,null));else{const o={env:l};i.cwd&&(o.cwd=i.cwd),this.x=d.spawn(a,n,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(l){this.n.fire(l)}}async stopSession(){return this.x?(await this.w(),N.$i?new Promise((a,n)=>{const i=d.exec(`taskkill /F /T /PID ${this.x.pid}`,function(l,o,t){if(l)return n(l)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=R.$jc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(R.$ic(a.program)?i.program=a.program:i.program=R.$jc(n,a.program)),a.args&&(i.args=a.args);const l=a;return l.win&&(i.win=h.A(l.win,n)),l.winx86&&(i.winx86=h.A(l.winx86,n)),l.windows&&(i.windows=h.A(l.windows,n)),l.osx&&(i.osx=h.A(l.osx,n)),l.linux&&(i.linux=h.A(l.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const c of a)if(c.contributes){const s=c.contributes.debuggers;s&&s.length>0&&s.filter(y=>typeof y.type=="string"&&p.$xf(y.type,n)).forEach(y=>{const b=h.A(y,c.extensionLocation.fsPath);i=L.$6n(i,b,c.isBuiltin)})}let l;N.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?l=i.winx86||i.win||i.windows:N.$i?l=i.win||i.windows:N.$j?l=i.osx:N.$k&&(l=i.linux),l=l||i;const o=l.program||i.program,t=l.args||i.args,u=l.runtime||i.runtime,r=l.runtimeArgs||i.runtimeArgs;if(u)return{type:"executable",command:u,args:(r||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$Dnc=h}),define(Se[301],De([1,0,54,31,12]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=N,e.$Fnc=m;function R(k,A){return new Promise((C,$)=>{let v="";const w=d.spawn(k,A);w.pid&&w.stdout.on("data",h=>{v+=h.toString()}),w.on("error",h=>{$(h)}),w.on("close",h=>{C(v)})})}async function N(k){if(k)if(L.$i){const A=await new Promise((C,$)=>{he(["@vscode/windows-process-tree"],C,$)});return new Promise(C=>{A.getProcessTree(k,$=>{C(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(k)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var p;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(p||(p={}));function m(k,A,C,$,v){k=k.trim().toLowerCase();let w;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?w=1:k.indexOf("cmd.exe")>=0?w=0:k.indexOf("bash")>=0?w=2:L.$i?w=0:w=2;let h,f=" ";switch(w){case 1:if(h=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),$){const a=(0,O.$Bg)($);a&&(f+=`${a}:; `),f+=`cd ${h($)}; `}if(v)for(const a in v){const n=v[a];n===null?f+=`Remove-Item env:${a}; `:f+=`\${env:${a}}='${n}'; `}if(A.length>0){const a=A.shift(),n=C?a:h(a);f+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)f+=i==="<"||i===">"||C?i:h(i),f+=" "}break;case 0:if(h=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>a.includes(n))||a.length===0?`"${a}"`:a),$){const a=(0,O.$Bg)($);a&&(f+=`${a}: && `),f+=`cd ${h($)} && `}if(v){f+='cmd /C "';for(const a in v){let n=v[a];n===null?f+=`set "${a}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),f+=`set "${a}=${n}" && `)}}for(const a of A)f+=a==="<"||a===">"||C?a:h(a),f+=" ";v&&(f+='"');break;case 2:{h=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const a=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if($&&(f+=`cd ${h($)} ; `),v){f+="/usr/bin/env";for(const n in v){const i=v[n];i===null?f+=` -u ${a(n)}`:f+=` ${a(`${n}=${i}`)}`}f+=" "}for(const n of A)f+=n==="<"||n===">"||C?n:h(n),f+=" ";break}}return f}}),define(Se[302],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.CellExecutionUpdateType=void 0;var O;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$PK=(0,d.$wi)("INotebookExecutionService")}),define(Se[303],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjb=e.$ijb=e.ProxyKernelState=e.$hjb=void 0,e.$hjb=100;var O;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$ijb=(0,d.$wi)("INotebookKernelService"),e.$jjb=(0,d.$wi)("INotebookKernelHistoryService")}),define(Se[304],De([1,0,3,29,205,100]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fXb=void 0;class N extends d.$Uc{constructor(m,k,A){super(),this._source=m,this.b=k,this.c=A,this.a=void 0}f(m){const k=m.getLineCount();return new O.$ut(1,1,k,this.g(m,k))}g(m,k){if(k<1||k>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const m=new L.$2C;m.acceptChunk(this._source);const k=m.finish(!0),{textBuffer:A,disposable:C}=k.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const k=new L.$2C;k.acceptChunk(m);const A=k.finish(!0),{textBuffer:C,disposable:$}=A.create(1);return this.B($),C})),this.a}findInInputs(m){const A=new R.$PC(m,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs(m){const A=new R.$PC(m,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const $=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if($.length!==0)return{textBuffer:C,matches:$}}).filter(C=>!!C):[]}}e.$fXb=N}),define(Se[69],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(R){R.Delimiter="\0"})(d||(e.TestIdPathParts=d={}));var O;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class L{static fromExtHostTestItem(N,p,m=N.parent){if(N._isRoot)return new L([p]);const k=[N.id];for(let A=m;A&&A.id!==p;A=A.parent)k.push(A.id);return k.push(p),new L(k.reverse())}static isRoot(N){return!N.includes("\0")}static root(N){const p=N.indexOf("\0");return p===-1?N:N.slice(0,p)}static fromString(N){return new L(N.split("\0"))}static join(N,p){return new L([...N.path,p])}static joinToString(N,p){return N.toString()+"\0"+p}static parentId(N){const p=N.lastIndexOf("\0");return p===-1?void 0:N.slice(0,p)}static localId(N){const p=N.lastIndexOf("\0");return p===-1?N:N.slice(p+1)}static isChild(N,p){return p.startsWith(N)&&p[N.length]==="\0"}static compare(N,p){return N===p?0:L.isChild(N,p)?2:L.isChild(p,N)?3:1}constructor(N,p=N.length){if(this.path=N,this.d=p,N.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let N=1;N<=this.d;N++)yield new L(this.path,N)}*idsToRoot(){for(let N=this.d;N>0;N--)yield new L(this.path,N)}compare(N){if(typeof N=="string")return L.compare(this.toString(),N);for(let p=0;p<N.d&&p<this.d;p++)if(N.path[p]!==this.path[p])return 1;return N.d>this.d?2:N.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let N=1;N<this.d;N++)this.c+="\0",this.c+=this.path[N]}return this.c}}e.$WL=L}),define(Se[89],De([1,0,2,51,29,69]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$5L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$4L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3L=e.$2L=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1L=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZL=e.$YL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$XL=e.TestResultState=void 0;var N;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(N||(e.TestResultState=N={})),e.$XL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var m;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$YL=[2,4,8,16,32,64];const k=M=>"runId"in M;e.$ZL=k;var A;(function(M){M.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),M.deserialize=(j,U)=>({range:L.$ut.lift(U.range),uri:j.asCanonicalUri(d.URI.revive(U.uri))})})(A||(e.IRichLocation=A={}));var C;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(C||(e.TestMessageType=C={}));var $;(function(M){M.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&A.serialize(j.location)}),M.deserialize=(j,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&A.deserialize(j,U.location)})})($||(e.ITestErrorMessage=$={}));const v=(M,j)=>`${j?"s":"e"}${M}`;e.$1L=v;var w;(function(M){M.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&A.serialize(j.location)}),M.deserialize=(j,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&A.deserialize(j,U.location)})})(w||(e.ITestOutputMessage=w={}));var h;(function(M){M.serialize=j=>j.type===0?$.serialize(j):w.serialize(j),M.deserialize=(j,U)=>U.type===0?$.deserialize(j,U):w.deserialize(j,U)})(h||(e.ITestMessage=h={}));var f;(function(M){M.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),M.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(h.serialize)}),M.deserialize=(j,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(Z=>h.deserialize(j,Z))})})(f||(e.ITestTaskState=f={}));const a="\0",n=(M,j)=>M+a+j;e.$2L=n;const i=M=>{const j=M.indexOf(a);return{ctrlId:M.slice(0,j),tagId:M.slice(j+1)}};e.$3L=i;var l;(function(M){M.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),M.deserialize=(j,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?j.asCanonicalUri(d.URI.revive(U.uri)):void 0,range:U.range?L.$ut.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(l||(e.ITestItem=l={}));var o;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(M){M.serialize=j=>({expand:j.expand,item:l.serialize(j.item)}),M.deserialize=(j,U)=>({controllerId:R.$WL.root(U.item.extId),expand:U.expand,item:l.deserialize(j,U.item)})})(t||(e.InternalTestItem=t={}));var u;(function(M){M.serialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.uri!==void 0&&(U.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(U.range=j.item.range?.toJSON()),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}},M.deserialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.range!==void 0&&(U.range=j.item.range?L.$ut.lift(j.item.range):null),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}}})(u||(e.ITestItemUpdate=u={}));const r=(M,j)=>{j.expand!==void 0&&(M.expand=j.expand),j.item!==void 0&&(M.item=M.item?Object.assign(M.item,j.item):j.item)};e.$4L=r;var c;(function(M){M.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(f.serializeWithoutMessages)}),M.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(f.serialize)}),M.deserialize=(j,U)=>({...t.deserialize(j,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(Z=>f.deserialize(j,Z)),retired:!0})})(c||(e.TestResultItem=c={}));var s;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(j,U)=>{j.covered+=U.covered,j.total+=U.total}})(s||(e.ICoverageCount=s={}));var y;(function(M){M.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),M.deserialize=(j,U)=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:j.asCanonicalUri(d.URI.revive(U.uri))})})(y||(e.IFileCoverage=y={}));function b(M){return{...M,location:M.location?.toJSON()}}function S(M){return M.location=M.location?O.$tt.isIPosition(M.location)?O.$tt.lift(M.location):L.$ut.lift(M.location):void 0,M}e.$5L=3;var g;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(g||(e.DetailType=g={}));var E;(function(M){M.serialize=j=>j.type===0?P.serialize(j):I.serialize(j),M.deserialize=j=>j.type===0?P.deserialize(j):I.deserialize(j)})(E||(e.CoverageDetails=E={}));var D;(function(M){M.serialize=b,M.deserialize=S})(D||(e.IBranchCoverage=D={}));var P;(function(M){M.serialize=b,M.deserialize=S})(P||(e.IDeclarationCoverage=P={}));var I;(function(M){M.serialize=j=>({...b(j),branches:j.branches?.map(D.serialize)}),M.deserialize=j=>({...S(j),branches:j.branches?.map(D.deserialize)})})(I||(e.IStatementCoverage=I={}));var F;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var T;(function(M){M.deserialize=(j,U)=>U.op===0?{op:U.op,item:t.deserialize(j,U.item)}:U.op===1?{op:U.op,item:u.deserialize(U.item)}:U.op===2?{op:U.op,uri:j.asCanonicalUri(d.URI.revive(U.uri)),docv:U.docv}:U,M.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:u.serialize(j.item)}:j})(T||(e.TestsDiffOp=T={}));class z{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const U=this.v();for(const Z of j)switch(Z.op){case 0:this.l(t.deserialize(this.k,Z.item),U);break;case 1:this.o(u.deserialize(Z.item),U);break;case 3:this.p(Z.itemId,U);break;case 5:this.q(Z.itemId);break;case 4:this.updatePendingRoots(Z.amount);break;case 6:this.c.set(Z.tag.id,Z.tag);break;case 7:this.c.delete(Z.id);break}U.complete?.()}l(j,U){const Z=R.$WL.parentId(j.item.extId)?.toString();let ie;if(!Z)ie=this.w(j),this.g.add(ie),this.f.set(j.item.extId,ie);else if(this.f.has(Z)){const Q=this.f.get(Z);Q.children.add(j.item.extId),ie=this.w(j,Q),this.f.set(j.item.extId,ie)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return U.add?.(ie),j.expand===2&&this.h++,ie}o(j,U){const Z=this.f.get(j.extId);if(Z)return j.expand!==void 0&&(Z.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$4L)(Z,j),U.update?.(Z),Z}p(j,U){const Z=this.f.get(j);if(!Z)return;const ie=R.$WL.parentId(Z.item.extId)?.toString();ie?this.f.get(ie).children.delete(Z.item.extId):this.g.delete(Z);const Q=[[j]];for(;Q.length;)for(const G of Q.pop()){const x=this.f.get(G);x&&(Q.push(x.children),this.f.delete(G),U.remove?.(x,x!==Z),x.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$6L=z}),define(Se[113],De([1,0,7,4,3,62,89,69]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const k=(n,i)=>n===i,C=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(l=>!i.includes(l)))}),$=(n,i)=>{let l;for(const[o,t]of C)t(n[o],i[o])||(l?l[o]=i[o]:l={[o]:i[o]});return l};class v extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new d.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new O.$de),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const l of this.tree.values())this.J(l)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const l of this.m)if(l.op===2&&l.uri===i.uri){l.docv=i.docv;return}break}case 1:{const l=this.m[this.m.length-1];if(l){if(l.op===1&&l.item.extId===i.item.extId){(0,N.$4L)(l.item,i.item);return}if(l.op===0&&l.item.item.extId===i.item.extId){(0,N.$4L)(l.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,l){const o=this.tree.get(i);if(o){if((o.expandLevels===void 0||l>o.expandLevels)&&(o.expandLevels=l),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,l-1):t.wait().then(()=>this.L(o,l-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,l-1)):this.L(o,l-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,l){switch(l.op){case 3:this.O(p.$WL.joinToString(i.fullId,l.id));break;case 0:this.z(l.item,i);break;case 5:for(const o of l.ops)this.w(i,o);break;case 1:this.C(l.new,l.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:l.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$ed)(l)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,l){const o=p.$WL.fromExtHostTestItem(i,this.root.id,l?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==l?.actual&&this.s.getChildren(t.parent).delete(i.id);let u=this.tree.get(o.toString());if(!u){u={fullId:o,actual:i,expandLevels:l?.expandLevels?l.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,l),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,l);return}if(u.actual===i){this.H(i,u,l);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(o.toString()),this.z(i,l);const r=this.s.getChildren(u.actual),c=u.actual,s=$(this.s.toITestItem(c),this.s.toITestItem(i));this.s.getApiFor(c).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=0,s&&(s.hasOwnProperty("tags")&&(this.C(i.tags,c.tags,o.toString()),delete s.tags),this.w(u,{op:4,update:s})),this.I(i,u,l);for(const[b,S]of r)this.s.getChildren(i).get(S.id)||this.O(p.$WL.joinToString(o,S.id));const y=u.expandLevels;y!==void 0&&queueMicrotask(()=>{u.expand===1&&(u.expandLevels=void 0,this.expand(o.toString(),y))}),this.y(u.actual.uri)}C(i,l,o){const t=new Set(l.map(u=>u.id));for(const u of i)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:o,item:{tags:i.map(u=>(0,N.$2L)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(i){const l=this.j.get(i.id);l?l.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,N.$2L)(this.s.controllerId,i.id)}}))}F(i){const l=this.j.get(i);l&&!--l.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,N.$2L)(this.s.controllerId,i)}))}G(i,l){this.s.getApiFor(i).parent=l&&l.actual!==this.root?l.actual:void 0}H(i,l,o){this.G(i,o);const t=this.s.getApiFor(i);t.parent=o?.actual,t.listener=u=>this.w(l,u),this.J(l)}I(i,l,o){this.H(i,l,o);for(const[t,u]of this.s.getChildren(i))this.z(u,l)}J(i){let l;this.h?i.resolveBarrier?l=i.resolveBarrier.isOpen()?3:2:l=i.actual.canResolveChildren?1:0:l=0,l!==i.expand&&(i.expand=l,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:l}}),l===1&&i.expandLevels!==void 0&&this.M(i))}L(i,l){if(l<0)return;const o=[];for(const[t,u]of this.s.getChildren(i.actual)){const r=this.expand(p.$WL.joinToString(i.fullId,u.id),l);(0,d.$ih)(r)&&o.push(r)}if(o.length)return Promise.all(o).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new d.$vh;return u.open(),u}i.expand=2,this.N(i);const l=i.resolveBarrier=new d.$vh,o=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(u){o(u)}return(0,d.$ih)(t)?t.catch(o).then(()=>{l.open(),this.J(i)}):(l.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const l=this.tree.get(i);if(!l)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const o=[l];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,r]of this.s.getChildren(t.actual))o.push(this.tree.get(p.$WL.joinToString(t.fullId,r.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$pP=v;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$qP=w;class h extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rP=h;class f extends Error{constructor(i,l,o){super(`TestItem with ID "${i}" is from controller "${l}" and cannot be added as a child of an item from controller "${o}".`)}}e.$sP=f;const a=(n,i,l)=>{let o=new Map;return{get size(){return o.size},forEach(t,u){for(const r of o.values())t.call(u,r,this)},[Symbol.iterator](){return o.entries()},replace(t){const u=new Map,r=new Set(o.keys()),c={op:5,ops:[]};for(const s of t){if(!(s instanceof l))throw new h(s.id);const y=i(s).controllerId;if(y!==n.controllerId)throw new f(s.id,y,n.controllerId);if(u.has(s.id))throw new w(s.id);u.set(s.id,s),r.delete(s.id),c.ops.push({op:0,item:s})}for(const s of r.keys())c.ops.push({op:3,id:s});n.listener?.(c),o=u},add(t){if(!(t instanceof l))throw new h(t.id);o.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){o.delete(t)&&n.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$tP=a}),define(Se[145],De([1,0,113]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=void 0;const O=new WeakMap,L=(N,p)=>{const m={controllerId:p};return O.set(N,m),m};e.$uP=L;const R=N=>{const p=O.get(N);if(!p)throw new d.$rP(N?.id||"<unknown>");return p};e.$vP=R}),define(Se[114],De([1,0,15,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MAb=e.$LAb=e.$KAb=void 0,e.$NAb=L,e.$OAb=N,e.$KAb="vscode-cdn.net",e.$LAb=`vscode-resource.${e.$KAb}`,e.$MAb=`'self' https://*.${e.$KAb}`;function L(p,m){return p.scheme===d.Schemas.http||p.scheme===d.Schemas.https?p:(m&&m.authority&&m.isRemote&&p.scheme===d.Schemas.file&&(p=O.URI.from({scheme:d.Schemas.vscodeRemote,authority:m.authority,path:p.path})),O.URI.from({scheme:d.Schemas.https,authority:`${p.scheme}+${R(p.authority)}.${e.$LAb}`,path:p.path,fragment:p.fragment,query:p.query}))}function R(p){return p.replace(/./g,m=>{const k=m.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?m:"-"+k.toString(16).padStart(4,"0")})}function N(p){return p.replace(/-([0-9a-f]{4})/g,(m,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Se[305],De([1,0,4,3,114]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class R{constructor(p,m,k){this.d=p,this.e=m,this.f=k,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const A=m.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,m,k,A,C){let $;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===p){$=i;break}if(!$)throw new Error("not a visible editor");const v=this,w=this.a++,h=new d.$de,f=new d.$de,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$NAb)(i,v.f)}get cspSource(){return L.$MAb}set options(i){this.b=i,v.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,v.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(i){return v.d.$postMessage(w,i)}},n=new class{constructor(){this.editor=p,this.line=m,this.height=k,this.webview=a,this.onDidDispose=f.event}dispose(){v.c.has(w)&&(v.c.delete(w),v.d.$disposeEditorInset(w),f.fire(),f.dispose(),h.dispose())}};return this.d.$createEditorInset(w,$.id,$.value.document.uri,m+1,k,A||{},C.identifier,C.extensionLocation),this.c.set(w,{editor:p,inset:n,onDidReceiveMessage:h}),n}$onDidDispose(p){const m=this.c.get(p);m&&m.inset.dispose()}$onDidReceiveMessage(p,m){this.c.get(p)?.onDidReceiveMessage.fire(m)}}e.$Alc=R}),define(Se[146],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=void 0,e.$aM="__",e.$bM=(0,d.$wi)("IAuthenticationService"),e.$cM=(0,d.$wi)("IAuthenticationExtensionsService")}),define(Se[306],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.VariableKind=e.$nQ=void 0,e.$nQ=(0,d.$wi)("configurationResolverService");var O;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class L extends Error{constructor(N,p){super(p),this.variable=N}}e.$oQ=L}),define(Se[307],De([1,0,17,52,18,24,12,103,246,306,14]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,w,h,f){this.h=new Map,this.a=v,this.b=w,this.g=h,f&&(this.c=f.then(a=>this.i(a)))}i(v){if(N.$i){const w=Object.create(null);return Object.keys(v).forEach(h=>{w[h.toLowerCase()]=v[h]}),w}return v}resolveWithEnvironment(v,w,h){return this.l({env:this.i(v),userHome:void 0},w?w.uri:void 0,h)}async resolveAsync(v,w){const h={env:await this.c,userHome:await this.g};return this.l(h,v?v.uri:void 0,w)}async j(v,w,h,f){const a=R.$3n(w);N.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):N.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):N.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,a,h,f)}async resolveAnyAsync(v,w,h){return this.j(v,w,h)}async resolveAnyMap(v,w,h){const f=new Map;return{newConfig:await this.j(v,w,h,f),resolvedVariables:f}}resolveWithInteractionReplace(v,w,h,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,w,h,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,w){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,w)}async l(v,w,h,f,a){if(L.$9f(h))return this.m(v,w,h,f,a);if(Array.isArray(h))return Promise.all(h.map(n=>this.l(v,w,n,f,a)));if(L.$$f(h)){const n=Object.create(null),i=await Promise.all(Object.keys(h).map(async l=>[await this.m(v,w,l,f,a),await this.l(v,w,h[l],f,a)]));for(const[l,o]of i)n[l]=o;return n}return h}m(v,w,h,f,a){return(0,A.$pf)(h,C.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(C.VARIABLE_LHS))return n;let l=await this.o(v,n,i,w,f);return a?.set(i,l),l!==n&&L.$9f(l)&&l.match(C.VARIABLE_REGEXP)&&(l=await this.m(v,w,l,f,a)),l})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,w,h,f,a){let n;const i=h.split(":");i.length>1&&(h=i[0],n=i[1]);const l=u=>{const r=this.a.getFilePath();if(r)return(0,p.$Ew)(r);throw new k.$oQ(u,(0,m.localize)(0,null,w))},o=u=>{const r=l(u);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,p.$Ew)(c)}throw new k.$oQ(u,(0,m.localize)(1,null,w,d.$nc(r)))},t=u=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new k.$oQ(u,(0,m.localize)(2,null,w,n))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new k.$oQ(u,(0,m.localize)(3,null,w)):new k.$oQ(u,(0,m.localize)(4,null,w))};switch(h){case"env":if(n){if(v.env){const u=v.env[N.$i?n.toLowerCase():n];if(L.$9f(u))return u}return""}throw new k.$oQ(k.VariableKind.Env,(0,m.localize)(5,null,w));case"config":if(n){const u=this.a.getConfigurationValue(f,n);if(L.$fg(u))throw new k.$oQ(k.VariableKind.Config,(0,m.localize)(6,null,w,n));if(L.$$f(u))throw new k.$oQ(k.VariableKind.Config,(0,m.localize)(7,null,w,n));return u}throw new k.$oQ(k.VariableKind.Config,(0,m.localize)(8,null,w));case"command":return this.p(k.VariableKind.Command,w,n,a,"command");case"input":return this.p(k.VariableKind.Input,w,n,a,"input");case"extensionInstallFolder":if(n){const u=await this.a.getExtension(n);if(!u)throw new k.$oQ(k.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,w,n));return this.n(u.extensionLocation)}throw new k.$oQ(k.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,w));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,p.$Ew)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return f||n?(0,p.$Ew)(this.n(t(k.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Ew)(d.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new k.$oQ(k.VariableKind.UserHome,(0,m.localize)(11,null,w))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new k.$oQ(k.VariableKind.LineNumber,(0,m.localize)(12,null,w))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new k.$oQ(k.VariableKind.SelectedText,(0,m.localize)(13,null,w))}case"file":return l(k.VariableKind.File);case"fileWorkspaceFolder":return o(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return d.$nc(o(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||n?d.$lc(this.n(t(k.VariableKind.RelativeFile)),l(k.VariableKind.RelativeFile)):l(k.VariableKind.RelativeFile);case"relativeFileDirname":{const u=d.$mc(l(k.VariableKind.RelativeFileDirname));if(f||n){const r=d.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),u);return r.length===0?".":r}return u}case"fileDirname":return d.$mc(l(k.VariableKind.FileDirname));case"fileExtname":return d.$oc(l(k.VariableKind.FileExtname));case"fileBasename":return d.$nc(l(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=d.$nc(l(k.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-d.$oc(u).length)}case"fileDirnameBasename":return d.$nc(d.$mc(l(k.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||w}case"execInstallFolder":{const u=this.a.getAppRoot();return u||w}case"pathSeparator":case"/":return d.sep;default:try{const u=n?`${h}:${n}`:h;return this.p(k.VariableKind.Unknown,w,u,a,void 0)}catch{return w}}}}p(v,w,h,f,a){if(h&&f){const n=a===void 0?f[h]:f[a+":"+h];if(typeof n=="string")return n;throw new k.$oQ(v,(0,m.localize)(14,null,w))}return w}}e.$DQ=C}),define(Se[147],De([1,0,5,143]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=k,e.$1D=$,e.$2D=v,e.$YD=(0,d.$wi)("editorGroupsService");var L;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var N;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(N||(e.GroupLocation=N={}));var p;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var m;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function k(w){const h=w;return(0,O.$JF)(h?.editor)&&(0,O.$JF)(h?.replacement)}var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function $(w){const h=w;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function v(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[308],De([1,0,5,147]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=L,e.$3D=(0,d.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function L(R){const N=R;return typeof R=="number"||(0,O.$1D)(N)}}),define(Se[148],De([1,0,5,137]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=void 0,e.$vM=(0,d.$xi)(O.$Di)}),define(Se[149],De([1,0,25,4,17,3,7]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=e.$V_b=e.$U_b=e.$T_b=void 0;class p{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$T_b=p;class m{static isHostExtension(n,i,l){if(i.getExtensionDescription(n))return!1;const o=l.getExtensionDescription(n);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$de,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(h),this.f=new d.$Tm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const l of i)this.h.has(l)||this.h.set(l,[]),this.h.get(l).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=f(this.e,i),this.e=this.e.concat(n);const l=m.l(this.e);return this.e=f(this.e,l.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,l)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,c){this.addNode(r),this.addNode(c),this.c.has(r)?this.c.get(r).push(c):this.c.set(r,[c])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,c){const s=i.getArcs(r);for(let y=0;y<s.length;y++)if(!c.has(s[y]))return!1;return!0}getNodes(){return this.e}},l=new d.$Tm;for(const r of n)if(l.set(r.identifier,r),r.extensionDependencies)for(const c of r.extensionDependencies)i.addArc(d.$Rm.toKey(r.identifier),d.$Rm.toKey(c));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const t=i.getNodes().filter(r=>!o.has(r));let u;do{u=!1;for(let r=0;r<t.length;r++){const c=t[r];i.hasOnlyGoodArcs(c,o)&&(t.splice(r,1),r--,o.add(c),u=!0)}}while(u);return t.map(r=>l.get(r))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$U_b=m;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$V_b=k;class A{constructor(n){this.d=new v,this.c=new m(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new C(this,i)}deltaExtensions(n,i,l){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,l)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$W_b=A;class C extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$X_b=C;class ${constructor(n){this.name=n;const i=(0,N.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class v{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new $(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const l=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(l),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(o))}}var w;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(w||(w={}));function h(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==l)return i-l;const o=L.$gc.basename(a.extensionLocation.path),t=L.$gc.basename(n.extensionLocation.path);return o<t?-1:o>t?1:0}function f(a,n){const i=new d.$Sm(n);return a.filter(l=>!i.has(l.identifier))}}),define(Se[309],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.ExtHostConnectionType=void 0,e.$nn=p,e.$on=m;var d;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(d||(e.ExtHostConnectionType=d={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[O.ENV_KEY]=this.pipeName}}e.$kn=O;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$ln=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[R.ENV_KEY]="1"}}e.$mn=R;function N(A){delete A[O.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function p(A,C){N(C),A.serialize(C)}function m(A){if(A[O.ENV_KEY])return k(A,new O(A[O.ENV_KEY]));if(A[L.ENV_KEY])return k(A,new L);if(A[R.ENV_KEY])return k(A,new R);throw new Error("No connection information defined in environment!")}function k(A,C){return N(A),C}}),define(Se[115],De([1,0,21]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=N,e.$1m=p;var O;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(O||(e.UIKind=O={}));var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function N(k){const A=d.$Fe.alloc(1);switch(k){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function p(k,A){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var m;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[90],De([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$RP=e.$QP=void 0,e.$SP=h;let v=class extends C.$Uc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new O.$de),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$de),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$kp,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const l=this.getTelemetryDetails(),o=new w(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:n["common.uikind"]="web";break;case N.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Im)((0,m.$qp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,l)=>{const o=i.filter(t=>!t.isDisposed);o.length===0?this.r.delete(l):this.r.set(l,o)}),this.r.forEach(i=>{for(const l of i)l.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const l=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!l)return this.r.delete(a.value),!1;let o=!1;for(const t of l)t.ignoreUnhandledExtHostErrors||(t.logError(n),o=!0);return o}};e.$QP=v,e.$QP=v=Ge([We(0,R.$PP),We(1,L.$4j)],v);class w{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,l,o,t,u){this.g=i,this.h=l,this.i=o,this.j=t,this.a=new O.$de,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,m.$tp)(n,[]),this.c&&(n=(0,k.$6n)(n,this.c)),this.b||(n=(0,k.$6n)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},l=(0,m.$tp)(i,[]),o=new Error(l.message,{cause:l.cause});o.stack=l.stack,o.name=l.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(o,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$RP=w;function h(f){const a=Date.now()-new Date(f).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$TP=(0,d.$wi)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,278,140,25,5]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=$,e.$PG=v,e.$SG=a,e.$TG=n,e.$JG=Object.freeze({identifier:new N.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,p.$wi)("extensionService");class m{constructor(o){this.dependency=o}}e.$MG=m;var k;(function(l){l[l.EagerAutoStart=1]="EagerAutoStart",l[l.EagerManualStart=2]="EagerManualStart",l[l.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,u){this.c=o,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$uG.createActivationEventsMap(this.d)}}set(o,t,u){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const r=[],c=[],s=[],y=[],b=C(this.d),S=C(t),g=(F,T)=>F.extensionLocation.toString()===T.extensionLocation.toString()||F.isBuiltin===T.isBuiltin||F.isUserBuiltin===T.isUserBuiltin||F.isUnderDevelopment===T.isUnderDevelopment;for(const F of this.d){const T=S.get(F.identifier);if(!T){r.push(F.identifier),b.delete(F.identifier);continue}if(!g(F,T)){r.push(F.identifier),b.delete(F.identifier);continue}}for(const F of t){const T=b.get(F.identifier);if(!T){c.push(F);continue}if(!g(T,F)){r.push(T.identifier),b.delete(T.identifier);continue}}const E=new N.$Sm(this.e),D=new N.$Sm(u);for(const F of this.e)D.has(F)||s.push(F);for(const F of u)E.has(F)||y.push(F);const P=R.$uG.createActivationEventsMap(c),I={versionId:o,toRemove:r,toAdd:c,addActivationEvents:P,myToRemove:s,myToAdd:y};return this.delta(I),I}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:r,myToAdd:c}=o,s=new N.$Sm(t),y=new N.$Sm(r);for(let b=0;b<this.d.length;b++)s.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)y.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of u)this.d.push(b);for(const b of c)this.e.push(b);return this.f=null,o}containsExtension(o){for(const t of this.e)if(N.$Rm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=R.$uG.readActivationEvents(t);for(const r of u)o.add(r)}return o}}e.$NG=A;function C(l){const o=new N.$Tm;for(const t of l)o.set(t.identifier,t);return o}function $(l,o){return l.enabledApiProposals?l.enabledApiProposals.includes(o):!1}function v(l,o){if(!$(l,o))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}class w{constructor(o,t,u,r){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=r}}e.$QG=w;class h{constructor(o,t){this.description=o,this.value=t}}e.$RG=h;var f;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function a(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,L.$zp)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}function n(l,o){return{identifier:new N.$Rm((0,L.$xp)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!o,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,publisherDisplayName:l.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None,this.onWillStop=d.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=i}),define(Se[310],De([1,0,13,149,25,26,11,7]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=e.$Zlc=e.$Ylc=e.$Xlc=e.$Wlc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(a,n,i,l){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=l}}e.$Wlc=m;class k{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Xlc=k;class A{constructor(a,n,i,l,o,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=l,this.exports=o,this.subscriptions=t}}e.$Ylc=A;class C extends A{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Zlc=C;class $ extends A{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$1lc=$;class v extends A{constructor(a){super(!0,a,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(a,n,i,l){this.g=l,this.a=a,this.b=n,this.c=i,this.d=new L.$Tm,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(l=>({id:l.identifier,reason:{startup:n,extensionId:l.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new v(o));return this.c.onExtensionActivationError(a.id,o,new R.$MG(a.id.value)),t}const i=[],l=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const o of l){if(this.m(o))continue;const t=this.d.get(o);if(t){i.push(t);continue}if(this.l(o)){i.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const u=this.a.getExtensionDescription(o);if(u){if(!u.main&&!u.browser)continue;i.push(this.j({id:u.identifier,reason:a.reason}));continue}const r=n.displayName||n.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${o}'`),s=this.k(a,n.displayName,[],new v(c));return this.c.onExtensionActivationError(n.identifier,c,new R.$MG(o)),s}return this.k(a,n.displayName,i,null)}k(a,n,i,l){const o=new h(a.id,n,a.reason,i,l,this.c,this.g);return this.d.set(a.id,o),o}l(a){return O.$U_b.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$2lc=w,e.$2lc=w=Ge([We(3,N.$3j)],w);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,l,o,t,u){this.c=a,this.d=n,this.f=i,this.g=l,this.h=o,this.j=t,this.k=u,this.a=new p.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new v(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new v(n),this.b&&d.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};h=Ge([We(6,N.$3j)],h)}),define(Se[311],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[312],De([1,0,248,13,41,138,110,36,25,311,108,140]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const $=p.$co.as(N.$do.JSONContribution);class v{constructor(o,t,u){this.a=o,this.b=t,this.c=u}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(L.default.Error,o)}warn(o){this.d(L.default.Warning,o)}info(o){this.d(L.default.Info,o)}}e.$DG=v;class w{static a(o){const t=new m.$Sm;for(let u=0,r=o.length;u<r;u++)t.add(o[u].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new w(t,[]);if(!t||!t.length)return new w([],o);const u=this.a(o),r=this.a(t),c=t.filter(y=>!u.has(y.description.identifier)),s=o.filter(y=>!r.has(y.description.identifier));return new w(c,s)}constructor(o,t){this.added=o,this.removed=t}}e.$EG=w;class h{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=w.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,O.$1)(o)}}}e.$FG=h;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[d.localize(0,null),d.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:d.localize(2,null),properties:{vscode:{type:"string",description:d.localize(3,null),default:"^1.22.0"}}},publisher:{description:d.localize(4,null),type:"string"},displayName:{description:d.localize(5,null),type:"string"},categories:{description:d.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Qm},{type:"string",const:"Languages",deprecationMessage:d.localize(7,null)}]}},galleryBanner:{type:"object",description:d.localize(8,null),properties:{color:{description:d.localize(9,null),type:"string"},theme:{description:d.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:d.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:d.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:d.localize(13,null)},enabledApiProposals:{markdownDescription:d.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:d.localize(15,null),type:"string",enum:["none"],enumDescriptions:[d.localize(16,null)]},activationEvents:{description:d.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:d.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:d.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:d.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:d.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:d.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:d.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:d.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:d.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:d.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:d.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:d.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:d.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:d.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:d.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:d.localize(32,null)},{label:"onUri",body:"onUri",description:d.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:d.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:d.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:d.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:d.localize(37,null)},{label:"onRenderer",description:d.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:d.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:d.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:d.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:d.localize(42,null)},{label:"*",description:d.localize(43,null),body:"*"}]}},badges:{type:"array",description:d.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:d.localize(45,null)},href:{type:"string",description:d.localize(46,null)},description:{type:"string",description:d.localize(47,null)}}}},markdown:{type:"string",description:d.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:d.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:d.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionPack:{description:d.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionKind:{description:d.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:d.localize(53,null)},{body:["workspace"],description:d.localize(54,null)},{body:["ui","workspace"],description:d.localize(55,null)},{body:["workspace","ui"],description:d.localize(56,null)},{body:[],description:d.localize(57,null)}]},capabilities:{description:d.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:d.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:d.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(61,null),d.localize(62,null),d.localize(63,null)]},description:{type:"string",markdownDescription:d.localize(64,null)}}},untrustedWorkspaces:{description:d.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:d.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(67,null),d.localize(68,null),d.localize(69,null)]},restrictedConfigurations:{description:d.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:d.localize(71,null)}}}}},sponsor:{description:d.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:d.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:d.localize(74,null),type:"string"},"vscode:uninstall":{description:d.localize(75,null),type:"string"}}},icon:{type:"string",description:d.localize(76,null)},l10n:{type:"string",description:d.localize(77,null)},pricing:{type:"string",markdownDescription:d.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new h(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&C.$uG.register(o.extensionPoint,o.activationEventsGenerator),e.$GG.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,$.registerSchema(a,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};p.$co.add(i.ExtensionsRegistry,new n),e.$IG=p.$co.as(i.ExtensionsRegistry),$.registerSchema(a,e.$GG),$.registerSchema(A.$kk,{properties:{extensionEnabledApiProposals:{description:d.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Se[313],De([1,0,244,18,24,312,38,4]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:d.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:d.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:d.localize(2,null),default:""}}};var k;(function($){function v(w,h,f){if(!w)return;const a=O.$9f(w.type)?w.type:void 0;if(!a||a.length===0){f.error(d.localize(3,null));return}const n=[];if(Array.isArray(w.required))for(const i of w.required)O.$9f(i)&&n.push(i);return{extensionId:h.value,taskType:a,required:n,properties:w.properties?L.$3n(w.properties):{},when:w.when?N.$uj.deserialize(w.when):void 0}}$.from=v})(k||(k={}));const A=R.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,v)=>{for(const w of $)w.type&&v.push(`onTaskType:${w.type}`)},jsonSchema:{description:d.localize(4,null),type:"array",items:m}});class C{constructor(){this.d=new p.$de,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,w)=>{A.setHandler((h,f)=>{this.c=void 0;try{for(const a of f.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of f.added){const n=a.value;for(const i of n){const l=k.from(i,a.description.identifier,a.collector);l&&(this.a[l.taskType]=l)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const w of this.all()){const h={type:"object",additionalProperties:!1};w.required.length>0&&(h.required=w.required.slice(0)),w.properties!==void 0?h.properties=L.$3n(w.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[w.taskType]},v.push(h)}this.c={oneOf:v}}return this.c}}e.$cI=new C}),define(Se[314],De([1,0,245,18,23,24,38,313]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new N.$Nj("taskRunning",!1,d.localize(0,null)),e.$fI=d.localize2(2,"Tasks");var m;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$gI="$customized",function(M){function j(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=j}(m||(e.ShellQuoting=m={}));var k;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var A;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(A||(e.RevealKind=A={})),function(M){function j(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=j}(A||(e.RevealKind=A={}));var C;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(M){function j(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=j}(C||(e.RevealProblemKind=C={}));var $;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})($||(e.PanelKind=$={})),function(M){function j(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=j}($||(e.PanelKind=$={}));var v;(function(M){M.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var w;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(M){function j(Z){switch(Z.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=j;function U(Z){switch(Z){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(w||(e.RuntimeType=w={}));var h;(function(M){function j(U){return O.$9f(U)?U:U.value}M.value=j})(h||(e.CommandString=h={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function j(Z){return Z===M.Clean._id||Z===M.Build._id||Z===M.Rebuild._id||Z===M.Test._id}M.is=j;function U(Z){if(Z!==void 0)return O.$9f(Z)?j(Z)?{_id:Z,isDefault:!1}:void 0:Z}M.from=U})(f||(e.TaskGroup=f={}));var a;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function j(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=j})(n||(e.TaskSourceKind=n={}));var i;(function(M){M.parallel="parallel",M.sequence="sequence"})(i||(e.DependsOrder=i={}));var l;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(l||(e.RunOnOptions=l={}));var o;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(j,U,Z,ie,Q,G){this._label="",this._id=j,U&&(this._label=U),Z&&(this.type=Z),this.runOptions=ie,this.configurationProperties=Q,this._source=G}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,U=!1){if(j===void 0)return!1;if(O.$9f(j))return j===this._label||j===this.configurationProperties.identifier||U&&j===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$hI=t;class u extends t{constructor(j,U,Z,ie,Q,G,x,ne){super(j,Z,void 0,x,ne,U),this.command={},this._source=U,this.hasDefinedMatchers=G,Q&&(this.command=Q)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case w.Shell:U="shell";break;case w.Process:U="process";break;case w.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(j){return j instanceof u}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Z={type:e.$gI,folder:j,id:U};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new u(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$iI=u;class r extends t{constructor(j,U,Z,ie,Q,G,x){super(j,Z,ie,G,x,U),this._source=U,this.configures=Q}static is(j){return j instanceof r}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Z={type:e.$gI,folder:j,id:U};return JSON.stringify(Z)}}e.$jI=r;class c extends t{constructor(j,U,Z,ie,Q,G,x,ne,be){super(j,Z,ie,ne,be,U),this.defines=Q,this.hasDefinedMatchers=x,this.command=G,this.icon=be.icon,this.hide=be.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof c}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new c(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$kI=c;class s extends t{constructor(j,U,Z,ie,Q,G){super(j,Z,ie,Q,G,U),this._source=U}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new s(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$lI=s;var y;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(y||(e.ExecutionEngine=y={})),function(M){M._default=M.Terminal}(y||(e.ExecutionEngine=y={}));var b;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class S{constructor(j){this.c=new Map;for(let U=0;U<j.length;U++)this.c.set(j[U].uri.toString(),U)}compare(j,U){const Z=j.getWorkspaceFolder(),ie=U.getWorkspaceFolder();if(Z&&ie){let Q=this.c.get(Z.uri.toString());Q=Q===void 0?0:Q+1;let G=this.c.get(ie.uri.toString());return G=G===void 0?0:G+1,Q===G?j._label.localeCompare(U._label):Q-G}else return!Z&&ie?-1:Z&&!ie?1:0}}e.$mI=S;var g;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(g||(e.TaskEventKind=g={}));var E;(function(M){M.SingleRun="singleRun",M.Background="background"})(E||(e.TaskRunType=E={}));var D;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var P;(function(M){function j(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function U(ne,be,ae){return{...j(ne),kind:"start",terminalId:be,resolvedVariables:ae}}M.start=U;function Z(ne,be,ae){return{...j(ne),kind:"processStarted",terminalId:be,processId:ae}}M.processStarted=Z;function ie(ne,be,ae){return{...j(ne),kind:"processEnded",terminalId:be,exitCode:ae}}M.processEnded=ie;function Q(ne,be,ae){return{...j(ne),kind:"terminated",exitReason:ae,terminalId:be}}M.terminated=Q;function G(ne,be,ae){return{...j(be),kind:ne,terminalId:ae}}M.general=G;function x(){return{kind:"changed"}}M.changed=x})(P||(e.TaskEvent=P={}));var I;(function(M){function j(Z){const ie=Object.keys(Z).sort();let Q="";for(const G of ie){let x=Z[G];x instanceof Object?x=j(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),Q+=G+","+x+","}return Q}function U(Z){const Q={_key:j(Z),type:Z.taskType};return Object.assign(Q,Z),Q}M.create=U})(I||(e.KeyedTaskIdentifier=I={}));var F;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var T;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var z;(function(M){function j(U,Z){const ie=p.$cI.get(U.type);if(ie===void 0){const ne=R.$3n(U);return delete ne._key,I.create(ne)}const Q=Object.create(null);Q.type=ie.taskType;const G=new Set;ie.required.forEach(ne=>G.add(ne));const x=ie.properties;for(const ne of Object.keys(x)){const be=U[ne];if(be!=null)Q[ne]=be;else if(G.has(ne)){const ae=x[ne];if(ae.default!==void 0)Q[ne]=R.$3n(ae.default);else switch(ae.type){case"boolean":Q[ne]=!1;break;case"number":case"integer":Q[ne]=0;break;case"string":Q[ne]="";break;default:Z.error(d.localize(1,null,JSON.stringify(U,void 0,0),ne));return}}}return I.create(Q)}M.createTaskIdentifier=j})(z||(e.TaskDefinition=z={}))}),define(Se[315],De([1,0,13]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=e.$Y_b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((N,p)=>{this.b=N,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(N){this.f||this.h||(this.f=!0,this.g=N,this.a&&this.b(N))}resolveErr(N){this.f||this.h||(this.h=!0,this.i=N,this.a?this.d(N):(0,d.$1)(N))}then(N,p){return this.j().then(N,p)}catch(N){return this.j().then(void 0,N)}finally(N){return this.j().finally(N)}}e.$Y_b=O;class L extends O{constructor(){super(),this.h=!0,this.i=new d.$5}}e.$Z_b=L}),define(Se[48],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$yw=void 0,e.$zw=L,e.$Aw=R;class d{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++d.count}}e.$yw=d;const O=[];function L(p){const m=new d(p);return O[m.nid]=m,m}function R(p){return O[p].sid}class N{constructor(m){this.value=m}}e.$Bw=N}),define(Se[6],De([1,0,48]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$0M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var L;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput",h[h.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var N;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(N||(e.WebviewEditorCapabilities=N={}));var p;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var m;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var k;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output",h[h.Hybrid=3]="Hybrid"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$0M=C;var $;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var v;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var w;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$$M={MainThreadAuthentication:(0,d.$zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,d.$zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,d.$zw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,d.$zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,d.$zw)("MainThreadChatVariables"),MainThreadClipboard:(0,d.$zw)("MainThreadClipboard"),MainThreadCommands:(0,d.$zw)("MainThreadCommands"),MainThreadComments:(0,d.$zw)("MainThreadComments"),MainThreadConfiguration:(0,d.$zw)("MainThreadConfiguration"),MainThreadConsole:(0,d.$zw)("MainThreadConsole"),MainThreadDebugService:(0,d.$zw)("MainThreadDebugService"),MainThreadDecorations:(0,d.$zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,d.$zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,d.$zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,d.$zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,d.$zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,d.$zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,d.$zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,d.$zw)("MainThreadEditorTabs"),MainThreadErrors:(0,d.$zw)("MainThreadErrors"),MainThreadTreeViews:(0,d.$zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,d.$zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,d.$zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,d.$zw)("MainThreadLanguages"),MainThreadLogger:(0,d.$zw)("MainThreadLogger"),MainThreadMessageService:(0,d.$zw)("MainThreadMessageService"),MainThreadOutputService:(0,d.$zw)("MainThreadOutputService"),MainThreadProgress:(0,d.$zw)("MainThreadProgress"),MainThreadQuickDiff:(0,d.$zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,d.$zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,d.$zw)("MainThreadStatusBar"),MainThreadSecretState:(0,d.$zw)("MainThreadSecretState"),MainThreadStorage:(0,d.$zw)("MainThreadStorage"),MainThreadSpeech:(0,d.$zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,d.$zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,d.$zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,d.$zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,d.$zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,d.$zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,d.$zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,d.$zw)("MainThreadCustomEditors"),MainThreadUrls:(0,d.$zw)("MainThreadUrls"),MainThreadUriOpeners:(0,d.$zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,d.$zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,d.$zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,d.$zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,d.$zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,d.$zw)("MainThreadExtensionService"),MainThreadSCM:(0,d.$zw)("MainThreadSCM"),MainThreadSearch:(0,d.$zw)("MainThreadSearch"),MainThreadShare:(0,d.$zw)("MainThreadShare"),MainThreadTask:(0,d.$zw)("MainThreadTask"),MainThreadWindow:(0,d.$zw)("MainThreadWindow"),MainThreadLabelService:(0,d.$zw)("MainThreadLabelService"),MainThreadNotebook:(0,d.$zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,d.$zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,d.$zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,d.$zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,d.$zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,d.$zw)("MainThreadInteractive"),MainThreadInlineChat:(0,d.$zw)("MainThreadInlineChatShape"),MainThreadTheming:(0,d.$zw)("MainThreadTheming"),MainThreadTunnelService:(0,d.$zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,d.$zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,d.$zw)("MainThreadTimeline"),MainThreadTesting:(0,d.$zw)("MainThreadTesting"),MainThreadLocalization:(0,d.$zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,d.$zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,d.$zw)("MainThreadAiEmbeddingVector")},e.$_M={ExtHostCommands:(0,d.$zw)("ExtHostCommands"),ExtHostConfiguration:(0,d.$zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,d.$zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,d.$zw)("ExtHostDebugService"),ExtHostDecorations:(0,d.$zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,d.$zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,d.$zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,d.$zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,d.$zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,d.$zw)("ExtHostEditors"),ExtHostTreeViews:(0,d.$zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,d.$zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,d.$zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,d.$zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,d.$zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,d.$zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,d.$zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,d.$zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,d.$zw)("ExtHostStatusBar"),ExtHostShare:(0,d.$zw)("ExtHostShare"),ExtHostExtensionService:(0,d.$zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,d.$zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,d.$zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,d.$zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,d.$zw)("ExtHostSCM"),ExtHostSearch:(0,d.$zw)("ExtHostSearch"),ExtHostTask:(0,d.$zw)("ExtHostTask"),ExtHostWorkspace:(0,d.$zw)("ExtHostWorkspace"),ExtHostWindow:(0,d.$zw)("ExtHostWindow"),ExtHostWebviews:(0,d.$zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,d.$zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,d.$zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,d.$zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,d.$zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,d.$zw)("ExtHostEditorTabs"),ExtHostProgress:(0,d.$zw)("ExtHostProgress"),ExtHostComments:(0,d.$zw)("ExtHostComments"),ExtHostSecretState:(0,d.$zw)("ExtHostSecretState"),ExtHostStorage:(0,d.$zw)("ExtHostStorage"),ExtHostUrls:(0,d.$zw)("ExtHostUrls"),ExtHostUriOpeners:(0,d.$zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,d.$zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,d.$zw)("ExtHostOutputService"),ExtHostLabelService:(0,d.$zw)("ExtHostLabelService"),ExtHostNotebook:(0,d.$zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,d.$zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,d.$zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,d.$zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,d.$zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,d.$zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,d.$zw)("ExtHostInteractive"),ExtHostInlineChat:(0,d.$zw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,d.$zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,d.$zw)("ExtHostChatVariables"),ExtHostChatProvider:(0,d.$zw)("ExtHostChatProvider"),ExtHostSpeech:(0,d.$zw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,d.$zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,d.$zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,d.$zw)("ExtHostTheming"),ExtHostTunnelService:(0,d.$zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,d.$zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,d.$zw)("ExtHostAuthentication"),ExtHostTimeline:(0,d.$zw)("ExtHostTimeline"),ExtHostTesting:(0,d.$zw)("ExtHostTesting"),ExtHostTelemetry:(0,d.$zw)("ExtHostTelemetry"),ExtHostLocalization:(0,d.$zw)("ExtHostLocalization")}}),define(Se[91],De([1,0,5,11,6,20]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=e.$jlc=void 0,e.$jlc=(0,d.$wi)("IExtHostApiDeprecationService");let N=class{constructor(m,k){this.c=k,this.a=new Set,this.b=m.getProxy(L.$$M.MainThreadTelemetry)}report(m,k,A){const C=this.d(m,k);this.a.has(C)||(this.a.add(C),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:m}))}d(m,k){return`${m}-${k.identifier.value}`}};e.$klc=N,e.$klc=N=Ge([We(0,R.$zP),We(1,O.$3j)],N),e.$llc=Object.freeze(new class{report(p,m,k){}})}),define(Se[316],De([1,0,6]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class O{constructor(R){const N=R.getProxy(d.$$M.MainThreadClipboard);this.value=Object.freeze({readText(){return N.$readText()},writeText(p){return N.$writeText(p)}})}}e.$ylc=O}),define(Se[317],De([1,0,24,6,28,20]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;let N=class{constructor(A,C){this.a=A.getProxy(O.$$M.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,C){const $=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,C,v,arguments)}})}e(A,C,$,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:m(v,this.b)}),this.c&&this.f(A,$,v)}};e.$snc=N,e.$snc=N=Ge([We(0,R.$zP),We(1,L.$PP)],N);const p=1e5;function m(k,A){const C=[];if(k.length)for(let $=0;$<k.length;$++){let v=k[$];if(typeof v>"u")v="undefined";else if(v instanceof Error){const w=v;w.stack?v=w.stack:v=w.toString()}C.push(v)}if(A){const $=new Error().stack;$&&C.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,d.$8n)(C);return $.length>p?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(Se[318],De([1,0,2,6,26]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class R{constructor(p){this.a=p.getProxy(O.$$M.MainThreadDialogs)}showOpenDialog(p,m){return m?.allowUIResources&&(0,L.$PG)(p,"showLocal"),this.a.$showOpenDialog(m).then(k=>k?k.map(A=>d.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(m=>m?d.URI.revive(m):void 0)}}e.$vmc=R}),define(Se[319],De([1,0,3,6]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;class L{constructor(N){this.b=0,this.a=N.getProxy(O.$$M.MainThreadLabelService)}$registerResourceLabelFormatter(N){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,N),(0,d.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Pmc=L}),define(Se[116],De([1,0,12,14,2,5,11,6,28,20]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=e.$dmc=void 0;let A=class{constructor($,v,w){this.f=w,this.d=new Map,this.a=v.getProxy(p.$$M.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===d.$g}getMessage($,v){const{message:w,args:h,comment:f}=v;if(this.c)return(0,O.$9e)(w,h??{});let a=w;f&&f.length>0&&(a+=`/${Array.isArray(f)?f.join(""):f}`);const n=this.d.get($)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,O.$9e)(n??w,h??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let v;const w=await this.g($);if(!w){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(w),f=JSON.parse(h);v=$.isBuiltin?f.contents?.bundle:f}catch(h){this.f.error(`Failed to load translations for ${$.identifier.value} from ${w}: ${h.message}`);return}v&&this.d.set($.identifier.value,{contents:v,uri:w})}async g($){if($.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return L.URI.revive(v)}return $.l10n?L.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$dmc=A,e.$dmc=A=Ge([We(0,m.$PP),We(1,k.$zP),We(2,N.$3j)],A),e.$emc=(0,R.$wi)("IExtHostLocalizationService")}),define(Se[150],De([1,0,11,6,28,20,2,58]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;let m=class extends d.$bk{constructor(C,$){super($.logLevel,$.logsLocation,$.loggers.map(v=>(0,p.$6h)(v))),this.r=C.getProxy(O.$$M.MainThreadLogger)}$setLogLevel(C,$){$?this.setLogLevel(N.URI.revive($),C):this.setLogLevel(C)}setVisibility(C,$){super.setVisibility(C,$),this.r.$setVisibility(C,$)}s(C,$,v){return new k(this.r,C,$,v)}};e.$rnc=m,e.$rnc=m=Ge([We(0,R.$zP),We(1,L.$PP)],m);class k extends d.$9j{constructor(C,$,v,w){super(w?.logLevel==="always"),this.r=C,this.s=$,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger($,w).then(()=>{this.u(this.n),this.m=!0})}g(C,$){const v=[[C,$]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[117],De([1,0,6,5,3,20,21]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=e.$fmc=void 0,e.$fmc=(0,O.$wi)("IExtHostManagedSockets");let p=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(d.$$M.MainThreadManagedSockets)}setFactory(C,$){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(C,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const $=++this.b,v=await this.c.makeConnection(),w=new L.$Tc;return this.d.set($,new k($,v,w)),w.add((0,L.$Sc)(()=>this.d.delete($))),w.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),w.dispose()})),w.add(v.onDidClose(h=>{this.a.$onDidManagedSocketClose($,h?.stack??h?.message),w.dispose()})),w.add(v.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData($,N.$Fe.wrap(h)))),$}$remoteSocketWrite(C,$){this.d.get(C)?.actual.send($.buffer)}$remoteSocketEnd(C){const $=this.d.get(C);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$gmc=p,e.$gmc=p=Ge([We(0,R.$zP)],p);class m{constructor(C,$){this.socketFactoryId=C,this.makeConnection=$}}class k extends L.$Uc{constructor(C,$,v){super(),this.socketId=C,this.actual=$,this.B(v)}}}),define(Se[320],De([1,0,6,11,26]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;function R(p){return p&&p.title}let N=class{constructor(m,k){this.b=k,this.a=m.getProxy(d.$$M.MainThreadMessageService)}showMessage(m,k,A,C,$){const v={source:{identifier:m.identifier,label:m.displayName||m.name}};let w;typeof C=="string"||R(C)?w=[C,...$]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,w=$),v.useCustom&&(0,L.$PG)(m,"resolvers");const h=[];let f=!1;for(let a=0;a<w.length;a++){const n=w[a];if(typeof n=="string")h.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:l}=n;h.push({title:i,isCloseAffordance:!!l,handle:a}),l&&(f?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):f=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,A,v,h).then(a=>{if(typeof a=="number")return w[a]})}};e.$Rmc=N,e.$Rmc=N=Ge([We(1,O.$3j)],N)}),define(Se[321],De([1,0,3,18,2,26,6]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class p{constructor(k){this.b=new Map,this.a=k.getProxy(N.$$M.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,A,C){if((0,R.$PG)(k,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,k.identifier.value),(0,d.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(k,A,C,$){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.saveProfile(A,C,$)}async $readProfile(k,A,C){const $=this.b.get(k);if(!$)throw new Error(`Unknown handler with id: ${k}`);return $.readProfile((0,O.$9f)(A)?A:L.URI.revive(A),C)}}e.$1mc=p}),define(Se[118],De([1,0,6,4,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class R{constructor(p){this.b=new O.$de,this.onDidChangePassword=this.b.event,this.a=p.getProxy(d.$$M.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,m){return this.a.$getPassword(p,m)}store(p,m,k){return this.a.$setPassword(p,m,k)}delete(p,m){return this.a.$deletePassword(p,m)}}e.$amc=R,e.$bmc=(0,L.$wi)("IExtHostSecretState")}),define(Se[322],De([1,0,22,3,6]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=void 0;class R{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.f=new Map,this.b=p.getProxy(L.$$M.MainThreadSpeech)}async $createSpeechToTextSession(p,m,k){const A=this.c.get(p);if(!A)return;const C=new O.$Tc,$=new d.$oe;this.d.set(m,$);const v=C.add(A.provideSpeechToTextSession($.token,k?{language:k}:void 0));C.add(v.onDidChange(w=>{$.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,w)})),C.add($.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createTextToSpeechSession(p,m){const k=this.c.get(p);if(!k)return;const A=new O.$Tc,C=new d.$oe;this.d.set(m,C);const $=A.add(k.provideTextToSpeechSession(C.token));this.f.set(m,$),A.add($.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,v)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $synthesizeSpeech(p,m){const k=this.f.get(p);k&&k.synthesize(m)}async $cancelTextToSpeechSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p),this.f.delete(p)}async $createKeywordRecognitionSession(p,m){const k=this.c.get(p);if(!k)return;const A=new O.$Tc,C=new d.$oe;this.d.set(m,C);const $=A.add(k.provideKeywordRecognitionSession(C.token));A.add($.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,v)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,m,k){const A=R.a++;return this.c.set(A,k),this.b.$registerProvider(A,m,{extension:p,displayName:p.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$8mc=R}),define(Se[119],De([1,0,6,4,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;class R{constructor(p,m){this.c=m,this.b=new O.$de,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(d.$$M.MainThreadStorage)}registerExtensionStorageKeysToSync(p,m){this.a.$registerExtensionStorageKeysToSync(p,m)}async initializeExtensionStorage(p,m,k){const A=await this.a.$initializeExtensionStorage(p,m);let C;return A&&(C=this.d(p,m,A)),C||k}setValue(p,m,k){return this.a.$setValue(p,m,k)}$acceptValue(p,m,k){const A=this.d(p,m,k);A&&this.b.fire({shared:p,key:m,value:A})}d(p,m,k){try{return JSON.parse(k)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${p}): ${A}`)}}}e.$3lc=R,e.$4lc=(0,L.$wi)("IExtHostStorage")}),define(Se[323],De([1,0,3,15,2,6]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class N{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(R.$$M.MainThreadUriOpeners)}registerExternalUriOpener(m,k,A,C){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const $=C.schemes.find(v=>!N.a.has(v));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(k,A),this.b.$registerUriOpener(k,C.schemes,m,C.label),(0,d.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(m,k,A){const C=this.c.get(m);if(!C)throw new Error(`Unknown opener with id: ${m}`);const $=L.URI.revive(k);return C.canOpenExternalUri($,A)}async $openUri(m,k,A){const C=this.c.get(m);if(!C)throw new Error(`Unknown opener id: '${m}'`);return C.openExternalUri(L.URI.revive(k.resolvedUri),{sourceUri:L.URI.revive(k.sourceUri)},A)}}e.$lnc=N}),define(Se[324],De([1,0,6,2,3,13,25]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class p{static{this.a=0}constructor(k){this.c=new N.$Sm,this.d=new Map,this.b=k.getProxy(d.$$M.MainThreadUrls)}registerUriHandler(k,A){const C=k.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const $=p.a++;return this.c.add(C),this.d.set($,A),this.b.$registerUriHandler($,C,k.displayName||k.name),(0,L.$Sc)(()=>{this.c.delete(C),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(k,A){const C=this.d.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(O.URI.revive(A))}catch($){(0,R.$1)($)}return Promise.resolve(void 0)}async createAppUri(k){return O.URI.revive(await this.b.$createAppUri(k))}}e.$mnc=p}),define(Se[92],De([1,0,4,3,15,24,2,252,290,114,6]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Nlc=void 0,e.$Olc=$,e.$Qlc=h,e.$Rlc=f;class C{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(l,o,t,u,r,c,s){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new d.$de,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new d.$de,this._onDidDispose=this.#h.event,this.#e=l,this.#t=o,this.#o=t,this.#i=u,this.#s=r,this.#r=c,this.#l=$(c),this.#d=v(c),this.#n=s}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return this.#u=!0,(0,k.$NAb)(l,this.#i)}get cspSource(){const l=this.#r.extensionLocation;if(l.scheme===L.Schemas.https||l.scheme===L.Schemas.http){let o=l.toString();return o.endsWith("/")||(o+="/"),o+" "+k.$MAb}return k.$MAb}get html(){return this.a(),this.#a}set html(l){this.a(),this.#a!==l&&(this.#a=l,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(l)))}get options(){return this.a(),this.#o}set options(l){this.a(),R.$7n(this.#o,l)||this.#t.$setOptions(this.#e,f(this.#r,this.#s,l)),this.#o=l}async postMessage(l){if(this.#c)return!1;const o=(0,m.$Erb)(l,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(l){if(!this.#d)return l;const o=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return l.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,r,c,s,y,b)=>{const S=N.URI.from({scheme:s||"file",path:decodeURIComponent(y)}),g=(0,k.$NAb)(S,{isRemote:o,authority:t}).toString();return`${r}${g}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,r,c,s,y,b)=>{const S=N.URI.from({scheme:s||"file",path:decodeURIComponent(y)}),g=(0,k.$NAb)(S,{isRemote:o,authority:t}).toString();return`${r}${g}${b}`})}}e.$Nlc=C;function $(i){try{const l=(0,p.$Ip)((0,p.$Hp)(i.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}function v(i){try{const l=(0,p.$Ip)((0,p.$Hp)(i.engines.vscode));return l?l.majorBase<1||l.majorBase===1&&l.minorBase<60:!1}catch{return!1}}class w extends O.$Uc{constructor(l,o,t,u,r){super(),this.c=o,this.f=t,this.g=u,this.h=r,this.b=new Map,this.a=l.getProxy(A.$$M.MainThreadWebviews)}dispose(){super.dispose();for(const l of this.b.values())l.dispose();this.b.clear()}$onMessage(l,o,t){const u=this.j(l);if(u){const{message:r}=(0,m.$Frb)(o,t.value);u._onMessageEmitter.fire(r)}}$onMissingCsp(l,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,o,t){const u=new C(l,this.a,a(o),this.c,this.f,t,this.h);this.b.set(l,u);const r=u._onDidDispose(()=>{r.dispose(),this.deleteWebview(l)});return u}deleteWebview(l){this.b.delete(l)}j(l){return this.b.get(l)}}e.$Plc=w;function h(i){return{id:i.identifier,location:i.extensionLocation}}function f(i,l,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||n(i,l)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(l=>N.URI.from(l))}}function n(i,l){return[...(l?.getWorkspaceFolders()||[]).map(o=>o.uri),i.extensionLocation]}}),define(Se[151],De([1,0,4,15,14,2,5,20,6]),function(he,e,d,O,L,R,N,p,m){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=e.$onc=void 0;let A=class{static{k=this}static{this.a={focused:!0,active:!0}}getState(){const $=this.d;return{get focused(){return $.focused},get active(){return $.active}}}constructor($){this.c=new d.$de,this.onDidChangeWindowState=this.c.event,this.d=k.a,this.b=$.getProxy(m.$$M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:w})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,v){v!==this.d[$]&&(this.d={...this.d,[$]:v},this.c.fire(this.d))}openUri($,v){let w;if(typeof $=="string"){w=$;try{$=R.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,L.$7e)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,w,v)}async asExternalUri($,v){if((0,L.$7e)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri($,v);return R.URI.from(w)}};e.$onc=A,e.$onc=A=k=Ge([We(0,p.$zP)],A),e.$pnc=(0,N.$wi)("IExtHostWindow")}),define(Se[325],De([1,0,317,28,20]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;const R=1024*1024;let N=class extends d.$snc{constructor(m,k){super(m,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(m,k,A){const C=m==="error"||m==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),k.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(m,k){const A=process[m],C=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(v,w,h)=>{if(!this.g){$+=v.toString(w);const f=$.length>R?$.length:$.lastIndexOf(`
`);f!==-1&&(console[k]($.slice(0,f)),$=$.slice(f+1))}C.call(A,v,w,h)}})}};e.$4nc=N,e.$4nc=N=Ge([We(0,L.$zP),We(1,O.$PP)],N)}),define(Se[326],De([1,0,150,15,267,30]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0;class N extends d.$rnc{s(m,k,A){return m.scheme===O.Schemas.file?new L.$OQ(A?.name||(0,R.$Sg)(),m.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,k):super.s(m,k,A)}registerLogger(m){super.registerLogger(m),this.r.$registerLogger(m)}deregisterLogger(m){super.deregisterLogger(m),this.r.$deregisterLogger(m)}}e.$doc=N}),define(Se[327],De([1,0,7,21,22,13,4,3,134,315,48]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$1_b=f,e.$2_b=a;function $(D,P){try{return JSON.stringify(D,P)}catch{return"null"}}const v="$$ref$$",w={[v]:-1};class h{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function f(D,P=null,I=!1){const F=[];return{jsonString:(I?$:JSON.stringify)(D,(z,M)=>{if(typeof M>"u")return w;if(typeof M=="object"){if(M instanceof O.$Fe){const j=F.push(M)-1;return{[v]:j}}if(P)return P(z,M)}return M}),referencedBuffers:F}}function a(D,P,I){return JSON.parse(D,(F,T)=>{if(T){const z=T[v];if(typeof z=="number")return P[z];if(I&&T.$mid===1)return I.transformIncoming(T)}return T})}function n(D,P){return JSON.stringify(D,P)}function i(D){return D?(P,I)=>I&&I.$mid===1?D.transformOutgoing(I):I:null}var l;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(l||(e.RequestInitiator=l={}));var o;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends p.$Uc{static{C=u}static{this.a=3*1e3}constructor(P,I=null,F=null){super(),this[C]=!0,this.b=this.B(new N.$de),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,z=A.$yw.count;T<z;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new d.$Ih(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,m.$Bn)(P,this.g):P}getProxy(P){const{nid:I,sid:F}=P;return this.s[I]||(this.s[I]=this.J(I,F)),this.s[I]}J(P,I){const F={get:(T,z)=>(typeof z=="string"&&!T[z]&&z.charCodeAt(0)===36&&(T[z]=(...M)=>this.U(P,z,M)),z===r?I:T[z])};return new Proxy(Object.create(null),F)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,F=P.length;I<F;I++){const T=P[I];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,F=y.read(P,0),T=F.readUInt8(),z=F.readUInt32();switch(T){case 1:case 2:{let{rpcId:M,method:j,args:U}=S.deserializeRequestJSONArgs(F);this.g&&(U=(0,m.$Bn)(U,this.g)),this.M(I,z,M,j,U,T===2);break}case 3:case 4:{let{rpcId:M,method:j,args:U}=S.deserializeRequestMixedArgs(F);this.g&&(U=(0,m.$Bn)(U,this.g)),this.M(I,z,M,j,U,T===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let M=S.deserializeReplyOKJSON(F);this.g&&(M=(0,m.$Bn)(M,this.g)),this.O(I,z,M);break}case 10:{const M=S.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(I,z,M);break}case 8:{const M=S.deserializeReplyOKVSBuffer(F);this.O(I,z,M);break}case 11:{let M=S.deserializeReplyErrError(F);this.g&&(M=(0,m.$Bn)(M,this.g)),this.P(I,z,M);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,F,T,z,M){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,A.$Aw)(F)}.${T}(`,z);const j=String(I);let U,Z;if(M){const Q=new L.$oe;z.push(Q.token),U=this.Q(F,T,z),Z=()=>Q.cancel()}else U=this.Q(F,T,z),Z=t;this.u[j]=Z;const ie=S.serializeAcknowledged(I);this.f?.logOutgoing(ie.byteLength,I,1,"ack"),this.c.send(ie),U.then(Q=>{delete this.u[j];const G=S.serializeReplyOK(I,Q,this.h);this.f?.logOutgoing(G.byteLength,I,1,"reply:",Q),this.c.send(G)},Q=>{delete this.u[j];const G=S.serializeReplyErr(I,Q);this.f?.logOutgoing(G.byteLength,I,1,"replyErr:",Q),this.c.send(G)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const F=String(I);this.u[F]?.()}O(P,I,F){this.f?.logIncoming(P,I,0,"receiveReply:",F);const T=String(I);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T],z.resolveOk(F)}P(P,I,F){this.f?.logIncoming(P,I,0,"receiveReplyErr:",F);const T=String(I);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T];let M;F&&(F.$isError?(M=new Error,M.name=F.name,M.message=F.message,M.stack=F.stack):M=F),z.resolveErr(M)}Q(P,I,F){try{return Promise.resolve(this.S(P,I,F))}catch(T){return Promise.reject(T)}}S(P,I,F){const T=this.m[P];if(!T)throw new Error("Unknown actor "+(0,A.$Aw)(P));const z=T[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$Aw)(P));return z.apply(T,F)}U(P,I,F){if(this.j)return new k.$Z_b;let T=null;if(F.length>0&&L.CancellationToken.isCancellationToken(F[F.length-1])&&(T=F.pop()),T&&T.isCancellationRequested)return Promise.reject(R.$6());const z=S.serializeRequestArguments(F,this.h),M=++this.t,j=String(M),U=new k.$Y_b,Z=new p.$Tc;T&&Z.add(T.onCancellationRequested(()=>{const Q=S.serializeCancel(M);this.f?.logOutgoing(Q.byteLength,M,0,"cancel"),this.c.send(S.serializeCancel(M))})),this.w[j]=new s(U,Z),this.F(M);const ie=S.serializeRequest(M,P,I,z,!!T);return this.f?.logOutgoing(ie.byteLength,M,0,`request: ${(0,A.$Aw)(P)}.${I}(`,F),this.c.send(ie),U}}e.$3_b=c;class s{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class y{static alloc(P,I,F){const T=new y(O.$Fe.alloc(F+1+4),0);return T.writeUInt8(P),T.writeUInt32(I),T}static read(P,I){return new y(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let F=0,T=P.length;F<T;F++){const z=P[F];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let M=0;M<z.buffers.length;++M)I+=this.sizeVSBuffer(z.buffers[M]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,F=P.length;I<F;I++){const T=P[I];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let z=0;z<T.buffers.length;++z)this.writeBuffer(T.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:I[F]=this.readLongString();break;case 2:I[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),M=this.readLongString(),j=[];for(let U=0;U<z;++U)j.push(this.readVSBuffer());I[F]=new A.$Bw(a(M,j,null));break}case 4:I[F]=void 0;break}return I}}var b;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(b||(b={}));class S{static a(P){for(let I=0,F=P.length;I<F;I++)if(P[I]instanceof O.$Fe||P[I]instanceof A.$Bw||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const F=[];for(let T=0,z=P.length;T<z;T++){const M=P[T];if(M instanceof O.$Fe)F[T]={type:2,value:M};else if(typeof M>"u")F[T]={type:4};else if(M instanceof A.$Bw){const{jsonString:j,referencedBuffers:U}=f(M.value,I);F[T]={type:3,value:O.$Fe.fromString(j),buffers:U}}else F[T]={type:1,value:O.$Fe.fromString(n(M,I))}}return{type:1,args:F}}return{type:0,args:n(P,I)}}static serializeRequest(P,I,F,T,z){switch(T.type){case 0:return this.b(P,I,F,T.args,z);case 1:return this.c(P,I,F,T.args,z)}}static b(P,I,F,T,z){const M=O.$Fe.fromString(F),j=O.$Fe.fromString(T);let U=0;U+=y.sizeUInt8(),U+=y.sizeShortString(M),U+=y.sizeLongString(j);const Z=y.alloc(z?2:1,P,U);return Z.writeUInt8(I),Z.writeShortString(M),Z.writeLongString(j),Z.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),F=P.readShortString(),T=P.readLongString();return{rpcId:I,method:F,args:JSON.parse(T)}}static c(P,I,F,T,z){const M=O.$Fe.fromString(F);let j=0;j+=y.sizeUInt8(),j+=y.sizeShortString(M),j+=y.sizeMixedArray(T);const U=y.alloc(z?4:3,P,j);return U.writeUInt8(I),U.writeShortString(M),U.writeMixedArray(T),U.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),F=P.readShortString(),T=P.readMixedArray(),z=new Array(T.length);for(let M=0,j=T.length;M<j;M++){const U=T[M];typeof U=="string"?z[M]=JSON.parse(U):z[M]=U}return{rpcId:I,method:F,args:z}}static serializeAcknowledged(P){return y.alloc(5,P,0).buffer}static serializeCancel(P){return y.alloc(6,P,0).buffer}static serializeReplyOK(P,I,F){if(typeof I>"u")return this.d(P);if(I instanceof O.$Fe)return this.e(P,I);if(I instanceof A.$Bw){const{jsonString:T,referencedBuffers:z}=f(I.value,F,!0);return this.g(P,T,z)}else return this.f(P,$(I,F))}static d(P){return y.alloc(7,P,0).buffer}static e(P,I){let F=0;F+=y.sizeVSBuffer(I);const T=y.alloc(8,P,F);return T.writeVSBuffer(I),T.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const F=O.$Fe.fromString(I);let T=0;T+=y.sizeLongString(F);const z=y.alloc(9,P,T);return z.writeLongString(F),z.buffer}static g(P,I,F){const T=O.$Fe.fromString(I);let z=0;z+=y.sizeUInt32,z+=y.sizeLongString(T);for(const j of F)z+=y.sizeVSBuffer(j);const M=y.alloc(10,P,z);M.writeUInt32(F.length),M.writeLongString(T);for(const j of F)M.writeBuffer(j);return M.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const F=P.readUInt32(),T=P.readLongString(),z=[];for(let M=0;M<F;++M)z.push(P.readVSBuffer());return new A.$Bw(a(T,z,I))}static serializeReplyErr(P,I){const F=I?$(R.$3(I),null):void 0;if(typeof F!="string")return this.h(P);const T=O.$Fe.fromString(F);let z=0;z+=y.sizeLongString(T);const M=y.alloc(11,P,z);return M.writeLongString(T),M.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return y.alloc(12,P,0).buffer}}var g;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var E;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(E||(E={}))}),define(Se[328],De([1,0,21,27,15,85,5]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=void 0,e.$MK=A,e.$NK=C,e.$LK=(0,N.$wi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${p.join("")}]+`),k=7;function A(v){if(v.scheme!==L.Schemas.vscodeNotebookCell)return;const w=v.fragment.indexOf("s");if(w<0)return;const h=parseInt(v.fragment.substring(0,w).replace(m,""),k),f=(0,d.$Ye)(v.fragment.substring(w+1)).toString();if(!isNaN(h))return{handle:h,notebook:v.with({scheme:f,fragment:null})}}function C(v,w){const h=w.toString(k),a=`${h.length<p.length?p[h.length-1]:"z"}${h}s${(0,d.$Ze)(d.$Fe.fromString(v.scheme),!0,!0)}`;return v.with({scheme:L.Schemas.vscodeNotebookCell,fragment:a})}class ${constructor(){this.a=new O.$Ac}getNotebook(w){if(w.scheme===L.Schemas.vscodeNotebookCell){const h=A(w);if(h){const f=this.a.get(h.notebook);if(f)return f}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$OK=$,(0,R.$xs)(e.$LK,$,1)}),define(Se[120],De([1,0,21,35,39,101,15,17,12,38,328]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$6K=e.CellStatusbarAlignment=e.$5K=e.NotebookEditorPriority=e.$2K=e.$1K=e.$YK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$XK=e.$WK=e.$VK=e.$UK=e.CellKind=e.$TK=e.$SK=e.$RK=void 0,e.$ZK=u,e.$3K=c,e.$4K=s,e.$7K=S,e.$8K=E,e.$RK="workbench.editor.notebook",e.$SK="workbench.editor.notebookTextDiffEditor",e.$TK="workbench.editor.interactive";var C;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(C||(e.CellKind=C={})),e.$UK=["application/json","application/javascript","text/html","image/svg+xml",R.$Qs.latex,R.$Qs.markdown,"image/png","image/jpeg",R.$Qs.text],e.$VK=[R.$Qs.latex,R.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Qs.text],e.$WK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$XK="_notAvailable";var $;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var w;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var h;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var f;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var a;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var l;(function(U){U.scheme=N.Schemas.vscodeNotebookCell;function Z(be,ae){return(0,A.$NK)(be,ae)}U.generate=Z;function ie(be){return(0,A.$MK)(be)}U.parse=ie;function Q(be,ae){return be.with({scheme:N.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${be.scheme!==N.Schemas.file?be.scheme:""}`})}U.generateCellOutputUri=Q;function G(be){if(be.scheme!==N.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!ae)return;const Ce=ae[1]&&ae[1]!==""?ae[1]:void 0,ee=ae[2];return{outputId:Ce,notebook:be.with({scheme:ee||N.Schemas.file,fragment:null})}}U.parseCellOutputUri=G;function x(be,ae,Ce){return U.generate(be,ae).with({scheme:Ce})}U.generateCellPropertyUri=x;function ne(be,ae){if(be.scheme===ae)return U.parse(be.with({scheme:U.scheme}))}U.parseCellPropertyUri=ne})(l||(e.CellUri=l={}));const o=U=>m.$i?U.replace(/\//g,"\\"):U;class t{constructor(Z=[],ie=e.$UK){this.e=ie,this.d=[...new Set(Z)].map(Q=>({pattern:Q,matches:O.$qk(o(Q))}))}sort(Z){const ie=new Map(L.Iterable.map(Z,G=>[G,o(G)]));let Q=[];for(const{matches:G}of this.d)for(const[x,ne]of ie)if(G(ne)){Q.push(x),ie.delete(x);break}return ie.size&&(Q=Q.concat([...ie.keys()].sort((G,x)=>this.e.indexOf(G)-this.e.indexOf(x)))),Q}prioritize(Z,ie){const Q=this.f(Z);if(Q===-1){this.d.unshift({pattern:Z,matches:O.$qk(o(Z))});return}const G=new Set(ie.map(ne=>this.f(ne,Q)));G.delete(-1);const x=Array.from(G).sort();this.d.splice(Q+1,0,...x.map(ne=>this.d[ne]));for(let ne=x.length-1;ne>=0;ne--)this.d.splice(x[ne],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,ie=this.d.length){const Q=o(Z);for(let G=0;G<ie;G++)if(this.d[G].matches(Q))return G;return-1}}e.$YK=t;function u(U,Z,ie,Q=(G,x)=>G===x){const G=[];function x(ae,Ce,ee){if(Ce===0&&ee.length===0)return;const B=G[G.length-1];B&&B.start+B.deleteCount===ae?(B.deleteCount+=Ce,B.toInsert.push(...ee)):G.push({start:ae,deleteCount:Ce,toInsert:ee})}let ne=0,be=0;for(;;){if(ne===U.length){x(ne,0,Z.slice(be));break}if(be===Z.length){x(ne,U.length-ne,[]);break}const ae=U[ne],Ce=Z[be];if(Q(ae,Ce)){ne+=1,be+=1;continue}ie(Ce)?(x(ne,1,[]),ne+=1):(x(ne,0,[Ce]),be+=1)}return G}e.$1K=new k.$Nj("notebookEditorCursorAtBoundary","none"),e.$2K=new k.$Nj("notebookEditorCursorAtLineBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r||(e.NotebookEditorPriority=r={}));function c(U){const Z=U;return!!((typeof Z.include=="string"||O.$rk(Z.include))&&(typeof Z.exclude=="string"||O.$rk(Z.exclude)))}function s(U,Z,ie){if(Array.isArray(U.viewType)&&U.viewType.indexOf(Z)>=0||U.viewType===Z)return!0;if(U.filenamePattern){const Q=c(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,G=c(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(O.$pk(Q,(0,p.$nc)(ie.fsPath).toLowerCase()))return!(G&&O.$pk(G,(0,p.$nc)(ie.fsPath).toLowerCase()))}return!1}e.$5K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class b{static{this.d="notebook/"}static create(Z){return`${b.d}${Z}`}static parse(Z){if(Z.startsWith(b.d))return Z.substring(b.d.length)}}e.$6K=b;function S(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}const g=new TextDecoder;function E(U){const Z=[];let ie=!1;for(const ne of U)(Z.length===0||ie)&&(Z.push(ne),ie=!0);let Q=I(Z);const G=d.$Fe.concat(Z.map(ne=>d.$Fe.wrap(ne))),x=j(G);return Q=Q||x.byteLength!==G.byteLength,{data:x,didCompression:Q}}e.$9K="\x1B[A";const D=e.$9K.split("").map(U=>U.charCodeAt(0)),P=10;function I(U){let Z=!1;return U.forEach((ie,Q)=>{if(Q===0||ie.length<e.$9K.length)return;const G=U[Q-1],x=ie.subarray(0,e.$9K.length);if(x[0]===D[0]&&x[1]===D[1]&&x[2]===D[2]){const ne=G.lastIndexOf(P);if(ne===-1)return;Z=!0,U[Q-1]=G.subarray(0,ne),U[Q]=ie.subarray(e.$9K.length)}}),Z}function F(U){let Z=U;do U=Z,Z=U.replace(/[^\n]\x08/gm,"");while(Z.length<U.length);return U}function T(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const Z=U.match(/^(.*)\r+/m)[1];let ie=U.match(/\r+(.*)$/m)[1];ie=ie+Z.slice(ie.length,Z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ie)}return U}const z=8,M=13;function j(U){return!U.buffer.includes(z)&&!U.buffer.includes(M)?U:d.$Fe.fromString(T(F(g.decode(U.buffer))))}}),define(Se[8],De([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w){"use strict";var h,f,a,n,i,l,o,t,u,r,c,s,y,b,S,g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$nP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$mP=e.$lP=e.$kP=e.$jP=e.ChatLocation=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$9O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$VO=e.$UO=e.$TO=e.$SO=e.$QO=e.$PO=e.$OO=e.$NO=e.TestRunProfileKind=e.TestResultState=e.$MO=e.$LO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$KO=e.NotebookVariablesRequestKind=e.$JO=e.$IO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$HO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.ColorThemeKind=e.$BO=e.$AO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$zO=e.$yO=e.DebugConsoleMode=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$sO=e.$rO=e.FileChangeType=e.$qO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$pO=e.$oO=e.$nO=e.$mO=e.InlineCompletionTriggerKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$_N=e.ConfigurationTarget=e.$$N=e.$0N=e.$9N=e.$8N=e.DocumentPasteTriggerKind=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1N=e.ViewBadge=e.ProgressLocation=e.$ZN=e.$YN=e.TaskScope=e.ShellQuoting=e.$XN=e.$WN=e.$VN=e.TaskPanelKind=e.TaskRevealKind=e.$UN=e.TerminalLocation=e.$TN=e.$SN=e.$RN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QN=e.$PN=e.$ON=e.$NN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$LN=e.$KN=e.$JN=e.$IN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HN=e.$GN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.LanguageStatusSeverity=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.CodeActionTriggerKind=e.$uN=e.$tN=e.SymbolTag=e.SymbolKind=e.$sN=e.$rN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.DiagnosticSeverity=e.DiagnosticTag=e.$lN=e.$kN=e.FileEditType=e.$jN=e.$iN=e.$hN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$MN=Dt,e.$aO=Y,e.$RO=vi;function D(H){return Object.assign(H,{apply:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const Me=me.length===1?[]:me[1];return Reflect.construct(H,Me,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const[Me,...Xe]=me;return Reflect.construct(H,Xe,Me.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let F=h=class{static from(...q){let me=q;return new h(function(){if(me){for(const Me of me)Me&&typeof Me.dispose=="function"&&Me.dispose();me=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$aN=F,e.$aN=F=h=Ge([D],F);let T=f=class{static Min(...q){if(q.length===0)throw new TypeError;let me=q[0];for(let Me=1;Me<q.length;Me++){const Xe=q[Me];Xe.isBefore(me)&&(me=Xe)}return me}static Max(...q){if(q.length===0)throw new TypeError;let me=q[0];for(let Me=1;Me<q.length;Me++){const Xe=q[Me];Xe.isAfter(me)&&(me=Xe)}return me}static isPosition(q){if(!q)return!1;if(q instanceof f)return!0;const{line:me,character:Me}=q;return typeof me=="number"&&typeof Me=="number"}static of(q){if(q instanceof f)return q;if(this.isPosition(q))return new f(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,me){if(q<0)throw(0,O.$7)("line must be non-negative");if(me<0)throw(0,O.$7)("character must be non-negative");this.c=q,this.e=me}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,me=0){if(q===null||me===null)throw(0,O.$7)();let Me;return typeof q>"u"?Me=0:typeof q=="number"?Me=q:(Me=typeof q.lineDelta=="number"?q.lineDelta:0,me=typeof q.characterDelta=="number"?q.characterDelta:0),Me===0&&me===0?this:new f(this.line+Me,this.character+me)}with(q,me=this.character){if(q===null||me===null)throw(0,O.$7)();let Me;return typeof q>"u"?Me=this.line:typeof q=="number"?Me=q:(Me=typeof q.line=="number"?q.line:this.line,me=typeof q.character=="number"?q.character:this.character),Me===this.line&&me===this.character?this:new f(Me,me)}toJSON(){return{line:this.line,character:this.character}}};e.$bN=T,e.$bN=T=f=Ge([D],T);let z=a=class{static isRange(q){return q instanceof a?!0:q?T.isPosition(q.start)&&T.isPosition(q.end):!1}static of(q){if(q instanceof a)return q;if(this.isRange(q))return new a(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,me,Me,Xe){let et,dt;if(typeof q=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Xe=="number"?(et=new T(q,me),dt=new T(Me,Xe)):T.isPosition(q)&&T.isPosition(me)&&(et=T.of(q),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this.c=et,this.e=dt):(this.c=dt,this.e=et)}contains(q){return a.isRange(q)?this.contains(q.start)&&this.contains(q.end):T.isPosition(q)?!(T.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const me=T.Max(q.start,this.c),Me=T.Min(q.end,this.e);if(!me.isAfter(Me))return new a(me,Me)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const me=T.Min(q.start,this.c),Me=T.Max(q.end,this.end);return new a(me,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,me=this.end){if(q===null||me===null)throw(0,O.$7)();let Me;return q?T.isPosition(q)?Me=q:(Me=q.start||this.start,me=q.end||this.end):Me=this.start,Me.isEqual(this.c)&&me.isEqual(this.end)?this:new a(Me,me)}toJSON(){return[this.start,this.end]}};e.$cN=z,e.$cN=z=a=Ge([D],z);let M=n=class extends z{static isSelection(q){return q instanceof n?!0:q?z.isRange(q)&&T.isPosition(q.anchor)&&T.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,me,Me,Xe){let et,dt;if(typeof q=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Xe=="number"?(et=new T(q,me),dt=new T(Me,Xe)):T.isPosition(q)&&T.isPosition(me)&&(et=T.of(q),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this.f=et,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$dN=M,e.$dN=M=n=Ge([D],M);const j=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,O.$7)("connectionToken")};class U{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,me,Me){if(typeof q!="string"||q.length===0)throw(0,O.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,O.$7)("port");typeof Me<"u"&&j(Me),this.host=q,this.port=Math.round(me),this.connectionToken=Me}}e.$eN=U;class Z{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,me){this.makeConnection=q,this.connectionToken=me,typeof me<"u"&&j(me)}}e.$fN=Z;class ie extends Error{static NotAvailable(q,me){return new ie(q,v.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(q){return new ie(q,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,me=v.RemoteAuthorityResolverErrorCode.Unknown,Me){super(q),this._message=q,this._code=me,this._detail=Me,Object.setPrototypeOf(this,ie.prototype)}}e.$gN=ie;var Q;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var G;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let x=i=class{static isTextEdit(q){return q instanceof i?!0:q?z.isRange(q)&&typeof q.newText=="string":!1}static replace(q,me){return new i(q,me)}static insert(q,me){return i.replace(new z(q,q),me)}static delete(q){return i.replace(q,"")}static setEndOfLine(q){const me=new i(new z(new T(0,0),new T(0,0)),"");return me.newEol=q,me}get range(){return this.c}set range(q){if(q&&!z.isRange(q))throw(0,O.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,O.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,O.$7)("newEol");this.f=q}constructor(q,me){this.c=q,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$hN=x,e.$hN=x=i=Ge([D],x);let ne=l=class{static isNotebookCellEdit(q){return q instanceof l?!0:q?$n.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,me){return new l(q,me)}static insertCells(q,me){return new l(new $n(q,q),me)}static deleteCells(q){return new l(q,[])}static updateCellMetadata(q,me){const Me=new l(new $n(q,q),[]);return Me.newCellMetadata=me,Me}static updateNotebookMetadata(q){const me=new l(new $n(0,0),[]);return me.newNotebookMetadata=q,me}constructor(q,me){this.range=q,this.newCells=me}};e.$iN=ne,e.$iN=ne=l=Ge([D],ne);class be{static isSnippetTextEdit(q){return q instanceof be?!0:q?z.isRange(q.range)&&ee.isSnippetString(q.snippet):!1}static replace(q,me){return new be(q,me)}static insert(q,me){return be.replace(new z(q,q),me)}constructor(q,me){this.range=q,this.snippet=me}}e.$jN=be;var ae;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,me,Me,Xe){this.c.push({_type:1,from:q,to:me,options:Me,metadata:Xe})}createFile(q,me,Me){this.c.push({_type:1,from:void 0,to:q,options:me,metadata:Me})}deleteFile(q,me,Me){this.c.push({_type:1,from:q,to:void 0,options:me,metadata:Me})}e(q,me,Me){this.c.push({_type:3,metadata:Me,uri:q,edit:{editType:5,metadata:me},notebookMetadata:me})}f(q,me,Me,Xe){const et=me.start,dt=me.end;(et!==dt||Me.length>0)&&this.c.push({_type:5,uri:q,index:et,count:dt-et,cells:Me,metadata:Xe})}g(q,me,Me,Xe){this.c.push({_type:3,metadata:Xe,uri:q,edit:{editType:3,index:me,metadata:Me}})}replace(q,me,Me,Xe){this.c.push({_type:2,uri:q,edit:new x(me,Me),metadata:Xe})}insert(q,me,Me,Xe){this.replace(q,new z(me,me),Me,Xe)}delete(q,me,Me){this.replace(q,me,"",Me)}has(q){return this.c.some(me=>me._type===2&&me.uri.toString()===q.toString())}set(q,me){if(me)for(const Me of me){if(!Me)continue;let Xe,et;Array.isArray(Me)?(Xe=Me[0],et=Me[1]):Xe=Me,ne.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(q,Xe.range.start,Xe.newCellMetadata,et):Xe.newNotebookMetadata?this.e(q,Xe.newNotebookMetadata,et):this.f(q,Xe.range,Xe.newCells,et):be.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:q,range:Xe.range,edit:Xe.snippet,metadata:et}):this.c.push({_type:2,uri:q,edit:Xe,metadata:et})}else{for(let Me=0;Me<this.c.length;Me++){const Xe=this.c[Me];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===q.toString()&&(this.c[Me]=void 0);break}}(0,d.$Ib)(this.c)}}get(q){const me=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===q.toString()&&me.push(Me.edit);return me}entries(){const q=new R.$Ac;for(const me of this.c)if(me._type===2){let Me=q.get(me.uri);Me||(Me=[me.uri,[]],q.set(me.uri,Me)),Me[1].push(me.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$kN=Ce,e.$kN=Ce=Ge([D],Ce);let ee=o=class{static isSnippetString(q){return q instanceof o?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=o.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,me=this.e++){if(typeof q=="function"){const Me=new o;Me.e=this.e,q(Me),this.e=Me.e,q=Me.value}else q=o.c(q);return this.value+="${",this.value+=me,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,me=this.e++){const Me=q.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(q,me){if(typeof me=="function"){const Me=new o;Me.e=this.e,me(Me),this.e=Me.e,me=Me.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$lN=ee,e.$lN=ee=o=Ge([D],ee);var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var _;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let pe=t=class{static isLocation(q){return q instanceof t?!0:q?z.isRange(q.range)&&k.URI.isUri(q.uri):!1}constructor(q,me){if(this.uri=q,me)if(z.isRange(me))this.range=z.of(me);else if(T.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$mN=pe,e.$mN=pe=t=Ge([D],pe);let ue=class{static is(q){return q?typeof q.message=="string"&&q.location&&z.isRange(q.location.range)&&k.URI.isUri(q.location.uri):!1}constructor(q,me){this.location=q,this.message=me}static isEqual(q,me){return q===me?!0:!q||!me?!1:q.message===me.message&&q.location.range.isEqual(me.location.range)&&q.location.uri.toString()===me.location.uri.toString()}};e.$nN=ue,e.$nN=ue=Ge([D],ue);let ce=class{constructor(q,me,Me=_.Error){if(!z.isRange(q))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=q,this.message=me,this.severity=Me}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,me){return q===me?!0:!q||!me?!1:q.message===me.message&&q.severity===me.severity&&q.code===me.code&&q.severity===me.severity&&q.source===me.source&&q.range.isEqual(me.range)&&(0,d.$ub)(q.tags,me.tags)&&(0,d.$ub)(q.relatedInformation,me.relatedInformation,ue.isEqual)}};e.$oN=ce,e.$oN=ce=Ge([D],ce);let oe=class{constructor(q,me){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=me}};e.$pN=oe,e.$pN=oe=Ge([D],oe);let le=class extends oe{constructor(q,me,Me,Xe){super(q,me),this.canIncreaseHover=Me,this.canDecreaseHover=Xe}};e.$qN=le,e.$qN=le=Ge([D],le);var J;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(J||(e.HoverVerbosityAction=J={}));var se;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let $e=class{constructor(q,me=se.Text){this.range=q,this.kind=me}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$rN=$e,e.$rN=$e=Ge([D],$e);let ve=class{constructor(q,me){this.uri=q,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$sN=ve,e.$sN=ve=Ge([D],ve);var Re;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var ge;(function(H){H[H.Deprecated=1]="Deprecated"})(ge||(e.SymbolTag=ge={}));let Ie=u=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,me,Me,Xe,et){this.name=q,this.kind=me,this.containerName=et,typeof Me=="string"&&(this.containerName=Me),Xe instanceof pe?this.location=Xe:Me instanceof z&&(this.location=new pe(Xe,Me)),u.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.$tN=Ie,e.$tN=Ie=u=Ge([D],Ie);let Ae=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(r.validate)}constructor(q,me,Me,Xe,et){this.name=q,this.detail=me,this.kind=Me,this.range=Xe,this.selectionRange=et,this.children=[],r.validate(this)}};e.$uN=Ae,e.$uN=Ae=r=Ge([D],Ae);var ze;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let V=class{constructor(q,me){this.title=q,this.kind=me}};e.$vN=V,e.$vN=V=Ge([D],V);let W=class{static{c=this}static{this.c="."}constructor(q){this.value=q}append(q){return new c(this.value?this.value+c.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+c.c)}};e.$wN=W,e.$wN=W=c=Ge([D],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let K=class{constructor(q,me){if(this.range=q,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xN=K,e.$xN=K=Ge([D],K);class X{constructor(q,me,Me,Xe,et,dt){this.kind=q,this.name=me,this.detail=Me,this.uri=Xe,this.range=et,this.selectionRange=dt}}e.$yN=X;class de{constructor(q,me){this.fromRanges=me,this.from=q}}e.$zN=de;class we{constructor(q,me){this.fromRanges=me,this.to=q}}e.$AN=we;var Fe;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let Ve=class{constructor(q,me){this.range=q,this.command=me}get isResolved(){return!!this.command}};e.$BN=Ve,e.$BN=Ve=Ge([D],Ve);let Je=s=class{#e;static isMarkdownString(q){return q instanceof s?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,me=!1){this.#e=new L.$Tk(q,{supportThemeIcons:me})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,me){return this.#e.appendCodeblock(me??"",q),this}};e.$CN=Je,e.$CN=Je=s=Ge([D],Je);let tt=class{constructor(q,me){this.label=q,this.documentation=me}};e.$DN=tt,e.$DN=tt=Ge([D],tt);let _e=class{constructor(q,me){this.label=q,this.documentation=me,this.parameters=[]}};e.$EN=_e,e.$EN=_e=Ge([D],_e);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FN=nt,e.$FN=nt=Ge([D],nt);var it;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let at=class{constructor(q){this.value=q}};e.$GN=at,e.$GN=at=Ge([D],at);let Ne=class{constructor(q,me,Me){this.position=q,this.label=me,this.kind=Me}};e.$HN=Ne,e.$HN=Ne=Ge([D],Ne);var ye;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var qe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(qe||(e.CompletionItemKind=qe={}));var te;(function(H){H[H.Deprecated=1]="Deprecated"})(te||(e.CompletionItemTag=te={}));let re=class{constructor(q,me){this.label=q,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IN=re,e.$IN=re=Ge([D],re);let Pe=class{constructor(q=[],me=!1){this.items=q,this.isIncomplete=me}};e.$JN=Pe,e.$JN=Pe=Ge([D],Pe);let He=class{constructor(q,me,Me){this.insertText=q,this.range=me,this.command=Me}};e.$KN=He,e.$KN=He=Ge([D],He);let Le=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$LN=Le,e.$LN=Le=Ge([D],Le);var st;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var ut;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(ut||(e.ViewColumn=ut={}));var mt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function Dt(H,q){return`${C.$Rm.toKey(H)}.${q}`}var It;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Ut;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ut||(e.TextDocumentSaveReason=Ut={}));var Wt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Wt||(e.TextEditorRevealType=Wt={}));var St;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(St||(e.TextEditorSelectionChangeKind=St={}));var Yt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Yt||(e.TextDocumentChangeReason=Yt={}));var xt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(H){function q(me){switch(me){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(St||(e.TextEditorSelectionChangeKind=St={}));var xe;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(H){function q(me){switch(me){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(xe||(e.SyntaxTokenType=xe={}));let cn=class{constructor(q,me){if(me&&!k.URI.isUri(me))throw(0,O.$7)("target");if(!z.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.target=me}};e.$NN=cn,e.$NN=cn=Ge([D],cn);let Kt=class{constructor(q,me,Me,Xe){this.red=q,this.green=me,this.blue=Me,this.alpha=Xe}};e.$ON=Kt,e.$ON=Kt=Ge([D],Kt);let ft=class{constructor(q,me){if(me&&!(me instanceof Kt))throw(0,O.$7)("color");if(!z.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.color=me}};e.$PN=ft,e.$PN=ft=Ge([D],ft);let $t=class{constructor(q){if(!q||typeof q!="string")throw(0,O.$7)("label");this.label=q}};e.$QN=$t,e.$QN=$t=Ge([D],$t);var _t;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var Xt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Xt||(e.SourceControlInputBoxValidationType=Xt={}));var jt;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var gt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class qt{constructor(q,me,Me){if(this.startIndex=q,this.length=me,this.tooltip=Me,typeof q!="number"||q<0)throw(0,O.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,O.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,O.$7)("tooltip")}}e.$RN=qt;class en{constructor(q){this.uri=q}}e.$SN=en;class Vt{constructor(q){this.terminalCommand=q}}e.$TN=Vt;var Ze;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Ze||(e.TerminalLocation=Ze={}));class dn{constructor(q){if(this.options=q,typeof q!="object")throw(0,O.$7)("options")}}e.$UN=dn;var Zt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Zt||(e.TaskRevealKind=Zt={}));var Ht;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Ht||(e.TaskPanelKind=Ht={}));let bt=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(q){switch(q){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(q,me){if(this.label=me,typeof q!="string"||typeof me!="string")throw(0,O.$7)("name");this.c=q}get id(){return this.c}};e.$VN=bt,e.$VN=bt=y=Ge([D],bt);function zt(H){let q="";for(let me=0;me<H.length;me++)q+=H[me].replace(/,/g,",,")+",";return q}let Mt=class{constructor(q,me,Me){if(typeof q!="string")throw(0,O.$7)("process");this.e=[],this.c=q,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Me):this.f=me)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,O.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const me of this.e)q.push(me);return zt(q)}};e.$WN=Mt,e.$WN=Mt=Ge([D],Mt);let Tt=class{constructor(q,me,Me){if(this.f=[],Array.isArray(me)){if(!q)throw(0,O.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q,this.f=me,this.g=Me}else{if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q,this.g=me}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)q.push(typeof me=="string"?me:me.value);return zt(q)}};e.$XN=Tt,e.$XN=Tt=Ge([D],Tt);var on;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(on||(e.ShellQuoting=on={}));var Gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Gt||(e.TaskScope=Gt={}));class an{constructor(q){this.c=q}computeId(){return"customExecution"+(0,A.$Sg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$YN=an;let Lt=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,me,Me,Xe,et,dt){this.k=!1,this.l=this.definition=q;let wt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Me,this.execution=Xe,wt=et,this.k=!0):me===Gt.Global||me===Gt.Workspace?(this.target=me,this.o=this.name=Me,this.w=this.source=Xe,this.execution=et,wt=dt):(this.target=me,this.o=this.name=Me,this.w=this.source=Xe,this.execution=et,wt=dt),typeof wt=="string"?(this.r=[wt],this.t=!0):Array.isArray(wt)?(this.r=wt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof an?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,A.$Sg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,O.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const me=this.l.type;(b.g===me||b.e===me||b.f===me||b.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$ZN=Lt,e.$ZN=Lt=b=Ge([D],Lt);var Ft;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Ft||(e.ProgressLocation=Ft={}));var Bt;(function(H){function q(me){const Me=me;return(0,m.$ag)(Me.value)?Me.tooltip&&!(0,m.$9f)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}H.isViewBadge=q})(Bt||(e.ViewBadge=Bt={}));let At=S=class{static isTreeItem(q,me){const Me=q;if(Me.checkboxState!==void 0){const Xe=(0,m.$ag)(Me.checkboxState)?Me.checkboxState:(0,m.$$f)(Me.checkboxState)&&(0,m.$ag)(Me.checkboxState.state)?Me.checkboxState.state:void 0,et=!(0,m.$ag)(Me.checkboxState)&&(0,m.$$f)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==kt.Checked&&Xe!==kt.Unchecked||et!==void 0&&!(0,m.$9f)(et))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(q instanceof S)return!0;if(Me.label!==void 0&&!(0,m.$9f)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,m.$9f)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,m.$9f)(Me.iconPath)&&!k.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,m.$9f)(Me.iconPath.id))){const Xe=Me.iconPath;if(!Xe||!(0,m.$9f)(Xe.light)&&!k.URI.isUri(Xe.light)&&!(0,m.$9f)(Xe.dark)&&!k.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,m.$9f)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!k.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,m.$9f)(Me.tooltip)&&!(Me.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<pt.None&&Me.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,m.$9f)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(q,me=pt.None){this.collapsibleState=me,k.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$1N=At,e.$1N=At=S=Ge([D],At);var pt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(pt||(e.TreeItemCollapsibleState=pt={}));var kt;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let un=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$2N=un,e.$2N=un=Ge([D],un);class Pt extends un{}e.$3N=Pt;class mn extends Pt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$4N=mn;class tn{constructor(q,me,Me,Xe){this.name=q,this.uri=me,this._itemId=Me,this.c=Xe}data(){return this.c()}}e.$5N=tn;let wn=class{#e=new Map;constructor(q){for(const[me,Me]of q??[]){const Xe=this.#e.get(this.#t(me));Xe?Xe.push(Me):this.#e.set(this.#t(me),[Me])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,me){this.#e.set(this.#t(q),[me])}forEach(q,me){for(const[Me,Xe]of this.#e)for(const et of Xe)q.call(me,et,Me,this)}*[Symbol.iterator](){for(const[q,me]of this.#e)for(const Me of me)yield[q,Me]}#t(q){return q.toLowerCase()}};e.$6N=wn,e.$6N=wn=Ge([D],wn);let ln=class{constructor(q,me,Me){this.insertText=q,this.title=me,this.kind=Me}};e.$7N=ln,e.$7N=ln=Ge([D],ln);var vn;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(vn||(e.DocumentPasteTriggerKind=vn={}));class Rt{static{this.c="."}constructor(q){this.value=q}append(...q){return new Rt((this.value?[this.value,...q]:q).join(Rt.c))}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+Rt.c)}}e.$8N=Rt,Rt.Empty=new Rt("");class Sn{constructor(q,me,Me){this.title=me,this.insertText=q,this.kind=Me}}e.$9N=Sn;let nn=class{constructor(q,me){this.id=q,this.color=me}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$0N=nn,e.$0N=nn=Ge([D],nn),nn.File=new nn("file"),nn.Folder=new nn("folder");let Ct=class{constructor(q){this.id=q}};e.$$N=Ct,e.$$N=Ct=Ge([D],Ct);var Oe;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Oe||(e.ConfigurationTarget=Oe={}));let je=class{get base(){return this.c}set base(q){this.c=q,this.e=k.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,me){if(typeof q!="string"&&(!q||!k.URI.isUri(q)&&!k.URI.isUri(q.uri)))throw(0,O.$7)("base");if(typeof me!="string")throw(0,O.$7)("pattern");typeof q=="string"?this.baseUri=k.URI.file(q):k.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$_N=je,e.$_N=je=Ge([D],je);const Ee=new WeakMap;function Y(H,q){Ee.set(H,q)}let Te=class{constructor(q,me,Me,Xe,et){this.enabled=typeof q=="boolean"?q:!0,typeof me=="string"&&(this.condition=me),typeof Me=="string"&&(this.hitCondition=Me),typeof Xe=="string"&&(this.logMessage=Xe),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=Ee.get(this)??(0,A.$Sg)()),this.c}};e.$bO=Te,e.$bO=Te=Ge([D],Te);let Qe=class extends Te{constructor(q,me,Me,Xe,et,dt){if(super(me,Me,Xe,et,dt),q===null)throw(0,O.$7)("location");this.location=q}};e.$cO=Qe,e.$cO=Qe=Ge([D],Qe);let Ye=class extends Te{constructor(q,me,Me,Xe,et,dt){super(me,Me,Xe,et,dt),this.functionName=q}};e.$dO=Ye,e.$dO=Ye=Ge([D],Ye);let Ke=class extends Te{constructor(q,me,Me,Xe,et,dt,wt,Jt){if(super(Xe,et,dt,wt,Jt),!me)throw(0,O.$7)("dataId");this.label=q,this.dataId=me,this.canPersist=Me}};e.$eO=Ke,e.$eO=Ke=Ge([D],Ke);let ht=class{constructor(q,me,Me){this.command=q,this.args=me||[],this.options=Me}};e.$fO=ht,e.$fO=ht=Ge([D],ht);let Et=class{constructor(q,me){this.port=q,this.host=me}};e.$gO=Et,e.$gO=Et=Ge([D],Et);let lt=class{constructor(q){this.path=q}};e.$hO=lt,e.$hO=lt=Ge([D],lt);let rn=class{constructor(q){this.implementation=q}};e.$iO=rn,e.$iO=rn=Ge([D],rn);class Nt{constructor(q,me,Me){this.session=q,this.threadId=me,this.frameId=Me}}e.$jO=Nt;class Qt{constructor(q,me){this.session=q,this.threadId=me}}e.$kO=Qt;let Dn=class{constructor(q,me){this.range=q,this.expression=me}};e.$lO=Dn,e.$lO=Dn=Ge([D],Dn);var Jn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Jn||(e.InlineCompletionTriggerKind=Jn={}));let On=class{constructor(q,me){this.range=q,this.text=me}};e.$mO=On,e.$mO=On=Ge([D],On);let Mn=class{constructor(q,me,Me=!0){this.range=q,this.variableName=me,this.caseSensitiveLookup=Me}};e.$nO=Mn,e.$nO=Mn=Ge([D],Mn);let Pn=class{constructor(q,me){this.range=q,this.expression=me}};e.$oO=Pn,e.$oO=Pn=Ge([D],Pn);let Tn=class{constructor(q,me){this.frameId=q,this.stoppedLocation=me}};e.$pO=Tn,e.$pO=Tn=Ge([D],Tn);var Fn;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Fn||(e.NewSymbolNameTag=Fn={}));var Kn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Kn||(e.NewSymbolNameTriggerKind=Kn={}));class jn{constructor(q,me){this.newSymbolName=q,this.tags=me}}e.$qO=jn;var Cn;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Cn||(e.FileChangeType=Cn={}));let zn=g=class extends Error{static FileExists(q){return new g(q,$.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(q){return new g(q,$.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(q){return new g(q,$.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(q){return new g(q,$.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(q){return new g(q,$.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(q){return new g(q,$.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(q,me=$.FileSystemProviderErrorCode.Unknown,Me){super(k.URI.isUri(q)?q.toString(!0):q),this.code=Me?.name??"Unknown",(0,$.$fl)(this,me),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$rO=zn,e.$rO=zn=g=Ge([D],zn);let Bn=class{constructor(q,me,Me){this.start=q,this.end=me,this.kind=Me}};e.$sO=Bn,e.$sO=Bn=Ge([D],Bn);var yn;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(yn||(e.FoldingRangeKind=yn={}));var Xn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Xn||(e.CommentThreadCollapsibleState=Xn={}));var Zn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Zn||(e.CommentMode=Zn={}));var Yn;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Yn||(e.CommentState=Yn={}));var In;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(In||(e.CommentThreadState=In={}));var xn;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(xn||(e.CommentThreadApplicability=xn={}));class _n{constructor(q,me=[]){this.tokenTypes=q,this.tokenModifiers=me}}e.$tO=_n;function di(H){return typeof H>"u"||(0,m.$0f)(H)}class An{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let me=0,Me=q.tokenTypes.length;me<Me;me++)this.k.set(q.tokenTypes[me],me);for(let me=0,Me=q.tokenModifiers.length;me<Me;me++)this.l.set(q.tokenModifiers[me],me)}}push(q,me,Me,Xe,et){if(typeof q=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Xe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(q,me,Me,Xe,et);if(z.isRange(q)&&typeof me=="string"&&di(Me))return this.o(q,me,Me);throw(0,O.$7)()}o(q,me,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Xe=q.start.line,et=q.start.character,dt=q.end.character-q.start.character,wt=this.k.get(me);let Jt=0;if(Me)for(const hn of Me){if(!this.l.has(hn))throw new Error("`tokenModifier` is not in the provided legend");const gn=this.l.get(hn);Jt|=1<<gn>>>0}this.q(Xe,et,dt,wt,Jt)}q(q,me,Me,Xe,et){if(this.f&&(q<this.c||q===this.c&&me<this.e)){this.f=!1;const Jt=this.g.length/5|0;let hn=0,gn=0;for(let pn=0;pn<Jt;pn++){let bn=this.g[5*pn],Hn=this.g[5*pn+1];bn===0?(bn=hn,Hn+=gn):bn+=hn,this.g[5*pn]=bn,this.g[5*pn+1]=Hn,hn=bn,gn=Hn}}let dt=q,wt=me;this.f&&this.j>0&&(dt-=this.c,dt===0&&(wt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=wt,this.g[this.j++]=Me,this.g[this.j++]=Xe,this.g[this.j++]=et,this.c=q,this.e=me}static r(q){const me=[],Me=q.length/5|0;for(let wt=0;wt<Me;wt++)me[wt]=wt;me.sort((wt,Jt)=>{const hn=q[5*wt],gn=q[5*Jt];if(hn===gn){const pn=q[5*wt+1],bn=q[5*Jt+1];return pn-bn}return hn-gn});const Xe=new Uint32Array(q.length);let et=0,dt=0;for(let wt=0;wt<Me;wt++){const Jt=5*me[wt],hn=q[Jt+0],gn=q[Jt+1],pn=q[Jt+2],bn=q[Jt+3],Hn=q[Jt+4],Ti=hn-et,gr=Ti===0?gn-dt:gn,Gn=5*wt;Xe[Gn+0]=Ti,Xe[Gn+1]=gr,Xe[Gn+2]=pn,Xe[Gn+3]=bn,Xe[Gn+4]=Hn,et=hn,dt=gn}return Xe}build(q){return this.f?new Un(new Uint32Array(this.g),q):new Un(An.r(this.g),q)}}e.$uO=An;class Un{constructor(q,me){this.resultId=me,this.data=q}}e.$vO=Un;class fi{constructor(q,me,Me){this.start=q,this.deleteCount=me,this.data=Me}}e.$wO=fi;class gi{constructor(q,me){this.resultId=me,this.edits=q}}e.$xO=gi;var ei;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(ei||(e.DebugConsoleMode=ei={}));class Wn{constructor(q){this.name=q}}e.$yO=Wn;let Rn=class{static{this.Back={iconPath:new nn("arrow-left")}}constructor(){}};e.$zO=Rn,e.$zO=Rn=Ge([D],Rn);var Ue;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Ue||(e.QuickPickItemKind=Ue={}));var fn;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(fn||(e.InputBoxValidationSeverity=fn={}));var Vn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Vn||(e.ExtensionKind=Vn={}));class ot{static validate(q){if(typeof q.badge=="string"){let me=(0,p.$Hf)(q.badge,0);if(me<q.badge.length&&(me+=(0,p.$Hf)(q.badge,me)),q.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!nn.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,me,Me){this.badge=q,this.tooltip=me,this.color=Me}}e.$AO=ot;let vt=class{constructor(q){this.kind=q}};e.$BO=vt,e.$BO=vt=Ge([D],vt);var ti;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(ti||(e.ColorThemeKind=ti={}));class $n{static isNotebookRange(q){return q instanceof $n?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,me){if(q<0)throw(0,O.$7)("start must be positive");if(me<0)throw(0,O.$7)("end must be positive");q<=me?(this.c=q,this.e=me):(this.c=me,this.e=q)}with(q){let me=this.c,Me=this.e;return q.start!==void 0&&(me=q.start),q.end!==void 0&&(Me=q.end),me===this.c&&Me===this.e?this:new $n(me,Me)}}e.$CO=$n;class En{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(me=>En.isNotebookCellData(me))}static isNotebookCellData(q){return!0}constructor(q,me,Me,Xe,et,dt,wt){this.kind=q,this.value=me,this.languageId=Me,this.mime=Xe,this.outputs=et??[],this.metadata=dt,this.executionSummary=wt,En.validate(this)}}e.$DO=En;class mi{constructor(q){this.cells=q}}e.$EO=mi;class sn{static isNotebookCellOutputItem(q){return q instanceof sn?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const me={name:q.name,message:q.message,stack:q.stack};return sn.json(me,"application/vnd.code.notebook.error")}static stdout(q){return sn.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return sn.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,me="application/octet-stream"){return new sn(q,me)}static#e=new TextEncoder;static text(q,me=N.$Qs.text){const Me=sn.#e.encode(String(q));return new sn(Me,me)}static json(q,me="text/x-json"){const Me=JSON.stringify(q,void 0,"	");return sn.text(Me,me)}constructor(q,me){this.data=q,this.mime=me;const Me=(0,N.$Us)(me,!0);if(!Me)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$FO=sn;class Nn{static isNotebookCellOutput(q){return q instanceof Nn?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,me=!1){const Me=new Set,Xe=new Set;for(let et=0;et<q.length;et++){const dt=q[et],wt=(0,N.$Us)(dt.mime);if(!Me.has(wt)||(0,w.$7K)(wt)){Me.add(wt);continue}Xe.add(et),me&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Xe.size===0?q:q.filter((et,dt)=>!Xe.has(dt))}constructor(q,me,Me){this.items=Nn.ensureUniqueMimeTypes(q,!0),typeof me=="string"?(this.id=me,this.metadata=Me):(this.id=(0,A.$Sg)(),this.metadata=me??Me)}}e.$GO=Nn;var ni;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ni||(e.NotebookCellKind=ni={}));var ii;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(ii||(e.NotebookCellExecutionState=ii={}));var qn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(qn||(e.NotebookCellStatusBarAlignment=qn={}));var ri;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ri||(e.NotebookEditorRevealType=ri={}));class $i{constructor(q,me){this.text=q,this.alignment=me}}e.$HO=$i;var si;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(si||(e.NotebookControllerAffinity=si={}));var oi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(oi||(e.NotebookControllerAffinity2=oi={}));class pi{constructor(q,me=[]){this.uri=q,this.provides=(0,d.$2b)(me)}}e.$IO=pi;class bi{constructor(q){this.label=q}}e.$JO=bi;var ai;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ai||(e.NotebookVariablesRequestKind=ai={}));let Qn=class{constructor(q,me){this.label=q,this.timestamp=me}};e.$KO=Qn,e.$KO=Qn=Ge([D],Qn);var ci;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(ci||(e.ExtensionMode=ci={}));var ui;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(ui||(e.ExtensionRuntime=ui={}));var li;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(li||(e.StandardTokenType=li={}));class fe{constructor(q,me){this.ranges=q,this.wordPattern=me}}e.$LO=fe;class ke{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$MO=ke;var Be;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Be||(e.TestResultState=Be={}));var ct;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(ct||(e.TestRunProfileKind=ct={}));let yt=class{constructor(q=void 0,me=void 0,Me=void 0,Xe=!1,et=!0){this.include=q,this.exclude=me,this.profile=Me,this.continuous=Xe,this.preserveFocus=et}};e.$NO=yt,e.$NO=yt=Ge([D],yt);let Ot=E=class{static diff(q,me,Me){const Xe=new E(q);return Xe.expectedOutput=me,Xe.actualOutput=Me,Xe}constructor(q){this.message=q}};e.$OO=Ot,e.$OO=Ot=E=Ge([D],Ot);let kn=class{constructor(q){this.id=q}};e.$PO=kn,e.$PO=kn=Ge([D],kn);class hi{constructor(q,me){this.covered=q,this.total=me,vi(this)}}e.$QO=hi;function vi(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class wi{static fromDetails(q,me){const Me=new hi(0,0),Xe=new hi(0,0),et=new hi(0,0);for(const wt of me)if("branches"in wt){Me.total+=1,Me.covered+=wt.executed?1:0;for(const Jt of wt.branches)Xe.total+=1,Xe.covered+=Jt.executed?1:0}else et.total+=1,et.covered+=wt.executed?1:0;const dt=new wi(q,Me,Xe.total>0?Xe:void 0,et.total>0?et:void 0);return dt.detailedCoverage=me,dt}constructor(q,me,Me,Xe){this.uri=q,this.statementCoverage=me,this.branchCoverage=Me,this.declarationCoverage=Xe}}e.$SO=wi;class Fi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,me,Me=[]){this.executed=q,this.location=me,this.branches=Me}}e.$TO=Fi;class ji{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,me,Me){this.executed=q,this.location=me,this.label=Me}}e.$UO=ji;class zi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,me,Me){this.name=q,this.executed=me,this.location=Me}}e.$VO=zi;var yi;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(yi||(e.ExternalUriOpenerPriority=yi={}));var Ei;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ei||(e.WorkspaceTrustState=Ei={}));var ki;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ki||(e.PortAutoForwardAction=ki={}));class Bi{constructor(q,me,Me,Xe,et,dt){this.kind=q,this.name=me,this.detail=Me,this.uri=Xe,this.range=et,this.selectionRange=dt}}e.$WO=Bi;class Ui{constructor(q){this.uri=q}}e.$XO=Ui;class Wi{constructor(q,me){this.original=q,this.modified=me}}e.$YO=Wi;class Vi{constructor(q,me,Me,Xe){this.base=q,this.input1=me,this.input2=Me,this.result=Xe}}e.$ZO=Vi;class qi{constructor(q,me){this.uri=q,this.viewType=me}}e.$1O=qi;class Qi{constructor(q){this.viewType=q}}e.$2O=Qi;class Hi{constructor(q,me){this.uri=q,this.notebookType=me}}e.$3O=Hi;class Gi{constructor(q,me,Me){this.original=q,this.modified=me,this.notebookType=Me}}e.$4O=Gi;class Ji{constructor(){}}e.$5O=Ji;class Ki{constructor(q,me){this.uri=q,this.inputBoxUri=me}}e.$6O=Ki;class Xi{constructor(){}}e.$7O=Xi;class Zi{constructor(q){this.textDiffs=q}}e.$8O=Zi;var Si;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(Si||(e.InteractiveSessionVoteDirection=Si={}));var Di;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(Di||(e.ChatCopyKind=Di={}));var Pi;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(Pi||(e.ChatVariableLevel=Pi={}));class Yi{constructor(q,me){this.label=q,this.values=me}}e.$9O=Yi;var Ci;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Ci||(e.InteractiveEditorResponseFeedbackKind=Ci={}));var Ii;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Ii||(e.ChatResultFeedbackKind=Ii={}));class xi{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new Je(q):q}}e.$0O=xi;class _i{constructor(q,me){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new Je(q):q,this.vulnerabilities=me}}e.$$O=_i;class er{constructor(q,me){this.participant=q,this.command=me}}e.$_O=er;class tr{constructor(q,me){this.value=q,this.baseUri=me}}e.$aP=tr;class nr{constructor(q,me){this.value=q,this.title=me}}e.$bP=nr;class ir{constructor(q){this.value=q}}e.$cP=ir;class rr{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new Je(q):q}}e.$dP=rr;class sr{constructor(q){this.value=q}}e.$eP=sr;class or{constructor(q,me){this.value=q,this.iconPath=me}}e.$fP=or;class ar{constructor(q,me){this.uri=q,this.edits=Array.isArray(me)?me:[me]}}e.$gP=ar;class cr{constructor(q,me,Me,Xe){this.prompt=q,this.command=me,this.variables=Me,this.participant=Xe}}e.$hP=cr;class ur{constructor(q,me,Me,Xe){this.response=q,this.result=me,this.participant=Me,this.command=Xe}}e.$iP=ur;var Ai;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Ai||(e.ChatLocation=Ai={}));class lr{constructor(q){this.content=q}}e.$jP=lr;class hr{constructor(q,me){this.content=q,this.name=me}}e.$kP=hr;class dr{constructor(q,me){this.content=q,this.name=me}}e.$lP=dr;class Ln extends Error{static NotFound(q){return new Ln(q,Ln.NotFound.name)}static NoPermissions(q){return new Ln(q,Ln.NoPermissions.name)}constructor(q,me,Me){super(q,{cause:Me}),this.name="LanguageModelError",this.code=me??""}}e.$mP=Ln;var Ri;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Ri||(e.RelatedInformationType=Ri={}));var Ni;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(Ni||(e.SpeechToTextStatus=Ni={}));var Li;(function(H){H[H.Started=1]="Started",H[H.Stopped=2]="Stopped",H[H.Error=3]="Error"})(Li||(e.TextToSpeechStatus=Li={}));var Oi;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(Oi||(e.KeywordRecognitionStatus=Oi={}));class fr{constructor(q,me){this.text=q,this.range=me}}e.$nP=fr;var Mi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Mi||(e.InlineEditTriggerKind=Mi={}))}),define(Se[329],De([1,0,6,8]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class L{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(d.$$M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(N,p,m){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(N);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(p,m)??[]}getRelatedInformation(N,p,m){return this.c.$getAiRelatedInformation(p,m)}registerRelatedInformationProvider(N,p,m){const k=this.b;return this.b++,this.a.set(k,m),this.c.$registerAiRelatedInformationProvider(k,p),new O.$aN(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$ilc=L}),define(Se[121],De([1,0,4,6,8,25,146,5,20]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0,e.$tlc=(0,p.$wi)("IExtHostAuthentication");let k=class{constructor($){this.b=new Map,this.c=new d.$de,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=$.getProxy(O.$$M.MainThreadAuthentication)}async getSession($,v,w,h={}){const f=R.$Rm.toKey($.identifier),a=[...w].sort().join(" ");return await this.d.getOrCreate(`${f} ${v} ${a}`,async()=>{await this.a.$ensureProvider(v);const n=$.displayName||$.name;return this.a.$getSession(v,w,f,n,h)})}async getSessions($,v,w){const h=R.$Rm.toKey($.identifier),f=[...w].sort().join(" ");return await this.f.getOrCreate(`${h} ${f}`,async()=>{await this.a.$ensureProvider(v);const a=$.displayName||$.name;return this.a.$getSessions(v,w,h,a)})}async removeSession($,v){const w=this.b.get($);return w?w.provider.removeSession(v):this.a.$removeSession($,v)}registerAuthenticationProvider($,v,w,h){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:v,provider:w,options:h??{supportsMultipleAccounts:!1}});const f=w.onDidChangeSessions(a=>this.a.$sendDidChangeSessions($,a));return this.a.$registerAuthenticationProvider($,v,h?.supportsMultipleAccounts??!1),new L.$aN(()=>{f.dispose(),this.b.delete($),this.a.$unregisterAuthenticationProvider($)})}async $createSession($,v,w){const h=this.b.get($);if(h)return await h.provider.createSession(v,w);throw new Error(`Unable to find authentication provider with handle: ${$}`)}async $removeSession($,v){const w=this.b.get($);if(w)return await w.provider.removeSession(v);throw new Error(`Unable to find authentication provider with handle: ${$}`)}async $getSessions($,v){const w=this.b.get($);if(w)return await w.provider.getSessions(v);throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,v){return $.startsWith(N.$aM)||this.c.fire({provider:{id:$,label:v}}),Promise.resolve()}};e.$ulc=k,e.$ulc=k=Ge([We(0,m.$zP)],k);class A{constructor(){this.a=new Map}getOrCreate($,v){const w=this.a.get($);if(w)return w;const h=v().finally(()=>this.a.delete($));return this.a.set($,h),h}}}),define(Se[152],De([1,0,2,6,8,5,20,11,19,14,17,26]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0;let v=class{static{$=this}static{this.c=0}static{this.d=250}constructor(h,f){this.h=f,this.f=new Map,this.g=h.getProxy(O.$$M.MainThreadDecorations)}registerFileDecorationProvider(h,f){const a=$.c++;this.f.set(a,{provider:h,extensionDescription:f}),this.g.$registerDecorationProvider(a,f.identifier.value);const n=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const l=(0,m.$2b)(i);if(l.length<=$.d){this.g.$onDidChange(a,l);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,l.length);const o=l.map(r=>({uri:r,rank:(0,k.$af)(r.path,"/")})),t=(0,m.$zb)(o,(r,c)=>r.rank-c.rank||(0,k.$qf)(r.uri.path,c.uri.path)),u=[];e:for(const r of t){let c;for(const s of r){const y=(0,A.$mc)(s.uri.path);if(c!==y&&(c=y,u.push(s.uri)>=$.d))break e}}this.g.$onDidChange(a,u)});return new L.$aN(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(h,f,a){if(!this.f.has(h))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:l}=this.f.get(h);return await Promise.all(f.map(async o=>{try{const{uri:t,id:u}=o,r=await Promise.resolve(i.provideFileDecoration(d.URI.revive(t),a));if(!r)return;try{L.$AO.validate(r),r.badge&&typeof r.badge!="string"&&(0,C.$PG)(l,"codiconDecoration"),n[u]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this.h.warn(`INVALID decoration from extension '${l.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),n}};e.$tmc=v,e.$tmc=v=$=Ge([We(0,N.$zP),We(1,p.$3j)],v),e.$umc=(0,R.$wi)("IExtHostDecorations")}),define(Se[330],De([1,0,13,2,8,6,15,22,14]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class k{static{this.a=0}constructor(C,$,v){this.d=$,this.e=v,this.b=new Map,this.c=C.getProxy(R.$$M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,$){if(Object.keys(N.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=k.a++;this.b.set(v,$),this.c.$registerTextContentProvider(v,C);let w;if(typeof $.onDidChange=="function"){let h;w=$.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;h&&await h;const a=this.$provideTextDocumentContent(v,f).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(f);if(!i)return;const l=(0,m.$kf)(n);if(!i.equalLines(l))return this.c.$onVirtualDocumentChange(f,n)}).catch(d.$1).finally(()=>{h===a&&(h=void 0)});h=a})}return new L.$aN(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(C,$){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(O.URI.revive($),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$wmc=k}),define(Se[153],De([1,0,62,15,14,188,130,8,19]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0,e.$BP=A;const k=new Map;function A(w,h){h?k.set(w,h):k.delete(w)}function C(w){return k.get(w)}class $ extends R.$6v{constructor(h,f,a,n,i,l,o){super(f,a,n,i),this.c=h,this.m=l,this.q=o,this.b=!1}dispose(){(0,d.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,m.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===O.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(f){return f?h.s(f):h.getText()},get eol(){return h.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(f){return h.t(f)},offsetAt(f){return h.u(f)},positionAt(f){return h.v(f)},validateRange(f){return h.w(f)},validatePosition(f){return h.x(f)},getWordRangeAtPosition(f,a){return h.y(f,a)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,d.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,d.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const f=this.w(h);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const a=this.g,n=f.start.line,i=f.end.line,l=[];l.push(this.f[n].substring(f.start.character));for(let o=n+1;o<i;o++)l.push(this.f[o]);return l.push(this.f[i].substring(0,f.end.character)),l.join(a)}t(h){let f;if(h instanceof p.$bN?f=h.line:typeof h=="number"&&(f=h),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new v(f,this.f[f],f===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const f=this.j.getIndexOf(h),a=this.f[f.index].length;return new p.$bN(f.index,Math.min(f.remainder,a))}w(h){if(!(h instanceof p.$cN))throw new Error("Invalid argument");const f=this.x(h.start),a=this.x(h.end);return f===h.start&&a===h.end?h:new p.$cN(f.line,f.character,a.line,a.character)}x(h){if(!(h instanceof p.$bN))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:f,character:a}=h,n=!1;if(f<0)f=0,a=0,n=!0;else if(f>=this.f.length)f=this.f.length-1,a=this.f[f].length,n=!0;else{const i=this.f[f].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new p.$bN(f,a):h}y(h,f){const a=this.x(h);if(!f)f=C(this.m);else if((0,L.$jf)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const n=(0,N.$9s)(a.character+1,(0,N.$7s)(f),this.f[a.line],0);if(n)return new p.$cN(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$CP=$;class v{constructor(h,f,a){this.a=h,this.b=f,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$cN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$cN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DP=v}),define(Se[331],De([1,0,6,8]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;class L{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(d.$$M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(N,p,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(N);if(!k)throw new Error("Embedding vector provider not found");const A=await k.provideEmbeddingVector(p,m);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(N,p,m){const k=this.b;return this.b++,this.a.set(k,m),this.c.$registerAiEmbeddingVectorProvider(p,k),new O.$aN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$ymc=L}),define(Se[70],De([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0;let w=v=class{constructor(f,a){this.b=new Map,this.c=new A.$Fh,this.a=f.getProxy(d.$$M.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let l;const o=n.b.get(i.scheme);return o?(await n.a.$ensureActivation(i.scheme),l=await o.impl.stat(i)):l=await n.a.$stat(i),{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions===O.FilePermission.Readonly?1:void 0}}catch(l){v.e(l)}},async readDirectory(i){try{const l=n.b.get(i.scheme);return l?(await n.a.$ensureActivation(i.scheme),(await l.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(l){return v.e(l)}},async createDirectory(i){try{const l=n.b.get(i.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(l.impl,l.extUri,i)):await n.a.$mkdir(i)}catch(l){return v.e(l)}},async readFile(i){try{const l=n.b.get(i.scheme);return l?(await n.a.$ensureActivation(i.scheme),(await l.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(l){return v.e(l)}},async writeFile(i,l){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(o.impl,o.extUri,o.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(o.impl.writeFile(i,l,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Fe.wrap(l))}catch(o){return v.e(o)}},async delete(i,l){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly&&!l?.useTrash?(await n.a.$ensureActivation(i.scheme),await o.impl.delete(i,{recursive:!1,...l})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...l})}catch(o){return v.e(o)}},async rename(i,l,o){try{return await n.a.$rename(i,l,{overwrite:!1,...o})}catch(t){return v.e(t)}},async copy(i,l,o){try{return await n.a.$copy(i,l,{overwrite:!1,...o})}catch(t){return v.e(t)}},isWritableFileSystem(i){const l=a.getCapabilities(i);if(typeof l=="number")return!(l&2048)}})}async d(f,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await f.stat(n)).type&O.FileType.Directory))throw L.$rO.FileExists(`Unable to create folder '${n.scheme===$.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(l){if(O.$gl(l)!==O.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(a.basename(n)),n=a.dirname(n)}for(let l=i.length-1;l>=0;l--){n=a.joinPath(n,i[l]);try{await f.createDirectory(n)}catch(o){if(O.$gl(o)!==O.FileSystemProviderErrorCode.FileExists)throw o}}}static e(f){if(f instanceof L.$rO)throw f;if(f instanceof O.$cl)switch(f.code){case O.FileSystemProviderErrorCode.FileExists:throw L.$rO.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$rO.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$rO.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$rO.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$rO.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$rO.Unavailable(f.message);default:throw new L.$rO(f.message,f.name)}if(!(f instanceof Error))throw new L.$rO(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw L.$rO.Unavailable(f.message);switch(f.name){case O.FileSystemProviderErrorCode.FileExists:throw L.$rO.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$rO.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$rO.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$rO.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$rO.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$rO.Unavailable(f.message);default:throw new L.$rO(f.message,f.name)}}addFileSystemProvider(f,a,n){return this.b.set(f,{impl:a,extUri:n?.isCaseSensitive?C.$Zg:C.$2g,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$Zg}};e.$Jlc=w,e.$Jlc=w=v=Ge([We(0,p.$zP),We(1,m.$nlc)],w),e.$Klc=(0,N.$wi)("IExtHostConsumerFileSystem")}),define(Se[93],De([1,0,5,28,11,70,2]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0,e.$Llc=(0,d.$wi)("IExtensionStoragePaths");let p=class{constructor(k,A,C){this.d=A,this.f=C,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then($=>this.c=$)}async g(k){return N.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,A=await this.g(k);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(N.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:N.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(k){if(this.c)return N.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return N.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Mlc=p,e.$Mlc=p=Ge([We(0,O.$PP),We(1,L.$3j),We(2,R.$Klc)],p)}),define(Se[332],De([1,0,8,20,4]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;let R=class{constructor(p){this.a=new d.$BO(d.ColorThemeKind.Dark),this.b=new L.$de}get activeColorTheme(){return this.a}$onColorThemeChange(p){let m;switch(p){case"light":m=d.ColorThemeKind.Light;break;case"hcDark":m=d.ColorThemeKind.HighContrast;break;case"hcLight":m=d.ColorThemeKind.HighContrastLight;break;default:m=d.ColorThemeKind.Dark}this.a=new d.$BO(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$hnc=R,e.$hnc=R=Ge([We(0,O.$zP)],R)}),define(Se[71],De([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tDb=e.$sDb=e.TunnelDtoConverter=void 0;class v extends m.$sw{}var w;(function(f){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}f.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}f.fromServiceTunnel=n})(w||(e.TunnelDtoConverter=w={})),e.$sDb=(0,N.$wi)("IExtHostTunnelService");let h=class extends L.$Uc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$de,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(k.$$M.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const l=new v(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(l),l}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new $.$aN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,l,o){const t=[];for(const r of a){const c=this.r.get(r);if(!c)return[];t.push(...await Promise.all(n.map(async s=>{let y;try{y=await c.provider.providePortAttributes({port:s,pid:i,commandLine:l},o)}catch{y=await c.provider.providePortAttributes(s,i,l,o)}return{providedAttributes:y,port:s}})))}const u=t.filter(r=>!!r.providedAttributes);return u.length>0?u.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(l,o)=>await a.provideTunnel(l,o,d.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let l=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&l.length===0&&(l=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:l,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const l=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),l===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(l.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(l.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:l,disposeListener:o}),w.fromApiTunnel(l)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(l=>this.f(l.host,l.port,l.detail??""))),i=a.filter((l,o)=>n[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(l=>l.port).join(", ")} to ${i.map(l=>l.port).join(", ")}`),i}};e.$tDb=h,e.$tDb=h=Ge([We(0,C.$zP),We(1,A.$PP),We(2,p.$3j)],h)}),define(Se[16],De([1,0,19,21,177,75,81,27,167,58,101,24,172,23,18,2,29,84,139,145,143,296,120,69,89,308,8,50]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u,r,c,s,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$wP=U,e.$xP=ie,e.$yP=Q;var b;(function(Oe){function je(Y){const{selectionStartLineNumber:Te,selectionStartColumn:Qe,positionLineNumber:Ye,positionColumn:Ke}=Y,ht=new s.$bN(Te-1,Qe-1),Et=new s.$bN(Ye-1,Ke-1);return new s.$dN(ht,Et)}Oe.to=je;function Ee(Y){const{anchor:Te,active:Qe}=Y;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}Oe.from=Ee})(b||(e.Selection=b={}));var S;(function(Oe){function je(Y){if(!Y)return;const{start:Te,end:Qe}=Y;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}Oe.from=je;function Ee(Y){if(!Y)return;const{startLineNumber:Te,startColumn:Qe,endLineNumber:Ye,endColumn:Ke}=Y;return new s.$cN(Te-1,Qe-1,Ye-1,Ke-1)}Oe.to=Ee})(S||(e.Range=S={}));var g;(function(Oe){function je(Y){return{uri:Y.uri,range:S.from(Y.range)}}Oe.from=je;function Ee(Y){return new s.$mN(h.URI.revive(Y.uri),S.to(Y.range))}Oe.to=Ee})(g||(e.Location=g={}));var E;(function(Oe){function je(Ee){switch(Ee){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Oe.to=je})(E||(e.TokenType=E={}));var D;(function(Oe){function je(Y){return new s.$bN(Y.lineNumber-1,Y.column-1)}Oe.to=je;function Ee(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Oe.from=Ee})(D||(e.Position=D={}));var P;(function(Oe){function je(Te,Qe,Ye){return(0,d.$Hb)((0,d.$2b)(Te).map(Ke=>Ee(Ke,Qe,Ye)))}Oe.from=je;function Ee(Te,Qe,Ye){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ye?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:Y(Te.scheme,Qe),pattern:Pe.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ye?.isBuiltin}}function Y(Te,Qe){return Qe&&typeof Te=="string"?Qe.transformOutgoingScheme(Te):Te}})(P||(e.DocumentSelector=P={}));var I;(function(Oe){function je(Y){switch(Y){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Oe.from=je;function Ee(Y){switch(Y){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Oe.to=Ee})(I||(e.DiagnosticTag=I={}));var F;(function(Oe){function je(Y){let Te;return Y.code&&((0,w.$9f)(Y.code)||(0,w.$ag)(Y.code)?Te=String(Y.code):Te={value:String(Y.code.value),target:Y.code.target}),{...S.from(Y.range),message:Y.message,source:Y.source,code:Te,severity:z.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(T.from),tags:Array.isArray(Y.tags)?(0,d.$Hb)(Y.tags.map(I.from)):void 0}}Oe.from=je;function Ee(Y){const Te=new s.$oN(S.to(Y),Y.message,z.to(Y.severity));return Te.source=Y.source,Te.code=(0,w.$9f)(Y.code)?Y.code:Y.code?.value,Te.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(T.to),Te.tags=Y.tags&&(0,d.$Hb)(Y.tags.map(I.to)),Te}Oe.to=Ee})(F||(e.Diagnostic=F={}));var T;(function(Oe){function je(Y){return{...S.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Oe.from=je;function Ee(Y){return new s.$nN(new s.$mN(Y.resource,S.to(Y)),Y.message)}Oe.to=Ee})(T||(e.DiagnosticRelatedInformation=T={}));var z;(function(Oe){function je(Y){switch(Y){case s.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Oe.from=je;function Ee(Y){switch(Y){case n.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Oe.to=Ee})(z||(e.DiagnosticSeverity=z={}));var M;(function(Oe){function je(Y){return typeof Y=="number"&&Y>=s.ViewColumn.One?Y-1:Y===s.ViewColumn.Beside?c.$5D:c.$4D}Oe.from=je;function Ee(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=Ee})(M||(e.ViewColumn=M={}));function j(Oe){return typeof Oe.range<"u"}function U(Oe){return Oe.length===0?!0:!!j(Oe[0])}var Z;(function(Oe){function je(Ke){return Ke.map(Oe.from)}Oe.fromMany=je;function Ee(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let ht;if(Ee(Ke)){const{language:Nt,value:Qt}=Ke;ht={value:"```"+Nt+`
`+Qt+"\n```\n"}}else s.$CN.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const lt=Nt=>{try{let Qt=h.URI.parse(Nt,!0);Qt=Qt.with({query:Te(Qt.query,Et)}),Et[Nt]=Qt}catch{}return""},rn=new m.marked.Renderer;return rn.link=lt,rn.image=Nt=>typeof Nt=="string"?lt(N.$2k(Nt).href):"",(0,m.marked)(ht.value,{renderer:rn}),ht}Oe.from=Y;function Te(Ke,ht){if(!Ke)return Ke;let Et;try{Et=(0,k.$5h)(Ke)}catch{}if(!Et)return Ke;let lt=!1;return Et=(0,C.$5n)(Et,rn=>{if(h.URI.isUri(rn)){const Nt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[Nt]=rn,lt=!0,Nt}else return}),lt?JSON.stringify(Et):Ke}function Qe(Ke){const ht=new s.$CN(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?h.URI.from(Ke.baseUri):void 0,ht}Oe.to=Qe;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:Oe.from(Ke)}Oe.fromStrict=Ye})(Z||(e.MarkdownString=Z={}));function ie(Oe){return U(Oe)?Oe.map(je=>({range:S.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?Z.fromMany(je.hoverMessage):je.hoverMessage?Z.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Oe.map(je=>({range:S.from(je)}))}function Q(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?h.URI.file(Oe):Oe}var G;(function(Oe){function je(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?Q(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Oe.from=je})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var x;(function(Oe){function je(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?Q(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?G.from(Ee.before):void 0,after:Ee.after?G.from(Ee.after):void 0}}Oe.from=je})(x||(e.ThemableDecorationRenderOptions=x={}));var ne;(function(Oe){function je(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=je})(ne||(e.DecorationRangeBehavior=ne={}));var be;(function(Oe){function je(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?ne.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?x.from(Ee.light):void 0,dark:Ee.dark?x.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?Q(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?G.from(Ee.before):void 0,after:Ee.after?G.from(Ee.after):void 0}}Oe.from=je})(be||(e.DecorationRenderOptions=be={}));var ae;(function(Oe){function je(Y){return{text:Y.newText,eol:Y.newEol&&Ne.from(Y.newEol),range:S.from(Y.range)}}Oe.from=je;function Ee(Y){const Te=new s.$hN(S.to(Y.range),Y.text);return Te.newEol=typeof Y.eol>"u"?void 0:Ne.to(Y.eol),Te}Oe.to=Ee})(ae||(e.TextEdit=ae={}));var Ce;(function(Oe){function je(Y,Te){const Qe={edits:[]};if(Y instanceof s.$kN){const Ye=new p.$Bc;for(const Ke of Y._allEntries())Ke._type===1&&h.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of Y._allEntries())if(Ke._type===1){let ht;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ht={type:"base64",value:(0,O.$Ze)(O.$Fe.wrap(Ke.options.contents))}:ht={type:"dataTransferItem",id:Ke.options.contents._itemId}),Qe.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ht},metadata:Ke.metadata})}else Ke._type===2?Qe.edits.push({resource:Ke.uri,textEdit:ae.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Qe.edits.push({resource:Ke.uri,textEdit:{range:S.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Ut.from)}})}return Qe}Oe.from=je;function Ee(Y){const Te=new s.$kN,Qe=new p.$Ac;for(const Ye of Y.edits)if(Ye.textEdit){const Ke=Ye,ht=h.URI.revive(Ke.resource),Et=S.to(Ke.textEdit.range),lt=Ke.textEdit.text,rn=Ke.textEdit.insertAsSnippet;let Nt;rn?Nt=s.$jN.replace(Et,new s.$lN(lt)):Nt=s.$hN.replace(Et,lt);const Qt=Qe.get(ht);Qt?Qt.push(Nt):Qe.set(ht,[Nt])}else Te.renameFile(h.URI.revive(Ye.oldResource),h.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of Qe)Te.set(Ye,Ke);return Te}Oe.to=Ee})(Ce||(e.WorkspaceEdit=Ce={}));var ee;(function(Oe){const je=Object.create(null);je[s.SymbolKind.File]=0,je[s.SymbolKind.Module]=1,je[s.SymbolKind.Namespace]=2,je[s.SymbolKind.Package]=3,je[s.SymbolKind.Class]=4,je[s.SymbolKind.Method]=5,je[s.SymbolKind.Property]=6,je[s.SymbolKind.Field]=7,je[s.SymbolKind.Constructor]=8,je[s.SymbolKind.Enum]=9,je[s.SymbolKind.Interface]=10,je[s.SymbolKind.Function]=11,je[s.SymbolKind.Variable]=12,je[s.SymbolKind.Constant]=13,je[s.SymbolKind.String]=14,je[s.SymbolKind.Number]=15,je[s.SymbolKind.Boolean]=16,je[s.SymbolKind.Array]=17,je[s.SymbolKind.Object]=18,je[s.SymbolKind.Key]=19,je[s.SymbolKind.Null]=20,je[s.SymbolKind.EnumMember]=21,je[s.SymbolKind.Struct]=22,je[s.SymbolKind.Event]=23,je[s.SymbolKind.Operator]=24,je[s.SymbolKind.TypeParameter]=25;function Ee(Te){return typeof je[Te]=="number"?je[Te]:6}Oe.from=Ee;function Y(Te){for(const Qe in je)if(je[Qe]===Te)return Number(Qe);return s.SymbolKind.Property}Oe.to=Y})(ee||(e.SymbolKind=ee={}));var B;(function(Oe){function je(Y){switch(Y){case s.SymbolTag.Deprecated:return 1}}Oe.from=je;function Ee(Y){switch(Y){case 1:return s.SymbolTag.Deprecated}}Oe.to=Ee})(B||(e.SymbolTag=B={}));var _;(function(Oe){function je(Y){return{name:Y.name,kind:ee.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:le.from(Y.location)}}Oe.from=je;function Ee(Y){const Te=new s.$tN(Y.name,ee.to(Y.kind),Y.containerName,le.to(Y.location));return Te.tags=Y.tags&&Y.tags.map(B.to),Te}Oe.to=Ee})(_||(e.WorkspaceSymbol=_={}));var pe;(function(Oe){function je(Y){const Te={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),kind:ee.from(Y.kind),tags:Y.tags?.map(B.from)??[]};return Y.children&&(Te.children=Y.children.map(je)),Te}Oe.from=je;function Ee(Y){const Te=new s.$uN(Y.name,Y.detail,ee.to(Y.kind),S.to(Y.range),S.to(Y.selectionRange));return(0,d.$Lb)(Y.tags)&&(Te.tags=Y.tags.map(B.to)),Y.children&&(Te.children=Y.children.map(Ee)),Te}Oe.to=Ee})(pe||(e.DocumentSymbol=pe={}));var ue;(function(Oe){function je(Y){const Te=new s.$yN(ee.to(Y.kind),Y.name,Y.detail||"",h.URI.revive(Y.uri),S.to(Y.range),S.to(Y.selectionRange));return Te._sessionId=Y._sessionId,Te._itemId=Y._itemId,Te}Oe.to=je;function Ee(Y,Te,Qe){if(Te=Te??Y._sessionId,Qe=Qe??Y._itemId,Te===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Qe,name:Y.name,detail:Y.detail,kind:ee.from(Y.kind),uri:Y.uri,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Oe.from=Ee})(ue||(e.CallHierarchyItem=ue={}));var ce;(function(Oe){function je(Ee){return new s.$zN(ue.to(Ee.from),Ee.fromRanges.map(Y=>S.to(Y)))}Oe.to=je})(ce||(e.CallHierarchyIncomingCall=ce={}));var oe;(function(Oe){function je(Ee){return new s.$AN(ue.to(Ee.to),Ee.fromRanges.map(Y=>S.to(Y)))}Oe.to=je})(oe||(e.CallHierarchyOutgoingCall=oe={}));var le;(function(Oe){function je(Y){return{range:Y.range&&S.from(Y.range),uri:Y.uri}}Oe.from=je;function Ee(Y){return new s.$mN(h.URI.revive(Y.uri),S.to(Y.range))}Oe.to=Ee})(le||(e.location=le={}));var J;(function(Oe){function je(Y){const Te=Y,Qe=Y;return{originSelectionRange:Te.originSelectionRange?S.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Qe.uri,range:S.from(Te.targetRange?Te.targetRange:Qe.range),targetSelectionRange:Te.targetSelectionRange?S.from(Te.targetSelectionRange):void 0}}Oe.from=je;function Ee(Y){return{targetUri:h.URI.revive(Y.uri),targetRange:S.to(Y.range),targetSelectionRange:Y.targetSelectionRange?S.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?S.to(Y.originSelectionRange):void 0}}Oe.to=Ee})(J||(e.DefinitionLink=J={}));var se;(function(Oe){function je(Y){return{range:S.from(Y.range),contents:Z.fromMany(Y.contents),canIncreaseVerbosity:Y.canIncreaseVerbosity,canDecreaseVerbosity:Y.canDecreaseVerbosity}}Oe.from=je;function Ee(Y){const Te=Y.contents.map(Z.to),Qe=S.to(Y.range),Ye=Y.canIncreaseVerbosity,Ke=Y.canDecreaseVerbosity;return new s.$qN(Te,Qe,Ye,Ke)}Oe.to=Ee})(se||(e.Hover=se={}));var $e;(function(Oe){function je(Y){return{range:S.from(Y.range),expression:Y.expression}}Oe.from=je;function Ee(Y){return new s.$lO(S.to(Y.range),Y.expression)}Oe.to=Ee})($e||(e.EvaluatableExpression=$e={}));var ve;(function(Oe){function je(Y){if(Y instanceof s.$mO)return{type:"text",range:S.from(Y.range),text:Y.text};if(Y instanceof s.$nO)return{type:"variable",range:S.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof s.$oO)return{type:"expression",range:S.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=je;function Ee(Y){switch(Y.type){case"text":return{range:S.to(Y.range),text:Y.text};case"variable":return{range:S.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:S.to(Y.range),expression:Y.expression}}}Oe.to=Ee})(ve||(e.InlineValue=ve={}));var Re;(function(Oe){function je(Y){return{frameId:Y.frameId,stoppedLocation:S.from(Y.stoppedLocation)}}Oe.from=je;function Ee(Y){return new s.$pO(Y.frameId,S.to(Y.stoppedLocation))}Oe.to=Ee})(Re||(e.InlineValueContext=Re={}));var ge;(function(Oe){function je(Y){return{range:S.from(Y.range),kind:Y.kind}}Oe.from=je;function Ee(Y){return new s.$rN(S.to(Y.range),Y.kind)}Oe.to=Ee})(ge||(e.DocumentHighlight=ge={}));var Ie;(function(Oe){function je(Y){return{uri:Y.uri,highlights:Y.highlights.map(ge.from)}}Oe.from=je;function Ee(Y){return new s.$sN(h.URI.revive(Y.uri),Y.highlights.map(ge.to))}Oe.to=Ee})(Ie||(e.MultiDocumentHighlight=Ie={}));var Ae;(function(Oe){function je(Ee){switch(Ee){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Oe.to=je})(Ae||(e.CompletionTriggerKind=Ae={}));var ze;(function(Oe){function je(Ee){return{triggerKind:Ae.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Oe.to=je})(ze||(e.CompletionContext=ze={}));var V;(function(Oe){function je(Y){switch(Y){case s.CompletionItemTag.Deprecated:return 1}}Oe.from=je;function Ee(Y){switch(Y){case 1:return s.CompletionItemTag.Deprecated}}Oe.to=Ee})(V||(e.CompletionItemTag=V={}));var W;(function(Oe){const je=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ee(Qe){return je.get(Qe)??9}Oe.from=Ee;const Y=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(Qe){return Y.get(Qe)??s.CompletionItemKind.Property}Oe.to=Te})(W||(e.CompletionItemKind=W={}));var K;(function(Oe){function je(Ee,Y){const Te=new s.$IN(Ee.label);return Te.insertText=Ee.insertText,Te.kind=W.to(Ee.kind),Te.tags=Ee.tags?.map(V.to),Te.detail=Ee.detail,Te.documentation=N.$Vk(Ee.documentation)?Z.to(Ee.documentation):Ee.documentation,Te.sortText=Ee.sortText,Te.filterText=Ee.filterText,Te.preselect=Ee.preselect,Te.commitCharacters=Ee.commitCharacters,f.$ut.isIRange(Ee.range)?Te.range=S.to(Ee.range):typeof Ee.range=="object"&&(Te.range={inserting:S.to(Ee.range.insert),replacing:S.to(Ee.range.replace)}),Te.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Te.insertText=new s.$lN(Ee.insertText):(Te.insertText=Ee.insertText,Te.textEdit=Te.range instanceof s.$cN?new s.$hN(Te.range,Te.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ee.additionalTextEdits.map(Qe=>ae.to(Qe))),Te.command=Y&&Ee.command?Y.fromInternal(Ee.command):void 0,Te}Oe.to=je})(K||(e.CompletionItem=K={}));var X;(function(Oe){function je(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:Z.fromStrict(Y.documentation)}}Oe.from=je;function Ee(Y){return{label:Y.label,documentation:N.$Vk(Y.documentation)?Z.to(Y.documentation):Y.documentation}}Oe.to=Ee})(X||(e.ParameterInformation=X={}));var de;(function(Oe){function je(Y){return{label:Y.label,documentation:Z.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(X.from):[],activeParameter:Y.activeParameter}}Oe.from=je;function Ee(Y){return{label:Y.label,documentation:N.$Vk(Y.documentation)?Z.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(X.to):[],activeParameter:Y.activeParameter}}Oe.to=Ee})(de||(e.SignatureInformation=de={}));var we;(function(Oe){function je(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(de.from):[]}}Oe.from=je;function Ee(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(de.to):[]}}Oe.to=Ee})(we||(e.SignatureHelp=we={}));var Fe;(function(Oe){function je(Ee,Y){const Te=new s.$HN(D.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(Ve.to.bind(void 0,Ee)),Y.kind&&Je.to(Y.kind));return Te.textEdits=Y.textEdits&&Y.textEdits.map(ae.to),Te.tooltip=N.$Vk(Y.tooltip)?Z.to(Y.tooltip):Y.tooltip,Te.paddingLeft=Y.paddingLeft,Te.paddingRight=Y.paddingRight,Te}Oe.to=je})(Fe||(e.InlayHint=Fe={}));var Ve;(function(Oe){function je(Ee,Y){const Te=new s.$GN(Y.label);return Te.tooltip=N.$Vk(Y.tooltip)?Z.to(Y.tooltip):Y.tooltip,a.Command.is(Y.command)&&(Te.command=Ee.fromInternal(Y.command)),Y.location&&(Te.location=le.to(Y.location)),Te}Oe.to=je})(Ve||(e.InlayHintLabelPart=Ve={}));var Je;(function(Oe){function je(Y){return Y}Oe.from=je;function Ee(Y){return Y}Oe.to=Ee})(Je||(e.InlayHintKind=Je={}));var tt;(function(Oe){function je(Y){return{range:S.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Oe.from=je;function Ee(Y){let Te;if(Y.url)try{Te=typeof Y.url=="string"?h.URI.parse(Y.url,!0):h.URI.revive(Y.url)}catch{}return new s.$NN(S.to(Y.range),Te)}Oe.to=Ee})(tt||(e.DocumentLink=tt={}));var _e;(function(Oe){function je(Y){const Te=new s.$QN(Y.label);return Y.textEdit&&(Te.textEdit=ae.to(Y.textEdit)),Y.additionalTextEdits&&(Te.additionalTextEdits=Y.additionalTextEdits.map(Qe=>ae.to(Qe))),Te}Oe.to=je;function Ee(Y){return{label:Y.label,textEdit:Y.textEdit?ae.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Te=>ae.from(Te)):void 0}}Oe.from=Ee})(_e||(e.ColorPresentation=_e={}));var nt;(function(Oe){function je(Y){return new s.$ON(Y[0],Y[1],Y[2],Y[3])}Oe.to=je;function Ee(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Oe.from=Ee})(nt||(e.Color=nt={}));var it;(function(Oe){function je(Y){return{range:S.from(Y.range)}}Oe.from=je;function Ee(Y){return new s.$xN(S.to(Y.range))}Oe.to=Ee})(it||(e.SelectionRange=it={}));var rt;(function(Oe){function je(Ee){switch(Ee){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Oe.to=je})(rt||(e.TextDocumentSaveReason=rt={}));var at;(function(Oe){function je(Y){switch(Y){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=je;function Ee(Y){switch(Y){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Oe.to=Ee})(at||(e.TextEditorLineNumbersStyle=at={}));var Ne;(function(Oe){function je(Y){if(Y===s.EndOfLine.CRLF)return 1;if(Y===s.EndOfLine.LF)return 0}Oe.from=je;function Ee(Y){if(Y===1)return s.EndOfLine.CRLF;if(Y===0)return s.EndOfLine.LF}Oe.to=Ee})(Ne||(e.EndOfLine=Ne={}));var ye;(function(Oe){function je(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=je})(ye||(e.ProgressLocation=ye={}));var qe;(function(Oe){function je(Y){const Te={start:Y.start+1,end:Y.end+1};return Y.kind&&(Te.kind=te.from(Y.kind)),Te}Oe.from=je;function Ee(Y){const Te={start:Y.start-1,end:Y.end-1};return Y.kind&&(Te.kind=te.to(Y.kind)),Te}Oe.to=Ee})(qe||(e.FoldingRange=qe={}));var te;(function(Oe){function je(Y){if(Y)switch(Y){case s.FoldingRangeKind.Comment:return a.$du.Comment;case s.FoldingRangeKind.Imports:return a.$du.Imports;case s.FoldingRangeKind.Region:return a.$du.Region}}Oe.from=je;function Ee(Y){if(Y)switch(Y.value){case a.$du.Comment.value:return s.FoldingRangeKind.Comment;case a.$du.Imports.value:return s.FoldingRangeKind.Imports;case a.$du.Region.value:return s.FoldingRangeKind.Region}}Oe.to=Ee})(te||(e.FoldingRangeKind=te={}));var re;(function(Oe){function je(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?S.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?l.$uF.id:void 0}}Oe.from=je})(re||(e.TextEditorOpenOptions=re={}));var Pe;(function(Oe){function je(Qe){return Qe instanceof s.$_N?Qe.toJSON():typeof Qe=="string"?Qe:Ee(Qe)||Y(Qe)?new s.$_N(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}Oe.from=je;function Ee(Qe){const Ye=Qe;return Ye?h.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Y(Qe){const Ye=Qe;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Te(Qe){return typeof Qe=="string"?Qe:new s.$_N(h.URI.revive(Qe.baseUri),Qe.pattern)}Oe.to=Te})(Pe||(e.GlobPattern=Pe={}));var He;(function(Oe){function je(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(je);if(typeof Ee=="string")return Ee;{const Y=Ee;return{language:Y.language,scheme:Y.scheme,pattern:Pe.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}Oe.from=je})(He||(e.LanguageSelector=He={}));var Le;(function(Oe){function je(Y){return!!Y&&typeof Y=="object"&&"documents"in Y&&Array.isArray(Y.documents)&&Y.documents.every(Te=>Array.isArray(Te)&&Te.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&h.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(Ye=>Ye instanceof s.$cN)))}Oe.is=je;function Ee(Y){return{documents:Y.documents.map(Te=>Te.map(Qe=>({uri:h.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(Ye=>S.from(Ye))})))}}Oe.from=Ee})(Le||(e.MappedEditsContext=Le={}));var st;(function(Oe){function je(Y){return{start:Y.start,end:Y.end}}Oe.from=je;function Ee(Y){return new s.$CO(Y.start,Y.end)}Oe.to=Ee})(st||(e.NotebookRange=st={}));var ut;(function(Oe){function je(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Oe.to=je;function Ee(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Oe.from=Ee})(ut||(e.NotebookCellExecutionSummary=ut={}));var mt;(function(Oe){function je(Ee){if(Ee===t.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ee===t.NotebookCellExecutionState.Pending)return;if(Ee===t.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Oe.to=je})(mt||(e.NotebookCellExecutionState=mt={}));var Dt;(function(Oe){function je(Y){switch(Y){case s.NotebookCellKind.Markup:return t.CellKind.Markup;case s.NotebookCellKind.Code:default:return t.CellKind.Code}}Oe.from=je;function Ee(Y){switch(Y){case t.CellKind.Markup:return s.NotebookCellKind.Markup;case t.CellKind.Code:default:return s.NotebookCellKind.Code}}Oe.to=Ee})(Dt||(e.NotebookCellKind=Dt={}));var It;(function(Oe){function je(Y){const Te={metadata:Y.metadata??Object.create(null),cells:[]};for(const Qe of Y.cells)s.$DO.validate(Qe),Te.cells.push(Ut.from(Qe));return Te}Oe.from=je;function Ee(Y){const Te=new s.$EO(Y.cells.map(Ut.to));return(0,w.$jg)(Y.metadata)||(Te.metadata=Y.metadata),Te}Oe.to=Ee})(It||(e.NotebookData=It={}));var Ut;(function(Oe){function je(Y){return{cellKind:Dt.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:ut.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(St.from):[]}}Oe.from=je;function Ee(Y){return new s.$DO(Dt.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(St.to):void 0,Y.metadata,Y.internalMetadata?ut.to(Y.internalMetadata):void 0)}Oe.to=Ee})(Ut||(e.NotebookCellData=Ut={}));var Wt;(function(Oe){function je(Y){return{mime:Y.mime,valueBytes:O.$Fe.wrap(Y.data)}}Oe.from=je;function Ee(Y){return new s.$FO(Y.valueBytes.buffer,Y.mime)}Oe.to=Ee})(Wt||(e.NotebookCellOutputItem=Wt={}));var St;(function(Oe){function je(Y){return{outputId:Y.id,items:Y.items.map(Wt.from),metadata:Y.metadata}}Oe.from=je;function Ee(Y){const Te=Y.items.map(Wt.to);return new s.$GO(Te,Y.outputId,Y.metadata)}Oe.to=Ee})(St||(e.NotebookCellOutput=St={}));var Yt;(function(Oe){function je(Te){return Y(Te)?{include:Pe.from(Te.include)??void 0,exclude:Pe.from(Te.exclude)??void 0}:Pe.from(Te)??void 0}Oe.from=je;function Ee(Te){return Y(Te)?{include:Pe.to(Te.include),exclude:Pe.to(Te.exclude)}:Pe.to(Te)}Oe.to=Ee;function Y(Te){const Qe=Te;return Qe?!(0,w.$fg)(Qe.include)&&!(0,w.$fg)(Qe.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var xt;(function(Oe){function je(Ee,Y,Te){const Qe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Qe,Te),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Oe.from=je})(xt||(e.NotebookStatusBarItem=xt={}));var xe;(function(Oe){function je(Ee,Y,Te){const Qe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:Y.toInternal(Qe,Te),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Oe.from=je})(xe||(e.NotebookKernelSourceAction=xe={}));var cn;(function(Oe){function je(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Oe.from=je})(cn||(e.NotebookDocumentContentOptions=cn={}));var Kt;(function(Oe){function je(Y){return{uri:Y.uri,provides:Y.provides}}Oe.from=je;function Ee(Y){return new s.$IO(h.URI.revive(Y.uri),Y.provides)}Oe.to=Ee})(Kt||(e.NotebookRendererScript=Kt={}));var ft;(function(Oe){function je(Y){return{message:Z.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,contextValue:Y.contextValue,location:Y.location&&{range:S.from(Y.location.range),uri:Y.location.uri}}}Oe.from=je;function Ee(Y){const Te=new s.$OO(typeof Y.message=="string"?Y.message:Z.to(Y.message));return Te.actualOutput=Y.actual,Te.expectedOutput=Y.expected,Te.contextValue=Y.contextValue,Te.location=Y.location?le.to(Y.location):void 0,Te}Oe.to=Ee})(ft||(e.TestMessage=ft={}));var $t;(function(Oe){Oe.namespace=r.$2L,Oe.denamespace=r.$3L})($t||(e.TestTag=$t={}));var _t;(function(Oe){function je(Y){const Te=(0,i.$vP)(Y).controllerId;return{extId:u.$WL.fromExtHostTestItem(Y,Te).toString(),label:Y.label,uri:h.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(Qe=>$t.namespace(Te,Qe.id)),range:f.$ut.lift(S.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&Z.fromStrict(Y.error)||null}}Oe.from=je;function Ee(Y){return{parent:void 0,error:void 0,id:u.$WL.fromString(Y.extId).localId,label:Y.label,uri:h.URI.revive(Y.uri),tags:(Y.tags||[]).map(Te=>{const{tagId:Qe}=$t.denamespace(Te);return new s.$PO(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:S.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}Oe.toPlain=Ee})(_t||(e.TestItem=_t={})),function(Oe){function je(Y){return{id:Y.id}}Oe.from=je;function Ee(Y){return new s.$PO(Y.id)}Oe.to=Ee}($t||(e.TestTag=$t={}));var Xt;(function(Oe){const je=(Y,Te)=>{const Qe=Y.value;if(!Qe)return;const Ye={..._t.toPlain(Qe.item),parent:Te,taskStates:Qe.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(Y.children)for(const Ke of Y.children.values()){const ht=je(Ke,Ye);ht&&Ye.children.push(ht)}return Ye};function Ee(Y){const Te=new $.$oP;for(const Ke of Y.items)Te.insert(u.$WL.fromString(Ke.item.extId).path,Ke);const Qe=[Te.nodes],Ye=[];for(;Qe.length;)for(const Ke of Qe.pop())Ke.value?Ye.push(Ke):Ke.children&&Qe.push(Ke.children.values());return{completedAt:Y.completedAt,results:Ye.map(Ke=>je(Ke)).filter(w.$eg)}}Oe.to=Ee})(Xt||(e.TestResults=Xt={}));var jt;(function(Oe){function je(Qe){return{covered:Qe.covered,total:Qe.total}}function Ee(Qe){return"line"in Qe?D.from(Qe):S.from(Qe)}function Y(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:Ee(Qe.location),type:1,branches:Qe.branches.length?Qe.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&Ee(Ye.location),label:Ye.label})):void 0}:{type:0,name:Qe.name,count:Qe.executed,location:Ee(Qe.location)}}Oe.fromDetails=Y;function Te(Qe,Ye){return s.$RO(Ye.statementCoverage),s.$RO(Ye.branchCoverage),s.$RO(Ye.declarationCoverage),{id:Qe,uri:Ye.uri,statement:je(Ye.statementCoverage),branch:Ye.branchCoverage&&je(Ye.branchCoverage),declaration:Ye.declarationCoverage&&je(Ye.declarationCoverage)}}Oe.fromFile=Te})(jt||(e.TestCoverage=jt={}));var gt;(function(Oe){function je(Ee){switch(Ee){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Oe.to=je})(gt||(e.CodeActionTriggerKind=gt={}));var qt;(function(Oe){function je(Y){const Te=new s.$WO(ee.to(Y.kind),Y.name,Y.detail||"",h.URI.revive(Y.uri),S.to(Y.range),S.to(Y.selectionRange));return Te._sessionId=Y._sessionId,Te._itemId=Y._itemId,Te}Oe.to=je;function Ee(Y,Te,Qe){if(Te=Te??Y._sessionId,Qe=Qe??Y._itemId,Te===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Qe,kind:ee.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Oe.from=Ee})(qt||(e.TypeHierarchyItem=qt={}));var en;(function(Oe){function je(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Oe.from=je})(en||(e.ViewBadge=en={}));var Vt;(function(Oe){function je(Qe,Ye,Ke){const ht=Ye.fileData;return ht?new s.$4N(new s.$5N(ht.name,h.URI.revive(ht.uri),ht.id,(0,R.$db)(()=>Ke(ht.id)))):Qe===A.$Qs.uriList&&Ye.uriListData?new s.$3N(Te(Ye.uriListData)):new s.$3N(Ye.asString)}Oe.to=je;async function Ee(Qe,Ye){const Ke=await Ye.asString();if(Qe===A.$Qs.uriList)return{asString:Ke,fileData:void 0,uriListData:Y(Ke)};const ht=Ye.asFile();return{asString:Ke,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Oe.from=Ee;function Y(Qe){return L.$Ut.split(Qe).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return h.URI.parse(Ye)}catch{}return Ye})}function Te(Qe){return L.$Ut.create(Qe.map(Ye=>typeof Ye=="string"?Ye:h.URI.revive(Ye)))}})(Vt||(e.DataTransferItem=Vt={}));var Ze;(function(Oe){function je(Y,Te){const Qe=Y.items.map(([Ye,Ke])=>[Ye,Vt.to(Ye,Ke,Te)]);return new s.$6N(Qe)}Oe.toDataTransfer=je;async function Ee(Y){const Te={items:[]},Qe=[];for(const[Ye,Ke]of Y)Qe.push((async()=>{Te.items.push([Ye,await Vt.from(Ye,Ke)])})());return await Promise.all(Qe),Te}Oe.from=Ee})(Ze||(e.DataTransfer=Ze={}));var dn;(function(Oe){function je(Y,Te){return{kind:"reply",agentId:Y.participant??Te?.agentId??"",subCommand:Y.command??Te?.command,message:Y.prompt,title:Y.label}}Oe.from=je;function Ee(Y){return{prompt:Y.message,label:Y.title,participant:Y.agentId,command:Y.subCommand}}Oe.to=Ee})(dn||(e.ChatFollowup=dn={}));var Zt;(function(Oe){function je(Ee){return"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",when:Ee.when??"",args:Ee.args}:{kind:"reply",message:Ee.message,title:Ee.title,tooltip:Ee.tooltip}}Oe.from=je})(Zt||(e.ChatInlineFollowup=Zt={}));var Ht;(function(Oe){function je(Y){switch(Y.role){case 0:return new s.$jP(Y.content);case 1:return new s.$kP(Y.content);case 2:return new s.$lP(Y.content)}}Oe.to=je;function Ee(Y){if(Y instanceof s.$jP)return{role:0,content:Y.content};if(Y instanceof s.$kP)return{role:1,content:Y.content};if(Y instanceof s.$lP)return{role:2,content:Y.content};throw new Error("Invalid LanguageModelMessage")}Oe.from=Ee})(Ht||(e.LanguageModelMessage=Ht={}));var bt;(function(Oe){function je(Te){const Qe={};for(const Ye of Object.keys(Te))Qe[Ye]=Te[Ye].map(Oe.to);return Qe}Oe.objectTo=je;function Ee(Te){return{level:zt.to(Te.level),kind:Te.kind,value:(0,h.$vc)(Te.value)?h.URI.revive(Te.value):Te.value,description:Te.description}}Oe.to=Ee;function Y(Te){return{level:zt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Oe.from=Y})(bt||(e.ChatVariable=bt={}));var zt;(function(Oe){function je(Y){switch(Y){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Oe.to=je;function Ee(Y){switch(Y){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Oe.from=Ee})(zt||(e.ChatVariableLevel=zt={}));var Mt;(function(Oe){function je(Ee){switch(Ee){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Oe.to=je})(Mt||(e.InteractiveEditorResponseFeedbackKind=Mt={}));var Tt;(function(Oe){function je(Y){return{kind:"markdownContent",content:Z.from(Y.value)}}Oe.from=je;function Ee(Y){return new s.$0O(Z.to(Y.content))}Oe.to=Ee})(Tt||(e.ChatResponseMarkdownPart=Tt={}));var on;(function(Oe){function je(Y){return{kind:"markdownVuln",content:Z.from(Y.value),vulnerabilities:Y.vulnerabilities}}Oe.from=je;function Ee(Y){return new s.$$O(Z.to(Y.content),Y.vulnerabilities)}Oe.to=Ee})(on||(e.ChatResponseMarkdownWithVulnerabilitiesPart=on={}));var Gt;(function(Oe){function je(Y){return{kind:"agentDetection",agentId:Y.participant,command:Y.command}}Oe.from=je;function Ee(Y){return new s.$_O(Y.agentId,Y.command)}Oe.to=Ee})(Gt||(e.ChatResponseDetectedParticipantPart=Gt={}));var an;(function(Oe){function je(Y){const{value:Te,baseUri:Qe}=Y;function Ye(Ke,ht){return Ke.map(Et=>{const lt=h.URI.joinPath(ht,Et.name);return{label:Et.name,uri:lt,children:Et.children&&Ye(Et.children,lt)}})}return{kind:"treeData",treeData:{label:(0,v.$7g)(Qe),uri:Qe,children:Ye(Te,Qe)}}}Oe.from=je;function Ee(Y){const Te=(0,k.$6h)(Y.treeData);function Qe(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&Qe(Et.children)}))}const Ye=Te.uri,Ke=Te.children?Qe(Te.children):[];return new s.$aP(Ke,Ye)}Oe.to=Ee})(an||(e.ChatResponseFilesPart=an={}));var Lt;(function(Oe){function je(Y){return{kind:"inlineReference",name:Y.title,inlineReference:h.URI.isUri(Y.value)?Y.value:g.from(Y.value)}}Oe.from=je;function Ee(Y){const Te=(0,k.$6h)(Y);return new s.$bP(h.URI.isUri(Te.inlineReference)?Te.inlineReference:g.to(Te.inlineReference),Y.name)}Oe.to=Ee})(Lt||(e.ChatResponseAnchorPart=Lt={}));var Ft;(function(Oe){function je(Y){return{kind:"progressMessage",content:Z.from(Y.value)}}Oe.from=je;function Ee(Y){return new s.$cP(Y.content.value)}Oe.to=Ee})(Ft||(e.ChatResponseProgressPart=Ft={}));var Bt;(function(Oe){function je(Y){return{kind:"warning",content:Z.from(Y.value)}}Oe.from=je;function Ee(Y){return new s.$dP(Y.content.value)}Oe.to=Ee})(Bt||(e.ChatResponseWarningPart=Bt={}));var At;(function(Oe){function je(Y,Te,Qe){return{kind:"command",command:Te.toInternal(Y.value,Qe)??{command:Y.value.command,title:Y.value.title}}}Oe.from=je;function Ee(Y,Te){return new s.$eP(Te.fromInternal(Y.command)??{command:Y.command.id,title:Y.command.title})}Oe.to=Ee})(At||(e.ChatResponseCommandButtonPart=At={}));var pt;(function(Oe){function je(Y){return{kind:"textEdit",uri:Y.uri,edits:Y.edits.map(Te=>ae.from(Te))}}Oe.from=je;function Ee(Y){return new s.$gP(h.URI.revive(Y.uri),Y.edits.map(Te=>ae.to(Te)))}Oe.to=Ee})(pt||(e.ChatResponseTextEditPart=pt={}));var kt;(function(Oe){function je(Y){const Te=y.ThemeIcon.isThemeIcon(Y.iconPath)?Y.iconPath:Y.iconPath&&"light"in Y.iconPath&&"dark"in Y.iconPath&&h.URI.isUri(Y.iconPath.light)&&h.URI.isUri(Y.iconPath.dark)?{light:h.URI.revive(Y.iconPath.light),dark:h.URI.revive(Y.iconPath.dark)}:void 0;return"variableName"in Y.value?{kind:"reference",reference:{variableName:Y.value.variableName,value:h.URI.isUri(Y.value.value)||!Y.value.value?Y.value.value:g.from(Y.value.value)},iconPath:Te}:{kind:"reference",reference:h.URI.isUri(Y.value)?Y.value:g.from(Y.value),iconPath:Te}}Oe.from=je;function Ee(Y){const Te=(0,k.$6h)(Y),Qe=Ye=>h.URI.isUri(Ye)?Ye:g.to(Ye);return new s.$fP("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&Qe(Te.reference.value)}:Qe(Te.reference))}Oe.to=Ee})(kt||(e.ChatResponseReferencePart=kt={}));var un;(function(Oe){function je(Te,Qe,Ye){return Te instanceof s.$0O?Tt.from(Te):Te instanceof s.$bP?Lt.from(Te):Te instanceof s.$fP?kt.from(Te):Te instanceof s.$cP?Ft.from(Te):Te instanceof s.$aP?an.from(Te):Te instanceof s.$eP?At.from(Te,Qe,Ye):Te instanceof s.$gP?pt.from(Te):Te instanceof s.$$O?on.from(Te):Te instanceof s.$_O?Gt.from(Te):{kind:"markdownContent",content:Z.from("")}}Oe.from=je;function Ee(Te,Qe){switch(Te.kind){case"reference":return kt.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Y(Te,Qe)}}Oe.to=Ee;function Y(Te,Qe){switch(Te.kind){case"markdownContent":return Tt.to(Te);case"inlineReference":return Lt.to(Te);case"progressMessage":return;case"treeData":return an.to(Te);case"command":return At.to(Te,Qe)}}Oe.toContent=Y})(un||(e.ChatResponsePart=un={}));var Pt;(function(Oe){function je(Ee){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,variables:Ee.variables.variables.map(tn.to),location:mn.to(Ee.location)}}Oe.to=je})(Pt||(e.ChatAgentRequest=Pt={}));var mn;(function(Oe){function je(Ee){switch(Ee){case o.ChatAgentLocation.Notebook:return s.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return s.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return s.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return s.ChatLocation.Editor}}Oe.to=je})(mn||(e.ChatLocation=mn={}));var tn;(function(Oe){function je(Ee){const Y=Ee.values[0]?.value;if(!Y)throw new Error("Invalid value reference");return{name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],value:(0,h.$vc)(Y)?h.URI.revive(Y):Y}}Oe.to=je})(tn||(e.ChatAgentValueReference=tn={}));var wn;(function(Oe){function je(Ee,Y,Te){return{label:Ee.label,values:Ee.values.map(bt.from),insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:Y.toInternal(Ee.command,Te)}}Oe.from=je})(wn||(e.ChatAgentCompletionItem=wn={}));var ln;(function(Oe){function je(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Oe.to=je})(ln||(e.ChatAgentResult=ln={}));var vn;(function(Oe){function je(Ee,Y,Te){if(Y.action.kind==="vote")return;const Qe=ln.to(Ee);if(Y.action.kind==="command"){const Ye=Y.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Qe}}else return Y.action.kind==="followUp"?{action:{kind:"followUp",followup:dn.to(Y.action.followup)},result:Qe}:Y.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Y.action.action==="accepted"},result:Qe}:{action:Y.action,result:Qe}}Oe.to=je})(vn||(e.ChatAgentUserActionEvent=vn={}));var Rt;(function(Oe){function je(Ee,Y,Te){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:Y.toInternal(Ee,Te)}Oe.from=je})(Rt||(e.TerminalQuickFix=Rt={}));var Sn;(function(Oe){function je(Ee){return{kind:nn.to(Ee.kind)}}Oe.to=je})(Sn||(e.PartialAcceptInfo=Sn={}));var nn;(function(Oe){function je(Ee){switch(Ee){case 0:return s.PartialAcceptTriggerKind.Word;case 1:return s.PartialAcceptTriggerKind.Line;case 2:return s.PartialAcceptTriggerKind.Suggest;default:return s.PartialAcceptTriggerKind.Unknown}}Oe.to=je})(nn||(e.PartialAcceptTriggerKind=nn={}));var Ct;(function(Oe){function je(Ee,Y){return{id:Y,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Oe.from=je})(Ct||(e.DebugTreeItem=Ct={}))}),define(Se[333],De([1,0,6,20,16,48]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;let N=class{constructor(m,k){this.a=m.getProxy(d.$$M.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>k.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,k,A){const C=new R.$Bw(L.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(C,void 0,A?.isRefactoring??!1)}};e.$vlc=N,e.$vlc=N=Ge([We(0,O.$zP)],N)}),define(Se[334],De([1,0,19,7,47,4,39,3,40,18,2,25,6,16,8,297,26]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class a{constructor(o,t,u,r,c){this.j=o,this.k=t,this.l=u,this.m=r,this.n=c,this.b=m.$_d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(r){if(o.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,r),c}};const o=this;this.b.reset();const u=r=>{typeof this.d>"u"&&"content"in r&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.g={markdown(r){t(this.markdown);const c=new w.$0O(r),s=v.ChatResponseMarkdownPart.from(c);return u(s),this},markdownWithVulnerabilities(r,c){t(this.markdown),c&&(0,f.$PG)(o.j,"chatParticipantAdditions");const s=new w.$$O(r,c),y=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(s);return u(y),this},filetree(r,c){t(this.filetree);const s=new w.$aP(r,c),y=v.ChatResponseFilesPart.from(s);return u(y),this},anchor(r,c){t(this.anchor);const s=new w.$bP(r,c),y=v.ChatResponseAnchorPart.from(s);return u(y),this},button(r){t(this.anchor);const c=new w.$eP(r),s=v.ChatResponseCommandButtonPart.from(c,o.m,o.n);return u(s),this},progress(r){t(this.progress);const c=new w.$cP(r),s=v.ChatResponseProgressPart.from(c);return u(s),this},warning(r){t(this.progress);const c=new w.$dP(r),s=v.ChatResponseWarningPart.from(c);return u(s),this},reference(r,c){if(t(this.reference),"variableName"in r&&!r.value){const s=o.k.variables.variables.find(y=>y.name===r.variableName);if(s){let y;if(s.references?.length)y=s.references.map(b=>({kind:"reference",reference:{variableName:r.variableName,value:b.reference}}));else{const b=new w.$fP(r,c);y=[v.ChatResponseReferencePart.from(b)]}return y.forEach(b=>u(b)),this}}else{const s=new w.$fP(r,c),y=v.ChatResponseReferencePart.from(s);u(y)}return this},textEdit(r,c){t(this.textEdit),(0,f.$PG)(o.j,"chatParticipantAdditions");const s=new w.$gP(r,c),y=v.ChatResponseTextEditPart.from(s);return u(y),this},detectedParticipant(r,c){t(this.detectedParticipant),(0,f.$PG)(o.j,"chatParticipantAdditions");const s=new w.$_O(r,c),y=v.ChatResponseDetectedParticipantPart.from(s);return u(y),this},push(r){if(t(this.push),(r instanceof w.$gP||r instanceof w.$$O||r instanceof w.$_O)&&(0,f.$PG)(o.j,"chatParticipantAdditions"),r instanceof w.$fP)this.reference(r.value,r.iconPath);else{const c=v.ChatResponsePart.from(r,o.m,o.n);u(c)}return this}}}return this.g}}class n extends p.$Uc{static{this.b=0}constructor(o,t,u){super(),this.n=t,this.s=u,this.c=new Map,this.j=this.B(new p.$4c),this.m=this.B(new p.$4c),this.g=o.getProxy($.$$M.MainThreadChatAgents2)}transferActiveChat(o){this.g.$transferActiveChatSession(o)}createChatAgent(o,t,u){const r=n.b++,c=new i(o,t,this.g,r,u);return this.c.set(r,c),this.g.$registerAgent(r,o.identifier,t,{},void 0),c.apiAgent}createDynamicChatAgent(o,t,u,r,c){const s=n.b++,y=new i(o,t,this.g,s,c);return this.c.set(s,y),this.g.$registerAgent(s,o.identifier,t,{isSticky:!0},{name:u,description:r}),y.apiAgent}async $invokeAgent(o,t,u,r){const c=this.c.get(o);if(!c)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let s=this.j.get(t.sessionId);s||(s=new p.$Tc,this.j.set(t.sessionId,s));const y=new a(c.extension,t,this.g,this.s.converter,s);try{const b=await this.t(t.agentId,u),S=c.invoke(v.ChatAgentRequest.to(t),{history:b},y.apiObject,r);return await(0,O.$kh)(Promise.resolve(S).then(g=>{if(g?.metadata)try{JSON.stringify(g.metadata)}catch(E){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.n.error(`[${c.extension.identifier.value}] [@${c.id}] ${D}`,c.extension),{errorDetails:{message:D},timings:y.timings}}return{errorDetails:g?.errorDetails,timings:y.timings,metadata:g?.metadata}}),r)}catch(b){return this.n.error(b,c.extension),{errorDetails:{message:(0,L.$hj)(b),responseIsIncomplete:!0}}}finally{y.close()}}async t(o,t){const u=[];for(const r of t.history){const c=v.ChatAgentResult.to(r.result),s=o===r.request.agentId?c:{...c,metadata:void 0};u.push(new w.$hP(r.request.message,r.request.command,r.request.variables.variables.map(v.ChatAgentValueReference.to),r.request.agentId));const y=(0,d.$Hb)(r.response.map(b=>v.ChatResponsePart.toContent(b,this.s.converter)));u.push(new w.$iP(y,s,r.request.agentId,r.request.command))}return u}$releaseSession(o){this.j.deleteAndDispose(o)}async $provideFollowups(o,t,u,r,c){const s=this.c.get(t);if(!s)return Promise.resolve([]);const y=await this.t(s.id,r),b=v.ChatAgentResult.to(u);return(await s.provideFollowups(b,{history:y},c)).filter(S=>{const g=!S.participant||N.Iterable.some(this.c.values(),E=>E.id===S.participant&&C.$Rm.equals(E.extension.identifier,s.extension.identifier));return g||this.n.warn(`[@${s.id}] ChatFollowup refers to an unknown participant: ${S.participant}`),g}).map(S=>v.ChatFollowup.from(S,o))}$acceptFeedback(o,t,u,r){const c=this.c.get(o);if(!c)return;const s=v.ChatAgentResult.to(t);let y;switch(u){case h.InteractiveSessionVoteDirection.Down:y=w.ChatResultFeedbackKind.Unhelpful;break;case h.InteractiveSessionVoteDirection.Up:y=w.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(r?{result:s,kind:y,reportIssue:r}:{result:s,kind:y}))}$acceptAction(o,t,u){const r=this.c.get(o);if(!r||u.action.kind==="vote")return;const c=v.ChatAgentUserActionEvent.to(t,u,this.s.converter);c&&r.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(o,t,u){const r=this.c.get(o);if(!r)return[];let c=this.m.get(o);return c?c.clear():(c=new p.$Tc,this.m.set(o,c)),(await r.invokeCompletionProvider(t,u)).map(y=>v.ChatAgentCompletionItem.from(y,this.s.converter,c))}async $provideWelcomeMessage(o,t,u){const r=this.c.get(o);if(r)return await r.provideWelcomeMessage(v.ChatLocation.to(t),u)}async $provideSampleQuestions(o,t,u){const r=this.c.get(o);if(r)return(await r.provideSampleQuestions(v.ChatLocation.to(t),u)).map(c=>v.ChatFollowup.from(c,void 0))}}e.$wlc=n;class i{constructor(o,t,u,r,c){this.extension=o,this.id=t,this.u=u,this.w=r,this.x=c,this.n=new R.$de,this.o=new R.$de}acceptFeedback(o){this.n.fire(o)}acceptAction(o){this.o.fire(o)}async invokeCompletionProvider(o,t){return this.q?await this.q.provider.provideCompletionItems(o,t)??[]:[]}async provideFollowups(o,t,u){if(!this.b)return[];const r=await this.b.provideFollowups(o,t,u);return r?r.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(o,t){if(!this.s)return[];const u=await this.s.provideWelcomeMessage(o,t);return u?u.map(r=>typeof r=="string"?r:v.MarkdownString.from(r)):[]}async provideSampleQuestions(o,t){if(!this.s||!this.s.provideSampleQuestions)return[];const u=await this.s.provideSampleQuestions(o,t);return u||[]}get apiAgent(){let o=!1,t=!1;const u=()=>{o||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof w.$0N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,f.$PG)(r.extension,"defaultChatParticipant"),r.c??r.extension.displayName??r.extension.name},set fullName(c){(0,f.$PG)(r.extension,"defaultChatParticipant"),r.c=c,u()},get iconPath(){return r.d},set iconPath(c){r.d=c,u()},get requestHandler(){return r.x},set requestHandler(c){(0,k.$gg)(typeof c=="function","Invalid request handler"),r.x=c},get followupProvider(){return r.b},set followupProvider(c){r.b=c,u()},get isDefault(){return(0,f.$PG)(r.extension,"defaultChatParticipant"),r.g},set isDefault(c){(0,f.$PG)(r.extension,"defaultChatParticipant"),r.g=c,u()},get helpTextPrefix(){return(0,f.$PG)(r.extension,"defaultChatParticipant"),r.j},set helpTextPrefix(c){(0,f.$PG)(r.extension,"defaultChatParticipant"),r.j=c,u()},get helpTextVariablesPrefix(){return(0,f.$PG)(r.extension,"defaultChatParticipant"),r.k},set helpTextVariablesPrefix(c){(0,f.$PG)(r.extension,"defaultChatParticipant"),r.k=c,u()},get helpTextPostfix(){return(0,f.$PG)(r.extension,"defaultChatParticipant"),r.l},set helpTextPostfix(c){(0,f.$PG)(r.extension,"defaultChatParticipant"),r.l=c,u()},get isSecondary(){return(0,f.$PG)(r.extension,"defaultChatParticipant"),r.m},set isSecondary(c){(0,f.$PG)(r.extension,"defaultChatParticipant"),r.m=c,u()},get supportIssueReporting(){return(0,f.$PG)(r.extension,"chatParticipantAdditions"),r.p},set supportIssueReporting(c){(0,f.$PG)(r.extension,"chatParticipantAdditions"),r.p=c,u()},get onDidReceiveFeedback(){return r.n.event},set participantVariableProvider(c){if((0,f.$PG)(r.extension,"chatParticipantAdditions"),r.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");r.u.$registerAgentCompletionsProvider(r.w,c.triggerCharacters)}else r.u.$unregisterAgentCompletionsProvider(r.w)},get participantVariableProvider(){return(0,f.$PG)(r.extension,"chatParticipantAdditions"),r.q},set welcomeMessageProvider(c){(0,f.$PG)(r.extension,"defaultChatParticipant"),r.s=c,u()},get welcomeMessageProvider(){return(0,f.$PG)(r.extension,"defaultChatParticipant"),r.s},onDidPerformAction:(0,f.$OG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){r.t=c,u()},get requester(){return r.t},dispose(){o=!0,r.b=void 0,r.n.dispose(),r.u.$unregisterAgent(r.w)}}}invoke(o,t,u,r){return this.x(o,t,u,r)}}}),define(Se[335],De([1,0,13,3,6,16,8,26]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class m{static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$$M.MainThreadChatVariables)}async $resolveVariable(C,$,v,w){const h=this.b.get(C);if(h)try{if(h.resolver.resolve2){(0,p.$PG)(h.extension,"chatParticipantAdditions");const f=new k($,this.c),a=await h.resolver.resolve2(h.data.name,{prompt:v},f.apiObject,w);if(a)return a.map(R.ChatVariable.from)}else{const f=await h.resolver.resolve(h.data.name,{prompt:v},w);if(f)return f.map(R.ChatVariable.from)}}catch(f){(0,d.$2)(f)}}registerVariableResolver(C,$,v,w){const h=m.a++;return this.b.set(h,{extension:C,data:{name:$,description:v},resolver:w}),this.c.$registerVariable(h,{name:$,description:v}),(0,O.$Sc)(()=>{this.b.delete(h),this.c.$unregisterVariable(h)})}}e.$xlc=m;class k{constructor(C,$){this.c=C,this.d=$,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let $=function(w){if(C.a){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,w),h}};const C=this,v=w=>{this.d.$handleProgressChunk(this.c,w)};this.b={progress(w){$(this.progress);const h=new N.$cP(w),f=R.ChatResponseProgressPart.from(h);return v(f),this},reference(w){$(this.reference);const h=new N.$fP(w),f=R.ChatResponseReferencePart.from(h);return v(f),this},push(w){return $(this.push),w instanceof N.$fP?v(R.ChatResponseReferencePart.from(w)):w instanceof N.$cP&&v(R.ChatResponseProgressPart.from(w)),this}}}return this.b}}}),define(Se[336],De([1,0,7,56,4,3,2,84,25,16,8,6,26]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=v;function v(w,h,f){const a=w.getProxy(C.$$M.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Tm,h.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const S=this.b.get(b.handle);return S?S.value:b}else if(b&&b.$mid===7){const S=b,g=this.b.get(S.commentControlHandle);if(!g)return S;const E=g.getCommentThread(S.commentThreadHandle);return E?E.value:S}else if(b&&(b.$mid===9||b.$mid===8)){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const g=S.getCommentThread(b.thread.commentThreadHandle);return g?b.$mid===8?g.value:{thread:g.value,text:b.text}:b}else if(b&&b.$mid===10){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const g=S.getCommentThread(b.thread.commentThreadHandle);if(!g)return b;const E=b.commentUniqueId,D=g.getCommentByUniqueId(E);return D||b}else if(b&&b.$mid===11){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const g=S.getCommentThread(b.thread.commentThreadHandle);if(!g)return b;const E=b.text,D=b.commentUniqueId,P=g.getCommentByUniqueId(D);return P?(typeof P.body=="string"?P.body=E:P.body=new A.$CN(E),P):b}return b}})}createCommentController(b,S,g){const E=n.a++,D=new l(b,E,S,g);this.b.set(D.handle,D);const P=this.c.get(b.identifier)||[];return P.push(D),this.c.set(b.identifier,P),D.value}async $createCommentThreadTemplate(b,S,g){const E=this.b.get(b);E&&E.$createCommentThreadTemplate(S,g)}async $setActiveComment(b,S){const g=this.b.get(b);g&&g.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(b,S,g){const E=this.b.get(b);E&&E.$updateCommentThreadTemplate(S,g)}$deleteCommentThread(b,S){this.b.get(b)?.$deleteCommentThread(S)}async $provideCommentingRanges(b,S,g){const E=this.b.get(b);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const D=await f.ensureDocumentData(N.URI.revive(S));return(0,d.$oh)(async()=>{const P=await E.commentingRangeProvider.provideCommentingRanges(D.document,g);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(F=>k.Range.from(F)),fileComments:P.fileComments}),I})}$toggleReaction(b,S,g,E,D){const P=this.b.get(b);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,d.$oh)(()=>{const I=P.getCommentThread(S);if(I){const F=I.getCommentByUniqueId(E.uniqueIdInThread);if(P!==void 0&&F&&P.reactionHandler)return P.reactionHandler(F,u(D))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,$.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,S,g,E,D,P,I,F){this.m=S,this.n=g,this.o=E,this.p=D,this.q=P,this.extensionDescription=I,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$de,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${b}.${this.handle}`),a.$createCommentThread(S,this.handle,this.n,this.o,k.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{a.$deleteCommentThread(S,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(z){T.range=z},get comments(){return T.comments},set comments(z){T.comments=z},get collapsibleState(){return T.collapsibleState},set collapsibleState(z){T.collapsibleState=z},get canReply(){return T.canReply},set canReply(z){T.canReply=z},get contextValue(){return T.contextValue},set contextValue(z){T.contextValue=z},get label(){return T.label},set label(z){T.label=z},get state(){return T.state},set state(z){T.state=z},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const b=g=>Object.prototype.hasOwnProperty.call(this.b,g),S={};b("range")&&(S.range=k.Range.from(this.p)),b("label")&&(S.label=this.label),b("contextValue")&&(S.contextValue=this.contextValue??null),b("comments")&&(S.comments=this.q.map(g=>o(this,g,this.k,this.extensionDescription))),b("collapsibleState")&&(S.collapseState=r(this.g)),b("canReply")&&(S.canReply=this.canReply),b("state")&&(S.state=c(this.h)),b("applicability")&&(S.applicability=s(this.h)),b("isTemplate")&&(S.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(b){for(const S of this.k){const g=S[0],E=S[1];if(b===E)return g}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Ge([(0,O.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class l{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,$.$PG)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,$.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,$.$PG)(this.h,"activeComment"),this.f}constructor(b,S,g,E){this.h=b,this.i=S,this.j=g,this.k=E,this.a=new Map,a.$registerCommentController(this.handle,g,E,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(P){D.options=P},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(P){D.commentingRangeProvider=P},get reactionHandler(){return D.reactionHandler},set reactionHandler(P){D.reactionHandler=P},get activeCommentThread(){return D.activeCommentThread},createCommentThread(P,I,F){return D.createCommentThread(P,I,F).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(b,S,g){S===void 0&&(0,$.$PG)(this.h,"fileComments");const E=new i(this.id,this.handle,void 0,b,S,g,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const S=this.a.get(b.commentThreadHandle);S&&(this.e=b.uniqueIdInThread?S.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(b,S){const g=new i(this.id,this.handle,void 0,N.URI.revive(b),k.Range.to(S),[],this.h,!0);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(b,S){const g=this.a.get(b);g&&(g.range=k.Range.to(S))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function o(y,b,S,g){let E=S.get(b);return E||(E=++y.commentHandle,S.set(b,E)),b.state!==void 0&&(0,$.$PG)(g,"commentsDraftState"),b.reactions?.some(D=>D.reactors!==void 0)&&(0,$.$PG)(g,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:E,body:typeof b.body=="string"?b.body:k.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(D=>t(D)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function t(y){return{label:y.label,iconPath:y.iconPath?k.$yP(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted,reactors:y.reactors&&y.reactors.length>0&&typeof y.reactors[0]!="string"?y.reactors.map(b=>b.name):y.reactors}}function u(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?N.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1,reactors:y.reactors?.map(b=>({name:b}))}}function r(y){if(y!==void 0)switch(y){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function c(y){let b;if(typeof y=="object"?b=y.resolved:b=y,b!==void 0)switch(b){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function s(y){let b;if(typeof y=="object"&&(b=y.applicability),b!==void 0)switch(b){case A.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Se[337],De([1,0,22,57,3,15,23,2,16,92,112,6,8]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class v{constructor(u,r){this.document=u,this.b=r,this.a=1,this.c=new A.$hlc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,r){await this.f(u).undo(),r||this.disposeBackup()}async redo(u,r){await this.f(u).redo(),r||this.disposeBackup()}disposeEdits(u){for(const r of u)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=o(this.document.uri)+this.a++;return(0,N.$0g)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const r=this.c.get(u,0);if(!r)throw new Error("No edit found");return r}}class w{constructor(){this.a=new Map}get(u,r){return this.a.get(this.b(u,r))}add(u,r,c){const s=this.b(u,r.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${u} resource:${r.uri}`);const y=new v(r,c);return this.a.set(s,y),y}delete(u,r){const c=this.b(u,r.uri);this.a.delete(c)}b(u,r){return`${u}@@@${r}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class f{constructor(){this.a=new Map}addTextProvider(u,r,c){return this.b(u,{type:0,extension:r,provider:c})}addCustomProvider(u,r,c){return this.b(u,{type:1,extension:r,provider:c})}get(u){return this.a.get(u)}b(u,r){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,r),new $.$aN(()=>this.a.delete(u))}}class a{constructor(u,r,c,s,y){this.d=r,this.f=c,this.g=s,this.h=y,this.b=new f,this.c=new w,this.a=u.getProxy(C.$$M.MainThreadCustomEditors)}registerCustomEditorProvider(u,r,c,s){const y=new L.$Tc;return i(c)?(y.add(this.b.addTextProvider(r,u,c)),this.a.$registerTextEditorProvider((0,k.$Qlc)(u),r,s.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,k.$Olc)(u))):(y.add(this.b.addCustomProvider(r,u,c)),n(c)&&y.add(c.onDidChangeCustomDocument(b=>{const S=this.i(r,b.document.uri);if(l(b)){const g=S.addEdit(b);this.a.$onDidEdit(b.document.uri,r,g,b.label)}else this.a.$onContentChange(b.document.uri,r)})),this.a.$registerCustomEditorProvider((0,k.$Qlc)(u),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,k.$Olc)(u))),$.$aN.from(y,new $.$aN(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(u,r,c,s,y){const b=this.b.get(r);if(!b)throw new Error(`No provider found for '${r}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${r}'`);const S=p.URI.revive(u),g=await b.provider.openCustomDocument(S,{backupId:c,untitledDocumentData:s?.buffer},y);let E;return n(b.provider)&&this.f&&(E=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(r,g,E),{editable:n(b.provider)}}async $disposeCustomDocument(u,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=p.URI.revive(u),{document:y}=this.i(r,s);this.c.delete(r,y),y.dispose()}async $resolveCustomEditor(u,r,c,s,y,b){const S=this.b.get(c);if(!S)throw new Error(`No provider found for '${c}'`);const g=m.ViewColumn.to(y),E=this.g.createNewWebview(r,s.contentOptions,S.extension),D=this.h.createNewWebviewPanel(r,c,s.title,g,s.options,E,s.active),P=p.URI.revive(u);switch(S.type){case 1:{const{document:I}=this.i(c,P);return S.provider.resolveCustomEditor(I,D,b)}case 0:{const I=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(I,D,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,r,c){this.i(r,u).disposeEdits(c)}async $onMoveCustomEditor(u,r,c){const s=this.b.get(c);if(!s)throw new Error(`No provider found for '${c}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const y=this.h.getWebviewPanel(u);if(!y)throw new Error("No webview found");const b=p.URI.revive(r),S=this.d.getDocument(b);await s.provider.moveCustomTextEditor(S,y,d.CancellationToken.None)}async $undo(u,r,c,s){return this.i(r,u).undo(c,s)}async $redo(u,r,c,s){return this.i(r,u).redo(c,s)}async $revert(u,r,c){const s=this.i(r,u);await this.j(r).revertCustomDocument(s.document,c),s.disposeBackup()}async $onSave(u,r,c){const s=this.i(r,u);await this.j(r).saveCustomDocument(s.document,c),s.disposeBackup()}async $onSaveAs(u,r,c,s){const y=this.i(r,u);return this.j(r).saveCustomDocumentAs(y.document,p.URI.revive(c),s)}async $backup(u,r,c){const s=this.i(r,u),b=await this.j(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},c);return s.updateBackup(b),b.id}i(u,r){const c=this.c.get(u,p.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(u){const c=this.b.get(u)?.provider;if(!c||!n(c))throw new Error("Custom document is not editable");return c}}e.$Tlc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function l(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const u=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,O.$kj)(u)+""}}),define(Se[338],De([1,0,224,139,2,6,8,16,4,11,27,60]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0;class v{#e;#t;#n;constructor(f,a,n,i,l,o,t,u){this.d=f,this.e=a,this.f=n,this.g=i,this.h=l,this.c=!1,this.f=Math.max(i,n),this.#n=new A.$Ac(r=>o.getComparisonKey(r)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,a){if(!f){this.clear();return}this.j();let n=[];if(L.URI.isUri(f)){if(!a){this.delete(f);return}this.#n.set(f,a.slice()),n=[f]}else if(Array.isArray(f)){n=[];let o;f=[...f].sort(v.k);for(const t of f){const[u,r]=t;if((!o||u.toString()!==o.toString())&&(o&&this.#n.get(o).length===0&&this.#n.delete(o),o=u,n.push(u),this.#n.set(u,[])),r)this.#n.get(u)?.push(...r);else{const c=this.#n.get(u);c&&(c.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let l=0;for(const o of n){let t=[];const u=this.#n.get(o);if(u)if(u.length>this.g){t=[];const r=[N.DiagnosticSeverity.Error,N.DiagnosticSeverity.Warning,N.DiagnosticSeverity.Information,N.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const s of u)if(s.severity===r[c]&&t.push({...p.Diagnostic.from(s),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,d.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(r=>({...p.Diagnostic.from(r),modelVersionId:this.h(o)}));if(i.push([o,t]),l+=t.length,l>this.f)break}this.#e.$changeMany(this.e,i)}delete(f){this.j(),this.#t.fire([f]),this.#n.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(f,a){this.j();for(const[n,i]of this)f.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const f of this.#n.keys())yield[f,this.get(f)]}get(f){this.j();const a=this.#n.get(f);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#n.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,a){return f[0].toString()<a[0].toString()?-1:f[0].toString()>a[0].toString()?1:0}}e.$olc=v;let w=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(f){const a=new A.$Ac;for(const n of f)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(f,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new m.$he({merge:l=>l.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,$._mapper),this.f=f.getProxy(R.$$M.MainThreadDiagnostics)}createDiagnosticCollection(f,a){const{g:n,f:i,h:l,j:o,k:t,l:u}=this,r=new class{$changeMany(y,b){i.$changeMany(y,b),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,y,b.length===0?"CLEARING":b)}$clear(y){i.$clear(y),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,y)}dispose(){i.dispose()}};let c;if(!a)a="_generated_diagnostic_collection_name_#"+$.c++,c=a;else if(!n.has(a))c=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do c=a+$.c++;while(n.has(c))}return new class extends v{constructor(){super(a,c,$.e,$.d,y=>u.getDocument(y)?.version,t.extUri,r,l),n.set(c,this)}dispose(){super.dispose(),n.delete(c)}}}getDiagnostics(f){if(f)return this.m(f);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((l,o)=>{let t=a.get(l.toString());typeof t>"u"&&(t=n.length,a.set(l.toString(),t),n.push([l,[]])),n[t][1]=n[t][1].concat(...o)});return n}}m(f){let a=[];for(const n of this.g.values())n.has(f)&&(a=a.concat(n.get(f)));return a}$acceptMarkersChange(f){if(!this.n){const a="_generated_mirror",n=new v(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of f)this.n.set(L.URI.revive(a),n.map(p.Diagnostic.to))}};e.$plc=w,e.$plc=w=$=Ge([We(1,k.$3j),We(2,C.$nlc)],w)}),define(Se[339],De([1,0,2,13,8,16,76,48]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class m{constructor(A,C,$,v={timeout:1500,errors:3}){this.c=A,this.d=C,this.f=$,this.g=v,this.a=new N.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(C,$,v)=>{const h={dispose:this.a.push([C,$,A])};return Array.isArray(v)&&v.push(h),h}}async $participateInSave(A,C){const $=d.URI.revive(A);let v=!1;const w=setTimeout(()=>v=!0,this.g.timeout),h=[];try{for(const f of[...this.a]){if(v)break;const a=this.d.getDocument($),n=await this.h(f,{document:a,reason:R.TextDocumentSaveReason.to(C)});h.push(n)}}finally{clearTimeout(w)}return h}h([A,C,$],v){const w=this.b.get(A);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i($,A,C,v).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const f=this.b.get(A);this.b.set(A,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,C,$,v){const w=[],h=Date.now(),{document:f,reason:a}=v,{version:n}=f,i=Object.freeze({document:f,reason:a,waitUntil(l){if(Object.isFrozen(w))throw(0,O.$8)("waitUntil can not be called async");w.push(Promise.resolve(l))}});try{C.apply($,[i])}catch(l){return Promise.reject(l)}return Object.freeze(w),new Promise((l,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(w).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(t),l(u)}).catch(u=>{clearTimeout(t),o(u)})}).then(l=>{const o={edits:[]};for(const t of l)if(Array.isArray(t)&&t.every(u=>u instanceof L.$hN))for(const{newText:u,newEol:r,range:c}of t)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:u,eol:r&&R.EndOfLine.from(r)}});if(o.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(new p.$Bw(o)):Promise.reject(new Error("concurrent_edits"))})}}e.$xmc=m}),define(Se[340],De([1,0,4,3,2,6,153,16,18,24,8]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class C{constructor(v,w){this.a=new d.$de,this.b=new d.$de,this.c=new d.$de,this.d=new d.$de,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=v.getProxy(R.$$M.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(h=>{for(const f of h)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const f of h)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const w=this.g.getDocument(v);if(w)return w}getDocument(v){const w=this.getDocumentData(v);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return w.document}ensureDocumentData(v){const w=this.g.getDocument(v);if(w)return Promise.resolve(w);let h=this.h.get(v.toString());return h||(h=this.f.$tryOpenDocument(v).then(f=>{this.h.delete(v.toString());const a=L.URI.revive(f);return(0,m.$hg)(this.g.getDocument(a))},f=>(this.h.delete(v.toString()),Promise.reject(f))),this.h.set(v.toString(),h)),h}createDocumentData(v){return this.f.$tryCreateDocument(v).then(w=>L.URI.revive(w))}$acceptModelLanguageChanged(v,w){const h=L.URI.revive(v),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(w),this.a.fire(f.document)}$acceptModelSaved(v){const w=L.URI.revive(v),h=this.g.getDocument(w);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(v,w){const h=L.URI.revive(v),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");f._acceptIsDirty(w),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,w,h){const f=L.URI.revive(v),a=this.g.getDocument(f);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),a.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,k.$4n)({document:a.document,contentChanges:w.changes.map(i=>({range:p.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(v,w){(0,N.$BP)(v,w)}}e.$qlc=C}),define(Se[72],De([1,0,74,4,18,2,5,6,20,16,8]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0,e.$Ulc=(0,N.$wi)("IExtHostEditorTabs");class C{constructor(f,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$XO(R.URI.revive(this.b.input.uri));case 2:return new A.$YO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$ZO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$1O(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$2O(this.b.input.viewType);case 4:return new A.$3O(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$4O(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$5O;case 9:return new A.$6O(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$7O;case 11:return new A.$8O(this.b.input.diffEditors.map(f=>new A.$YO(R.URI.revive(f.original),R.URI.revive(f.modified))));default:return}}}class ${constructor(f,a){this.c=[],this.d="",this.b=f,this.e=a;for(const n of f.tabs)n.isActive&&(this.d=n.id),this.c.push(new C(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return k.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(n=>n.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const n=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,n),f.tabDto.isActive&&(this.d=n.tabId),n}else if(f.kind===1){const n=this.c.splice(f.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(f.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,n),n}const a=this.c.find(n=>n.tabId===f.tabDto.id);if(!a)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(f.tabDto),a}activeTabId(){return this.d}}let v=class{constructor(f){this.b=new O.$de,this.c=new O.$de,this.e=[],this.a=f.getProxy(p.$$M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,a={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(n=>n.apiObject))},get activeTabGroup(){const n=f.d;return(0,L.$hg)(f.e.find(l=>l.groupId===n)?.apiObject)},close:async(n,i)=>{const l=Array.isArray(n)?n:[n];return l.length?w(l[0])?this.j(l,i):this.i(l,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(f){const a=new Set(this.e.map(r=>r.groupId)),n=new Set(f.map(r=>r.groupId)),i=(0,d.$L)(a,n),l=this.e.filter(r=>i.removed.includes(r.groupId)).map(r=>r.apiObject),o=[],t=[];this.e=f.map(r=>{const c=new $(r,()=>this.d);return i.added.includes(c.groupId)?o.push(c.apiObject):t.push(c.apiObject),c});const u=(0,L.$hg)(f.find(r=>r.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:o,closed:l,changed:t}))}$acceptTabGroupUpdate(f){const a=this.e.find(n=>n.groupId===f.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const a=this.e.find(i=>i.groupId===f.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(f){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===f)return n}h(f){return this.e.find(a=>a.apiObject===f)}async i(f,a){const n=[];for(const i of f){const l=this.g(i);if(!l)throw new Error("Tab close: Invalid tab not found!");n.push(l.tabId)}return this.a.$closeTab(n,a)}async j(f,a){const n=[];for(const i of f){const l=this.h(i);if(!l)throw new Error("Group close: Invalid group not found!");n.push(l.groupId)}return this.a.$closeGroup(n,a)}};e.$Vlc=v,e.$Vlc=v=Ge([We(0,m.$zP)],v);function w(h){return h.tabs!==void 0}}),define(Se[341],De([1,0,2,6,3,8,16,185,14,21,26,81]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class ${constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const f=this.a.indexOf(h);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),f=[];let a,n,i=14,l=14;for(const o of h){let t=a?(0,m.$zf)(a,o):0;for(t===0?n=1:n=l;t<o.length;t++)t+1===o.length?(i=l,l=9):l+=1,f.push([n,o.toUpperCase().charCodeAt(t),l]),f.push([n,o.toLowerCase().charCodeAt(t),l]),n=l;a=o,l=i}f.push([9,58,10]),f.push([10,47,12]),this.b=new p.$w3(f)}}provideDocumentLinks(h){this.c();const f=[],a=p.$x3.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of a){const i=N.DocumentLink.to(n);i.target&&f.push(i)}return f}}class v{constructor(h,f){this.i=f,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(O.$$M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,f,a,n={}){if(v.j(a),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const i=this.h++;this.b.add(f),this.d.add(f),this.c.set(i,a);let l=2;n.isCaseSensitive&&(l+=1024),n.isReadonly&&(l+=2048),typeof a.copy=="function"&&(l+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,A.$PG)(h,"fsChunks"),l+=4);let o;n.isReadonly&&(0,C.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(o={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,f,l,o).catch(u=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${f}`),console.error(u)});const t=a.onDidChangeFile(u=>{const r=[];for(const c of u){const{uri:s,type:y}=c;if(s.scheme!==f)continue;let b;switch(y){case R.FileChangeType.Changed:b=0;break;case R.FileChangeType.Created:b=1;break;case R.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:s,type:b})}this.a.$onFileSystemChange(i,r)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:f,ctime:a,mtime:n,size:i,permissions:l}=h;return{type:f,ctime:a,mtime:n,size:i,permissions:l}}$stat(h,f){return Promise.resolve(this.l(h).stat(d.URI.revive(f))).then(a=>v.k(a))}$readdir(h,f){return Promise.resolve(this.l(h).readDirectory(d.URI.revive(f)))}$readFile(h,f){return Promise.resolve(this.l(h).readFile(d.URI.revive(f))).then(a=>k.$Fe.wrap(a))}$writeFile(h,f,a,n){return Promise.resolve(this.l(h).writeFile(d.URI.revive(f),a.buffer,n))}$delete(h,f,a){return Promise.resolve(this.l(h).delete(d.URI.revive(f),a))}$rename(h,f,a,n){return Promise.resolve(this.l(h).rename(d.URI.revive(f),d.URI.revive(a),n))}$copy(h,f,a,n){const i=this.l(h);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(d.URI.revive(f),d.URI.revive(a),n))}$mkdir(h,f){return Promise.resolve(this.l(h).createDirectory(d.URI.revive(f)))}$watch(h,f,a,n){const i=this.l(h).watch(d.URI.revive(a),n);this.f.set(f,i)}$unwatch(h,f){const a=this.f.get(f);a&&(a.dispose(),this.f.delete(f))}$open(h,f,a){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(d.URI.revive(f),a))}$close(h,f){const a=this.l(h);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(f))}$read(h,f,a,n){const i=this.l(h);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const l=k.$Fe.alloc(n);return Promise.resolve(i.read(f,a,l.buffer,0,n)).then(o=>l.slice(0,o))}$write(h,f,a,n){const i=this.l(h);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(f,a,n.buffer,0,n.byteLength))}l(h){const f=this.c.get(h);if(!f){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return f}}e.$zmc=v}),define(Se[342],De([1,0,4,35,2,6,16,8,46]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,w,h,f,a,n){this.a=Math.random(),this.b=new d.$de,this.c=new d.$de,this.d=new d.$de,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$qk)(a),l=typeof a=="string",o=n?.correlate,t=f(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(o&&typeof u.session>"u")){if(!n?.ignoreCreateEvents)for(const r of u.created){const c=L.URI.revive(r);i(c.fsPath)&&(!l||w.getWorkspaceFolder(c))&&this.b.fire(c)}if(!n?.ignoreChangeEvents)for(const r of u.changed){const c=L.URI.revive(r);i(c.fsPath)&&(!l||w.getWorkspaceFolder(c))&&this.c.fire(c)}if(!n?.ignoreDeleteEvents)for(const r of u.deleted){const c=L.URI.revive(r);i(c.fsPath)&&(!l||w.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=p.$aN.from(this.i(v,h,a,n,n?.correlate),this.b,this.c,this.d,t)}i(v,w,h,f,a){const n=p.$aN.from();if(typeof h=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return n;const i=v.getProxy(R.$$M.MainThreadFileSystemEventService);let l=!1;(h.pattern.includes(O.$mk)||h.pattern.includes(O.$nk))&&(l=!0);let o;return a&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(o=14,f?.ignoreChangeEvents&&(o&=-3),f?.ignoreCreateEvents&&(o&=-5),f?.ignoreDeleteEvents&&(o&=-9)),i.$watch(w.identifier.value,this.a,h.baseUri,{recursive:l,excludes:f?.excludes??[],filter:o},!!a),p.$aN.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(L.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,w,h){this.j=v,this.k=w,this.l=h,this.a=new d.$de,this.b=new d.$de,this.c=new d.$de,this.d=new d.$de,this.g=new d.$fe,this.h=new d.$fe,this.i=new d.$fe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,w,h,f){return new k(this.j,v,w,this.a.event,N.GlobPattern.from(h),f)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,w){switch(v){case 2:this.b.fire(Object.freeze({files:w.map(h=>({oldUri:L.URI.revive(h.source),newUri:L.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(h=>L.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(h=>L.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,w){return(h,f,a)=>{const n=function(l){h.call(f,l)};return n.extension=v,w.event(n,void 0,a)}}async $onWillRunFileOperation(v,w,h,f){switch(v){case 2:return await this.n(this.g,{files:w.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))},h,f);case 1:return await this.n(this.i,{files:w.map(a=>L.URI.revive(a.target))},h,f);case 0:case 3:return await this.n(this.h,{files:w.map(a=>L.URI.revive(a.target))},h,f)}}async n(v,w,h,f){const a=new Set,n=[];if(await v.fireAsync(w,f,async(l,o)=>{const t=Date.now(),u=await Promise.resolve(l);u instanceof p.$kN&&(n.push([o.extension,u]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",o.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,l]of n){const{edits:o}=N.WorkspaceEdit.from(l,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(o)}return{edit:i,extensionNames:Array.from(a)}}}e.$Amc=C}),define(Se[343],De([1,0,19,7,22,13,125,3,24,40,14,18,2,29,181,84,135,226,25,16,8,26,112,6]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class r{constructor(V,W){this.d=V,this.e=W}async provideDocumentSymbols(V,W){const K=this.d.getDocument(V),X=await this.e.provideDocumentSymbols(K,W);if(!(0,d.$Kb)(X))return X[0]instanceof l.$uN?X.map(i.DocumentSymbol.from):r.f(X)}static f(V){V=V.slice(0).sort((X,de)=>{let we=X.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(X.location.range.end)),we});const W=[],K=[];for(const X of V){const de={name:X.name||"!!MISSING: name!!",kind:i.SymbolKind.from(X.kind),tags:X.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:i.Range.from(X.location.range),selectionRange:i.Range.from(X.location.range),children:[]};for(;;){if(K.length===0){K.push(de),W.push(de);break}const we=K[K.length-1];if(v.$ut.containsRange(we.range,de.range)&&!v.$ut.equalsRange(we.range,de.range)){we.children?.push(de),K.push(de);break}K.pop()}}return W}}class c{constructor(V,W,K,X,de,we){this.f=V,this.g=W,this.h=K,this.j=X,this.k=de,this.l=we,this.d=new t.$hlc("CodeLens"),this.e=new Map}async provideCodeLenses(V,W){const K=this.f.getDocument(V),X=await this.h.provideCodeLenses(K,W);if(!X||W.isCancellationRequested)return;const de=this.d.add(X),we=new p.$Tc;this.e.set(de,we);const Fe={cacheId:de,lenses:[]};for(let Ve=0;Ve<X.length;Ve++)Fe.lenses.push({cacheId:[de,Ve],range:i.Range.from(X[Ve].range),command:this.g.toInternal(X[Ve].command,we)});return Fe}async resolveCodeLens(V,W){const K=V.cacheId&&this.d.get(...V.cacheId);if(!K)return;let X;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?X=K:X=await this.h.resolveCodeLens(K,W),X||(X=K),W.isCancellationRequested)return;const de=V.cacheId&&this.e.get(V.cacheId[0]);if(de){if(!X.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(X.command,de),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function s(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class y{constructor(V,W){this.d=V,this.e=W}async provideDefinition(V,W,K){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDefinition(X,de,K);return s(we)}}class b{constructor(V,W){this.d=V,this.e=W}async provideDeclaration(V,W,K){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDeclaration(X,de,K);return s(we)}}class S{constructor(V,W){this.d=V,this.e=W}async provideImplementation(V,W,K){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideImplementation(X,de,K);return s(we)}}class g{constructor(V,W){this.d=V,this.e=W}async provideTypeDefinition(V,W,K){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideTypeDefinition(X,de,K);return s(we)}}class E{static{this.f=10}constructor(V,W){this.g=V,this.h=W,this.d=0,this.e=new Map}async provideHover(V,W,K,X){const de=this.g.getDocument(V),we=i.Position.to(W);let Fe;if(K&&K.verbosityRequest){const _e=K.verbosityRequest.previousHover.id,nt=this.e.get(_e);if(!nt)throw new Error(`Hover with id ${_e} not found`);const it={action:K.verbosityRequest.action,previousHover:nt};Fe=await this.h.provideHover(de,we,X,it)}else Fe=await this.h.provideHover(de,we,X);if(!Fe||(0,d.$Kb)(Fe.contents))return;Fe.range||(Fe.range=de.getWordRangeAtPosition(we)),Fe.range||(Fe.range=new l.$cN(we,we));const Ve=i.Hover.from(Fe),Je=this.d;if(this.e.size===E.f){const _e=Math.min(...this.e.keys());this.e.delete(_e)}return this.e.set(Je,Fe),this.d+=1,{...Ve,id:Je}}releaseHover(V){this.e.delete(V)}}class D{constructor(V,W){this.d=V,this.e=W}async provideEvaluatableExpression(V,W,K){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideEvaluatableExpression(X,de,K);if(we)return i.EvaluatableExpression.from(we)}}class P{constructor(V,W){this.d=V,this.e=W}async provideInlineValues(V,W,K,X){const de=this.d.getDocument(V),we=await this.e.provideInlineValues(de,i.Range.to(W),i.InlineValueContext.to(K),X);if(Array.isArray(we))return we.map(Fe=>i.InlineValue.from(Fe))}}class I{constructor(V,W){this.d=V,this.e=W}async provideDocumentHighlights(V,W,K){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDocumentHighlights(X,de,K);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class F{constructor(V,W){this.d=V,this.e=W}async provideMultiDocumentHighlights(V,W,K,X){const de=this.d.getDocument(V),we=K.map(Je=>this.d.getDocument(Je)),Fe=i.Position.to(W),Ve=await this.e.provideMultiDocumentHighlights(de,Fe,we,X);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class T{constructor(V,W){this.d=V,this.e=W}async provideLinkedEditingRanges(V,W,K){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(X,de,K);if(we&&Array.isArray(we.ranges))return{ranges:(0,d.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(V,W){this.d=V,this.e=W}async provideReferences(V,W,K,X){const de=this.d.getDocument(V),we=i.Position.to(W),Fe=await this.e.provideReferences(de,we,K,X);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class M{static{this.d=1e3}constructor(V,W,K,X,de,we,Fe){this.g=V,this.h=W,this.j=K,this.k=X,this.l=de,this.m=we,this.n=Fe,this.e=new t.$hlc("CodeAction"),this.f=new Map}async provideCodeActions(V,W,K,X){const de=this.g.getDocument(V),we=w.$wt.isISelection(W)?i.Selection.to(W):i.Range.to(W),Fe=[];for(const it of this.j.getDiagnostics(V))if(we.intersection(it.range)&&Fe.push(it)>M.d)break;const Ve={diagnostics:Fe,only:K.only?new l.$wN(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Je=await this.k.provideCodeActions(de,we,Ve,X);if(!(0,d.$Lb)(Je)||X.isCancellationRequested)return;const tt=this.e.add(Je),_e=new p.$Tc;this.f.set(tt,_e);const nt=[];for(let it=0;it<Je.length;it++){const rt=Je[it];if(rt)if(M.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{Ve.only&&(rt.kind?Ve.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=rt.ranges??[];nt.push({cacheId:[tt,it],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,o.$OG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,o.$OG)(this.m,"codeActionRanges")?(0,d.$Hb)(at.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:tt,actions:nt}}async resolveCodeAction(V,W){const[K,X]=V,de=this.e.get(K,X);if(!de||M.o(de))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(de,W)??de;let Fe;we.edit&&(Fe=i.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Je=this.f.get(K);Je&&(Ve=this.h.toInternal(we.command,Je))}return{edit:Fe,command:Ve}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class j{constructor(V,W,K,X,de){this.e=V,this.f=W,this.g=K,this.h=X,this.j=de,this.d=new t.$hlc("DocumentPasteEdit")}async prepareDocumentPaste(V,W,K,X){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(V),we=W.map(Je=>i.Range.to(Je)),Fe=i.DataTransfer.toDataTransfer(K,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(de,we,Fe,X),X.isCancellationRequested)return;const Ve=Array.from(Fe).filter(([,Je])=>!(Je instanceof l.$3N));return i.DataTransfer.from(Ve)}async providePasteEdits(V,W,K,X,de,we){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(W),Ve=K.map(nt=>i.Range.to(nt)),Je=i.DataTransfer.toDataTransfer(X,async nt=>(await this.e.$resolvePasteFileData(this.h,V,nt)).buffer),tt=await this.g.provideDocumentPasteEdits(Fe,Ve,Je,{only:de.only?new l.$8N(de.only):void 0,triggerKind:de.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const _e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,W){const[K,X]=V,de=this.d.get(K,X);if(!de||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class U{constructor(V,W){this.d=V,this.e=W}async provideDocumentFormattingEdits(V,W,K){const X=this.d.getDocument(V),de=await this.e.provideDocumentFormattingEdits(X,W,K);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class Z{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeFormattingEdits(V,W,K,X){const de=this.d.getDocument(V),we=i.Range.to(W),Fe=await this.e.provideDocumentRangeFormattingEdits(de,we,K,X);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,W,K,X){(0,C.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(V),we=W.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(de,we,K,X);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class ie{constructor(V,W){this.d=V,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,W,K,X,de){const we=this.d.getDocument(V),Fe=i.Position.to(W),Ve=await this.e.provideOnTypeFormattingEdits(we,Fe,K,X,de);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class Q{constructor(V,W){this.e=V,this.f=W,this.d=new t.$hlc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,W){const K=await this.e.provideWorkspaceSymbols(V,W);if(!(0,d.$Lb)(K))return{symbols:[]};const X=this.d.add(K),de={cacheId:X,symbols:[]};for(let we=0;we<K.length;we++){const Fe=K[we];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}de.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[X,we]})}return de}async resolveWorkspaceSymbol(V,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const K=this.d.get(...V.cacheId);if(K){const X=await this.e.resolveWorkspaceSymbol(K,W);return X&&(0,m.$6n)(V,i.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class G{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,W,K){this.d=V,this.e=W,this.f=K}async provideRenameEdits(V,W,K,X){const de=this.d.getDocument(V),we=i.Position.to(W);try{const Fe=await this.e.provideRenameEdits(de,we,K,X);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Ve=G.g(Fe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(V,W,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(V),de=i.Position.to(W);try{const we=await this.e.prepareRename(X,de,K);let Fe,Ve;if(l.$cN.isRange(we)?(Fe=we,Ve=X.getText(we)):(0,C.$$f)(we)&&(Fe=we.range,Ve=we.placeholder),!Fe||!Ve)return;if(Fe.start.line>de.line||Fe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Ve}}catch(we){const Fe=G.g(we);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{static{this.d={[h.NewSymbolNameTriggerKind.Invoke]:l.NewSymbolNameTriggerKind.Invoke,[h.NewSymbolNameTriggerKind.Automatic]:l.NewSymbolNameTriggerKind.Automatic}}constructor(V,W,K){this.e=V,this.f=W,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,W,K,X){const de=this.e.getDocument(V),we=i.Range.to(W);try{const Fe=x.d[K],Ve=await this.f.provideNewSymbolNames(de,we,Fe,X);return Ve?Ve.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Fe){this.g.error(x.h(Fe)??JSON.stringify(Fe,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ne{constructor(V,W){this.resultId=V,this.tokens=W}}class be{constructor(V,W){this.f=V,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,W,K){const X=this.f.getDocument(V),de=W!==0?this.d.get(W):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,de.resultId,K):await this.g.provideDocumentSemanticTokens(X,K);return de&&this.d.delete(W),we?(we=be.h(we),this.o(be.n(de,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return be.j(V)?be.k(V)?V:new l.$vO(new Uint32Array(V.data),V.resultId):be.l(V)?be.m(V)?V:new l.$xO(V.edits.map(W=>new l.$wO(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const W of V.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(V,W){if(!be.j(W)||!V||!V.tokens)return W;const K=V.tokens,X=K.length,de=W.data,we=de.length;let Fe=0;const Ve=Math.min(X,we);for(;Fe<Ve&&K[Fe]===de[Fe];)Fe++;if(Fe===X&&Fe===we)return new l.$xO([],W.resultId);let Je=0;const tt=Ve-Fe;for(;Je<tt&&K[X-Je-1]===de[we-Je-1];)Je++;return new l.$xO([{start:Fe,deleteCount:X-Fe-Je,data:de.subarray(Fe,we-Je)}],W.resultId)}o(V,W){if(be.j(V)){const K=this.e++;return this.d.set(K,new ne(V.resultId,V.data)),(0,f.$ccb)({id:K,type:"full",data:V.data})}if(be.l(V)){const K=this.e++;return be.j(W)?this.d.set(K,new ne(W.resultId,W.data)):this.d.set(K,new ne(V.resultId)),(0,f.$ccb)({id:K,type:"delta",deltas:(V.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class ae{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeSemanticTokens(V,W,K){const X=this.d.getDocument(V),de=await this.e.provideDocumentRangeSemanticTokens(X,i.Range.to(W),K);return de?this.f(de):null}f(V){return(0,f.$ccb)({id:0,type:"full",data:V.data})}}class Ce{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,W,K,X,de){this.f=V,this.g=W,this.h=K,this.j=X,this.k=de,this.d=new t.$hlc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,W,K,X){const de=this.f.getDocument(V),we=i.Position.to(W),Fe=de.getWordRangeAtPosition(we)||new l.$cN(we,we),Ve=Fe.with({end:we}),Je=new k.$_d,tt=await this.h.provideCompletionItems(de,we,X,i.CompletionContext.to(K));if(!tt||X.isCancellationRequested)return;const _e=Array.isArray(tt)?new l.$JN(tt):tt,nt=Ce.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),it=new p.$Tc;this.e.set(nt,it);const rt=[],at={x:nt,b:rt,a:{replace:i.Range.from(Fe),insert:i.Range.from(Ve)},c:_e.isIncomplete||void 0,d:Je.elapsed()};for(let Ne=0;Ne<_e.items.length;Ne++){const ye=_e.items[Ne],qe=this.l(ye,[nt,Ne],Ve,Fe);rt.push(qe)}return at}async resolveCompletionItem(V,W){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...V);if(!K)return;const X=this.l(K,V),de=await this.h.resolveCompletionItem(K,W);if(!de)return;const we=this.l(de,V);return(X.h!==we.h||X.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==we.n||X.o!==we.o||!(0,m.$7n)(X.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W,K,X){const de=this.e.get(W[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,de),Fe={x:W,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=V.textEdit.newText):typeof V.insertText=="string"?Fe.h=V.insertText:V.insertText instanceof l.$lN&&(Fe.h=V.insertText.value,Fe.i|=4);let Ve;return V.textEdit?Ve=V.textEdit.range:V.range&&(Ve=V.range),l.$cN.isRange(Ve)?Fe.j=i.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!X?.isEqual(Ve.replacing))&&(Fe.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Fe}}class ee{async provideInlineCompletions(V,W,K,X){}disposeCompletions(V){}handleDidShowCompletionItem(V,W,K){}handlePartialAccept(V,W,K,X){}}class B extends ee{constructor(V,W,K,X){super(),this.f=V,this.g=W,this.h=K,this.j=X,this.d=new pe,this.e=(0,o.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[h.InlineCompletionTriggerKind.Automatic]:l.InlineCompletionTriggerKind.Automatic,[h.InlineCompletionTriggerKind.Explicit]:l.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,W,K,X){const de=this.g.getDocument(V),we=i.Position.to(W),Fe=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},X);if(!Fe||X.isCancellationRequested)return;const Ve=Array.isArray(Fe)?Fe:Fe.items,Je=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],tt=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Ve}),items:Ve.map((it,rt)=>{let at;it.command&&(_e||(_e=new p.$Tc),at=this.j.toInternal(it.command,_e));const Ne=it.insertText;return{insertText:typeof Ne=="string"?Ne:{snippet:Ne.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:at,idx:rt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(_e||(_e=new p.$Tc),this.j.toInternal(it,_e))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,W,K){const X=this.d.get(V)?.items[W];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,K)}handlePartialAccept(V,W,K,X){const de=this.d.get(V)?.items[W];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,K),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(X)))}}class _{async provideInlineEdits(V,W,K){const X=this.f.getDocument(V),de=await this.g.provideInlineEdit(X,{triggerKind:this.e[W.triggerKind]},K);if(!de||K.isCancellationRequested)return;let we;const Fe=this.d.createReferenceId({dispose(){we?.dispose()},item:de});let Ve;de.accepted&&(we||(we=new p.$Tc),Ve=this.h.toInternal(de.accepted,we));let Je;return de.rejected&&(we||(we=new p.$Tc),Je=this.h.toInternal(de.rejected,we)),{pid:Fe,text:de.text,range:i.Range.from(de.range),accepted:Ve,rejected:Je}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,W,K,X){this.f=W,this.g=K,this.h=X,this.d=new pe,this.e={[h.InlineEditTriggerKind.Automatic]:l.InlineEditTriggerKind.Automatic,[h.InlineEditTriggerKind.Invoke]:l.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const W=this.e++;return this.d.set(W,V),W}disposeReferenceId(V){const W=this.d.get(V);return this.d.delete(V),W}get(V){return this.d.get(V)}}class ue{constructor(V,W){this.e=V,this.f=W,this.d=new t.$hlc("SignatureHelp")}async provideSignatureHelp(V,W,K,X){const de=this.e.getDocument(V),we=i.Position.to(W),Fe=this.g(K),Ve=await this.f.provideSignatureHelp(de,we,X,Fe);if(Ve){const Je=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Je}}}g(V){let W;if(V.activeSignatureHelp){const K=i.SignatureHelp.to(V.activeSignatureHelp),X=this.d.get(V.activeSignatureHelp.id,0);X?(W=X,W.activeSignature=K.activeSignature,W.activeParameter=K.activeParameter):W=K}return{...V,activeSignatureHelp:W}}releaseSignatureHelp(V){this.d.delete(V)}}class ce{constructor(V,W,K,X,de){this.f=V,this.g=W,this.h=K,this.j=X,this.k=de,this.d=new t.$hlc("InlayHints"),this.e=new Map}async provideInlayHints(V,W,K){const X=this.f.getDocument(V),de=i.Range.to(W),we=await this.h.provideInlayHints(X,de,K);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(K.isCancellationRequested)return;const Fe=this.d.add(we);this.e.set(Fe,new p.$Tc);const Ve={hints:[],cacheId:Fe};for(let Je=0;Je<we.length;Je++)this.l(we[Je],de)&&Ve.hints.push(this.m(we[Je],[Fe,Je]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),Ve}async resolveInlayHint(V,W){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...V);if(!K)return;const X=await this.h.resolveInlayHint(K,W);if(X&&this.l(X))return this.m(X,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W){return V.label.length===0||Array.isArray(V.label)&&V.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(W&&!W.contains(V.position))}m(V,W){const K=this.e.get(W[0]);if(!K)throw Error("DisposableStore is missing...");const X={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")X.label=V.label;else{const de=[];X.label=de;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};l.$mN.isLocation(we.location)&&(Fe.location=i.location.from(we.location)),we.command&&(Fe.command=this.g.toInternal(we.command,K)),de.push(Fe)}}return X}}class oe{constructor(V,W){this.e=V,this.f=W,this.d=new t.$hlc("DocumentLink")}async provideLinks(V,W){const K=this.e.getDocument(V),X=await this.f.provideDocumentLinks(K,W);if(!(!Array.isArray(X)||X.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(oe.g).map(i.DocumentLink.from)};{const de=this.d.add(X),we={links:[],cacheId:de};for(let Fe=0;Fe<X.length;Fe++){if(!oe.g(X[Fe]))continue;const Ve=i.DocumentLink.from(X[Fe]);Ve.cacheId=[de,Fe],we.links.push(Ve)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,W){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...V);if(!K)return;const X=await this.f.resolveDocumentLink(K,W);if(!(!X||!oe.g(X)))return i.DocumentLink.from(X)}releaseLinks(V){this.d.delete(V)}}class le{constructor(V,W){this.d=V,this.e=W}async provideColors(V,W){const K=this.d.getDocument(V),X=await this.e.provideDocumentColors(K,W);return Array.isArray(X)?X.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,W,K){const X=this.d.getDocument(V),de=i.Range.to(W.range),we=i.Color.to(W.color),Fe=await this.e.provideColorPresentations(we,{document:X,range:de},K);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class J{constructor(V,W){this.d=V,this.e=W}async provideFoldingRanges(V,W,K){const X=this.d.getDocument(V),de=await this.e.provideFoldingRanges(X,W,K);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class se{constructor(V,W,K){this.d=V,this.e=W,this.f=K}async provideSelectionRanges(V,W,K){const X=this.d.getDocument(V),de=W.map(i.Position.to),we=await this.e.provideSelectionRanges(X,de,K);if(!(0,d.$Lb)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Ve=0;Ve<de.length;Ve++){const Je=[];Fe.push(Je);let tt=de[Ve],_e=we[Ve];for(;;){if(!_e.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(_e)),!_e.parent)break;tt=_e.range,_e=_e.parent}}return Fe}}class $e{constructor(V,W){this.f=V,this.g=W,this.d=new N.$EP(""),this.e=new Map}async prepareSession(V,W,K){const X=this.f.getDocument(V),de=i.Position.to(W),we=await this.g.prepareCallHierarchy(X,de,K);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,we)]}async provideCallsTo(V,W,K){const X=this.j(V,W);if(!X)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(X,K);if(de)return de.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(V,W,K){const X=this.j(V,W);if(!X)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(X,K);if(de)return de.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(V){this.e.delete(V)}h(V,W){const K=this.e.get(V),X=i.CallHierarchyItem.from(W,V,K.size.toString(36));return K.set(X._itemId,W),X}j(V,W){return this.e.get(V)?.get(W)}}class ve{constructor(V,W){this.f=V,this.g=W,this.d=new N.$EP(""),this.e=new Map}async prepareSession(V,W,K){const X=this.f.getDocument(V),de=i.Position.to(W),we=await this.g.prepareTypeHierarchy(X,de,K);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,we)]}async provideSupertypes(V,W,K){const X=this.j(V,W);if(!X)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(X,K);if(de)return de.map(we=>this.h(V,we))}async provideSubtypes(V,W,K){const X=this.j(V,W);if(!X)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(X,K);if(de)return de.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,W){const K=this.e.get(V),X=i.TypeHierarchyItem.from(W,V,K.size.toString(36));return K.set(X._itemId,W),X}j(V,W){return this.e.get(V)?.get(W)}}class Re{constructor(V,W,K,X,de){this.e=V,this.f=W,this.g=K,this.h=X,this.j=de,this.d=new t.$hlc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,W,K,X,de){const we=this.f.getDocument(W),Fe=i.Position.to(K),Ve=i.DataTransfer.toDataTransfer(X,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,nt)).buffer),Je=await this.g.provideDocumentDropEdits(we,Fe,Ve,de);if(!Je)return;const tt=(0,d.$2b)(Je),_e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,W){const[K,X]=V,de=this.d.get(K,X);if(!de||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class ge{constructor(V,W){this.d=V,this.e=W}async provideMappedEdits(V,W,K,X){const de=$.URI.revive(V),we=this.d.getDocument(de),Fe=K.documents.map(tt=>tt.map(_e=>({uri:$.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(nt=>i.Range.to(nt))}))),Ve={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(we,W,Ve,X);return Je?i.WorkspaceEdit.from(Je):null}}class Ie{constructor(V,W){this.adapter=V,this.extension=W}}class Ae{static{this.d=0}constructor(V,W,K,X,de,we,Fe,Ve){this.g=W,this.h=K,this.j=X,this.k=de,this.l=we,this.m=Fe,this.n=Ve,this.f=new Map,this.e=V.getProxy(u.$$M.MainThreadLanguageFeatures)}o(V,W){return i.DocumentSelector.from(V,this.g,W)}p(V){return new l.$aN(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ae.d++}async s(V,W,K,X,de,we=!1){const Fe=this.f.get(V);if(!Fe||!(Fe.adapter instanceof W))return X;const Ve=Date.now();we||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Je=K(Fe.adapter,Fe.extension);return Promise.resolve(Je).catch(tt=>{(0,R.$4)(tt)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Fe.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(de)?(0,O.$lh)(Je,de):Je}t(V,W){const K=this.q();return this.f.set(K,new Ie(V,W)),K}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,W,K,X){const de=this.t(new r(this.h,K),V),we=X&&X.label||Ae.u(V);return this.e.$registerDocumentSymbolProvider(de,this.o(W,V),we),this.p(de)}$provideDocumentSymbols(V,W,K){return this.s(V,r,X=>X.provideDocumentSymbols($.URI.revive(W),K),void 0,K)}registerCodeLensProvider(V,W,K){const X=this.q(),de=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new Ie(new c(this.h,this.j.converter,K,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(X,this.o(W,V),de);let we=this.p(X);if(de!==void 0){const Fe=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(de));we=l.$aN.from(we,Fe)}return we}$provideCodeLenses(V,W,K){return this.s(V,c,X=>X.provideCodeLenses($.URI.revive(W),K),void 0,K)}$resolveCodeLens(V,W,K){return this.s(V,c,X=>X.resolveCodeLens(W,K),void 0,void 0)}$releaseCodeLenses(V,W){this.s(V,c,K=>Promise.resolve(K.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(V,W,K){const X=this.t(new y(this.h,K),V);return this.e.$registerDefinitionSupport(X,this.o(W,V)),this.p(X)}$provideDefinition(V,W,K,X){return this.s(V,y,de=>de.provideDefinition($.URI.revive(W),K,X),[],X)}registerDeclarationProvider(V,W,K){const X=this.t(new b(this.h,K),V);return this.e.$registerDeclarationSupport(X,this.o(W,V)),this.p(X)}$provideDeclaration(V,W,K,X){return this.s(V,b,de=>de.provideDeclaration($.URI.revive(W),K,X),[],X)}registerImplementationProvider(V,W,K){const X=this.t(new S(this.h,K),V);return this.e.$registerImplementationSupport(X,this.o(W,V)),this.p(X)}$provideImplementation(V,W,K,X){return this.s(V,S,de=>de.provideImplementation($.URI.revive(W),K,X),[],X)}registerTypeDefinitionProvider(V,W,K){const X=this.t(new g(this.h,K),V);return this.e.$registerTypeDefinitionSupport(X,this.o(W,V)),this.p(X)}$provideTypeDefinition(V,W,K,X){return this.s(V,g,de=>de.provideTypeDefinition($.URI.revive(W),K,X),[],X)}registerHoverProvider(V,W,K,X){const de=this.t(new E(this.h,K),V);return this.e.$registerHoverProvider(de,this.o(W,V)),this.p(de)}$provideHover(V,W,K,X,de){return this.s(V,E,we=>we.provideHover($.URI.revive(W),K,X,de),void 0,de)}$releaseHover(V,W){this.s(V,E,K=>Promise.resolve(K.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(V,W,K,X){const de=this.t(new D(this.h,K),V);return this.e.$registerEvaluatableExpressionProvider(de,this.o(W,V)),this.p(de)}$provideEvaluatableExpression(V,W,K,X){return this.s(V,D,de=>de.provideEvaluatableExpression($.URI.revive(W),K,X),void 0,X)}registerInlineValuesProvider(V,W,K,X){const de=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new P(this.h,K),V);this.e.$registerInlineValuesProvider(we,this.o(W,V),de);let Fe=this.p(we);if(de!==void 0){const Ve=K.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(de));Fe=l.$aN.from(Fe,Ve)}return Fe}$provideInlineValues(V,W,K,X,de){return this.s(V,P,we=>we.provideInlineValues($.URI.revive(W),K,X,de),void 0,de)}registerDocumentHighlightProvider(V,W,K){const X=this.t(new I(this.h,K),V);return this.e.$registerDocumentHighlightProvider(X,this.o(W,V)),this.p(X)}registerMultiDocumentHighlightProvider(V,W,K){const X=this.t(new F(this.h,K),V);return this.e.$registerMultiDocumentHighlightProvider(X,this.o(W,V)),this.p(X)}$provideDocumentHighlights(V,W,K,X){return this.s(V,I,de=>de.provideDocumentHighlights($.URI.revive(W),K,X),void 0,X)}$provideMultiDocumentHighlights(V,W,K,X,de){return this.s(V,F,we=>we.provideMultiDocumentHighlights($.URI.revive(W),K,X.map(Fe=>$.URI.revive(Fe)),de),void 0,de)}registerLinkedEditingRangeProvider(V,W,K){const X=this.t(new T(this.h,K),V);return this.e.$registerLinkedEditingRangeProvider(X,this.o(W,V)),this.p(X)}$provideLinkedEditingRanges(V,W,K,X){return this.s(V,T,async de=>{const we=await de.provideLinkedEditingRanges($.URI.revive(W),K,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ae.w(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(V,W,K){const X=this.t(new z(this.h,K),V);return this.e.$registerReferenceSupport(X,this.o(W,V)),this.p(X)}$provideReferences(V,W,K,X,de){return this.s(V,z,we=>we.provideReferences($.URI.revive(W),K,X,de),void 0,de)}registerCodeActionProvider(V,W,K,X){const de=new p.$Tc,we=this.t(new M(this.h,this.j.converter,this.k,K,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(W,V),{providedKinds:X?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:X?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,de)}))},Ae.u(V),!!K.resolveCodeAction),de.add(this.p(we)),de}$provideCodeActions(V,W,K,X,de){return this.s(V,M,we=>we.provideCodeActions($.URI.revive(W),K,X,de),void 0,de)}$resolveCodeAction(V,W,K){return this.s(V,M,X=>X.resolveCodeAction(W,K),{},void 0)}$releaseCodeActions(V,W){this.s(V,M,K=>Promise.resolve(K.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(V,W,K){const X=this.t(new U(this.h,K),V);return this.e.$registerDocumentFormattingSupport(X,this.o(W,V),V.identifier,V.displayName||V.name),this.p(X)}$provideDocumentFormattingEdits(V,W,K,X){return this.s(V,U,de=>de.provideDocumentFormattingEdits($.URI.revive(W),K,X),void 0,X)}registerDocumentRangeFormattingEditProvider(V,W,K){const X=typeof K.provideDocumentRangesFormattingEdits=="function",de=this.t(new Z(this.h,K),V);return this.e.$registerRangeFormattingSupport(de,this.o(W,V),V.identifier,V.displayName||V.name,X),this.p(de)}$provideDocumentRangeFormattingEdits(V,W,K,X,de){return this.s(V,Z,we=>we.provideDocumentRangeFormattingEdits($.URI.revive(W),K,X,de),void 0,de)}$provideDocumentRangesFormattingEdits(V,W,K,X,de){return this.s(V,Z,we=>we.provideDocumentRangesFormattingEdits($.URI.revive(W),K,X,de),void 0,de)}registerOnTypeFormattingEditProvider(V,W,K,X){const de=this.t(new ie(this.h,K),V);return this.e.$registerOnTypeFormattingSupport(de,this.o(W,V),X,V.identifier),this.p(de)}$provideOnTypeFormattingEdits(V,W,K,X,de,we){return this.s(V,ie,Fe=>Fe.provideOnTypeFormattingEdits($.URI.revive(W),K,X,de,we),void 0,we)}registerWorkspaceSymbolProvider(V,W){const K=this.t(new Q(W,this.l),V);return this.e.$registerNavigateTypeSupport(K,typeof W.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(V,W,K){return this.s(V,Q,X=>X.provideWorkspaceSymbols(W,K),{symbols:[]},K)}$resolveWorkspaceSymbol(V,W,K){return this.s(V,Q,X=>X.resolveWorkspaceSymbol(W,K),void 0,void 0)}$releaseWorkspaceSymbols(V,W){this.s(V,Q,K=>K.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(V,W,K){const X=this.t(new G(this.h,K,this.l),V);return this.e.$registerRenameSupport(X,this.o(W,V),G.supportsResolving(K)),this.p(X)}$provideRenameEdits(V,W,K,X,de){return this.s(V,G,we=>we.provideRenameEdits($.URI.revive(W),K,X,de),void 0,de)}$resolveRenameLocation(V,W,K,X){return this.s(V,G,de=>de.resolveRenameLocation($.URI.revive(W),K,X),void 0,X)}registerNewSymbolNamesProvider(V,W,K){const X=this.t(new x(this.h,K,this.l),V);return this.e.$registerNewSymbolNamesProvider(X,this.o(W,V)),this.p(X)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,x,W=>W.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,W,K,X,de){return this.s(V,x,we=>we.provideNewSymbolNames($.URI.revive(W),K,X,de),void 0,de)}registerDocumentSemanticTokensProvider(V,W,K,X){const de=this.t(new be(this.h,K),V),we=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(W,V),X,we);let Fe=this.p(de);if(we){const Ve=K.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(we));Fe=l.$aN.from(Fe,Ve)}return Fe}$provideDocumentSemanticTokens(V,W,K,X){return this.s(V,be,de=>de.provideDocumentSemanticTokens($.URI.revive(W),K,X),null,X)}$releaseDocumentSemanticTokens(V,W){this.s(V,be,K=>K.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,W,K,X){const de=this.t(new ae(this.h,K),V);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(W,V),X),this.p(de)}$provideDocumentRangeSemanticTokens(V,W,K,X){return this.s(V,ae,de=>de.provideDocumentRangeSemanticTokens($.URI.revive(W),K,X),null,X)}registerCompletionItemProvider(V,W,K,X){const de=this.t(new Ce(this.h,this.j.converter,K,this.m,V),V);return this.e.$registerCompletionsProvider(de,this.o(W,V),X,Ce.supportsResolving(K),V.identifier),this.p(de)}$provideCompletionItems(V,W,K,X,de){return this.s(V,Ce,we=>we.provideCompletionItems($.URI.revive(W),K,X,de),void 0,de)}$resolveCompletionItem(V,W,K){return this.s(V,Ce,X=>X.resolveCompletionItem(W,K),void 0,K)}$releaseCompletionItems(V,W){this.s(V,Ce,K=>K.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(V,W,K,X){const de=new B(V,this.h,K,this.j.converter),we=this.t(de,V);return this.e.$registerInlineCompletionsSupport(we,this.o(W,V),de.supportsHandleEvents,n.$Rm.toKey(V.identifier.value),X?.yieldTo?.map(Fe=>n.$Rm.toKey(Fe))||[]),this.p(we)}$provideInlineCompletions(V,W,K,X,de){return this.s(V,ee,we=>we.provideInlineCompletions($.URI.revive(W),K,X,de),void 0,de)}$handleInlineCompletionDidShow(V,W,K,X){this.s(V,ee,async de=>{de.handleDidShowCompletionItem(W,K,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,W,K,X,de){this.s(V,ee,async we=>{we.handlePartialAccept(W,K,X,de)},void 0,void 0)}$freeInlineCompletionsList(V,W){this.s(V,ee,async K=>{K.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(V,W,K){const X=new _(V,this.h,K,this.j.converter),de=this.t(X,V);return this.e.$registerInlineEditProvider(de,this.o(W,V),V.identifier),this.p(de)}$provideInlineEdit(V,W,K,X){return this.s(V,_,de=>de.provideInlineEdits($.URI.revive(W),K,X),void 0,X)}$freeInlineEdit(V,W){this.s(V,_,async K=>{K.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(V,W,K,X){const de=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this.t(new ue(this.h,K),V);return this.e.$registerSignatureHelpProvider(we,this.o(W,V),de),this.p(we)}$provideSignatureHelp(V,W,K,X,de){return this.s(V,ue,we=>we.provideSignatureHelp($.URI.revive(W),K,X,de),void 0,de)}$releaseSignatureHelp(V,W){this.s(V,ue,K=>K.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(V,W,K){const X=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ce(this.h,this.j.converter,K,this.l,V),V);this.e.$registerInlayHintsProvider(de,this.o(W,V),typeof K.resolveInlayHint=="function",X,Ae.u(V));let we=this.p(de);if(X!==void 0){const Fe=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(X));we=l.$aN.from(we,Fe)}return we}$provideInlayHints(V,W,K,X){return this.s(V,ce,de=>de.provideInlayHints($.URI.revive(W),K,X),void 0,X)}$resolveInlayHint(V,W,K){return this.s(V,ce,X=>X.resolveInlayHint(W,K),void 0,K)}$releaseInlayHints(V,W){this.s(V,ce,K=>K.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(V,W,K){const X=this.t(new oe(this.h,K),V);return this.e.$registerDocumentLinkProvider(X,this.o(W,V),typeof K.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(V,W,K){return this.s(V,oe,X=>X.provideLinks($.URI.revive(W),K),void 0,K,W.scheme==="output")}$resolveDocumentLink(V,W,K){return this.s(V,oe,X=>X.resolveLink(W,K),void 0,void 0,!0)}$releaseDocumentLinks(V,W){this.s(V,oe,K=>K.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(V,W,K){const X=this.t(new le(this.h,K),V);return this.e.$registerDocumentColorProvider(X,this.o(W,V)),this.p(X)}$provideDocumentColors(V,W,K){return this.s(V,le,X=>X.provideColors($.URI.revive(W),K),[],K)}$provideColorPresentations(V,W,K,X){return this.s(V,le,de=>de.provideColorPresentations($.URI.revive(W),K,X),void 0,X)}registerFoldingRangeProvider(V,W,K){const X=this.q(),de=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new Ie(new J(this.h,K),V)),this.e.$registerFoldingRangeProvider(X,this.o(W,V),V.identifier,de);let we=this.p(X);if(de!==void 0){const Fe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=l.$aN.from(we,Fe)}return we}$provideFoldingRanges(V,W,K,X){return this.s(V,J,de=>de.provideFoldingRanges($.URI.revive(W),K,X),void 0,X)}registerSelectionRangeProvider(V,W,K){const X=this.t(new se(this.h,K,this.l),V);return this.e.$registerSelectionRangeProvider(X,this.o(W,V)),this.p(X)}$provideSelectionRanges(V,W,K,X){return this.s(V,se,de=>de.provideSelectionRanges($.URI.revive(W),K,X),[],X)}registerCallHierarchyProvider(V,W,K){const X=this.t(new $e(this.h,K),V);return this.e.$registerCallHierarchyProvider(X,this.o(W,V)),this.p(X)}$prepareCallHierarchy(V,W,K,X){return this.s(V,$e,de=>Promise.resolve(de.prepareSession($.URI.revive(W),K,X)),void 0,X)}$provideCallHierarchyIncomingCalls(V,W,K,X){return this.s(V,$e,de=>de.provideCallsTo(W,K,X),void 0,X)}$provideCallHierarchyOutgoingCalls(V,W,K,X){return this.s(V,$e,de=>de.provideCallsFrom(W,K,X),void 0,X)}$releaseCallHierarchy(V,W){this.s(V,$e,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(V,W,K){const X=this.t(new ve(this.h,K),V);return this.e.$registerTypeHierarchyProvider(X,this.o(W,V)),this.p(X)}$prepareTypeHierarchy(V,W,K,X){return this.s(V,ve,de=>Promise.resolve(de.prepareSession($.URI.revive(W),K,X)),void 0,X)}$provideTypeHierarchySupertypes(V,W,K,X){return this.s(V,ve,de=>de.provideSupertypes(W,K,X),void 0,X)}$provideTypeHierarchySubtypes(V,W,K,X){return this.s(V,ve,de=>de.provideSubtypes(W,K,X),void 0,X)}$releaseTypeHierarchy(V,W){this.s(V,ve,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(V,W,K,X){const de=this.q();return this.f.set(de,new Ie(new Re(this.e,this.h,K,de,V),V)),this.e.$registerDocumentOnDropEditProvider(de,this.o(W,V),(0,o.$OG)(V,"documentPaste")&&X?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:X.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(V,W,K,X,de,we){return this.s(V,Re,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(W,$.URI.revive(K),X,de,we)),void 0,void 0)}$resolveDropEdit(V,W,K){return this.s(V,Re,X=>X.resolveDropEdit(W,K),{},void 0)}$releaseDropEdits(V,W){this.s(V,Re,K=>Promise.resolve(K.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(V,W,K){const X=this.t(new ge(this.h,K),V);return this.e.$registerMappedEditsProvider(X,this.o(W,V)),this.p(X)}$provideMappedEdits(V,W,K,X,de){return this.s(V,ge,we=>Promise.resolve(we.provideMappedEdits(W,K,X,de)),null,de)}registerDocumentPasteEditProvider(V,W,K,X){const de=this.q();return this.f.set(de,new Ie(new j(this.e,this.h,K,de,V),V)),this.e.$registerPasteEditProvider(de,this.o(W,V),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:X.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(V,W,K,X,de){return this.s(V,j,we=>we.prepareDocumentPaste($.URI.revive(W),K,X,de),void 0,de)}$providePasteEdits(V,W,K,X,de,we,Fe){return this.s(V,j,Ve=>Ve.providePasteEdits(W,$.URI.revive(K),X,de,we,Fe),void 0,Fe)}$resolvePasteEdit(V,W,K){return this.s(V,j,X=>X.resolvePasteEdit(W,K),{},void 0)}$releasePasteEdits(V,W){this.s(V,j,K=>Promise.resolve(K.releasePasteEdits(W)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Ae.w(V.decreaseIndentPattern),increaseIndentPattern:Ae.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ae.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ae.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Ae.w(V.beforeText),afterText:V.afterText?Ae.w(V.afterText):void 0,previousLineText:V.previousLineText?Ae.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Ae.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(W=>l.SyntaxTokenType.toString(W)):void 0}}static D(V){return V.map(Ae.C)}setLanguageConfiguration(V,W,K){const{wordPattern:X}=K;if(X&&(0,A.$jf)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(W,X):this.h.setWordDefinitionFor(W,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const de=this.q(),we={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,W,we),this.p(de)}$setWordDefinitions(V){for(const W of V)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$rlc=Ae}),define(Se[122],De([1,0,3,6,16,8,109,25,7,4,227,146,13,5,20,121,11,39]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=void 0,e.$$lc=(0,v.$wi)("IExtHostLanguageModels");class i{constructor(u,r){this.option=u,this.stream=new m.$Zh,this.stream=r??new m.$Zh}}class l{constructor(){this.a=new Map,this.b=new m.$Zh,this.c=!1,this.d=!1;const u=this;this.apiObject={stream:u.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,u]of this.a)yield u.stream;else yield this.b}handleFragment(u){if(this.c)return;this.d=!0;let r=this.a.get(u.index);r||(this.a.size===0?r=new i(u.index,this.b):r=new i(u.index),this.a.set(u.index,r)),r.stream.emitOne(u.part)}get isStreaming(){return this.d}reject(u){this.c=!0;for(const r of this.f())r.reject(u)}resolve(){this.c=!0;for(const u of this.f())u.resolve()}}let o=class{static{n=this}static{this.a=1}constructor(u,r,c){this.j=r,this.k=c,this.c=new k.$de,this.d=new k.$de,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Tm,this.i=new Map,this.o=new Set,this.b=u.getProxy(O.$$M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(u,r,c,s){const y=n.a++;this.f.set(y,{extension:u.identifier,provider:c,languageModelId:r});let b;s.auth&&(b={providerLabel:u.displayName||u.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,r,{extension:u.identifier,identifier:r,name:s.name??"",version:s.version,tokens:s.tokens,auth:b});const S=c.onDidReceiveLanguageModelResponse2?.(({extensionId:g,participant:E,tokenCount:D})=>{this.b.$whenLanguageModelChatRequestMade(r,new p.$Rm(g),E,D)});return(0,d.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),S?.dispose()})}async $provideLanguageModelResponse(u,r,c,s,y,b){const S=this.f.get(u);if(!S)return;const g=new N.$dw(async E=>{if(b.isCancellationRequested){this.j.warn(`[CHAT](${S.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:E.index,part:E.part})});return S.provider.provideLanguageModelResponse2(s.map(L.LanguageModelMessage.to),y,p.$Rm.toKey(c),g,b)}$provideTokenLength(u,r,c){const s=this.f.get(u);return s?Promise.resolve(s.provider.provideTokenCount(r,c)):Promise.resolve(0)}$updateLanguageModels(u){const r=[],c=[];if(u.added)for(const s of u.added)this.g.set(s.identifier,s),r.push(s.identifier);if(u.removed)for(const s of u.removed){this.g.delete(s),c.push(s);for(const[y,b]of this.i)b.languageModelId===s&&(b.res.reject(new $.$5),this.i.delete(y))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(c)})),u.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(u){const r=new Array;for(const{from:c,to:s,enabled:y}of u){const b=this.h.get(c)??new p.$Sm;if(b.has(s)!==y){y?b.add(s):b.delete(s),this.h.set(c,b);const g={from:c,to:s};r.push(g),this.c.fire(g)}}}async sendChatRequest(u,r,c,s,y){const b=u.identifier,S=await this.b.$prepareChatAccess(b,r,s.justification);if(!S||!this.g.has(r))throw R.$mP.NotFound(`Language model '${r}' is unknown.`);if(this.m(b,S)&&(!await this.l(u,{identifier:S.extension,displayName:S.auth.providerLabel},s.justification,s.silent)||!this.h.get(b)?.has(S.extension)))throw R.$mP.NoPermissions(`Language model '${r}' cannot be used by '${b.value}'.`);const g=Math.random()*1e6|0,E=this.b.$fetchResponse(b,r,g,c.map(L.LanguageModelMessage.from),s.modelOptions??{},y),D=new m.$vh,P=new l;this.i.set(g,{languageModelId:r,res:P});let I;if(E.catch(F=>{D.isOpen()?P.reject(F):I=F}).finally(()=>{this.i.delete(g),P.resolve(),D.open()}),await D.wait(),I)throw new R.$mP(`Language model '${r}' errored, check cause for more details`,"Unknown",I);return P.apiObject}async $handleResponseFragment(u,r){const c=this.i.get(u);c&&c.res.handleFragment(r)}async l(u,r,c,s){const y=C.$aM+r.identifier.value;if(await this.k.getSession(u,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:u.identifier,to:r.identifier,enabled:!0}]),!0;if(s)return!1;try{const S=c?(0,A.localize)(0,null,r.displayName,c):(0,A.localize)(1,null,r.displayName);return await this.k.getSession(u,y,[],{forceNewSession:{detail:S}}),this.$updateModelAccesslist([{from:u.identifier,to:r.identifier,enabled:!0}]),!0}catch{return!1}}m(u,r){return!!r.auth&&!p.$Rm.equals(r.extension,u)}async n(u){for(const r of this.o)try{await this.l(r,{identifier:u.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}async computeTokenLength(u,r,c){const s=this.g.get(u);if(!s)throw R.$mP.NotFound(`Language model '${u}' is unknown.`);const y=a.Iterable.find(this.f.values(),b=>b.languageModelId===u);return y?y.provider.provideTokenCount(r,c):this.b.$countTokens(s.identifier,typeof r=="string"?r:L.LanguageModelMessage.from(r),c)}getLanguageModelInfo(u){const r=this.g.get(u);if(r)return{id:r.identifier,name:r.name,version:r.version,tokens:r.tokens}}createLanguageModelAccessInformation(u){this.o.add(u);const r=this,c=k.Event.signal(k.Event.filter(this.c.event,y=>p.$Rm.equals(y.from,u.identifier))),s=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(c,s)},canSendRequest(y){const b=r.g.get(y);if(!b)return;if(!r.m(u.identifier,b))return!0;const S=r.h.get(u.identifier);if(S)return S.has(b.extension)}}}};e.$_lc=o,e.$_lc=o=n=Ge([We(0,w.$zP),We(1,f.$3j),We(2,h.$tlc)],o)}),define(Se[344],De([1,0,6,16,8,41,7,3,26]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class k{constructor(C,$,v,w){this.c=$,this.d=v,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(d.$$M.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,$){await this.a.$changeLanguage(C,$);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,$){const v=C.version,w=O.Position.from($),h=await this.a.$tokensAtPosition(C.uri,w),f={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition($)??new L.$cN($.line,$.character,$.line,$.character)};if(!h)return f;const a={range:O.Range.to(h.range),type:O.TokenType.to(h.type)};return!a.range.contains($)||v!==C.version?f:a}createLanguageStatusItem(C,$,v){const w=this.f++,h=this.a,f=this.g,a=`${C.identifier.value}/${$}`;if(f.has(a))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);f.add(a);const n={selector:v,id:$,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const l=new p.$Tc,o=()=>{if(i?.dispose(),!f.has(a)){console.warn(`LanguageStatusItem (${$}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,N.$yh)(()=>{l.clear(),this.a.$setLanguageStatus(w,{id:a,name:n.name??C.displayName??C.name,source:C.displayName??C.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,l),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){l.dispose(),i?.dispose(),h.$removeLanguageStatus(w),f.delete(a)},get id(){return n.id},get name(){return n.name},set name(u){n.name=u,o()},get selector(){return n.selector},set selector(u){n.selector=u,o()},get text(){return n.text},set text(u){n.text=u,o()},set text2(u){(0,m.$PG)(C,"languageStatusText"),n.text=u,o()},get text2(){return(0,m.$PG)(C,"languageStatusText"),n.text},get detail(){return n.detail},set detail(u){n.detail=u,o()},get severity(){return n.severity},set severity(u){n.severity=u,o()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(u){n.accessibilityInformation=u,o()},get command(){return n.command},set command(u){n.command=u,o()},get busy(){return n.busy},set busy(u){n.busy=u,o()}};return o(),t}}e.$Qmc=k}),define(Se[345],De([1,0,15,2,16,8,120]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=e.$Cmc=void 0;class p{constructor(C,$,v,w){this.start=C,this.deletedCount=$,this.deletedItems=v,this.items=w}asApiEvent(){return{range:new R.$CO(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,$,v){this.notebook=C,this.h=$,this.j=v,this.handle=v.handle,this.uri=O.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(L.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return C.g},set mime(w){C.g=w},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,$,v){const w=v.map(L.NotebookCellOutputItem.to),h=this.a.find(f=>f.id===C);if(h&&($||(h.items.length=0),h.items.push(...w),h.items.length>1&&h.items.every(f=>N.$7K(f.mime)))){const f=new Map,a=[];h.items.forEach(n=>{let i;f.has(n.mime)?i=f.get(n.mime):(i=[],f.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),h.items.length=0,a.forEach(n=>{const i=N.$8K(f.get(n));h.items.push({mime:n,data:i.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Cmc=m;class k{static{this.a=0}constructor(C,$,v,w,h){this.k=C,this.l=$,this.m=v,this.uri=w,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,$={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===d.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(h=>h.apiCell)},save(){return C.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,$,v){this.g=C.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:v});const w={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},h=[];for(const a of C.rawEvents)a.kind===N.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,w.contentChanges):a.kind===N.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,w.contentChanges):a.kind===N.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),h.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===N.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),h.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===N.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),h.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===N.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===N.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===N.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),h.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===N.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),h.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const f=new Map;for(let a=0;a<h.length;a++){const n=h[a],i=f.get(n.cell);if(i===void 0){const l=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});f.set(n.cell,l-1)}else w.cellChanges[i]={...w.cellChanges[i],...n}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let $=C.start|0,v=C.end|0;return $<0&&($=0),v>this.b.length&&(v=this.b.length),C.with({start:$,end:v})}p(C){C=this.o(C);const $=[];for(let v=C.start;v<C.end;v++)$.push(this.b[v]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,$,v){if(this.j)return;const w=[],h=[],f=[];if(C.reverse().forEach(a=>{const i=a[2].map(t=>{const u=new m(this,this.l,t);return $||h.push(m.asModelAddData(t)),u}),l=new p(a[0],a[1],[],i),o=this.b.splice(a[0],a[1],...i);for(const t of o)f.push(t.uri),l.deletedItems.push(t.apiCell);w.push(l)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:f}),v)for(const a of w)v.push(a.asApiEvent())}s(C,$,v,w){const h=this.b.splice(C,$);this.b.splice(v,0,...h);const f=[new p(C,$,h.map(a=>a.apiCell),[]),new p(v,0,[],h)];for(const a of f)w.push(a.asApiEvent())}t(C,$){this.b[C].setOutputs($)}u(C,$,v,w){this.b[C].setOutputItems($,v,w)}v(C,$){const v=this.b[C];v.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(v.uri,$)}w(C,$){const v=this.b[C];v.apiCell.mime=$}x(C,$){this.b[C].setMetadata($)}y(C,$){this.b[C].setInternalMetadata($)}getCellFromApiCell(C){return this.b.find($=>$.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find($=>$.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Dmc=k}),define(Se[346],De([1,0,4,2,16,8,48]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class p{constructor(k,A,C,$={timeout:1500,errors:3}){this.b=k,this.c=A,this.d=C,this.f=$,this.a=new d.$fe}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(A,C,$)=>{const v=function(h){A.call(C,h)};return v.extension=k,this.a.event(v,void 0,$)}}async $participateInSave(k,A,C){const $=O.URI.revive(k),v=this.c.getNotebookDocument($);if(!v)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},C,async(f,a)=>{const n=Date.now(),i=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!C.isCancellationRequested&&i&&(i instanceof R.$kN?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(w.length===0)return!0;const h={edits:[]};for(const f of w){const{edits:a}=L.WorkspaceEdit.from(f);h.edits=h.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new N.$Bw(h))}}e.$Smc=p}),define(Se[154],De([1,0,13,16,8]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,m,k,A,C,$){this.id=p,this.f=m,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=$}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(m){this.selections=[m]},get selections(){return p.a},set selections(m){if(!Array.isArray(m)||!m.every(L.$CO.isNotebookRange))throw(0,d.$7)("selections");p.a=m,p.g(m)},get visibleRanges(){return p.b},revealRange(m,k){p.f.$tryRevealRange(p.id,O.NotebookRange.from(m),k??L.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(O.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Emc=R}),define(Se[347],De([1,0,4,11,16]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;let R=class{constructor(p,m){this.c=p,this.d=m,this.a=new d.$de,this.b=new d.$de,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,m);const k=this.d.getEditorById(p);m.visibleRanges&&k._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&k._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const m in p)this.d.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(p[m]))}};e.$Umc=R,e.$Umc=R=Ge([We(0,O.$3j)],R)}),define(Se[348],De([1,0,4,6,154]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class R{constructor(p,m){this.c=m,this.a=new Map,this.b=p.getProxy(O.$$M.MainThreadNotebookRenderers)}$postRendererMessage(p,m,k){const A=this.c.getEditorById(p);this.a.get(m)?.fire({editor:A.apiEditor,message:k})}createRendererMessaging(p,m){if(!p.contributes?.notebookRenderer?.some(A=>A.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(A,C,$)=>this.d(m).event(A,C,$),postMessage:(A,C)=>{L.$Emc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const $=C&&L.$Emc.apiEditorsToExtHost.get(C);return this.b.$postMessage($?.id,m,A)}}}d(p){let m=this.a.get(p);return m||(m=new d.$de({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(p)}}),this.a.set(p,m),m)}}e.$Xmc=R}),define(Se[349],De([1,0,16,109,22,56,13]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class p{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,$,v){const w=this.b++,{title:h,location:f,cancellable:a}=$,n={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(w,{location:d.ProgressLocation.from(f),title:h,source:n,cancellable:a},C.isUnderDevelopment?void 0:C.identifier.value).catch(N.$2),this.d(w,v,!!a)}d(C,$,v){let w;v&&(w=new L.$oe,this.c.set(C,w));const h=a=>{this.a.$progressEnd(a),this.c.delete(a),w?.dispose()};let f;try{f=$(new k(this.a,C),v&&w?w.token:L.CancellationToken.None)}catch(a){throw h(C),a}return f.then(a=>h(C),a=>h(C)),f}$acceptProgressCanceled(C){const $=this.c.get(C);$&&($.cancel(),this.c.delete(C))}}e.$2mc=p;function m(A,C){return A.message=C.message,typeof C.increment=="number"&&(typeof A.increment=="number"?A.increment+=C.increment:A.increment=C.increment),A}class k extends O.$dw{constructor(C,$){super(v=>this.throttledReport(v)),this.c=C,this.d=$}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,R.$3h)(100,(A,C)=>m(A,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Se[350],De([1,0,2,6,7,16]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;class N{static{this.a=0}constructor(m,k){this.d=k,this.c=new Map,this.b=m.getProxy(O.$$M.MainThreadQuickDiff)}$provideOriginalResource(m,k,A){const C=d.URI.revive(k),$=this.c.get(m);return $?(0,L.$oh)(()=>$.provideOriginalResource(C,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(m,k,A,C){const $=N.a++;return this.c.set($,k),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(m,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$3mc=N}),define(Se[351],De([1,0,22,4,3,6,2,8,13,19,41,50,26,16]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=w;function w(h,f,a){const n=h.getProxy(R.$$M.MainThreadQuickOpen);class i{constructor(b,S){this.e=new Map,this.f=0,this.a=b,this.b=S}showQuickPick(b,S,g,E=d.CancellationToken.None){this.c=void 0;const D=Promise.resolve(S),P=++this.f,I=n.$show(P,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},E),F={},T=I.then(()=>F);return Promise.race([T,D]).then(z=>{if(z===F)return;const M=(0,$.$OG)(b,"quickPickItemTooltip");return D.then(j=>{const U=[];for(let Z=0;Z<j.length;Z++){const ie=j[Z];if(typeof ie=="string")U.push({label:ie,handle:Z});else if(ie.kind===p.QuickPickItemKind.Separator)U.push({type:"separator",label:ie.label});else{ie.tooltip&&!M&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const Q=ie.iconPath?r(ie.iconPath):void 0;U.push({label:ie.label,iconPath:Q?.iconPath,iconClass:Q?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:M?v.MarkdownString.fromStrict(ie.tooltip):void 0,handle:Z})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=Z=>{g.onDidSelectItem(j[Z])}),n.$setItems(P,U),I.then(Z=>{if(typeof Z=="number")return j[Z];if(Array.isArray(Z))return Z.map(ie=>j[ie])})})}).then(void 0,z=>{if(!(0,m.$4)(z))return n.$setError(P,z),Promise.reject(z)})}$onItemSelected(b){this.c?.(b)}showInput(b,S=d.CancellationToken.None){return this.d=b?.validateInput,n.$input(b,typeof this.d=="function",S).then(void 0,g=>{if(!(0,m.$4)(g))return Promise.reject(g)})}async $validateInput(b){if(!this.d)return;const S=await this.d(b);if(!S||typeof S=="string")return S;let g;switch(S.severity){case p.InputBoxValidationSeverity.Info:g=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:g=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:g=A.default.Error;break;default:g=S.message?A.default.Error:A.default.Ignore;break}return{content:S.message,severity:g}}async showWorkspaceFolderPick(b,S=d.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!g)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(D=>D.uri.toString()===g.uri.toString())}createQuickPick(b){const S=new c(b,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(b){const S=new s(b,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(b,S){this.e.get(b)?._fireDidChangeValue(S)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,S){const g=this.e.get(b);g instanceof c&&g._fireDidChangeActive(S)}$onDidChangeSelection(b,S){const g=this.e.get(b);g instanceof c&&g._fireDidChangeSelection(S)}$onDidTriggerButton(b,S){this.e.get(b)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(b,S,g){const E=this.e.get(b);E instanceof c&&E._fireDidTriggerItemButton(S,g)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class l{static{this.a=1}constructor(b,S){this.x=b,this.y=S,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$de,this.q=new O.$de,this.r=new O.$de,this.s=new O.$de,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((S,g)=>{const E=S===p.$zO.Back?-1:g;this.o.set(E,S)}),this.z({buttons:b.map((S,g)=>({...r(S.iconPath),tooltip:S.tooltip,handle:S===p.$zO.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const S=this.o.get(b);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(b){if(!this.v){for(const S of Object.keys(b)){const g=b[S];this.u[S]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function o(y){if(y instanceof p.$0N)return{id:y.id};const b=u(y),S=t(y);return{dark:typeof b=="string"?N.URI.file(b):b,light:typeof S=="string"?N.URI.file(S):S}}function t(y){return typeof y=="object"&&"light"in y?y.light:y}function u(y){return typeof y=="object"&&"dark"in y?y.dark:y}function r(y){const b=o(y);let S,g;return"id"in b?g=C.ThemeIcon.asClassName(b):S=b,{iconPath:S,iconClass:g}}class c extends l{constructor(b,S){super(b.identifier,S),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$de,this.L=[],this.M=new O.$de,this.N=new O.$de,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((E,D)=>{this.C.set(D,E),this.D.set(E,D)});const S=(0,$.$OG)(this.O,"quickPickItemTooltip"),g=[];for(let E=0;E<b.length;E++){const D=b[E];if(D.kind===p.QuickPickItemKind.Separator)g.push({type:"separator",label:D.label});else{D.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=D.iconPath?r(D.iconPath):void 0;g.push({handle:E,label:D.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:S?v.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((I,F)=>({...r(I.iconPath),tooltip:I.tooltip,handle:F}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(b){const S=(0,k.$Hb)(b.map(g=>this.C.get(g)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(b){const S=(0,k.$Hb)(b.map(g=>this.C.get(g)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(b,S){const g=this.C.get(b);if(!g||!g.buttons||!g.buttons.length)return;const E=g.buttons[S];E&&this.N.fire({button:E,item:g})}}class s extends l{constructor(b,S){super(b.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:A.default.Error}):this.z({validationMessage:b.message,severity:b.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(f,a)}}),define(Se[352],De([1,0,2,4,56,3,7,6,19,132,11,25,50,16,26,15,12]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=e.$5mc=void 0;function n(P){return P instanceof d.URI}function i(P,I){return P.scheme===h.Schemas.file&&I.scheme===h.Schemas.file&&f.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function l(P){if(P)return typeof P.iconPath=="string"?d.URI.file(P.iconPath):d.URI.isUri(P.iconPath)||$.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function o(P){if(P.icon){if(d.URI.isUri(P.icon))return P.icon;if($.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function t(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const F=typeof P.iconPath=="string"?P.iconPath:d.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,T=typeof I.iconPath=="string"?I.iconPath:d.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,k.$qr)(F,T)}function u(P,I){let F=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(F=t(P,I),F!==0)return F;if(P.light&&I.light)F=t(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(F!==0)return F;if(P.dark&&I.dark)F=t(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return F}function r(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let F=0;F<P.arguments.length;F++){const T=P.arguments[F],z=I.arguments[F];if(T!==z&&!(n(T)&&n(z)&&i(T,z)))return T<z?-1:1}return 0}function c(P,I){let F=(0,k.$qr)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(F!==0)return F;if(P.command&&I.command)F=r(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(F!==0)return F;if(P.decorations&&I.decorations)F=u(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)F=(0,k.$qr)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)F=(0,k.$qr)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return F}function s(P,I){for(let F=0;F<P.length;F++)if(P[F]!==I[F])return!1;return!0}function y(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?s(P.arguments,I.arguments):P.arguments===I.arguments)}function b(P,I){return(0,m.$ub)(P,I,y)}class S{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,w.$PG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,w.$PG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,w.$PG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,F,T,z,M){this.k=I,this.l=z,this.m=M,this.d="",this.e=new O.$de,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=T}showValidationMessage(I,F){(0,w.$PG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,F)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$5mc=S;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,F,T,z,M,j,U){this.q=I,this.s=F,this.t=T,this.u=z,this.v=M,this.multiDiffEditorEnableViewChanges=j,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$de,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$de,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,F){const T=this.h.get(I);return T?(0,N.$oh)(()=>this.s.executeCommand(T.command,...T.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(c),T=(0,m.$Db)(this.o,I,c).map(j=>{const U=j.toInsert.map(Z=>{const ie=this.e++;this.g.set(ie,Z);const Q=Z.resourceUri;let G;if(Z.command)if(Z.command.command==="vscode.open"||Z.command.command==="vscode.diff"||Z.command.command==="vscode.changes"){const le=new R.$Tc;G=this.s.converter.toInternal(Z.command,le),this.j.set(ie,le)}else this.h.set(ie,Z.command);const x=(0,w.$OG)(this.w,"scmMultiDiffEditor"),ne=x?Z.multiDiffEditorOriginalUri:void 0,be=x?Z.multiFileDiffEditorModifiedUri:void 0,ae=l(Z.decorations),Ce=Z.decorations&&l(Z.decorations.light)||ae,ee=Z.decorations&&l(Z.decorations.dark)||ae,B=[Ce,ee],_=Z.decorations&&Z.decorations.tooltip||"",pe=Z.decorations&&!!Z.decorations.strikeThrough,ue=Z.decorations&&!!Z.decorations.faded,ce=Z.contextValue||"";return{rawResource:[ie,Q,B,_,pe,ue,ce,G,ne,be],handle:ie}});return{start:j.start,deleteCount:j.deleteCount,toInsert:U}}),z=T.map(({start:j,deleteCount:U,toInsert:Z})=>[j,U,Z.map(ie=>ie.rawResource)]),M=T.reverse();for(const{start:j,deleteCount:U,toInsert:Z}of M){const ie=Z.map(G=>G.handle),Q=this.n.splice(j,U,...ie);for(const G of Q)this.g.delete(G),this.h.delete(G),this.j.get(G)?.dispose(),this.j.delete(G)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let F;(0,w.$OG)(this.x,"quickDiffProvider")&&(F=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:F})}get historyProvider(){return(0,w.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,w.$PG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const F=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,w.$PG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,w.$PG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const F=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(T=>T.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&b(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const F=(I||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(I,F,T,z,M,j,U){this.x=I,this.y=z,this.z=M,this.A=j,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new O.$de,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=T;const Z=d.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new S(I,F,this.#e,this.w,Z),this.#e.$registerSourceControl(this.w,M,j,U,Z)}createResourceGroup(I,F,T){const z=(0,w.$OG)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,M=new g(this.#e,this.y,this.w,I,F,z,this.x),j=O.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,j),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const I=[],F=[];for(const[T,z]of this.C){z.dispose();const M=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});O.Event.once(T.onDidDispose)(()=>{this.D.delete(T),M.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),I.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const j=T._takeResourceStateSnapshot();j.length>0&&F.push([T.handle,j]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,I,F),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(F=>{const T=F._takeResourceStateSnapshot();T.length!==0&&I.push([F.handle,T])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,L.$2h)(100)],E.prototype,"eventuallyAddResourceGroups",null),Ge([(0,L.$2h)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,F,T,z){this.l=F,this.m=T,this.n=z,this.g=new Map,this.h=new C.$Tm,this.j=new O.$de,this.e=I.getProxy(p.$$M.MainThreadSCM),this.f=I.getProxy(p.$$M.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const U=j.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(I,F,T,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,F,T,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const M=a.d++,j=new E(I,this.m,this.e,this.l,F,T,z);this.g.set(M,j);const U=this.h.get(I.identifier)||[];return U.push(j),this.h.set(I.identifier,U),j}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const F=this.h.get(I.identifier),T=F&&F[F.length-1];return T&&T.inputBox}$provideOriginalResource(I,F,T){const z=d.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const M=this.g.get(I);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,N.$oh)(()=>M.quickDiffProvider.provideOriginalResource(z,T)).then(j=>j||null)}$onInputBoxValueChange(I,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const T=this.g.get(I);return T&&T.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(I,F,T,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,F,T);const M=this.g.get(I);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(F);return j?j.$executeResourceCommand(T,z):Promise.resolve(void 0)}$validateInput(I,F,T){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,N.$oh)(()=>z.inputBox.validateInput(F,T)).then(M=>{if(!M)return Promise.resolve(void 0);const j=v.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,F,T,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,T,z)??void 0}async $provideHistoryItems(I,F,T,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(F,T,z))?.map(U=>({...U,icon:o(U)}))??void 0}async $provideHistoryItemSummary(I,F,T,z){const M=this.g.get(I)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const j=await M.provideHistoryItemSummary(F,T,z);return j?{...j,icon:o(j)}:void 0}async $provideHistoryItemChanges(I,F,T,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(F,T,z)??void 0}};e.$6mc=D,e.$6mc=D=a=Ge([We(3,A.$3j)],D)}),define(Se[353],De([1,0,6,16,2]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class R{static{this.a=0}constructor(p,m){this.d=m,this.c=new Map,this.b=p.getProxy(d.$$M.MainThreadShare)}async $provideShare(p,m,k){return await this.c.get(p)?.provideShare({selection:O.Range.to(m.selection),resourceUri:L.URI.revive(m.resourceUri)},k)??void 0}registerShareProvider(p,m){const k=R.a++;return this.c.set(k,m),this.b.$registerShareProvider(k,O.DocumentSelector.from(p,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$7mc=R}),define(Se[354],De([1,0,8,6,230,3,16,18]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new d.$$N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.$$N("statusBarItem.warningForeground")]])}#e;#t;constructor($,v,w,h,f,a=d.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=$,this.#t=v,f&&h){this.c=(0,d.$MN)(h.identifier,f);const i=w.get(this.c);i&&(a=i.alignLeft?d.StatusBarAlignment.Left:d.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=h,this.f=f,this.g=a,this.h=this.u(n)}u($){if((0,p.$ag)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!m.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let v;this.m?v=this.m:v=(0,L.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=m.b.get(this.o.id));const h=N.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,v,this.k,h,this.r?.internal,w,this.o,this.g===d.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$9mc=m;class k{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const v={message:$};return this.b.unshift(v),this.c(),new d.$aN(()=>{const w=this.b.indexOf(v);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,v){this.e=new Map,this.a=$.getProxy(O.$$M.MainThreadStatusBar),this.b=v,this.c=new k(this)}$acceptStaticEntries($){for(const v of $)this.e.set(v.entryId,v)}createStatusBarEntry($,v,w,h){return new m(this.a,this.b,this.e,$,v,w,h)}setStatusBarMessage($,v){const w=this.c.setMessage($);let h;return typeof v=="number"?h=setTimeout(()=>w.dispose(),v):typeof v<"u"&&v.then(()=>w.dispose(),()=>w.dispose()),new d.$aN(()=>{w.dispose(),clearTimeout(h)})}}e.$0mc=A}),define(Se[155],De([1,0,29,145,69,113,89,16,2]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$NP=e.$MP=e.$LP=void 0;const k=(i,l,o,t)=>{let u=l;return{enumerable:!0,configurable:!1,get(){return u},set(r){if(!o(u,r)){const c=u;u=r,i.listener?.(t(r,c))}}}},A=(i,l)=>i===l,C={range:(i,l)=>i===l?!0:!i||!l?!1:i.isEqual(l),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,l)=>!(i.length!==l.length||i.some(o=>!l.find(t=>o.id===t.id)))},$=i=>l=>({op:4,update:i(l)}),v=(i,l)=>({range:(()=>{let o;const t=$(u=>({range:d.$ut.lift(p.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return o},set(u){i.listener?.({op:6}),C.range(o,u)||(o=u,i.listener?.(t(u)))}}})(),label:k(i,l,C.label,$(o=>({label:o}))),description:k(i,void 0,C.description,$(o=>({description:o}))),sortText:k(i,void 0,C.sortText,$(o=>({sortText:o}))),canResolveChildren:k(i,!1,C.canResolveChildren,o=>({op:2,state:o})),busy:k(i,!1,C.busy,$(o=>({busy:o}))),error:k(i,void 0,C.error,$(o=>({error:p.MarkdownString.fromStrict(o)||null}))),tags:k(i,[],C.tags,(o,t)=>({op:1,new:o.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),w=i=>{const l=L.$WL.fromString(i.extId),o=new f(l.controllerId,l.localId,i.label,m.URI.revive(i.uri)||void 0);return o.range=p.Range.to(i.range||void 0),o.description=i.description||void 0,o.sortText=i.sortText||void 0,o.tags=i.tags.map(t=>p.TestTag.to({id:(0,N.$3L)(t).tagId})),o},h=i=>{let l;for(const o of i.tests){const t=w(o.item);(0,O.$vP)(t).parent=l,l=t}return l};e.$LP=h;class f{constructor(l,o,t,u){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const r=(0,O.$uP)(this,l);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof a?void 0:r.parent}},children:{value:(0,R.$tP)(r,O.$vP,f),enumerable:!0,writable:!1},...v(r,t)})}}e.$MP=f;class a extends f{constructor(l,o){super(l,l,o,void 0),this._isRoot=!0}}e.$NP=a;class n extends R.$pP{constructor(l,o,t){super({controllerId:l,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:O.$vP,getChildren:u=>u.children,root:new a(l,o),toITestItem:p.TestItem.from})}}e.$OP=n}),define(Se[34],De([1,0,18,8,16,24,6,19,11,58,29,51,2,3,5,20,155,21,48,47,40,87,90,30]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=void 0;let r=class{#e;#t;#n;constructor(g,E,D){this.b=new Map,this.c=new Map,this.#e=g.getProxy(N.$$M.MainThreadCommands),this.d=E,this.#n=D,this.#t=g.getProxy(N.$$M.MainThreadTelemetry),this.converter=new c(this,P=>{const I=this.c.get(P);return I?.result===y.Void?I:void 0},E),this.f=[{processArgument(P){return(0,k.$6h)(P)}},{processArgument(P){return(0,R.$5n)(P,function(I){if(A.$ut.isIRange(I))return L.Range.to(I);if(C.$tt.isIPosition(I))return L.Position.to(I);if(A.$ut.isIRange(I.range)&&$.URI.isUri(I.uri))return L.location.to(I);if(I instanceof a.$Fe)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const E=this.registerCommand(!1,g.id,async(...D)=>{const P=g.args.map((F,T)=>{if(!F.validate(D[T]))throw new Error(`Invalid argument '${F.name}' when running '${g.id}', received: ${typeof D[T]=="object"?JSON.stringify(D[T],null,"	"):D[T]} `);return F.convert(D[T])}),I=await this.executeCommand(g.internalId,...P);return g.result.convert(I,D,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new O.$aN(()=>{E.dispose(),this.c.delete(g.id)})}registerCommand(g,E,D,P,I,F){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:D,thisArg:P,metadata:I,extension:F}),g&&this.#e.$registerCommand(E),new O.$aN(()=>{this.b.delete(E)&&g&&this.#e.$unregisterCommand(E)})}executeCommand(g,...E){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,E,!0)}async g(g,E,D){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,E,!1);{let P=!1;const I=(0,R.$5n)(E,function(F){if(F instanceof O.$bN)return L.Position.from(F);if(F instanceof O.$cN)return L.Range.from(F);if(F instanceof O.$mN)return L.location.from(F);if(O.$CO.isNotebookRange(F))return L.NotebookRange.from(F);if(F instanceof ArrayBuffer)return P=!0,a.$Fe.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return P=!0,a.$Fe.wrap(F);if(F instanceof a.$Fe)return P=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(g,P?new n.$Bw(I):I,D);return(0,k.$6h)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(g,E,!1);throw F}}}async h(g,E,D){const P=this.b.get(g);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:F,metadata:T}=P;if(T?.args)for(let M=0;M<T.args.length;M++)try{(0,d.$ng)(E[M],T.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${T.args[M].name}' - ${T.args[M].description}`)}const z=l.$_d.create();try{return await I.apply(F,E)}catch(M){if(g===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...E);j&&(g=j.command)}if(this.d.error(M,g,P.extension?.identifier),!D)throw M;if(P.extension?.identifier){const j=this.#n.onExtensionError(P.extension.identifier,M);this.d.trace("forwarded error to extension?",j,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(M)),this.id=g,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,g,z.elapsed())}}j(g,E,D){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new o.$fp(E),duration:D})}$executeContributedCommand(g,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const D=this.b.get(g);return D?(E=E.map(P=>this.f.reduce((I,F)=>F.processArgument(I,D.extension?.identifier),P)),this.h(g,E,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(E=>(g&&(E=E.filter(D=>D[0]!=="_")),E))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[E,D]of this.b){const{metadata:P}=D;P&&(g[E]=P)}return Promise.resolve(g)}};e.$UP=r,e.$UP=r=Ge([We(0,h.$zP),We(1,m.$3j),We(2,t.$TP)],r),e.$VP=(0,w.$wi)("IExtHostCommands");class c{constructor(g,E,D){this.d=g,this.f=E,this.g=D,this.delegatingCommandId=`__vsc${(0,u.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,E){if(!g)return;const D={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return D;const P=this.f(g.command);if(P)D.id=P.internalId,D.arguments=P.args.map((I,F)=>I.convert(g.arguments&&g.arguments[F]));else if((0,p.$Lb)(g.arguments)){const I=`${g.command} /${++this.c}`;this.b.set(I,g),E.add((0,v.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),D.$ident=I,D.id=this.delegatingCommandId,D.arguments=[I],this.g.trace("CommandsConverter#CREATE",g.command,I)}return D}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const E=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$WP=c;class s{static{this.Uri=new s("uri","Uri of a text document",g=>$.URI.isUri(g),g=>g)}static{this.Position=new s("position","A position in a text document",g=>O.$bN.isPosition(g),L.Position.from)}static{this.Range=new s("range","A range in a text document",g=>O.$cN.isRange(g),L.Range.from)}static{this.Selection=new s("selection","A selection in a text document",g=>O.$dN.isSelection(g),L.Selection.from)}static{this.Number=new s("number","",g=>typeof g=="number",g=>g)}static{this.String=new s("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=s.Arr(s.String)}static Arr(g){return new s(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,E=>Array.isArray(E)&&E.every(D=>g.validate(D)),E=>E.map(D=>g.convert(D)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",g=>g instanceof O.$yN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",g=>g instanceof O.$WO,L.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",g=>g instanceof f.$MP,L.TestItem.from)}constructor(g,E,D,P){this.name=g,this.description=E,this.validate=D,this.convert=P}optional(){return new s(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,E){return new s(g??this.name,E??this.description,this.validate,this.convert)}}e.$XP=s;class y{static{this.Void=new y("no result",g=>g)}constructor(g,E){this.description=g,this.convert=E}}e.$YP=y;class b{constructor(g,E,D,P,I){this.id=g,this.internalId=E,this.description=D,this.args=P,this.result=I}}e.$ZP=b}),define(Se[355],De([1,0,19,15,2,84,135,38,34,16,8]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;const C=[new m.$ZP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of DocumentHighlight-instances.",v(k.DocumentHighlight.to))),new m.$ZP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$XP.Uri],new m.$YP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,f)=>{if((0,d.$Kb)(h))return;class a extends A.$tN{static to(i){const l=new a(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new A.$mN(f[0],k.Range.to(i.range)));return l.detail=i.detail,l.range=l.location.range,l.selectionRange=k.Range.to(i.selectionRange),l.children=i.children?i.children.map(a.to):[],l}}return h.map(a.to)})),new m.$ZP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$XP.Uri,new m.$XP("options","Formatting options",h=>!0,h=>h)],new m.$YP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new m.$ZP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$XP.Uri,m.$XP.Range,new m.$XP("options","Formatting options",h=>!0,h=>h)],new m.$YP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new m.$ZP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$XP.Uri,m.$XP.Position,new m.$XP("ch","Trigger character",h=>typeof h=="string",h=>h),new m.$XP("options","Formatting options",h=>!0,h=>h)],new m.$YP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new m.$ZP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$ZP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location-instances.",v(k.location.to))),new m.$ZP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new m.$ZP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$XP.Uri,new m.$XP("position","A position in a text document",h=>Array.isArray(h)&&h.every(f=>A.$bN.isPosition(f)),h=>h.map(k.Position.from))],new m.$YP("A promise that resolves to an array of ranges.",h=>h.map(f=>{let a;for(const n of f.reverse())a=new A.$xN(k.Range.to(n),a);return a}))),new m.$ZP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$XP.String.with("query","Search string")],new m.$YP("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(k.WorkspaceSymbol.to))),new m.$ZP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(k.CallHierarchyItem.to))),new m.$ZP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$XP.CallHierarchyItem],new m.$YP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(k.CallHierarchyIncomingCall.to))),new m.$ZP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$XP.CallHierarchyItem],new m.$YP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(k.CallHierarchyOutgoingCall.to))),new m.$ZP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:k.Range.to(h.range),placeholder:h.text}})),new m.$ZP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$XP.Uri,m.$XP.Position,m.$XP.String.with("newName","The new symbol name")],new m.$YP("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return k.WorkspaceEdit.to(h)}})),new m.$ZP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$XP.Uri,m.$XP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$YP("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(k.DocumentLink.to))),new m.$ZP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$XP.Uri],new m.$YP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$tO(h.tokenTypes,h.tokenModifiers)})),new m.$ZP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$XP.Uri],new m.$YP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,N.$dcb)(h);if(f.type==="full")return new A.$vO(f.data,void 0)})),new m.$ZP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$XP.Uri,m.$XP.Range.optional()],new m.$YP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$tO(h.tokenTypes,h.tokenModifiers)})),new m.$ZP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$XP.Uri,m.$XP.Range],new m.$YP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,N.$dcb)(h);if(f.type==="full")return new A.$vO(f.data,void 0)})),new m.$ZP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$XP.Uri,m.$XP.Position,m.$XP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$XP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$YP("A promise that resolves to a CompletionList-instance.",(h,f,a)=>{if(!h)return new A.$JN([]);const n=h.suggestions.map(i=>k.CompletionItem.to(i,a));return new A.$JN(n,h.incomplete)})),new m.$ZP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$XP.Uri,m.$XP.Position,m.$XP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$YP("A promise that resolves to SignatureHelp.",h=>{if(h)return k.SignatureHelp.to(h)})),new m.$ZP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$XP.Uri,m.$XP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$YP("A promise that resolves to an array of CodeLens-instances.",(h,f,a)=>v(n=>new A.$BN(k.Range.to(n.range),n.command&&a.fromInternal(n.command)))(h))),new m.$ZP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$XP.Uri,new m.$XP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>A.$cN.isRange(h),h=>A.$dN.isSelection(h)?k.Selection.from(h):k.Range.from(h)),m.$XP.String.with("kind","Code action kind to return code actions for").optional(),m.$XP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$YP("A promise that resolves to an array of Command-instances.",(h,f,a)=>v(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new A.$vN(n.title,n.kind?new A.$wN(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(h))),new m.$ZP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$XP.Uri],new m.$YP("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(f=>new A.$PN(k.Range.to(f.range),k.Color.to(f.color))):[])),new m.$ZP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$XP("color","The color to show and insert",h=>h instanceof A.$ON,k.Color.from),new m.$XP("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:k.Range.from(h.range)}))],new m.$YP("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(k.ColorPresentation.to):[])),new m.$ZP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$XP.Uri,m.$XP.Range],new m.$YP("A promise that resolves to an array of Inlay objects",(h,f,a)=>h.map(k.InlayHint.to.bind(void 0,a)))),new m.$ZP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$XP.Uri],new m.$YP("A promise that resolves to an array of FoldingRange objects",(h,f)=>{if(h)return h.map(k.FoldingRange.to)})),new m.$ZP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$YP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(f=>k.NotebookExclusiveDocumentPattern.to(f))})))),new m.$ZP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$XP.Uri,m.$XP.Range,new m.$XP("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof A.$cN,h=>k.InlineValueContext.from(h))],new m.$YP("A promise that resolves to an array of InlineValue objects",h=>h.map(k.InlineValue.to))),new m.$ZP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$XP("uriOrString","Uri-instance or string (only http/https)",h=>L.URI.isUri(h)||typeof h=="string"&&(0,O.$Gg)(h,O.Schemas.http,O.Schemas.https),h=>h),new m.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[k.ViewColumn.from(h),void 0]:[k.ViewColumn.from(h.viewColumn),k.TextEditorOpenOptions.from(h)])).optional(),m.$XP.String.with("label","").optional()],m.$YP.Void),new m.$ZP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$XP.Uri.with("resource","Resource to open"),m.$XP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[k.ViewColumn.from(h),void 0]:[k.ViewColumn.from(h.viewColumn),k.TextEditorOpenOptions.from(h)])).optional()],m.$YP.Void),new m.$ZP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$XP.Uri.with("left","Left-hand side resource of the diff editor"),m.$XP.Uri.with("right","Right-hand side resource of the diff editor"),m.$XP.String.with("title","Human readable title for the diff editor").optional(),new m.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[k.ViewColumn.from(h.viewColumn),k.TextEditorOpenOptions.from(h)]).optional()],m.$YP.Void),new m.$ZP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$XP.String.with("title","Human readable title for the changes editor"),new m.$XP("resourceList","List of resources to compare",h=>{for(const f of h){if(f.length!==3)return!1;const[a,n,i]=f;if(!L.URI.isUri(a)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},h=>h)],m.$YP.Void),new m.$ZP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(k.TypeHierarchyItem.to))),new m.$ZP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$XP.TypeHierarchyItem],new m.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(k.TypeHierarchyItem.to))),new m.$ZP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$XP.TypeHierarchyItem],new m.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(k.TypeHierarchyItem.to))),new m.$ZP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$XP.TestItem],m.$YP.Void),new m.$ZP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$XP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$YP.Void),new m.$ZP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$XP.String.with("name","The context key name"),new m.$XP("value","The context key value",()=>!0,h=>h)],m.$YP.Void),new m.$ZP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$XP.Uri,m.$XP.StringArray,new m.$XP("MappedEditsContext","Mapped Edits Context",h=>k.MappedEditsContext.is(h),h=>k.MappedEditsContext.from(h))],new m.$YP("A promise that resolves to a workspace edit or null",h=>h?k.WorkspaceEdit.to(h):null))];class ${static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",p.$vj)}}e.$slc=$;function v(h){return f=>{if(Array.isArray(f))return f.map(h)}}function w(h){if(!Array.isArray(h))return;const f=[];for(const a of h)R.$_t(a)?f.push(k.DefinitionLink.to(a)):f.push(k.location.to(a));return f}}),define(Se[356],De([1,0,7,3,2,6,34,16,8]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;class k{static{this.a=0}constructor(v,w){this.extension=v,this.provider=w,this.handle=k.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,w,h,f){this.f=h,this.g=f,this.b=new Map,this.d=new Map,this.e=v.getProxy(R.$$M.MainThreadInlineChat),w.registerApiCommand(new N.$ZP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new N.$XP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?p.Range.from(a.initialRange):void 0,initialSelection:m.$dN.isSelection(a.initialSelection)?p.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?p.Position.from(a.position):void 0}})],N.$YP.Void))}registerProvider(v,w,h){const f=new k(v,w);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,h?.label??v.displayName??v.name,v.identifier,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",h?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(v,w,h,f){const a=this.b.get(v);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(w)),i=p.Selection.to(h),l=await a.provider.prepareInteractiveEditorSession({document:n,selection:i},f);if(!l)return;if(l.wholeRange&&!l.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=C.a++;return this.d.set(o,new A(l)),{id:o,placeholder:l.placeholder,input:l.input,slashCommands:l.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(l.wholeRange),message:l.message}}async $provideResponse(v,w,h,f){const a=this.b.get(v);if(!a)return;const n=this.d.get(w.id);if(!n)return;const i={prompt:h.prompt,selection:p.Selection.to(h.selection),wholeRange:p.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,previewDocument:this.f.getDocument(L.URI.revive(h.previewDocument)),withIntentDetection:h.withIntentDetection};let l=!1;const o={report:async S=>{if(!h.live&&S.edits?.length)throw new Error("Progress reporting is only supported for live sessions");l||f.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:S.message,edits:S.edits?.map(p.TextEdit.from),editsShouldBeInstant:S.editsShouldBeInstant,slashCommand:S.slashCommand?.command,markdownFragment:m.$CN.isMarkdownString(S.content)?S.content.value:S.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(n.session,i,o,f));let u;try{u=await(0,d.$kh)(t,f)}finally{l=!0}if(!u)return;const r=n.responses.push(u)-1,c={wholeRange:p.Range.from(u.wholeRange),placeholder:u.placeholder};if(!C.h(u))return{...c,id:r,type:"editorEdit",message:p.MarkdownString.from(u.contents),edits:[]};const{edits:s,contents:y}=u,b=y!==void 0?p.MarkdownString.from(y):void 0;return s instanceof m.$kN?{...c,id:r,type:"bulkEdit",edits:p.WorkspaceEdit.from(s),message:b}:{...c,id:r,type:"editorEdit",edits:s.map(p.TextEdit.from),message:b}}async $provideFollowups(v,w,h,f){const a=this.b.get(v),n=this.d.get(w),i=n?.responses[h];if(a&&i&&a.provider.provideFollowups){const l=Promise.resolve(a.provider.provideFollowups(n.session,i,f));return(await(0,d.$kh)(l,f))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(v,w,h,f){const a=this.b.get(v),n=this.d.get(w),i=n?.responses[h];if(a&&i){const l=p.InteractiveEditorResponseFeedbackKind.to(f);a.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,l)}}$releaseSession(v,w){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$Bmc=C}),define(Se[357],De([1,0,2,34]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class L{constructor(N,p,m,k,A){this.a=p,this.b=m,this.c=k;const C=new O.$ZP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$XP("showOptions","Show Options",$=>!0,$=>$),new O.$XP("resource","Interactive resource Uri",$=>!0,$=>$),new O.$XP("controllerId","Notebook controller Id",$=>!0,$=>$),new O.$XP("title","Interactive editor title",$=>!0,$=>$)],new O.$YP("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const v=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:d.URI.revive($.notebookUri),inputUri:d.URI.revive($.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:d.URI.revive($.notebookUri),inputUri:d.URI.revive($.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(N,p,m,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:m,uri:N,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(N,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[N]})}}e.$Omc=L}),define(Se[358],De([1,0,19,7,22,4,3,27,2,25,11,6,34,16,8,114,302,26,48,303]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0,e.$Wmc=s;let l=class{constructor(b,S,g,E,D){this.m=S,this.n=g,this.o=E,this.q=D,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$de,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(C.$$M.MainThreadNotebookKernels);const P=new $.$ZP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$XP("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const T=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:T}}else if(F&&"notebookEditor"in F){const T=this.n.getIdByEditor(F.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return F})],$.$YP.Void),I=new $.$ZP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[$.$XP.Uri],new $.$YP("A promise that resolves to an array of variables",(F,T)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(b,S,g,E,D,P){for(const ae of this.j.values())if(ae.controller.id===S&&k.$Rm.equals(b.identifier,ae.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const I=this.k++,F=this;this.q.trace(`NotebookController[${I}], CREATED by ${b.identifier.value}, ${S}`);const T=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${b.identifier}'`);let z=!1;const M=new R.$de,j=new R.$de,U={id:s(b.identifier,S),notebookType:g,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:E||b.identifier.value,preloads:P?P.map(v.NotebookRendererScript.from):[]};let Z=D??T,ie,Q;this.a.$addKernel(I,U).catch(ae=>{console.log(ae),z=!0});let G=0;const x=()=>{if(z)return;const ae=++G;Promise.resolve().then(()=>{ae===G&&this.a.$updateKernel(I,U)})},ne=new p.$Ac,be={get id(){return S},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return U.label},set label(ae){U.label=ae??b.displayName??b.name,x()},get detail(){return U.detail??""},set detail(ae){U.detail=ae,x()},get description(){return U.description??""},set description(ae){U.description=ae,x()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ae){U.supportedLanguages=ae,x()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){U.supportsExecutionOrder=ae,x()},get rendererScripts(){return U.preloads?U.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(ae){Z=ae??T},get interruptHandler(){return ie},set interruptHandler(ae){ie=ae,U.supportsInterrupt=!!ae,x()},set variableProvider(ae){(0,a.$PG)(b,"notebookVariableProvider"),Q=ae,U.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ce=>F.a.$variablesUpdated(Ce.uri)),x()},get variableProvider(){return Q},createNotebookCellExecution(ae){if(z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.notebook.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return F._createNotebookCellExecution(ae,s(b.identifier,this.id))},createNotebookExecution(ae){if((0,a.$PG)(b,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return F._createNotebookExecution(ae,s(b.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),M.dispose(),j.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ae,Ce){Ce===w.NotebookControllerAffinity2.Hidden&&(0,a.$PG)(b,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(I,ae.uri,Ce)},onDidReceiveMessage:j.event,postMessage(ae,Ce){return(0,a.$PG)(b,"notebookMessaging"),F.a.$postMessage(I,Ce&&F.n.getIdByEditor(Ce),ae)},asWebviewUri(ae){return(0,a.$PG)(b,"notebookMessaging"),(0,h.$NAb)(ae,F.m.remote)}};return this.j.set(I,{extensionId:b.identifier,controller:be,onDidReceiveMessage:j,onDidChangeSelection:M,associatedNotebooks:ne}),be}getIdByController(b){for(const[S,g]of this.j)if(g.controller===b)return s(g.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,S){const g=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(g,S);const D={dispose:()=>{this.f.delete(g),E.a.$removeKernelDetectionTask(g)}};return this.f.set(g,D),D}registerKernelSourceActionProvider(b,S,g){const E=this.i++,D=typeof g.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,P=this;this.h.set(E,g),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,S);let I;return D!==void 0&&(I=g.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(D))),{dispose:()=>{this.h.delete(E),P.a.$removeKernelSourceActionProvider(E,E),I?.dispose()}}}async $provideKernelSourceActions(b,S){const g=this.h.get(b);if(g){const E=new N.$Tc;return(await g.provideNotebookKernelSourceActions(S)??[]).map(P=>v.NotebookKernelSourceAction.from(P,this.o.converter,E))}return[]}$acceptNotebookAssociation(b,S,g){const E=this.j.get(b);if(E){const D=this.n.getNotebookDocument(m.URI.revive(S));g?E.associatedNotebooks.set(D.uri,!0):E.associatedNotebooks.delete(D.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,D.uri.toString(),g),E.onDidChangeSelection.fire({selected:g,notebook:D.apiNotebook})}}async $executeCells(b,S,g){const E=this.j.get(b);if(!E)return;const D=this.n.getNotebookDocument(m.URI.revive(S)),P=[];for(const I of g){const F=D.getCell(I);F&&P.push(F.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,D.uri.toString(),P.length),await E.controller.executeHandler.call(E.controller,P,D.apiNotebook,E.controller)}catch(I){this.q.error(`NotebookController[${b}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(b,S,g){const E=this.j.get(b);if(!E)return;const D=this.n.getNotebookDocument(m.URI.revive(S));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,D.apiNotebook);else for(const P of g){const I=D.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(E.controller.interruptHandler){const P=this.c.get(D.uri);this.c.delete(D.uri),g.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(b,S,g,E,D,P,I){const F=this.j.get(b);if(!F)return;const T=this.n.getNotebookDocument(m.URI.revive(g)),z=F.controller.variableProvider;if(!z)return;let M;if(E!==void 0){if(M=this.s[E],!M)return}else this.s={};const j=D==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,U=z.provideVariables(T.apiNotebook,M,j,P,I);let Z=0;for await(const ie of U){if(I.isCancellationRequested)return;const Q={id:this.r++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,interfaces:ie.variable.interfaces,language:ie.variable.language,expression:ie.variable.expression,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[Q.id]=ie.variable,this.a.$receiveVariable(S,Q),Z++>=i.$hjb)return}}$acceptKernelMessageFromRenderer(b,S,g){const E=this.j.get(b);if(!E)return;const D=this.n.getEditorById(S);E.onDidReceiveMessage.fire(Object.freeze({editor:D.apiEditor,message:g}))}$cellExecutionChanged(b,S,g){const D=this.n.getNotebookDocument(m.URI.revive(b)).getCell(S);if(D){const P=g?v.NotebookCellExecutionState.to(g):w.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:D.apiCell,state:P})}}_createNotebookCellExecution(b,S){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const D=new t(S,E,this.a);this.b.set(E.uri,D);const P=D.onDidChangeState(()=>{D.state===o.Resolved&&(D.dispose(),P.dispose(),this.b.delete(E.uri))});return D.asApiObject()}_createNotebookExecution(b,S){const g=this.n.getNotebookDocument(b.uri),E=b.getCells().find(I=>{const F=g.getCellFromApiCell(I);return F&&this.b.has(F.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const D=new r(S,g,this.a),P=D.onDidChangeState(()=>{D.state===u.Resolved&&(D.dispose(),P.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[D,P]),D.asApiObject()}};e.$Vmc=l,e.$Vmc=l=Ge([We(4,A.$3j)],l);var o;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(o||(o={}));class t extends N.$Uc{static{this.a=0}get state(){return this.f}constructor(b,S,g){super(),this.m=S,this.n=g,this.b=t.a++,this.c=new R.$de,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new L.$oe),this.h=new c(10,E=>this.s(E)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const S=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new n.$Bw(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let S=this.m;if(b&&(S=this.m.notebook.getCellFromApiCell(b)),!S)throw new Error("INVALID cell");return S.handle}y(b){return b.map(S=>{const g=w.$GO.ensureUniqueMimeTypes(S.items,!0);return g===S.items?v.NotebookCellOutput.from(S):v.NotebookCellOutput.from({items:g,id:S.id,metadata:S.metadata})})}async z(b,S,g){const E=this.w(S),D=this.y((0,d.$2b)(b));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:E,append:g,outputs:D})}async C(b,S,g){return b=w.$GO.ensureUniqueMimeTypes((0,d.$2b)(b),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:b.map(v.NotebookCellOutputItem.from),outputId:S.id,append:g})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(g){b.j=g,b.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(g){if(b.f===o.Resolved||b.f===o.Started)throw new Error("Cannot call start again");b.f=o.Started,b.c.fire(),b.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,E,D){if(b.f===o.Resolved)throw new Error("Cannot call resolve twice");b.f=o.Resolved,b.c.fire(),b.h.flush();const P=D?{message:D.message,stack:D.stack,location:D?.location?{startLineNumber:D.location.start.line,startColumn:D.location.start.character,endLineNumber:D.location.end.line,endColumn:D.location.end.character}:void 0,uri:D.uri}:void 0;b.n.$completeExecution(b.b,new n.$Bw({runEndTime:E,lastRunSuccess:g,error:P}))},clearOutput(g){return b.t(),b.z([],g,!1)},appendOutput(g,E){return b.t(),b.z(g,E,!0)},replaceOutput(g,E){return b.t(),b.z(g,E,!1)},appendOutputItems(g,E){return b.t(),b.C(g,E,!0)},replaceOutputItems(g,E){return b.t(),b.C(g,E,!1)}})}}var u;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(u||(u={}));class r extends N.$Uc{static{this.a=0}get state(){return this.f}constructor(b,S,g){super(),this.h=S,this.j=g,this.b=r.a++,this.c=new R.$de,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new L.$oe),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(b,S){this.f=b,this.g=S,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new O.$Th,this.b=Date.now(),(0,O.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>b.complete())}}function s(y,b){return`${y.value}/${b}`}}),define(Se[43],De([1,0,4,6,5,2,20,3,8,232,13,279,22,30,280,50,7,16,34]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=e.$8lc=e.$7lc=void 0,e.$7lc=(0,L.$wi)("IExtHostTerminalService");class i extends p.$Uc{constructor(g,E,D,P){super(),this.u=g,this._id=E,this.w=D,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new d.$de),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(F,T=!0){I.C(),I.u.$sendText(I._id,F,T)},show(F){I.C(),I.u.$show(I._id,F)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??E?.cwd??void 0,env:g.env??void 0,icon:s(g.iconPath)??void 0,color:h.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(g.location,E?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,E,D,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:h.ThemeColor.isThemeColor(I)?I.id:void 0,location:E?.location||this.z(g,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,E){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in g?{viewColumn:a.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,E){this.j=Object.freeze({code:g,reason:E})}setDimensions(g,E){return g===this.f&&E===this.h||g===0||E===0?!1:(this.f=g,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(E=>{E!==g&&(this.b=Promise.resolve(g))})}}e.$8lc=i;class l{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new d.$de,this.onProcessData=this.a.event,this.b=new d.$de,this.d=new d.$de,this.onDidChangeProperty=this.d.event,this.f=new d.$de,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,E){this.g.setDimensions?.({columns:g,rows:E})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,E,D){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new d.$de,this.onDidCloseTerminal=this.H.event,this.I=new d.$de,this.onDidOpenTerminal=this.I.event,this.J=new d.$de,this.onDidChangeActiveTerminal=this.J.event,this.L=new d.$de,this.onDidChangeTerminalDimensions=this.L.event,this.M=new d.$de,this.onDidChangeTerminalState=this.M.event,this.N=new d.$de,this.onDidChangeShell=this.N.event,this.O=new d.$de({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new d.$de({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(O.$$M.MainThreadTerminalService),this.y=new w.$Fvb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:P=>{const I=F=>{const T=F;return this.getTerminalById(T.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let F=0;F<P.length&&P[F].$mid===15;F++)P[F]=I(P[F]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,E){const D=new i(this.a,(0,v.$Sg)(),g,g.name),P=new l(g.pty);return D.createExtensionTerminal(g.location,E,this.R(g,E).resolvedExtHostIdentifier,s(g.iconPath),y(g.color)).then(I=>{const F=this.S(I,P);this.h[I]=F}),this.f.push(D),D.value}R(g,E){if(E=E||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const D=g.location.parentTerminal;if(D){const P=this.f.find(I=>I.value===D);P&&(E.resolvedExtHostIdentifier=P._id)}}else g.location&&typeof g.location!="object"?E.location=g.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(g,E){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const P=new l(E),I=this.S(g,P);this.h[g]=I}async $acceptActiveTerminalChanged(g){const E=this.b;if(g===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const D=this.getTerminalById(g);D&&(this.b=D,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,E){const D=this.getTerminalById(g);D&&this.O.fire({terminal:D.value,data:E})}async $acceptTerminalDimensions(g,E,D){const P=this.getTerminalById(g);P&&P.setDimensions(E,D)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(g,E){const D=this.getTerminalById(g);D&&this.P.fire({terminal:D.value,...E})}async $acceptTerminalMaximumDimensions(g,E,D){this.g.get(g)?.resize(E,D)}async $acceptTerminalTitleChange(g,E){const D=this.getTerminalById(g);D&&(D.name=E)}async $acceptTerminalClosed(g,E,D){const P=this.X(this.f,g);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(E,D),this.H.fire(I.value)}}$acceptTerminalOpened(g,E,D,P){if(E){const T=this.X(this.f,E);if(T!==null){this.f[T]._id=g,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},F=new i(this.a,g,I,D);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(g,E){this.getTerminalById(g)?._setProcessId(E)}async $startExtensionTerminal(g,E){const D=this.getTerminalById(g);if(!D)return{message:(0,k.localize)(0,null,g)};D.isOpen||await new Promise(I=>{const F=this.onDidOpenTerminal(async T=>{T===D.value&&(F.dispose(),I())})});const P=this.g.get(g);P?P.startSendingEvents(E):this.j[g]={initialDimensions:E}}S(g,E){const D=new p.$Tc;D.add(E.onProcessReady(I=>this.a.$sendProcessReady(g,I.pid,I.cwd,I.windowsPty))),D.add(E.onDidChangeProperty(I=>this.a.$sendProcessProperty(g,I))),this.y.startBuffering(g,E.onProcessData),D.add(E.onProcessExit(I=>this.U(g,I))),this.g.set(g,E);const P=this.j[g];return P&&E instanceof l&&(E.startSendingEvents(P.initialDimensions),delete this.j[g]),D}$acceptProcessAckDataEvent(g,E){this.g.get(g)?.acknowledgeDataEvent(E)}$acceptProcessInput(g,E){this.g.get(g)?.input(E)}$acceptTerminalInteraction(g){const E=this.getTerminalById(g);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(g,E){this.getTerminalById(g)?.setSelection(E)}$acceptProcessResize(g,E,D){try{this.g.get(g)?.resize(E,D)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(g,E){this.g.get(g)?.shutdown(E)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(E=>this.a.$sendProcessProperty(g,{type:"cwd",value:E}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new m.$aN(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,E,D){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,D),this.a.$registerProfileProvider(E,g.identifier.value),new m.$aN(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(g,E,D){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,D),this.a.$registerQuickFixProvider(g,E),new m.$aN(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,E){const D=new $.$oe().token;if(D.isCancellationRequested)return;const P=this.D.get(g);if(!P)return;const I=await P.provideTerminalQuickFixes(E,D);if(I===null||Array.isArray(I)&&I.length===0)return;const F=new p.$Tc;if(this.w.value=F,!Array.isArray(I))return I?a.TerminalQuickFix.from(I,this.Q.converter,F):void 0;const T=[];for(const z of I){const M=a.TerminalQuickFix.from(z,this.Q.converter,F);M&&T.push(M)}return T}async $createContributedProfileTerminal(g,E){const D=new $.$oe().token;let P=await this.C.get(g)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,E);return}this.createTerminalFromOptions(P.options,E)}}async $provideLinks(g,E){const D=this.getTerminalById(g);if(!D)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const I=new $.$oe;this.G.set(g,I);const F=[],T={terminal:D.value,line:E},z=[];for(const U of this.z)z.push(f.Promises.withAsyncBody(async Z=>{I.token.onCancellationRequested(()=>Z({provider:U,links:[]}));const ie=await U.provideTerminalLinks(T,I.token)||[];I.token.isCancellationRequested||Z({provider:U,links:ie})}));const M=await Promise.all(z);if(I.token.isCancellationRequested)return[];const j=new Map;for(const U of M)U&&U.links.length>0&&F.push(...U.links.map(Z=>{const ie={id:o++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return j.set(ie.id,{provider:U.provider,link:Z}),ie}));return this.F.set(g,j),F}$activateLink(g,E){const D=this.F.get(g)?.get(E);D&&D.provider.handleTerminalLink(D.link)}U(g,E){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const D=this.h[g];D&&(D.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,E)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const E=this.f.findIndex(D=>D.value===g);return E>=0?E:null}W(g,E){const D=this.X(g,E);return D!==null?g[D]:null}X(g,E){const D=g.findIndex(P=>P._id===E);return D>=0?D:null}getEnvironmentVariableCollection(g){let E=this.n.get(g.identifier.value);return E||(E=new u,this.Z(g.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(g,E){const D=(0,C.$ls)(E.map),P=(0,C.$ms)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(g,E.persistent,D.length===0?void 0:D,P)}$initEnvironmentVariableCollections(g){g.forEach(E=>{const D=E[0],P=new u(E[1]);this.Z(D,P)})}$acceptDefaultProfile(g,E){const D=this.s;this.s=g,this.u=E,D?.path!==g.path&&this.N.fire(g.path)}Z(g,E){this.n.set(g,E),E.onDidChangeCollection(()=>{this.Y(g,E)})}};e.$9lc=t,e.$9lc=t=Ge([We(1,n.$VP),We(2,N.$zP)],t);class u{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new d.$de,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const E=this.h(g);let D=this.a.get(E);return D||(D=new r(this,g),this.a.set(E,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(g,E,D,P){this.f(g,{value:E,type:m.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:P})}append(g,E,D,P){this.f(g,{value:E,type:m.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:P})}prepend(g,E,D,P){this.f(g,{value:E,type:m.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:P})}f(g,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(g,E.scope),P=this.map.get(D),I=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==E.value||P.type!==E.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const F=this.g(g,E.scope),T={variable:g,...E,options:I};this.map.set(F,T),this.d.fire()}}get(g,E){const D=this.g(g,E),P=this.map.get(D);return P?b(P):void 0}g(g,E){const D=this.h(E);return D.length?`${g}:::${D}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const E=new Map;for(const[D,P]of this.map)this.h(P.scope)===this.h(g)&&E.set(P.variable,b(P));return E}delete(g,E){const D=this.g(g,E);this.map.delete(D),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[E,D]of this.map)D.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(E);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,E){const D=this.h(E),P=this.descriptionMap.get(D);if(!P||P.description!==g){let I;typeof g=="string"?I=g:I=g?.value.split(`

`)[0];const F={description:I,scope:E};this.descriptionMap.set(D,F),this.d.fire()}}getDescription(g){const E=this.h(g);return this.descriptionMap.get(E)?.description}k(g){const E=this.h(g);this.descriptionMap.delete(E)}}class r{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,E){this.b=g,this.d=E,this.a=new d.$de}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,E,D){this.b.replace(g,E,D,this.d)}append(g,E,D){this.b.append(g,E,D,this.d)}prepend(g,E,D){this.b.prepend(g,E,D,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,E){this.b.getVariableMap(this.d).forEach((D,P)=>g.call(E,P,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(g,E){super(!1,g,E)}createTerminal(g,E,D){throw new A.$_}createTerminalFromOptions(g,E){throw new A.$_}};e.$0lc=c,e.$0lc=c=Ge([We(0,n.$VP),We(1,N.$zP)],c);function s(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function y(S){return h.ThemeColor.isThemeColor(S)?S:void 0}function b(S){const g={...S};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Se[156],De([1,0,8,3,5,6,20,43,4,2,7]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0,e.$bnc=(0,L.$wi)("IExtHostTerminalShellIntegration");let C=class extends O.$Uc{constructor(f,a){super(),this.h=a,this.b=new Map,this.c=new m.$de,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$de,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$de,this.onDidEndTerminalShellExecution=this.g.event,this.a=f.getProxy(R.$$M.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(f){const a=this.h.getTerminalById(f);if(!a)return;const n=a.value;let i=this.b.get(f);i||(i=new $(a.value,this.f),this.b.set(f,i),i.store.add(a.onWillDispose(()=>this.b.get(f)?.dispose())),i.store.add(i.onDidRequestShellExecution(l=>this.a.$executeCommand(f,l))),i.store.add(i.onDidRequestEndExecution(l=>this.g.fire(l))),i.store.add(i.onDidRequestChangeShellIntegration(l=>this.c.fire(l))),a.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(f,a,n,i,l){this.b.has(f)||this.$shellIntegrationChange(f);const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.startShellExecution(o,l)}$shellExecutionEnd(f,a,n,i,l){const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.endShellExecution(o,l)}$shellExecutionData(f,a){this.b.get(f)?.emitData(a)}$cwdChange(f,a){this.b.get(f)?.setCwd((0,k.$vc)(a)?k.URI.revive(a):a)}$closeTerminal(f){this.b.get(f)?.dispose(),this.b.delete(f)}};e.$cnc=C,e.$cnc=C=Ge([We(0,N.$zP),We(1,p.$7lc)],C);class $ extends O.$Uc{get currentExecution(){return this.a}constructor(f,a){super(),this.j=f,this.m=a,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$de),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$de),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$de),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,l){let o=i;l&&(o+=` "${l.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(o);const t={value:o,confidence:d.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=n.startShellExecution(t,n.c,!0).value;return n.b=!0,u}}}startShellExecution(f,a,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new v(f,a);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(f){this.currentExecution?.emitData(f)}endShellExecution(f,a){this.a&&(this.a.endExecution(f),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(f){let a=!1;k.URI.isUri(this.c)?a=!k.URI.isUri(f)||this.c.toString()!==f.toString():this.c!==f&&(a=!0),a&&(this.c=f,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(f,a){this.c=f,this.cwd=a,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Wh.EMPTY;this.a=new w}return this.a.createIterable()}emitData(f){this.a?.emitData(f)}endExecution(f){f&&(this.c=f),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$vh);const f=this.a;return new A.$Wh(async n=>{this.b.push(n),await f.wait()})}emitData(f){for(const a of this.b)a.emitOne(f)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[359],De([1,0,7,21,22,4,75,57,3,18,30,11,6,20,155,16,8,69,113,89]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=e.$enc=e.$dnc=void 0;let l=class extends m.$Uc{constructor(I,F,T,z){super(),this.w=z,this.f=this.B(new R.$de),this.g=new Map,this.s=this.B(new R.$de),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy($.$$M.MainThreadTesting),this.m=new S(this.h),this.j=new r(this.h,F),T.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 16:{const j=M,U=j.tests[j.tests.length-1].item.extId;return this.g.get(a.$WL.root(U))?.collection.tree.get(U)?.actual??(0,w.$LP)(M)}case 18:{const{test:j,message:U}=M,Z=j.item.extId;return{test:this.g.get(a.$WL.root(Z))?.collection.tree.get(Z)?.actual??(0,w.$LP)({$mid:16,tests:[j]}),message:h.TestMessage.to(U)}}default:return M}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await T.executeCommand("_testing.getExplorerSelection"),j=U=>{const Z=this.g.get(a.$WL.root(U));if(Z)return a.$WL.isRoot(U)?Z.controller:Z.collection.tree.get(U)?.actual};return{include:M?.include.map(j).filter(k.$eg)||[],exclude:M?.exclude.map(j).filter(k.$eg)||[]}})}createTestController(I,F,T,z){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const M=new m.$Tc,j=M.add(new w.$OP(F,T,this.w));j.root.label=T;const U=new Map,Z=new Set,ie=this.h,Q={items:j.root.children,get label(){return T},set label(x){T=x,j.root.label=x,ie.$updateController(F,{label:T})},get refreshHandler(){return z},set refreshHandler(x){z=x,ie.$updateController(F,{canRefresh:!!x})},get id(){return F},createRunProfile:(x,ne,be,ae,Ce,ee)=>{let B=(0,p.$kj)(x);for(;U.has(B);)B++;return new E(this.h,U,Z,this.s.event,F,B,x,ne,be,ae,Ce,ee)},createTestItem(x,ne,be){return new w.$MP(F,x,ne,be)},createTestRun:(x,ne,be=!0)=>this.j.createTestRun(F,j,x,ne,be),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const ne=x instanceof Array?x:[x];this.h.$markTestRetired(ne.map(be=>a.$WL.fromExtHostTestItem(be,F).toString()))}},set resolveHandler(x){j.resolveHandler=x},get resolveHandler(){return j.resolveHandler},dispose:()=>{M.dispose()}};ie.$registerTestController(F,T,!!z),M.add((0,m.$Sc)(()=>ie.$unregisterTestController(F)));const G={controller:Q,collection:j,profiles:U,extension:I,activeProfiles:Z};return this.g.set(F,G),M.add((0,m.$Sc)(()=>this.g.delete(F))),M.add(j.onDidGenerateDiff(x=>ie.$publishDiff(F,x.map(i.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.m.checkout()}async runTests(I,F=L.CancellationToken.None){const T=c(I);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(T.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:I.preserveFocus??!0,targets:[{testIds:I.include?.map(M=>a.$WL.fromExtHostTestItem(M,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:D[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:I.exclude?.map(M=>M.id)},F)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,F){return(await this.j.getCoverageDetails(I,F))?.map(h.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,F){this.g.get(I)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(I){const F=new Map;for(const[T,z]of Object.entries(I)){const M=this.g.get(T);if(!M)continue;const j=new Map,U=z.filter(ie=>!M.activeProfiles.has(ie)),Z=[...M.activeProfiles].filter(ie=>!z.includes(ie));for(const ie of U)j.set(ie,!0),M.activeProfiles.add(ie);for(const ie of Z)j.set(ie,!1),M.activeProfiles.delete(ie);j.size&&F.set(T,j)}this.s.fire(F)}async $refreshTests(I,F){await this.g.get(I)?.controller.refreshHandler?.(F)}$publishTestResults(I){this.results=Object.freeze(I.map(h.TestResults.to).concat(this.results).sort((F,T)=>T.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,F){const T=this.g.get(a.$WL.fromString(I).controllerId)?.collection;T&&(await T.expand(I,F<0?1/0:F),T.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(F=>i.TestsDiffOp.deserialize({asCanonicalUri:T=>T},F)))}async $runControllerTests(I,F){return Promise.all(I.map(T=>this.y(T,!1,F)))}async $startContinuousRun(I,F){const T=new L.$oe(F),z=await Promise.all(I.map(M=>this.y(M,!0,T.token)));return!F.isCancellationRequested&&!z.some(M=>M.error)&&await new Promise(M=>F.onCancellationRequested(M)),T.dispose(!0),z}async y(I,F,T){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:M,profiles:j}=z,U=j.get(I.profileId);if(!U)return{};const Z=I.testIds.map(x=>M.tree.get(x)).filter(k.$eg),ie=I.excludeExtIds.map(x=>z.collection.tree.get(x)).filter(k.$eg).filter(x=>Z.some(ne=>ne.fullId.compare(x.fullId)===2));if(!Z.length)return{};const Q=new f.$NO(Z.some(x=>x.actual instanceof w.$NP)?void 0:Z.map(x=>x.actual),ie.map(x=>x.actual),U,F),G=(0,i.$ZL)(I)&&this.j.prepareForMainThreadTestRun(Q,s.fromInternal(I,z.collection),U,T);try{return await U.runHandler(Q,T),{}}catch(x){return{error:String(x)}}finally{G&&G.hasRunningTasks&&!T.isCancellationRequested&&await R.Event.toPromise(G.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$dnc=l,e.$dnc=l=Ge([We(0,v.$zP),We(1,C.$3j)],l);const o=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class u extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,F,T,z,M){super(),this.y=I,this.z=F,this.C=T,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$de),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$oe(M));const j=this.B(new d.$Ih(()=>this.F(),o));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const U=new R.$de;this.s=U.event,this.B((0,m.$Sc)(()=>{U.fire(),U.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,F){const[,T,z]=a.$WL.fromString(I).path,M=this.w.get(z);if(!M)return[];const j=this.g.get(T);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,M,F)??[]}createRun(I){const F=this.y.id,T=this.y.controllerId,z=(0,A.$Sg)(),M=ie=>(Q,...G)=>{if(U){this.C.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}this.y.isIncluded(Q)&&(this.H(Q),ie(Q,...G))},j=(ie,Q)=>{const G=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if(ie.uri&&ie.range){const x={range:h.Range.from(ie.range),uri:ie.uri};for(const ne of G)ne.location=ne.location||x}this.z.$appendTestMessagesInRun(F,z,a.$WL.fromExtHostTestItem(ie,T).toString(),G)};let U=!1;const Z={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:ie=>{const Q=ie.uri.toString(),G=new a.$WL([F,z,Q]).toString();this.w.set(Q,ie),this.z.$appendCoverage(F,z,h.TestCoverage.fromFile(G,ie))},enqueued:M(ie=>{this.z.$updateTestStateInRun(F,z,a.$WL.fromExtHostTestItem(ie,T).toString(),1)}),skipped:M(ie=>{this.z.$updateTestStateInRun(F,z,a.$WL.fromExtHostTestItem(ie,T).toString(),5)}),started:M(ie=>{this.z.$updateTestStateInRun(F,z,a.$WL.fromExtHostTestItem(ie,T).toString(),2)}),errored:M((ie,Q,G)=>{j(ie,Q),this.z.$updateTestStateInRun(F,z,a.$WL.fromExtHostTestItem(ie,T).toString(),6,G)}),failed:M((ie,Q,G)=>{j(ie,Q),this.z.$updateTestStateInRun(F,z,a.$WL.fromExtHostTestItem(ie,T).toString(),4,G)}),passed:M((ie,Q)=>{this.z.$updateTestStateInRun(F,z,a.$WL.fromExtHostTestItem(ie,this.y.controllerId).toString(),3,Q)}),appendOutput:(ie,Q,G)=>{U||(G&&(this.y.isIncluded(G)?this.H(G):G=void 0),this.z.$appendOutputToRun(F,z,O.$Fe.fromString(ie),Q&&h.location.from(Q),G&&a.$WL.fromExtHostTestItem(G,T).toString()))},end:()=>{U||(U=!0,this.z.$finishedTestRunTask(F,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:Z}),this.z.$startedTestRunTask(F,{id:z,name:I,running:!0}),Z}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof w.$MP))throw new n.$rP(I.id);if(this.h.has(a.$WL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const F=[],T=this.y.colllection.root;for(;;){const z=h.TestItem.from(I);if(F.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===T))break;I=I.parent||T}this.z.$addTestsToRun(this.y.controllerId,this.y.id,F)}dispose(){this.G(),super.dispose()}}class r{get trackers(){return this.c.values()}constructor(I,F){this.g=I,this.h=F,this.c=new Map,this.f=new Map}getCoverageDetails(I,F){const T=a.$WL.root(I);return this.f.get(T)?.getCoverageDetails(I,F)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[F,{id:T}]of this.c)T===I&&this.c.delete(F)}prepareForMainThreadTestRun(I,F,T,z){return this.j(I,F,T,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,F,T,z,M){const j=this.c.get(T);if(j)return j.createRun(z);const U=s.fromPublic(I,F,T,M),Z=c(T);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!T.continuous,profile:Z&&{group:D[Z.kind],id:Z.profileId},exclude:T.exclude?.map(Q=>a.$WL.fromExtHostTestItem(Q,F.root.id).toString())??[],id:U.id,include:T.include?.map(Q=>a.$WL.fromExtHostTestItem(Q,F.root.id).toString())??[F.root.id],preserveFocus:T.preserveFocus??!0,persist:M});const ie=this.j(T,U,T.profile);return R.Event.once(ie.onEnd)(()=>{this.g.$finishedExtensionTestRun(U.id)}),ie.createRun(z)}j(I,F,T,z){const M=new u(F,this.g,this.h,T,z);return this.c.set(I,M),this.f.set(M.id,M),M}}e.$enc=r;const c=P=>{if(P.profile){if(!(P.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class s{static fromPublic(I,F,T,z){return new s(I,(0,A.$Sg)(),T.include?.map(M=>a.$WL.fromExtHostTestItem(M,I).toString())??[I],T.exclude?.map(M=>a.$WL.fromExtHostTestItem(M,I).toString())??[],z,F)}static fromInternal(I,F){return new s(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,F)}constructor(I,F,T,z,M,j){this.controllerId=I,this.id=F,this.isPersisted=M,this.colllection=j,this.c=T.map(U=>U+"\0"),this.f=z.map(U=>U+"\0")}isIncluded(I){const F=a.$WL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const T of this.f)if(F===T||F.startsWith(T))return!1;for(const T of this.c)if(F===T||F.startsWith(T))return!0;return!1}}e.$fnc=s;class y{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,h.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const F=a.$WL.parentId(I.item.extId);if(F&&this.h.has(F.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:F,g:T}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...T].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class b extends i.$6L{constructor(){super(...arguments),this.s=new R.$de,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,F){return{...I,revived:h.TestItem.toPlain(I.item),depth:F?F.depth+1:0,children:new Set}}v(){return new y(this.s)}}class S{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(F=>F.revived)},dispose:(0,N.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new b({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const g=(P,I,F,T)=>{F?Object.assign(F,T):I.$updateTestRunConfig(P.controllerId,P.profileId,T)};class E{#e;#t;#n;#i;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,g(this,this.#e,this.#i,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,g(this,this.#e,this.#i,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),g(this,this.#e,this.#i,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,g(this,this.#e,this.#i,{tag:I?h.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,g(this,this.#e,this.#i,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#n,I=>I.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(k.$eg))}constructor(I,F,T,z,M,j,U,Z,ie,Q=!1,G=void 0,x=!1){this.controllerId=M,this.profileId=j,this.f=U,this.kind=Z,this.runHandler=ie,this._tag=G,this.g=x,this.#e=I,this.#s=F,this.#t=T,this.#n=z,F.set(j,this);const ne=D[Z];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);Q&&T.add(j),this.#i={profileId:j,controllerId:M,tag:G?h.TestTag.namespace(this.controllerId,G.id):null,label:U,group:ne,isDefault:Q,hasConfigurationHandler:!1,supportsContinuousRun:x},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$gnc=E;const D={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(Se[157],De([1,0,62,13,125,16,8]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$HP=e.$GP=void 0;class p{static{this.c=new L.$EP("TextEditorDecorationType")}constructor($,v,w){const h=p.c.nextId();$.$registerTextEditorDecorationType(v.identifier,h,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:h,dispose(){$.$removeTextEditorDecorationType(h)}})}}e.$GP=p;class m{constructor($,v){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,v){this.k();let w=null;if($ instanceof N.$bN)w=new N.$cN($,$);else if($ instanceof N.$cN)w=$;else throw new Error("Unrecognized location");this.l(w,v,!1)}insert($,v){this.k(),this.l(new N.$cN($,$),v,!0)}delete($){this.k();let v=null;if($ instanceof N.$cN)v=$;else throw new Error("Unrecognized location");this.l(v,null,!0)}l($,v,w){const h=this.c.validateRange($);this.g.push({range:h,text:v,forceMoveMarkers:w})}setEndOfLine($){if(this.k(),$!==N.EndOfLine.LF&&$!==N.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=$}}class k{constructor($,v,w,h){this.c=$,this.d=v,this._accept(w),this.e=h;const f=this;this.value={get tabSize(){return f.f},set tabSize(a){f.n(a)},get indentSize(){return f.g},set indentSize(a){f.p(a)},get insertSpaces(){return f.j},set insertSpaces(a){f.s(a)},get cursorStyle(){return f.k},set cursorStyle(a){f.t(a)},get lineNumbers(){return f.l},set lineNumbers(a){f.u(a)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.originalIndentSize,this.j=$.insertSpaces,this.k=$.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to($.lineNumbers)}m($){if($==="auto")return"auto";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}n($){const v=this.m($);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}p($){const v=this.o($);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q($){return $==="auto"?"auto":$==="false"?!1:!!$}s($){const v=this.q($);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t($){this.k!==$&&(this.k=$,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}u($){this.l!==$&&(this.l=$,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const v={};let w=!1;if(typeof $.tabSize<"u"){const h=this.m($.tabSize);h==="auto"?(w=!0,v.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,w=!0,v.tabSize=h)}if(typeof $.indentSize<"u"){const h=this.o($.indentSize);h==="tabSize"?(w=!0,v.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,w=!0,v.indentSize=h)}if(typeof $.insertSpaces<"u"){const h=this.q($.insertSpaces);h==="auto"?(w=!0,v.insertSpaces=h):this.j!==h&&(this.j=h,w=!0,v.insertSpaces=h)}typeof $.cursorStyle<"u"&&this.k!==$.cursorStyle&&(this.k=$.cursorStyle,w=!0,v.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.l!==$.lineNumbers&&(this.l=$.lineNumbers,w=!0,v.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v($,v){v.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(w)})}}e.$HP=k;class A{constructor($,v,w,h,f,a,n,i){this.id=$,this.j=v,this.k=w,this.g=!1,this.h=new Set,this.c=f,this.d=new k(this.j,this.id,a,w),this.e=n,this.f=i;const l=this;this.value=Object.freeze({get document(){return h.value},set document(o){throw new O.$9("document")},get selection(){return l.c&&l.c[0]},set selection(o){if(!(o instanceof N.$dN))throw(0,O.$7)("selection");l.c=[o],l.l()},get selections(){return l.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof N.$dN)))throw(0,O.$7)("selections");l.c=o,l.l()},get visibleRanges(){return l.e},set visibleRanges(o){throw new O.$9("visibleRanges")},get options(){return l.d.value},set options(o){l.g||l.d.assign(o)},get viewColumn(){return l.f},set viewColumn(o){throw new O.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(l.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new m(h.value,t);return o(u),l.m(u)},insertSnippet(o,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(l.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=l.c.map(c=>R.Range.from(c));else if(t instanceof N.$bN){const{lineNumber:c,column:s}=R.Position.from(t);r=[{startLineNumber:c,startColumn:s,endLineNumber:c,endColumn:s}]}else if(t instanceof N.$cN)r=[R.Range.from(t)];else{r=[];for(const c of t)if(c instanceof N.$cN)r.push(R.Range.from(c));else{const{lineNumber:s,column:y}=R.Position.from(c);r.push({startLineNumber:s,startColumn:y,endLineNumber:s,endColumn:y})}}return v.$tryInsertSnippet($,h.value.version,o.value,r,u)},setDecorations(o,t){const u=t.length===0;u&&!l.h.has(o.key)||(u?l.h.delete(o.key):l.h.add(o.key),l.n(()=>{if(R.$wP(t))return v.$trySetDecorations($,o.key,R.$xP(t));{const r=new Array(4*t.length);for(let c=0,s=t.length;c<s;c++){const y=t[c];r[4*c]=y.start.line+1,r[4*c+1]=y.start.character+1,r[4*c+2]=y.end.line+1,r[4*c+3]=y.end.character+1}return v.$trySetDecorationsFast($,o.key,r)}}))},revealRange(o,t){l.n(()=>v.$tryRevealRange($,R.Range.from(o),t||N.TextEditorRevealType.Default))},show(o){v.$tryShowEditor($,R.ViewColumn.from(o))},hide(){v.$tryHideEditor($)}})}dispose(){(0,d.ok)(!this.g),this.g=!0}_acceptOptions($){(0,d.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,d.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,d.ok)(!this.g),this.f=$}_acceptSelections($){(0,d.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const v=$.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const w=v.edits.map(f=>f.range);w.sort((f,a)=>f.end.line===a.end.line?f.end.character===a.end.character?f.start.line===a.start.line?f.start.character-a.start.character:f.start.line-a.start.line:f.end.character-a.end.character:f.end.line-a.end.line);for(let f=0,a=w.length-1;f<a;f++){const n=w[f].end;if(w[f+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=v.edits.map(f=>({range:R.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,h,{setEndOfLine:typeof v.setEndOfLine=="number"?R.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$IP=A}),define(Se[73],De([1,0,62,4,3,2,5,6,153,20,157,16,11,27,15,39,46]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$JP=void 0;class a{constructor(l){this.value=l,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(l,o){this.h=l,this.i=o,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new O.$de,this.e=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const o=[],t=[],u=[];if(l.removedDocuments)for(const r of l.removedDocuments){const c=R.URI.revive(r),s=this.c.get(c);s?.unref()&&(this.c.delete(c),o.push(s.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const c=R.URI.revive(r.uri);let s=this.c.get(c);if(s&&c.scheme!==w.Schemas.vscodeNotebookCell&&c.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);s||(s=new a(new m.$CP(this.h.getProxy(p.$$M.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this.c.set(c,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const r of l.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&u.push(c)}if(l.addedEditors)for(const r of l.addedEditors){const c=R.URI.revive(r.documentUri);d.ok(this.c.has(c),`document '${c}' does not exist`),d.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const s=this.c.get(c).value,y=new A.$IP(r.id,this.h.getProxy(p.$$M.MainThreadTextEditors),this.i,new f.$V(()=>s.document),r.selections.map(C.Selection.to),r.options,r.visibleRanges.map(b=>C.Range.to(b)),typeof r.editorPosition=="number"?C.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,y)}l.newActiveEditor!==void 0&&(d.ok(l.newActiveEditor===null||this.b.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this.a=l.newActiveEditor),(0,L.$Pc)(o),(0,L.$Pc)(u),l.removedDocuments&&this.e.fire(o),l.addedDocuments&&this.d.fire(t),(l.removedEditors||l.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(l){return this.c.get(l)?.value}allDocuments(){return h.Iterable.map(this.c.values(),l=>l.value)}getEditor(l){return this.b.get(l)}activeEditor(l){if(!this.a)return;const o=this.b.get(this.a);return l?o:o?.value}allEditors(){return[...this.b.values()]}};e.$JP=n,e.$JP=n=Ge([We(0,k.$zP),We(1,$.$3j)],n),e.$KP=(0,N.$wi)("IExtHostDocumentsAndEditors")}),define(Se[360],De([1,0,19,4,6,157,16,8]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class m{constructor(A,C){this.i=C,this.a=new O.$de,this.b=new O.$de,this.c=new O.$de,this.d=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$$M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const C=this.i.allEditors();return A?C:C.map($=>$.value)}async showTextDocument(A,C,$){let v;typeof C=="number"?v={position:N.ViewColumn.from(C),preserveFocus:$}:typeof C=="object"?v={position:N.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?N.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:v={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(A.uri,v),h=w&&this.i.getEditor(w);if(h)return h.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,C){return new R.$GP(this.h,A,C).value}$acceptEditorPropertiesChanged(A,C){const $=this.i.getEditor(A);if(!$)throw new Error("unknown text editor");if(C.options&&$._acceptOptions(C.options),C.selections){const v=C.selections.selections.map(N.Selection.to);$._acceptSelections(v)}if(C.visibleRanges){const v=d.$Hb(C.visibleRanges.map(N.Range.to));$._acceptVisibleRanges(v)}if(C.options&&this.b.fire({textEditor:$.value,options:{...C.options,lineNumbers:N.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const v=p.TextEditorSelectionChangeKind.fromValue(C.selections.source),w=C.selections.selections.map(N.Selection.to);this.a.fire({textEditor:$.value,selections:w,kind:v})}if(C.visibleRanges){const v=d.$Hb(C.visibleRanges.map(N.Range.to));this.c.fire({textEditor:$.value,visibleRanges:v})}}$acceptEditorPositionData(A){for(const C in A){const $=this.i.getEditor(C);if(!$)throw new Error("Unknown text editor");const v=N.ViewColumn.to(A[C]);$.value.viewColumn!==v&&($._acceptViewColumn(v),this.d.fire({textEditor:$.value,viewColumn:v}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$zlc=m}),define(Se[361],De([1,0,2,5,6,3,8,16,25,18]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,O.$wi)("IExtHostTimeline");class A{constructor(v,w){this.b=new Map,this.c=new Map,this.a=v.getProxy(L.$$M.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(h,f)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&m.$Rm.equals(f,this.b.get(h.source)?.extension)){const a=h.uri===void 0?void 0:d.URI.revive(h.uri);return this.c.get(h.source)?.get(C(a))?.get(h.handle)}else return;return h}})}async $getTimeline(v,w,h,f){return this.b.get(v)?.provider.provideTimeline(d.URI.revive(w),h,f)}registerTimelineProvider(v,w,h,f){const a=new R.$Tc,n=this.d(w.id,f,a).bind(this);let i;w.onDidChange&&(i=w.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:w.id}),this));const l=this.c;return this.f({...w,scheme:v,onDidChange:void 0,async provideTimeline(o,t,u){t?.resetCache&&(a.clear(),l.get(w.id)?.clear());const r=await w.provideTimeline(o,t,u);if(r==null)return;const c=n(o,t);return{...r,source:w.id,items:r.items.map(c)}},dispose(){for(const o of l.values())o.get(w.id)?.clear();i?.dispose(),a.dispose()}},h)}d(v,w,h){return(f,a)=>{let n;if(a?.cacheResults){let i=this.c.get(v);i===void 0&&(i=new Map,this.c.set(v,i));const l=C(f);n=i.get(l),n===void 0&&(n=new Map,i.set(l,n))}return i=>{const{iconPath:l,...o}=i,t=`${v}|${i.id??i.timestamp}`;n?.set(t,i);let u,r,c;i.iconPath&&(l instanceof N.$0N?c={id:l.id,color:l.color}:d.URI.isUri(l)?(u=l,r=l):{light:u,dark:r}=l);let s;return N.$CN.isMarkdownString(o.tooltip)?s=p.MarkdownString.from(o.tooltip):(0,k.$9f)(o.tooltip)?s=o.tooltip:N.$CN.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=p.MarkdownString.from(o.detail)):(0,k.$9f)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=o.detail),{...o,id:o.id??void 0,handle:t,source:v,command:i.command?w.toInternal(i.command,h):void 0,icon:u,iconDark:r,themeIcon:c,tooltip:s,accessibilityInformation:i.accessibilityInformation}}}}f(v,w){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:w}),(0,R.$Sc)(()=>{for(const f of this.c.values())f.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$jnc=A;function C($){return $?.toString()}}),define(Se[362],De([1,0,233,23,2,4,3,294,7,8,18,19,16,81,22,189,26]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;function a(l,o){if((0,A.$9f)(l))return{label:l};if(l&&typeof l=="object"&&typeof l.label=="string"){let t;return Array.isArray(l.highlights)&&(t=l.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:l.label,highlights:t}}}class n extends N.$Uc{constructor(o,t,u){super(),this.f=o,this.g=t,this.h=u,this.a=new Map,this.b=new h.$v$;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>r(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(s=>r(s)?this.r(s):s):c})}registerTreeDataProvider(o,t,u){const r=this.createTreeView(o,{treeDataProvider:t},u);return{dispose:()=>r.dispose()}}createTreeView(o,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,y=!!t.dragAndDropController?.handleDrop,b=this.m(o,t,u),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:s,hasHandleDrop:y,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(o,S),E={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,f.$PG)(u,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,f.$PG)(u,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(D){(0,v.$Vk)(D)&&(0,f.$PG)(u,"treeViewMarkdownMessage"),b.message=D},get title(){return b.title},set title(D){b.title=D},get description(){return b.description},set description(D){b.description=D},get badge(){return b.badge},set badge(D){D!==void 0&&k.ViewBadge.isViewBadge(D)?b.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(b.badge=void 0)},reveal:(D,P)=>b.reveal(D,P),dispose:async()=>{await g,this.a.delete(o),b.dispose()}};return this.B(E),E}$getChildren(o,t){const u=this.a.get(o);return u?u.getChildren(t):Promise.reject(new p.$4F(o))}async $handleDrop(o,t,u,r,c,s,y,b){const S=this.a.get(o);if(!S)return Promise.reject(new p.$4F(o));const g=$.DataTransfer.toDataTransfer(u,async E=>(await this.f.$resolveDropFileData(o,t,E)).buffer);return y===o&&b&&await this.j(g,S,b,c,s),S.onDrop(g,r,c)}async j(o,t,u,r,c){const s=this.b.removeDragOperationTransfer(c);if(s)(await s)?.forEach((y,b)=>{y&&o.set(b,y)});else if(c&&t.handleDrag){const y=t.handleDrag(u,o,r);this.b.addDragOperationTransfer(c,y),await y}return o}async $handleDrag(o,t,u,r){const c=this.a.get(o);if(!c)return Promise.reject(new p.$4F(o));const s=await this.j(new k.$6N,c,t,r,u);if(!(!s||r.isCancellationRequested))return $.DataTransfer.from(s)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new p.$4F(o);return t.hasResolve}$resolve(o,t,u){const r=this.a.get(o);if(!r)throw new p.$4F(o);return r.resolveTreeItem(t,u)}$setExpanded(o,t,u){const r=this.a.get(o);if(!r)throw new p.$4F(o);r.setExpanded(t,u)}$setSelectionAndFocus(o,t,u){const r=this.a.get(o);if(!r)throw new p.$4F(o);r.setSelectionAndFocus(t,u)}$setVisible(o,t){const u=this.a.get(o);if(!u){if(!t)return;throw new p.$4F(o)}u.setVisible(t)}$changeCheckboxState(o,t){const u=this.a.get(o);if(!u)throw new p.$4F(o);u.setCheckboxState(t)}m(o,t,u){const r=this.B(new i(o,t,this.f,this.g.converter,this.h,u));return this.a.set(o,r),r}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$knc=n;class i extends N.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,A.$fg)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,u,r,c,s){if(super(),this.I=o,this.J=u,this.L=r,this.M=c,this.N=s,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$de),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$de),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$de),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$de),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$de),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$de),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$de),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$oe,s.contributes&&s.contributes.views)for(const g in s.contributes.views)for(const E of s.contributes.views[g])E.id===o&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>{Array.isArray(g)&&g.length===0||this.F.fire({message:!1,element:g})}));let y,b;const S=R.Event.debounce(this.F.event,(g,E)=>(g||(g={message:!1,elements:[]}),E.element!==!1&&(y||(y=new Promise(D=>b=D),this.G=this.G.then(()=>y)),Array.isArray(E.element)?g.elements.push(...E.element):g.elements.push(E.element)),E.message&&(g.message=!0),g),200,!0);this.B(S(({message:g,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const D=b;return y=null,this.$(E).then(()=>D())})),g&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let u=this.X(o);return u||(u=await this.Y(t)),u?u.map(r=>r.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const u=(0,A.$fg)(t.select)?!0:t.select,r=(0,A.$fg)(t.focus)?!1:t.focus,c=(0,A.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(s=>this.W(o,s[s.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:s.map(b=>b.item)},{select:u,focus:r,expand:c})),s=>this.M.error(s)):this.J.$reveal(this.I,void 0,{select:u,focus:r,expand:c})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=$.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const u=this.getExtensionElement(o);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(o,t){const u=!(0,C.$ub)(this.s,o);this.s=o;const r=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async u=>{const r=this.getExtensionElement(u.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:u.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(o,t,u){const r=[];for(const c of o){const s=this.getExtensionElement(c);s&&r.push(s)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,u){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,m.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(r,o,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(o);if(u){const r=this.m.get(u);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,u,t)??r.extensionItem;return this.hb(c),r.item.tooltip=this.eb(c.tooltip),r.item.command=this.fb(r.disposableStore,c.command),r.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(r=>(u.push(r),u))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$oh)(()=>this.f.getParent(o))}W(o,t){const u=this.m.get(o);return u?Promise.resolve(u):(0,m.$oh)(()=>this.f.getTreeItem(o)).then(r=>this.kb(o,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const s=this.m.get(c);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const u=this.getExtensionElement(o);t=u?this.m.get(u):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new w.$oe(this.Z.token);try{const u=o?this.m.get(o):void 0,r=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const c=(0,C.$Hb)(r||[]),s=await Promise.all((0,C.$Hb)(c).map(b=>this.f.getTreeItem(b)));if(t.token.isCancellationRequested)return;const y=s.map((b,S)=>b?this.db(c[S],b,u):null);return(0,C.$Hb)(y)}finally{t.dispose()}}$(o){if(o.some(u=>!u))return this.Z.dispose(!0),this.Z=new w.$oe,this.tb(),this.J.$refresh(this.I);{const u=this.ab(o);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(o){const t=new Set,u=o.map(c=>this.m.get(c));for(const c of u)if(c&&!t.has(c.item.handle)){let s=c;for(;s&&s.parent&&u.findIndex(y=>s&&s.parent&&y&&y.item.handle===s.parent.item.handle)===-1;){const y=this.j.get(s.parent.item.handle);s=y?this.m.get(y):void 0}s&&!s.parent&&t.add(c.item.handle)}const r=[];return t.forEach(c=>{const s=this.j.get(c);if(s){const y=this.m.get(s);y&&(!y.parent||!t.has(y.parent.item.handle))&&r.push(c)}}),r}bb(o){const t={};return Promise.all(o.map(u=>this.cb(u).then(r=>{r&&(t[u]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,m.$oh)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const c=this.ib(t,r,u.parent);return this.pb(t,c,u,u.parent),u.dispose(),c}return null})}return Promise.resolve(null)}db(o,t,u){const r=this.ib(o,t,u);if(t.id&&this.j.has(r.item.handle))throw new Error((0,d.localize)(0,null,t.id));return this.ob(o,r),this.qb(r,u),r}eb(o){return k.$CN.isMarkdownString(o)?$.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,u,r;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,u=o.checkboxState.tooltip,r=o.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:r}}hb(o){if(!k.$1N.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,u){this.hb(t);const r=this.B(new N.$Tc),c=this.kb(o,t,u),s=this.lb(t);return{item:{handle:c,parentHandle:u?u.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:s,iconDark:this.mb(t)||s,themeIcon:this.jb(t),collapsibleState:(0,A.$fg)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(o){return o.iconPath instanceof k.$0N?o.iconPath:void 0}kb(o,{id:t,label:u,resourceUri:r},c,s){if(t)return`${i.b}/${t}`;const y=a(u,this.N),b=c?c.item.handle:i.a;let S=y?y.label:r?(0,O.$7g)(r):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const g=this.m.has(o)?this.m.get(o).item.handle:void 0,E=this.X(c)||[];let D,P=0;do{if(D=`${b}/${P}:${S}`,s||!this.j.has(D)||g===D)break;P++}while(P<=E.length);return D}lb(o){if(o.iconPath&&!(o.iconPath instanceof k.$0N))return typeof o.iconPath=="string"||L.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof k.$0N)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return L.URI.isUri(o)?o:L.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,u,r){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(o,t);const c=this.X(r)||[],s=c.filter(y=>y.item.handle===u.item.handle)[0];s&&c.splice(c.indexOf(s),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const u of t.children){const r=this.j.get(u.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const u of t.children){const r=this.j.get(u.item.handle);r&&this.sb(r)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[363],De([1,0,4,3,2,30,16,92,6,8]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;class A extends O.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(w,h,f,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new d.$de),this.onDidDispose=this.#d.event,this.#h=this.B(new d.$de),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=h,this.#i=f,this.#n=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,L.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:N.ViewColumn.from(w),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends O.$Uc{static c(){return(0,R.$Sg)()}constructor(w,h,f){super(),this.j=h,this.m=f,this.g=new Map,this.h=new Map,this.f=w.getProxy(m.$$M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,h,f,a,n={}){const i=typeof a=="object"?a.viewColumn:a,l={viewColumn:N.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,p.$Olc)(w),t=C.c();this.f.$createWebviewPanel((0,p.$Qlc)(w),t,h,{title:f,panelOptions:$(n),webviewOptions:(0,p.$Rlc)(w,this.m,n),serializeBuffersForPostMessage:o},l);const u=this.j.createNewWebview(t,n,w);return this.createNewWebviewPanel(t,h,f,i,n,u,!0)}$onDidChangeWebviewPanelViewStates(w){const h=Object.keys(w);h.sort((f,a)=>{const n=w[f],i=w[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const f of h){const a=this.getWebviewPanel(f);if(!a)continue;const n=w[f];a._updateViewState({active:n.active,visible:n.visible,viewColumn:N.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,h,f){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:f,extension:w}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,p.$Olc)(w)}),new k.$aN(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(w,h,f,a){const n=this.h.get(h);if(!n)throw new Error(`No serializer found for '${h}'`);const{serializer:i,extension:l}=n,o=this.j.createNewWebview(w,f.webviewOptions,l),t=this.createNewWebviewPanel(w,h,f.title,a,f.panelOptions,o,f.active);await i.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(w,h,f,a,n,i,l){const o=new A(w,this.f,i,{viewType:h,title:f,viewColumn:a,panelOptions:n,active:l});return this.g.set(w,o),o}getWebviewPanel(w){return this.g.get(w)}}e.$Slc=C;function $(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Se[364],De([1,0,4,3,92,16,6,8]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;class m extends O.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(C,$,v,w,h,f){super(),this.#s=!1,this.#u=this.B(new d.$de),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new d.$de),this.onDidDispose=this.#l.event,this.#n=v,this.#a=w,this.#e=C,this.#t=$,this.#i=h,this.#r=f}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(C,$){this.d=$,this.b=new Map,this.c=new Map,this.a=C.getProxy(N.$$M.MainThreadWebviewViews)}registerWebviewViewProvider(C,$,v,w){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,L.$Qlc)(C),$,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$Olc)(C)}),new p.$aN(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(C,$,v,w,h){const f=this.b.get($);if(!f)throw new Error(`No view provider found for '${$}'`);const{provider:a,extension:n}=f,i=this.d.createNewWebview(C,{},n),l=new m(C,this.a,$,v,i,!0);this.c.set(C,l),await a.resolveWebviewView(l,{state:w},h)}async $onDidChangeWebviewViewVisibility(C,$){this.e(C)._setVisible($)}async $disposeWebviewView(C){const $=this.e(C);this.c.delete(C),$.dispose(),this.d.deleteWebview(C)}e(C){const $=this.c.get(C);if(!$)throw new Error("No webview found");return $}}e.$nnc=k}),define(Se[365],De([1,0,70,15,11,265,33,12]),function(he,e,d,O,L,R,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;let m=class{constructor(C,$){C.addFileSystemProvider(O.Schemas.file,new k($),{isCaseSensitive:p.$k})}};e.$5nc=m,e.$5nc=m=Ge([We(0,d.$Klc),We(1,L.$3j)],m);class k{constructor(C){this.b=C,this.a=new R.$_q(this.b)}async stat(C){const $=await this.a.stat(C);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===N.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,$,v){return this.a.writeFile(C,$,{...v,unlock:!1,atomic:!1})}delete(C,$){return this.a.delete(C,{...$,useTrash:!1,atomic:!1})}rename(C,$,v){return this.a.rename(C,$,v)}copy(C,$,v){return this.a.copy(C,$,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,$){throw new Error("Method not implemented.")}}}),define(Se[366],De([1,0,17,64,30,34,3,6,2,20]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;let A=class extends N.$Uc{constructor($,v){super();const w=$.getProxy(p.$$M.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async h=>{const f=m.URI.file((0,d.$jc)((0,O.tmpdir)(),(0,L.$Sg)()));return await w.$download(h,f),f})}};e.$3nc=A,e.$3nc=A=Ge([We(0,k.$zP),We(1,R.$VP)],A)}),define(Se[367],De([1,0,53,17,2,93,3,15,7,32]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;class A extends R.$Mlc{constructor(){super(...arguments),this.i=null}async g(t){const u=await super.g(t);if(u.scheme!==p.Schemas.file)return u;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const r=u.fsPath;let c=0;do{let s;c===0?s=r:s=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await C(s);const y=O.$jc(s,"vscode.lock"),b=await h(this.d,y,!1);if(b)return this.i=b,process.on("exit",()=>{b.dispose()}),L.URI.file(s);c++}while(c<10);return u}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$coc=A;async function C(o){try{await k.Promises.stat(o);return}catch{}try{await k.Promises.mkdir(o,{recursive:!0})}catch{}}const $=1e3,v=10*60*1e3;class w extends N.$Uc{constructor(t,u){super(),this.b=t,this.c=u,this.a=this.B(new m.$Hh),this.a.cancelAndSet(async()=>{const r=await f(t,u);(!r||r.pid!==process.pid)&&(t.info(`Lock '${u}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(u,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${u}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{d.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(u),{flag:"w"})}catch(u){this.b.error(u)}}}async function h(o,t,u){try{const c={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){o.error(c)}const r=await f(o,t);return!r||r.pid!==process.pid?u?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new w(o,t))}async function f(o,t){let u;try{u=await k.Promises.readFile(t)}catch(r){return o.error(r),null}try{return JSON.parse(String(u))}catch(r){return o.error(r),null}}async function a(o,t){let u;try{u=await k.Promises.stat(t)}catch(r){return o.error(r),0}return u.mtime.getTime()}function n(o){try{return process.kill(o,0),!0}catch{return!1}}async function i(o,t){const u=await f(o,t);if(!u)return o.info(`Lock '${t}': Could not read pid of lock holder.`),l(o,t);if(u.willReleaseAt){let b=u.willReleaseAt-Date.now();if(b<5e3){for(b>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${b} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);b>0;){if(await(0,m.$xh)(Math.min(100,b)),await a(o,t)===0)return l(o,t);b=u.willReleaseAt-Date.now()}return l(o,t)}}if(!n(u.pid))return o.info(`Lock '${t}': The pid ${u.pid} appears to be gone.`),l(o,t);const r=await a(o,t),c=Date.now()-r;if(c<=v)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,m.$xh)(2e3);const s=await a(o,t),y=Date.now()-s;return y<=v?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),l(o,t))}async function l(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return h(o,t,!0)}}),define(Se[368],De([1,0,30,20,43,34]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;let N=class extends L.$9lc{constructor(m,k){super(!0,m,k)}createTerminal(m,k,A){return this.createTerminalFromOptions({name:m,shellPath:k,shellArgs:A})}createTerminalFromOptions(m,k){const A=new L.$8lc(this.a,(0,d.$Sg)(),m,m.name);return this.f.push(A),A.create(m,this.R(m,k)),A.value}};e.$xnc=N,e.$xnc=N=Ge([We(0,R.$VP),We(1,O.$zP)],N)}),define(Se[369],De([1,0,4,36,38,5]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.OutputChannelUpdateMode=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=void 0,e.$gM="text/x-code-output",e.$hM="output",e.$iM="Log",e.$jM="text/x-code-log-output",e.$kM="log",e.$lM="workbench.panel.output",e.$mM=new L.$Nj("inOutput",!1),e.$nM=new L.$Nj("activeLogOutput",!1),e.$oM=new L.$Nj("activeLogOutput.levelSettable",!1),e.$pM=new L.$Nj("activeLogOutput.level",""),e.$qM=new L.$Nj("activeLogOutput.levelIsDefault",!1),e.$rM=new L.$Nj("outputView.scrollLock",!1),e.$sM=(0,R.$wi)("outputService");var N;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(N||(e.OutputChannelUpdateMode=N={})),e.$tM={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new d.$de,this.onDidRegisterChannel=this.b.event,this.c=new d.$de,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(A=>k.push(A)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}O.$co.add(e.$tM.OutputChannels,new p),e.$uM=new L.$Nj("activeOutputChannel","")}),define(Se[158],De([1,0,6,5,20,25,11,369,70,28,60,194,21,18,33,4,3]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;class a extends N.$9j{get disposed(){return this.n}constructor(o,t,u,r,c){super(),this.id=o,this.name=t,this.r=u,this.s=r,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=$.$Fe.fromString(t).byteLength,(0,N.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(o){this.append(o)}}let i=class{constructor(o,t,u,r,c,s){this.i=t,this.j=u,this.k=r,this.l=c,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(d.$$M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(o,t,u){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,c=(0,v.$9f)(t)?t:void 0;if((0,v.$9f)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const y=this.i.environment.extensionLogLevel?.find(([S])=>R.$Rm.equals(u.identifier,S))?.[1];y&&(s=(0,N.$hk)(y));const b=r?this.o(o,s,u):this.n(o,c,u);return b.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),r?this.r(o,s??this.m.getLevel(),b):this.q(o,b)}async n(o,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(o,c,t,u.identifier.value);return new a(y,o,s,this.a,u)}async o(o,t,u){const r=await this.p(u),c=o.replace(/[\\/:\*\?"<>\|]/g,""),s=this.k.extUri.joinPath(r,`${c}.log`),y=`${u.identifier.value}.${c}`,b=this.l.createLogger(s,{id:y,name:o,logLevel:t,extensionId:u.identifier.value});return new n(y,o,b,this.a,u)}p(o){let t=this.d.get(o.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(r){if((0,w.$gl)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}return u})())}return t}q(o,t){let u=!1;const r=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return o},append(c){r(),t.then(s=>s.append(c))},appendLine(c){r(),t.then(s=>s.appendLine(c))},clear(){r(),t.then(c=>c.clear())},replace(c){r(),t.then(s=>s.replace(c))},show(c,s){r(),t.then(y=>y.show(c,s))},hide(){r(),t.then(c=>c.hide())},dispose(){u=!0,t.then(c=>c.dispose())}}}r(o,t,u){const r=new f.$Tc,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},s=r.add(new h.$de);function y(b){t=b,s.fire(b)}return u.then(b=>{r.add(b),b.logLevel!==t&&y(b.logLevel),r.add(b.onDidChangeLogLevel(S=>y(S)))}),{...this.q(o,u),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(b,...S){c(),u.then(g=>g.trace(b,...S))},debug(b,...S){c(),u.then(g=>g.debug(b,...S))},info(b,...S){c(),u.then(g=>g.info(b,...S))},warn(b,...S){c(),u.then(g=>g.warn(b,...S))},error(b,...S){c(),u.then(g=>g.error(b,...S))},dispose(){r.dispose()}}}};e.$Ymc=i,e.$Ymc=i=Ge([We(0,L.$zP),We(1,k.$PP),We(2,m.$Klc),We(3,A.$nlc),We(4,N.$4j),We(5,N.$3j)],i),e.$Zmc=(0,O.$wi)("IExtHostOutputService")}),define(Se[159],De([1,0,5,7]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,d.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let p=0;p<this.maxSampleCount;p++){const m=await L.getRoundTripTime();if(m===void 0)return;R=Math.min(R,m/2),await(0,O.$xh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let N;return this.initial.length<this.maxInitialCount?this.initial.push(R):N=this.initial.reduce((p,m)=>p+m,0)/this.initial.length,this.lastMeasurement={initial:N,current:R,average:this.average.reduce((p,m)=>p+m,0)/this.average.length,high:typeof N>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>N*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[370],De([1,0,237,66,36,42,55,3,4,159,12,24,7]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=Object.freeze({id:"application",order:100,title:(0,d.localize)(0,null),type:"object"}),e.$LJ=Object.freeze({id:"workbench",order:7,title:(0,d.localize)(1,null),type:"object"}),e.$MJ=Object.freeze({id:"security",scope:1,title:(0,d.localize)(2,null),type:"object",order:7}),e.$NJ=Object.freeze({id:"problems",title:(0,d.localize)(3,null),type:"object",order:101}),e.$OJ={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new m.$de,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const w=new v;L.$co.add(e.$OJ.ConfigurationMigration,w);let h=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async l=>{for(const o of l.added)await this.f(o,w.migrations)})),this.c(w.migrations),this.B(w.onDidRegisterConfigurationMigration(l=>this.c(l)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(l=>this.g(l,n?.uri))])}async g(n,i){const l=this.a.inspect(n.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,u]of o){const r=l[t];if(!r)continue;const c=[];if(r.value!==void 0){const s=await this.h(n,t,r.value,i,void 0);for(const y of s??[])c.push([y,[]])}for(const{identifiers:s,value:y}of r.overrides??[])if(y!==void 0){const b=await this.h(n,t,y,i,s);for(const S of b??[])c.push([S,s])}c.length&&await Promise.allSettled(c.map(async([[s,y],b])=>this.a.updateValue(s,y.value,{resource:i,overrideIdentifiers:b},u)))}}async h(n,i,l,o,t){const u=c=>{const y=this.a.inspect(c,{resource:o})[i];if(y)return t?y.overrides?.find(({identifiers:b})=>(0,C.$7n)(b,t))?.value:y.value},r=await n.migrateFn(l,u);return Array.isArray(r)?r:[[n.key,r]]}};e.$PJ=h,e.$PJ=h=Ge([We(0,N.$3i),We(1,R.$Fi)],h);let f=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new $.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$co.as(O.$ho.Configuration).registerConfiguration({...e.$MJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,d.localize)(4,null)},default:[],markdownDescription:(0,d.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,d.localize)(6,null),scope:2}}})}};e.$QJ=f,e.$QJ=f=Ge([We(0,k.$gn)],f)}),define(Se[371],De([1,0,35,15,17,23,247,370,66,5,36]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$hhb=e.$ghb=void 0,e.$ihb=h,e.$jhb=f,e.$ghb=(0,k.$wi)("editorResolverService"),e.$hhb="workbench.editorAssociations";const C=A.$co.as(m.$ho.Configuration),$={...p.$LJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,N.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration($);var v;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(v||(e.RegisteredEditorPriority=v={}));var w;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function h(a){switch(a){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function f(a,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const o=typeof a=="string"&&a.indexOf(L.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$7g)(n);return d.$pk(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(Se[372],De([1,0,31,15,17,12,23,2,5,284,42,148,159]),function(he,e,d,O,L,R,N,p,m,k,A,C,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0,e.$MM=(0,m.$wi)("pathService");let w=v=class{constructor(f,a,n,i){this.d=f,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const l=await this.e.getEnvironment();return this.c=l?.userHome??f})()}hasValidBasename(f,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(f,i,a)):this.h(f,a,n)}h(f,a,n){return f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote?(0,d.$tg)(n??(0,N.$7g)(f),a===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,a){if(f.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,k.$JM)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const l=a.getWorkspace().configuration;return l?l.scheme:O.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?L.$fc:L.$gc)}async fileURI(f){let a="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const i=f.indexOf("/",2);i===-1?(a=f.substring(2),f="/"):(a=f.substring(2,i),f=f.substring(i)||"/")}return p.URI.from({scheme:O.Schemas.file,authority:a,path:f,query:"",fragment:""})}};e.$NM=w,e.$NM=w=v=Ge([We(1,$.$gn),We(2,C.$vM),We(3,A.$Fi)],w)}),define(Se[373],De([1,0,249,56,4,57,3,2,55,254,11,67,142,88,42,148,26,22,18,24,38]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.OnPortForward=e.$AM=e.$zM=e.TunnelSource=e.TunnelCloseReason=e.$xM=e.$wM=void 0,e.$yM=c,e.$BM=b,e.$CM=S,e.$DM=g,e.$EM=D;const o=10*1e3,t="remote.tunnels.toRestore",u="remote.tunnels.toRestoreExpiration",r=1e3*60*60*24*14;e.$wM="onTunnel",e.$xM=new l.$Nj("forwardedPortsViewEnabled",!1,d.localize(0,null));function c(F){const T=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var s;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(s||(e.TunnelCloseReason=s={}));var y;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$zM={source:y.User,description:d.localize(1,null)},e.$AM={source:y.Auto,description:d.localize(2,null)};function b(F,T,z){const M=F.get(g(T,z));if(M)return M;if((0,v.$ow)(T))for(const j of v.$nw){const U=g(j,z);if(F.has(U))return F.get(U)}else if((0,v.$qw)(T))for(const j of v.$pw){const U=g(j,z);if(F.has(U))return F.get(U)}}function S(F,T,z){const M=b(F,T,z);if(M)return M;const j=(0,v.$qw)(T)?"localhost":(0,v.$ow)(T)?"0.0.0.0":void 0;if(j)return b(F,j,z)}function g(F,T){return F+":"+T}var E;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(E||(e.OnPortForward=E={}));function D(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class P extends N.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new L.$de,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(z=>{(z.affectsConfiguration(P.c)||z.affectsConfiguration(P.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,z,M){let j=this.w(T,z,M,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const Z=this.j[j];Z.key===T?(U.onAutoForward=Z.onAutoForward??U.onAutoForward,U.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:U.elevateIfNeeded,U.label=Z.label??U.label,U.requireLocalPort=Z.requireLocalPort,U.protocol=Z.protocol):(U.onAutoForward=U.onAutoForward??Z.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:Z.elevateIfNeeded,U.label=U.label??Z.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??Z.protocol),j=this.w(T,z,M,this.j,j+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,n.$9f)(T.host)&&(0,n.$ag)(T.port)}w(T,z,M,j,U){if(U>=j.length)return-1;const Z=!(0,v.$ow)(z)&&!(0,v.$qw)(z),Q=j.slice(U).findIndex(G=>(0,n.$ag)(G.key)?Z?!1:G.key===T:this.t(G.key)?Z?!1:T>=G.key.start&&T<=G.key.end:this.u(G.key)?T===G.key.port&&z===G.key.host:M?G.key.test(M):!1);return Q>=0?Q+U:-1}y(){const T=this.r.getValue(P.c);if(!T||!(0,n.$$f)(T))return[];const z=[];for(const j in T){if(j===void 0)continue;const U=T[j];let Z;if(Number(j))Z=Number(j);else if((0,n.$9f)(j))if(P.g.test(j)){const ie=j.match(P.g);Z={start:Number(ie[1]),end:Number(ie[2])}}else if(P.h.test(j)){const ie=j.match(P.h);Z={host:ie[1],port:Number(ie[2])}}else{let ie;try{ie=RegExp(j)}catch{}ie&&(Z=ie)}Z&&z.push({key:Z,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const M=this.r.getValue(P.f);return M&&(this.m={elevateIfNeeded:M.elevateIfNeeded,label:M.label,onAutoForward:M.onAutoForward,requireLocalPort:M.requireLocalPort,protocol:M.protocol}),this.z(z)}z(T){function z(M,j){return(0,n.$ag)(M.key)?M.key:j.t(M.key)?M.key.start:j.u(M.key)?M.key.port:Number.MAX_VALUE}return T.sort((M,j)=>z(M,this)-z(j,this))}C(){return this.m}static providedActionToAction(T){switch(T){case v.ProvidedOnAutoForward.Notify:return E.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return E.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return E.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return E.OpenPreview;case v.ProvidedOnAutoForward.Silent:return E.Silent;case v.ProvidedOnAutoForward.Ignore:return E.Ignore;default:return}}async addAttributes(T,z,M){const U=this.r.inspect(P.c).userRemoteValue;let Z;!U||!(0,n.$$f)(U)?Z={}:Z=(0,i.$3n)(U),Z[`${T}`]||(Z[`${T}`]={});for(const ie in z)Z[`${T}`][ie]=z[ie];return this.r.updateValue(P.c,Z,M)}}e.$FM=P;let I=class extends N.$Uc{constructor(T,z,M,j,U,Z,ie,Q,G,x){super(),this.H=T,this.I=z,this.J=M,this.L=j,this.M=U,this.N=Z,this.O=ie,this.P=Q,this.Q=G,this.R=x,this.c=new Map,this.g=new L.$de,this.onForwardPort=this.g.event,this.h=new L.$de,this.onClosePort=this.h.event,this.j=new L.$de,this.onPortName=this.j.event,this.n=new L.$de,this.onCandidatesChanged=this.n.event,this.t=new L.$de,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$de,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new P(M),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const be=await this.getAttributes(ne.map(ae=>({port:ae.tunnelRemotePort,host:ae.tunnelRemoteHost})));for(const ae of ne)if(ae.localAddress){const Ce=g(ae.tunnelRemoteHost,ae.tunnelRemotePort),ee=S(this.m??new Map,ae.tunnelRemoteHost,ae.tunnelRemotePort);this.forwarded.set(Ce,{remotePort:ae.tunnelRemotePort,remoteHost:ae.tunnelRemoteHost,localAddress:ae.localAddress,protocol:be?.get(ae.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ae.localAddress,be?.get(ae.tunnelRemotePort)),localPort:ae.tunnelLocalPort,runningProcess:ee?.detail,hasRunningProcess:!!ee,pid:ee?.pid,privacy:ae.privacy,source:e.$zM}),this.f.set(Ce,ae)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const be=g(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!S(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!S(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!S(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const ae=S(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),Ce=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set(be,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:Ce?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,Ce),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,privacy:ne.privacy,source:e.$zM})}await this.cb(),this.f.set(be,ne),this.g.fire(this.forwarded.get(be))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,s.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$wM))?(this.R.createKey(e.$xM.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,z){const M=g(T.host,T.port);this.forwarded.has(M)&&(this.forwarded.delete(M),await this.cb(),this.h.fire(T))}X(T,z){if(T.startsWith("http"))return p.URI.parse(T);const M=z?.protocol??"http";return p.URI.parse(`${M}://${T}`)}async Y(T){const z=this.N.getWorkspace(),M=z.configuration?(0,R.$kj)(z.configuration.path):z.folders.length>0?(0,R.$kj)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${M}`}async Z(){return this.Y(t)}async $(){return this.Y(u)}async ab(){const T=this.I.get(t,1);if(T)return this.I.remove(t,1),await this.cb(),T;const z=await this.Z();if(z)return this.I.get(z,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const z=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${z.map(M=>M.remotePort).join(", ")}`);for(const M of z){const j=S(this.detected,M.remoteHost,M.remotePort);M.source.source!==y.Extension&&!j||M.source.source===y.Extension&&j?await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,elevateIfNeeded:!0,source:M.source}):M.source.source===y.Extension&&!j&&this.D.set(g(M.remoteHost,M.remotePort),M)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new N.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async z=>{z.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(z=>z.startsWith(u));for(const z of T){const M=this.I.getNumber(z,0);if(M&&M<Date.now()){this.s=Promise.resolve(void 0);const j=z.replace(u,t);this.I.remove(z,0),this.I.remove(j,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),z=T.map(Z=>({remoteHost:Z.remoteHost,remotePort:Z.remotePort,localPort:Z.localPort,name:Z.name,localAddress:Z.localAddress,localUri:Z.localUri,protocol:Z.protocol,source:Z.source}));let M;T.length>0&&(M=JSON.stringify(z));const j=await this.Z(),U=await this.$();!M&&j&&U?(this.I.remove(j,0),this.I.remove(U,0)):M!==this.y&&j&&U&&(this.I.store(j,M,0,0),this.I.store(U,Date.now()+r,0,0)),this.y=M}}async eb(T,z,M){if(!T.tunnelLocalPort||!M?.requireLocalPort||T.tunnelLocalPort===z)return;const j=new Date;if(this.db.getTime()+o>j.getTime())return;this.db=j;const U=d.localize(3,null,z,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(U)}async forward(T,z){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.fb(T,z)}async fb(T,z){await this.Q.activateByEvent(e.$wM);const M=S(this.forwarded,T.remote.host,T.remote.port);z=z??(z!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const j=T.local!==void 0?T.local:T.remote.port;let U;if(M)return this.hb(M,T,z);{const Z=this.L.remoteAuthority,ie=Z?{getAddress:async()=>(await this.M.resolveAuthority(Z)).authority}:void 0,Q=g(T.remote.host,T.remote.port);this.c.set(Q,!0),T=this.gb(Q,T);const G=await this.H.openTunnel(ie,T.remote.host,T.remote.port,void 0,j,T.elevateIfNeeded?T.elevateIfNeeded:z?.elevateIfNeeded,T.privacy,z?.protocol);if(typeof G=="string")U=G;else if(G&&G.localAddress){const x=S(this.m??new Map,T.remote.host,T.remote.port),ne=G.protocol?G.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:z?.protocol??v.TunnelProtocol.Http,be={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:z?.label??T.name,closeable:!0,localAddress:G.localAddress,protocol:ne,localUri:await this.X(G.localAddress,z),runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,source:T.source??e.$zM,privacy:G.privacy};return this.forwarded.set(Q,be),this.f.set(Q,G),this.c.delete(Q),await this.cb(),await this.eb(G,j,z),this.g.fire(be),G}this.c.delete(Q)}return U}gb(T,z){const M=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(M){const j=M.get(T);M.delete(T),j&&(z.name=j.name??z.name,z.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??z.local,z.privacy=z.privacy)}return z}async hb(T,z,M){const j=M?.label??z.name;let U;(function(ie){ie[ie.None=0]="None",ie[ie.Fire=1]="Fire",ie[ie.Reopen=2]="Reopen"})(U||(U={}));let Z=U.None;switch(j!==T.name&&(T.name=j,Z=U.Fire),(M?.protocol||T.protocol!==v.TunnelProtocol.Http)&&M?.protocol!==T.protocol&&(z.source=T.source,Z=U.Reopen),z.privacy&&T.privacy!==z.privacy&&(Z=U.Reopen),Z){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(T.remoteHost,T.remotePort,s.User),await this.fb(z,M)}return S(this.f,z.remote.host,z.remote.port)}async name(T,z,M){const j=S(this.forwarded,T,z),U=g(T,z);if(j){j.name=M,await this.cb(),this.j.fire({host:T,port:z});return}else this.detected.has(U)&&(this.detected.get(U).name=M,this.j.fire({host:T,port:z}))}async close(T,z,M){const j=g(T,z),U=this.forwarded.get(j);return M===s.AutoForwardEnd&&U&&U.source.source===y.Auto&&this.F.set(j,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(T,z),this.W({host:T,port:z},M)}address(T,z){const M=g(T,z);return(this.forwarded.get(M)||this.detected.get(M))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const z of T){const M=S(this.m??new Map,z.remoteAddress.host,z.remoteAddress.port),j=typeof z.localAddress=="string"?z.localAddress:g(z.localAddress.host,z.localAddress.port);this.detected.set(g(z.remoteAddress.host,z.remoteAddress.port),{remoteHost:z.remoteAddress.host,remotePort:z.remoteAddress.port,localAddress:j,protocol:v.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:M?.detail,hasRunningProcess:!!M,pid:M?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:d.localize(4,null)}}),this.H.setEnvironmentTunnel(z.remoteAddress.host,z.remoteAddress.port,j,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let z=T;this.r&&(z=await this.r(T));const M=this.ib(z);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(M.values()).map(j=>j.port).join(", ")}`),this.n.fire(M)}ib(T){const z=this.m??new Map,M=new Map;return this.m=M,T.forEach(j=>{const U=g(j.host,j.port);M.set(U,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),z.has(U)&&z.delete(U);const Z=S(this.forwarded,j.host,j.port);Z&&(Z.runningProcess=j.detail,Z.hasRunningProcess=!0,Z.pid=j.pid)}),z.forEach((j,U)=>{const Z=c(U);if(!Z)return;const ie=S(this.forwarded,Z.host,Z.port);ie&&(ie.runningProcess=void 0,ie.hasRunningProcess=!1,ie.pid=void 0);const Q=S(this.detected,Z.host,Z.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0)}),z}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),z=await this.getAttributes(T.map(M=>({port:M.remotePort,host:M.remoteHost})),!1);if(z)for(const M of T){const j=z.get(M.remotePort);(j?.protocol||M.protocol!==v.TunnelProtocol.Http)&&j?.protocol!==M.protocol&&await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,source:M.source},j),j&&j.label&&j.label!==M.name&&await this.name(M.remoteHost,M.remotePort,j.label)}}async getAttributes(T,z=!0){const M=new Map,j=new Map;T.forEach(G=>{const x=S(this.m??new Map,v.$nw[0],G.port)??G;if(x){M.set(G.port,x);const ne=D(x)?x.pid:void 0;j.has(ne)||j.set(ne,[]),j.get(ne)?.push(G.port)}});const U=new Map;if(T.forEach(G=>{const x=this.configPortsAttributes.getAttributes(G.port,G.host,M.get(G.port)?.detail);x&&U.set(G.port,x)}),this.G.length===0||!z)return U.size>0?U:void 0;const Z=await Promise.all(this.G.flatMap(G=>Array.from(j.entries()).map(x=>{const ne=x[1],be=M.get(ne[0]);return G.providePortAttributes(ne,be?.pid,be?.detail,a.CancellationToken.None)}))),ie=new Map;if(Z.forEach(G=>G.forEach(x=>{x&&ie.set(x.port,x)})),!U&&!ie)return;const Q=new Map;return T.forEach(G=>{const x=U.get(G.port),ne=ie.get(G.port);Q.set(G.port,{elevateIfNeeded:x?.elevateIfNeeded,label:x?.label,onAutoForward:x?.onAutoForward??P.providedActionToAction(ne?.autoForwardAction),requireLocalPort:x?.requireLocalPort,protocol:x?.protocol})}),Q}addAttributesProvider(T){this.G.push(T)}};e.$GM=I,Ge([(0,O.$2h)(1e3)],I.prototype,"cb",null),e.$GM=I=Ge([We(0,v.$iw),We(1,$.$1p),We(2,m.$3i),We(3,h.$vM),We(4,C.$Hl),We(5,w.$Fi),We(6,A.$3j),We(7,k.$Nw),We(8,f.$LG),We(9,l.$Oj)],I)}),define(Se[94],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$fL=e.$eL=void 0;class d{constructor(N,p){this.line=N,this.character=p}isBefore(N){return!1}isBeforeOrEqual(N){return!1}isAfter(N){return!1}isAfterOrEqual(N){return!1}isEqual(N){return!1}compareTo(N){return 0}translate(N,p){return new d(0,0)}with(N){return new d(0,0)}}e.$eL=d;class O{constructor(N,p,m,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(N,p),this.end=new d(m,k)}contains(N){return!1}isEqual(N){return!1}intersection(N){}union(N){return new O(0,0,0,0)}with(N){return new O(0,0,0,0)}}e.$fL=O;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(Se[37],De([1,0,19,35,24,31,14,5,17,13,94,7]),function(he,e,d,O,L,R,N,p,m,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.TextSearchCompleteMessageType=void 0,e.$mL=a,e.$nL=n,e.$oL=i,e.$tL=b,e.$uL=S,e.$wL=D,e.$xL=P,e.$yL=I,e.$zL=F,e.$AL=T,e.$BL=z,e.$DL=j,e.$FL=ie,e.$GL=Q,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$gL="workbench.view.search",e.$hL="workbench.panel.search",e.$iL="workbench.view.search",e.$jL="search-result",e.$kL="search.exclude";const $="\u27EA ",v=" characters skipped \u27EB",w=($.length+v.length+5)*2;e.$lL=(0,p.$wi)("searchService");var h;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(h||(e.SearchProviderType=h={}));var f;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(f||(e.QueryType=f={}));function a(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var l;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(l||(e.SearchCompletionExitCode=l={}));class o{constructor(ne){this.resource=ne,this.results=[]}}e.$pL=o;class t{constructor(ne,be,ae,Ce){this.ranges=be,this.webviewIndex=Ce;const ee=Array.isArray(be)?be:[be];if(ae&&ae.matchLines===1&&u(ee)){ne=(0,N.$2f)(ne,ae.matchLines);let B="",_=0,pe=0;const ue=Math.floor(ae.charsPerLine/5),ce=[];for(const oe of ee){const le=Math.max(oe.startColumn-ue,0),J=oe.startColumn+ae.charsPerLine;if(le>pe+ue+w){const se=$+(le-pe)+v;B+=se+ne.slice(le,J),_+=le-(pe+se.length)}else B+=ne.slice(pe,J);ce.push(new c(0,oe.startColumn-_,oe.endColumn-_)),pe=J}this.preview={text:B,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const B=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:ne,matches:(0,d.$1b)(be,_=>new r(_.startLineNumber-B,_.startColumn,_.endLineNumber-B,_.endColumn))}}}}e.$qL=t;function u(x){const ne=x[0].startLineNumber;for(const be of x)if(be.startLineNumber!==ne||be.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,be,ae,Ce){this.startLineNumber=ne,this.startColumn=be,this.endLineNumber=ae,this.endColumn=Ce}}e.$rL=r;class c extends r{constructor(ne,be,ae){super(ne,be,ne,ae)}}e.$sL=c;var s;(function(x){x.List="list",x.Tree="tree"})(s||(e.ViewMode=s={}));var y;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function b(x,ne=!0){const be=x&&x.files&&x.files.exclude,ae=ne&&x&&x.search&&x.search.exclude;if(!be&&!ae)return;if(!be||!ae)return be||ae;let Ce=Object.create(null);return Ce=L.$6n(Ce,L.$3n(be)),Ce=L.$6n(Ce,L.$3n(ae),!0),Ce}function S(x,ne){return x.excludePattern&&O.$pk(x.excludePattern,ne)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&O.$pk(x.includePattern,ne)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(be=>{const ae=be.folder.fsPath;if(R.$vg(ne,ae)){const Ce=m.$lc(ae,ne);return!be.includePattern||!!O.$pk(be.includePattern,Ce)}else return!1}):!1:!0}var g;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class E extends Error{constructor(ne,be){super(ne),this.code=be}}e.$vL=E;function D(x){const ne=x.message;if((0,k.$4)(x))return new E(ne,g.canceled);try{const be=JSON.parse(ne);return new E(be.message,be.code)}catch{return new E(ne,g.other)}}function P(x){const ne={message:x.message,code:x.code};return new Error(JSON.stringify(ne))}function I(x){return x.type==="error"?!0:x.type==="success"}function F(x){return x.type==="success"}function T(x){return!!x.path}function z(x,ne,be=!0){const ae=x.searchPath?x.searchPath:x.relativePath;return be?(0,N.$Yf)(ae,ne):O.$pk(ne,ae)}class M{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=M;function j(x,ne){const be={...x||{},...ne||{}};return Object.keys(be).filter(ae=>{const Ce=be[ae];return typeof Ce=="boolean"&&Ce})}class U{constructor(ne,be){this.c=null,this.a={...ne.excludePattern||{},...be.excludePattern||{}},this.b=O.$qk(this.a);let ae=ne.includePattern;be.includePattern&&(ae?ae={...ae,...be.includePattern}:ae=be.includePattern),ae&&(this.c=O.$qk(ae))}matchesExcludesSync(ne,be,ae){return!!(this.b&&this.b(ne,be,ae))}includedInQuerySync(ne,be,ae){return!(this.b&&this.b(ne,be,ae)||this.c&&!this.c(ne,be,ae))}includedInQuery(ne,be,ae){const Ce=this.b(ne,be,ae),ee=()=>this.c?!!this.c(ne,be,ae):!0;return(0,C.$ih)(Ce)?Ce.then(B=>B?!1:ee()):ee()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$EL=U;function Z(x){for(const ne in x)if(typeof x[ne]!="boolean")return!0;return!1}function ie(x){if(!x)return;let ne;return be=>(ne||(ne=(x()||Promise.resolve([])).then(ae=>ae?G(ae):{})),ne.then(ae=>!!ae[be]))}function Q(x){if(!x)return;let ne;return be=>{if(!ne){const ae=x();ne=ae?G(ae):{}}return!!ne[be]}}function G(x){const ne={};for(const be of x)ne[be]=!0;return ne}}),define(Se[44],De([1,0,19,7,22,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,16,8,68,37,6,58]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0;function y(F,T,z){return new A.$Yg(M=>E(M,z)).isEqual(F,T)}function b(F,T,z){return y(F.uri,T.uri,z)?0:(0,C.$qf)(F.uri.toString(),T.uri.toString())}function S(F,T,z){return F.index!==T.index?F.index<T.index?-1:1:y(F.uri,T.uri,z)?(0,C.$qf)(F.name,T.name):(0,C.$qf)(F.uri.toString(),T.uri.toString())}function g(F,T,z,M){const j=F.slice(0).sort((Z,ie)=>z(Z,ie,M)),U=T.slice(0).sort((Z,ie)=>z(Z,ie,M));return(0,d.$Eb)(j,U,(Z,ie)=>z(Z,ie,M))}function E(F,T){const z=T.getCapabilities(F.scheme);return!(z&&z&1024)}class D extends a.$Pi{static toExtHostWorkspace(T,z,M,j){if(!T)return{workspace:null,added:[],removed:[]};const{id:U,name:Z,folders:ie,configuration:Q,transient:G,isUntitled:x}=T,ne=[],be=z;z?ie.forEach((B,_)=>{const pe=$.URI.revive(B.uri),ue=D.o(M||z,pe,j);ue?(ue.name=B.name,ue.index=B.index,ne.push(ue)):ne.push({uri:pe,name:B.name,index:_})}):ne.push(...ie.map(({uri:B,name:_,index:pe})=>({uri:$.URI.revive(B),name:_,index:pe}))),ne.sort((B,_)=>B.index<_.index?-1:1);const ae=new D(U,Z,ne,!!G,Q?$.URI.revive(Q):null,!!x,B=>E(B,j)),{added:Ce,removed:ee}=g(be?be.workspaceFolders:[],ae.workspaceFolders,b,j);return{workspace:ae,added:Ce,removed:ee}}static o(T,z,M){for(let j=0;j<T.folders.length;j++){const U=T.workspaceFolders[j];if(y(U.uri,z,M))return U}}constructor(T,z,M,j,U,Z,ie){super(T,M.map(Q=>new a.$Qi(Q)),j,U,ie),this.t=z,this.u=Z,this.q=[],this.s=p.$Ci.forUris(ie),M.forEach(Q=>{this.q.push(Q),this.s.set(Q.uri,Q)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,z){return z&&this.s.get(T)&&(T=(0,A.$9g)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let P=class{constructor(T,z,M,j,U){this.c=new R.$de,this.onDidChangeWorkspace=this.c.event,this.g=new R.$de,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$fe,this.C=new Map,this.h=j,this.s=M,this.t=U,this.j=new k.$Dm,this.k=new O.$vh,this.o=T.getProxy(c.$$M.MainThreadWorkspace),this.q=T.getProxy(c.$$M.MainThreadMessageService);const Z=z.workspace;this.l=Z?new D(Z.id,Z.name,[],!!Z.transient,Z.configuration?$.URI.revive(Z.configuration):null,!!Z.isUntitled,ie=>E(ie,M)):void 0}$initializeWorkspace(T,z){this.v=z,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:m.Schemas.untitled,path:(0,A.$7g)((0,A.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,z,M,...j){const U=[];if(Array.isArray(j)&&j.forEach(x=>{$.URI.isUri(x.uri)&&!U.some(ne=>y(ne.uri,x.uri,this.s))&&U.push({uri:x.uri,name:x.name||(0,A.$6g)(x.uri)})}),this.n||[z,M].some(x=>typeof x!="number"||x<0)||M===0&&U.length===0)return!1;const Z=this.x?this.x.workspaceFolders:[];if(z+M>Z.length)return!1;const ie=Z.slice(0);ie.splice(z,M,...U.map(x=>({uri:x.uri,name:x.name||(0,A.$6g)(x.uri),index:void 0})));for(let x=0;x<ie.length;x++){const ne=ie[x];if(ie.some((be,ae)=>ae!==x&&y(ne.uri,be.uri,this.s)))return!1}ie.forEach((x,ne)=>x.index=ne);const{added:Q,removed:G}=g(Z,ie,S,this.s);if(Q.length===0&&G.length===0)return!1;if(this.o){const x=T.displayName||T.name;this.o.$updateWorkspaceFolders(x,z,M,U).then(void 0,ne=>{this.n=void 0;const be={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(f.Severity.Error,(0,v.localize)(0,null,x,ne.toString()),be,[])})}return this.y(ie),!0}getWorkspaceFolder(T,z){if(this.x)return this.x.getWorkspaceFolder(T,z)}async getWorkspaceFolder2(T,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,z)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,z){let M,j="";if(typeof T=="string"?(M=$.URI.file(T),j=T):typeof T<"u"&&(M=T,j=T.fsPath),!M)return j;const U=this.getWorkspaceFolder(M,!0);if(!U)return j;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Z=(0,A.$_g)(U.uri,M);return z&&U.name&&(Z=`${U.name}/${Z}`),Z}y(T){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:z,added:M,removed:j}=D.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:j}))}findFiles(T,z,M,j,U=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let Z="",ie=!0;return z===null?ie=!1:z!==void 0&&(typeof z=="string"?Z=z:Z=z.pattern),this.z(T,void 0,{exclude:Z,maxResults:M,useDefaultExcludes:ie,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},U)}findFiles2(T,z={},M,j=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,T,z,j)}async z(T,z,M,j=L.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const U=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,Z={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:U,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let ie;if(T){const{includePattern:Q,folder:G}=I(o.GlobPattern.from(T));ie=G,Z.includePattern=Q}else{const{includePattern:Q,folder:G}=I(o.GlobPattern.from(z));ie=G,Z.filePattern=Q}return this.o.$startFileSearch(ie??null,Z,j).then(Q=>Array.isArray(Q)?Q.map(G=>$.URI.revive(G)):[])}async findTextInFiles(T,z,M,j,U=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const Z=this.j.getNext(),ie=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:Q,folder:G}=I(o.GlobPattern.from(z.include)),x=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ne={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ie,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:Q,excludePattern:x},be=!1;if(this.u[Z]=ae=>{if(be)return;const Ce=$.URI.revive(ae.resource);ae.results.forEach(ee=>{const B=(0,s.$6h)(ee);(0,r.$mL)(B)?M({uri:Ce,preview:{text:B.preview.text,matches:(0,d.$1b)(B.preview.matches,_=>new t.$cN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,d.$1b)(B.ranges,_=>new t.$cN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):M({uri:Ce,text:B.text,lineNumber:B.lineNumber})})},U.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(T,G??null,ne,Z,U);return delete this.u[Z],ae||{}}catch(ae){throw delete this.u[Z],ae}}$handleTextSearchResult(T,z){this.u[z]?.(T)}async save(T){const z=await this.o.$save(T,{saveAs:!1});return $.URI.revive(z)}async saveAs(T){const z=await this.o.$save(T,{saveAs:!0});return $.URI.revive(z)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,z){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,z);const M=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,M),(0,N.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(T,z){this.h.info("Getting edit session identifier for workspaceFolder",T);const M=await this.resolveWorkspaceFolder($.URI.revive(T));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const j=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!j),!j)return;const U=await j.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(T,z,M,j){this.h.info("Getting edit session identifier for workspaceFolder",T);const U=await this.resolveWorkspaceFolder($.URI.revive(T));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const Z=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!Z),!Z)return;const ie=await Z.provideEditSessionIdentityMatch?.(z,M,j);if(this.h.info("Provider returned edit session identifier match result: ",ie),!!ie)return ie}getOnWillCreateEditSessionIdentityEvent(T){return(z,M,j)=>{const U=function(ie){z.call(M,ie)};return U.extension=T,this.B.event(U,void 0,j)}}async $onWillCreateEditSessionIdentity(T,z,M){const j=await this.resolveWorkspaceFolder($.URI.revive(T));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},z,async(U,Z)=>{const ie=Date.now();await Promise.resolve(U),Date.now()-ie>M&&this.h.warn("SLOW edit session create-participant",Z.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(T,z){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,z);const M=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerCanonicalUriProvider(j,M),(0,N.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(T,z,M){const j=this.C.get(T.scheme);if(!j)return;const U=await j.provideCanonicalUri?.($.URI.revive(T),z,M);if(U)return U}async $provideCanonicalUri(T,z,M){return this.provideCanonicalUri($.URI.revive(T),{targetScheme:z},M)}};e.$Elc=P,e.$Elc=P=Ge([We(0,l.$zP),We(1,i.$PP),We(2,n.$nlc),We(3,h.$3j),We(4,u.$Clc)],P),e.$Flc=(0,w.$wi)("IExtHostWorkspace");function I(F){let T,z;return F&&(typeof F=="string"?T=F:(T=F.pattern,z=$.URI.revive(F.baseUri))),{includePattern:T,folder:z}}}),define(Se[45],De([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=e.$Glc=void 0;function h(u,r){if(r){const c=r.split(".");let s=u;for(let y=0;s&&y<c.length;y++)s=s[c[y]];return s}}function f(u){return u instanceof w.URI}function a(u){return u&&u.uri instanceof w.URI&&u.languageId&&typeof u.languageId=="string"}function n(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&u.uri instanceof w.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function l(u){if(f(u))return{resource:u};if(a(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(n(u))return{overrideIdentifier:u.languageId};if(i(u))return{resource:u.uri};if(u===null)return{resource:null}}let o=class{constructor(r,c,s){this.a=r.getProxy(R.$$M.MainThreadConfiguration),this.c=c,this.b=s,this.d=new A.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,c))}};e.$Glc=o,e.$Glc=o=Ge([We(0,$.$zP),We(1,L.$Flc),We(2,v.$3j)],o);class t{constructor(r,c,s,y){this.a=new O.$de,this.b=r,this.f=y,this.c=c,this.e=p.$Ao.parse(s,y),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Ao.parse(r,this.f),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,s))}getConfiguration(r,c,s){const y=l(c)||{},b=this.g(r?h(this.e.getValue(void 0,y,this.c.workspace),r):this.e.getValue(void 0,y,this.c.workspace));r&&this.h(r,y,s?.identifier);function S(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case N.ConfigurationTarget.Global:return 2;case N.ConfigurationTarget.Workspace:return 5;case N.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(E){return typeof h(b,E)<"u"},get:(E,D)=>{this.h(r?`${r}.${E}`:E,y,s?.identifier);let P=h(b,E);if(typeof P>"u")P=D;else{let I;const F=(T,z)=>{if((0,k.$$f)(T)){let M;const j=()=>{I=I||(0,d.$3n)(b),M=M||h(I,z)};return new Proxy(T,{get:(U,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return j(),()=>M;if(I)return M=M||h(I,z),M[Z];const ie=U[Z];return typeof Z=="string"?F(ie,`${z}.${Z}`):ie},set:(U,Z,ie)=>(j(),M&&(M[Z]=ie),!0),deleteProperty:(U,Z)=>(j(),M&&delete M[Z],!0),defineProperty:(U,Z,ie)=>(j(),M&&Object.defineProperty(M,Z,ie),!0)})}return Array.isArray(T)?(0,d.$3n)(T):T};P=F(P,E)}return P},update:(E,D,P,I)=>{E=r?`${r}.${E}`:E;const F=S(P);return D!==void 0?this.b.$updateConfigurationOption(F,E,D,y,I):this.b.$removeConfigurationOption(F,E,y,I)},inspect:E=>{E=r?`${r}.${E}`:E;const D=this.e.inspect(E,y,this.c.workspace);if(D)return{key:E,defaultValue:(0,d.$3n)(D.policy?.value??D.default?.value),globalValue:(0,d.$3n)(D.user?.value??D.application?.value),workspaceValue:(0,d.$3n)(D.workspace?.value),workspaceFolderValue:(0,d.$3n)(D.workspaceFolder?.value),defaultLanguageValue:(0,d.$3n)(D.default?.override),globalLanguageValue:(0,d.$3n)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,d.$3n)(D.workspace?.override),workspaceFolderLanguageValue:(0,d.$3n)(D.workspaceFolder?.override),languageIds:(0,d.$3n)(D.overrideIdentifiers)}}};return typeof b=="object"&&(0,d.$6n)(g,b,!1),Object.freeze(g)}g(r){const c=s=>(0,k.$$f)(s)?new Proxy(s,{get:(y,b)=>c(y[b]),set:(y,b,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(y,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(y,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:y=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return c(r)}h(r,c,s){const y=m.$ro.test(r)?4:this.d.get(r),b=s?`[${s.value}] `:"";if(y===4){typeof c?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(y===3){c?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const s=new p.$Co(r,c,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(y,b)=>s.affectsConfiguration(y,l(b))})}k(r){return r.reduce((c,s)=>(c.set(s[0],s[1]),c),new Map)}}e.$Hlc=t,e.$Ilc=(0,C.$wi)("IExtHostConfiguration")}),define(Se[95],De([1,0,2,7,4,6,8,44,73,45,22,43,20,28,5,15,12,11,91,314,13]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=e.$$mc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(o||(o={}));var t;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(t||(t={}));var u;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(u||(u={}));var r;(function(F){function T(j){if(j){const U=j;return U&&!!U.process}else return!1}F.is=T;function z(j){if(j==null)return;const U={process:j.process,args:j.args};return j.options&&(U.options=u.from(j.options)),U}F.from=z;function M(j){if(j!=null)return new N.$WN(j.process,j.args,j.options)}F.to=M})(r||(r={}));var c;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(c||(c={}));var s;(function(F){function T(j){if(j){const U=j;return U&&(!!U.commandLine||!!U.command)}else return!1}F.is=T;function z(j){if(j==null)return;const U={};return j.commandLine!==void 0?U.commandLine=j.commandLine:(U.command=j.command,U.args=j.args),j.options&&(U.options=c.from(j.options)),U}F.from=z;function M(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new N.$XN(j.commandLine,j.options):new N.$XN(j.command,j.args?j.args:[],j.options)}F.to=M})(s||(s={}));var y;(function(F){function T(j){if(j){const U=j;return U&&U.customExecution==="customExecution"}else return!1}F.is=T;function z(j){return{customExecution:"customExecution"}}F.from=z;function M(j,U){return U.get(j)}F.to=M})(y||(e.CustomExecutionDTO=y={}));var b;(function(F){function T(z,M){let j;return z.scope!==void 0&&typeof z.scope!="number"?j=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===N.TaskScope.Workspace&&M&&M.workspaceFile?j=M.workspaceFile:j=i.$dI),{id:z._id,workspaceFolder:j}}F.from=T})(b||(e.TaskHandleDTO=b={}));var S;(function(F){function T(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=T})(S||(S={}));var g;(function(F){function T(j,U){if(j==null)return[];const Z=[];for(const ie of j){const Q=z(ie,U);Q&&Z.push(Q)}return Z}F.fromMany=T;function z(j,U){if(j==null)return;let Z;j.execution instanceof N.$WN?Z=r.from(j.execution):j.execution instanceof N.$XN?Z=s.from(j.execution):j.execution&&j.execution instanceof N.$YN&&(Z=y.from(j.execution));const ie=o.from(j.definition);let Q;return j.scope?typeof j.scope=="number"?Q=j.scope:Q=j.scope.uri:Q=N.TaskScope.Workspace,!ie||!Q?void 0:{_id:j._id,definition:ie,name:j.name,source:{extensionId:U.identifier.value,label:j.source,scope:Q},execution:Z,isBackground:j.isBackground,group:S.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}F.from=z;async function M(j,U,Z){if(j==null)return;let ie;r.is(j.execution)?ie=r.to(j.execution):s.is(j.execution)?ie=s.to(j.execution):y.is(j.execution)&&(ie=y.to(j._id,Z));const Q=o.to(j.definition);let G;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?G=j.source.scope:G=await U.resolveWorkspaceFolder(d.URI.revive(j.source.scope)):G=N.TaskScope.Workspace),!Q||!G)return;const x=new N.$ZN(Q,G,j.name,j.source.label,ie,j.problemMatchers);return j.isBackground!==void 0&&(x.isBackground=j.isBackground),j.group!==void 0&&(x.group=N.$VN.from(j.group._id),x.group&&j.group.isDefault&&(x.group=new N.$VN(x.group.id,x.group.label),j.group.isDefault===!0&&(x.group.isDefault=j.group.isDefault))),j.presentationOptions&&(x.presentationOptions=t.to(j.presentationOptions)),j._id&&(x._id=j._id),j.detail&&(x.detail=j.detail),x}F.to=M})(g||(e.TaskDTO=g={}));var E;(function(F){function T(M){return M}F.from=T;function z(M){if(M)return Object.assign(Object.create(null),M)}F.to=z})(E||(E={}));class D{#e;constructor(T,z,M){this._id=z,this.a=M,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let P=class{constructor(T,z,M,j,U,Z,ie,Q){this.q=new L.$de,this.r=new L.$de,this.s=new L.$de,this.u=new L.$de,this.a=T.getProxy(R.$$M.MainThreadTask),this.b=M,this.c=j,this.d=U,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,z,M){if(!M)return new N.$aN(()=>{});const j=this.x();return this.j.set(j,{type:z,provider:M,extension:T}),this.a.$registerTaskProvider(j,z),new N.$aN(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(T,z){this.a.$registerTaskSystem(T,z)}fetchTasks(T){return this.a.$fetchTasks(E.from(T)).then(async z=>{const M=[];for(const j of z){const U=await g.to(j,this.b,this.m);U&&M.push(U)}return M})}get taskExecutions(){const T=[];return this.k.forEach(z=>T.push(z)),T}terminateTask(T){if(!(T instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,z,M){const j=this.m.get(T.id);j&&(this.o.set(T.id,j),this.e.attachPtyToTerminal(z,await j.callback(M))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const z=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const z=await this.z(T.id);this.s.fire({execution:z,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const z=await this.z(T.id);this.u.fire({execution:z,exitCode:T.exitCode})}$provideTasks(T,z){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));const j=[],U=(0,O.$oh)(()=>M.provider.provideTasks(A.CancellationToken.None)).then(Z=>this.v(z,j,M,Z));return new Promise(Z=>{U.then(ie=>{Promise.all(j).then(()=>{Z(ie)})})})}async $resolveTask(T,z){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));if(z.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${M.type}].`);const j=await g.to(z,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const U=await M.provider.resolveTask(j,A.CancellationToken.None);if(!U)return;this.A(U,M);const Z=g.from(U,M.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(Z.execution)&&await this.y(Z,U,!0),await this.w(Z)}x(){return this.h++}async y(T,z,M){const j=await this.a.$createTaskId(T);!M&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,z.execution)),this.m.set(j,z.execution)}async z(T,z){if(typeof T=="string"){const U=this.l.get(T);if(!U)throw new l.$bb("Unexpected: The specified task is missing an execution");return U}const M=this.l.get(T.id);if(M)return M;let j;return z?j=Promise.resolve(new D(this,T.id,z)):j=g.to(T.task,this.b,this.m).then(U=>{if(!U)throw new l.$bb("Unexpected: Task does not exist.");return new D(this,T.id,U)}),this.l.set(T.id,j),j.then(U=>(this.k.set(T.id,U),U))}A(T,z){T._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const M=this.n.values();let j=M.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=M.next()}};e.$$mc=P,e.$$mc=P=Ge([We(0,$.$zP),We(1,v.$PP),We(2,p.$Flc),We(3,m.$KP),We(4,k.$Ilc),We(5,C.$7lc),We(6,a.$3j),We(7,n.$jlc)],P);let I=class extends P{constructor(T,z,M,j,U,Z,ie,Q){super(T,z,M,j,U,Z,ie,Q),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(T,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const M=g.from(z,T);if(M===void 0)throw new Error("Task is not valid");if(y.is(M.execution))await this.y(M,z,!1);else throw new l.$_;const j=await this.z(await this.a.$getTaskExecution(M),z);return this.a.$executeTask(M).catch(U=>{throw new Error(U)}),j}v(T,z,M,j){const U=[];if(j)for(const Z of j){if(this.A(Z,M),!Z.definition||!T[Z.definition.type]){const Q=Z.source?Z.source:"No task source";this.f.warn(`The task [${Q}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=g.from(Z,M.extension);ie&&y.is(ie.execution)?(U.push(ie),z.push(this.y(ie,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:M.extension}}async w(T){if(y.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,z,M){}};e.$_mc=I,e.$_mc=I=Ge([We(0,$.$zP),We(1,v.$PP),We(2,p.$Flc),We(3,m.$KP),We(4,k.$Ilc),We(5,C.$7lc),We(6,a.$3j),We(7,n.$jlc)],I),e.$anc=(0,w.$wi)("IExtHostTask")}),define(Se[374],De([1,0,37,29]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=L,e.$OL=R;function L(N){return"cellResults"in N}e.$NL="rawCell#";function R(N,p){let m=-1;const k=[];let A=[];return N.forEach($=>{$.range.startLineNumber!==m&&A.length>0&&(k.push([...A]),A=[]),A.push($),m=$.range.endLineNumber}),A.length>0&&k.push([...A]),k.map($=>{const v=[],w=$[0].range.startLineNumber,h=$[$.length-1].range.endLineNumber;for(let f=w;f<=h;f++)v.push(p.getLineContent(f));return new d.$qL(v.join(`
`)+`
`,$.map(f=>new O.$ut(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}}),define(Se[375],De([1,0,229,21,4,3,27,14,18,2,33,112,6,34,16,8,48,345,154,24,15,304,374,371]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,y,b,S,g,E){this.q=b,this.r=S,this.s=g,this.t=E,this.f=new Map,this.g=new N.$Ac,this.h=new Map,this.j=new L.$de,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$de,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$de,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$de,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$hlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=s.getProxy($.$$M.MainThreadNotebook),this.c=s.getProxy($.$$M.MainThreadNotebookDocuments),this.d=s.getProxy($.$$M.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const P=D.notebookEditor?.notebookUri,I=D.cell.handle,T=this.g.get(P)?.getCell(I);if(T)return T.apiCell}if(D&&D.$mid===14){const P=D.uri,I=this.g.get(P);if(I)return I.apiNotebook}return D}}),r.B(y)}getEditorById(s){const y=this.h.get(s);if(!y)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(s){for(const[y,b]of this.h)if(b.apiEditor===s)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,y){const b=this.g.get(s);if(!b&&!y)throw new Error(`NO notebook document for '${s}'`);return b}static u(s,y){if(!y)return;const b=y.filenamePattern.map(S=>w.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(y.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:y.displayName,filenamePattern:b,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,y,b){const S=r.a++,g=typeof b.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(S,b),this.b.$registerNotebookCellStatusBarItemProvider(S,g,y);let E;return g!==void 0&&(E=b.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(g))),new h.$aN(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,g),E?.dispose()})}async createNotebookDocument(s){const y=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&w.NotebookData.from(s.content)});return k.URI.revive(y)}async openNotebookDocument(s){const y=this.g.get(s);if(y)return y.apiNotebook;const b=await this.c.$tryOpenNotebook(s),S=this.g.get(k.URI.revive(b));return(0,m.$hg)(S?.apiNotebook)}async showNotebookDocument(s,y){k.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let b;typeof y=="object"?b={position:w.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(w.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,b),g=S&&this.h.get(S)?.apiEditor;if(g)return g;throw S?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,y,b,S){const g=this.f.get(s),E=k.URI.revive(y),D=this.g.get(E);if(!D||!g)return;const P=D.getCellFromIndex(b);if(!P)return;const I=await g.provideCellStatusBarItems(P.apiCell,S);if(!I)return;const F=new R.$Tc,T=this.p.add([F]),M=(Array.isArray(I)?I:[I]).map(j=>w.NotebookStatusBarItem.from(j,this.i,F));return{cacheId:T,items:M}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,y,b,S,g){if((0,p.$7e)(y))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:y,serializer:b,options:S}),this.b.$registerNotebookSerializer(E,{id:s.identifier,location:s.extensionLocation},y,w.NotebookDocumentContentOptions.from(S),r.u(s,g)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(s,y,b){const S=this.x.get(s);if(!S)throw new Error("NO serializer found");const g=await S.serializer.deserializeNotebook(y.buffer,b);return new f.$Bw(w.NotebookData.from(g))}async $notebookToData(s,y,b){const S=this.x.get(s);if(!S)throw new Error("NO serializer found");const g=await S.serializer.serializeNotebook(w.NotebookData.to(y.value),b);return O.$Fe.wrap(g)}async $saveNotebook(s,y,b,S,g){const E=k.URI.revive(y),D=this.x.get(s);if(!D)throw new Error("NO serializer found");const P=this.g.get(E);if(!P)throw new Error("Document NOT found");if(P.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new A.$ll((0,d.localize)(0,null,this.z(E)),6);await this.y(E,S);const I={metadata:(0,i.$$n)(P.apiNotebook.metadata,j=>!(D.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of P.apiNotebook.getCells()){const U=new h.$DO(j.kind,j.document.getText(),j.document.languageId,j.mime,D.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,i.$$n)(j.metadata,Z=>!(D.options?.transientCellMetadata??{})[Z]),I.cells.push(U)}const F=await D.serializer.serializeNotebook(I,g);await this.s.value.writeFile(E,F);const T=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:T.basename(E),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$wl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(s,y,b,S,g){const E=this.x.get(s)?.serializer;if(!E)return{limitHit:!1,results:[]};const D=new N.$Bc;await(async(z,M,j)=>{await Promise.all(z.map(async U=>await Promise.all(U.filenamePatterns.map(Z=>{const ie={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:Z};return this.t.doInternalFileSearchWithCustomCallback(ie,M,Q=>{Q.forEach(G=>{D.has(G)||S.some(ne=>U.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(be=>(0,u.$jhb)(be,G)))||D.add(G)})}).catch(Q=>{if(Q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Q})}))))})(b,g,y);const I=new N.$Ac;let F=!1;const T=Array.from(D).map(async z=>{const M=[];try{if(g.isCancellationRequested)return;if(y.maxResults&&[...I.values()].reduce((ie,Q)=>ie+Q.cellResults.length,0)>y.maxResults){F=!0;return}const j=[],U=this.g.get(z);if(U)U.apiNotebook.getCells().forEach(Q=>j.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(G=>G.items.map(x=>x.data.toString()))}));else{const ie=await this.s.value.readFile(z),Q=O.$Fe.fromString(ie.toString()),G=await E.deserializeNotebook(Q.buffer,g);if(g.isCancellationRequested)return;w.NotebookData.from(G).cells.forEach(ne=>j.push({input:ne.source,outputs:ne.outputs.flatMap(be=>be.items.map(ae=>ae.valueBytes.toString()))}))}if(g.isCancellationRequested)return;j.forEach((ie,Q)=>{const G=y.contentPattern.pattern,x=new o.$fXb(ie.input,void 0,ie.outputs),ne=x.findInInputs(G),be=x.findInOutputs(G),ae=be.flatMap(Ce=>(0,t.$OL)(Ce.matches,Ce.textBuffer)).map((Ce,ee)=>(Ce.webviewIndex=ee,Ce));if(ne.length>0||be.length>0){const Ce={index:Q,contentResults:(0,t.$OL)(ne,x.inputTextBuffer),webviewResults:ae};M.push(Ce)}});const Z={resource:z,cellResults:M};I.set(z,Z);return}catch{return}});return await Promise.all(T),{limitHit:F,results:[...I.values()]}}async y(s,y){const b=await this.s.value.stat(s);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==A.$vl&&typeof b.mtime=="number"&&typeof b.size=="number"&&y.mtime<b.mtime&&y.etag!==A.$wl({mtime:y.mtime,size:b.size}))throw new A.$ll((0,d.localize)(1,null),3,y)}z(s){return s.scheme===l.Schemas.file?s.fsPath:s.toString()}A(s,y,b){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const S=new n.$Emc(y,this.d,s,b.visibleRanges.map(w.NotebookRange.to),b.selections.map(w.NotebookRange.to),typeof b.viewColumn=="number"?w.ViewColumn.to(b.viewColumn):void 0);this.h.set(y,S)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const b of s.value.removedDocuments){const S=k.URI.revive(b),g=this.g.get(S);g&&(g.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(g.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===S.toString()&&this.h.delete(E.id)}if(s.value.addedDocuments){const b=[];for(const S of s.value.addedDocuments){const g=k.URI.revive(S.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const E=new a.$Dmc(this.c,this.q,this.r,g,S);b.push(...S.cells.map(D=>a.$Cmc.asModelAddData(D))),this.g.get(g)?.dispose(),this.g.set(g,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(E.apiNotebook)}}if(s.value.addedEditors)for(const b of s.value.addedEditors){if(this.h.has(b.id))return;const S=k.URI.revive(b.documentUri),g=this.g.get(S);g&&this.A(g,b.id,b)}const y=[];if(s.value.removedEditors)for(const b of s.value.removedEditors){const S=this.h.get(b);S&&(this.h.delete(b),this.k?.id===S.id&&(this.k=void 0),y.push(S))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const b=new Set;this.l.forEach(S=>b.add(S.id));for(const S of this.h.values()){const g=b.has(S.id);S._acceptVisibility(g)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(s){const y=v.$XP.String.with("notebookType","A notebook type"),b=new v.$ZP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new v.$XP("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>O.$Fe.wrap(g))],new v.$YP("Notebook Data",g=>w.NotebookData.to(g.value))),S=new v.$ZP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new v.$XP("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new f.$Bw(w.NotebookData.from(g)))],new v.$YP("Bytes",g=>g.buffer));s.registerApiCommand(b),s.registerApiCommand(S)}}e.$Nmc=r}),define(Se[376],De([1,0,17,22,47,35,23,40,37]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class k{constructor($,v,w){this.k=$,this.l=v,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$qk($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$qk($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const v=this.k.folderQueries||[];return new Promise((w,h)=>{const f=a=>{this.f++,$(a)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=d.$nc(n);this.j&&this.j(n,i)||this.v(f,{base:a,basename:i})}),Promise.all(v.map(a=>this.p(a,f))).then(a=>{w({limitHit:this.e,stats:a[0]||void 0})},a=>{h(new Error((0,L.$hj)(a)))})})}async p($,v){const w=new O.$oe,h=this.q($),f=this.r(),a=new m.$EL(this.k,$),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=p.$_d.create();const l=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,w.token),o=i.elapsed(),t=p.$_d.create();return this.g&&!this.e||(l&&l.forEach(u=>{const r=d.$gc.relative($.folder.path,u.path);if(n){const c=d.$nc(u.path);this.v(v,{base:$.folder,relativePath:r,basename:c});return}this.s(f,$.folder,r,v)}),this.g&&!this.e)?null:(this.u(f,a,v),{providerTime:o,postProcessTime:t.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q($){const v=(0,m.$DL)(this.k.includePattern,$.includePattern),w=(0,m.$DL)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:w,includes:v,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},v,w,h){if(w===this.a){const a=d.$nc(this.a);this.v(h,{base:v,relativePath:this.a,basename:a})}function f(a){const n=d.$nc(a),i=d.$mc(a);let l=$[i];l||(l=$[i]=[],f(i)),l.push({base:v,relativePath:a,basename:n})}f(w)}u({rootEntries:$,pathToEntries:v},w,h){const f=this,a=this.a;function n(i){const l=(0,m.$GL)(()=>i.map(o=>o.basename));for(let o=0,t=i.length;o<t;o++){const u=i[o],{relativePath:r,basename:c}=u;if(w.matchesExcludesSync(r,c,a!==c?l:void 0))continue;const s=v[r];if(s)n(s);else{if(r===a)continue;f.v(h,u)}if(f.e)break}}n($)}v($,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,v,w,h){const f=this.c($.cacheKey),a=new k($,v,f&&f.token);let n=0;const i=l=>{n+=l.length,w(l.map(o=>this.d(o)))};return this.e(a,A.a,i,h).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:l.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new O.$oe),this.b.get($)}d($){return $.relativePath?{resource:N.$0g($.base,$.relativePath)}:{resource:$.base}}e($,v,w,h){const f=h.onCancellationRequested(()=>{$.cancel()}),a=i=>{i&&(n.push(i),v>0&&n.length>=v&&(w(n),n=[]))};let n=[];return $.search(a).then(i=>(n.length&&w(n),f.dispose(),i),i=>(n.length&&w(n),f.dispose(),Promise.reject(i)))}}e.$Fmc=A}),define(Se[377],De([1,0,19,74,35,103,27,15,17,23,14,18,2,100,250,55,11,42,147,372,37]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$PM=S;let o=class{constructor(E,D,P,I,F){this.a=E,this.b=D,this.c=P,this.d=I,this.e=F}text(E,D,P={}){E=this.f(E,P);const I=this.a.getValue(),F=D&&D.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(D?.map(a.$Ri),P),type:2,contentPattern:E,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(E,D){const P=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const I={...E,wordSeparators:P.editor.wordSeparators};return this.j(E,D)&&(I.isCaseSensitive=!0),this.k(E)&&(I.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),I}file(E,D={}){return{...this.h(E,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey,shouldGlobMatchFilePattern:D.shouldGlobSearch}}g(E,D){return E?(E=Array.isArray(E)?E.map(s):s(E),D?this.parseSearchPaths(E):{pattern:u(...Array.isArray(E)?E:[E])}):{}}h(E=[],D={}){const P=this.g(D.includePattern,D.expandPatterns),I=this.g(D.excludePattern,D.expandPatterns),F=E.length>1,T=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(j=>this.q(j,D,I)):E.map(j=>this.r(j,D,I,F))).filter(j=>!!j),z={_reason:D._reason,folderQueries:T,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const j=d.$Hb(this.c.groups.flatMap(ie=>ie.editors.map(Q=>Q.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const U=j.filter(ie=>(0,l.$uL)(z,ie.fsPath)),Z=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...z,...Z}}const M=D.extraFileResources&&D.extraFileResources.filter(j=>(0,l.$uL)(z,j.fsPath));return z.extraFileResources=M&&M.length?M:void 0,z}i(E){const D=[],P=new N.$Ac,I={};let F=!1;return E.forEach(T=>{if(T.scheme===p.Schemas.walkThrough)return;if((0,k.$bh)(T)){const M=this.b.getWorkspaceFolder(T)?.uri??T.with({path:m.$mc(T.fsPath)});let j=P.get(M);j||(F=!0,j={folder:M,includePattern:{}},D.push(j),P.set(M,j));const U=m.$lc(M.fsPath,T.fsPath);(0,C.$hg)(j.includePattern)[U.replace(/\\/g,"/")]=!0}else T.fsPath&&(F=!0,I[T.fsPath]=!0)}),{folderQueries:D,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(E,D){if(D.isSmartCase){if(E.isRegExp){if(A.$Zf(E.pattern,!0))return!0}else if(A.$Zf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,v.$QC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const D=Z=>m.$ic(Z)||/^\.\.?([\/\\]|$)/.test(Z),I=(Array.isArray(E)?E:r(E)).map(Z=>{const ie=this.e.resolvedUserHome;return ie?(0,R.$Gw)(Z,ie.scheme===p.Schemas.file?ie.fsPath:ie.path):Z}),F=O.$K(I,Z=>D(Z)?"searchPaths":"exprSegments"),T=(F.exprSegments||[]).map(Z=>A.$ff(Z,"/")).map(Z=>A.$ff(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),c(Z))),z={},M=this.m(F.searchPaths||[]);M&&M.length&&(z.searchPaths=M);const j=T.flat(),U=u(...j);return U&&(z.pattern=U),z}l(E,D){return D.disregardExcludeSettings?void 0:(0,l.$tL)(E,!D.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const D=E.flatMap(I=>{let{pathPortion:F,globPortion:T}=t(I);return T&&(T=y(T)),this.n(F).flatMap(M=>this.o(M,T))}),P=new Map;return D.forEach(I=>{const F=I.searchPath.toString(),T=P.get(F);T?I.pattern&&(T.pattern=T.pattern||{},T.pattern[I.pattern]=!0):P.set(F,{searchPath:I.searchPath,pattern:I.pattern?u(I.pattern):void 0})}),Array.from(P.values())}n(E){if(m.$ic(E)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==p.Schemas.file?[{searchPath:D[0].uri.with({path:E})}]:[{searchPath:$.URI.file(m.$hc(E))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(E=s(E),E.startsWith("../")||E===".."){const I=m.$gc.resolve(D.path,E);return[{searchPath:D.with({path:I})}]}const P=y(E);return[{searchPath:D,pattern:P}]}else{if(E==="./"||E===".\\")return[];{const D=E.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(F=>{const T=D.match(new RegExp(`^${A.$_e(F.name)}(?:/(.*)|$)`));return T?{match:T,folder:F}:null}).filter(C.$eg);if(I.length)return I.map(F=>{const T=F.match[1];return{searchPath:F.folder.uri,pattern:T&&y(T)}});{const F=E.match(/\.[\/\\](.+)[\/\\]?/),T=F?F[1]:E,z=w.localize(0,null,T);throw new Error(z)}}}}o(E,D){const P=E.pattern&&D?`${E.pattern}/${D}`:E.pattern||D,I=[{searchPath:E.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:E.searchPath,pattern:P+"/**"}),I}q(E,D,P){const I=this.r((0,a.$Ri)(E.searchPath),D,P,!1);return I?{...I,includePattern:E.pattern}:null}r(E,D,P,I){let F;const T=$.URI.isUri(E)?E:E.uri;if(P.searchPaths){const Z=P.searchPaths.filter(ie=>(0,k.$3g)(ie.searchPath,T))[0];if(Z&&!Z.pattern)return null;Z&&(F=Z.pattern)}const z=this.a.getValue({resource:T}),j={...this.l(z,D)||{},...F||{}},U=$.URI.isUri(E)?(0,k.$7g)(E):E.name;return{folder:T,folderName:I?U:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!z.search.followSymlinks}}};e.$OM=o,e.$OM=o=Ge([We(0,h.$3i),We(1,a.$Fi),We(2,n.$YD),We(3,f.$3j),We(4,i.$MM)],o);function t(g){const E=g.match(/[\*\{\}\(\)\[\]\?]/);if(E){const D=E.index,P=g.substr(0,D).match(/[/|\\][^/\\]*$/);if(P){let I=g.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function u(...g){return g.length?g.reduce((E,D)=>(E[D]=!0,E),Object.create(null)):void 0}function r(g){return L.$ok(g,",").map(E=>E.trim()).filter(E=>!!E.length)}function c(g){return[`**/${g}/**`,`**/${g}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function s(g){return g.replace(/\\/g,"/")}function y(g){return s(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(g){return g.replace(/([?*[\]])/g,"[$1]")}function S(g,E){g=d.$Mb(g,I=>I.toString());const D=[],P=E.getWorkspace();return g&&g.forEach(I=>{let F;if(E.getWorkbenchState()===2)F=(0,k.$_g)(P.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const T=E.getWorkspaceFolder(I);if(T){const z=T.name;if(P.folders.filter(j=>j.name===z).length===1){const j=(0,k.$_g)(T.uri,I);j===""?F=`./${T.name}`:F=`./${T.name}/${j}`}else F=I.fsPath}}F&&D.push(b(F))}),D}}),define(Se[378],De([1,0,23,2,22,13,5,377,37,42,7]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mwb=$,e.$nwb=h;const C=7e3;function $(f,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],l=[];for(const s of n)if(/^workspaceContains:/.test(s)){const y=s.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||f.forceUsingSearch?l.push(y):i.push(y)}if(i.length===0&&l.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,A.$ph)(),u=s=>t({activationEvent:s}),r=Promise.all(i.map(s=>v(f,s,u))).then(()=>{}),c=w(f,a.identifier,l,u);return Promise.all([r,c]).then(()=>{t(void 0)}),o}async function v(f,a,n){for(const i of f.folders)if(await f.exists(d.$0g(O.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function w(f,a,n,i){if(n.length===0)return Promise.resolve(void 0);const l=new L.$oe,o=f.checkExists(f.folders,n,l.token),t=setTimeout(async()=>{l.cancel(),f.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},C);let u=!1;try{u=await o}catch(r){R.$4(r)||R.$1(r)}l.dispose(),clearTimeout(t),u&&i(`workspaceContains:${n.join(",")}`)}function h(f,a,n,i){const l=f.get(N.$vi),o=f.get(m.$lL),u=l.createInstance(p.$OM).file(a.map(r=>(0,k.$Ri)(O.URI.revive(r))),{_reason:"checkExists",includePattern:n,exists:!0});return o.fileSearch(u,i).then(r=>!!r.limitHit,r=>R.$4(r)?!1:Promise.reject(r))}}),define(Se[49],De([1,0,225,17,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,21,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u,r,c,s,y,b,S,g,E,D,P,I,F,T,z,M,j,U){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=e.$jmc=e.$imc=e.$hmc=void 0,e.$hmc=(0,r.$wi)("IHostUtils");let ie=Z=class extends p.$Uc{constructor(B,_,pe,ue,ce,oe,le,J,se,$e,ve,Re,ge){super(),this.Y=Re,this.Z=ge,this.a=this.B(new D.$de),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=pe,this.f=le,this.j=ue,this.m=ce,this.s=oe,this.t=se,this.u=$e,this.w=ve,this.y=this.g.getProxy(C.$$M.MainThreadWorkspace),this.z=this.g.getProxy(C.$$M.MainThreadTelemetry),this.C=this.g.getProxy(C.$$M.MainThreadExtensionService),this.D=new N.$vh,this.F=new N.$vh,this.G=new N.$vh,this.H=new N.$vh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new a.$U_b(this.I,this.f.extensions.allExtensions);const Ie=new i.$Sm(this.f.extensions.myExtensions);this.J=new a.$U_b(this.I,be(this.L,Ie)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new w.$3lc(this.g,this.s),this.N=new I.$amc(this.g),this.O=J,this.h=B.createChild(new b.$ui([w.$4lc,this.M],[I.$bmc,this.N])),this.P=this.B(new v.$2lc(this.J,this.L,{onExtensionActivationError:(Ae,ze,V)=>{this.C.$onExtensionActivationError(Ae,n.$3(ze),V)},actualActivateExtension:async(Ae,ze)=>{if(a.$U_b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,ze),new v.$1lc;const V=this.J.getExtensionDescription(Ae);return this.fb(V,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(B){n.$1(B)}}async $(){this.O.onWillDeactivateAll();let B=[];try{B=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(B)}terminate(B,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${B}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const pe=this.$();Promise.race([(0,N.$xh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(B){return this.G.isOpen()?this.P.isActivated(B):!1}async getExtension(B){const _=await this.C.$getExtension(B);return _&&{..._,identifier:new i.$Rm(_.identifier.value),extensionLocation:k.URI.revive(_.extensionLocation)}}ab(B,_){return this.P.activateByEvent(B,_)}bb(B,_){return this.P.activateById(B,_)}activateByIdWithErrors(B,_){return this.bb(B,_).then(()=>{const pe=this.P.getActivatedExtension(B);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(B=>this.J)}getExtensionExports(B){if(this.G.isOpen())return this.P.getActivatedExtension(B).exports;try{return this.P.getActivatedExtension(B).exports}catch{return null}}async cb(B){if(B.scheme===T.Schemas.file&&this.c.fsRealpath){const _=B.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const pe=await this.R.get(_);return k.URI.file(pe)}return B}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(B=>new ae(B))),this.Q}async db(B){const _=m.$Ci.forUris(pe=>R.$1g.ignorePathCasing(pe));return await Promise.all(B.map(async pe=>{if(this.wb(pe)){const ue=await this.cb(pe.extensionLocation);_.set(ue,pe)}})),_}eb(B){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(B))return _;const pe=this.P.getActivatedExtension(B);if(!pe)return _;try{typeof pe.module.deactivate=="function"&&(_=Promise.resolve(pe.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${B.value}':`),this.s.error(ue)}try{(0,p.$Pc)(pe.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this.s.error(ue)}return _}async fb(B,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(B.identifier):await this.C.$onWillActivateExtension(B.identifier),this.hb(B,_).then(pe=>{const ue=pe.activationTimes;return this.C.$onDidActivateExtension(B.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,_),this.gb(B,_,"success",ue),pe},pe=>{throw this.gb(B,_,"failure"),pe})}gb(B,_,pe,ue){const ce=G(B,_);this.z.$publicLog2("extensionActivationTimes",{...ce,...ue||{},outcome:pe})}hb(B,_){const pe=G(B,_);this.z.$publicLog2("activatePlugin",pe);const ue=this.wb(B);if(!ue)return Promise.resolve(new v.$Zlc(v.$Wlc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${B.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const ce=new v.$Xlc(_.startup);return Promise.all([this.xb(B,(0,R.$0g)(B.extensionLocation,ue),ce),this.ib(B)]).then(oe=>(L.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Z.jb(this.s,B.identifier,oe[0],oe[1],ce))).then(oe=>(L.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),oe))}ib(B){const _=this.Z.createLanguageModelAccessInformation(B),pe=new o.$6lc(B,this.M),ue=new o.$5lc(B.identifier.value,!1,this.M),ce=new F.$cmc(B,this.N),oe=B.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([pe.whenReady,ue.whenReady,this.O.whenReady]).then(()=>{const J=this;let se,$e;const ve=(0,f.$OG)(B,"ipc")?this.f.messagePorts?.get(i.$Rm.toKey(B.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:ue,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Re){return O.$jc(B.extensionLocation.fsPath,Re)},get storagePath(){return J.O.workspaceValue(B)?.fsPath},get globalStoragePath(){return J.O.globalValue(B).fsPath},get logPath(){return O.$jc(J.f.logsLocation.fsPath,B.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,B.identifier.value)},get storageUri(){return J.O.workspaceValue(B)},get globalStorageUri(){return J.O.globalValue(B)},get extensionMode(){return oe},get extension(){return se===void 0&&(se=new ne(J,B.identifier,B,le,!1)),se},get extensionRuntime(){return(0,f.$PG)(B,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!$e){if(!ve)return;const Re=D.Event.buffer(D.Event.fromDOMEventEmitter(ve,"message",ge=>ge.data));ve.start(),$e={onDidReceiveMessage:Re,postMessage:ve.postMessage.bind(ve)}}return $e}})})}static jb(B,_,pe,ue,ce){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(B,_,pe,ue,ce).then(oe=>new v.$Ylc(!1,null,ce.build(),pe,oe,ue.subscriptions))}static kb(B,_,pe,ue,ce){if(typeof pe.activate=="function")try{ce.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${_.value}`);const oe=typeof global=="object"?global:self,le=pe.activate.apply(oe,[ue]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(le).then(J=>(ce.activateResolveStop(),J))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(pe)}lb(B,_){this.bb(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:_}).then(void 0,pe=>{this.s.error(pe)})}mb(B,_=0){const ue=Date.now();(0,j.$B)(()=>{for(let ce=_;ce<B.length;ce+=1){const oe=B[ce];for(const le of oe.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ue>50){this.mb(B,ce);break}else this.lb(oe,le)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(B=>{const _=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(_)this.mb(pe);else for(const ue of pe)if(ue.activationEvents)for(const ce of ue.activationEvents)ce==="onStartupFinished"&&this.lb(ue,ce)})}ob(){const B=this.ab("*",!0).then(void 0,oe=>{this.s.error(oe)});this.B(this.j.onDidChangeWorkspace(oe=>this.pb(oe.added)));const _=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(_),ue=this.rb(),ce=Promise.all([ue,B,pe]).then(()=>{});return Promise.race([ce,(0,N.$xh)(1e4)]).then(()=>{this.nb()}),ce}pb(B){return B.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(B,_))).then(()=>{})}async qb(B,_){if(this.isActivated(_.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:B.map(oe=>oe.uri),forceUsingSearch:pe||!this.c.fsExists,exists:oe=>this.c.fsExists(oe.fsPath),checkExists:(oe,le,J)=>this.y.$checkExists(oe,le,J)},ce=await(0,P.$mwb)(ue,_);if(ce)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:ce.activationEvent}).then(void 0,oe=>this.s.error(oe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(B){throw console.error(B),B}}async sb(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:_}=this.f.environment;if(!B||!_)throw new Error(d.localize(0,null));const pe=await this.xb(null,_,new v.$Xlc(!1));if(!pe||typeof pe.run!="function")throw new Error(d.localize(1,null,_.toString()));return new Promise((ue,ce)=>{const oe=(se,$e)=>{se?(j.$t&&this.s.error("Test runner called back with error",se),ce(se)):(j.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof $e=="number"&&$e>0?1:0))},le=(0,R.$Xg)(_),J=pe.run(le,oe);J&&J.then&&J.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(se=>{j.$t&&this.s.error("Test runner finished with error",se),ce(se instanceof Error&&se.stack?se.stack:String(se))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,N.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,_){return this.S[B]=_,(0,p.$Sc)(()=>{delete this.S[B]})}async getRemoteExecServer(B){const{resolver:_}=await this.ub(B);return _?.resolveExecServer?.(B,{resolveAttempt:0})}async ub(B){const _=B.indexOf("+");if(_===-1)throw new t.$gN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=B.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(B,_){const pe=M.$_d.create(!1),ue=()=>`[resolveAuthority(${(0,u.$Ll)(B)},${_})][${pe.elapsed()}ms] `,ce=W=>this.s.info(`${ue()}${W}`),oe=W=>this.s.warn(`${ue()}${W}`),le=(W,K=void 0)=>this.s.error(`${ue()}${W}`,K),J=W=>{if(W instanceof t.$gN)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},se=async W=>{ce(`activating resolver for ${W}...`);const{resolver:K,authorityPrefix:X}=await this.ub(W);if(!K)throw le(`no resolver for ${X}`),new t.$gN(`No remote extension installed to resolve ${X}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:X,remoteAuthority:W}},$e=B.split(/@|%40/g).reverse();ce(`activating remote resolvers ${$e.join(" -> ")}`);let ve;try{ve=await Promise.all($e.map(se)).catch(async W=>{if(!(W instanceof t.$gN)||W._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return oe(`resolving nested authorities failed: ${W.message}`),[await se(B)]})}catch(W){return J(W)}const Re=new N.$Hh;Re.cancelAndSet(()=>ce("waiting..."),1e3);let ge,Ie;for(const[W,{authorityPrefix:K,resolver:X,remoteAuthority:de}]of ve.entries())try{if(W===ve.length-1)ce("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${K}`),ge=await X.resolve(de,{resolveAttempt:_,execServer:Ie}),L.mark(`code/extHost/didResolveAuthorityOK/${K}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,t.$fN.isManagedResolvedAuthority(ge)?ge:void 0));else{if(ce(`invoking resolveExecServer() for ${de}`),L.mark(`code/extHost/willResolveExecServer/${K}`),Ie=await X.resolveExecServer?.(de,{resolveAttempt:_,execServer:Ie}),!Ie)throw new t.$gN(`Exec server was not available for ${de}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(we){return L.mark(`code/extHost/didResolveAuthorityError/${K}`),le("returned an error",we),Re.dispose(),J(we)}Re.dispose();const Ae={environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures?{elevation:ge.tunnelFeatures.elevation,privacyOptions:ge.tunnelFeatures.privacyOptions,protocol:ge.tunnelFeatures.protocol===void 0?!0:ge.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${t.$fN.isManagedResolvedAuthority(ge)?"managed authority":`${ge.host}:${ge.port}`}`);let V;if(t.$fN.isManagedResolvedAuthority(ge)){const W=_;this.Y.setFactory(W,ge.makeConnection),V={authority:B,connectTo:new u.$Il(W),connectionToken:ge.connectionToken}}else V={authority:B,connectTo:new u.$Jl(ge.host,ge.port),connectionToken:ge.connectionToken};return{type:"ok",value:{authority:V,options:ze,tunnelInformation:Ae}}}async $getCanonicalURI(B,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Ll)(B)})`);const{resolver:pe}=await this.ub(B);if(!pe)return null;const ue=k.URI.revive(_);if(typeof pe.getCanonicalURI>"u")return ue;const ce=await(0,N.$oh)(()=>pe.getCanonicalURI(ue));return ce||ue}async $startExtensionHost(B){B.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=Q(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(B,_){return _===1?this.D.wait().then(pe=>this.ab(B,!1)):this.G.wait().then(pe=>this.ab(B,!1))}async $activate(B,_){return await this.G.wait(),this.J.getExtensionDescription(B)?(await this.bb(B,_),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=Q(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const _=l.$Fe.alloc(B),pe=Math.random()%256;for(let ue=0;ue<B;ue++)_.writeUInt8(pe,ue);return _}async $updateRemoteConnectionData(B){this.X=B,this.a.fire()}};e.$imc=ie,e.$imc=ie=Z=Ge([We(0,r.$vi),We(1,e.$hmc),We(2,y.$zP),We(3,h.$Flc),We(4,$.$Ilc),We(5,A.$3j),We(6,c.$PP),We(7,s.$Llc),We(8,S.$sDb),We(9,g.$7lc),We(10,z.$emc),We(11,U.$fmc),We(12,E.$$lc)],ie);function Q(ee,B,_,pe){ee.addActivationEvents(pe.addActivationEvents);const ue=new a.$U_b(ee,B.getAllExtensionDescriptions());ue.deltaExtensions(pe.toAdd,pe.toRemove);const ce=new i.$Sm(_.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of pe.myToRemove)ce.delete(le);for(const le of pe.myToAdd)ce.add(le);const oe=be(ue,ce);return{globalRegistry:ue,myExtensions:oe}}function G(ee,B){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function x(ee){return ee.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.$jmc=(0,r.$wi)("IExtHostExtensionService");class ne{#e;#t;#n;constructor(B,_,pe,ue,ce){this.#e=B,this.#t=_,this.#n=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=O.$hc((0,R.$Xg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=ue,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$kmc=ne;function be(ee,B){return ee.getAllExtensionDescriptions().filter(_=>B.has(_.identifier))}class ae{constructor(B){this.a=B}setSearchTree(B){this.a=B}findSubstr(B){return this.a.findSubstr(B)}forEach(B){return this.a.forEach(B)}}e.$lmc=ae;class Ce{constructor(B){this.a=new i.$Tm,this.addActivationEvents(B)}readActivationEvents(B){return this.a.get(B.identifier)??[]}addActivationEvents(B){for(const _ of Object.keys(B))this.a.set(_,B[_])}}}),define(Se[379],De([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;let h=class{constructor(l,o,t,u,r,c,s){this.c=l,this.d=o,this.e=t,this.f=u,this.g=r,this.h=c,this.i=s,this.a=new Map,this.b=[]}async install(){this.j(),d.mark("code/extHost/willWaitForConfig");const l=await this.f.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,l,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,o,this.h.environment.appUriScheme))}register(l){if("nodeModuleName"in l)if(Array.isArray(l.nodeModuleName))for(const o of l.nodeModuleName)this.a.set(o,l);else this.a.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this.b.push(o=>l.alternativeModuleName(o))}};e.$unc=h,e.$unc=h=Ge([We(2,A.$vi),We(3,R.$Ilc),We(4,C.$jmc),We(5,k.$PP),We(6,$.$3j)],h);let f=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(l){if(l.environment.appRoot&&w.a.size){const o=(0,v.$_e)(this.c(l.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${r}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(l){if(!this.b)return;const o=this.b.exec(this.c(l));if(!o)return;const[,t,u,r]=o,c=w.a.get(u);if(c!==void 0)return console.warn(`${u} as been renamed to ${c}, please update your imports`),t+c+r}c(l){return l.replace(/\\/g,"/")}};f=w=Ge([We(0,k.$PP)],f);class a{constructor(l,o,t,u,r){this.c=l,this.d=o,this.e=t,this.f=u,this.g=r,this.nodeModuleName="vscode",this.a=new p.$Tm}load(l,o){const t=this.d.findSubstr(o);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((r,c)=>u+=`	${c} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${u}`),this.b=this.c(N.$JG,this.e,this.f)}return this.b}}let n=class{constructor(l,o,t){this.e=l,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$$M.MainThreadTelemetry);const u=t.getProxy(L.$$M.MainThreadWindow);this.c=(r,c)=>{const s=O.URI.parse(r);return c?this.g(r,c):s.scheme==="http"||s.scheme==="https"?u.$openUri(s,r,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?u.$openUri(s,r,{}):this.g(r,c)}}load(l,o,t){const u=this.e.findSubstr(o);return u&&(this.a=u.identifier.value,this.h()),this.b=t(l),this.c}g(l,o){return this.i(),this.b(l,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ge([We(2,m.$zP)],n)}),define(Se[61],De([1,0,46,3,17,52,5,73,72,49,8,44,307,45]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=e.$mmc=void 0,e.$mmc=(0,N.$wi)("IExtHostVariableResolverProvider");class w extends $.$DQ{constructor(a,n,i,l,o,t,u){function r(){if(i){const c=i.activeEditor();if(c)return c.document.uri;const s=l.tabGroups.all.find(y=>y.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof A.$YO||s.input instanceof A.$4O)return s.input.modified;if(s.input instanceof A.$XO||s.input instanceof A.$3O||s.input instanceof A.$1O)return s.input.uri}}}super({getFolderUri:c=>{const s=t.folders.filter(y=>y.name===c);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,s)=>o.getConfiguration(void 0,c).get(s),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return L.$hc(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const c=r();if(c){const s=n.getWorkspaceFolder(c);if(s)return L.$hc(s.uri.fsPath)}}},getSelectedText:()=>{if(i){const c=i.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(i){const c=i.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(R.env))}}let h=class extends O.$Uc{constructor(a,n,i,l,o){super(),this.b=a,this.c=n,this.g=i,this.h=l,this.j=o,this.a=new d.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$nmc=h,e.$nmc=h=Ge([We(0,k.$jmc),We(1,C.$Flc),We(2,p.$KP),We(3,v.$Ilc),We(4,m.$Ulc)],h)}),define(Se[96],De([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,16,19]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=e.$qmc=e.$pmc=e.$omc=void 0,e.$omc=(0,N.$wi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(S,g,E,D,P,I,F){this.N=g,this.O=E,this.P=D,this.Q=P,this.R=I,this.S=F,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$de,this.o=new O.$de,this.q=new O.$de,this.w=new O.$de,this.l=S.getProxy(p.$$M.MainThreadDebugService),this.A=new O.$de,this.C=new O.$de,this.y=new r(this.l),this.z=new Map,this.O.getExtensionRegistry().then(T=>{T.onDidChange(z=>{this.V(T)}),this.V(T)})}async $getVisualizerTreeItem(S,g){const E=this.W(g);if(!E)return;const D=await this.H.get(S)?.getTreeItem?.(E);return D?this.U(S,D):void 0}registerDebugVisualizationTree(S,g,E){const D=R.$Rm.toKey(S.identifier),P=this.jb(D,g);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.H.set(P,E),this.l.$registerDebugVisualizerTree(P,!!E.editItem),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(P),this.H.delete(g)})}async $getVisualizerTreeItemChildren(S,g){const E=this.J.get(g)?.item;return E?(await this.H.get(S)?.getChildren?.(E))?.map(P=>this.U(S,P))||[]:[]}async $editVisualizerTreeItem(S,g){const E=this.J.get(S);if(!E)return;const D=await this.H.get(E.provider)?.editItem?.(E.item,g);return this.U(E.provider,D||E.item)}$disposeVisualizedTree(S){const g=this.J.get(S);if(!g)return;const E=[g.children];for(const D of E)if(D)for(const P of D)E.push(this.J.get(P)?.children),this.J.delete(P)}U(S,g){let E=this.I.get(g);return E||(E=this.F++,this.I.set(g,E),this.J.set(E,{provider:S,item:g})),l.DebugTreeItem.from(g,E)}asDebugSourceUri(S,g){const E=S;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let D=`debug:${encodeURIComponent(E.path||"")}`,P="?";return g&&(D+=`${P}session=${encodeURIComponent(g.id)}`,P="&"),D+=`${P}ref=${E.sourceReference}`,L.URI.parse(D)}else{if(E.path)return L.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(S){const g=[];for(const E of S.getAllExtensionDescriptions())if(E.contributes){const D=E.contributes.debuggers;if(D&&D.length>0)for(const P of D)(0,w.$tH)(P)&&g.push(P.type)}this.l.$registerDebugTypes(g)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const S=[];return this.z.forEach(g=>S.push(g)),S}async $resolveDebugVisualizer(S,g){const E=this.L.get(S);if(!E)throw new Error(`No debug visualizer found with id '${S}'`);let{v:D,provider:P,extensionId:I}=E;if(D.visualization||(D=await P.resolveDebugVisualization?.(D,g)||D,E.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${P}'`);return this.kb(I,D.visualization)}async $executeDebugVisualizerCommand(S){const g=this.L.get(S);if(!g)throw new Error(`No debug visualizer found with id '${S}'`);const E=g.v.visualization;E&&"command"in E&&this.S.executeCommand(E.command,...E.arguments||[])}W(S){const g=this.m.get(S.sessionId);return g&&{session:g.api,variable:S.variable,containerId:S.containerId,frameId:S.frameId,threadId:S.threadId}}async $provideDebugVisualizers(S,g,E,D){const P=this.W(E),I=this.jb(S,g),F=this.G.get(I);if(!P||!F)return[];const T=await F.provideDebugVisualization(P,D);return T?T.map(z=>{const M=++this.M;this.L.set(M,{v:z,provider:F,extensionId:S});const j=z.iconPath?this.lb(z.iconPath):void 0;return{id:M,name:z.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(S,z.visualization)}}):[]}$disposeDebugVisualizers(S){for(const g of S)this.L.delete(g)}registerDebugVisualizationProvider(S,g,E){if(!S.contributes?.debugVisualizers?.some(I=>I.id===g))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${g})`);const D=R.$Rm.toKey(S.identifier),P=this.jb(D,g);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.G.set(P,E),this.l.$registerDebugVisualizer(D,g),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,g),this.G.delete(g)})}addBreakpoints(S){const g=S.filter(P=>{const I=P.id;return this.z.has(I)?!1:(this.z.set(I,P),!0)});this.gb(g,[],[]);const E=[],D=new Map;for(const P of g)if(P instanceof C.$cO){let I=D.get(P.location.uri.toString());I||(I={type:"sourceMulti",uri:P.location.uri,lines:[]},D.set(P.location.uri.toString(),I),E.push(I)),I.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character,mode:P.mode})}else P instanceof C.$dO&&E.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName,mode:P.mode});return this.l.$registerBreakpoints(E)}removeBreakpoints(S){const g=S.filter(I=>this.z.delete(I.id));this.gb([],g,[]);const E=g.filter(I=>I instanceof C.$cO).map(I=>I.id),D=g.filter(I=>I instanceof C.$dO).map(I=>I.id),P=g.filter(I=>I instanceof C.$eO).map(I=>I.id);return this.l.$unregisterBreakpoints(E,D,P)}startDebugging(S,g,E){return this.l.$startDebugging(S?S.uri:void 0,g,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(S){return this.l.$stopDebugging(S?S.id:void 0)}registerDebugConfigurationProvider(S,g,E){if(!g)return new C.$aN(()=>{});const D=this.d++;return this.f.push({type:S,handle:D,provider:g}),this.l.$registerDebugConfigurationProvider(S,E,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,D),new C.$aN(()=>{this.f=this.f.filter(P=>P.provider!==g),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(S,g,E){if(!E)return new C.$aN(()=>{});if(!this.cb(S,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.$(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:g,handle:D,factory:E}),this.l.$registerDebugAdapterDescriptorFactory(g,D),new C.$aN(()=>{this.h=this.h.filter(P=>P.factory!==E),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(S,g){if(!g)return new C.$aN(()=>{});const E=this.j++;return this.k.push({type:S,handle:E,factory:g}),new C.$aN(()=>{this.k=this.k.filter(D=>D.factory!==g)})}async $runInTerminal(S,g){return Promise.resolve(void 0)}async $substituteVariables(S,g){let E;const D=await this.ib(S);return D&&(E={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(E,g)}X(S,g){if(S.type==="implementation")return new s(S.implementation)}Y(){}async $startDASession(S,g){const E=this,D=await this.hb(g);return this.eb(this.$(D.type),D).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const I=this.Z(P),F=this.X(I,D);if(!F)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const T=F;return this.D.set(S,T),this.db(D).then(z=>(z&&this.E.set(S,z),T.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const j=M,U={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const Z=await this.K.sign(j.arguments.value);U.body={signature:Z},T.sendResponse(U)}else throw new Error("no signer")}catch(Z){U.success=!1,U.message=Z.message,T.sendResponse(U)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(M),M=(0,w.$yH)(M,!0),E.l.$acceptDAMessage(S,M)}),T.onError(M=>{z&&z.onError&&z.onError(M),this.l.$acceptDAError(S,M.name,M.message,M.stack)}),T.onExit(M=>{z&&z.onExit&&z.onExit(M??void 0,void 0),this.l.$acceptDAExit(S,M??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),T.startSession()))})}$sendDAMessage(S,g){g=(0,w.$xH)(g,!1);const E=this.E.get(S);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(g),this.D.get(S)?.sendMessage(g)}$stopDASession(S){const g=this.E.get(S);this.E.delete(S),g&&g.onWillStopSession&&g.onWillStopSession();const E=this.D.get(S);return this.D.delete(S),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(S){const g=[],E=[],D=[];if(S.added)for(const P of S.added){const I=P.id;if(I&&!this.z.has(I)){let F;if(P.type==="function")F=new C.$dO(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode);else if(P.type==="data")F=new C.$eO(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage,P.mode);else{const T=L.URI.revive(P.uri);F=new C.$cO(new C.$mN(T,new C.$bN(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode)}(0,C.$aO)(F,I),this.z.set(I,F),g.push(F)}}if(S.removed)for(const P of S.removed){const I=this.z.get(P);I&&(this.z.delete(P),E.push(I))}if(S.changed){for(const P of S.changed)if(P.id){const I=this.z.get(P.id);if(I){if(I instanceof C.$dO&&P.type==="function"){const F=I;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.functionName=P.functionName}else if(I instanceof C.$cO&&P.type==="source"){const F=I;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.location=new C.$mN(L.URI.revive(P.uri),new C.$bN(P.line,P.character))}D.push(I)}}}this.gb(g,E,D)}async $acceptStackFrameFocus(S){let g;if(S){const E=await this.hb(S.sessionId);S.kind==="thread"?g=new C.$kO(E.api,S.threadId):g=new C.$jO(E.api,S.threadId,S.frameId)}this.B=g,this.C.fire(this.B)}$provideDebugConfigurations(S,g,E){return(0,d.$oh)(async()=>{const D=this.bb(S);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.ib(g);return D.provideDebugConfigurations(P,E)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(S,g,E,D){return(0,d.$oh)(async()=>{const P=this.bb(S);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.ib(g);return P.resolveDebugConfiguration(I,E,D)})}$resolveDebugConfigurationWithSubstitutedVariables(S,g,E,D){return(0,d.$oh)(async()=>{const P=this.bb(S);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.ib(g);return P.resolveDebugConfigurationWithSubstitutedVariables(I,E,D)})}async $provideDebugAdapter(S,g){const E=this.ab(S);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(g);return this.eb(E,D).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(P)})}async $acceptDebugSessionStarted(S){const g=await this.hb(S);this.n.fire(g.api)}async $acceptDebugSessionTerminated(S){const g=await this.hb(S);g&&(this.o.fire(g.api),this.m.delete(g.id))}async $acceptDebugSessionActiveChanged(S){this.u=S?await this.hb(S):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(S,g){(await this.hb(S))?._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(S,g){const D={session:(await this.hb(S)).api,event:g.event,body:g.body};this.w.fire(D)}Z(S){if(S instanceof C.$fO)return{type:"executable",command:S.command,args:S.args,options:S.options};if(S instanceof C.$gO)return{type:"server",port:S.port,host:S.host};if(S instanceof C.$hO)return{type:"pipeServer",path:S.path};if(S instanceof C.$iO)return{type:"implementation",implementation:S.implementation};throw new Error("convertToDto unexpected type")}$(S){const g=this.h.filter(E=>E.type===S);if(g.length>0)return g[0].factory}ab(S){const g=this.h.filter(E=>E.handle===S);if(g.length>0)return g[0].factory}bb(S){const g=this.f.filter(E=>E.handle===S);if(g.length>0)return g[0].provider}cb(S,g){if(S.contributes){const E=S.contributes.debuggers;if(E&&E.length>0){for(const D of E)if(D.label&&D.type&&D.type===g)return!0}}return!1}db(S){const E=S.configuration.type,D=this.k.filter(P=>P.type===E||P.type==="*").map(P=>(0,d.$oh)(()=>P.factory.createDebugAdapterTracker(S.api)).then(I=>I,I=>null));return Promise.race([Promise.all(D).then(P=>{const I=(0,o.$Hb)(P);if(I.length>0)return new c(I)}),new Promise(P=>setTimeout(()=>P(void 0),1e3))]).catch(P=>{})}async eb(S,g){const E=g.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new C.$gO(E));if(S){const P=await this.O.getExtensionRegistry();return(0,d.$oh)(()=>S.createDebugAdapterDescriptor(g.api,this.fb(g,P))).then(I=>{if(I)return I})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(g,D))}fb(S,g){}gb(S,g,E){(S.length>0||g.length>0||E.length>0)&&this.A.fire(Object.freeze({added:S,removed:g,changed:E}))}async hb(S){if(S)if(typeof S=="string"){const g=this.m.get(S);if(g)return g}else{let g=this.m.get(S.id);if(!g){const E=await this.ib(S.folderUri),D=S.parent?this.m.get(S.parent):void 0;g=new u(this.l,S.id,S.type,S.name,E,S.configuration,D?.api),this.m.set(g.id,g),this.l.$sessionCached(g.id)}return g}throw new Error("cannot find session")}ib(S){if(S){const g=L.URI.revive(S);return this.N.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}jb(S,g){return`${S}\0${g}`}kb(S,g){if(g){if("title"in g&&"command"in g)return{type:0};if("treeId"in g)return{type:1,id:`${S}\0${g.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(S){const g=this.mb(S);let E,D;return"id"in g?D=n.ThemeIcon.asClassName(g):E=g,{iconPath:E,iconClass:D}}mb(S){if(S instanceof C.$0N)return{id:S.id};const g=typeof S=="object"&&"dark"in S?S.dark:S,E=typeof S=="object"&&"light"in S?S.light:S;return{dark:typeof g=="string"?L.URI.file(g):g,light:typeof E=="string"?L.URI.file(E):E}}};e.$pmc=t,e.$pmc=t=Ge([We(0,A.$zP),We(1,$.$Flc),We(2,k.$jmc),We(3,h.$Ilc),We(4,m.$Ulc),We(5,f.$mmc),We(6,i.$VP)],t);class u{constructor(S,g,E,D,P,I,F){this.f=S,this.g=g,this.h=E,this.j=D,this.k=P,this.l=I,this.m=F}get api(){const S=this;return this.d??=Object.freeze({id:S.g,type:S.h,get name(){return S.j},set name(g){S.j=g,S.f.$setDebugSessionName(S.g,g)},parentSession:S.m,workspaceFolder:S.k,configuration:S.l,customRequest(g,E){return S.f.$customDebugAdapterRequest(S.g,g,E)},getDebugProtocolBreakpoint(g){return S.f.$getDebugProtocolBreakpoint(S.g,g.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(S){this.j=S}get configuration(){return this.l}}e.$qmc=u;class r{constructor(S){this.value=Object.freeze({append(g){S.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.$rmc=r;class c{constructor(S){this.d=S}onWillStartSession(){this.d.forEach(S=>S.onWillStartSession?S.onWillStartSession():void 0)}onWillReceiveMessage(S){this.d.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(S):void 0)}onDidSendMessage(S){this.d.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(S):void 0)}onWillStopSession(){this.d.forEach(S=>S.onWillStopSession?S.onWillStopSession():void 0)}onError(S){this.d.forEach(g=>g.onError?g.onError(S):void 0)}onExit(S,g){this.d.forEach(E=>E.onExit?E.onExit(S,g):void 0)}}class s extends v.$Rrb{constructor(S){super(),this.h=S,S.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(S){this.h.handleMessage(S)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends t{constructor(S,g,E,D,P,I,F){super(S,g,E,D,P,I,F)}};e.$smc=y,e.$smc=y=Ge([We(0,A.$zP),We(1,$.$Flc),We(2,k.$jmc),We(3,h.$Ilc),We(4,m.$Ulc),We(5,f.$mmc),We(6,i.$VP)],y)}),define(Se[380],De([1,0,13,59,2,6,327,11,85,107,28,263,20,68,49,90]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=e.$vnc=void 0;class f{static async installEarlyHandler(i){Error.stackTraceLimit=100;const l=i.get(p.$3j),t=i.get($.$zP).getProxy(R.$$M.MainThreadErrors);d.setUnexpectedErrorHandler(u=>{l.error(u);const r=d.$3(u);t.$onUnexpectedError(r)})}static async installFullHandler(i){const l=i.get(p.$3j),o=i.get($.$zP),t=i.get(w.$jmc),u=i.get(h.$TP),r=o.getProxy(R.$$M.MainThreadExtensionService),c=o.getProxy(R.$$M.MainThreadErrors),s=await t.getExtensionPathIndex(),y=new WeakMap;function b(E,D){if(y.has(E))return y.get(E).stack;let P="",I,F;for(const z of D)P+=`
	at ${z.toString()}`,F=z.getFileName(),!I&&F&&(I=s.findSubstr(L.URI.file(F)));const T=`${E.name||"Error"}: ${E.message||""}${P}`;return y.set(E,{extensionIdentifier:I?.identifier,stack:T}),T}const S=Symbol("prepareStackTrace wrapped");let g=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(E){if(E===b||!E||E[S]){g=E||b;return}g=function(D,P){return b(D,P),E.call(Error,D,P)},Object.assign(g,{[S]:!0})}}),d.setUnexpectedErrorHandler(E=>{l.error(E);const D=d.$3(E),P=y.get(E);if(!P?.extensionIdentifier){c.$onUnexpectedError(D);return}r.$onExtensionRuntimeError(P.extensionIdentifier,D);const I=u.onExtensionError(P.extensionIdentifier,E);l.trace("forwarded error to extension?",I,P)})}}e.$vnc=f;class a{constructor(i,l,o,t,u){this.a=o,this.b=new N.$3_b(i,null,t),l=a.e(l,this.b);const r=new k.$ui(...(0,m.$ys)());r.set(A.$PP,{_serviceBrand:void 0,...l,messagePorts:u}),r.set($.$zP,new $.$AP(this.b)),r.set(v.$Clc,new v.$Dlc(t)),r.set(w.$hmc,o);const c=new C.$cr(r,!0);c.invokeFunction(f.installEarlyHandler),this.d=c.invokeFunction(s=>s.get(p.$3j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",l),this.c=c.invokeFunction(s=>s.get(w.$jmc)),this.c.initialize(),c.invokeFunction(f.installFullHandler)}async asBrowserUri(i){const l=this.b.getProxy(R.$$M.MainThreadExtensionService);return L.URI.revive(await l.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,l){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(l.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(l.transformIncomingURIs(i.environment.appRoot));const o=i.environment.extensionDevelopmentLocationURI;return o&&(i.environment.extensionDevelopmentLocationURI=o.map(t=>L.URI.revive(l.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(l.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(l.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(l.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(l.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(l.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(l.transformIncomingURIs(i.logsLocation)),i.workspace=l.transformIncomingURIs(i.workspace),i}}e.$wnc=a}),define(Se[381],De([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=void 0;let i=class extends p.$pmc{constructor(r,c,s,y,b,S,g,E){super(r,c,s,y,S,g,E),this.pb=b,this.nb=new t}X(r,c){switch(r.type){case"server":return new h.$Bnc(r);case"pipeServer":return new h.$Cnc(r);case"executable":return new h.$Dnc(r,c.type)}return super.X(r,c)}fb(r,c){const s=h.$Dnc.platformAdapterExecutable(c.getAllExtensionDescriptions(),r.type);if(s)return new $.$fO(s.command,s.args,s.options)}Y(){return new N.$Qdc}async $runInTerminal(r,c){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const s=await this.P.getConfigProvider(),y=this.pb.getDefaultShell(!0),b=this.pb.getDefaultShellArgs(!0),S=r.title||L.localize(0,null),g=JSON.stringify({shell:y,shellArgs:b});let E=await this.nb.checkout(g,S),D,P=!1;if(E)D=r.cwd;else{const z={shellPath:y,shellArgs:b,cwd:r.cwd,name:S,iconPath:new $.$0N("debug")};P=!0,E=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(E,g)}E.show(!0);const I=await E.processId;P?await new Promise(z=>setTimeout(z,1e3)):(E.state.isInteractedWith&&(E.sendText(""),await(0,d.$xh)(200)),s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0||y.indexOf("cmd.exe")>=0?E.sendText("cls"):y.indexOf("bash")>=0?E.sendText("clear"):O.$i?E.sendText("cls"):E.sendText("clear")));const F=(0,f.$Fnc)(y,r.args,!!r.argsCanBeInterpretedByShell,D,r.env);E.sendText(F);const T=this.onDidTerminateDebugSession(z=>{z.id===c&&(this.nb.free(E),T.dispose())});return I}else if(r.kind==="external")return o(r,await this.P.getConfigProvider());return super.$runInTerminal(r,c)}};e.$Gnc=i,e.$Gnc=i=Ge([We(0,A.$zP),We(1,w.$Flc),We(2,k.$jmc),We(3,a.$Ilc),We(4,C.$7lc),We(5,m.$Ulc),We(6,v.$mmc),We(7,n.$VP)],i);let l;function o(u,r){if(!l)if(O.$i)l=new R.$Bcc;else if(O.$j)l=new R.$Ccc;else if(O.$k)l=new R.$Dcc;else throw new Error("external terminals not supported on this platform");const c=r.getConfiguration("terminal");return l.runInTerminal(u.title,u.cwd,u.args,u.env||{},c.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,c,s=!1){const b=[...this.b.entries()].map(([S,g])=>(0,d.$jh)(async E=>{if(S.name!==c||g.lastUsedAt!==-1&&await(0,f.$Enc)(await S.processId))return null;const D=Date.now();return g.lastUsedAt+t.a>D||E.isCancellationRequested?null:g.config!==r?(s&&S.dispose(),null):(g.lastUsedAt=D,S)}));return await(0,d.$Bh)(b,S=>!!S)}insert(r,c){this.b.set(r,{lastUsedAt:Date.now(),config:c})}free(r){const c=this.b.get(r);c&&(c.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[382],De([1,0,17,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;let i=class extends $.$$mc{constructor(o,t,u,r,c,s,y,b,S){super(o,t,u,r,c,s,y,b),this.C=u,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const u=t;if(!t.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const r=$.TaskHandleDTO.from(u,this.C),c=await this.a.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.z(c,t);return this.a.$executeTask(r).catch(()=>{}),s}else{const r=$.TaskDTO.from(t,o);if(r===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const c=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),c}}v(o,t,u,r){const c=[];if(r)for(const s of r){this.A(s,u),(!s.definition||!o[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const y=$.TaskDTO.from(s,u.extension);y&&(c.push(y),$.CustomExecutionDTO.is(y.execution)&&t.push(this.y(y,s,!0)))}return{tasks:c,extension:u.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const u=O.URI.file((0,a.homedir)());t=new m.$Qi({uri:u,name:f.$7g(u),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const u=O.URI.revive(o),r={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(u),s=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),b=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(s);for(const S of t.variables)r.variables[S]=await y.resolveAsync(b,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(d.$tc);for(let g=0;g<S.length;g++)S[g]=await y.resolveAsync(b,S[g])}r.process=await L.win32.findExecutable(await y.resolveAsync(b,t.process.name),t.process.cwd!==void 0?await y.resolveAsync(b,t.process.cwd):void 0,S)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,u){return L.win32.findExecutable(o,t,u)}};e.$ync=i,e.$ync=i=Ge([We(0,A.$zP),We(1,C.$PP),We(2,R.$Flc),We(3,N.$KP),We(4,p.$Ilc),We(5,k.$7lc),We(6,w.$3j),We(7,h.$jlc),We(8,n.$mmc)],i)}),define(Se[383],De([1,0,64,61]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=void 0;class L extends O.$nmc{m(){return(0,d.homedir)()}}e.$eoc=L}),define(Se[160],De([1,0,19,7,22,47,15,17,23,2,37]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Hmc=e.$Gmc=void 0,e.$Imc=h;class C{constructor(n,i,l){this.d=n,this.e=i,this.f=l,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const l=this.g.folderQueries||[],o=new L.$oe(i);return new Promise((t,u)=>{this.a=new v(n);let r=!1;const c=(s,y)=>{if(!r&&!this.b){const b=this.h(s);h(s)&&typeof this.g.maxResults=="number"&&this.c+b>this.g.maxResults&&(this.b=!0,r=!0,o.cancel(),s=this.j(s,this.g.maxResults-this.c));const S=this.h(s);this.c+=S,(S>0||!h(s))&&this.a.add(s,y)}};Promise.all(l.map((s,y)=>this.k(s,b=>c(b,y),o.token))).then(s=>{o.dispose(),this.a.flush();const y=s.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||y,messages:s.flatMap(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[]),stats:{type:this.f}})},s=>{o.dispose();const y=(0,R.$hj)(s);u(new Error(y))})})}h(n){return h(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const l=Array.isArray(n.ranges)?n.ranges:[n.ranges],o=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:l.slice(0,i),preview:{matches:o.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,l){const o=new A.$EL(this.g,n),t=[],u={report:s=>{if(!this.l(s))return;const y=n.folder.scheme===N.Schemas.file?(0,A.$FL)(()=>this.e.readdir(m.$9g(s.uri))):void 0,b=m.$_g(n.folder,s.uri);if(b){const S=o.includedInQuery(b,p.$nc(b),y);(0,O.$ih)(S)?t.push(S.then(g=>{g&&i(s)})):S&&i(s)}}},r=this.n(n);let c;return this.d.query.type===3?c=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,r,u,l):c=await this.d.provider.provideTextSearchResults($(this.d.query.contentPattern),r,u,l),t.length&&await Promise.all(t),c}l(n){if(h(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$DL)(this.g.includePattern,n.includePattern),l=(0,A.$DL)(this.g.excludePattern,n.excludePattern),o={folder:k.URI.from(n.folder),excludes:l,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$Gmc=C;function $(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new f(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(w(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Hmc=v;function w(a){return h(a)?{preview:{matches:(0,d.$1b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,d.$1b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function h(a){return!!a.preview}class f{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Jmc=f}),define(Se[97],De([1,0,3,6,5,376,20,68,11,2,160]),function(he,e,d,O,L,R,N,p,m,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0,e.$Mmc=$,e.$Kmc=(0,L.$wi)("IExtHostSearch");let C=class{constructor(h,f,a){this.n=h,this.o=f,this.q=a,this.c=this.n.getProxy(O.$$M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Fmc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProvider(h,f){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const a=this.d++;return this.e.set(a,f),this.c.$registerTextSearchProvider(a,this.s(h)),(0,d.$Sc)(()=>{this.g.delete(h),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(h,f){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const a=this.d++;return this.h.set(a,f),this.c.$registerAITextSearchProvider(a,this.s(h)),(0,d.$Sc)(()=>{this.i.delete(h),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(h,f){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const a=this.d++;return this.j.set(a,f),this.c.$registerFileSearchProvider(a,this.s(h)),(0,d.$Sc)(()=>{this.k.delete(h),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(h,f,a,n){const i=$(a),l=this.j.get(h);if(l)return this.l.fileSearch(i,l,o=>{this.c.$handleFileMatch(h,f,o.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,f,a){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,f,a,n){const i=this.e.get(h);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${h}`);const l=$(a);return this.t(l,i).search(t=>this.c.$handleTextMatch(h,f,t),n)}$provideAITextSearchResults(h,f,a,n){const i=this.h.get(h);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${h}`);const l=$(a);return this.v(l,i).search(t=>this.c.$handleTextMatch(h,f,t),n)}$enableExtensionHostSearch(){}t(h,f){return new A.$Gmc({query:h,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(h,f){return new A.$Gmc({query:h,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$Lmc=C,e.$Lmc=C=Ge([We(0,N.$zP),We(1,p.$Clc),We(2,m.$3j)],C);function $(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(v),extraFileResources:w.extraFileResources&&w.extraFileResources.map(h=>k.URI.revive(h))}}function v(w){return{...w,folder:k.URI.revive(w.folder)}}}),define(Se[384],De([1,0,22,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,329,355,91,121,333,334,335,316,305,34,336,45,337,96,152,338,318,330,339,340,73,72,331,49,341,70,342,60,28,356,357,319,343,122,344,116,117,320,375,346,288,347,358,348,158,321,349,350,351,20,352,97,118,353,322,354,119,93,95,90,43,156,359,360,332,361,362,71,16,8,323,68,324,92,363,364,151,44,298,115,26,94]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u,r,c,s,y,b,S,g,E,D,P,I,F,T,z,M,j,U,Z,ie,Q,G,x,ne,be,ae,Ce,ee,B,_,pe,ue,ce,oe,le,J,se,$e,ve,Re,ge,Ie,Ae,ze,V,W,K,X,de,we,Fe,Ve,Je,tt,_e,nt,it,rt,at,Ne,ye,qe,te,re,Pe,He,Le,st,ut,mt,Dt,It,Ut,Wt,St,Yt,xt,xe,cn){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=Kt;function Kt(ft){const $t=ft.get(ae.$PP),_t=ft.get(be.$nlc),Xt=ft.get(x.$Klc),jt=ft.get(Q.$jmc),gt=ft.get(St.$Flc),qt=ft.get(it.$TP),en=ft.get(E.$Ilc),Vt=ft.get(ut.$Clc),Ze=ft.get(K.$zP),dn=ft.get(tt.$4lc),Zt=ft.get(_e.$Llc),Ht=ft.get(h.$4j),bt=ft.get(h.$3j),zt=ft.get(Pe.$sDb),Mt=ft.get(t.$jlc),Tt=ft.get(Wt.$pnc),on=ft.get(we.$bmc),Gt=ft.get(Z.$Ulc),an=ft.get(oe.$fmc),Lt=ft.get(u.$tlc),Ft=ft.get(pe.$$lc);Ze.set(i.$_M.ExtHostFileSystemInfo,_t),Ze.set(i.$_M.ExtHostLogLevelServiceShape,Ht),Ze.set(i.$_M.ExtHostWorkspace,gt),Ze.set(i.$_M.ExtHostConfiguration,en),Ze.set(i.$_M.ExtHostExtensionService,jt),Ze.set(i.$_M.ExtHostStorage,dn),Ze.set(i.$_M.ExtHostTunnelService,zt),Ze.set(i.$_M.ExtHostWindow,Tt),Ze.set(i.$_M.ExtHostSecretState,on),Ze.set(i.$_M.ExtHostTelemetry,qt),Ze.set(i.$_M.ExtHostEditorTabs,Gt),Ze.set(i.$_M.ExtHostManagedSockets,an),Ze.set(i.$_M.ExtHostAuthentication,Lt),Ze.set(i.$_M.ExtHostChatProvider,Ft);const Bt=Ze.set(i.$_M.ExtHostDecorations,ft.get(I.$umc)),At=Ze.set(i.$_M.ExtHostDocumentsAndEditors,ft.get(U.$KP)),pt=Ze.set(i.$_M.ExtHostCommands,ft.get(S.$VP)),kt=Ze.set(i.$_M.ExtHostTerminalService,ft.get(rt.$7lc)),un=Ze.set(i.$_M.ExtHostTerminalShellIntegration,ft.get(at.$bnc)),Pt=Ze.set(i.$_M.ExtHostDebugService,ft.get(P.$omc)),mn=Ze.set(i.$_M.ExtHostSearch,ft.get(de.$Kmc)),tn=Ze.set(i.$_M.ExtHostTask,ft.get(nt.$anc)),wn=Ze.set(i.$_M.ExtHostOutputService,ft.get(Ie.$Zmc)),ln=Ze.set(i.$_M.ExtHostLocalization,ft.get(ce.$emc)),vn=Ze.set(i.$_M.ExtHostUrls,new mt.$mnc(Ze)),Rt=Ze.set(i.$_M.ExtHostDocuments,new j.$qlc(Ze,At)),Sn=Ze.set(i.$_M.ExtHostDocumentContentProviders,new z.$wmc(Ze,At,bt)),nn=Ze.set(i.$_M.ExtHostDocumentSaveParticipant,new M.$xmc(bt,Rt,Ze.getProxy(i.$$M.MainThreadBulkEdits))),Ct=Ze.set(i.$_M.ExtHostNotebook,new J.$Nmc(Ze,pt,At,Rt,Xt,mn)),Oe=Ze.set(i.$_M.ExtHostNotebookDocuments,new $e.$Tmc(Ct)),je=Ze.set(i.$_M.ExtHostNotebookEditors,new ve.$Umc(bt,Ct)),Ee=Ze.set(i.$_M.ExtHostNotebookKernels,new Re.$Vmc(Ze,$t,Ct,pt,bt)),Y=Ze.set(i.$_M.ExtHostNotebookRenderers,new ge.$Xmc(Ze,Ct)),Te=Ze.set(i.$_M.ExtHostNotebookDocumentSaveParticipant,new se.$Smc(bt,Ct,Ze.getProxy(i.$$M.MainThreadBulkEdits))),Qe=Ze.set(i.$_M.ExtHostEditors,new ye.$zlc(Ze,At)),Ye=Ze.set(i.$_M.ExtHostTreeViews,new re.$knc(Ze.getProxy(i.$$M.MainThreadTreeViews),pt,bt)),Ke=Ze.set(i.$_M.ExtHostEditorInsets,new b.$Alc(Ze.getProxy(i.$$M.MainThreadEditorInsets),Qe,$t.remote)),ht=Ze.set(i.$_M.ExtHostDiagnostics,new F.$plc(Ze,bt,_t,At)),Et=Ze.set(i.$_M.ExtHostLanguages,new ue.$Qmc(Ze,Rt,pt.converter,Vt)),lt=Ze.set(i.$_M.ExtHostLanguageFeatures,new _.$rlc(Ze,Vt,Rt,pt,ht,bt,Mt,qt)),rn=Ze.set(i.$_M.ExtHostFileSystem,new G.$zmc(Ze,lt)),Nt=Ze.set(i.$_M.ExtHostFileSystemEventService,new ne.$Amc(Ze,bt,At)),Qt=Ze.set(i.$_M.ExtHostQuickOpen,(0,W.$4mc)(Ze,gt,pt)),Dn=Ze.set(i.$_M.ExtHostSCM,new X.$6mc(Ze,pt,Rt,bt)),Jn=Ze.set(i.$_M.ExtHostQuickDiff,new V.$3mc(Ze,Vt)),On=Ze.set(i.$_M.ExtHostShare,new Fe.$7mc(Ze,Vt)),Mn=Ze.set(i.$_M.ExtHostComments,(0,g.$Blc)(Ze,pt,Rt)),Pn=Ze.set(i.$_M.ExtHostProgress,new ze.$2mc(Ze.getProxy(i.$$M.MainThreadProgress))),Tn=Ze.set(i.$_M.ExtHostLabelService,new B.$Pmc(Ze)),Fn=Ze.set(i.$_M.ExtHostTheming,new qe.$hnc(Ze)),Kn=Ze.set(i.$_M.ExtHostTimeline,new te.$jnc(Ze,pt)),jn=Ze.set(i.$_M.ExtHostWebviews,new Dt.$Plc(Ze,$t.remote,gt,bt,Mt)),Cn=Ze.set(i.$_M.ExtHostWebviewPanels,new It.$Slc(Ze,jn,gt)),zn=Ze.set(i.$_M.ExtHostCustomEditors,new D.$Tlc(Ze,Rt,Zt,jn,Cn)),Bn=Ze.set(i.$_M.ExtHostWebviewViews,new Ut.$nnc(Ze,jn)),yn=Ze.set(i.$_M.ExtHostTesting,new Ne.$dnc(Ze,bt,pt,At)),Xn=Ze.set(i.$_M.ExtHostUriOpeners,new st.$lnc(Ze)),Zn=Ze.set(i.$_M.ExtHostProfileContentHandlers,new Ae.$1mc(Ze));Ze.set(i.$_M.ExtHostInteractive,new ee.$Omc(Ze,Ct,At,pt,bt));const Yn=Ze.set(i.$_M.ExtHostInlineChat,new Ce.$Bmc(Ze,pt,Rt,bt)),In=Ze.set(i.$_M.ExtHostChatAgents2,new c.$wlc(Ze,bt,pt)),xn=Ze.set(i.$_M.ExtHostChatVariables,new s.$xlc(Ze)),_n=Ze.set(i.$_M.ExtHostAiRelatedInformation,new l.$ilc(Ze)),di=Ze.set(i.$_M.ExtHostAiEmbeddingVector,new ie.$ymc(Ze)),An=Ze.set(i.$_M.ExtHostStatusBar,new Je.$0mc(Ze,pt.converter)),Un=Ze.set(i.$_M.ExtHostSpeech,new Ve.$8mc(Ze)),fi=Object.values(i.$_M);Ze.assertRegistered(fi);const gi=new r.$vlc(Ze,At),ei=new y.$ylc(Ze),Wn=new le.$Rmc(Ze,bt),Rn=new T.$vmc(Ze);return o.$slc.register(pt),function(Ue,fn,Vn){function ot(fe){return(ke,Be,ct)=>{const yt=fe(Ot=>{try{ke.call(Be,Ot)}catch(kn){O.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${kn.toString()}`,{cause:kn})),qt.onExtensionError(Ue.identifier,kn)}});return ct?.push(yt),yt}}const vt=function(){let fe=!Ue.isUnderDevelopment;function ke(){fe||(bt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(ct){if(Array.isArray(ct))ct.forEach(Be);else if(typeof ct=="string")ke();else{const yt=ct;typeof yt.scheme>"u"&&ke(),typeof yt.exclusive=="boolean"&&(0,xe.$PG)(Ue,"documentFiltersExclusive")}return ct}}(),ti={getSession(fe,ke,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,xe.$PG)(Ue,"authLearnMore"),Lt.getSession(Ue,fe,ke,Be)},getSessions(fe,ke){return(0,xe.$PG)(Ue,"authGetSessions"),Lt.getSessions(Ue,fe,ke)},async hasSession(fe,ke){return(0,xe.$PG)(Ue,"authSession"),!!await Lt.getSession(Ue,fe,ke,{silent:!0})},get onDidChangeSessions(){return ot(Lt.onDidChangeSessions)},registerAuthenticationProvider(fe,ke,Be,ct){return Lt.registerAuthenticationProvider(fe,ke,Be,ct)}},$n={registerCommand(fe,ke,Be){return pt.registerCommand(!0,fe,ke,Be,void 0,Ue)},registerTextEditorCommand(fe,ke,Be){return pt.registerCommand(!0,fe,(...ct)=>{const yt=Qe.getActiveTextEditor();if(!yt){bt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return yt.edit(Ot=>{ke.apply(Be,[yt,Ot,...ct])}).then(Ot=>{Ot||bt.warn("Edits from command "+fe+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+fe,Ot)})},void 0,void 0,Ue)},registerDiffInformationCommand:(fe,ke,Be)=>((0,xe.$PG)(Ue,"diffCommand"),pt.registerCommand(!0,fe,async(...ct)=>{const yt=At.activeEditor(!0);if(!yt){bt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Ot=await Qe.getDiffInformation(yt.id);ke.apply(Be,[Ot,...ct])},void 0,void 0,Ue)),executeCommand(fe,...ke){return pt.executeCommand(fe,...ke)},getCommands(fe=!1){return pt.getCommands(fe)}},En={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return ei.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ot(kt.onDidChangeShell)},get isTelemetryEnabled(){return qt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(qt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$PG)(Ue,"telemetry"),qt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$PG)(Ue,"telemetry"),ot(qt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$SP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,ke){return it.$RP.validateSender(fe),qt.instantiateLogger(Ue,fe,ke)},openExternal(fe,ke){return Tt.openUri(fe,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===$t.environment.appUriScheme)return vn.createAppUri(fe);try{return await Tt.asExternalUri(fe,{allowTunneling:!!$t.remote.authority})}catch(ke){if((0,N.$Fg)(fe,N.Schemas.http)||(0,N.$Fg)(fe,N.Schemas.https))return fe;throw ke}},get remoteName(){return(0,f.$Im)($t.remote.authority)},get remoteAuthority(){return(0,xe.$PG)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return ot(bt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$PG)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,xe.$PG)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(En);const mi={createTestController(fe,ke,Be){return yn.createTestController(Ue,fe,ke,Be)},createTestObserver(){return(0,xe.$PG)(Ue,"testObserver"),yn.createTestObserver()},runTests(fe){return(0,xe.$PG)(Ue,"testObserver"),yn.runTests(fe)},get onDidChangeTestResults(){return(0,xe.$PG)(Ue,"testObserver"),ot(yn.onResultsChanged)},get testResults(){return(0,xe.$PG)(Ue,"testObserver"),yn.results}},sn=$t.remote.isRemote?Le.ExtensionKind.Workspace:Le.ExtensionKind.UI,Nn={getExtension(fe,ke){(0,xe.$OG)(Ue,"extensionsAny")||(ke=!1);const Be=fn.mine.getExtensionDescription(fe);if(Be)return new Q.$kmc(jt,Ue.identifier,Be,sn,!1);if(ke){const ct=fn.all.getExtensionDescription(fe);if(ct)return new Q.$kmc(jt,Ue.identifier,ct,sn,!0)}},get all(){const fe=[];for(const ke of fn.mine.getAllExtensionDescriptions())fe.push(new Q.$kmc(jt,Ue.identifier,ke,sn,!1));return fe},get allAcrossExtensionHosts(){(0,xe.$PG)(Ue,"extensionsAny");const fe=new v.$Sm(fn.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ke=[];for(const Be of fn.all.getAllExtensionDescriptions()){const ct=!fe.has(Be.identifier);ke.push(new Q.$kmc(jt,Ue.identifier,Be,sn,ct))}return ke},get onDidChange(){return(0,xe.$OG)(Ue,"extensionsAny")?ot(L.Event.any(fn.mine.onDidChange,fn.all.onDidChange)):ot(fn.mine.onDidChange)}},ni={createDiagnosticCollection(fe){return ht.createDiagnosticCollection(Ue.identifier,fe)},get onDidChangeDiagnostics(){return ot(ht.onDidChangeDiagnostics)},getDiagnostics:fe=>ht.getDiagnostics(fe),getLanguages(){return Et.getLanguages()},setTextDocumentLanguage(fe,ke){return Et.changeLanguage(fe.uri,ke)},match(fe,ke){const Be=He.LanguageSelector.from(fe);let ct;return(0,A.$Yt)(Be)&&(ct=Ct.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Ot=>Ot.document===ke))?.apiNotebook),(0,A.$Xt)(Be,ke.uri,ke.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(fe,ke,Be){return lt.registerCodeActionProvider(Ue,vt(fe),ke,Be)},registerDocumentPasteEditProvider(fe,ke,Be){return(0,xe.$PG)(Ue,"documentPaste"),lt.registerDocumentPasteEditProvider(Ue,vt(fe),ke,Be)},registerCodeLensProvider(fe,ke){return lt.registerCodeLensProvider(Ue,vt(fe),ke)},registerDefinitionProvider(fe,ke){return lt.registerDefinitionProvider(Ue,vt(fe),ke)},registerDeclarationProvider(fe,ke){return lt.registerDeclarationProvider(Ue,vt(fe),ke)},registerImplementationProvider(fe,ke){return lt.registerImplementationProvider(Ue,vt(fe),ke)},registerTypeDefinitionProvider(fe,ke){return lt.registerTypeDefinitionProvider(Ue,vt(fe),ke)},registerHoverProvider(fe,ke){return lt.registerHoverProvider(Ue,vt(fe),ke,Ue.identifier)},registerEvaluatableExpressionProvider(fe,ke){return lt.registerEvaluatableExpressionProvider(Ue,vt(fe),ke,Ue.identifier)},registerInlineValuesProvider(fe,ke){return lt.registerInlineValuesProvider(Ue,vt(fe),ke,Ue.identifier)},registerDocumentHighlightProvider(fe,ke){return lt.registerDocumentHighlightProvider(Ue,vt(fe),ke)},registerMultiDocumentHighlightProvider(fe,ke){return lt.registerMultiDocumentHighlightProvider(Ue,vt(fe),ke)},registerLinkedEditingRangeProvider(fe,ke){return lt.registerLinkedEditingRangeProvider(Ue,vt(fe),ke)},registerReferenceProvider(fe,ke){return lt.registerReferenceProvider(Ue,vt(fe),ke)},registerRenameProvider(fe,ke){return lt.registerRenameProvider(Ue,vt(fe),ke)},registerNewSymbolNamesProvider(fe,ke){return(0,xe.$PG)(Ue,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Ue,vt(fe),ke)},registerDocumentSymbolProvider(fe,ke,Be){return lt.registerDocumentSymbolProvider(Ue,vt(fe),ke,Be)},registerWorkspaceSymbolProvider(fe){return lt.registerWorkspaceSymbolProvider(Ue,fe)},registerDocumentFormattingEditProvider(fe,ke){return lt.registerDocumentFormattingEditProvider(Ue,vt(fe),ke)},registerDocumentRangeFormattingEditProvider(fe,ke){return lt.registerDocumentRangeFormattingEditProvider(Ue,vt(fe),ke)},registerOnTypeFormattingEditProvider(fe,ke,Be,...ct){return lt.registerOnTypeFormattingEditProvider(Ue,vt(fe),ke,[Be].concat(ct))},registerDocumentSemanticTokensProvider(fe,ke,Be){return lt.registerDocumentSemanticTokensProvider(Ue,vt(fe),ke,Be)},registerDocumentRangeSemanticTokensProvider(fe,ke,Be){return lt.registerDocumentRangeSemanticTokensProvider(Ue,vt(fe),ke,Be)},registerSignatureHelpProvider(fe,ke,Be,...ct){return typeof Be=="object"?lt.registerSignatureHelpProvider(Ue,vt(fe),ke,Be):lt.registerSignatureHelpProvider(Ue,vt(fe),ke,typeof Be>"u"?[]:[Be,...ct])},registerCompletionItemProvider(fe,ke,...Be){return lt.registerCompletionItemProvider(Ue,vt(fe),ke,Be)},registerInlineCompletionItemProvider(fe,ke,Be){return ke.handleDidShowCompletionItem&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),Be&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ue,vt(fe),ke,Be)},registerInlineEditProvider(fe,ke){return(0,xe.$PG)(Ue,"inlineEdit"),lt.registerInlineEditProvider(Ue,vt(fe),ke)},registerDocumentLinkProvider(fe,ke){return lt.registerDocumentLinkProvider(Ue,vt(fe),ke)},registerColorProvider(fe,ke){return lt.registerColorProvider(Ue,vt(fe),ke)},registerFoldingRangeProvider(fe,ke){return lt.registerFoldingRangeProvider(Ue,vt(fe),ke)},registerSelectionRangeProvider(fe,ke){return lt.registerSelectionRangeProvider(Ue,fe,ke)},registerCallHierarchyProvider(fe,ke){return lt.registerCallHierarchyProvider(Ue,fe,ke)},registerTypeHierarchyProvider(fe,ke){return lt.registerTypeHierarchyProvider(Ue,fe,ke)},setLanguageConfiguration:(fe,ke)=>lt.setLanguageConfiguration(Ue,fe,ke),getTokenInformationAtPosition(fe,ke){return(0,xe.$PG)(Ue,"tokenInformation"),Et.tokenAtPosition(fe,ke)},registerInlayHintsProvider(fe,ke){return lt.registerInlayHintsProvider(Ue,fe,ke)},createLanguageStatusItem(fe,ke){return Et.createLanguageStatusItem(Ue,fe,ke)},registerDocumentDropEditProvider(fe,ke,Be){return lt.registerDocumentOnDropEditProvider(Ue,fe,ke,(0,xe.$OG)(Ue,"documentPaste")?Be:void 0)}},ii={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(fe,ke,Be){m.URI.isUri(fe)&&fe.scheme===N.Schemas.vscodeRemote&&!fe.authority&&Mt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(m.URI.isUri(fe)?Promise.resolve(qn.openTextDocument(fe)):Promise.resolve(fe));return Qe.showTextDocument(ct,ke,Be)},createTextEditorDecorationType(fe){return Qe.createTextEditorDecorationType(Ue,fe)},onDidChangeActiveTextEditor(fe,ke,Be){return ot(Qe.onDidChangeActiveTextEditor)(fe,ke,Be)},onDidChangeVisibleTextEditors(fe,ke,Be){return ot(Qe.onDidChangeVisibleTextEditors)(fe,ke,Be)},onDidChangeTextEditorSelection(fe,ke,Be){return ot(Qe.onDidChangeTextEditorSelection)(fe,ke,Be)},onDidChangeTextEditorOptions(fe,ke,Be){return ot(Qe.onDidChangeTextEditorOptions)(fe,ke,Be)},onDidChangeTextEditorVisibleRanges(fe,ke,Be){return ot(Qe.onDidChangeTextEditorVisibleRanges)(fe,ke,Be)},onDidChangeTextEditorViewColumn(fe,ke,Be){return ot(Qe.onDidChangeTextEditorViewColumn)(fe,ke,Be)},onDidCloseTerminal(fe,ke,Be){return ot(kt.onDidCloseTerminal)(fe,ke,Be)},onDidOpenTerminal(fe,ke,Be){return ot(kt.onDidOpenTerminal)(fe,ke,Be)},onDidChangeActiveTerminal(fe,ke,Be){return ot(kt.onDidChangeActiveTerminal)(fe,ke,Be)},onDidChangeTerminalDimensions(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalDimensions"),ot(kt.onDidChangeTerminalDimensions)(fe,ke,Be)},onDidChangeTerminalState(fe,ke,Be){return ot(kt.onDidChangeTerminalState)(fe,ke,Be)},onDidWriteTerminalData(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalDataWriteEvent"),ot(kt.onDidWriteTerminalData)(fe,ke,Be)},onDidExecuteTerminalCommand(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalExecuteCommandEvent"),ot(kt.onDidExecuteTerminalCommand)(fe,ke,Be)},onDidChangeTerminalShellIntegration(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),ot(un.onDidChangeTerminalShellIntegration)(fe,ke,Be)},onDidStartTerminalShellExecution(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),ot(un.onDidStartTerminalShellExecution)(fe,ke,Be)},onDidEndTerminalShellExecution(fe,ke,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),ot(un.onDidEndTerminalShellExecution)(fe,ke,Be)},get state(){return Tt.getState()},onDidChangeWindowState(fe,ke,Be){return ot(Tt.onDidChangeWindowState)(fe,ke,Be)},showInformationMessage(fe,...ke){return Wn.showMessage(Ue,p.default.Info,fe,ke[0],ke.slice(1))},showWarningMessage(fe,...ke){return Wn.showMessage(Ue,p.default.Warning,fe,ke[0],ke.slice(1))},showErrorMessage(fe,...ke){return Wn.showMessage(Ue,p.default.Error,fe,ke[0],ke.slice(1))},showQuickPick(fe,ke,Be){return Qt.showQuickPick(Ue,fe,ke,Be)},showWorkspaceFolderPick(fe){return Qt.showWorkspaceFolderPick(fe)},showInputBox(fe,ke){return Qt.showInput(fe,ke)},showOpenDialog(fe){return Rn.showOpenDialog(Ue,fe)},showSaveDialog(fe){return Rn.showSaveDialog(fe)},createStatusBarItem(fe,ke,Be){let ct,yt,Ot;return typeof fe=="string"?(ct=fe,yt=ke,Ot=Be):(yt=fe,Ot=ke),An.createStatusBarEntry(Ue,ct,yt,Ot)},setStatusBarMessage(fe,ke){return An.setStatusBarMessage(fe,ke)},withScmProgress(fe){return Mt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Pn.withProgress(Ue,{location:Le.ProgressLocation.SourceControl},(ke,Be)=>fe({report(ct){}}))},withProgress(fe,ke){return Pn.withProgress(Ue,fe,ke)},createOutputChannel(fe,ke){return wn.createOutputChannel(fe,ke,Ue)},createWebviewPanel(fe,ke,Be,ct){return Cn.createWebviewPanel(Ue,fe,ke,Be,ct)},createWebviewTextEditorInset(fe,ke,Be,ct){return(0,xe.$PG)(Ue,"editorInsets"),Ke.createWebviewEditorInset(fe,ke,Be,ct,Ue)},createTerminal(fe,ke,Be){return typeof fe=="object"?"pty"in fe?kt.createExtensionTerminal(fe):kt.createTerminalFromOptions(fe):kt.createTerminal(fe,ke,Be)},registerTerminalLinkProvider(fe){return kt.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,ke){return kt.registerProfileProvider(Ue,fe,ke)},registerTerminalQuickFixProvider(fe,ke){return(0,xe.$PG)(Ue,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(fe,Ue.identifier.value,ke)},registerTreeDataProvider(fe,ke){return Ye.registerTreeDataProvider(fe,ke,Ue)},createTreeView(fe,ke){return Ye.createTreeView(fe,ke,Ue)},registerWebviewPanelSerializer:(fe,ke)=>Cn.registerWebviewPanelSerializer(Ue,fe,ke),registerCustomEditorProvider:(fe,ke,Be={})=>zn.registerCustomEditorProvider(Ue,fe,ke,Be),registerFileDecorationProvider(fe){return Bt.registerFileDecorationProvider(fe,Ue)},registerUriHandler(fe){return vn.registerUriHandler(Ue,fe)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return Fn.activeColorTheme},onDidChangeActiveColorTheme(fe,ke,Be){return ot(Fn.onDidChangeActiveColorTheme)(fe,ke,Be)},registerWebviewViewProvider(fe,ke,Be){return Bn.registerWebviewViewProvider(Ue,fe,ke,Be?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,ke,Be){return ot(Ct.onDidChangeActiveNotebookEditor)(fe,ke,Be)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,ke,Be){return ot(je.onDidChangeNotebookEditorSelection)(fe,ke,Be)},onDidChangeNotebookEditorVisibleRanges(fe,ke,Be){return ot(je.onDidChangeNotebookEditorVisibleRanges)(fe,ke,Be)},showNotebookDocument(fe,ke){return Ct.showNotebookDocument(fe,ke)},registerExternalUriOpener(fe,ke,Be){return(0,xe.$PG)(Ue,"externalUriOpener"),Xn.registerExternalUriOpener(Ue.identifier,fe,ke,Be)},registerProfileContentHandler(fe,ke){return(0,xe.$PG)(Ue,"profileContentHandlers"),Zn.registerProfileContentHandler(Ue,fe,ke)},registerQuickDiffProvider(fe,ke,Be,ct){return(0,xe.$PG)(Ue,"quickDiffProvider"),Jn.registerQuickDiffProvider(vt(fe),ke,Be,ct)},get tabGroups(){return Gt.tabGroups},registerShareProvider(fe,ke){return(0,xe.$PG)(Ue,"shareProvider"),On.registerShareProvider(vt(fe),ke)}},qn={get rootPath(){return Mt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(fe){throw new O.$9("rootPath")},getWorkspaceFolder(fe){return gt.getWorkspaceFolder(fe)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(fe){throw new O.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(fe){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(fe,ke,...Be)=>gt.updateWorkspaceFolders(Ue,fe,ke||0,...Be),onDidChangeWorkspaceFolders:function(fe,ke,Be){return ot(gt.onDidChangeWorkspace)(fe,ke,Be)},asRelativePath:(fe,ke)=>gt.getRelativePath(fe,ke),findFiles:(fe,ke,Be,ct)=>gt.findFiles(fe,ke,Be,Ue.identifier,ct),findFiles2:(fe,ke,Be)=>((0,xe.$PG)(Ue,"findFiles2"),gt.findFiles2(fe,ke,Ue.identifier,Be)),findTextInFiles:(fe,ke,Be,ct)=>{(0,xe.$PG)(Ue,"findTextInFiles");let yt,Ot;return typeof ke=="object"?(yt=ke,Ot=Be):(yt={},Ot=ke,ct=Be),gt.findTextInFiles(fe,yt||{},Ot,Ue.identifier,ct)},save:fe=>gt.save(fe),saveAs:fe=>gt.saveAs(fe),saveAll:fe=>gt.saveAll(fe),applyEdit(fe,ke){return gi.applyWorkspaceEdit(fe,Ue,ke)},createFileSystemWatcher:(fe,ke,Be,ct)=>{let yt;return typeof ke=="boolean"?yt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ct,correlate:!1}:ke&&((0,xe.$PG)(Ue,"createFileSystemWatcher"),yt={...ke,correlate:!0}),Nt.createFileSystemWatcher(gt,Ue,fe,yt)},get textDocuments(){return Rt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new O.$9("textDocuments")},openTextDocument(fe){let ke;const Be=fe;if(typeof fe=="string")ke=Promise.resolve(m.URI.file(fe));else if(m.URI.isUri(fe))ke=Promise.resolve(fe);else if(!Be||typeof Be=="object")ke=Rt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(ct=>(ct.scheme===N.Schemas.vscodeRemote&&!ct.authority&&Mt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(fe,ke,Be)=>ot(Rt.onDidAddDocument)(fe,ke,Be),onDidCloseTextDocument:(fe,ke,Be)=>ot(Rt.onDidRemoveDocument)(fe,ke,Be),onDidChangeTextDocument:(fe,ke,Be)=>ot(Rt.onDidChangeDocument)(fe,ke,Be),onDidSaveTextDocument:(fe,ke,Be)=>ot(Rt.onDidSaveDocument)(fe,ke,Be),onWillSaveTextDocument:(fe,ke,Be)=>ot(nn.getOnWillSaveTextDocumentEvent(Ue))(fe,ke,Be),get notebookDocuments(){return Ct.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,ke){let Be;if(m.URI.isUri(fe))Be=fe,await Ct.openNotebookDocument(fe);else if(typeof fe=="string")Be=m.URI.revive(await Ct.createNotebookDocument({viewType:fe,content:ke}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,ke,Be){return ot(Oe.onDidSaveNotebookDocument)(fe,ke,Be)},onDidChangeNotebookDocument(fe,ke,Be){return ot(Oe.onDidChangeNotebookDocument)(fe,ke,Be)},onWillSaveNotebookDocument(fe,ke,Be){return ot(Te.getOnWillSaveNotebookDocumentEvent(Ue))(fe,ke,Be)},get onDidOpenNotebookDocument(){return ot(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,ke,Be,ct){return Ct.registerNotebookSerializer(Ue,fe,ke,Be,(0,xe.$OG)(Ue,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(fe,ke,Be)=>ot(Vn.onDidChangeConfiguration)(fe,ke,Be),getConfiguration(fe,ke){return ke=arguments.length===1?void 0:ke,Vn.getConfiguration(fe,ke,Ue)},registerTextDocumentContentProvider(fe,ke){return Sn.registerTextDocumentContentProvider(fe,ke)},registerTaskProvider:(fe,ke)=>(Mt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),tn.registerTaskProvider(Ue,fe,ke)),registerFileSystemProvider(fe,ke,Be){return(0,R.$Rc)(rn.registerFileSystemProvider(Ue,fe,ke,Be),Xt.addFileSystemProvider(fe,ke,Be))},get fs(){return Xt.value},registerFileSearchProvider:(fe,ke)=>((0,xe.$PG)(Ue,"fileSearchProvider"),mn.registerFileSearchProvider(fe,ke)),registerTextSearchProvider:(fe,ke)=>((0,xe.$PG)(Ue,"textSearchProvider"),mn.registerTextSearchProvider(fe,ke)),registerAITextSearchProvider:(fe,ke)=>((0,xe.$PG)(Ue,"aiTextSearchProvider"),(0,xe.$PG)(Ue,"textSearchProvider"),mn.registerAITextSearchProvider(fe,ke)),registerRemoteAuthorityResolver:(fe,ke)=>((0,xe.$PG)(Ue,"resolvers"),jt.registerRemoteAuthorityResolver(fe,ke)),registerResourceLabelFormatter:fe=>((0,xe.$PG)(Ue,"resolvers"),Tn.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,xe.$PG)(Ue,"resolvers"),jt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,ke,Be)=>ot(Nt.onDidCreateFile)(fe,ke,Be),onDidDeleteFiles:(fe,ke,Be)=>ot(Nt.onDidDeleteFile)(fe,ke,Be),onDidRenameFiles:(fe,ke,Be)=>ot(Nt.onDidRenameFile)(fe,ke,Be),onWillCreateFiles:(fe,ke,Be)=>ot(Nt.getOnWillCreateFileEvent(Ue))(fe,ke,Be),onWillDeleteFiles:(fe,ke,Be)=>ot(Nt.getOnWillDeleteFileEvent(Ue))(fe,ke,Be),onWillRenameFiles:(fe,ke,Be)=>ot(Nt.getOnWillRenameFileEvent(Ue))(fe,ke,Be),openTunnel:fe=>((0,xe.$PG)(Ue,"tunnels"),zt.openTunnel(Ue,fe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,xe.$PG)(Ue,"tunnels"),zt.getTunnels()},onDidChangeTunnels:(fe,ke,Be)=>((0,xe.$PG)(Ue,"tunnels"),ot(zt.onDidChangeTunnels)(fe,ke,Be)),registerPortAttributesProvider:(fe,ke)=>((0,xe.$PG)(Ue,"portsAttributes"),zt.registerPortsAttributesProvider(fe,ke)),registerTunnelProvider:(fe,ke)=>((0,xe.$PG)(Ue,"tunnelFactory"),zt.registerTunnelProvider(fe,ke)),registerTimelineProvider:(fe,ke)=>((0,xe.$PG)(Ue,"timeline"),Kn.registerTimelineProvider(fe,ke,Ue.identifier,pt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:fe=>((0,xe.$PG)(Ue,"workspaceTrust"),gt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,ke,Be)=>ot(gt.onDidGrantWorkspaceTrust)(fe,ke,Be),registerEditSessionIdentityProvider:(fe,ke)=>((0,xe.$PG)(Ue,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(fe,ke)),onWillCreateEditSessionIdentity:(fe,ke,Be)=>((0,xe.$PG)(Ue,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Ue))(fe,ke,Be)),registerCanonicalUriProvider:(fe,ke)=>((0,xe.$PG)(Ue,"canonicalUriProvider"),gt.registerCanonicalUriProvider(fe,ke)),getCanonicalUri:(fe,ke,Be)=>((0,xe.$PG)(Ue,"canonicalUriProvider"),gt.provideCanonicalUri(fe,ke,Be))},ri={get inputBox(){return Mt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Dn.getLastInputBox(Ue)},createSourceControl(fe,ke,Be){return Dn.createSourceControl(Ue,fe,ke,Be)}},$i={createCommentController(fe,ke){return Mn.createCommentController(Ue,fe,ke)}},si={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){if((0,xe.$OG)(Ue,"debugFocus"))return Pt.activeStackItem},registerDebugVisualizationProvider(fe,ke){return(0,xe.$PG)(Ue,"debugVisualization"),Pt.registerDebugVisualizationProvider(Ue,fe,ke)},registerDebugVisualizationTreeProvider(fe,ke){return(0,xe.$PG)(Ue,"debugVisualization"),Pt.registerDebugVisualizationTree(Ue,fe,ke)},onDidStartDebugSession(fe,ke,Be){return ot(Pt.onDidStartDebugSession)(fe,ke,Be)},onDidTerminateDebugSession(fe,ke,Be){return ot(Pt.onDidTerminateDebugSession)(fe,ke,Be)},onDidChangeActiveDebugSession(fe,ke,Be){return ot(Pt.onDidChangeActiveDebugSession)(fe,ke,Be)},onDidReceiveDebugSessionCustomEvent(fe,ke,Be){return ot(Pt.onDidReceiveDebugSessionCustomEvent)(fe,ke,Be)},onDidChangeBreakpoints(fe,ke,Be){return ot(Pt.onDidChangeBreakpoints)(fe,ke,Be)},onDidChangeActiveStackItem(fe,ke,Be){return(0,xe.$PG)(Ue,"debugFocus"),ot(Pt.onDidChangeActiveStackItem)(fe,ke,Be)},registerDebugConfigurationProvider(fe,ke,Be){return Pt.registerDebugConfigurationProvider(fe,ke,Be||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,ke){return Pt.registerDebugAdapterDescriptorFactory(Ue,fe,ke)},registerDebugAdapterTrackerFactory(fe,ke){return Pt.registerDebugAdapterTrackerFactory(fe,ke)},startDebugging(fe,ke,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Pt.startDebugging(fe,ke,{parentSession:Be}):Pt.startDebugging(fe,ke,Be||{})},stopDebugging(fe){return Pt.stopDebugging(fe)},addBreakpoints(fe){return Pt.addBreakpoints(fe)},removeBreakpoints(fe){return Pt.removeBreakpoints(fe)},asDebugSourceUri(fe,ke){return Pt.asDebugSourceUri(fe,ke)}},oi={registerTaskProvider:(fe,ke)=>tn.registerTaskProvider(Ue,fe,ke),fetchTasks:fe=>tn.fetchTasks(fe),executeTask:fe=>tn.executeTask(Ue,fe),get taskExecutions(){return tn.taskExecutions},onDidStartTask:(fe,ke,Be)=>ot(tn.onDidStartTask)(fe,ke,Be),onDidEndTask:(fe,ke,Be)=>ot(tn.onDidEndTask)(fe,ke,Be),onDidStartTaskProcess:(fe,ke,Be)=>ot(tn.onDidStartTaskProcess)(fe,ke,Be),onDidEndTaskProcess:(fe,ke,Be)=>ot(tn.onDidEndTaskProcess)(fe,ke,Be)},pi={createNotebookController(fe,ke,Be,ct,yt){return Ee.createNotebookController(Ue,fe,ke,Be,ct,(0,xe.$OG)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,ke)=>Ct.registerNotebookCellStatusBarItemProvider(Ue,fe,ke),createRendererMessaging(fe){return Y.createRendererMessaging(Ue,fe)},createNotebookControllerDetectionTask(fe){return(0,xe.$PG)(Ue,"notebookKernelSource"),Ee.createNotebookControllerDetectionTask(Ue,fe)},registerKernelSourceActionProvider(fe,ke){return(0,xe.$PG)(Ue,"notebookKernelSource"),Ee.registerKernelSourceActionProvider(Ue,fe,ke)},onDidChangeNotebookCellExecutionState(fe,ke,Be){return(0,xe.$PG)(Ue,"notebookCellExecutionState"),ot(Ee.onDidChangeNotebookCellExecutionState)(fe,ke,Be)}},bi={t(...fe){if(typeof fe[0]=="string"){const ke=fe.shift(),Be=!fe||typeof fe[0]!="object"?fe:fe[0];return ln.getMessage(Ue.identifier.value,{message:ke,args:Be})}return ln.getMessage(Ue.identifier.value,fe[0])},get bundle(){return ln.getBundle(Ue.identifier.value)},get uri(){return ln.getBundleUri(Ue.identifier.value)}},ai={_version:1,registerInteractiveEditorSessionProvider(fe,ke){return(0,xe.$PG)(Ue,"interactive"),Yn.registerProvider(Ue,fe,ke)},transferActiveChat(fe){return(0,xe.$PG)(Ue,"interactive"),In.transferActiveChat(fe)}},Qn={getRelatedInformation(fe,ke){return(0,xe.$PG)(Ue,"aiRelatedInformation"),_n.getRelatedInformation(Ue,fe,ke)},registerRelatedInformationProvider(fe,ke){return(0,xe.$PG)(Ue,"aiRelatedInformation"),_n.registerRelatedInformationProvider(Ue,fe,ke)},registerEmbeddingVectorProvider(fe,ke){return(0,xe.$PG)(Ue,"aiRelatedInformation"),di.registerEmbeddingVectorProvider(Ue,fe,ke)}},ci={registerChatResponseProvider(fe,ke,Be){return(0,xe.$PG)(Ue,"chatProvider"),Ft.registerLanguageModel(Ue,fe,ke,Be)},registerChatVariableResolver(fe,ke,Be){return(0,xe.$PG)(Ue,"chatVariableResolver"),xn.registerVariableResolver(Ue,fe,ke,Be)},registerMappedEditsProvider(fe,ke){return(0,xe.$PG)(Ue,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ue,fe,ke)},createChatParticipant(fe,ke){return(0,xe.$PG)(Ue,"chatParticipant"),In.createChatAgent(Ue,fe,ke)},createDynamicChatParticipant(fe,ke,Be,ct){return(0,xe.$PG)(Ue,"chatParticipantAdditions"),In.createDynamicChatAgent(Ue,fe,ke,Be,ct)}},ui={get languageModels(){return(0,xe.$PG)(Ue,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:(fe,ke,Be)=>((0,xe.$PG)(Ue,"languageModels"),Ft.onDidChangeProviders(fe,ke,Be)),sendChatRequest(fe,ke,Be,ct){return(0,xe.$PG)(Ue,"languageModels"),Ft.sendChatRequest(Ue,fe,ke,Be,ct)},computeTokenLength(fe,ke,Be){return(0,xe.$PG)(Ue,"languageModels"),Be??=d.CancellationToken.None,Ft.computeTokenLength(fe,ke,Be)},getLanguageModelInformation(fe){return(0,xe.$PG)(Ue,"languageModels"),Ft.getLanguageModelInfo(fe)}},li={registerSpeechProvider(fe,ke){return(0,xe.$PG)(Ue,"speech"),Un.registerProvider(Ue.identifier,fe,ke)}};return{version:$t.version,ai:Qn,authentication:ti,commands:$n,comments:$i,chat:ci,debug:si,env:En,extensions:Nn,interactive:ai,l10n:bi,languages:ni,lm:ui,notebooks:pi,scm:ri,speech:li,tasks:oi,tests:mi,window:ii,workspace:qn,Breakpoint:Le.$bO,TerminalOutputAnchor:Le.TerminalOutputAnchor,ChatResultFeedbackKind:Le.ChatResultFeedbackKind,ChatVariableLevel:Le.ChatVariableLevel,ChatCompletionItem:Le.$9O,CallHierarchyIncomingCall:Le.$zN,CallHierarchyItem:Le.$yN,CallHierarchyOutgoingCall:Le.$AN,CancellationError:O.$5,CancellationTokenSource:d.$oe,CandidatePortSource:i.CandidatePortSource,CodeAction:Le.$vN,CodeActionKind:Le.$wN,CodeActionTriggerKind:Le.CodeActionTriggerKind,CodeLens:Le.$BN,Color:Le.$ON,ColorInformation:Le.$PN,ColorPresentation:Le.$QN,ColorThemeKind:Le.ColorThemeKind,CommentMode:Le.CommentMode,CommentState:Le.CommentState,CommentThreadCollapsibleState:Le.CommentThreadCollapsibleState,CommentThreadState:Le.CommentThreadState,CommentThreadApplicability:Le.CommentThreadApplicability,CompletionItem:Le.$IN,CompletionItemKind:Le.CompletionItemKind,CompletionItemTag:Le.CompletionItemTag,CompletionList:Le.$JN,CompletionTriggerKind:Le.CompletionTriggerKind,ConfigurationTarget:Le.ConfigurationTarget,CustomExecution:Le.$YN,DebugAdapterExecutable:Le.$fO,DebugAdapterInlineImplementation:Le.$iO,DebugAdapterNamedPipeServer:Le.$hO,DebugAdapterServer:Le.$gO,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Le.DebugConsoleMode,DebugVisualization:Le.$yO,DecorationRangeBehavior:Le.DecorationRangeBehavior,Diagnostic:Le.$oN,DiagnosticRelatedInformation:Le.$nN,DiagnosticSeverity:Le.DiagnosticSeverity,DiagnosticTag:Le.DiagnosticTag,Disposable:Le.$aN,DocumentHighlight:Le.$rN,DocumentHighlightKind:Le.DocumentHighlightKind,MultiDocumentHighlight:Le.$sN,DocumentLink:Le.$NN,DocumentSymbol:Le.$uN,EndOfLine:Le.EndOfLine,EnvironmentVariableMutatorType:Le.EnvironmentVariableMutatorType,EvaluatableExpression:Le.$lO,InlineValueText:Le.$mO,InlineValueVariableLookup:Le.$nO,InlineValueEvaluatableExpression:Le.$oO,InlineCompletionTriggerKind:Le.InlineCompletionTriggerKind,EventEmitter:L.$de,ExtensionKind:Le.ExtensionKind,ExtensionMode:Le.ExtensionMode,ExternalUriOpenerPriority:Le.ExternalUriOpenerPriority,FileChangeType:Le.FileChangeType,FileDecoration:Le.$AO,FileDecoration2:Le.$AO,FileSystemError:Le.$rO,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Le.$sO,FoldingRangeKind:Le.FoldingRangeKind,FunctionBreakpoint:Le.$dO,InlineCompletionItem:Le.$KN,InlineCompletionList:Le.$LN,Hover:Le.$pN,VerboseHover:Le.$qN,HoverVerbosityAction:Le.HoverVerbosityAction,IndentAction:C.IndentAction,Location:Le.$mN,MarkdownString:Le.$CN,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Le.$DN,PortAutoForwardAction:Le.PortAutoForwardAction,Position:Le.$bN,ProcessExecution:Le.$WN,ProgressLocation:Le.ProgressLocation,QuickInputButtons:Le.$zO,Range:Le.$cN,RelativePattern:Le.$_N,Selection:Le.$dN,SelectionRange:Le.$xN,SemanticTokens:Le.$vO,SemanticTokensBuilder:Le.$uO,SemanticTokensEdit:Le.$wO,SemanticTokensEdits:Le.$xO,SemanticTokensLegend:Le.$tO,ShellExecution:Le.$XN,ShellQuoting:Le.ShellQuoting,SignatureHelp:Le.$FN,SignatureHelpTriggerKind:Le.SignatureHelpTriggerKind,SignatureInformation:Le.$EN,SnippetString:Le.$lN,SourceBreakpoint:Le.$cO,StandardTokenType:Le.StandardTokenType,StatusBarAlignment:Le.StatusBarAlignment,SymbolInformation:Le.$tN,SymbolKind:Le.SymbolKind,SymbolTag:Le.SymbolTag,Task:Le.$ZN,TaskGroup:Le.$VN,TaskPanelKind:Le.TaskPanelKind,TaskRevealKind:Le.TaskRevealKind,TaskScope:Le.TaskScope,TerminalLink:Le.$RN,TerminalQuickFixTerminalCommand:Le.$TN,TerminalQuickFixOpener:Le.$SN,TerminalLocation:Le.TerminalLocation,TerminalProfile:Le.$UN,TerminalExitReason:Le.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Le.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Le.TextDocumentSaveReason,TextEdit:Le.$hN,SnippetTextEdit:Le.$jN,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Le.TextEditorLineNumbersStyle,TextEditorRevealType:Le.TextEditorRevealType,TextEditorSelectionChangeKind:Le.TextEditorSelectionChangeKind,SyntaxTokenType:Le.SyntaxTokenType,TextDocumentChangeReason:Le.TextDocumentChangeReason,ThemeColor:Le.$$N,ThemeIcon:Le.$0N,TreeItem:Le.$1N,TreeItemCheckboxState:Le.TreeItemCheckboxState,TreeItemCollapsibleState:Le.TreeItemCollapsibleState,TypeHierarchyItem:Le.$WO,UIKind:xt.UIKind,Uri:m.URI,ViewColumn:Le.ViewColumn,WorkspaceEdit:Le.$kN,DocumentPasteTriggerKind:Le.DocumentPasteTriggerKind,DocumentDropEdit:Le.$7N,DocumentDropOrPasteEditKind:Le.$8N,DocumentPasteEdit:Le.$9N,InlayHint:Le.$HN,InlayHintLabelPart:Le.$GN,InlayHintKind:Le.InlayHintKind,RemoteAuthorityResolverError:Le.$gN,ResolvedAuthority:Le.$eN,ManagedResolvedAuthority:Le.$fN,SourceControlInputBoxValidationType:Le.SourceControlInputBoxValidationType,ExtensionRuntime:Le.ExtensionRuntime,TimelineItem:Le.$KO,NotebookRange:Le.$CO,NotebookCellKind:Le.NotebookCellKind,NotebookCellExecutionState:Le.NotebookCellExecutionState,NotebookCellData:Le.$DO,NotebookData:Le.$EO,NotebookRendererScript:Le.$IO,NotebookCellStatusBarAlignment:Le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Le.NotebookEditorRevealType,NotebookCellOutput:Le.$GO,NotebookCellOutputItem:Le.$FO,NotebookCellStatusBarItem:Le.$HO,NotebookControllerAffinity:Le.NotebookControllerAffinity,NotebookControllerAffinity2:Le.NotebookControllerAffinity2,NotebookEdit:Le.$iN,NotebookKernelSourceAction:Le.$JO,NotebookVariablesRequestKind:Le.NotebookVariablesRequestKind,PortAttributes:Le.$MO,LinkedEditingRanges:Le.$LO,TestResultState:Le.TestResultState,TestRunRequest:Le.$NO,TestRunRequest2:Le.$NO,TestMessage:Le.$OO,TestTag:Le.$PO,TestRunProfileKind:Le.TestRunProfileKind,TextSearchCompleteMessageType:cn.TextSearchCompleteMessageType,DataTransfer:Le.$6N,DataTransferItem:Le.$2N,TestCoverageCount:Le.$QO,FileCoverage:Le.$SO,StatementCoverage:Le.$TO,BranchCoverage:Le.$UO,DeclarationCoverage:Le.$VO,WorkspaceTrustState:Le.WorkspaceTrustState,LanguageStatusSeverity:Le.LanguageStatusSeverity,QuickPickItemKind:Le.QuickPickItemKind,InputBoxValidationSeverity:Le.InputBoxValidationSeverity,TabInputText:Le.$XO,TabInputTextDiff:Le.$YO,TabInputTextMerge:Le.$ZO,TabInputCustom:Le.$1O,TabInputNotebook:Le.$3O,TabInputNotebookDiff:Le.$4O,TabInputWebview:Le.$2O,TabInputTerminal:Le.$5O,TabInputInteractiveWindow:Le.$6O,TabInputChat:Le.$7O,TabInputTextMultiDiff:Le.$8O,TelemetryTrustedValue:a.$fp,LogLevel:h.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Le.InteractiveSessionVoteDirection,ChatCopyKind:Le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Le.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Le.$jO,DebugThread:Le.$kO,RelatedInformationType:Le.RelatedInformationType,SpeechToTextStatus:Le.SpeechToTextStatus,TextToSpeechStatus:Le.TextToSpeechStatus,PartialAcceptTriggerKind:Le.PartialAcceptTriggerKind,KeywordRecognitionStatus:Le.KeywordRecognitionStatus,ChatResponseMarkdownPart:Le.$0O,ChatResponseFileTreePart:Le.$aP,ChatResponseAnchorPart:Le.$bP,ChatResponseProgressPart:Le.$cP,ChatResponseReferencePart:Le.$fP,ChatResponseWarningPart:Le.$dP,ChatResponseTextEditPart:Le.$gP,ChatResponseMarkdownWithVulnerabilitiesPart:Le.$$O,ChatResponseCommandButtonPart:Le.$eP,ChatResponseDetectedParticipantPart:Le.$_O,ChatRequestTurn:Le.$hP,ChatResponseTurn:Le.$iP,ChatLocation:Le.ChatLocation,LanguageModelChatSystemMessage:Le.$jP,LanguageModelChatUserMessage:Le.$kP,LanguageModelChatAssistantMessage:Le.$lP,LanguageModelSystemMessage:Le.$jP,LanguageModelUserMessage:Le.$kP,LanguageModelAssistantMessage:Le.$lP,LanguageModelError:Le.$mP,NewSymbolName:Le.$qO,NewSymbolNameTag:Le.NewSymbolNameTag,NewSymbolNameTriggerKind:Le.NewSymbolNameTriggerKind,InlineEdit:Le.$nP,InlineEditTriggerKind:Le.InlineEditTriggerKind}}}}),define(Se[385],De([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u,r,c,s,y,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$xs)(c.$emc,c.$dmc,1),(0,d.$xs)(u.$4j,t.$rnc,1),(0,d.$xs)(h.$jlc,h.$klc,1),(0,d.$xs)(p.$VP,p.$UP,0),(0,d.$xs)(y.$tlc,y.$ulc,0),(0,d.$xs)(b.$$lc,b.$_lc,0),(0,d.$xs)(N.$Ilc,N.$Glc,0),(0,d.$xs)(a.$Klc,a.$Jlc,0),(0,d.$xs)(C.$omc,C.$smc,0),(0,d.$xs)(R.$umc,R.$tmc,0),(0,d.$xs)(m.$KP,m.$JP,0),(0,d.$xs)(s.$fmc,s.$gmc,0),(0,d.$xs)(n.$nlc,n.$mlc,0),(0,d.$xs)(O.$Zmc,O.$Ymc,1),(0,d.$xs)($.$Kmc,$.$Lmc,0),(0,d.$xs)(v.$4lc,v.$3lc,0),(0,d.$xs)(A.$anc,A.$_mc,0),(0,d.$xs)(k.$7lc,k.$0lc,0),(0,d.$xs)(S.$bnc,S.$cnc,0),(0,d.$xs)(w.$sDb,w.$tDb,0),(0,d.$xs)(f.$pnc,f.$onc,0),(0,d.$xs)(L.$Flc,L.$Elc,0),(0,d.$xs)(i.$bmc,i.$amc,0),(0,d.$xs)(l.$TP,l.$QP,0),(0,d.$xs)(o.$Ulc,o.$Vlc,0),(0,d.$xs)(r.$mmc,r.$nmc,0)}),define(Se[123],De([1,0,19,11,37,94]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0,e.$Hnc=N,e.$Inc=p;function N(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}function p(C,$,v,w){const h=(0,d.$1b)(v,m),f=new L.$qL($,h,w),a=f.preview.matches;return{ranges:(0,d.$1b)(h,k),uri:C,preview:{text:f.preview.text,matches:(0,d.$1b)(a,k)}}}function m(C){return new L.$rL(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new R.$fL(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor($,v){this.a=$,this.b=v}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$Jnc=A,e.$Jnc=A=Ge([We(1,O.$3j)],A)}),define(Se[386],De([1,0,54,17,77,31,12,14,123,387]),function(he,e,d,O,L,R,N,p,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=C,e.$Lnc=f,e.$Mnc=n;const A=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(i,l,o,t){const u=$(i,l,o,t),r=l.folder.fsPath;return{cmd:d.spawn(A,u.args,{cwd:r}),rgDiskPath:A,siblingClauses:u.siblingClauses,rgArgs:u,cwd:r}}function $(i,l,o,t){const u=["--files","--hidden","--case-sensitive","--no-require-git"];w([l],o,!1).forEach(c=>{const s=(0,m.$Hnc)(c);if(u.push("-g",s),N.$j){const y=(0,L.$cm)(s);y!==s&&u.push("-g",y)}});const r=v([l],t,void 0,!1);return r.globArgs.forEach(c=>{const s=`!${(0,m.$Hnc)(c)}`;if(u.push("-g",s),N.$j){const y=(0,L.$cm)(s);y!==s&&u.push("-g",y)}}),l.disregardIgnoreFiles!==!1?u.push("--no-ignore"):l.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),l.ignoreSymlinks||u.push("--follow"),i.exists&&u.push("--quiet"),u.push("--no-config"),l.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:r.siblingClauses}}function v(i,l,o,t=!0){const u=[];let r={};return i.forEach(c=>{const s=Object.assign({},c.excludePattern||{},l||{}),y=h(s,t?c.folder.fsPath:void 0,o);u.push(...y.globArgs),y.siblingClauses&&(r=Object.assign(r,y.siblingClauses))}),{globArgs:u,siblingClauses:r}}function w(i,l,o=!0){const t=[];return i.forEach(u=>{const r=Object.assign({},l||{},u.includePattern||{}),c=h(r,o?u.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function h(i,l,o){const t=[],u={};return Object.keys(i).forEach(r=>{if(o&&o.has(r)||!r)return;const c=i[r];r=a(l?f(l,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),t.push(n(r))):c&&c.when&&(u[r]=c)}),{globArgs:t,siblingClauses:u}}function f(i,l){return O.$ic(l)?l:O.$jc(i,l)}function a(i){return i=p.$ff(i,"\\"),p.$ff(i,"/")}function n(i){return R.$rg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Se[388],De([1,0,54,53,17,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=e.$Nnc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(r=>r())});class l{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&m.$qk(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=c.shouldGlobMatchFilePattern?null:(0,n.$xr)(this.b).normalizedLowercase),this.u=c.excludePattern&&m.$qk(c.excludePattern),this.t=new Map,c.folderQueries.forEach(s=>{const y=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),b=s.folder.fsPath;c.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==b).forEach(S=>{(0,A.$vg)(S,b)&&(y[L.$lc(b,S)]=!0)}),this.t.set(b,new t(y,b))})}cancel(){this.l=!0,i.forEach(c=>c())}walk(c,s,y,b,S){if(this.m=$.$_d.create(!1),this.l)return S(null,this.j);s.forEach(g=>{const E=L.$nc(g.fsPath);this.u&&this.u(g.fsPath,E)||this.J(y,{relativePath:g.fsPath,searchPath:void 0})}),this.r=$.$_d.create(!1),this.w(c,(g,E)=>{this.x(this.y,this,g,y,b,D=>{if(D){const P=(0,p.$hj)(D);console.error(P),this.q.push(P),E(D,void 0)}else E(null,void 0)})},(g,E)=>{this.m.stop();const D=g?N.$Hb(g)[0]:null;S(D,this.j)})}w(c,s,y){const b=new Array(c.length),S=new Array(c.length);let g=!1,E=0;if(c.length===0)return y(null,[]);c.forEach((D,P)=>{s(D,(I,F)=>{if(I?(g=!0,b[P]=null,S[P]=I):(b[P]=F,S[P]=null),++E===c.length)return y(g?S:null,b)})})}x(c,s,...y){try{c.apply(s,y)}catch(b){y[y.length-1](b)}}y(c,s,y,b){const S=c.folder.fsPath,g=C.$j,E=()=>T&&T.kill();i.add(E);let D=U=>{i.delete(E),D=()=>{},b(U)},P="";const I=this.D(),F=(0,a.$Knc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),T=F.cmd,z=!Object.keys(F.siblingClauses).length,M=F.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${F.rgDiskPath} ${M}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),y({message:j}),this.s=0,this.z(T,"utf8",y,(U,Z,ie)=>{if(U){D(U);return}if(this.j){D();return}const G=(P+(g?k.$bm(Z||""):Z)).split(`
`);if(ie){const x=G.length;G[x-1]=G[x-1].trim(),G[x-1]||G.pop()}else P=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=G.length,z){for(const x of G)if(this.J(s,{base:S,relativePath:x,searchPath:this.N(c,x)}),this.j){E();break}(ie||this.j)&&D();return}this.G(c,I,S,G,s),ie&&(this.H(I,S,s),D())})}spawnFindCmd(c){const s=this.t.get(c.folder.fsPath),y=s.getBasenameTerms(),b=s.getPathTerms(),S=["-L","."];if(y.length||b.length){S.push("-not","(","(");for(const g of y)S.push("-name",g),S.push("-o");for(const g of b)S.push("-path",g),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),d.spawn("find",S,{cwd:c.folder.fsPath})}readStdout(c,s,y){let b="";this.z(c,s,()=>{},(S,g,E)=>{if(S){y(S);return}b+=g,E&&y(null,b)})}z(c,s,y,b){let S=(D,P,I)=>{(D||I)&&(S=()=>{},this.r?.stop()),b(D,P,I)},g=!1;c.stdout?(this.A(c.stdout,s,S),c.stdout.once("data",()=>g=!0)):y({message:"stdout is null"});let E;c.stderr?E=this.B(c.stderr):y({message:"stderr is null"}),c.on("error",D=>{S(D)}),c.on("close",D=>{let P;!g&&(P=this.C(E,s))&&u(P)?S(new Error(`command failed with error code ${D}: ${this.C(E,s)}`)):(this.g&&D===0&&(this.j=!0),S(null,"",!0))})}A(c,s,y){const b=new R.StringDecoder(s);return c.on("data",S=>{y(null,b.write(S))}),b}B(c){const s=[];return c.on("data",y=>{s.push(y)}),s}C(c,s){const y=new R.StringDecoder(s);return c.map(b=>y.write(b)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:s},y,b,S){b.indexOf(this.b)!==-1&&this.J(S,{base:y,relativePath:this.b,searchPath:this.N(c,this.b)});const g=E=>{const D=L.$nc(E),P=L.$mc(E);let I=s[P];I||(I=s[P]=[],g(P)),I.push({base:y,relativePath:E,basename:D,searchPath:this.N(c,E)})};b.forEach(g)}H({rootEntries:c,pathToEntries:s},y,b){const S=this,g=this.t.get(y),E=this.b;function D(P){S.o++;const I=(0,f.$GL)(()=>P.map(F=>F.basename));for(let F=0,T=P.length;F<T;F++){const z=P[F],{relativePath:M,basename:j}=z;if(g.test(M,j,E!==j?I:void 0))continue;const U=s[M];if(U)D(U);else{if(S.p++,M===E)continue;S.J(b,z)}if(S.j)break}}D(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,s,y,b,S){const g=c.folder,E=(0,f.$GL)(()=>y);this.w(y,(D,P)=>{if(this.l||this.j)return P(null);const I=s?[s,D].join(L.sep):D;if(this.t.get(c.folder.fsPath).test(I,D,this.a.filePattern!==D?E:void 0))return P(null);const F=[g.fsPath,I].join(L.sep);O.lstat(F,(T,z)=>{if(T||this.l||this.j)return P(null);this.L(F,z,(M,j)=>M||this.l||this.j?P(null):j.isDirectory()?(this.o++,this.M(F,z,(U,Z)=>U||this.l||this.j||(Z=Z||"",this.v[Z])?P(null):(this.v[Z]=!0,h.Promises.readdir(F).then(ie=>{if(this.l||this.j)return P(null);this.I(c,I,ie,b,Q=>P(Q||null))},ie=>{P(null)})))):(this.p++,I===this.b||this.h&&w.$ag(j.size)&&j.size>this.h||this.J(b,{base:g.fsPath,relativePath:I,searchPath:this.N(c,I)}),P(null,void 0)))})},D=>{const P=D&&N.$Hb(D);return S(P&&P.length>0?P[0]:void 0)})}J(c,s){this.K(s)&&(!this.d||this.d(s.relativePath,L.$nc(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(s))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$BL)(c,this.c);if(this.b)return(0,f.$BL)(c,this.b,!1)}return!0}L(c,s,y){return s.isSymbolicLink()?O.stat(c,y):y(null,s)}M(c,s,y){return s.isSymbolicLink()?O.realpath(c,(b,S)=>b?y(b):y(null,S)):y(null,c)}N(c,s){return c.folderName?L.$jc(c.folderName,s):s}}e.$Nnc=l;class o{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new l(c)}search(c,s,y){this.c.walk(this.a,this.b,c,s,(b,S)=>{y(b,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Onc=o;class t{constructor(c,s){this.expression=c,this.c=s,this.d(c)}d(c){let s,y;Object.keys(c).filter(b=>c[b]).forEach(b=>{L.$ic(b)?(s=s||m.$lk(),s[b]=c[b]):(y=y||m.$lk(),y[b]=c[b])}),this.a=s&&m.$qk(s,{trimForExclusions:!0}),this.b=y&&m.$qk(y,{trimForExclusions:!0})}test(c,s,y){return this.b&&this.b(c,s,y)||this.a&&this.a(L.$jc(this.c,c),s,y)}getBasenameTerms(){const c=[];return this.a&&c.push(...m.$sk(this.a)),this.b&&c.push(...m.$sk(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...m.$tk(this.a)),this.b&&c.push(...m.$tk(this.b)),c}}function u(r){const c=r.trim().split(`
`),s=c[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return v.$1f(c[c.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(Se[390],De([1,0,98,21,198,22]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$eE=e.DecodeStreamErrorKind=e.$dE=e.$cE=e.$bE=e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$aE=N,e.$fE=w,e.$gE=h,e.$hE=f,e.$iE=a,e.$jE=n,e.$kE=r,e.$lE=c,e.$9D="utf8",e.$0D="utf8bom",e.$$D="utf16be",e.$_D="utf16le";function N(s){return[e.$9D,e.$0D,e.$$D,e.$_D].some(y=>y===s)}e.$bE=[254,255],e.$cE=[255,254],e.$dE=[239,187,191];const p=512,m=512,k=512*8,A=512*128;var C;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class $ extends Error{constructor(y,b){super(y),this.decodeStreamErrorKind=b}}e.$eE=$;class v{static async create(y){let b;if(y!==e.$9D)b=(await(0,L.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(y));else{const S=new TextDecoder;b={write(g){return S.decode(g,{stream:!0})},end(){return S.decode()}}}return new v(b)}constructor(y){this.a=y}write(y){return this.a.write(y)}end(){return this.a.end()}}function w(s,y){const b=y.minBytesRequiredForDetection??y.guessEncoding?k:m;return new Promise((S,g)=>{const E=(0,d.$te)(z=>z.join("")),D=[];let P=0,I;const F=new R.$oe,T=async()=>{try{const z=await c({buffer:O.$Fe.concat(D),bytesRead:P},y.guessEncoding);if(z.seemsBinary&&y.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);z.encoding=await y.overwriteEncoding(z.encoding),I=await v.create(z.encoding);const M=I.write(O.$Fe.concat(D).buffer);E.write(M),D.length=0,P=0,S({stream:E,detected:z})}catch(z){F.cancel(),E.destroy(),g(z)}};(0,d.$xe)(s,{onData:async z=>{I?E.write(I.write(z.buffer)):(D.push(z),P+=z.byteLength,P>=b&&(s.pause(),await T(),setTimeout(()=>s.resume())))},onError:z=>E.error(z),onEnd:async()=>{I||await T(),E.end(I?.end())}},F.token)})}async function h(s,y,b){const g=(await(0,L.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(y),b);let E=!1,D=!1;return{read(){if(D)return null;const P=s.read();if(typeof P!="string"){if(D=!0,!E&&b?.addBOM)switch(y){case e.$9D:case e.$0D:return O.$Fe.wrap(Uint8Array.from(e.$dE));case e.$$D:return O.$Fe.wrap(Uint8Array.from(e.$bE));case e.$_D:return O.$Fe.wrap(Uint8Array.from(e.$cE))}const I=g.end();return I&&I.length>0?(E=!0,O.$Fe.wrap(I)):null}return E=!0,O.$Fe.wrap(g.write(P))}}}async function f(s){return(await(0,L.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(s))}function a(s){return s===e.$0D||s===null?e.$9D:s}function n(s,y){if(!s||y<e.$bE.length)return null;const b=s.readUInt8(0),S=s.readUInt8(1);if(b===e.$bE[0]&&S===e.$bE[1])return e.$$D;if(b===e.$cE[0]&&S===e.$cE[1])return e.$_D;if(y<e.$dE.length)return null;const g=s.readUInt8(2);return b===e.$dE[0]&&S===e.$dE[1]&&g===e.$dE[2]?e.$0D:null}const i=["ascii","utf-16","utf-32"];async function l(s){const y=await(0,L.$8D)("jschardet","dist/jschardet.min.js"),b=s.slice(0,A),S=u(b.buffer),g=y.detect(S);if(!g||!g.encoding)return null;const E=g.encoding.toLowerCase();return 0<=i.indexOf(E)?null:t(g.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(s){const y=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[y]||y}function u(s){let y="";for(let b=0;b<s.length;b++)y+=String.fromCharCode(s[b]);return y}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const y=s.match(/windows(\d+)/);return y?"windows-"+y[1]:s}}}function c({buffer:s,bytesRead:y},b){let S=n(s,y),g=!1;if(S!==e.$$D&&S!==e.$_D&&s){let E=!0,D=!0,P=!1;for(let I=0;I<y&&I<p;I++){const F=I%2===1,T=s.readUInt8(I)===0;if(T&&(P=!0),E&&(F&&!T||!F&&T)&&(E=!1),D&&(F&&T||!F&&!T)&&(D=!1),T&&!E&&!D)break}P&&(E?S=e.$_D:D?S=e.$$D:g=!0)}return b&&!g&&!S&&s?l(s.slice(0,y)).then(E=>({seemsBinary:!1,encoding:E})):{seemsBinary:g,encoding:S}}e.$mE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[161],De([1,0,390,32,160]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class R extends L.$Gmc{constructor(p,m,k=O,A="searchProcess"){super({query:p,provider:m},{readdir:C=>k.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,d.$kE)(C)},A)}}e.$Wnc=R}),define(Se[162],De([1,0,54,406,389,19,74,35,14,2,37,94,407,387,123]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=e.$Pnc=void 0,e.$Rnc=t,e.$Snc=r,e.$Tnc=s,e.$Unc=y,e.$Vnc=S;const h=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(E){this.a=E}provideTextSearchResults(E,D,P,I){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((F,T)=>{I.onCancellationRequested(()=>G());const z=t(E,D),M=D.folder.fsPath,j=z.map(Ce=>Ce.match(/^-/)?Ce:`'${Ce}'`).join(" ");this.a.appendLine(`${h} ${j}
 - cwd: ${M}`);let U=d.spawn(h,z,{cwd:M});U.on("error",Ce=>{console.error(Ce),this.a.appendLine("Error: "+(Ce&&Ce.message)),T((0,A.$xL)(new A.$vL(Ce&&Ce.message,A.SearchErrorCode.rgProcessError)))});let Z=!1;const ie=new i(D.maxResults,D.folder,D.previewOptions);ie.on("result",Ce=>{Z=!0,ne="",P.report(Ce)});let Q=!1;const G=()=>{Q=!0,U?.kill(),ie?.cancel()};let x=!1;ie.on("hitLimit",()=>{x=!0,G()});let ne="";U.stdout.on("data",Ce=>{ie.handleData(Ce),Z||(ne+=Ce)});let be=!1;U.stdout.once("data",()=>be=!0);let ae="";U.stderr.on("data",Ce=>{const ee=Ce.toString();this.a.appendLine(ee),ae.length+ee.length<1e6&&(ae+=ee)}),U.on("close",()=>{if(this.a.appendLine(be?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),Q)F({limitHit:x});else{ie.flush(),U=null;let Ce;ae&&!be&&(Ce=a(ae))?T((0,A.$xL)(new A.$vL(Ce.message,Ce.code))):F({limitHit:x})}})})}}e.$Pnc=f;function a(g){const E=g.split(`
`),D=E[0].trim();if(E.some(I=>I.startsWith("regex parse error")))return new A.$vL(n(E),A.SearchErrorCode.regexParseError);const P=D.match(/grep config error: unknown encoding: (.*)/);if(P)return new A.$vL(`Unknown encoding: ${P[1]}`,A.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new A.$vL(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new A.$vL(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new A.$vL(D,A.SearchErrorCode.regexParseError)}function n(g){const E=["Regex parse error"],D=g.filter(P=>P.startsWith("PCRE2:"));if(D.length>=1){const P=D[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const I=P.split(":")[1];E.push(":"+I)}}return E.join("")}class i extends O.EventEmitter{constructor(E,D,P){super(),this.g=E,this.h=D,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,D){return super.on(E,D),this}handleData(E){if(this.b)return;const D=typeof E=="string"?E:this.d.write(E);this.k(D)}k(E){let D=E.indexOf(`
`);const P=this.a+E;if(D>=0)D+=this.a.length;else{this.a=P;return}let I=0;for(;D>=0;)this.m(P.substring(I,D).trim()),I=D+1,D=P.indexOf(`
`,I);this.a=P.substring(I)}m(E){if(this.b||!E)return;let D;try{D=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(D.type==="match"){const P=l(D.data.path),I=k.URI.joinPath(this.h,P),F=this.n(D.data,I);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const P=l(D.data.path),I=k.URI.joinPath(this.h,P);this.o(D.data,I).forEach(T=>this.p(T))}}n(E,D){const P=E.line_number-1,I=l(E.lines),F=Buffer.from(I);let T=0,z=0,M=P;E.submatches.length===0&&E.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const j=(0,R.$Hb)(E.submatches.map((U,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=l(U.match),Q=F.slice(T,U.start).toString(),G=o(Q),x=G.numLines>0?G.lastLineLength:G.lastLineLength+z,ne=o(ie),be=G.numLines+M,ae=ne.numLines+be,Ce=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+x;return T=U.end,z=Ce,M=ae,new C.$fL(be,x,ae,Ce)}));return(0,w.$Inc)(D,I,j,this.j)}o(E,D){const P=l(E.lines),I=E.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((F,T)=>({text:F,uri:D,lineNumber:I+T}))}p(E){this.emit("result",E)}}e.$Qnc=i;function l(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function o(g){const E=/\n/g;let D=0,P=-1,I;for(;I=E.exec(g);)D++,P=I.index;const F=P>=0?g.length-P-1:g.length;return{numLines:D,lastLineLength:F}}function t(g,E){const D=["--hidden","--no-require-git"];D.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:I}=(0,N.$K)(E.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const T=new Set;I.forEach(z=>{T.add(z)}),D.push("-g","!*"),T.forEach(z=>{u(z).map(w.$Hnc).forEach(M=>{D.push("-g",M)})})}P&&P.length&&P.forEach(T=>{D.push("-g",T)}),E.excludes.map(w.$Hnc).forEach(T=>D.push("-g",`!${T}`)),E.maxFileSize&&D.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),E.followSymlinks&&D.push("--follow"),E.encoding&&E.encoding!=="utf8"&&D.push("--encoding",E.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,m.$_e)(g.pattern),g.isRegExp=!0),E.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),g.isRegExp&&(g.pattern=r(g.pattern),D.push("--engine","auto"));let F;if(g.isWordMatch){const z=(0,m.$if)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",z)}else if(g.isRegExp){let T=s(g.pattern);T=y(T),D.push("--regexp",T)}else F=g.pattern,D.push("--fixed-strings");return D.push("--no-config"),E.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),g.isMultiline&&D.push("--multiline"),E.beforeContext&&D.push("--before-context",E.beforeContext+""),E.afterContext&&D.push("--after-context",E.afterContext+""),D.push("--"),F&&D.push(F),D.push("."),D}function u(g){return S(g).flatMap(D=>{const P=(0,p.$ok)(D,"/");return P.map((I,F)=>P.slice(0,F+1).join("/"))})}function r(g){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(E);)g=g.replace(E,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(D);)g=g.replace(D,"$1\\x{$2}");return g}const c=g=>g.type==="Assertion"&&g.kind==="lookbehind";function s(g){let E;try{E=new $.RegExpParser().parsePattern(g)}catch{return g}let D="",P=0;const I=(z,M,j)=>{D+=g.slice(P,z)+j,P=M},F=[];return new $.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const M=F[0];if(!M)I(z.start,z.end,"\\r?\\n");else if(!F.some(c))if(M.type==="CharacterClass")if(M.negate){const j=g.slice(M.start+2,z.start)+g.slice(z.end,M.end-1);M.parent?.type==="Quantifier"?I(M.start,M.end,j?`[^${j}]`:"."):I(M.start,M.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=g.slice(M.start+1,z.start)+g.slice(z.end,M.end-1);I(M.start,M.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else M.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){c(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(E),D+=g.slice(P),D}function y(g){return g.replace(/\n/g,"\\r?\\n")}function b(g){let E=!1,D=!1,P="",I="";for(let F=0;F<g.length;F++){const T=g[F];switch(T){case"\\":D?(E?I+="\\"+T:P+="\\"+T,D=!1):D=!0;break;case"{":if(D)E?I+=T:P+=T,D=!1;else{if(E)return{strInBraces:P+"{"+I+"{"+g.substring(F+1)};E=!0}break;case"}":if(D)E?I+=T:P+=T,D=!1;else{if(E)return{fixedStart:P,strInBraces:I,fixedEnd:g.substring(F+1)};P+=T}break;default:E?I+=(D?"\\":"")+T:P+=(D?"\\":"")+T,D=!1;break}}return{strInBraces:P+(E?"{"+I:"")}}function S(g){const{fixedStart:E,strInBraces:D,fixedEnd:P}=b(g);if(E===void 0||P===void 0)return[D];let I=(0,p.$ok)(D,",");I.length||(I=[""]);const F=S(P);return I.flatMap(T=>{const z=E+T;return F.map(M=>z+M)})}}),define(Se[391],De([1,0,22,162,109,15]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=void 0;class N{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,A,C,$){const v=new O.$Pnc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const w={...A,folder:A.folder.with({scheme:R.Schemas.file})},h=new L.$dw(f=>C.report({...f,uri:f.uri.with({scheme:A.folder.scheme})}));return this.c($,f=>v.provideTextSearchResults(k,w,h,f))}else return this.c($,w=>v.provideTextSearchResults(k,A,C,w))}async c(k,A){const C=p(k);this.a.add(C);const $=await A(C.token);return this.a.delete(C),$}d(){this.a.forEach(k=>k.cancel())}}e.$Znc=N;function p(m){const k=new d.$oe;return m.onCancellationRequested(()=>k.cancel()),k}}),define(Se[392],De([1,0,32,162,161]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class R{constructor(m){this.a=m}search(m,k,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){A({message:v})}},$=new L.$Wnc(this.a,new O.$Pnc(C),d);return new Promise((v,w)=>$.search(h=>{k(h.map(N))},m).then(h=>v({limitHit:h.limitHit,type:"success",stats:h.stats}),w))}}e.$Xnc=R;function N(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((m,k)=>{if(k.ranges){const A=k;return m+(Array.isArray(A.ranges)?A.ranges.length:1)}else return m+1},0)}}}),define(Se[393],De([1,0,19,7,13,4,133,17,40,2,33,37,388,392]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;class w{static{this.a=512}constructor(l="searchProcess"){this.d=l,this.b=Object.create(null)}fileSearch(l){let o;const t=a(l),u=new R.$de({onDidAddFirstListener:()=>{o=(0,O.$jh)(r=>this.doFileSearchWithEngine($.$Onc,t,c=>u.fire(c),r)),o.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return u.event}textSearch(l){let o;const t=a(l),u=new R.$de({onDidAddFirstListener:()=>{o=(0,O.$jh)(r=>this.f(t,c=>u.fire(c),r)),o.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return u.event}f(l,o,t){return l.maxFileSize=this.g().maxFileSize,new v.$Xnc(l).search(t,o,o)}g(){return{maxFileSize:16*A.$yl.GB}}doFileSearch(l,o,t){return this.doFileSearchWithEngine($.$Onc,l,o,t)}doFileSearchWithEngine(l,o,t,u,r=w.a){let c=0;const s=b=>{Array.isArray(b)?(c+=b.length,t(b.map(S=>this.h(S)))):b.relativePath?(c++,t(this.h(b))):t(b)};if(o.sortByScore){let b=this.l(o,s,u);if(!b){const S=o.maxResults?Object.assign({},o,{maxResults:null}):o,g=new l(S);b=this.j(g,o,t,s,u)}return new Promise((S,g)=>{b.then(([E,D])=>{const P=D.map(I=>this.h(I));this.o(P,t,r),S(E)},g)})}const y=new l(o);return this.r(y,s,r,u).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(l){return{path:l.base?(0,p.$jc)(l.base,l.relativePath):l.relativePath}}j(l,o,t,u,r){const c=new R.$de;let s=(0,O.$jh)(b=>{let S=[];const g=E=>{Array.isArray(E)?S=E:(u(E),c.fire(E))};return this.r(l,g,-1,b).then(E=>[E,S])}),y;if(o.cacheKey){y=this.k(o.cacheKey);const b={promise:s,event:c.event,resolved:!1};y.resultsToSearchCache[o.filePattern||""]=b,s.then(()=>{b.resolved=!0},S=>{delete y.resultsToSearchCache[o.filePattern||""]}),s=this.s(s)}return s.then(([b,S])=>{const g=y?y.scorerCache:Object.create(null),E=(typeof o.maxResults!="number"||o.maxResults>0)&&m.$_d.create(!1);return this.n(o,S,g,r).then(D=>{const P=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:D.length},messages:b.messages,limitHit:b.limitHit||typeof o.maxResults=="number"&&S.length>o.maxResults},D]})})}k(l){const o=this.b[l];return o||(this.b[l]=new h)}l(l,o,t){const u=l.cacheKey&&this.b[l.cacheKey];if(!u)return;const r=this.q(u,l.filePattern||"",o,t);if(r)return r.then(([c,s,y])=>{const b=m.$_d.create(!1);return this.n(l,s,u.scorerCache,t).then(S=>{const g=b.elapsed(),E={fromCache:!0,detailStats:y,type:this.d,resultCount:s.length,sortingTime:g};return[{type:"success",limitHit:c.limitHit||typeof l.maxResults=="number"&&s.length>l.maxResults,stats:E},S]})})}n(l,o,t,u){const r=(0,N.$xr)(l.filePattern||""),c=(y,b)=>(0,N.$wr)(y,b,r,!0,f,t),s=typeof l.maxResults=="number"?l.maxResults:Number.MAX_VALUE;return d.$Gb(o,c,s,1e4,u)}o(l,o,t){if(t&&t>0)for(let u=0;u<l.length;u+=t)o(l.slice(u,u+t));else o(l)}q(l,o,t,u){const r=m.$_d.create(!1),c=o.indexOf(p.sep)>=0;let s;for(const g in l.resultsToSearchCache)if(o.startsWith(g)){if(c&&g.indexOf(p.sep)<0&&g!=="")continue;const E=l.resultsToSearchCache[g];s={promise:this.s(E.promise),event:E.event,resolved:E.resolved};break}if(!s)return null;const y=r.elapsed(),b=m.$_d.create(!1),S=s.event(t);return u&&u.onCancellationRequested(()=>{S.dispose()}),s.promise.then(([g,E])=>{if(u&&u.isCancellationRequested)throw(0,L.$6)();const D=[],P=(0,N.$xr)(o).normalizedLowercase;for(const I of E)(0,C.$BL)(I,P)&&D.push(I);return[g,D,{cacheWasResolved:s.resolved,cacheLookupTime:y,cacheFilterTime:b.elapsed(),cacheEntryCount:E.length}]})}r(l,o,t,u){return new Promise((r,c)=>{let s=[];u?.onCancellationRequested(()=>l.cancel()),l.search(y=>{y&&(t?(s.push(y),t>0&&s.length>=t&&(o(s),s=[])):o(y))},y=>{o(y)},(y,b)=>{s.length&&o(s),y?(o({message:"Search finished. Error: "+y.message}),c(y)):(o({message:"Search finished. Stats: "+JSON.stringify(b.stats)}),r(b))})})}clearCache(l){return delete this.b[l],Promise.resolve(void 0)}s(l){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return l.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return l.finally(o)}}}}e.$Ync=w;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(i){return(0,p.$nc)(i.relativePath)}getItemDescription(i){return(0,p.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(l=>k.URI.revive(l))}}function n(i){return{...i,folder:k.URI.revive(i.folder)}}}),define(Se[394],De([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;let f=class extends k.$Lmc{constructor(n,i,l,o){super(n,l,o),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new d.$Tc;const t=new w.$Jnc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new v.$Znc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new w.$Jnc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.file,new v.$Znc(n))),this.A.add(this.C(O.Schemas.file,new $.$Ync("fileSearchProvider")))}C(n,i){const l=this.d++;return this.y=i,this.x=l,this.c.$registerFileSearchProvider(l,this.s(n)),(0,d.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(l)})}$provideFileSearchResults(n,i,l,o){const t=(0,k.$Mmc)(l);if(n===this.x){const u=Date.now();return this.D(n,i,t,o).then(r=>{const c=Date.now()-u;return this.q.debug(`Ext host file search time: ${c}ms`),r})}return super.$provideFileSearchResults(n,i,l,o)}doInternalFileSearchWithCustomCallback(n,i,l){const o=t=>{if((0,C.$AL)(t)&&(t=[t]),Array.isArray(t)){l(t.map(u=>L.URI.file(u.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,o,i)}async D(n,i,l,o){return this.doInternalFileSearchWithCustomCallback(l,o,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new h.$Wnc(n,i,void 0,"textSearchProvider")}};e.$1nc=f,e.$1nc=f=Ge([We(0,m.$zP),We(1,p.$PP),We(2,A.$Clc),We(3,N.$3j)],f)}),define(Se[124],De([1,0,408,63,64,409,21,13,4,3,17,12,30,82,83]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=r,e.$pi=c,e.$ri=b,e.$si=S;class h{traceSocketEvent(E,D){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,D)}constructor(E,D=""){this.f=!0,this.debugLabel=D,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,p.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const D=P=>{this.traceSocketEvent("read",P),E(N.$Fe.wrap(P))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(E){const D=P=>{E({type:0,hadError:P,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(E){const D=()=>{E()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,p.$1)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,p.$1)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$li=h;var f;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var a;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(a||(a={}));class n extends k.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,D){this.socket.traceSocketEvent(E,D)}constructor(E,D,P,I){super(),this.f=this.B(new m.$de),this.g=this.B(new m.$de),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,D,P,I,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,p.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new w.$gi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let D=0;for(;D<E.byteLength;)this.a.writeMessage(E.slice(D,Math.min(D+262144,E.byteLength)),{compressed:!0,opcode:2}),D+=262144}m(E,{compressed:D,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let I=2;E.byteLength<126?I+=0:E.byteLength<2**16?I+=2:I+=8;const F=N.$Fe.alloc(I),T=D?64:0,z=P&15;if(F.writeUInt8(128|T|z,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let M=1;F.writeUInt8(E.byteLength>>>8&255,++M),F.writeUInt8(E.byteLength>>>0&255,++M)}else{F.writeUInt8(127,1);let M=1;F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(E.byteLength>>>24&255,++M),F.writeUInt8(E.byteLength>>>16&255,++M),F.writeUInt8(E.byteLength>>>8&255,++M),F.writeUInt8(E.byteLength>>>0&255,++M)}this.socket.write(N.$Fe.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),P=D.readUInt8(0),I=(P&128)>>>7,F=(P&64)>>>6,T=P&15,z=D.readUInt8(1),M=(z&128)>>>7,j=z&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),P=D.readUInt8(1),I=(P&128)>>>7;let F=P&127,T=1;F===126?F=D.readUInt8(++T)*2**8+D.readUInt8(++T):F===127&&(F=D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T));let z=0;I&&(z=D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(D,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=n;class i extends k.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Fe.alloc(0)}constructor(E,D,P,I,F,T){super(),this.n=E,this.r=F,this.s=T,this.a=this.B(new m.$de),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new m.$de),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new m.$de),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,D?(this.b=this.B(new l(this.n,I,P,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(E,D){this.g.push({data:E,options:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:D}=this.g.shift();if(this.f&&D.compressed){const P=await this.w(this.f,E);this.s(P,D)}else this.s(E,{...D,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,D){return new Promise((P,I)=>{E.write(D),E.flush(F=>P(F))})}acceptFrame(E,D,P){this.h.push({data:E,isCompressed:D,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const D=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(D)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,D,P){return new Promise((I,F)=>{E.write(D),P&&E.write(N.$Fe.fromByteArray([0,0,255,255])),E.flush(T=>I(T))})}}class l extends k.$Uc{get recordedInflateBytes(){return this.j?N.$Fe.concat(this.f):N.$Fe.alloc(0)}constructor(E,D,P,I){super(),this.h=E,this.j=D,this.a=this.B(new m.$de),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(N.$Fe.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=N.$Fe.concat(this.g);this.g.length=0,E(D)})}}class o extends k.$Uc{constructor(E,D){super(),this.g=E,this.a=this.B(new m.$de),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(N.$Fe.wrap(P))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=N.$Fe.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),E(D)})}}function t(g,E){if(E===0)return;const D=g.byteLength>>>2;for(let M=0;M<D;M++){const j=g.readUInt32BE(M*4);g.writeUInt32BE(j^E,M*4)}const P=D*4,I=g.byteLength-P,F=E>>>24&255,T=E>>>16&255,z=E>>>8&255;I>=1&&g.writeUInt8(g.readUInt8(P)^F,P),I>=2&&g.writeUInt8(g.readUInt8(P+1)^T,P+1),I>=3&&g.writeUInt8(g.readUInt8(P+2)^z,P+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const u={2:107,1:103};function r(){const g=(0,$.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;const E=process.platform!=="darwin"&&e.$ni?e.$ni:(0,L.tmpdir)(),D=(0,A.$jc)(E,`vscode-ipc-${g}.sock`);return s(D),D}function c(g,E,D){const I=(0,d.createHash)("sha256").update(g).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${D}-${E}-sock`;const F=D.substr(0,4),T=E.substr(0,6);let z;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?z=(0,A.$jc)(e.$ni,`vscode-${I}-${F}-${T}.sock`):z=(0,A.$jc)(g,`${F}-${T}.sock`),s(z),z}function s(g){const E=u[C.$u];typeof E=="number"&&g.length>=E&&console.warn(`WARNING: IPC handle "${g}" is longer than ${E} chars, try a shorter --user-data-dir`)}class y extends v.$ai{static b(E){const D=m.Event.fromNodeEventEmitter(E,"connection");return m.Event.map(D,P=>({protocol:new w.$hi(new h(P,"ipc-server-connection")),onDidClientDisconnect:m.Event.once(m.Event.fromNodeEventEmitter(P,"close"))}))}constructor(E){super(y.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=y;function b(g){return new Promise((E,D)=>{const P=(0,O.createServer)();P.on("error",D),P.listen(g,()=>{P.removeListener("error",D),E(new y(P))})})}function S(g,E){return new Promise((D,P)=>{const I=(0,O.createConnection)(g,()=>{I.removeListener("error",P),D(w.$ii.fromSocket(new h(I,`ipc-client${E}`),E))});I.once("error",P)})}}),define(Se[395],De([1,0,63,64,178,124,7,3,12,55,11,108,272,273,111,88,21]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=void 0;async function a(t,u,r,c,s){let y;for(let b=3;b&&(y?.dispose(),y=await new n(t,u,r,c,s).waitForReady(),!(s&&L.$Vg[s]||!L.$Vg[y.tunnelLocalPort]));b--);return y}class n extends p.$Uc{constructor(u,r,c,s,y){super(),this.m=r,this.n=y,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=d.createServer(),this.c=new N.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,r=(0,h.$qw)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,L.$Wg)(u,2,1e3,r),s=null;return this.b.listen(c,this.m),await this.c.wait(),s=this.b.address(),s||(c=0,this.b.listen(c,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(u){u.pause();const r=(0,h.$ow)(this.tunnelRemoteHost)||(0,h.$qw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,$.$Sl)(this.a,r,this.tunnelRemotePort),s=c.getSocket(),y=c.readEntireBuffer();c.dispose(),y.byteLength>0&&u.write(y.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),s.end()}),u.on("close",()=>s.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),s instanceof R.$li?s.socket.destroy():s.end()}),s instanceof R.$li?this.t(u,s):this.s(u,s),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),s.end()})}s(u,r){r.onClose(()=>u.destroy()),r.onEnd(()=>u.end()),r.onData(c=>u.write(c.buffer)),u.on("data",c=>r.write(f.$Fe.wrap(c))),u.resume()}t(u,r){const c=r.socket;c.on("end",()=>u.end()),c.on("close",()=>u.end()),c.on("error",()=>{u.destroy()}),c.pipe(u),u.pipe(c)}}e.$Ldc=n;let i=class extends h.$tw{constructor(u,r,c,s,y){super(r,y),this.v=u,this.w=c,this.y=s}isPortPrivileged(u){return(0,h.$rw)(u,this.m,m.OS,O.release())}t(u,r,c,s,y,b,S,g){const E=this.s(r,c);if(E)return++E.refcount,E.value;if((0,h.$kw)(u))return this.u(u,r,c,y,b,S,g);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${c} on local port ${y}.`);const D={commit:this.y.commit,quality:this.y.quality,addressProvider:u,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=a(D,s,r,c,y);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,c,P),P}}};e.$Mdc=i,e.$Mdc=i=Ge([We(0,v.$Ml),We(1,A.$3j),We(2,w.$Pl),We(3,C.$jk),We(4,k.$3i)],i);let l=class extends i{constructor(u,r,c,s,y){super(u,r,c,s,y)}};e.$Ndc=l,e.$Ndc=l=Ge([We(0,v.$Ml),We(1,A.$3j),We(2,w.$Pl),We(3,C.$jk),We(4,k.$3i)],l);let o=class extends p.$Uc{constructor(u,r,c,s,y){super(),this.b=u,this.c=r,this.f=c,this.g=s,this.h=y,this.a=new Map}async openTunnel(u,r,c,s,y,b,S,g,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${b}.`),!this.a.has(u)){const D=new l(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(u,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(r,c,s,y,b,S,g,E)}};e.$Odc=o,e.$Odc=o=Ge([We(0,v.$Ml),We(1,A.$3j),We(2,C.$jk),We(3,w.$Pl),We(4,k.$3i)],o)}),define(Se[396],De([1,0,124,292,53,34,2,11,42]),function(he,e,d,O,L,R,N,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0;class k{constructor($,v,w){this.b=$,this.c=v,this.f=w,this.a=O.createServer((h,f)=>this.h(h,f)),this.g().catch(h=>(v.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,v){const w=(f,a)=>{v.writeHead(f,{"content-type":"application/json"}),v.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},h=[];$.setEncoding("utf8"),$.on("data",f=>h.push(f)),$.on("end",async()=>{try{const f=JSON.parse(h.join(""));let a;switch(f.type){case"open":a=await this.i(f);break;case"openExternal":a=await this.j(f);break;case"status":a=await this.l(f);break;case"extensionManagement":a=await this.k(f);break;default:w(404,`Unknown message type: ${f.type}`);break}w(200,a)}catch(f){const a=f instanceof Error?f.message:JSON.stringify(f);w(500,a),this.c.error("Error while processing pipe request",f)}})}async i($){const{fileURIs:v,folderURIs:w,forceNewWindow:h,diffMode:f,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:l,waitMarkerFilePath:o,remoteAuthority:t}=$,u=[];if(Array.isArray(w))for(const y of w)try{u.push({folderUri:N.URI.parse(y)})}catch{}if(Array.isArray(v))for(const y of v)try{(0,m.$2i)(y)?u.push({workspaceUri:N.URI.parse(y)}):u.push({fileUri:N.URI.parse(y)})}catch{}const r=o?N.URI.file(o):void 0,s={forceNewWindow:h,diffMode:f,mergeMode:a,addMode:n,gotoLineMode:l,forceReuseWindow:i,preferNewWindow:!i&&!r&&!n,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",u,s)}async j($){for(const v of $.uris){const w=N.URI.parse(v),h=w.scheme==="file"?w:v;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k($){const v=h=>h?.map(f=>/\.vsix$/i.test(f)?N.URI.parse(f):f),w={list:$.list,install:v($.install),uninstall:v($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$1P=k;let A=class extends k{constructor($,v){super($,v,(0,d.$oi)())}};e.$2P=A,e.$2P=A=Ge([We(0,R.$VP),We(1,p.$3j)],A)}),define(Se[397],De([1,0,59,384,379,291,49,366,2,15,8,396,104,325,365]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class h extends L.$unc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,l=i._load;i._load=function(r,c,s){return r=t(r),n.a.has(r)?n.a.get(r).load(r,m.URI.file((0,$.$7q)(c.filename)),y=>l.apply(this,[y,c,s])):l.apply(this,arguments)};const o=i._resolveLookupPaths;i._resolveLookupPaths=(u,r)=>o.call(this,t(u),r);const t=u=>{for(const r of n.b){const c=r(u);if(c){u=c;break}}return u}}}class f extends N.$imc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(v.$4nc);const n=this.h.invokeFunction(O.$qnc);if(this.h.createInstance(p.$3nc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(C.$2P);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(w.$5nc),await this.h.createInstance(h,n,{mine:this.J,all:this.L}).install(),d.mark("code/extHost/didInitAPI");const l=await this.m.getConfigProvider();await(0,R.$2nc)(this.j,l,this,this.s,this.z,this.f),d.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,l){if(i.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let o=null;l.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&d.mark(`code/extHost/willLoadExtensionCode/${t}`),o=he.__$__nodeRequire(i.fsPath)}finally{t&&d.mark(`code/extHost/didLoadExtensionCode/${t}`),l.codeLoadingStop()}return o}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const l=n[i];l===null?delete process.env[i]:process.env[i]=l}}}e.$6nc=f}),define(Se[398],De([1,0,54,21,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0,e.$7nc=o,e.$8nc=t,e.$9nc=u,e.$0nc=r,e.$$nc=s,e.$_nc=y,e.$aoc=b;function o(E){const D=E.trim().split(`
`),P=[];return D.forEach(F=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);T&&T.length>=3&&P.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),P.reduce((F,T)=>(F[T.socket]=T,F),{})}function t(...E){const D=[].concat(...E.map(r));return[...new Map(D.filter(P=>P.st==="0A").map(P=>{const I=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:u(I[0]),port:parseInt(I[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function u(E){let D="";if(E.length===8)for(let P=E.length-2;P>=0;P-=2)D+=parseInt(E.substr(P,2),16),P!==0&&(D+=".");else for(let P=0;P<E.length;P+=8){const I=E.substring(P,P+8);let F="";for(let T=8;T>=2;T-=2)F+=I.substring(T-2,T),(T===6||T===2)&&(F=parseInt(F,16).toString(16),D+=`${F}`,F="",P+T!==E.length-6&&(D+=":"))}return D}function r(E){const D=E.trim().split(`
`),P=D.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return D.map(F=>F.trim().split(/\s+/).reduce((T,z,M)=>(T[P[M]||M]=z,T),{}))}function c(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function s(E){const D=E.trim().split(`
`),P=[];return D.forEach(I=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);F&&F.length>=4&&P.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),P}async function y(E,D,P){const I=P.reduce((T,z)=>(T[z.pid]=z,T),{}),F=[];return E.forEach(({socket:T,ip:z,port:M})=>{const j=D[T]?D[T].pid:void 0,U=j?I[j]?.cmd:void 0;j&&U&&!c(U)&&F.push({host:z,port:M,detail:U,pid:j})}),F}function b(E,D,P){const I=new Map,F=s(D);for(const T of E){const z=P.get(T.port);if(z){I.set(T.port,z);continue}const M=F.find(j=>j.cmd.includes(`${T.port}`));if(M){let j=M,U;do U=F.find(Z=>Z.ppid===j.pid),U&&(j=U);while(U);I.set(T.port,{host:T.ip,port:T.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else I.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return I}let S=class extends i.$tDb{constructor(D,P,I,F){super(D,P,I),this.D=P,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(D){if(D&&this.C)return;this.C=D;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new N.$Em;let F=0;for(;this.C;){const T=new Date().getTime(),z=(await this.I()).filter(U=>(0,h.$ow)(U.host)||(0,h.$qw)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(U=>U.port).join(", ")}`);const M=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),F++>3&&I.update(M),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P));const j=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(U=>setTimeout(()=>U(),j))}}G(D){return Math.max(D*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(D=>D.port).join(", ")}`)}async I(){let D="",P="";try{D=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(D,P),F=await new Promise(Q=>{(0,d.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,x,ne)=>{Q(x)})}),T=o(F),z=await A.Promises.readdir("/proc"),M=[];for(const Q of z)try{const G=Number(Q),x=m.$0g(k.URI.file("/proc"),Q);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(G)){const be=await A.Promises.readlink(m.$0g(x,"cwd").fsPath),ae=await A.Promises.readFile(m.$0g(x,"cmdline").fsPath,"utf8");M.push({pid:G,cwd:be,cmd:ae})}}catch{}const j=[],U=I.filter(Q=>{const G=T[Q.socket];return G||j.push(Q),G}),Z=y(U,T,M);let ie;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const Q=await new Promise(G=>{(0,d.exec)("ps -F -A -l | grep root",(x,ne,be)=>{G(ne)})});this.z=b(j,Q,this.z),ie=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ie.map(G=>G.port).join(", ")}`)}return Z.then(Q=>ie?Q.concat(ie):Q)}w(D){return async P=>{const I=new f.$Ldc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,z,M,j){const U=await D.makeConnection();return g.connect(U,z,M,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$Il(0),connectionToken:D.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await I.waitForReady();const F=new L.$de;return{localAddress:(0,l.$yM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{I.dispose(),F.fire(),F.dispose()}}}}};e.$boc=S,e.$boc=S=Ge([We(0,n.$zP),We(1,a.$PP),We(2,C.$3j),We(3,w.$Pl)],S);class g extends $.$nvb{static connect(D,P,I,F){const T=new R.$Tc,z={onClose:T.add(new L.$de),onData:T.add(new L.$de),onEnd:T.add(new L.$de)};T.add(D.onDidReceiveMessage(j=>z.onData.fire(O.$Fe.wrap(j)))),T.add(D.onDidEnd(()=>z.onEnd.fire())),T.add(D.onDidClose(j=>z.onClose.fire({type:0,error:j,hadError:!!j})));const M=new g(D,F,z);return M.B(T),(0,$.$mvb)(M,P,I,F,z)}constructor(D,P,I){super(P,I),this.n=D}write(D){this.n.send(D.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[399],De([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,326,11,383,61,286,106,111,141]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a,n,i,l,o,t,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$xs)(A.$jmc,p.$6nc,0),(0,d.$xs)(n.$4j,a.$doc,1),(0,d.$xs)(n.$3j,new t.$ti(o.$tnc,[!1],!0)),(0,d.$xs)(u.$Pl,r.$Qdc,1),(0,d.$xs)(h.$Llc,f.$coc,0),(0,d.$xs)(k.$omc,R.$Gnc,0),(0,d.$xs)(C.$Kmc,N.$1nc,0),(0,d.$xs)($.$anc,L.$ync,0),(0,d.$xs)(v.$7lc,O.$xnc,0),(0,d.$xs)(w.$sDb,m.$boc,0),(0,d.$xs)(l.$mmc,i.$eoc,0)}),define(Se[410],De([1,0,63,411,59,13,83,124,269,115,380,21,32,104,7,136,293,309,385,399]),function(he,e,d,O,L,R,N,p,m,k,A,C,$,v,w,h,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let b=0;b<process.execArgv.length;b++)process.execArgv[b]==="--inspect-port=0"&&(process.execArgv.splice(b,1),b--)}();const n=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const y=globalThis._VSCODE_NODE_MODULES.module,b=y._load;y._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return b.apply(this,arguments)}})();const i=process.exit.bind(process),l=process.on.bind(process);function o(y){process.exit=function(b){if(y)i(b);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const b=new Error("An extension called process.crash() and this was prevented.");console.warn(b.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(b,S){b==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),l(b,S)}}let t=function(y){i()};function u(){const y=(0,a.$on)(process.env);if(y.type===3)return new Promise((b,S)=>{const g=E=>{const D=E[0],P=new N.$ji;D.on("message",I=>P.fire(C.$Fe.wrap(I.data))),D.on("close",()=>{t("renderer closed the MessagePort")}),D.start(),b({onMessage:P.event,send:I=>D.postMessage(I.buffer)})};process.parentPort.on("message",E=>g(E.ports))});if(y.type===2)return new Promise((b,S)=>{let g=null;const E=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,P=3e5,I=new w.$Jh(()=>t("renderer disconnected for too long (1)"),D),F=new w.$Jh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,M)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const j=C.$Fe.wrap(Buffer.from(z.initialDataChunk,"base64"));let U;if(z.skipWebSocketFrames)U=new p.$li(M,"extHost-socket");else{const Z=C.$Fe.wrap(Buffer.from(z.inflateBytes,"base64"));U=new p.$mi(new p.$li(M,"extHost-socket"),z.permessageDeflate,Z,!1)}g?(I.cancel(),F.cancel(),g.beginAcceptReconnection(U,j),g.endAcceptReconnection(),g.sendResume()):(clearTimeout(E),g=new N.$ki({socket:U,initialChunk:j}),g.sendResume(),g.onDidDispose(()=>t("renderer disconnected")),b(g),g.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;I.isScheduled()&&F.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const b=y.pipeName;return new Promise((S,g)=>{const E=d.createConnection(b,()=>{E.removeListener("error",g);const D=new N.$ki({socket:new p.$li(E,"extHost-renderer")});D.sendResume(),S(D)});E.once("error",g),E.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const y=await u();return new class{constructor(){this.a=new N.$ji,this.onMessage=this.a.event,this.b=!1,y.onMessage(b=>{(0,k.$1m)(b,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(b)})}send(b){this.b||y.send(b)}async drain(){if(y.drain)return y.drain()}}}function c(y){return new Promise(b=>{const S=y.onMessage(g=>{S.dispose();const E=JSON.parse(g.toString()),D=E.commit,P=m.default.commit;if(D&&P&&D!==P&&i(55),E.parentPid){let I=0;setInterval(function(){try{process.kill(E.parentPid,0),I=0}catch(T){T&&T.code==="EPERM"?(I++,I>=3&&t(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${E.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(E.parentPid)}catch(T){(0,R.$1)(T)}}y.send((0,k.$Zm)(0)),b({protocol:y,initData:E})});y.send((0,k.$Zm)(1))})}async function s(){const y=[];process.on("unhandledRejection",(I,F)=>{y.push(F),setTimeout(()=>{const T=y.indexOf(F);T>=0&&F.catch(z=>{y.splice(T,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const F=y.indexOf(I);F>=0&&y.splice(F,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const b=await r();L.mark("code/extHost/didConnectToRenderer");const S=await c(b);L.mark("code/extHost/didWaitForInitData");const{initData:g}=S;o(!!g.environment.extensionTestsLocationURI),g.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,g.environment.skipWorkspaceStorageLock=(0,h.boolean)(n.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return $.Promises.exists(F)}fsRealpath(F){return(0,v.$6q)(F)}};let D=null;g.remote.authority&&n.transformURIs&&(D=(0,f.$Bs)(g.remote.authority));const P=new A.$wnc(S.protocol,g,E,D);t=I=>P.terminate(I)}s().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/03dd3c3b93322b41fe108a3448308595ee7077a4/core/vs/workbench/api/node/extensionHostProcess.js.map
