/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(le){for(var e=[],I=0,O=le.length;I<O;I++)e[I]=Pe[le[I]];return e};define(Pe[69],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=O,e.$2h=R,e.$3h=M;function I(A){return(p,$,y)=>{let T=null,D=null;if(typeof y.value=="function"?(T="value",D=y.value):typeof y.get=="function"&&(T="get",D=y.get),!D)throw new Error("not supported");y[T]=A(D,$)}}function O(A,p,$){let y=null,T=null;if(typeof $.value=="function"?(y="value",T=$.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",T=$.get),!T)throw new Error("not supported");const D=`$memoize$${p}`;$[y]=function(...h){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,h)}),this[D]}}function R(A,p,$){return I((y,T)=>{const D=`$debounce$${T}`,h=`$debounce$result$${T}`;return function(...w){this[h]||(this[h]=$?$():void 0),clearTimeout(this[D]),p&&(this[h]=p(this[h],...w),w=[this[h]]),this[D]=setTimeout(()=>{y.apply(this,w),this[h]=$?$():void 0},A)}})}function M(A,p,$){return I((y,T)=>{const D=`$throttle$timer$${T}`,h=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,g=`$throttle$pending$${T}`;return function(...r){if(this[h]||(this[h]=$?$():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),p&&(this[h]=p(this[h],...r)),this[g])return;const o=this[w]+A;o<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[h]]),this[h]=$?$():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[w]=Date.now(),y.apply(this,[this[h]]),this[h]=$?$():void 0},o-Date.now()))}})}}),define(Pe[125],Ie([1,0,18]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=R,e.$8c=M,e.$9c=A,e.$0c=p,e.$$c=$,e.$_c=y;const O=(w,g)=>w===g;e.$6c=O;function R(w=e.$6c){return(g,r)=>I.$ub(g,r,w)}function M(){return(w,g)=>JSON.stringify(w)===JSON.stringify(g)}function A(){return(w,g)=>w.equals(g)}function p(w,g,r){return!w||!g?w===g:r(w,g)}function $(w,g){if(w===g)return!0;if(Array.isArray(w)&&Array.isArray(g)){if(w.length!==g.length)return!1;for(let r=0;r<w.length;r++)if(!$(w[r],g[r]))return!1;return!0}if(w&&typeof w=="object"&&g&&typeof g=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(g)===Object.prototype){const r=w,o=g,s=Object.keys(r),i=Object.keys(o),n=new Set(i);if(s.length!==i.length)return!1;for(const c of s)if(!n.has(c)||!$(r[c],o[c]))return!1;return!0}return!1}function y(w){return JSON.stringify(h(w))}let T=0;const D=new WeakMap;function h(w){if(Array.isArray(w))return w.map(h);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const g=w,r=Object.create(null);for(const o of Object.keys(g).sort())r[o]=h(g[o]);return r}else{let g=D.get(w);return g===void 0&&(g=T++,D.set(w,g)),g+"----2b76a038c20c4bcc"}return w}}),define(Pe[91],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$EP=I,e.$FP=new I("id#")}),define(Pe[126],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=A,e.$In=D,e.$Jn=h,e.$Kn=w,e.$Ln=g,e.$Mn=r,e.$Nn=o,e.$On=s,e.$Pn=i,e.$Qn=n,e.$Rn=c,e.$Sn=l;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,f=!1){let a=0;const m=t.length;let u="",C=0,b=16,v=0;function d(q){let N=0,B=0;for(;N<q;){const K=t.charCodeAt(a);if(K>=48&&K<=57)B=B*16+K-48;else if(K>=65&&K<=70)B=B*16+K-65+10;else if(K>=97&&K<=102)B=B*16+K-97+10;else break;a++,N++}return N<q&&(B=-1),B}function E(q){a=q,u="",C=0,b=16,v=0}function k(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&y(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&y(t.charCodeAt(a)))for(a++;a<t.length&&y(t.charCodeAt(a));)a++;else return v=3,t.substring(q,a);let N=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&y(t.charCodeAt(a))){for(a++;a<t.length&&y(t.charCodeAt(a));)a++;N=a}else v=3;return t.substring(q,N)}function P(){let q="",N=a;for(;;){if(a>=m){q+=t.substring(N,a),v=2;break}const B=t.charCodeAt(a);if(B===34){q+=t.substring(N,a),a++;break}if(B===92){if(q+=t.substring(N,a),a++,a>=m){v=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=d(4);ie>=0?q+=String.fromCharCode(ie):v=4;break}default:v=5}N=a;continue}if(B>=0&&B<=31)if($(B)){q+=t.substring(N,a),v=2;break}else v=6;a++}return q}function S(){if(u="",v=0,C=a,a>=m)return C=m,b=17;let q=t.charCodeAt(a);if(p(q)){do a++,u+=String.fromCharCode(q),q=t.charCodeAt(a);while(p(q));return b=15}if($(q))return a++,u+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,u+=`
`),b=14;switch(q){case 123:return a++,b=1;case 125:return a++,b=2;case 91:return a++,b=3;case 93:return a++,b=4;case 58:return a++,b=6;case 44:return a++,b=5;case 34:return a++,u=P(),b=10;case 47:{const N=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<m&&!$(t.charCodeAt(a));)a++;return u=t.substring(N,a),b=12}if(t.charCodeAt(a+1)===42){a+=2;const B=m-1;let K=!1;for(;a<B;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,v=1),u=t.substring(N,a),b=13}return u+=String.fromCharCode(q),a++,b=16}case 45:if(u+=String.fromCharCode(q),a++,a===m||!y(t.charCodeAt(a)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=k(),b=11;default:for(;a<m&&W(q);)a++,q=t.charCodeAt(a);if(C!==a){switch(u=t.substring(C,a),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode(q),a++,b=16}}function W(q){if(p(q)||$(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=S();while(q>=12&&q<=15);return q}return{setPosition:E,getPosition:()=>a,scan:f?V:S,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>C,getTokenLength:()=>a-C,getTokenError:()=>v}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function D(t,f){const a=[],m=new Object;let u;const C={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function v(d,E,k,P){C.value=d,C.offset=E,C.length=k,C.type=P,C.colonOffset=void 0,u=C}try{n(t,{onObjectBegin:(d,E)=>{if(f<=d)throw m;u=void 0,b=f>d,a.push("")},onObjectProperty:(d,E,k)=>{if(f<E||(v(d,E,k,"property"),a[a.length-1]=d,f<=E+k))throw m},onObjectEnd:(d,E)=>{if(f<=d)throw m;u=void 0,a.pop()},onArrayBegin:(d,E)=>{if(f<=d)throw m;u=void 0,a.push(0)},onArrayEnd:(d,E)=>{if(f<=d)throw m;u=void 0,a.pop()},onLiteralValue:(d,E,k)=>{if(f<E||(v(d,E,k,l(d)),f<=E+k))throw m},onSeparator:(d,E,k)=>{if(f<=E)throw m;if(d===":"&&u&&u.type==="property")u.colonOffset=E,b=!1,u=void 0;else if(d===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(b=!0,a[a.length-1]=""),u=void 0}}})}catch(d){if(d!==m)throw d}return{path:a,previousNode:u,isAtPropertyKey:b,matches:d=>{let E=0;for(let k=0;E<d.length&&k<a.length;k++)if(d[E]===a[k]||d[E]==="*")E++;else if(d[E]!=="**")return!1;return E===d.length}}}function h(t,f=[],a=M.DEFAULT){let m=null,u=[];const C=[];function b(d){Array.isArray(u)?u.push(d):m!==null&&(u[m]=d)}return n(t,{onObjectBegin:()=>{const d={};b(d),C.push(u),u=d,m=null},onObjectProperty:d=>{m=d},onObjectEnd:()=>{u=C.pop()},onArrayBegin:()=>{const d=[];b(d),C.push(u),u=d,m=null},onArrayEnd:()=>{u=C.pop()},onLiteralValue:b,onError:(d,E,k)=>{f.push({error:d,offset:E,length:k})}},a),u[0]}function w(t,f=[],a=M.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(d){m.type==="property"&&(m.length=d-m.offset,m=m.parent)}function C(d){return m.children.push(d),d}n(t,{onObjectBegin:d=>{m=C({type:"object",offset:d,length:-1,parent:m,children:[]})},onObjectProperty:(d,E,k)=>{m=C({type:"property",offset:E,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:d,offset:E,length:k,parent:m})},onObjectEnd:(d,E)=>{m.length=d+E-m.offset,m=m.parent,u(d+E)},onArrayBegin:(d,E)=>{m=C({type:"array",offset:d,length:-1,parent:m,children:[]})},onArrayEnd:(d,E)=>{m.length=d+E-m.offset,m=m.parent,u(d+E)},onLiteralValue:(d,E,k)=>{C({type:l(d),offset:E,length:k,parent:m,value:d}),u(E+k)},onSeparator:(d,E,k)=>{m.type==="property"&&(d===":"?m.colonOffset=E:d===","&&u(E))},onError:(d,E,k)=>{f.push({error:d,offset:E,length:k})}},a);const v=m.children[0];return v&&delete v.parent,v}function g(t,f){if(!t)return;let a=t;for(const m of f)if(typeof m=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let u=!1;for(const C of a.children)if(Array.isArray(C.children)&&C.children[0].value===m){a=C.children[1],u=!0;break}if(!u)return}else{const u=m;if(a.type!=="array"||u<0||!Array.isArray(a.children)||u>=a.children.length)return;a=a.children[u]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;f.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&f.push(a)}return f}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const f=Object.create(null);for(const a of t.children){const m=a.children[1];m&&(f[a.children[0].value]=o(m))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,f,a=!1){return f>=t.offset&&f<t.offset+t.length||a&&f===t.offset+t.length}function i(t,f,a=!1){if(s(t,f,a)){const m=t.children;if(Array.isArray(m))for(let u=0;u<m.length&&m[u].offset<=f;u++){const C=i(m[u],f,a);if(C)return C}return t}}function n(t,f,a=M.DEFAULT){const m=A(t,!1);function u(Te){return Te?()=>Te(m.getTokenOffset(),m.getTokenLength()):()=>!0}function C(Te){return Te?ae=>Te(ae,m.getTokenOffset(),m.getTokenLength()):()=>!0}const b=u(f.onObjectBegin),v=C(f.onObjectProperty),d=u(f.onObjectEnd),E=u(f.onArrayBegin),k=u(f.onArrayEnd),P=C(f.onLiteralValue),S=C(f.onSeparator),W=u(f.onComment),V=C(f.onError),q=a&&a.disallowComments,N=a&&a.allowTrailingComma;function B(){for(;;){const Te=m.scan();switch(m.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Te){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Te}}}function K(Te,ae=[],Ne=[]){if(V(Te),ae.length+Ne.length>0){let ne=m.getToken();for(;ne!==17;){if(ae.indexOf(ne)!==-1){B();break}else if(Ne.indexOf(ne)!==-1)break;ne=B()}}}function ie(Te){const ae=m.getTokenValue();return Te?P(ae):v(ae),B(),!0}function ce(){switch(m.getToken()){case 11:{let Te=0;try{Te=JSON.parse(m.getTokenValue()),typeof Te!="number"&&(K(2),Te=0)}catch{K(2)}P(Te);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return B(),!0}function ye(){return m.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),m.getToken()===6?(S(":"),B(),$e()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Se(){b(),B();let Te=!1;for(;m.getToken()!==2&&m.getToken()!==17;){if(m.getToken()===5){if(Te||K(4,[],[]),S(","),B(),m.getToken()===2&&N)break}else Te&&K(6,[],[]);ye()||K(4,[],[2,5]),Te=!0}return d(),m.getToken()!==2?K(7,[2],[]):B(),!0}function fe(){E(),B();let Te=!1;for(;m.getToken()!==4&&m.getToken()!==17;){if(m.getToken()===5){if(Te||K(4,[],[]),S(","),B(),m.getToken()===4&&N)break}else Te&&K(6,[],[]);$e()||K(4,[],[4,5]),Te=!0}return k(),m.getToken()!==4?K(8,[4],[]):B(),!0}function $e(){switch(m.getToken()){case 3:return fe();case 1:return Se();case 10:return ie(!0);default:return ce()}}return B(),m.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):$e()?(m.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(t,f){const a=A(t),m=[];let u,C=0,b;do switch(b=a.getPosition(),u=a.scan(),u){case 12:case 13:case 17:C!==b&&m.push(t.substring(C,b)),f!==void 0&&m.push(a.getTokenValue().replace(/[^\r\n]/g,f)),C=a.getPosition();break}while(u!==17);return m.join("")}function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Pe[127],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(De,pe){for(var ge=0;ge<pe.length;ge++){var Q=pe[ge];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(De,Q.key,Q)}}function I(De,pe,ge){return pe&&e(De.prototype,pe),ge&&e(De,ge),Object.defineProperty(De,"prototype",{writable:!1}),De}function O(De,pe){if(De){if(typeof De=="string")return R(De,pe);var ge=Object.prototype.toString.call(De).slice(8,-1);if(ge==="Object"&&De.constructor&&(ge=De.constructor.name),ge==="Map"||ge==="Set")return Array.from(De);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return R(De,pe)}}function R(De,pe){(pe==null||pe>De.length)&&(pe=De.length);for(var ge=0,Q=new Array(pe);ge<pe;ge++)Q[ge]=De[ge];return Q}function M(De,pe){var ge=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ge)return(ge=ge.call(De)).next.bind(ge);if(Array.isArray(De)||(ge=O(De))||pe&&De&&typeof De.length=="number"){ge&&(De=ge);var Q=0;return function(){return Q>=De.length?{done:!0}:{done:!1,value:De[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=A();function p(De){le.defaults=De}var $=/[&<>"']/,y=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(pe){return h[pe]};function g(De,pe){if(pe){if($.test(De))return De.replace(y,w)}else if(T.test(De))return De.replace(D,w);return De}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(De){return De.replace(r,function(pe,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(De,pe){De=typeof De=="string"?De:De.source,pe=pe||"";var ge={replace:function(Y,he){return he=he.source||he,he=he.replace(s,"$1"),De=De.replace(Y,he),ge},getRegex:function(){return new RegExp(De,pe)}};return ge}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(De,pe,ge){if(De){var Q;try{Q=decodeURIComponent(o(ge)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}pe&&!c.test(ge)&&(ge=u(pe,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},f=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(De,pe){t[" "+De]||(f.test(De)?t[" "+De]=De+"/":t[" "+De]=d(De,"/",!0)),De=t[" "+De];var ge=De.indexOf(":")===-1;return pe.substring(0,2)==="//"?ge?pe:De.replace(a,"$1")+pe:pe.charAt(0)==="/"?ge?pe:De.replace(m,"$1")+pe:De+pe}var C={exec:function(){}};function b(De){for(var pe=1,ge,Q;pe<arguments.length;pe++){ge=arguments[pe];for(Q in ge)Object.prototype.hasOwnProperty.call(ge,Q)&&(De[Q]=ge[Q])}return De}function v(De,pe){var ge=De.replace(/\|/g,function(he,ue,Me){for(var de=!1,Ce=ue;--Ce>=0&&Me[Ce]==="\\";)de=!de;return de?"|":" |"}),Q=ge.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>pe)Q.splice(pe);else for(;Q.length<pe;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function d(De,pe,ge){var Q=De.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=De.charAt(Q-Y-1);if(he===pe&&!ge)Y++;else if(he!==pe&&ge)Y++;else break}return De.slice(0,Q-Y)}function E(De,pe){if(De.indexOf(pe[1])===-1)return-1;for(var ge=De.length,Q=0,Y=0;Y<ge;Y++)if(De[Y]==="\\")Y++;else if(De[Y]===pe[0])Q++;else if(De[Y]===pe[1]&&(Q--,Q<0))return Y;return-1}function k(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(De,pe){if(pe<1)return"";for(var ge="";pe>1;)pe&1&&(ge+=De),pe>>=1,De+=De;return ge+De}function S(De,pe,ge,Q){var Y=pe.href,he=pe.title?g(pe.title):null,ue=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){Q.state.inLink=!0;var Me={type:"link",raw:ge,href:Y,title:he,text:ue,tokens:Q.inlineTokens(ue)};return Q.state.inLink=!1,Me}return{type:"image",raw:ge,href:Y,title:he,text:g(ue)}}function W(De,pe){var ge=De.match(/^(\s+)(?:```)/);if(ge===null)return pe;var Q=ge[1];return pe.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ue=he[0];return ue.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var V=function(){function De(ge){this.options=ge||le.defaults}var pe=De.prototype;return pe.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},pe.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:d(he,`
`)}}},pe.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ue=W(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ue}}},pe.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ue=d(he,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(he=ue.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},pe.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},pe.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},pe.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ue,Me,de,Ce,Ae,je,U,F,G,H,ee,re=Y[1].trim(),Oe=re.length>1,Ve={type:"list",raw:"",ordered:Oe,start:Oe?+re.slice(0,-1):"",loose:!1,items:[]};re=Oe?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Oe?re:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=Ge.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),U=Y[2].split(`
`,1)[0],F=Q.split(`
`,1)[0],this.options.pedantic?(de=2,H=U.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=U.slice(de),de+=Y[1].length),Ae=!1,!U&&/^ *$/.test(F)&&(he+=F+`
`,Q=Q.substring(F.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(G=Q.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(U)||tt.test(U)||_e.test(U)||xe.test(Q)));){if(U.search(/[^ ]/)>=de||!U.trim())H+=`
`+U.slice(de);else if(!Ae)H+=`
`+U;else break;!Ae&&!U.trim()&&(Ae=!0),he+=G+`
`,Q=Q.substring(G.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test(he)&&(je=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(H),ue&&(Me=ue[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:he,task:!!ue,checked:Me,loose:!1,text:H}),Ve.raw+=he}Ve.items[Ve.items.length-1].raw=he.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var it=Ve.items.length;for(Ce=0;Ce<it;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var at=Ve.items[Ce].tokens.filter(function(Ue){return Ue.type==="space"}),gt=at.every(function(Ue){for(var st=Ue.raw.split(""),Z=0,X=M(st),me;!(me=X()).done;){var qe=me.value;if(qe===`
`&&(Z+=1),Z>1)return!0}return!1});!Ve.loose&&at.length&&gt&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},pe.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);he.type="paragraph",he.text=ue,he.tokens=this.lexer.inline(ue)}return he}},pe.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},pe.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:v(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ue=he.align.length,Me,de,Ce,Ae;for(Me=0;Me<ue;Me++)/^ *-+: *$/.test(he.align[Me])?he.align[Me]="right":/^ *:-+: *$/.test(he.align[Me])?he.align[Me]="center":/^ *:-+ *$/.test(he.align[Me])?he.align[Me]="left":he.align[Me]=null;for(ue=he.rows.length,Me=0;Me<ue;Me++)he.rows[Me]=v(he.rows[Me],he.header.length).map(function(je){return{text:je}});for(ue=he.header.length,de=0;de<ue;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(ue=he.rows.length,de=0;de<ue;de++)for(Ae=he.rows[de],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=this.lexer.inline(Ae[Ce].text);return he}}},pe.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},pe.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},pe.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},pe.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},pe.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},pe.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ue=d(he.slice(0,-1),"\\");if((he.length-ue.length)%2===0)return}else{var Me=E(Y[2],"()");if(Me>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Me;Y[2]=Y[2].substring(0,Me),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Ae=Y[2],je="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);U&&(Ae=U[1],je=U[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(he)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),S(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},pe.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ue=(he[2]||he[1]).replace(/\s+/g," ");if(ue=Y[ue.toLowerCase()],!ue||!ue.href){var Me=he[0].charAt(0);return{type:"text",raw:Me,text:Me}}return S(he,ue,he[0],this.lexer)}},pe.emStrong=function(Q,Y,he){he===void 0&&(he="");var ue=this.rules.inline.emStrong.lDelim.exec(Q);if(ue&&!(ue[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=ue[1]||ue[2]||"";if(!Me||Me&&(he===""||this.rules.inline.punctuation.exec(he))){var de=ue[0].length-1,Ce,Ae,je=de,U=0,F=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(F.lastIndex=0,Y=Y.slice(-1*Q.length+de);(ue=F.exec(Y))!=null;)if(Ce=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Ce){if(Ae=Ce.length,ue[3]||ue[4]){je+=Ae;continue}else if((ue[5]||ue[6])&&de%3&&!((de+Ae)%3)){U+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+U),Math.min(de,Ae)%2){var G=Q.slice(1,de+ue.index+Ae);return{type:"em",raw:Q.slice(0,de+ue.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,de+ue.index+Ae-1);return{type:"strong",raw:Q.slice(0,de+ue.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},pe.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ue=/[^ ]/.test(he),Me=/^ /.test(he)&&/ $/.test(he);return ue&&Me&&(he=he.substring(1,he.length-1)),he=g(he,!0),{type:"codespan",raw:Y[0],text:he}}},pe.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},pe.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},pe.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ue,Me;return he[2]==="@"?(ue=g(this.options.mangle?Y(he[1]):he[1]),Me="mailto:"+ue):(ue=g(he[1]),Me=ue),{type:"link",raw:he[0],text:ue,href:Me,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ue,Me;if(he[2]==="@")ue=g(this.options.mangle?Y(he[0]):he[0]),Me="mailto:"+ue;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);ue=g(he[0]),he[1]==="www."?Me="http://"+ue:Me=ue}return{type:"link",raw:he[0],text:ue,href:Me,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):g(he[0]):he[0]:ue=g(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ue}}},De}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=i(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=i(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=i(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=i(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=i(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=b({},q),q.gfm=b({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=i(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=b({},q.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:i(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(q._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",q._label).getRegex(),N.nolink=i(N.nolink).replace("ref",q._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=b({},N),N.pedantic=b({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=b({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=b({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(De){var pe="",ge,Q,Y=De.length;for(ge=0;ge<Y;ge++)Q=De.charCodeAt(ge),Math.random()>.5&&(Q="x"+Q.toString(16)),pe+="&#"+Q+";";return pe}var ie=function(){function De(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||le.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:N.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=N.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=N.breaks:Q.inline=N.gfm),this.tokenizer.rules=Q}De.lex=function(Q,Y){var he=new De(Y);return he.lex(Q)},De.lexInline=function(Q,Y){var he=new De(Y);return he.inlineTokens(Q)};var pe=De.prototype;return pe.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},pe.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,U,F){return U+"    ".repeat(F.length)});for(var ue,Me,de,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ue=je.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Q)){Q=Q.substring(ue.raw.length),ue.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ue);continue}if(ue=this.tokenizer.code(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(ue);continue}if(ue=this.tokenizer.fences(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.heading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.hr(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.blockquote(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.list(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.html(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.def(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.lheading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,U=Q.slice(1),F=void 0;he.options.extensions.startBlock.forEach(function(G){F=G.call({lexer:this},U),typeof F=="number"&&F>=0&&(je=Math.min(je,F))}),je<1/0&&je>=0&&(de=Q.substring(0,je+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(de))){Me=Y[Y.length-1],Ce&&Me.type==="paragraph"?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(ue),Ce=de.length!==Q.length,Q=Q.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(ue);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},pe.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},pe.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ue,Me,de,Ce=Q,Ae,je,U;if(this.tokens.links){var F=Object.keys(this.tokens.links);if(F.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)F.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(U=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ue=H.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.tag(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&ue.type==="text"&&Me.type==="text"?(Me.raw+=ue.raw,Me.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.link(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&ue.type==="text"&&Me.type==="text"?(Me.raw+=ue.raw,Me.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.emStrong(Q,Ce,U)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.codespan(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.br(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.del(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.autolink(Q,K)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Q,K))){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Oe){re=Oe.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(de=Q.substring(0,H+1))}(),ue=this.tokenizer.inlineText(de,B)){Q=Q.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(U=ue.raw.slice(-1)),je=!0,Me=Y[Y.length-1],Me&&Me.type==="text"?(Me.raw+=ue.raw,Me.text+=ue.text):Y.push(ue);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(De,null,[{key:"rules",get:function(){return{block:q,inline:N}}}]),De}(),ce=function(){function De(ge){this.options=ge||le.defaults}var pe=De.prototype;return pe.code=function(Q,Y,he){var ue=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(Q,ue);Me!=null&&Me!==Q&&(he=!0,Q=Me)}return Q=Q.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+g(ue,!0)+'">'+(he?Q:g(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:g(Q,!0))+`</code></pre>
`},pe.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},pe.html=function(Q){return Q},pe.heading=function(Q,Y,he,ue){if(this.options.headerIds){var Me=this.options.headerPrefix+ue.slug(he);return"<h"+Y+' id="'+Me+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(Q,Y,he){var ue=Y?"ol":"ul",Me=Y&&he!==1?' start="'+he+'"':"";return"<"+ue+Me+`>
`+Q+"</"+ue+`>
`},pe.listitem=function(Q){return"<li>"+Q+`</li>
`},pe.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(Q){return"<p>"+Q+`</p>
`},pe.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},pe.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},pe.tablecell=function(Q,Y){var he=Y.header?"th":"td",ue=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ue+Q+("</"+he+`>
`)},pe.strong=function(Q){return"<strong>"+Q+"</strong>"},pe.em=function(Q){return"<em>"+Q+"</em>"},pe.codespan=function(Q){return"<code>"+Q+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(Q){return"<del>"+Q+"</del>"},pe.link=function(Q,Y,he){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<a href="'+g(Q)+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=">"+he+"</a>",ue},pe.image=function(Q,Y,he){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<img src="'+Q+'" alt="'+he+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=this.options.xhtml?"/>":">",ue},pe.text=function(Q){return Q},De}(),ye=function(){function De(){}var pe=De.prototype;return pe.strong=function(Q){return Q},pe.em=function(Q){return Q},pe.codespan=function(Q){return Q},pe.del=function(Q){return Q},pe.html=function(Q){return Q},pe.text=function(Q){return Q},pe.link=function(Q,Y,he){return""+he},pe.image=function(Q,Y,he){return""+he},pe.br=function(){return""},De}(),Se=function(){function De(){this.seen={}}var pe=De.prototype;return pe.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(Q,Y){var he=Q,ue=0;if(this.seen.hasOwnProperty(he)){ue=this.seen[Q];do ue++,he=Q+"-"+ue;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ue,this.seen[he]=0),he},pe.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},De}(),fe=function(){function De(ge){this.options=ge||le.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Se}De.parse=function(Q,Y){var he=new De(Y);return he.parse(Q)},De.parseInline=function(Q,Y){var he=new De(Y);return he.parseInline(Q)};var pe=De.prototype;return pe.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ue,Me,de,Ce,Ae,je,U,F,G,H,ee,re,Oe,Ve,Ge,_e,xe,et,tt,it=Q.length;for(ue=0;ue<it;ue++){if(H=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(F="",U="",Ce=H.header.length,Me=0;Me<Ce;Me++)U+=this.renderer.tablecell(this.parseInline(H.header[Me].tokens),{header:!0,align:H.align[Me]});for(F+=this.renderer.tablerow(U),G="",Ce=H.rows.length,Me=0;Me<Ce;Me++){for(je=H.rows[Me],U="",Ae=je.length,de=0;de<Ae;de++)U+=this.renderer.tablecell(this.parseInline(je[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(U)}he+=this.renderer.table(F,G);continue}case"blockquote":{G=this.parse(H.tokens),he+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,re=H.start,Oe=H.loose,Ce=H.items.length,G="",Me=0;Me<Ce;Me++)Ge=H.items[Me],_e=Ge.checked,xe=Ge.task,Ve="",Ge.task&&(et=this.renderer.checkbox(_e),Oe?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=et+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=et+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:et}):Ve+=et),Ve+=this.parse(Ge.tokens,Oe),G+=this.renderer.listitem(Ve,xe,_e);he+=this.renderer.list(G,ee,re);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;ue+1<it&&Q[ue+1].type==="text";)H=Q[++ue],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(G):G;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},pe.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ue,Me,de,Ce=Q.length;for(ue=0;ue<Ce;ue++){if(Me=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(de=this.options.extensions.renderers[Me.type].call({parser:this},Me),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){he+=de||"";continue}switch(Me.type){case"escape":{he+=Y.text(Me.text);break}case"html":{he+=Y.html(Me.text);break}case"link":{he+=Y.link(Me.href,Me.title,this.parseInline(Me.tokens,Y));break}case"image":{he+=Y.image(Me.href,Me.title,Me.text);break}case"strong":{he+=Y.strong(this.parseInline(Me.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Me.tokens,Y));break}case"codespan":{he+=Y.codespan(Me.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Me.tokens,Y));break}case"text":{he+=Y.text(Me.text);break}default:{var Ae='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return he},De}();function $e(De,pe,ge){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof pe=="function"&&(ge=pe,pe=null),pe=b({},$e.defaults,pe||{}),k(pe),ge){var Q=pe.highlight,Y;try{Y=ie.lex(De,pe)}catch(Ce){return ge(Ce)}var he=function(Ae){var je;if(!Ae)try{pe.walkTokens&&$e.walkTokens(Y,pe.walkTokens),je=fe.parse(Y,pe)}catch(U){Ae=U}return pe.highlight=Q,Ae?ge(Ae):ge(null,je)};if(!Q||Q.length<3||(delete pe.highlight,!Y.length))return he();var ue=0;$e.walkTokens(Y,function(Ce){Ce.type==="code"&&(ue++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Ae,je){if(Ae)return he(Ae);je!=null&&je!==Ce.text&&(Ce.text=je,Ce.escaped=!0),ue--,ue===0&&he()})},0))}),ue===0&&he();return}function Me(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+g(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ie.lex(De,pe);if(pe.walkTokens){if(pe.async)return Promise.all($e.walkTokens(de,pe.walkTokens)).then(function(){return fe.parse(de,pe)}).catch(Me);$e.walkTokens(de,pe.walkTokens)}return fe.parse(de,pe)}catch(Ce){Me(Ce)}}$e.options=$e.setOptions=function(De){return b($e.defaults,De),p($e.defaults),$e},$e.getDefaults=A,$e.defaults=le.defaults,$e.use=function(){for(var De=arguments.length,pe=new Array(De),ge=0;ge<De;ge++)pe[ge]=arguments[ge];var Q=b.apply(void 0,[{}].concat(pe)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},he;pe.forEach(function(ue){if(ue.extensions&&(he=!0,ue.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),U=0;U<Ae;U++)je[U]=arguments[U];var F=de.renderer.apply(this,je);return F===!1&&(F=Ce.apply(this,je)),F}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),ue.renderer&&function(){var de=$e.defaults.renderer||new ce,Ce=function(U){var F=de[U];de[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=ue.renderer[U].apply(de,H);return re===!1&&(re=F.apply(de,H)),re}};for(var Ae in ue.renderer)Ce(Ae);Q.renderer=de}(),ue.tokenizer&&function(){var de=$e.defaults.tokenizer||new V,Ce=function(U){var F=de[U];de[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=ue.tokenizer[U].apply(de,H);return re===!1&&(re=F.apply(de,H)),re}};for(var Ae in ue.tokenizer)Ce(Ae);Q.tokenizer=de}(),ue.walkTokens){var Me=$e.defaults.walkTokens;Q.walkTokens=function(de){var Ce=[];return Ce.push(ue.walkTokens.call(this,de)),Me&&(Ce=Ce.concat(Me.call(this,de))),Ce}}he&&(Q.extensions=Y),$e.setOptions(Q)})},$e.walkTokens=function(De,pe){for(var ge=[],Q=function(){var Me=he.value;switch(ge=ge.concat(pe.call($e,Me)),Me.type){case"table":{for(var de=M(Me.header),Ce;!(Ce=de()).done;){var Ae=Ce.value;ge=ge.concat($e.walkTokens(Ae.tokens,pe))}for(var je=M(Me.rows),U;!(U=je()).done;)for(var F=U.value,G=M(F),H;!(H=G()).done;){var ee=H.value;ge=ge.concat($e.walkTokens(ee.tokens,pe))}break}case"list":{ge=ge.concat($e.walkTokens(Me.items,pe));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Me.type]?$e.defaults.extensions.childTokens[Me.type].forEach(function(re){ge=ge.concat($e.walkTokens(Me[re],pe))}):Me.tokens&&(ge=ge.concat($e.walkTokens(Me.tokens,pe)))}},Y=M(De),he;!(he=Y()).done;)Q();return ge},$e.parseInline=function(De,pe){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");pe=b({},$e.defaults,pe||{}),k(pe);try{var ge=ie.lexInline(De,pe);return pe.walkTokens&&$e.walkTokens(ge,pe.walkTokens),fe.parseInline(ge,pe)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+g(Q.message+"",!0)+"</pre>";throw Q}},$e.Parser=fe,$e.parser=fe.parse,$e.Renderer=ce,$e.TextRenderer=ye,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=V,$e.Slugger=Se,$e.parse=$e;var Te=$e.options,ae=$e.setOptions,Ne=$e.use,ne=$e.walkTokens,z=$e.parseInline,x=$e,be=fe.parse,Fe=ie.lex;le.Lexer=ie,le.Parser=fe,le.Renderer=ce,le.Slugger=Se,le.TextRenderer=ye,le.Tokenizer=V,le.getDefaults=A,le.lexer=Fe,le.marked=$e,le.options=Te,le.parse=x,le.parseInline=z,le.parser=be,le.setOptions=ae,le.use=Ne,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(Pe[128],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=I;function I(r){const o=M(r);if(o&&o.length>0)return new Uint32Array(o)}let O=0;const R=new Uint32Array(10);function M(r){if(O=0,A(r,D,4352),O>0||(A(r,h,4449),O>0)||(A(r,w,4520),O>0)||(A(r,g,12593),O))return R.subarray(0,O);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,i=Math.floor(o/588),n=Math.floor(s/28),c=s%28-1;if(i<D.length?A(i,D,0):4352+i-12593<g.length&&A(4352+i,g,12593),n<h.length?A(n,h,0):4449+n-12593<g.length&&A(4449+n-12593,g,12593),c>=0&&(c<w.length?A(c,w,0):4520+c-12593<g.length&&A(4520+c-12593,g,12593)),O>0)return R.subarray(0,O)}}function A(r,o,s){r>=s&&r<s+o.length&&p(o[r-s])}function p(r){r!==0&&(R[O++]=r&255,r>>8&&(R[O++]=r>>8&255),r>>16&&(R[O++]=r>>16&255))}var $;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(y||(y={}));var T;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(T||(T={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),h=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[129],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=I,e.rot=O;function I(p,$,y){return Math.min(Math.max(p,$),y)}function O(p,$){return($+p%$)%$}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=R;class M{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=M;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=A}),define(Pe[130],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=M,e.$cd=h;class I{constructor(g,r,o){this.owner=g,this.debugNameSource=r,this.referenceFn=o}getDebugName(g){return M(g,this)}}e.$ad=I;const O=new Map,R=new WeakMap;function M(w,g){const r=R.get(w);if(r)return r;const o=A(w,g);if(o){let s=O.get(o)??0;s++,O.set(o,s);const i=s===1?o:`${o}#${s}`;return R.set(w,i),i}}function A(w,g){const r=R.get(w);if(r)return r;const o=g.owner?T(g.owner)+".":"";let s;const i=g.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(s=i(),s!==void 0)return o+s}else return o+i;const n=g.referenceFn;if(n!==void 0&&(s=h(n),s!==void 0))return o+s;if(g.owner!==void 0){const c=p(g.owner,w);if(c!==void 0)return o+c}}function p(w,g){for(const r in w)if(w[r]===g)return r}const $=new Map,y=new WeakMap;function T(w){const g=y.get(w);if(g)return g;const r=D(w);let o=$.get(r)??0;o++,$.set(r,o);const s=o===1?r:`${r}#${o}`;return y.set(w,s),s}function D(w){const g=w.constructor;return g?g.name:"Object"}function h(w){const g=w.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(g);return(o?o[1]:void 0)?.trim()}}),define(Pe[131],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=R;let I;function O(r){I=r}function R(){return I}class M{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([p(w("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[p(" "),y(T(o.oldValue,70),{color:"red",strikeThrough:!0}),p(" "),y(T(o.newValue,60),{color:"green"})]:[p(" (unchanged)")]:[p(" "),y(T(o.newValue,60),{color:"green"}),p(" (initial)")]}handleObservableChanged(o,s){console.log(...this.b([$("observable value changed"),y(o.debugName,{color:"BlueViolet"}),...this.c(s)]))}formatChanges(o){if(o.size!==0)return y(" (changed deps: "+[...o].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(i,n)=>(this.d.get(o).add(i),s.apply(o,[i,n]))}handleDerivedRecomputed(o,s){const i=this.d.get(o);console.log(...this.b([$("derived recomputed"),y(o.debugName,{color:"BlueViolet"}),...this.c(s),this.formatChanges(i),{data:[{fn:o._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(o,s){console.log(...this.b([$("observable from event triggered"),y(o.debugName,{color:"BlueViolet"}),...this.c(s),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(i,n)=>(this.d.get(o).add(i),s.apply(o,[i,n]))}handleAutorunTriggered(o){const s=this.d.get(o);console.log(...this.b([$("autorun"),y(o.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:o._runFn}]}])),s.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let s=o.getDebugName();s===void 0&&(s=""),console.log(...this.b([$("transaction"),y(s,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=M;function A(r){const o=new Array,s=[];let i="";function n(l){if("length"in l)for(const t of l)t&&n(t);else"text"in l?(i+=`%c${l.text}`,o.push(l.style),l.data&&s.push(...l.data)):"data"in l&&s.push(...l.data)}n(r);const c=[i,...o];return c.push(...s),c}function p(r){return y(r,{color:"black"})}function $(r){return y(g(`${r}: `,10),{color:"black",bold:!0})}function y(r,o={color:"black"}){function s(n){return Object.entries(n).reduce((c,[l,t])=>`${c}${l}:${t};`,"")}const i={color:o.color};return o.strikeThrough&&(i["text-decoration"]="line-through"),o.bold&&(i["font-weight"]="bold"),{text:r,style:s(i)}}function T(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?D(r,o):h(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function D(r,o){let s="[ ",i=!0;for(const n of r){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${T(n,o-s.length)}`}return s+=" ]",s}function h(r,o){let s="{ ",i=!0;for(const[n,c]of Object.entries(r)){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${n}: ${T(c,o-s.length)}`}return s+=" }",s}function w(r,o){let s="";for(let i=1;i<=o;i++)s+=r;return s}function g(r,o){for(;r.length<o;)r+=" ";return r}}),define(Pe[132],Ie([1,0,125,130,131]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$3d=e.$Zd=e.$Ud=e.$Td=void 0,e.$Qd=A,e.$Rd=$,e.$Sd=T,e.$Vd=w,e.$Wd=r,e.$Xd=o,e.$Yd=s,e.$1d=n,e.$2d=c,e.$4d=t;let M;function A(a){M=a}let p;function $(a){p=a}let y;function T(a){y=a}class D{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,u){const C=u===void 0?void 0:m,b=u===void 0?m:u;return y({owner:C,debugName:()=>{const v=(0,O.$cd)(b);if(v!==void 0)return v;const E=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(b.toString());if(E)return`${this.debugName}.${E[2]}`;if(!C)return`${this.debugName} (mapped)`},debugReferenceFn:b},v=>b(this.read(v),v))}recomputeInitiallyAndOnChange(m,u){return m.add(M(this,u)),this}keepObserved(m){return m.add(p(this)),this}get a(){return this.get()}}e.$Td=D;class h extends D{constructor(){super(...arguments),this.b=new Set}addObserver(m){const u=this.b.size;this.b.add(m),u===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Ud=h;function w(a,m){const u=new i(a,m);try{a(u)}finally{u.finish()}}let g;function r(a){if(g)a(g);else{const m=new i(a,void 0);g=m;try{a(m)}finally{m.finish(),g=void 0}}}async function o(a,m){const u=new i(a,m);try{await a(u)}finally{u.finish()}}function s(a,m,u){a?m(a):w(m,u)}class i{constructor(m,u){this._fn=m,this.b=u,this.a=[],(0,R.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(m,u){this.a.push({observer:m,observable:u}),m.beginUpdate(u)}finish(){const m=this.a;for(let u=0;u<m.length;u++){const{observer:C,observable:b}=m[u];C.endUpdate(b)}this.a=null,(0,R.$Id)()?.handleEndTransaction()}}e.$Zd=i;function n(a,m){let u;return typeof a=="string"?u=new O.$ad(void 0,a,void 0):u=new O.$ad(a,void 0,void 0),new l(u,m,I.$6c)}function c(a,m){return new l(new O.$ad(a.owner,a.debugName,void 0),m,a.equalsFn??I.$6c)}class l extends h{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,u,C){super(),this.e=m,this.g=C,this.d=u}get(){return this.d}set(m,u,C){if(this.g(this.d,m))return;let b;u||(u=b=new i(()=>{},()=>`Setting ${this.debugName}`));try{const v=this.d;this.h(m),(0,R.$Id)()?.handleObservableChanged(this,{oldValue:v,newValue:m,change:C,didChange:!0,hadValue:!0});for(const d of this.b)u.updateObserver(d,this),d.handleChange(this,C)}finally{b&&b.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$3d=l;function t(a,m){let u;return typeof a=="string"?u=new O.$ad(void 0,a,void 0):u=new O.$ad(a,void 0,void 0),new f(u,m,I.$6c)}class f extends l{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$5d=f}),function(){function le(R){const M=[];typeof R=="number"&&M.push("code/timeOrigin",R);function A($){M.push($,Date.now())}function p(){const $=[];for(let y=0;y<M.length;y+=2)$.push({name:M[y],startTime:M[y+1]});return $}return{mark:A,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(R+A.startTime)});return M}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=I(O))}(),define(Pe[133],Ie([1,0,42]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=void 0;const O=Symbol("unset");class R{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert($,y,T){this.d($,D=>D._value=y,T)}mutate($,y){this.d($,T=>T._value=y(T._value===O?void 0:T._value))}delete($){const y=this.c($);if(!y)return;let T=y.length-1;const D=y[T].node._value;if(D!==O){for(this.b--,y[T].node._value=O;T>0;T--){const{node:h,part:w}=y[T];if(h.children?.size||h._value!==O)break;y[T-1].node.children.delete(w)}return D}}*deleteRecursive($){const y=this.c($);if(!y)return;const T=y[y.length-1].node;for(let D=y.length-1;D>0;D--){const h=y[D-1];if(h.node.children.delete(y[D].part),h.node.children.size>0||h.node._value!==O)break}for(const D of M(T))D._value!==O&&(this.b--,yield D._value)}find($){let y=this.a;for(const T of $){const D=y.children?.get(T);if(!D)return;y=D}return y._value===O?void 0:y._value}hasKeyOrParent($){let y=this.a;for(const T of $){const D=y.children?.get(T);if(!D)return!1;if(D._value!==O)return!0;y=D}return!1}hasKeyOrChildren($){let y=this.a;for(const T of $){const D=y.children?.get(T);if(!D)return!1;y=D}return!0}hasKey($){let y=this.a;for(const T of $){const D=y.children?.get(T);if(!D)return!1;y=D}return y._value!==O}c($){const y=[{part:"",node:this.a}];let T=0;for(const D of $){const h=y[T].node.children?.get(D);if(!h)return;y.push({part:D,node:h}),T++}return y}d($,y,T){let D=this.a;for(const g of $){if(D.children)if(D.children.has(g))D=D.children.get(g);else{const r=new A;D.children.set(g,r),D=r}else{const r=new A;D.children=new Map([[g,r]]),D=r}T?.(D)}const h=D._value===O?0:1;y(D);const w=D._value===O?0:1;this.b+=w-h}*values(){for(const{_value:$}of M(this.a))$!==O&&(yield $)}}e.$oP=R;function*M(p){const $=[p];for(;$.length>0;){const y=$.pop();if(yield y,y.children)for(const T of y.children.values())$.push(T)}}class A{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value($){this._value=$===void 0?O:$}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var O in I)(typeof exports=="object"?exports:le)[O]=I[O]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function I(O){if(e[O])return e[O].exports;var R=e[O]={i:O,l:!1,exports:{}};return le[O].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=le,I.c=e,I.d=function(O,R,M){I.o(O,R)||Object.defineProperty(O,R,{enumerable:!0,get:M})},I.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},I.t=function(O,R){if(1&R&&(O=I(O)),8&R||4&R&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(I.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&R&&typeof O!="string")for(var A in O)I.d(M,A,function(p){return O[p]}.bind(null,A));return M},I.n=function(O){var R=O&&O.__esModule?function(){return O.default}:function(){return O};return I.d(R,"a",R),R},I.o=function(O,R){return Object.prototype.hasOwnProperty.call(O,R)},I.p="",I(I.s=0)}([function(le,e,I){(function(O){var R;e=le.exports=Ne,R=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],y=0,T=y++;$[T]="0|[1-9]\\d*";var D=y++;$[D]="[0-9]+";var h=y++;$[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=y++;$[w]="("+$[T]+")\\.("+$[T]+")\\.("+$[T]+")";var g=y++;$[g]="("+$[D]+")\\.("+$[D]+")\\.("+$[D]+")";var r=y++;$[r]="(?:"+$[T]+"|"+$[h]+")";var o=y++;$[o]="(?:"+$[D]+"|"+$[h]+")";var s=y++;$[s]="(?:-("+$[r]+"(?:\\."+$[r]+")*))";var i=y++;$[i]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var n=y++;$[n]="[0-9A-Za-z-]+";var c=y++;$[c]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var l=y++,t="v?"+$[w]+$[s]+"?"+$[c]+"?";$[l]="^"+t+"$";var f="[v=\\s]*"+$[g]+$[i]+"?"+$[c]+"?",a=y++;$[a]="^"+f+"$";var m=y++;$[m]="((?:<|>)?=?)";var u=y++;$[u]=$[D]+"|x|X|\\*";var C=y++;$[C]=$[T]+"|x|X|\\*";var b=y++;$[b]="[v=\\s]*("+$[C]+")(?:\\.("+$[C]+")(?:\\.("+$[C]+")(?:"+$[s]+")?"+$[c]+"?)?)?";var v=y++;$[v]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[i]+")?"+$[c]+"?)?)?";var d=y++;$[d]="^"+$[m]+"\\s*"+$[b]+"$";var E=y++;$[E]="^"+$[m]+"\\s*"+$[v]+"$";var k=y++;$[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;$[P]="(?:~>?)";var S=y++;$[S]="(\\s*)"+$[P]+"\\s+",p[S]=new RegExp($[S],"g");var W=y++;$[W]="^"+$[P]+$[b]+"$";var V=y++;$[V]="^"+$[P]+$[v]+"$";var q=y++;$[q]="(?:\\^)";var N=y++;$[N]="(\\s*)"+$[q]+"\\s+",p[N]=new RegExp($[N],"g");var B=y++;$[B]="^"+$[q]+$[b]+"$";var K=y++;$[K]="^"+$[q]+$[v]+"$";var ie=y++;$[ie]="^"+$[m]+"\\s*("+f+")$|^$";var ce=y++;$[ce]="^"+$[m]+"\\s*("+t+")$|^$";var ye=y++;$[ye]="(\\s*)"+$[m]+"\\s*("+f+"|"+$[b]+")",p[ye]=new RegExp($[ye],"g");var Se=y++;$[Se]="^\\s*("+$[b]+")\\s+-\\s+("+$[b]+")\\s*$";var fe=y++;$[fe]="^\\s*("+$[v]+")\\s+-\\s+("+$[v]+")\\s*$";var $e=y++;$[$e]="(<|>)?=?\\s*\\*";for(var Te=0;Te<35;Te++)R(Te,$[Te]),p[Te]||(p[Te]=new RegExp($[Te]));function ae(F,G){if(F instanceof Ne)return F;if(typeof F!="string"||F.length>M||!(G?p[a]:p[l]).test(F))return null;try{return new Ne(F,G)}catch{return null}}function Ne(F,G){if(F instanceof Ne){if(F.loose===G)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Ne))return new Ne(F,G);R("SemVer",F,G),this.loose=G;var H=F.trim().match(G?p[a]:p[l]);if(!H)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<A)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=ae,e.valid=function(F,G){var H=ae(F,G);return H?H.version:null},e.clean=function(F,G){var H=ae(F.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Ne,Ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ne.prototype.toString=function(){return this.version},Ne.prototype.compare=function(F){return R("SemVer.compare",this.version,this.loose,F),F instanceof Ne||(F=new Ne(F,this.loose)),this.compareMain(F)||this.comparePre(F)},Ne.prototype.compareMain=function(F){return F instanceof Ne||(F=new Ne(F,this.loose)),z(this.major,F.major)||z(this.minor,F.minor)||z(this.patch,F.patch)},Ne.prototype.comparePre=function(F){if(F instanceof Ne||(F=new Ne(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=F.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return z(H,ee)}while(++G)},Ne.prototype.inc=function(F,G){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},e.inc=function(F,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Ne(F,H).inc(G,ee).version}catch{return null}},e.diff=function(F,G){if(De(F,G))return null;var H=ae(F),ee=ae(G);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=z;var ne=/^[0-9]+$/;function z(F,G){var H=ne.test(F),ee=ne.test(G);return H&&ee&&(F=+F,G=+G),H&&!ee?-1:ee&&!H?1:F<G?-1:F>G?1:0}function x(F,G,H){return new Ne(F,H).compare(new Ne(G,H))}function be(F,G,H){return x(F,G,H)>0}function Fe(F,G,H){return x(F,G,H)<0}function De(F,G,H){return x(F,G,H)===0}function pe(F,G,H){return x(F,G,H)!==0}function ge(F,G,H){return x(F,G,H)>=0}function Q(F,G,H){return x(F,G,H)<=0}function Y(F,G,H,ee){var re;switch(G){case"===":typeof F=="object"&&(F=F.version),typeof H=="object"&&(H=H.version),re=F===H;break;case"!==":typeof F=="object"&&(F=F.version),typeof H=="object"&&(H=H.version),re=F!==H;break;case"":case"=":case"==":re=De(F,H,ee);break;case"!=":re=pe(F,H,ee);break;case">":re=be(F,H,ee);break;case">=":re=ge(F,H,ee);break;case"<":re=Fe(F,H,ee);break;case"<=":re=Q(F,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return re}function he(F,G){if(F instanceof he){if(F.loose===G)return F;F=F.value}if(!(this instanceof he))return new he(F,G);R("comparator",F,G),this.loose=G,this.parse(F),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(F,G){return z(G,F)},e.major=function(F,G){return new Ne(F,G).major},e.minor=function(F,G){return new Ne(F,G).minor},e.patch=function(F,G){return new Ne(F,G).patch},e.compare=x,e.compareLoose=function(F,G){return x(F,G,!0)},e.rcompare=function(F,G,H){return x(G,F,H)},e.sort=function(F,G){return F.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(F,G){return F.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=be,e.lt=Fe,e.eq=De,e.neq=pe,e.gte=ge,e.lte=Q,e.cmp=Y,e.Comparator=he;var ue={};function Me(F,G){if(F instanceof Me)return F.loose===G?F:new Me(F.raw,G);if(F instanceof he)return new Me(F.value,G);if(!(this instanceof Me))return new Me(F,G);if(this.loose=G,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function de(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ce(F,G,H,ee,re,Oe,Ve,Ge,_e,xe,et,tt,it){return((G=de(H)?"":de(ee)?">="+H+".0.0":de(re)?">="+H+"."+ee+".0":">="+G)+" "+(Ge=de(_e)?"":de(xe)?"<"+(+_e+1)+".0.0":de(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+Ge)).trim()}function Ae(F,G){for(var H=0;H<F.length;H++)if(!F[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<F.length;H++)if(R(F[H].semver),F[H].semver!==ue&&F[H].semver.prerelease.length>0){var ee=F[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function je(F,G,H){try{G=new Me(G,H)}catch{return!1}return G.test(F)}function U(F,G,H,ee){var re,Oe,Ve,Ge,_e;switch(F=new Ne(F,ee),G=new Me(G,ee),H){case">":re=be,Oe=Q,Ve=Fe,Ge=">",_e=">=";break;case"<":re=Fe,Oe=ge,Ve=be,Ge="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(F,G,ee))return!1;for(var xe=0;xe<G.set.length;++xe){var et=G.set[xe],tt=null,it=null;if(et.forEach(function(at){at.semver===ue&&(at=new he(">=0.0.0")),tt=tt||at,it=it||at,re(at.semver,tt.semver,ee)?tt=at:Ve(at.semver,it.semver,ee)&&(it=at)}),tt.operator===Ge||tt.operator===_e||(!it.operator||it.operator===Ge)&&Oe(F,it.semver)||it.operator===_e&&Ve(F,it.semver))return!1}return!0}he.prototype.parse=function(F){var G=this.loose?p[ie]:p[ce],H=F.match(G);if(!H)throw new TypeError("Invalid comparator: "+F);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Ne(H[2],this.loose):this.semver=ue},he.prototype.toString=function(){return this.value},he.prototype.test=function(F){return R("Comparator.test",F,this.loose),this.semver===ue||(typeof F=="string"&&(F=new Ne(F,this.loose)),Y(F,this.operator,this.semver,this.loose))},he.prototype.intersects=function(F,G){if(!(F instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Me(F.value,G),je(this.value,H,G);if(F.operator==="")return H=new Me(this.value,G),je(F.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Oe=this.semver.version===F.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Ge=Y(this.semver,"<",F.semver,G)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),_e=Y(this.semver,">",F.semver,G)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ee||re||Oe&&Ve||Ge||_e},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(F){var G=this.loose;F=F.trim(),R("range",F,G);var H=G?p[fe]:p[Se];F=F.replace(H,Ce),R("hyphen replace",F),F=F.replace(p[ye],"$1$2$3"),R("comparator trim",F,p[ye]),F=(F=(F=F.replace(p[S],"$1~")).replace(p[N],"$1^")).split(/\s+/).join(" ");var ee=G?p[ie]:p[ce],re=F.split(" ").map(function(Oe){return function(Ve,Ge){return R("comp",Ve),Ve=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){R("caret",tt,it);var at=it?p[K]:p[B];return tt.replace(at,function(gt,Ue,st,Z,X){var me;return R("caret",tt,gt,Ue,st,Z,X),de(Ue)?me="":de(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(Z)?me=Ue==="0"?">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+".0 <"+(+Ue+1)+".0.0":X?(R("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Z+X+" <"+Ue+"."+st+"."+(+Z+1):">="+Ue+"."+st+"."+Z+X+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Z+X+" <"+(+Ue+1)+".0.0"):(R("no pr"),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Z+" <"+Ue+"."+st+"."+(+Z+1):">="+Ue+"."+st+"."+Z+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Z+" <"+(+Ue+1)+".0.0"),R("caret return",me),me})}(et,xe)}).join(" ")}(Ve,Ge),R("caret",Ve),Ve=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var at=it?p[V]:p[W];return tt.replace(at,function(gt,Ue,st,Z,X){var me;return R("tilde",tt,gt,Ue,st,Z,X),de(Ue)?me="":de(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(Z)?me=">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":X?(R("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=">="+Ue+"."+st+"."+Z+X+" <"+Ue+"."+(+st+1)+".0"):me=">="+Ue+"."+st+"."+Z+" <"+Ue+"."+(+st+1)+".0",R("tilde return",me),me})}(et,xe)}).join(" ")}(Ve,Ge),R("tildes",Ve),Ve=function(_e,xe){return R("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var at=it?p[E]:p[d];return tt.replace(at,function(gt,Ue,st,Z,X,me){R("xRange",tt,gt,Ue,st,Z,X,me);var qe=de(st),we=qe||de(Z),ot=we||de(X);return Ue==="="&&ot&&(Ue=""),qe?gt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&ot?(we&&(Z=0),ot&&(X=0),Ue===">"?(Ue=">=",we?(st=+st+1,Z=0,X=0):ot&&(Z=+Z+1,X=0)):Ue==="<="&&(Ue="<",we?st=+st+1:Z=+Z+1),gt=Ue+st+"."+Z+"."+X):we?gt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(gt=">="+st+"."+Z+".0 <"+st+"."+(+Z+1)+".0"),R("xRange return",gt),gt})}(et,xe)}).join(" ")}(Ve,Ge),R("xrange",Ve),Ve=function(_e,xe){return R("replaceStars",_e,xe),_e.trim().replace(p[$e],"")}(Ve,Ge),R("stars",Ve),Ve}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Oe){return!!Oe.match(ee)})),re=re.map(function(Oe){return new he(Oe,G)})},Me.prototype.intersects=function(F,G){if(!(F instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return F.set.some(function(re){return re.every(function(Oe){return ee.intersects(Oe,G)})})})})},e.toComparators=function(F,G){return new Me(F,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new Ne(F,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],F))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(F,G,H){var ee=null,re=null;try{var Oe=new Me(G,H)}catch{return null}return F.forEach(function(Ve){Oe.test(Ve)&&(ee&&re.compare(Ve)!==-1||(re=new Ne(ee=Ve,H)))}),ee},e.minSatisfying=function(F,G,H){var ee=null,re=null;try{var Oe=new Me(G,H)}catch{return null}return F.forEach(function(Ve){Oe.test(Ve)&&(ee&&re.compare(Ve)!==1||(re=new Ne(ee=Ve,H)))}),ee},e.validRange=function(F,G){try{return new Me(F,G).range||"*"}catch{return null}},e.ltr=function(F,G,H){return U(F,G,"<",H)},e.gtr=function(F,G,H){return U(F,G,">",H)},e.outside=U,e.prerelease=function(F,G){var H=ae(F,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(F,G,H){return F=new Me(F,H),G=new Me(G,H),F.intersects(G)},e.coerce=function(F){if(F instanceof Ne)return F;if(typeof F!="string")return null;var G=F.match(p[k]);return G==null?null:ae((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(le,e){var I,O,R=le.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function p(o){if(I===setTimeout)return setTimeout(o,0);if((I===M||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:M}catch{I=M}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var $,y=[],T=!1,D=-1;function h(){T&&$&&(T=!1,$.length?y=$.concat(y):D=-1,y.length&&w())}function w(){if(!T){var o=p(h);T=!0;for(var s=y.length;s;){for($=y,y=[];++D<s;)$&&$[D].run();D=-1,s=y.length}$=null,T=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(o)}}function g(o,s){this.fun=o,this.array=s}function r(){}R.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new g(o,s)),y.length!==1||T||p(w)},g.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=r,R.addListener=r,R.once=r,R.off=r,R.removeListener=r,R.removeAllListeners=r,R.emit=r,R.prependListener=r,R.prependOnceListener=r,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Pe[134],Ie([1,0,14,6]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=R,e.$re=M,e.$se=A,e.$te=p,e.$ue=y,e.$ve=T,e.$we=D,e.$xe=h,e.$ye=w,e.$ze=g,e.$Ae=r,e.$Be=o,e.$Ce=s,e.$De=i,e.$Ee=n;function R(c){const l=c;return l?typeof l.read=="function":!1}function M(c){const l=c;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}function A(c){const l=c;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function p(c,l){return new $(c,l)}class ${constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,I.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let f;switch(l){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const a=f.indexOf(t);a>=0&&f.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(c,l){const t=[];let f;for(;(f=c.read())!==null;)t.push(f);return l(t)}function T(c,l,t){const f=[];let a;for(;(a=c.read())!==null&&f.length<t;)f.push(a);return a===null&&f.length>0?l(f):{read:()=>{if(f.length>0)return f.shift();if(typeof a<"u"){const m=a;return a=void 0,m}return c.read()}}}function D(c,l){return new Promise((t,f)=>{const a=[];h(c,{onData:m=>{l&&a.push(m)},onError:m=>{l?f(m):t(void 0)},onEnd:()=>{t(l?l(a):void 0)}})})}function h(c,l,t){c.on("error",f=>{t?.isCancellationRequested||l.onError(f)}),c.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),c.on("data",f=>{t?.isCancellationRequested||l.onData(f)})}function w(c,l){return new Promise((t,f)=>{const a=new O.$Tc,m=[],u=v=>{if(m.push(v),m.length>l)return a.dispose(),c.pause(),t({stream:c,buffer:m,ended:!1})},C=v=>(a.dispose(),f(v)),b=()=>(a.dispose(),t({stream:c,buffer:m,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",C))),c.on("error",C),a.add((0,O.$Sc)(()=>c.removeListener("end",b))),c.on("end",b),a.add((0,O.$Sc)(()=>c.removeListener("data",u))),c.on("data",u)})}function g(c,l){const t=p(l);return t.end(c),t}function r(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let l=!1;return{read:()=>l?null:(l=!0,c)}}function s(c,l,t){const f=p(t);return h(c,{onData:a=>f.write(l.data(a)),onError:a=>f.error(l.error?l.error(a):a),onEnd:()=>f.end()}),f}function i(c,l,t){let f=!1;return{read:()=>{const a=l.read();return f?a:(f=!0,a!==null?t([c,a]):c)}}}function n(c,l,t){let f=!1;const a=p(t);return h(l,{onData:m=>f?a.write(m):(f=!0,a.write(t([c,m]))),onError:m=>a.error(m),onEnd:()=>{f||(f=!0,a.write(c)),a.end()}}),a}}),define(Pe[21],Ie([1,0,43,134]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=y,e.$He=T,e.$Ie=D,e.$Je=h,e.$Ke=w,e.$Le=g,e.$Me=r,e.$Ne=o,e.$Oe=s,e.$Pe=i,e.$Qe=n,e.$Re=c,e.$Se=l,e.$Te=t,e.$Ue=f,e.$Ve=a,e.$We=m,e.$Xe=u,e.$Ye=C,e.$Ze=d;const R=typeof Buffer<"u",M=new I.$V(()=>new Uint8Array(256));let A,p;class ${static alloc(k){return R?new $(Buffer.allocUnsafe(k)):new $(new Uint8Array(k))}static wrap(k){return R&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new $(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&R?new $(Buffer.from(k)):(A||(A=new TextEncoder),new $(A.encode(k)))}static fromByteArray(k){const P=$.alloc(k.length);for(let S=0,W=k.length;S<W;S++)P.buffer[S]=k[S];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let V=0,q=k.length;V<q;V++)P+=k[V].byteLength}const S=$.alloc(P);let W=0;for(let V=0,q=k.length;V<q;V++){const N=k[V];S.set(N,W),W+=N.byteLength}return S}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=$.alloc(this.byteLength);return k.set(this),k}toString(){return R?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,P){return new $(this.buffer.subarray(k,P))}set(k,P){if(k instanceof $)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return h(this.buffer,k)}writeUInt32BE(k,P){w(this.buffer,k,P)}readUInt32LE(k){return g(this.buffer,k)}writeUInt32LE(k,P){r(this.buffer,k,P)}readUInt8(k){return o(this.buffer,k)}writeUInt8(k,P){s(this.buffer,k,P)}indexOf(k,P=0){return y(this.buffer,k instanceof $?k.buffer:k,P)}}e.$Fe=$;function y(E,k,P=0){const S=k.byteLength,W=E.byteLength;if(S===0)return 0;if(S===1)return E.indexOf(k[0]);if(S>W-P)return-1;const V=M.value;V.fill(k.length);for(let K=0;K<k.length;K++)V[k[K]]=k.length-K-1;let q=P+k.length-1,N=q,B=-1;for(;q<W;)if(E[q]===k[N]){if(N===0){B=q;break}q--,N--}else q+=Math.max(k.length-N,V[E[q]]),N=k.length-1;return B}function T(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}function D(E,k,P){E[P+0]=k&255,k=k>>>8,E[P+1]=k&255}function h(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}function w(E,k,P){E[P+3]=k,k=k>>>8,E[P+2]=k,k=k>>>8,E[P+1]=k,k=k>>>8,E[P]=k}function g(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}function r(E,k,P){E[P+0]=k&255,k=k>>>8,E[P+1]=k&255,k=k>>>8,E[P+2]=k&255,k=k>>>8,E[P+3]=k&255}function o(E,k){return E[k]}function s(E,k,P){E[P]=k}function i(E){return O.$ue(E,k=>$.concat(k))}function n(E){return O.$Be(E)}function c(E){return O.$we(E,k=>$.concat(k))}async function l(E){return E.ended?$.concat(E.buffer):$.concat([...E.buffer,await c(E.stream)])}function t(E){return O.$ze(E,k=>$.concat(k))}function f(E){return O.$Ce(E,{data:k=>typeof k=="string"?$.fromString(k):$.wrap(k)},k=>$.concat(k))}function a(E){return O.$te(k=>$.concat(k),E)}function m(E,k){return O.$De(E,k,P=>$.concat(P))}function u(E,k){return O.$Ee(E,k,P=>$.concat(P))}function C(E){let k=0,P=0,S=0;const W=new Uint8Array(Math.floor(E.length/4*3)),V=N=>{switch(P){case 3:W[S++]=k|N,P=0;break;case 2:W[S++]=k|N>>>2,k=N<<6,P=3;break;case 1:W[S++]=k|N>>>4,k=N<<4,P=2;break;default:k=N<<2,P=1}};for(let N=0;N<E.length;N++){const B=E.charCodeAt(N);if(B>=65&&B<=90)V(B-65);else if(B>=97&&B<=122)V(B-97+26);else if(B>=48&&B<=57)V(B-48+52);else if(B===43||B===45)V(62);else if(B===47||B===95)V(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${E[N]}`)}}const q=S;for(;P>0;)V(0);return $.wrap(W).slice(0,q)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:E},k=!0,P=!1){const S=P?v:b;let W="";const V=E.byteLength%3;let q=0;for(;q<E.byteLength-V;q+=3){const N=E[q+0],B=E[q+1],K=E[q+2];W+=S[N>>>2],W+=S[(N<<4|B>>>4)&63],W+=S[(B<<2|K>>>6)&63],W+=S[K&63]}if(V===1){const N=E[q+0];W+=S[N>>>2],W+=S[N<<4&63],k&&(W+="==")}else if(V===2){const N=E[q+0],B=E[q+1];W+=S[N>>>2],W+=S[(N<<4|B>>>4)&63],W+=S[B<<2&63],k&&(W+="=")}return W}}),define(Pe[135],Ie([1,0,28,128,13]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=M,e.$zk=p,e.$Ak=$,e.$Bk=D,e.$Ck=C,e.$Dk=b,e.$Ek=S,e.$Fk=W,e.$Gk=V,e.$Hk=q,e.$Ik=x,e.$Kk=pe,e.$Lk=Y,e.$Mk=he;function M(...de){return function(Ce,Ae){for(let je=0,U=de.length;je<U;je++){const F=de[je](Ce,Ae);if(F)return F}return null}}e.$xk=A.bind(void 0,!1),e.$yk=A.bind(void 0,!0);function A(de,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let je;return de?je=R.$yf(Ae,Ce):je=Ae.indexOf(Ce)===0,je?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(de,Ce){const Ae=Ce.toLowerCase().indexOf(de.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+de.length}]}function $(de,Ce){return y(de.toLowerCase(),Ce.toLowerCase(),0,0)}function y(de,Ce,Ae,je){if(Ae===de.length)return[];if(je===Ce.length)return null;if(de[Ae]===Ce[je]){let U=null;return(U=y(de,Ce,Ae+1,je+1))?c({start:je,end:je+1},U):null}return y(de,Ce,Ae,je+1)}function T(de){return 97<=de&&de<=122}function D(de){return 65<=de&&de<=90}function h(de){return 48<=de&&de<=57}function w(de){return de===32||de===9||de===10||de===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>g.add(de.charCodeAt(0)));function r(de){return w(de)||g.has(de)}function o(de,Ce){return de===Ce||r(de)&&r(Ce)}const s=new Map;function i(de){if(s.has(de))return s.get(de);let Ce;const Ae=(0,O.$vk)(de);return Ae&&(Ce=Ae),s.set(de,Ce),Ce}function n(de){return T(de)||D(de)||h(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function l(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++){const je=de.charCodeAt(Ae);if(D(je)||h(je)||Ae>0&&!n(de.charCodeAt(Ae-1)))return Ae}return de.length}function t(de,Ce,Ae,je){if(Ae===de.length)return[];if(je===Ce.length)return null;if(de[Ae]!==Ce[je].toLowerCase())return null;{let U=null,F=je+1;for(U=t(de,Ce,Ae+1,je+1);!U&&(F=l(Ce,F))<Ce.length;)U=t(de,Ce,Ae+1,F),F++;return U===null?null:c({start:je,end:je+1},U)}}function f(de){let Ce=0,Ae=0,je=0,U=0,F=0;for(let Oe=0;Oe<de.length;Oe++)F=de.charCodeAt(Oe),D(F)&&Ce++,T(F)&&Ae++,n(F)&&je++,h(F)&&U++;const G=Ce/de.length,H=Ae/de.length,ee=je/de.length,re=U/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function a(de){const{upperPercent:Ce,lowerPercent:Ae}=de;return Ae===0&&Ce>.6}function m(de){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:je,numericPercent:U}=de;return Ae>.2&&Ce<.8&&je>.6&&U<.2}function u(de){let Ce=0,Ae=0,je=0,U=0;for(let F=0;F<de.length;F++)je=de.charCodeAt(F),D(je)&&Ce++,T(je)&&Ae++,w(je)&&U++;return(Ce===0||Ae===0)&&U===0?de.length<=30:Ce<=5}function C(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!u(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Ae=f(Ce);if(!m(Ae)){if(!a(Ae))return null;Ce=Ce.toLowerCase()}let je=null,U=0;for(de=de.toLowerCase();U<Ce.length&&(je=t(de,Ce,0,U))===null;)U=l(Ce,U+1);return je}function b(de,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let je=null,U=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();U<Ce.length&&(je=v(de,Ce,0,U,Ae),je===null);)U=d(Ce,U+1);return je}function v(de,Ce,Ae,je,U){let F=0;if(Ae===de.length)return[];if(je===Ce.length)return null;if(!o(de.charCodeAt(Ae),Ce.charCodeAt(je))){const ee=i(de.charCodeAt(Ae));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!o(ee[re],Ce.charCodeAt(je+re)))return null;F+=ee.length-1}let G=null,H=je+F+1;if(G=v(de,Ce,Ae+1,H,U),!U)for(;!G&&(H=d(Ce,H))<Ce.length;)G=v(de,Ce,Ae+1,H,U),H++;if(!G)return null;if(de.charCodeAt(Ae)!==Ce.charCodeAt(je)){const ee=i(de.charCodeAt(Ae));if(!ee)return G;for(let re=0;re<ee.length;re++)if(ee[re]!==Ce.charCodeAt(je+re))return G}return c({start:je,end:je+F+1},G)}function d(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++)if(r(de.charCodeAt(Ae))||Ae>0&&r(de.charCodeAt(Ae-1)))return Ae;return de.length}const E=M(e.$yk,C,p),k=M(e.$yk,C,$),P=new I.$Dc(1e4);function S(de,Ce,Ae=!1){if(typeof de!="string"||typeof Ce!="string")return null;let je=P.get(de);je||(je=new RegExp(R.$gf(de),"i"),P.set(de,je));const U=je.exec(Ce);return U?[{start:U.index,end:U.index+U[0].length}]:Ae?k(de,Ce):E(de,Ce)}function W(de,Ce){const Ae=pe(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?q(Ae):null}function V(de,Ce,Ae,je,U,F){const G=Math.min(13,de.length);for(;Ae<G;Ae++){const H=pe(de,Ce,Ae,je,U,F,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,F]}function q(de){if(typeof de>"u")return[];const Ce=[],Ae=de[1];for(let je=de.length-1;je>1;je--){const U=de[je]+Ae,F=Ce[Ce.length-1];F&&F.end===U?F.end=U+1:Ce.push({start:U,end:U+1})}return Ce}const N=128;function B(){const de=[],Ce=[];for(let Ae=0;Ae<=N;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=N;Ae++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Ae=0;Ae<=de;Ae++)Ce[Ae]=0;return Ce}const ie=K(2*N),ce=K(2*N),ye=B(),Se=B(),fe=B(),$e=!1;function Te(de,Ce,Ae,je,U){function F(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let G=` |   |${je.split("").map(H=>F(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=de[H].slice(0,U+1).map(ee=>F(ee.toString(),3)).join("|")+`
`;return G}function ae(de,Ce,Ae,je){de=de.substr(Ce),Ae=Ae.substr(je),console.log(Te(Se,de,de.length,Ae,Ae.length)),console.log(Te(fe,de,de.length,Ae,Ae.length)),console.log(Te(ye,de,de.length,Ae,Ae.length))}function Ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Ae=de.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Qf(Ae)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function z(de,Ce,Ae){return Ce[de]!==Ae[de]}function x(de,Ce,Ae,je,U,F,G=!1){for(;Ce<Ae&&U<F;)de[Ce]===je[U]&&(G&&(ie[Ce]=U),Ce+=1),U+=1;return Ce===Ae}var be;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(be||(be={}));var Fe;(function(de){de.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}de.isDefault=Ce})(Fe||(e.FuzzyScore=Fe={}));class De{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Ae){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Ae}}e.$Jk=De;function pe(de,Ce,Ae,je,U,F,G=De.default){const H=de.length>N?N:de.length,ee=je.length>N?N:je.length;if(Ae>=H||F>=ee||H-Ae>ee-F||!x(Ce,Ae,H,U,F,ee,!0))return;ge(H,ee,Ae,F,Ce,U);let re=1,Oe=1,Ve=Ae,Ge=F;const _e=[!1];for(re=1,Ve=Ae;Ve<H;re++,Ve++){const at=ie[Ve],gt=ce[Ve],Ue=Ve+1<H?ce[Ve+1]:ee;for(Oe=at-F+1,Ge=at;Ge<Ue;Oe++,Ge++){let st=Number.MIN_SAFE_INTEGER,Z=!1;Ge<=gt&&(st=Q(de,Ce,Ve,Ae,je,U,Ge,ee,F,ye[re-1][Oe-1]===0,_e));let X=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=st+Se[re-1][Oe-1]);const me=Ge>at,qe=me?Se[re][Oe-1]+(ye[re][Oe-1]>0?-5:0):0,we=Ge>at+1&&ye[re][Oe-1]>0,ot=we?Se[re][Oe-2]+(ye[re][Oe-2]>0?-5:0):0;if(we&&(!me||ot>=qe)&&(!Z||ot>=X))Se[re][Oe]=ot,fe[re][Oe]=3,ye[re][Oe]=0;else if(me&&(!Z||qe>=X))Se[re][Oe]=qe,fe[re][Oe]=2,ye[re][Oe]=0;else if(Z)Se[re][Oe]=X,fe[re][Oe]=1,ye[re][Oe]=ye[re-1][Oe-1]+1;else throw new Error("not possible")}}if($e&&ae(de,Ae,je,F),!_e[0]&&!G.firstMatchCanBeWeak)return;re--,Oe--;const xe=[Se[re][Oe],F];let et=0,tt=0;for(;re>=1;){let at=Oe;do{const gt=fe[re][at];if(gt===3)at=at-2;else if(gt===2)at=at-1;else break}while(at>=1);et>1&&Ce[Ae+re-1]===U[F+Oe-1]&&!z(at+F-1,je,U)&&et+1>ye[re][at]&&(at=Oe),at===Oe?et++:et=1,tt||(tt=at),re--,Oe=at-1,xe.push(Oe)}ee-F===H&&G.boostFullMatch&&(xe[0]+=2);const it=tt-H;return xe[0]-=it,xe}function ge(de,Ce,Ae,je,U,F){let G=de-1,H=Ce-1;for(;G>=Ae&&H>=je;)U[G]===F[H]&&(ce[G]=H,G--),H--}function Q(de,Ce,Ae,je,U,F,G,H,ee,re,Oe){if(Ce[Ae]!==F[G])return Number.MIN_SAFE_INTEGER;let Ve=1,Ge=!1;return G===Ae-je?Ve=de[Ae]===U[G]?7:5:z(G,U,F)&&(G===0||!z(G-1,U,F))?(Ve=de[Ae]===U[G]?7:5,Ge=!0):Ne(F,G)&&(G===0||!Ne(F,G-1))?Ve=5:(Ne(F,G-1)||ne(F,G-1))&&(Ve=5,Ge=!0),Ve>1&&Ae===je&&(Oe[0]=!0),Ge||(Ge=z(G,U,F)||Ne(F,G-1)||ne(F,G-1)),Ae===je?G>ee&&(Ve-=Ge?3:5):re?Ve+=Ge?2:0:Ve+=Ge?0:1,G+1===H&&(Ve-=Ge?3:5),Ve}function Y(de,Ce,Ae,je,U,F,G){return ue(de,Ce,Ae,je,U,F,!0,G)}function he(de,Ce,Ae,je,U,F,G){return ue(de,Ce,Ae,je,U,F,!1,G)}function ue(de,Ce,Ae,je,U,F,G,H){let ee=pe(de,Ce,Ae,je,U,F,H);if(ee&&!G)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Oe=Ae+1;Oe<re;Oe++){const Ve=Me(de,Oe);if(Ve){const Ge=pe(Ve,Ve.toLowerCase(),Ae,je,U,F,H);Ge&&(Ge[0]-=3,(!ee||Ge[0]>ee[0])&&(ee=Ge))}}}return ee}function Me(de,Ce){if(Ce+1>=de.length)return;const Ae=de[Ce],je=de[Ce+1];if(Ae!==je)return de.slice(0,Ce)+je+Ae+de.slice(Ce+2)}}),define(Pe[33],Ie([1,0,13]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(O||(O={})),function(R){const M="error",A="warning",p="warn",$="info",y="ignore";function T(h){return h?I.$xf(M,h)?R.Error:I.$xf(A,h)||I.$xf(p,h)?R.Warning:I.$xf($,h)?R.Info:R.Ignore:R.Ignore}R.fromValue=T;function D(h){switch(h){case R.Error:return M;case R.Warning:return A;case R.Info:return $;default:return y}}R.toString=D}(O||(O={})),e.default=O}),define(Pe[136],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(Pe[54],Ie([1,0,18,13]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const g=w.charCodeAt(0),r=this.b.charCodeAt(this.c);return g-r}value(){return this.b[this.c]}}e.$yi=R;class M{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,O.$rf)(w,this.b,0,w.length,this.c,this.d):(0,O.$tf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=M;class A{constructor(w=!0,g=!0){this.f=w,this.g=g}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let g=w.length-1;g>=0;g--,this.c--){const r=this.b.charCodeAt(g);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,O.$rf)(w,this.b,0,w.length,this.d,this.e):(0,O.$tf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=A;var p;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(w,g){this.f=w,this.g=g,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,O.$sf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,O.$sf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,O.$qf)(w,this.c.query);if(this.d[this.e]===5)return(0,O.$qf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(T||(T={}));class D{static forUris(w=()=>!1,g=()=>!1){return new D(new $(w,g))}static forPaths(w=!1){return new D(new A(void 0,!w))}static forStrings(){return new D(new R)}static forConfigKeys(){return new D(new M)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,g){if(g){const r=g.slice(0);(0,I.$Wb)(r);for(const o of r)this.set(o,w)}else{const r=w.slice(0);(0,I.$Wb)(r);for(const o of r)this.set(o[0],o[1])}}set(w,g){const r=this.b.reset(w);let o;this.c||(this.c=new y,this.c.segment=r.value());const s=[];for(o=this.c;;){const n=r.cmp(o.segment);if(n>0)o.left||(o.left=new y,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(n<0)o.right||(o.right=new y,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new y,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const i=o.value;o.value=g,o.key=w;for(let n=s.length-1;n>=0;n--){const c=s[n][1];c.updateHeight();const l=c.balanceFactor();if(l<-1||l>1){const t=s[n][0],f=s[n+1][0];if(t===1&&f===1)s[n][1]=c.rotateLeft();else if(t===-1&&f===-1)s[n][1]=c.rotateRight();else if(t===1&&f===-1)c.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=c.rotateLeft();else if(t===-1&&f===1)c.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const g=this.b.reset(w);let r=this.c;for(;r;){const o=g.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(g.hasNext())g.next(),r=r.mid;else break}return r}has(w){const g=this.d(w);return!(g?.value===void 0&&g?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,g){const r=this.b.reset(w),o=[];let s=this.c;for(;s;){const i=r.cmp(s.segment);if(i>0)o.push([-1,s]),s=s.left;else if(i<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(g?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:c,segment:l}=i;this.e(i.key,!1),s.key=n,s.value=c,s.segment=l}}else{const i=s.left??s.right;if(o.length>0){const[n,c]=o[o.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=o.length-1;i>=0;i--){const n=o[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),o[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),o[i][1]=n.rotateRight()),i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const g=this.b.reset(w);let r=this.c,o;for(;r;){const s=g.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(g.hasNext())g.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(w){return this.g(w,!1)}g(w,g){const r=this.b.reset(w);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):g?o.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[g,r]of this)w(r,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const g=[];return this.j(w,g),g[Symbol.iterator]()}j(w,g){w&&(w.left&&this.j(w.left,g),w.value&&g.push([w.key,w.value]),w.mid&&this.j(w.mid,g),w.right&&this.j(w.right,g))}_isBalanced(){const w=g=>{if(!g)return!0;const r=g.balanceFactor();return r<-1||r>1?!1:w(g.left)&&w(g.right)};return w(this.c)}}e.$Ci=D}),define(Pe[36],Ie([1,0,92]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=R;var O;(function(A){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=p})(O||(e.ThemeColor=O={}));function R(A){return{id:A}}var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(i){const n=p.exec(i.id);if(!n)return $(I.$Vj.error);const[,c,l]=n,t=["codicon","codicon-"+c];return l&&t.push("codicon-modifier-"+l.substring(1)),t}A.asClassNameArray=$;function y(i){return $(i).join(" ")}A.asClassName=y;function T(i){return"."+$(i).join(".")}A.asCSSSelector=T;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}A.isThemeIcon=D;const h=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(i){const n=h.exec(i);if(!n)return;const[,c]=n;return{id:c}}A.fromString=w;function g(i){return{id:i}}A.fromId=g;function r(i,n){let c=i.id;const l=c.lastIndexOf("~");return l!==-1&&(c=c.substring(0,l)),n&&(c=`${c}~${n}`),{id:c}}A.modify=r;function o(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}A.getModifier=o;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}A.isEqual=s})(M||(e.ThemeIcon=M={}))}),define(Pe[137],Ie([1,0,135,13,36]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=$,e.$Ok=T,e.$Pk=h,e.$Qk=w,e.$Rk=r,e.$Sk=o;const M="$(",A=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${A.source}`,"g");function $(s){return s.replace(p,(i,n)=>n?i:`\\${i}`)}const y=new RegExp(`\\\\${A.source}`,"g");function T(s){return s.replace(y,i=>`\\${i}`)}const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function h(s){return s.indexOf(M)===-1?s:s.replace(D,(i,n,c,l)=>c?i:n||l||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const g=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){g.lastIndex=0;let i="";const n=[];let c=0;for(;;){const l=g.lastIndex,t=g.exec(s),f=s.substring(l,t?.index);if(f.length>0){i+=f;for(let a=0;a<f.length;a++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function o(s,i,n=!1){const{text:c,iconOffsets:l}=i;if(!l||l.length===0)return(0,I.$Ek)(s,c,n);const t=(0,O.$ef)(c," "),f=c.length-t.length,a=(0,I.$Ek)(s,t,n);if(a)for(const m of a){const u=l[m.start+f]+f;m.start+=u,m.end+=u}return a}}),define(Pe[34],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=O;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(R){return I.test(R)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const M=new Uint8Array(16),A=[];for(let p=0;p<256;p++)A.push(p.toString(16).padStart(2,"0"));return function(){R(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let $=0,y="";return y+=A[M[$++]],y+=A[M[$++]],y+=A[M[$++]],y+=A[M[$++]],y+="-",y+=A[M[$++]],y+=A[M[$++]],y+="-",y+=A[M[$++]],y+=A[M[$++]],y+="-",y+=A[M[$++]],y+=A[M[$++]],y+="-",y+=A[M[$++]],y+=A[M[$++]],y+=A[M[$++]],y+=A[M[$++]],y+=A[M[$++]],y+=A[M[$++]],y}}()}),define(Pe[138],Ie([1,0,18,42,34]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=M,e.$Rt=A,e.$Tt=y;function M(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}function A(D,h,w){const g={id:(0,R.$Sg)(),name:D,uri:h,data:w};return{asString:async()=>"",asFile:()=>g,value:void 0}}class p{constructor(){this.a=new Map}get size(){let h=0;for(const w of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const w=[...this.a.keys()];return O.Iterable.some(this,([g,r])=>r.asFile())&&w.push("files"),T($(h),w)}get(h){return this.a.get(this.b(h))?.[0]}append(h,w){const g=this.a.get(h);g?g.push(w):this.a.set(this.b(h),[w])}replace(h,w){this.a.set(this.b(h),[w])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,w]of this.a)for(const g of w)yield[h,g]}b(h){return $(h)}}e.$St=p;function $(D){return D.toLowerCase()}function y(D,h){return T($(D),h.map($))}function T(D,h){if(D==="*/*")return h.length>0;if(h.includes(D))return!0;const w=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[g,r,o]=w;return o==="*"?h.some(s=>s.startsWith(r+"/")):!1}e.$Ut=Object.freeze({create:D=>(0,I.$Mb)(D.map(h=>h.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ut.split(D).filter(h=>!h.startsWith("#"))})}),define(Pe[139],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=O;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function O(R){let M=0,A=0,p=0,$=0;for(let y=0,T=R.length;y<T;y++){const D=R.charCodeAt(y);D===13?(M===0&&(A=y),M++,y+1<T&&R.charCodeAt(y+1)===10?($|=2,y++):$|=3,p=y+1):D===10&&($|=1,M===0&&(A=y),M++,p=y+1)}return M===0&&(A=R.length),[M,A,R.length-p,$]}}),define(Pe[140],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[141],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,y=p.notIn.length;$<y;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const y=p.findTokenIndexAtOffset($-2),T=p.getStandardTokenType(y);return this.isOK(T)}g(p,$){for(let y=p;y<=$;y++){const T=String.fromCharCode(y);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=O;class R{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)M(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),M(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),M(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),M(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&M(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$lu=R;function M(A,p,$){A.has(p)?A.get(p).push($):A.set(p,[$])}}),define(Pe[142],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.NodeColor=e.$FC=void 0,e.$HC=R,e.$IC=M,e.$JC=y,e.$KC=T,e.$LC=D,e.$MC=h,e.$NC=w,e.$OC=g;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$GC)return R(this.right);let o=this;for(;o.parent!==e.$GC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$GC?e.$GC:o.parent}prev(){if(this.left!==e.$GC)return M(this.left);let o=this;for(;o.parent!==e.$GC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$GC?e.$GC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$FC=I;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$GC=new I(null,0),e.$GC.parent=e.$GC,e.$GC.left=e.$GC,e.$GC.right=e.$GC,e.$GC.color=0;function R(r){for(;r.left!==e.$GC;)r=r.left;return r}function M(r){for(;r.right!==e.$GC;)r=r.right;return r}function A(r){return r===e.$GC?0:r.size_left+r.piece.length+A(r.right)}function p(r){return r===e.$GC?0:r.lf_left+r.piece.lineFeedCnt+p(r.right)}function $(){e.$GC.parent=e.$GC}function y(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$GC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$GC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function T(r,o){const s=o.left;o.left=s.right,s.right!==e.$GC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$GC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function D(r,o){let s,i;if(o.left===e.$GC?(i=o,s=i.right):o.right===e.$GC?(i=o,s=i.left):(i=R(o.right),s=i.right),i===r.root){r.root=s,s.color=0,o.detach(),$(),r.root.parent=e.$GC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===o?(s.parent=i.parent,g(r,s)):(i.parent===o?s.parent=i:s.parent=i.parent,g(r,s),i.left=o.left,i.right=o.right,i.parent=o.parent,i.color=o.color,o===r.root?r.root=i:o===o.parent.left?o.parent.left=i:o.parent.right=i,i.left!==e.$GC&&(i.left.parent=i),i.right!==e.$GC&&(i.right.parent=i),i.size_left=o.size_left,i.lf_left=o.lf_left,g(r,i)),o.detach(),s.parent.left===s){const l=A(s),t=p(s);if(l!==s.parent.size_left||t!==s.parent.lf_left){const f=l-s.parent.size_left,a=t-s.parent.lf_left;s.parent.size_left=l,s.parent.lf_left=t,w(r,s.parent,f,a)}}if(g(r,s.parent),n){$();return}let c;for(;s!==r.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,y(r,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(r,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,y(r,s.parent),s=r.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,T(r,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,y(r,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,T(r,s.parent),s=r.root));s.color=0,$()}function h(r,o){for(g(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,y(r,o)),o.parent.color=0,o.parent.parent.color=1,T(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(r,o)),o.parent.color=0,o.parent.parent.color=1,y(r,o.parent.parent))}r.root.color=0}function w(r,o,s,i){for(;o!==r.root&&o!==e.$GC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}function g(r,o){let s=0,i=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=A(o.left)-o.size_left,i=p(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=i;o!==r.root&&(s!==0||i!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}}}),define(Pe[93],Ie([1,0,94,30,95,142,96]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=void 0,e.$VC=T,e.$WC=D;const p=65535;function $(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,n,c,l,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=l,this.isBasicASCII=t}}function T(s,i=!0){const n=[0];let c=1;for(let l=0,t=s.length;l<t;l++){const f=s.charCodeAt(l);f===13?l+1<t&&s.charCodeAt(l+1)===10?(n[c++]=l+2,l++):n[c++]=l+1:f===10&&(n[c++]=l+1)}return i?$(n):n}function D(s,i){s.length=0,s[0]=0;let n=1,c=0,l=0,t=0,f=!0;for(let m=0,u=i.length;m<u;m++){const C=i.charCodeAt(m);C===13?m+1<u&&i.charCodeAt(m+1)===10?(t++,s[n++]=m+2,m++):(c++,s[n++]=m+1):C===10?(l++,s[n++]=m+1):f&&C!==9&&(C<32||C>126)&&(f=!1)}const a=new y($(s),c,l,t,f);return s.length=0,a}class h{constructor(i,n,c,l,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=l,this.length=t}}e.$XC=h;class w{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$YC=w;class g{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==M.$GC&&i.iterate(i.root,c=>(c!==M.$GC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let l=0;l<c.length;l++){const t=c[l];if(t.node.parent===null||t.nodeStartOffset>=i){c[l]=null,n=!0;continue}}if(n){const l=[];for(const t of c)t!==null&&l.push(t);this.b=l}}}class o{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=M.$GC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let l=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=T(i[t].buffer));const a=new h(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),l=this.S(l,a)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,c=n-Math.floor(n/3),l=c*2;let t="",f=0;const a=[];if(this.iterate(this.root,m=>{const u=this.R(m),C=u.length;if(f<=c||f+C<l)return t+=u,f+=C,!0;const b=t.replace(/\r\n|\r|\n/g,i);return a.push(new w(b,T(b))),t=u,f=C,!0}),f>0){const m=t.replace(/\r\n|\r|\n/g,i);a.push(new w(m,T(m)))}this.create(a,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new g(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,l=>{if(l===M.$GC)return!0;const t=this.R(l),f=t.length,a=i.G(n),m=i.G(n+f),u=i.getValueInRange2(a,m);return n+=f,t===u})}getOffsetAt(i,n){let c=0,l=this.root;for(;l!==M.$GC;)if(l.left!==M.$GC&&l.lf_left+1>=i)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=i){c+=l.size_left;const t=this.B(l,i-l.lf_left-2);return c+=t+n-1}else i-=l.lf_left+l.piece.lineFeedCnt,c+=l.size_left+l.piece.length,l=l.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const l=i;for(;n!==M.$GC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(c+1,1),a=l-f;return new I.$tt(c+1,a+1)}return new I.$tt(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===M.$GC){const t=this.getOffsetAt(c+1,1),f=l-i-t;return new I.$tt(c+1,f+1)}else n=n.right;return new I.$tt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),l=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,l);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,m=this.a[a.piece.bufferIndex].buffer,u=this.u(a.piece.bufferIndex,a.piece.start);return m.substring(u+i.remainder,u+n.remainder)}let c=i.node;const l=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let f=l.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==M.$GC;){const a=this.a[c.piece.bufferIndex].buffer,m=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){f+=a.substring(m,m+n.remainder);break}else f+=a.substr(m,c.piece.length);c=c.next()}return f}getLinesContent(){const i=[];let n=0,c="",l=!1;return this.iterate(this.root,t=>{if(t===M.$GC)return!0;const f=t.piece;let a=f.length;if(a===0)return!0;const m=this.a[f.bufferIndex].buffer,u=this.a[f.bufferIndex].lineStarts,C=f.start.line,b=f.end.line;let v=u[C]+f.start.column;if(l&&(m.charCodeAt(v)===10&&(v++,a--),i[n++]=c,c="",l=!1,a===0))return!0;if(C===b)return!this.f&&m.charCodeAt(v+a-1)===13?(l=!0,c+=m.substr(v,a-1)):c+=m.substr(v,a),!0;c+=this.f?m.substring(v,Math.max(v,u[C+1]-this.e)):m.substring(v,u[C+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let d=C+1;d<b;d++)c=this.f?m.substring(u[d],u[d+1]-this.e):m.substring(u[d],u[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&m.charCodeAt(u[b]+f.end.column-1)===13?(l=!0,f.end.column===0?n--:c=m.substr(u[b],f.end.column-1)):c=m.substr(u[b],f.end.column),!0}),l&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(l)}else{const n=this.a[i.node.piece.bufferIndex],l=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(l)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,l,t,f,a,m,u,C,b){const v=this.a[i.piece.bufferIndex],d=this.u(i.piece.bufferIndex,i.piece.start),E=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,f);let P;const S={line:0,column:0};let W,V;n._wordSeparators?(W=v.buffer.substring(E,k),V=q=>q+E,n.reset(0)):(W=v.buffer,V=q=>q,n.reset(E));do if(P=n.next(W),P){if(V(P.index)>=k)return C;this.s(i,V(P.index)-d,S);const q=this.t(i.piece.bufferIndex,t,S),N=S.line===t.line?S.column-t.column+l:S.column+1,B=N+P[0].length;if(b[C++]=(0,A.$RC)(new O.$ut(c+q,N,c+q,B),P,m),V(P.index)+P[0].length>=k||C>=u)return C}while(P);return C}findMatchesLineByLine(i,n,c,l){const t=[];let f=0;const a=new A.$UC(n.wordSeparators,n.regex);let m=this.H(i.startLineNumber,i.startColumn);if(m===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let C=this.s(m.node,m.remainder);const b=this.s(u.node,u.remainder);if(m.node===u.node)return this.findMatchesInNode(m.node,a,i.startLineNumber,i.startColumn,C,b,n,c,l,f,t),t;let v=i.startLineNumber,d=m.node;for(;d!==u.node;){const k=this.t(d.piece.bufferIndex,C,d.piece.end);if(k>=1){const S=this.a[d.piece.bufferIndex].lineStarts,W=this.u(d.piece.bufferIndex,d.piece.start),V=S[C.line+k],q=v===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(d,a,v,q,C,this.s(d,V-W),n,c,l,f,t),f>=l)return t;v+=k}const P=v===i.startLineNumber?i.startColumn-1:0;if(v===i.endLineNumber){const S=this.getLineContent(v).substring(P,i.endColumn-1);return f=this.n(n,a,S,i.endLineNumber,P,f,t,c,l),t}if(f=this.n(n,a,this.getLineContent(v).substr(P),v,P,f,t,c,l),f>=l)return t;v++,m=this.H(v,1),d=m.node,C=this.s(m.node,m.remainder)}if(v===i.endLineNumber){const k=v===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(v).substring(k,i.endColumn-1);return f=this.n(n,a,P,i.endLineNumber,k,f,t,c,l),t}const E=v===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(u.node,a,v,E,C,b,n,c,l,f,t),t}n(i,n,c,l,t,f,a,m,u){const C=i.wordSeparators;if(!m&&i.simpleSearch){const v=i.simpleSearch,d=v.length,E=c.length;let k=-d;for(;(k=c.indexOf(v,k+d))!==-1;)if((!C||(0,A.$TC)(C,c,E,k,d))&&(a[f++]=new R.$Fv(new O.$ut(l,k+1+t,l,k+1+d+t),null),f>=u))return f;return f}let b;n.reset(0);do if(b=n.next(c),b&&(a[f++]=(0,A.$RC)(new O.$ut(l,b.index+1+t,l,b.index+1+b[0].length+t),b,m),f>=u))return f;while(b);return f}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$GC){const{node:l,remainder:t,nodeStartOffset:f}=this.G(i),a=l.piece,m=a.bufferIndex,u=this.s(l,t);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&f+a.length===i&&n.length<p){this.F(l,n),this.y();return}if(f===i)this.o(n,l),this.h.validate(i);else if(f+l.piece.length>i){const C=[];let b=new h(a.bufferIndex,u,a.end,this.t(a.bufferIndex,u,a.end),this.u(m,a.end)-this.u(m,u));if(this.K()&&this.M(n)&&this.I(l,t)===10){const k={line:b.start.line+1,column:0};b=new h(b.bufferIndex,k,b.end,this.t(b.bufferIndex,k,b.end),b.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(l,t-1)===13){const k=this.s(l,t-1);this.C(l,k),n="\r"+n,l.piece.length===0&&C.push(l)}else this.C(l,u);else this.C(l,u);const v=this.w(n);b.length>0&&this.S(l,b);let d=l;for(let E=0;E<v.length;E++)d=this.S(d,v[E]);this.v(C)}else this.q(n,l)}else{const l=this.w(n);let t=this.T(null,l[0]);for(let f=1;f<l.length;f++)t=this.S(t,l[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===M.$GC)return;const c=this.G(i),l=this.G(i+n),t=c.node,f=l.node;if(t===f){const v=this.s(t,c.remainder),d=this.s(t,l.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const E=t.next();(0,M.$LC)(this,t),this.N(E),this.y();return}this.D(t,d),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,v),this.O(t),this.y();return}this.E(t,v,d),this.y();return}const a=[],m=this.s(t,c.remainder);this.C(t,m),this.h.validate(i),t.piece.length===0&&a.push(t);const u=this.s(f,l.remainder);this.D(f,u),f.piece.length===0&&a.push(f);const C=t.next();for(let v=C;v!==M.$GC&&v!==f;v=v.next())a.push(v);const b=t.piece.length===0?t.prev():t;this.v(a),this.O(b),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,a={line:f.start.line+1,column:0},m=new h(f.bufferIndex,a,f.end,this.t(f.bufferIndex,a,f.end),f.length-1);n.piece=m,i+=`
`,(0,M.$NC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const l=this.w(i);let t=this.T(n,l[l.length-1]);for(let f=l.length-2;f>=0;f--)t=this.T(t,l[f]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),l=this.S(n,c[0]);let t=l;for(let f=1;f<c.length;f++)t=this.S(t,c[f]);this.N(l)}s(i,n,c){const l=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,m=f[l.start.line]+l.start.column+n;let u=l.start.line,C=l.end.line,b=0,v=0,d=0;for(;u<=C&&(b=u+(C-u)/2|0,d=f[b],b!==C);)if(v=f[b+1],m<d)C=b-1;else if(m>=v)u=b+1;else break;return c?(c.line=b,c.column=m-d,null):{line:b,column:m-d}}t(i,n,c){if(c.column===0)return c.line-n.line;const l=this.a[i].lineStarts;if(c.line===l.length-1)return c.line-n.line;const t=l[c.line+1],f=l[c.line]+c.column;if(t>f+1)return c.line-n.line;const a=f-1;return this.a[i].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,M.$LC)(this,i[n])}w(i){if(i.length>p){const C=[];for(;i.length>p;){const v=i.charCodeAt(p-1);let d;v===13||v>=55296&&v<=56319?(d=i.substring(0,p-1),i=i.substring(p-1)):(d=i.substring(0,p),i=i.substring(p));const E=T(d);C.push(new h(this.a.length,{line:0,column:0},{line:E.length-1,column:d.length-E[E.length-1]},E.length-1,d.length)),this.a.push(new w(d,E))}const b=T(i);return C.push(new h(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new w(i,b)),C}let n=this.a[0].buffer.length;const c=T(i,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let C=0;C<c.length;C++)c[C]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let C=0;C<c.length;C++)c[C]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[f],m={line:f,column:a},u=new h(0,l,m,this.t(0,l,m),t-n);return this.g=m,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,l="";const t=this.h.get2(i);if(t){c=t.node;const f=this.B(c,i-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,m=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)l=a.substring(m+f,m+c.piece.length);else{const u=this.B(c,i-t.nodeStartLineNumber);return a.substring(m+f,m+u-n)}}else{let f=0;const a=i;for(;c!==M.$GC;)if(c.left!==M.$GC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const m=this.B(c,i-c.lf_left-2),u=this.B(c,i-c.lf_left-1),C=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);return f+=c.size_left,this.h.set({node:c,nodeStartOffset:f,nodeStartLineNumber:a-(i-1-c.lf_left)}),C.substring(b+m,b+u-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const m=this.B(c,i-c.lf_left-2),u=this.a[c.piece.bufferIndex].buffer,C=this.u(c.piece.bufferIndex,c.piece.start);l=u.substring(C+m,C+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,f+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$GC;){const f=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),m=this.u(c.piece.bufferIndex,c.piece.start);return l+=f.substring(m,m+a-n),l}else{const a=this.u(c.piece.bufferIndex,c.piece.start);l+=f.substr(a,c.piece.length)}c=c.next()}return l}y(){let i=this.root,n=1,c=0;for(;i!==M.$GC;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,l=this.s(i,n),t=l.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const f=this.t(i.piece.bufferIndex,c.start,l);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:l.column}}B(i,n){if(n<0)return 0;const c=i.piece,l=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?l[c.end.line]+c.end.column-l[c.start.line]-c.start.column:l[t]-l[c.start.line]-c.start.column}C(i,n){const c=i.piece,l=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),f=n,a=this.u(c.bufferIndex,f),m=this.t(c.bufferIndex,c.start,f),u=m-l,C=a-t,b=c.length+C;i.piece=new h(c.bufferIndex,c.start,f,m,b),(0,M.$NC)(this,i,C,u)}D(i,n){const c=i.piece,l=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),f=n,a=this.t(c.bufferIndex,f,c.end),m=this.u(c.bufferIndex,f),u=a-l,C=t-m,b=c.length+C;i.piece=new h(c.bufferIndex,f,c.end,a,b),(0,M.$NC)(this,i,C,u)}E(i,n,c){const l=i.piece,t=l.start,f=l.end,a=l.length,m=l.lineFeedCnt,u=n,C=this.t(l.bufferIndex,l.start,u),b=this.u(l.bufferIndex,n)-this.u(l.bufferIndex,t);i.piece=new h(l.bufferIndex,l.start,u,C,b),(0,M.$NC)(this,i,b-a,C-m);const v=new h(l.bufferIndex,c,f,this.t(l.bufferIndex,c,f),this.u(l.bufferIndex,f)-this.u(l.bufferIndex,c)),d=this.S(i,v);this.N(d)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),l=this.a[0].buffer.length;this.a[0].buffer+=n;const t=T(n,!1);for(let d=0;d<t.length;d++)t[d]+=l;if(c){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[f],m={line:f,column:a},u=i.piece.length+n.length,C=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,m),v=b-C;i.piece=new h(i.piece.bufferIndex,i.piece.start,m,b,u),this.g=m,(0,M.$NC)(this,i,n.length,v)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let l=0;for(;n!==M.$GC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){l+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:l};return this.h.set(t),t}else i-=n.size_left+n.piece.length,l+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,l=0;for(;c!==M.$GC;)if(c.left!==M.$GC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),f=this.B(c,i-c.lf_left-1);return l+=c.size_left,{node:c,remainder:Math.min(t+n-1,f),nodeStartOffset:l}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:l};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,l+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$GC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),f=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],l=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(l)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===M.$GC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,l=n.start.line,t=c[l]+n.start.column;return l===c.length-1||c[l+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===M.$GC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],l=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:l[i.piece.end.line]-l[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new h(i.piece.bufferIndex,i.piece.start,t,a,f),(0,M.$NC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const m={line:n.piece.start.line+1,column:0},u=n.piece.length-1,C=this.t(n.piece.bufferIndex,m,n.piece.end);n.piece=new h(n.piece.bufferIndex,m,n.piece.end,C,u),(0,M.$NC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const b=this.w(`\r
`);this.S(i,b[0]);for(let v=0;v<c.length;v++)(0,M.$LC)(this,c[v])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,M.$LC)(this,c);else{const l=c.piece,t={line:l.start.line+1,column:0},f=l.length-1,a=this.t(l.bufferIndex,t,l.end);c.piece=new h(l.bufferIndex,t,l.end,a,f),(0,M.$NC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===M.$GC)return n(M.$GC);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===M.$GC)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,l=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(l,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),l=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,l)}S(i,n){const c=new M.$FC(n,1);if(c.left=M.$GC,c.right=M.$GC,c.parent=M.$GC,c.size_left=0,c.lf_left=0,this.root===M.$GC)this.root=c,c.color=0;else if(i.right===M.$GC)i.right=c,c.parent=i;else{const t=(0,M.$HC)(i.right);t.left=c,c.parent=t}return(0,M.$MC)(this,c),c}T(i,n){const c=new M.$FC(n,1);if(c.left=M.$GC,c.right=M.$GC,c.parent=M.$GC,c.size_left=0,c.lf_left=0,this.root===M.$GC)this.root=c,c.color=0;else if(i.left===M.$GC)i.left=c,c.parent=i;else{const l=(0,M.$IC)(i.left);l.right=c,c.parent=l}return(0,M.$MC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$ZC=o}),define(Pe[143],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$=e.$v$=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$v$=I;class O{constructor(M){this.identifier=M}}e.$w$=O}),define(Pe[144],Ie([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Pe[145],Ie([1,0,5,6,144]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=T;class M extends O.$Uc{constructor(h,w="",g="",r=!0,o){super(),this.h=this.B(new I.$de),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=w,this.u=g,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,w){this.C&&await this.C(h)}}e.$bj=M;class A extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$de),this.onWillRun=this.f.event,this.m=this.B(new I.$de),this.onDidRun=this.m.event}async run(h,w){if(!h.enabled)return;this.f.fire({action:h});let g;try{await this.u(h,w)}catch(r){g=r}this.m.fire({action:h,error:g})}async u(h,w){await h.run(w)}}e.$cj=A;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let w=[];for(const g of h)g.length&&(w.length?w=[...w,new p,...g]:w=g);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=p;class ${get actions(){return this.a}constructor(h,w,g,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=w,this.class=r,this.a=g}async run(){}}e.$ej=$;class y extends M{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,R.localize(0,null),void 0,!1)}}e.$fj=y;function T(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...h)=>D.run(...h),tooltip:D.label}}}),define(Pe[146],Ie([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Pe[147],Ie([1,0,146]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=y,e.$3m=T,e.$4m=D;const O=60,R=O*60,M=R*24,A=M*7,p=M*30,$=M*365;function y(h,w,g,r){typeof h!="number"&&(h=h.getTime());const o=Math.round((new Date().getTime()-h)/1e3);if(o<-30)return(0,I.localize)(0,null,y(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<O?(s=o,w?s===1?g?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):g?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?g?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):g?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<R?(s=Math.floor(o/O),w?s===1?g?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):g?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?g?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):g?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<M?(s=Math.floor(o/R),w?s===1?g?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):g?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?g?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):g?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<A?(s=Math.floor(o/M),w?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<p?(s=Math.floor(o/A),w?s===1?g?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):g?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?g?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):g?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<$?(s=Math.floor(o/p),w?s===1?g?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):g?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?g?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):g?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/$),w?s===1?g?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):g?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?g?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):g?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function T(h,w){const g=Math.abs(h/1e3);return g<1?w?(0,I.localize)(54,null,h):(0,I.localize)(55,null,h):g<O?w?(0,I.localize)(56,null,Math.round(h)/1e3):(0,I.localize)(57,null,Math.round(h)/1e3):g<R?w?(0,I.localize)(58,null,Math.round(h/(1e3*O))):(0,I.localize)(59,null,Math.round(h/(1e3*O))):g<M?w?(0,I.localize)(60,null,Math.round(h/(1e3*R))):(0,I.localize)(61,null,Math.round(h/(1e3*R))):(0,I.localize)(62,null,Math.round(h/(1e3*M)))}function D(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[148],Ie([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Pe[44],Ie([1,0,18,15,148]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=$,e.$ij=y,e.$jj=T;function M(D,h){return h&&(D.stack||D.stacktrace)?R.localize(0,null,p(D),A(D.stack)||A(D.stacktrace)):p(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function p(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?R.localize(1,null,D.message):D.message||R.localize(2,null)}function $(D=null,h=!1){if(!D)return R.localize(3,null);if(Array.isArray(D)){const w=I.$Hb(D),g=$(w[0],h);return w.length>1?R.localize(4,null,g,w.length):g}if(O.$9f(D))return D;if(D.detail){const w=D.detail;if(w.error)return M(w.error,h);if(w.exception)return M(w.exception,h)}return D.stack?M(D,h):D.message?D.message:R.localize(5,null)}function y(D){const h=D;return h instanceof Error&&Array.isArray(h.actions)}function T(D,h){let w;return typeof D=="string"?w=new Error(D):w=D,w.actions=h,w}}),define(Pe[149],Ie([1,0,43,19]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=p,e.$hr=$,e.$ir=y,e.$jr=T,e.$kr=D,e.$lr=h,e.$mr=w,e.$nr=g,e.$or=r,e.$pr=o,e.$qr=u,e.$rr=C,e.$sr=b;const R=new I.$V(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(v,d,E=!1){const k=v||"",P=d||"",S=R.value.collator.compare(k,P);return R.value.collatorIsNumeric&&S===0&&k!==P?k<P?-1:1:S}function $(v,d){const E=M.value.collator;return v=v||"",d=d||"",c(E,v,d)}function y(v,d){const E=M.value.collator;return v=v||"",d=d||"",a(v,d)||c(E,v,d)}function T(v,d){const E=M.value.collator;return v=v||"",d=d||"",f(v,d)||c(E,v,d)}function D(v,d){return v=v||"",d=d||"",v===d?0:v<d?-1:1}function h(v,d){const[E,k]=i(v),[P,S]=i(d);let W=R.value.collator.compare(k,S);if(W===0){if(R.value.collatorIsNumeric&&k!==S)return k<S?-1:1;if(W=R.value.collator.compare(E,P),R.value.collatorIsNumeric&&W===0&&E!==P)return E<P?-1:1}return W}function w(v,d){v=v||"",d=d||"";const E=n(v),k=n(d),P=M.value.collator,S=A.value.collator;return c(S,E,k)||c(P,v,d)}function g(v,d){v=v||"",d=d||"";const E=n(v),k=n(d),P=M.value.collator,S=A.value.collator;return c(S,E,k)||a(v,d)||c(P,v,d)}function r(v,d){v=v||"",d=d||"";const E=n(v),k=n(d),P=M.value.collator,S=A.value.collator;return c(S,E,k)||f(v,d)||c(P,v,d)}function o(v,d){v=v||"",d=d||"";const E=n(v).toLowerCase(),k=n(d).toLowerCase();return E!==k?E<k?-1:1:v!==d?v<d?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function i(v,d=!1){const E=v?s.exec(v):[];let k=[E&&E[1]||"",E&&E[3]||""];return d&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(v){const d=v?s.exec(v):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function c(v,d,E){const k=v.compare(d,E);return k!==0?k:d.length!==E.length?d.length<E.length?-1:1:0}function l(v){const d=v.charAt(0);return d.toLocaleUpperCase()!==d}function t(v){const d=v.charAt(0);return d.toLocaleLowerCase()!==d}function f(v,d){return l(v)&&t(d)?-1:t(v)&&l(d)?1:0}function a(v,d){return t(v)&&l(d)?-1:l(v)&&t(d)?1:0}function m(v,d,E=!1){return E||(v=v&&v.toLowerCase(),d=d&&d.toLowerCase()),v===d?0:v<d?-1:1}function u(v,d,E=!1){const k=v.split(O.sep),P=d.split(O.sep),S=k.length-1,W=P.length-1;let V,q;for(let N=0;;N++){if(V=S===N,q=W===N,V&&q)return p(k[N],P[N],E);if(V)return-1;if(q)return 1;const B=m(k[N],P[N],E);if(B!==0)return B}}function C(v,d,E){const k=v.toLowerCase(),P=d.toLowerCase(),S=b(v,d,E);if(S)return S;const W=k.endsWith(E),V=P.endsWith(E);if(W!==V)return W?-1:1;const q=p(k,P);return q!==0?q:k.localeCompare(P)}function b(v,d,E){const k=v.toLowerCase(),P=d.toLowerCase(),S=k.startsWith(E),W=P.startsWith(E);if(S!==W)return S?-1:1;if(S&&W){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}}),define(Pe[48],Ie([1,0,19,22,13,15]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=A,e.$pg=p,e.$qg=$,e.$rg=y,e.$sg=T,e.$tg=g,e.$ug=r,e.$vg=o,e.$wg=s,e.$xg=i,e.$yg=n,e.$zg=c,e.$Ag=l,e.$Bg=t,e.$Cg=f,e.$Dg=a,e.$Eg=C;function A(b){return b===47||b===92}function p(b){return b.replace(/[\\/]/g,I.$gc.sep)}function $(b){return b.indexOf("/")===-1&&(b=p(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function y(b,v=I.$gc.sep){if(!b)return"";const d=b.length,E=b.charCodeAt(0);if(A(E)){if(A(b.charCodeAt(1))&&!A(b.charCodeAt(2))){let P=3;const S=P;for(;P<d&&!A(b.charCodeAt(P));P++);if(S!==P&&!A(b.charCodeAt(P+1))){for(P+=1;P<d;P++)if(A(b.charCodeAt(P)))return b.slice(0,P+1).replace(/[\\/]/g,v)}}return v}else if(s(E)&&b.charCodeAt(1)===58)return A(b.charCodeAt(2))?b.slice(0,2)+v:b.slice(0,2);let k=b.indexOf("://");if(k!==-1){for(k+=3;k<d;k++)if(A(b.charCodeAt(k)))return b.slice(0,k+1)}return""}function T(b){if(!O.$i||!b||b.length<5)return!1;let v=b.charCodeAt(0);if(v!==92||(v=b.charCodeAt(1),v!==92))return!1;let d=2;const E=d;for(;d<b.length&&(v=b.charCodeAt(d),v!==92);d++);return!(E===d||(v=b.charCodeAt(d+1),isNaN(v)||v===92))}const D=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(b,v=O.$i){const d=v?D:h;return!(!b||b.length===0||/^\s+$/.test(b)||(d.lastIndex=0,d.test(b))||v&&w.test(b)||b==="."||b===".."||v&&b[b.length-1]==="."||v&&b.length!==b.trim().length||b.length>255)}function r(b,v,d){const E=b===v;return!d||E?E:!b||!v?!1:(0,R.$xf)(b,v)}function o(b,v,d,E=I.sep){if(b===v)return!0;if(!b||!v||v.length>b.length)return!1;if(d){if(!(0,R.$yf)(b,v))return!1;if(v.length===b.length)return!0;let P=v.length;return v.charAt(v.length-1)===E&&P--,b.charAt(P)===E}return v.charAt(v.length-1)!==E&&(v+=E),b.indexOf(v)===0}function s(b){return b>=65&&b<=90||b>=97&&b<=122}function i(b,v){return O.$i&&b.endsWith(":")&&(b+=I.sep),(0,I.$ic)(b)||(b=(0,I.$jc)(v,b)),b=(0,I.$hc)(b),n(b)}function n(b){return O.$i?(b=(0,R.$ff)(b,I.sep),b.endsWith(":")&&(b+=I.sep)):(b=(0,R.$ff)(b,I.sep),b||(b=I.sep)),b}function c(b){const v=(0,I.$hc)(b);return O.$i?b.length>3?!1:l(v)&&(b.length===2||v.charCodeAt(2)===92):v===I.$gc.sep}function l(b,v=O.$i){return v?s(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function t(b,v=O.$i){return l(b,v)?b[0]:void 0}function f(b,v,d){return v.length>b.length?-1:b===v?0:(d&&(b=b.toLowerCase(),v=v.toLowerCase()),b.indexOf(v))}function a(b){const v=b.split(":");let d,E,k;for(const P of v){const S=Number(P);(0,M.$ag)(S)?E===void 0?E=S:k===void 0&&(k=S):d=d?[d,P].join(":"):P}if(!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(b,v,d=8){let E="";for(let P=0;P<d;P++){let S;P===0&&O.$i&&!v&&(d===3||d===4)?S=u:S=m,E+=S.charAt(Math.floor(Math.random()*S.length))}let k;return v?k=`${v}-${E}`:k=E,b?(0,I.$jc)(b,k):k}}),define(Pe[70],Ie([1,0,19]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=M,e.$Ss=A,e.$Ts=p,e.$Us=y,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(T){const D=(0,I.$oc)(T),h=O[D.toLowerCase()];return h!==void 0?h:A(T)}function A(T){const D=(0,I.$oc)(T);return R[D.toLowerCase()]}function p(T){for(const D in R)if(R[D]===T)return D}const $=/^(.+)\/(.+?)(;.+)?$/;function y(T,D){const h=$.exec(T);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:D?void 0:T}}),define(Pe[49],Ie([1,0,21,2]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=R,e.$5h=M,e.$6h=p;function R($){return JSON.stringify($,A)}function M($){let y=JSON.parse($);return y=p(y),y}function A($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function p($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return O.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof I.$Fe||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let T=0;T<$.length;++T)$[T]=p($[T],y+1);else for(const T in $)Object.hasOwnProperty.call($,T)&&($[T]=p($[T],y+1))}return $}}),define(Pe[16],Ie([1,0,14,22,13,2,19]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=$,e.$Gg=y,e.$Kg=D;var p;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.commentsInput="comment",g.codeSetting="code-setting"})(p||(e.Schemas=p={}));function $(g,r){return M.URI.isUri(g)?(0,R.$xf)(g.scheme,r):(0,R.$yf)(g,r+":")}function y(g,...r){return r.some(o=>$(g,o))}e.$Hg="vscode-tkn",e.$Ig="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=D(r,o)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,p.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(l){return I.$1(l),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const i=this.b[o],n=this.c[o];let c=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(c+=`&${e.$Ig}=${encodeURIComponent(n)}`),M.URI.from({scheme:O.$o?this.d:p.vscodeRemoteResource,authority:`${s}:${i}`,path:this.g,query:c})}}e.$Jg=new T;function D(g,r){return A.$gc.join(r??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class h{static{this.a=e.$Pg}asBrowserUri(r){const o=this.b(r,le);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===p.vscodeRemote?e.$Jg.rewrite(r):r.scheme===p.file&&(O.$m||O.$q===`${p.vscodeFileResource}://${h.a}`)?r.with({scheme:p.vscodeFileResource,authority:r.authority||h.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,le);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===p.vscodeFileResource?r.with({scheme:p.file,authority:r.authority!==h.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return M.URI.isUri(r)?r:M.URI.parse(o.toUrl(r))}}e.$Qg=new h;var w;(function(g){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:M.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const l=c?.get(o);if(l)return r.get(l)}g.getHeadersFromQuery=s;function i(n,c,l){if(!globalThis.crossOriginIsolated)return;const t=c&&l?"3":l?"2":"1";n instanceof URLSearchParams?n.set(o,t):n[o]=t}g.addSearchParam=i})(w||(e.COI=w={}))}),define(Pe[23],Ie([1,0,48,16,19,22,13,2]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=$,e.$gh=T,e.$hh=h;function $(w){return(0,p.$wc)(w,!0)}class y{constructor(g){this.a=g}compare(g,r,o=!1){return g===r?0:(0,A.$qf)(this.getComparisonKey(g,o),this.getComparisonKey(r,o))}isEqual(g,r,o=!1){return g===r?!0:!g||!r?!1:this.getComparisonKey(g,o)===this.getComparisonKey(r,o)}getComparisonKey(g,r=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,r,o=!1){if(g.scheme===r.scheme){if(g.scheme===O.Schemas.file)return I.$vg($(g),$(r),this.a(g))&&g.query===r.query&&(o||g.fragment===r.fragment);if((0,e.$ch)(g.authority,r.authority))return I.$vg(g.path,r.path,this.a(g),"/")&&g.query===r.query&&(o||g.fragment===r.fragment)}return!1}joinPath(g,...r){return p.URI.joinPath(g,...r)}basenameOrAuthority(g){return(0,e.$7g)(g)||g.authority}basename(g){return R.$gc.basename(g.path)}extname(g){return R.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let r;return g.scheme===O.Schemas.file?r=p.URI.file(R.$mc($(g))).path:(r=R.$gc.dirname(g.path),g.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),r="/")),g.with({path:r})}normalizePath(g){if(!g.path.length)return g;let r;return g.scheme===O.Schemas.file?r=p.URI.file(R.$hc($(g))).path:r=R.$gc.normalize(g.path),g.with({path:r})}relativePath(g,r){if(g.scheme!==r.scheme||!(0,e.$ch)(g.authority,r.authority))return;if(g.scheme===O.Schemas.file){const i=R.$lc($(g),$(r));return M.$i?I.$pg(i):i}let o=g.path||"/";const s=r.path||"/";if(this.a(g)){let i=0;for(const n=Math.min(o.length,s.length);i<n&&!(o.charCodeAt(i)!==s.charCodeAt(i)&&o.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);o=s.substr(0,i)+o.substr(i)}return R.$gc.relative(o,s)}resolvePath(g,r){if(g.scheme===O.Schemas.file){const o=p.URI.file(R.$kc($(g),r));return g.with({authority:o.authority,path:o.path})}return r=I.$qg(r),g.with({path:R.$gc.resolve(g.path,r)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,r){return g===r||g!==void 0&&r!==void 0&&(0,A.$xf)(g,r)}hasTrailingPathSeparator(g,r=R.sep){if(g.scheme===O.Schemas.file){const o=$(g);return o.length>I.$rg(o).length&&o[o.length-1]===r}else{const o=g.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,r=R.sep){return(0,e.$dh)(g,r)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,r=R.sep){let o=!1;if(g.scheme===O.Schemas.file){const s=$(g);o=s!==void 0&&s.length===I.$rg(s).length&&s[s.length-1]===r}else{r="/";const s=g.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$dh)(g,r)?g.with({path:g.path+"/"}):g}}e.$Yg=y,e.$Zg=new y(()=>!1),e.$1g=new y(w=>w.scheme===O.Schemas.file?!M.$k:!0),e.$2g=new y(w=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function T(w,g){const r=[];for(let o=0;o<w.length;o++){const s=g(w[o]);w.some((i,n)=>n===o?!1:(0,e.$4g)(s,g(i)))||r.push(w[o])}return r}var D;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function g(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,l]=n.split(":");c&&l&&o.set(c,l)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&o.set(w.META_DATA_MIME,i),o}w.parseMetaData=g})(D||(e.DataUri=D={}));function h(w,g,r){if(g){let o=w.path;return o&&o[0]!==R.$gc.sep&&(o=R.$gc.sep+o),w.with({scheme:r,authority:g,path:o})}return w.with({scheme:r})}}),define(Pe[11],Ie([1,0,24,14,5,6,23,22,136,43]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=T,e.$jh=D,e.$kh=h,e.$lh=w,e.$mh=g,e.$nh=r,e.$oh=o,e.$ph=s,e.$xh=C,e.$yh=b,e.$zh=v,e.$Ah=d,e.$Bh=E,e.$Qh=Se,e.$Yh=De;function T(ge){return!!ge&&typeof ge.then=="function"}function D(ge){const Q=new I.$oe,Y=ge(Q.token),he=new Promise((ue,Me)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Me(new O.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),Q.dispose(),ue(Ce)},Ce=>{de.dispose(),Q.dispose(),Me(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,Me){return he.then(ue,Me)}catch(ue){return this.then(void 0,ue)}finally(ue){return he.finally(ue)}}}function h(ge,Q,Y){return new Promise((he,ue)=>{const Me=Q.onCancellationRequested(()=>{Me.dispose(),he(Y)});ge.then(he,ue).finally(()=>Me.dispose())})}function w(ge,Q){return new Promise((Y,he)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),he(new O.$5)});ge.then(Y,he).finally(()=>ue.dispose())})}async function g(ge){let Q=-1;const Y=ge.map((he,ue)=>he.then(Me=>(Q=ue,Me)));try{return await Promise.race(Y)}finally{ge.forEach((he,ue)=>{ue!==Q&&he.cancel()})}}function r(ge,Q,Y){let he;const ue=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([ge.finally(()=>clearTimeout(ue)),new Promise(Me=>he=Me)])}function o(ge){return new Promise((Q,Y)=>{const he=ge();T(he)?he.then(Q,Y):Q(he)})}function s(){let ge,Q;return{promise:new Promise((he,ue)=>{ge=he,Q=ue}),resolve:ge,reject:Q}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ue=>{this.a=null,Y(ue)},ue=>{this.a=null,he(ue)})})}dispose(){this.f=!0}}e.$qh=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$rh=n;class c{constructor(){this.a=new Map}queue(Q,Y){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$sh=c;const l=(ge,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=ge=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ge())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class f{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,Me)=>{this.d=ue,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===$.$ae?t(he):l(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=f;class a{constructor(Q){this.a=new f(Q),this.b=new i}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=a;class m{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=m;class u extends m{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$wh=u;function C(ge,Q){return Q?new Promise((Y,he)=>{const ue=setTimeout(()=>{Me.dispose(),Y()},ge),Me=Q.onCancellationRequested(()=>{clearTimeout(ue),Me.dispose(),he(new O.$5)})}):D(Y=>C(ge,Y))}function b(ge,Q=0,Y){const he=setTimeout(()=>{ge(),Y&&ue.dispose()},Q),ue=(0,M.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ue)});return Y?.add(ue),ue}function v(ge){const Q=[];let Y=0;const he=ge.length;function ue(){return Y<he?ge[Y++]():null}function Me(de){de!=null&&Q.push(de);const Ce=ue();return Ce?Ce.then(Me):Promise.resolve(Q)}return Promise.resolve(null).then(Me)}function d(ge,Q=he=>!!he,Y=null){let he=0;const ue=ge.length,Me=()=>{if(he>=ue)return Promise.resolve(Y);const de=ge[he++];return Promise.resolve(de()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Me())};return Me()}function E(ge,Q=he=>!!he,Y=null){if(ge.length===0)return Promise.resolve(Y);let he=ge.length;const ue=()=>{he=-1;for(const Me of ge)Me.cancel?.()};return new Promise((Me,de)=>{for(const Ce of ge)Ce.then(Ae=>{--he>=0&&Q(Ae)?(ue(),Me(Ae)):he===0&&Me(Y)}).catch(Ae=>{--he>=0&&(ue(),de(Ae))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$de}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=k;class P extends k{constructor(){super(1)}}e.$Dh=P;class S{constructor(){this.a=new fe,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Eh=S;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ae;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=A.$Zg){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=A.$Zg){const ue=he.getComparisonKey(Q);let Me=this.a.get(ue);if(!Me){Me=new P;const de=this.f++,Ce=R.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(de,Ce),this.a.set(ue,Me)}return Me.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=W;class V{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Gh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ue=he.setInterval(()=>{Q()},Y);this.d=(0,M.$Sc)(()=>{he.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=q;class N{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=N;class B{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=B;class K extends N{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Kh=K;class ie extends M.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(ge,Q)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Nh=(ge,Q,Y)=>{const he=ge.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,ge.cancelIdleCallback(he))}}},e.$Mh=ge=>(0,e.$Nh)(globalThis,ge)}();class ce{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Nh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ce;class ye extends ce{constructor(Q){super(globalThis,Q)}}e.$Ph=ye;async function Se(ge,Q,Y){let he;for(let ue=0;ue<Y;ue++)try{return await ge()}catch(Me){he=Me,await C(Q)}throw he}class fe{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ue}=s();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=fe;class $e{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Sh=$e;var Te;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Te||(Te={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Th=ae;var Ne;(function(ge){async function Q(he){let ue;const Me=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{ue||(ue=Ce)})));if(typeof ue<"u")throw ue;return Me}ge.settled=Q;function Y(he){return new Promise(async(ue,Me)=>{try{await he(ue,Me)}catch(de){Me(de)}})}ge.withAsyncBody=Y})(Ne||(e.Promises=Ne={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=ne;class z{constructor(Q){this.b=Q,this.a=new y.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=z;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class be{static fromArray(Q){return new be(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new be(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>{for await(const ue of he)Y.emitOne(ue)}))})}static{this.EMPTY=be.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new R.$de,queueMicrotask(async()=>{const he={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Q(he)),this.k()}catch(ue){this.l(ue)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new be(async he=>{for await(const ue of Q)he.emitOne(Y(ue))})}map(Q){return be.map(this,Q)}static filter(Q,Y){return new be(async he=>{for await(const ue of Q)Y(ue)&&he.emitOne(ue)})}filter(Q){return be.filter(this,Q)}static coalesce(Q){return be.filter(Q,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return be.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Wh=be;class Fe extends be{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Xh=Fe;function De(ge){const Q=new I.$oe,Y=ge(Q.token);return new Fe(Q,async he=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),he.reject(new O.$5)});try{for await(const Me of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Me)}ue.dispose(),Q.dispose()}catch(Me){ue.dispose(),Q.dispose(),he.reject(Me)}})}class pe{constructor(Q){this.a=new ae,this.b=new be(ue=>{if(Y){ue.reject(Y);return}return he&&ue.emitMany(he),this.d=Me=>ue.reject(Me),this.f=Me=>ue.emitOne(Me),this.a.p},Q);let Y,he;this.f=ue=>{he||(he=[]),he.push(ue)},this.d=ue=>{Y||(Y=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Zh=pe}),define(Pe[37],Ie([1,0,18,11,48,28,19,22,13]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=y,e.$ok=g,e.$pk=P,e.$qk=S,e.$rk=W,e.$sk=V,e.$tk=q,e.$uk=ie;function y(){return Object.create(null)}e.$mk="**",e.$nk="/";const T="[/\\\\]",D="[^/\\\\]",h=/\//g;function w(ce,ye){switch(ce){case 0:return"";case 1:return`${D}*?`;default:return`(?:${T}|${D}+${T}${ye?`|${T}${D}+`:""})*?`}}function g(ce,ye){if(!ce)return[];const Se=[];let fe=!1,$e=!1,Te="";for(const ae of ce){switch(ae){case ye:if(!fe&&!$e){Se.push(Te),Te="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}Te+=ae}return Te&&Se.push(Te),Se}function r(ce){if(!ce)return"";let ye="";const Se=g(ce,e.$nk);if(Se.every(fe=>fe===e.$mk))ye=".*";else{let fe=!1;Se.forEach(($e,Te)=>{if($e===e.$mk){if(fe)return;ye+=w(2,Te===Se.length-1)}else{let ae=!1,Ne="",ne=!1,z="";for(const x of $e){if(x!=="}"&&ae){Ne+=x;continue}if(ne&&(x!=="]"||!z)){let be;x==="-"?be=x:(x==="^"||x==="!")&&!z?be="^":x===e.$nk?be="":be=(0,$.$_e)(x),z+=be;continue}switch(x){case"{":ae=!0;continue;case"[":ne=!0;continue;case"}":{const Fe=`(?:${g(Ne,",").map(De=>r(De)).join("|")})`;ye+=Fe,ae=!1,Ne="";break}case"]":{ye+="["+z+"]",ne=!1,z="";break}case"?":ye+=D;continue;case"*":ye+=w(1);continue;default:ye+=(0,$.$_e)(x)}}Te<Se.length-1&&(Se[Te+1]!==e.$mk||Te+2<Se.length)&&(ye+=T)}fe=$e===e.$mk})}return ye}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),f=function(){return!1},a=function(){return null};function m(ce,ye){if(!ce)return a;let Se;typeof ce!="string"?Se=ce.pattern:Se=ce,Se=Se.trim();const fe=`${Se}_${!!ye.trimForExclusions}`;let $e=t.get(fe);if($e)return u($e,ce);let Te;return o.test(Se)?$e=b(Se.substr(4),Se):(Te=s.exec(C(Se,ye)))?$e=v(Te[1],Se):(ye.trimForExclusions?n:i).test(Se)?$e=d(Se,ye):(Te=c.exec(C(Se,ye)))?$e=E(Te[1].substr(1),Se,!0):(Te=l.exec(C(Se,ye)))?$e=E(Te[1],Se,!1):$e=k(Se),t.set(fe,$e),u($e,ce)}function u(ce,ye){if(typeof ye=="string")return ce;const Se=function(fe,$e){return(0,R.$vg)(fe,ye.base,!p.$k)?ce((0,$.$ef)(fe.substr(ye.base.length),A.sep),$e):null};return Se.allBasenames=ce.allBasenames,Se.allPaths=ce.allPaths,Se.basenames=ce.basenames,Se.patterns=ce.patterns,Se}function C(ce,ye){return ye.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function b(ce,ye){return function(Se,fe){return typeof Se=="string"&&Se.endsWith(ce)?ye:null}}function v(ce,ye){const Se=`/${ce}`,fe=`\\${ce}`,$e=function(ae,Ne){return typeof ae!="string"?null:Ne?Ne===ce?ye:null:ae===ce||ae.endsWith(Se)||ae.endsWith(fe)?ye:null},Te=[ce];return $e.basenames=Te,$e.patterns=[ye],$e.allBasenames=Te,$e}function d(ce,ye){const Se=K(ce.slice(1,-1).split(",").map(Ne=>m(Ne,ye)).filter(Ne=>Ne!==a),ce),fe=Se.length;if(!fe)return a;if(fe===1)return Se[0];const $e=function(Ne,ne){for(let z=0,x=Se.length;z<x;z++)if(Se[z](Ne,ne))return ce;return null},Te=Se.find(Ne=>!!Ne.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=Se.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return ae.length&&($e.allPaths=ae),$e}function E(ce,ye,Se){const fe=A.sep===A.$gc.sep,$e=fe?ce:ce.replace(h,A.sep),Te=A.sep+$e,ae=A.$gc.sep+ce;let Ne;return Se?Ne=function(ne,z){return typeof ne=="string"&&(ne===$e||ne.endsWith(Te)||!fe&&(ne===ce||ne.endsWith(ae)))?ye:null}:Ne=function(ne,z){return typeof ne=="string"&&(ne===$e||!fe&&ne===ce)?ye:null},Ne.allPaths=[(Se?"*/":"./")+ce],Ne}function k(ce){try{const ye=new RegExp(`^${r(ce)}$`);return function(Se){return ye.lastIndex=0,typeof Se=="string"&&ye.test(Se)?ce:null}}catch{return a}}function P(ce,ye,Se){return!ce||typeof ye!="string"?!1:S(ce)(ye,void 0,Se)}function S(ce,ye={}){if(!ce)return f;if(typeof ce=="string"||W(ce)){const Se=m(ce,ye);if(Se===a)return f;const fe=function($e,Te){return!!Se($e,Te)};return Se.allBasenames&&(fe.allBasenames=Se.allBasenames),Se.allPaths&&(fe.allPaths=Se.allPaths),fe}return N(ce,ye)}function W(ce){const ye=ce;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function V(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function N(ce,ye){const Se=K(Object.getOwnPropertyNames(ce).map(Ne=>B(Ne,ce[Ne],ye)).filter(Ne=>Ne!==a)),fe=Se.length;if(!fe)return a;if(!Se.some(Ne=>!!Ne.requiresSiblings)){if(fe===1)return Se[0];const Ne=function(x,be){let Fe;for(let De=0,pe=Se.length;De<pe;De++){const ge=Se[De](x,be);if(typeof ge=="string")return ge;(0,O.$ih)(ge)&&(Fe||(Fe=[]),Fe.push(ge))}return Fe?(async()=>{for(const De of Fe){const pe=await De;if(typeof pe=="string")return pe}return null})():null},ne=Se.find(x=>!!x.allBasenames);ne&&(Ne.allBasenames=ne.allBasenames);const z=Se.reduce((x,be)=>be.allPaths?x.concat(be.allPaths):x,[]);return z.length&&(Ne.allPaths=z),Ne}const $e=function(Ne,ne,z){let x,be;for(let Fe=0,De=Se.length;Fe<De;Fe++){const pe=Se[Fe];pe.requiresSiblings&&z&&(ne||(ne=(0,A.$nc)(Ne)),x||(x=ne.substr(0,ne.length-(0,A.$oc)(Ne).length)));const ge=pe(Ne,ne,x,z);if(typeof ge=="string")return ge;(0,O.$ih)(ge)&&(be||(be=[]),be.push(ge))}return be?(async()=>{for(const Fe of be){const De=await Fe;if(typeof De=="string")return De}return null})():null},Te=Se.find(Ne=>!!Ne.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=Se.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return ae.length&&($e.allPaths=ae),$e}function B(ce,ye,Se){if(ye===!1)return a;const fe=m(ce,Se);if(fe===a)return a;if(typeof ye=="boolean")return fe;if(ye){const $e=ye.when;if(typeof $e=="string"){const Te=(ae,Ne,ne,z)=>{if(!z||!fe(ae,Ne))return null;const x=$e.replace("$(basename)",()=>ne),be=z(x);return(0,O.$ih)(be)?be.then(Fe=>Fe?ce:null):be?ce:null};return Te.requiresSiblings=!0,Te}}return fe}function K(ce,ye){const Se=ce.filter(Ne=>!!Ne.basenames);if(Se.length<2)return ce;const fe=Se.reduce((Ne,ne)=>{const z=ne.basenames;return z?Ne.concat(z):Ne},[]);let $e;if(ye){$e=[];for(let Ne=0,ne=fe.length;Ne<ne;Ne++)$e.push(ye)}else $e=Se.reduce((Ne,ne)=>{const z=ne.patterns;return z?Ne.concat(z):Ne},[]);const Te=function(Ne,ne){if(typeof Ne!="string")return null;if(!ne){let x;for(x=Ne.length;x>0;x--){const be=Ne.charCodeAt(x-1);if(be===47||be===92)break}ne=Ne.substr(x)}const z=fe.indexOf(ne);return z!==-1?$e[z]:null};Te.basenames=fe,Te.patterns=$e,Te.allBasenames=fe;const ae=ce.filter(Ne=>!Ne.basenames);return ae.push(Te),ae}function ie(ce,ye){return(0,I.$ub)(ce,ye,(Se,fe)=>typeof Se=="string"&&typeof fe=="string"?Se===fe:typeof Se!="string"&&typeof fe!="string"?Se.base===fe.base&&Se.pattern===fe.pattern:!1)}}),define(Pe[55],Ie([1,0,14,137,23,13,2]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=y,e.$Vk=T,e.$Wk=D,e.$Xk=h,e.$Yk=w,e.$Zk=g,e.$1k=r,e.$2k=o;var p;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,I.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=h(this.supportThemeIcons?(0,O.$Nk)(i):i).replace(/([ \t]+)/g,(c,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${w(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,M.$_e)(n),"g");return i.replace(c,(l,t)=>i.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$Tk=$;function y(s){return T(s)?!s.value:Array.isArray(s)?s.every(y):!0}function T(s){return s instanceof $?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function D(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,R.$3g)(A.URI.from(s.baseUri),A.URI.from(i.baseUri)))}function h(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,i){const n=s.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,s,`${"`".repeat(c)}`].join(`
`)}function g(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const i=[],n=s.split("|").map(l=>l.trim());s=n[0];const c=n[1];if(c){const l=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),f=l?l[1]:"",a=t?t[1]:"",m=isFinite(parseInt(a)),u=isFinite(parseInt(f));m&&i.push(`width="${a}"`),u&&i.push(`height="${f}"`)}return{href:s,dimensions:i}}}),define(Pe[97],Ie([1,0,18,48,19,22,23,13]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=$,e.$Ew=T,e.$Fw=h,e.$Gw=w,e.$Hw=s,e.$Iw=n,e.$Jw=c,e.$Kw=l,e.$Lw=t,e.$Mw=f;function $(m,u){const{os:C,tildify:b,relative:v}=u;if(v){const k=y(m,v,C);if(typeof k=="string")return k}let d=m.fsPath;if(C===1&&!M.$i?d=d.replace(/\//g,"\\"):C!==1&&M.$i&&(d=d.replace(/\\/g,"/")),C!==1&&b?.userHome){const k=b.userHome.fsPath;let P;m.scheme!==b.userHome.scheme&&m.path[0]===R.$gc.sep&&m.path[1]!==R.$gc.sep?P=b.userHome.with({path:m.path}).fsPath:P=d,d=h(P,k,C)}return(C===1?R.$fc:R.$gc).normalize(T(d,C===1))}function y(m,u,C){const b=C===1?R.$fc:R.$gc,v=C===3?A.$Zg:A.$2g,d=u.getWorkspace(),E=(0,I.$Ob)(d.folders);if(!E)return;m.scheme!==E.uri.scheme&&m.path[0]===R.$gc.sep&&m.path[1]!==R.$gc.sep&&(m=E.uri.with({path:m.path}));const k=u.getWorkspaceFolder(m);if(!k)return;let P;if(v.isEqual(k.uri,m)?P="":P=v.relativePath(k.uri,m)??"",P&&(P=b.normalize(P)),d.folders.length>1&&!u.noPrefix){const S=k.name?k.name:v.basenameOrAuthority(k.uri);P=P?`${S} \u2022 ${P}`:S}return P}function T(m,u=M.$i){return(0,O.$Ag)(m,u)?m.charAt(0).toUpperCase()+m.slice(1):m}let D=Object.create(null);function h(m,u,C=M.OS){if(C===1||!m||!u)return m;let b=D.original===u?D.normalized:void 0;b||(b=u,M.$i&&(b=(0,O.$pg)(b)),b=`${(0,p.$ff)(b,R.$gc.sep)}${R.$gc.sep}`,D={original:u,normalized:b});let v=m;return M.$i&&(v=(0,O.$pg)(v)),(C===3?v.startsWith(b):(0,p.$yf)(v,b))?`~/${v.substr(b.length)}`:m}function w(m,u){return m.replace(/^~($|\/|\\)/,`${u}$1`)}const g="\u2026",r="\\\\",o="~";function s(m,u=R.sep){const C=new Array(m.length);let b=!1;for(let v=0;v<m.length;v++){const d=m[v];if(d===""){C[v]=`.${u}`;continue}if(!d){C[v]=d;continue}b=!0;let E="",k=d;k.indexOf(r)===0?(E=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(u)===0?(E=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(o)===0&&(E=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const P=k.split(u);for(let S=1;b&&S<=P.length;S++)for(let W=P.length-S;b&&W>=0;W--){b=!1;let V=P.slice(W,W+S).join(u);for(let q=0;!b&&q<m.length;q++)if(q!==v&&m[q]&&m[q].indexOf(V)>-1){const N=W+S===P.length,B=W>0&&m[q].indexOf(u)>-1?u+V:V,K=m[q].endsWith(B);b=!N||K}if(!b){let q="";(P[0].endsWith(":")||E!=="")&&(W===1&&(W=0,S++,V=P[0]+u+V),W>0&&(q=P[0]+u),q=E+q),W>0&&(q=q+g+u),q=q+V,W+S<P.length&&(q=q+u+g),C[v]=q}}b&&(C[v]=d)}return C}var i;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(m,u=Object.create(null)){const C=[];let b=!1,v="";for(const d of m)if(d==="$"||b&&d==="{")v&&C.push({value:v,type:i.TEXT}),v="",b=!0;else if(d==="}"&&b){const E=u[v];if(typeof E=="string")E.length&&C.push({value:E,type:i.VARIABLE});else if(E){const k=C[C.length-1];(!k||k.type!==i.SEPARATOR)&&C.push({value:E.label,type:i.SEPARATOR})}v="",b=!1}else v+=d;return v&&!b&&C.push({value:v,type:i.TEXT}),C.filter((d,E)=>{if(d.type===i.SEPARATOR){const k=C[E-1],P=C[E+1];return[k,P].every(S=>S&&(S.type===i.VARIABLE||S.type===i.TEXT)&&S.value.length>0)}return!0}).map(d=>d.value).join("")}function c(m,u){return M.$j||u?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):m.replace(/&&|&/g,C=>C==="&"?"&&":"&")}function l(m,u){return M.$j||u?m.replace(/\(&&\w\)|&&/g,""):M.$i?m.replace(/&&|&/g,C=>C==="&"?"&&":"&"):m.replace(/&&/g,"_")}function t(m){return m.replace(/&/g,"&&")}function f(m){if(m.endsWith("]")){const u=m.lastIndexOf(" [",m.length-2);if(u!==-1){const C=a(m.substring(0,u)),b=m.substring(u);return{name:C.name+b,parentPath:C.parentPath}}}return a(m)}function a(m){const u=m.indexOf("/")!==-1?R.$gc:R.$fc,C=u.basename(m),b=u.dirname(m);return C.length?{name:C,parentPath:b}:{name:b,parentPath:""}}}),define(Pe[150],Ie([1,0,21,2]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=p,e.$Bn=y,e.$Cn=T;function R(D){return D.toJSON()}class M{constructor(h){this.a=h}transformIncoming(h){const w=this.a.transformIncoming(h);return w===h?h:R(O.URI.from(w))}transformOutgoing(h){const w=this.a.transformOutgoing(h);return w===h?h:R(O.URI.from(w))}transformOutgoingURI(h){const w=this.a.transformOutgoing(h);return w===h?h:O.URI.from(w)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.$yn=M,e.$zn=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,h,w){if(!D||w>200)return null;if(typeof D=="object"){if(D instanceof O.URI)return h.transformOutgoing(D);for(const g in D)if(Object.hasOwnProperty.call(D,g)){const r=A(D[g],h,w+1);r!==null&&(D[g]=r)}}return null}function p(D,h){const w=A(D,h,0);return w===null?D:w}function $(D,h,w,g){if(!D||g>200)return null;if(typeof D=="object"){if(D.$mid===1)return w?O.URI.revive(h.transformIncoming(D)):h.transformIncoming(D);if(D instanceof I.$Fe)return null;for(const r in D)if(Object.hasOwnProperty.call(D,r)){const o=$(D[r],h,w,g+1);o!==null&&(D[r]=o)}}return null}function y(D,h){const w=$(D,h,!1,0);return w===null?D:w}function T(D,h){const w=$(D,h,!0,0);return w===null?D:w}}),define(Pe[151],Ie([1,0,11,5,6,49,15]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=$;var p;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function $(h){const w=h;return w?.changed instanceof Map||w?.deleted instanceof Set}var y;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(y||(e.StorageState=y={}));class T extends R.$Uc{static{this.a=100}constructor(w,g=Object.create(null)){super(),this.r=w,this.s=g,this.b=this.B(new O.$ge),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new I.$uh(T.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((g,r)=>this.w(r,g)),w.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(w,g){if(this.c===y.Closed)return;let r=!1;(0,A.$fg)(g)?r=this.f.delete(w):this.f.get(w)!==g&&(this.f.set(w,g),r=!0),r&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,g){const r=this.f.get(w);return(0,A.$fg)(r)?g:r}getBoolean(w,g){const r=this.get(w);return(0,A.$fg)(r)?g:r==="true"}getNumber(w,g){const r=this.get(w);return(0,A.$fg)(r)?g:parseInt(r,10)}getObject(w,g){const r=this.get(w);return(0,A.$fg)(r)?g:(0,M.$5h)(r)}async set(w,g,r=!1){if(this.c===y.Closed)return;if((0,A.$fg)(g))return this.delete(w,r);const o=(0,A.$$f)(g)||Array.isArray(g)?(0,M.$4h)(g):String(g);if(this.f.get(w)!==o)return this.f.set(w,o),this.j.set(w,o),this.h.delete(w),this.b.fire({key:w,external:r}),this.D()}async delete(w,g=!1){if(!(this.c===y.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:g}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===y.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Wp=T;class D{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((g,r)=>this.a.set(r,g)),w.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Xp=D}),define(Pe[152],Ie([1,0,13,22,21]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=T,e.$Et=D;let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let y;function T(){return y||(y=O.$D()?A():$()),y}function D(g,r,o){const s=new Uint16Array(g.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?h(g,r,o):A().decode(s)}function h(g,r,o){const s=[];let i=0;for(let n=0;n<o;n++){const c=R.$He(g,r);r+=2,s[i++]=String.fromCharCode(c)}return s.join("")}class w{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return T().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||I.$Bf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$Ft=w}),define(Pe[153],Ie([1,0,21,152]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=A;function R($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,T,D,h){this.oldPosition=y,this.oldText=T,this.newPosition=D,this.newText=h}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,T,D){const h=T.length;I.$Ke(y,h,D),D+=4;for(let w=0;w<h;w++)I.$Ie(y,T.charCodeAt(w),D),D+=2;return D}static d(y,T){const D=I.$Je(y,T);return T+=4,(0,O.$Et)(y,T,D)}writeSize(){return 8+M.a(this.oldText)+M.a(this.newText)}write(y,T){return I.$Ke(y,this.oldPosition,T),T+=4,I.$Ke(y,this.newPosition,T),T+=4,T=M.c(y,this.oldText,T),T=M.c(y,this.newText,T),T}static read(y,T,D){const h=I.$Je(y,T);T+=4;const w=I.$Je(y,T);T+=4;const g=M.d(y,T);T+=M.a(g);const r=M.d(y,T);return T+=M.a(r),D.push(new M(h,g,w,r)),T}}e.$Gt=M;function A($,y){return $===null||$.length===0?y:new p($,y).compress()}class p{constructor(y,T){this.a=y,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,T=0,D=this.n(y),h=this.l(T);for(;y<this.f||T<this.h;){if(D===null){this.k(h),h=this.l(++T);continue}if(h===null){this.m(D),D=this.n(++y);continue}if(h.oldEnd<=D.newPosition){this.k(h),h=this.l(++T);continue}if(D.newEnd<=h.oldPosition){this.m(D),D=this.n(++y);continue}if(h.oldPosition<D.newPosition){const[s,i]=p.r(h,D.newPosition-h.oldPosition);this.k(s),h=i;continue}if(D.newPosition<h.oldPosition){const[s,i]=p.q(D,h.oldPosition-D.newPosition);this.m(s),D=i;continue}let r,o;if(h.oldEnd===D.newEnd)r=D,o=h,D=this.n(++y),h=this.l(++T);else if(h.oldEnd<D.newEnd){const[s,i]=p.q(D,h.oldLength);r=s,o=h,D=i,h=this.l(++T)}else{const[s,i]=p.r(h,D.newLength);r=D,o=s,D=this.n(++y),h=i}this.d[this.e++]=new M(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const w=p.s(this.d);return p.t(w)}k(y){this.d[this.e++]=p.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=p.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,T){return new M(T.oldPosition-y,T.oldText,T.newPosition,T.newText)}static p(y,T){return new M(T.oldPosition,T.oldText,T.newPosition+y,T.newText)}static q(y,T){const D=y.newText.substr(0,T),h=y.newText.substr(T);return[new M(y.oldPosition,y.oldText,y.newPosition,D),new M(y.oldEnd,"",y.newPosition+T,h)]}static r(y,T){const D=y.oldText.substr(0,T),h=y.oldText.substr(T);return[new M(y.oldPosition,D,y.newPosition,y.newText),new M(y.oldPosition+T,h,y.newEnd,"")]}static s(y){if(y.length===0)return y;const T=[];let D=0,h=y[0];for(let w=1;w<y.length;w++){const g=y[w];h.oldEnd===g.oldPosition?h=new M(h.oldPosition,h.oldText+g.oldText,h.newPosition,h.newText+g.newText):(T[D++]=h,h=g)}return T[D++]=h,T}static t(y){if(y.length===0)return y;const T=[];let D=0;for(let h=0;h<y.length;h++){const w=y[h];w.oldText!==w.newText&&(T[D++]=w)}return T}}}),define(Pe[154],Ie([1,0,37,19]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=R,e.$Yt=M;function R(A,p,$,y,T,D){if(Array.isArray(A)){let h=0;for(const w of A){const g=R(w,p,$,y,T,D);if(g===10)return g;g>h&&(h=g)}return h}else{if(typeof A=="string")return y?A==="*"?5:A===$?10:0:0;if(A){const{language:h,pattern:w,scheme:g,hasAccessToAllModels:r,notebookType:o}=A;if(!y&&!r)return 0;o&&T&&(p=T);let s=0;if(g)if(g===p.scheme)s=10;else if(g==="*")s=5;else return 0;if(h)if(h===$)s=10;else if(h==="*")s=Math.max(s,5);else return 0;if(o)if(o===D)s=10;else if(o==="*"&&D!==void 0)s=Math.max(s,5);else return 0;if(w){let i;if(typeof w=="string"?i=w:i={...w,base:(0,O.$hc)(w.base)},i===p.fsPath||(0,I.$pk)(i,p.fsPath))s=10;else return 0}return s}else return 0}}function M(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(M):!!A.notebookType}}),define(Pe[155],Ie([1,0,5,13,30,95,93,139,153,6]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=void 0;class T extends y.$Uc{constructor(h,w,g,r,o,s,i){super(),this.m=this.B(new I.$de),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=r,this.h=o,this.c=new A.$ZC(h,g,i)}equals(h){return!(h instanceof T)||this.f!==h.f||this.getEOL()!==h.getEOL()?!1:this.c.equal(h.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(h){return this.c.createSnapshot(h?this.f:"")}getOffsetAt(h,w){return this.c.getOffsetAt(h,w)}getPositionAt(h){return this.c.getPositionAt(h)}getRangeAt(h,w){const g=h+w,r=this.getPositionAt(h),o=this.getPositionAt(g);return new R.$ut(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(h,w=0){if(h.isEmpty())return"";const g=this.n(w);return this.c.getValueInRange(h,g)}getValueLengthInRange(h,w=0){if(h.isEmpty())return 0;if(h.startLineNumber===h.endLineNumber)return h.endColumn-h.startColumn;const g=this.getOffsetAt(h.startLineNumber,h.startColumn),r=this.getOffsetAt(h.endLineNumber,h.endColumn);let o=0;const s=this.n(w),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,c=h.endLineNumber-h.startLineNumber;o=n*c}return r-g+o}getCharacterCountInRange(h,w=0){if(this.j){let g=0;const r=h.startLineNumber,o=h.endLineNumber;for(let s=r;s<=o;s++){const i=this.getLineContent(s),n=s===r?h.startColumn-1:0,c=s===o?h.endColumn-1:i.length;for(let l=n;l<c;l++)O.$Bf(i.charCodeAt(l))?(g=g+1,l=l+1):g=g+1}return g+=this.n(w).length*(o-r),g}return this.getValueLengthInRange(h,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(h){return this.c.getLineContent(h)}getLineCharCode(h,w){return this.c.getLineCharCode(h,w)}getCharCode(h){return this.c.getCharCode(h)}getLineLength(h){return this.c.getLineLength(h)}getLineMinColumn(h){return 1}getLineMaxColumn(h){return this.getLineLength(h)+1}getLineFirstNonWhitespaceColumn(h){const w=O.$mf(this.getLineContent(h));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(h){const w=O.$of(this.getLineContent(h));return w===-1?0:w+2}n(h){switch(h){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(h){this.c.setEOL(h)}applyEdits(h,w,g){let r=this.g,o=this.h,s=this.j,i=!0,n=[];for(let u=0;u<h.length;u++){const C=h[u];i&&C._isTracked&&(i=!1);const b=C.range;if(C.text){let P=!0;s||(P=!O.$Mf(C.text),s=P),!r&&P&&(r=O.$Lf(C.text)),!o&&P&&(o=O.$Of(C.text))}let v="",d=0,E=0,k=0;if(C.text){let P;[d,E,k,P]=(0,p.$1t)(C.text);const S=this.getEOL();P===0||P===(S===`\r
`?2:1)?v=C.text:v=C.text.replace(/\r\n|\r|\n/g,S)}n[u]={sortIndex:u,identifier:C.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:v,eolCount:d,firstLineLength:E,lastLineLength:k,forceMoveMarkers:!!C.forceMoveMarkers,isAutoWhitespaceEdit:C.isAutoWhitespaceEdit||!1}}n.sort(T.u);let c=!1;for(let u=0,C=n.length-1;u<C;u++){const b=n[u].range.getEndPosition(),v=n[u+1].range.getStartPosition();if(v.isBeforeOrEqual(b)){if(v.isBefore(b))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const l=g||w?T._getInverseEditRanges(n):[],t=[];if(w)for(let u=0;u<n.length;u++){const C=n[u],b=l[u];if(C.isAutoWhitespaceEdit&&C.range.isEmpty())for(let v=b.startLineNumber;v<=b.endLineNumber;v++){let d="";v===b.startLineNumber&&(d=this.getLineContent(C.range.startLineNumber),O.$mf(d)!==-1)||t.push({lineNumber:v,oldContent:d})}}let f=null;if(g){let u=0;f=[];for(let C=0;C<n.length;C++){const b=n[C],v=l[C],d=this.getValueInRange(b.range),E=b.rangeOffset+u;u+=b.text.length-d.length,f[C]={sortIndex:b.sortIndex,identifier:b.identifier,range:v,text:d,textChange:new $.$Gt(b.rangeOffset,d,E,b.text)}}c||f.sort((C,b)=>C.sortIndex-b.sortIndex)}this.g=r,this.h=o,this.j=s;const a=this.t(n);let m=null;if(w&&t.length>0){t.sort((u,C)=>C.lineNumber-u.lineNumber),m=[];for(let u=0,C=t.length;u<C;u++){const b=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===b)continue;const v=t[u].oldContent,d=this.getLineContent(b);d.length===0||d===v||O.$mf(d)!==-1||m.push(b)}}return this.m.fire(),new M.$Jv(f,a,m)}s(h){return h.length<1e3?h:[this._toSingleEditOperation(h)]}_toSingleEditOperation(h){let w=!1;const g=h[0].range,r=h[h.length-1].range,o=new R.$ut(g.startLineNumber,g.startColumn,r.endLineNumber,r.endColumn);let s=g.startLineNumber,i=g.startColumn;const n=[];for(let a=0,m=h.length;a<m;a++){const u=h[a],C=u.range;w=w||u.forceMoveMarkers,n.push(this.getValueInRange(new R.$ut(s,i,C.startLineNumber,C.startColumn))),u.text.length>0&&n.push(u.text),s=C.endLineNumber,i=C.endColumn}const c=n.join(""),[l,t,f]=(0,p.$1t)(c);return{sortIndex:0,identifier:h[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:l,firstLineLength:t,lastLineLength:f,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(h){h.sort(T.w);const w=[];for(let g=0;g<h.length;g++){const r=h[g],o=r.range.startLineNumber,s=r.range.startColumn,i=r.range.endLineNumber,n=r.range.endColumn;if(o===i&&s===n&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new R.$ut(o,s,i,n);w.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return w}findMatchesLineByLine(h,w,g,r){return this.c.findMatchesLineByLine(h,w,g,r)}getPieceTree(){return this.c}static _getInverseEditRange(h,w){const g=h.startLineNumber,r=h.startColumn,[o,s,i]=(0,p.$1t)(w);let n;if(w.length>0){const c=o+1;c===1?n=new R.$ut(g,r,g,r+s):n=new R.$ut(g,r,g+c-1,i+1)}else n=new R.$ut(g,r,g,r);return n}static _getInverseEditRanges(h){const w=[];let g=0,r=0,o=null;for(let s=0,i=h.length;s<i;s++){const n=h[s];let c,l;o?o.range.endLineNumber===n.range.startLineNumber?(c=g,l=r+(n.range.startColumn-o.range.endColumn)):(c=g+(n.range.startLineNumber-o.range.endLineNumber),l=n.range.startColumn):(c=n.range.startLineNumber,l=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new R.$ut(c,l,c,l+n.firstLineLength):t=new R.$ut(c,l,c+f-1,n.lastLineLength+1)}else t=new R.$ut(c,l,c,l);g=t.endLineNumber,r=t.endColumn,w.push(t),o=n}return w}static u(h,w){const g=R.$ut.compareRangesUsingEnds(h.range,w.range);return g===0?h.sortIndex-w.sortIndex:g}static w(h,w){const g=R.$ut.compareRangesUsingEnds(h.range,w.range);return g===0?w.sortIndex-h.sortIndex:-g}}e.$1C=T}),define(Pe[156],Ie([1,0,13,93,155]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class M{constructor($,y,T,D,h,w,g,r,o){this.a=$,this.b=y,this.c=T,this.d=D,this.e=h,this.f=w,this.g=g,this.h=r,this.j=o}k($){const y=this.c+this.d+this.e,T=this.c+this.e;return y===0?$===1?`
`:`\r
`:T>y/2?`\r
`:`
`}create($){const y=this.k($),T=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let h=0,w=T.length;h<w;h++){const g=T[h].buffer.replace(/\r\n|\r|\n/g,y),r=(0,O.$VC)(g);T[h]=new O.$YC(g,r)}const D=new R.$1C(T,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&I.$Wf($)&&(this.b=I.$Vf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,O.$WC)(this.e,$);this.a.push(new O.$YC($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Lf($)),this.k||(this.k=I.$Of($)))}finish($=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,O.$VC)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$2C=A}),define(Pe[98],Ie([1,0,21,22]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccb=$,e.$dcb=T;var R;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(R||(R={}));function M(D){for(let h=0,w=D.length;h<w;h+=4){const g=D[h+0],r=D[h+1],o=D[h+2],s=D[h+3];D[h+0]=s,D[h+1]=o,D[h+2]=r,D[h+3]=g}}function A(D){const h=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return O.$D()||M(h),I.$Fe.wrap(h)}function p(D){const h=D.buffer;if(O.$D()||M(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const w=new Uint8Array(h.byteLength);return w.set(h),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function $(D){const h=new Uint32Array(y(D));let w=0;if(h[w++]=D.id,D.type==="full")h[w++]=1,h[w++]=D.data.length,h.set(D.data,w),w+=D.data.length;else{h[w++]=2,h[w++]=D.deltas.length;for(const g of D.deltas)h[w++]=g.start,h[w++]=g.deleteCount,g.data?(h[w++]=g.data.length,h.set(g.data,w),w+=g.data.length):h[w++]=0}return A(h)}function y(D){let h=0;if(h+=2,D.type==="full")h+=1+D.data.length;else{h+=1,h+=3*D.deltas.length;for(const w of D.deltas)w.data&&(h+=w.data.length)}return h}function T(D){const h=p(D);let w=0;const g=h[w++];if(h[w++]===1){const i=h[w++],n=h.subarray(w,w+i);return w+=i,{id:g,type:"full",data:n}}const o=h[w++],s=[];for(let i=0;i<o;i++){const n=h[w++],c=h[w++],l=h[w++];let t;l>0&&(t=h.subarray(w,w+l),w+=l),s[i]={start:n,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:s}}}),define(Pe[157],Ie([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Pe[158],Ie([1,0,18,25,22,140,159,157]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=i,e.clampedFloat=c,e.stringSet=f,e.cursorStyleToString=k,e.filterValidationDecorations=ue;var $;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=y;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class D{constructor(X,me,qe,we){this.id=X,this.name=me,this.defaultValue=qe,this.schema=we}applyUpdate(X,me){return w(X,me)}compute(X,me,qe){return qe}}class h{constructor(X,me){this.newValue=X,this.didChange=me}}e.ApplyUpdateResult=h;function w(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new h(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const qe=Array.isArray(Z)&&Array.isArray(X)&&I.$ub(Z,X);return new h(X,!qe)}let me=!1;for(const qe in X)if(X.hasOwnProperty(qe)){const we=w(Z[qe],X[qe]);we.didChange&&(Z[qe]=we.newValue,me=!0)}return new h(Z,me)}class g{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,me){return w(X,me)}validate(X){return this.defaultValue}}class r{constructor(X,me,qe,we){this.id=X,this.name=me,this.defaultValue=qe,this.schema=we}applyUpdate(X,me){return w(X,me)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,me,qe){return qe}}function o(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class s extends r{constructor(X,me,qe,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=qe),super(X,me,qe,we)}validate(X){return o(X,this.defaultValue)}}function i(Z,X,me,qe){if(typeof Z>"u")return X;let we=parseInt(Z,10);return isNaN(we)?X:(we=Math.max(me,we),we=Math.min(qe,we),we|0)}class n extends r{static clampedInt(X,me,qe,we){return i(X,me,qe,we)}constructor(X,me,qe,we,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=qe,dt.minimum=we,dt.maximum=ot),super(X,me,qe,dt),this.minimum=we,this.maximum=ot}validate(X){return n.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Z,X,me,qe){if(typeof Z>"u")return X;const we=l.float(Z,X);return l.clamp(we,me,qe)}class l extends r{static clamp(X,me,qe){return X<me?me:X>qe?qe:X}static float(X,me){if(typeof X=="number")return X;if(typeof X>"u")return me;const qe=parseFloat(X);return isNaN(qe)?me:qe}constructor(X,me,qe,we,ot){typeof ot<"u"&&(ot.type="number",ot.default=qe),super(X,me,qe,ot),this.validationFn=we}validate(X){return this.validationFn(l.float(X,this.defaultValue))}}class t extends r{static string(X,me){return typeof X!="string"?me:X}constructor(X,me,qe,we=void 0){typeof we<"u"&&(we.type="string",we.default=qe),super(X,me,qe,we)}validate(X){return t.string(X,this.defaultValue)}}function f(Z,X,me,qe){return typeof Z!="string"?X:qe&&Z in qe?qe[Z]:me.indexOf(Z)===-1?X:Z}class a extends r{constructor(X,me,qe,we,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=we,ot.default=qe),super(X,me,qe,ot),this.c=we}validate(X){return f(X,this.defaultValue,this.c)}}class m extends D{constructor(X,me,qe,we,ot,dt,Rt=void 0){typeof Rt<"u"&&(Rt.type="string",Rt.enum=ot,Rt.default=we),super(X,me,qe,Rt),this.c=ot,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function u(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class C extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,me,qe){return qe===0?X.accessibilitySupport:qe}}class b extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:p.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var v;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(v||(e.TextEditorCursorBlinkingStyle=v={}));function d(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function k(Z){switch(Z){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function P(Z){switch(Z){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class S extends g{constructor(){super(142)}compute(X,me,qe){const we=["monaco-editor"];return me.get(39)&&we.push(me.get(39)),X.extraEditorClassName&&we.push(X.extraEditorClassName),me.get(74)==="default"?we.push("mouse-default"):me.get(74)==="copy"&&we.push("mouse-copy"),me.get(111)&&we.push("showUnused"),me.get(140)&&we.push("showDeprecated"),we.join(" ")}}class W extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(X,me,qe){return qe&&X.emptySelectionClipboard}}class V extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:p.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:p.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":f(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":f(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?q.OFF:X==="true"?q.ON:X:X?q.ON:q.OFF}}e.EditorFontLigatures=q;class N extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?N.OFF:X==="true"?N.TRANSLATE:X:X?N.TRANSLATE:N.OFF}compute(X,me,qe){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class B extends g{constructor(){super(50)}compute(X,me,qe){return X.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(X){const me=l.float(X,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(me,6,100)}compute(X,me,qe){return X.fontInfo.fontSize}}class ie extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(n.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:qe,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:qe,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:qe,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:qe,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:qe,description:p.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{multiple:f(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??f(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??f(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??f(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??f(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??f(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends D{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:p.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:n.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Se;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class fe extends g{constructor(){super(145)}compute(X,me,qe){return fe.computeLayout(me,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const me=X.height/X.lineHeight,qe=Math.floor(X.paddingTop/X.lineHeight);let we=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(we=Math.max(we,me-1));const ot=(qe+X.viewLineCount+we)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:we,desiredRatio:ot,minimapLineCount:dt}}static c(X,me){const qe=X.outerWidth,we=X.outerHeight,ot=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=me.stableMinimapLayoutInput,Rt=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,Vt=X.lineHeight,Qt=X.typicalHalfwidthCharacterWidth,ri=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let Dt=ot>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Zt=X.minimap.maxColumn,Yt=X.minimap.size,Ze=X.minimap.side,ai=X.verticalScrollbarWidth,Ht=X.viewLineCount,ht=X.remainingWidth,mt=X.isViewportWrapping,xt=Xt?2:3;let Kt=Math.floor(ot*we);const Ft=Kt/ot;let ft=!1,jt=!1,_t=xt*Dt,Ut=Dt/ot,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Mt,extraLinesBeforeFirstLine:si,extraLinesBeyondLastLine:qt,desiredRatio:oi,minimapLineCount:At}=fe.computeContainedMinimapLineCount({viewLineCount:Ht,scrollBeyondLastLine:ri,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:we,lineHeight:Vt,pixelRatio:ot});if(Ht/At>1)ft=!0,jt=!0,Dt=1,_t=1,Ut=Dt/ot;else{let zt=!1,Pt=Dt+1;if(Yt==="fit"){const $t=Math.ceil((si+Ht+qt)*_t);mt&&Rt&&ht<=me.stableFitRemainingWidth?(zt=!0,Pt=me.stableFitMaxMinimapScale):zt=$t>Kt}if(Yt==="fill"||zt){ft=!0;const $t=Dt;_t=Math.min(Vt*ot,Math.max(1,Math.floor(1/oi))),mt&&Rt&&ht<=me.stableFitRemainingWidth&&(Pt=me.stableFitMaxMinimapScale),Dt=Math.min(Pt,Math.max(1,Math.floor(_t/xt))),Dt>$t&&(Qe=Math.min(2,Dt/$t)),Ut=Dt/ot/Qe,Kt=Math.ceil(Math.max(Mt,si+Ht+qt)*_t),mt?(me.stableMinimapLayoutInput=X,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Dt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const hi=Math.floor(Zt*Ut),Jt=Math.min(hi,Math.max(0,Math.floor((ht-ai-2)*Ut/(Qt+Ut)))+e.MINIMAP_GUTTER_WIDTH);let Wt=Math.floor(ot*Jt);const pt=Wt/ot;Wt=Math.floor(Wt*Qe);const Lt=Xt?1:2,Ot=Ze==="left"?0:qe-Jt-ai;return{renderMinimap:Lt,minimapLeft:Ot,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:Dt,minimapLineHeight:_t,minimapCanvasInnerWidth:Wt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:Ft}}static computeLayout(X,me){const qe=me.outerWidth|0,we=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Rt=me.typicalHalfwidthCharacterWidth,Vt=me.maxDigitWidth,Qt=me.pixelRatio,ri=me.viewLineCount,Xt=X.get(137),Dt=Xt==="inherit"?X.get(136):Xt,Zt=Dt==="inherit"?X.get(132):Dt,Yt=X.get(135),Ze=me.isDominatedByLongLines,ai=X.get(57),Ht=X.get(68).renderType!==0,ht=X.get(69),mt=X.get(105),xt=X.get(84),Kt=X.get(73),Ft=X.get(103),ft=Ft.verticalScrollbarSize,jt=Ft.verticalHasArrows,_t=Ft.arrowSize,Ut=Ft.horizontalScrollbarSize,Qe=X.get(43),hi=X.get(110)!=="never";let Jt=X.get(66);Qe&&hi&&(Jt+=16);let Wt=0;if(Ht){const ci=Math.max(dt,ht);Wt=Math.round(ci*Vt)}let pt=0;ai&&(pt=ot*me.glyphMarginDecorationLaneCount);let Lt=0,Ot=Lt+pt,Mt=Ot+Wt,si=Mt+Jt;const qt=qe-pt-Wt-Jt;let oi=!1,At=!1,Tt=-1;Dt==="inherit"&&Ze?(oi=!0,At=!0):Zt==="on"||Zt==="bounded"?At=!0:Zt==="wordWrapColumn"&&(Tt=Yt);const zt=fe.c({outerWidth:qe,outerHeight:we,lineHeight:ot,typicalHalfwidthCharacterWidth:Rt,pixelRatio:Qt,scrollBeyondLastLine:mt,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Kt,verticalScrollbarWidth:ft,viewLineCount:ri,remainingWidth:qt,isViewportWrapping:At},me.memory||new T);zt.renderMinimap!==0&&zt.minimapLeft===0&&(Lt+=zt.minimapWidth,Ot+=zt.minimapWidth,Mt+=zt.minimapWidth,si+=zt.minimapWidth);const Pt=qt-zt.minimapWidth,$t=Math.max(1,Math.floor((Pt-ft-2)/Rt)),Et=jt?_t:0;return At&&(Tt=Math.max(1,$t),Zt==="bounded"&&(Tt=Math.min(Tt,Yt))),{width:qe,height:we,glyphMarginLeft:Lt,glyphMarginWidth:pt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Ot,lineNumbersWidth:Wt,decorationsLeft:Mt,decorationsWidth:Jt,contentLeft:si,contentWidth:Pt,minimap:zt,viewportColumn:$t,isWordWrapMinified:oi,isViewportWrapping:At,wrappingColumn:Tt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Ut,overviewRuler:{top:Et,width:ft,height:we-2*Et,right:0}}}}e.EditorLayoutInfoComputer=fe;class $e extends D{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(X){return f(X,"simple",["simple","advanced"])}compute(X,me,qe){return me.get(2)===2?"advanced":qe}}var Te;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Te||(e.ShowLightbulbIconMode=Te={}));class ae extends D{constructor(){const X={enabled:Te.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Te.Off,Te.OnCode,Te.On],default:X.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:f(X.enabled,this.defaultValue.enabled,[Te.Off,Te.OnCode,Te.On])}}}class Ne extends D{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:p.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:p.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:f(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class z extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):n.clampedInt(X,this.defaultValue,0,1e3)}compute(X,me,qe){return qe<0?n.clampedInt(-qe*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class x extends l{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>l.clamp(X,0,150),{markdownDescription:p.localize(66,null)})}compute(X,me,qe){return X.fontInfo.lineHeight}}class be extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:X.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:f(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(me.side,this.defaultValue.side,["right","left"]),showSlider:f(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(me.scale,1,1,3),maxColumn:n.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:l.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Fe(Z){return Z==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class De extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{top:n.clampedInt(me.top,0,0,1e3),bottom:n.clampedInt(me.bottom,0,0,1e3)}}}class pe extends D{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:p.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class ge extends g{constructor(){super(143)}compute(X,me,qe){return X.pixelRatio}}class Q extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:X.strings,description:p.localize(88,null)},comments:{anyOf:me,default:X.comments,description:p.localize(89,null)},other:{anyOf:me,default:X.other,description:p.localize(90,null)}},default:X,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Qt=X?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!X||typeof X!="object")return this.defaultValue;const{other:me,comments:qe,strings:we}=X,ot=["on","inline","off"];let dt,Rt,Vt;return typeof me=="boolean"?dt=me?"on":"off":dt=f(me,this.defaultValue.other,ot),typeof qe=="boolean"?Rt=qe?"on":"off":Rt=f(qe,this.defaultValue.comments,ot),typeof we=="boolean"?Vt=we?"on":"off":Vt=f(we,this.defaultValue.strings,ot),{other:dt,comments:Rt,strings:Vt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(X){let me=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(me=4,qe=X):X==="interval"?me=3:X==="relative"?me=2:X==="on"?me=1:me=0),{renderType:me,renderFn:qe}}}function ue(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Me extends D{constructor(){const X=[],me={type:"number",description:p.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:X,description:p.localize(99,null)})}validate(X){if(Array.isArray(X)){const me=[];for(const qe of X)if(typeof qe=="number")me.push({column:n.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const we=qe;me.push({column:n.clampedInt(we.column,0,0,1e4),color:we.color})}return me.sort((qe,we)=>qe.column-we.column),me}return this.defaultValue}}class de extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ce(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X,qe=n.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=n.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:n.clampedInt(me.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:we,verticalSliderSize:n.clampedInt(me.verticalSliderSize,we,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:p.localize(118,null)}})}applyUpdate(X,me){let qe=!1;me.allowedCharacters&&X&&(O.$7n(X.allowedCharacters,me.allowedCharacters)||(X={...X,allowedCharacters:me.allowedCharacters},qe=!0)),me.allowedLocales&&X&&(O.$7n(X.allowedLocales,me.allowedLocales)||(X={...X,allowedLocales:me.allowedLocales},qe=!0));const we=super.applyUpdate(X,me);return qe?new h(we.newValue,!0):we}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,me){if(typeof X!="object"||!X)return me;const qe={};for(const[we,ot]of Object.entries(X))ot===!0&&(qe[we]=!0);return qe}}class U extends D{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:f(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class F extends D{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:p.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:f(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends D{constructor(){const X={enabled:M.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:X.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:X.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:X.highlightActiveIndentation,description:p.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,X,me){const qe=me.indexOf(Z);return qe===-1?X:me[qe]}class re extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:X.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:X.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertMode:f(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:f(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends D{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const me=[];for(const qe of X)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&me.push(qe)}catch{}return me}return this.defaultValue}}var Ge;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ge||(e.WrappingIndent=Ge={}));class _e extends D{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,me,qe){return me.get(2)===2?0:qe}}class xe extends g{constructor(){super(146)}compute(X,me,qe){const we=me.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class et extends D{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:f(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends D{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:f(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?at:R.$k?gt:it,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ue(new C),accessibilityPageSize:Ue(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ue(new m(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ue(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ue(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ue(new b),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ue(new m(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ue(new m(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:p.localize(260,null)})),cursorSurroundingLines:Ue(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ue(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ue(new W),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Ne),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new l(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:p.localize(271,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ue(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ue(new B),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new N),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ue(new ye),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new l(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>l.clamp(Z,-5,20),{description:p.localize(285,null)})),lightbulb:Ue(new ae),lineDecorationsWidth:Ue(new z),lineHeight:Ue(new x),lineNumbers:Ue(new he),lineNumbersMinChars:Ue(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ue(new s(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ue(new be),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new l(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ue(new m(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ue(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ue(new n(83,"overviewRulerLanes",3,0,3)),padding:Ue(new De),pasteAs:Ue(new tt),parameterHints:Ue(new pe),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new s(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ue(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ue(new Me),scrollbar:Ue(new Ae),scrollBeyondLastColumn:Ue(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:p.localize(325,null),included:R.$k})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ue(new Oe),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ue(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new U),inlineEdit:Ue(new F),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ue(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ue(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ue(new Ve),wordSeparators:Ue(new t(131,"wordSeparators",A.$5s,{description:p.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new S),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ue(new fe),wrappingInfo:Ue(new xe),wrappingIndent:Ue(new _e),wrappingStrategy:Ue(new $e)}}),define(Pe[160],Ie([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[161],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[162],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[163],Ie([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[164],Ie([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[165],Ie([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Pe[166],Ie([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Pe[167],Ie([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Pe[168],Ie([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Pe[169],Ie([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[170],Ie([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Pe[171],Ie([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Pe[172],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[173],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[174],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[175],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[176],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[177],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[178],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[179],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[180],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[181],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[182],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[183],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[184],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Pe[185],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Pe[186],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Pe[187],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Pe[188],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[189],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[190],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[191],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[192],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[193],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[194],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[195],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[196],Ie([1,0,14,162]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var R;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(R||(e.TokenType=R={}));function M(...y){switch(y.length){case 1:return(0,O.localize)(0,null,y[0]);case 2:return(0,O.localize)(1,null,y[0],y[1]);case 3:return(0,O.localize)(2,null,y[0],y[1],y[2]);default:return}}const A=(0,O.localize)(3,null),p=(0,O.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const D=this.d,h=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:h};this.g.push({offset:D,lexeme:h,additionalInfo:T}),this.f.push(w)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const D=this.c.substring(this.d,this.e),h=$.b.get(D);h?this.k(h):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,D=!1,h=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(p);return}const g=this.c.charCodeAt(T);if(D)D=!1;else if(g===47&&!h){T++;break}else g===91?h=!0:g===92?D=!0:g===93&&(h=!1);T++}for(;T<this.c.length&&$.a.has(this.c.charCodeAt(T));)T++;this.e=T;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=$}),define(Pe[197],Ie([1,0,23,33,164,311]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=$,e.$Hp=y,e.$Ip=T,e.$Jp=D,e.$Kp=h,e.$Lp=w,e.$Mp=g;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||A.test(s)}function y(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function T(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,c=s.minorBase;let l=s.minorMustEqual;const t=s.patchBase;let f=s.patchMustEqual;s.hasCaret&&(i===0||(l=!1),f=!1);let a=0;if(s.preRelease){const m=p.exec(s.preRelease);if(m){const[,u,C,b]=m;a=Date.UTC(Number(u),Number(C)-1,Number(b))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:l,patchBase:t,patchMustEqual:f,isMinimum:s.hasGreaterEquals,notBefore:a}}function D(s,i,n){let c;typeof s=="string"?c=T(y(s)):c=s;let l;i instanceof Date?l=i.getTime():typeof i=="string"&&(l=new Date(i).getTime());let t;if(typeof n=="string"?t=T(y(n)):t=n,!c||!t)return!1;const f=c.majorBase,a=c.minorBase,m=c.patchBase;let u=t.majorBase,C=t.minorBase,b=t.patchBase;const v=t.notBefore;let d=t.majorMustEqual,E=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>u?!0:f<u?!1:a>C?!0:a<C||l&&l<v?!1:m>=b:(f===1&&u===0&&(!d||!E||!k)&&(u=1,C=0,b=0,d=!0,E=!1,k=!1),f<u?!1:f>u?!d:a<C?!1:a>C?!E:m<b?!1:m>b?!k:!(l&&l<v))}function h(s,i,n,c,l){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,R.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,R.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,R.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,R.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return t.push([O.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return t.push([O.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,R.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,R.localize(9,null,"main")]),t;{const m=(0,I.$0g)(n,c.main);(0,I.$4g)(m,n)||t.push([O.default.Warning,R.localize(10,null,m.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,R.localize(11,null,"browser")]),t;{const m=(0,I.$0g)(n,c.browser);(0,I.$4g)(m,n)||t.push([O.default.Warning,R.localize(12,null,m.path,n.path)])}}if(!M.valid(c.version))return t.push([O.default.Error,R.localize(13,null)]),t;const f=[];if(!w(s,i,c,l,f))for(const m of f)t.push([O.default.Error,m]);return t}function w(s,i,n,c,l){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(s,i,n.engines.vscode,l)}function g(s,i,n){return s==="*"||r(i,n,s)}function r(s,i,n,c=[]){const l=T(y(n));if(!l)return c.push(R.localize(14,null,n)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return c.push(R.localize(15,null,n)),!1}else if(!l.majorMustEqual)return c.push(R.localize(16,null,n)),!1;return D(s,i,l)?!0:(c.push(R.localize(17,null,s,n)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Pe[71],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class I{constructor(R,M=[],A=!1){this.ctor=R,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$ti=I}),define(Pe[56],Ie([1,0,71]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=M,e.$ys=A;const O=[];var R;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function M(p,$,y){$ instanceof I.$ti||($=new I.$ti($,[],!!y)),O.push([p,$])}function A(){return O}}),define(Pe[198],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class I{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ar=I;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const p=this.lookupOrInsertNode(M),$=this.lookupOrInsertNode(A);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const p of this.a.values())p.outgoing.delete(A),p.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let p=this.a.get(A);return p||(p=new I(A,M),this.a.set(A,p)),p}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,p]of this.a)M.push(`${A}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const p=new Set([M]),$=this.c(A,p);if($)return $}}c(M,A){for(const[p,$]of M.outgoing){if(A.has(p))return[...A,p].join(" -> ");A.add(p);const y=this.c($,A);if(y)return y;A.delete(p)}}}e.$br=O}),define(Pe[3],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=R,e.$xi=M;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function p($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=p})(I||(e._util=I={})),e.$vi=R("instantiationService");function O(A,p,$){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:A,index:$}):(p[I.DI_DEPENDENCIES]=[{id:A,index:$}],p[I.DI_TARGET]=p)}function R(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const p=function($,y,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(p,$,T)};return p.toString=()=>A,I.serviceIds.set(A,p),p}function M(A){return A}}),define(Pe[50],Ie([1,0,15,2,3]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=M,e.$5i=A,e.$6i=$,e.$7i=y,e.$8i=T,e.$9i=D,e.$0i=h,e.$$i=g,e.$_i=r,e.$aj=o,e.$3i=(0,R.$wi)("configurationService");function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof O.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof O.URI)}var p;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function T(s,i){const n=Object.create(null);for(const c in s)D(n,c,s[c],i);return n}function D(s,i,n,c){const l=i.split("."),t=l.pop();let f=s;for(let a=0;a<l.length;a++){const m=l[a];let u=f[m];switch(typeof u){case"undefined":u=f[m]=Object.create(null);break;case"object":if(u===null){c(`Ignoring ${i} as ${l.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${i} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(u)}`);return}f=u}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{c(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(f)}`)}else c(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(f)}`)}function h(s,i){const n=i.split(".");w(s,n)}function w(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const c=s[n];typeof c=="object"&&!Array.isArray(c)&&(w(c,i),Object.keys(c).length===0&&delete s[n])}}function g(s,i,n){function c(f,a){let m=f;for(const u of a){if(typeof m!="object"||m===null)return;m=m[u]}return m}const l=i.split("."),t=c(s,l);return typeof t>"u"?n:t}function r(s,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in s?I.$$f(s[c])&&I.$$f(i[c])?r(s[c],i[c],n):n&&(s[c]=i[c]):s[c]=i[c])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Pe[31],Ie([1,0,22,13,196,3,161,14]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=y,e.$vj=f,e.$wj=a,e.$Pj=Te;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",I.$j),$.set("isLinux",I.$k),$.set("isWindows",I.$i),$.set("isWeb",I.$o),$.set("isMacNative",I.$j&&!I.$o),$.set("isEdge",I.$H),$.set("isFirefox",I.$F),$.set("isChrome",I.$E),$.set("isSafari",I.$G);function y(ne,z){if($.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(ne,z)}const T=Object.prototype.hasOwnProperty;var D;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const h={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),g=(0,A.localize)(1,null),r=(0,A.localize)(2,null),o=(0,A.localize)(3,null),s=(0,A.localize)(4,null),i=(0,A.localize)(5,null),n=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=h){this.k=z,this.d=new R.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const be=this.D(),Fe=be.type===17?i:void 0;throw this.h.push({message:s,offset:be.offset,lexeme:R.$rj.getLexeme(be),additionalInfo:Fe}),l.c}return x}catch(x){if(x!==l.c)throw x;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const x=this.o();z.push(x)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const x=this.s();z.push(x)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),C.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),P.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=z.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const De=Fe.lexeme,pe=De.lastIndexOf("/"),ge=pe===De.length-1?void 0:this.w(De.substring(pe+1));let Q;try{Q=new RegExp(De.substring(1,pe),ge)}catch{throw this.B("REGEX",Fe)}return B.create(x,Q)}switch(Fe.type){case 10:case 19:{const De=[Fe.lexeme];this.z();let pe=this.D(),ge=0;for(let Me=0;Me<Fe.lexeme.length;Me++)Fe.lexeme.charCodeAt(Me)===40?ge++:Fe.lexeme.charCodeAt(Me)===41&&ge--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Me=0;Me<pe.lexeme.length;Me++)pe.lexeme.charCodeAt(Me)===40?ge++:Fe.lexeme.charCodeAt(Me)===41&&ge--}if(ge<0)break;De.push(R.$rj.getLexeme(pe)),this.z(),pe=this.D()}const Q=De.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ue;try{ue=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Fe)}return t.regex(x,ue)}case 18:{const De=Fe.lexeme;this.z();let pe=null;if(!(0,O.$7e)(De)){const ge=De.indexOf("/"),Q=De.lastIndexOf("/");if(ge!==Q&&ge>=0){const Y=De.slice(ge+1,Q),he=De[Q+1]==="i"?"i":"";try{pe=new RegExp(Y,he)}catch{throw this.B("REGEX",Fe)}}}if(pe===null)throw this.B("REGEX",Fe);return B.create(x,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Fe=this.u();return t.notIn(x,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return t.equals(x,Fe);switch(Fe){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return t.notEquals(x,Fe);switch(Fe){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Fe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),N.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:n,offset:z.offset,lexeme:"",additionalInfo:c}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,x){if(this.C(z))return this.z();throw this.B(x,this.D())}B(z,x,be){const Fe=(0,A.localize)(8,null,z,R.$rj.getLexeme(x)),De=x.offset,pe=R.$rj.getLexeme(x);return this.h.push({message:Fe,offset:De,lexeme:pe,additionalInfo:be}),l.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=l;class t{static false(){return u.INSTANCE}static true(){return C.INSTANCE}static has(z){return b.create(z)}static equals(z,x){return v.create(z,x)}static notEquals(z,x){return k.create(z,x)}static regex(z,x){return B.create(z,x)}static in(z,x){return d.create(z,x)}static notIn(z,x){return E.create(z,x)}static not(z){return P.create(z)}static and(...z){return ce.create(z,null,!0)}static or(...z){return ye.create(z,null,!0)}static greater(z,x){return W.create(z,x)}static greaterEquals(z,x){return V.create(z,x)}static smaller(z,x){return q.create(z,x)}static smallerEquals(z,x){return N.create(z,x)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$uj=t;function f(ne){const z=new l({regexParsingWithErrorRecovery:!1});return ne.map(x=>(z.parse(x),z.lexingErrors.length>0?z.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,A.localize)(9,null,be.additionalInfo):(0,A.localize)(10,null),offset:be.offset,length:be.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function a(ne,z){const x=ne?ne.substituteConstants():void 0,be=z?z.substituteConstants():void 0;return!x&&!be?!0:!x||!be?!1:x.equals(be)}function m(ne,z){return ne.cmp(z)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return C.INSTANCE}}e.$xj=u;class C{static{this.INSTANCE=new C}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return u.INSTANCE}}e.$yj=C;class b{static create(z,x=null){const be=$.get(z);return typeof be=="boolean"?be?C.INSTANCE:u.INSTANCE:new b(z,x)}constructor(z,x){this.key=z,this.c=x,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=$.get(this.key);return typeof z=="boolean"?z?C.INSTANCE:u.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$zj=b;class v{static create(z,x,be=null){if(typeof x=="boolean")return x?b.create(z,be):P.create(z,be);const Fe=$.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?C.INSTANCE:u.INSTANCE:new v(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=$.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?C.INSTANCE:u.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Aj=v;class d{static create(z,x){return new d(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.f),be=z.getValue(this.d);return Array.isArray(x)?x.includes(be):typeof be=="string"&&typeof x=="object"&&x!==null?T.call(x,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Bj=d;class E{static create(z,x){return new E(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=11,this.c=d.create(z,x)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=E;class k{static create(z,x,be=null){if(typeof x=="boolean")return x?P.create(z,be):b.create(z,be);const Fe=$.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?u.INSTANCE:C.INSTANCE:new k(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=$.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?u.INSTANCE:C.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Dj=k;class P{static create(z,x=null){const be=$.get(z);return typeof be=="boolean"?be?u.INSTANCE:C.INSTANCE:new P(z,x)}constructor(z,x){this.c=z,this.d=x,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=$.get(this.c);return typeof z=="boolean"?z?u.INSTANCE:C.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Ej=P;function S(ne,z){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?z(ne):u.INSTANCE}class W{static create(z,x,be=null){return S(x,Fe=>new W(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Fj=W;class V{static create(z,x,be=null){return S(x,Fe=>new V(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Gj=V;class q{static create(z,x,be=null){return S(x,Fe=>new q(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Hj=q;class N{static create(z,x,be=null){return S(x,Fe=>new N(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ij=N;class B{static create(z,x){return new B(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return x<be?-1:x>be?1:0}equals(z){if(z.type===this.type){const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return this.d===z.d&&x===be}return!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Jj=B;class K{static create(z){return new K(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new K(this.c.map(z))}negate(){return this.c}}e.$Kj=K;function ie(ne){let z=null;for(let x=0,be=ne.length;x<be;x++){const Fe=ne[x].substituteConstants();if(ne[x]!==Fe&&z===null){z=[];for(let De=0;De<x;De++)z[De]=ne[De]}z!==null&&(z[x]=Fe)}return z===null?ne:z}class ce{static create(z,x,be){return ce.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Fe=m(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ce.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].evaluate(z))return!1;return!0}static d(z,x,be){const Fe=[];let De=!1;for(const pe of z)if(pe){if(pe.type===1){De=!0;continue}if(pe.type===0)return u.INSTANCE;if(pe.type===6){Fe.push(...pe.expr);continue}Fe.push(pe)}if(Fe.length===0&&De)return C.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(m);for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const pe=Fe[Fe.length-1];if(pe.type!==9)break;Fe.pop();const ge=Fe.pop(),Q=Fe.length===0,Y=ye.create(pe.expr.map(he=>ce.create([he,ge],null,be)),null,Q);Y&&(Fe.push(Y),Fe.sort(m))}if(Fe.length===1)return Fe[0];if(be){for(let pe=0;pe<Fe.length;pe++)for(let ge=pe+1;ge<Fe.length;ge++)if(Fe[pe].negate().equals(Fe[ge]))return u.INSTANCE;if(Fe.length===1)return Fe[0]}return new ce(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ce(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());this.c=ye.create(z,this,!0)}return this.c}}e.$Lj=ce;class ye{static create(z,x,be){return ye.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Fe=m(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(this.expr[x].evaluate(z))return!0;return!1}static d(z,x,be){let Fe=[],De=!1;if(z){for(let pe=0,ge=z.length;pe<ge;pe++){const Q=z[pe];if(Q){if(Q.type===0){De=!0;continue}if(Q.type===1)return C.INSTANCE;if(Q.type===9){Fe=Fe.concat(Q.expr);continue}Fe.push(Q)}}if(Fe.length===0&&De)return u.INSTANCE;Fe.sort(m)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];if(be){for(let pe=0;pe<Fe.length;pe++)for(let ge=pe+1;ge<Fe.length;ge++)if(Fe[pe].negate().equals(Fe[ge]))return C.INSTANCE;if(Fe.length===1)return Fe[0]}return new ye(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ye(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());for(;z.length>1;){const x=z.shift(),be=z.shift(),Fe=[];for(const De of Ne(x))for(const pe of Ne(be))Fe.push(ce.create([De,pe],null,!1));z.unshift(ye.create(Fe,null,!1))}this.c=ye.create(z,this,!0)}return this.c}}e.$Mj=ye;class Se extends b{static{this.d=[]}static all(){return Se.d.values()}constructor(z,x,be){super(z,null),this.f=x,typeof be=="object"?Se.d.push({...be,key:z}):be!==!0&&Se.d.push({key:z,description:be,type:x!=null?typeof x:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return v.create(this.key,z)}notEqualsTo(z){return k.create(this.key,z)}}e.$Nj=Se,e.$Oj=(0,M.$wi)("contextKeyService");function fe(ne,z){return ne<z?-1:ne>z?1:0}function $e(ne,z,x,be){return ne<x?-1:ne>x?1:z<be?-1:z>be?1:0}function Te(ne,z){if(ne.type===0||z.type===1)return!0;if(ne.type===9)return z.type===9?ae(ne.expr,z.expr):!1;if(z.type===9){for(const x of z.expr)if(Te(ne,x))return!0;return!1}if(ne.type===6){if(z.type===6)return ae(z.expr,ne.expr);for(const x of ne.expr)if(Te(x,z))return!0;return!1}return ne.equals(z)}function ae(ne,z){let x=0,be=0;for(;x<ne.length&&be<z.length;){const Fe=ne[x].cmp(z[be]);if(Fe<0)return!1;Fe===0&&x++,be++}return x===ne.length}function Ne(ne){return ne.type===9?ne.expr:[ne]}}),define(Pe[99],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,I.$wi)("environmentService"),e.$Ei=(0,I.$xi)(e.$Di)}),define(Pe[100],Ie([1,0,163,3]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=R,e.$1o=M,e.$2o=A,e.$3o=p,e.$4o=$,e.$5o=y,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(i,n){return n==="web"&&!i.includes("web")}function $(i,n,c){return p(n,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var h;(function(i){i.Install="install",i.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$6o=(0,O.$wi)("extensionGalleryService");var g;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$7o=r;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class s extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$8o=s,e.$9o=(0,O.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,O.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,O.$wi)("IExtensionTipsService"),e.$bp=(0,I.localize2)(0,"Extensions"),e.$cp=(0,I.localize2)(1,"Preferences")}),define(Pe[38],Ie([1,0,54,19,13,15,2,165,3,22,16,43]),function(le,e,I,O,R,M,A,p,$,y,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=h,e.$5k=o,e.$6k=i,e.$7k=n,e.$8k=c,e.$9k=l,e.$0k=t,e.$$k=f,e.$_k=a,e.$al=m,e.$bl=u,e.$dl=v,e.$el=d,e.$fl=E,e.$gl=k,e.$hl=P,e.$kl=N,e.$wl=Se,e.$xl=fe,e.$zl=Te,e.$3k=(0,$.$wi)("fileService");function h(ae){return ae.create===!0}var w;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var g;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(g||(e.FilePermission=g={}));var r;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(ae){const Ne=ae;return!!Ne&&typeof Ne.onDidChange=="function"}var s;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function i(ae){return!!(ae.capabilities&2)}function n(ae){return!!(ae.capabilities&8)}function c(ae){return!!(ae.capabilities&131072)}function l(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function f(ae){return i(ae)?!!(ae.capabilities&16384):!1}function a(ae){return i(ae)?!!(ae.capabilities&32768):!1}function m(ae){return!!(ae.capabilities&65536)}function u(ae){return!!(ae.capabilities&2048)}var C;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class b extends Error{static create(Ne,ne){const z=new b(Ne.toString(),ne);return E(z,ne),z}constructor(Ne,ne){super(Ne),this.code=ne}}e.$cl=b;function v(ae,Ne){return b.create(ae,Ne)}function d(ae){return ae||v((0,p.localize)(0,null),C.Unknown)}function E(ae,Ne){return ae.name=Ne?`${Ne} (FileSystemError)`:"FileSystemError",ae}function k(ae){if(!ae)return C.Unknown;if(ae instanceof b)return ae.code;const Ne=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ne)return C.Unknown;switch(Ne[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}function P(ae){if(ae instanceof B)return ae.fileOperationResult;switch(k(ae)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 9;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileTooLarge:return 7;default:return 10}}var S;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(S||(e.FileOperation=S={}));class W{constructor(Ne,ne,z){this.resource=Ne,this.operation=ne,this.target=z}isOperation(Ne){return this.operation===Ne}}e.$il=W;var V;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Ne,ne){this.c=ne,this.b=void 0,this.d=new D.$V(()=>{const z=I.$Ci.forUris(()=>this.c);return z.fill(this.rawAdded.map(x=>[x,!0])),z}),this.f=new D.$V(()=>{const z=I.$Ci.forUris(()=>this.c);return z.fill(this.rawUpdated.map(x=>[x,!0])),z}),this.g=new D.$V(()=>{const z=I.$Ci.forUris(()=>this.c);return z.fill(this.rawDeleted.map(x=>[x,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of Ne){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==q.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ne,...ne){return this.h(Ne,{includeChildren:!1},...ne)}affects(Ne,...ne){return this.h(Ne,{includeChildren:!0},...ne)}h(Ne,ne,...z){if(!Ne)return!1;const x=z.length>0;return!!((!x||z.includes(1))&&(this.d.value.get(Ne)||ne.includeChildren&&this.d.value.findSuperstr(Ne))||(!x||z.includes(0))&&(this.f.value.get(Ne)||ne.includeChildren&&this.f.value.findSuperstr(Ne))||(!x||z.includes(2))&&(this.g.value.findSubstr(Ne)||ne.includeChildren&&this.g.value.findSuperstr(Ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ne){return this.b===Ne}hasCorrelation(){return typeof this.b=="number"}}e.$jl=q;function N(ae,Ne,ne){return!ae||!Ne||ae===Ne||Ne.length>ae.length?!1:(Ne.charAt(Ne.length-1)!==O.sep&&(Ne+=O.sep),ne?(0,R.$yf)(ae,Ne):ae.indexOf(Ne)===0)}class B extends Error{constructor(Ne,ne,z){super(Ne),this.fileOperationResult=ne,this.options=z}}e.$ll=B;class K extends B{constructor(Ne,ne,z,x){super(Ne,ne,x),this.fileOperationResult=ne,this.size=z}}e.$ml=K;class ie extends B{constructor(Ne,ne,z){super(Ne,2,z),this.stat=ne}}e.$nl=ie;var ce;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var ye;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$vl="";function Se(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function fe(ae,Ne){if(!Ne.hasProvider(A.URI.from({scheme:ae.scheme})))return new Promise(ne=>{const z=Ne.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ae.scheme&&x.added&&(z.dispose(),ne())})})}class $e{static{this.KB=1024}static{this.MB=$e.KB*$e.KB}static{this.GB=$e.MB*$e.KB}static{this.TB=$e.GB*$e.KB}static formatSize(Ne){return(0,M.$ag)(Ne)||(Ne=0),Ne<$e.KB?(0,p.localize)(1,null,Ne.toFixed(0)):Ne<$e.MB?(0,p.localize)(2,null,(Ne/$e.KB).toFixed(2)):Ne<$e.GB?(0,p.localize)(3,null,(Ne/$e.MB).toFixed(2)):Ne<$e.TB?(0,p.localize)(4,null,(Ne/$e.GB).toFixed(2)):(0,p.localize)(5,null,(Ne/$e.TB).toFixed(2))}}e.$yl=$e;function Te(ae){const Ne=typeof ae=="string"||ae?.scheme===T.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===T.Schemas.file?1024*$e.MB:Ne?10*$e.MB:y.$o?50*$e.MB:1024*$e.MB}}),define(Pe[72],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class I{constructor(...R){this.a=new Map;for(const[M,A]of R)this.set(M,A)}set(R,M){const A=this.a.get(R);return this.a.set(R,M),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$ui=I}),define(Pe[199],Ie([1,0,11,14,6,71,198,3,72,200]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const T=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class h{constructor(o=new $.$ui,s=!1,i,n=T){this.i=o,this.j=s,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$vi,this),this._globalGraph=n?i?._globalGraph??new A.$br(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const s=new class extends h{dispose(){this.h.delete(s),super.dispose()}}(o,this.j,this,this.l);return this.h.add(s),s}invokeFunction(o,...s){this.m();const i=g.traceInvocation(this.l,o);let n=!1;try{return o({get:l=>{if(n)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(l,i);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(o,...s){this.m();let i,n;return o instanceof M.$ti?(i=g.traceCreation(this.l,o.ctor),n=this.o(o.ctor,o.staticArguments.concat(s),i)):(i=g.traceCreation(this.l,o),n=this.o(o,s,i)),i.stop(),n}o(o,s=[],i){const n=p._util.getServiceDependencies(o).sort((t,f)=>t.index-f.index),c=[];for(const t of n){const f=this.s(t.id,i);f||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(f)}const l=n.length>0?n[0].index:s.length;if(s.length!==l){console.trace(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${s.length} static arguments`);const t=l-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,l)}return Reflect.construct(o,s.concat(c))}q(o,s){if(this.i.get(o)instanceof M.$ti)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const i=this.r(o);return i instanceof M.$ti?this.u(o,i,s.branch(o,!0)):(s.branch(o,!1),i)}u(o,s,i){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,i)}finally{this.t.delete(o)}}v(o,s,i){const n=new A.$br(t=>t.id.toString());let c=0;const l=[{id:o,desc:s,_trace:i}];for(;l.length;){const t=l.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new D(n);for(const f of p._util.getServiceDependencies(t.desc.ctor)){const a=this.r(f.id);if(a||this.y(`[createInstance] ${o} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),a instanceof M.$ti){const m={id:f.id,desc:a,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,m),l.push(m)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new D(n);break}for(const{data:f}of t){if(this.r(f.id)instanceof M.$ti){const m=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,m)}n.removeNode(f)}}return this.r(o)}w(o,s,i=[],n,c){if(this.i.get(o)instanceof M.$ti)return this.x(o,s,i,n,c,this.g);if(this.k)return this.k.w(o,s,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,i=[],n,c,l){if(n){const t=new h(void 0,this.j,this,this.l);t.c=String(o);const f=new Map,a=new I.$Ph(()=>{const m=t.o(s,i,c);for(const[u,C]of f){const b=m[u];if(typeof b=="function")for(const v of C)v.disposable=b.apply(m,v.listener)}return f.clear(),l.add(m),m});return new Proxy(Object.create(null),{get(m,u){if(!a.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let v=f.get(u);return v||(v=new y.$5c,f.set(u,v)),(E,k,P)=>{if(a.isInitialized)return a.value[u](E,k,P);{const S={listener:[E,k,P],disposable:void 0},W=v.push(S);return(0,R.$Sc)(()=>{W(),S.disposable?.dispose()})}}}if(u in m)return m[u];const C=a.value;let b=C[u];return typeof b!="function"||(b=b.bind(C),m[u]=b),b},set(m,u,C){return a.value[u]=C,!0},getPrototypeOf(m){return s.prototype}})}else{const t=this.o(s,i,c);return l.add(t),t}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$cr=h;var w;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(w||(w={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new g(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(o,s){return o?new g(1,s.name):g.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const i=new g(3,o.toString());return this.h.push([o,s,i]),i}stop(){const o=Date.now()-this.g;g.f+=o;let s=!1;function i(c,l){const t=[],f=new Array(c+1).join("	");for(const[a,m,u]of l.h)if(m&&u){s=!0,t.push(`${f}CREATES -> ${a}`);const C=i(c+1,u);C&&t.push(C)}else t.push(`${f}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(o>2||s)&&g.all.add(n.join(`
`))}}e.$dr=g}),define(Pe[12],Ie([1,0,166,44,5,73,6,28,22,23,15,2,31,3]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=r,e.log=s,e.$ek=b,e.$fk=v,e.$gk=d,e.$hk=E,e.$3j=(0,w.$wi)("logService"),e.$4j=(0,w.$wi)("loggerService");function g(){return new Date().toISOString()}function r(k){return(0,T.$ag)(k)}var o;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$6j=o.Info;function s(k,P,S){switch(P){case o.Trace:k.trace(S);break;case o.Debug:k.debug(S);break;case o.Info:k.info(S);break;case o.Warning:k.warn(S);break;case o.Error:k.error(S);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function i(k,P=!1){let S="";for(let W=0;W<k.length;W++){let V=k[W];if(V instanceof Error&&(V=(0,O.$hj)(V,P)),typeof V=="object")try{V=JSON.stringify(V)}catch{}S+=(W>0?" ":"")+V}return S}class n extends A.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new R.$de),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==o.Off&&this.b<=P}}e.$8j=n;class c extends n{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...S){this.f(o.Trace)&&this.g(o.Trace,i([P,...S],!0))}debug(P,...S){this.f(o.Debug)&&this.g(o.Debug,i([P,...S]))}info(P,...S){this.f(o.Info)&&this.g(o.Info,i([P,...S]))}warn(P,...S){this.f(o.Warning)&&this.g(o.Warning,i([P,...S]))}error(P,...S){if(this.f(o.Error))if(P instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=P.stack,this.g(o.Error,i(W))}else this.g(o.Error,i([P,...S]))}flush(){}}e.$9j=c;class l extends n{constructor(P=e.$6j){super(),this.setLevel(P),this.g=!$.$i}trace(P,...S){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,P,...S):console.log(`[main ${g()}]`,P,...S))}debug(P,...S){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,P,...S):console.log(`[main ${g()}]`,P,...S))}info(P,...S){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,P,...S):console.log(`[main ${g()}]`,P,...S))}warn(P,...S){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,P,...S):console.warn(`[main ${g()}]`,P,...S))}error(P,...S){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,P,...S):console.error(`[main ${g()}]`,P,...S))}flush(){}}e.$0j=l;class t extends n{constructor(P=e.$6j,S=!0){super(),this.g=S,this.setLevel(P)}trace(P,...S){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...S):console.log(P,...S))}debug(P,...S){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...S):console.log(P,...S))}info(P,...S){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...S):console.log(P,...S))}warn(P,...S){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...S):console.log(P,...S))}error(P,...S){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...S):console.error(P,...S))}flush(){}}e.$$j=t;class f extends n{constructor(P,S=e.$6j){super(),this.g=P,this.setLevel(S)}trace(P,...S){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(P),...S])}debug(P,...S){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(P),...S])}info(P,...S){this.f(o.Info)&&this.g.log(o.Info,[this.h(P),...S])}warn(P,...S){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(P),...S])}error(P,...S){this.f(o.Error)&&this.g.log(o.Error,[this.h(P),...S])}h(P){return typeof P=="string"?P:(0,O.$hj)(P,this.f(o.Trace))}flush(){}}e.$_j=f;class a extends n{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const S of this.g)S.setLevel(P);super.setLevel(P)}trace(P,...S){for(const W of this.g)W.trace(P,...S)}debug(P,...S){for(const W of this.g)W.debug(P,...S)}info(P,...S){for(const W of this.g)W.info(P,...S)}warn(P,...S){for(const W of this.g)W.warn(P,...S)}error(P,...S){for(const W of this.g)W.error(P,...S)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$ak=a;class m extends A.$Uc{constructor(P,S,W){if(super(),this.h=P,this.j=S,this.b=new p.$Ac,this.c=this.B(new R.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$de),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(P){return(0,T.$9f)(P)?[...this.b.values()].find(S=>S.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,S){const W=this.n(P),V=(0,T.$9f)(P)?P:S?.id??(0,M.$kj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const N=S?.logLevel==="always"?o.Trace:S?.logLevel;q||(q=this.s(W,N??this.getLogLevel(W)??this.h,{...S,id:V}));const B={logger:q,info:{resource:W,id:V,logLevel:N,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(B.info),this.b.set(W,B),q}n(P){return(0,T.$9f)(P)?(0,y.$0g)(this.j,`${P}.log`):P}setLogLevel(P,S){if(D.URI.isUri(P)){const W=P,V=S,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=P;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,S){const W=this.m(P);W&&S!==!W.info.hidden&&(W.info.hidden=!S,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,S]))}getLogLevel(P){let S;return P&&(S=this.b.get(P)?.info.logLevel),S??this.h}registerLogger(P){const S=this.b.get(P.resource);S?S.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const S=this.b.get(P);S&&(S.logger&&S.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=m;class u{constructor(){this.onDidChangeLogLevel=new R.$de().event}setLevel(P){}getLevel(){return o.Info}trace(P,...S){}debug(P,...S){}info(P,...S){}warn(P,...S){}error(P,...S){}critical(P,...S){}dispose(){}flush(){}}e.$ck=u;class C extends u{}e.$dk=C;function b(k){if(k.verbose)return o.Trace;if(typeof k.logLevel=="string"){const P=E(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.$6j}function v(k){switch(k){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function d(k){switch(k){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function E(k){switch(k){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ik=new h.$Nj("logLevel",v(o.Info))}),define(Pe[201],Ie([1,0,6,12]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=void 0;class R extends I.$Uc{constructor(A,p=[]){super(),this.a=new O.$ak([A,...p]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...p){this.a.trace(A,...p)}debug(A,...p){this.a.debug(A,...p)}info(A,...p){this.a.info(A,...p)}warn(A,...p){this.a.warn(A,...p)}error(A,...p){this.a.error(A,...p)}flush(){this.a.flush()}}e.$ZQ=R}),define(Pe[101],Ie([1,0,33,167,3]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function y(g,r){return r-g}$.compare=y;const T=Object.create(null);T[$.Error]=(0,O.localize)(0,null),T[$.Warning]=(0,O.localize)(1,null),T[$.Info]=(0,O.localize)(2,null);function D(g){return T[g]||""}$.toString=D;function h(g){switch(g){case I.default.Error:return $.Error;case I.default.Warning:return $.Warning;case I.default.Info:return $.Info;case I.default.Ignore:return $.Hint}}$.fromSeverity=h;function w(g){switch(g){case $.Error:return I.default.Error;case $.Warning:return I.default.Warning;case $.Info:return I.default.Info;case $.Hint:return I.default.Ignore}}$.toSeverity=w}(A||(e.MarkerSeverity=A={}));var p;(function($){const y="";function T(h){return D(h,!0)}$.makeKey=T;function D(h,w){const g=[y];return h.source?g.push(h.source.replace("\xA6","\\\xA6")):g.push(y),h.code?typeof h.code=="string"?g.push(h.code.replace("\xA6","\\\xA6")):g.push(h.code.value.replace("\xA6","\\\xA6")):g.push(y),h.severity!==void 0&&h.severity!==null?g.push(A.toString(h.severity)):g.push(y),h.message&&w?g.push(h.message.replace("\xA6","\\\xA6")):g.push(y),h.startLineNumber!==void 0&&h.startLineNumber!==null?g.push(h.startLineNumber.toString()):g.push(y),h.startColumn!==void 0&&h.startColumn!==null?g.push(h.startColumn.toString()):g.push(y),h.endLineNumber!==void 0&&h.endLineNumber!==null?g.push(h.endLineNumber.toString()):g.push(y),h.endColumn!==void 0&&h.endColumn!==null?g.push(h.endColumn.toString()):g.push(y),g.push(y),g.join("\xA6")}$.makeKeyOptionalMessage=D})(p||(e.IMarkerData=p={})),e.$7t=(0,R.$wi)("markerService")}),define(Pe[202],Ie([1,0,5,33,3]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0v=e.Severity=void 0,e.$$v=p,e.Severity=O.default,e.$0v=(0,R.$wi)("notificationService");var M;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function p(D){if(D){const h=D;return typeof h.id=="string"&&typeof h.label=="string"}return!1}var $;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class y{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(h){}updateMessage(h){}updateActions(h){}close(){}}e.$_v=y;class T{infinite(){}done(){}total(h){}worked(h){}}e.$aw=T}),define(Pe[102],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,I.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,I,O){var R=arguments.length,M=R<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,I):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(le,e,I,O);else for(var p=le.length-1;p>=0;p--)(A=le[p])&&(M=(R<3?A(M):R>3?A(e,I,M):A(e,I))||M);return R>3&&M&&Object.defineProperty(e,I,M),M},We=this&&this.__param||function(le,e){return function(I,O){e(I,O,le)}};define(Pe[103],Ie([1,0,11,24,6,3]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.ProgressLocation=e.$bw=void 0,e.$bw=(0,M.$wi)("progressService");var A;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$cw=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(h){this.b=h}report(h){this.a=h,this.b(this.a)}}e.$dw=p;class ${get value(){return this.a}constructor(h){this.e=h}report(h){this.b?this.b.push(h):this.b=[h],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const h=this.b.shift();this.a=h,await this.e(this.a)}}finally{this.c=!1;const h=this.d;this.d=void 0,h?.()}}drain(){return this.c?new Promise(h=>{const w=this.d;this.d=()=>{w?.(),h()}}):Promise.resolve()}}e.$ew=$;let y=class extends R.$Uc{constructor(h,w){super(),this.a=new I.$Th,w.withProgress(h,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(h){this.b?this.b.report(h):this.c=h}};e.$fw=y,e.$fw=y=Je([We(1,e.$bw)],y);class T extends R.$Uc{constructor(h){super(),this.g=h,this.a=0,this.b=this.B(new R.$Tc)}start(h){this.stop();const w=++this.a,g=new O.$oe;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},h),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>g.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:g.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(h){this.a===h&&this.b.clear()}}e.$gw=T,e.$hw=(0,M.$wi)("editorProgressService")}),define(Pe[29],Ie([1,0,57,15]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class R{constructor(){this.a=new Map}add(A,p){I.ok(O.$9f(A)),I.ok(O.$$f(p)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,p)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$co=new R}),define(Pe[74],Ie([1,0,5,29]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class M{constructor(){this.b=new I.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[R($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;O.$co.add(e.$do.JSONContribution,A)}),define(Pe[51],Ie([1,0,18,5,15,160,50,74,29]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=r,e.$to=o,e.$uo=s,e.$vo=n,e.$wo=c;var y;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$ho={Configuration:"base.contributions.configuration"};var T;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const D=$.$co.as(p.$do.JSONContribution);class h{constructor(){this.h=new Set,this.i=new O.$de,this.onDidSchemaChange=this.i.event,this.j=new O.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const a=new Set;this.n(t,f,a),D.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const f=new Set;this.o(t,f),D.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const a=new Set;this.o(f,a),this.n(t,!1,a),D.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const a=[];for(const{overrides:m,source:u}of t)for(const C in m)if(f.add(C),e.$ro.test(C)){const b=this.a.get(C),v=b?.valuesSources??new Map;if(u)for(const P of Object.keys(m[C]))v.set(P,u);const d={...b?.value||{},...m[C]};this.a.set(C,{source:u,value:d,valuesSources:v});const E=(0,A.$aj)(C),k={type:"object",default:d,description:M.localize(1,null,E),$ref:e.$oo,defaultDefaultValue:d,source:R.$9f(u)?void 0:u,defaultValueSource:u};a.push(...r(C)),this.d[C]=k,this.b.properties[C]=k}else{this.a.set(C,{value:m[C],source:u});const b=this.d[C];b&&(this.w(C,b),this.r(C,b))}this.m(a)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:a,source:m}of t)for(const u in a){const C=this.a.get(u),b=R.$9f(m)?m:m?.id,v=R.$9f(C?.source)?C?.source:C?.source?.id;if(b===v)if(f.add(u),this.a.delete(u),e.$ro.test(u))delete this.d[u],delete this.b.properties[u];else{const d=this.d[u];d&&(this.w(u,d),this.r(u,d))}}this.u()}deltaConfiguration(t){let f=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,a){t.forEach(m=>{this.p(m,f,m.extensionInfo,m.restrictedProperties,void 0,a),this.c.push(m),this.q(m)})}o(t,f){const a=m=>{if(m.properties)for(const u in m.properties){f.add(u);const C=this.d[u];C?.policy?.name&&this.e.delete(C.policy.name),delete this.d[u],this.s(u,m.properties[u])}m.allOf?.forEach(u=>a(u))};for(const m of t){a(m);const u=this.c.indexOf(m);u!==-1&&this.c.splice(u,1)}}p(t,f=!0,a,m,u=3,C){u=R.$fg(t.scope)?u:t.scope;const b=t.properties;if(b)for(const d in b){const E=b[d];if(f&&n(d,E)){delete b[d];continue}if(E.source=a,E.defaultDefaultValue=b[d].default,this.w(d,E),e.$ro.test(d)?E.scope=void 0:(E.scope=R.$fg(E.scope)?u:E.scope,E.restricted=R.$fg(E.restricted)?!!m?.includes(d):E.restricted),b[d].hasOwnProperty("included")&&!b[d].included){this.f[d]=b[d],delete b[d];continue}else this.d[d]=b[d],b[d].policy?.name&&this.e.set(b[d].policy.name,d);!b[d].deprecationMessage&&b[d].markdownDeprecationMessage&&(b[d].deprecationMessage=b[d].markdownDeprecationMessage),C.add(d)}const v=t.allOf;if(v)for(const d of v)this.p(d,f,a,m,u,C)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=a=>{const m=a.properties;if(m)for(const C in m)this.r(C,m[C]);a.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$io.properties[t]=f,f.scope){case 1:e.$jo.properties[t]=f;break;case 2:e.$ko.properties[t]=f;break;case 6:e.$lo.properties[t]=f;break;case 3:e.$mo.properties[t]=f;break;case 4:e.$no.properties[t]=f;break;case 5:e.$no.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$io.properties[t],f.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$oo};this.w(f,a),e.$io.properties[f]=a,e.$jo.properties[f]=a,e.$ko.properties[f]=a,e.$lo.properties[f]=a,e.$mo.properties[f]=a,e.$no.properties[f]=a}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,f){const a=this.a.get(t);let m=a?.value,u=a?.source;R.$dg(m)&&(m=f.defaultDefaultValue,u=void 0),R.$dg(m)&&(m=s(f.type)),f.default=m,f.defaultValueSource=u}}const w="\\[([^\\]]+)\\]",g=new RegExp(w,"g");e.$qo=`^(${w})+$`,e.$ro=new RegExp(e.$qo);function r(l){const t=[];if(e.$ro.test(l)){let f=g.exec(l);for(;f?.length;){const a=f[1].trim();a&&t.push(a),f=g.exec(l)}}return(0,I.$Mb)(t)}function o(l){return l.reduce((t,f)=>`${t}[${f}]`,"")}function s(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new h;$.$co.add(e.$ho.Configuration,i);function n(l,t){return l.trim()?e.$ro.test(l)?M.localize(7,null,l):i.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,l,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function c(){const l=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))l.push([f,t[f].scope]);return l.push(["launch",4]),l.push(["task",4]),l}}),define(Pe[203],Ie([1,0,18,5,126,6,28,25,15,2,50,51,29]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=n;function w(f){return Object.isFrozen(f)?f:p.$4n(f)}class g{static createEmptyModel(a){return new g({},[],[],void 0,a)}constructor(a,m,u,C,b){this.b=a,this.c=m,this.d=u,this.raw=C,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(m=>{if(m instanceof g)return m;const u=new r("",this.f);return u.parseRaw(m),u.configurationModel});this.g=a.reduce((m,u)=>u===m?u:m.merge(u),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$$i)(this.contents,a):this.contents}inspect(a,m){const u=this;return{get value(){return w(u.rawConfiguration.getValue(a))},get override(){return m?w(u.rawConfiguration.getOverrideValue(a,m)):void 0},get merged(){return w(m?u.rawConfiguration.override(m).getValue(a):u.rawConfiguration.getValue(a))},get overrides(){const C=[];for(const{contents:b,identifiers:v,keys:d}of u.rawConfiguration.overrides){const E=new g(b,d,[],void 0,u.f).getValue(a);E!==void 0&&C.push({identifiers:v,value:E})}return C.length?w(C):void 0}}}getOverrideValue(a,m){const u=this.j(m);return u?a?(0,T.$$i)(u,a):u:void 0}getKeysForOverrideIdentifier(a){const m=[];for(const u of this.overrides)u.identifiers.includes(a)&&m.push(...u.keys);return I.$Mb(m)}getAllOverrideIdentifiers(){const a=[];for(const m of this.overrides)a.push(...m.identifiers);return I.$Mb(a)}override(a){let m=this.a.get(a);return m||(m=this.h(a),this.a.set(a,m)),m}merge(...a){const m=p.$3n(this.contents),u=p.$3n(this.overrides),C=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const v of a)if(b.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.i(m,v.contents);for(const d of v.overrides){const[E]=u.filter(k=>I.$ub(k.identifiers,d.identifiers));E?(this.i(E.contents,d.contents),E.keys.push(...d.keys),E.keys=I.$Mb(E.keys)):u.push(p.$3n(d))}for(const d of v.keys)C.indexOf(d)===-1&&C.push(d)}return new g(m,C,u,b.every(v=>v instanceof g)?void 0:b,this.f)}h(a){const m=this.j(a);if(!m||typeof m!="object"||!Object.keys(m).length)return this;const u={};for(const C of I.$Mb([...Object.keys(this.contents),...Object.keys(m)])){let b=this.contents[C];const v=m[C];v&&(typeof b=="object"&&typeof v=="object"?(b=p.$3n(b),this.i(b,v)):b=v),u[C]=b}return new g(u,this.keys,this.overrides,void 0,this.f)}i(a,m){for(const u of Object.keys(m)){if(u in a&&$.$$f(a[u])&&$.$$f(m[u])){this.i(a[u],m[u]);continue}a[u]=p.$3n(m[u])}}j(a){let m=null,u=null;const C=b=>{b&&(u?this.i(u,b):u=p.$3n(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===a?m=b.contents:b.identifiers.includes(a)&&C(b.contents);return C(m),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,m){this.k(a,m,!0)}setValue(a,m){this.k(a,m,!1)}removeValue(a){const m=this.keys.indexOf(a);m!==-1&&(this.keys.splice(m,1),(0,T.$0i)(this.contents,a),D.$ro.test(a)&&this.overrides.splice(this.overrides.findIndex(u=>I.$ub(u.identifiers,(0,D.$so)(a))),1))}k(a,m,u){(0,T.$9i)(this.contents,a,m,C=>this.f.error(C)),u=u||this.keys.indexOf(a)===-1,u&&this.keys.push(a),D.$ro.test(a)&&this.overrides.push({identifiers:(0,D.$so)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$8i)(this.contents[a],C=>this.f.error(C))})}}e.$xo=g;class r{constructor(a,m){this.f=a,this.g=m,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,m){if(!$.$fg(a)){const u=this.h(a);this.parseRaw(u,m)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,m){this.a=a;const{contents:u,keys:C,overrides:b,restricted:v,hasExcludedProperties:d}=this.i(a,m);this.b=new g(u,C,b,d?[a]:void 0,this.g),this.c=v||[]}h(a){let m={},u=null,C=[];const b=[],v=[];function d(k){Array.isArray(C)?C.push(k):u!==null&&(C[u]=k)}const E={onObjectBegin:()=>{const k={};d(k),b.push(C),C=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{C=b.pop()},onArrayBegin:()=>{const k=[];d(k),b.push(C),C=k,u=null},onArrayEnd:()=>{C=b.pop()},onLiteralValue:d,onError:(k,P,S)=>{v.push({error:k,offset:P,length:S})}};if(a)try{R.$Qn(a,E),m=C[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return m}i(a,m){const u=h.$co.as(D.$ho.Configuration).getConfigurationProperties(),C=this.j(a,u,!0,m);a=C.raw;const b=(0,T.$8i)(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),v=Object.keys(a),d=this.l(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:b,keys:v,overrides:d,restricted:C.restricted,hasExcludedProperties:C.hasExcludedProperties}}j(a,m,u,C){let b=!1;if(!C?.scopes&&!C?.skipRestricted&&!C?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:b};const v={},d=[];for(const E in a)if(D.$ro.test(E)&&u){const k=this.j(a[E],m,!1,C);v[E]=k.raw,b=b||k.hasExcludedProperties,d.push(...k.restricted)}else{const k=m[E],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&d.push(E),!C.exclude?.includes(E)&&(C.include?.includes(E)||(P===void 0||C.scopes===void 0||C.scopes.includes(P))&&!(C.skipRestricted&&k?.restricted))?v[E]=a[E]:b=!0}return{raw:v,restricted:d,hasExcludedProperties:b}}l(a,m){const u=[];for(const C of Object.keys(a))if(D.$ro.test(C)){const b={};for(const v in a[C])b[v]=a[C][v];u.push({identifiers:(0,D.$so)(C),keys:Object.keys(b),contents:(0,T.$8i)(b,m)})}return u}}e.$yo=r;class o extends M.$Uc{constructor(a,m,u,C,b){super(),this.c=a,this.f=m,this.g=C,this.h=b,this.b=this.B(new O.$de),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),b),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&u.isEqual(v.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=o;class s{constructor(a,m,u,C,b,v,d,E,k,P,S,W,V){this.a=a,this.b=m,this.c=u,this.overrideIdentifiers=C,this.d=b,this.f=v,this.g=d,this.h=E,this.i=k,this.j=P,this.k=S,this.l=W,this.m=V}get value(){return w(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(a,m,u,C,b,v,d,E,k,P){this.j=a,this.l=m,this.m=u,this.n=C,this.p=b,this.q=v,this.r=d,this.s=E,this.t=k,this.u=P,this.h=null,this.i=new A.$Ac,this.v=null}getValue(a,m,u){return this.w(a,m,u).getValue(a)}updateValue(a,m,u={}){let C;u.resource?(C=this.t.get(u.resource),C||(C=g.createEmptyModel(this.u),this.t.set(u.resource,C))):C=this.s,m===void 0?C.removeValue(a):C.setValue(a,m),u.resource||(this.h=null)}inspect(a,m,u){const C=this.w(a,m,u),b=this.A(m.resource,u),v=m.resource?this.t.get(m.resource)||this.s:this.s,d=new Set;for(const E of C.overrides)for(const k of E.identifiers)C.getOverrideValue(a,k)!==void 0&&d.add(k);return new s(a,m,C.getValue(a),d.size?[...d]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,b||void 0,v)}keys(a){const m=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:m?m.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,m){this.r.set(a,m),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,m){const u=[];if(!m){const{added:C,updated:b,removed:v}=l(this.j,a);m=[...C,...b,...v]}for(const C of m)for(const b of(0,D.$so)(C)){const v=this.j.getKeysForOverrideIdentifier(b),d=a.getKeysForOverrideIdentifier(b),E=[...d.filter(k=>v.indexOf(k)===-1),...v.filter(k=>d.indexOf(k)===-1),...v.filter(k=>!p.$7n(this.j.override(b).getValue(k),a.override(b).getValue(k)))];u.push([b,E])}return this.updateDefaultConfiguration(a),{keys:m,overrides:u}}compareAndUpdatePolicyConfiguration(a){const{added:m,updated:u,removed:C}=l(this.l,a),b=[...m,...u,...C];return b.length&&this.updatePolicyConfiguration(a),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:m,updated:u,removed:C,overrides:b}=l(this.applicationConfiguration,a),v=[...m,...u,...C];return v.length&&this.updateApplicationConfiguration(a),{keys:v,overrides:b}}compareAndUpdateLocalUserConfiguration(a){const{added:m,updated:u,removed:C,overrides:b}=l(this.localUserConfiguration,a),v=[...m,...u,...C];return v.length&&this.updateLocalUserConfiguration(a),{keys:v,overrides:b}}compareAndUpdateRemoteUserConfiguration(a){const{added:m,updated:u,removed:C,overrides:b}=l(this.remoteUserConfiguration,a),v=[...m,...u,...C];return v.length&&this.updateRemoteUserConfiguration(a),{keys:v,overrides:b}}compareAndUpdateWorkspaceConfiguration(a){const{added:m,updated:u,removed:C,overrides:b}=l(this.workspaceConfiguration,a),v=[...m,...u,...C];return v.length&&this.updateWorkspaceConfiguration(a),{keys:v,overrides:b}}compareAndUpdateFolderConfiguration(a,m){const u=this.folderConfigurations.get(a),{added:C,updated:b,removed:v,overrides:d}=l(u,m),E=[...C,...b,...v];return(E.length||!u)&&this.updateFolderConfiguration(a,m),{keys:E,overrides:d}}compareAndDeleteFolderConfiguration(a){const m=this.folderConfigurations.get(a);if(!m)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:u,updated:C,removed:b,overrides:v}=l(m,void 0);return{keys:[...u,...C,...b],overrides:v}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,m,u){let C=this.x(m,u);return m.overrideIdentifier&&(C=C.override(m.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(C=C.merge(this.l)),C}x({resource:a},m){let u=this.y();if(m&&a){const C=m.getFolder(a);C&&(u=this.z(C.uri)||u);const b=this.t.get(a);b&&(u=u.merge(b))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let m=this.i.get(a);if(!m){const u=this.y(),C=this.r.get(a);C?(m=u.merge(C),this.i.set(a,m)):m=u}return m}A(a,m){if(m&&a){const u=m.getFolder(a);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,m)=>{const{contents:u,overrides:C,keys:b}=this.r.get(m);return a.push([m,{contents:u,overrides:C,keys:b}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(m=>a.add(m)),this.userConfiguration.keys.forEach(m=>a.add(m)),this.q.keys.forEach(m=>a.add(m)),this.r.forEach(m=>m.keys.forEach(u=>a.add(u))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(m=>a.add(m)),this.userConfiguration.getAllOverrideIdentifiers().forEach(m=>a.add(m)),this.q.getAllOverrideIdentifiers().forEach(m=>a.add(m)),this.r.forEach(m=>m.getAllOverrideIdentifiers().forEach(u=>a.add(u))),[...a.values()]}D(a){const m=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(u=>m.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(u=>m.add(u)),this.q.getKeysForOverrideIdentifier(a).forEach(u=>m.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(a).forEach(C=>m.add(C))),[...m.values()]}static parse(a,m){const u=this.E(a.defaults,m),C=this.E(a.policy,m),b=this.E(a.application,m),v=this.E(a.user,m),d=this.E(a.workspace,m),E=a.folders.reduce((k,P)=>(k.set(y.URI.revive(P[0]),this.E(P[1],m)),k),new A.$Ac);return new i(u,C,b,v,g.createEmptyModel(m),d,E,g.createEmptyModel(m),new A.$Ac,m)}static E(a,m){return new g(a.contents,a.keys,a.overrides,void 0,m)}}e.$Ao=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const a=new Set,m=new Map;for(const C of f)C.keys.forEach(b=>a.add(b)),C.overrides.forEach(([b,v])=>{const d=(0,A.$xc)(m,b,new Set);v.forEach(E=>d.add(E))});const u=[];return m.forEach((C,b)=>u.push([b,[...C.values()]])),{keys:[...a.values()],overrides:u}}class c{constructor(a,m,u,C,b){this.change=a,this.f=m,this.g=u,this.h=C,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const v of a.keys)this.affectedKeys.add(v);for(const[,v]of a.overrides)for(const d of v)this.affectedKeys.add(d);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,m){const u=this.a+a,C=this.d.indexOf(u);if(C<0)return!1;const b=C+u.length;if(b>=this.d.length)return!1;const v=this.d.charCodeAt(b);if(v!==this.b&&v!==this.c)return!1;if(m){const d=this.previousConfiguration?this.previousConfiguration.getValue(a,m,this.f?.workspace):void 0,E=this.g.getValue(a,m,this.h);return!p.$7n(d,E)}return!0}}e.$Co=c;function l(f,a){const{added:m,removed:u,updated:C}=t(a?.rawConfiguration,f?.rawConfiguration),b=[],v=f?.getAllOverrideIdentifiers()||[],d=a?.getAllOverrideIdentifiers()||[];if(a){const E=d.filter(k=>!v.includes(k));for(const k of E)b.push([k,a.getKeysForOverrideIdentifier(k)])}if(f){const E=v.filter(k=>!d.includes(k));for(const k of E)b.push([k,f.getKeysForOverrideIdentifier(k)])}if(a&&f){for(const E of v)if(d.includes(E)){const k=t({contents:f.getOverrideValue(void 0,E)||{},keys:f.getKeysForOverrideIdentifier(E)},{contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)});b.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:m,removed:u,updated:C,overrides:b}}function t(f,a){const m=f?a?f.keys.filter(b=>a.keys.indexOf(b)===-1):[...f.keys]:[],u=a?f?a.keys.filter(b=>f.keys.indexOf(b)===-1):[...a.keys]:[],C=[];if(f&&a){for(const b of a.keys)if(f.keys.indexOf(b)!==-1){const v=(0,T.$$i)(a.contents,b),d=(0,T.$$i)(f.contents,b);p.$7n(v,d)||C.push(b)}}return{added:m,removed:u,updated:C}}}),define(Pe[104],Ie([1,0,14,3]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=y,e.$Hl=(0,O.$wi)("remoteAuthorityResolverService");var R;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class M{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=M;class A{constructor(D,h){this.host=D,this.port=h,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=A;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends I.$bb{static isNotAvailable(D){return D instanceof $&&D._code===p.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof $&&D._code===p.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof $&&D._code===p.NoResolverFound}static isInvalidAuthority(D){return D instanceof $&&D._code===p.InvalidAuthority}static isHandled(D){return D instanceof $&&D.isHandled}constructor(D,h=p.Unknown,w){super(D),this._message=D,this._code=h,this._detail=w,this.isHandled=h===p.NotAvailable&&w===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Kl=$;function y(T){const D=T.indexOf("+");return D===-1?T:T.substring(0,D)}}),define(Pe[58],Ie([1,0,16]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=O,e.$Im=R,e.$Jm=M,e.$Km=A;function O($){return $.scheme===I.Schemas.vscodeRemote?$.authority:void 0}function R($){if(!$)return;const y=$.indexOf("+");return y<0?$:$.substr(0,y)}function M($){const{host:y,port:T}=p($);if(typeof T>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:T}}function A($,y){let{host:T,port:D}=p($);return typeof D>"u"&&(D=y),{host:T,port:D}}function p($){const y=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const T=$.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const D=$.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:$,port:void 0}}}),define(Pe[20],Ie([1,0,13,3,58]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=M,e.$Um=D,e.$Vm=h,e.$Wm=w,e.$Xm=g,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function M(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var p;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const i=typeof o=="string"?o:o.value,n=typeof s=="string"?s:s.value;return I.$xf(i,n)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Rm=$;class y{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add($.toKey(o))}delete(o){return this.c.delete($.toKey(o))}has(o){return this.c.has($.toKey(o))}}e.$Sm=y;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete($.toKey(o))}get(o){return this.c.get($.toKey(o))}has(o){return this.c.has($.toKey(o))}set(o,s){this.c.set($.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=T;function D(r){return h(r)}function h(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function w(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function g(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,R.$Im)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Ym=(0,O.$wi)("IBuiltinExtensionsScannerService")}),define(Pe[105],Ie([1,0,14,20]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(A,p){this.a.set(A,p)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const p=Object.create(null);for(const $ of A){const y=this.readActivationEvents($);y.length>0&&(p[O.$Rm.toKey($.identifier)]=y)}return p}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const p=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${O.$Rm.toKey(A.identifier)}`);if(!A.contributes)return p;for(const $ in A.contributes){const y=this.a.get($);if(!y)continue;const T=A.contributes[$],D=Array.isArray(T)?T:[T];try{y(D,p)}catch(h){(0,I.$1)(h)}}return p}}e.$tG=R,e.$uG=new R}),define(Pe[204],Ie([1,0,21,14,6,168,51,3,12,29]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=h,e.$Qp=w,e.$Rp=g,e.$Sp=r,e.$Tp=o,e.$Up=s,e.$Np=(0,p.$wi)("requestService");class T{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class D extends R.$Uc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,M.localize)(0,null),when:$.$ik.isEqualTo((0,$.$fk)($.LogLevel.Trace)).serialize()})}async c(l,t,f){const a=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new T(t.headers??{}));try{const m=await f();return this.a.trace(`${a} - end`,t.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${a} - error`,t.type,(0,O.$0)(m)),m}}}e.$Op=D;function h(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function w(c){return c.res.statusCode===204}async function g(c){return w(c)?null:(await(0,I.$Re)(c.stream)).toString()}async function r(c){if(!h(c))throw new Error("Server returned "+c.res.statusCode);return g(c)}async function o(c){if(!h(c))throw new Error("Server returned "+c.res.statusCode);if(w(c))return null;const t=(await(0,I.$Re)(c.stream)).toString();try{return JSON.parse(t)}catch(f){throw f.message+=`:
`+t,f}}function s(c){n(c)}let i;function n(c){const l=y.$co.as(A.$ho.Configuration),t=i;i={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(Pe[205],Ie([1,0,22,75,34]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=A,e.$ep=p;function M($){if(I.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,y,T,D,h,w,g,r,o){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=g,s.sessionID=(0,R.$Sg)()+Date.now(),s.commitHash=D,s.version=h,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=O.$dc,s["common.nodeArch"]=T,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const c=M(y);return c&&(s["common.platformDetail"]=c),s}function p($){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const T=y.toLowerCase();return $.some(D=>T===D)}}),define(Pe[206],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,I.$wi)("telemetryService"),e.$3l=(0,I.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var R;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Pe[59],Ie([1,0,25,15,58,205,206]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=T,e.$np=D,e.$op=h,e.$pp=w,e.$qp=r,e.$rp=s,e.$sp=i,e.$tp=l;class p{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$fp=p;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=$,e.$hp=new $;class y{async publicLog(f,a,m){}async publicLogError(f,a,m){}}e.$ip=y,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function D(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function h(t){const f=t.getValue(A.$0l),a=t.getValue(A.$$l);if(t.getValue(A.$_l)===!1||a===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const f={},a={},m={};o(t,m);for(let u in m){u=u.length>150?u.substr(u.length-149):u;const C=m[u];typeof C=="number"?a[u]=C:typeof C=="boolean"?a[u]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${C.length}`),f[u]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(f[u]=C)}return{properties:f,measurements:a}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,R.$Im)(t);return g.has(f)?f:"other"}function o(t,f,a=0,m){if(t)for(const u of Object.getOwnPropertyNames(t)){const C=t[u],b=m?m+u:u;Array.isArray(C)?f[b]=(0,I.$8n)(C):C instanceof Date?f[b]=C.toISOString():(0,O.$$f)(C)?a<2?o(C,f,a+1,b+"."):f[b]=(0,I.$8n)(C):f[b]=C}}function s(t,f){const a=t.msftInternalDomains||[],m=f.getValue("telemetry.internalTesting");return(0,M.$ep)(a)||m}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const m=[];for(const v of f)for(;;){const d=v.exec(t);if(!d)break;m.push([d.index,v.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(a="";;){const v=C.exec(t);if(!v)break;const d=m.some(([E,k])=>v.index<k&&E<C.lastIndex);!u.test(v[0])&&!d&&(a+=t.substring(b,v.index)+"<REDACTED: user-file-path>",b=C.lastIndex)}return b<t.length&&(a+=t.substr(b)),a}function c(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of f)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function l(t,f){return(0,I.$5n)(t,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let m=a.replaceAll("%20"," ");m=n(m,f);for(const u of f)m=m.replace(u,"");return m=c(m),m}})}}),define(Pe[207],Ie([1,0,13,100,20,22,2,14,75,59]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=T,e.$wp=g,e.$xp=r,e.$yp=o,e.$zp=s,e.$Ap=i,e.$Bp=n,e.$Cp=c,e.$Ep=l,e.$Fp=f;function T(a,m){return a.uuid&&m.uuid?a.uuid===m.uuid:a.id===m.id?!0:(0,I.$sf)(a.id,m.id)===0}const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(m){const u=m.manifest?m.manifest.version:m.version,C=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new h(m.identifier,u,C)}static parse(m){const u=D.exec(m);return u&&u[1]&&u[2]?new h({id:u[1]},u[2],u[4]||void 0):null}constructor(m,u,C="undefined"){this.version=u,this.targetPlatform=C,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof h?T(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$vp=h;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(a){const m=w.exec(a);return m&&m[1]?[o(m[1]),m[2]]:[o(a),void 0]}function r(a,m){return`${a}.${m}`}function o(a){return a.toLowerCase()}function s(a,m){return o(r(a??R.$Nm,m))}function i(a,m){const u=[],C=b=>{for(const v of u)if(v.some(d=>T(m(d),m(b))))return v;return null};for(const b of a){const v=C(b);v?v.push(b):u.push([b])}return u}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new y.$fp(a.identifier.id),name:new y.$fp(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Dp=new R.$Rm("pprice.better-merge");function l(a,m){const u=[],C=m.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const b=C.shift();if(b&&u.every(v=>!T(v.identifier,{id:b}))){const v=a.filter(d=>T(d.identifier,{id:b}));v.length===1&&(u.push(v[0]),C.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function t(a,m){if(!M.$k)return!1;let u;try{u=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){m.debug("Error while getting the os-release file.",(0,p.$0)(b))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(a,m){const u=await t(a,m),C=(0,O.$2o)(u?"alpine":M.$u,$.$ec);return m.debug("ComputeTargetPlatform:",C),C}}),define(Pe[208],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=I,e.$ms=O,e.$ns=R,e.$os=M,e.$ps=A,e.$qs=p;function I($){return[...$.entries()]}function O($){return $?[...$.entries()]:[]}function R($){return new Map($)}function M($){return new Map($??[])}function A($){return Array.from($.entries()).map(y=>[y[0],I(y[1].map),O(y[1].descriptionMap)])}function p($){return new Map($.map(y=>[y[0],{map:R(y[1]),descriptionMap:M(y[2])}]))}}),define(Pe[209],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fvb=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,M,A=5){const p=M($=>{const y=typeof $=="string"?$:$.data;let T=this.a.get(R);if(T){T.data.push(y);return}const D=setTimeout(()=>this.flushBuffer(R),A);T={data:[y],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(R),p.dispose()}},this.a.set(R,T)});return p}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const M=this.a.get(R);M&&(this.a.delete(R),this.b(R,M.data.join("")))}}e.$Fvb=I}),define(Pe[210],Ie([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,I,O,R,M,A,p,$,y,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.$hx=e.IconFontDefinition=e.IconContribution=e.$ex=void 0,e.$fx=o,e.$gx=s,e.$ex={IconContribution:"base.contributions.icons"};var h;(function(l){function t(f,a){let m=f.defaults;for(;M.ThemeIcon.isThemeIcon(m);){const u=r.getIcon(m.id);if(!u)return;m=u.defaults}return m}l.getDefinition=t})(h||(e.IconContribution=h={}));var w;(function(l){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(m=>({format:m.format,location:m.location.toString()}))}}l.toJSONObject=t;function f(a){const m=u=>(0,p.$9f)(u)?u:void 0;if(a&&Array.isArray(a.src)&&a.src.every(u=>(0,p.$9f)(u.format)&&(0,p.$9f)(u.location)))return{weight:m(a.weight),style:m(a.style),src:a.src.map(u=>({format:u.format,location:$.URI.parse(u.location)}))}}l.fromJSONObject=f})(w||(e.IconFontDefinition=w={}));class g{constructor(){this.a=new A.$de,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${M.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,a,m){const u=this.b[t];if(u){if(a&&!u.description){u.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enumDescriptions[v]=a),this.a.fire()}return u}const C={id:t,description:a,defaults:f,deprecationMessage:m};this.b[t]=C;const b={$ref:"#/definitions/icons"};return m&&(b.deprecationMessage=m),a&&(b.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=b,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const a=this.f[t];return a||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(u,C)=>u.id.localeCompare(C.id),f=u=>{for(;M.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map(u=>this.b[u]);for(const u of m.filter(C=>!!C.description).sort(t))a.push(`|<i class="${f(u)}"></i>|${u.id}|${M.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const u of m.filter(C=>!M.ThemeIcon.isThemeIcon(C.defaults)).sort(t))a.push(`|<i class="${f(u)}"></i>|${u.id}|`);return a.join(`
`)}}const r=new g;D.$co.add(e.$ex.IconContribution,r);function o(l,t,f,a){return r.registerIcon(l,t,f,a)}function s(){return r}function i(){const l=(0,R.$Rj)();for(const t in l){const f="\\"+l[t].toString(16);r.registerIcon(t,{fontCharacter:f})}}i(),e.$hx="vscode://schemas/icons";const n=D.$co.as(T.$do.JSONContribution);n.registerSchema(e.$hx,r.getIconSchema());const c=new I.$Ih(()=>n.notifySchemaChanged(e.$hx),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$ix=o("widget-close",O.$Vj.close,(0,y.localize)(2,null)),e.$jx=o("goto-previous-location",O.$Vj.arrowUp,(0,y.localize)(3,null)),e.$kx=o("goto-next-location",O.$Vj.arrowDown,(0,y.localize)(4,null)),e.$lx=M.ThemeIcon.modify(O.$Vj.sync,"spin"),e.$mx=M.ThemeIcon.modify(O.$Vj.loading,"spin")}),define(Pe[211],Ie([1,0,5,2,50,3,12]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$pw=e.$nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$jw=e.$iw=void 0,e.$kw=y,e.$lw=D,e.$mw=h,e.$ow=w,e.$qw=g,e.$rw=r,e.$iw=(0,M.$wi)("tunnelService"),e.$jw=(0,M.$wi)("sharedTunnelsService");var p;(function(i){i.Http="http",i.Https="https"})(p||(e.TunnelProtocol=p={}));var $;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})($||(e.TunnelPrivacyId=$={}));function y(i){return!!i.forwardPort}var T;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function D(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function h(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const l=c.split("=")[1];if(/^https?:/.exec(l)){const t=D(O.URI.parse(l));if(t)return t}}}e.$nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(i){return e.$nw.indexOf(i)>=0}e.$pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(i){return e.$pw.indexOf(i)>=0}function r(i,n,c,l){if(c===1)return!1;if(c===2&&g(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class o{constructor(n,c,l){this.remoteAddress=n,this.localAddress=c,this.b=l,this.a=new I.$de,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sw=o;let s=class{constructor(n,c){this.k=n,this.l=c,this.a=new I.$de,this.onTunnelOpened=this.a.event,this.b=new I.$de,this.onTunnelClosed=this.b.event,this.c=new I.$de,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const l of c){const t=Array.from(l.values());for(const f of t){const a=await f.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(l=>typeof l!="string"?l?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,l,t,f){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:l,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(g(n)||w(n))&&(n=e.$nw[0]);const l=this.s(n,c);if(l)return++l.refcount,l.value}openTunnel(n,c,l,t,f,a=!1,m,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${l} on local port ${f}.`);const C=this.f??n;if(!C)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(l)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(C,c,l,t,f,a,m,u);return b?b.then(v=>{if(v){if(typeof v=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,l),v}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,l);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.o(v);return(v.tunnelRemoteHost!==c||v.tunnelRemotePort!==l)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),m&&v.privacy!==m&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(d),d}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const l=c.get(n.tunnelRemotePort);l&&(l.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,l))}}}}async p(n,c,l){if(l.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=l.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),t}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const l=this.e.get(n);if(l&&l.has(c)){const t=l.get(c);t.refcount=0,await this.p(n,c,t)}}q(n,c,l){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:l})}async r(n,c){const l=this.e.get(n);if(l){const t=l.get(c),f=t?await t.value:void 0;(!f||typeof f=="string")&&l.delete(c),l.size===0&&this.e.delete(n)}}s(n,c){const l=[n];w(n)?(l.push(...e.$nw),l.push(...e.$pw)):g(n)&&l.push(...e.$pw);const t=l.map(f=>this.e.get(f));for(const f of t){const a=f?.get(c);if(a)return a}}canTunnel(n){return!!D(n)}u(n,c,l,t,f,a,m){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${l} on local port ${t}.`);const u=l;this.j.add(u);const C=t===void 0?l:t,b={elevationRequired:f?this.isPortPrivileged(C):!1},v={remoteAddress:{host:c,port:l},localAddressPort:t,privacy:a,public:a?a!==$.Private:void 0,protocol:m},d=n.forwardPort(v,b);return d?(this.q(c,l,d),d.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),d}};e.$tw=s,e.$tw=s=Je([We(0,A.$3j),We(1,R.$3i)],s)}),define(Pe[212],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,I.$wi)("IUriIdentityService")}),define(Pe[213],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uw=void 0,e.$uw=(0,I.$wi)("editSessionIdentityService");var O;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Pe[214],Ie([1,0,16]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=O,e.$IM=R,e.$JM=M,e.$KM=A,e.$LM=p;function O($){return $.scheme!==I.Schemas.file&&$.scheme!==I.Schemas.vscodeRemote}function R($){if($.folders.length)return $.folders.every(y=>O(y.uri))?$.folders[0].uri:void 0;if($.configuration&&O($.configuration))return $.configuration}function M($){return R($)?.scheme}function A($){return R($)?.authority}function p($){return R($)!==void 0}}),define(Pe[45],Ie([1,0,171,19,54,23,2,3,16]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=y,e.$Hi=T,e.$Ki=D,e.$Li=h,e.$Mi=w,e.$Ni=r,e.$Oi=o,e.$Ri=n,e.$Wi=c,e.$Xi=l,e.$Zi=t,e.$1i=f,e.$2i=a,e.$Fi=(0,p.$wi)("contextService");function y(m){const u=m;return typeof u?.id=="string"&&A.URI.isUri(u.uri)}function T(m){return typeof m?.id=="string"&&!y(m)&&!h(m)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function D(m,u){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,O.$nc)(m)}:u?e.$Ii:e.$Ji;const C=m;return C.configuration?{id:C.id,configPath:C.configuration}:C.folders.length===1?{id:C.id,uri:C.folders[0].uri}:{id:C.id}}function h(m){const u=m;return typeof u?.id=="string"&&A.URI.isUri(u.configPath)}function w(m){const u=m;if(u?.uri)return{id:u.id,uri:A.URI.revive(u.uri)};const C=m;if(C?.configPath)return{id:C.id,configPath:A.URI.revive(C.configPath)};if(m?.id)return{id:m.id}}var g;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function r(m){const u=m;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function o(m){const u=m;return!!(u&&typeof u=="object"&&A.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class s{constructor(u,C,b,v,d){this.h=u,this.j=b,this.k=v,this.l=d,this.c=R.$Ci.forUris(this.l,()=>!0),this.folders=C}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=R.$Ci.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=s;class i{constructor(u,C){this.raw=C,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,M.$0g)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=i;function n(m){return new i({uri:m,index:0,name:(0,M.$6g)(m)},{uri:m.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,I.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function c(m,u){return M.$1g.isEqualOrParent(m,u.untitledWorkspacesHome)}function l(m){let u;return A.URI.isUri(m)?u=m:u=m.configuration,u?.scheme===$.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(m){return m.id===e.$Yi}function f(m,u){return!c(m,u)&&!l(m)}function a(m){return(typeof m=="string"?(0,O.$oc)(m):(0,M.$8g)(m))===e.$Ti}}),define(Pe[215],Ie([1,0,73,5,6,23,2,170,99,38,3,12,45,28,212,11,34,13,15]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=c,e.$Dl=l,e.$El=t;var n;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function c(m){const u=m;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&A.URI.isUri(u.location)&&A.URI.isUri(u.globalStorageHome)&&A.URI.isUri(u.settingsResource)&&A.URI.isUri(u.keybindingsResource)&&A.URI.isUri(u.tasksResource)&&A.URI.isUri(u.snippetsHome)&&A.URI.isUri(u.extensionsResource))}e.$Cl=(0,T.$wi)("IUserDataProfilesService");function l(m,u){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:u}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:u}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:u}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:u}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:u}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:u}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:u}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:u}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function t(m,u,C,b,v,d){return{id:m,name:u,location:C,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:d&&v?.useDefaultFlags?.globalState?d.globalStorageHome:(0,M.$0g)(C,"globalStorage"),settingsResource:d&&v?.useDefaultFlags?.settings?d.settingsResource:(0,M.$0g)(C,"settings.json"),keybindingsResource:d&&v?.useDefaultFlags?.keybindings?d.keybindingsResource:(0,M.$0g)(C,"keybindings.json"),tasksResource:d&&v?.useDefaultFlags?.tasks?d.tasksResource:(0,M.$0g)(C,"tasks.json"),snippetsHome:d&&v?.useDefaultFlags?.snippets?d.snippetsHome:(0,M.$0g)(C,"snippets"),extensionsResource:d&&v?.useDefaultFlags?.extensions?d.extensionsResource:(0,M.$0g)(C,"extensions.json"),cacheHome:(0,M.$0g)(b,m),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let f=class extends R.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,C,b,v){super(),this.t=u,this.u=C,this.w=b,this.y=v,this.f=!0,this.h=this.B(new O.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),C=[u];if(this.f)try{for(const d of this.O()){if(!d.name||!(0,i.$9f)(d.name)||!d.location){this.y.warn("Skipping the invalid stored profile",d.location||d.name);continue}C.push(t((0,M.$7g)(d.location),d.name,d.location,this.g,{shortName:d.shortName,icon:d.icon,useDefaultFlags:d.useDefaultFlags},u))}}catch(d){this.y.error(d)}const b=new w.$Ac,v=new Map;if(C.length)try{const d=this.Q();if(d.workspaces)for(const[E,k]of Object.entries(d.workspaces)){const P=A.URI.parse(E),S=C.find(W=>W.id===k);S&&b.set(P,S)}if(d.emptyWindows)for(const[E,k]of Object.entries(d.emptyWindows)){const P=C.find(S=>S.id===k);P&&v.set(E,P)}}catch(d){this.y.error(d)}this.z={profiles:C,workspaces:b,emptyWindows:v}}return this.z}D(){const u=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const C="Temp",b=new RegExp(`${(0,s.$_e)(C)}\\s(\\d+)`);let v=0;for(const E of this.profiles){const k=b.exec(E.name),P=k?parseInt(k[1]):0;v=P>v?P:v}const d=`${C} ${v+1}`;return this.createProfile((0,I.$kj)((0,o.$Sg)()).toString(16),d,{transient:!0},u)}async createNamedProfile(u,C,b){return this.createProfile((0,I.$kj)((0,o.$Sg)()).toString(16),u,C,b)}async createProfile(u,C,b,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=await this.F(u,C,b);return v&&await this.setProfileForWorkspace(v,d),d}async F(u,C,b){if(!(0,i.$9f)(C)||!C)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(C);return v||(v=(async()=>{try{if(this.profiles.find(P=>P.name===C||P.id===u))throw new Error(`Profile with ${C} name already exists`);const E=t(u,C,(0,M.$0g)(this.profilesHome,u),this.g,b,this.defaultProfile);await this.u.createFolder(E.location);const k=[];return this.j.fire({profile:E,join(P){k.push(P)}}),await r.Promises.settled(k),this.I([E],[],[]),E}finally{this.r.delete(C)}})(),this.r.set(C,v)),v}async updateProfile(u,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(v=>v.id===u.id);if(!b)throw new Error(`Profile '${u.name}' does not exist`);return b=t(b.id,C.name??b.name,b.location,this.g,{shortName:C.shortName??b.shortName,icon:C.icon===null?void 0:C.icon??b.icon,transient:C.transient??b.isTransient,useDefaultFlags:C.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const C=this.profiles.find(v=>v.id===u.id);if(!C)throw new Error(`Profile '${u.name}' does not exist`);const b=[];this.m.fire({profile:C,join(v){b.push(v)}});try{await Promise.allSettled(b)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])C.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])C.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[C],[]);try{await this.u.del(C.cacheHome,{recursive:!0})}catch(v){(0,y.$hl)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(u,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(v=>v.id===C.id);if(!b)throw new Error(`Profile '${C.name}' does not exist`);this.L(u,b)}unsetWorkspace(u,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,C)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(C=>C.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,C.resource))).map(C=>this.u.del(C.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(C=>!this.H(C));await Promise.allSettled(u.map(C=>this.removeProfile(C)))}getProfileForWorkspace(u){const C=this.G(u);return A.URI.isUri(C)?this.s.workspaces.get(C)??this.C.workspaces.get(C):this.s.emptyWindows.get(C)??this.C.emptyWindows.get(C)}G(u){return(0,h.$Gi)(u)?u.uri:(0,h.$Li)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(C=>this.w.extUri.isEqual(C.location,u.location))||[...this.s.workspaces.values()].some(C=>this.w.extUri.isEqual(C.location,u.location))||[...this.C.emptyWindows.values()].some(C=>this.w.extUri.isEqual(C.location,u.location))||[...this.C.workspaces.values()].some(C=>this.w.extUri.isEqual(C.location,u.location)))}I(u,C,b){const v=[...this.profiles,...u],d=[];this.s.profiles=[];for(let E of v)E.isDefault||C.some(k=>E.id===k.id)||(E=b.find(k=>E.id===k.id)??E,E.isTransient?this.s.profiles.push(E):d.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(d),this.z=void 0,this.J(u,C,b)}J(u,C,b){this.h.fire({added:u,removed:C,updated:b,all:this.profiles})}L(u,C,b){b=C?.isTransient?!0:b,b||this.L(u,void 0,!0);const v=this.G(u),d=b?this.s:this.C;A.URI.isUri(v)?(d.workspaces.delete(v),C&&d.workspaces.set(v,C)):(d.emptyWindows.delete(v),C&&d.emptyWindows.set(v,C)),b||this.M()}M(){const u={};for(const[b,v]of this.C.workspaces.entries())u[b.toString()]=v.id;const C={};for(const[b,v]of this.C.emptyWindows.entries())C[b.toString()]=v.id;this.R({workspaces:u,emptyWindows:C}),this.z=void 0}N(u){const C={},b=this.D();if(u.workspaces)for(const[d,E]of Object.entries(u.workspaces)){const k=A.URI.parse(E);C[d]=this.w.extUri.isEqual(k,b.location)?b.id:this.w.extUri.basename(k)}const v={};if(u.emptyWindows)for(const[d,E]of Object.entries(u.emptyWindows)){const k=A.URI.parse(E);v[d]=this.w.extUri.isEqual(k,b.location)?b.id:this.w.extUri.basename(k)}return{workspaces:C,emptyWindows:v}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Fl=f,e.$Fl=f=Je([We(0,$.$Di),We(1,y.$3k),We(2,g.$Al),We(3,D.$3j)],f);class a extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Gl=a}),define(Pe[216],Ie([1,0,11,5,6,60,15,151,3,215]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=w,e.$4p=r,e.$6p=s,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,$.$wi)("storageService");var T;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var D;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var h;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function w(i){const n=i.get(e.$Zp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class g extends R.$Uc{static{this.a=60*1e3}constructor(n={flushInterval:g.a}){super(),this.m=n,this.b=this.B(new O.$ge),this.c=this.B(new O.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$de),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,c,l){return O.Event.filter(this.b.event,t=>t.scope===n&&(c===void 0||t.key===c),l)}n(){this.j.value=(0,I.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,c){const{key:l,external:t}=c;if(l===e.$Zp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:l,target:this.J(n)[l],external:t})}w(n){this.f.fire({reason:n})}get(n,c,l){return this.P(c)?.get(n,l)}getBoolean(n,c,l){return this.P(c)?.getBoolean(n,l)}getNumber(n,c,l){return this.P(c)?.getNumber(n,l)}getObject(n,c,l){return this.P(c)?.getObject(n,l)}storeAll(n,c){this.y(()=>{for(const l of n)this.store(l.key,l.value,l.scope,l.target,c)})}store(n,c,l,t,f=!1){if((0,A.$fg)(c)){this.remove(n,l,f);return}this.y(()=>{this.z(n,l,t),this.P(l)?.set(n,c,f)})}remove(n,c,l=!1){this.y(()=>{this.z(n,c,void 0),this.P(c)?.delete(n,l)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,c){const l=[],t=this.J(n);for(const f of Object.keys(t))t[f]===c&&l.push(f);return l}z(n,c,l,t=!1){const f=this.J(c);typeof l=="number"?f[n]!==l&&(f[n]=l,this.P(c)?.set(e.$Zp,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(c)?.set(e.$Zp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const c=this.P(n);return c?w(c):Object.create(null)}isNew(n){return this.getBoolean(e.$Yp,n)===!0}async flush(n=T.NONE){this.f.fire({reason:n});const c=this.P(-1),l=this.P(0),t=this.P(1);switch(n){case T.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return s(n,c,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,c){return this.w(T.NONE),(0,y.$Bl)(n)?this.R(n,c):this.S(n,c)}M(n,c){return!(n.id===c.id||r(c)&&r(n))}N(n,c,l){this.y(()=>{const t=new Set;for(const[f,a]of n)t.add(f),c.get(f)!==a&&this.u(l,{key:f,external:!0});for(const[f]of c.items)t.has(f)||this.u(l,{key:f,external:!0})})}}e.$3p=g;function r(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class o extends g{constructor(){super(),this.U=this.B(new p.$Wp(new p.$Xp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Wp(new p.$Xp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Wp(new p.$Xp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$5p=o;async function s(i,n,c,l,t,f){const a=P=>{try{return JSON.parse(P)}catch{return P}},m=new Map,u=new Map;i.forEach((P,S)=>{m.set(S,P),u.set(S,a(P))});const C=new Map,b=new Map;n.forEach((P,S)=>{C.set(S,P),b.set(S,a(P))});const v=new Map,d=new Map;c.forEach((P,S)=>{v.set(S,P),d.set(S,a(P))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const E=[];if(m.forEach((P,S)=>{E.push({key:S,value:P})}),console.table(E),console.groupEnd(),console.log(u),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];C.forEach((S,W)=>{P.push({key:W,value:S})}),console.table(P),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${f})`);const k=[];v.forEach((P,S)=>{k.push({key:S,value:P})}),console.table(k),console.groupEnd(),console.log(d)}}),define(Pe[76],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const M=this.c++;return this.b.set(M,R),this.e(),M}get(R,M){return this.b.has(R)?this.b.get(R)[M]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$hlc=I}),define(Pe[46],Ie([1,0,16,23,3]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$mlc=void 0;class M{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new O.$Yg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$mlc=M,e.$nlc=(0,R.$wi)("IExtHostFileSystemInfo")}),define(Pe[27],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0,e.$PP=(0,I.$wi)("IExtHostInitDataService")}),define(Pe[217],Ie([1,0,176,12,201,27]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;let A=class extends R.$ZQ{constructor($,y,T){const D=T.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",h=T.remote.isRemote?(0,I.localize)(0,null):$?(0,I.localize)(1,null):(0,I.localize)(2,null);super(y.createLogger(D,{name:h}))}};e.$tnc=A,e.$tnc=A=Je([We(1,O.$4j),We(2,M.$PP)],A)}),define(Pe[218],Ie([1,0,11]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=e.$5lc=void 0;class O{constructor(A,p,$){this.h=new Map,this.a=A,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new I.$Ih(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of y.values())T.complete()}catch(T){for(const D of y.values())D.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,p){let $=this.f[A];return typeof $>"u"&&($=p),$}update(A,p){this.f[A]=p;const $=this.h.get(A);if($!==void 0)return $.p;const y=new I.$Th;return this.h.set(A,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$5lc=O;class R extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,p){super(A.identifier.value,!0,p),this.j=A}}e.$6lc=R}),define(Pe[219],Ie([1,0,5,2]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;class R{constructor(A){this.c=A,this.a=new I.$de,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$de,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,p,$,y){const D=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged(p.value,$,y);this.b.fire(D)}$acceptDirtyStateChanged(A,p){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty(p)}$acceptModelSaved(A){const p=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire(p.apiNotebook)}}e.$Tmc=R}),define(Pe[17],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0,e.$zP=(0,I.$wi)("IExtHostRpcService");class O{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$AP=O}),define(Pe[220],Ie([1,0,20,5]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class R{#e;constructor(A,p){this.b=new O.$de,this.onDidChange=this.b.event,this.a=I.$Rm.toKey(A.identifier),this.#e=p,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,p){return this.#e.store(this.a,A,p)}delete(A){return this.#e.delete(this.a,A)}}e.$cmc=R}),define(Pe[61],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0,e.$Clc=(0,I.$wi)("IURITransformerService");class O{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Dlc=O}),define(Pe[221],Ie([1,0,21]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erb=R,e.$Frb=A;class O{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function R(p,$){if($.serializeBuffersForPostMessage){const y=new O,D=JSON.stringify(p,(w,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(g)};if(ArrayBuffer.isView(g)){const r=M(g);if(r)return{$$vscode_array_buffer_reference$$:!0,index:y.add(g.buffer),view:{type:r,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),h=y.buffers.map(w=>{const g=new Uint8Array(w);return I.$Fe.wrap(g)});return{message:D,buffers:h}}else return{message:JSON.stringify(p),buffers:[]}}function M(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(p,$){const y=$.map(h=>{const w=new ArrayBuffer(h.byteLength);return new Uint8Array(w).set(h.buffer),w}),T=$.length?(h,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const g=w,{index:r}=g,o=y[r];if(g.view)switch(g.view.type){case 1:return new Int8Array(o,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(p,T),arrayBuffers:y}}}),define(Pe[106],Ie([1,0,185,15,2,6,3,29,38,16,44,145,33]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=r,e.$zF=o,e.$AF=s,e.$BF=i,e.$CF=n,e.$DF=c,e.$EF=l,e.$FF=t,e.$GF=f,e.$JF=v,e.$KF=E,e.$LF=k,e.$MF=P,e.$NF=S,e.$OF=W,e.$PF=V,e.$QF=ce,e.$SF=fe,e.$TF=Te,e.$UF=ae,e.$VF=Ne,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var w;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var g;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function r(ne){const z=ne;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function o(ne){const z=ne;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function s(ne,z,x){for(const be of x.visibleEditorPanes)if(be.group.id===z&&ne.matches(be.input))return be.getViewState()}function i(ne){if(v(ne))return!1;const z=ne;return R.URI.isUri(z?.resource)}function n(ne){if(v(ne))return!1;const z=ne;return z?.original!==void 0&&z.modified!==void 0}function c(ne){if(v(ne))return!1;const z=ne;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function l(ne){if(v(ne)||n(ne))return!1;const z=ne;return z?.primary!==void 0&&z.secondary!==void 0}function t(ne){if(v(ne))return!1;const z=ne;return z?z.resource===void 0||z.resource.scheme===y.Schemas.untitled||z.forceUntitled===!0:!1}function f(ne){if(v(ne))return!1;const z=ne;return R.URI.isUri(z?.base?.resource)&&R.URI.isUri(z?.input1?.resource)&&R.URI.isUri(z?.input2?.resource)&&R.URI.isUri(z?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var m;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class u{constructor(){this.a=new Map}registerSource(z,x){let be=this.a.get(z);return be||(be={source:z,label:x},this.a.set(z,be)),be.source}getSourceLabel(z){return this.a.get(z)?.label??z}}e.$HF=new u;var C;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(C||(e.EditorInputCapabilities=C={}));class b extends M.$Uc{}e.$IF=b;function v(ne){return ne instanceof b}function d(ne){const z=ne;return R.URI.isUri(z?.preferredResource)}function E(ne){const z=ne;return v(z?.primary)&&v(z?.secondary)}function k(ne){const z=ne;return v(z?.modified)&&v(z?.original)}function P(ne,z,x,be,Fe){return Ne(be,[(0,D.$gj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const De={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(z,De)}}),(0,D.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}function S(ne){return v(ne?.editor)}function W(ne){const z=ne;return S(ne)&&z?.group!==void 0}function V(ne){const z=ne;return typeof z?.groupId=="number"&&v(z.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var N;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var B;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class K{getOriginalUri(z,x){if(!z)return;if(f(z))return e.$RF.getOriginalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Fe:De}}if(n(z)||c(z)||l(z)||f(z))return;const be=d(z)?z.preferredResource:z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}a(z){return E(z)||l(z)?{primary:z.primary,secondary:z.secondary}:k(z)||n(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,x){if(!z)return;if(f(z))return e.$RF.getCanonicalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Fe:De}}if(n(z)||c(z)||l(z)||f(z))return;const be=z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}b(z,x){if(Array.isArray(x)){if(x.some(be=>z.scheme===be))return z}else if(x===z.scheme)return z}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,z,x,be){if(!ne.isSticky(z))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$RF=new K;var ye;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class Se{constructor(){this.c=new Map,this.d=new Map}start(z){const x=this.a=z.get(A.$vi);for(const[be,Fe]of this.c)this.e(be,Fe,x);this.c.clear()}e(z,x,be){const Fe=be.createInstance(x);this.d.set(z,Fe)}registerFileEditorFactory(z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=z}getFileEditorFactory(){return(0,O.$hg)(this.b)}registerEditorSerializer(z,x){if(this.c.has(z)||this.d.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.a?this.e(z,x,this.a):this.c.set(z,x),(0,M.$Sc)(()=>{this.c.delete(z),this.d.delete(z)})}getEditorSerializer(z){return this.d.get(typeof z=="string"?z:z.typeId)}}p.$co.add(e.$tF.EditorFactory,new Se);async function fe(ne,z,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async be=>{const Fe=R.URI.revive(be.fileUri);if(!Fe){x.info("Cannot resolve the path because it is not valid.",be);return}if(!await z.canHandleResource(Fe)){x.info("Cannot resolve the path because it cannot be handled",be);return}let pe=be.exists,ge=be.type;if(typeof pe!="boolean"||typeof ge!="number")try{ge=(await z.stat(Fe)).isDirectory?$.FileType.Directory:$.FileType.Unknown,pe=!0}catch(Y){x.error(Y),pe=!1}if(!pe&&be.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",be);return}if(ge===$.FileType.Directory){x.info("Cannot resolve the path because it is a directory",be);return}const Q={...be.options,pinned:!0};return pe?{resource:Fe,options:Q}:{resource:Fe,options:Q,forceUntitled:!0}}))}var $e;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function Te(ne){const z=ne;if(!z)return!1;const x=z;if(x.modified)return Te(x.modified);const be=z;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ae(ne){return(0,T.$ij)(ne)}function Ne(ne,z,x){const be=(0,T.$jj)(ne,z);return be.forceMessage=x?.forceMessage,be.forceSeverity=x?.forceSeverity,be.allowDialog=x?.allowDialog,be}}),define(Pe[222],Ie([1,0,5,186,3,6,28,29,25,92,210]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=w,e.$WF="views",e.$XF=(0,O.localize)(0,null),e.$YF=(0,T.$fx)("default-view-icon",y.$Vj.window,(0,O.localize)(1,null));var D;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var h;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(h||(e.ViewContainerLocation=h={})),e.$ZF=[0,1,2];function w(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class g extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$de),this.onDidRegister=this.c.event,this.f=this.B(new I.$de),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(f,a,m){const u=this.get(f.id);if(u)return u;const C=f;return C.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,A.$xc)(this.g,a,[]).push(C),m?.isDefault&&this.h.push(C),this.c.fire({viewContainer:C,viewContainerLocation:a}),C}deregisterViewContainer(f){for(const a of this.g.keys()){const m=this.g.get(a),u=m?.indexOf(f);if(u!==-1){m?.splice(u,1),m.length===0&&this.g.delete(a),this.f.fire({viewContainer:f,viewContainerLocation:a});return}}}get(f){return this.all.filter(a=>a.id===f)[0]}getViewContainers(f){return[...this.g.get(f)||[]]}getViewContainerLocation(f){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(m=>m?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.h.find(a=>this.getViewContainerLocation(a)===f)}}p.$co.add(D.ViewContainersRegistry,new g);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(t,f){const a=t.group??r.More,m=f.group??r.More;return a!==m?a.localeCompare(m):(t.order??5)-(f.order??5)}class s extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$de),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$de),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$de),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$de),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(f,a){this.registerViews2([{views:f,viewContainer:a}])}registerViews2(f){f.forEach(({views:a,viewContainer:m})=>this.r(a,m)),this.c.fire(f)}deregisterViews(f,a){const m=this.s(f,a);m.length&&this.f.fire({views:m,viewContainer:a})}moveViews(f,a){for(const m of this.m.keys())if(m!==a){const u=this.s(f,m);u.length&&(this.r(u,a),this.g.fire({views:u,from:m,to:a}))}}getViews(f){return this.m.get(f)||[]}getView(f){for(const a of this.j){const m=(this.m.get(a)||[]).filter(u=>u.id===f)[0];if(m)return m}return null}getViewContainer(f){for(const a of this.j)if((this.m.get(a)||[]).filter(u=>u.id===f)[0])return a;return null}registerViewWelcomeContent(f,a){return this.n.add(f,a),this.h.fire(f),(0,M.$Sc)(()=>{this.n.delete(f,a),this.h.fire(f)})}registerViewWelcomeContent2(f,a){const m=new Map;for(const[u,C]of a)this.n.add(f,C),m.set(u,(0,M.$Sc)(()=>{this.n.delete(f,C),this.h.fire(f)}));return this.h.fire(f),m}getViewWelcomeContent(f){const a=[];return this.n.forEach(f,m=>a.push(m)),a.sort(o)}r(f,a){let m=this.m.get(a);m||(m=[],this.m.set(a,m),this.j.push(a));for(const u of f){if(this.getView(u.id)!==null)throw new Error((0,O.localize)(2,null,u.id));m.push(u)}}s(f,a){const m=this.m.get(a);if(!m)return[];const u=[],C=[];for(const b of m)f.includes(b)?u.push(b):C.push(b);return u.length&&(C.length?this.m.set(a,C):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),u}}p.$co.add(D.ViewsRegistry,new s),e.$2F=(0,R.$wi)("viewDescriptorService");var i;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(f,a){this.c=!1,this.d=!1,(0,$.$6n)(this,f),this.d=!!a,this.resolve=async m=>{if(a&&!this.c){const u=await a(m);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=c;class l extends Error{constructor(f){super((0,O.localize)(3,null,f)),this.name="NoTreeViewError"}static is(f){return f.name==="NoTreeViewError"}}e.$4F=l}),define(Pe[223],Ie([1,0,187,31]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new O.$Nj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$9F=new O.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$0F=new O.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$$F=new O.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$_F=new O.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$aG=new O.$Nj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$bG=new O.$Nj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$cG=new O.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$dG=new O.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$eG=new O.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$fG=new O.$Nj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$gG=new O.$Nj("inChat",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$hG=new O.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(12,null)}),e.$iG=new O.$Nj("chatCursorAtTop",!1),e.$jG=new O.$Nj("chatInputHasAgent",!1),e.$kG=new O.$Nj("chatLocation",void 0)}),define(Pe[224],Ie([1,0,11,24,5,42,6,132,13,31,3,12,102,204,216,223]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var s;(function(l){l.Panel="panel",l.Terminal="terminal",l.Notebook="notebook",l.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(l){function t(f){switch(f){case"panel":return l.Panel;case"terminal":return l.Terminal;case"notebook":return l.Notebook;case"editor":return l.Editor}return l.Panel}l.fromRaw=t}(s||(e.ChatAgentLocation=s={})),e.$iH=(0,T.$wi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new R.$de,this.onDidChangeAgents=this.d.event,this.e=r.$hG.bindTo(this.f)}registerAgent(t,f){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const m=this,u=f.slashCommands;f={...f,get slashCommands(){return u.filter(b=>!b.when||m.f.contextMatchesRules(y.$uj.deserialize(b.when)))}};const C={data:f};return this.b.push(C),(0,A.$Sc)(()=>{this.b=this.b.filter(b=>b!==C),this.d.fire(void 0)})}registerAgentImplementation(t,f){const a=this.g(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this.e.set(!0),a.impl=f,this.d.fire(new n(a.data,f)),(0,A.$Sc)(()=>{a.impl=void 0,this.d.fire(void 0),a.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,f){const a={data:t,impl:f};return this.b.push(a),this.d.fire(new n(t,f)),(0,A.$Sc)(()=>{this.b=this.b.filter(m=>m!==a),this.d.fire(void 0)})}updateAgent(t,f){const a=this.g(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...f},this.d.fire(new n(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getSecondaryAgent(){return M.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(f=>f.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new n(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(f=>f.name===t)}async invokeAgent(t,f,a,m,u){const C=this.g(t);if(!C?.impl)throw new Error(`No activated agent with id ${t}`);return await C.impl.invoke(f,a,m,u)}async getFollowups(t,f,a,m,u){const C=this.g(t);if(!C?.impl)throw new Error(`No activated agent with id ${t}`);return C.impl?.provideFollowups?C.impl.provideFollowups(f,a,m,u):[]}};e.$jH=i,e.$jH=i=Je([We(0,y.$Oj)],i);class n{constructor(t,f){this.b=t,this.d=f}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,f,a,m){return this.d.invoke(t,f,a,m)}async provideFollowups(t,f,a,m){return this.d.provideFollowups?this.d.provideFollowups(t,f,a,m):[]}provideWelcomeMessage(t,f){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,f)}provideSampleQuestions(t,f){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,f)}}e.$kH=n,e.$lH=(0,T.$wi)("chatAgentNameService");let c=class{static{o=this}static{this.b="chat.participantNameRegistry"}constructor(t,f,a,m){if(this.g=f,this.h=a,this.i=m,this.e=(0,p.$1d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const u=m.get(o.b,-1);try{this.e.set(JSON.parse(u??"{}"),void 0)}catch{m.remove(o.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,I.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const f=await(0,w.$Tp)(t);if(!f||f.version!==1)throw new Error("Unexpected chat participant registry response.");const a=f.restrictedChatParticipants;this.e.set(a,void 0),this.i.store(o.b,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.e.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some(m=>(0,$.$xf)(m,m.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=c,e.$mH=c=o=Je([We(0,h.$jk),We(1,w.$Np),We(2,D.$3j),We(3,g.$1p)],c)}),define(Pe[225],Ie([1,0,2,30,3]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=M,e.$qG=A;function M(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof I.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(O.$ut.isIRange)}function A(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(M)}var p;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$rG=(0,R.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(Pe[226],Ie([1,0,5,11,188]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrb=void 0;class M{constructor(){this.f=new Map,this.m=[],this.n=new I.$de,this.o=new I.$de,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,$,y,T){const D={command:p};if($&&Object.keys($).length>0&&(D.arguments=$),this.u("request",D),typeof T=="number"){const h=setTimeout(()=>{clearTimeout(h);const w=this.f.get(D.seq);if(w){this.f.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:p,message:(0,R.localize)(0,null,T,p)};w(g)}},T)}return y&&this.f.set(D.seq,y),D.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,$){return p.type!=="event"||$.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,O.$xh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}u(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,y)=>p.set(y,$)),await(0,O.$xh)(500),p.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Rrb=M}),define(Pe[227],Ie([1,0,2,189,31,3]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=$,e.$BJ=T,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new R.$Nj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$xI=new R.$Nj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$yI=new R.$Nj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$zI="debugUx",e.$AI=new R.$Nj(e.$zI,"default",{type:"string",description:O.localize(3,null)}),e.$BI=new R.$Nj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$CI=new R.$Nj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$DI=new R.$Nj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$EI=new R.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$FI=new R.$Nj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$GI=new R.$Nj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$HI=new R.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$II=new R.$Nj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$JI=new R.$Nj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$KI=new R.$Nj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$LI=new R.$Nj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$MI=new R.$Nj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$NI=new R.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$OI=new R.$Nj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$PI=new R.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$QI=new R.$Nj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$RI=new R.$Nj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$SI=new R.$Nj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$TI=new R.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$UI=new R.$Nj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$VI=new R.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$WI=new R.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$XI=new R.$Nj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$YI=new R.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$ZI=new R.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$1I=new R.$Nj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$2I=new R.$Nj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$3I=new R.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$4I=new R.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$5I=new R.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$6I=new R.$Nj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$7I=new R.$Nj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$8I=new R.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$9I=new R.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$0I=new R.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$$I=new R.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$_I=new R.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$aJ=new R.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$bJ=new R.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$cJ=new R.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$dJ=new R.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$eJ=new R.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$fJ=new R.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$gJ=new R.$Nj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$hJ=new R.$Nj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$iJ=new R.$Nj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$jJ=new R.$Nj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$kJ=new R.$Nj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$lJ=new R.$Nj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$mJ=new R.$Nj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$nJ=new R.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$oJ=new R.$Nj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$pJ=new R.$Nj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$qJ=new R.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$rJ=new R.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$sJ=new R.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$tJ=new R.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const A=n=>O.localize(61,null,n);e.$uJ=A,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var p;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(p||(e.State=p={}));function $(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var y;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$AJ="vscode-debug-memory";function T(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var D;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(D||(e.DataBreakpointSetType=D={}));var h;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var w;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$CJ=(0,M.$wi)("debugService");var g;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(g||(e.BreakpointWidgetContext=g={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(s||(e.IDebugVisualizationTreeItem=s={}));var i;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:I.URI.revive(c.iconPath.light),dark:I.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(i||(e.IDebugVisualization=i={}))}),define(Pe[228],Ie([1,0,13,2,19,25,16,30,24,18]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=D,e.$qH=h,e.$rH=w,e.$sH=g,e.$tH=r,e.$uH=o,e.$vH=s,e.$wH=n,e.$xH=t,e.$yH=f,e.$zH=m,e.$AH=C;const T=/{([^}]+)}/g;function D(v,d,E){return v.replace(T,function(k,P){return d&&P.length>0&&P[0]!=="_"?k:E&&E.hasOwnProperty(P)?E[P]:k})}function h(v){const d={};for(const E of Object.keys(v))E.startsWith("!")||(d[E]=v[E]);return d}function w(v){return v.configuration.request==="attach"&&!g(v)&&(!v.parentSession||w(v.parentSession))}function g(v){let d=v.configuration.type;if(d)return d==="vslsShare"&&(d=v.configuration.adapterProxy.configuration.type),(0,I.$xf)(d,"extensionhost")||(0,I.$xf)(d,"pwa-extensionhost")?v:v.parentSession?g(v.parentSession):void 0}function r(v){return v.type&&(v.label||v.program||v.runtime)}function o(v,d,E){let k,P=0;const S=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=S.exec(v);){const V=W.index+1,q=V+W[0].length;if(V<=d&&q>=E){k=W[0],P=V;break}}if(k){const V=/\w+/g;let q=null;for(;(q=V.exec(k))&&!(q.index+1+P+q[0].length>=E););q&&(k=k.substring(0,V.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}async function s(v,d,E,k){if(v.evaluatableExpressionProvider.has(d)){const P=v.evaluatableExpressionProvider.ordered(d),S=(0,y.$Hb)(await Promise.all(P.map(async W=>{try{return await W.provideEvaluatableExpression(d,E,k??$.CancellationToken.None)}catch{return}})));if(S.length>0){let W=S[0].expression;const V=S[0].range;return W||(W=d.getLineContent(E.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const P=d.getLineContent(E.lineNumber),{start:S,end:W}=o(P,E.column,E.column),V=P.substring(S-1,W);return{matchingExpression:V,range:new p.$ut(E.lineNumber,S,E.lineNumber,S+V.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(v){return!!(v&&v.match(i))}function c(v){if(typeof v.path=="string"&&!(typeof v.sourceReference=="number"&&v.sourceReference>0)){if(n(v.path))return O.URI.parse(v.path);if((0,R.$ic)(v.path))return O.URI.file(v.path)}return v.path}function l(v){if(typeof v.path=="object"){const d=O.URI.revive(v.path);if(d)return d.scheme===A.Schemas.file?d.fsPath:d.toString()}return v.path}function t(v,d){const E=d?c:l,k=(0,M.$3n)(v);return a(k,(P,S)=>{P&&S&&(S.path=E(S))}),k}function f(v,d){const E=d?c:l,k=(0,M.$3n)(v);return a(k,(P,S)=>{!P&&S&&(S.path=E(S))}),k}function a(v,d){switch(v.type){case"event":{const E=v;switch(E.event){case"output":d(!1,E.body.source);break;case"loadedSource":d(!1,E.body.source);break;case"breakpoint":d(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=v;switch(E.command){case"setBreakpoints":d(!0,E.arguments.source);break;case"breakpointLocations":d(!0,E.arguments.source);break;case"source":d(!0,E.arguments.source);break;case"gotoTargets":d(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(k=>d(!1,k));break;default:break}break}case"response":{const E=v;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(k=>d(!1,k.source));break;case"loadedSources":E.body.sources.forEach(k=>d(!1,k));break;case"scopes":E.body.scopes.forEach(k=>d(!1,k.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(k=>d(!1,k.source));break;case"setBreakpoints":E.body.breakpoints.forEach(k=>d(!1,k.source));break;case"disassemble":E.body?.instructions.forEach(P=>d(!1,P.location));break;default:break}break}}}function m(v){return v.filter(d=>!d.presentation?.hidden).sort((d,E)=>d.presentation?E.presentation?d.presentation.group?E.presentation.group?d.presentation.group!==E.presentation.group?d.presentation.group.localeCompare(E.presentation.group):u(d.presentation.order,E.presentation.order):-1:E.presentation.group?1:u(d.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function u(v,d){return typeof v!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:v-d}async function C(v,d){const E=v.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(E!=="none"&&(await d.saveAll(),E==="allEditorsInActiveGroup")){const k=d.activeEditorPane;k&&k.input.resource?.scheme===A.Schemas.untitled&&await d.save({editor:k.input,groupId:k.group.id})}await v.reloadConfiguration()}const b=(v,d)=>!v||!d?v===d:v.name===d.name&&v.path===d.path&&v.sourceReference===d.sourceReference;e.$BH=b}),define(Pe[229],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.CellExecutionUpdateType=void 0;var O;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$PK=(0,I.$wi)("INotebookExecutionService")}),define(Pe[230],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjb=e.$ijb=e.ProxyKernelState=e.$hjb=void 0,e.$hjb=100;var O;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$ijb=(0,I.$wi)("INotebookKernelService"),e.$jjb=(0,I.$wi)("INotebookKernelHistoryService")}),define(Pe[231],Ie([1,0,6,30,156,96]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fXb=void 0;class A extends I.$Uc{constructor($,y,T){super(),this._source=$,this.b=y,this.c=T,this.a=void 0}f($){const y=$.getLineCount();return new O.$ut(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new R.$2C;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:T,disposable:D}=y.create(1);this.b=T,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new R.$2C;y.acceptChunk($);const T=y.finish(!0),{textBuffer:D,disposable:h}=T.create(1);return this.B(h),D})),this.a}findInInputs($){const T=new M.$PC($,!1,!1,null).parseSearchRequest();if(!T)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,T,!0,5e3)}findInOutputs($){const T=new M.$PC($,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(D=>{const h=D.findMatchesLineByLine(this.f(D),T,!0,5e3);if(h.length!==0)return{textBuffer:D,matches:h}}).filter(D=>!!D):[]}}e.$fXb=A}),define(Pe[52],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(M){M.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var O;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class R{static fromExtHostTestItem(A,p,$=A.parent){if(A._isRoot)return new R([p]);const y=[A.id];for(let T=$;T&&T.id!==p;T=T.parent)y.push(T.id);return y.push(p),new R(y.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const p=A.indexOf("\0");return p===-1?A:A.slice(0,p)}static fromString(A){return new R(A.split("\0"))}static join(A,p){return new R([...A.path,p])}static joinToString(A,p){return A.toString()+"\0"+p}static parentId(A){const p=A.lastIndexOf("\0");return p===-1?void 0:A.slice(0,p)}static localId(A){const p=A.lastIndexOf("\0");return p===-1?A:A.slice(p+1)}static isChild(A,p){return p.startsWith(A)&&p[A.length]==="\0"}static compare(A,p){return A===p?0:R.isChild(A,p)?2:R.isChild(p,A)?3:1}constructor(A,p=A.length){if(this.path=A,this.d=p,A.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new R(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new R(this.path,A)}compare(A){if(typeof A=="string")return R.compare(this.toString(),A);for(let p=0;p<A.d&&p<this.d;p++)if(A.path[p]!==this.path[p])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$WL=R}),define(Pe[62],Ie([1,0,2,94,30,52]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$5L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$4L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3L=e.$2L=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1L=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZL=e.$YL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$XL=e.TestResultState=void 0;var A;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$XL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$YL=[2,4,8,16,32,64];const y=N=>"runId"in N;e.$ZL=y;var T;(function(N){N.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),N.deserialize=(B,K)=>({range:R.$ut.lift(K.range),uri:B.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var D;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(D||(e.TestMessageType=D={}));var h;(function(N){N.serialize=B=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&T.serialize(B.location)}),N.deserialize=(B,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(B,K.location)})})(h||(e.ITestErrorMessage=h={}));const w=(N,B)=>`${B?"s":"e"}${N}`;e.$1L=w;var g;(function(N){N.serialize=B=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&T.serialize(B.location)}),N.deserialize=(B,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(B,K.location)})})(g||(e.ITestOutputMessage=g={}));var r;(function(N){N.serialize=B=>B.type===0?h.serialize(B):g.serialize(B),N.deserialize=(B,K)=>K.type===0?h.deserialize(B,K):g.deserialize(B,K)})(r||(e.ITestMessage=r={}));var o;(function(N){N.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),N.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map(r.serialize)}),N.deserialize=(B,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>r.deserialize(B,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",i=(N,B)=>N+s+B;e.$2L=i;const n=N=>{const B=N.indexOf(s);return{ctrlId:N.slice(0,B),tagId:N.slice(B+1)}};e.$3L=n;var c;(function(N){N.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),N.deserialize=(B,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?B.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$ut.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var l;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(N){N.serialize=B=>({expand:B.expand,item:c.serialize(B.item)}),N.deserialize=(B,K)=>({controllerId:M.$WL.root(K.item.extId),expand:K.expand,item:c.deserialize(B,K.item)})})(t||(e.InternalTestItem=t={}));var f;(function(N){N.serialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.uri!==void 0&&(K.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(K.range=B.item.range?.toJSON()),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}},N.deserialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.range!==void 0&&(K.range=B.item.range?R.$ut.lift(B.item.range):null),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}}})(f||(e.ITestItemUpdate=f={}));const a=(N,B)=>{B.expand!==void 0&&(N.expand=B.expand),B.item!==void 0&&(N.item=N.item?Object.assign(N.item,B.item):B.item)};e.$4L=a;var m;(function(N){N.serializeWithoutMessages=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(o.serializeWithoutMessages)}),N.serialize=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(o.serialize)}),N.deserialize=(B,K)=>({...t.deserialize(B,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>o.deserialize(B,ie)),retired:!0})})(m||(e.TestResultItem=m={}));var u;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(B,K)=>{B.covered+=K.covered,B.total+=K.total}})(u||(e.ICoverageCount=u={}));var C;(function(N){N.serialize=B=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:B.uri.toJSON()}),N.deserialize=(B,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:B.asCanonicalUri(I.URI.revive(K.uri))})})(C||(e.IFileCoverage=C={}));function b(N){return{...N,location:N.location?.toJSON()}}function v(N){return N.location=N.location?O.$tt.isIPosition(N.location)?O.$tt.lift(N.location):R.$ut.lift(N.location):void 0,N}e.$5L=3;var d;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(d||(e.DetailType=d={}));var E;(function(N){N.serialize=B=>B.type===0?P.serialize(B):S.serialize(B),N.deserialize=B=>B.type===0?P.deserialize(B):S.deserialize(B)})(E||(e.CoverageDetails=E={}));var k;(function(N){N.serialize=b,N.deserialize=v})(k||(e.IBranchCoverage=k={}));var P;(function(N){N.serialize=b,N.deserialize=v})(P||(e.IDeclarationCoverage=P={}));var S;(function(N){N.serialize=B=>({...b(B),branches:B.branches?.map(k.serialize)}),N.deserialize=B=>({...v(B),branches:B.branches?.map(k.deserialize)})})(S||(e.IStatementCoverage=S={}));var W;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(N){N.deserialize=(B,K)=>K.op===0?{op:K.op,item:t.deserialize(B,K.item)}:K.op===1?{op:K.op,item:f.deserialize(K.item)}:K.op===2?{op:K.op,uri:B.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,N.serialize=B=>B.op===0?{op:B.op,item:t.serialize(B.item)}:B.op===1?{op:B.op,item:f.serialize(B.item)}:B})(V||(e.TestsDiffOp=V={}));class q{constructor(B){this.k=B,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(B){const K=this.v();for(const ie of B)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(f.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(B,K){const ie=M.$WL.parentId(B.item.extId)?.toString();let ce;if(!ie)ce=this.w(B),this.g.add(ce),this.f.set(B.item.extId,ce);else if(this.f.has(ie)){const ye=this.f.get(ie);ye.children.add(B.item.extId),ce=this.w(B,ye),this.f.set(B.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return K.add?.(ce),B.expand===2&&this.h++,ce}o(B,K){const ie=this.f.get(B.extId);if(ie)return B.expand!==void 0&&(ie.expand===2&&this.h--,B.expand===2&&this.h++),(0,e.$4L)(ie,B),K.update?.(ie),ie}p(B,K){const ie=this.f.get(B);if(!ie)return;const ce=M.$WL.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ye=[[B]];for(;ye.length;)for(const Se of ye.pop()){const fe=this.f.get(Se);fe&&(ye.push(fe.children),this.f.delete(Se),K.remove?.(fe,fe!==ie),fe.expand===2&&this.h--)}}q(B){}updatePendingRoots(B){this.j+=B}v(){return{}}}e.$6L=q}),define(Pe[77],Ie([1,0,11,5,6,57,62,52]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,n)=>i===n,D=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),h=(i,n)=>{let c;for(const[l,t]of D)t(i[l],n[l])||(c?c[l]=n[l]:c={[l]:n[l]});return c};class w extends R.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new O.$de),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,A.$4L)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,A.$4L)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const l=this.tree.get(n);if(l){if((l.expandLevels===void 0||c>l.expandLevels)&&(l.expandLevels=c),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,c-1):t.wait().then(()=>this.L(l,c-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,c-1)):this.L(l,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(p.$WL.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const l of c.ops)this.w(n,l);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,M.$ed)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const l=p.$WL.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(l.toString());if(!f){f={fullId:l,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,c);return}if(f.actual===n){this.H(n,f,c);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(l.toString()),this.z(n,c);const a=this.s.getChildren(f.actual),m=f.actual,u=h(this.s.toITestItem(m),this.s.toITestItem(n));this.s.getApiFor(m).listener=void 0,f.actual=n,f.resolveBarrier=void 0,f.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(n.tags,m.tags,l.toString()),delete u.tags),this.w(f,{op:4,update:u})),this.I(n,f,c);for(const[b,v]of a)this.s.getChildren(n).get(v.id)||this.O(p.$WL.joinToString(l,v.id));const C=f.expandLevels;C!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(l.toString(),C))}),this.y(f.actual.uri)}C(n,c,l){const t=new Set(c.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:l,item:{tags:n.map(f=>(0,A.$2L)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$2L)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,A.$2L)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,l){this.G(n,l);const t=this.s.getApiFor(n);t.parent=l?.actual,t.listener=f=>this.w(c,f),this.J(c)}I(n,c,l){this.H(n,c,l);for(const[t,f]of this.s.getChildren(n))this.z(f,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const l=[];for(const[t,f]of this.s.getChildren(n.actual)){const a=this.expand(p.$WL.joinToString(n.fullId,f.id),c);(0,I.$ih)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new I.$vh;return f.open(),f}n.expand=2,this.N(n);const c=n.resolveBarrier=new I.$vh,l=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){l(f)}return(0,I.$ih)(t)?t.catch(l).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const l=[c];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,a]of this.s.getChildren(t.actual))l.push(this.tree.get(p.$WL.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$pP=w;class g extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$qP=g;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rP=r;class o extends Error{constructor(n,c,l){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${l}".`)}}e.$sP=o;const s=(i,n,c)=>{let l=new Map;return{get size(){return l.size},forEach(t,f){for(const a of l.values())t.call(f,a,this)},[Symbol.iterator](){return l.entries()},replace(t){const f=new Map,a=new Set(l.keys()),m={op:5,ops:[]};for(const u of t){if(!(u instanceof c))throw new r(u.id);const C=n(u).controllerId;if(C!==i.controllerId)throw new o(u.id,C,i.controllerId);if(f.has(u.id))throw new g(u.id);f.set(u.id,u),a.delete(u.id),m.ops.push({op:0,item:u})}for(const u of a.keys())m.ops.push({op:3,id:u});i.listener?.(m),l=f},add(t){if(!(t instanceof c))throw new r(t.id);l.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){l.delete(t)&&i.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$tP=s}),define(Pe[107],Ie([1,0,77]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=void 0;const O=new WeakMap,R=(A,p)=>{const $={controllerId:p};return O.set(A,$),$};e.$uP=R;const M=A=>{const p=O.get(A);if(!p)throw new I.$rP(A?.id||"<unknown>");return p};e.$vP=M}),define(Pe[78],Ie([1,0,16,2]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MAb=e.$LAb=e.$KAb=void 0,e.$NAb=R,e.$OAb=A,e.$KAb="vscode-cdn.net",e.$LAb=`vscode-resource.${e.$KAb}`,e.$MAb=`'self' https://*.${e.$KAb}`;function R(p,$){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===I.Schemas.file&&(p=O.URI.from({scheme:I.Schemas.vscodeRemote,authority:$.authority,path:p.path})),O.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${M(p.authority)}.${e.$LAb}`,path:p.path,fragment:p.fragment,query:p.query}))}function M(p){return p.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function A(p){return p.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}}),define(Pe[232],Ie([1,0,5,6,78]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class M{constructor(p,$,y){this.d=p,this.e=$,this.f=y,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const T=$.getVisibleTextEditors();for(const D of this.c.values())T.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,y,T,D){let h;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){h=n;break}if(!h)throw new Error("not a visible editor");const w=this,g=this.a++,r=new I.$de,o=new I.$de,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,R.$NAb)(n,w.f)}get cspSource(){return R.$MAb}set options(n){this.b=n,w.d.$setOptions(g,n)}get options(){return this.b}set html(n){this.a=n,w.d.$setHtml(g,n)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(n){return w.d.$postMessage(g,n)}},i=new class{constructor(){this.editor=p,this.line=$,this.height=y,this.webview=s,this.onDidDispose=o.event}dispose(){w.c.has(g)&&(w.c.delete(g),w.d.$disposeEditorInset(g),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(g,h.id,h.value.document.uri,$+1,y,T||{},D.identifier,D.extensionLocation),this.c.set(g,{editor:p,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$Alc=M}),define(Pe[108],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=void 0,e.$aM="__",e.$bM=(0,I.$wi)("IAuthenticationService"),e.$cM=(0,I.$wi)("IAuthenticationExtensionsService")}),define(Pe[233],Ie([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.VariableKind=e.$nQ=void 0,e.$nQ=(0,I.$wi)("configurationResolverService");var O;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class R extends Error{constructor(A,p){super(p),this.variable=A}}e.$oQ=R}),define(Pe[234],Ie([1,0,19,75,15,25,22,97,192,233,13]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,g,r,o){this.h=new Map,this.a=w,this.b=g,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(w){if(A.$i){const g=Object.create(null);return Object.keys(w).forEach(r=>{g[r.toLowerCase()]=w[r]}),g}return w}resolveWithEnvironment(w,g,r){return this.l({env:this.i(w),userHome:void 0},g?g.uri:void 0,r)}async resolveAsync(w,g){const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,g)}async j(w,g,r,o){const s=M.$3n(g);A.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):A.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):A.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,w?w.uri:void 0,s,r,o)}async resolveAnyAsync(w,g,r){return this.j(w,g,r)}async resolveAnyMap(w,g,r){const o=new Map;return{newConfig:await this.j(w,g,r,o),resolvedVariables:o}}resolveWithInteractionReplace(w,g,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,g,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,g){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,g)}async l(w,g,r,o,s){if(R.$9f(r))return this.m(w,g,r,o,s);if(Array.isArray(r))return Promise.all(r.map(i=>this.l(w,g,i,o,s)));if(R.$$f(r)){const i=Object.create(null),n=await Promise.all(Object.keys(r).map(async c=>[await this.m(w,g,c,o,s),await this.l(w,g,r[c],o,s)]));for(const[c,l]of n)i[c]=l;return i}return r}m(w,g,r,o,s){return(0,T.$pf)(r,D.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(D.VARIABLE_LHS))return i;let c=await this.o(w,i,n,g,o);return s?.set(n,c),c!==i&&R.$9f(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(w,g,c,o,s)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,g,r,o,s){let i;const n=r.split(":");n.length>1&&(r=n[0],i=n[1]);const c=f=>{const a=this.a.getFilePath();if(a)return(0,p.$Ew)(a);throw new y.$oQ(f,(0,$.localize)(0,null,g))},l=f=>{const a=c(f);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,p.$Ew)(m)}throw new y.$oQ(f,(0,$.localize)(1,null,g,I.$nc(a)))},t=f=>{if(i){const a=this.a.getFolderUri(i);if(a)return a;throw new y.$oQ(f,(0,$.localize)(2,null,g,i))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new y.$oQ(f,(0,$.localize)(3,null,g)):new y.$oQ(f,(0,$.localize)(4,null,g))};switch(r){case"env":if(i){if(w.env){const f=w.env[A.$i?i.toLowerCase():i];if(R.$9f(f))return f}return""}throw new y.$oQ(y.VariableKind.Env,(0,$.localize)(5,null,g));case"config":if(i){const f=this.a.getConfigurationValue(o,i);if(R.$fg(f))throw new y.$oQ(y.VariableKind.Config,(0,$.localize)(6,null,g,i));if(R.$$f(f))throw new y.$oQ(y.VariableKind.Config,(0,$.localize)(7,null,g,i));return f}throw new y.$oQ(y.VariableKind.Config,(0,$.localize)(8,null,g));case"command":return this.p(y.VariableKind.Command,g,i,s,"command");case"input":return this.p(y.VariableKind.Input,g,i,s,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new y.$oQ(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,g,i));return this.n(f.extensionLocation)}throw new y.$oQ(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,g));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,p.$Ew)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return o||i?(0,p.$Ew)(this.n(t(y.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Ew)(I.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new y.$oQ(y.VariableKind.UserHome,(0,$.localize)(11,null,g))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new y.$oQ(y.VariableKind.LineNumber,(0,$.localize)(12,null,g))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new y.$oQ(y.VariableKind.SelectedText,(0,$.localize)(13,null,g))}case"file":return c(y.VariableKind.File);case"fileWorkspaceFolder":return l(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$nc(l(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||i?I.$lc(this.n(t(y.VariableKind.RelativeFile)),c(y.VariableKind.RelativeFile)):c(y.VariableKind.RelativeFile);case"relativeFileDirname":{const f=I.$mc(c(y.VariableKind.RelativeFileDirname));if(o||i){const a=I.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),f);return a.length===0?".":a}return f}case"fileDirname":return I.$mc(c(y.VariableKind.FileDirname));case"fileExtname":return I.$oc(c(y.VariableKind.FileExtname));case"fileBasename":return I.$nc(c(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=I.$nc(c(y.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-I.$oc(f).length)}case"fileDirnameBasename":return I.$nc(I.$mc(c(y.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||g}case"execInstallFolder":{const f=this.a.getAppRoot();return f||g}case"pathSeparator":case"/":return I.sep;default:try{const f=i?`${r}:${i}`:r;return this.p(y.VariableKind.Unknown,g,f,s,void 0)}catch{return g}}}}p(w,g,r,o,s){if(r&&o){const i=s===void 0?o[r]:o[s+":"+r];if(typeof i=="string")return i;throw new y.$oQ(w,(0,$.localize)(14,null,g))}return g}}e.$DQ=D}),define(Pe[109],Ie([1,0,3,106]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=y,e.$1D=h,e.$2D=w,e.$YD=(0,I.$wi)("editorGroupsService");var R;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var M;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var p;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(g){const r=g;return(0,O.$JF)(r?.editor)&&(0,O.$JF)(r?.replacement)}var T;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function h(g){const r=g;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function w(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[235],Ie([1,0,3,109]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=R,e.$3D=(0,I.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function R(M){const A=M;return typeof M=="number"||(0,O.$1D)(A)}}),define(Pe[236],Ie([1,0,3,99]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=void 0,e.$vM=(0,I.$xi)(O.$Di)}),define(Pe[110],Ie([1,0,20,5,19,6,11]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=e.$V_b=e.$U_b=e.$T_b=void 0;class p{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$T_b=p;class ${static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const l=c.getExtensionDescription(i);return l?!!((l.main||l.browser)&&l.api==="none"):!1}constructor(i,n){this.j=i,this.c=new O.$de,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(r),this.f=new I.$Tm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=o(this.e,n),this.e=this.e.concat(i);const c=$.l(this.e);return this.e=o(this.e,c.map(l=>l.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,m){this.addNode(a),this.addNode(m),this.c.has(a)?this.c.get(a).push(m):this.c.set(a,[m])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,m){const u=n.getArcs(a);for(let C=0;C<u.length;C++)if(!m.has(u[C]))return!1;return!0}getNodes(){return this.e}},c=new I.$Tm;for(const a of i)if(c.set(a.identifier,a),a.extensionDependencies)for(const m of a.extensionDependencies)n.addArc(I.$Rm.toKey(a.identifier),I.$Rm.toKey(m));const l=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>l.add(a));const t=n.getNodes().filter(a=>!l.has(a));let f;do{f=!1;for(let a=0;a<t.length;a++){const m=t[a];n.hasOnlyGoodArcs(m,l)&&(t.splice(a,1),a--,l.add(m),f=!0)}}while(f);return t.map(a=>c.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new y(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$U_b=$;class y{constructor(i,n){this.versionId=i,this.extensions=n}}e.$V_b=y;class T{constructor(i){this.d=new w,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new D(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$W_b=T;class D extends M.$Uc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$X_b=D;class h{constructor(i){this.name=i;const n=(0,A.$ph)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class w{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new h(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),l=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,M.$Sc)(l))}}var g;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(g||(g={}));function r(s,i){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const l=R.$gc.basename(s.extensionLocation.path),t=R.$gc.basename(i.extensionLocation.path);return l<t?-1:l>t?1:0}function o(s,i){const n=new I.$Sm(i);return s.filter(c=>!n.has(c.identifier))}}),define(Pe[79],Ie([1,0,21]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=A,e.$1m=p;var O;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(O||(e.UIKind=O={}));var R;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var M;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(y){const T=I.$Fe.alloc(1);switch(y){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function p(y,T){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Pe[63],Ie([1,0,3,5,12,27,79,58,59,25,2,6,179]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$RP=e.$QP=void 0,e.$SP=r;let w=class extends D.$Uc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new O.$de),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$de),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$kp,name:(0,h.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,R.$5j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const c=this.getTelemetryDetails(),l=new g(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$Im)((0,$.$qp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const l=n.filter(t=>!t.isDisposed);l.length===0?this.r.delete(c):this.r.set(c,l)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let l=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),l=!0);return l}};e.$QP=w,e.$QP=w=Je([We(0,M.$PP),We(1,R.$4j)],w);class g{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,c,l,t,f){this.g=n,this.h=c,this.i=l,this.j=t,this.a=new O.$de,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,$.$tp)(i,[]),this.c&&(i=(0,y.$6n)(i,this.c)),this.b||(i=(0,y.$6n)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,$.$tp)(n,[]),l=new Error(c.message,{cause:c.cause});l.stack=c.stack,l.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(l,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$RP=g;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$TP=(0,I.$wi)("IExtHostTelemetry")}),define(Pe[26],Ie([1,0,5,2,207,105,20,3]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=h,e.$PG=w,e.$SG=s,e.$TG=i,e.$JG=Object.freeze({identifier:new A.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,p.$wi)("extensionService");class ${constructor(l){this.dependency=l}}e.$MG=$;var y;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,f){this.c=l,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$uG.createActivationEventsMap(this.d)}}set(l,t,f){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],m=[],u=[],C=[],b=D(this.d),v=D(t),d=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=v.get(W.identifier);if(!V){a.push(W.identifier),b.delete(W.identifier);continue}if(!d(W,V)){a.push(W.identifier),b.delete(W.identifier);continue}}for(const W of t){const V=b.get(W.identifier);if(!V){m.push(W);continue}if(!d(V,W)){a.push(V.identifier),b.delete(V.identifier);continue}}const E=new A.$Sm(this.e),k=new A.$Sm(f);for(const W of this.e)k.has(W)||u.push(W);for(const W of f)E.has(W)||C.push(W);const P=M.$uG.createActivationEventsMap(m),S={versionId:l,toRemove:a,toAdd:m,addActivationEvents:P,myToRemove:u,myToAdd:C};return this.delta(S),S}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:a,myToAdd:m}=l,u=new A.$Sm(t),C=new A.$Sm(a);for(let b=0;b<this.d.length;b++)u.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)C.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of f)this.d.push(b);for(const b of m)this.e.push(b);return this.f=null,l}containsExtension(l){for(const t of this.e)if(A.$Rm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=M.$uG.readActivationEvents(t);for(const a of f)l.add(a)}return l}}e.$NG=T;function D(c){const l=new A.$Tm;for(const t of c)l.set(t.identifier,t);return l}function h(c,l){return c.enabledApiProposals?c.enabledApiProposals.includes(l):!1}function w(c,l){if(!h(c,l))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class g{constructor(l,t,f,a){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=a}}e.$QG=g;class r{constructor(l,t){this.description=l,this.value=t}}e.$RG=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.$zp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,l){return{identifier:new A.$Rm((0,R.$xp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!l,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=n}),define(Pe[237],Ie([1,0,14,110,20,26,12,11]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=e.$Zlc=e.$Ylc=e.$Xlc=e.$Wlc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,i,n,c){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$Wlc=$;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Xlc=y;class T{constructor(s,i,n,c,l,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=l,this.subscriptions=t}}e.$Ylc=T;class D extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Zlc=D;class h extends T{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$1lc=h;class w extends T{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(s,i,n,c){this.g=c,this.a=s,this.b=i,this.c=n,this.d=new R.$Tm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const l=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(l));return this.c.onExtensionActivationError(s.id,l,new M.$MG(s.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const l of c){if(this.m(l))continue;const t=this.d.get(l);if(t){n.push(t);continue}if(this.l(l)){n.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:s.reason}));continue}const f=this.a.getExtensionDescription(l);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:s.reason}));continue}const a=i.displayName||i.identifier.value,m=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),u=this.k(s,i.displayName,[],new w(m));return this.c.onExtensionActivationError(i.identifier,m,new M.$MG(l)),u}return this.k(s,i.displayName,n,null)}k(s,i,n,c){const l=new r(s.id,i,s.reason,n,c,this.c,this.g);return this.d.set(s.id,l),l}l(s){return O.$U_b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$2lc=g,e.$2lc=g=Je([We(3,A.$3j)],g);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,c,l,t,f){this.c=s,this.d=i,this.f=n,this.g=c,this.h=l,this.j=t,this.k=f,this.a=new p.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new w(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new w(i),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([We(6,A.$3j)],r)}),define(Pe[238],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[239],Ie([1,0,194,14,33,100,74,29,20,238,102,105]),function(le,e,I,O,R,M,A,p,$,y,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const h=p.$co.as(A.$do.JSONContribution);class w{constructor(l,t,f){this.a=l,this.b=t,this.c=f}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(R.default.Error,l)}warn(l){this.d(R.default.Warning,l)}info(l){this.d(R.default.Info,l)}}e.$DG=w;class g{static a(l){const t=new $.$Sm;for(let f=0,a=l.length;f<a;f++)t.add(l[f].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new g(t,[]);if(!t||!t.length)return new g([],l);const f=this.a(l),a=this.a(t),m=t.filter(C=>!f.has(C.description.identifier)),u=l.filter(C=>!a.has(C.description.identifier));return new g(m,u)}constructor(l,t){this.added=l,this.removed=t}}e.$EG=g;class r{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=g.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,O.$1)(l)}}}e.$FG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Qm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$To}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$To}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new r(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&D.$uG.register(l.extensionPoint,l.activationEventsGenerator),e.$GG.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,h.registerSchema(s,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$co.add(n.ExtensionsRegistry,new i),e.$IG=p.$co.as(n.ExtensionsRegistry),h.registerSchema(s,e.$GG),h.registerSchema(T.$kk,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Pe[240],Ie([1,0,190,15,25,239,31,5]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var y;(function(h){function w(g,r,o){if(!g)return;const s=O.$9f(g.type)?g.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const i=[];if(Array.isArray(g.required))for(const n of g.required)O.$9f(n)&&i.push(n);return{extensionId:r.value,taskType:s,required:i,properties:g.properties?R.$3n(g.properties):{},when:g.when?A.$uj.deserialize(g.when):void 0}}h.from=w})(y||(y={}));const T=M.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,w)=>{for(const g of h)g.type&&w.push(`onTaskType:${g.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:$}});class D{constructor(){this.d=new p.$de,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,g)=>{T.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of o.added){const i=s.value;for(const n of i){const c=y.from(n,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const g of this.all()){const r={type:"object",additionalProperties:!1};g.required.length>0&&(r.required=g.required.slice(0)),g.properties!==void 0?r.properties=R.$3n(g.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[g.taskType]},w.push(r)}this.c={oneOf:w}}return this.c}}e.$cI=new D}),define(Pe[241],Ie([1,0,191,15,23,25,31,240]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new A.$Nj("taskRunning",!1,I.localize(0,null)),e.$fI=I.localize2(2,"Tasks");var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$gI="$customized",function(N){function B(K){if(!K)return N.Strong;switch(K.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=B}($||(e.ShellQuoting=$={}));var y;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var T;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(T||(e.RevealKind=T={})),function(N){function B(K){switch(K.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=B}(T||(e.RevealKind=T={}));var D;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(N){function B(K){switch(K.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=B}(D||(e.RevealProblemKind=D={}));var h;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(h||(e.PanelKind=h={})),function(N){function B(K){switch(K.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=B}(h||(e.PanelKind=h={}));var w;(function(N){N.defaults={echo:!0,reveal:T.Always,revealProblems:D.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var g;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(N){function B(ie){switch(ie.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=B;function K(ie){switch(ie){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=K}(g||(e.RuntimeType=g={}));var r;(function(N){function B(K){return O.$9f(K)?K:K.value}N.value=B})(r||(e.CommandString=r={}));var o;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function B(ie){return ie===N.Clean._id||ie===N.Build._id||ie===N.Rebuild._id||ie===N.Test._id}N.is=B;function K(ie){if(ie!==void 0)return O.$9f(ie)?B(ie)?{_id:ie,isDefault:!1}:void 0:ie}N.from=K})(o||(e.TaskGroup=o={}));var s;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function B(K){switch(K){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=B})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var l;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(B,K,ie,ce,ye,Se){this._label="",this._id=B,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ye,this._source=Se}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,K=!1){if(B===void 0)return!1;if(O.$9f(B))return B===this._label||B===this.configurationProperties.identifier||K&&B===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$hI=t;class f extends t{constructor(B,K,ie,ce,ye,Se,fe,$e){super(B,ie,void 0,fe,$e,K),this.command={},this._source=K,this.hasDefinedMatchers=Se,ye&&(this.command=ye)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case g.Shell:K="shell";break;case g.Process:K="process";break;case g.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(B){return B instanceof f}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const ie={type:e.$gI,folder:B,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new f(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$iI=f;class a extends t{constructor(B,K,ie,ce,ye,Se,fe){super(B,ie,ce,Se,fe,K),this._source=K,this.configures=ye}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const ie={type:e.$gI,folder:B,id:K};return JSON.stringify(ie)}}e.$jI=a;class m extends t{constructor(B,K,ie,ce,ye,Se,fe,$e,Te){super(B,ie,ce,$e,Te,K),this.defines=ye,this.hasDefinedMatchers=fe,this.command=Se,this.icon=Te.icon,this.hide=Te.hide}clone(){return new m(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof m}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new m(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$kI=m;class u extends t{constructor(B,K,ie,ce,ye,Se){super(B,ie,ce,ye,Se,K),this._source=K}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new u(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$lI=u;var C;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(C||(e.ExecutionEngine=C={})),function(N){N._default=N.Terminal}(C||(e.ExecutionEngine=C={}));var b;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class v{constructor(B){this.c=new Map;for(let K=0;K<B.length;K++)this.c.set(B[K].uri.toString(),K)}compare(B,K){const ie=B.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ye=this.c.get(ie.uri.toString());ye=ye===void 0?0:ye+1;let Se=this.c.get(ce.uri.toString());return Se=Se===void 0?0:Se+1,ye===Se?B._label.localeCompare(K._label):ye-Se}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$mI=v;var d;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(d||(e.TaskEventKind=d={}));var E;(function(N){N.SingleRun="singleRun",N.Background="background"})(E||(e.TaskRunType=E={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(N){function B($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function K($e,Te,ae){return{...B($e),kind:"start",terminalId:Te,resolvedVariables:ae}}N.start=K;function ie($e,Te,ae){return{...B($e),kind:"processStarted",terminalId:Te,processId:ae}}N.processStarted=ie;function ce($e,Te,ae){return{...B($e),kind:"processEnded",terminalId:Te,exitCode:ae}}N.processEnded=ce;function ye($e,Te,ae){return{...B($e),kind:"terminated",exitReason:ae,terminalId:Te}}N.terminated=ye;function Se($e,Te,ae){return{...B(Te),kind:$e,terminalId:ae}}N.general=Se;function fe(){return{kind:"changed"}}N.changed=fe})(P||(e.TaskEvent=P={}));var S;(function(N){function B(ie){const ce=Object.keys(ie).sort();let ye="";for(const Se of ce){let fe=ie[Se];fe instanceof Object?fe=B(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ye+=Se+","+fe+","}return ye}function K(ie){const ye={_key:B(ie),type:ie.taskType};return Object.assign(ye,ie),ye}N.create=K})(S||(e.KeyedTaskIdentifier=S={}));var W;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(N){function B(K,ie){const ce=p.$cI.get(K.type);if(ce===void 0){const $e=M.$3n(K);return delete $e._key,S.create($e)}const ye=Object.create(null);ye.type=ce.taskType;const Se=new Set;ce.required.forEach($e=>Se.add($e));const fe=ce.properties;for(const $e of Object.keys(fe)){const Te=K[$e];if(Te!=null)ye[$e]=Te;else if(Se.has($e)){const ae=fe[$e];if(ae.default!==void 0)ye[$e]=M.$3n(ae.default);else switch(ae.type){case"boolean":ye[$e]=!1;break;case"number":case"integer":ye[$e]=0;break;case"string":ye[$e]="";break;default:ie.error(I.localize(1,null,JSON.stringify(K,void 0,0),$e));return}}}return S.create(ye)}N.createTaskIdentifier=B})(q||(e.TaskDefinition=q={}))}),define(Pe[242],Ie([1,0,14]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=e.$Y_b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,p)=>{this.b=A,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,I.$1)(A))}then(A,p){return this.j().then(A,p)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Y_b=O;class R extends O{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$Z_b=R}),define(Pe[35],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$yw=void 0,e.$zw=R,e.$Aw=M;class I{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++I.count}}e.$yw=I;const O=[];function R(p){const $=new I(p);return O[$.nid]=$,$}function M(p){return O[p].sid}class A{constructor($){this.value=$}}e.$Bw=A}),define(Pe[4],Ie([1,0,35]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$0M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var R;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var M;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var p;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var T;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(T||(e.CandidatePortSource=T={}));class D{static{this.a=0}static mixin(o){return o._id=D.a++,o}}e.$0M=D;var h;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var w;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var g;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$$M={MainThreadAuthentication:(0,I.$zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$zw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$zw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$zw)("MainThreadClipboard"),MainThreadCommands:(0,I.$zw)("MainThreadCommands"),MainThreadComments:(0,I.$zw)("MainThreadComments"),MainThreadConfiguration:(0,I.$zw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$zw)("MainThreadConsole"),MainThreadDebugService:(0,I.$zw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$zw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$zw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$zw)("MainThreadLanguages"),MainThreadLogger:(0,I.$zw)("MainThreadLogger"),MainThreadMessageService:(0,I.$zw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$zw)("MainThreadOutputService"),MainThreadProgress:(0,I.$zw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$zw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$zw)("MainThreadSecretState"),MainThreadStorage:(0,I.$zw)("MainThreadStorage"),MainThreadSpeech:(0,I.$zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$zw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$zw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$zw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$zw)("MainThreadSCM"),MainThreadSearch:(0,I.$zw)("MainThreadSearch"),MainThreadShare:(0,I.$zw)("MainThreadShare"),MainThreadTask:(0,I.$zw)("MainThreadTask"),MainThreadWindow:(0,I.$zw)("MainThreadWindow"),MainThreadLabelService:(0,I.$zw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$zw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$zw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$zw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$zw)("MainThreadTimeline"),MainThreadTesting:(0,I.$zw)("MainThreadTesting"),MainThreadLocalization:(0,I.$zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$zw)("MainThreadAiEmbeddingVector")},e.$_M={ExtHostCommands:(0,I.$zw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$zw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$zw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$zw)("ExtHostStatusBar"),ExtHostShare:(0,I.$zw)("ExtHostShare"),ExtHostExtensionService:(0,I.$zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$zw)("ExtHostSCM"),ExtHostSearch:(0,I.$zw)("ExtHostSearch"),ExtHostTask:(0,I.$zw)("ExtHostTask"),ExtHostWorkspace:(0,I.$zw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$zw)("ExtHostWindow"),ExtHostWebviews:(0,I.$zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$zw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$zw)("ExtHostProgress"),ExtHostComments:(0,I.$zw)("ExtHostComments"),ExtHostSecretState:(0,I.$zw)("ExtHostSecretState"),ExtHostStorage:(0,I.$zw)("ExtHostStorage"),ExtHostUrls:(0,I.$zw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$zw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$zw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$zw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$zw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$zw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$zw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$zw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$zw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$zw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$zw)("ExtHostTimeline"),ExtHostTesting:(0,I.$zw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$zw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$zw)("ExtHostLocalization")}}),define(Pe[80],Ie([1,0,3,12,4,17]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=e.$jlc=void 0,e.$jlc=(0,I.$wi)("IExtHostApiDeprecationService");let A=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(R.$$M.MainThreadTelemetry)}report($,y,T){const D=this.d($,y);this.a.has(D)||(this.a.add(D),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$klc=A,e.$klc=A=Je([We(0,M.$zP),We(1,O.$3j)],A),e.$llc=Object.freeze(new class{report(p,$,y){}})}),define(Pe[243],Ie([1,0,4]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class O{constructor(M){const A=M.getProxy(I.$$M.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(p){return A.$writeText(p)}})}}e.$ylc=O}),define(Pe[244],Ie([1,0,25,4,27,17]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;let A=class{constructor(T,D){this.a=T.getProxy(O.$$M.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,D){const h=this,w=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){h.e(T,D,w,arguments)}})}e(T,D,h,w){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:$(w,this.b)}),this.c&&this.f(T,h,w)}};e.$snc=A,e.$snc=A=Je([We(0,M.$zP),We(1,R.$PP)],A);const p=1e5;function $(y,T){const D=[];if(y.length)for(let h=0;h<y.length;h++){let w=y[h];if(typeof w>"u")w="undefined";else if(w instanceof Error){const g=w;g.stack?w=g.stack:w=g.toString()}D.push(w)}if(T){const h=new Error().stack;h&&D.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,I.$8n)(D);return h.length>p?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Pe[245],Ie([1,0,2,4,26]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class M{constructor(p){this.a=p.getProxy(O.$$M.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,R.$PG)(p,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?I.URI.revive($):void 0)}}e.$vmc=M}),define(Pe[246],Ie([1,0,6,4]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;class R{constructor(A){this.b=0,this.a=A.getProxy(O.$$M.MainThreadLabelService)}$registerResourceLabelFormatter(A){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,A),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Pmc=R}),define(Pe[81],Ie([1,0,22,13,2,3,12,4,27,17]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=e.$dmc=void 0;let T=class{constructor(h,w,g){this.f=g,this.d=new Map,this.a=w.getProxy(p.$$M.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===I.$g}getMessage(h,w){const{message:g,args:r,comment:o}=w;if(this.c)return(0,O.$9e)(g,r??{});let s=g;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const i=this.d.get(h)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,O.$9e)(i??g,r??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let w;const g=await this.g(h);if(!g){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(g),o=JSON.parse(r);w=h.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${h.identifier.value} from ${g}: ${r.message}`);return}w&&this.d.set(h.identifier.value,{contents:w,uri:g})}async g(h){if(h.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return R.URI.revive(w)}return h.l10n?R.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$dmc=T,e.$dmc=T=Je([We(0,$.$PP),We(1,y.$zP),We(2,A.$3j)],T),e.$emc=(0,M.$wi)("IExtHostLocalizationService")}),define(Pe[247],Ie([1,0,12,4,27,17,2,49]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;let $=class extends I.$bk{constructor(D,h){super(h.logLevel,h.logsLocation,h.loggers.map(w=>(0,p.$6h)(w))),this.r=D.getProxy(O.$$M.MainThreadLogger)}$setLogLevel(D,h){h?this.setLogLevel(A.URI.revive(h),D):this.setLogLevel(D)}setVisibility(D,h){super.setVisibility(D,h),this.r.$setVisibility(D,h)}s(D,h,w){return new y(this.r,D,h,w)}};e.$rnc=$,e.$rnc=$=Je([We(0,M.$zP),We(1,R.$PP)],$);class y extends I.$9j{constructor(D,h,w,g){super(g?.logLevel==="always"),this.r=D,this.s=h,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(h,g).then(()=>{this.u(this.n),this.m=!0})}g(D,h){const w=[[D,h]];this.m?this.u(w):this.n.push(...w)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[82],Ie([1,0,4,3,6,17,21]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=e.$fmc=void 0,e.$fmc=(0,O.$wi)("IExtHostManagedSockets");let p=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(I.$$M.MainThreadManagedSockets)}setFactory(D,h){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(D,h),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const h=++this.b,w=await this.c.makeConnection(),g=new R.$Tc;return this.d.set(h,new y(h,w,g)),g.add((0,R.$Sc)(()=>this.d.delete(h))),g.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(h),g.dispose()})),g.add(w.onDidClose(r=>{this.a.$onDidManagedSocketClose(h,r?.stack??r?.message),g.dispose()})),g.add(w.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(h,A.$Fe.wrap(r)))),h}$remoteSocketWrite(D,h){this.d.get(D)?.actual.send(h.buffer)}$remoteSocketEnd(D){const h=this.d.get(D);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$gmc=p,e.$gmc=p=Je([We(0,M.$zP)],p);class ${constructor(D,h){this.socketFactoryId=D,this.makeConnection=h}}class y extends R.$Uc{constructor(D,h,w){super(),this.socketId=D,this.actual=h,this.B(w)}}}),define(Pe[248],Ie([1,0,4,12,26]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;function M(p){return p&&p.title}let A=class{constructor($,y){this.b=y,this.a=$.getProxy(I.$$M.MainThreadMessageService)}showMessage($,y,T,D,h){const w={source:{identifier:$.identifier,label:$.displayName||$.name}};let g;typeof D=="string"||M(D)?g=[D,...h]:(w.modal=D?.modal,w.useCustom=D?.useCustom,w.detail=D?.detail,g=h),w.useCustom&&(0,R.$PG)($,"resolvers");const r=[];let o=!1;for(let s=0;s<g.length;s++){const i=g[s];if(typeof i=="string")r.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;r.push({title:n,isCloseAffordance:!!c,handle:s}),c&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,T,w,r).then(s=>{if(typeof s=="number")return g[s]})}};e.$Rmc=A,e.$Rmc=A=Je([We(1,O.$3j)],A)}),define(Pe[249],Ie([1,0,6,15,2,26,4]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class p{constructor(y){this.b=new Map,this.a=y.getProxy(A.$$M.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,T,D){if((0,M.$PG)(y,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,D),this.a.$registerProfileContentHandler(T,D.name,D.description,y.identifier.value),(0,I.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(y,T,D,h){const w=this.b.get(y);if(!w)throw new Error(`Unknown handler with id: ${y}`);return w.saveProfile(T,D,h)}async $readProfile(y,T,D){const h=this.b.get(y);if(!h)throw new Error(`Unknown handler with id: ${y}`);return h.readProfile((0,O.$9f)(T)?T:R.URI.revive(T),D)}}e.$1mc=p}),define(Pe[83],Ie([1,0,4,5,3]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class M{constructor(p){this.b=new O.$de,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$$M.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,y){return this.a.$setPassword(p,$,y)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$amc=M,e.$bmc=(0,R.$wi)("IExtHostSecretState")}),define(Pe[250],Ie([1,0,24,6,4]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=void 0;class M{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.f=new Map,this.b=p.getProxy(R.$$M.MainThreadSpeech)}async $createSpeechToTextSession(p,$,y){const T=this.c.get(p);if(!T)return;const D=new O.$Tc,h=new I.$oe;this.d.set($,h);const w=D.add(T.provideSpeechToTextSession(h.token,y?{language:y}:void 0));D.add(w.onDidChange(g=>{h.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,g)})),D.add(h.token.onCancellationRequested(()=>D.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createTextToSpeechSession(p,$){const y=this.c.get(p);if(!y)return;const T=new O.$Tc,D=new I.$oe;this.d.set($,D);const h=T.add(y.provideTextToSpeechSession(D.token));this.f.set($,h),T.add(h.onDidChange(w=>{D.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,w)})),T.add(D.token.onCancellationRequested(()=>T.dispose()))}async $synthesizeSpeech(p,$){const y=this.f.get(p);y&&y.synthesize($)}async $cancelTextToSpeechSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p),this.f.delete(p)}async $createKeywordRecognitionSession(p,$){const y=this.c.get(p);if(!y)return;const T=new O.$Tc,D=new I.$oe;this.d.set($,D);const h=T.add(y.provideKeywordRecognitionSession(D.token));T.add(h.onDidChange(w=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,w)})),T.add(D.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,y){const T=M.a++;return this.c.set(T,y),this.b.$registerProvider(T,$,{extension:p,displayName:p.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$8mc=M}),define(Pe[84],Ie([1,0,4,5,3]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;class M{constructor(p,$){this.c=$,this.b=new O.$de,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$$M.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,y){const T=await this.a.$initializeExtensionStorage(p,$);let D;return T&&(D=this.d(p,$,T)),D||y}setValue(p,$,y){return this.a.$setValue(p,$,y)}$acceptValue(p,$,y){const T=this.d(p,$,y);T&&this.b.fire({shared:p,key:$,value:T})}d(p,$,y){try{return JSON.parse(y)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${T}`)}}}e.$3lc=M,e.$4lc=(0,R.$wi)("IExtHostStorage")}),define(Pe[251],Ie([1,0,6,16,2,4]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(M.$$M.MainThreadUriOpeners)}registerExternalUriOpener($,y,T,D){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const h=D.schemes.find(w=>!A.a.has(w));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(y,T),this.b.$registerUriOpener(y,D.schemes,$,D.label),(0,I.$Sc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,T){const D=this.c.get($);if(!D)throw new Error(`Unknown opener with id: ${$}`);const h=R.URI.revive(y);return D.canOpenExternalUri(h,T)}async $openUri($,y,T){const D=this.c.get($);if(!D)throw new Error(`Unknown opener id: '${$}'`);return D.openExternalUri(R.URI.revive(y.resolvedUri),{sourceUri:R.URI.revive(y.sourceUri)},T)}}e.$lnc=A}),define(Pe[252],Ie([1,0,4,2,6,14,20]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class p{static{this.a=0}constructor(y){this.c=new A.$Sm,this.d=new Map,this.b=y.getProxy(I.$$M.MainThreadUrls)}registerUriHandler(y,T){const D=y.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const h=p.a++;return this.c.add(D),this.d.set(h,T),this.b.$registerUriHandler(h,D,y.displayName||y.name),(0,R.$Sc)(()=>{this.c.delete(D),this.d.delete(h),this.b.$unregisterUriHandler(h)})}$handleExternalUri(y,T){const D=this.d.get(y);if(!D)return Promise.resolve(void 0);try{D.handleUri(O.URI.revive(T))}catch(h){(0,M.$1)(h)}return Promise.resolve(void 0)}async createAppUri(y){return O.URI.revive(await this.b.$createAppUri(y))}}e.$mnc=p}),define(Pe[64],Ie([1,0,5,6,16,25,2,197,221,78,4]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Nlc=void 0,e.$Olc=h,e.$Qlc=r,e.$Rlc=o;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,l,t,f,a,m,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$de,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$de,this._onDidDispose=this.#h.event,this.#e=c,this.#t=l,this.#o=t,this.#n=f,this.#s=a,this.#r=m,this.#l=h(m),this.#d=w(m),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,y.$NAb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===R.Schemas.https||c.scheme===R.Schemas.http){let l=c.toString();return l.endsWith("/")||(l+="/"),l+" "+y.$MAb}return y.$MAb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),M.$7n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const l=(0,$.$Erb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const l=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,m,u,C,b)=>{const v=A.URI.from({scheme:u||"file",path:decodeURIComponent(C)}),d=(0,y.$NAb)(v,{isRemote:l,authority:t}).toString();return`${a}${d}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,m,u,C,b)=>{const v=A.URI.from({scheme:u||"file",path:decodeURIComponent(C)}),d=(0,y.$NAb)(v,{isRemote:l,authority:t}).toString();return`${a}${d}${b}`})}}e.$Nlc=D;function h(n){try{const c=(0,p.$Ip)((0,p.$Hp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function w(n){try{const c=(0,p.$Ip)((0,p.$Hp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class g extends O.$Uc{constructor(c,l,t,f,a){super(),this.c=l,this.f=t,this.g=f,this.h=a,this.b=new Map,this.a=c.getProxy(T.$$M.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,l,t){const f=this.j(c);if(f){const{message:a}=(0,$.$Frb)(l,t.value);f._onMessageEmitter.fire(a)}}$onMissingCsp(c,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,l,t){const f=new D(c,this.a,s(l),this.c,this.f,t,this.h);this.b.set(c,f);const a=f._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return f}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Plc=g;function r(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,c,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||i(n,c)}}function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>A.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(l=>l.uri),n.extensionLocation]}}),define(Pe[111],Ie([1,0,5,16,13,2,3,17,4]),function(le,e,I,O,R,M,A,p,$){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=e.$onc=void 0;let T=class{static{y=this}static{this.a={focused:!0,active:!0}}getState(){const h=this.d;return{get focused(){return h.focused},get active(){return h.active}}}constructor(h){this.c=new I.$de,this.onDidChangeWindowState=this.c.event,this.d=y.a,this.b=h.getProxy($.$$M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:g})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(h){this.onDidChangeWindowProperty("focused",h)}$onDidChangeWindowActive(h){this.onDidChangeWindowProperty("active",h)}onDidChangeWindowProperty(h,w){w!==this.d[h]&&(this.d={...this.d,[h]:w},this.c.fire(this.d))}openUri(h,w){let g;if(typeof h=="string"){g=h;try{h=M.URI.parse(h)}catch{return Promise.reject(`Invalid uri - '${h}'`)}}return(0,R.$7e)(h.scheme)?Promise.reject("Invalid scheme - cannot be empty"):h.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${h.scheme}'`):this.b.$openUri(h,g,w)}async asExternalUri(h,w){if((0,R.$7e)(h.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(h,w);return M.URI.from(g)}};e.$onc=T,e.$onc=T=y=Je([We(0,p.$zP)],T),e.$pnc=(0,A.$wi)("IExtHostWindow")}),define(Pe[253],Ie([1,0,244,27,17]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;let M=class extends I.$snc{constructor(p,$){super(p,$)}f(p,$,y){$.apply(console,y)}};e.$Apc=M,e.$Apc=M=Je([We(0,R.$zP),We(1,O.$PP)],M)}),define(Pe[254],Ie([1,0,11,21,24,14,5,6,150,242,35]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$1_b=o,e.$2_b=s;function h(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const w="$$ref$$",g={[w]:-1};class r{constructor(P,S){this.jsonString=P,this.referencedBuffers=S}}function o(k,P=null,S=!1){const W=[];return{jsonString:(S?h:JSON.stringify)(k,(q,N)=>{if(typeof N>"u")return g;if(typeof N=="object"){if(N instanceof O.$Fe){const B=W.push(N)-1;return{[w]:B}}if(P)return P(q,N)}return N}),referencedBuffers:W}}function s(k,P,S){return JSON.parse(k,(W,V)=>{if(V){const q=V[w];if(typeof q=="number")return P[q];if(S&&V.$mid===1)return S.transformIncoming(V)}return V})}function i(k,P){return JSON.stringify(k,P)}function n(k){return k?(P,S)=>S&&S.$mid===1?k.transformOutgoing(S):S:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},f=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class m extends p.$Uc{static{D=f}static{this.a=3*1e3}constructor(P,S=null,W=null){super(),this[D]=!0,this.b=this.B(new A.$de),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=S,this.g=W,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$yw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Ih(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const S=this.w[P];delete this.w[P],S.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+m.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+m.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$Bn)(P,this.g):P}getProxy(P){const{nid:S,sid:W}=P;return this.s[S]||(this.s[S]=this.J(S,W)),this.s[S]}J(P,S){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...N)=>this.U(P,q,N)),q===a?S:V[q])};return new Proxy(Object.create(null),W)}set(P,S){return this.m[P.nid]=S,S}assertRegistered(P){for(let S=0,W=P.length;S<W;S++){const V=P[S];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(P){if(this.j)return;const S=P.byteLength,W=C.read(P,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:N,method:B,args:K}=v.deserializeRequestJSONArgs(W);this.g&&(K=(0,$.$Bn)(K,this.g)),this.M(S,q,N,B,K,V===2);break}case 3:case 4:{let{rpcId:N,method:B,args:K}=v.deserializeRequestMixedArgs(W);this.g&&(K=(0,$.$Bn)(K,this.g)),this.M(S,q,N,B,K,V===4);break}case 5:{this.f?.logIncoming(S,q,0,"ack"),this.G(q);break}case 6:{this.N(S,q);break}case 7:{this.O(S,q,void 0);break}case 9:{let N=v.deserializeReplyOKJSON(W);this.g&&(N=(0,$.$Bn)(N,this.g)),this.O(S,q,N);break}case 10:{const N=v.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(S,q,N);break}case 8:{const N=v.deserializeReplyOKVSBuffer(W);this.O(S,q,N);break}case 11:{let N=v.deserializeReplyErrError(W);this.g&&(N=(0,$.$Bn)(N,this.g)),this.P(S,q,N);break}case 12:{this.P(S,q,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,S,W,V,q,N){this.f?.logIncoming(P,S,1,`receiveRequest ${(0,T.$Aw)(W)}.${V}(`,q);const B=String(S);let K,ie;if(N){const ye=new R.$oe;q.push(ye.token),K=this.Q(W,V,q),ie=()=>ye.cancel()}else K=this.Q(W,V,q),ie=t;this.u[B]=ie;const ce=v.serializeAcknowledged(S);this.f?.logOutgoing(ce.byteLength,S,1,"ack"),this.c.send(ce),K.then(ye=>{delete this.u[B];const Se=v.serializeReplyOK(S,ye,this.h);this.f?.logOutgoing(Se.byteLength,S,1,"reply:",ye),this.c.send(Se)},ye=>{delete this.u[B];const Se=v.serializeReplyErr(S,ye);this.f?.logOutgoing(Se.byteLength,S,1,"replyErr:",ye),this.c.send(Se)})}N(P,S){this.f?.logIncoming(P,S,1,"receiveCancel");const W=String(S);this.u[W]?.()}O(P,S,W){this.f?.logIncoming(P,S,0,"receiveReply:",W);const V=String(S);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(P,S,W){this.f?.logIncoming(P,S,0,"receiveReplyErr:",W);const V=String(S);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let N;W&&(W.$isError?(N=new Error,N.name=W.name,N.message=W.message,N.stack=W.stack):N=W),q.resolveErr(N)}Q(P,S,W){try{return Promise.resolve(this.S(P,S,W))}catch(V){return Promise.reject(V)}}S(P,S,W){const V=this.m[P];if(!V)throw new Error("Unknown actor "+(0,T.$Aw)(P));const q=V[S];if(typeof q!="function")throw new Error("Unknown method "+S+" on actor "+(0,T.$Aw)(P));return q.apply(V,W)}U(P,S,W){if(this.j)return new y.$Z_b;let V=null;if(W.length>0&&R.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(M.$6());const q=v.serializeRequestArguments(W,this.h),N=++this.t,B=String(N),K=new y.$Y_b,ie=new p.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const ye=v.serializeCancel(N);this.f?.logOutgoing(ye.byteLength,N,0,"cancel"),this.c.send(v.serializeCancel(N))})),this.w[B]=new u(K,ie),this.F(N);const ce=v.serializeRequest(N,P,S,q,!!V);return this.f?.logOutgoing(ce.byteLength,N,0,`request: ${(0,T.$Aw)(P)}.${S}(`,W),this.c.send(ce),K}}e.$3_b=m;class u{constructor(P,S){this.a=P,this.b=S}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class C{static alloc(P,S,W){const V=new C(O.$Fe.alloc(W+1+4),0);return V.writeUInt8(P),V.writeUInt32(S),V}static read(P,S){return new C(P,S)}get buffer(){return this.a}constructor(P,S){this.a=P,this.b=S}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const S=this.a.slice(this.b,this.b+P);return this.b+=P,S}static sizeMixedArray(P){let S=0;S+=1;for(let W=0,V=P.length;W<V;W++){const q=P[W];switch(S+=1,q.type){case 1:S+=this.sizeLongString(q.value);break;case 2:S+=this.sizeVSBuffer(q.value);break;case 3:S+=this.sizeUInt32,S+=this.sizeLongString(q.value);for(let N=0;N<q.buffers.length;++N)S+=this.sizeVSBuffer(q.buffers[N]);break;case 4:break}}return S}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let S=0,W=P.length;S<W;S++){const V=P[S];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const S=new Array(P);for(let W=0;W<P;W++)switch(this.readUInt8()){case 1:S[W]=this.readLongString();break;case 2:S[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),N=this.readLongString(),B=[];for(let K=0;K<q;++K)B.push(this.readVSBuffer());S[W]=new T.$Bw(s(N,B,null));break}case 4:S[W]=void 0;break}return S}}var b;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(b||(b={}));class v{static a(P){for(let S=0,W=P.length;S<W;S++)if(P[S]instanceof O.$Fe||P[S]instanceof T.$Bw||typeof P[S]>"u")return!0;return!1}static serializeRequestArguments(P,S){if(this.a(P)){const W=[];for(let V=0,q=P.length;V<q;V++){const N=P[V];if(N instanceof O.$Fe)W[V]={type:2,value:N};else if(typeof N>"u")W[V]={type:4};else if(N instanceof T.$Bw){const{jsonString:B,referencedBuffers:K}=o(N.value,S);W[V]={type:3,value:O.$Fe.fromString(B),buffers:K}}else W[V]={type:1,value:O.$Fe.fromString(i(N,S))}}return{type:1,args:W}}return{type:0,args:i(P,S)}}static serializeRequest(P,S,W,V,q){switch(V.type){case 0:return this.b(P,S,W,V.args,q);case 1:return this.c(P,S,W,V.args,q)}}static b(P,S,W,V,q){const N=O.$Fe.fromString(W),B=O.$Fe.fromString(V);let K=0;K+=C.sizeUInt8(),K+=C.sizeShortString(N),K+=C.sizeLongString(B);const ie=C.alloc(q?2:1,P,K);return ie.writeUInt8(S),ie.writeShortString(N),ie.writeLongString(B),ie.buffer}static deserializeRequestJSONArgs(P){const S=P.readUInt8(),W=P.readShortString(),V=P.readLongString();return{rpcId:S,method:W,args:JSON.parse(V)}}static c(P,S,W,V,q){const N=O.$Fe.fromString(W);let B=0;B+=C.sizeUInt8(),B+=C.sizeShortString(N),B+=C.sizeMixedArray(V);const K=C.alloc(q?4:3,P,B);return K.writeUInt8(S),K.writeShortString(N),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(P){const S=P.readUInt8(),W=P.readShortString(),V=P.readMixedArray(),q=new Array(V.length);for(let N=0,B=V.length;N<B;N++){const K=V[N];typeof K=="string"?q[N]=JSON.parse(K):q[N]=K}return{rpcId:S,method:W,args:q}}static serializeAcknowledged(P){return C.alloc(5,P,0).buffer}static serializeCancel(P){return C.alloc(6,P,0).buffer}static serializeReplyOK(P,S,W){if(typeof S>"u")return this.d(P);if(S instanceof O.$Fe)return this.e(P,S);if(S instanceof T.$Bw){const{jsonString:V,referencedBuffers:q}=o(S.value,W,!0);return this.g(P,V,q)}else return this.f(P,h(S,W))}static d(P){return C.alloc(7,P,0).buffer}static e(P,S){let W=0;W+=C.sizeVSBuffer(S);const V=C.alloc(8,P,W);return V.writeVSBuffer(S),V.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,S){const W=O.$Fe.fromString(S);let V=0;V+=C.sizeLongString(W);const q=C.alloc(9,P,V);return q.writeLongString(W),q.buffer}static g(P,S,W){const V=O.$Fe.fromString(S);let q=0;q+=C.sizeUInt32,q+=C.sizeLongString(V);for(const B of W)q+=C.sizeVSBuffer(B);const N=C.alloc(10,P,q);N.writeUInt32(W.length),N.writeLongString(V);for(const B of W)N.writeBuffer(B);return N.buffer}static deserializeReplyOKJSON(P){const S=P.readLongString();return JSON.parse(S)}static deserializeReplyOKJSONWithBuffers(P,S){const W=P.readUInt32(),V=P.readLongString(),q=[];for(let N=0;N<W;++N)q.push(P.readVSBuffer());return new T.$Bw(s(V,q,S))}static serializeReplyErr(P,S){const W=S?h(M.$3(S),null):void 0;if(typeof W!="string")return this.h(P);const V=O.$Fe.fromString(W);let q=0;q+=C.sizeLongString(V);const N=C.alloc(11,P,q);return N.writeLongString(V),N.buffer}static deserializeReplyErrError(P){const S=P.readLongString();return JSON.parse(S)}static h(P){return C.alloc(12,P,0).buffer}}var d;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var E;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(E||(E={}))}),define(Pe[255],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0;const I=function(M){const A=p=>{globalThis.removeEventListener("message",A);const $=p.data;Object.defineProperties(globalThis,{postMessage:{value(y,T){$.postMessage(y,T)}},onmessage:{get(){return $.onmessage},set(y){$.onmessage=y}}}),$.addEventListener("message",y=>{globalThis.dispatchEvent(new MessageEvent("message",{data:y.data,ports:y.ports?[...y.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class O extends EventTarget{constructor(M,A,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${I})('${A}'))`,y=new Blob([$],{type:"application/javascript"}),T=URL.createObjectURL(y),D=new MessageChannel,h=T,w={type:"_newWorker",id:h,port:D.port2,url:T,options:p};M(w,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:h}),URL.revokeObjectURL(T),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(g){D.port1.onmessage=g}},onmessageerror:{get(){return D.port1.onmessageerror},set(g){D.port1.onmessageerror=g}}}),D.port1.addEventListener("messageerror",g=>{const r=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(r)}),D.port1.addEventListener("message",g=>{const r=new MessageEvent("message",{data:g.data});this.dispatchEvent(r)}),D.port1.start()}}e.$Cpc=O}),define(Pe[256],Ie([1,0,21,28,16,56,3]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=void 0,e.$MK=T,e.$NK=D,e.$LK=(0,A.$wi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${p.join("")}]+`),y=7;function T(w){if(w.scheme!==R.Schemas.vscodeNotebookCell)return;const g=w.fragment.indexOf("s");if(g<0)return;const r=parseInt(w.fragment.substring(0,g).replace($,""),y),o=(0,I.$Ye)(w.fragment.substring(g+1)).toString();if(!isNaN(r))return{handle:r,notebook:w.with({scheme:o,fragment:null})}}function D(w,g){const r=g.toString(y),s=`${r.length<p.length?p[r.length-1]:"z"}${r}s${(0,I.$Ze)(I.$Fe.fromString(w.scheme),!0,!0)}`;return w.with({scheme:R.Schemas.vscodeNotebookCell,fragment:s})}class h{constructor(){this.a=new O.$Ac}getNotebook(g){if(g.scheme===R.Schemas.vscodeNotebookCell){const r=T(g);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$OK=h,(0,M.$xs)(e.$LK,h,1)}),define(Pe[85],Ie([1,0,21,37,42,70,16,19,22,31,256]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$6K=e.CellStatusbarAlignment=e.$5K=e.NotebookEditorPriority=e.$2K=e.$1K=e.$YK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$XK=e.$WK=e.$VK=e.$UK=e.CellKind=e.$TK=e.$SK=e.$RK=void 0,e.$ZK=f,e.$3K=m,e.$4K=u,e.$7K=v,e.$8K=E,e.$RK="workbench.editor.notebook",e.$SK="workbench.editor.notebookTextDiffEditor",e.$TK="workbench.editor.interactive";var D;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(D||(e.CellKind=D={})),e.$UK=["application/json","application/javascript","text/html","image/svg+xml",M.$Qs.latex,M.$Qs.markdown,"image/png","image/jpeg",M.$Qs.text],e.$VK=[M.$Qs.latex,M.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Qs.text],e.$WK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$XK="_notAvailable";var h;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var g;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(K){K.scheme=A.Schemas.vscodeNotebookCell;function ie(Te,ae){return(0,T.$NK)(Te,ae)}K.generate=ie;function ce(Te){return(0,T.$MK)(Te)}K.parse=ce;function ye(Te,ae){return Te.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${Te.scheme!==A.Schemas.file?Te.scheme:""}`})}K.generateCellOutputUri=ye;function Se(Te){if(Te.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Te.fragment);if(!ae)return;const Ne=ae[1]&&ae[1]!==""?ae[1]:void 0,ne=ae[2];return{outputId:Ne,notebook:Te.with({scheme:ne||A.Schemas.file,fragment:null})}}K.parseCellOutputUri=Se;function fe(Te,ae,Ne){return K.generate(Te,ae).with({scheme:Ne})}K.generateCellPropertyUri=fe;function $e(Te,ae){if(Te.scheme===ae)return K.parse(Te.with({scheme:K.scheme}))}K.parseCellPropertyUri=$e})(c||(e.CellUri=c={}));const l=K=>$.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$UK){this.e=ce,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:O.$qk(l(ye))}))}sort(ie){const ce=new Map(R.Iterable.map(ie,Se=>[Se,l(Se)]));let ye=[];for(const{matches:Se}of this.d)for(const[fe,$e]of ce)if(Se($e)){ye.push(fe),ce.delete(fe);break}return ce.size&&(ye=ye.concat([...ce.keys()].sort((Se,fe)=>this.e.indexOf(Se)-this.e.indexOf(fe)))),ye}prioritize(ie,ce){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:O.$qk(l(ie))});return}const Se=new Set(ce.map($e=>this.f($e,ye)));Se.delete(-1);const fe=Array.from(Se).sort();this.d.splice(ye+1,0,...fe.map($e=>this.d[$e]));for(let $e=fe.length-1;$e>=0;$e--)this.d.splice(fe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ye=l(ie);for(let Se=0;Se<ce;Se++)if(this.d[Se].matches(ye))return Se;return-1}}e.$YK=t;function f(K,ie,ce,ye=(Se,fe)=>Se===fe){const Se=[];function fe(ae,Ne,ne){if(Ne===0&&ne.length===0)return;const z=Se[Se.length-1];z&&z.start+z.deleteCount===ae?(z.deleteCount+=Ne,z.toInsert.push(...ne)):Se.push({start:ae,deleteCount:Ne,toInsert:ne})}let $e=0,Te=0;for(;;){if($e===K.length){fe($e,0,ie.slice(Te));break}if(Te===ie.length){fe($e,K.length-$e,[]);break}const ae=K[$e],Ne=ie[Te];if(ye(ae,Ne)){$e+=1,Te+=1;continue}ce(Ne)?(fe($e,1,[]),$e+=1):(fe($e,0,[Ne]),Te+=1)}return Se}e.$1K=new y.$Nj("notebookEditorCursorAtBoundary","none"),e.$2K=new y.$Nj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function m(K){const ie=K;return!!((typeof ie.include=="string"||O.$rk(ie.include))&&(typeof ie.exclude=="string"||O.$rk(ie.exclude)))}function u(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ye=m(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Se=m(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(O.$pk(ye,(0,p.$nc)(ce.fsPath).toLowerCase()))return!(Se&&O.$pk(Se,(0,p.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$5K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var C;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(C||(e.CellStatusbarAlignment=C={}));class b{static{this.d="notebook/"}static create(ie){return`${b.d}${ie}`}static parse(ie){if(ie.startsWith(b.d))return ie.substring(b.d.length)}}e.$6K=b;function v(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const d=new TextDecoder;function E(K){const ie=[];let ce=!1;for(const $e of K)(ie.length===0||ce)&&(ie.push($e),ce=!0);let ye=S(ie);const Se=I.$Fe.concat(ie.map($e=>I.$Fe.wrap($e))),fe=B(Se);return ye=ye||fe.byteLength!==Se.byteLength,{data:fe,didCompression:ye}}e.$9K="\x1B[A";const k=e.$9K.split("").map(K=>K.charCodeAt(0)),P=10;function S(K){let ie=!1;return K.forEach((ce,ye)=>{if(ye===0||ce.length<e.$9K.length)return;const Se=K[ye-1],fe=ce.subarray(0,e.$9K.length);if(fe[0]===k[0]&&fe[1]===k[1]&&fe[2]===k[2]){const $e=Se.lastIndexOf(P);if($e===-1)return;ie=!0,K[ye-1]=Se.subarray(0,$e),K[ye]=ce.subarray(e.$9K.length)}}),ie}function W(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,N=13;function B(K){return!K.buffer.includes(q)&&!K.buffer.includes(N)?K:I.$Fe.fromString(V(W(d.decode(K.buffer))))}}),define(Pe[7],Ie([1,0,18,14,55,28,70,13,15,2,34,20,38,104,85]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g){"use strict";var r,o,s,i,n,c,l,t,f,a,m,u,C,b,v,d,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$nP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$mP=e.$lP=e.$kP=e.$jP=e.ChatLocation=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$9O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$VO=e.$UO=e.$TO=e.$SO=e.$QO=e.$PO=e.$OO=e.$NO=e.TestRunProfileKind=e.TestResultState=e.$MO=e.$LO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$KO=e.NotebookVariablesRequestKind=e.$JO=e.$IO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$HO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.ColorThemeKind=e.$BO=e.$AO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$zO=e.$yO=e.DebugConsoleMode=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$sO=e.$rO=e.FileChangeType=e.$qO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$pO=e.$oO=e.$nO=e.$mO=e.InlineCompletionTriggerKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$_N=e.ConfigurationTarget=e.$$N=e.$0N=e.$9N=e.$8N=e.DocumentPasteTriggerKind=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1N=e.ViewBadge=e.ProgressLocation=e.$ZN=e.$YN=e.TaskScope=e.ShellQuoting=e.$XN=e.$WN=e.$VN=e.TaskPanelKind=e.TaskRevealKind=e.$UN=e.TerminalLocation=e.$TN=e.$SN=e.$RN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QN=e.$PN=e.$ON=e.$NN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$LN=e.$KN=e.$JN=e.$IN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HN=e.$GN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.LanguageStatusSeverity=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.CodeActionTriggerKind=e.$uN=e.$tN=e.SymbolTag=e.SymbolKind=e.$sN=e.$rN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.DiagnosticSeverity=e.DiagnosticTag=e.$lN=e.$kN=e.FileEditType=e.$jN=e.$iN=e.$hN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$MN=Vt,e.$aO=J,e.$RO=vn;function k(j){return Object.assign(j,{apply:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(j,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const[Ee,...Ke]=te;return Reflect.construct(j,Ke,Ee.constructor)}}})}var P;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var S;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(S||(e.TerminalQuickFixType=S={}));let W=r=class{static from(...L){let te=L;return new r(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$aN=W,e.$aN=W=r=Je([k],W);let V=o=class{static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof o)return!0;const{line:te,character:Ee}=L;return typeof te=="number"&&typeof Ee=="number"}static of(L){if(L instanceof o)return L;if(this.isPosition(L))return new o(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,te){if(L<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=L,this.e=te}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,te=0){if(L===null||te===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$bN=V,e.$bN=V=o=Je([k],V);let q=s=class{static isRange(L){return L instanceof s?!0:L?V.isPosition(L.start)&&V.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,te,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(L,te),lt=new V(Ee,Ke)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):V.isPosition(L)?!(V.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const te=V.Max(L.start,this.c),Ee=V.Min(L.end,this.e);if(!te.isAfter(Ee))return new s(te,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=V.Min(L.start,this.c),Ee=V.Max(L.end,this.end);return new s(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,te=this.end){if(L===null||te===null)throw(0,O.$7)();let Ee;return L?V.isPosition(L)?Ee=L:(Ee=L.start||this.start,te=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new s(Ee,te)}toJSON(){return[this.start,this.end]}};e.$cN=q,e.$cN=q=s=Je([k],q);let N=i=class extends q{static isSelection(L){return L instanceof i?!0:L?q.isRange(L)&&V.isPosition(L.anchor)&&V.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,te,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(L,te),lt=new V(Ee,Ke)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$dN=N,e.$dN=N=i=Je([k],N);const B=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,O.$7)("connectionToken")};class K{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te,Ee){if(typeof L!="string"||L.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof Ee<"u"&&B(Ee),this.host=L,this.port=Math.round(te),this.connectionToken=Ee}}e.$eN=K;class ie{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te){this.makeConnection=L,this.connectionToken=te,typeof te<"u"&&B(te)}}e.$fN=ie;class ce extends Error{static NotAvailable(L,te){return new ce(L,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new ce(L,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,te=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$gN=ce;var ye;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Se;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Se||(e.EnvironmentVariableMutatorType=Se={}));let fe=n=class{static isTextEdit(L){return L instanceof n?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new n(L,te)}static insert(L,te){return n.replace(new q(L,L),te)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const te=new n(new q(new V(0,0),new V(0,0)),"");return te.newEol=L,te}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,O.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,O.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,O.$7)("newEol");this.f=L}constructor(L,te){this.c=L,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$hN=fe,e.$hN=fe=n=Je([k],fe);let $e=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?mi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new c(L,te)}static insertCells(L,te){return new c(new mi(L,L),te)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,te){const Ee=new c(new mi(L,L),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(L){const te=new c(new mi(0,0),[]);return te.newNotebookMetadata=L,te}constructor(L,te){this.range=L,this.newCells=te}};e.$iN=$e,e.$iN=$e=c=Je([k],$e);class Te{static isSnippetTextEdit(L){return L instanceof Te?!0:L?q.isRange(L.range)&&ne.isSnippetString(L.snippet):!1}static replace(L,te){return new Te(L,te)}static insert(L,te){return Te.replace(new q(L,L),te)}constructor(L,te){this.range=L,this.snippet=te}}e.$jN=Te;var ae;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,te,Ee,Ke){this.c.push({_type:1,from:L,to:te,options:Ee,metadata:Ke})}createFile(L,te,Ee){this.c.push({_type:1,from:void 0,to:L,options:te,metadata:Ee})}deleteFile(L,te,Ee){this.c.push({_type:1,from:L,to:void 0,options:te,metadata:Ee})}e(L,te,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}f(L,te,Ee,Ke){const Ye=te.start,lt=te.end;(Ye!==lt||Ee.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:lt-Ye,cells:Ee,metadata:Ke})}g(L,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:L,edit:{editType:3,index:te,metadata:Ee}})}replace(L,te,Ee,Ke){this.c.push({_type:2,uri:L,edit:new fe(te,Ee),metadata:Ke})}insert(L,te,Ee,Ke){this.replace(L,new q(te,te),Ee,Ke)}delete(L,te,Ee){this.replace(L,te,"",Ee)}has(L){return this.c.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,Ye;Array.isArray(Ee)?(Ke=Ee[0],Ye=Ee[1]):Ke=Ee,$e.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(L,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(L,Ke.newNotebookMetadata,Ye):this.f(L,Ke.range,Ke.newCells,Ye):Te.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:L,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:Ke,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,I.$Ib)(this.c)}}get(L){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&te.push(Ee.edit);return te}entries(){const L=new M.$Ac;for(const te of this.c)if(te._type===2){let Ee=L.get(te.uri);Ee||(Ee=[te.uri,[]],L.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$kN=Ne,e.$kN=Ne=Je([k],Ne);let ne=l=class{static isSnippetString(L){return L instanceof l?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=l.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this.e++){if(typeof L=="function"){const Ee=new l;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=l.c(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this.e++){const Ee=L.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ee=new l;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$lN=ne,e.$lN=ne=l=Je([k],ne);var z;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var x;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let be=t=class{static isLocation(L){return L instanceof t?!0:L?q.isRange(L.range)&&y.URI.isUri(L.uri):!1}constructor(L,te){if(this.uri=L,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$mN=be,e.$mN=be=t=Je([k],be);let Fe=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&y.URI.isUri(L.location.uri):!1}constructor(L,te){this.location=L,this.message=te}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};e.$nN=Fe,e.$nN=Fe=Je([k],Fe);let De=class{constructor(L,te,Ee=x.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,I.$ub)(L.tags,te.tags)&&(0,I.$ub)(L.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$oN=De,e.$oN=De=Je([k],De);let pe=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};e.$pN=pe,e.$pN=pe=Je([k],pe);let ge=class extends pe{constructor(L,te,Ee,Ke){super(L,te),this.canIncreaseHover=Ee,this.canDecreaseHover=Ke}};e.$qN=ge,e.$qN=ge=Je([k],ge);var Q;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(L,te=Y.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$rN=he,e.$rN=he=Je([k],he);let ue=class{constructor(L,te){this.uri=L,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$sN=ue,e.$sN=ue=Je([k],ue);var Me;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var de;(function(j){j[j.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ce=f=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,te,Ee,Ke,Ye){this.name=L,this.kind=te,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof be?this.location=Ke:Ee instanceof q&&(this.location=new be(Ke,Ee)),f.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$tN=Ce,e.$tN=Ce=f=Je([k],Ce);let Ae=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,te,Ee,Ke,Ye){this.name=L,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$uN=Ae,e.$uN=Ae=a=Je([k],Ae);var je;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let U=class{constructor(L,te){this.title=L,this.kind=te}};e.$vN=U,e.$vN=U=Je([k],U);let F=class{static{m=this}static{this.c="."}constructor(L){this.value=L}append(L){return new m(this.value?this.value+m.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+m.c)}};e.$wN=F,e.$wN=F=m=Je([k],F),F.Empty=new F(""),F.QuickFix=F.Empty.append("quickfix"),F.Refactor=F.Empty.append("refactor"),F.RefactorExtract=F.Refactor.append("extract"),F.RefactorInline=F.Refactor.append("inline"),F.RefactorMove=F.Refactor.append("move"),F.RefactorRewrite=F.Refactor.append("rewrite"),F.Source=F.Empty.append("source"),F.SourceOrganizeImports=F.Source.append("organizeImports"),F.SourceFixAll=F.Source.append("fixAll"),F.Notebook=F.Empty.append("notebook");let G=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xN=G,e.$xN=G=Je([k],G);class H{constructor(L,te,Ee,Ke,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$yN=H;class ee{constructor(L,te){this.fromRanges=te,this.from=L}}e.$zN=ee;class re{constructor(L,te){this.fromRanges=te,this.to=L}}e.$AN=re;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Ve=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};e.$BN=Ve,e.$BN=Ve=Je([k],Ve);let Ge=u=class{#e;static isMarkdownString(L){return L instanceof u?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,te=!1){this.#e=new R.$Tk(L,{supportThemeIcons:te})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,te){return this.#e.appendCodeblock(te??"",L),this}};e.$CN=Ge,e.$CN=Ge=u=Je([k],Ge);let _e=class{constructor(L,te){this.label=L,this.documentation=te}};e.$DN=_e,e.$DN=_e=Je([k],_e);let xe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};e.$EN=xe,e.$EN=xe=Je([k],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FN=et,e.$FN=et=Je([k],et);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let at=class{constructor(L){this.value=L}};e.$GN=at,e.$GN=at=Je([k],at);let gt=class{constructor(L,te,Ee){this.position=L,this.label=te,this.kind=Ee}};e.$HN=gt,e.$HN=gt=Je([k],gt);var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var st;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(st||(e.CompletionItemKind=st={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let X=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IN=X,e.$IN=X=Je([k],X);let me=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};e.$JN=me,e.$JN=me=Je([k],me);let qe=class{constructor(L,te,Ee){this.insertText=L,this.range=te,this.command=Ee}};e.$KN=qe,e.$KN=qe=Je([k],qe);let we=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$LN=we,e.$LN=we=Je([k],we);var ot;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(ot||(e.PartialAcceptTriggerKind=ot={}));var dt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Rt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Rt||(e.StatusBarAlignment=Rt={}));function Vt(j,L){return`${D.$Rm.toKey(j)}.${L}`}var Qt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ri;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ri||(e.TextDocumentSaveReason=ri={}));var Xt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var Dt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var Zt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Yt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(j){function L(te){switch(te){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var Ze;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(j){function L(te){switch(te){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(Ze||(e.SyntaxTokenType=Ze={}));let ai=class{constructor(L,te){if(te&&!y.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.target=te}};e.$NN=ai,e.$NN=ai=Je([k],ai);let Ht=class{constructor(L,te,Ee,Ke){this.red=L,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$ON=Ht,e.$ON=Ht=Je([k],Ht);let ht=class{constructor(L,te){if(te&&!(te instanceof Ht))throw(0,O.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.color=te}};e.$PN=ht,e.$PN=ht=Je([k],ht);let mt=class{constructor(L){if(!L||typeof L!="string")throw(0,O.$7)("label");this.label=L}};e.$QN=mt,e.$QN=mt=Je([k],mt);var xt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Kt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Ft;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var ft;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class jt{constructor(L,te,Ee){if(this.startIndex=L,this.length=te,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,O.$7)("tooltip")}}e.$RN=jt;class _t{constructor(L){this.uri=L}}e.$SN=_t;class Ut{constructor(L){this.terminalCommand=L}}e.$TN=Ut;var Qe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class hi{constructor(L){if(this.options=L,typeof L!="object")throw(0,O.$7)("options")}}e.$UN=hi;var Jt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var Wt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Wt||(e.TaskPanelKind=Wt={}));let pt=class{static{C=this}static{this.Clean=new C("clean","Clean")}static{this.Build=new C("build","Build")}static{this.Rebuild=new C("rebuild","Rebuild")}static{this.Test=new C("test","Test")}static from(L){switch(L){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=L}get id(){return this.c}};e.$VN=pt,e.$VN=pt=C=Je([k],pt);function Lt(j){let L="";for(let te=0;te<j.length;te++)L+=j[te].replace(/,/g,",,")+",";return L}let Ot=class{constructor(L,te,Ee){if(typeof L!="string")throw(0,O.$7)("process");this.e=[],this.c=L,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,O.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const te of this.e)L.push(te);return Lt(L)}};e.$WN=Ot,e.$WN=Ot=Je([k],Ot);let Mt=class{constructor(L,te,Ee){if(this.f=[],Array.isArray(te)){if(!L)throw(0,O.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L,this.f=te,this.g=Ee}else{if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L,this.g=te}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)L.push(typeof te=="string"?te:te.value);return Lt(L)}};e.$XN=Mt,e.$XN=Mt=Je([k],Mt);var si;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(si||(e.ShellQuoting=si={}));var qt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(qt||(e.TaskScope=qt={}));class oi{constructor(L){this.c=L}computeId(){return"customExecution"+(0,T.$Sg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$YN=oi;let At=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,te,Ee,Ke,Ye,lt){this.k=!1,this.l=this.definition=L;let wt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,wt=Ye,this.k=!0):te===qt.Global||te===qt.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,wt=lt):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,wt=lt),typeof wt=="string"?(this.r=[wt],this.t=!0):Array.isArray(wt)?(this.r=wt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ot?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,T.$Sg)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,O.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const te=this.l.type;(b.g===te||b.e===te||b.f===te||b.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$ZN=At,e.$ZN=At=b=Je([k],At);var Tt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Tt||(e.ProgressLocation=Tt={}));var zt;(function(j){function L(te){const Ee=te;return(0,$.$ag)(Ee.value)?Ee.tooltip&&!(0,$.$9f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}j.isViewBadge=L})(zt||(e.ViewBadge=zt={}));let Pt=v=class{static isTreeItem(L,te){const Ee=L;if(Ee.checkboxState!==void 0){const Ke=(0,$.$ag)(Ee.checkboxState)?Ee.checkboxState:(0,$.$$f)(Ee.checkboxState)&&(0,$.$ag)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,$.$ag)(Ee.checkboxState)&&(0,$.$$f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||Ye!==void 0&&!(0,$.$9f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof v)return!0;if(Ee.label!==void 0&&!(0,$.$9f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,$.$9f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,$.$9f)(Ee.iconPath)&&!y.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,$.$9f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,$.$9f)(Ke.light)&&!y.URI.isUri(Ke.light)&&!(0,$.$9f)(Ke.dark)&&!y.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,$.$9f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!y.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,$.$9f)(Ee.tooltip)&&!(Ee.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<$t.None&&Ee.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,$.$9f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,te=$t.None){this.collapsibleState=te,y.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$1N=Pt,e.$1N=Pt=v=Je([k],Pt);var $t;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Et;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let ci=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$2N=ci,e.$2N=ci=Je([k],ci);class kt extends ci{}e.$3N=kt;class gi extends kt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$4N=gi;class ei{constructor(L,te,Ee,Ke){this.name=L,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$5N=ei;let wi=class{#e=new Map;constructor(L){for(const[te,Ee]of L??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,te){this.#e.set(this.#t(L),[te])}forEach(L,te){for(const[Ee,Ke]of this.#e)for(const Ye of Ke)L.call(te,Ye,Ee,this)}*[Symbol.iterator](){for(const[L,te]of this.#e)for(const Ee of te)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$6N=wi,e.$6N=wi=Je([k],wi);let ui=class{constructor(L,te,Ee){this.insertText=L,this.title=te,this.kind=Ee}};e.$7N=ui,e.$7N=ui=Je([k],ui);var bi;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(bi||(e.DocumentPasteTriggerKind=bi={}));class It{static{this.c="."}constructor(L){this.value=L}append(...L){return new It((this.value?[this.value,...L]:L).join(It.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+It.c)}}e.$8N=It,It.Empty=new It("");class Di{constructor(L,te,Ee){this.title=te,this.insertText=L,this.kind=Ee}}e.$9N=Di;let ti=class{constructor(L,te){this.id=L,this.color=te}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$0N=ti,e.$0N=ti=Je([k],ti),ti.File=new ti("file"),ti.Folder=new ti("folder");let St=class{constructor(L){this.id=L}};e.$$N=St,e.$$N=St=Je([k],St);var ve;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ve||(e.ConfigurationTarget=ve={}));let Re=class{get base(){return this.c}set base(L){this.c=L,this.e=y.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,te){if(typeof L!="string"&&(!L||!y.URI.isUri(L)&&!y.URI.isUri(L.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof L=="string"?this.baseUri=y.URI.file(L):y.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$_N=Re,e.$_N=Re=Je([k],Re);const se=new WeakMap;function J(j,L){se.set(j,L)}let ke=class{constructor(L,te,Ee,Ke,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=se.get(this)??(0,T.$Sg)()),this.c}};e.$bO=ke,e.$bO=ke=Je([k],ke);let Be=class extends ke{constructor(L,te,Ee,Ke,Ye,lt){if(super(te,Ee,Ke,Ye,lt),L===null)throw(0,O.$7)("location");this.location=L}};e.$cO=Be,e.$cO=Be=Je([k],Be);let Xe=class extends ke{constructor(L,te,Ee,Ke,Ye,lt){super(te,Ee,Ke,Ye,lt),this.functionName=L}};e.$dO=Xe,e.$dO=Xe=Je([k],Xe);let He=class extends ke{constructor(L,te,Ee,Ke,Ye,lt,wt,Gt){if(super(Ke,Ye,lt,wt,Gt),!te)throw(0,O.$7)("dataId");this.label=L,this.dataId=te,this.canPersist=Ee}};e.$eO=He,e.$eO=He=Je([k],He);let ut=class{constructor(L,te,Ee){this.command=L,this.args=te||[],this.options=Ee}};e.$fO=ut,e.$fO=ut=Je([k],ut);let yt=class{constructor(L,te){this.port=L,this.host=te}};e.$gO=yt,e.$gO=yt=Je([k],yt);let ct=class{constructor(L){this.path=L}};e.$hO=ct,e.$hO=ct=Je([k],ct);let ii=class{constructor(L){this.implementation=L}};e.$iO=ii,e.$iO=ii=Je([k],ii);class Ct{constructor(L,te,Ee){this.session=L,this.threadId=te,this.frameId=Ee}}e.$jO=Ct;class Bt{constructor(L,te){this.session=L,this.threadId=te}}e.$kO=Bt;let ki=class{constructor(L,te){this.range=L,this.expression=te}};e.$lO=ki,e.$lO=ki=Je([k],ki);var Ki;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ki||(e.InlineCompletionTriggerKind=Ki={}));let Oi=class{constructor(L,te){this.range=L,this.text=te}};e.$mO=Oi,e.$mO=Oi=Je([k],Oi);let Mi=class{constructor(L,te,Ee=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$nO=Mi,e.$nO=Mi=Je([k],Mi);let Si=class{constructor(L,te){this.range=L,this.expression=te}};e.$oO=Si,e.$oO=Si=Je([k],Si);let Ti=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};e.$pO=Ti,e.$pO=Ti=Je([k],Ti);var Fi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Fi||(e.NewSymbolNameTag=Fi={}));var Ji;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ji||(e.NewSymbolNameTriggerKind=Ji={}));class Li{constructor(L,te){this.newSymbolName=L,this.tags=te}}e.$qO=Li;var Pi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let zi=d=class extends Error{static FileExists(L){return new d(L,h.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(L){return new d(L,h.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(L){return new d(L,h.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(L){return new d(L,h.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(L){return new d(L,h.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(L){return new d(L,h.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(L,te=h.FileSystemProviderErrorCode.Unknown,Ee){super(y.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,h.$fl)(this,te),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$rO=zi,e.$rO=zi=d=Je([k],zi);let Ui=class{constructor(L,te,Ee){this.start=L,this.end=te,this.kind=Ee}};e.$sO=Ui,e.$sO=Ui=Je([k],Ui);var vi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Qi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Qi||(e.CommentThreadCollapsibleState=Qi={}));var Xi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Zi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var Ii;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Ii||(e.CommentThreadState=Ii={}));var Yi;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(Yi||(e.CommentThreadApplicability=Yi={}));class xi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.$tO=xi;function dn(j){return typeof j>"u"||(0,$.$0f)(j)}class Ci{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let te=0,Ee=L.tokenTypes.length;te<Ee;te++)this.k.set(L.tokenTypes[te],te);for(let te=0,Ee=L.tokenModifiers.length;te<Ee;te++)this.l.set(L.tokenModifiers[te],te)}}push(L,te,Ee,Ke,Ye){if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(L,te,Ee,Ke,Ye);if(q.isRange(L)&&typeof te=="string"&&dn(Ee))return this.o(L,te,Ee);throw(0,O.$7)()}o(L,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,Ye=L.start.character,lt=L.end.character-L.start.character,wt=this.k.get(te);let Gt=0;if(Ee)for(const li of Ee){if(!this.l.has(li))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(li);Gt|=1<<fi>>>0}this.q(Ke,Ye,lt,wt,Gt)}q(L,te,Ee,Ke,Ye){if(this.f&&(L<this.c||L===this.c&&te<this.e)){this.f=!1;const Gt=this.g.length/5|0;let li=0,fi=0;for(let $i=0;$i<Gt;$i++){let pi=this.g[5*$i],Gi=this.g[5*$i+1];pi===0?(pi=li,Gi+=fi):pi+=li,this.g[5*$i]=pi,this.g[5*$i+1]=Gi,li=pi,fi=Gi}}let lt=L,wt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(wt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=wt,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=L,this.e=te}static r(L){const te=[],Ee=L.length/5|0;for(let wt=0;wt<Ee;wt++)te[wt]=wt;te.sort((wt,Gt)=>{const li=L[5*wt],fi=L[5*Gt];if(li===fi){const $i=L[5*wt+1],pi=L[5*Gt+1];return $i-pi}return li-fi});const Ke=new Uint32Array(L.length);let Ye=0,lt=0;for(let wt=0;wt<Ee;wt++){const Gt=5*te[wt],li=L[Gt+0],fi=L[Gt+1],$i=L[Gt+2],pi=L[Gt+3],Gi=L[Gt+4],Fn=li-Ye,gr=Fn===0?fi-lt:fi,Hi=5*wt;Ke[Hi+0]=Fn,Ke[Hi+1]=gr,Ke[Hi+2]=$i,Ke[Hi+3]=pi,Ke[Hi+4]=Gi,Ye=li,lt=fi}return Ke}build(L){return this.f?new ji(new Uint32Array(this.g),L):new ji(Ci.r(this.g),L)}}e.$uO=Ci;class ji{constructor(L,te){this.resultId=te,this.data=L}}e.$vO=ji;class fn{constructor(L,te,Ee){this.start=L,this.deleteCount=te,this.data=Ee}}e.$wO=fn;class gn{constructor(L,te){this.resultId=te,this.edits=L}}e.$xO=gn;var _i;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Bi{constructor(L){this.name=L}}e.$yO=Bi;let Ri=class{static{this.Back={iconPath:new ti("arrow-left")}}constructor(){}};e.$zO=Ri,e.$zO=Ri=Je([k],Ri);var ze;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var di;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(di||(e.InputBoxValidationSeverity=di={}));var Vi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Vi||(e.ExtensionKind=Vi={}));class nt{static validate(L){if(typeof L.badge=="string"){let te=(0,p.$Hf)(L.badge,0);if(te<L.badge.length&&(te+=(0,p.$Hf)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!ti.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,te,Ee){this.badge=L,this.tooltip=te,this.color=Ee}}e.$AO=nt;let bt=class{constructor(L){this.kind=L}};e.$BO=bt,e.$BO=bt=Je([k],bt);var en;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class mi{static isNotebookRange(L){return L instanceof mi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,te){if(L<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");L<=te?(this.c=L,this.e=te):(this.c=te,this.e=L)}with(L){let te=this.c,Ee=this.e;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ee=L.end),te===this.c&&Ee===this.e?this:new mi(te,Ee)}}e.$CO=mi;class yi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>yi.isNotebookCellData(te))}static isNotebookCellData(L){return!0}constructor(L,te,Ee,Ke,Ye,lt,wt){this.kind=L,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=wt,yi.validate(this)}}e.$DO=yi;class mn{constructor(L){this.cells=L}}e.$EO=mn;class ni{static isNotebookCellOutputItem(L){return L instanceof ni?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return ni.json(te,"application/vnd.code.notebook.error")}static stdout(L){return ni.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ni.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new ni(L,te)}static#e=new TextEncoder;static text(L,te=A.$Qs.text){const Ee=ni.#e.encode(String(L));return new ni(Ee,te)}static json(L,te="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return ni.text(Ee,te)}constructor(L,te){this.data=L,this.mime=te;const Ee=(0,A.$Us)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$FO=ni;class Ai{static isNotebookCellOutput(L){return L instanceof Ai?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ee=new Set,Ke=new Set;for(let Ye=0;Ye<L.length;Ye++){const lt=L[Ye],wt=(0,A.$Us)(lt.mime);if(!Ee.has(wt)||(0,g.$7K)(wt)){Ee.add(wt);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?L:L.filter((Ye,lt)=>!Ke.has(lt))}constructor(L,te,Ee){this.items=Ai.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,T.$Sg)(),this.metadata=te??Ee)}}e.$GO=Ai;var tn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Wi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Wi||(e.NotebookCellStatusBarAlignment=Wi={}));var rn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class $n{constructor(L,te){this.text=L,this.alignment=te}}e.$HO=$n;var sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(L,te=[]){this.uri=L,this.provides=(0,I.$2b)(te)}}e.$IO=pn;class wn{constructor(L){this.label=L}}e.$JO=wn;var an;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let qi=class{constructor(L,te){this.label=L,this.timestamp=te}};e.$KO=qi,e.$KO=qi=Je([k],qi);var cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.$LO=_;class oe{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$MO=oe;var Le;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var rt;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(rt||(e.TestRunProfileKind=rt={}));let vt=class{constructor(L=void 0,te=void 0,Ee=void 0,Ke=!1,Ye=!0){this.include=L,this.exclude=te,this.profile=Ee,this.continuous=Ke,this.preserveFocus=Ye}};e.$NO=vt,e.$NO=vt=Je([k],vt);let Nt=E=class{static diff(L,te,Ee){const Ke=new E(L);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(L){this.message=L}};e.$OO=Nt,e.$OO=Nt=E=Je([k],Nt);let Ei=class{constructor(L){this.id=L}};e.$PO=Ei,e.$PO=Ei=Je([k],Ei);class hn{constructor(L,te){this.covered=L,this.total=te,vn(this)}}e.$QO=hn;function vn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class bn{static fromDetails(L,te){const Ee=new hn(0,0),Ke=new hn(0,0),Ye=new hn(0,0);for(const wt of te)if("branches"in wt){Ee.total+=1,Ee.covered+=wt.executed?1:0;for(const Gt of wt.branches)Ke.total+=1,Ke.covered+=Gt.executed?1:0}else Ye.total+=1,Ye.covered+=wt.executed?1:0;const lt=new bn(L,Ee,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(L,te,Ee,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke}}e.$SO=bn;class Ln{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee=[]){this.executed=L,this.location=te,this.branches=Ee}}e.$TO=Ln;class zn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.executed=L,this.location=te,this.label=Ee}}e.$UO=zn;class Un{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.name=L,this.executed=te,this.location=Ee}}e.$VO=Un;var yn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var En;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(En||(e.WorkspaceTrustState=En={}));var Dn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class jn{constructor(L,te,Ee,Ke,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$WO=jn;class Bn{constructor(L){this.uri=L}}e.$XO=Bn;class Vn{constructor(L,te){this.original=L,this.modified=te}}e.$YO=Vn;class Wn{constructor(L,te,Ee,Ke){this.base=L,this.input1=te,this.input2=Ee,this.result=Ke}}e.$ZO=Wn;class qn{constructor(L,te){this.uri=L,this.viewType=te}}e.$1O=qn;class Gn{constructor(L){this.viewType=L}}e.$2O=Gn;class Hn{constructor(L,te){this.uri=L,this.notebookType=te}}e.$3O=Hn;class Kn{constructor(L,te,Ee){this.original=L,this.modified=te,this.notebookType=Ee}}e.$4O=Kn;class Jn{constructor(){}}e.$5O=Jn;class Qn{constructor(L,te){this.uri=L,this.inputBoxUri=te}}e.$6O=Qn;class Xn{constructor(){}}e.$7O=Xn;class Zn{constructor(L){this.textDiffs=L}}e.$8O=Zn;var kn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var Pn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class Yn{constructor(L,te){this.label=L,this.values=te}}e.$9O=Yn;var In;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class xn{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ge(L):L}}e.$0O=xn;class _n{constructor(L,te){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ge(L):L,this.vulnerabilities=te}}e.$$O=_n;class er{constructor(L,te){this.participant=L,this.command=te}}e.$_O=er;class tr{constructor(L,te){this.value=L,this.baseUri=te}}e.$aP=tr;class ir{constructor(L,te){this.value=L,this.title=te}}e.$bP=ir;class nr{constructor(L){this.value=L}}e.$cP=nr;class rr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ge(L):L}}e.$dP=rr;class sr{constructor(L){this.value=L}}e.$eP=sr;class or{constructor(L,te){this.value=L,this.iconPath=te}}e.$fP=or;class ar{constructor(L,te){this.uri=L,this.edits=Array.isArray(te)?te:[te]}}e.$gP=ar;class cr{constructor(L,te,Ee,Ke){this.prompt=L,this.command=te,this.variables=Ee,this.participant=Ke}}e.$hP=cr;class ur{constructor(L,te,Ee,Ke){this.response=L,this.result=te,this.participant=Ee,this.command=Ke}}e.$iP=ur;var Rn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Rn||(e.ChatLocation=Rn={}));class lr{constructor(L){this.content=L}}e.$jP=lr;class hr{constructor(L,te){this.content=L,this.name=te}}e.$kP=hr;class dr{constructor(L,te){this.content=L,this.name=te}}e.$lP=dr;class Ni extends Error{static NotFound(L){return new Ni(L,Ni.NotFound.name)}static NoPermissions(L){return new Ni(L,Ni.NoPermissions.name)}constructor(L,te,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$mP=Ni;var An;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Nn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Nn||(e.SpeechToTextStatus=Nn={}));var On;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(On||(e.TextToSpeechStatus=On={}));var Mn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class fr{constructor(L,te){this.text=L,this.range=te}}e.$nP=fr;var Tn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Tn||(e.InlineEditTriggerKind=Tn={}))}),define(Pe[257],Ie([1,0,4,7]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$$M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(A);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(p,$)??[]}getRelatedInformation(A,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(A,p,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,p),new O.$aN(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$ilc=R}),define(Pe[86],Ie([1,0,5,4,7,20,108,3,17]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0,e.$tlc=(0,p.$wi)("IExtHostAuthentication");let y=class{constructor(h){this.b=new Map,this.c=new I.$de,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=h.getProxy(O.$$M.MainThreadAuthentication)}async getSession(h,w,g,r={}){const o=M.$Rm.toKey(h.identifier),s=[...g].sort().join(" ");return await this.d.getOrCreate(`${o} ${w} ${s}`,async()=>{await this.a.$ensureProvider(w);const i=h.displayName||h.name;return this.a.$getSession(w,g,o,i,r)})}async getSessions(h,w,g){const r=M.$Rm.toKey(h.identifier),o=[...g].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(w);const s=h.displayName||h.name;return this.a.$getSessions(w,g,r,s)})}async removeSession(h,w){const g=this.b.get(h);return g?g.provider.removeSession(w):this.a.$removeSession(h,w)}registerAuthenticationProvider(h,w,g,r){if(this.b.get(h))throw new Error(`An authentication provider with id '${h}' is already registered.`);this.b.set(h,{label:w,provider:g,options:r??{supportsMultipleAccounts:!1}});const o=g.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(h,s));return this.a.$registerAuthenticationProvider(h,w,r?.supportsMultipleAccounts??!1),new R.$aN(()=>{o.dispose(),this.b.delete(h),this.a.$unregisterAuthenticationProvider(h)})}async $createSession(h,w,g){const r=this.b.get(h);if(r)return await r.provider.createSession(w,g);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $removeSession(h,w){const g=this.b.get(h);if(g)return await g.provider.removeSession(w);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $getSessions(h,w){const g=this.b.get(h);if(g)return await g.provider.getSessions(w);throw new Error(`Unable to find authentication provider with handle: ${h}`)}$onDidChangeAuthenticationSessions(h,w){return h.startsWith(A.$aM)||this.c.fire({provider:{id:h,label:w}}),Promise.resolve()}};e.$ulc=y,e.$ulc=y=Je([We(0,$.$zP)],y);class T{constructor(){this.a=new Map}getOrCreate(h,w){const g=this.a.get(h);if(g)return g;const r=w().finally(()=>this.a.delete(h));return this.a.set(h,r),r}}}),define(Pe[112],Ie([1,0,2,4,7,3,17,12,18,13,19,26]),function(le,e,I,O,R,M,A,p,$,y,T,D){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0;let w=class{static{h=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(O.$$M.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=h.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const c=(0,$.$2b)(n);if(c.length<=h.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const l=c.map(a=>({uri:a,rank:(0,y.$af)(a.path,"/")})),t=(0,$.$zb)(l,(a,m)=>a.rank-m.rank||(0,y.$qf)(a.uri.path,m.uri.path)),f=[];e:for(const a of t){let m;for(const u of a){const C=(0,T.$mc)(u.uri.path);if(m!==C&&(m=C,f.push(u.uri)>=h.d))break e}}this.g.$onDidChange(s,f)});return new R.$aN(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async l=>{try{const{uri:t,id:f}=l,a=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!a)return;try{R.$AO.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$PG)(c,"codiconDecoration"),i[f]=[a.propagate,a.tooltip,a.badge,a.color]}catch(m){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${m}`)}}catch(t){this.h.error(t)}})),i}};e.$tmc=w,e.$tmc=w=h=Je([We(0,A.$zP),We(1,p.$3j)],w),e.$umc=(0,M.$wi)("IExtHostDecorations")}),define(Pe[258],Ie([1,0,14,2,7,4,16,24,13]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class y{static{this.a=0}constructor(D,h,w){this.d=h,this.e=w,this.b=new Map,this.c=D.getProxy(M.$$M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,h){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const w=y.a++;this.b.set(w,h),this.c.$registerTextContentProvider(w,D);let g;if(typeof h.onDidChange=="function"){let r;g=h.onDidChange(async o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(w,o).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(o);if(!n)return;const c=(0,$.$kf)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(o,i)}).catch(I.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new R.$aN(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,h){const w=this.b.get(D);return w?Promise.resolve(w.provideTextDocumentContent(O.URI.revive(h),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.$wmc=y}),define(Pe[113],Ie([1,0,57,16,13,313,159,7,18]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0,e.$BP=T;const y=new Map;function T(g,r){r?y.set(g,r):y.delete(g)}function D(g){return y.get(g)}class h extends M.$6v{constructor(r,o,s,i,n,c,l){super(o,s,i,n),this.c=r,this.m=c,this.q=l,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,$.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===O.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,I.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,I.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,i=o.start.line,n=o.end.line,c=[];c.push(this.f[i].substring(o.start.character));for(let l=i+1;l<n;l++)c.push(this.f[l]);return c.push(this.f[n].substring(0,o.end.character)),c.join(s)}t(r){let o;if(r instanceof p.$bN?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new p.$bN(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof p.$cN))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new p.$cN(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof p.$bN))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,i=!1;if(o<0)o=0,s=0,i=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,i=!0;else{const n=this.f[o].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new p.$bN(o,s):r}y(r,o){const s=this.x(r);if(!o)o=D(this.m);else if((0,R.$jf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const i=(0,A.$9s)(s.character+1,(0,A.$7s)(o),this.f[s.line],0);if(i)return new p.$cN(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$CP=h;class w{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$cN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$cN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DP=w}),define(Pe[259],Ie([1,0,4,7]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$$M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(A);if(!y)throw new Error("Embedding vector provider not found");const T=await y.provideEmbeddingVector(p,$);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(A,p,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(p,y),new O.$aN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$ymc=R}),define(Pe[65],Ie([1,0,4,38,7,21,3,17,46,6,11,23,16]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0;let g=w=class{constructor(o,s){this.b=new Map,this.c=new T.$Fh,this.a=o.getProxy(I.$$M.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const l=i.b.get(n.scheme);return l?(await i.a.$ensureActivation(n.scheme),c=await l.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return w.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return w.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return w.e(c)}},async writeFile(n,c){try{const l=i.b.get(n.scheme);return l&&!l.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(l.impl,l.extUri,l.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(l.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,M.$Fe.wrap(c))}catch(l){return w.e(l)}},async delete(n,c){try{const l=i.b.get(n.scheme);return l&&!l.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await l.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(l){return w.e(l)}},async rename(n,c,l){try{return await i.a.$rename(n,c,{overwrite:!1,...l})}catch(t){return w.e(t)}},async copy(n,c,l){try{return await i.a.$copy(n,c,{overwrite:!1,...l})}catch(t){return w.e(t)}},isWritableFileSystem(n){const c=s.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(o,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await o.stat(i)).type&O.FileType.Directory))throw R.$rO.FileExists(`Unable to create folder '${i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$gl(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(s.basename(i)),i=s.dirname(i)}for(let c=n.length-1;c>=0;c--){i=s.joinPath(i,n[c]);try{await o.createDirectory(i)}catch(l){if(O.$gl(l)!==O.FileSystemProviderErrorCode.FileExists)throw l}}}static e(o){if(o instanceof R.$rO)throw o;if(o instanceof O.$cl)switch(o.code){case O.FileSystemProviderErrorCode.FileExists:throw R.$rO.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$rO.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$rO.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$rO.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$rO.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$rO.Unavailable(o.message);default:throw new R.$rO(o.message,o.name)}if(!(o instanceof Error))throw new R.$rO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$rO.Unavailable(o.message);switch(o.name){case O.FileSystemProviderErrorCode.FileExists:throw R.$rO.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$rO.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$rO.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$rO.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$rO.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$rO.Unavailable(o.message);default:throw new R.$rO(o.message,o.name)}}addFileSystemProvider(o,s,i){return this.b.set(o,{impl:s,extUri:i?.isCaseSensitive?D.$Zg:D.$2g,isReadonly:!!i?.isReadonly}),(0,y.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??D.$Zg}};e.$Jlc=g,e.$Jlc=g=w=Je([We(0,p.$zP),We(1,$.$nlc)],g),e.$Klc=(0,A.$wi)("IExtHostConsumerFileSystem")}),define(Pe[87],Ie([1,0,3,27,12,65,2]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0,e.$Llc=(0,I.$wi)("IExtensionStoragePaths");let p=class{constructor(y,T,D){this.d=T,this.f=D,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(y){return A.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,T=await this.g(y);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(A.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(y){if(this.c)return A.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return A.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Mlc=p,e.$Mlc=p=Je([We(0,O.$PP),We(1,R.$3j),We(2,M.$Klc)],p)}),define(Pe[260],Ie([1,0,7,17,5]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;let M=class{constructor(p){this.a=new I.$BO(I.ColorThemeKind.Dark),this.b=new R.$de}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=I.ColorThemeKind.Light;break;case"hcDark":$=I.ColorThemeKind.HighContrast;break;case"hcLight":$=I.ColorThemeKind.HighContrastLight;break;default:$=I.ColorThemeKind.Dark}this.a=new I.$BO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$hnc=M,e.$hnc=M=Je([We(0,O.$zP)],M)}),define(Pe[88],Ie([1,0,24,5,6,182,3,12,211,4,27,17,7]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tDb=e.$sDb=e.TunnelDtoConverter=void 0;class w extends $.$sw{}var g;(function(o){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=i})(g||(e.TunnelDtoConverter=g={})),e.$sDb=(0,A.$wi)("IExtHostTunnelService");let r=class extends R.$Uc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$de,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$$M.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const c=new w(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new h.$aN(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,c,l){const t=[];for(const a of s){const m=this.r.get(a);if(!m)return[];t.push(...await Promise.all(i.map(async u=>{let C;try{C=await m.provider.providePortAttributes({port:u,pid:n,commandLine:c},l)}catch{C=await m.provider.providePortAttributes(u,n,c,l)}return{providedAttributes:C,port:u}})))}const f=t.filter(a=>!!a.providedAttributes);return f.length>0?f.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,l)=>await s.provideTunnel(c,l,I.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const l=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:l}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),n=s.filter((c,l)=>i[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$tDb=r,e.$tDb=r=Je([We(0,D.$zP),We(1,T.$PP),We(2,p.$3j)],r)}),define(Pe[8],Ie([1,0,18,21,138,261,55,28,127,49,70,25,133,23,15,2,30,89,101,107,106,224,85,52,62,235,7,36]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f,a,m,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$wP=K,e.$xP=ce,e.$yP=ye;var b;(function(ve){function Re(J){const{selectionStartLineNumber:ke,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:He}=J,ut=new u.$bN(ke-1,Be-1),yt=new u.$bN(Xe-1,He-1);return new u.$dN(ut,yt)}ve.to=Re;function se(J){const{anchor:ke,active:Be}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}ve.from=se})(b||(e.Selection=b={}));var v;(function(ve){function Re(J){if(!J)return;const{start:ke,end:Be}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}ve.from=Re;function se(J){if(!J)return;const{startLineNumber:ke,startColumn:Be,endLineNumber:Xe,endColumn:He}=J;return new u.$cN(ke-1,Be-1,Xe-1,He-1)}ve.to=se})(v||(e.Range=v={}));var d;(function(ve){function Re(J){return{uri:J.uri,range:v.from(J.range)}}ve.from=Re;function se(J){return new u.$mN(r.URI.revive(J.uri),v.to(J.range))}ve.to=se})(d||(e.Location=d={}));var E;(function(ve){function Re(se){switch(se){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}ve.to=Re})(E||(e.TokenType=E={}));var k;(function(ve){function Re(J){return new u.$bN(J.lineNumber-1,J.column-1)}ve.to=Re;function se(J){return{lineNumber:J.line+1,column:J.character+1}}ve.from=se})(k||(e.Position=k={}));var P;(function(ve){function Re(ke,Be,Xe){return(0,I.$Hb)((0,I.$2b)(ke).map(He=>se(He,Be,Xe)))}ve.from=Re;function se(ke,Be,Xe){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Xe?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Be),pattern:me.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Xe?.isBuiltin}}function J(ke,Be){return Be&&typeof ke=="string"?Be.transformOutgoingScheme(ke):ke}})(P||(e.DocumentSelector=P={}));var S;(function(ve){function Re(J){switch(J){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}ve.from=Re;function se(J){switch(J){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}ve.to=se})(S||(e.DiagnosticTag=S={}));var W;(function(ve){function Re(J){let ke;return J.code&&((0,g.$9f)(J.code)||(0,g.$ag)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...v.from(J.range),message:J.message,source:J.source,code:ke,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(S.from)):void 0}}ve.from=Re;function se(J){const ke=new u.$oN(v.to(J),J.message,q.to(J.severity));return ke.source=J.source,ke.code=(0,g.$9f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),ke.tags=J.tags&&(0,I.$Hb)(J.tags.map(S.to)),ke}ve.to=se})(W||(e.Diagnostic=W={}));var V;(function(ve){function Re(J){return{...v.from(J.location.range),message:J.message,resource:J.location.uri}}ve.from=Re;function se(J){return new u.$nN(new u.$mN(J.resource,v.to(J)),J.message)}ve.to=se})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(ve){function Re(J){switch(J){case u.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ve.from=Re;function se(J){switch(J){case i.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}ve.to=se})(q||(e.DiagnosticSeverity=q={}));var N;(function(ve){function Re(J){return typeof J=="number"&&J>=u.ViewColumn.One?J-1:J===u.ViewColumn.Beside?m.$5D:m.$4D}ve.from=Re;function se(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=se})(N||(e.ViewColumn=N={}));function B(ve){return typeof ve.range<"u"}function K(ve){return ve.length===0?!0:!!B(ve[0])}var ie;(function(ve){function Re(He){return He.map(ve.from)}ve.fromMany=Re;function se(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function J(He){let ut;if(se(He)){const{language:Ct,value:Bt}=He;ut={value:"```"+Ct+`
`+Bt+"\n```\n"}}else u.$CN.isMarkdownString(He)?ut={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ut={value:He}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const ct=Ct=>{try{let Bt=r.URI.parse(Ct,!0);Bt=Bt.with({query:ke(Bt.query,yt)}),yt[Ct]=Bt}catch{}return""},ii=new $.marked.Renderer;return ii.link=ct,ii.image=Ct=>typeof Ct=="string"?ct(A.$2k(Ct).href):"",(0,$.marked)(ut.value,{renderer:ii}),ut}ve.from=J;function ke(He,ut){if(!He)return He;let yt;try{yt=(0,y.$5h)(He)}catch{}if(!yt)return He;let ct=!1;return yt=(0,D.$5n)(yt,ii=>{if(r.URI.isUri(ii)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ct]=ii,ct=!0,Ct}else return}),ct?JSON.stringify(yt):He}function Be(He){const ut=new u.$CN(He.value,He.supportThemeIcons);return ut.isTrusted=He.isTrusted,ut.supportHtml=He.supportHtml,ut.baseUri=He.baseUri?r.URI.from(He.baseUri):void 0,ut}ve.to=Be;function Xe(He){if(He)return typeof He=="string"?He:ve.from(He)}ve.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function ce(ve){return K(ve)?ve.map(Re=>({range:v.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?ie.fromMany(Re.hoverMessage):Re.hoverMessage?ie.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):ve.map(Re=>({range:v.from(Re)}))}function ye(ve){return typeof ve>"u"?ve:typeof ve=="string"?r.URI.file(ve):ve}var Se;(function(ve){function Re(se){return typeof se>"u"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?ye(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}ve.from=Re})(Se||(e.ThemableDecorationAttachmentRenderOptions=Se={}));var fe;(function(ve){function Re(se){return typeof se>"u"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ye(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Se.from(se.before):void 0,after:se.after?Se.from(se.after):void 0}}ve.from=Re})(fe||(e.ThemableDecorationRenderOptions=fe={}));var $e;(function(ve){function Re(se){if(typeof se>"u")return se;switch(se){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=Re})($e||(e.DecorationRangeBehavior=$e={}));var Te;(function(ve){function Re(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?$e.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?fe.from(se.light):void 0,dark:se.dark?fe.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ye(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Se.from(se.before):void 0,after:se.after?Se.from(se.after):void 0}}ve.from=Re})(Te||(e.DecorationRenderOptions=Te={}));var ae;(function(ve){function Re(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:v.from(J.range)}}ve.from=Re;function se(J){const ke=new u.$hN(v.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),ke}ve.to=se})(ae||(e.TextEdit=ae={}));var Ne;(function(ve){function Re(J,ke){const Be={edits:[]};if(J instanceof u.$kN){const Xe=new p.$Bc;for(const He of J._allEntries())He._type===1&&r.URI.isUri(He.to)&&He.from===void 0&&Xe.add(He.to);for(const He of J._allEntries())if(He._type===1){let ut;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ut={type:"base64",value:(0,O.$Ze)(O.$Fe.wrap(He.options.contents))}:ut={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ut},metadata:He.metadata})}else He._type===2?Be.edits.push({resource:He.uri,textEdit:ae.from(He.edit),versionId:Xe.has(He.uri)?void 0:ke?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?Be.edits.push({resource:He.uri,textEdit:{range:v.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Xe.has(He.uri)?void 0:ke?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(He.uri)}):He._type===5&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:ke?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(ri.from)}})}return Be}ve.from=Re;function se(J){const ke=new u.$kN,Be=new p.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const He=Xe,ut=r.URI.revive(He.resource),yt=v.to(He.textEdit.range),ct=He.textEdit.text,ii=He.textEdit.insertAsSnippet;let Ct;ii?Ct=u.$jN.replace(yt,new u.$lN(ct)):Ct=u.$hN.replace(yt,ct);const Bt=Be.get(ut);Bt?Bt.push(Ct):Be.set(ut,[Ct])}else ke.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,He]of Be)ke.set(Xe,He);return ke}ve.to=se})(Ne||(e.WorkspaceEdit=Ne={}));var ne;(function(ve){const Re=Object.create(null);Re[u.SymbolKind.File]=0,Re[u.SymbolKind.Module]=1,Re[u.SymbolKind.Namespace]=2,Re[u.SymbolKind.Package]=3,Re[u.SymbolKind.Class]=4,Re[u.SymbolKind.Method]=5,Re[u.SymbolKind.Property]=6,Re[u.SymbolKind.Field]=7,Re[u.SymbolKind.Constructor]=8,Re[u.SymbolKind.Enum]=9,Re[u.SymbolKind.Interface]=10,Re[u.SymbolKind.Function]=11,Re[u.SymbolKind.Variable]=12,Re[u.SymbolKind.Constant]=13,Re[u.SymbolKind.String]=14,Re[u.SymbolKind.Number]=15,Re[u.SymbolKind.Boolean]=16,Re[u.SymbolKind.Array]=17,Re[u.SymbolKind.Object]=18,Re[u.SymbolKind.Key]=19,Re[u.SymbolKind.Null]=20,Re[u.SymbolKind.EnumMember]=21,Re[u.SymbolKind.Struct]=22,Re[u.SymbolKind.Event]=23,Re[u.SymbolKind.Operator]=24,Re[u.SymbolKind.TypeParameter]=25;function se(ke){return typeof Re[ke]=="number"?Re[ke]:6}ve.from=se;function J(ke){for(const Be in Re)if(Re[Be]===ke)return Number(Be);return u.SymbolKind.Property}ve.to=J})(ne||(e.SymbolKind=ne={}));var z;(function(ve){function Re(J){switch(J){case u.SymbolTag.Deprecated:return 1}}ve.from=Re;function se(J){switch(J){case 1:return u.SymbolTag.Deprecated}}ve.to=se})(z||(e.SymbolTag=z={}));var x;(function(ve){function Re(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(z.from),containerName:J.containerName,location:ge.from(J.location)}}ve.from=Re;function se(J){const ke=new u.$tN(J.name,ne.to(J.kind),J.containerName,ge.to(J.location));return ke.tags=J.tags&&J.tags.map(z.to),ke}ve.to=se})(x||(e.WorkspaceSymbol=x={}));var be;(function(ve){function Re(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:v.from(J.range),selectionRange:v.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(z.from)??[]};return J.children&&(ke.children=J.children.map(Re)),ke}ve.from=Re;function se(J){const ke=new u.$uN(J.name,J.detail,ne.to(J.kind),v.to(J.range),v.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ke.tags=J.tags.map(z.to)),J.children&&(ke.children=J.children.map(se)),ke}ve.to=se})(be||(e.DocumentSymbol=be={}));var Fe;(function(ve){function Re(J){const ke=new u.$yN(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),v.to(J.range),v.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}ve.to=Re;function se(J,ke,Be){if(ke=ke??J._sessionId,Be=Be??J._itemId,ke===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Be,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:v.from(J.range),selectionRange:v.from(J.selectionRange),tags:J.tags?.map(z.from)}}ve.from=se})(Fe||(e.CallHierarchyItem=Fe={}));var De;(function(ve){function Re(se){return new u.$zN(Fe.to(se.from),se.fromRanges.map(J=>v.to(J)))}ve.to=Re})(De||(e.CallHierarchyIncomingCall=De={}));var pe;(function(ve){function Re(se){return new u.$AN(Fe.to(se.to),se.fromRanges.map(J=>v.to(J)))}ve.to=Re})(pe||(e.CallHierarchyOutgoingCall=pe={}));var ge;(function(ve){function Re(J){return{range:J.range&&v.from(J.range),uri:J.uri}}ve.from=Re;function se(J){return new u.$mN(r.URI.revive(J.uri),v.to(J.range))}ve.to=se})(ge||(e.location=ge={}));var Q;(function(ve){function Re(J){const ke=J,Be=J;return{originSelectionRange:ke.originSelectionRange?v.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Be.uri,range:v.from(ke.targetRange?ke.targetRange:Be.range),targetSelectionRange:ke.targetSelectionRange?v.from(ke.targetSelectionRange):void 0}}ve.from=Re;function se(J){return{targetUri:r.URI.revive(J.uri),targetRange:v.to(J.range),targetSelectionRange:J.targetSelectionRange?v.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?v.to(J.originSelectionRange):void 0}}ve.to=se})(Q||(e.DefinitionLink=Q={}));var Y;(function(ve){function Re(J){return{range:v.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ve.from=Re;function se(J){const ke=J.contents.map(ie.to),Be=v.to(J.range),Xe=J.canIncreaseVerbosity,He=J.canDecreaseVerbosity;return new u.$qN(ke,Be,Xe,He)}ve.to=se})(Y||(e.Hover=Y={}));var he;(function(ve){function Re(J){return{range:v.from(J.range),expression:J.expression}}ve.from=Re;function se(J){return new u.$lO(v.to(J.range),J.expression)}ve.to=se})(he||(e.EvaluatableExpression=he={}));var ue;(function(ve){function Re(J){if(J instanceof u.$mO)return{type:"text",range:v.from(J.range),text:J.text};if(J instanceof u.$nO)return{type:"variable",range:v.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof u.$oO)return{type:"expression",range:v.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Re;function se(J){switch(J.type){case"text":return{range:v.to(J.range),text:J.text};case"variable":return{range:v.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:v.to(J.range),expression:J.expression}}}ve.to=se})(ue||(e.InlineValue=ue={}));var Me;(function(ve){function Re(J){return{frameId:J.frameId,stoppedLocation:v.from(J.stoppedLocation)}}ve.from=Re;function se(J){return new u.$pO(J.frameId,v.to(J.stoppedLocation))}ve.to=se})(Me||(e.InlineValueContext=Me={}));var de;(function(ve){function Re(J){return{range:v.from(J.range),kind:J.kind}}ve.from=Re;function se(J){return new u.$rN(v.to(J.range),J.kind)}ve.to=se})(de||(e.DocumentHighlight=de={}));var Ce;(function(ve){function Re(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}ve.from=Re;function se(J){return new u.$sN(r.URI.revive(J.uri),J.highlights.map(de.to))}ve.to=se})(Ce||(e.MultiDocumentHighlight=Ce={}));var Ae;(function(ve){function Re(se){switch(se){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}ve.to=Re})(Ae||(e.CompletionTriggerKind=Ae={}));var je;(function(ve){function Re(se){return{triggerKind:Ae.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}ve.to=Re})(je||(e.CompletionContext=je={}));var U;(function(ve){function Re(J){switch(J){case u.CompletionItemTag.Deprecated:return 1}}ve.from=Re;function se(J){switch(J){case 1:return u.CompletionItemTag.Deprecated}}ve.to=se})(U||(e.CompletionItemTag=U={}));var F;(function(ve){const Re=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function se(Be){return Re.get(Be)??9}ve.from=se;const J=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function ke(Be){return J.get(Be)??u.CompletionItemKind.Property}ve.to=ke})(F||(e.CompletionItemKind=F={}));var G;(function(ve){function Re(se,J){const ke=new u.$IN(se.label);return ke.insertText=se.insertText,ke.kind=F.to(se.kind),ke.tags=se.tags?.map(U.to),ke.detail=se.detail,ke.documentation=A.$Vk(se.documentation)?ie.to(se.documentation):se.documentation,ke.sortText=se.sortText,ke.filterText=se.filterText,ke.preselect=se.preselect,ke.commitCharacters=se.commitCharacters,o.$ut.isIRange(se.range)?ke.range=v.to(se.range):typeof se.range=="object"&&(ke.range={inserting:v.to(se.range.insert),replacing:v.to(se.range.replace)}),ke.keepWhitespace=typeof se.insertTextRules>"u"?!1:!!(se.insertTextRules&1),typeof se.insertTextRules<"u"&&se.insertTextRules&4?ke.insertText=new u.$lN(se.insertText):(ke.insertText=se.insertText,ke.textEdit=ke.range instanceof u.$cN?new u.$hN(ke.range,ke.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(ke.additionalTextEdits=se.additionalTextEdits.map(Be=>ae.to(Be))),ke.command=J&&se.command?J.fromInternal(se.command):void 0,ke}ve.to=Re})(G||(e.CompletionItem=G={}));var H;(function(ve){function Re(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}ve.from=Re;function se(J){return{label:J.label,documentation:A.$Vk(J.documentation)?ie.to(J.documentation):J.documentation}}ve.to=se})(H||(e.ParameterInformation=H={}));var ee;(function(ve){function Re(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}ve.from=Re;function se(J){return{label:J.label,documentation:A.$Vk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}ve.to=se})(ee||(e.SignatureInformation=ee={}));var re;(function(ve){function Re(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}ve.from=Re;function se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}ve.to=se})(re||(e.SignatureHelp=re={}));var Oe;(function(ve){function Re(se,J){const ke=new u.$HN(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Ve.to.bind(void 0,se)),J.kind&&Ge.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(ae.to),ke.tooltip=A.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}ve.to=Re})(Oe||(e.InlayHint=Oe={}));var Ve;(function(ve){function Re(se,J){const ke=new u.$GN(J.label);return ke.tooltip=A.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(ke.command=se.fromInternal(J.command)),J.location&&(ke.location=ge.to(J.location)),ke}ve.to=Re})(Ve||(e.InlayHintLabelPart=Ve={}));var Ge;(function(ve){function Re(J){return J}ve.from=Re;function se(J){return J}ve.to=se})(Ge||(e.InlayHintKind=Ge={}));var _e;(function(ve){function Re(J){return{range:v.from(J.range),url:J.target,tooltip:J.tooltip}}ve.from=Re;function se(J){let ke;if(J.url)try{ke=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new u.$NN(v.to(J.range),ke)}ve.to=se})(_e||(e.DocumentLink=_e={}));var xe;(function(ve){function Re(J){const ke=new u.$QN(J.label);return J.textEdit&&(ke.textEdit=ae.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Be=>ae.to(Be))),ke}ve.to=Re;function se(J){return{label:J.label,textEdit:J.textEdit?ae.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>ae.from(ke)):void 0}}ve.from=se})(xe||(e.ColorPresentation=xe={}));var et;(function(ve){function Re(J){return new u.$ON(J[0],J[1],J[2],J[3])}ve.to=Re;function se(J){return[J.red,J.green,J.blue,J.alpha]}ve.from=se})(et||(e.Color=et={}));var tt;(function(ve){function Re(J){return{range:v.from(J.range)}}ve.from=Re;function se(J){return new u.$xN(v.to(J.range))}ve.to=se})(tt||(e.SelectionRange=tt={}));var it;(function(ve){function Re(se){switch(se){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}ve.to=Re})(it||(e.TextDocumentSaveReason=it={}));var at;(function(ve){function Re(J){switch(J){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.Interval:return 3;case u.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=Re;function se(J){switch(J){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 3:return u.TextEditorLineNumbersStyle.Interval;case 1:default:return u.TextEditorLineNumbersStyle.On}}ve.to=se})(at||(e.TextEditorLineNumbersStyle=at={}));var gt;(function(ve){function Re(J){if(J===u.EndOfLine.CRLF)return 1;if(J===u.EndOfLine.LF)return 0}ve.from=Re;function se(J){if(J===1)return u.EndOfLine.CRLF;if(J===0)return u.EndOfLine.LF}ve.to=se})(gt||(e.EndOfLine=gt={}));var Ue;(function(ve){function Re(se){if(typeof se=="object")return se.viewId;switch(se){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=Re})(Ue||(e.ProgressLocation=Ue={}));var st;(function(ve){function Re(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=Z.from(J.kind)),ke}ve.from=Re;function se(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=Z.to(J.kind)),ke}ve.to=se})(st||(e.FoldingRange=st={}));var Z;(function(ve){function Re(J){if(J)switch(J){case u.FoldingRangeKind.Comment:return s.$du.Comment;case u.FoldingRangeKind.Imports:return s.$du.Imports;case u.FoldingRangeKind.Region:return s.$du.Region}}ve.from=Re;function se(J){if(J)switch(J.value){case s.$du.Comment.value:return u.FoldingRangeKind.Comment;case s.$du.Imports.value:return u.FoldingRangeKind.Imports;case s.$du.Region.value:return u.FoldingRangeKind.Region}}ve.to=se})(Z||(e.FoldingRangeKind=Z={}));var X;(function(ve){function Re(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?v.from(se.selection):void 0,override:typeof se.override=="boolean"?c.$uF.id:void 0}}ve.from=Re})(X||(e.TextEditorOpenOptions=X={}));var me;(function(ve){function Re(Be){return Be instanceof u.$_N?Be.toJSON():typeof Be=="string"?Be:se(Be)||J(Be)?new u.$_N(Be.baseUri??Be.base,Be.pattern).toJSON():Be}ve.from=Re;function se(Be){const Xe=Be;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function ke(Be){return typeof Be=="string"?Be:new u.$_N(r.URI.revive(Be.baseUri),Be.pattern)}ve.to=ke})(me||(e.GlobPattern=me={}));var qe;(function(ve){function Re(se){if(se){if(Array.isArray(se))return se.map(Re);if(typeof se=="string")return se;{const J=se;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ve.from=Re})(qe||(e.LanguageSelector=qe={}));var we;(function(ve){function Re(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&r.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Xe=>Xe instanceof u.$cN)))}ve.is=Re;function se(J){return{documents:J.documents.map(ke=>ke.map(Be=>({uri:r.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>v.from(Xe))})))}}ve.from=se})(we||(e.MappedEditsContext=we={}));var ot;(function(ve){function Re(J){return{start:J.start,end:J.end}}ve.from=Re;function se(J){return new u.$CO(J.start,J.end)}ve.to=se})(ot||(e.NotebookRange=ot={}));var dt;(function(ve){function Re(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ve.to=Re;function se(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ve.from=se})(dt||(e.NotebookCellExecutionSummary=dt={}));var Rt;(function(ve){function Re(se){if(se===t.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(se===t.NotebookCellExecutionState.Pending)return;if(se===t.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${se}`)}ve.to=Re})(Rt||(e.NotebookCellExecutionState=Rt={}));var Vt;(function(ve){function Re(J){switch(J){case u.NotebookCellKind.Markup:return t.CellKind.Markup;case u.NotebookCellKind.Code:default:return t.CellKind.Code}}ve.from=Re;function se(J){switch(J){case t.CellKind.Markup:return u.NotebookCellKind.Markup;case t.CellKind.Code:default:return u.NotebookCellKind.Code}}ve.to=se})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(ve){function Re(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Be of J.cells)u.$DO.validate(Be),ke.cells.push(ri.from(Be));return ke}ve.from=Re;function se(J){const ke=new u.$EO(J.cells.map(ri.to));return(0,g.$jg)(J.metadata)||(ke.metadata=J.metadata),ke}ve.to=se})(Qt||(e.NotebookData=Qt={}));var ri;(function(ve){function Re(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Dt.from):[]}}ve.from=Re;function se(J){return new u.$DO(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Dt.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}ve.to=se})(ri||(e.NotebookCellData=ri={}));var Xt;(function(ve){function Re(J){return{mime:J.mime,valueBytes:O.$Fe.wrap(J.data)}}ve.from=Re;function se(J){return new u.$FO(J.valueBytes.buffer,J.mime)}ve.to=se})(Xt||(e.NotebookCellOutputItem=Xt={}));var Dt;(function(ve){function Re(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}ve.from=Re;function se(J){const ke=J.items.map(Xt.to);return new u.$GO(ke,J.outputId,J.metadata)}ve.to=se})(Dt||(e.NotebookCellOutput=Dt={}));var Zt;(function(ve){function Re(ke){return J(ke)?{include:me.from(ke.include)??void 0,exclude:me.from(ke.exclude)??void 0}:me.from(ke)??void 0}ve.from=Re;function se(ke){return J(ke)?{include:me.to(ke.include),exclude:me.to(ke.exclude)}:me.to(ke)}ve.to=se;function J(ke){const Be=ke;return Be?!(0,g.$fg)(Be.include)&&!(0,g.$fg)(Be.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Yt;(function(ve){function Re(se,J,ke){const Be=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Be,ke),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}ve.from=Re})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ze;(function(ve){function Re(se,J,ke){const Be=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{command:J.toInternal(Be,ke),label:se.label,description:se.description,detail:se.detail,documentation:se.documentation}}ve.from=Re})(Ze||(e.NotebookKernelSourceAction=Ze={}));var ai;(function(ve){function Re(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{},cellContentMetadata:se?.cellContentMetadata??{}}}ve.from=Re})(ai||(e.NotebookDocumentContentOptions=ai={}));var Ht;(function(ve){function Re(J){return{uri:J.uri,provides:J.provides}}ve.from=Re;function se(J){return new u.$IO(r.URI.revive(J.uri),J.provides)}ve.to=se})(Ht||(e.NotebookRendererScript=Ht={}));var ht;(function(ve){function Re(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:v.from(J.location.range),uri:J.location.uri}}}ve.from=Re;function se(J){const ke=new u.$OO(typeof J.message=="string"?J.message:ie.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?ge.to(J.location):void 0,ke}ve.to=se})(ht||(e.TestMessage=ht={}));var mt;(function(ve){ve.namespace=a.$2L,ve.denamespace=a.$3L})(mt||(e.TestTag=mt={}));var xt;(function(ve){function Re(J){const ke=(0,n.$vP)(J).controllerId;return{extId:f.$WL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Be=>mt.namespace(ke,Be.id)),range:o.$ut.lift(v.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}ve.from=Re;function se(J){return{parent:void 0,error:void 0,id:f.$WL.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Be}=mt.denamespace(ke);return new u.$PO(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ve.toPlain=se})(xt||(e.TestItem=xt={})),function(ve){function Re(J){return{id:J.id}}ve.from=Re;function se(J){return new u.$PO(J.id)}ve.to=se}(mt||(e.TestTag=mt={}));var Kt;(function(ve){const Re=(J,ke)=>{const Be=J.value;if(!Be)return;const Xe={...xt.toPlain(Be.item),parent:ke,taskStates:Be.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const He of J.children.values()){const ut=Re(He,Xe);ut&&Xe.children.push(ut)}return Xe};function se(J){const ke=new h.$oP;for(const He of J.items)ke.insert(f.$WL.fromString(He.item.extId).path,He);const Be=[ke.nodes],Xe=[];for(;Be.length;)for(const He of Be.pop())He.value?Xe.push(He):He.children&&Be.push(He.children.values());return{completedAt:J.completedAt,results:Xe.map(He=>Re(He)).filter(g.$eg)}}ve.to=se})(Kt||(e.TestResults=Kt={}));var Ft;(function(ve){function Re(Be){return{covered:Be.covered,total:Be.total}}function se(Be){return"line"in Be?k.from(Be):v.from(Be)}function J(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:se(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&se(Xe.location),label:Xe.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:se(Be.location)}}ve.fromDetails=J;function ke(Be,Xe){return u.$RO(Xe.statementCoverage),u.$RO(Xe.branchCoverage),u.$RO(Xe.declarationCoverage),{id:Be,uri:Xe.uri,statement:Re(Xe.statementCoverage),branch:Xe.branchCoverage&&Re(Xe.branchCoverage),declaration:Xe.declarationCoverage&&Re(Xe.declarationCoverage)}}ve.fromFile=ke})(Ft||(e.TestCoverage=Ft={}));var ft;(function(ve){function Re(se){switch(se){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}ve.to=Re})(ft||(e.CodeActionTriggerKind=ft={}));var jt;(function(ve){function Re(J){const ke=new u.$WO(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),v.to(J.range),v.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}ve.to=Re;function se(J,ke,Be){if(ke=ke??J._sessionId,Be=Be??J._itemId,ke===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Be,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:v.from(J.range),selectionRange:v.from(J.selectionRange),tags:J.tags?.map(z.from)}}ve.from=se})(jt||(e.TypeHierarchyItem=jt={}));var _t;(function(ve){function Re(se){if(se)return{value:se.value,tooltip:se.tooltip}}ve.from=Re})(_t||(e.ViewBadge=_t={}));var Ut;(function(ve){function Re(Be,Xe,He){const ut=Xe.fileData;return ut?new u.$4N(new u.$5N(ut.name,r.URI.revive(ut.uri),ut.id,(0,M.$db)(()=>He(ut.id)))):Be===T.$Qs.uriList&&Xe.uriListData?new u.$3N(ke(Xe.uriListData)):new u.$3N(Xe.asString)}ve.to=Re;async function se(Be,Xe){const He=await Xe.asString();if(Be===T.$Qs.uriList)return{asString:He,fileData:void 0,uriListData:J(He)};const ut=Xe.asFile();return{asString:He,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ve.from=se;function J(Be){return R.$Ut.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function ke(Be){return R.$Ut.create(Be.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(Ut||(e.DataTransferItem=Ut={}));var Qe;(function(ve){function Re(J,ke){const Be=J.items.map(([Xe,He])=>[Xe,Ut.to(Xe,He,ke)]);return new u.$6N(Be)}ve.toDataTransfer=Re;async function se(J){const ke={items:[]},Be=[];for(const[Xe,He]of J)Be.push((async()=>{ke.items.push([Xe,await Ut.from(Xe,He)])})());return await Promise.all(Be),ke}ve.from=se})(Qe||(e.DataTransfer=Qe={}));var hi;(function(ve){function Re(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}ve.from=Re;function se(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ve.to=se})(hi||(e.ChatFollowup=hi={}));var Jt;(function(ve){function Re(se){return"commandId"in se?{kind:"command",title:se.title??"",commandId:se.commandId??"",when:se.when??"",args:se.args}:{kind:"reply",message:se.message,title:se.title,tooltip:se.tooltip}}ve.from=Re})(Jt||(e.ChatInlineFollowup=Jt={}));var Wt;(function(ve){function Re(J){switch(J.role){case 0:return new u.$jP(J.content);case 1:return new u.$kP(J.content);case 2:return new u.$lP(J.content)}}ve.to=Re;function se(J){if(J instanceof u.$jP)return{role:0,content:J.content};if(J instanceof u.$kP)return{role:1,content:J.content};if(J instanceof u.$lP)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}ve.from=se})(Wt||(e.LanguageModelMessage=Wt={}));var pt;(function(ve){function Re(ke){const Be={};for(const Xe of Object.keys(ke))Be[Xe]=ke[Xe].map(ve.to);return Be}ve.objectTo=Re;function se(ke){return{level:Lt.to(ke.level),kind:ke.kind,value:(0,r.$vc)(ke.value)?r.URI.revive(ke.value):ke.value,description:ke.description}}ve.to=se;function J(ke){return{level:Lt.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}ve.from=J})(pt||(e.ChatVariable=pt={}));var Lt;(function(ve){function Re(J){switch(J){case"short":return u.ChatVariableLevel.Short;case"medium":return u.ChatVariableLevel.Medium;case"full":default:return u.ChatVariableLevel.Full}}ve.to=Re;function se(J){switch(J){case u.ChatVariableLevel.Short:return"short";case u.ChatVariableLevel.Medium:return"medium";case u.ChatVariableLevel.Full:default:return"full"}}ve.from=se})(Lt||(e.ChatVariableLevel=Lt={}));var Ot;(function(ve){function Re(se){switch(se){case 1:return u.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return u.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return u.InteractiveEditorResponseFeedbackKind.Undone;case 3:return u.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return u.InteractiveEditorResponseFeedbackKind.Bug}}ve.to=Re})(Ot||(e.InteractiveEditorResponseFeedbackKind=Ot={}));var Mt;(function(ve){function Re(J){return{kind:"markdownContent",content:ie.from(J.value)}}ve.from=Re;function se(J){return new u.$0O(ie.to(J.content))}ve.to=se})(Mt||(e.ChatResponseMarkdownPart=Mt={}));var si;(function(ve){function Re(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}ve.from=Re;function se(J){return new u.$$O(ie.to(J.content),J.vulnerabilities)}ve.to=se})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var qt;(function(ve){function Re(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ve.from=Re;function se(J){return new u.$_O(J.agentId,J.command)}ve.to=se})(qt||(e.ChatResponseDetectedParticipantPart=qt={}));var oi;(function(ve){function Re(J){const{value:ke,baseUri:Be}=J;function Xe(He,ut){return He.map(yt=>{const ct=r.URI.joinPath(ut,yt.name);return{label:yt.name,uri:ct,children:yt.children&&Xe(yt.children,ct)}})}return{kind:"treeData",treeData:{label:(0,w.$7g)(Be),uri:Be,children:Xe(ke,Be)}}}ve.from=Re;function se(J){const ke=(0,y.$6h)(J.treeData);function Be(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Be(yt.children)}))}const Xe=ke.uri,He=ke.children?Be(ke.children):[];return new u.$aP(He,Xe)}ve.to=se})(oi||(e.ChatResponseFilesPart=oi={}));var At;(function(ve){function Re(J){return{kind:"inlineReference",name:J.title,inlineReference:r.URI.isUri(J.value)?J.value:d.from(J.value)}}ve.from=Re;function se(J){const ke=(0,y.$6h)(J);return new u.$bP(r.URI.isUri(ke.inlineReference)?ke.inlineReference:d.to(ke.inlineReference),J.name)}ve.to=se})(At||(e.ChatResponseAnchorPart=At={}));var Tt;(function(ve){function Re(J){return{kind:"progressMessage",content:ie.from(J.value)}}ve.from=Re;function se(J){return new u.$cP(J.content.value)}ve.to=se})(Tt||(e.ChatResponseProgressPart=Tt={}));var zt;(function(ve){function Re(J){return{kind:"warning",content:ie.from(J.value)}}ve.from=Re;function se(J){return new u.$dP(J.content.value)}ve.to=se})(zt||(e.ChatResponseWarningPart=zt={}));var Pt;(function(ve){function Re(J,ke,Be){return{kind:"command",command:ke.toInternal(J.value,Be)??{command:J.value.command,title:J.value.title}}}ve.from=Re;function se(J,ke){return new u.$eP(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ve.to=se})(Pt||(e.ChatResponseCommandButtonPart=Pt={}));var $t;(function(ve){function Re(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>ae.from(ke))}}ve.from=Re;function se(J){return new u.$gP(r.URI.revive(J.uri),J.edits.map(ke=>ae.to(ke)))}ve.to=se})($t||(e.ChatResponseTextEditPart=$t={}));var Et;(function(ve){function Re(J){const ke=C.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&r.URI.isUri(J.iconPath.light)&&r.URI.isUri(J.iconPath.dark)?{light:r.URI.revive(J.iconPath.light),dark:r.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:d.from(J.value.value)},iconPath:ke}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:d.from(J.value),iconPath:ke}}ve.from=Re;function se(J){const ke=(0,y.$6h)(J),Be=Xe=>r.URI.isUri(Xe)?Xe:d.to(Xe);return new u.$fP("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Be(ke.reference.value)}:Be(ke.reference))}ve.to=se})(Et||(e.ChatResponseReferencePart=Et={}));var ci;(function(ve){function Re(ke,Be,Xe){return ke instanceof u.$0O?Mt.from(ke):ke instanceof u.$bP?At.from(ke):ke instanceof u.$fP?Et.from(ke):ke instanceof u.$cP?Tt.from(ke):ke instanceof u.$aP?oi.from(ke):ke instanceof u.$eP?Pt.from(ke,Be,Xe):ke instanceof u.$gP?$t.from(ke):ke instanceof u.$$O?si.from(ke):ke instanceof u.$_O?qt.from(ke):{kind:"markdownContent",content:ie.from("")}}ve.from=Re;function se(ke,Be){switch(ke.kind){case"reference":return Et.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,Be)}}ve.to=se;function J(ke,Be){switch(ke.kind){case"markdownContent":return Mt.to(ke);case"inlineReference":return At.to(ke);case"progressMessage":return;case"treeData":return oi.to(ke);case"command":return Pt.to(ke,Be)}}ve.toContent=J})(ci||(e.ChatResponsePart=ci={}));var kt;(function(ve){function Re(se){return{prompt:se.message,command:se.command,attempt:se.attempt??0,enableCommandDetection:se.enableCommandDetection??!0,variables:se.variables.variables.map(ei.to),location:gi.to(se.location)}}ve.to=Re})(kt||(e.ChatAgentRequest=kt={}));var gi;(function(ve){function Re(se){switch(se){case l.ChatAgentLocation.Notebook:return u.ChatLocation.Notebook;case l.ChatAgentLocation.Terminal:return u.ChatLocation.Terminal;case l.ChatAgentLocation.Panel:return u.ChatLocation.Panel;case l.ChatAgentLocation.Editor:return u.ChatLocation.Editor}}ve.to=Re})(gi||(e.ChatLocation=gi={}));var ei;(function(ve){function Re(se){const J=se.values[0]?.value;if(!J)throw new Error("Invalid value reference");return{name:se.name,range:se.range&&[se.range.start,se.range.endExclusive],value:(0,r.$vc)(J)?r.URI.revive(J):J}}ve.to=Re})(ei||(e.ChatAgentValueReference=ei={}));var wi;(function(ve){function Re(se,J,ke){return{label:se.label,values:se.values.map(pt.from),insertText:se.insertText,detail:se.detail,documentation:se.documentation,command:J.toInternal(se.command,ke)}}ve.from=Re})(wi||(e.ChatAgentCompletionItem=wi={}));var ui;(function(ve){function Re(se){return{errorDetails:se.errorDetails,metadata:se.metadata}}ve.to=Re})(ui||(e.ChatAgentResult=ui={}));var bi;(function(ve){function Re(se,J,ke){if(J.action.kind==="vote")return;const Be=ui.to(se);if(J.action.kind==="command"){const Xe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Be}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:hi.to(J.action.followup)},result:Be}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Be}:{action:J.action,result:Be}}ve.to=Re})(bi||(e.ChatAgentUserActionEvent=bi={}));var It;(function(ve){function Re(se,J,ke){return"terminalCommand"in se?{terminalCommand:se.terminalCommand,shouldExecute:se.shouldExecute}:"uri"in se?{uri:se.uri}:J.toInternal(se,ke)}ve.from=Re})(It||(e.TerminalQuickFix=It={}));var Di;(function(ve){function Re(se){return{kind:ti.to(se.kind)}}ve.to=Re})(Di||(e.PartialAcceptInfo=Di={}));var ti;(function(ve){function Re(se){switch(se){case 0:return u.PartialAcceptTriggerKind.Word;case 1:return u.PartialAcceptTriggerKind.Line;case 2:return u.PartialAcceptTriggerKind.Suggest;default:return u.PartialAcceptTriggerKind.Unknown}}ve.to=Re})(ti||(e.PartialAcceptTriggerKind=ti={}));var St;(function(ve){function Re(se,J){return{id:J,label:se.label,description:se.description,canEdit:se.canEdit,collapsibleState:se.collapsibleState||0,contextValue:se.contextValue}}ve.from=Re})(St||(e.DebugTreeItem=St={}))}),define(Pe[262],Ie([1,0,4,17,8,35]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;let A=class{constructor($,y){this.a=$.getProxy(I.$$M.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>y.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,y,T){const D=new M.$Bw(R.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(D,void 0,T?.isRefactoring??!1)}};e.$vlc=A,e.$vlc=A=Je([We(0,O.$zP)],A)}),define(Pe[263],Ie([1,0,18,11,44,5,42,6,66,15,2,20,4,8,7,225,26]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class s{constructor(l,t,f,a,m){this.j=l,this.k=t,this.l=f,this.m=a,this.n=m,this.b=$.$_d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(l.c){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,a),m}};const l=this;this.b.reset();const f=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){t(this.markdown);const m=new g.$0O(a),u=w.ChatResponseMarkdownPart.from(m);return f(u),this},markdownWithVulnerabilities(a,m){t(this.markdown),m&&(0,o.$PG)(l.j,"chatParticipantAdditions");const u=new g.$$O(a,m),C=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(u);return f(C),this},filetree(a,m){t(this.filetree);const u=new g.$aP(a,m),C=w.ChatResponseFilesPart.from(u);return f(C),this},anchor(a,m){t(this.anchor);const u=new g.$bP(a,m),C=w.ChatResponseAnchorPart.from(u);return f(C),this},button(a){t(this.anchor);const m=new g.$eP(a),u=w.ChatResponseCommandButtonPart.from(m,l.m,l.n);return f(u),this},progress(a){t(this.progress);const m=new g.$cP(a),u=w.ChatResponseProgressPart.from(m);return f(u),this},warning(a){t(this.progress);const m=new g.$dP(a),u=w.ChatResponseWarningPart.from(m);return f(u),this},reference(a,m){if(t(this.reference),"variableName"in a&&!a.value){const u=l.k.variables.variables.find(C=>C.name===a.variableName);if(u){let C;if(u.references?.length)C=u.references.map(b=>({kind:"reference",reference:{variableName:a.variableName,value:b.reference}}));else{const b=new g.$fP(a,m);C=[w.ChatResponseReferencePart.from(b)]}return C.forEach(b=>f(b)),this}}else{const u=new g.$fP(a,m),C=w.ChatResponseReferencePart.from(u);f(C)}return this},textEdit(a,m){t(this.textEdit),(0,o.$PG)(l.j,"chatParticipantAdditions");const u=new g.$gP(a,m),C=w.ChatResponseTextEditPart.from(u);return f(C),this},detectedParticipant(a,m){t(this.detectedParticipant),(0,o.$PG)(l.j,"chatParticipantAdditions");const u=new g.$_O(a,m),C=w.ChatResponseDetectedParticipantPart.from(u);return f(C),this},push(a){if(t(this.push),(a instanceof g.$gP||a instanceof g.$$O||a instanceof g.$_O)&&(0,o.$PG)(l.j,"chatParticipantAdditions"),a instanceof g.$fP)this.reference(a.value,a.iconPath);else{const m=w.ChatResponsePart.from(a,l.m,l.n);f(m)}return this}}}return this.g}}class i extends p.$Uc{static{this.b=0}constructor(l,t,f){super(),this.n=t,this.s=f,this.c=new Map,this.j=this.B(new p.$4c),this.m=this.B(new p.$4c),this.g=l.getProxy(h.$$M.MainThreadChatAgents2)}transferActiveChat(l){this.g.$transferActiveChatSession(l)}createChatAgent(l,t,f){const a=i.b++,m=new n(l,t,this.g,a,f);return this.c.set(a,m),this.g.$registerAgent(a,l.identifier,t,{},void 0),m.apiAgent}createDynamicChatAgent(l,t,f,a,m){const u=i.b++,C=new n(l,t,this.g,u,m);return this.c.set(u,C),this.g.$registerAgent(u,l.identifier,t,{isSticky:!0},{name:f,description:a}),C.apiAgent}async $invokeAgent(l,t,f,a){const m=this.c.get(l);if(!m)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let u=this.j.get(t.sessionId);u||(u=new p.$Tc,this.j.set(t.sessionId,u));const C=new s(m.extension,t,this.g,this.s.converter,u);try{const b=await this.t(t.agentId,f),v=m.invoke(w.ChatAgentRequest.to(t),{history:b},C.apiObject,a);return await(0,O.$kh)(Promise.resolve(v).then(d=>{if(d?.metadata)try{JSON.stringify(d.metadata)}catch(E){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.n.error(`[${m.extension.identifier.value}] [@${m.id}] ${k}`,m.extension),{errorDetails:{message:k},timings:C.timings}}return{errorDetails:d?.errorDetails,timings:C.timings,metadata:d?.metadata}}),a)}catch(b){return this.n.error(b,m.extension),{errorDetails:{message:(0,R.$hj)(b),responseIsIncomplete:!0}}}finally{C.close()}}async t(l,t){const f=[];for(const a of t.history){const m=w.ChatAgentResult.to(a.result),u=l===a.request.agentId?m:{...m,metadata:void 0};f.push(new g.$hP(a.request.message,a.request.command,a.request.variables.variables.map(w.ChatAgentValueReference.to),a.request.agentId));const C=(0,I.$Hb)(a.response.map(b=>w.ChatResponsePart.toContent(b,this.s.converter)));f.push(new g.$iP(C,u,a.request.agentId,a.request.command))}return f}$releaseSession(l){this.j.deleteAndDispose(l)}async $provideFollowups(l,t,f,a,m){const u=this.c.get(t);if(!u)return Promise.resolve([]);const C=await this.t(u.id,a),b=w.ChatAgentResult.to(f);return(await u.provideFollowups(b,{history:C},m)).filter(v=>{const d=!v.participant||A.Iterable.some(this.c.values(),E=>E.id===v.participant&&D.$Rm.equals(E.extension.identifier,u.extension.identifier));return d||this.n.warn(`[@${u.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),d}).map(v=>w.ChatFollowup.from(v,l))}$acceptFeedback(l,t,f,a){const m=this.c.get(l);if(!m)return;const u=w.ChatAgentResult.to(t);let C;switch(f){case r.InteractiveSessionVoteDirection.Down:C=g.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:C=g.ChatResultFeedbackKind.Helpful;break}m.acceptFeedback(Object.freeze(a?{result:u,kind:C,reportIssue:a}:{result:u,kind:C}))}$acceptAction(l,t,f){const a=this.c.get(l);if(!a||f.action.kind==="vote")return;const m=w.ChatAgentUserActionEvent.to(t,f,this.s.converter);m&&a.acceptAction(Object.freeze(m))}async $invokeCompletionProvider(l,t,f){const a=this.c.get(l);if(!a)return[];let m=this.m.get(l);return m?m.clear():(m=new p.$Tc,this.m.set(l,m)),(await a.invokeCompletionProvider(t,f)).map(C=>w.ChatAgentCompletionItem.from(C,this.s.converter,m))}async $provideWelcomeMessage(l,t,f){const a=this.c.get(l);if(a)return await a.provideWelcomeMessage(w.ChatLocation.to(t),f)}async $provideSampleQuestions(l,t,f){const a=this.c.get(l);if(a)return(await a.provideSampleQuestions(w.ChatLocation.to(t),f)).map(m=>w.ChatFollowup.from(m,void 0))}}e.$wlc=i;class n{constructor(l,t,f,a,m){this.extension=l,this.id=t,this.u=f,this.w=a,this.x=m,this.n=new M.$de,this.o=new M.$de}acceptFeedback(l){this.n.fire(l)}acceptAction(l){this.o.fire(l)}async invokeCompletionProvider(l,t){return this.q?await this.q.provider.provideCompletionItems(l,t)??[]:[]}async provideFollowups(l,t,f){if(!this.b)return[];const a=await this.b.provideFollowups(l,t,f);return a?a.filter(m=>!(m&&"commandId"in m)).filter(m=>!(m&&"message"in m)):[]}async provideWelcomeMessage(l,t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(l,t);return f?f.map(a=>typeof a=="string"?a:w.MarkdownString.from(a)):[]}async provideSampleQuestions(l,t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(l,t);return f||[]}get apiAgent(){let l=!1,t=!1;const f=()=>{l||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof g.$0N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:w.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$PG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(m){(0,o.$PG)(a.extension,"defaultChatParticipant"),a.c=m,f()},get iconPath(){return a.d},set iconPath(m){a.d=m,f()},get requestHandler(){return a.x},set requestHandler(m){(0,y.$gg)(typeof m=="function","Invalid request handler"),a.x=m},get followupProvider(){return a.b},set followupProvider(m){a.b=m,f()},get isDefault(){return(0,o.$PG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(m){(0,o.$PG)(a.extension,"defaultChatParticipant"),a.g=m,f()},get helpTextPrefix(){return(0,o.$PG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(m){(0,o.$PG)(a.extension,"defaultChatParticipant"),a.j=m,f()},get helpTextVariablesPrefix(){return(0,o.$PG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(m){(0,o.$PG)(a.extension,"defaultChatParticipant"),a.k=m,f()},get helpTextPostfix(){return(0,o.$PG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(m){(0,o.$PG)(a.extension,"defaultChatParticipant"),a.l=m,f()},get isSecondary(){return(0,o.$PG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(m){(0,o.$PG)(a.extension,"defaultChatParticipant"),a.m=m,f()},get supportIssueReporting(){return(0,o.$PG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(m){(0,o.$PG)(a.extension,"chatParticipantAdditions"),a.p=m,f()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(m){if((0,o.$PG)(a.extension,"chatParticipantAdditions"),a.q=m,m){if(!m.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,m.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,o.$PG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(m){(0,o.$PG)(a.extension,"defaultChatParticipant"),a.s=m,f()},get welcomeMessageProvider(){return(0,o.$PG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,o.$OG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(m){a.t=m,f()},get requester(){return a.t},dispose(){l=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(l,t,f,a){return this.x(l,t,f,a)}}}),define(Pe[264],Ie([1,0,14,6,4,8,7,26]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class ${static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(R.$$M.MainThreadChatVariables)}async $resolveVariable(D,h,w,g){const r=this.b.get(D);if(r)try{if(r.resolver.resolve2){(0,p.$PG)(r.extension,"chatParticipantAdditions");const o=new y(h,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:w},o.apiObject,g);if(s)return s.map(M.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:w},g);if(o)return o.map(M.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(D,h,w,g){const r=$.a++;return this.b.set(r,{extension:D,data:{name:h,description:w},resolver:g}),this.c.$registerVariable(r,{name:h,description:w}),(0,O.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$xlc=$;class y{constructor(D,h){this.c=D,this.d=h,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let h=function(g){if(D.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,g),r}};const D=this,w=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){h(this.progress);const r=new A.$cP(g),o=M.ChatResponseProgressPart.from(r);return w(o),this},reference(g){h(this.reference);const r=new A.$fP(g),o=M.ChatResponseReferencePart.from(r);return w(o),this},push(g){return h(this.push),g instanceof A.$fP?w(M.ChatResponseReferencePart.from(g)):g instanceof A.$cP&&w(M.ChatResponseProgressPart.from(g)),this}}}return this.b}}}),define(Pe[265],Ie([1,0,11,69,5,6,2,89,20,8,7,4,26]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=w;function w(g,r,o){const s=g.getProxy(D.$$M.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Tm,r.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const v=this.b.get(b.handle);return v?v.value:b}else if(b&&b.$mid===7){const v=b,d=this.b.get(v.commentControlHandle);if(!d)return v;const E=d.getCommentThread(v.commentThreadHandle);return E?E.value:v}else if(b&&(b.$mid===9||b.$mid===8)){const v=this.b.get(b.thread.commentControlHandle);if(!v)return b;const d=v.getCommentThread(b.thread.commentThreadHandle);return d?b.$mid===8?d.value:{thread:d.value,text:b.text}:b}else if(b&&b.$mid===10){const v=this.b.get(b.thread.commentControlHandle);if(!v)return b;const d=v.getCommentThread(b.thread.commentThreadHandle);if(!d)return b;const E=b.commentUniqueId,k=d.getCommentByUniqueId(E);return k||b}else if(b&&b.$mid===11){const v=this.b.get(b.thread.commentControlHandle);if(!v)return b;const d=v.getCommentThread(b.thread.commentThreadHandle);if(!d)return b;const E=b.text,k=b.commentUniqueId,P=d.getCommentByUniqueId(k);return P?(typeof P.body=="string"?P.body=E:P.body=new T.$CN(E),P):b}return b}})}createCommentController(b,v,d){const E=i.a++,k=new c(b,E,v,d);this.b.set(k.handle,k);const P=this.c.get(b.identifier)||[];return P.push(k),this.c.set(b.identifier,P),k.value}async $createCommentThreadTemplate(b,v,d){const E=this.b.get(b);E&&E.$createCommentThreadTemplate(v,d)}async $setActiveComment(b,v){const d=this.b.get(b);d&&d.$setActiveComment(v??void 0)}async $updateCommentThreadTemplate(b,v,d){const E=this.b.get(b);E&&E.$updateCommentThreadTemplate(v,d)}$deleteCommentThread(b,v){this.b.get(b)?.$deleteCommentThread(v)}async $provideCommentingRanges(b,v,d){const E=this.b.get(b);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const k=await o.ensureDocumentData(A.URI.revive(v));return(0,I.$oh)(async()=>{const P=await E.commentingRangeProvider.provideCommentingRanges(k.document,d);let S;return Array.isArray(P)?S={ranges:P,fileComments:!1}:P?S={ranges:P.ranges||[],fileComments:P.fileComments||!1}:S=P??void 0,S}).then(P=>{let S;return P&&(S={ranges:P.ranges.map(W=>y.Range.from(W)),fileComments:P.fileComments}),S})}$toggleReaction(b,v,d,E,k){const P=this.b.get(b);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,I.$oh)(()=>{const S=P.getCommentThread(v);if(S){const W=S.getCommentByUniqueId(E.uniqueIdInThread);if(P!==void 0&&W&&P.reactionHandler)return P.reactionHandler(W,f(k))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,h.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,v,d,E,k,P,S,W){this.m=v,this.n=d,this.o=E,this.p=k,this.q=P,this.extensionDescription=S,this.r=W,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$de,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Vc,this.l.value=new M.$Tc,this.n===void 0&&(this.n=`${b}.${this.handle}`),s.$createCommentThread(v,this.handle,this.n,this.o,y.Range.from(this.p),S.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{s.$deleteCommentThread(v,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Tc);const b=d=>Object.prototype.hasOwnProperty.call(this.b,d),v={};b("range")&&(v.range=y.Range.from(this.p)),b("label")&&(v.label=this.label),b("contextValue")&&(v.contextValue=this.contextValue??null),b("comments")&&(v.comments=this.q.map(d=>l(this,d,this.k,this.extensionDescription))),b("collapsibleState")&&(v.collapseState=a(this.g)),b("canReply")&&(v.canReply=this.canReply),b("state")&&(v.state=m(this.h)),b("applicability")&&(v.applicability=u(this.h)),b("isTemplate")&&(v.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(b){for(const v of this.k){const d=v[0],E=v[1];if(b===E)return d}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Je([(0,O.$2h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,h.$PG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,h.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,h.$PG)(this.h,"activeComment"),this.f}constructor(b,v,d,E){this.h=b,this.i=v,this.j=d,this.k=E,this.a=new Map,s.$registerCommentController(this.handle,d,E,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(P){k.options=P},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(P){k.commentingRangeProvider=P},get reactionHandler(){return k.reactionHandler},set reactionHandler(P){k.reactionHandler=P},get activeCommentThread(){return k.activeCommentThread},createCommentThread(P,S,W){return k.createCommentThread(P,S,W).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(b,v,d){v===void 0&&(0,h.$PG)(this.h,"fileComments");const E=new n(this.id,this.handle,void 0,b,v,d,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const v=this.a.get(b.commentThreadHandle);v&&(this.e=b.uniqueIdInThread?v.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=v)}$createCommentThreadTemplate(b,v){const d=new n(this.id,this.handle,void 0,A.URI.revive(b),y.Range.to(v),[],this.h,!0);return d.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(d.handle,d),d}$updateCommentThreadTemplate(b,v){const d=this.a.get(b);d&&(d.range=y.Range.to(v))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function l(C,b,v,d){let E=v.get(b);return E||(E=++C.commentHandle,v.set(b,E)),b.state!==void 0&&(0,h.$PG)(d,"commentsDraftState"),b.reactions?.some(k=>k.reactors!==void 0)&&(0,h.$PG)(d,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:E,body:typeof b.body=="string"?b.body:y.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(k=>t(k)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function t(C){return{label:C.label,iconPath:C.iconPath?y.$yP(C.iconPath):void 0,count:C.count,hasReacted:C.authorHasReacted,reactors:C.reactors&&C.reactors.length>0&&typeof C.reactors[0]!="string"?C.reactors.map(b=>b.name):C.reactors}}function f(C){return{label:C.label||"",count:C.count||0,iconPath:C.iconPath?A.URI.revive(C.iconPath):"",authorHasReacted:C.hasReacted||!1,reactors:C.reactors?.map(b=>({name:b}))}}function a(C){if(C!==void 0)switch(C){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function m(C){let b;if(typeof C=="object"?b=C.resolved:b=C,b!==void 0)switch(b){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function u(C){let b;if(typeof C=="object"&&(b=C.applicability),b!==void 0)switch(b){case T.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Pe[266],Ie([1,0,24,73,6,16,23,2,8,64,76,4,7]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=void 0;class w{constructor(f,a){this.document=f,this.b=a,this.a=1,this.c=new T.$hlc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,a){await this.f(f).undo(),a||this.disposeBackup()}async redo(f,a){await this.f(f).redo(),a||this.disposeBackup()}disposeEdits(f){for(const a of f)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=l(this.document.uri)+this.a++;return(0,A.$0g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const a=this.c.get(f,0);if(!a)throw new Error("No edit found");return a}}class g{constructor(){this.a=new Map}get(f,a){return this.a.get(this.b(f,a))}add(f,a,m){const u=this.b(f,a.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${f} resource:${a.uri}`);const C=new w(a,m);return this.a.set(u,C),C}delete(f,a){const m=this.b(f,a.uri);this.a.delete(m)}b(f,a){return`${f}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(f,a,m){return this.b(f,{type:0,extension:a,provider:m})}addCustomProvider(f,a,m){return this.b(f,{type:1,extension:a,provider:m})}get(f){return this.a.get(f)}b(f,a){if(this.a.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this.a.set(f,a),new h.$aN(()=>this.a.delete(f))}}class s{constructor(f,a,m,u,C){this.d=a,this.f=m,this.g=u,this.h=C,this.b=new o,this.c=new g,this.a=f.getProxy(D.$$M.MainThreadCustomEditors)}registerCustomEditorProvider(f,a,m,u){const C=new R.$Tc;return n(m)?(C.add(this.b.addTextProvider(a,f,m)),this.a.$registerTextEditorProvider((0,y.$Qlc)(f),a,u.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,y.$Olc)(f))):(C.add(this.b.addCustomProvider(a,f,m)),i(m)&&C.add(m.onDidChangeCustomDocument(b=>{const v=this.i(a,b.document.uri);if(c(b)){const d=v.addEdit(b);this.a.$onDidEdit(b.document.uri,a,d,b.label)}else this.a.$onContentChange(b.document.uri,a)})),this.a.$registerCustomEditorProvider((0,y.$Qlc)(f),a,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,y.$Olc)(f))),h.$aN.from(C,new h.$aN(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(f,a,m,u,C){const b=this.b.get(a);if(!b)throw new Error(`No provider found for '${a}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${a}'`);const v=p.URI.revive(f),d=await b.provider.openCustomDocument(v,{backupId:m,untitledDocumentData:u?.buffer},C);let E;return i(b.provider)&&this.f&&(E=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(a,d,E),{editable:i(b.provider)}}async $disposeCustomDocument(f,a){const m=this.b.get(a);if(!m)throw new Error(`No provider found for '${a}'`);if(m.type!==1)throw new Error(`Invalid provider type for '${a}'`);const u=p.URI.revive(f),{document:C}=this.i(a,u);this.c.delete(a,C),C.dispose()}async $resolveCustomEditor(f,a,m,u,C,b){const v=this.b.get(m);if(!v)throw new Error(`No provider found for '${m}'`);const d=$.ViewColumn.to(C),E=this.g.createNewWebview(a,u.contentOptions,v.extension),k=this.h.createNewWebviewPanel(a,m,u.title,d,u.options,E,u.active),P=p.URI.revive(f);switch(v.type){case 1:{const{document:S}=this.i(m,P);return v.provider.resolveCustomEditor(S,k,b)}case 0:{const S=this.d.getDocument(P);return v.provider.resolveCustomTextEditor(S,k,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,a,m){this.i(a,f).disposeEdits(m)}async $onMoveCustomEditor(f,a,m){const u=this.b.get(m);if(!u)throw new Error(`No provider found for '${m}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const C=this.h.getWebviewPanel(f);if(!C)throw new Error("No webview found");const b=p.URI.revive(a),v=this.d.getDocument(b);await u.provider.moveCustomTextEditor(v,C,I.CancellationToken.None)}async $undo(f,a,m,u){return this.i(a,f).undo(m,u)}async $redo(f,a,m,u){return this.i(a,f).redo(m,u)}async $revert(f,a,m){const u=this.i(a,f);await this.j(a).revertCustomDocument(u.document,m),u.disposeBackup()}async $onSave(f,a,m){const u=this.i(a,f);await this.j(a).saveCustomDocument(u.document,m),u.disposeBackup()}async $onSaveAs(f,a,m,u){const C=this.i(a,f);return this.j(a).saveCustomDocumentAs(C.document,p.URI.revive(m),u)}async $backup(f,a,m){const u=this.i(a,f),b=await this.j(a).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},m);return u.updateBackup(b),b.id}i(f,a){const m=this.c.get(f,p.URI.revive(a));if(!m)throw new Error("No custom document found");return m}j(f){const m=this.b.get(f)?.provider;if(!m||!i(m))throw new Error("Custom document is not editable");return m}}e.$Tlc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const f=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,O.$kj)(f)+""}}),define(Pe[267],Ie([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,I,O,R,M,A,p,$,y,T,D){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0;class w{#e;#t;#i;constructor(o,s,i,n,c,l,t,f){this.d=o,this.e=s,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new T.$Ac(a=>l.getComparisonKey(a)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let i=[];if(R.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),i=[o]}else if(Array.isArray(o)){i=[];let l;o=[...o].sort(w.k);for(const t of o){const[f,a]=t;if((!l||f.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=f,i.push(f),this.#i.set(f,[])),a)this.#i.get(f)?.push(...a);else{const m=this.#i.get(f);m&&(m.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const l of i){let t=[];const f=this.#i.get(l);if(f)if(f.length>this.g){t=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const u of f)if(u.severity===a[m]&&t.push({...p.Diagnostic.from(u),modelVersionId:this.h(l)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,I.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(l)}));if(n.push([l,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[i,n]of this)o.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$olc=w;let g=class{static{h=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*h.d}static _mapper(o){const s=new T.$Ac;for(const i of o)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new $.$he({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,h._mapper),this.f=o.getProxy(M.$$M.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:i,f:n,h:c,j:l,k:t,l:f}=this,a=new class{$changeMany(C,b){n.$changeMany(C,b),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,C,b.length===0?"CLEARING":b)}$clear(C){n.$clear(C),l.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,C)}dispose(){n.dispose()}};let m;if(!s)s="_generated_diagnostic_collection_name_#"+h.c++,m=s;else if(!i.has(s))m=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do m=s+h.c++;while(i.has(m))}return new class extends w{constructor(){super(s,m,h.e,h.d,C=>f.getDocument(C)?.version,t.extUri,a,c),i.set(m,this)}dispose(){super.dispose(),i.delete(m)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((c,l)=>{let t=s.get(c.toString());typeof t>"u"&&(t=i.length,s.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...l)});return i}}m(o){let s=[];for(const i of this.g.values())i.has(o)&&(s=s.concat(i.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",i=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of o)this.n.set(R.URI.revive(s),i.map(p.Diagnostic.to))}};e.$plc=g,e.$plc=g=h=Je([We(1,y.$3j),We(2,D.$nlc)],g)}),define(Pe[268],Ie([1,0,2,14,7,8,200,35]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class ${constructor(T,D,h,w={timeout:1500,errors:3}){this.c=T,this.d=D,this.f=h,this.g=w,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(D,h,w)=>{const r={dispose:this.a.push([D,h,T])};return Array.isArray(w)&&w.push(r),r}}async $participateInSave(T,D){const h=I.URI.revive(T);let w=!1;const g=setTimeout(()=>w=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(w)break;const s=this.d.getDocument(h),i=await this.h(o,{document:s,reason:M.TextDocumentSaveReason.to(D)});r.push(i)}}finally{clearTimeout(g)}return r}h([T,D,h],w){const g=this.b.get(T);return typeof g=="number"&&g>this.g.errors?Promise.resolve(!1):this.i(h,T,D,w).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,D,h,w){const g=[],r=Date.now(),{document:o,reason:s}=w,{version:i}=o,n=Object.freeze({document:o,reason:s,waitUntil(c){if(Object.isFrozen(g))throw(0,O.$8)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{D.apply(h,[n])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,l)=>{const t=setTimeout(()=>l(new Error("timeout")),this.g.timeout);return Promise.all(g).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(f)}).catch(f=>{clearTimeout(t),l(f)})}).then(c=>{const l={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(f=>f instanceof R.$hN))for(const{newText:f,newEol:a,range:m}of t)l.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:m&&M.Range.from(m),text:f,eol:a&&M.EndOfLine.from(a)}});if(l.edits.length!==0)return i===o.version?this.f.$tryApplyWorkspaceEdit(new p.$Bw(l)):Promise.reject(new Error("concurrent_edits"))})}}e.$xmc=$}),define(Pe[269],Ie([1,0,5,6,2,4,113,8,15,25,7]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class D{constructor(w,g){this.a=new I.$de,this.b=new I.$de,this.c=new I.$de,this.d=new I.$de,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=w.getProxy(M.$$M.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const g=this.g.getDocument(w);if(g)return g}getDocument(w){const g=this.getDocumentData(w);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return g.document}ensureDocumentData(w){const g=this.g.getDocument(w);if(g)return Promise.resolve(g);let r=this.h.get(w.toString());return r||(r=this.f.$tryOpenDocument(w).then(o=>{this.h.delete(w.toString());const s=R.URI.revive(o);return(0,$.$hg)(this.g.getDocument(s))},o=>(this.h.delete(w.toString()),Promise.reject(o))),this.h.set(w.toString(),r)),r}createDocumentData(w){return this.f.$tryCreateDocument(w).then(g=>R.URI.revive(g))}$acceptModelLanguageChanged(w,g){const r=R.URI.revive(w),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(g),this.a.fire(o.document)}$acceptModelSaved(w){const g=R.URI.revive(w),r=this.g.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(w,g){const r=R.URI.revive(w),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(g),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,g,r){const o=R.URI.revive(w),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(g);let i;g.isUndoing?i=T.TextDocumentChangeReason.Undo:g.isRedoing&&(i=T.TextDocumentChangeReason.Redo),this.c.fire((0,y.$4n)({document:s.document,contentChanges:g.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(w,g){(0,A.$BP)(w,g)}}e.$qlc=D}),define(Pe[67],Ie([1,0,270,5,15,2,3,4,17,8,7]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0,e.$Ulc=(0,A.$wi)("IExtHostEditorTabs");class D{constructor(o,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$XO(M.URI.revive(this.b.input.uri));case 2:return new T.$YO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new T.$ZO(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new T.$1O(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$2O(this.b.input.viewType);case 4:return new T.$3O(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$4O(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$5O;case 9:return new T.$6O(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$7O;case 11:return new T.$8O(this.b.input.diffEditors.map(o=>new T.$YO(M.URI.revive(o.original),M.URI.revive(o.modified))));default:return}}}class h{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const i of o.tabs)i.isActive&&(this.d=i.id),this.c.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return y.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(i=>i.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const i=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,i),o.tabDto.isActive&&(this.d=i.tabId),i}else if(o.kind===1){const i=this.c.splice(o.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(o.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,i),i}const s=this.c.find(i=>i.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(o){this.b=new O.$de,this.c=new O.$de,this.e=[],this.a=o.getProxy(p.$$M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(i=>i.apiObject))},get activeTabGroup(){const i=o.d;return(0,R.$hg)(o.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?g(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(a=>a.groupId)),i=new Set(o.map(a=>a.groupId)),n=(0,I.$L)(s,i),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],t=[];this.e=o.map(a=>{const m=new h(a,()=>this.d);return n.added.includes(m.groupId)?l.push(m.apiObject):t.push(m.apiObject),m});const f=(0,R.$hg)(o.find(a=>a.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:l,closed:c,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(o){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===o)return i}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const i=[];for(const n of o){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,s)}async j(o,s){const i=[];for(const n of o){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,s)}};e.$Vlc=w,e.$Vlc=w=Je([We(0,$.$zP)],w);function g(r){return r.tabs!==void 0}}),define(Pe[271],Ie([1,0,2,4,6,7,8,314,13,21,26,55]),function(le,e,I,O,R,M,A,p,$,y,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class h{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,i,n=14,c=14;for(const l of r){let t=s?(0,$.$zf)(s,l):0;for(t===0?i=1:i=c;t<l.length;t++)t+1===l.length?(n=c,c=9):c+=1,o.push([i,l.toUpperCase().charCodeAt(t),c]),o.push([i,l.toLowerCase().charCodeAt(t),c]),i=c;s=l,c=n}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$w3(o)}}provideDocumentLinks(r){this.c();const o=[],s=p.$x3.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of s){const n=A.DocumentLink.to(i);n.target&&o.push(n)}return o}}class w{constructor(r,o){this.i=o,this.b=new h,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(O.$$M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,i={}){if(w.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const n=this.h++;this.b.add(o),this.d.add(o),this.c.set(n,s);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,T.$PG)(r,"fsChunks"),c+=4);let l;i.isReadonly&&(0,D.$Vk)(i.isReadonly)&&i.isReadonly.value!==""&&(l={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,o,c,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(f)});const t=s.onDidChangeFile(f=>{const a=[];for(const m of f){const{uri:u,type:C}=m;if(u.scheme!==o)continue;let b;switch(C){case M.FileChangeType.Changed:b=0;break;case M.FileChangeType.Created:b=1;break;case M.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:u,type:b})}this.a.$onFileSystemChange(n,a)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:i,size:n,permissions:c}=r;return{type:o,ctime:s,mtime:i,size:n,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(I.URI.revive(o))).then(s=>w.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(I.URI.revive(o))).then(s=>y.$Fe.wrap(s))}$writeFile(r,o,s,i){return Promise.resolve(this.l(r).writeFile(I.URI.revive(o),s.buffer,i))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(I.URI.revive(o),s))}$rename(r,o,s,i){return Promise.resolve(this.l(r).rename(I.URI.revive(o),I.URI.revive(s),i))}$copy(r,o,s,i){const n=this.l(r);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(o),I.URI.revive(s),i))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,i){const n=this.l(r).watch(I.URI.revive(s),i);this.f.set(o,n)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,i){const n=this.l(r);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$Fe.alloc(i);return Promise.resolve(n.read(o,s,c.buffer,0,i)).then(l=>c.slice(0,l))}$write(r,o,s,i){const n=this.l(r);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(o,s,i.buffer,0,i.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$zmc=w}),define(Pe[272],Ie([1,0,5,37,2,4,8,7,43]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,g,r,o,s,i){this.a=Math.random(),this.b=new I.$de,this.c=new I.$de,this.d=new I.$de,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,O.$qk)(s),c=typeof s=="string",l=i?.correlate,t=o(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(l&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const a of f.created){const m=R.URI.revive(a);n(m.fsPath)&&(!c||g.getWorkspaceFolder(m))&&this.b.fire(m)}if(!i?.ignoreChangeEvents)for(const a of f.changed){const m=R.URI.revive(a);n(m.fsPath)&&(!c||g.getWorkspaceFolder(m))&&this.c.fire(m)}if(!i?.ignoreDeleteEvents)for(const a of f.deleted){const m=R.URI.revive(a);n(m.fsPath)&&(!c||g.getWorkspaceFolder(m))&&this.d.fire(m)}}});this.g=p.$aN.from(this.i(w,r,s,i,i?.correlate),this.b,this.c,this.d,t)}i(w,g,r,o,s){const i=p.$aN.from();if(typeof r=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const n=w.getProxy(M.$$M.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(O.$mk)||r.pattern.includes(O.$nk))&&(c=!0);let l;return s&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(l=14,o?.ignoreChangeEvents&&(l&=-3),o?.ignoreCreateEvents&&(l&=-5),o?.ignoreDeleteEvents&&(l&=-9)),n.$watch(g.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[],filter:l},!!s),p.$aN.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(w){this.a=w,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(R.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(w,g,r){this.j=w,this.k=g,this.l=r,this.a=new I.$de,this.b=new I.$de,this.c=new I.$de,this.d=new I.$de,this.g=new I.$fe,this.h=new I.$fe,this.i=new I.$fe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,g,r,o){return new y(this.j,w,g,this.a.event,A.GlobPattern.from(r),o)}$onFileEvent(w){this.a.fire(new T(w))}$onDidRunFileOperation(w,g){switch(w){case 2:this.b.fire(Object.freeze({files:g.map(r=>({oldUri:R.URI.revive(r.source),newUri:R.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(r=>R.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(r=>R.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,g){return(r,o,s)=>{const i=function(c){r.call(o,c)};return i.extension=w,g.event(i,void 0,s)}}async $onWillRunFileOperation(w,g,r,o){switch(w){case 2:return await this.n(this.g,{files:g.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:g.map(s=>R.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:g.map(s=>R.URI.revive(s.target))},r,o)}}async n(w,g,r,o){const s=new Set,i=[];if(await w.fireAsync(g,o,async(c,l)=>{const t=Date.now(),f=await Promise.resolve(c);f instanceof p.$kN&&(i.push([l.extension,f]),s.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",l.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:l}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(l)}return{edit:n,extensionNames:Array.from(s)}}}e.$Amc=D}),define(Pe[273],Ie([1,0,18,11,24,14,91,6,25,66,13,15,2,30,315,89,98,174,20,8,7,26,76,4]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class a{constructor(U,F){this.d=U,this.e=F}async provideDocumentSymbols(U,F){const G=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(G,F);if(!(0,I.$Kb)(H))return H[0]instanceof c.$uN?H.map(n.DocumentSymbol.from):a.f(H)}static f(U){U=U.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const F=[],G=[];for(const H of U){const ee={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),F.push(ee);break}const re=G[G.length-1];if(w.$ut.containsRange(re.range,ee.range)&&!w.$ut.equalsRange(re.range,ee.range)){re.children?.push(ee),G.push(ee);break}G.pop()}}return F}}class m{constructor(U,F,G,H,ee,re){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.l=re,this.d=new t.$hlc("CodeLens"),this.e=new Map}async provideCodeLenses(U,F){const G=this.f.getDocument(U),H=await this.h.provideCodeLenses(G,F);if(!H||F.isCancellationRequested)return;const ee=this.d.add(H),re=new p.$Tc;this.e.set(ee,re);const Oe={cacheId:ee,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Oe.lenses.push({cacheId:[ee,Ve],range:n.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,re)});return Oe}async resolveCodeLens(U,F){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,F),H||(H=G),F.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return U.command=this.g.toInternal(H.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function u(je){return Array.isArray(je)?je.map(n.DefinitionLink.from):je?[n.DefinitionLink.from(je)]:[]}class C{constructor(U,F){this.d=U,this.e=F}async provideDefinition(U,F,G){const H=this.d.getDocument(U),ee=n.Position.to(F),re=await this.e.provideDefinition(H,ee,G);return u(re)}}class b{constructor(U,F){this.d=U,this.e=F}async provideDeclaration(U,F,G){const H=this.d.getDocument(U),ee=n.Position.to(F),re=await this.e.provideDeclaration(H,ee,G);return u(re)}}class v{constructor(U,F){this.d=U,this.e=F}async provideImplementation(U,F,G){const H=this.d.getDocument(U),ee=n.Position.to(F),re=await this.e.provideImplementation(H,ee,G);return u(re)}}class d{constructor(U,F){this.d=U,this.e=F}async provideTypeDefinition(U,F,G){const H=this.d.getDocument(U),ee=n.Position.to(F),re=await this.e.provideTypeDefinition(H,ee,G);return u(re)}}class E{static{this.f=10}constructor(U,F){this.g=U,this.h=F,this.d=0,this.e=new Map}async provideHover(U,F,G,H){const ee=this.g.getDocument(U),re=n.Position.to(F);let Oe;if(G&&G.verbosityRequest){const xe=G.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:G.verbosityRequest.action,previousHover:et};Oe=await this.h.provideHover(ee,re,H,tt)}else Oe=await this.h.provideHover(ee,re,H);if(!Oe||(0,I.$Kb)(Oe.contents))return;Oe.range||(Oe.range=ee.getWordRangeAtPosition(re)),Oe.range||(Oe.range=new c.$cN(re,re));const Ve=n.Hover.from(Oe),Ge=this.d;if(this.e.size===E.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(Ge,Oe),this.d+=1,{...Ve,id:Ge}}releaseHover(U){this.e.delete(U)}}class k{constructor(U,F){this.d=U,this.e=F}async provideEvaluatableExpression(U,F,G){const H=this.d.getDocument(U),ee=n.Position.to(F),re=await this.e.provideEvaluatableExpression(H,ee,G);if(re)return n.EvaluatableExpression.from(re)}}class P{constructor(U,F){this.d=U,this.e=F}async provideInlineValues(U,F,G,H){const ee=this.d.getDocument(U),re=await this.e.provideInlineValues(ee,n.Range.to(F),n.InlineValueContext.to(G),H);if(Array.isArray(re))return re.map(Oe=>n.InlineValue.from(Oe))}}class S{constructor(U,F){this.d=U,this.e=F}async provideDocumentHighlights(U,F,G){const H=this.d.getDocument(U),ee=n.Position.to(F),re=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(re))return re.map(n.DocumentHighlight.from)}}class W{constructor(U,F){this.d=U,this.e=F}async provideMultiDocumentHighlights(U,F,G,H){const ee=this.d.getDocument(U),re=G.map(Ge=>this.d.getDocument(Ge)),Oe=n.Position.to(F),Ve=await this.e.provideMultiDocumentHighlights(ee,Oe,re,H);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class V{constructor(U,F){this.d=U,this.e=F}async provideLinkedEditingRanges(U,F,G){const H=this.d.getDocument(U),ee=n.Position.to(F),re=await this.e.provideLinkedEditingRanges(H,ee,G);if(re&&Array.isArray(re.ranges))return{ranges:(0,I.$Hb)(re.ranges.map(n.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(U,F){this.d=U,this.e=F}async provideReferences(U,F,G,H){const ee=this.d.getDocument(U),re=n.Position.to(F),Oe=await this.e.provideReferences(ee,re,G,H);if(Array.isArray(Oe))return Oe.map(n.location.from)}}class N{static{this.d=1e3}constructor(U,F,G,H,ee,re,Oe){this.g=U,this.h=F,this.j=G,this.k=H,this.l=ee,this.m=re,this.n=Oe,this.e=new t.$hlc("CodeAction"),this.f=new Map}async provideCodeActions(U,F,G,H){const ee=this.g.getDocument(U),re=g.$wt.isISelection(F)?n.Selection.to(F):n.Range.to(F),Oe=[];for(const tt of this.j.getDiagnostics(U))if(re.intersection(tt.range)&&Oe.push(tt)>N.d)break;const Ve={diagnostics:Oe,only:G.only?new c.$wN(G.only):void 0,triggerKind:n.CodeActionTriggerKind.to(G.trigger)},Ge=await this.k.provideCodeActions(ee,re,Ve,H);if(!(0,I.$Lb)(Ge)||H.isCancellationRequested)return;const _e=this.e.add(Ge),xe=new p.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<Ge.length;tt++){const it=Ge[tt];if(it)if(N.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Ve.only&&(it.kind?Ve.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(n.Diagnostic.from),edit:it.edit&&n.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,l.$OG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,l.$OG)(this.m,"codeActionRanges")?(0,I.$Hb)(at.map(n.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(U,F){const[G,H]=U,ee=this.e.get(G,H);if(!ee||N.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,F)??ee;let Oe;re.edit&&(Oe=n.WorkspaceEdit.from(re.edit,void 0));let Ve;if(re.command){const Ge=this.f.get(G);Ge&&(Ve=this.h.toInternal(re.command,Ge))}return{edit:Oe,command:Ve}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class B{constructor(U,F,G,H,ee){this.e=U,this.f=F,this.g=G,this.h=H,this.j=ee,this.d=new t.$hlc("DocumentPasteEdit")}async prepareDocumentPaste(U,F,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),re=F.map(Ge=>n.Range.to(Ge)),Oe=n.DataTransfer.toDataTransfer(G,()=>{throw new M.$$});if(await this.g.prepareDocumentPaste(ee,re,Oe,H),H.isCancellationRequested)return;const Ve=Array.from(Oe).filter(([,Ge])=>!(Ge instanceof c.$3N));return n.DataTransfer.from(Ve)}async providePasteEdits(U,F,G,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(F),Ve=G.map(et=>n.Range.to(et)),Ge=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,U,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Ve,Ge,{only:ee.only?new c.$8N(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,F){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,F){this.d=U,this.e=F}async provideDocumentFormattingEdits(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(H,F,G);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class ie{constructor(U,F){this.d=U,this.e=F}async provideDocumentRangeFormattingEdits(U,F,G,H){const ee=this.d.getDocument(U),re=n.Range.to(F),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,re,G,H);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,F,G,H){(0,D.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),re=F.map(n.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,re,G,H);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}}class ce{constructor(U,F){this.d=U,this.e=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,F,G,H,ee){const re=this.d.getDocument(U),Oe=n.Position.to(F),Ve=await this.e.provideOnTypeFormattingEdits(re,Oe,G,H,ee);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class ye{constructor(U,F){this.e=U,this.f=F,this.d=new t.$hlc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,F){const G=await this.e.provideWorkspaceSymbols(U,F);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let re=0;re<G.length;re++){const Oe=G[re];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Oe),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(U,F){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,F);return H&&(0,$.$6n)(U,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Se{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,F,G){this.d=U,this.e=F,this.f=G}async provideRenameEdits(U,F,G,H){const ee=this.d.getDocument(U),re=n.Position.to(F);try{const Oe=await this.e.provideRenameEdits(ee,re,G,H);return Oe?n.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Ve=Se.g(Oe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(U,F,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ee=n.Position.to(F);try{const re=await this.e.prepareRename(H,ee,G);let Oe,Ve;if(c.$cN.isRange(re)?(Oe=re,Ve=H.getText(re)):(0,D.$$f)(re)&&(Oe=re.range,Ve=re.placeholder),!Oe||!Ve)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Oe),text:Ve}}catch(re){const Oe=Se.g(re);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(re)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class fe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(U,F,G){this.e=U,this.f=F,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,F,G,H){const ee=this.e.getDocument(U),re=n.Range.to(F);try{const Oe=fe.d[G],Ve=await this.f.provideNewSymbolNames(ee,re,Oe,H);return Ve?Ve.map(Ge=>typeof Ge=="string"?{newSymbolName:Ge}:{newSymbolName:Ge.newSymbolName,tags:Ge.tags}):void 0}catch(Oe){this.g.error(fe.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class $e{constructor(U,F){this.resultId=U,this.tokens=F}}class Te{constructor(U,F){this.f=U,this.g=F,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,F,G){const H=this.f.getDocument(U),ee=F!==0?this.d.get(F):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(F),re?(re=Te.h(re),this.o(Te.n(ee,re),re)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return Te.j(U)?Te.k(U)?U:new c.$vO(new Uint32Array(U.data),U.resultId):Te.l(U)?Te.m(U)?U:new c.$xO(U.edits.map(F=>new c.$wO(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const F of U.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static n(U,F){if(!Te.j(F)||!U||!U.tokens)return F;const G=U.tokens,H=G.length,ee=F.data,re=ee.length;let Oe=0;const Ve=Math.min(H,re);for(;Oe<Ve&&G[Oe]===ee[Oe];)Oe++;if(Oe===H&&Oe===re)return new c.$xO([],F.resultId);let Ge=0;const _e=Ve-Oe;for(;Ge<_e&&G[H-Ge-1]===ee[re-Ge-1];)Ge++;return new c.$xO([{start:Oe,deleteCount:H-Oe-Ge,data:ee.subarray(Oe,re-Ge)}],F.resultId)}o(U,F){if(Te.j(U)){const G=this.e++;return this.d.set(G,new $e(U.resultId,U.data)),(0,o.$ccb)({id:G,type:"full",data:U.data})}if(Te.l(U)){const G=this.e++;return Te.j(F)?this.d.set(G,new $e(F.resultId,F.data)):this.d.set(G,new $e(U.resultId)),(0,o.$ccb)({id:G,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class ae{constructor(U,F){this.d=U,this.e=F}async provideDocumentRangeSemanticTokens(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(F),G);return ee?this.f(ee):null}f(U){return(0,o.$ccb)({id:0,type:"full",data:U.data})}}class Ne{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,F,G,H,ee){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.d=new t.$hlc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,F,G,H){const ee=this.f.getDocument(U),re=n.Position.to(F),Oe=ee.getWordRangeAtPosition(re)||new c.$cN(re,re),Ve=Oe.with({end:re}),Ge=new y.$_d,_e=await this.h.provideCompletionItems(ee,re,H,n.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$JN(_e):_e,et=Ne.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new p.$Tc;this.e.set(et,tt);const it=[],at={x:et,b:it,a:{replace:n.Range.from(Oe),insert:n.Range.from(Ve)},c:xe.isIncomplete||void 0,d:Ge.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const Ue=xe.items[gt],st=this.l(Ue,[et,gt],Ve,Oe);it.push(st)}return at}async resolveCompletionItem(U,F){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const H=this.l(G,U),ee=await this.h.resolveCompletionItem(G,F);if(!ee)return;const re=this.l(ee,U);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,$.$7n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,F,G,H){const ee=this.e.get(F[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(U.command,ee),Oe={x:F,a:U.label,b:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(n.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=U.textEdit.newText):typeof U.insertText=="string"?Oe.h=U.insertText:U.insertText instanceof c.$lN&&(Oe.h=U.insertText.value,Oe.i|=4);let Ve;return U.textEdit?Ve=U.textEdit.range:U.range&&(Ve=U.range),c.$cN.isRange(Ve)?Oe.j=n.Range.from(Ve):Ve&&(!G?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Oe.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Oe}}class ne{async provideInlineCompletions(U,F,G,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,F,G){}handlePartialAccept(U,F,G,H){}}class z extends ne{constructor(U,F,G,H){super(),this.f=U,this.g=F,this.h=G,this.j=H,this.d=new be,this.e=(0,l.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,l.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,F,G,H){const ee=this.g.getDocument(U),re=n.Position.to(F),Oe=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:n.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Ve=Array.isArray(Oe)?Oe:Oe.items,Ge=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Ve}),items:Ve.map((tt,it)=>{let at;tt.command&&(xe||(xe=new p.$Tc),at=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:at,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ge.map(tt=>(xe||(xe=new p.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,F,G){const H=this.d.get(U)?.items[F];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(U,F,G,H){const ee=this.d.get(U)?.items[F];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(U,F,G){const H=this.f.getDocument(U),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[F.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let re;const Oe=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Ve;ee.accepted&&(re||(re=new p.$Tc),Ve=this.h.toInternal(ee.accepted,re));let Ge;return ee.rejected&&(re||(re=new p.$Tc),Ge=this.h.toInternal(ee.rejected,re)),{pid:Oe,text:ee.text,range:n.Range.from(ee.range),accepted:Ve,rejected:Ge}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,F,G,H){this.f=F,this.g=G,this.h=H,this.d=new be,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const F=this.e++;return this.d.set(F,U),F}disposeReferenceId(U){const F=this.d.get(U);return this.d.delete(U),F}get(U){return this.d.get(U)}}class Fe{constructor(U,F){this.e=U,this.f=F,this.d=new t.$hlc("SignatureHelp")}async provideSignatureHelp(U,F,G,H){const ee=this.e.getDocument(U),re=n.Position.to(F),Oe=this.g(G),Ve=await this.f.provideSignatureHelp(ee,re,H,Oe);if(Ve){const Ge=this.d.add([Ve]);return{...n.SignatureHelp.from(Ve),id:Ge}}}g(U){let F;if(U.activeSignatureHelp){const G=n.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(F=H,F.activeSignature=G.activeSignature,F.activeParameter=G.activeParameter):F=G}return{...U,activeSignatureHelp:F}}releaseSignatureHelp(U){this.d.delete(U)}}class De{constructor(U,F,G,H,ee){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.d=new t.$hlc("InlayHints"),this.e=new Map}async provideInlayHints(U,F,G){const H=this.f.getDocument(U),ee=n.Range.to(F),re=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`);return}if(G.isCancellationRequested)return;const Oe=this.d.add(re);this.e.set(Oe,new p.$Tc);const Ve={hints:[],cacheId:Oe};for(let Ge=0;Ge<re.length;Ge++)this.l(re[Ge],ee)&&Ve.hints.push(this.m(re[Ge],[Oe,Ge]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`),Ve}async resolveInlayHint(U,F){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.h.resolveInlayHint(G,F);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,F){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(F&&!F.contains(U.position))}m(U,F){const G=this.e.get(F[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:F,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ee=[];H.label=ee;for(const re of U.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:re.value,tooltip:n.MarkdownString.fromStrict(re.tooltip)};c.$mN.isLocation(re.location)&&(Oe.location=n.location.from(re.location)),re.command&&(Oe.command=this.g.toInternal(re.command,G)),ee.push(Oe)}}return H}}class pe{constructor(U,F){this.e=U,this.f=F,this.d=new t.$hlc("DocumentLink")}async provideLinks(U,F){const G=this.e.getDocument(U),H=await this.f.provideDocumentLinks(G,F);if(!(!Array.isArray(H)||H.length===0)&&!F.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(pe.g).map(n.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Oe=0;Oe<H.length;Oe++){if(!pe.g(H[Oe]))continue;const Ve=n.DocumentLink.from(H[Oe]);Ve.cacheId=[ee,Oe],re.links.push(Ve)}return re}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,F){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.f.resolveDocumentLink(G,F);if(!(!H||!pe.g(H)))return n.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class ge{constructor(U,F){this.d=U,this.e=F}async provideColors(U,F){const G=this.d.getDocument(U),H=await this.e.provideDocumentColors(G,F);return Array.isArray(H)?H.map(re=>({color:n.Color.from(re.color),range:n.Range.from(re.range)})):[]}async provideColorPresentations(U,F,G){const H=this.d.getDocument(U),ee=n.Range.to(F.range),re=n.Color.to(F.color),Oe=await this.e.provideColorPresentations(re,{document:H,range:ee},G);if(Array.isArray(Oe))return Oe.map(n.ColorPresentation.from)}}class Q{constructor(U,F){this.d=U,this.e=F}async provideFoldingRanges(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(H,F,G);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class Y{constructor(U,F,G){this.d=U,this.e=F,this.f=G}async provideSelectionRanges(U,F,G){const H=this.d.getDocument(U),ee=F.map(n.Position.to),re=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Ve=0;Ve<ee.length;Ve++){const Ge=[];Oe.push(Ge);let _e=ee[Ve],xe=re[Ve];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(n.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Oe}}class he{constructor(U,F){this.f=U,this.g=F,this.d=new A.$EP(""),this.e=new Map}async prepareSession(U,F,G){const H=this.f.getDocument(U),ee=n.Position.to(F),re=await this.g.prepareCallHierarchy(H,ee,G);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,re)]}async provideCallsTo(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(re=>({from:this.h(U,re.from),fromRanges:re.fromRanges.map(Oe=>n.Range.from(Oe))}))}async provideCallsFrom(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(re=>({to:this.h(U,re.to),fromRanges:re.fromRanges.map(Oe=>n.Range.from(Oe))}))}releaseSession(U){this.e.delete(U)}h(U,F){const G=this.e.get(U),H=n.CallHierarchyItem.from(F,U,G.size.toString(36));return G.set(H._itemId,F),H}j(U,F){return this.e.get(U)?.get(F)}}class ue{constructor(U,F){this.f=U,this.g=F,this.d=new A.$EP(""),this.e=new Map}async prepareSession(U,F,G){const H=this.f.getDocument(U),ee=n.Position.to(F),re=await this.g.prepareTypeHierarchy(H,ee,G);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,re)]}async provideSupertypes(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(re=>this.h(U,re))}async provideSubtypes(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(re=>this.h(U,re))}releaseSession(U){this.e.delete(U)}h(U,F){const G=this.e.get(U),H=n.TypeHierarchyItem.from(F,U,G.size.toString(36));return G.set(H._itemId,F),H}j(U,F){return this.e.get(U)?.get(F)}}class Me{constructor(U,F,G,H,ee){this.e=U,this.f=F,this.g=G,this.h=H,this.j=ee,this.d=new t.$hlc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,F,G,H,ee){const re=this.f.getDocument(F),Oe=n.Position.to(G),Ve=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,et)).buffer),Ge=await this.g.provideDocumentDropEdits(re,Oe,Ve,ee);if(!Ge)return;const _e=(0,I.$2b)(Ge),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,F){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class de{constructor(U,F){this.d=U,this.e=F}async provideMappedEdits(U,F,G,H){const ee=h.URI.revive(U),re=this.d.getDocument(ee),Oe=G.documents.map(_e=>_e.map(xe=>({uri:h.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>n.Range.to(et))}))),Ve={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(re,F,Ve,H);return Ge?n.WorkspaceEdit.from(Ge):null}}class Ce{constructor(U,F){this.adapter=U,this.extension=F}}class Ae{static{this.d=0}constructor(U,F,G,H,ee,re,Oe,Ve){this.g=F,this.h=G,this.j=H,this.k=ee,this.l=re,this.m=Oe,this.n=Ve,this.f=new Map,this.e=U.getProxy(f.$$M.MainThreadLanguageFeatures)}o(U,F){return n.DocumentSelector.from(U,this.g,F)}p(U){return new c.$aN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ae.d++}async s(U,F,G,H,ee,re=!1){const Oe=this.f.get(U);if(!Oe||!(Oe.adapter instanceof F))return H;const Ve=Date.now();re||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ge=G(Oe.adapter,Oe.extension);return Promise.resolve(Ge).catch(_e=>{(0,M.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,O.$lh)(Ge,ee):Ge}t(U,F){const G=this.q();return this.f.set(G,new Ce(U,F)),G}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,F,G,H){const ee=this.t(new a(this.h,G),U),re=H&&H.label||Ae.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(F,U),re),this.p(ee)}$provideDocumentSymbols(U,F,G){return this.s(U,a,H=>H.provideDocumentSymbols(h.URI.revive(F),G),void 0,G)}registerCodeLensProvider(U,F,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new m(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(F,U),ee);let re=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(ee));re=c.$aN.from(re,Oe)}return re}$provideCodeLenses(U,F,G){return this.s(U,m,H=>H.provideCodeLenses(h.URI.revive(F),G),void 0,G)}$resolveCodeLens(U,F,G){return this.s(U,m,H=>H.resolveCodeLens(F,G),void 0,void 0)}$releaseCodeLenses(U,F){this.s(U,m,G=>Promise.resolve(G.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(U,F,G){const H=this.t(new C(this.h,G),U);return this.e.$registerDefinitionSupport(H,this.o(F,U)),this.p(H)}$provideDefinition(U,F,G,H){return this.s(U,C,ee=>ee.provideDefinition(h.URI.revive(F),G,H),[],H)}registerDeclarationProvider(U,F,G){const H=this.t(new b(this.h,G),U);return this.e.$registerDeclarationSupport(H,this.o(F,U)),this.p(H)}$provideDeclaration(U,F,G,H){return this.s(U,b,ee=>ee.provideDeclaration(h.URI.revive(F),G,H),[],H)}registerImplementationProvider(U,F,G){const H=this.t(new v(this.h,G),U);return this.e.$registerImplementationSupport(H,this.o(F,U)),this.p(H)}$provideImplementation(U,F,G,H){return this.s(U,v,ee=>ee.provideImplementation(h.URI.revive(F),G,H),[],H)}registerTypeDefinitionProvider(U,F,G){const H=this.t(new d(this.h,G),U);return this.e.$registerTypeDefinitionSupport(H,this.o(F,U)),this.p(H)}$provideTypeDefinition(U,F,G,H){return this.s(U,d,ee=>ee.provideTypeDefinition(h.URI.revive(F),G,H),[],H)}registerHoverProvider(U,F,G,H){const ee=this.t(new E(this.h,G),U);return this.e.$registerHoverProvider(ee,this.o(F,U)),this.p(ee)}$provideHover(U,F,G,H,ee){return this.s(U,E,re=>re.provideHover(h.URI.revive(F),G,H,ee),void 0,ee)}$releaseHover(U,F){this.s(U,E,G=>Promise.resolve(G.releaseHover(F)),void 0,void 0)}registerEvaluatableExpressionProvider(U,F,G,H){const ee=this.t(new k(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(F,U)),this.p(ee)}$provideEvaluatableExpression(U,F,G,H){return this.s(U,k,ee=>ee.provideEvaluatableExpression(h.URI.revive(F),G,H),void 0,H)}registerInlineValuesProvider(U,F,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new P(this.h,G),U);this.e.$registerInlineValuesProvider(re,this.o(F,U),ee);let Oe=this.p(re);if(ee!==void 0){const Ve=G.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(ee));Oe=c.$aN.from(Oe,Ve)}return Oe}$provideInlineValues(U,F,G,H,ee){return this.s(U,P,re=>re.provideInlineValues(h.URI.revive(F),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(U,F,G){const H=this.t(new S(this.h,G),U);return this.e.$registerDocumentHighlightProvider(H,this.o(F,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,F,G){const H=this.t(new W(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(F,U)),this.p(H)}$provideDocumentHighlights(U,F,G,H){return this.s(U,S,ee=>ee.provideDocumentHighlights(h.URI.revive(F),G,H),void 0,H)}$provideMultiDocumentHighlights(U,F,G,H,ee){return this.s(U,W,re=>re.provideMultiDocumentHighlights(h.URI.revive(F),G,H.map(Oe=>h.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,F,G){const H=this.t(new V(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(F,U)),this.p(H)}$provideLinkedEditingRanges(U,F,G,H){return this.s(U,V,async ee=>{const re=await ee.provideLinkedEditingRanges(h.URI.revive(F),G,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Ae.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,F,G){const H=this.t(new q(this.h,G),U);return this.e.$registerReferenceSupport(H,this.o(F,U)),this.p(H)}$provideReferences(U,F,G,H,ee){return this.s(U,q,re=>re.provideReferences(h.URI.revive(F),G,H,ee),void 0,ee)}registerCodeActionProvider(U,F,G,H){const ee=new p.$Tc,re=this.t(new N(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(re,this.o(F,U),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Ae.u(U),!!G.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(U,F,G,H,ee){return this.s(U,N,re=>re.provideCodeActions(h.URI.revive(F),G,H,ee),void 0,ee)}$resolveCodeAction(U,F,G){return this.s(U,N,H=>H.resolveCodeAction(F,G),{},void 0)}$releaseCodeActions(U,F){this.s(U,N,G=>Promise.resolve(G.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(U,F,G){const H=this.t(new K(this.h,G),U);return this.e.$registerDocumentFormattingSupport(H,this.o(F,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,F,G,H){return this.s(U,K,ee=>ee.provideDocumentFormattingEdits(h.URI.revive(F),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,F,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,G),U);return this.e.$registerRangeFormattingSupport(ee,this.o(F,U),U.identifier,U.displayName||U.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(U,F,G,H,ee){return this.s(U,ie,re=>re.provideDocumentRangeFormattingEdits(h.URI.revive(F),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,F,G,H,ee){return this.s(U,ie,re=>re.provideDocumentRangesFormattingEdits(h.URI.revive(F),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,F,G,H){const ee=this.t(new ce(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(F,U),H,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,F,G,H,ee,re){return this.s(U,ce,Oe=>Oe.provideOnTypeFormattingEdits(h.URI.revive(F),G,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(U,F){const G=this.t(new ye(F,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof F.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,F,G){return this.s(U,ye,H=>H.provideWorkspaceSymbols(F,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,F,G){return this.s(U,ye,H=>H.resolveWorkspaceSymbol(F,G),void 0,void 0)}$releaseWorkspaceSymbols(U,F){this.s(U,ye,G=>G.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(U,F,G){const H=this.t(new Se(this.h,G,this.l),U);return this.e.$registerRenameSupport(H,this.o(F,U),Se.supportsResolving(G)),this.p(H)}$provideRenameEdits(U,F,G,H,ee){return this.s(U,Se,re=>re.provideRenameEdits(h.URI.revive(F),G,H,ee),void 0,ee)}$resolveRenameLocation(U,F,G,H){return this.s(U,Se,ee=>ee.resolveRenameLocation(h.URI.revive(F),G,H),void 0,H)}registerNewSymbolNamesProvider(U,F,G){const H=this.t(new fe(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(F,U)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,fe,F=>F.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,F,G,H,ee){return this.s(U,fe,re=>re.provideNewSymbolNames(h.URI.revive(F),G,H,ee),void 0,ee)}registerDocumentSemanticTokensProvider(U,F,G,H){const ee=this.t(new Te(this.h,G),U),re=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(F,U),H,re);let Oe=this.p(ee);if(re){const Ve=G.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(re));Oe=c.$aN.from(Oe,Ve)}return Oe}$provideDocumentSemanticTokens(U,F,G,H){return this.s(U,Te,ee=>ee.provideDocumentSemanticTokens(h.URI.revive(F),G,H),null,H)}$releaseDocumentSemanticTokens(U,F){this.s(U,Te,G=>G.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,F,G,H){const ee=this.t(new ae(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(F,U),H),this.p(ee)}$provideDocumentRangeSemanticTokens(U,F,G,H){return this.s(U,ae,ee=>ee.provideDocumentRangeSemanticTokens(h.URI.revive(F),G,H),null,H)}registerCompletionItemProvider(U,F,G,H){const ee=this.t(new Ne(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(F,U),H,Ne.supportsResolving(G),U.identifier),this.p(ee)}$provideCompletionItems(U,F,G,H,ee){return this.s(U,Ne,re=>re.provideCompletionItems(h.URI.revive(F),G,H,ee),void 0,ee)}$resolveCompletionItem(U,F,G){return this.s(U,Ne,H=>H.resolveCompletionItem(F,G),void 0,G)}$releaseCompletionItems(U,F){this.s(U,Ne,G=>G.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(U,F,G,H){const ee=new z(U,this.h,G,this.j.converter),re=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(re,this.o(F,U),ee.supportsHandleEvents,i.$Rm.toKey(U.identifier.value),H?.yieldTo?.map(Oe=>i.$Rm.toKey(Oe))||[]),this.p(re)}$provideInlineCompletions(U,F,G,H,ee){return this.s(U,ne,re=>re.provideInlineCompletions(h.URI.revive(F),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(U,F,G,H){this.s(U,ne,async ee=>{ee.handleDidShowCompletionItem(F,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,F,G,H,ee){this.s(U,ne,async re=>{re.handlePartialAccept(F,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(U,F){this.s(U,ne,async G=>{G.disposeCompletions(F)},void 0,void 0)}registerInlineEditProvider(U,F,G){const H=new x(U,this.h,G,this.j.converter),ee=this.t(H,U);return this.e.$registerInlineEditProvider(ee,this.o(F,U),U.identifier),this.p(ee)}$provideInlineEdit(U,F,G,H){return this.s(U,x,ee=>ee.provideInlineEdits(h.URI.revive(F),G,H),void 0,H)}$freeInlineEdit(U,F){this.s(U,x,async G=>{G.disposeEdit(F)},void 0,void 0)}registerSignatureHelpProvider(U,F,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Fe(this.h,G),U);return this.e.$registerSignatureHelpProvider(re,this.o(F,U),ee),this.p(re)}$provideSignatureHelp(U,F,G,H,ee){return this.s(U,Fe,re=>re.provideSignatureHelp(h.URI.revive(F),G,H,ee),void 0,ee)}$releaseSignatureHelp(U,F){this.s(U,Fe,G=>G.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(U,F,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new De(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(F,U),typeof G.resolveInlayHint=="function",H,Ae.u(U));let re=this.p(ee);if(H!==void 0){const Oe=G.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));re=c.$aN.from(re,Oe)}return re}$provideInlayHints(U,F,G,H){return this.s(U,De,ee=>ee.provideInlayHints(h.URI.revive(F),G,H),void 0,H)}$resolveInlayHint(U,F,G){return this.s(U,De,H=>H.resolveInlayHint(F,G),void 0,G)}$releaseInlayHints(U,F){this.s(U,De,G=>G.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(U,F,G){const H=this.t(new pe(this.h,G),U);return this.e.$registerDocumentLinkProvider(H,this.o(F,U),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,F,G){return this.s(U,pe,H=>H.provideLinks(h.URI.revive(F),G),void 0,G,F.scheme==="output")}$resolveDocumentLink(U,F,G){return this.s(U,pe,H=>H.resolveLink(F,G),void 0,void 0,!0)}$releaseDocumentLinks(U,F){this.s(U,pe,G=>G.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(U,F,G){const H=this.t(new ge(this.h,G),U);return this.e.$registerDocumentColorProvider(H,this.o(F,U)),this.p(H)}$provideDocumentColors(U,F,G){return this.s(U,ge,H=>H.provideColors(h.URI.revive(F),G),[],G)}$provideColorPresentations(U,F,G,H){return this.s(U,ge,ee=>ee.provideColorPresentations(h.URI.revive(F),G,H),void 0,H)}registerFoldingRangeProvider(U,F,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new Q(this.h,G),U)),this.e.$registerFoldingRangeProvider(H,this.o(F,U),U.identifier,ee);let re=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$aN.from(re,Oe)}return re}$provideFoldingRanges(U,F,G,H){return this.s(U,Q,ee=>ee.provideFoldingRanges(h.URI.revive(F),G,H),void 0,H)}registerSelectionRangeProvider(U,F,G){const H=this.t(new Y(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(F,U)),this.p(H)}$provideSelectionRanges(U,F,G,H){return this.s(U,Y,ee=>ee.provideSelectionRanges(h.URI.revive(F),G,H),[],H)}registerCallHierarchyProvider(U,F,G){const H=this.t(new he(this.h,G),U);return this.e.$registerCallHierarchyProvider(H,this.o(F,U)),this.p(H)}$prepareCallHierarchy(U,F,G,H){return this.s(U,he,ee=>Promise.resolve(ee.prepareSession(h.URI.revive(F),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,F,G,H){return this.s(U,he,ee=>ee.provideCallsTo(F,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,F,G,H){return this.s(U,he,ee=>ee.provideCallsFrom(F,G,H),void 0,H)}$releaseCallHierarchy(U,F){this.s(U,he,G=>Promise.resolve(G.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(U,F,G){const H=this.t(new ue(this.h,G),U);return this.e.$registerTypeHierarchyProvider(H,this.o(F,U)),this.p(H)}$prepareTypeHierarchy(U,F,G,H){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(h.URI.revive(F),G,H)),void 0,H)}$provideTypeHierarchySupertypes(U,F,G,H){return this.s(U,ue,ee=>ee.provideSupertypes(F,G,H),void 0,H)}$provideTypeHierarchySubtypes(U,F,G,H){return this.s(U,ue,ee=>ee.provideSubtypes(F,G,H),void 0,H)}$releaseTypeHierarchy(U,F){this.s(U,ue,G=>Promise.resolve(G.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(U,F,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Me(this.e,this.h,G,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(F,U),(0,l.$OG)(U,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,F,G,H,ee,re){return this.s(U,Me,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(F,h.URI.revive(G),H,ee,re)),void 0,void 0)}$resolveDropEdit(U,F,G){return this.s(U,Me,H=>H.resolveDropEdit(F,G),{},void 0)}$releaseDropEdits(U,F){this.s(U,Me,G=>Promise.resolve(G.releaseDropEdits(F)),void 0,void 0)}registerMappedEditsProvider(U,F,G){const H=this.t(new de(this.h,G),U);return this.e.$registerMappedEditsProvider(H,this.o(F,U)),this.p(H)}$provideMappedEdits(U,F,G,H,ee){return this.s(U,de,re=>Promise.resolve(re.provideMappedEdits(F,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(U,F,G,H){const ee=this.q();return this.f.set(ee,new Ce(new B(this.e,this.h,G,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(F,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,F,G,H,ee){return this.s(U,B,re=>re.prepareDocumentPaste(h.URI.revive(F),G,H,ee),void 0,ee)}$providePasteEdits(U,F,G,H,ee,re,Oe){return this.s(U,B,Ve=>Ve.providePasteEdits(F,h.URI.revive(G),H,ee,re,Oe),void 0,Oe)}$resolvePasteEdit(U,F,G){return this.s(U,B,H=>H.resolvePasteEdit(F,G),{},void 0)}$releasePasteEdits(U,F){this.s(U,B,G=>Promise.resolve(G.releasePasteEdits(F)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Ae.w(U.decreaseIndentPattern),increaseIndentPattern:Ae.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ae.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ae.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Ae.w(U.beforeText),afterText:U.afterText?Ae.w(U.afterText):void 0,previousLineText:U.previousLineText?Ae.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Ae.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(F=>c.SyntaxTokenType.toString(F)):void 0}}static D(U){return U.map(Ae.C)}setLanguageConfiguration(U,F,G){const{wordPattern:H}=G;if(H&&(0,T.$jf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(F,H):this.h.setWordDefinitionFor(F,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),re={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,F,re),this.p(ee)}$setWordDefinitions(U){for(const F of U)this.h.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.$rlc=Ae}),define(Pe[90],Ie([1,0,6,4,8,7,103,20,11,5,175,108,14,3,17,86,12,42]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=void 0,e.$$lc=(0,w.$wi)("IExtHostLanguageModels");class n{constructor(f,a){this.option=f,this.stream=new $.$Zh,this.stream=a??new $.$Zh}}class c{constructor(){this.a=new Map,this.b=new $.$Zh,this.c=!1,this.d=!1;const f=this;this.apiObject={stream:f.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,f]of this.a)yield f.stream;else yield this.b}handleFragment(f){if(this.c)return;this.d=!0;let a=this.a.get(f.index);a||(this.a.size===0?a=new n(f.index,this.b):a=new n(f.index),this.a.set(f.index,a)),a.stream.emitOne(f.part)}get isStreaming(){return this.d}reject(f){this.c=!0;for(const a of this.f())a.reject(f)}resolve(){this.c=!0;for(const f of this.f())f.resolve()}}let l=class{static{i=this}static{this.a=1}constructor(f,a,m){this.j=a,this.k=m,this.c=new y.$de,this.d=new y.$de,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Tm,this.i=new Map,this.o=new Set,this.b=f.getProxy(O.$$M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(f,a,m,u){const C=i.a++;this.f.set(C,{extension:f.identifier,provider:m,languageModelId:a});let b;u.auth&&(b={providerLabel:f.displayName||f.name,accountLabel:typeof u.auth=="object"?u.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,a,{extension:f.identifier,identifier:a,name:u.name??"",version:u.version,tokens:u.tokens,auth:b});const v=m.onDidReceiveLanguageModelResponse2?.(({extensionId:d,participant:E,tokenCount:k})=>{this.b.$whenLanguageModelChatRequestMade(a,new p.$Rm(d),E,k)});return(0,I.$Sc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),v?.dispose()})}async $provideLanguageModelResponse(f,a,m,u,C,b){const v=this.f.get(f);if(!v)return;const d=new A.$dw(async E=>{if(b.isCancellationRequested){this.j.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:E.index,part:E.part})});return v.provider.provideLanguageModelResponse2(u.map(R.LanguageModelMessage.to),C,p.$Rm.toKey(m),d,b)}$provideTokenLength(f,a,m){const u=this.f.get(f);return u?Promise.resolve(u.provider.provideTokenCount(a,m)):Promise.resolve(0)}$updateLanguageModels(f){const a=[],m=[];if(f.added)for(const u of f.added)this.g.set(u.identifier,u),a.push(u.identifier);if(f.removed)for(const u of f.removed){this.g.delete(u),m.push(u);for(const[C,b]of this.i)b.languageModelId===u&&(b.res.reject(new h.$5),this.i.delete(C))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(m)})),f.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(f){const a=new Array;for(const{from:m,to:u,enabled:C}of f){const b=this.h.get(m)??new p.$Sm;if(b.has(u)!==C){C?b.add(u):b.delete(u),this.h.set(m,b);const d={from:m,to:u};a.push(d),this.c.fire(d)}}}async sendChatRequest(f,a,m,u,C){const b=f.identifier,v=await this.b.$prepareChatAccess(b,a,u.justification);if(!v||!this.g.has(a))throw M.$mP.NotFound(`Language model '${a}' is unknown.`);if(this.m(b,v)&&(!await this.l(f,{identifier:v.extension,displayName:v.auth.providerLabel},u.justification,u.silent)||!this.h.get(b)?.has(v.extension)))throw M.$mP.NoPermissions(`Language model '${a}' cannot be used by '${b.value}'.`);const d=Math.random()*1e6|0,E=this.b.$fetchResponse(b,a,d,m.map(R.LanguageModelMessage.from),u.modelOptions??{},C),k=new $.$vh,P=new c;this.i.set(d,{languageModelId:a,res:P});let S;if(E.catch(W=>{k.isOpen()?P.reject(W):S=W}).finally(()=>{this.i.delete(d),P.resolve(),k.open()}),await k.wait(),S)throw new M.$mP(`Language model '${a}' errored, check cause for more details`,"Unknown",S);return P.apiObject}async $handleResponseFragment(f,a){const m=this.i.get(f);m&&m.res.handleFragment(a)}async l(f,a,m,u){const C=D.$aM+a.identifier.value;if(await this.k.getSession(f,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0;if(u)return!1;try{const v=m?(0,T.localize)(0,null,a.displayName,m):(0,T.localize)(1,null,a.displayName);return await this.k.getSession(f,C,[],{forceNewSession:{detail:v}}),this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m(f,a){return!!a.auth&&!p.$Rm.equals(a.extension,f)}async n(f){for(const a of this.o)try{await this.l(a,{identifier:f.extension,displayName:""},void 0,!0)}catch(m){this.j.error("Fake Auth request failed"),this.j.error(m)}}async computeTokenLength(f,a,m){const u=this.g.get(f);if(!u)throw M.$mP.NotFound(`Language model '${f}' is unknown.`);const C=s.Iterable.find(this.f.values(),b=>b.languageModelId===f);return C?C.provider.provideTokenCount(a,m):this.b.$countTokens(u.identifier,typeof a=="string"?a:R.LanguageModelMessage.from(a),m)}getLanguageModelInfo(f){const a=this.g.get(f);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation(f){this.o.add(f);const a=this,m=y.Event.signal(y.Event.filter(this.c.event,C=>p.$Rm.equals(C.from,f.identifier))),u=y.Event.signal(this.d.event);return{get onDidChange(){return y.Event.any(m,u)},canSendRequest(C){const b=a.g.get(C);if(!b)return;if(!a.m(f.identifier,b))return!0;const v=a.h.get(f.identifier);if(v)return v.has(b.extension)}}}};e.$_lc=l,e.$_lc=l=i=Je([We(0,g.$zP),We(1,o.$3j),We(2,r.$tlc)],l)}),define(Pe[274],Ie([1,0,4,8,7,33,11,6,26]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class y{constructor(D,h,w,g){this.c=h,this.d=w,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(I.$$M.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,h){await this.a.$changeLanguage(D,h);const w=this.c.getDocumentData(D);if(!w)throw new Error(`document '${D.toString()}' NOT found`);return w.document}async tokenAtPosition(D,h){const w=D.version,g=O.Position.from(h),r=await this.a.$tokensAtPosition(D.uri,g),o={type:R.StandardTokenType.Other,range:D.getWordRangeAtPosition(h)??new R.$cN(h.line,h.character,h.line,h.character)};if(!r)return o;const s={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!s.range.contains(h)||w!==D.version?o:s}createLanguageStatusItem(D,h,w){const g=this.f++,r=this.a,o=this.g,s=`${D.identifier.value}/${h}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${h}' ALREADY exists`);o.add(s);const i={selector:w,id:h,name:D.displayName??D.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new p.$Tc,l=()=>{if(n?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${h}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.$yh)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:s,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===R.LanguageStatusSeverity.Error?M.default.Error:i.severity===R.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),r.$removeLanguageStatus(g),o.delete(s)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,l()},get selector(){return i.selector},set selector(f){i.selector=f,l()},get text(){return i.text},set text(f){i.text=f,l()},set text2(f){(0,$.$PG)(D,"languageStatusText"),i.text=f,l()},get text2(){return(0,$.$PG)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,l()},get severity(){return i.severity},set severity(f){i.severity=f,l()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,l()},get command(){return i.command},set command(f){i.command=f,l()},get busy(){return i.busy},set busy(f){i.busy=f,l()}};return l(),t}}e.$Qmc=y}),define(Pe[275],Ie([1,0,16,2,8,7,85]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=e.$Cmc=void 0;class p{constructor(D,h,w,g){this.start=D,this.deletedCount=h,this.deletedItems=w,this.items=g}asApiEvent(){return{range:new M.$CO(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,h,w){this.notebook=D,this.h=h,this.j=w,this.handle=w.handle,this.uri=O.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(R.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return D.g},set mime(g){D.g=g},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(w)}return this.f}setOutputs(D){this.a=D.map(R.NotebookCellOutput.to)}setOutputItems(D,h,w){const g=w.map(R.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===D);if(r&&(h||(r.items.length=0),r.items.push(...g),r.items.length>1&&r.items.every(o=>A.$7K(o.mime)))){const o=new Map,s=[];r.items.forEach(i=>{let n;o.has(i.mime)?n=o.get(i.mime):(n=[],o.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),r.items.length=0,s.forEach(i=>{const n=A.$8K(o.get(i));r.items.push({mime:i,data:n.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Cmc=$;class y{static{this.a=0}constructor(D,h,w,g,r){this.k=D,this.l=h,this.m=w,this.uri=g,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,h={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===I.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(w){return w=D.n(w),D.b[w].apiCell},getCells(w){return(w?D.p(w):D.b).map(r=>r.apiCell)},save(){return D.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,h,w){this.g=D.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:w});const g={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},r=[];for(const s of D.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,g.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,g.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const i=r[s],n=o.get(i.cell);if(n===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});o.set(i.cell,c-1)}else g.cellChanges[n]={...g.cellChanges[n],...i}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let h=D.start|0,w=D.end|0;return h<0&&(h=0),w>this.b.length&&(w=this.b.length),D.with({start:h,end:w})}p(D){D=this.o(D);const h=[];for(let w=D.start;w<D.end;w++)h.push(this.b[w]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,h,w){if(this.j)return;const g=[],r=[],o=[];if(D.reverse().forEach(s=>{const n=s[2].map(t=>{const f=new $(this,this.l,t);return h||r.push($.asModelAddData(t)),f}),c=new p(s[0],s[1],[],n),l=this.b.splice(s[0],s[1],...n);for(const t of l)o.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),w)for(const s of g)w.push(s.asApiEvent())}s(D,h,w,g){const r=this.b.splice(D,h);this.b.splice(w,0,...r);const o=[new p(D,h,r.map(s=>s.apiCell),[]),new p(w,0,[],r)];for(const s of o)g.push(s.asApiEvent())}t(D,h){this.b[D].setOutputs(h)}u(D,h,w,g){this.b[D].setOutputItems(h,w,g)}v(D,h){const w=this.b[D];w.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(w.uri,h)}w(D,h){const w=this.b[D];w.apiCell.mime=h}x(D,h){this.b[D].setMetadata(h)}y(D,h){this.b[D].setInternalMetadata(h)}getCellFromApiCell(D){return this.b.find(h=>h.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(h=>h.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Dmc=y}),define(Pe[276],Ie([1,0,5,2,8,7,35]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class p{constructor(y,T,D,h={timeout:1500,errors:3}){this.b=y,this.c=T,this.d=D,this.f=h,this.a=new I.$fe}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(T,D,h)=>{const w=function(r){T.call(D,r)};return w.extension=y,this.a.event(w,void 0,h)}}async $participateInSave(y,T,D){const h=O.URI.revive(y),w=this.c.getNotebookDocument(h);if(!w)throw new Error("Unable to resolve notebook document");const g=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:R.TextDocumentSaveReason.to(T)},D,async(o,s)=>{const i=Date.now(),n=await await Promise.resolve(o);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!D.isCancellationRequested&&n&&(n instanceof M.$kN?g.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),D.isCancellationRequested)return!1;if(g.length===0)return!0;const r={edits:[]};for(const o of g){const{edits:s}=R.WorkspaceEdit.from(o);r.edits=r.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new A.$Bw(r))}}e.$Smc=p}),define(Pe[114],Ie([1,0,14,8,7]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,$,y,T,D,h){this.id=p,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=T,this.c=h}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(R.$CO.isNotebookRange))throw(0,I.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,y){p.f.$tryRevealRange(p.id,O.NotebookRange.from($),y??R.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(O.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Emc=M}),define(Pe[277],Ie([1,0,5,12,8]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;let M=class{constructor(p,$){this.c=p,this.d=$,this.a=new I.$de,this.b=new I.$de,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,$);const y=this.d.getEditorById(p);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(R.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(R.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const $ in p)this.d.getEditorById($)._acceptViewColumn(R.ViewColumn.to(p[$]))}};e.$Umc=M,e.$Umc=M=Je([We(0,O.$3j)],M)}),define(Pe[278],Ie([1,0,5,4,114]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class M{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(O.$$M.MainThreadNotebookRenderers)}$postRendererMessage(p,$,y){const T=this.c.getEditorById(p);this.a.get($)?.fire({editor:T.apiEditor,message:y})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(T=>T.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(T,D,h)=>this.d($).event(T,D,h),postMessage:(T,D)=>{R.$Emc.apiEditorsToExtHost.has(T)&&([T,D]=[D,T]);const h=D&&R.$Emc.apiEditorsToExtHost.get(D);return this.b.$postMessage(h?.id,$,T)}}}d(p){let $=this.a.get(p);return $||($=new I.$de({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$Xmc=M}),define(Pe[279],Ie([1,0,8,103,24,69,14]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class p{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,h,w){const g=this.b++,{title:r,location:o,cancellable:s}=h,i={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(g,{location:I.ProgressLocation.from(o),title:r,source:i,cancellable:s},D.isUnderDevelopment?void 0:D.identifier.value).catch(A.$2),this.d(g,w,!!s)}d(D,h,w){let g;w&&(g=new R.$oe,this.c.set(D,g));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),g?.dispose()};let o;try{o=h(new y(this.a,D),w&&g?g.token:R.CancellationToken.None)}catch(s){throw r(D),s}return o.then(s=>r(D),s=>r(D)),o}$acceptProgressCanceled(D){const h=this.c.get(D);h&&(h.cancel(),this.c.delete(D))}}e.$2mc=p;function $(T,D){return T.message=D.message,typeof D.increment=="number"&&(typeof T.increment=="number"?T.increment+=D.increment:T.increment=D.increment),T}class y extends O.$dw{constructor(D,h){super(w=>this.throttledReport(w)),this.c=D,this.d=h}throttledReport(D){this.c.$progressReport(this.d,D)}}Je([(0,M.$3h)(100,(T,D)=>$(T,D),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(Pe[280],Ie([1,0,2,4,11,8]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;class A{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(O.$$M.MainThreadQuickDiff)}$provideOriginalResource($,y,T){const D=I.URI.revive(y),h=this.c.get($);return h?(0,R.$oh)(()=>h.provideOriginalResource(D,T)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider($,y,T,D){const h=A.a++;return this.c.set(h,y),this.b.$registerQuickDiffProvider(h,M.DocumentSelector.from($,this.d),T,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}e.$3mc=A}),define(Pe[281],Ie([1,0,24,5,6,4,2,7,14,18,33,36,26,8]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=g;function g(r,o,s){const i=r.getProxy(M.$$M.MainThreadQuickOpen);class n{constructor(b,v){this.e=new Map,this.f=0,this.a=b,this.b=v}showQuickPick(b,v,d,E=I.CancellationToken.None){this.c=void 0;const k=Promise.resolve(v),P=++this.f,S=i.$show(P,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},E),W={},V=S.then(()=>W);return Promise.race([V,k]).then(q=>{if(q===W)return;const N=(0,h.$OG)(b,"quickPickItemTooltip");return k.then(B=>{const K=[];for(let ie=0;ie<B.length;ie++){const ce=B[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!N&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const ye=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:N?w.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=ie=>{d.onDidSelectItem(B[ie])}),i.$setItems(P,K),S.then(ie=>{if(typeof ie=="number")return B[ie];if(Array.isArray(ie))return ie.map(ce=>B[ce])})})}).then(void 0,q=>{if(!(0,$.$4)(q))return i.$setError(P,q),Promise.reject(q)})}$onItemSelected(b){this.c?.(b)}showInput(b,v=I.CancellationToken.None){return this.d=b?.validateInput,i.$input(b,typeof this.d=="function",v).then(void 0,d=>{if(!(0,$.$4)(d))return Promise.reject(d)})}async $validateInput(b){if(!this.d)return;const v=await this.d(b);if(!v||typeof v=="string")return v;let d;switch(v.severity){case p.InputBoxValidationSeverity.Info:d=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:d=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:d=T.default.Error;break;default:d=v.message?T.default.Error:T.default.Ignore;break}return{content:v.message,severity:d}}async showWorkspaceFolderPick(b,v=I.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!d)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(k=>k.uri.toString()===d.uri.toString())}createQuickPick(b){const v=new m(b,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}createInputBox(b){const v=new u(b,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}$onDidChangeValue(b,v){this.e.get(b)?._fireDidChangeValue(v)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,v){const d=this.e.get(b);d instanceof m&&d._fireDidChangeActive(v)}$onDidChangeSelection(b,v){const d=this.e.get(b);d instanceof m&&d._fireDidChangeSelection(v)}$onDidTriggerButton(b,v){this.e.get(b)?._fireDidTriggerButton(v)}$onDidTriggerItemButton(b,v,d){const E=this.e.get(b);E instanceof m&&E._fireDidTriggerItemButton(v,d)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class c{static{this.a=1}constructor(b,v){this.x=b,this.y=v,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$de,this.q=new O.$de,this.r=new O.$de,this.s=new O.$de,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((v,d)=>{const E=v===p.$zO.Back?-1:d;this.o.set(E,v)}),this.z({buttons:b.map((v,d)=>({...a(v.iconPath),tooltip:v.tooltip,handle:v===p.$zO.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const v=this.o.get(b);v&&this.r.fire(v)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(b){if(!this.v){for(const v of Object.keys(b)){const d=b[v];this.u[v]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function l(C){if(C instanceof p.$0N)return{id:C.id};const b=f(C),v=t(C);return{dark:typeof b=="string"?A.URI.file(b):b,light:typeof v=="string"?A.URI.file(v):v}}function t(C){return typeof C=="object"&&"light"in C?C.light:C}function f(C){return typeof C=="object"&&"dark"in C?C.dark:C}function a(C){const b=l(C);let v,d;return"id"in b?d=D.ThemeIcon.asClassName(b):v=b,{iconPath:v,iconClass:d}}class m extends c{constructor(b,v){super(b.identifier,v),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$de,this.L=[],this.M=new O.$de,this.N=new O.$de,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((E,k)=>{this.C.set(k,E),this.D.set(E,k)});const v=(0,h.$OG)(this.O,"quickPickItemTooltip"),d=[];for(let E=0;E<b.length;E++){const k=b[E];if(k.kind===p.QuickPickItemKind.Separator)d.push({type:"separator",label:k.label});else{k.tooltip&&!v&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?a(k.iconPath):void 0;d.push({handle:E,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:v?w.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((S,W)=>({...a(S.iconPath),tooltip:S.tooltip,handle:W}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(v=>this.D.has(v)),this.z({activeItems:this.J.map(v=>this.D.get(v))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(v=>this.D.has(v)),this.z({selectedItems:this.L.map(v=>this.D.get(v))})}_fireDidChangeActive(b){const v=(0,y.$Hb)(b.map(d=>this.C.get(d)));this.J=v,this.K.fire(v)}_fireDidChangeSelection(b){const v=(0,y.$Hb)(b.map(d=>this.C.get(d)));this.L=v,this.M.fire(v)}_fireDidTriggerItemButton(b,v){const d=this.C.get(b);if(!d||!d.buttons||!d.buttons.length)return;const E=d.buttons[v];E&&this.N.fire({button:E,item:d})}}class u extends c{constructor(b,v){super(b.identifier,v),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:T.default.Error}):this.z({validationMessage:b.message,severity:b.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new n(o,s)}}),define(Pe[282],Ie([1,0,2,5,69,6,11,4,18,149,12,20,36,8,26,16,22]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=e.$5mc=void 0;function i(P){return P instanceof I.URI}function n(P,S){return P.scheme===r.Schemas.file&&S.scheme===r.Schemas.file&&o.$k?P.toString()===S.toString():P.toString().toLowerCase()===S.toString().toLowerCase()}function c(P){if(P)return typeof P.iconPath=="string"?I.URI.file(P.iconPath):I.URI.isUri(P.iconPath)||h.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function l(P){if(P.icon){if(I.URI.isUri(P.icon))return P.icon;if(h.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const S=P.icon;return{light:S.light,dark:S.dark}}}else return}function t(P,S){if(!P.iconPath&&!S.iconPath)return 0;if(P.iconPath){if(!S.iconPath)return 1}else return-1;const W=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,V=typeof S.iconPath=="string"?S.iconPath:I.URI.isUri(S.iconPath)?S.iconPath.fsPath:S.iconPath.id;return(0,y.$qr)(W,V)}function f(P,S){let W=0;if(P.strikeThrough!==S.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==S.faded)return P.faded?1:-1;if(P.tooltip!==S.tooltip)return(P.tooltip||"").localeCompare(S.tooltip||"");if(W=t(P,S),W!==0)return W;if(P.light&&S.light)W=t(P.light,S.light);else{if(P.light)return 1;if(S.light)return-1}if(W!==0)return W;if(P.dark&&S.dark)W=t(P.dark,S.dark);else{if(P.dark)return 1;if(S.dark)return-1}return W}function a(P,S){if(P.command!==S.command)return P.command<S.command?-1:1;if(P.title!==S.title)return P.title<S.title?-1:1;if(P.tooltip!==S.tooltip){if(P.tooltip!==void 0&&S.tooltip!==void 0)return P.tooltip<S.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(S.tooltip!==void 0)return-1}if(P.arguments===S.arguments)return 0;if(P.arguments)if(S.arguments){if(P.arguments.length!==S.arguments.length)return P.arguments.length-S.arguments.length}else return 1;else return-1;for(let W=0;W<P.arguments.length;W++){const V=P.arguments[W],q=S.arguments[W];if(V!==q&&!(i(V)&&i(q)&&n(V,q)))return V<q?-1:1}return 0}function m(P,S){let W=(0,y.$qr)(P.resourceUri.fsPath,S.resourceUri.fsPath,!0);if(W!==0)return W;if(P.command&&S.command)W=a(P.command,S.command);else{if(P.command)return 1;if(S.command)return-1}if(W!==0)return W;if(P.decorations&&S.decorations)W=f(P.decorations,S.decorations);else{if(P.decorations)return 1;if(S.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&S.multiFileDiffEditorModifiedUri)W=(0,y.$qr)(P.multiFileDiffEditorModifiedUri.fsPath,S.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(S.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&S.multiDiffEditorOriginalUri)W=(0,y.$qr)(P.multiDiffEditorOriginalUri.fsPath,S.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(S.multiDiffEditorOriginalUri)return-1}return W}function u(P,S){for(let W=0;W<P.length;W++)if(P[W]!==S[W])return!1;return!0}function C(P,S){return P.command===S.command&&P.title===S.title&&P.tooltip===S.tooltip&&(P.arguments&&S.arguments?u(P.arguments,S.arguments):P.arguments===S.arguments)}function b(P,S){return(0,$.$ub)(P,S,C)}class v{#e;#t;get value(){return this.d}set value(S){S=S??"",this.#e.$setInputBoxValue(this.l,S),this.n(S)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(S){this.#e.$setInputBoxPlaceholder(this.l,S),this.f=S}get validateInput(){return(0,g.$PG)(this.k,"scmValidation"),this.g}set validateInput(S){if((0,g.$PG)(this.k,"scmValidation"),S&&typeof S!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=S,this.#e.$setValidationProviderIsEnabled(this.l,!!S)}get enabled(){return this.h}set enabled(S){S=!!S,this.h!==S&&(this.h=S,this.#e.$setInputBoxEnablement(this.l,S))}get visible(){return this.j}set visible(S){S=!!S,this.j!==S&&(this.j=S,this.#e.$setInputBoxVisibility(this.l,S))}get document(){return(0,g.$PG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(S,W,V,q,N){this.k=S,this.l=q,this.m=N,this.d="",this.e=new O.$de,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(S,W){(0,g.$PG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,S,W)}$onInputBoxValueChange(S){this.n(S)}n(S){this.d=S,this.e.fire(S)}}e.$5mc=v;class d{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(S){this.v=S,this.q.$updateGroupLabel(this.t,this.handle,S)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(S){this.p=S,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(S){this.f=[...S],this.k.fire()}constructor(S,W,V,q,N,B,K){this.q=S,this.s=W,this.t=V,this.u=q,this.v=N,this.multiDiffEditorEnableViewChanges=B,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$de,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$de,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=d.d++}getResourceState(S){return this.g.get(S)}$executeResourceCommand(S,W){const V=this.h.get(S);return V?(0,A.$oh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const S=[...this.f].sort(m),V=(0,$.$Db)(this.o,S,m).map(B=>{const K=B.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ye=ie.resourceUri;let Se;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const ge=new M.$Tc;Se=this.s.converter.toInternal(ie.command,ge),this.j.set(ce,ge)}else this.h.set(ce,ie.command);const fe=(0,g.$OG)(this.w,"scmMultiDiffEditor"),$e=fe?ie.multiDiffEditorOriginalUri:void 0,Te=fe?ie.multiFileDiffEditorModifiedUri:void 0,ae=c(ie.decorations),Ne=ie.decorations&&c(ie.decorations.light)||ae,ne=ie.decorations&&c(ie.decorations.dark)||ae,z=[Ne,ne],x=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Fe=ie.decorations&&!!ie.decorations.faded,De=ie.contextValue||"";return{rawResource:[ce,ye,z,x,be,Fe,De,Se,$e,Te],handle:ce}});return{start:B.start,deleteCount:B.deleteCount,toInsert:K}}),q=V.map(({start:B,deleteCount:K,toInsert:ie})=>[B,K,ie.map(ce=>ce.rawResource)]),N=V.reverse();for(const{start:B,deleteCount:K,toInsert:ie}of N){const ce=ie.map(Se=>Se.handle),ye=this.n.splice(B,K,...ce);for(const Se of ye)this.g.delete(Se),this.h.delete(Se),this.j.get(Se)?.dispose(),this.j.delete(Se)}return this.o=S,q}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(S){this.g!==S&&(this.g=S,this.#e.$updateSourceControl(this.w,{count:S}))}get quickDiffProvider(){return this.h}set quickDiffProvider(S){this.h=S;let W;(0,g.$OG)(this.x,"quickDiffProvider")&&(W=S?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!S,quickDiffLabel:W})}get historyProvider(){return(0,g.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(S){(0,g.$PG)(this.x,"scmHistoryProvider"),this.j=S,this.k.value=new M.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!S}),S&&this.k.value.add(S.onDidChangeCurrentHistoryItemGroup(()=>{this.l=S?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(S){S!==this.m&&(this.m=S,this.#e.$updateSourceControl(this.w,{commitTemplate:S}))}get acceptInputCommand(){return this.o}set acceptInputCommand(S){this.n.value=new M.$Tc,this.o=S;const W=this.y.converter.toInternal(S,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,g.$PG)(this.x,"scmActionButton"),this.q}set actionButton(S){(0,g.$PG)(this.x,"scmActionButton"),this.p.value=new M.$Tc,this.q=S;const W=S!==void 0?{command:this.y.converter.toInternal(S.command,this.p.value),secondaryCommands:S.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:S.description,enabled:S.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(S){if(this.t&&S&&b(this.t,S))return;this.s.value=new M.$Tc,this.t=S;const W=(S||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(S,W,V,q,N,B,K){this.x=S,this.y=q,this.z=N,this.A=B,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Vc,this.m=void 0,this.n=new M.$Vc,this.o=void 0,this.p=new M.$Vc,this.s=new M.$Vc,this.t=void 0,this.u=!1,this.v=new O.$de,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new v(S,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,N,B,K,ie)}createResourceGroup(S,W,V){const q=(0,g.$OG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,N=new d(this.#e,this.y,this.w,S,W,q,this.x),B=O.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,B),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const S=[],W=[];for(const[V,q]of this.C){q.dispose();const N=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});O.Event.once(V.onDidDispose)(()=>{this.D.delete(V),N.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),S.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const B=V._takeResourceStateSnapshot();B.length>0&&W.push([V.handle,B]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,S,W),this.C.clear()}eventuallyUpdateResourceStates(){const S=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&S.push([W.handle,V])}),S.length>0&&this.#e.$spliceResourceStates(this.w,S),this.D.clear()}getResourceGroup(S){return this.e.get(S)}setSelectionState(S){this.u=S,this.v.fire(S)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(S=>S.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$2h)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$2h)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(S,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new D.$Tm,this.j=new O.$de,this.e=S.getProxy(p.$$M.MainThreadSCM),this.f=S.getProxy(p.$$M.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const B=this.g.get(N.sourceControlHandle);if(!B)return N;const K=B.getResourceGroup(N.groupHandle);return K?K.getResourceState(N.handle):N}else if(N&&N.$mid===4){const B=this.g.get(N.sourceControlHandle);return B?B.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const B=this.g.get(N.handle);return B||N}return N}})}createSourceControl(S,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",S.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:S.identifier.value});const N=s.d++,B=new E(S,this.m,this.e,this.l,W,V,q);this.g.set(N,B);const K=this.h.get(S.identifier)||[];return K.push(B),this.h.set(S.identifier,K),B}getLastInputBox(S){this.n.trace("ExtHostSCM#getLastInputBox",S.identifier.value);const W=this.h.get(S.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(S,W,V){const q=I.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",S,q.toString());const N=this.g.get(S);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$oh)(()=>N.quickDiffProvider.provideOriginalResource(q,V)).then(B=>B||null)}$onInputBoxValueChange(S,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",S);const V=this.g.get(S);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(S,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",S,W,V);const N=this.g.get(S);if(!N)return Promise.resolve(void 0);const B=N.getResourceGroup(W);return B?B.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(S,W,V){this.n.trace("ExtHostSCM#$validateInput",S);const q=this.g.get(S);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$oh)(()=>q.inputBox.validateInput(W,V)).then(N=>{if(!N)return Promise.resolve(void 0);const B=w.MarkdownString.fromStrict(N.message);return B?Promise.resolve([B,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(S){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",S),S!==void 0&&this.g.get(S)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=S,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(S,W,V,q){return await this.g.get(S)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(S,W,V,q){return(await this.g.get(S)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:l(K)}))??void 0}async $provideHistoryItemSummary(S,W,V,q){const N=this.g.get(S)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const B=await N.provideHistoryItemSummary(W,V,q);return B?{...B,icon:l(B)}:void 0}async $provideHistoryItemChanges(S,W,V,q){return await this.g.get(S)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$6mc=k,e.$6mc=k=s=Je([We(3,T.$3j)],k)}),define(Pe[283],Ie([1,0,4,8,2]),function(le,e,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class M{static{this.a=0}constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(I.$$M.MainThreadShare)}async $provideShare(p,$,y){return await this.c.get(p)?.provideShare({selection:O.Range.to($.selection),resourceUri:R.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(p,$){const y=M.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,O.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$7mc=M}),define(Pe[284],Ie([1,0,7,4,178,6,8,15]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$$N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$$N("statusBarItem.warningForeground")]])}#e;#t;constructor(h,w,g,r,o,s=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new M.$Tc,this.#e=h,this.#t=w,o&&r){this.c=(0,I.$MN)(r.identifier,o);const n=g.get(this.c);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(i)}u(h){if((0,p.$ag)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(h){this.k=h,this.v()}set name(h){this.m=h,this.v()}set tooltip(h){this.l=h,this.v()}set color(h){this.n=h,this.v()}set backgroundColor(h){h&&!$.b.has(h.id)&&(h=void 0),this.o=h,this.v()}set command(h){this.r?.fromApi!==h&&(this.p&&this.q.add(this.p),this.p=new M.$Tc,typeof h=="string"?this.r={fromApi:h,internal:this.#t.toInternal({title:"",command:h},this.p)}:h?this.r={fromApi:h,internal:this.#t.toInternal(h,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(h){this.t=h,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let w;this.m?w=this.m:w=(0,R.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=$.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,h,this.e?.identifier.value,w,this.k,r,this.r?.internal,g,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$9mc=$;class y{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const w={message:h};return this.b.unshift(w),this.c(),new I.$aN(()=>{const g=this.b.indexOf(w);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(h,w){this.e=new Map,this.a=h.getProxy(O.$$M.MainThreadStatusBar),this.b=w,this.c=new y(this)}$acceptStaticEntries(h){for(const w of h)this.e.set(w.entryId,w)}createStatusBarEntry(h,w,g,r){return new $(this.a,this.b,this.e,h,w,g,r)}setStatusBarMessage(h,w){const g=this.c.setMessage(h);let r;return typeof w=="number"?r=setTimeout(()=>g.dispose(),w):typeof w<"u"&&w.then(()=>g.dispose(),()=>g.dispose()),new I.$aN(()=>{g.dispose(),clearTimeout(r)})}}e.$0mc=T}),define(Pe[115],Ie([1,0,30,107,52,77,62,8,2]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$NP=e.$MP=e.$LP=void 0;const y=(n,c,l,t)=>{let f=c;return{enumerable:!0,configurable:!1,get(){return f},set(a){if(!l(f,a)){const m=f;f=a,n.listener?.(t(a,m))}}}},T=(n,c)=>n===c,D={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(n,c)=>!(n.length!==c.length||n.some(l=>!c.find(t=>l.id===t.id)))},h=n=>c=>({op:4,update:n(c)}),w=(n,c)=>({range:(()=>{let l;const t=h(f=>({range:I.$ut.lift(p.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return l},set(f){n.listener?.({op:6}),D.range(l,f)||(l=f,n.listener?.(t(f)))}}})(),label:y(n,c,D.label,h(l=>({label:l}))),description:y(n,void 0,D.description,h(l=>({description:l}))),sortText:y(n,void 0,D.sortText,h(l=>({sortText:l}))),canResolveChildren:y(n,!1,D.canResolveChildren,l=>({op:2,state:l})),busy:y(n,!1,D.busy,h(l=>({busy:l}))),error:y(n,void 0,D.error,h(l=>({error:p.MarkdownString.fromStrict(l)||null}))),tags:y(n,[],D.tags,(l,t)=>({op:1,new:l.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),g=n=>{const c=R.$WL.fromString(n.extId),l=new o(c.controllerId,c.localId,n.label,$.URI.revive(n.uri)||void 0);return l.range=p.Range.to(n.range||void 0),l.description=n.description||void 0,l.sortText=n.sortText||void 0,l.tags=n.tags.map(t=>p.TestTag.to({id:(0,A.$3L)(t).tagId})),l},r=n=>{let c;for(const l of n.tests){const t=g(l.item);(0,O.$vP)(t).parent=c,c=t}return c};e.$LP=r;class o{constructor(c,l,t,f){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,O.$uP)(this,c);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,M.$tP)(a,O.$vP,o),enumerable:!0,writable:!1},...w(a,t)})}}e.$MP=o;class s extends o{constructor(c,l){super(c,c,l,void 0),this._isRoot=!0}}e.$NP=s;class i extends M.$pP{constructor(c,l,t){super({controllerId:c,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:O.$vP,getChildren:f=>f.children,root:new s(c,l),toITestItem:p.TestItem.from})}}e.$OP=i}),define(Pe[32],Ie([1,0,15,7,8,25,4,18,12,49,30,94,2,6,3,17,115,21,35,44,66,59,63,34]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=void 0;let a=class{#e;#t;#i;constructor(d,E,k){this.b=new Map,this.c=new Map,this.#e=d.getProxy(A.$$M.MainThreadCommands),this.d=E,this.#i=k,this.#t=d.getProxy(A.$$M.MainThreadTelemetry),this.converter=new m(this,P=>{const S=this.c.get(P);return S?.result===C.Void?S:void 0},E),this.f=[{processArgument(P){return(0,y.$6h)(P)}},{processArgument(P){return(0,M.$5n)(P,function(S){if(T.$ut.isIRange(S))return R.Range.to(S);if(D.$tt.isIPosition(S))return R.Position.to(S);if(T.$ut.isIRange(S.range)&&h.URI.isUri(S.uri))return R.location.to(S);if(S instanceof s.$Fe)return S.buffer.buffer;if(!Array.isArray(S))return S})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const E=this.registerCommand(!1,d.id,async(...k)=>{const P=d.args.map((W,V)=>{if(!W.validate(k[V]))throw new Error(`Invalid argument '${W.name}' when running '${d.id}', received: ${typeof k[V]=="object"?JSON.stringify(k[V],null,"	"):k[V]} `);return W.convert(k[V])}),S=await this.executeCommand(d.internalId,...P);return d.result.convert(S,k,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new O.$aN(()=>{E.dispose(),this.c.delete(d.id)})}registerCommand(d,E,k,P,S,W){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:P,metadata:S,extension:W}),d&&this.#e.$registerCommand(E),new O.$aN(()=>{this.b.delete(E)&&d&&this.#e.$unregisterCommand(E)})}executeCommand(d,...E){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,E,!0)}async g(d,E,k){if(this.b.has(d))return this.#e.$fireCommandActivationEvent(d),this.h(d,E,!1);{let P=!1;const S=(0,M.$5n)(E,function(W){if(W instanceof O.$bN)return R.Position.from(W);if(W instanceof O.$cN)return R.Range.from(W);if(W instanceof O.$mN)return R.location.from(W);if(O.$CO.isNotebookRange(W))return R.NotebookRange.from(W);if(W instanceof ArrayBuffer)return P=!0,s.$Fe.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return P=!0,s.$Fe.wrap(W);if(W instanceof s.$Fe)return P=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(d,P?new i.$Bw(S):S,k);return(0,y.$6h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(d,E,!1);throw W}}}async h(d,E,k){const P=this.b.get(d);if(!P)throw new Error("Unknown command");const{callback:S,thisArg:W,metadata:V}=P;if(V?.args)for(let N=0;N<V.args.length;N++)try{(0,I.$ng)(E[N],V.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${V.args[N].name}' - ${V.args[N].description}`)}const q=c.$_d.create();try{return await S.apply(W,E)}catch(N){if(d===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...E);B&&(d=B.command)}if(this.d.error(N,d,P.extension?.identifier),!k)throw N;if(P.extension?.identifier){const B=this.#i.onExtensionError(P.extension.identifier,N);this.d.trace("forwarded error to extension?",B,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$hj)(N)),this.id=d,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,d,q.elapsed())}}j(d,E,k){d.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new l.$fp(E),duration:k})}$executeContributedCommand(d,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const k=this.b.get(d);return k?(E=E.map(P=>this.f.reduce((S,W)=>W.processArgument(S,k.extension?.identifier),P)),this.h(d,E,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),this.#e.$getCommands().then(E=>(d&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandMetadata(){const d=Object.create(null);for(const[E,k]of this.b){const{metadata:P}=k;P&&(d[E]=P)}return Promise.resolve(d)}};e.$UP=a,e.$UP=a=Je([We(0,r.$zP),We(1,$.$3j),We(2,t.$TP)],a),e.$VP=(0,g.$wi)("IExtHostCommands");class m{constructor(d,E,k){this.d=d,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${(0,f.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,E){if(!d)return;const k={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return k;const P=this.f(d.command);if(P)k.id=P.internalId,k.arguments=P.args.map((S,W)=>S.convert(d.arguments&&d.arguments[W]));else if((0,p.$Lb)(d.arguments)){const S=`${d.command} /${++this.c}`;this.b.set(S,d),E.add((0,w.$Sc)(()=>{this.b.delete(S),this.g.trace("CommandsConverter#DISPOSE",S)})),k.$ident=S,k.id=this.delegatingCommandId,k.arguments=[S],this.g.trace("CommandsConverter#CREATE",d.command,S)}return k}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const E=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.$WP=m;class u{static{this.Uri=new u("uri","Uri of a text document",d=>h.URI.isUri(d),d=>d)}static{this.Position=new u("position","A position in a text document",d=>O.$bN.isPosition(d),R.Position.from)}static{this.Range=new u("range","A range in a text document",d=>O.$cN.isRange(d),R.Range.from)}static{this.Selection=new u("selection","A selection in a text document",d=>O.$dN.isSelection(d),R.Selection.from)}static{this.Number=new u("number","",d=>typeof d=="number",d=>d)}static{this.String=new u("string","",d=>typeof d=="string",d=>d)}static{this.StringArray=u.Arr(u.String)}static Arr(d){return new u(`${d.name}_array`,`Array of ${d.name}, ${d.description}`,E=>Array.isArray(E)&&E.every(k=>d.validate(k)),E=>E.map(k=>d.convert(k)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",d=>d instanceof O.$yN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",d=>d instanceof O.$WO,R.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",d=>d instanceof o.$MP,R.TestItem.from)}constructor(d,E,k,P){this.name=d,this.description=E,this.validate=k,this.convert=P}optional(){return new u(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,E){return new u(d??this.name,E??this.description,this.validate,this.convert)}}e.$XP=u;class C{static{this.Void=new C("no result",d=>d)}constructor(d,E){this.description=d,this.convert=E}}e.$YP=C;class b{constructor(d,E,k,P,S){this.id=d,this.internalId=E,this.description=k,this.args=P,this.result=S}}e.$ZP=b}),define(Pe[285],Ie([1,0,18,16,2,89,98,31,32,8,7]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=void 0;const D=[new $.$ZP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of DocumentHighlight-instances.",w(y.DocumentHighlight.to))),new $.$ZP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$XP.Uri],new $.$YP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.$Kb)(r))return;class s extends T.$tN{static to(n){const c=new s(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new T.$mN(o[0],y.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=y.Range.to(n.selectionRange),c.children=n.children?n.children.map(s.to):[],c}}return r.map(s.to)})),new $.$ZP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$XP.Uri,new $.$XP("options","Formatting options",r=>!0,r=>r)],new $.$YP("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$ZP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$XP.Uri,$.$XP.Range,new $.$XP("options","Formatting options",r=>!0,r=>r)],new $.$YP("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$ZP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$XP.Uri,$.$XP.Position,new $.$XP("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$XP("options","Formatting options",r=>!0,r=>r)],new $.$YP("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$ZP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$ZP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$ZP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$ZP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",g)),new $.$ZP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location-instances.",w(y.location.to))),new $.$ZP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Hover-instances.",w(y.Hover.to))),new $.$ZP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$XP.Uri,new $.$XP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>T.$bN.isPosition(o)),r=>r.map(y.Position.from))],new $.$YP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const i of o.reverse())s=new T.$xN(y.Range.to(i),s);return s}))),new $.$ZP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$XP.String.with("query","Search string")],new $.$YP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(y.WorkspaceSymbol.to))),new $.$ZP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(y.CallHierarchyItem.to))),new $.$ZP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$XP.CallHierarchyItem],new $.$YP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(y.CallHierarchyIncomingCall.to))),new $.$ZP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$XP.CallHierarchyItem],new $.$YP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(y.CallHierarchyOutgoingCall.to))),new $.$ZP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:y.Range.to(r.range),placeholder:r.text}})),new $.$ZP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$XP.Uri,$.$XP.Position,$.$XP.String.with("newName","The new symbol name")],new $.$YP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return y.WorkspaceEdit.to(r)}})),new $.$ZP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$XP.Uri,$.$XP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$YP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(y.DocumentLink.to))),new $.$ZP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$XP.Uri],new $.$YP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$tO(r.tokenTypes,r.tokenModifiers)})),new $.$ZP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$XP.Uri],new $.$YP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$dcb)(r);if(o.type==="full")return new T.$vO(o.data,void 0)})),new $.$ZP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$XP.Uri,$.$XP.Range.optional()],new $.$YP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$tO(r.tokenTypes,r.tokenModifiers)})),new $.$ZP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$XP.Uri,$.$XP.Range],new $.$YP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$dcb)(r);if(o.type==="full")return new T.$vO(o.data,void 0)})),new $.$ZP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$XP.Uri,$.$XP.Position,$.$XP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$XP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$YP("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new T.$JN([]);const i=r.suggestions.map(n=>y.CompletionItem.to(n,s));return new T.$JN(i,r.incomplete)})),new $.$ZP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$XP.Uri,$.$XP.Position,$.$XP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$YP("A promise that resolves to SignatureHelp.",r=>{if(r)return y.SignatureHelp.to(r)})),new $.$ZP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$XP.Uri,$.$XP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$YP("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>w(i=>new T.$BN(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(r))),new $.$ZP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$XP.Uri,new $.$XP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.$cN.isRange(r),r=>T.$dN.isSelection(r)?y.Selection.from(r):y.Range.from(r)),$.$XP.String.with("kind","Code action kind to return code actions for").optional(),$.$XP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$YP("A promise that resolves to an array of Command-instances.",(r,o,s)=>w(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new T.$vN(i.title,i.kind?new T.$wN(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(r))),new $.$ZP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$XP.Uri],new $.$YP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new T.$PN(y.Range.to(o.range),y.Color.to(o.color))):[])),new $.$ZP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$XP("color","The color to show and insert",r=>r instanceof T.$ON,y.Color.from),new $.$XP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:y.Range.from(r.range)}))],new $.$YP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(y.ColorPresentation.to):[])),new $.$ZP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$XP.Uri,$.$XP.Range],new $.$YP("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(y.InlayHint.to.bind(void 0,s)))),new $.$ZP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$XP.Uri],new $.$YP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(y.FoldingRange.to)})),new $.$ZP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$YP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>y.NotebookExclusiveDocumentPattern.to(o))})))),new $.$ZP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$XP.Uri,$.$XP.Range,new $.$XP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof T.$cN,r=>y.InlineValueContext.from(r))],new $.$YP("A promise that resolves to an array of InlineValue objects",r=>r.map(y.InlineValue.to))),new $.$ZP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$XP("uriOrString","Uri-instance or string (only http/https)",r=>R.URI.isUri(r)||typeof r=="string"&&(0,O.$Gg)(r,O.Schemas.http,O.Schemas.https),r=>r),new $.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[y.ViewColumn.from(r),void 0]:[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)])).optional(),$.$XP.String.with("label","").optional()],$.$YP.Void),new $.$ZP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$XP.Uri.with("resource","Resource to open"),$.$XP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[y.ViewColumn.from(r),void 0]:[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)])).optional()],$.$YP.Void),new $.$ZP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$XP.Uri.with("left","Left-hand side resource of the diff editor"),$.$XP.Uri.with("right","Right-hand side resource of the diff editor"),$.$XP.String.with("title","Human readable title for the diff editor").optional(),new $.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)]).optional()],$.$YP.Void),new $.$ZP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$XP.String.with("title","Human readable title for the changes editor"),new $.$XP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,i,n]=o;if(!R.URI.isUri(s)||!R.URI.isUri(i)&&i!==void 0&&i!==null||!R.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],$.$YP.Void),new $.$ZP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new $.$ZP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$XP.TypeHierarchyItem],new $.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new $.$ZP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$XP.TypeHierarchyItem],new $.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new $.$ZP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$XP.TestItem],$.$YP.Void),new $.$ZP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$XP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$YP.Void),new $.$ZP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$XP.String.with("name","The context key name"),new $.$XP("value","The context key value",()=>!0,r=>r)],$.$YP.Void),new $.$ZP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$XP.Uri,$.$XP.StringArray,new $.$XP("MappedEditsContext","Mapped Edits Context",r=>y.MappedEditsContext.is(r),r=>y.MappedEditsContext.from(r))],new $.$YP("A promise that resolves to a workspace edit or null",r=>r?y.WorkspaceEdit.to(r):null))];class h{static register(o){D.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$vj)}}e.$slc=h;function w(r){return o=>{if(Array.isArray(o))return o.map(r)}}function g(r){if(!Array.isArray(r))return;const o=[];for(const s of r)M.$_t(s)?o.push(y.DefinitionLink.to(s)):o.push(y.location.to(s));return o}}),define(Pe[286],Ie([1,0,11,6,2,4,32,8,7]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;class y{static{this.a=0}constructor(w,g){this.extension=w,this.provider=g,this.handle=y.a++}}class T{constructor(w){this.session=w,this.responses=[]}}class D{static{this.a=0}constructor(w,g,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=w.getProxy(M.$$M.MainThreadInlineChat),g.registerApiCommand(new A.$ZP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$XP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?p.Range.from(s.initialRange):void 0,initialSelection:$.$dN.isSelection(s.initialSelection)?p.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?p.Position.from(s.position):void 0}})],A.$YP.Void))}registerProvider(w,g,r){const o=new y(w,g);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??w.displayName??w.name,w.identifier,typeof g.handleInteractiveEditorResponseFeedback=="function",typeof g.provideFollowups=="function",r?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(w,g,r,o){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(R.URI.revive(g)),n=p.Selection.to(r),c=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=D.a++;return this.d.set(l,new T(c)),{id:l,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(c.wholeRange),message:c.message}}async $provideResponse(w,g,r,o){const s=this.b.get(w);if(!s)return;const i=this.d.get(g.id);if(!i)return;const n={prompt:r.prompt,selection:p.Selection.to(r.selection),wholeRange:p.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(R.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let c=!1;const l={report:async v=>{if(!r.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:v.message,edits:v.edits?.map(p.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:$.$CN.isMarkdownString(v.content)?v.content.value:v.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,l,o));let f;try{f=await(0,I.$kh)(t,o)}finally{c=!0}if(!f)return;const a=i.responses.push(f)-1,m={wholeRange:p.Range.from(f.wholeRange),placeholder:f.placeholder};if(!D.h(f))return{...m,id:a,type:"editorEdit",message:p.MarkdownString.from(f.contents),edits:[]};const{edits:u,contents:C}=f,b=C!==void 0?p.MarkdownString.from(C):void 0;return u instanceof $.$kN?{...m,id:a,type:"bulkEdit",edits:p.WorkspaceEdit.from(u),message:b}:{...m,id:a,type:"editorEdit",edits:u.map(p.TextEdit.from),message:b}}async $provideFollowups(w,g,r,o){const s=this.b.get(w),i=this.d.get(g),n=i?.responses[r];if(s&&n&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(i.session,n,o));return(await(0,I.$kh)(c,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(w,g,r,o){const s=this.b.get(w),i=this.d.get(g),n=i?.responses[r];if(s&&n){const c=p.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,c)}}$releaseSession(w,g){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$Bmc=D}),define(Pe[287],Ie([1,0,2,32]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class R{constructor(A,p,$,y,T){this.a=p,this.b=$,this.c=y;const D=new O.$ZP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$XP("showOptions","Show Options",h=>!0,h=>h),new O.$XP("resource","Interactive resource Uri",h=>!0,h=>h),new O.$XP("controllerId","Notebook controller Id",h=>!0,h=>h),new O.$XP("title","Interactive editor title",h=>!0,h=>h)],new O.$YP("Notebook and input URI",h=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const w=this.a.getEditorById(h.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:I.URI.revive(h.notebookUri),inputUri:I.URI.revive(h.inputUri),notebookEditor:w.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:I.URI.revive(h.notebookUri),inputUri:I.URI.revive(h.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,p,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Omc=R}),define(Pe[288],Ie([1,0,18,11,24,5,6,28,2,20,12,4,32,8,7,78,229,26,35,230]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0,e.$Wmc=u;let c=class{constructor(b,v,d,E,k){this.m=v,this.n=d,this.o=E,this.q=k,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$de,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(D.$$M.MainThreadNotebookKernels);const P=new h.$ZP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new h.$XP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],h.$YP.Void),S=new h.$ZP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[h.$XP.Uri],new h.$YP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(S)}createNotebookController(b,v,d,E,k,P){for(const ae of this.j.values())if(ae.controller.id===v&&y.$Rm.equals(b.identifier,ae.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const S=this.k++,W=this;this.q.trace(`NotebookController[${S}], CREATED by ${b.identifier.value}, ${v}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${b.identifier}'`);let q=!1;const N=new M.$de,B=new M.$de,K={id:u(b.identifier,v),notebookType:d,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:E||b.identifier.value,preloads:P?P.map(w.NotebookRendererScript.from):[]};let ie=k??V,ce,ye;this.a.$addKernel(S,K).catch(ae=>{console.log(ae),q=!0});let Se=0;const fe=()=>{if(q)return;const ae=++Se;Promise.resolve().then(()=>{ae===Se&&this.a.$updateKernel(S,K)})},$e=new p.$Ac,Te={get id(){return v},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return K.label},set label(ae){K.label=ae??b.displayName??b.name,fe()},get detail(){return K.detail??""},set detail(ae){K.detail=ae,fe()},get description(){return K.description??""},set description(ae){K.description=ae,fe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ae){K.supportedLanguages=ae,fe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){K.supportsExecutionOrder=ae,fe()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ae){ie=ae??V},get interruptHandler(){return ce},set interruptHandler(ae){ce=ae,K.supportsInterrupt=!!ae,fe()},set variableProvider(ae){(0,s.$PG)(b,"notebookVariableProvider"),ye=ae,K.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ne=>W.a.$variablesUpdated(Ne.uri)),fe()},get variableProvider(){return ye},createNotebookCellExecution(ae){if(q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.notebook.uri))throw W.q.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,u(b.identifier,this.id))},createNotebookExecution(ae){if((0,s.$PG)(b,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.uri))throw W.q.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return W._createNotebookExecution(ae,u(b.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${S}], DISPOSED`),q=!0,this.j.delete(S),N.dispose(),B.dispose(),this.a.$removeKernel(S))},updateNotebookAffinity(ae,Ne){Ne===g.NotebookControllerAffinity2.Hidden&&(0,s.$PG)(b,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(S,ae.uri,Ne)},onDidReceiveMessage:B.event,postMessage(ae,Ne){return(0,s.$PG)(b,"notebookMessaging"),W.a.$postMessage(S,Ne&&W.n.getIdByEditor(Ne),ae)},asWebviewUri(ae){return(0,s.$PG)(b,"notebookMessaging"),(0,r.$NAb)(ae,W.m.remote)}};return this.j.set(S,{extensionId:b.identifier,controller:Te,onDidReceiveMessage:B,onDidChangeSelection:N,associatedNotebooks:$e}),Te}getIdByController(b){for(const[v,d]of this.j)if(d.controller===b)return u(d.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,v){const d=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${d}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(d,v);const k={dispose:()=>{this.f.delete(d),E.a.$removeKernelDetectionTask(d)}};return this.f.set(d,k),k}registerKernelSourceActionProvider(b,v,d){const E=this.i++,k=typeof d.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,P=this;this.h.set(E,d),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,v);let S;return k!==void 0&&(S=d.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(E),P.a.$removeKernelSourceActionProvider(E,E),S?.dispose()}}}async $provideKernelSourceActions(b,v){const d=this.h.get(b);if(d){const E=new A.$Tc;return(await d.provideNotebookKernelSourceActions(v)??[]).map(P=>w.NotebookKernelSourceAction.from(P,this.o.converter,E))}return[]}$acceptNotebookAssociation(b,v,d){const E=this.j.get(b);if(E){const k=this.n.getNotebookDocument($.URI.revive(v));d?E.associatedNotebooks.set(k.uri,!0):E.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,k.uri.toString(),d),E.onDidChangeSelection.fire({selected:d,notebook:k.apiNotebook})}}async $executeCells(b,v,d){const E=this.j.get(b);if(!E)return;const k=this.n.getNotebookDocument($.URI.revive(v)),P=[];for(const S of d){const W=k.getCell(S);W&&P.push(W.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,k.uri.toString(),P.length),await E.controller.executeHandler.call(E.controller,P,k.apiNotebook,E.controller)}catch(S){this.q.error(`NotebookController[${b}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(b,v,d){const E=this.j.get(b);if(!E)return;const k=this.n.getNotebookDocument($.URI.revive(v));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,k.apiNotebook);else for(const P of d){const S=k.getCell(P);S&&this.b.get(S.uri)?.cancel()}if(E.controller.interruptHandler){const P=this.c.get(k.uri);this.c.delete(k.uri),d.length&&Array.isArray(P)&&P.length&&P.forEach(S=>S.dispose())}}async $provideVariables(b,v,d,E,k,P,S){const W=this.j.get(b);if(!W)return;const V=this.n.getNotebookDocument($.URI.revive(d)),q=W.controller.variableProvider;if(!q)return;let N;if(E!==void 0){if(N=this.s[E],!N)return}else this.s={};const B=k==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,N,B,P,S);let ie=0;for await(const ce of K){if(S.isCancellationRequested)return;const ye={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[ye.id]=ce.variable,this.a.$receiveVariable(v,ye),ie++>=n.$hjb)return}}$acceptKernelMessageFromRenderer(b,v,d){const E=this.j.get(b);if(!E)return;const k=this.n.getEditorById(v);E.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:d}))}$cellExecutionChanged(b,v,d){const k=this.n.getNotebookDocument($.URI.revive(b)).getCell(v);if(k){const P=d?w.NotebookCellExecutionState.to(d):g.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:k.apiCell,state:P})}}_createNotebookCellExecution(b,v){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const k=new t(v,E,this.a);this.b.set(E.uri,k);const P=k.onDidChangeState(()=>{k.state===l.Resolved&&(k.dispose(),P.dispose(),this.b.delete(E.uri))});return k.asApiObject()}_createNotebookExecution(b,v){const d=this.n.getNotebookDocument(b.uri),E=b.getCells().find(S=>{const W=d.getCellFromApiCell(S);return W&&this.b.has(W.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(d.uri))throw new Error(`duplicate notebook execution for ${d.uri}`);const k=new a(v,d,this.a),P=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),P.dispose(),this.c.delete(d.uri))});return this.c.set(d.uri,[k,P]),k.asApiObject()}};e.$Vmc=c,e.$Vmc=c=Je([We(4,T.$3j)],c);var l;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(l||(l={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(b,v,d){super(),this.m=v,this.n=d,this.b=t.a++,this.c=new M.$de,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new R.$oe),this.h=new m(10,E=>this.s(E)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const v=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new i.$Bw(v))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let v=this.m;if(b&&(v=this.m.notebook.getCellFromApiCell(b)),!v)throw new Error("INVALID cell");return v.handle}y(b){return b.map(v=>{const d=g.$GO.ensureUniqueMimeTypes(v.items,!0);return d===v.items?w.NotebookCellOutput.from(v):w.NotebookCellOutput.from({items:d,id:v.id,metadata:v.metadata})})}async z(b,v,d){const E=this.w(v),k=this.y((0,I.$2b)(b));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:E,append:d,outputs:k})}async C(b,v,d){return b=g.$GO.ensureUniqueMimeTypes((0,I.$2b)(b),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:b.map(w.NotebookCellOutputItem.from),outputId:v.id,append:d})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(d){b.j=d,b.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(d){if(b.f===l.Resolved||b.f===l.Started)throw new Error("Cannot call start again");b.f=l.Started,b.c.fire(),b.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,E,k){if(b.f===l.Resolved)throw new Error("Cannot call resolve twice");b.f=l.Resolved,b.c.fire(),b.h.flush();const P=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;b.n.$completeExecution(b.b,new i.$Bw({runEndTime:E,lastRunSuccess:d,error:P}))},clearOutput(d){return b.t(),b.z([],d,!1)},appendOutput(d,E){return b.t(),b.z(d,E,!0)},replaceOutput(d,E){return b.t(),b.z(d,E,!1)},appendOutputItems(d,E){return b.t(),b.C(d,E,!0)},replaceOutputItems(d,E){return b.t(),b.C(d,E,!1)}})}}var f;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(f||(f={}));class a extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(b,v,d){super(),this.h=v,this.j=d,this.b=a.a++,this.c=new M.$de,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new R.$oe),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(b,v){this.f=b,this.g=v,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new O.$Th,this.b=Date.now(),(0,O.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const v=this.a;return this.a=[],this.g(v).finally(()=>b.complete())}}function u(C,b){return`${C.value}/${b}`}}),define(Pe[53],Ie([1,0,5,4,3,2,17,6,7,180,14,208,24,34,209,36,11,8,32]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=e.$8lc=e.$7lc=void 0,e.$7lc=(0,R.$wi)("IExtHostTerminalService");class n extends p.$Uc{constructor(d,E,k,P){super(),this.u=d,this._id=E,this.w=k,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$de),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const S=this;this.value={get name(){return S.y||""},get processId(){return S.b},get creationOptions(){return S.w},get exitStatus(){return S.j},get state(){return S.m},get selection(){return S.n},get shellIntegration(){return S.shellIntegration},sendText(W,V=!0){S.C(),S.u.$sendText(S._id,W,V)},show(W){S.C(),S.u.$show(S._id,W)},hide(){S.C(),S.u.$hide(S._id)},dispose(){S.a||(S.a=!0,S.u.$dispose(S._id))},get dimensions(){if(!(S.f===void 0||S.h===void 0))return{columns:S.f,rows:S.h}}}}dispose(){this.s.fire(),super.dispose()}async create(d,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??E?.cwd??void 0,env:d.env??void 0,icon:u(d.iconPath)??void 0,color:r.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(d.location,E?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,E,k,P,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:r.ThemeColor.isThemeColor(S)?S.id:void 0,location:E?.location||this.z(d,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(d,E){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in d?{viewColumn:s.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.y=d}setExitStatus(d,E){this.j=Object.freeze({code:d,reason:E})}setDimensions(d,E){return d===this.f&&E===this.h||d===0||E===0?!1:(this.f=d,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(d){this.n=d}_setProcessId(d){this.g?(this.g(d),this.g=void 0):this.b.then(E=>{E!==d&&(this.b=Promise.resolve(d))})}}e.$8lc=n;class c{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new I.$de,this.onProcessData=this.a.event,this.b=new I.$de,this.d=new I.$de,this.onDidChangeProperty=this.d.event,this.f=new I.$de,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,E){this.g.setDimensions?.({columns:d,rows:E})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,E,k){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$de,this.onDidCloseTerminal=this.H.event,this.I=new I.$de,this.onDidOpenTerminal=this.I.event,this.J=new I.$de,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$de,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$de,this.onDidChangeTerminalState=this.M.event,this.N=new I.$de,this.onDidChangeShell=this.N.event,this.O=new I.$de({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$de({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$$M.MainThreadTerminalService),this.y=new g.$Fvb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:P=>{const S=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(P?.$mid){case 15:return S(P);default:{if(Array.isArray(P))for(let W=0;W<P.length&&P[W].$mid===15;W++)P[W]=S(P[W]);return P}}}}),this.B({dispose:()=>{for(const[P,S]of this.g)S.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,E){const k=new n(this.a,(0,w.$Sg)(),d,d.name),P=new c(d.pty);return k.createExtensionTerminal(d.location,E,this.R(d,E).resolvedExtHostIdentifier,u(d.iconPath),C(d.color)).then(S=>{const W=this.S(S,P);this.h[S]=W}),this.f.push(k),k.value}R(d,E){if(E=E||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const k=d.location.parentTerminal;if(k){const P=this.f.find(S=>S.value===k);P&&(E.resolvedExtHostIdentifier=P._id)}}else d.location&&typeof d.location!="object"?E.location=d.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(d,E){if(!this.getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const P=new c(E),S=this.S(d,P);this.h[d]=S}async $acceptActiveTerminalChanged(d){const E=this.b;if(d===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(d);k&&(this.b=k,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,E){const k=this.getTerminalById(d);k&&this.O.fire({terminal:k.value,data:E})}async $acceptTerminalDimensions(d,E,k){const P=this.getTerminalById(d);P&&P.setDimensions(E,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(d,E){const k=this.getTerminalById(d);k&&this.P.fire({terminal:k.value,...E})}async $acceptTerminalMaximumDimensions(d,E,k){this.g.get(d)?.resize(E,k)}async $acceptTerminalTitleChange(d,E){const k=this.getTerminalById(d);k&&(k.name=E)}async $acceptTerminalClosed(d,E,k){const P=this.X(this.f,d);if(P!==null){const S=this.f.splice(P,1)[0];S.setExitStatus(E,k),this.H.fire(S.value)}}$acceptTerminalOpened(d,E,k,P){if(E){const V=this.X(this.f,E);if(V!==null){this.f[V]._id=d,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const S={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},W=new n(this.a,d,S,k);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(d,E){this.getTerminalById(d)?._setProcessId(E)}async $startExtensionTerminal(d,E){const k=this.getTerminalById(d);if(!k)return{message:(0,y.localize)(0,null,d)};k.isOpen||await new Promise(S=>{const W=this.onDidOpenTerminal(async V=>{V===k.value&&(W.dispose(),S())})});const P=this.g.get(d);P?P.startSendingEvents(E):this.j[d]={initialDimensions:E}}S(d,E){const k=new p.$Tc;k.add(E.onProcessReady(S=>this.a.$sendProcessReady(d,S.pid,S.cwd,S.windowsPty))),k.add(E.onDidChangeProperty(S=>this.a.$sendProcessProperty(d,S))),this.y.startBuffering(d,E.onProcessData),k.add(E.onProcessExit(S=>this.U(d,S))),this.g.set(d,E);const P=this.j[d];return P&&E instanceof c&&(E.startSendingEvents(P.initialDimensions),delete this.j[d]),k}$acceptProcessAckDataEvent(d,E){this.g.get(d)?.acknowledgeDataEvent(E)}$acceptProcessInput(d,E){this.g.get(d)?.input(E)}$acceptTerminalInteraction(d){const E=this.getTerminalById(d);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(d,E){this.getTerminalById(d)?.setSelection(E)}$acceptProcessResize(d,E,k){try{this.g.get(d)?.resize(E,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(d,E){this.g.get(d)?.shutdown(E)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(E=>this.a.$sendProcessProperty(d,{type:"cwd",value:E}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new $.$aN(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,E,k){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,k),this.a.$registerProfileProvider(E,d.identifier.value),new $.$aN(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(d,E,k){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,k),this.a.$registerQuickFixProvider(d,E),new $.$aN(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,E){const k=new h.$oe().token;if(k.isCancellationRequested)return;const P=this.D.get(d);if(!P)return;const S=await P.provideTerminalQuickFixes(E,k);if(S===null||Array.isArray(S)&&S.length===0)return;const W=new p.$Tc;if(this.w.value=W,!Array.isArray(S))return S?s.TerminalQuickFix.from(S,this.Q.converter,W):void 0;const V=[];for(const q of S){const N=s.TerminalQuickFix.from(q,this.Q.converter,W);N&&V.push(N)}return V}async $createContributedProfileTerminal(d,E){const k=new h.$oe().token;let P=await this.C.get(d)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,E);return}this.createTerminalFromOptions(P.options,E)}}async $provideLinks(d,E){const k=this.getTerminalById(d);if(!k)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const S=new h.$oe;this.G.set(d,S);const W=[],V={terminal:k.value,line:E},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async ie=>{S.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(V,S.token)||[];S.token.isCancellationRequested||ie({provider:K,links:ce})}));const N=await Promise.all(q);if(S.token.isCancellationRequested)return[];const B=new Map;for(const K of N)K&&K.links.length>0&&W.push(...K.links.map(ie=>{const ce={id:l++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return B.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(d,B),W}$activateLink(d,E){const k=this.F.get(d)?.get(E);k&&k.provider.handleTerminalLink(k.link)}U(d,E){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const k=this.h[d];k&&(k.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,E)}getTerminalById(d){return this.W(this.f,d)}getTerminalIdByApiObject(d){const E=this.f.findIndex(k=>k.value===d);return E>=0?E:null}W(d,E){const k=this.X(d,E);return k!==null?d[k]:null}X(d,E){const k=d.findIndex(P=>P._id===E);return k>=0?k:null}getEnvironmentVariableCollection(d){let E=this.n.get(d.identifier.value);return E||(E=new f,this.Z(d.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(d,E){const k=(0,D.$ls)(E.map),P=(0,D.$ms)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(d,E.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(d){d.forEach(E=>{const k=E[0],P=new f(E[1]);this.Z(k,P)})}$acceptDefaultProfile(d,E){const k=this.s;this.s=d,this.u=E,k?.path!==d.path&&this.N.fire(d.path)}Z(d,E){this.n.set(d,E),E.onDidChangeCollection(()=>{this.Y(d,E)})}};e.$9lc=t,e.$9lc=t=Je([We(1,i.$VP),We(2,A.$zP)],t);class f{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$de,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const E=this.h(d);let k=this.a.get(E);return k||(k=new a(this,d),this.a.set(E,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(d,E,k,P){this.f(d,{value:E,type:$.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(d,E,k,P){this.f(d,{value:E,type:$.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(d,E,k,P){this.f(d,{value:E,type:$.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(d,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(d,E.scope),P=this.map.get(k),S=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==E.value||P.type!==E.type||P.options?.applyAtProcessCreation!==S.applyAtProcessCreation||P.options?.applyAtShellIntegration!==S.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const W=this.g(d,E.scope),V={variable:d,...E,options:S};this.map.set(W,V),this.d.fire()}}get(d,E){const k=this.g(d,E),P=this.map.get(k);return P?b(P):void 0}g(d,E){const k=this.h(E);return k.length?`${d}:::${k}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const E=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(d)&&E.set(P.variable,b(P));return E}delete(d,E){const k=this.g(d,E);this.map.delete(k),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[E,k]of this.map)k.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(E);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,E){const k=this.h(E),P=this.descriptionMap.get(k);if(!P||P.description!==d){let S;typeof d=="string"?S=d:S=d?.value.split(`

`)[0];const W={description:S,scope:E};this.descriptionMap.set(k,W),this.d.fire()}}getDescription(d){const E=this.h(d);return this.descriptionMap.get(E)?.description}k(d){const E=this.h(d);this.descriptionMap.delete(E)}}class a{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,E){this.b=d,this.d=E,this.a=new I.$de}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,E,k){this.b.replace(d,E,k,this.d)}append(d,E,k){this.b.append(d,E,k,this.d)}prepend(d,E,k){this.b.prepend(d,E,k,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,E){this.b.getVariableMap(this.d).forEach((k,P)=>d.call(E,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let m=class extends t{constructor(d,E){super(!1,d,E)}createTerminal(d,E,k){throw new T.$_}createTerminalFromOptions(d,E){throw new T.$_}};e.$0lc=m,e.$0lc=m=Je([We(0,i.$VP),We(1,A.$zP)],m);function u(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function C(v){return r.ThemeColor.isThemeColor(v)?v:void 0}function b(v){const d={...v};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Pe[116],Ie([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0,e.$bnc=(0,R.$wi)("IExtHostTerminalShellIntegration");let D=class extends O.$Uc{constructor(o,s){super(),this.h=s,this.b=new Map,this.c=new $.$de,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$de,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$de,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(M.$$M.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(o){const s=this.h.getTerminalById(o);if(!s)return;const i=s.value;let n=this.b.get(o);n||(n=new h(s.value,this.f),this.b.set(o,n),n.store.add(s.onWillDispose(()=>this.b.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),s.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(o,s,i,n,c){this.b.has(o)||this.$shellIntegrationChange(o);const l={value:s,confidence:i,isTrusted:n};this.b.get(o)?.startShellExecution(l,c)}$shellExecutionEnd(o,s,i,n,c){const l={value:s,confidence:i,isTrusted:n};this.b.get(o)?.endShellExecution(l,c)}$shellExecutionData(o,s){this.b.get(o)?.emitData(s)}$cwdChange(o,s){this.b.get(o)?.setCwd((0,y.$vc)(s)?y.URI.revive(s):s)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$cnc=D,e.$cnc=D=Je([We(0,A.$zP),We(1,p.$7lc)],D);class h extends O.$Uc{get currentExecution(){return this.a}constructor(o,s){super(),this.j=o,this.m=s,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new $.$de),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$de),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$de),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,c){let l=n;c&&(l+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(l);const t={value:l,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=i.startShellExecution(t,i.c,!0).value;return i.b=!0,f}}}startShellExecution(o,s,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new w(o,s);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,s){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:s}),this.a=void 0)}setCwd(o){let s=!1;y.URI.isUri(this.c)?s=!y.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(s=!0),s&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class w{constructor(o,s){this.c=o,this.cwd=s,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return T.$Wh.EMPTY;this.a=new g}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class g extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$vh);const o=this.a;return new T.$Wh(async i=>{this.b.push(i),await o.wait()})}emitData(o){for(const s of this.b)s.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Pe[289],Ie([1,0,11,21,24,5,261,73,6,15,34,12,4,17,115,8,7,52,77,62]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=e.$enc=e.$dnc=void 0;let c=class extends $.$Uc{constructor(S,W,V,q){super(),this.w=q,this.f=this.B(new M.$de),this.g=new Map,this.s=this.B(new M.$de),this.onResultsChanged=this.f.event,this.results=[],this.h=S.getProxy(h.$$M.MainThreadTesting),this.m=new v(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const B=N,K=B.tests[B.tests.length-1].item.extId;return this.g.get(s.$WL.root(K))?.collection.tree.get(K)?.actual??(0,g.$LP)(N)}case 18:{const{test:B,message:K}=N,ie=B.item.extId;return{test:this.g.get(s.$WL.root(ie))?.collection.tree.get(ie)?.actual??(0,g.$LP)({$mid:16,tests:[B]}),message:r.TestMessage.to(K)}}default:return N}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await V.executeCommand("_testing.getExplorerSelection"),B=K=>{const ie=this.g.get(s.$WL.root(K));if(ie)return s.$WL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:N?.include.map(B).filter(y.$eg)||[],exclude:N?.exclude.map(B).filter(y.$eg)||[]}})}createTestController(S,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const N=new $.$Tc,B=N.add(new g.$OP(W,V,this.w));B.root.label=V;const K=new Map,ie=new Set,ce=this.h,ye={items:B.root.children,get label(){return V},set label(fe){V=fe,B.root.label=fe,ce.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(fe){q=fe,ce.$updateController(W,{canRefresh:!!fe})},get id(){return W},createRunProfile:(fe,$e,Te,ae,Ne,ne)=>{let z=(0,p.$kj)(fe);for(;K.has(z);)z++;return new E(this.h,K,ie,this.s.event,W,z,fe,$e,Te,ae,Ne,ne)},createTestItem(fe,$e,Te){return new g.$MP(W,fe,$e,Te)},createTestRun:(fe,$e,Te=!0)=>this.j.createTestRun(W,B,fe,$e,Te),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const $e=fe instanceof Array?fe:[fe];this.h.$markTestRetired($e.map(Te=>s.$WL.fromExtHostTestItem(Te,W).toString()))}},set resolveHandler(fe){B.resolveHandler=fe},get resolveHandler(){return B.resolveHandler},dispose:()=>{N.dispose()}};ce.$registerTestController(W,V,!!q),N.add((0,$.$Sc)(()=>ce.$unregisterTestController(W)));const Se={controller:ye,collection:B,profiles:K,extension:S,activeProfiles:ie};return this.g.set(W,Se),N.add((0,$.$Sc)(()=>this.g.delete(W))),N.add(B.onDidGenerateDiff(fe=>ce.$publishDiff(W,fe.map(n.TestsDiffOp.serialize)))),ye}createTestObserver(){return this.m.checkout()}async runTests(S,W=R.CancellationToken.None){const V=m(S);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:S.preserveFocus??!0,targets:[{testIds:S.include?.map(N=>s.$WL.fromExtHostTestItem(N,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:k[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:S.exclude?.map(N=>N.id)},W)}$syncTests(){for(const{collection:S}of this.g.values())S.flushDiff();return Promise.resolve()}async $getCoverageDetails(S,W){return(await this.j.getCoverageDetails(S,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(S){this.j.disposeTestRun(S)}$configureRunProfile(S,W){this.g.get(S)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(S){const W=new Map;for(const[V,q]of Object.entries(S)){const N=this.g.get(V);if(!N)continue;const B=new Map,K=q.filter(ce=>!N.activeProfiles.has(ce)),ie=[...N.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)B.set(ce,!0),N.activeProfiles.add(ce);for(const ce of ie)B.set(ce,!1),N.activeProfiles.delete(ce);B.size&&W.set(V,B)}this.s.fire(W)}async $refreshTests(S,W){await this.g.get(S)?.controller.refreshHandler?.(W)}$publishTestResults(S){this.results=Object.freeze(S.map(r.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(S,W){const V=this.g.get(s.$WL.fromString(S).controllerId)?.collection;V&&(await V.expand(S,W<0?1/0:W),V.flushDiff())}$acceptDiff(S){this.m.applyDiff(S.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(S,W){return Promise.all(S.map(V=>this.y(V,!1,W)))}async $startContinuousRun(S,W){const V=new R.$oe(W),q=await Promise.all(S.map(N=>this.y(N,!0,V.token)));return!W.isCancellationRequested&&!q.some(N=>N.error)&&await new Promise(N=>W.onCancellationRequested(N)),V.dispose(!0),q}async y(S,W,V){const q=this.g.get(S.controllerId);if(!q)return{};const{collection:N,profiles:B}=q,K=B.get(S.profileId);if(!K)return{};const ie=S.testIds.map(fe=>N.tree.get(fe)).filter(y.$eg),ce=S.excludeExtIds.map(fe=>q.collection.tree.get(fe)).filter(y.$eg).filter(fe=>ie.some($e=>$e.fullId.compare(fe.fullId)===2));if(!ie.length)return{};const ye=new o.$NO(ie.some(fe=>fe.actual instanceof g.$NP)?void 0:ie.map(fe=>fe.actual),ce.map(fe=>fe.actual),K,W),Se=(0,n.$ZL)(S)&&this.j.prepareForMainThreadTestRun(ye,u.fromInternal(S,q.collection),K,V);try{return await K.runHandler(ye,V),{}}catch(fe){return{error:String(fe)}}finally{Se&&Se.hasRunningTasks&&!V.isCancellationRequested&&await M.Event.toPromise(Se.onEnd)}}$cancelExtensionTestRun(S){S===void 0?this.j.cancelAllRuns():this.j.cancelRunById(S)}};e.$dnc=c,e.$dnc=c=Je([We(0,w.$zP),We(1,D.$3j)],c);const l=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class f extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(S,W,V,q,N){super(),this.y=S,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new M.$de),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$oe(N));const B=this.B(new I.$Ih(()=>this.F(),l));this.B(this.j.token.onCancellationRequested(()=>B.schedule()));const K=new M.$de;this.s=K.event,this.B((0,$.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(S,W){const[,V,q]=s.$WL.fromString(S).path,N=this.w.get(q);if(!N)return[];const B=this.g.get(V);if(!B)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(B.run,N,W)??[]}createRun(S){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Sg)(),N=ce=>(ye,...Se)=>{if(K){this.C.warn(`Setting the state of test "${ye.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ye)&&(this.H(ye),ce(ye,...Se))},B=(ce,ye)=>{const Se=ye instanceof Array?ye.map(r.TestMessage.from):[r.TestMessage.from(ye)];if(ce.uri&&ce.range){const fe={range:r.Range.from(ce.range),uri:ce.uri};for(const $e of Se)$e.location=$e.location||fe}this.z.$appendTestMessagesInRun(W,q,s.$WL.fromExtHostTestItem(ce,V).toString(),Se)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:S,onDidDispose:this.s,addCoverage:ce=>{const ye=ce.uri.toString(),Se=new s.$WL([W,q,ye]).toString();this.w.set(ye,ce),this.z.$appendCoverage(W,q,r.TestCoverage.fromFile(Se,ce))},enqueued:N(ce=>{this.z.$updateTestStateInRun(W,q,s.$WL.fromExtHostTestItem(ce,V).toString(),1)}),skipped:N(ce=>{this.z.$updateTestStateInRun(W,q,s.$WL.fromExtHostTestItem(ce,V).toString(),5)}),started:N(ce=>{this.z.$updateTestStateInRun(W,q,s.$WL.fromExtHostTestItem(ce,V).toString(),2)}),errored:N((ce,ye,Se)=>{B(ce,ye),this.z.$updateTestStateInRun(W,q,s.$WL.fromExtHostTestItem(ce,V).toString(),6,Se)}),failed:N((ce,ye,Se)=>{B(ce,ye),this.z.$updateTestStateInRun(W,q,s.$WL.fromExtHostTestItem(ce,V).toString(),4,Se)}),passed:N((ce,ye)=>{this.z.$updateTestStateInRun(W,q,s.$WL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ye)}),appendOutput:(ce,ye,Se)=>{K||(Se&&(this.y.isIncluded(Se)?this.H(Se):Se=void 0),this.z.$appendOutputToRun(W,q,O.$Fe.fromString(ce),ye&&r.location.from(ye),Se&&s.$WL.fromExtHostTestItem(Se,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(W,{id:q,name:S,running:!0}),ie}F(){for(const{run:S}of this.g.values())S.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(S){if(!(S instanceof g.$MP))throw new i.$rP(S.id);if(this.h.has(s.$WL.fromExtHostTestItem(S,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=r.TestItem.from(S);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),S===V))break;S=S.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(S,W){this.g=S,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(S,W){const V=s.$WL.root(S);return this.f.get(V)?.getCoverageDetails(S,W)||[]}disposeTestRun(S){this.f.get(S)?.dispose(),this.f.delete(S);for(const[W,{id:V}]of this.c)V===S&&this.c.delete(W)}prepareForMainThreadTestRun(S,W,V,q){return this.j(S,W,V,q)}cancelRunById(S){this.f.get(S)?.cancel()}cancelAllRuns(){for(const S of this.c.values())S.cancel()}createTestRun(S,W,V,q,N){const B=this.c.get(V);if(B)return B.createRun(q);const K=u.fromPublic(S,W,V,N),ie=m(V);this.g.$startedExtensionTestRun({controllerId:S,continuous:!!V.continuous,profile:ie&&{group:k[ie.kind],id:ie.profileId},exclude:V.exclude?.map(ye=>s.$WL.fromExtHostTestItem(ye,W.root.id).toString())??[],id:K.id,include:V.include?.map(ye=>s.$WL.fromExtHostTestItem(ye,W.root.id).toString())??[W.root.id],preserveFocus:V.preserveFocus??!0,persist:N});const ce=this.j(V,K,V.profile);return M.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(S,W,V,q){const N=new f(W,this.g,this.h,V,q);return this.c.set(S,N),this.f.set(N.id,N),N}}e.$enc=a;const m=P=>{if(P.profile){if(!(P.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class u{static fromPublic(S,W,V,q){return new u(S,(0,T.$Sg)(),V.include?.map(N=>s.$WL.fromExtHostTestItem(N,S).toString())??[S],V.exclude?.map(N=>s.$WL.fromExtHostTestItem(N,S).toString())??[],q,W)}static fromInternal(S,W){return new u(S.controllerId,S.runId,S.testIds,S.excludeExtIds,!0,W)}constructor(S,W,V,q,N,B){this.controllerId=S,this.id=W,this.isPersisted=N,this.colllection=B,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(S){const W=s.$WL.fromExtHostTestItem(S,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$fnc=u;class C{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(S){this.j=S,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(S){this.c.add(S)}update(S){Object.assign(S.revived,r.TestItem.toPlain(S.item)),this.c.has(S)||this.f.add(S)}remove(S){if(this.c.has(S)){this.c.delete(S);return}this.f.delete(S);const W=s.$WL.parentId(S.item.extId);if(W&&this.h.has(W.toString())){this.h.add(S.item.extId);return}this.g.add(S)}getChangeEvent(){const{c:S,f:W,g:V}=this;return{get added(){return[...S].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class b extends n.$6L{constructor(){super(...arguments),this.s=new M.$de,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(S){return this.f.get(S)}getMirroredTestDataByReference(S){return this.f.get(S.id)}w(S,W){return{...S,revived:r.TestItem.toPlain(S.item),depth:W?W.depth+1:0,children:new Set}}v(){return new C(this.s)}}class v{constructor(S){this.f=S}checkout(){this.c||(this.c=this.g());const S=this.c;return S.observers++,{onDidChangeTest:S.tests.onDidChangeTests,get tests(){return[...S.tests.rootTests].map(W=>W.revived)},dispose:(0,A.$db)(()=>{--S.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(S){return this.c?.tests.getMirroredTestDataByReference(S)}applyDiff(S){this.c?.tests.apply(S)}g(){const S=new b({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:S}}}const d=(P,S,W,V)=>{W?Object.assign(W,V):S.$updateTestRunConfig(P.controllerId,P.profileId,V)};class E{#e;#t;#i;#n;#s;get label(){return this.f}set label(S){S!==this.f&&(this.f=S,d(this,this.#e,this.#n,{label:S}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(S){S!==this.g&&(this.g=S,d(this,this.#e,this.#n,{supportsContinuousRun:S}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(S){S!==this.isDefault&&(S?this.#t.add(this.profileId):this.#t.delete(this.profileId),d(this,this.#e,this.#n,{isDefault:S}))}get tag(){return this._tag}set tag(S){S?.id!==this._tag?.id&&(this._tag=S,d(this,this.#e,this.#n,{tag:S?r.TestTag.namespace(this.controllerId,S.id):null}))}get configureHandler(){return this.c}set configureHandler(S){S!==this.c&&(this.c=S,d(this,this.#e,this.#n,{hasConfigurationHandler:!!S}))}get onDidChangeDefault(){return M.Event.chain(this.#i,S=>S.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(y.$eg))}constructor(S,W,V,q,N,B,K,ie,ce,ye=!1,Se=void 0,fe=!1){this.controllerId=N,this.profileId=B,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=Se,this.g=fe,this.#e=S,this.#s=W,this.#t=V,this.#i=q,W.set(B,this);const $e=k[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);ye&&V.add(B),this.#n={profileId:B,controllerId:N,tag:Se?r.TestTag.namespace(this.controllerId,Se.id):null,label:K,group:$e,isDefault:ye,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$gnc=E;const k={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[117],Ie([1,0,57,14,91,8,7]),function(le,e,I,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$HP=e.$GP=void 0;class p{static{this.c=new R.$EP("TextEditorDecorationType")}constructor(h,w,g){const r=p.c.nextId();h.$registerTextEditorDecorationType(w.identifier,r,M.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){h.$removeTextEditorDecorationType(r)}})}}e.$GP=p;class ${constructor(h,w){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,w){this.k();let g=null;if(h instanceof A.$bN)g=new A.$cN(h,h);else if(h instanceof A.$cN)g=h;else throw new Error("Unrecognized location");this.l(g,w,!1)}insert(h,w){this.k(),this.l(new A.$cN(h,h),w,!0)}delete(h){this.k();let w=null;if(h instanceof A.$cN)w=h;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(h,w,g){const r=this.c.validateRange(h);this.g.push({range:r,text:w,forceMoveMarkers:g})}setEndOfLine(h){if(this.k(),h!==A.EndOfLine.LF&&h!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=h}}class y{constructor(h,w,g,r){this.c=h,this.d=w,this._accept(g),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.originalIndentSize,this.j=h.insertSpaces,this.k=h.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(h.lineNumbers)}m(h){if(h==="auto")return"auto";if(typeof h=="number"){const w=Math.floor(h);return w>0?w:null}if(typeof h=="string"){const w=parseInt(h,10);return isNaN(w)?null:w>0?w:null}return null}n(h){const w=this.m(h);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const w=Math.floor(h);return w>0?w:null}if(typeof h=="string"){const w=parseInt(h,10);return isNaN(w)?null:w>0?w:null}return null}p(h){const w=this.o(h);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(h){return h==="auto"?"auto":h==="false"?!1:!!h}s(h){const w=this.q(h);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(h){this.k!==h&&(this.k=h,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}u(h){this.l!==h&&(this.l=h,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(h)})))}assign(h){const w={};let g=!1;if(typeof h.tabSize<"u"){const r=this.m(h.tabSize);r==="auto"?(g=!0,w.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,g=!0,w.tabSize=r)}if(typeof h.indentSize<"u"){const r=this.o(h.indentSize);r==="tabSize"?(g=!0,w.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,g=!0,w.indentSize=r)}if(typeof h.insertSpaces<"u"){const r=this.q(h.insertSpaces);r==="auto"?(g=!0,w.insertSpaces=r):this.j!==r&&(this.j=r,g=!0,w.insertSpaces=r)}typeof h.cursorStyle<"u"&&this.k!==h.cursorStyle&&(this.k=h.cursorStyle,g=!0,w.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.l!==h.lineNumbers&&(this.l=h.lineNumbers,g=!0,w.lineNumbers=M.TextEditorLineNumbersStyle.from(h.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(h,w){w.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(g)})}}e.$HP=y;class T{constructor(h,w,g,r,o,s,i,n){this.id=h,this.j=w,this.k=g,this.g=!1,this.h=new Set,this.c=o,this.d=new y(this.j,this.id,s,g),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return r.value},set document(l){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(l){if(!(l instanceof A.$dN))throw(0,O.$7)("selection");c.c=[l],c.l()},get selections(){return c.c},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof A.$dN)))throw(0,O.$7)("selections");c.c=l,c.l()},get visibleRanges(){return c.e},set visibleRanges(l){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(l){c.g||c.d.assign(l)},get viewColumn(){return c.f},set viewColumn(l){throw new O.$9("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new $(r.value,t);return l(f),c.m(f)},insertSnippet(l,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(m=>M.Range.from(m));else if(t instanceof A.$bN){const{lineNumber:m,column:u}=M.Position.from(t);a=[{startLineNumber:m,startColumn:u,endLineNumber:m,endColumn:u}]}else if(t instanceof A.$cN)a=[M.Range.from(t)];else{a=[];for(const m of t)if(m instanceof A.$cN)a.push(M.Range.from(m));else{const{lineNumber:u,column:C}=M.Position.from(m);a.push({startLineNumber:u,startColumn:C,endLineNumber:u,endColumn:C})}}return w.$tryInsertSnippet(h,r.value.version,l.value,a,f)},setDecorations(l,t){const f=t.length===0;f&&!c.h.has(l.key)||(f?c.h.delete(l.key):c.h.add(l.key),c.n(()=>{if(M.$wP(t))return w.$trySetDecorations(h,l.key,M.$xP(t));{const a=new Array(4*t.length);for(let m=0,u=t.length;m<u;m++){const C=t[m];a[4*m]=C.start.line+1,a[4*m+1]=C.start.character+1,a[4*m+2]=C.end.line+1,a[4*m+3]=C.end.character+1}return w.$trySetDecorationsFast(h,l.key,a)}}))},revealRange(l,t){c.n(()=>w.$tryRevealRange(h,M.Range.from(l),t||A.TextEditorRevealType.Default))},show(l){w.$tryShowEditor(h,M.ViewColumn.from(l))},hide(){w.$tryHideEditor(h)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,I.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,I.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,I.ok)(!this.g),this.f=h}_acceptSelections(h){(0,I.ok)(!this.g),this.c=h}async l(){const h=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const w=h.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const g=w.edits.map(o=>o.range);g.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=g.length-1;o<s;o++){const i=g[o].end;if(g[o+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=w.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,r,{setEndOfLine:typeof w.setEndOfLine=="number"?M.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$IP=T}),define(Pe[68],Ie([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$JP=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,l){this.h=c,this.i=l,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new O.$de,this.e=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const l=[],t=[],f=[];if(c.removedDocuments)for(const a of c.removedDocuments){const m=M.URI.revive(a),u=this.c.get(m);u?.unref()&&(this.c.delete(m),l.push(u.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const m=M.URI.revive(a.uri);let u=this.c.get(m);if(u&&m.scheme!==g.Schemas.vscodeNotebookCell&&m.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);u||(u=new s(new $.$CP(this.h.getProxy(p.$$M.MainThreadDocuments),m,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(m,u),t.push(u.value)),u.ref()}if(c.removedEditors)for(const a of c.removedEditors){const m=this.b.get(a);this.b.delete(a),m&&f.push(m)}if(c.addedEditors)for(const a of c.addedEditors){const m=M.URI.revive(a.documentUri);I.ok(this.c.has(m),`document '${m}' does not exist`),I.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const u=this.c.get(m).value,C=new T.$IP(a.id,this.h.getProxy(p.$$M.MainThreadTextEditors),this.i,new o.$V(()=>u.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(b=>D.Range.to(b)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,C)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,R.$Pc)(l),(0,R.$Pc)(f),c.removedDocuments&&this.e.fire(l),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const l=this.b.get(this.a);return c?l:l?.value}allEditors(){return[...this.b.values()]}};e.$JP=i,e.$JP=i=Je([We(0,y.$zP),We(1,h.$3j)],i),e.$KP=(0,A.$wi)("IExtHostDocumentsAndEditors")}),define(Pe[290],Ie([1,0,18,5,4,117,8,7]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class ${constructor(T,D){this.i=D,this.a=new O.$de,this.b=new O.$de,this.c=new O.$de,this.d=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.$$M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(h=>this.g.fire(h)),this.i.onDidChangeActiveTextEditor(h=>this.f.fire(h))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const D=this.i.allEditors();return T?D:D.map(h=>h.value)}async showTextDocument(T,D,h){let w;typeof D=="number"?w={position:A.ViewColumn.from(D),preserveFocus:h}:typeof D=="object"?w={position:A.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?A.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:w={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(T.uri,w),r=g&&this.i.getEditor(g);if(r)return r.value;throw g?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,D){return new M.$GP(this.h,T,D).value}$acceptEditorPropertiesChanged(T,D){const h=this.i.getEditor(T);if(!h)throw new Error("unknown text editor");if(D.options&&h._acceptOptions(D.options),D.selections){const w=D.selections.selections.map(A.Selection.to);h._acceptSelections(w)}if(D.visibleRanges){const w=I.$Hb(D.visibleRanges.map(A.Range.to));h._acceptVisibleRanges(w)}if(D.options&&this.b.fire({textEditor:h.value,options:{...D.options,lineNumbers:A.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const w=p.TextEditorSelectionChangeKind.fromValue(D.selections.source),g=D.selections.selections.map(A.Selection.to);this.a.fire({textEditor:h.value,selections:g,kind:w})}if(D.visibleRanges){const w=I.$Hb(D.visibleRanges.map(A.Range.to));this.c.fire({textEditor:h.value,visibleRanges:w})}}$acceptEditorPositionData(T){for(const D in T){const h=this.i.getEditor(D);if(!h)throw new Error("Unknown text editor");const w=A.ViewColumn.to(T[D]);h.value.viewColumn!==w&&(h._acceptViewColumn(w),this.d.fire({textEditor:h.value,viewColumn:w}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$zlc=$}),define(Pe[291],Ie([1,0,2,3,4,6,7,8,20,15]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,O.$wi)("IExtHostTimeline");class T{constructor(w,g){this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$$M.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&$.$Rm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this.c.get(r.source)?.get(D(s))?.get(r.handle)}else return;return r}})}async $getTimeline(w,g,r,o){return this.b.get(w)?.provider.provideTimeline(I.URI.revive(g),r,o)}registerTimelineProvider(w,g,r,o){const s=new M.$Tc,i=this.d(g.id,o,s).bind(this);let n;g.onDidChange&&(n=g.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:g.id}),this));const c=this.c;return this.f({...g,scheme:w,onDidChange:void 0,async provideTimeline(l,t,f){t?.resetCache&&(s.clear(),c.get(g.id)?.clear());const a=await g.provideTimeline(l,t,f);if(a==null)return;const m=i(l,t);return{...a,source:g.id,items:a.items.map(m)}},dispose(){for(const l of c.values())l.get(g.id)?.clear();n?.dispose(),s.dispose()}},r)}d(w,g,r){return(o,s)=>{let i;if(s?.cacheResults){let n=this.c.get(w);n===void 0&&(n=new Map,this.c.set(w,n));const c=D(o);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...l}=n,t=`${w}|${n.id??n.timestamp}`;i?.set(t,n);let f,a,m;n.iconPath&&(c instanceof A.$0N?m={id:c.id,color:c.color}:I.URI.isUri(c)?(f=c,a=c):{light:f,dark:a}=c);let u;return A.$CN.isMarkdownString(l.tooltip)?u=p.MarkdownString.from(l.tooltip):(0,y.$9f)(l.tooltip)?u=l.tooltip:A.$CN.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=p.MarkdownString.from(l.detail)):(0,y.$9f)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=l.detail),{...l,id:l.id??void 0,handle:t,source:w,command:n.command?g.toInternal(n.command,r):void 0,icon:f,iconDark:a,themeIcon:m,tooltip:u,accessibilityInformation:n.accessibilityInformation}}}}f(w,g){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:g}),(0,M.$Sc)(()=>{for(const o of this.c.values())o.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$jnc=T;function D(h){return h?.toString()}}),define(Pe[292],Ie([1,0,181,23,2,5,6,222,11,7,15,18,8,55,24,143,26]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;function s(c,l){if((0,T.$9f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends A.$Uc{constructor(l,t,f){super(),this.f=l,this.g=t,this.h=f,this.a=new Map,this.b=new r.$v$;function a(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:m=>a(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map(u=>a(u)?this.r(u):u):m})}registerTreeDataProvider(l,t,f){const a=this.createTreeView(l,{treeDataProvider:t},f);return{dispose:()=>a.dispose()}}createTreeView(l,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],m=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,C=!!t.dragAndDropController?.handleDrop,b=this.m(l,t,f),v={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:m,hasHandleDrag:u,hasHandleDrop:C,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,v),E={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,o.$PG)(f,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,o.$PG)(f,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(k){(0,w.$Vk)(k)&&(0,o.$PG)(f,"treeViewMarkdownMessage"),b.message=k},get title(){return b.title},set title(k){b.title=k},get description(){return b.description},set description(k){b.description=k},get badge(){return b.badge},set badge(k){k!==void 0&&y.ViewBadge.isViewBadge(k)?b.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(b.badge=void 0)},reveal:(k,P)=>b.reveal(k,P),dispose:async()=>{await d,this.a.delete(l),b.dispose()}};return this.B(E),E}$getChildren(l,t){const f=this.a.get(l);return f?f.getChildren(t):Promise.reject(new p.$4F(l))}async $handleDrop(l,t,f,a,m,u,C,b){const v=this.a.get(l);if(!v)return Promise.reject(new p.$4F(l));const d=h.DataTransfer.toDataTransfer(f,async E=>(await this.f.$resolveDropFileData(l,t,E)).buffer);return C===l&&b&&await this.j(d,v,b,m,u),v.onDrop(d,a,m)}async j(l,t,f,a,m){const u=this.b.removeDragOperationTransfer(m);if(u)(await u)?.forEach((C,b)=>{C&&l.set(b,C)});else if(m&&t.handleDrag){const C=t.handleDrag(f,l,a);this.b.addDragOperationTransfer(m,C),await C}return l}async $handleDrag(l,t,f,a){const m=this.a.get(l);if(!m)return Promise.reject(new p.$4F(l));const u=await this.j(new y.$6N,m,t,a,f);if(!(!u||a.isCancellationRequested))return h.DataTransfer.from(u)}async $hasResolve(l){const t=this.a.get(l);if(!t)throw new p.$4F(l);return t.hasResolve}$resolve(l,t,f){const a=this.a.get(l);if(!a)throw new p.$4F(l);return a.resolveTreeItem(t,f)}$setExpanded(l,t,f){const a=this.a.get(l);if(!a)throw new p.$4F(l);a.setExpanded(t,f)}$setSelectionAndFocus(l,t,f){const a=this.a.get(l);if(!a)throw new p.$4F(l);a.setSelectionAndFocus(t,f)}$setVisible(l,t){const f=this.a.get(l);if(!f){if(!t)return;throw new p.$4F(l)}f.setVisible(t)}$changeCheckboxState(l,t){const f=this.a.get(l);if(!f)throw new p.$4F(l);f.setCheckboxState(t)}m(l,t,f){const a=this.B(new n(l,t,this.f,this.g.converter,this.h,f));return this.a.set(l,a),a}r(l){const t=this.a.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.$knc=i;class n extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,T.$fg)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,t,f,a,m,u){if(super(),this.I=l,this.J=f,this.L=a,this.M=m,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$de),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$de),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$de),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$de),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$de),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$de),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$de),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$oe,u.contributes&&u.contributes.views)for(const d in u.contributes.views)for(const E of u.contributes.views[d])E.id===l&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>{Array.isArray(d)&&d.length===0||this.F.fire({message:!1,element:d})}));let C,b;const v=M.Event.debounce(this.F.event,(d,E)=>(d||(d={message:!1,elements:[]}),E.element!==!1&&(C||(C=new Promise(k=>b=k),this.G=this.G.then(()=>C)),Array.isArray(E.element)?d.elements.push(...E.element):d.elements.push(E.element)),E.message&&(d.message=!0),d),200,!0);this.B(v(({message:d,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const k=b;return C=null,this.$(E).then(()=>k())})),d&&this.J.$setMessage(this.I,h.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let f=this.X(l);return f||(f=await this.Y(t)),f?f.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const f=(0,T.$fg)(t.select)?!0:t.select,a=(0,T.$fg)(t.focus)?!1:t.focus,m=(0,T.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(u=>this.W(l,u[u.length-1]).then(C=>this.J.$reveal(this.I,{item:C.item,parentChain:u.map(b=>b.item)},{select:f,focus:a,expand:m})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:f,focus:a,expand:m})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=h.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,t){const f=this.getExtensionElement(l);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(l,t){const f=!(0,D.$ub)(this.s,l);this.s=l;const a=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async f=>{const a=this.getExtensionElement(f.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:f.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(l,t,f){const a=[];for(const m of l){const u=this.getExtensionElement(m);u&&a.push(u)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,t,f){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,$.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(l);if(f){const a=this.m.get(f);if(a){const m=await this.f.resolveTreeItem(a.extensionItem,f,t)??a.extensionItem;return this.hb(m),a.item.tooltip=this.eb(m.tooltip),a.item.command=this.fb(a.disposableStore,m.command),a.item}}}S(l){return this.U(l).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(a=>(f.push(a),f))):Promise.resolve([]))}U(l){const t=this.m.get(l);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$oh)(()=>this.f.getParent(l))}W(l,t){const f=this.m.get(l);return f?Promise.resolve(f):(0,$.$oh)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const m=this.getExtensionElement(a);if(m){const u=this.m.get(m);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let t;if(typeof l=="string"){const f=this.getExtensionElement(l);t=f?this.m.get(f):void 0}else t=l;return t&&t.children||void 0}return this.h}async Y(l){this.rb(l);const t=new g.$oe(this.Z.token);try{const f=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(t.token.isCancellationRequested)return;const m=(0,D.$Hb)(a||[]),u=await Promise.all((0,D.$Hb)(m).map(b=>this.f.getTreeItem(b)));if(t.token.isCancellationRequested)return;const C=u.map((b,v)=>b?this.db(m[v],b,f):null);return(0,D.$Hb)(C)}finally{t.dispose()}}$(l){if(l.some(f=>!f))return this.Z.dispose(!0),this.Z=new g.$oe,this.tb(),this.J.$refresh(this.I);{const f=this.ab(l);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(l){const t=new Set,f=l.map(m=>this.m.get(m));for(const m of f)if(m&&!t.has(m.item.handle)){let u=m;for(;u&&u.parent&&f.findIndex(C=>u&&u.parent&&C&&C.item.handle===u.parent.item.handle)===-1;){const C=this.j.get(u.parent.item.handle);u=C?this.m.get(C):void 0}u&&!u.parent&&t.add(m.item.handle)}const a=[];return t.forEach(m=>{const u=this.j.get(m);if(u){const C=this.m.get(u);C&&(!C.parent||!t.has(C.parent.item.handle))&&a.push(m)}}),a}bb(l){const t={};return Promise.all(l.map(f=>this.cb(f).then(a=>{a&&(t[f]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(l){const t=this.getExtensionElement(l);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,$.$oh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const m=this.ib(t,a,f.parent);return this.pb(t,m,f,f.parent),f.dispose(),m}return null})}return Promise.resolve(null)}db(l,t,f){const a=this.ib(l,t,f);if(t.id&&this.j.has(a.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(l,a),this.qb(a,f),a}eb(l){return y.$CN.isMarkdownString(l)?h.MarkdownString.from(l):l}fb(l,t){return t?{...this.L.toInternal(t,l),originalId:t.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let t,f,a;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,f=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:a}}hb(l){if(!y.$1N.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,t,f){this.hb(t);const a=this.B(new A.$Tc),m=this.kb(l,t,f),u=this.lb(t);return{item:{handle:m,parentHandle:f?f.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,T.$fg)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof y.$0N?l.iconPath:void 0}kb(l,{id:t,label:f,resourceUri:a},m,u){if(t)return`${n.b}/${t}`;const C=s(f,this.N),b=m?m.item.handle:n.a;let v=C?C.label:a?(0,O.$7g)(a):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,E=this.X(m)||[];let k,P=0;do{if(k=`${b}/${P}:${v}`,u||!this.j.has(k)||d===k)break;P++}while(P<=E.length);return k}lb(l){if(l.iconPath&&!(l.iconPath instanceof y.$0N))return typeof l.iconPath=="string"||R.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof y.$0N)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return R.URI.isUri(l)?l:R.URI.file(l)}ob(l,t){this.j.set(t.item.handle,l),this.m.set(l,t)}pb(l,t,f,a){this.j.delete(t.item.handle),this.m.delete(l),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(l,t);const m=this.X(a)||[],u=m.filter(C=>C.item.handle===f.item.handle)[0];u&&m.splice(m.indexOf(u),1,t)}qb(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const t=this.m.get(l);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(l){const t=this.m.get(l);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[293],Ie([1,0,5,6,2,34,8,64,4,7]),function(le,e,I,O,R,M,A,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;class T extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(g,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$de),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$de),this.onDidChangeViewState=this.#h.event,this.#e=g,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(g){this.c(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#a}set iconPath(g){this.c(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,R.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(g){this.#l||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#u=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(g,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:A.ViewColumn.from(g),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends O.$Uc{static c(){return(0,M.$Sg)()}constructor(g,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=g.getProxy($.$$M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,r,o,s,i={}){const n=typeof s=="object"?s.viewColumn:s,c={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},l=(0,p.$Olc)(g),t=D.c();this.f.$createWebviewPanel((0,p.$Qlc)(g),t,r,{title:o,panelOptions:h(i),webviewOptions:(0,p.$Rlc)(g,this.m,i),serializeBuffersForPostMessage:l},c);const f=this.j.createNewWebview(t,i,g);return this.createNewWebviewPanel(t,r,o,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(g){const r=Object.keys(g);r.sort((o,s)=>{const i=g[o],n=g[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const i=g[o];s._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:g}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,p.$Olc)(g)}),new y.$aN(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(g,r,o,s){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:c}=i,l=this.j.createNewWebview(g,o.webviewOptions,c),t=this.createNewWebviewPanel(g,r,o.title,s,o.panelOptions,l,o.active);await n.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(g,r,o,s,i,n,c){const l=new T(g,this.f,n,{viewType:r,title:o,viewColumn:s,panelOptions:i,active:c});return this.g.set(g,l),l}getWebviewPanel(g){return this.g.get(g)}}e.$Slc=D;function h(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Pe[294],Ie([1,0,5,6,64,8,4,7]),function(le,e,I,O,R,M,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;class $ extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,h,w,g,r,o){super(),this.#s=!1,this.#u=this.B(new I.$de),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$de),this.onDidDispose=this.#l.event,this.#i=w,this.#a=g,this.#e=D,this.#t=h,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class y{constructor(D,h){this.d=h,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$$M.MainThreadWebviewViews)}registerWebviewViewProvider(D,h,w,g){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:w,extension:D}),this.a.$registerWebviewViewProvider((0,R.$Qlc)(D),h,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$Olc)(D)}),new p.$aN(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(D,h,w,g,r){const o=this.b.get(h);if(!o)throw new Error(`No view provider found for '${h}'`);const{provider:s,extension:i}=o,n=this.d.createNewWebview(D,{},i),c=new $(D,this.a,h,w,n,!0);this.c.set(D,c),await s.resolveWebviewView(c,{state:g},r)}async $onDidChangeWebviewViewVisibility(D,h){this.e(D)._setVisible(h)}async $disposeWebviewView(D){const h=this.e(D);this.c.delete(D),h.dispose(),this.d.deleteWebview(D)}e(D){const h=this.c.get(D);if(!h)throw new Error("No webview found");return h}}e.$nnc=y}),define(Pe[295],Ie([1,0,5,29,31,3]),function(le,e,I,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.OutputChannelUpdateMode=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=void 0,e.$gM="text/x-code-output",e.$hM="output",e.$iM="Log",e.$jM="text/x-code-log-output",e.$kM="log",e.$lM="workbench.panel.output",e.$mM=new R.$Nj("inOutput",!1),e.$nM=new R.$Nj("activeLogOutput",!1),e.$oM=new R.$Nj("activeLogOutput.levelSettable",!1),e.$pM=new R.$Nj("activeLogOutput.level",""),e.$qM=new R.$Nj("activeLogOutput.levelIsDefault",!1),e.$rM=new R.$Nj("outputView.scrollLock",!1),e.$sM=(0,M.$wi)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$tM={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$de,this.onDidRegisterChannel=this.b.event,this.c=new I.$de,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(T=>y.push(T)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}O.$co.add(e.$tM.OutputChannels,new p),e.$uM=new R.$Nj("activeOutputChannel","")}),define(Pe[118],Ie([1,0,4,3,17,20,12,295,65,27,46,147,21,15,38,5,6]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;class s extends A.$9j{get disposed(){return this.n}constructor(l,t,f,a,m){super(),this.id=l,this.name=t,this.r=f,this.s=a,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.m;this.info(l),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(l,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.s.$close(this.id)}g(l,t){this.m+=h.$Fe.fromString(t).byteLength,(0,A.log)(this.r,l,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(l){this.append(l)}}let n=class{constructor(l,t,f,a,m,u){this.i=t,this.j=f,this.k=a,this.l=m,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(I.$$M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(l,t,f){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,m=(0,w.$9f)(t)?t:void 0;if((0,w.$9f)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const C=this.i.environment.extensionLogLevel?.find(([v])=>M.$Rm.equals(f.identifier,v))?.[1];C&&(u=(0,A.$hk)(C));const b=a?this.o(l,u,f):this.n(l,m,f);return b.then(v=>{this.g.set(v.id,v),v.visible=v.id===this.h}),a?this.r(l,u??this.m.getLevel(),b):this.q(l,b)}async n(l,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,m=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),C=await this.a.$register(l,m,t,f.identifier.value);return new s(C,l,u,this.a,f)}async o(l,t,f){const a=await this.p(f),m=l.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(a,`${m}.log`),C=`${f.identifier.value}.${m}`,b=this.l.createLogger(u,{id:C,name:l,logLevel:t,extensionId:f.identifier.value});return new i(C,l,b,this.a,f)}p(l){let t=this.d.get(l.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(a){if((0,g.$gl)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}return f})())}return t}q(l,t){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return l},append(m){a(),t.then(u=>u.append(m))},appendLine(m){a(),t.then(u=>u.appendLine(m))},clear(){a(),t.then(m=>m.clear())},replace(m){a(),t.then(u=>u.replace(m))},show(m,u){a(),t.then(C=>C.show(m,u))},hide(){a(),t.then(m=>m.hide())},dispose(){f=!0,t.then(m=>m.dispose())}}}r(l,t,f){const a=new o.$Tc,m=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},u=a.add(new r.$de);function C(b){t=b,u.fire(b)}return f.then(b=>{a.add(b),b.logLevel!==t&&C(b.logLevel),a.add(b.onDidChangeLogLevel(v=>C(v)))}),{...this.q(l,f),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(b,...v){m(),f.then(d=>d.trace(b,...v))},debug(b,...v){m(),f.then(d=>d.debug(b,...v))},info(b,...v){m(),f.then(d=>d.info(b,...v))},warn(b,...v){m(),f.then(d=>d.warn(b,...v))},error(b,...v){m(),f.then(d=>d.error(b,...v))},dispose(){a.dispose()}}}};e.$Ymc=n,e.$Ymc=n=Je([We(0,R.$zP),We(1,y.$PP),We(2,$.$Klc),We(3,T.$nlc),We(4,A.$4j),We(5,A.$3j)],n),e.$Zmc=(0,O.$wi)("IExtHostOutputService")}),define(Pe[119],Ie([1,0,3,11]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,I.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let M=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await R.getRoundTripTime();if($===void 0)return;M=Math.min(M,$/2),await(0,O.$xh)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[296],Ie([1,0,184,51,29,45,50,6,5,119,22,25,11]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$LJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$MJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$NJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$OJ={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new $.$de,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const g=new w;R.$co.add(e.$OJ.ConfigurationMigration,g);let r=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const l of c.added)await this.f(l,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),l=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of l){const a=c[t];if(!a)continue;const m=[];if(a.value!==void 0){const u=await this.h(i,t,a.value,n,void 0);for(const C of u??[])m.push([C,[]])}for(const{identifiers:u,value:C}of a.overrides??[])if(C!==void 0){const b=await this.h(i,t,C,n,u);for(const v of b??[])m.push([v,u])}m.length&&await Promise.allSettled(m.map(async([[u,C],b])=>this.a.updateValue(u,C.value,{resource:n,overrideIdentifiers:b},f)))}}async h(i,n,c,l,t){const f=m=>{const C=this.a.inspect(m,{resource:l})[n];if(C)return t?C.overrides?.find(({identifiers:b})=>(0,D.$7n)(b,t))?.value:C.value},a=await i.migrateFn(c,f);return Array.isArray(a)?a:[[i.key,a]]}};e.$PJ=r,e.$PJ=r=Je([We(0,A.$3i),We(1,M.$Fi)],r);let o=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new h.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$co.as(O.$ho.Configuration).registerConfiguration({...e.$MJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$QJ=o,e.$QJ=o=Je([We(0,y.$gn)],o)}),define(Pe[297],Ie([1,0,37,16,19,23,193,296,51,3,29]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$hhb=e.$ghb=void 0,e.$ihb=r,e.$jhb=o,e.$ghb=(0,y.$wi)("editorResolverService"),e.$hhb="workbench.editorAssociations";const D=T.$co.as($.$ho.Configuration),h={...p.$LJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(h);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var g;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function r(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(s,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const l=typeof s=="string"&&s.indexOf(R.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,M.$7g)(i);return I.$pk(typeof s=="string"?s.toLowerCase():s,l.toLowerCase())}}),define(Pe[298],Ie([1,0,48,16,19,22,23,2,3,214,45,236,119]),function(le,e,I,O,R,M,A,p,$,y,T,D,h){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0,e.$MM=(0,$.$wi)("pathService");let g=w=class{constructor(o,s,i,n){this.d=o,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(o,n,s)):this.h(o,s,i)}h(o,s,i){return o.scheme===O.Schemas.file||o.scheme===O.Schemas.vscodeRemote?(0,I.$tg)(i??(0,A.$7g)(o),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,y.$JM)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$fc:R.$gc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(s=o.substring(2),o="/"):(s=o.substring(2,n),o=o.substring(n)||"/")}return p.URI.from({scheme:O.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$NM=g,e.$NM=g=w=Je([We(1,h.$gn),We(2,D.$vM),We(3,T.$Fi)],g)}),define(Pe[120],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$fL=e.$eL=void 0;class I{constructor(A,p){this.line=A,this.character=p}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,p){return new I(0,0)}with(A){return new I(0,0)}}e.$eL=I;class O{constructor(A,p,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,p),this.end=new I($,y)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$fL=O;var R;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Pe[47],Ie([1,0,18,37,25,48,13,3,19,14,120,11]),function(le,e,I,O,R,M,A,p,$,y,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.TextSearchCompleteMessageType=void 0,e.$mL=s,e.$nL=i,e.$oL=n,e.$tL=b,e.$uL=v,e.$wL=k,e.$xL=P,e.$yL=S,e.$zL=W,e.$AL=V,e.$BL=q,e.$DL=B,e.$FL=ce,e.$GL=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$gL="workbench.view.search",e.$hL="workbench.panel.search",e.$iL="workbench.view.search",e.$jL="search-result",e.$kL="search.exclude";const h="\u27EA ",w=" characters skipped \u27EB",g=(h.length+w.length+5)*2;e.$lL=(0,p.$wi)("searchService");var r;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text",fe[fe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text",fe[fe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(fe){return!!fe.preview}function i(fe){return!!fe.resource}function n(fe){return!!fe.message}var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class l{constructor($e){this.resource=$e,this.results=[]}}e.$pL=l;class t{constructor($e,Te,ae,Ne){this.ranges=Te,this.webviewIndex=Ne;const ne=Array.isArray(Te)?Te:[Te];if(ae&&ae.matchLines===1&&f(ne)){$e=(0,A.$2f)($e,ae.matchLines);let z="",x=0,be=0;const Fe=Math.floor(ae.charsPerLine/5),De=[];for(const pe of ne){const ge=Math.max(pe.startColumn-Fe,0),Q=pe.startColumn+ae.charsPerLine;if(ge>be+Fe+g){const Y=h+(ge-be)+w;z+=Y+$e.slice(ge,Q),x+=ge-(be+Y.length)}else z+=$e.slice(be,Q);De.push(new m(0,pe.startColumn-x,pe.endColumn-x)),be=Q}this.preview={text:z,matches:Array.isArray(this.ranges)?De:De[0]}}else{const z=Array.isArray(Te)?Te[0].startLineNumber:Te.startLineNumber;this.preview={text:$e,matches:(0,I.$1b)(Te,x=>new a(x.startLineNumber-z,x.startColumn,x.endLineNumber-z,x.endColumn))}}}}e.$qL=t;function f(fe){const $e=fe[0].startLineNumber;for(const Te of fe)if(Te.startLineNumber!==$e||Te.endLineNumber!==$e)return!1;return!0}class a{constructor($e,Te,ae,Ne){this.startLineNumber=$e,this.startColumn=Te,this.endLineNumber=ae,this.endColumn=Ne}}e.$rL=a;class m extends a{constructor($e,Te,ae){super($e,Te,$e,ae)}}e.$sL=m;var u;(function(fe){fe.List="list",fe.Tree="tree"})(u||(e.ViewMode=u={}));var C;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(C||(e.SearchSortOrder=C={}));function b(fe,$e=!0){const Te=fe&&fe.files&&fe.files.exclude,ae=$e&&fe&&fe.search&&fe.search.exclude;if(!Te&&!ae)return;if(!Te||!ae)return Te||ae;let Ne=Object.create(null);return Ne=R.$6n(Ne,R.$3n(Te)),Ne=R.$6n(Ne,R.$3n(ae),!0),Ne}function v(fe,$e){return fe.excludePattern&&O.$pk(fe.excludePattern,$e)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&O.$pk(fe.includePattern,$e)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(Te=>{const ae=Te.folder.fsPath;if(M.$vg($e,ae)){const Ne=$.$lc(ae,$e);return!Te.includePattern||!!O.$pk(Te.includePattern,Ne)}else return!1}):!1:!0}var d;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class E extends Error{constructor($e,Te){super($e),this.code=Te}}e.$vL=E;function k(fe){const $e=fe.message;if((0,y.$4)(fe))return new E($e,d.canceled);try{const Te=JSON.parse($e);return new E(Te.message,Te.code)}catch{return new E($e,d.other)}}function P(fe){const $e={message:fe.message,code:fe.code};return new Error(JSON.stringify($e))}function S(fe){return fe.type==="error"?!0:fe.type==="success"}function W(fe){return fe.type==="success"}function V(fe){return!!fe.path}function q(fe,$e,Te=!0){const ae=fe.searchPath?fe.searchPath:fe.relativePath;return Te?(0,A.$Yf)(ae,$e):O.$pk($e,ae)}class N{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=N;function B(fe,$e){const Te={...fe||{},...$e||{}};return Object.keys(Te).filter(ae=>{const Ne=Te[ae];return typeof Ne=="boolean"&&Ne})}class K{constructor($e,Te){this.c=null,this.a={...$e.excludePattern||{},...Te.excludePattern||{}},this.b=O.$qk(this.a);let ae=$e.includePattern;Te.includePattern&&(ae?ae={...ae,...Te.includePattern}:ae=Te.includePattern),ae&&(this.c=O.$qk(ae))}matchesExcludesSync($e,Te,ae){return!!(this.b&&this.b($e,Te,ae))}includedInQuerySync($e,Te,ae){return!(this.b&&this.b($e,Te,ae)||this.c&&!this.c($e,Te,ae))}includedInQuery($e,Te,ae){const Ne=this.b($e,Te,ae),ne=()=>this.c?!!this.c($e,Te,ae):!0;return(0,D.$ih)(Ne)?Ne.then(z=>z?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$EL=K;function ie(fe){for(const $e in fe)if(typeof fe[$e]!="boolean")return!0;return!1}function ce(fe){if(!fe)return;let $e;return Te=>($e||($e=(fe()||Promise.resolve([])).then(ae=>ae?Se(ae):{})),$e.then(ae=>!!ae[Te]))}function ye(fe){if(!fe)return;let $e;return Te=>{if(!$e){const ae=fe();$e=ae?Se(ae):{}}return!!$e[Te]}}function Se(fe){const $e={};for(const Te of fe)$e[Te]=!0;return $e}}),define(Pe[39],Ie([1,0,18,11,24,5,6,54,16,129,23,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f,a,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0;function C(W,V,q){return new T.$Yg(N=>E(N,q)).isEqual(W,V)}function b(W,V,q){return C(W.uri,V.uri,q)?0:(0,D.$qf)(W.uri.toString(),V.uri.toString())}function v(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:C(W.uri,V.uri,q)?(0,D.$qf)(W.name,V.name):(0,D.$qf)(W.uri.toString(),V.uri.toString())}function d(W,V,q,N){const B=W.slice(0).sort((ie,ce)=>q(ie,ce,N)),K=V.slice(0).sort((ie,ce)=>q(ie,ce,N));return(0,I.$Eb)(B,K,(ie,ce)=>q(ie,ce,N))}function E(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class k extends s.$Pi{static toExtHostWorkspace(V,q,N,B){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ye,transient:Se,isUntitled:fe}=V,$e=[],Te=q;q?ce.forEach((z,x)=>{const be=h.URI.revive(z.uri),Fe=k.o(N||q,be,B);Fe?(Fe.name=z.name,Fe.index=z.index,$e.push(Fe)):$e.push({uri:be,name:z.name,index:x})}):$e.push(...ce.map(({uri:z,name:x,index:be})=>({uri:h.URI.revive(z),name:x,index:be}))),$e.sort((z,x)=>z.index<x.index?-1:1);const ae=new k(K,ie,$e,!!Se,ye?h.URI.revive(ye):null,!!fe,z=>E(z,B)),{added:Ne,removed:ne}=d(Te?Te.workspaceFolders:[],ae.workspaceFolders,b,B);return{workspace:ae,added:Ne,removed:ne}}static o(V,q,N){for(let B=0;B<V.folders.length;B++){const K=V.workspaceFolders[B];if(C(K.uri,q,N))return K}}constructor(V,q,N,B,K,ie,ce){super(V,N.map(ye=>new s.$Qi(ye)),B,K,ce),this.t=q,this.u=ie,this.q=[],this.s=p.$Ci.forUris(ce),N.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$9g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let P=class{constructor(V,q,N,B,K){this.c=new M.$de,this.onDidChangeWorkspace=this.c.event,this.g=new M.$de,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new M.$fe,this.C=new Map,this.h=B,this.s=N,this.t=K,this.j=new y.$Dm,this.k=new O.$vh,this.o=V.getProxy(m.$$M.MainThreadWorkspace),this.q=V.getProxy(m.$$M.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?h.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>E(ce,N)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?h.URI.from({scheme:$.Schemas.untitled,path:(0,T.$7g)((0,T.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,N,...B){const K=[];if(Array.isArray(B)&&B.forEach(fe=>{h.URI.isUri(fe.uri)&&!K.some($e=>C($e.uri,fe.uri,this.s))&&K.push({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri)})}),this.n||[q,N].some(fe=>typeof fe!="number"||fe<0)||N===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+N>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,N,...K.map(fe=>({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri),index:void 0})));for(let fe=0;fe<ce.length;fe++){const $e=ce[fe];if(ce.some((Te,ae)=>ae!==fe&&C($e.uri,Te.uri,this.s)))return!1}ce.forEach((fe,$e)=>fe.index=$e);const{added:ye,removed:Se}=d(ie,ce,v,this.s);if(ye.length===0&&Se.length===0)return!1;if(this.o){const fe=V.displayName||V.name;this.o.$updateWorkspaceFolders(fe,q,N,K).then(void 0,$e=>{this.n=void 0;const Te={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,w.localize)(0,null,fe,$e.toString()),Te,[])})}return this.y(ce),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let N,B="";if(typeof V=="string"?(N=h.URI.file(V),B=V):typeof V<"u"&&(N=V,B=V.fsPath),!N)return B;const K=this.getWorkspaceFolder(N,!0);if(!K)return B;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$_g)(K.uri,N);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:N,removed:B}=k.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:B}))}findFiles(V,q,N,B,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:N,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},N,B=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,V,q,B)}async z(V,q,N,B=R.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const K=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ie={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:K,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let ce;if(V){const{includePattern:ye,folder:Se}=S(l.GlobPattern.from(V));ce=Se,ie.includePattern=ye}else{const{includePattern:ye,folder:Se}=S(l.GlobPattern.from(q));ce=Se,ie.filePattern=ye}return this.o.$startFileSearch(ce??null,ie,B).then(ye=>Array.isArray(ye)?ye.map(Se=>h.URI.revive(Se)):[])}async findTextInFiles(V,q,N,B,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:Se}=S(l.GlobPattern.from(q.include)),fe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,$e={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:fe},Te=!1;if(this.u[ie]=ae=>{if(Te)return;const Ne=h.URI.revive(ae.resource);ae.results.forEach(ne=>{const z=(0,u.$6h)(ne);(0,a.$mL)(z)?N({uri:Ne,preview:{text:z.preview.text,matches:(0,I.$1b)(z.preview.matches,x=>new t.$cN(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$1b)(z.ranges,x=>new t.$cN(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):N({uri:Ne,text:z.text,lineNumber:z.lineNumber})})},K.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(V,Se??null,$e,ie,K);return delete this.u[ie],ae||{}}catch(ae){throw delete this.u[ie],ae}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return h.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return h.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const N=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,N),(0,A.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(h.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const B=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!B),!B)return;const K=await B.provideEditSessionIdentity(N,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,N,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(h.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,N,B);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(V){return(q,N,B)=>{const K=function(ce){q.call(N,ce)};return K.extension=V,this.B.event(K,void 0,B)}}async $onWillCreateEditSessionIdentity(V,q,N){const B=await this.resolveWorkspaceFolder(h.URI.revive(V));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>N&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const N=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerCanonicalUriProvider(B,N),(0,A.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(V,q,N){const B=this.C.get(V.scheme);if(!B)return;const K=await B.provideCanonicalUri?.(h.URI.revive(V),q,N);if(K)return K}async $provideCanonicalUri(V,q,N){return this.provideCanonicalUri(h.URI.revive(V),{targetScheme:q},N)}};e.$Elc=P,e.$Elc=P=Je([We(0,c.$zP),We(1,n.$PP),We(2,i.$nlc),We(3,r.$3j),We(4,f.$Clc)],P),e.$Flc=(0,g.$wi)("IExtHostWorkspace");function S(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=h.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Pe[40],Ie([1,0,25,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=e.$Glc=void 0;function r(f,a){if(a){const m=a.split(".");let u=f;for(let C=0;u&&C<m.length;C++)u=u[m[C]];return u}}function o(f){return f instanceof g.URI}function s(f){return f&&f.uri instanceof g.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof g.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function c(f){if(o(f))return{resource:f};if(s(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let l=class{constructor(a,m,u){this.a=a.getProxy(M.$$M.MainThreadConfiguration),this.c=m,this.b=u,this.d=new T.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,m){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(a,m))}};e.$Glc=l,e.$Glc=l=Je([We(0,h.$zP),We(1,R.$Flc),We(2,w.$3j)],l);class t{constructor(a,m,u,C){this.a=new O.$de,this.b=a,this.f=C,this.c=m,this.e=p.$Ao.parse(u,C),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,m){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Ao.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(m,u))}getConfiguration(a,m,u){const C=c(m)||{},b=this.g(a?r(this.e.getValue(void 0,C,this.c.workspace),a):this.e.getValue(void 0,C,this.c.workspace));a&&this.h(a,C,u?.identifier);function v(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(E){return typeof r(b,E)<"u"},get:(E,k)=>{this.h(a?`${a}.${E}`:E,C,u?.identifier);let P=r(b,E);if(typeof P>"u")P=k;else{let S;const W=(V,q)=>{if((0,y.$$f)(V)){let N;const B=()=>{S=S||(0,I.$3n)(b),N=N||r(S,q)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return B(),()=>N;if(S)return N=N||r(S,q),N[ie];const ce=K[ie];return typeof ie=="string"?W(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(B(),N&&(N[ie]=ce),!0),deleteProperty:(K,ie)=>(B(),N&&delete N[ie],!0),defineProperty:(K,ie,ce)=>(B(),N&&Object.defineProperty(N,ie,ce),!0)})}return Array.isArray(V)?(0,I.$3n)(V):V};P=W(P,E)}return P},update:(E,k,P,S)=>{E=a?`${a}.${E}`:E;const W=v(P);return k!==void 0?this.b.$updateConfigurationOption(W,E,k,C,S):this.b.$removeConfigurationOption(W,E,C,S)},inspect:E=>{E=a?`${a}.${E}`:E;const k=this.e.inspect(E,C,this.c.workspace);if(k)return{key:E,defaultValue:(0,I.$3n)(k.policy?.value??k.default?.value),globalValue:(0,I.$3n)(k.user?.value??k.application?.value),workspaceValue:(0,I.$3n)(k.workspace?.value),workspaceFolderValue:(0,I.$3n)(k.workspaceFolder?.value),defaultLanguageValue:(0,I.$3n)(k.default?.override),globalLanguageValue:(0,I.$3n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,I.$3n)(k.workspace?.override),workspaceFolderLanguageValue:(0,I.$3n)(k.workspaceFolder?.override),languageIds:(0,I.$3n)(k.overrideIdentifiers)}}};return typeof b=="object"&&(0,I.$6n)(d,b,!1),Object.freeze(d)}g(a){const m=u=>(0,y.$$f)(u)?new Proxy(u,{get:(C,b)=>m(C[b]),set:(C,b,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(C,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(C,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:C=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return m(a)}h(a,m,u){const C=$.$ro.test(a)?4:this.d.get(a),b=u?`[${u.value}] `:"";if(C===4){typeof m?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(C===3){m?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,m){const u=new p.$Co(a,m,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(C,b)=>u.affectsConfiguration(C,c(b))})}k(a){return a.reduce((m,u)=>(m.set(u[0],u[1]),m),new Map)}}e.$Hlc=t,e.$Ilc=(0,D.$wi)("IExtHostConfiguration")}),define(Pe[121],Ie([1,0,2,11,5,4,7,39,68,40,24,53,17,27,3,16,22,12,80,241,14]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=e.$$mc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(l||(l={}));var t;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(t||(t={}));var f;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(f||(f={}));var a;(function(W){function V(B){if(B){const K=B;return K&&!!K.process}else return!1}W.is=V;function q(B){if(B==null)return;const K={process:B.process,args:B.args};return B.options&&(K.options=f.from(B.options)),K}W.from=q;function N(B){if(B!=null)return new A.$WN(B.process,B.args,B.options)}W.to=N})(a||(a={}));var m;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(m||(m={}));var u;(function(W){function V(B){if(B){const K=B;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(B){if(B==null)return;const K={};return B.commandLine!==void 0?K.commandLine=B.commandLine:(K.command=B.command,K.args=B.args),B.options&&(K.options=m.from(B.options)),K}W.from=q;function N(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new A.$XN(B.commandLine,B.options):new A.$XN(B.command,B.args?B.args:[],B.options)}W.to=N})(u||(u={}));var C;(function(W){function V(B){if(B){const K=B;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(B){return{customExecution:"customExecution"}}W.from=q;function N(B,K){return K.get(B)}W.to=N})(C||(e.CustomExecutionDTO=C={}));var b;(function(W){function V(q,N){let B;return q.scope!==void 0&&typeof q.scope!="number"?B=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?B=N.workspaceFile:B=n.$dI),{id:q._id,workspaceFolder:B}}W.from=V})(b||(e.TaskHandleDTO=b={}));var v;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(v||(v={}));var d;(function(W){function V(B,K){if(B==null)return[];const ie=[];for(const ce of B){const ye=q(ce,K);ye&&ie.push(ye)}return ie}W.fromMany=V;function q(B,K){if(B==null)return;let ie;B.execution instanceof A.$WN?ie=a.from(B.execution):B.execution instanceof A.$XN?ie=u.from(B.execution):B.execution&&B.execution instanceof A.$YN&&(ie=C.from(B.execution));const ce=l.from(B.definition);let ye;return B.scope?typeof B.scope=="number"?ye=B.scope:ye=B.scope.uri:ye=A.TaskScope.Workspace,!ce||!ye?void 0:{_id:B._id,definition:ce,name:B.name,source:{extensionId:K.identifier.value,label:B.source,scope:ye},execution:ie,isBackground:B.isBackground,group:v.from(B.group),presentationOptions:t.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}W.from=q;async function N(B,K,ie){if(B==null)return;let ce;a.is(B.execution)?ce=a.to(B.execution):u.is(B.execution)?ce=u.to(B.execution):C.is(B.execution)&&(ce=C.to(B._id,ie));const ye=l.to(B.definition);let Se;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Se=B.source.scope:Se=await K.resolveWorkspaceFolder(I.URI.revive(B.source.scope)):Se=A.TaskScope.Workspace),!ye||!Se)return;const fe=new A.$ZN(ye,Se,B.name,B.source.label,ce,B.problemMatchers);return B.isBackground!==void 0&&(fe.isBackground=B.isBackground),B.group!==void 0&&(fe.group=A.$VN.from(B.group._id),fe.group&&B.group.isDefault&&(fe.group=new A.$VN(fe.group.id,fe.group.label),B.group.isDefault===!0&&(fe.group.isDefault=B.group.isDefault))),B.presentationOptions&&(fe.presentationOptions=t.to(B.presentationOptions)),B._id&&(fe._id=B._id),B.detail&&(fe.detail=B.detail),fe}W.to=N})(d||(e.TaskDTO=d={}));var E;(function(W){function V(N){return N}W.from=V;function q(N){if(N)return Object.assign(Object.create(null),N)}W.to=q})(E||(E={}));class k{#e;constructor(V,q,N){this._id=q,this.a=N,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let P=class{constructor(V,q,N,B,K,ie,ce,ye){this.q=new R.$de,this.r=new R.$de,this.s=new R.$de,this.u=new R.$de,this.a=V.getProxy(M.$$M.MainThreadTask),this.b=N,this.c=B,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,N){if(!N)return new A.$aN(()=>{});const B=this.x();return this.j.set(B,{type:q,provider:N,extension:V}),this.a.$registerTaskProvider(B,q),new A.$aN(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(E.from(V)).then(async q=>{const N=[];for(const B of q){const K=await d.to(B,this.b,this.m);K&&N.push(K)}return N})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,N){const B=this.m.get(V.id);B&&(this.o.set(V.id,B),this.e.attachPtyToTerminal(q,await B.callback(N))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const N=this.j.get(V);if(!N)return Promise.reject(new Error("no handler found"));const B=[],K=(0,O.$oh)(()=>N.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,B,N,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(B).then(()=>{ie(ce)})})})}async $resolveTask(V,q){const N=this.j.get(V);if(!N)return Promise.reject(new Error("no handler found"));if(q.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${N.type}].`);const B=await d.to(q,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const K=await N.provider.resolveTask(B,T.CancellationToken.None);if(!K)return;this.A(K,N);const ie=d.from(K,N.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return C.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,q,N){const B=await this.a.$createTaskId(V);!N&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,q.execution)),this.m.set(B,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const N=this.l.get(V.id);if(N)return N;let B;return q?B=Promise.resolve(new k(this,V.id,q)):B=d.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,V.id,K)}),this.l.set(V.id,B),B.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const N=this.n.values();let B=N.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=N.next()}};e.$$mc=P,e.$$mc=P=Je([We(0,h.$zP),We(1,w.$PP),We(2,p.$Flc),We(3,$.$KP),We(4,y.$Ilc),We(5,D.$7lc),We(6,s.$3j),We(7,i.$jlc)],P);let S=class extends P{constructor(V,q,N,B,K,ie,ce,ye){super(V,q,N,B,K,ie,ce,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const N=d.from(q,V);if(N===void 0)throw new Error("Task is not valid");if(C.is(N.execution))await this.y(N,q,!1);else throw new c.$_;const B=await this.z(await this.a.$getTaskExecution(N),q);return this.a.$executeTask(N).catch(K=>{throw new Error(K)}),B}v(V,q,N,B){const K=[];if(B)for(const ie of B){if(this.A(ie,N),!ie.definition||!V[ie.definition.type]){const ye=ie.source?ie.source:"No task source";this.f.warn(`The task [${ye}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=d.from(ie,N.extension);ce&&C.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:N.extension}}async w(V){if(C.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,N){}};e.$_mc=S,e.$_mc=S=Je([We(0,h.$zP),We(1,w.$PP),We(2,p.$Flc),We(3,$.$KP),We(4,y.$Ilc),We(5,D.$7lc),We(6,s.$3j),We(7,i.$jlc)],S),e.$anc=(0,g.$wi)("IExtHostTask")}),define(Pe[299],Ie([1,0,47,30]),function(le,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=R,e.$OL=M;function R(A){return"cellResults"in A}e.$NL="rawCell#";function M(A,p){let $=-1;const y=[];let T=[];return A.forEach(h=>{h.range.startLineNumber!==$&&T.length>0&&(y.push([...T]),T=[]),T.push(h),$=h.range.endLineNumber}),T.length>0&&y.push([...T]),y.map(h=>{const w=[],g=h[0].range.startLineNumber,r=h[h.length-1].range.endLineNumber;for(let o=g;o<=r;o++)w.push(p.getLineContent(o));return new I.$qL(w.join(`
`)+`
`,h.map(o=>new O.$ut(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Pe[300],Ie([1,0,177,21,5,6,28,13,15,2,38,76,4,32,8,7,35,275,114,25,16,231,299,297]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,C,b,v,d,E){this.q=b,this.r=v,this.s=d,this.t=E,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new R.$de,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$de,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$de,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$de,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$hlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(h.$$M.MainThreadNotebook),this.c=u.getProxy(h.$$M.MainThreadNotebookDocuments),this.d=u.getProxy(h.$$M.MainThreadNotebookEditors),this.i=C.converter,C.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const P=k.notebookEditor?.notebookUri,S=k.cell.handle,V=this.g.get(P)?.getCell(S);if(V)return V.apiCell}if(k&&k.$mid===14){const P=k.uri,S=this.g.get(P);if(S)return S.apiNotebook}return k}}),a.B(C)}getEditorById(u){const C=this.h.get(u);if(!C)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return C}getIdByEditor(u){for(const[C,b]of this.h)if(b.apiEditor===u)return C}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,C){const b=this.g.get(u);if(!b&&!C)throw new Error(`NO notebook document for '${u}'`);return b}static u(u,C){if(!C)return;const b=C.filenamePattern.map(v=>g.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(C.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:C.displayName,filenamePattern:b,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,C,b){const v=a.a++,d=typeof b.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(v,b),this.b.$registerNotebookCellStatusBarItemProvider(v,d,C);let E;return d!==void 0&&(E=b.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(d))),new r.$aN(()=>{this.f.delete(v),this.b.$unregisterNotebookCellStatusBarItemProvider(v,d),E?.dispose()})}async createNotebookDocument(u){const C=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&g.NotebookData.from(u.content)});return y.URI.revive(C)}async openNotebookDocument(u){const C=this.g.get(u);if(C)return C.apiNotebook;const b=await this.c.$tryOpenNotebook(u),v=this.g.get(y.URI.revive(b));return(0,$.$hg)(v?.apiNotebook)}async showNotebookDocument(u,C){y.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let b;typeof C=="object"?b={position:g.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(g.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:b={preserveFocus:!1};const v=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,b),d=v&&this.h.get(v)?.apiEditor;if(d)return d;throw v?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,C,b,v){const d=this.f.get(u),E=y.URI.revive(C),k=this.g.get(E);if(!k||!d)return;const P=k.getCellFromIndex(b);if(!P)return;const S=await d.provideCellStatusBarItems(P.apiCell,v);if(!S)return;const W=new M.$Tc,V=this.p.add([W]),N=(Array.isArray(S)?S:[S]).map(B=>g.NotebookStatusBarItem.from(B,this.i,W));return{cacheId:V,items:N}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,C,b,v,d){if((0,p.$7e)(C))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:C,serializer:b,options:v}),this.b.$registerNotebookSerializer(E,{id:u.identifier,location:u.extensionLocation},C,g.NotebookDocumentContentOptions.from(v),a.u(u,d)),(0,M.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(u,C,b){const v=this.x.get(u);if(!v)throw new Error("NO serializer found");const d=await v.serializer.deserializeNotebook(C.buffer,b);return new o.$Bw(g.NotebookData.from(d))}async $notebookToData(u,C,b){const v=this.x.get(u);if(!v)throw new Error("NO serializer found");const d=await v.serializer.serializeNotebook(g.NotebookData.to(C.value),b);return O.$Fe.wrap(d)}async $saveNotebook(u,C,b,v,d){const E=y.URI.revive(C),k=this.x.get(u);if(!k)throw new Error("NO serializer found");const P=this.g.get(E);if(!P)throw new Error("Document NOT found");if(P.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new T.$ll((0,I.localize)(0,null,this.z(E)),6);await this.y(E,v);const S={metadata:(0,n.$$n)(P.apiNotebook.metadata,B=>!(k.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of P.apiNotebook.getCells()){const K=new r.$DO(B.kind,B.document.getText(),B.document.languageId,B.mime,k.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);K.metadata=(0,n.$$n)(B.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),S.cells.push(K)}const W=await k.serializer.serializeNotebook(S,d);await this.s.value.writeFile(E,W);const V=this.s.getFileSystemProviderExtUri(E.scheme),q=await this.s.value.stat(E);return{name:V.basename(E),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$wl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(u,C,b,v,d){const E=this.x.get(u)?.serializer;if(!E)return{limitHit:!1,results:[]};const k=new A.$Bc;await(async(q,N,B)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,N,ye=>{ye.forEach(Se=>{k.has(Se)||v.some($e=>K.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(Te=>(0,f.$jhb)(Te,Se)))||k.add(Se)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(b,d,C);const S=new A.$Ac;let W=!1;const V=Array.from(k).map(async q=>{const N=[];try{if(d.isCancellationRequested)return;if(C.maxResults&&[...S.values()].reduce((ce,ye)=>ce+ye.cellResults.length,0)>C.maxResults){W=!0;return}const B=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ye=>B.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Se=>Se.items.map(fe=>fe.data.toString()))}));else{const ce=await this.s.value.readFile(q),ye=O.$Fe.fromString(ce.toString()),Se=await E.deserializeNotebook(ye.buffer,d);if(d.isCancellationRequested)return;g.NotebookData.from(Se).cells.forEach($e=>B.push({input:$e.source,outputs:$e.outputs.flatMap(Te=>Te.items.map(ae=>ae.valueBytes.toString()))}))}if(d.isCancellationRequested)return;B.forEach((ce,ye)=>{const Se=C.contentPattern.pattern,fe=new l.$fXb(ce.input,void 0,ce.outputs),$e=fe.findInInputs(Se),Te=fe.findInOutputs(Se),ae=Te.flatMap(Ne=>(0,t.$OL)(Ne.matches,Ne.textBuffer)).map((Ne,ne)=>(Ne.webviewIndex=ne,Ne));if($e.length>0||Te.length>0){const Ne={index:ye,contentResults:(0,t.$OL)($e,fe.inputTextBuffer),webviewResults:ae};N.push(Ne)}});const ie={resource:q,cellResults:N};S.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...S.values()]}}async y(u,C){const b=await this.s.value.stat(u);if(typeof C?.mtime=="number"&&typeof C.etag=="string"&&C.etag!==T.$vl&&typeof b.mtime=="number"&&typeof b.size=="number"&&C.mtime<b.mtime&&C.etag!==T.$wl({mtime:C.mtime,size:b.size}))throw new T.$ll((0,I.localize)(1,null),3,C)}z(u){return u.scheme===c.Schemas.file?u.fsPath:u.toString()}A(u,C,b){if(this.h.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const v=new i.$Emc(C,this.d,u,b.visibleRanges.map(g.NotebookRange.to),b.selections.map(g.NotebookRange.to),typeof b.viewColumn=="number"?g.ViewColumn.to(b.viewColumn):void 0);this.h.set(C,v)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const b of u.value.removedDocuments){const v=y.URI.revive(b),d=this.g.get(v);d&&(d.dispose(),this.g.delete(v),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(d.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===v.toString()&&this.h.delete(E.id)}if(u.value.addedDocuments){const b=[];for(const v of u.value.addedDocuments){const d=y.URI.revive(v.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const E=new s.$Dmc(this.c,this.q,this.r,d,v);b.push(...v.cells.map(k=>s.$Cmc.asModelAddData(k))),this.g.get(d)?.dispose(),this.g.set(d,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(E.apiNotebook)}}if(u.value.addedEditors)for(const b of u.value.addedEditors){if(this.h.has(b.id))return;const v=y.URI.revive(b.documentUri),d=this.g.get(v);d&&this.A(d,b.id,b)}const C=[];if(u.value.removedEditors)for(const b of u.value.removedEditors){const v=this.h.get(b);v&&(this.h.delete(b),this.k?.id===v.id&&(this.k=void 0),C.push(v))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(v=>this.h.get(v)).filter(v=>!!v);const b=new Set;this.l.forEach(v=>b.add(v.id));for(const v of this.h.values()){const d=b.has(v.id);v._acceptVisibility(d)}this.l=[...this.h.values()].map(v=>v).filter(v=>v.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const C=w.$XP.String.with("notebookType","A notebook type"),b=new w.$ZP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new w.$XP("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>O.$Fe.wrap(d))],new w.$YP("Notebook Data",d=>g.NotebookData.to(d.value))),v=new w.$ZP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new w.$XP("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new o.$Bw(g.NotebookData.from(d)))],new w.$YP("Bytes",d=>d.buffer));u.registerApiCommand(b),u.registerApiCommand(v)}}e.$Nmc=a}),define(Pe[301],Ie([1,0,19,24,44,37,23,66,47]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class y{constructor(h,w,g){this.k=h,this.l=w,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&M.$qk(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&M.$qk(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const w=this.k.folderQueries||[];return new Promise((g,r)=>{const o=s=>{this.f++,h(s)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=I.$nc(i);this.j&&this.j(i,n)||this.v(o,{base:s,basename:n})}),Promise.all(w.map(s=>this.p(s,o))).then(s=>{g({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,R.$hj)(s)))})})}async p(h,w){const g=new O.$oe,r=this.q(h),o=this.r(),s=new $.$EL(this.k,h),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(g),n=p.$_d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,g.token),l=n.elapsed(),t=p.$_d.create();return this.g&&!this.e||(c&&c.forEach(f=>{const a=I.$gc.relative(h.folder.path,f.path);if(i){const m=I.$nc(f.path);this.v(w,{base:h.folder,relativePath:a,basename:m});return}this.s(o,h.folder,a,w)}),this.g&&!this.e)?null:(this.u(o,s,w),{providerTime:l,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(h){const w=(0,$.$DL)(this.k.includePattern,h.includePattern),g=(0,$.$DL)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:g,includes:w,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},w,g,r){if(g===this.a){const s=I.$nc(this.a);this.v(r,{base:w,relativePath:this.a,basename:s})}function o(s){const i=I.$nc(s),n=I.$mc(s);let c=h[n];c||(c=h[n]=[],o(n)),c.push({base:w,relativePath:s,basename:i})}o(g)}u({rootEntries:h,pathToEntries:w},g,r){const o=this,s=this.a;function i(n){const c=(0,$.$GL)(()=>n.map(l=>l.basename));for(let l=0,t=n.length;l<t;l++){const f=n[l],{relativePath:a,basename:m}=f;if(g.matchesExcludesSync(a,m,s!==m?c:void 0))continue;const u=w[a];if(u)i(u);else{if(a===s)continue;o.v(r,f)}if(o.e)break}}i(h)}v(h,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(w))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(h,w,g,r){const o=this.c(h.cacheKey),s=new y(h,w,o&&o.token);let i=0;const n=c=>{i+=c.length,g(c.map(l=>this.d(l)))};return this.e(s,T.a,n,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(h)return this.b.has(h)||this.b.set(h,new O.$oe),this.b.get(h)}d(h){return h.relativePath?{resource:A.$0g(h.base,h.relativePath)}:{resource:h.base}}e(h,w,g,r){const o=r.onCancellationRequested(()=>{h.cancel()}),s=n=>{n&&(i.push(n),w>0&&i.length>=w&&(g(i),i=[]))};let i=[];return h.search(s).then(n=>(i.length&&g(i),o.dispose(),n),n=>(i.length&&g(i),o.dispose(),Promise.reject(n)))}}e.$Fmc=T}),define(Pe[302],Ie([1,0,18,270,37,97,28,16,19,23,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$PM=v;let l=class{constructor(E,k,P,S,W){this.a=E,this.b=k,this.c=P,this.d=S,this.e=W}text(E,k,P={}){E=this.f(E,P);const S=this.a.getValue(),W=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(s.$Ri),P),type:2,contentPattern:E,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:S.search.usePCRE2||W||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(E,k){const P=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const S={...E,wordSeparators:P.editor.wordSeparators};return this.j(E,k)&&(S.isCaseSensitive=!0),this.k(E)&&(S.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(S.notebookInfo||(S.notebookInfo={}),S.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(S.notebookInfo||(S.notebookInfo={}),S.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(S.notebookInfo||(S.notebookInfo={}),S.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(S.notebookInfo||(S.notebookInfo={}),S.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),S}file(E,k={}){return{...this.h(E,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(E,k){return E?(E=Array.isArray(E)?E.map(u):u(E),k?this.parseSearchPaths(E):{pattern:f(...Array.isArray(E)?E:[E])}):{}}h(E=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),S=this.g(k.excludePattern,k.expandPatterns),W=E.length>1,V=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(B=>this.q(B,k,S)):E.map(B=>this.r(B,k,S,W))).filter(B=>!!B),q={_reason:k._reason,folderQueries:V,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:S.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const B=I.$Hb(this.c.groups.flatMap(ce=>ce.editors.map(ye=>ye.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const K=B.filter(ce=>(0,c.$uL)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const N=k.extraFileResources&&k.extraFileResources.filter(B=>(0,c.$uL)(q,B.fsPath));return q.extraFileResources=N&&N.length?N:void 0,q}i(E){const k=[],P=new A.$Ac,S={};let W=!1;return E.forEach(V=>{if(V.scheme===p.Schemas.walkThrough)return;if((0,y.$bh)(V)){const N=this.b.getWorkspaceFolder(V)?.uri??V.with({path:$.$mc(V.fsPath)});let B=P.get(N);B||(W=!0,B={folder:N,includePattern:{}},k.push(B),P.set(N,B));const K=$.$lc(N.fsPath,V.fsPath);(0,D.$hg)(B.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,S[V.fsPath]=!0)}),{folderQueries:k,includePattern:S,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(E,k){if(k.isSmartCase){if(E.isRegExp){if(T.$Zf(E.pattern,!0))return!0}else if(T.$Zf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,w.$QC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const k=ie=>$.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),S=(Array.isArray(E)?E:a(E)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,M.$Gw)(ie,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):ie}),W=O.$K(S,ie=>k(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>T.$ff(ie,"/")).map(ie=>T.$ff(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),m(ie))),q={},N=this.m(W.searchPaths||[]);N&&N.length&&(q.searchPaths=N);const B=V.flat(),K=f(...B);return K&&(q.pattern=K),q}l(E,k){return k.disregardExcludeSettings?void 0:(0,c.$tL)(E,!k.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const k=E.flatMap(S=>{let{pathPortion:W,globPortion:V}=t(S);return V&&(V=C(V)),this.n(W).flatMap(N=>this.o(N,V))}),P=new Map;return k.forEach(S=>{const W=S.searchPath.toString(),V=P.get(W);V?S.pattern&&(V.pattern=V.pattern||{},V.pattern[S.pattern]=!0):P.set(W,{searchPath:S.searchPath,pattern:S.pattern?f(S.pattern):void 0})}),Array.from(P.values())}n(E){if($.$ic(E)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:E})}]:[{searchPath:h.URI.file($.$hc(E))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(E=u(E),E.startsWith("../")||E===".."){const S=$.$gc.resolve(k.path,E);return[{searchPath:k.with({path:S})}]}const P=C(E);return[{searchPath:k,pattern:P}]}else{if(E==="./"||E===".\\")return[];{const k=E.replace(/^\.[\/\\]/,""),S=this.b.getWorkspace().folders.map(W=>{const V=k.match(new RegExp(`^${T.$_e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(D.$eg);if(S.length)return S.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&C(V)}});{const W=E.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:E,q=g.localize(0,null,V);throw new Error(q)}}}}o(E,k){const P=E.pattern&&k?`${E.pattern}/${k}`:E.pattern||k,S=[{searchPath:E.searchPath,pattern:P}];return P&&!P.endsWith("**")&&S.push({searchPath:E.searchPath,pattern:P+"/**"}),S}q(E,k,P){const S=this.r((0,s.$Ri)(E.searchPath),k,P,!1);return S?{...S,includePattern:E.pattern}:null}r(E,k,P,S){let W;const V=h.URI.isUri(E)?E:E.uri;if(P.searchPaths){const ie=P.searchPaths.filter(ce=>(0,y.$3g)(ce.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),B={...this.l(q,k)||{},...W||{}},K=h.URI.isUri(E)?(0,y.$7g)(E):E.name;return{folder:V,folderName:S?K:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$OM=l,e.$OM=l=Je([We(0,r.$3i),We(1,s.$Fi),We(2,i.$YD),We(3,o.$3j),We(4,n.$MM)],l);function t(d){const E=d.match(/[\*\{\}\(\)\[\]\?]/);if(E){const k=E.index,P=d.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let S=d.substr(0,P.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:d.substr((P.index||0)+1)}}}return{pathPortion:d}}function f(...d){return d.length?d.reduce((E,k)=>(E[k]=!0,E),Object.create(null)):void 0}function a(d){return R.$ok(d,",").map(E=>E.trim()).filter(E=>!!E.length)}function m(d){return[`**/${d}/**`,`**/${d}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function u(d){return d.replace(/\\/g,"/")}function C(d){return u(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(d){return d.replace(/([?*[\]])/g,"[$1]")}function v(d,E){d=I.$Mb(d,S=>S.toString());const k=[],P=E.getWorkspace();return d&&d.forEach(S=>{let W;if(E.getWorkbenchState()===2)W=(0,y.$_g)(P.folders[0].uri,S),W&&W!=="."&&(W="./"+W);else{const V=E.getWorkspaceFolder(S);if(V){const q=V.name;if(P.folders.filter(B=>B.name===q).length===1){const B=(0,y.$_g)(V.uri,S);B===""?W=`./${V.name}`:W=`./${V.name}/${B}`}else W=S.fsPath}}W&&k.push(b(W))}),k}}),define(Pe[303],Ie([1,0,23,2,24,14,3,302,47,45,11]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mwb=h,e.$nwb=r;const D=7e3;function h(o,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const u of i)if(/^workspaceContains:/.test(u)){const C=u.substr(18);C.indexOf("*")>=0||C.indexOf("?")>=0||o.forceUsingSearch?c.push(C):n.push(C)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:l,resolve:t}=(0,T.$ph)(),f=u=>t({activationEvent:u}),a=Promise.all(n.map(u=>w(o,u,f))).then(()=>{}),m=g(o,s.identifier,c,f);return Promise.all([a,m]).then(()=>{t(void 0)}),l}async function w(o,s,i){for(const n of o.folders)if(await o.exists(I.$0g(O.URI.revive(n),s))){i(`workspaceContains:${s}`);return}}async function g(o,s,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new R.$oe,l=o.checkExists(o.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},D);let f=!1;try{f=await l}catch(a){M.$4(a)||M.$1(a)}c.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function r(o,s,i,n){const c=o.get(A.$vi),l=o.get($.$lL),f=c.createInstance(p.$OM).file(s.map(a=>(0,y.$Ri)(O.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return l.fileSearch(f,n).then(a=>!!a.limitHit,a=>M.$4(a)?!1:Promise.reject(a))}}),define(Pe[41],Ie([1,0,173,19,60,23,11,6,54,2,12,4,40,237,84,39,26,110,14,20,21,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,22,82]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f,a,m,u,C,b,v,d,E,k,P,S,W,V,q,N,B,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=e.$jmc=e.$imc=e.$hmc=void 0,e.$hmc=(0,a.$wi)("IHostUtils");let ce=ie=class extends p.$Uc{constructor(z,x,be,Fe,De,pe,ge,Q,Y,he,ue,Me,de){super(),this.Y=Me,this.Z=de,this.a=this.B(new k.$de),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=be,this.f=ge,this.j=Fe,this.m=De,this.s=pe,this.t=Y,this.u=he,this.w=ue,this.y=this.g.getProxy(D.$$M.MainThreadWorkspace),this.z=this.g.getProxy(D.$$M.MainThreadTelemetry),this.C=this.g.getProxy(D.$$M.MainThreadExtensionService),this.D=new A.$vh,this.F=new A.$vh,this.G=new A.$vh,this.H=new A.$vh,this.I=new Ne(this.f.extensions.activationEvents),this.L=new s.$U_b(this.I,this.f.extensions.allExtensions);const Ce=new n.$Sm(this.f.extensions.myExtensions);this.J=new s.$U_b(this.I,Te(this.L,Ce)),B.$t&&(this.s.info(`Creating extension host with the following global extensions: ${fe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${fe(this.J)}`)),this.M=new g.$3lc(this.g,this.s),this.N=new S.$amc(this.g),this.O=Q,this.h=z.createChild(new b.$ui([g.$4lc,this.M],[S.$bmc,this.N])),this.P=this.B(new w.$2lc(this.J,this.L,{onExtensionActivationError:(Ae,je,U)=>{this.C.$onExtensionActivationError(Ae,i.$3(je),U)},actualActivateExtension:async(Ae,je)=>{if(s.$U_b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,je),new w.$1lc;const U=this.J.getExtensionDescription(Ae);return this.fb(U,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(z){i.$1(z)}}async $(){this.O.onWillDeactivateAll();let z=[];try{z=this.J.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this.eb(De))}catch{}await Promise.all(z)}terminate(z,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Fe=>{this.s.error(Fe)}),this.g.dispose();const be=this.$();Promise.race([(0,A.$xh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(z){return this.G.isOpen()?this.P.isActivated(z):!1}async getExtension(z){const x=await this.C.$getExtension(z);return x&&{...x,identifier:new n.$Rm(x.identifier.value),extensionLocation:y.URI.revive(x.extensionLocation)}}ab(z,x){return this.P.activateByEvent(z,x)}bb(z,x){return this.P.activateById(z,x)}activateByIdWithErrors(z,x){return this.bb(z,x).then(()=>{const be=this.P.getActivatedExtension(z);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(z=>this.J)}getExtensionExports(z){if(this.G.isOpen())return this.P.getActivatedExtension(z).exports;try{return this.P.getActivatedExtension(z).exports}catch{return null}}async cb(z){if(z.scheme===V.Schemas.file&&this.c.fsRealpath){const x=z.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const be=await this.R.get(x);return y.URI.file(be)}return z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(z=>new ae(z))),this.Q}async db(z){const x=$.$Ci.forUris(be=>M.$1g.ignorePathCasing(be));return await Promise.all(z.map(async be=>{if(this.wb(be)){const Fe=await this.cb(be.extensionLocation);x.set(Fe,be)}})),x}eb(z){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(z))return x;const be=this.P.getActivatedExtension(z);if(!be)return x;try{typeof be.module.deactivate=="function"&&(x=Promise.resolve(be.module.deactivate()).then(void 0,Fe=>(this.s.error(Fe),Promise.resolve(void 0))))}catch(Fe){this.s.error(`An error occurred when deactivating the extension '${z.value}':`),this.s.error(Fe)}try{(0,p.$Pc)(be.subscriptions)}catch(Fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${z.value}':`),this.s.error(Fe)}return x}async fb(z,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(z.identifier):await this.C.$onWillActivateExtension(z.identifier),this.hb(z,x).then(be=>{const Fe=be.activationTimes;return this.C.$onDidActivateExtension(z.identifier,Fe.codeLoadingTime,Fe.activateCallTime,Fe.activateResolvedTime,x),this.gb(z,x,"success",Fe),be},be=>{throw this.gb(z,x,"failure"),be})}gb(z,x,be,Fe){const De=Se(z,x);this.z.$publicLog2("extensionActivationTimes",{...De,...Fe||{},outcome:be})}hb(z,x){const be=Se(z,x);this.z.$publicLog2("activatePlugin",be);const Fe=this.wb(z);if(!Fe)return Promise.resolve(new w.$Zlc(w.$Wlc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${z.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${z.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const De=new w.$Xlc(x.startup);return Promise.all([this.xb(z,(0,M.$0g)(z.extensionLocation,Fe),De),this.ib(z)]).then(pe=>(R.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),ie.jb(this.s,z.identifier,pe[0],pe[1],De))).then(pe=>(R.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),pe))}ib(z){const x=this.Z.createLanguageModelAccessInformation(z),be=new l.$6lc(z,this.M),Fe=new l.$5lc(z.identifier.value,!1,this.M),De=new W.$cmc(z,this.N),pe=z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([be.whenReady,Fe.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ue=(0,o.$OG)(z,"ipc")?this.f.messagePorts?.get(n.$Rm.toKey(z.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Fe,secrets:De,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Me){return O.$jc(z.extensionLocation.fsPath,Me)},get storagePath(){return Q.O.workspaceValue(z)?.fsPath},get globalStoragePath(){return Q.O.globalValue(z).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,z.identifier.value)},get logUri(){return y.URI.joinPath(Q.f.logsLocation,z.identifier.value)},get storageUri(){return Q.O.workspaceValue(z)},get globalStorageUri(){return Q.O.globalValue(z)},get extensionMode(){return pe},get extension(){return Y===void 0&&(Y=new $e(Q,z.identifier,z,ge,!1)),Y},get extensionRuntime(){return(0,o.$PG)(z,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(z)},get messagePassingProtocol(){if(!he){if(!ue)return;const Me=k.Event.buffer(k.Event.fromDOMEventEmitter(ue,"message",de=>de.data));ue.start(),he={onDidReceiveMessage:Me,postMessage:ue.postMessage.bind(ue)}}return he}})})}static jb(z,x,be,Fe,De){return be=be||{activate:void 0,deactivate:void 0},this.kb(z,x,be,Fe,De).then(pe=>new w.$Ylc(!1,null,De.build(),be,pe,Fe.subscriptions))}static kb(z,x,be,Fe,De){if(typeof be.activate=="function")try{De.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,ge=be.activate.apply(pe,[Fe]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ge).then(Q=>(De.activateResolveStop(),Q))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(be)}lb(z,x){this.bb(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:x}).then(void 0,be=>{this.s.error(be)})}mb(z,x=0){const Fe=Date.now();(0,B.$B)(()=>{for(let De=x;De<z.length;De+=1){const pe=z[De];for(const ge of pe.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Fe>50){this.mb(z,De);break}else this.lb(pe,ge)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(z=>{const x=z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(x)this.mb(be);else for(const Fe of be)if(Fe.activationEvents)for(const De of Fe.activationEvents)De==="onStartupFinished"&&this.lb(Fe,De)})}ob(){const z=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const x=this.j.workspace?this.j.workspace.folders:[],be=this.pb(x),Fe=this.rb(),De=Promise.all([Fe,z,be]).then(()=>{});return Promise.race([De,(0,A.$xh)(1e4)]).then(()=>{this.nb()}),De}pb(z){return z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(z,x))).then(()=>{})}async qb(z,x){if(this.isActivated(x.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Fe={logService:this.s,folders:z.map(pe=>pe.uri),forceUsingSearch:be||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,ge,Q)=>this.y.$checkExists(pe,ge,Q)},De=await(0,P.$mwb)(Fe,x);if(De)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:De.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(z){throw console.error(z),z}}async sb(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:x}=this.f.environment;if(!z||!x)throw new Error(I.localize(0,null));const be=await this.xb(null,x,new w.$Xlc(!1));if(!be||typeof be.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Fe,De)=>{const pe=(Y,he)=>{Y?(B.$t&&this.s.error("Test runner called back with error",Y),De(Y)):(B.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Fe(typeof he=="number"&&he>0?1:0))},ge=(0,M.$Xg)(x),Q=be.run(ge,pe);Q&&Q.then&&Q.then(()=>{B.$t&&this.s.info("Test runner finished successfully."),Fe(0)}).catch(Y=>{B.$t&&this.s.error("Test runner finished with error",Y),De(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(z,x){return this.S[z]=x,(0,p.$Sc)(()=>{delete this.S[z]})}async getRemoteExecServer(z){const{resolver:x}=await this.ub(z);return x?.resolveExecServer?.(z,{resolveAttempt:0})}async ub(z){const x=z.indexOf("+");if(x===-1)throw new t.$gN("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=z.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(z,x){const be=N.$_d.create(!1),Fe=()=>`[resolveAuthority(${(0,f.$Ll)(z)},${x})][${be.elapsed()}ms] `,De=F=>this.s.info(`${Fe()}${F}`),pe=F=>this.s.warn(`${Fe()}${F}`),ge=(F,G=void 0)=>this.s.error(`${Fe()}${F}`,G),Q=F=>{if(F instanceof t.$gN)return{type:"error",error:{code:F._code,message:F._message,detail:F._detail}};throw F},Y=async F=>{De(`activating resolver for ${F}...`);const{resolver:G,authorityPrefix:H}=await this.ub(F);if(!G)throw ge(`no resolver for ${H}`),new t.$gN(`No remote extension installed to resolve ${H}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:F}},he=z.split(/@|%40/g).reverse();De(`activating remote resolvers ${he.join(" -> ")}`);let ue;try{ue=await Promise.all(he.map(Y)).catch(async F=>{if(!(F instanceof t.$gN)||F._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw F;return pe(`resolving nested authorities failed: ${F.message}`),[await Y(z)]})}catch(F){return Q(F)}const Me=new A.$Hh;Me.cancelAndSet(()=>De("waiting..."),1e3);let de,Ce;for(const[F,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of ue.entries())try{if(F===ue.length-1)De("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(ee,{resolveAttempt:x,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),De("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$fN.isManagedResolvedAuthority(de)?de:void 0));else{if(De(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$gN(`Exec server was not available for ${ee}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(re){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),ge("returned an error",re),Me.dispose(),Q(re)}Me.dispose();const Ae={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${t.$fN.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let U;if(t.$fN.isManagedResolvedAuthority(de)){const F=x;this.Y.setFactory(F,de.makeConnection),U={authority:z,connectTo:new f.$Il(F),connectionToken:de.connectionToken}}else U={authority:z,connectTo:new f.$Jl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:U,options:je,tunnelInformation:Ae}}}async $getCanonicalURI(z,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Ll)(z)})`);const{resolver:be}=await this.ub(z);if(!be)return null;const Fe=y.URI.revive(x);if(typeof be.getCanonicalURI>"u")return Fe;const De=await(0,A.$oh)(()=>be.getCanonicalURI(Fe));return De||Fe}async $startExtensionHost(z){z.toAdd.forEach(pe=>pe.extensionLocation=y.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ye(this.I,this.L,this.J,z),Fe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$startExtensionHost: global extensions: ${fe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${fe(this.J)}`)),this.tb()}$activateByEvent(z,x){return x===1?this.D.wait().then(be=>this.ab(z,!1)):this.G.wait().then(be=>this.ab(z,!1))}async $activate(z,x){return await this.G.wait(),this.J.getExtensionDescription(z)?(await this.bb(z,x),!0):!1}async $deltaExtensions(z){z.toAdd.forEach(pe=>pe.extensionLocation=y.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ye(this.I,this.L,this.J,z),Fe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$deltaExtensions: global extensions: ${fe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${fe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){const x=c.$Fe.alloc(z),be=Math.random()%256;for(let Fe=0;Fe<z;Fe++)x.writeUInt8(be,Fe);return x}async $updateRemoteConnectionData(z){this.X=z,this.a.fire()}};e.$imc=ce,e.$imc=ce=ie=Je([We(0,a.$vi),We(1,e.$hmc),We(2,C.$zP),We(3,r.$Flc),We(4,h.$Ilc),We(5,T.$3j),We(6,m.$PP),We(7,u.$Llc),We(8,v.$sDb),We(9,d.$7lc),We(10,q.$emc),We(11,K.$fmc),We(12,E.$$lc)],ce);function ye(ne,z,x,be){ne.addActivationEvents(be.addActivationEvents);const Fe=new s.$U_b(ne,z.getAllExtensionDescriptions());Fe.deltaExtensions(be.toAdd,be.toRemove);const De=new n.$Sm(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of be.myToRemove)De.delete(ge);for(const ge of be.myToAdd)De.add(ge);const pe=Te(Fe,De);return{globalRegistry:Fe,myExtensions:pe}}function Se(ne,z){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}function fe(ne){return ne.getAllExtensionDescriptions().map(z=>z.identifier.value).join(",")}e.$jmc=(0,a.$wi)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(z,x,be,Fe,De){this.#e=z,this.#t=x,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.$hc((0,M.$Xg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Fe,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$kmc=$e;function Te(ne,z){return ne.getAllExtensionDescriptions().filter(x=>z.has(x.identifier))}class ae{constructor(z){this.a=z}setSearchTree(z){this.a=z}findSubstr(z){return this.a.findSubstr(z)}forEach(z){return this.a.forEach(z)}}e.$lmc=ae;class Ne{constructor(z){this.a=new n.$Tm,this.addActivationEvents(z)}readActivationEvents(z){return this.a.get(z.identifier)??[]}addActivationEvents(z){for(const x of Object.keys(z))this.a.set(x,z[x])}}}),define(Pe[304],Ie([1,0,60,2,4,40,26,20,17,27,3,41,12,13]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;let r=class{constructor(c,l,t,f,a,m,u){this.c=c,this.d=l,this.e=t,this.f=f,this.g=a,this.h=m,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new s(this.c,l,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,l,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const l of c.nodeModuleName)this.a.set(l,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(l=>c.alternativeModuleName(l))}};e.$unc=r,e.$unc=r=Je([We(2,T.$vi),We(3,M.$Ilc),We(4,D.$jmc),We(5,y.$PP),We(6,h.$3j)],r);let o=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&g.a.size){const l=(0,w.$_e)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const l=this.b.exec(this.c(c));if(!l)return;const[,t,f,a]=l,m=g.a.get(f);if(m!==void 0)return console.warn(`${f} as been renamed to ${m}, please update your imports`),t+m+a}c(c){return c.replace(/\\/g,"/")}};o=g=Je([We(0,y.$PP)],o);class s{constructor(c,l,t,f,a){this.c=c,this.d=l,this.e=t,this.f=f,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Tm}load(c,l){const t=this.d.findSubstr(l);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((a,m)=>f+=`	${m} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${f}`),this.b=this.c(A.$JG,this.e,this.f)}return this.b}}let i=class{constructor(c,l,t){this.e=c,this.f=l,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$$M.MainThreadTelemetry);const f=t.getProxy(R.$$M.MainThreadWindow);this.c=(a,m)=>{const u=O.URI.parse(a);return m?this.g(a,m):u.scheme==="http"||u.scheme==="https"?f.$openUri(u,a,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?f.$openUri(u,a,{}):this.g(a,m)}}load(c,l,t){const f=this.e.findSubstr(l);return f&&(this.a=f.identifier.value,this.h()),this.b=t(c),this.c}g(c,l){return this.i(),this.b(c,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,$.$zP)],i)}),define(Pe[122],Ie([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=e.$mmc=void 0,e.$mmc=(0,A.$wi)("IExtHostVariableResolverProvider");class g extends h.$DQ{constructor(s,i,n,c,l,t,f){function a(){if(n){const m=n.activeEditor();if(m)return m.document.uri;const u=c.tabGroups.all.find(C=>C.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof T.$YO||u.input instanceof T.$4O)return u.input.modified;if(u.input instanceof T.$XO||u.input instanceof T.$3O||u.input instanceof T.$1O)return u.input.uri}}}super({getFolderUri:m=>{const u=t.folders.filter(C=>C.name===m);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(m,u)=>l.getConfiguration(void 0,m).get(u),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=a();if(m)return R.$hc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const m=a();if(m){const u=i.getWorkspaceFolder(m);if(u)return R.$hc(u.uri.fsPath)}}},getSelectedText:()=>{if(n){const m=n.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(n){const m=n.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>s.getExtension(m)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(M.env))}}let r=class extends O.$Uc{constructor(s,i,n,c,l){super(),this.b=s,this.c=i,this.g=n,this.h=c,this.j=l,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$nmc=r,e.$nmc=r=Je([We(0,y.$jmc),We(1,D.$Flc),We(2,p.$KP),We(3,w.$Ilc),We(4,$.$Ulc)],r)}),define(Pe[123],Ie([1,0,11,5,2,20,3,4,67,41,17,7,39,226,228,40,122,6,36,32,8,18]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=e.$qmc=e.$pmc=e.$omc=void 0,e.$omc=(0,A.$wi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(v,d,E,k,P,S,W){this.N=d,this.O=E,this.P=k,this.Q=P,this.R=S,this.S=W,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$de,this.o=new O.$de,this.q=new O.$de,this.w=new O.$de,this.l=v.getProxy(p.$$M.MainThreadDebugService),this.A=new O.$de,this.C=new O.$de,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(q=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(v,d){const E=this.W(d);if(!E)return;const k=await this.H.get(v)?.getTreeItem?.(E);return k?this.U(v,k):void 0}registerDebugVisualizationTree(v,d,E){const k=M.$Rm.toKey(v.identifier),P=this.jb(k,d);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${d}' is already registered`);return this.H.set(P,E),this.l.$registerDebugVisualizerTree(P,!!E.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(P),this.H.delete(d)})}async $getVisualizerTreeItemChildren(v,d){const E=this.J.get(d)?.item;return E?(await this.H.get(v)?.getChildren?.(E))?.map(P=>this.U(v,P))||[]:[]}async $editVisualizerTreeItem(v,d){const E=this.J.get(v);if(!E)return;const k=await this.H.get(E.provider)?.editItem?.(E.item,d);return this.U(E.provider,k||E.item)}$disposeVisualizedTree(v){const d=this.J.get(v);if(!d)return;const E=[d.children];for(const k of E)if(k)for(const P of k)E.push(this.J.get(P)?.children),this.J.delete(P)}U(v,d){let E=this.I.get(d);return E||(E=this.F++,this.I.set(d,E),this.J.set(E,{provider:v,item:d})),c.DebugTreeItem.from(d,E)}asDebugSourceUri(v,d){const E=v;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let k=`debug:${encodeURIComponent(E.path||"")}`,P="?";return d&&(k+=`${P}session=${encodeURIComponent(d.id)}`,P="&"),k+=`${P}ref=${E.sourceReference}`,R.URI.parse(k)}else{if(E.path)return R.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(v){const d=[];for(const E of v.getAllExtensionDescriptions())if(E.contributes){const k=E.contributes.debuggers;if(k&&k.length>0)for(const P of k)(0,g.$tH)(P)&&d.push(P.type)}this.l.$registerDebugTypes(d)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const v=[];return this.z.forEach(d=>v.push(d)),v}async $resolveDebugVisualizer(v,d){const E=this.L.get(v);if(!E)throw new Error(`No debug visualizer found with id '${v}'`);let{v:k,provider:P,extensionId:S}=E;if(k.visualization||(k=await P.resolveDebugVisualization?.(k,d)||k,E.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${P}'`);return this.kb(S,k.visualization)}async $executeDebugVisualizerCommand(v){const d=this.L.get(v);if(!d)throw new Error(`No debug visualizer found with id '${v}'`);const E=d.v.visualization;E&&"command"in E&&this.S.executeCommand(E.command,...E.arguments||[])}W(v){const d=this.m.get(v.sessionId);return d&&{session:d.api,variable:v.variable,containerId:v.containerId,frameId:v.frameId,threadId:v.threadId}}async $provideDebugVisualizers(v,d,E,k){const P=this.W(E),S=this.jb(v,d),W=this.G.get(S);if(!P||!W)return[];const V=await W.provideDebugVisualization(P,k);return V?V.map(q=>{const N=++this.M;this.L.set(N,{v:q,provider:W,extensionId:v});const B=q.iconPath?this.lb(q.iconPath):void 0;return{id:N,name:q.name,iconClass:B?.iconClass,iconPath:B?.iconPath,visualization:this.kb(v,q.visualization)}}):[]}$disposeDebugVisualizers(v){for(const d of v)this.L.delete(d)}registerDebugVisualizationProvider(v,d,E){if(!v.contributes?.debugVisualizers?.some(S=>S.id===d))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${d})`);const k=M.$Rm.toKey(v.identifier),P=this.jb(k,d);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${d}' is already registered`);return this.G.set(P,E),this.l.$registerDebugVisualizer(k,d),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,d),this.G.delete(d)})}addBreakpoints(v){const d=v.filter(P=>{const S=P.id;return this.z.has(S)?!1:(this.z.set(S,P),!0)});this.gb(d,[],[]);const E=[],k=new Map;for(const P of d)if(P instanceof D.$cO){let S=k.get(P.location.uri.toString());S||(S={type:"sourceMulti",uri:P.location.uri,lines:[]},k.set(P.location.uri.toString(),S),E.push(S)),S.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character,mode:P.mode})}else P instanceof D.$dO&&E.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName,mode:P.mode});return this.l.$registerBreakpoints(E)}removeBreakpoints(v){const d=v.filter(S=>this.z.delete(S.id));this.gb([],d,[]);const E=d.filter(S=>S instanceof D.$cO).map(S=>S.id),k=d.filter(S=>S instanceof D.$dO).map(S=>S.id),P=d.filter(S=>S instanceof D.$eO).map(S=>S.id);return this.l.$unregisterBreakpoints(E,k,P)}startDebugging(v,d,E){return this.l.$startDebugging(v?v.uri:void 0,d,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(v){return this.l.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,d,E){if(!d)return new D.$aN(()=>{});const k=this.d++;return this.f.push({type:v,handle:k,provider:d}),this.l.$registerDebugConfigurationProvider(v,E,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,k),new D.$aN(()=>{this.f=this.f.filter(P=>P.provider!==d),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(v,d,E){if(!E)return new D.$aN(()=>{});if(!this.cb(v,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.$(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:d,handle:k,factory:E}),this.l.$registerDebugAdapterDescriptorFactory(d,k),new D.$aN(()=>{this.h=this.h.filter(P=>P.factory!==E),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(v,d){if(!d)return new D.$aN(()=>{});const E=this.j++;return this.k.push({type:v,handle:E,factory:d}),new D.$aN(()=>{this.k=this.k.filter(k=>k.factory!==d)})}async $runInTerminal(v,d){return Promise.resolve(void 0)}async $substituteVariables(v,d){let E;const k=await this.ib(v);return k&&(E={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(E,d)}X(v,d){if(v.type==="implementation")return new u(v.implementation)}Y(){}async $startDASession(v,d){const E=this,k=await this.hb(d);return this.eb(this.$(k.type),k).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const S=this.Z(P),W=this.X(S,k);if(!W)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const V=W;return this.D.set(v,V),this.db(k).then(q=>(q&&this.E.set(v,q),V.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const B=N,K={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(B.arguments.value);K.body={signature:ie},V.sendResponse(K)}else throw new Error("no signer")}catch(ie){K.success=!1,K.message=ie.message,V.sendResponse(K)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(N),N=(0,g.$yH)(N,!0),E.l.$acceptDAMessage(v,N)}),V.onError(N=>{q&&q.onError&&q.onError(N),this.l.$acceptDAError(v,N.name,N.message,N.stack)}),V.onExit(N=>{q&&q.onExit&&q.onExit(N??void 0,void 0),this.l.$acceptDAExit(v,N??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),V.startSession()))})}$sendDAMessage(v,d){d=(0,g.$xH)(d,!1);const E=this.E.get(v);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(d),this.D.get(v)?.sendMessage(d)}$stopDASession(v){const d=this.E.get(v);this.E.delete(v),d&&d.onWillStopSession&&d.onWillStopSession();const E=this.D.get(v);return this.D.delete(v),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const d=[],E=[],k=[];if(v.added)for(const P of v.added){const S=P.id;if(S&&!this.z.has(S)){let W;if(P.type==="function")W=new D.$dO(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode);else if(P.type==="data")W=new D.$eO(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage,P.mode);else{const V=R.URI.revive(P.uri);W=new D.$cO(new D.$mN(V,new D.$bN(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode)}(0,D.$aO)(W,S),this.z.set(S,W),d.push(W)}}if(v.removed)for(const P of v.removed){const S=this.z.get(P);S&&(this.z.delete(P),E.push(S))}if(v.changed){for(const P of v.changed)if(P.id){const S=this.z.get(P.id);if(S){if(S instanceof D.$dO&&P.type==="function"){const W=S;W.enabled=P.enabled,W.condition=P.condition,W.hitCondition=P.hitCondition,W.logMessage=P.logMessage,W.functionName=P.functionName}else if(S instanceof D.$cO&&P.type==="source"){const W=S;W.enabled=P.enabled,W.condition=P.condition,W.hitCondition=P.hitCondition,W.logMessage=P.logMessage,W.location=new D.$mN(R.URI.revive(P.uri),new D.$bN(P.line,P.character))}k.push(S)}}}this.gb(d,E,k)}async $acceptStackFrameFocus(v){let d;if(v){const E=await this.hb(v.sessionId);v.kind==="thread"?d=new D.$kO(E.api,v.threadId):d=new D.$jO(E.api,v.threadId,v.frameId)}this.B=d,this.C.fire(this.B)}$provideDebugConfigurations(v,d,E){return(0,I.$oh)(async()=>{const k=this.bb(v);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.ib(d);return k.provideDebugConfigurations(P,E)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(v,d,E,k){return(0,I.$oh)(async()=>{const P=this.bb(v);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.ib(d);return P.resolveDebugConfiguration(S,E,k)})}$resolveDebugConfigurationWithSubstitutedVariables(v,d,E,k){return(0,I.$oh)(async()=>{const P=this.bb(v);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.ib(d);return P.resolveDebugConfigurationWithSubstitutedVariables(S,E,k)})}async $provideDebugAdapter(v,d){const E=this.ab(v);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(d);return this.eb(E,k).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(P)})}async $acceptDebugSessionStarted(v){const d=await this.hb(v);this.n.fire(d.api)}async $acceptDebugSessionTerminated(v){const d=await this.hb(v);d&&(this.o.fire(d.api),this.m.delete(d.id))}async $acceptDebugSessionActiveChanged(v){this.u=v?await this.hb(v):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(v,d){(await this.hb(v))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(v,d){const k={session:(await this.hb(v)).api,event:d.event,body:d.body};this.w.fire(k)}Z(v){if(v instanceof D.$fO)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof D.$gO)return{type:"server",port:v.port,host:v.host};if(v instanceof D.$hO)return{type:"pipeServer",path:v.path};if(v instanceof D.$iO)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}$(v){const d=this.h.filter(E=>E.type===v);if(d.length>0)return d[0].factory}ab(v){const d=this.h.filter(E=>E.handle===v);if(d.length>0)return d[0].factory}bb(v){const d=this.f.filter(E=>E.handle===v);if(d.length>0)return d[0].provider}cb(v,d){if(v.contributes){const E=v.contributes.debuggers;if(E&&E.length>0){for(const k of E)if(k.label&&k.type&&k.type===d)return!0}}return!1}db(v){const E=v.configuration.type,k=this.k.filter(P=>P.type===E||P.type==="*").map(P=>(0,I.$oh)(()=>P.factory.createDebugAdapterTracker(v.api)).then(S=>S,S=>null));return Promise.race([Promise.all(k).then(P=>{const S=(0,l.$Hb)(P);if(S.length>0)return new m(S)}),new Promise(P=>setTimeout(()=>P(void 0),1e3))]).catch(P=>{})}async eb(v,d){const E=d.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new D.$gO(E));if(v){const P=await this.O.getExtensionRegistry();return(0,I.$oh)(()=>v.createDebugAdapterDescriptor(d.api,this.fb(d,P))).then(S=>{if(S)return S})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(d,k))}fb(v,d){}gb(v,d,E){(v.length>0||d.length>0||E.length>0)&&this.A.fire(Object.freeze({added:v,removed:d,changed:E}))}async hb(v){if(v)if(typeof v=="string"){const d=this.m.get(v);if(d)return d}else{let d=this.m.get(v.id);if(!d){const E=await this.ib(v.folderUri),k=v.parent?this.m.get(v.parent):void 0;d=new f(this.l,v.id,v.type,v.name,E,v.configuration,k?.api),this.m.set(d.id,d),this.l.$sessionCached(d.id)}return d}throw new Error("cannot find session")}ib(v){if(v){const d=R.URI.revive(v);return this.N.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}jb(v,d){return`${v}\0${d}`}kb(v,d){if(d){if("title"in d&&"command"in d)return{type:0};if("treeId"in d)return{type:1,id:`${v}\0${d.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(v){const d=this.mb(v);let E,k;return"id"in d?k=i.ThemeIcon.asClassName(d):E=d,{iconPath:E,iconClass:k}}mb(v){if(v instanceof D.$0N)return{id:v.id};const d=typeof v=="object"&&"dark"in v?v.dark:v,E=typeof v=="object"&&"light"in v?v.light:v;return{dark:typeof d=="string"?R.URI.file(d):d,light:typeof E=="string"?R.URI.file(E):E}}};e.$pmc=t,e.$pmc=t=Je([We(0,T.$zP),We(1,h.$Flc),We(2,y.$jmc),We(3,r.$Ilc),We(4,$.$Ulc),We(5,o.$mmc),We(6,n.$VP)],t);class f{constructor(v,d,E,k,P,S,W){this.f=v,this.g=d,this.h=E,this.j=k,this.k=P,this.l=S,this.m=W}get api(){const v=this;return this.d??=Object.freeze({id:v.g,type:v.h,get name(){return v.j},set name(d){v.j=d,v.f.$setDebugSessionName(v.g,d)},parentSession:v.m,workspaceFolder:v.k,configuration:v.l,customRequest(d,E){return v.f.$customDebugAdapterRequest(v.g,d,E)},getDebugProtocolBreakpoint(d){return v.f.$getDebugProtocolBreakpoint(v.g,d.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(v){this.j=v}get configuration(){return this.l}}e.$qmc=f;class a{constructor(v){this.value=Object.freeze({append(d){v.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$rmc=a;class m{constructor(v){this.d=v}onWillStartSession(){this.d.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(v):void 0)}onWillStopSession(){this.d.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.d.forEach(d=>d.onError?d.onError(v):void 0)}onExit(v,d){this.d.forEach(E=>E.onExit?E.onExit(v,d):void 0)}}class u extends w.$Rrb{constructor(v){super(),this.h=v,v.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.h.handleMessage(v)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let C=class extends t{constructor(v,d,E,k,P,S,W){super(v,d,E,k,P,S,W)}};e.$smc=C,e.$smc=C=Je([We(0,T.$zP),We(1,h.$Flc),We(2,y.$jmc),We(3,r.$Ilc),We(4,$.$Ulc),We(5,o.$mmc),We(6,n.$VP)],C)}),define(Pe[305],Ie([1,0,14,60,2,4,254,12,56,72,27,199,17,61,41,63]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=e.$vnc=void 0;class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(p.$3j),t=n.get(h.$zP).getProxy(M.$$M.MainThreadErrors);I.setUnexpectedErrorHandler(f=>{c.error(f);const a=I.$3(f);t.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(p.$3j),l=n.get(h.$zP),t=n.get(g.$jmc),f=n.get(r.$TP),a=l.getProxy(M.$$M.MainThreadExtensionService),m=l.getProxy(M.$$M.MainThreadErrors),u=await t.getExtensionPathIndex(),C=new WeakMap;function b(E,k){if(C.has(E))return C.get(E).stack;let P="",S,W;for(const q of k)P+=`
	at ${q.toString()}`,W=q.getFileName(),!S&&W&&(S=u.findSubstr(R.URI.file(W)));const V=`${E.name||"Error"}: ${E.message||""}${P}`;return C.set(E,{extensionIdentifier:S?.identifier,stack:V}),V}const v=Symbol("prepareStackTrace wrapped");let d=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(E){if(E===b||!E||E[v]){d=E||b;return}d=function(k,P){return b(k,P),E.call(Error,k,P)},Object.assign(d,{[v]:!0})}}),I.setUnexpectedErrorHandler(E=>{c.error(E);const k=I.$3(E),P=C.get(E);if(!P?.extensionIdentifier){m.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(P.extensionIdentifier,k);const S=f.onExtensionError(P.extensionIdentifier,E);c.trace("forwarded error to extension?",S,P)})}}e.$vnc=o;class s{constructor(n,c,l,t,f){this.a=l,this.b=new A.$3_b(n,null,t),c=s.e(c,this.b);const a=new y.$ui(...(0,$.$ys)());a.set(T.$PP,{_serviceBrand:void 0,...c,messagePorts:f}),a.set(h.$zP,new h.$AP(this.b)),a.set(w.$Clc,new w.$Dlc(t)),a.set(g.$hmc,l);const m=new D.$cr(a,!0);m.invokeFunction(o.installEarlyHandler),this.d=m.invokeFunction(u=>u.get(p.$3j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=m.invokeFunction(u=>u.get(g.$jmc)),this.c.initialize(),m.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(M.$$M.MainThreadExtensionService);return R.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=R.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const l=n.environment.extensionDevelopmentLocationURI;return l&&(n.environment.extensionDevelopmentLocationURI=l.map(t=>R.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=R.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=R.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$wnc=s}),define(Pe[306],Ie([1,0,18,11,24,44,16,19,23,2,47]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Hmc=e.$Gmc=void 0,e.$Imc=r;class D{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],l=new R.$oe(n);return new Promise((t,f)=>{this.a=new w(i);let a=!1;const m=(u,C)=>{if(!a&&!this.b){const b=this.h(u);r(u)&&typeof this.g.maxResults=="number"&&this.c+b>this.g.maxResults&&(this.b=!0,a=!0,l.cancel(),u=this.j(u,this.g.maxResults-this.c));const v=this.h(u);this.c+=v,(v>0||!r(u))&&this.a.add(u,C)}};Promise.all(c.map((u,C)=>this.k(u,b=>m(b,C),l.token))).then(u=>{l.dispose(),this.a.flush();const C=u.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||C,messages:u.flatMap(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[]),stats:{type:this.f}})},u=>{l.dispose();const C=(0,M.$hj)(u);f(new Error(C))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],l=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:l.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const l=new T.$EL(this.g,i),t=[],f={report:u=>{if(!this.l(u))return;const C=i.folder.scheme===A.Schemas.file?(0,T.$FL)(()=>this.e.readdir($.$9g(u.uri))):void 0,b=$.$_g(i.folder,u.uri);if(b){const v=l.includedInQuery(b,p.$nc(b),C);(0,O.$ih)(v)?t.push(v.then(d=>{d&&n(u)})):v&&n(u)}}},a=this.n(i);let m;return this.d.query.type===3?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,f,c):m=await this.d.provider.provideTextSearchResults(h(this.d.query.contentPattern),a,f,c),t.length&&await Promise.all(t),m}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,T.$DL)(this.g.includePattern,i.includePattern),c=(0,T.$DL)(this.g.excludePattern,i.excludePattern),l={folder:y.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(l.usePCRE2=this.g.usePCRE2),l}}e.$Gmc=D;function h(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new o(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$3g(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(g(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Hmc=w;function g(s){return r(s)?{preview:{matches:(0,I.$1b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.$1b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Jmc=o}),define(Pe[124],Ie([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0,e.$Mmc=h,e.$Kmc=(0,R.$wi)("IExtHostSearch");let D=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(O.$$M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new M.$Fmc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,i){const n=h(s),c=this.j.get(r);if(c)return this.l.fileSearch(n,c,l=>{this.c.$handleFileMatch(r,o,l.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,i){const n=this.e.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=h(s);return this.t(c,n).search(t=>this.c.$handleTextMatch(r,o,t),i)}$provideAITextSearchResults(r,o,s,i){const n=this.h.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=h(s);return this.v(c,n).search(t=>this.c.$handleTextMatch(r,o,t),i)}$enableExtensionHostSearch(){}t(r,o){return new T.$Gmc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new T.$Gmc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$Lmc=D,e.$Lmc=D=Je([We(0,A.$zP),We(1,p.$Clc),We(2,$.$3j)],D);function h(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(w),extraFileResources:g.extraFileResources&&g.extraFileResources.map(r=>y.URI.revive(r))}}function w(g){return{...g,folder:y.URI.revive(g.folder)}}}),define(Pe[307],Ie([1,0,24,14,5,6,16,33,2,158,154,141,95,20,38,12,58,59,213,4,257,285,80,86,262,263,264,243,232,32,265,40,266,123,112,267,245,258,268,269,68,67,259,41,271,65,272,46,27,286,287,246,273,90,274,81,82,248,300,276,219,277,288,278,118,249,279,280,281,17,282,124,83,283,250,284,84,87,121,63,53,116,289,290,260,291,292,88,8,7,251,61,252,64,293,294,111,39,227,79,26,120]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f,a,m,u,C,b,v,d,E,k,P,S,W,V,q,N,B,K,ie,ce,ye,Se,fe,$e,Te,ae,Ne,ne,z,x,be,Fe,De,pe,ge,Q,Y,he,ue,Me,de,Ce,Ae,je,U,F,G,H,ee,re,Oe,Ve,Ge,_e,xe,et,tt,it,at,gt,Ue,st,Z,X,me,qe,we,ot,dt,Rt,Vt,Qt,ri,Xt,Dt,Zt,Yt,Ze,ai){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=Ht;function Ht(ht){const mt=ht.get(ae.$PP),xt=ht.get(Te.$nlc),Kt=ht.get(fe.$Klc),Ft=ht.get(ye.$jmc),ft=ht.get(Dt.$Flc),jt=ht.get(tt.$TP),_t=ht.get(E.$Ilc),Ut=ht.get(dt.$Clc),Qe=ht.get(G.$zP),hi=ht.get(_e.$4lc),Jt=ht.get(xe.$Llc),Wt=ht.get(r.$4j),pt=ht.get(r.$3j),Lt=ht.get(me.$sDb),Ot=ht.get(t.$jlc),Mt=ht.get(Xt.$pnc),si=ht.get(re.$bmc),qt=ht.get(ie.$Ulc),oi=ht.get(pe.$fmc),At=ht.get(f.$tlc),Tt=ht.get(be.$$lc);Qe.set(n.$_M.ExtHostFileSystemInfo,xt),Qe.set(n.$_M.ExtHostLogLevelServiceShape,Wt),Qe.set(n.$_M.ExtHostWorkspace,ft),Qe.set(n.$_M.ExtHostConfiguration,_t),Qe.set(n.$_M.ExtHostExtensionService,Ft),Qe.set(n.$_M.ExtHostStorage,hi),Qe.set(n.$_M.ExtHostTunnelService,Lt),Qe.set(n.$_M.ExtHostWindow,Mt),Qe.set(n.$_M.ExtHostSecretState,si),Qe.set(n.$_M.ExtHostTelemetry,jt),Qe.set(n.$_M.ExtHostEditorTabs,qt),Qe.set(n.$_M.ExtHostManagedSockets,oi),Qe.set(n.$_M.ExtHostAuthentication,At),Qe.set(n.$_M.ExtHostChatProvider,Tt);const zt=Qe.set(n.$_M.ExtHostDecorations,ht.get(S.$umc)),Pt=Qe.set(n.$_M.ExtHostDocumentsAndEditors,ht.get(K.$KP)),$t=Qe.set(n.$_M.ExtHostCommands,ht.get(v.$VP)),Et=Qe.set(n.$_M.ExtHostTerminalService,ht.get(it.$7lc)),ci=Qe.set(n.$_M.ExtHostTerminalShellIntegration,ht.get(at.$bnc)),kt=Qe.set(n.$_M.ExtHostDebugService,ht.get(P.$omc)),gi=Qe.set(n.$_M.ExtHostSearch,ht.get(ee.$Kmc)),ei=Qe.set(n.$_M.ExtHostTask,ht.get(et.$anc)),wi=Qe.set(n.$_M.ExtHostOutputService,ht.get(Ce.$Zmc)),ui=Qe.set(n.$_M.ExtHostLocalization,ht.get(De.$emc)),bi=Qe.set(n.$_M.ExtHostUrls,new Rt.$mnc(Qe)),It=Qe.set(n.$_M.ExtHostDocuments,new B.$qlc(Qe,Pt)),Di=Qe.set(n.$_M.ExtHostDocumentContentProviders,new q.$wmc(Qe,Pt,pt)),ti=Qe.set(n.$_M.ExtHostDocumentSaveParticipant,new N.$xmc(pt,It,Qe.getProxy(n.$$M.MainThreadBulkEdits))),St=Qe.set(n.$_M.ExtHostNotebook,new Q.$Nmc(Qe,$t,Pt,It,Kt,gi)),ve=Qe.set(n.$_M.ExtHostNotebookDocuments,new he.$Tmc(St)),Re=Qe.set(n.$_M.ExtHostNotebookEditors,new ue.$Umc(pt,St)),se=Qe.set(n.$_M.ExtHostNotebookKernels,new Me.$Vmc(Qe,mt,St,$t,pt)),J=Qe.set(n.$_M.ExtHostNotebookRenderers,new de.$Xmc(Qe,St)),ke=Qe.set(n.$_M.ExtHostNotebookDocumentSaveParticipant,new Y.$Smc(pt,St,Qe.getProxy(n.$$M.MainThreadBulkEdits))),Be=Qe.set(n.$_M.ExtHostEditors,new Ue.$zlc(Qe,Pt)),Xe=Qe.set(n.$_M.ExtHostTreeViews,new X.$knc(Qe.getProxy(n.$$M.MainThreadTreeViews),$t,pt)),He=Qe.set(n.$_M.ExtHostEditorInsets,new b.$Alc(Qe.getProxy(n.$$M.MainThreadEditorInsets),Be,mt.remote)),ut=Qe.set(n.$_M.ExtHostDiagnostics,new W.$plc(Qe,pt,xt,Pt)),yt=Qe.set(n.$_M.ExtHostLanguages,new Fe.$Qmc(Qe,It,$t.converter,Ut)),ct=Qe.set(n.$_M.ExtHostLanguageFeatures,new x.$rlc(Qe,Ut,It,$t,ut,pt,Ot,jt)),ii=Qe.set(n.$_M.ExtHostFileSystem,new Se.$zmc(Qe,ct)),Ct=Qe.set(n.$_M.ExtHostFileSystemEventService,new $e.$Amc(Qe,pt,Pt)),Bt=Qe.set(n.$_M.ExtHostQuickOpen,(0,F.$4mc)(Qe,ft,$t)),ki=Qe.set(n.$_M.ExtHostSCM,new H.$6mc(Qe,$t,It,pt)),Ki=Qe.set(n.$_M.ExtHostQuickDiff,new U.$3mc(Qe,Ut)),Oi=Qe.set(n.$_M.ExtHostShare,new Oe.$7mc(Qe,Ut)),Mi=Qe.set(n.$_M.ExtHostComments,(0,d.$Blc)(Qe,$t,It)),Si=Qe.set(n.$_M.ExtHostProgress,new je.$2mc(Qe.getProxy(n.$$M.MainThreadProgress))),Ti=Qe.set(n.$_M.ExtHostLabelService,new z.$Pmc(Qe)),Fi=Qe.set(n.$_M.ExtHostTheming,new st.$hnc(Qe)),Ji=Qe.set(n.$_M.ExtHostTimeline,new Z.$jnc(Qe,$t)),Li=Qe.set(n.$_M.ExtHostWebviews,new Vt.$Plc(Qe,mt.remote,ft,pt,Ot)),Pi=Qe.set(n.$_M.ExtHostWebviewPanels,new Qt.$Slc(Qe,Li,ft)),zi=Qe.set(n.$_M.ExtHostCustomEditors,new k.$Tlc(Qe,It,Jt,Li,Pi)),Ui=Qe.set(n.$_M.ExtHostWebviewViews,new ri.$nnc(Qe,Li)),vi=Qe.set(n.$_M.ExtHostTesting,new gt.$dnc(Qe,pt,$t,Pt)),Qi=Qe.set(n.$_M.ExtHostUriOpeners,new ot.$lnc(Qe)),Xi=Qe.set(n.$_M.ExtHostProfileContentHandlers,new Ae.$1mc(Qe));Qe.set(n.$_M.ExtHostInteractive,new ne.$Omc(Qe,St,Pt,$t,pt));const Zi=Qe.set(n.$_M.ExtHostInlineChat,new Ne.$Bmc(Qe,$t,It,pt)),Ii=Qe.set(n.$_M.ExtHostChatAgents2,new m.$wlc(Qe,pt,$t)),Yi=Qe.set(n.$_M.ExtHostChatVariables,new u.$xlc(Qe)),xi=Qe.set(n.$_M.ExtHostAiRelatedInformation,new c.$ilc(Qe)),dn=Qe.set(n.$_M.ExtHostAiEmbeddingVector,new ce.$ymc(Qe)),Ci=Qe.set(n.$_M.ExtHostStatusBar,new Ge.$0mc(Qe,$t.converter)),ji=Qe.set(n.$_M.ExtHostSpeech,new Ve.$8mc(Qe)),fn=Object.values(n.$_M);Qe.assertRegistered(fn);const gn=new a.$vlc(Qe,Pt),_i=new C.$ylc(Qe),Bi=new ge.$Rmc(Qe,pt),Ri=new V.$vmc(Qe);return l.$slc.register($t),function(ze,di,Vi){function nt(_){return(oe,Le,rt)=>{const vt=_(Nt=>{try{oe.call(Le,Nt)}catch(Ei){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Ei.toString()}`,{cause:Ei})),jt.onExtensionError(ze.identifier,Ei)}});return rt?.push(vt),vt}}const bt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(pt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")oe();else{const vt=rt;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Ze.$PG)(ze,"documentFiltersExclusive")}return rt}}(),en={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ze.$PG)(ze,"authLearnMore"),At.getSession(ze,_,oe,Le)},getSessions(_,oe){return(0,Ze.$PG)(ze,"authGetSessions"),At.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Ze.$PG)(ze,"authSession"),!!await At.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(At.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,rt){return At.registerAuthenticationProvider(_,oe,Le,rt)}},mi={registerCommand(_,oe,Le){return $t.registerCommand(!0,_,oe,Le,void 0,ze)},registerTextEditorCommand(_,oe,Le){return $t.registerCommand(!0,_,(...rt)=>{const vt=Be.getActiveTextEditor();if(!vt){pt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Nt=>{oe.apply(Le,[vt,Nt,...rt])}).then(Nt=>{Nt||pt.warn("Edits from command "+_+" were not applied.")},Nt=>{pt.warn("An error occurred while running command "+_,Nt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Le)=>((0,Ze.$PG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...rt)=>{const vt=Pt.activeEditor(!0);if(!vt){pt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Nt=await Be.getDiffInformation(vt.id);oe.apply(Le,[Nt,...rt])},void 0,void 0,ze)),executeCommand(_,...oe){return $t.executeCommand(_,...oe)},getCommands(_=!1){return $t.getCommands(_)}},yi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return nt(Et.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$PG)(ze,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$PG)(ze,"telemetry"),nt(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$SP)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$RP.validateSender(_),jt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return Mt.openUri(_,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===mt.environment.appUriScheme)return bi.createAppUri(_);try{return await Mt.asExternalUri(_,{allowTunneling:!!mt.remote.authority})}catch(oe){if((0,A.$Fg)(_,A.Schemas.http)||(0,A.$Fg)(_,A.Schemas.https))return _;throw oe}},get remoteName(){return(0,o.$Im)(mt.remote.authority)},get remoteAuthority(){return(0,Ze.$PG)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return nt(pt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$PG)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Ze.$PG)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(yi);const mn={createTestController(_,oe,Le){return vi.createTestController(ze,_,oe,Le)},createTestObserver(){return(0,Ze.$PG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$PG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$PG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Ze.$PG)(ze,"testObserver"),vi.results}},ni=mt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,Ai={getExtension(_,oe){(0,Ze.$OG)(ze,"extensionsAny")||(oe=!1);const Le=di.mine.getExtensionDescription(_);if(Le)return new ye.$kmc(Ft,ze.identifier,Le,ni,!1);if(oe){const rt=di.all.getExtensionDescription(_);if(rt)return new ye.$kmc(Ft,ze.identifier,rt,ni,!0)}},get all(){const _=[];for(const oe of di.mine.getAllExtensionDescriptions())_.push(new ye.$kmc(Ft,ze.identifier,oe,ni,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$PG)(ze,"extensionsAny");const _=new w.$Sm(di.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of di.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);oe.push(new ye.$kmc(Ft,ze.identifier,Le,ni,rt))}return oe},get onDidChange(){return(0,Ze.$OG)(ze,"extensionsAny")?nt(R.Event.any(di.mine.onDidChange,di.all.onDidChange)):nt(di.mine.onDidChange)}},tn={createDiagnosticCollection(_){return ut.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(ut.onDidChangeDiagnostics)},getDiagnostics:_=>ut.getDiagnostics(_),getLanguages(){return yt.getLanguages()},setTextDocumentLanguage(_,oe){return yt.changeLanguage(_.uri,oe)},match(_,oe){const Le=qe.LanguageSelector.from(_);let rt;return(0,T.$Yt)(Le)&&(rt=St.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Nt=>Nt.document===oe))?.apiNotebook),(0,T.$Xt)(Le,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ct.registerCodeActionProvider(ze,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Ze.$PG)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(ze,bt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(ze,bt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(ze,bt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(ze,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(ze,bt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(ze,bt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(ze,bt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(ze,bt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(ze,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(ze,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(ze,bt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(ze,bt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(ze,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Ze.$PG)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ct.registerDocumentSymbolProvider(ze,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(ze,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(ze,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...rt){return ct.registerOnTypeFormattingEditProvider(ze,bt(_),oe,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,oe,Le){return ct.registerDocumentSemanticTokensProvider(ze,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ct.registerDocumentRangeSemanticTokensProvider(ze,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(ze,bt(_),oe,Le):ct.registerSignatureHelpProvider(ze,bt(_),oe,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,oe,...Le){return ct.registerCompletionItemProvider(ze,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Ze.$PG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$PG)(ze,"inlineCompletionsAdditions"),Le&&(0,Ze.$PG)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Ze.$PG)(ze,"inlineEdit"),ct.registerInlineEditProvider(ze,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(ze,bt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(ze,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(ze,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Ze.$PG)(ze,"tokenInformation"),yt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return yt.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ct.registerDocumentOnDropEditProvider(ze,_,oe,(0,Ze.$OG)(ze,"documentPaste")?Le:void 0)}},nn={get activeTextEditor(){return Be.getActiveTextEditor()},get visibleTextEditors(){return Be.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(_,oe,Le){$.URI.isUri(_)&&_.scheme===A.Schemas.vscodeRemote&&!_.authority&&Ot.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await($.URI.isUri(_)?Promise.resolve(Wi.openTextDocument(_)):Promise.resolve(_));return Be.showTextDocument(rt,oe,Le)},createTextEditorDecorationType(_){return Be.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Le){return nt(Be.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return nt(Be.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return nt(Be.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return nt(Be.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return nt(Be.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return nt(Be.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return nt(Et.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return nt(Et.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return nt(Et.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Ze.$PG)(ze,"terminalDimensions"),nt(Et.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return nt(Et.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Ze.$PG)(ze,"terminalDataWriteEvent"),nt(Et.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Ze.$PG)(ze,"terminalExecuteCommandEvent"),nt(Et.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Ze.$PG)(ze,"terminalShellIntegration"),nt(ci.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Ze.$PG)(ze,"terminalShellIntegration"),nt(ci.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Ze.$PG)(ze,"terminalShellIntegration"),nt(ci.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Mt.getState()},onDidChangeWindowState(_,oe,Le){return nt(Mt.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Bi.showMessage(ze,p.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Bi.showMessage(ze,p.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Bi.showMessage(ze,p.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return Bt.showQuickPick(ze,_,oe,Le)},showWorkspaceFolderPick(_){return Bt.showWorkspaceFolderPick(_)},showInputBox(_,oe){return Bt.showInput(_,oe)},showOpenDialog(_){return Ri.showOpenDialog(ze,_)},showSaveDialog(_){return Ri.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let rt,vt,Nt;return typeof _=="string"?(rt=_,vt=oe,Nt=Le):(vt=_,Nt=oe),Ci.createStatusBarEntry(ze,rt,vt,Nt)},setStatusBarMessage(_,oe){return Ci.setStatusBarMessage(_,oe)},withScmProgress(_){return Ot.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Si.withProgress(ze,{location:we.ProgressLocation.SourceControl},(oe,Le)=>_({report(rt){}}))},withProgress(_,oe){return Si.withProgress(ze,_,oe)},createOutputChannel(_,oe){return wi.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Le,rt){return Pi.createWebviewPanel(ze,_,oe,Le,rt)},createWebviewTextEditorInset(_,oe,Le,rt){return(0,Ze.$PG)(ze,"editorInsets"),He.createWebviewEditorInset(_,oe,Le,rt,ze)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?Et.createExtensionTerminal(_):Et.createTerminalFromOptions(_):Et.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return Et.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return Et.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Ze.$PG)(ze,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return Xe.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return Xe.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Pi.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>zi.registerCustomEditorProvider(ze,_,oe,Le),registerFileDecorationProvider(_){return zt.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return bi.registerUriHandler(ze,_)},createQuickPick(){return Bt.createQuickPick(ze)},createInputBox(){return Bt.createInputBox(ze)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return nt(Fi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return Ui.registerWebviewViewProvider(ze,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return nt(St.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(St.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return nt(Re.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return nt(Re.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return St.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Ze.$PG)(ze,"externalUriOpener"),Qi.registerExternalUriOpener(ze.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Ze.$PG)(ze,"profileContentHandlers"),Xi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Le,rt){return(0,Ze.$PG)(ze,"quickDiffProvider"),Ki.registerQuickDiffProvider(bt(_),oe,Le,rt)},get tabGroups(){return qt.tabGroups},registerShareProvider(_,oe){return(0,Ze.$PG)(ze,"shareProvider"),Oi.registerShareProvider(bt(_),oe)}},Wi={get rootPath(){return Ot.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(ze,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return nt(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,rt)=>ft.findFiles(_,oe,Le,ze.identifier,rt),findFiles2:(_,oe,Le)=>((0,Ze.$PG)(ze,"findFiles2"),ft.findFiles2(_,oe,ze.identifier,Le)),findTextInFiles:(_,oe,Le,rt)=>{(0,Ze.$PG)(ze,"findTextInFiles");let vt,Nt;return typeof oe=="object"?(vt=oe,Nt=Le):(vt={},Nt=oe,rt=Le),ft.findTextInFiles(_,vt||{},Nt,ze.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return gn.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Le,rt)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Ze.$PG)(ze,"createFileSystemWatcher"),vt={...oe,correlate:!0}),Ct.createFileSystemWatcher(ft,ze,_,vt)},get textDocuments(){return It.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve($.URI.file(_));else if($.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===A.Schemas.vscodeRemote&&!rt.authority&&Ot.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),It.ensureDocumentData(rt).then(vt=>vt.document)))},onDidOpenTextDocument:(_,oe,Le)=>nt(It.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>nt(It.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>nt(It.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>nt(It.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>nt(ti.getOnWillSaveTextDocumentEvent(ze))(_,oe,Le),get notebookDocuments(){return St.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if($.URI.isUri(_))Le=_,await St.openNotebookDocument(_);else if(typeof _=="string")Le=$.URI.revive(await St.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return nt(ve.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return nt(ve.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return nt(ke.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Le)},get onDidOpenNotebookDocument(){return nt(St.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(St.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,rt){return St.registerNotebookSerializer(ze,_,oe,Le,(0,Ze.$OG)(ze,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,oe,Le)=>nt(Vi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Vi.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return Di.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Ot.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ei.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,M.$Rc)(ii.registerFileSystemProvider(ze,_,oe,Le),Kt.addFileSystemProvider(_,oe,Le))},get fs(){return Kt.value},registerFileSearchProvider:(_,oe)=>((0,Ze.$PG)(ze,"fileSearchProvider"),gi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Ze.$PG)(ze,"textSearchProvider"),gi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Ze.$PG)(ze,"aiTextSearchProvider"),(0,Ze.$PG)(ze,"textSearchProvider"),gi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Ze.$PG)(ze,"resolvers"),Ft.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Ze.$PG)(ze,"resolvers"),Ti.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$PG)(ze,"resolvers"),Ft.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>nt(Ct.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>nt(Ct.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>nt(Ct.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>nt(Ct.getOnWillCreateFileEvent(ze))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>nt(Ct.getOnWillDeleteFileEvent(ze))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>nt(Ct.getOnWillRenameFileEvent(ze))(_,oe,Le),openTunnel:_=>((0,Ze.$PG)(ze,"tunnels"),Lt.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ze.$PG)(ze,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Ze.$PG)(ze,"tunnels"),nt(Lt.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Ze.$PG)(ze,"portsAttributes"),Lt.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Ze.$PG)(ze,"tunnelFactory"),Lt.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Ze.$PG)(ze,"timeline"),Ji.registerTimelineProvider(_,oe,ze.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$PG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>nt(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Ze.$PG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Ze.$PG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Ze.$PG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Ze.$PG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},rn={get inputBox(){return Ot.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(ze)},createSourceControl(_,oe,Le){return ki.createSourceControl(ze,_,oe,Le)}},$n={createCommentController(_,oe){return Mi.createCommentController(ze,_,oe)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Ze.$OG)(ze,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Ze.$PG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Ze.$PG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Le){return nt(kt.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return nt(kt.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return nt(kt.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return nt(kt.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return(0,Ze.$PG)(ze,"debugFocus"),nt(kt.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return kt.registerDebugConfigurationProvider(_,oe,Le||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return kt.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return kt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,oe,{parentSession:Le}):kt.startDebugging(_,oe,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return kt.asDebugSourceUri(_,oe)}},on={registerTaskProvider:(_,oe)=>ei.registerTaskProvider(ze,_,oe),fetchTasks:_=>ei.fetchTasks(_),executeTask:_=>ei.executeTask(ze,_),get taskExecutions(){return ei.taskExecutions},onDidStartTask:(_,oe,Le)=>nt(ei.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>nt(ei.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>nt(ei.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>nt(ei.onDidEndTaskProcess)(_,oe,Le)},pn={createNotebookController(_,oe,Le,rt,vt){return se.createNotebookController(ze,_,oe,Le,rt,(0,Ze.$OG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>St.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return J.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$PG)(ze,"notebookKernelSource"),se.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Ze.$PG)(ze,"notebookKernelSource"),se.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Ze.$PG)(ze,"notebookCellExecutionState"),nt(se.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},wn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ui.getMessage(ze.identifier.value,{message:oe,args:Le})}return ui.getMessage(ze.identifier.value,_[0])},get bundle(){return ui.getBundle(ze.identifier.value)},get uri(){return ui.getBundleUri(ze.identifier.value)}},an={_version:1,registerInteractiveEditorSessionProvider(_,oe){return(0,Ze.$PG)(ze,"interactive"),Zi.registerProvider(ze,_,oe)},transferActiveChat(_){return(0,Ze.$PG)(ze,"interactive"),Ii.transferActiveChat(_)}},qi={getRelatedInformation(_,oe){return(0,Ze.$PG)(ze,"aiRelatedInformation"),xi.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Ze.$PG)(ze,"aiRelatedInformation"),xi.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Ze.$PG)(ze,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(ze,_,oe)}},cn={registerChatResponseProvider(_,oe,Le){return(0,Ze.$PG)(ze,"chatProvider"),Tt.registerLanguageModel(ze,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Ze.$PG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Ze.$PG)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Ze.$PG)(ze,"chatParticipant"),Ii.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Le,rt){return(0,Ze.$PG)(ze,"chatParticipantAdditions"),Ii.createDynamicChatAgent(ze,_,oe,Le,rt)}},un={get languageModels(){return(0,Ze.$PG)(ze,"languageModels"),Tt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Le)=>((0,Ze.$PG)(ze,"languageModels"),Tt.onDidChangeProviders(_,oe,Le)),sendChatRequest(_,oe,Le,rt){return(0,Ze.$PG)(ze,"languageModels"),Tt.sendChatRequest(ze,_,oe,Le,rt)},computeTokenLength(_,oe,Le){return(0,Ze.$PG)(ze,"languageModels"),Le??=I.CancellationToken.None,Tt.computeTokenLength(_,oe,Le)},getLanguageModelInformation(_){return(0,Ze.$PG)(ze,"languageModels"),Tt.getLanguageModelInfo(_)}},ln={registerSpeechProvider(_,oe){return(0,Ze.$PG)(ze,"speech"),ji.registerProvider(ze.identifier,_,oe)}};return{version:mt.version,ai:qi,authentication:en,commands:mi,comments:$n,chat:cn,debug:sn,env:yi,extensions:Ai,interactive:an,l10n:wn,languages:tn,lm:un,notebooks:pn,scm:rn,speech:ln,tasks:on,tests:mn,window:nn,workspace:Wi,Breakpoint:we.$bO,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$9O,CallHierarchyIncomingCall:we.$zN,CallHierarchyItem:we.$yN,CallHierarchyOutgoingCall:we.$AN,CancellationError:O.$5,CancellationTokenSource:I.$oe,CandidatePortSource:n.CandidatePortSource,CodeAction:we.$vN,CodeActionKind:we.$wN,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$BN,Color:we.$ON,ColorInformation:we.$PN,ColorPresentation:we.$QN,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$IN,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$JN,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$YN,DebugAdapterExecutable:we.$fO,DebugAdapterInlineImplementation:we.$iO,DebugAdapterNamedPipeServer:we.$hO,DebugAdapterServer:we.$gO,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$yO,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$oN,DiagnosticRelatedInformation:we.$nN,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$aN,DocumentHighlight:we.$rN,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$sN,DocumentLink:we.$NN,DocumentSymbol:we.$uN,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$lO,InlineValueText:we.$mO,InlineValueVariableLookup:we.$nO,InlineValueEvaluatableExpression:we.$oO,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:R.$de,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$AO,FileDecoration2:we.$AO,FileSystemError:we.$rO,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:we.$sO,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$dO,InlineCompletionItem:we.$KN,InlineCompletionList:we.$LN,Hover:we.$pN,VerboseHover:we.$qN,HoverVerbosityAction:we.HoverVerbosityAction,IndentAction:D.IndentAction,Location:we.$mN,MarkdownString:we.$CN,OverviewRulerLane:h.OverviewRulerLane,ParameterInformation:we.$DN,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$bN,ProcessExecution:we.$WN,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$zO,Range:we.$cN,RelativePattern:we.$_N,Selection:we.$dN,SelectionRange:we.$xN,SemanticTokens:we.$vO,SemanticTokensBuilder:we.$uO,SemanticTokensEdit:we.$wO,SemanticTokensEdits:we.$xO,SemanticTokensLegend:we.$tO,ShellExecution:we.$XN,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$FN,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$EN,SnippetString:we.$lN,SourceBreakpoint:we.$cO,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$tN,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$ZN,TaskGroup:we.$VN,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$RN,TerminalQuickFixTerminalCommand:we.$TN,TerminalQuickFixOpener:we.$SN,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$UN,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$hN,SnippetTextEdit:we.$jN,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$$N,ThemeIcon:we.$0N,TreeItem:we.$1N,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$WO,UIKind:Yt.UIKind,Uri:$.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$kN,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$7N,DocumentDropOrPasteEditKind:we.$8N,DocumentPasteEdit:we.$9N,InlayHint:we.$HN,InlayHintLabelPart:we.$GN,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$gN,ResolvedAuthority:we.$eN,ManagedResolvedAuthority:we.$fN,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$KO,NotebookRange:we.$CO,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$DO,NotebookData:we.$EO,NotebookRendererScript:we.$IO,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$GO,NotebookCellOutputItem:we.$FO,NotebookCellStatusBarItem:we.$HO,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$iN,NotebookKernelSourceAction:we.$JO,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$MO,LinkedEditingRanges:we.$LO,TestResultState:we.TestResultState,TestRunRequest:we.$NO,TestRunRequest2:we.$NO,TestMessage:we.$OO,TestTag:we.$PO,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:ai.TextSearchCompleteMessageType,DataTransfer:we.$6N,DataTransferItem:we.$2N,TestCoverageCount:we.$QO,FileCoverage:we.$SO,StatementCoverage:we.$TO,BranchCoverage:we.$UO,DeclarationCoverage:we.$VO,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$XO,TabInputTextDiff:we.$YO,TabInputTextMerge:we.$ZO,TabInputCustom:we.$1O,TabInputNotebook:we.$3O,TabInputNotebookDiff:we.$4O,TabInputWebview:we.$2O,TabInputTerminal:we.$5O,TabInputInteractiveWindow:we.$6O,TabInputChat:we.$7O,TabInputTextMultiDiff:we.$8O,TelemetryTrustedValue:s.$fp,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,DebugStackFrame:we.$jO,DebugThread:we.$kO,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,TextToSpeechStatus:we.TextToSpeechStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$0O,ChatResponseFileTreePart:we.$aP,ChatResponseAnchorPart:we.$bP,ChatResponseProgressPart:we.$cP,ChatResponseReferencePart:we.$fP,ChatResponseWarningPart:we.$dP,ChatResponseTextEditPart:we.$gP,ChatResponseMarkdownWithVulnerabilitiesPart:we.$$O,ChatResponseCommandButtonPart:we.$eP,ChatResponseDetectedParticipantPart:we.$_O,ChatRequestTurn:we.$hP,ChatResponseTurn:we.$iP,ChatLocation:we.ChatLocation,LanguageModelChatSystemMessage:we.$jP,LanguageModelChatUserMessage:we.$kP,LanguageModelChatAssistantMessage:we.$lP,LanguageModelSystemMessage:we.$jP,LanguageModelUserMessage:we.$kP,LanguageModelAssistantMessage:we.$lP,LanguageModelError:we.$mP,NewSymbolName:we.$qO,NewSymbolNameTag:we.NewSymbolNameTag,NewSymbolNameTriggerKind:we.NewSymbolNameTriggerKind,InlineEdit:we.$nP,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Pe[308],Ie([1,0,56,118,39,112,40,32,68,53,121,123,124,84,88,80,111,65,46,83,63,67,247,12,122,81,82,86,90,116]),function(le,e,I,O,R,M,A,p,$,y,T,D,h,w,g,r,o,s,i,n,c,l,t,f,a,m,u,C,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$xs)(m.$emc,m.$dmc,1),(0,I.$xs)(f.$4j,t.$rnc,1),(0,I.$xs)(r.$jlc,r.$klc,1),(0,I.$xs)(p.$VP,p.$UP,0),(0,I.$xs)(C.$tlc,C.$ulc,0),(0,I.$xs)(b.$$lc,b.$_lc,0),(0,I.$xs)(A.$Ilc,A.$Glc,0),(0,I.$xs)(s.$Klc,s.$Jlc,0),(0,I.$xs)(D.$omc,D.$smc,0),(0,I.$xs)(M.$umc,M.$tmc,0),(0,I.$xs)($.$KP,$.$JP,0),(0,I.$xs)(u.$fmc,u.$gmc,0),(0,I.$xs)(i.$nlc,i.$mlc,0),(0,I.$xs)(O.$Zmc,O.$Ymc,1),(0,I.$xs)(h.$Kmc,h.$Lmc,0),(0,I.$xs)(w.$4lc,w.$3lc,0),(0,I.$xs)(T.$anc,T.$_mc,0),(0,I.$xs)(y.$7lc,y.$0lc,0),(0,I.$xs)(v.$bnc,v.$cnc,0),(0,I.$xs)(g.$sDb,g.$tDb,0),(0,I.$xs)(o.$pnc,o.$onc,0),(0,I.$xs)(R.$Flc,R.$Elc,0),(0,I.$xs)(n.$bmc,n.$amc,0),(0,I.$xs)(c.$TP,c.$QP,0),(0,I.$xs)(l.$Ulc,l.$Vlc,0),(0,I.$xs)(a.$mmc,a.$nmc,0)}),define(Pe[309],Ie([1,0,307,41,2,304,7,11,253]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0;class y extends M.$unc{j(){}getModule(w,g){for(const r of this.b){const o=r(w);if(o){w=o;break}}if(this.a.has(w))return this.a.get(w).load(w,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends O.$imc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$Apc);const w=this.h.invokeFunction(I.$qnc);this.r=this.h.createInstance(y,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,g,r){g=g.with({path:D(g.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=R.URI.revive(await this.C.$asBrowserUri(g)),i=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${g.toString(!0)}#vscode-extension`,l=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",l)}catch(u){throw console.error(o?`Loading code for extension ${o} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${g.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}w&&await this.w.initializeLocalizedMessages(w);const f={},a={exports:f},m=u=>{const C=this.r.getModule(u,g);if(C===void 0)throw new Error(`Cannot load module '${u}'`);return C};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(a,f,m),a.exports!==f?a.exports:f}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+w;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,p.$xh)(10)}}e.$Bpc=T;function D(h,w){return h.endsWith(w)?h:h+w}}),define(Pe[310],Ie([1,0,71,56,12,41,217,87,309]),function(le,e,I,O,R,M,A,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$xs)(R.$3j,new I.$ti(A.$tnc,[!0],!0)),(0,O.$xs)(M.$jmc,$.$Bpc,0),(0,O.$xs)(p.$Llc,p.$Mlc,0)}),define(Pe[316],Ie([1,0,21,5,79,305,255,19,60,16,2,308,310]),function(le,e,I,O,R,M,A,p,$,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=l;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function r(t){self.fetch=async function(f,a){return f instanceof Request||w(String(f))&&(f=(await t(T.URI.parse(String(f)))).toString(!0)),g(f,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,a,m,u,C){(async()=>(w(a.toString())&&(a=(await t(T.URI.parse(a.toString()))).toString(!0)),super.open(f,a,m??!0,u,C)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,a){if(/^file:/i.test(f.toString()))f=y.$Qg.uriToBrowserUri(T.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function(d){function E(S){return typeof S=="string"||S instanceof URL?String(S).replace(/^file:\/\//i,"vscode-file://vscode-app"):S}const k=fetch.bind(self);self.fetch=function(S,W){return S instanceof Request?k(S,W):k(E(S),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(S,W,V,q,N){return super.open(S,E(W),V??!0,q,N)}};const P=importScripts.bind(self);self.importScripts=(...S)=>{P(...S.map(E))},P(d)}.toString()}('${f}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$nc(f.toString())}`;const C=new Blob([u],{type:"application/javascript"}),b=URL.createObjectURL(C);return new t(b,a)}}else self.Worker=class extends A.$Cpc{constructor(t,f){super(h,t,{name:p.$nc(t.toString()),...f})}};const o=new class{constructor(){this.pid=void 0}exit(t){D()}};class s{constructor(){const f=new MessageChannel,a=new O.$de;let m=!1;h(f.port2,[f.port2]),f.port1.onmessage=u=>{const{data:C}=u;if(!(C instanceof ArrayBuffer)){console.warn("UNKNOWN data received",C);return}const b=I.$Fe.wrap(new Uint8Array(C,0,C.byteLength));if((0,R.$1m)(b,2)){m=!0,n("received terminate message from renderer");return}a.fire(b)},this.protocol={onMessage:a.event,send:u=>{if(!m){const C=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);f.port1.postMessage(C,[C])}}}}}function i(t){return new Promise(f=>{const a=t.onMessage(m=>{a.dispose();const u=JSON.parse(m.toString());t.send((0,R.$Zm)(0)),f({protocol:t,initData:u})});t.send((0,R.$Zm)(1))})}let n=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function l(){$.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(f){c(f)&&i(t.protocol).then(a=>{$.mark("code/extHost/didWaitForInitData");const m=new M.$wnc(a.protocol,a.initData,o,null,f.data);r(u=>m.asBrowserUri(u)),n=u=>m.terminate(u)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/03dd3c3b93322b41fe108a3448308595ee7077a4/core/vs/workbench/api/worker/extensionHostWorker.js.map
